/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ge=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/path","vs/base/common/platform","vs/base/common/strings","vs/base/common/network","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/types","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/errors","vs/base/common/async","vs/workbench/api/common/extHostTypeConverters","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/map","vs/base/common/resources","vs/base/node/pfs","vs/workbench/api/common/extHostInitDataService","vs/base/common/uuid","vs/platform/extensions/common/extensions","vs/base/common/extpath","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostWorkspace","vs/base/common/glob","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","fs","child_process","vs/workbench/api/common/extHostDocumentsAndEditors","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/editor/common/core/range","vs/platform/files/common/files","vs/workbench/api/common/extHostDebugService","vs/base/common/stopwatch","os","vs/editor/common/core/position","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostCommands","vs/base/common/assert","vs/base/common/collections","vs/base/common/json","vs/base/common/linkedList","vs/base/common/severity","vs/base/common/marshalling","vs/base/common/errorMessage","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/decorators","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/numbers","vs/base/common/hash","vs/base/common/normalization","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/base/node/processes","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/contextkey/common/contextkey","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/configuration/common/configuration","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/stream","vs/base/common/uint","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/node/powershell","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/testing/common/testCollection","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/processes","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHost.api.impl","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionActivator","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/externalTerminal/node/externalTerminalService","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/commands/common/commands","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/theme/common/iconRegistry","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/views","vs/workbench/api/common/apiCommands","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/externalTerminal/node/externalTerminal","vs/workbench/contrib/externalTerminal/node/externalTerminalService","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/contrib/terminal/node/terminalProfiles","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostOutputService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","graceful-fs","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],pe=function(G){for(var e=[],E=0,P=G.length;E<P;E++)e[E]=ge[G[E]];return e};define(ge[52],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function E(P,T){if(!P)throw new Error(T?`Assertion failed (${T})`:"Assertion Failed")}e.ok=E}),define(ge[53],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const E=Object.prototype.hasOwnProperty;function P(R){const C=[];for(let w in R)E.call(R,w)&&C.push(R[w]);return C}e.values=P;function T(R,C){for(let w in R)if(E.call(R,w)&&C({key:w,value:R[w]},function(){delete R[w]})===!1)return}e.forEach=T;function I(R,C){const w=Object.create(null);for(const g of R){const s=C(g);let u=w[s];u||(u=w[s]=[]),u.push(g)}return w}e.groupBy=I;function D(R){const C=Object.create(null);return R&&R.forEach((w,g)=>{C[g]=w}),C}e.fromMap=D;function k(R,C){const w=[],g=[];for(let s of R)C.has(s)||w.push(s);for(let s of C)R.has(s)||g.push(s);return{removed:w,added:g}}e.diffSets=k;function y(R,C){const w=[],g=[];for(let[s,u]of R)C.has(s)||w.push(u);for(let[s,u]of C)R.has(s)||g.push(u);return{removed:w,added:g}}e.diffMaps=y;class n{constructor(){this.map=new Map}add(C,w){let g=this.map.get(C);g||(g=new Set,this.map.set(C,g)),g.add(w)}delete(C,w){const g=this.map.get(C);!g||(g.delete(w),g.size===0&&this.map.delete(C))}forEach(C,w){const g=this.map.get(C);!g||g.forEach(w)}}e.SetMap=n}),define(ge[68],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function E(y){return(n,R,C)=>{let w=null,g=null;if(typeof C.value=="function"?(w="value",g=C.value):typeof C.get=="function"&&(w="get",g=C.get),!g)throw new Error("not supported");C[w]=y(g,R)}}e.createDecorator=E;let P=0;function T(){const y=`$memoize${P++}`;let n;const R=function(w,g,s){let u=null,S=null;if(typeof s.value=="function"?(u="value",S=s.value,S.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof s.get=="function"&&(u="get",S=s.get),!S)throw new Error("not supported");const v=`${y}:${g}`;s[u]=function(..._){return n=this,this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!0,enumerable:!1,writable:!0,value:S.apply(this,_)}),this[v]}};return R.clear=()=>{typeof n!="undefined"&&Object.getOwnPropertyNames(n).forEach(C=>{C.indexOf(y)===0&&delete n[C]})},R}e.createMemoizer=T;function I(y,n,R){return T()(y,n,R)}e.memoize=I;function D(y,n,R){return E((C,w)=>{const g=`$debounce$${w}`,s=`$debounce$result$${w}`;return function(...u){this[s]||(this[s]=R?R():void 0),clearTimeout(this[g]),n&&(this[s]=n(this[s],...u),u=[this[s]]),this[g]=setTimeout(()=>{C.apply(this,u),this[s]=R?R():void 0},y)}})}e.debounce=D;function k(y,n,R){return E((C,w)=>{const g=`$throttle$timer$${w}`,s=`$throttle$result$${w}`,u=`$throttle$lastRun$${w}`,S=`$throttle$pending$${w}`;return function(...v){if(this[s]||(this[s]=R?R():void 0),(this[u]===null||this[u]===void 0)&&(this[u]=-Number.MAX_VALUE),n&&(this[s]=n(this[s],...v)),!this[S]){const _=this[u]+y;_<=Date.now()?(this[u]=Date.now(),C.apply(this,[this[s]]),this[s]=R?R():void 0):(this[S]=!0,this[g]=setTimeout(()=>{this[S]=!1,this[u]=Date.now(),C.apply(this,[this[s]]),this[s]=R?R():void 0},_-Date.now()))}}})}e.throttle=k}),define(ge[18],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class E{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(i=>{i(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=E,e.errorHandler=new E;function P(l){e.errorHandler.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=P;function T(l){y(l)||e.errorHandler.onUnexpectedError(l)}e.onUnexpectedError=T;function I(l){y(l)||e.errorHandler.onUnexpectedExternalError(l)}e.onUnexpectedExternalError=I;function D(l){if(l instanceof Error){let{name:t,message:i}=l;const o=l.stacktrace||l.stack;return{$isError:!0,name:t,message:i,stack:o}}return l}e.transformErrorForSerialization=D;const k="Canceled";function y(l){return l instanceof Error&&l.name===k&&l.message===k}e.isPromiseCanceledError=y;class n extends Error{constructor(){super(k);this.name=this.message}}e.CancellationError=n;function R(){const l=new Error(k);return l.name=l.message,l}e.canceled=R;function C(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.illegalArgument=C;function w(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.illegalState=w;function g(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=g;function s(l){const t=new Error(`${l} has been disposed`);return t.name="DISPOSED",t}e.disposed=s;function u(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.getErrorMessage=u;class S extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=S;class v extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=v;class _ extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=_;function p(l){const t=l;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=p;function c(l,t=Object.create(null)){const i=new Error(l);return t.actions&&(i.actions=t.actions),i}e.createErrorWithActions=c}),define(ge[14],pe([0,1,18]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function P(F,N=0){return F[F.length-(1+N)]}e.tail=P;function T(F){if(F.length===0)throw new Error("Invalid tail call");return[F.slice(0,F.length-1),F[F.length-1]]}e.tail2=T;function I(F,N,M=(x,O)=>x===O){if(F===N)return!0;if(!F||!N||F.length!==N.length)return!1;for(let x=0,O=F.length;x<O;x++)if(!M(F[x],N[x]))return!1;return!0}e.equals=I;function D(F,N,M){let x=0,O=F.length-1;for(;x<=O;){const V=(x+O)/2|0,q=M(F[V],N);if(q<0)x=V+1;else if(q>0)O=V-1;else return V}return-(x+1)}e.binarySearch=D;function k(F,N){let M=0,x=F.length;if(x===0)return 0;for(;M<x;){const O=Math.floor((M+x)/2);N(F[O])?x=O:M=O+1}return M}e.findFirstInSorted=k;function y(F,N,M){if(F=F|0,F>=N.length)throw new TypeError("invalid index");let x=N[Math.floor(N.length*Math.random())],O=[],V=[],q=[];for(let X of N){const me=M(X,x);me<0?O.push(X):me>0?V.push(X):q.push(X)}return F<O.length?y(F,O,M):F<O.length+q.length?q[0]:y(F-(O.length+q.length),V,M)}e.quickSelect=y;function n(F,N){const M=[];let x;for(const O of F.slice(0).sort(N))!x||N(x[0],O)!==0?(x=[O],M.push(x)):x.push(O);return M}e.groupBy=n;function R(F,N,M){const x=[];function O(X,me,we){if(!(me===0&&we.length===0)){const Te=x[x.length-1];Te&&Te.start+Te.deleteCount===X?(Te.deleteCount+=me,Te.toInsert.push(...we)):x.push({start:X,deleteCount:me,toInsert:we})}}let V=0,q=0;for(;;){if(V===F.length){O(V,0,N.slice(q));break}if(q===N.length){O(V,F.length-V,[]);break}const X=F[V],me=N[q],we=M(X,me);we===0?(V+=1,q+=1):we<0?(O(V,1,[]),V+=1):we>0&&(O(V,0,[me]),q+=1)}return x}e.sortedDiff=R;function C(F,N,M){const x=R(F,N,M),O=[],V=[];for(const q of x)O.push(...F.slice(q.start,q.start+q.deleteCount)),V.push(...q.toInsert);return{removed:O,added:V}}e.delta=C;function w(F,N,M){if(M===0)return[];const x=F.slice(0,M).sort(N);return s(F,N,x,M,F.length),x}e.top=w;function g(F,N,M,x,O){return M===0?Promise.resolve([]):new Promise((V,q)=>{(async()=>{const X=F.length,me=F.slice(0,M).sort(N);for(let we=M,Te=Math.min(M+x,X);we<X;we=Te,Te=Math.min(Te+x,X)){if(we>M&&await new Promise(Pe=>setTimeout(Pe)),O&&O.isCancellationRequested)throw(0,E.canceled)();s(F,N,me,we,Te)}return me})().then(V,q)})}e.topAsync=g;function s(F,N,M,x,O){for(const V=M.length;x<O;x++){const q=F[x];if(N(q,M[V-1])<0){M.pop();const X=k(M,me=>N(q,me)<0);M.splice(X,0,q)}}}function u(F){return F.filter(N=>!!N)}e.coalesce=u;function S(F){let N=0;for(let M=0;M<F.length;M++)F[M]&&(F[N]=F[M],N+=1);F.length=N}e.coalesceInPlace=S;function v(F,N,M){F.splice(M,0,F.splice(N,1)[0])}e.move=v;function _(F){return!Array.isArray(F)||F.length===0}e.isFalsyOrEmpty=_;function p(F){return Array.isArray(F)&&F.length>0}e.isNonEmptyArray=p;function c(F,N){if(!N)return F.filter((x,O)=>F.indexOf(x)===O);const M=Object.create(null);return F.filter(x=>{const O=N(x);return M[O]?!1:(M[O]=!0,!0)})}e.distinct=c;function l(F){const N=new Set;return F.filter(M=>N.has(M)?!1:(N.add(M),!0))}e.distinctES6=l;function t(F){const N=Object.create(null);return M=>{const x=F(M);return N[x]?!1:(N[x]=!0,!0)}}e.uniqueFilter=t;function i(F,N){for(let M=F.length-1;M>=0;M--){const x=F[M];if(N(x))return M}return-1}e.lastIndex=i;function o(F,N){return F.length>0?F[0]:N}e.firstOrDefault=o;function r(F,N,M=(x,O)=>x===O){let x=0;for(let O=0,V=Math.min(F.length,N.length);O<V&&M(F[O],N[O]);O++)x++;return x}e.commonPrefixLength=r;function a(F){return[].concat(...F)}e.flatten=a;function h(F,N){let M=typeof N=="number"?F:0;typeof N=="number"?M=F:(M=0,N=F);const x=[];if(M<=N)for(let O=M;O<N;O++)x.push(O);else for(let O=M;O>N;O--)x.push(O);return x}e.range=h;function m(F,N,M){return F.reduce((x,O)=>(x[N(O)]=M?M(O):O,x),Object.create(null))}e.index=m;function b(F,N){return F.push(N),()=>f(F,N)}e.insert=b;function f(F,N){const M=F.indexOf(N);if(M>-1)return F.splice(M,1),N}e.remove=f;function d(F,N,M){const x=F.slice(0,N),O=F.slice(N);return x.concat(M,O)}e.arrayInsert=d;function A(F,N){let M;if(typeof N=="number"){let x=N;M=()=>{const O=Math.sin(x++)*179426549;return O-Math.floor(O)}}else M=Math.random;for(let x=F.length-1;x>0;x-=1){const O=Math.floor(M()*(x+1)),V=F[x];F[x]=F[O],F[O]=V}}e.shuffle=A;function L(F,N){const M=F.indexOf(N);M>-1&&(F.splice(M,1),F.unshift(N))}e.pushToStart=L;function B(F,N){const M=F.indexOf(N);M>-1&&(F.splice(M,1),F.push(N))}e.pushToEnd=B;function J(F,N){return Array.isArray(F)?F.map(N):N(F)}e.mapArrayOrNot=J;function j(F){return Array.isArray(F)?F:[F]}e.asArray=j;function U(F){return F[Math.floor(Math.random()*F.length)]}e.getRandomElement=U;function $(F,N){for(const M of F){const x=N(M);if(x!==void 0)return x}}e.mapFind=$}),define(ge[69],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function E(P){const T=this;let I=!1,D;return function(){return I||(I=!0,D=P.apply(T,arguments)),D}}e.once=E}),define(ge[70],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class E{constructor(T){this._prefix=T,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=E,e.defaultGenerator=new E("id#")}),define(ge[71],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var E;(function(P){function T(l){return l&&typeof l=="object"&&typeof l[Symbol.iterator]=="function"}P.is=T;const I=Object.freeze([]);function D(){return I}P.empty=D;function*k(l){yield l}P.single=k;function y(l){return l||I}P.from=y;function n(l){return!l||l[Symbol.iterator]().next().done===!0}P.isEmpty=n;function R(l){return l[Symbol.iterator]().next().value}P.first=R;function C(l,t){for(const i of l)if(t(i))return!0;return!1}P.some=C;function w(l,t){for(const i of l)if(t(i))return i}P.find=w;function*g(l,t){for(const i of l)t(i)&&(yield i)}P.filter=g;function*s(l,t){for(const i of l)yield t(i)}P.map=s;function*u(...l){for(const t of l)for(const i of t)yield i}P.concat=u;function*S(l){for(const t of l)for(const i of t)yield i}P.concatNested=S;function v(l,t,i){let o=i;for(const r of l)o=t(o,r);return o}P.reduce=v;function*_(l,t,i=l.length){for(t<0&&(t+=l.length),i<0?i+=l.length:i>l.length&&(i=l.length);t<i;t++)yield l[t]}P.slice=_;function p(l,t=Number.POSITIVE_INFINITY){const i=[];if(t===0)return[i,l];const o=l[Symbol.iterator]();for(let r=0;r<t;r++){const a=o.next();if(a.done)return[i,P.empty()];i.push(a.value)}return[i,{[Symbol.iterator](){return o}}]}P.consume=p;function c(l,t,i=(o,r)=>o===r){const o=l[Symbol.iterator](),r=t[Symbol.iterator]();for(;;){const a=o.next(),h=r.next();if(a.done!==h.done)return!1;if(a.done)return!0;if(!i(a.value,h.value))return!1}}P.equals=c})(E=e.Iterable||(e.Iterable={}))}),define(ge[54],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var E;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(E=e.ScanError||(e.ScanError={}));var P;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(P=e.SyntaxKind||(e.SyntaxKind={}));var T;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(T=e.ParseErrorCode||(e.ParseErrorCode={}));var I;(function(t){t.DEFAULT={allowTrailingComma:!0}})(I=e.ParseOptions||(e.ParseOptions={}));function D(t,i=!1){let o=0,r=t.length,a="",h=0,m=16,b=0;function f(U){let $=0,F=0;for(;$<U;){const N=t.charCodeAt(o);if(N>=48&&N<=57)F=F*16+N-48;else if(N>=65&&N<=70)F=F*16+N-65+10;else if(N>=97&&N<=102)F=F*16+N-97+10;else break;o++,$++}return $<U&&(F=-1),F}function d(U){o=U,a="",h=0,m=16,b=0}function A(){const U=o;if(t.charCodeAt(o)===48)o++;else for(o++;o<t.length&&n(t.charCodeAt(o));)o++;if(o<t.length&&t.charCodeAt(o)===46)if(o++,o<t.length&&n(t.charCodeAt(o)))for(o++;o<t.length&&n(t.charCodeAt(o));)o++;else return b=3,t.substring(U,o);let $=o;if(o<t.length&&(t.charCodeAt(o)===69||t.charCodeAt(o)===101))if(o++,(o<t.length&&t.charCodeAt(o)===43||t.charCodeAt(o)===45)&&o++,o<t.length&&n(t.charCodeAt(o))){for(o++;o<t.length&&n(t.charCodeAt(o));)o++;$=o}else b=3;return t.substring(U,$)}function L(){let U="",$=o;for(;;){if(o>=r){U+=t.substring($,o),b=2;break}const F=t.charCodeAt(o);if(F===34){U+=t.substring($,o),o++;break}if(F===92){if(U+=t.substring($,o),o++,o>=r){b=2;break}switch(t.charCodeAt(o++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:const M=f(4);M>=0?U+=String.fromCharCode(M):b=4;break;default:b=5}$=o;continue}if(F>=0&&F<=31)if(y(F)){U+=t.substring($,o),b=2;break}else b=6;o++}return U}function B(){if(a="",b=0,h=o,o>=r)return h=r,m=17;let U=t.charCodeAt(o);if(k(U)){do o++,a+=String.fromCharCode(U),U=t.charCodeAt(o);while(k(U));return m=15}if(y(U))return o++,a+=String.fromCharCode(U),U===13&&t.charCodeAt(o)===10&&(o++,a+=`
`),m=14;switch(U){case 123:return o++,m=1;case 125:return o++,m=2;case 91:return o++,m=3;case 93:return o++,m=4;case 58:return o++,m=6;case 44:return o++,m=5;case 34:return o++,a=L(),m=10;case 47:const $=o-1;if(t.charCodeAt(o+1)===47){for(o+=2;o<r&&!y(t.charCodeAt(o));)o++;return a=t.substring($,o),m=12}if(t.charCodeAt(o+1)===42){o+=2;const F=r-1;let N=!1;for(;o<F;){if(t.charCodeAt(o)===42&&t.charCodeAt(o+1)===47){o+=2,N=!0;break}o++}return N||(o++,b=1),a=t.substring($,o),m=13}return a+=String.fromCharCode(U),o++,m=16;case 45:if(a+=String.fromCharCode(U),o++,o===r||!n(t.charCodeAt(o)))return m=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=A(),m=11;default:for(;o<r&&J(U);)o++,U=t.charCodeAt(o);if(h!==o){switch(a=t.substring(h,o),a){case"true":return m=8;case"false":return m=9;case"null":return m=7}return m=16}return a+=String.fromCharCode(U),o++,m=16}}function J(U){if(k(U)||y(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function j(){let U;do U=B();while(U>=12&&U<=15);return U}return{setPosition:d,getPosition:()=>o,scan:i?j:B,getToken:()=>m,getTokenValue:()=>a,getTokenOffset:()=>h,getTokenLength:()=>o-h,getTokenError:()=>b}}e.createScanner=D;function k(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function y(t){return t===10||t===13||t===8232||t===8233}function n(t){return t>=48&&t<=57}var R;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(R||(R={}));function C(t,i){const o=[],r=new Object;let a;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let m=!1;function b(f,d,A,L){h.value=f,h.offset=d,h.length=A,h.type=L,h.colonOffset=void 0,a=h}try{p(t,{onObjectBegin:(f,d)=>{if(i<=f)throw r;a=void 0,m=i>f,o.push("")},onObjectProperty:(f,d,A)=>{if(i<d||(b(f,d,A,"property"),o[o.length-1]=f,i<=d+A))throw r},onObjectEnd:(f,d)=>{if(i<=f)throw r;a=void 0,o.pop()},onArrayBegin:(f,d)=>{if(i<=f)throw r;a=void 0,o.push(0)},onArrayEnd:(f,d)=>{if(i<=f)throw r;a=void 0,o.pop()},onLiteralValue:(f,d,A)=>{if(i<d||(b(f,d,A,l(f)),i<=d+A))throw r},onSeparator:(f,d,A)=>{if(i<=d)throw r;if(f===":"&&a&&a.type==="property")a.colonOffset=d,m=!1,a=void 0;else if(f===","){const L=o[o.length-1];typeof L=="number"?o[o.length-1]=L+1:(m=!0,o[o.length-1]=""),a=void 0}}})}catch(f){if(f!==r)throw f}return{path:o,previousNode:a,isAtPropertyKey:m,matches:f=>{let d=0;for(let A=0;d<f.length&&A<o.length;A++)if(f[d]===o[A]||f[d]==="*")d++;else if(f[d]!=="**")return!1;return d===f.length}}}e.getLocation=C;function w(t,i=[],o=I.DEFAULT){let r=null,a=[];const h=[];function m(f){Array.isArray(a)?a.push(f):r!==null&&(a[r]=f)}return p(t,{onObjectBegin:()=>{const f={};m(f),h.push(a),a=f,r=null},onObjectProperty:f=>{r=f},onObjectEnd:()=>{a=h.pop()},onArrayBegin:()=>{const f=[];m(f),h.push(a),a=f,r=null},onArrayEnd:()=>{a=h.pop()},onLiteralValue:m,onError:(f,d,A)=>{i.push({error:f,offset:d,length:A})}},o),a[0]}e.parse=w;function g(t,i=[],o=I.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(f){r.type==="property"&&(r.length=f-r.offset,r=r.parent)}function h(f){return r.children.push(f),f}p(t,{onObjectBegin:f=>{r=h({type:"object",offset:f,length:-1,parent:r,children:[]})},onObjectProperty:(f,d,A)=>{r=h({type:"property",offset:d,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:f,offset:d,length:A,parent:r})},onObjectEnd:(f,d)=>{r.length=f+d-r.offset,r=r.parent,a(f+d)},onArrayBegin:(f,d)=>{r=h({type:"array",offset:f,length:-1,parent:r,children:[]})},onArrayEnd:(f,d)=>{r.length=f+d-r.offset,r=r.parent,a(f+d)},onLiteralValue:(f,d,A)=>{h({type:l(f),offset:d,length:A,parent:r,value:f}),a(d+A)},onSeparator:(f,d,A)=>{r.type==="property"&&(f===":"?r.colonOffset=d:f===","&&a(d))},onError:(f,d,A)=>{i.push({error:f,offset:d,length:A})}},o);const b=r.children[0];return b&&delete b.parent,b}e.parseTree=g;function s(t,i){if(!!t){let o=t;for(let r of i)if(typeof r=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let a=!1;for(const h of o.children)if(Array.isArray(h.children)&&h.children[0].value===r){o=h.children[1],a=!0;break}if(!a)return}else{const a=r;if(o.type!=="array"||a<0||!Array.isArray(o.children)||a>=o.children.length)return;o=o.children[a]}return o}}e.findNodeAtLocation=s;function u(t){if(!t.parent||!t.parent.children)return[];const i=u(t.parent);if(t.parent.type==="property"){const o=t.parent.children[0].value;i.push(o)}else if(t.parent.type==="array"){const o=t.parent.children.indexOf(t);o!==-1&&i.push(o)}return i}e.getNodePath=u;function S(t){switch(t.type){case"array":return t.children.map(S);case"object":const i=Object.create(null);for(let o of t.children){const r=o.children[1];r&&(i[o.children[0].value]=S(r))}return i;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=S;function v(t,i,o=!1){return i>=t.offset&&i<t.offset+t.length||o&&i===t.offset+t.length}e.contains=v;function _(t,i,o=!1){if(v(t,i,o)){const r=t.children;if(Array.isArray(r))for(let a=0;a<r.length&&r[a].offset<=i;a++){const h=_(r[a],i,o);if(h)return h}return t}}e.findNodeAtOffset=_;function p(t,i,o=I.DEFAULT){const r=D(t,!1);function a(me){return me?()=>me(r.getTokenOffset(),r.getTokenLength()):()=>!0}function h(me){return me?we=>me(we,r.getTokenOffset(),r.getTokenLength()):()=>!0}const m=a(i.onObjectBegin),b=h(i.onObjectProperty),f=a(i.onObjectEnd),d=a(i.onArrayBegin),A=a(i.onArrayEnd),L=h(i.onLiteralValue),B=h(i.onSeparator),J=a(i.onComment),j=h(i.onError),U=o&&o.disallowComments,$=o&&o.allowTrailingComma;function F(){for(;;){const me=r.scan();switch(r.getTokenError()){case 4:N(14);break;case 5:N(15);break;case 3:N(13);break;case 1:U||N(11);break;case 2:N(12);break;case 6:N(16);break}switch(me){case 12:case 13:U?N(10):J();break;case 16:N(1);break;case 15:case 14:break;default:return me}}}function N(me,we=[],Te=[]){if(j(me),we.length+Te.length>0){let Pe=r.getToken();for(;Pe!==17;){if(we.indexOf(Pe)!==-1){F();break}else if(Te.indexOf(Pe)!==-1)break;Pe=F()}}}function M(me){const we=r.getTokenValue();return me?L(we):b(we),F(),!0}function x(){switch(r.getToken()){case 11:let me=0;try{me=JSON.parse(r.getTokenValue()),typeof me!="number"&&(N(2),me=0)}catch(we){N(2)}L(me);break;case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return F(),!0}function O(){return r.getToken()!==10?(N(3,[],[2,5]),!1):(M(!1),r.getToken()===6?(B(":"),F(),X()||N(4,[],[2,5])):N(5,[],[2,5]),!0)}function V(){m(),F();let me=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(me||N(4,[],[]),B(","),F(),r.getToken()===2&&$)break}else me&&N(6,[],[]);O()||N(4,[],[2,5]),me=!0}return f(),r.getToken()!==2?N(7,[2],[]):F(),!0}function q(){d(),F();let me=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(me||N(4,[],[]),B(","),F(),r.getToken()===4&&$)break}else me&&N(6,[],[]);X()||N(4,[],[4,5]),me=!0}return A(),r.getToken()!==4?N(8,[4],[]):F(),!0}function X(){switch(r.getToken()){case 3:return q();case 1:return V();case 10:return M(!0);default:return x()}}return F(),r.getToken()===17?o.allowEmptyContent?!0:(N(4,[],[]),!1):X()?(r.getToken()!==17&&N(9,[],[]),!0):(N(4,[],[]),!1)}e.visit=p;function c(t,i){let o=D(t),r=[],a,h=0,m;do switch(m=o.getPosition(),a=o.scan(),a){case 12:case 13:case 17:h!==m&&r.push(t.substring(h,m)),i!==void 0&&r.push(o.getTokenValue().replace(/[^\r\n]/g,i)),h=o.getPosition();break}while(a!==17);return r.join("")}e.stripComments=c;function l(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=l}),define(ge[131],pe([0,1,54]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function P(y,n,R){let C,w,g,s,u;if(n){for(s=n.offset,u=s+n.length,g=s;g>0&&!k(y,g-1);)g--;let h=u;for(;h<y.length&&!k(y,h);)h++;w=y.substring(g,h),C=I(w,R)}else w=y,C=0,g=0,s=0,u=y.length;const S=D(R,y);let v=!1,_=0,p;R.insertSpaces?p=T(" ",R.tabSize||4):p="	";const c=(0,E.createScanner)(w,!1);let l=!1;function t(){return S+T(p,C+_)}function i(){let h=c.scan();for(v=!1;h===15||h===14;)v=v||h===14,h=c.scan();return l=h===16||c.getTokenError()!==0,h}const o=[];function r(h,m,b){!l&&m<u&&b>s&&y.substring(m,b)!==h&&o.push({offset:m,length:b-m,content:h})}let a=i();if(a!==17){const h=c.getTokenOffset()+g,m=T(p,C);r(m,g,h)}for(;a!==17;){let h=c.getTokenOffset()+c.getTokenLength()+g,m=i(),b="";for(;!v&&(m===12||m===13);){const d=c.getTokenOffset()+g;r(" ",h,d),h=c.getTokenOffset()+c.getTokenLength()+g,b=m===12?t():"",m=i()}if(m===2)a!==1&&(_--,b=t());else if(m===4)a!==3&&(_--,b=t());else{switch(a){case 3:case 1:_++,b=t();break;case 5:case 12:b=t();break;case 13:v?b=t():b=" ";break;case 6:b=" ";break;case 10:if(m===6){b="";break}case 7:case 8:case 9:case 11:case 2:case 4:m===12||m===13?b=" ":m!==5&&m!==17&&(l=!0);break;case 16:l=!0;break}v&&(m===12||m===13)&&(b=t())}const f=c.getTokenOffset()+g;r(b,h,f),a=m}return o}e.format=P;function T(y,n){let R="";for(let C=0;C<n;C++)R+=y;return R}function I(y,n){let R=0,C=0;const w=n.tabSize||4;for(;R<y.length;){const g=y.charAt(R);if(g===" ")C++;else if(g==="	")C+=w;else break;R++}return Math.floor(C/w)}function D(y,n){for(let R=0;R<n.length;R++){const C=n.charAt(R);if(C==="\r")return R+1<n.length&&n.charAt(R+1)===`
`?`\r
`:"\r";if(C===`
`)return`
`}return y&&y.eol||`
`}e.getEOL=D;function k(y,n){return`\r
`.indexOf(y.charAt(n))!==-1}e.isEOL=k}),define(ge[132],pe([0,1,54,131]),function(G,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function T(n,R,C){return I(n,R,void 0,C)}e.removeProperty=T;function I(n,R,C,w,g){const s=R.slice(),u=[],S=(0,E.parseTree)(n,u);let v,_;for(;s.length>0&&(_=s.pop(),v=(0,E.findNodeAtLocation)(S,s),v===void 0&&C!==void 0);)typeof _=="string"?C={[_]:C}:C=[C];if(v)if(v.type==="object"&&typeof _=="string"&&Array.isArray(v.children)){const p=(0,E.findNodeAtLocation)(v,[_]);if(p!==void 0)if(C===void 0){if(!p.parent)throw new Error("Malformed AST");const c=v.children.indexOf(p.parent);let l,t=p.parent.offset+p.parent.length;if(c>0){const i=v.children[c-1];l=i.offset+i.length}else l=v.offset+1,v.children.length>1&&(t=v.children[1].offset);return D(n,{offset:l,length:t-l,content:""},w)}else return D(n,{offset:p.offset,length:p.length,content:JSON.stringify(C)},w);else{if(C===void 0)return[];const c=`${JSON.stringify(_)}: ${JSON.stringify(C)}`,l=g?g(v.children.map(i=>i.children[0].value)):v.children.length;let t;if(l>0){const i=v.children[l-1];t={offset:i.offset+i.length,length:0,content:","+c}}else v.children.length===0?t={offset:v.offset+1,length:0,content:c}:t={offset:v.offset+1,length:0,content:c+","};return D(n,t,w)}}else if(v.type==="array"&&typeof _=="number"&&Array.isArray(v.children))if(C!==void 0){const p=`${JSON.stringify(C)}`;let c;if(v.children.length===0||_===0)c={offset:v.offset+1,length:0,content:v.children.length===0?p:p+","};else{const l=_===-1||_>v.children.length?v.children.length:_,t=v.children[l-1];c={offset:t.offset+t.length,length:0,content:","+p}}return D(n,c,w)}else{const p=_,c=v.children[p];let l;if(v.children.length===1)l={offset:v.offset+1,length:v.length-2,content:""};else if(v.children.length-1===p){const t=v.children[p-1],i=t.offset+t.length,o=v.offset+v.length;l={offset:i,length:o-2-i,content:""}}else l={offset:c.offset,length:v.children[p+1].offset-c.offset,content:""};return D(n,l,w)}else throw new Error(`Can not add ${typeof _!="number"?"index":"property"} to parent of type ${v.type}`);else{if(C===void 0)throw new Error("Can not delete in empty document");return D(n,{offset:S?S.offset:0,length:S?S.length:0,content:JSON.stringify(C)},w)}}e.setProperty=I;function D(n,R,C){let w=k(n,R),g=R.offset,s=R.offset+R.content.length;if(R.length===0||R.content.length===0){for(;g>0&&!(0,P.isEOL)(w,g-1);)g--;for(;s<w.length&&!(0,P.isEOL)(w,s);)s++}const u=(0,P.format)(w,{offset:g,length:s-g},C);for(let v=u.length-1;v>=0;v--){const _=u[v];w=k(w,_),g=Math.min(g,_.offset),s=Math.max(s,_.offset+_.length),s+=_.content.length-_.length}const S=n.length-(w.length-s)-g;return[{offset:g,length:S,content:w.substring(g,s)}]}e.withFormatting=D;function k(n,R){return n.substring(0,R.offset)+R.content+n.substring(R.offset+R.length)}e.applyEdit=k;function y(n,R){let C=R.slice(0).sort((g,s)=>{const u=g.offset-s.offset;return u===0?g.length-s.length:u}),w=n.length;for(let g=C.length-1;g>=0;g--){let s=C[g];if(s.offset+s.length<=w)n=k(n,s);else throw new Error("Overlapping edit");w=s.offset}return n}e.applyEdits=y}),define(ge[133],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class E{constructor(T){this.executor=T,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(T){this._error=T}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(T){return new E(()=>T(this.getValue()))}}e.Lazy=E}),define(ge[6],pe([0,1,69,71]),function(G,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const T=!1;let I=null;function D(p){I=p}if(e.setDisposableTracker=D,T){const p="__is_disposable_tracked__";I=new class{trackDisposable(c){const l=new Error("Potentially leaked disposable").stack;setTimeout(()=>{c[p]||console.log(l)},3e3)}markTracked(c){if(c&&c!==u.None)try{c[p]=!0}catch(l){}}}}function k(p){!I||I.markTracked(p)}function y(p){return I&&I.trackDisposable(p),p}e.trackDisposable=y;class n extends Error{constructor(c){super(`Encountered errors while disposing of store. Errors: [${c.join(", ")}]`);this.errors=c}}e.MultiDisposeError=n;function R(p){return typeof p.dispose=="function"&&p.dispose.length===0}e.isDisposable=R;function C(p){if(P.Iterable.is(p)){let c=[];for(const l of p)if(l){k(l);try{l.dispose()}catch(t){c.push(t)}}if(c.length===1)throw c[0];if(c.length>1)throw new n(c);return Array.isArray(p)?[]:p}else if(p)return k(p),p.dispose(),p}e.dispose=C;function w(...p){return p.forEach(k),g(()=>C(p))}e.combinedDisposable=w;function g(p){const c=y({dispose:()=>{k(c),p()}});return c}e.toDisposable=g;class s{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(k(this),this._isDisposed=!0,this.clear())}clear(){try{C(this._toDispose.values())}finally{this._toDispose.clear()}}add(c){if(!c)return c;if(c===this)throw new Error("Cannot register a disposable on itself!");return k(c),this._isDisposed?s.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(c),c}}e.DisposableStore=s,s.DISABLE_DISPOSED_WARNING=!1;class u{constructor(){this._store=new s,y(this)}dispose(){k(this),this._store.dispose()}_register(c){if(c===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(c)}}e.Disposable=u,u.None=Object.freeze({dispose(){}});class S{constructor(){this._isDisposed=!1,y(this)}get value(){return this._isDisposed?void 0:this._value}set value(c){var l;this._isDisposed||c===this._value||((l=this._value)===null||l===void 0||l.dispose(),c&&k(c),this._value=c)}clear(){this.value=void 0}dispose(){var c;this._isDisposed=!0,k(this),(c=this._value)===null||c===void 0||c.dispose(),this._value=void 0}}e.MutableDisposable=S;class v{constructor(){this.references=new Map}acquire(c,...l){let t=this.references.get(c);t||(t={counter:0,object:this.createReferencedObject(c,...l)},this.references.set(c,t));const{object:i}=t,o=(0,E.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(c,t.object),this.references.delete(c))});return t.counter++,{object:i,dispose:o}}}e.ReferenceCollection=v;class _{constructor(c){this.object=c}dispose(){}}e.ImmortalReference=_}),define(ge[55],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class E{constructor(I){this.element=I,this.next=E.Undefined,this.prev=E.Undefined}}E.Undefined=new E(void 0);class P{constructor(){this._first=E.Undefined,this._last=E.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===E.Undefined}clear(){this._first=E.Undefined,this._last=E.Undefined,this._size=0}unshift(I){return this._insert(I,!1)}push(I){return this._insert(I,!0)}_insert(I,D){const k=new E(I);if(this._first===E.Undefined)this._first=k,this._last=k;else if(D){const n=this._last;this._last=k,k.prev=n,n.next=k}else{const n=this._first;this._first=k,k.next=n,n.prev=k}this._size+=1;let y=!1;return()=>{y||(y=!0,this._remove(k))}}shift(){if(this._first!==E.Undefined){const I=this._first.element;return this._remove(this._first),I}}pop(){if(this._last!==E.Undefined){const I=this._last.element;return this._remove(this._last),I}}_remove(I){if(I.prev!==E.Undefined&&I.next!==E.Undefined){const D=I.prev;D.next=I.next,I.next.prev=D}else I.prev===E.Undefined&&I.next===E.Undefined?(this._first=E.Undefined,this._last=E.Undefined):I.next===E.Undefined?(this._last=this._last.prev,this._last.next=E.Undefined):I.prev===E.Undefined&&(this._first=this._first.next,this._first.prev=E.Undefined);this._size-=1}*[Symbol.iterator](){let I=this._first;for(;I!==E.Undefined;)yield I.element,I=I.next}}e.LinkedList=P}),function(G,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(G=typeof globalThis!="undefined"?globalThis:G||self,G.marked=e())}(this,function(){"use strict";function G(K,oe){for(var de=0;de<oe.length;de++){var Z=oe[de];Z.enumerable=Z.enumerable||!1,Z.configurable=!0,"value"in Z&&(Z.writable=!0),Object.defineProperty(K,Z.key,Z)}}function e(K,oe,de){return oe&&G(K.prototype,oe),de&&G(K,de),K}function E(K,oe){if(!!K){if(typeof K=="string")return P(K,oe);var de=Object.prototype.toString.call(K).slice(8,-1);if(de==="Object"&&K.constructor&&(de=K.constructor.name),de==="Map"||de==="Set")return Array.from(K);if(de==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(de))return P(K,oe)}}function P(K,oe){(oe==null||oe>K.length)&&(oe=K.length);for(var de=0,Z=new Array(oe);de<oe;de++)Z[de]=K[de];return Z}function T(K,oe){var de;if(typeof Symbol=="undefined"||K[Symbol.iterator]==null){if(Array.isArray(K)||(de=E(K))||oe&&K&&typeof K.length=="number"){de&&(K=de);var Z=0;return function(){return Z>=K.length?{done:!0}:{done:!1,value:K[Z++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return de=K[Symbol.iterator](),de.next.bind(de)}function I(K){var oe={exports:{}};return K(oe,oe.exports),oe.exports}var D=I(function(K){function oe(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function de(Z){K.exports.defaults=Z}K.exports={defaults:oe(),getDefaults:oe,changeDefaults:de}}),k=/[&<>"']/,y=/[&<>"']/g,n=/[<>"']|&(?!#?\w+;)/,R=/[<>"']|&(?!#?\w+;)/g,C={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},w=function(oe){return C[oe]};function g(K,oe){if(oe){if(k.test(K))return K.replace(y,w)}else if(n.test(K))return K.replace(R,w);return K}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function u(K){return K.replace(s,function(oe,de){return de=de.toLowerCase(),de==="colon"?":":de.charAt(0)==="#"?de.charAt(1)==="x"?String.fromCharCode(parseInt(de.substring(2),16)):String.fromCharCode(+de.substring(1)):""})}var S=/(^|[^\[])\^/g;function v(K,oe){K=K.source||K,oe=oe||"";var de={replace:function(ie,le){return le=le.source||le,le=le.replace(S,"$1"),K=K.replace(ie,le),de},getRegex:function(){return new RegExp(K,oe)}};return de}var _=/[^\w:]/g,p=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function c(K,oe,de){if(K){var Z;try{Z=decodeURIComponent(u(de)).replace(_,"").toLowerCase()}catch(ie){return null}if(Z.indexOf("javascript:")===0||Z.indexOf("vbscript:")===0||Z.indexOf("data:")===0)return null}oe&&!p.test(de)&&(de=r(oe,de));try{de=encodeURI(de).replace(/%25/g,"%")}catch(ie){return null}return de}var l={},t=/^[^:]+:\/*[^/]*$/,i=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(K,oe){l[" "+K]||(t.test(K)?l[" "+K]=K+"/":l[" "+K]=b(K,"/",!0)),K=l[" "+K];var de=K.indexOf(":")===-1;return oe.substring(0,2)==="//"?de?oe:K.replace(i,"$1")+oe:oe.charAt(0)==="/"?de?oe:K.replace(o,"$1")+oe:K+oe}var a={exec:function(){}};function h(K){for(var oe=1,de,Z;oe<arguments.length;oe++){de=arguments[oe];for(Z in de)Object.prototype.hasOwnProperty.call(de,Z)&&(K[Z]=de[Z])}return K}function m(K,oe){var de=K.replace(/\|/g,function(le,ve,ye){for(var We=!1,Ne=ve;--Ne>=0&&ye[Ne]==="\\";)We=!We;return We?"|":" |"}),Z=de.split(/ \|/),ie=0;if(Z.length>oe)Z.splice(oe);else for(;Z.length<oe;)Z.push("");for(;ie<Z.length;ie++)Z[ie]=Z[ie].trim().replace(/\\\|/g,"|");return Z}function b(K,oe,de){var Z=K.length;if(Z===0)return"";for(var ie=0;ie<Z;){var le=K.charAt(Z-ie-1);if(le===oe&&!de)ie++;else if(le!==oe&&de)ie++;else break}return K.substr(0,Z-ie)}function f(K,oe){if(K.indexOf(oe[1])===-1)return-1;for(var de=K.length,Z=0,ie=0;ie<de;ie++)if(K[ie]==="\\")ie++;else if(K[ie]===oe[0])Z++;else if(K[ie]===oe[1]&&(Z--,Z<0))return ie;return-1}function d(K){K&&K.sanitize&&!K.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function A(K,oe){if(oe<1)return"";for(var de="";oe>1;)oe&1&&(de+=K),oe>>=1,K+=K;return de+K}var L={escape:g,unescape:u,edit:v,cleanUrl:c,resolveUrl:r,noopTest:a,merge:h,splitCells:m,rtrim:b,findClosingBracket:f,checkSanitizeDeprecation:d,repeatString:A},B=D.defaults,J=L.rtrim,j=L.splitCells,U=L.escape,$=L.findClosingBracket;function F(K,oe,de){var Z=oe.href,ie=oe.title?U(oe.title):null,le=K[1].replace(/\\([\[\]])/g,"$1");return K[0].charAt(0)!=="!"?{type:"link",raw:de,href:Z,title:ie,text:le}:{type:"image",raw:de,href:Z,title:ie,text:U(le)}}function N(K,oe){var de=K.match(/^(\s+)(?:```)/);if(de===null)return oe;var Z=de[1];return oe.split(`
`).map(function(ie){var le=ie.match(/^\s+/);if(le===null)return ie;var ve=le[0];return ve.length>=Z.length?ie.slice(Z.length):ie}).join(`
`)}var M=function(){function K(de){this.options=de||B}var oe=K.prototype;return oe.space=function(Z){var ie=this.rules.block.newline.exec(Z);if(ie)return ie[0].length>1?{type:"space",raw:ie[0]}:{raw:`
`}},oe.code=function(Z){var ie=this.rules.block.code.exec(Z);if(ie){var le=ie[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ie[0],codeBlockStyle:"indented",text:this.options.pedantic?le:J(le,`
`)}}},oe.fences=function(Z){var ie=this.rules.block.fences.exec(Z);if(ie){var le=ie[0],ve=N(le,ie[3]||"");return{type:"code",raw:le,lang:ie[2]?ie[2].trim():ie[2],text:ve}}},oe.heading=function(Z){var ie=this.rules.block.heading.exec(Z);if(ie){var le=ie[2].trim();if(/#$/.test(le)){var ve=J(le,"#");(this.options.pedantic||!ve||/ $/.test(ve))&&(le=ve.trim())}return{type:"heading",raw:ie[0],depth:ie[1].length,text:le}}},oe.nptable=function(Z){var ie=this.rules.block.nptable.exec(Z);if(ie){var le={type:"table",header:j(ie[1].replace(/^ *| *\| *$/g,"")),align:ie[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ie[3]?ie[3].replace(/\n$/,"").split(`
`):[],raw:ie[0]};if(le.header.length===le.align.length){var ve=le.align.length,ye;for(ye=0;ye<ve;ye++)/^ *-+: *$/.test(le.align[ye])?le.align[ye]="right":/^ *:-+: *$/.test(le.align[ye])?le.align[ye]="center":/^ *:-+ *$/.test(le.align[ye])?le.align[ye]="left":le.align[ye]=null;for(ve=le.cells.length,ye=0;ye<ve;ye++)le.cells[ye]=j(le.cells[ye],le.header.length);return le}}},oe.hr=function(Z){var ie=this.rules.block.hr.exec(Z);if(ie)return{type:"hr",raw:ie[0]}},oe.blockquote=function(Z){var ie=this.rules.block.blockquote.exec(Z);if(ie){var le=ie[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ie[0],text:le}}},oe.list=function(Z){var ie=this.rules.block.list.exec(Z);if(ie){var le=ie[0],ve=ie[2],ye=ve.length>1,We={type:"list",raw:le,ordered:ye,start:ye?+ve.slice(0,-1):"",loose:!1,items:[]},Ne=ie[0].match(this.rules.block.item),qe=!1,Je,et,nt,st,it,Ee,fe,ce,ee=Ne.length;nt=this.rules.block.listItemStart.exec(Ne[0]);for(var Ae=0;Ae<ee;Ae++){if(Je=Ne[Ae],le=Je,Ae!==ee-1){if(st=this.rules.block.listItemStart.exec(Ne[Ae+1]),this.options.pedantic?st[1].length>nt[1].length:st[1].length>nt[0].length||st[1].length>3){Ne.splice(Ae,2,Ne[Ae]+`
`+Ne[Ae+1]),Ae--,ee--;continue}else(!this.options.pedantic||this.options.smartLists?st[2][st[2].length-1]!==ve[ve.length-1]:ye===(st[2].length===1))&&(it=Ne.slice(Ae+1).join(`
`),We.raw=We.raw.substring(0,We.raw.length-it.length),Ae=ee-1);nt=st}et=Je.length,Je=Je.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Je.indexOf(`
 `)&&(et-=Je.length,Je=this.options.pedantic?Je.replace(/^ {1,4}/gm,""):Je.replace(new RegExp("^ {1,"+et+"}","gm"),"")),Ee=qe||/\n\n(?!\s*$)/.test(Je),Ae!==ee-1&&(qe=Je.charAt(Je.length-1)===`
`,Ee||(Ee=qe)),Ee&&(We.loose=!0),this.options.gfm&&(fe=/^\[[ xX]\] /.test(Je),ce=void 0,fe&&(ce=Je[1]!==" ",Je=Je.replace(/^\[[ xX]\] +/,""))),We.items.push({type:"list_item",raw:le,task:fe,checked:ce,loose:Ee,text:Je})}return We}},oe.html=function(Z){var ie=this.rules.block.html.exec(Z);if(ie)return{type:this.options.sanitize?"paragraph":"html",raw:ie[0],pre:!this.options.sanitizer&&(ie[1]==="pre"||ie[1]==="script"||ie[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ie[0]):U(ie[0]):ie[0]}},oe.def=function(Z){var ie=this.rules.block.def.exec(Z);if(ie){ie[3]&&(ie[3]=ie[3].substring(1,ie[3].length-1));var le=ie[1].toLowerCase().replace(/\s+/g," ");return{tag:le,raw:ie[0],href:ie[2],title:ie[3]}}},oe.table=function(Z){var ie=this.rules.block.table.exec(Z);if(ie){var le={type:"table",header:j(ie[1].replace(/^ *| *\| *$/g,"")),align:ie[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ie[3]?ie[3].replace(/\n$/,"").split(`
`):[]};if(le.header.length===le.align.length){le.raw=ie[0];var ve=le.align.length,ye;for(ye=0;ye<ve;ye++)/^ *-+: *$/.test(le.align[ye])?le.align[ye]="right":/^ *:-+: *$/.test(le.align[ye])?le.align[ye]="center":/^ *:-+ *$/.test(le.align[ye])?le.align[ye]="left":le.align[ye]=null;for(ve=le.cells.length,ye=0;ye<ve;ye++)le.cells[ye]=j(le.cells[ye].replace(/^ *\| *| *\| *$/g,""),le.header.length);return le}}},oe.lheading=function(Z){var ie=this.rules.block.lheading.exec(Z);if(ie)return{type:"heading",raw:ie[0],depth:ie[2].charAt(0)==="="?1:2,text:ie[1]}},oe.paragraph=function(Z){var ie=this.rules.block.paragraph.exec(Z);if(ie)return{type:"paragraph",raw:ie[0],text:ie[1].charAt(ie[1].length-1)===`
`?ie[1].slice(0,-1):ie[1]}},oe.text=function(Z){var ie=this.rules.block.text.exec(Z);if(ie)return{type:"text",raw:ie[0],text:ie[0]}},oe.escape=function(Z){var ie=this.rules.inline.escape.exec(Z);if(ie)return{type:"escape",raw:ie[0],text:U(ie[1])}},oe.tag=function(Z,ie,le){var ve=this.rules.inline.tag.exec(Z);if(ve)return!ie&&/^<a /i.test(ve[0])?ie=!0:ie&&/^<\/a>/i.test(ve[0])&&(ie=!1),!le&&/^<(pre|code|kbd|script)(\s|>)/i.test(ve[0])?le=!0:le&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ve[0])&&(le=!1),{type:this.options.sanitize?"text":"html",raw:ve[0],inLink:ie,inRawBlock:le,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ve[0]):U(ve[0]):ve[0]}},oe.link=function(Z){var ie=this.rules.inline.link.exec(Z);if(ie){var le=ie[2].trim();if(!this.options.pedantic&&/^</.test(le)){if(!/>$/.test(le))return;var ve=J(le.slice(0,-1),"\\");if((le.length-ve.length)%2==0)return}else{var ye=$(ie[2],"()");if(ye>-1){var We=ie[0].indexOf("!")===0?5:4,Ne=We+ie[1].length+ye;ie[2]=ie[2].substring(0,ye),ie[0]=ie[0].substring(0,Ne).trim(),ie[3]=""}}var qe=ie[2],Je="";if(this.options.pedantic){var et=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(qe);et&&(qe=et[1],Je=et[3])}else Je=ie[3]?ie[3].slice(1,-1):"";return qe=qe.trim(),/^</.test(qe)&&(this.options.pedantic&&!/>$/.test(le)?qe=qe.slice(1):qe=qe.slice(1,-1)),F(ie,{href:qe&&qe.replace(this.rules.inline._escapes,"$1"),title:Je&&Je.replace(this.rules.inline._escapes,"$1")},ie[0])}},oe.reflink=function(Z,ie){var le;if((le=this.rules.inline.reflink.exec(Z))||(le=this.rules.inline.nolink.exec(Z))){var ve=(le[2]||le[1]).replace(/\s+/g," ");if(ve=ie[ve.toLowerCase()],!ve||!ve.href){var ye=le[0].charAt(0);return{type:"text",raw:ye,text:ye}}return F(le,ve,le[0])}},oe.emStrong=function(Z,ie,le){le===void 0&&(le="");var ve=this.rules.inline.emStrong.lDelim.exec(Z);if(!!ve&&!(ve[3]&&le.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ye=ve[1]||ve[2]||"";if(!ye||ye&&(le===""||this.rules.inline.punctuation.exec(le))){var We=ve[0].length-1,Ne,qe,Je=We,et=0,nt=ve[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(nt.lastIndex=0,ie=ie.slice(-1*Z.length+We);(ve=nt.exec(ie))!=null;)if(Ne=ve[1]||ve[2]||ve[3]||ve[4]||ve[5]||ve[6],!!Ne){if(qe=Ne.length,ve[3]||ve[4]){Je+=qe;continue}else if((ve[5]||ve[6])&&We%3&&!((We+qe)%3)){et+=qe;continue}if(Je-=qe,!(Je>0)){if(Je+et-qe<=0&&!ie.slice(nt.lastIndex).match(nt)&&(qe=Math.min(qe,qe+Je+et)),Math.min(We,qe)%2)return{type:"em",raw:Z.slice(0,We+ve.index+qe+1),text:Z.slice(1,We+ve.index+qe)};if(Math.min(We,qe)%2==0)return{type:"strong",raw:Z.slice(0,We+ve.index+qe+1),text:Z.slice(2,We+ve.index+qe-1)}}}}}},oe.codespan=function(Z){var ie=this.rules.inline.code.exec(Z);if(ie){var le=ie[2].replace(/\n/g," "),ve=/[^ ]/.test(le),ye=/^ /.test(le)&&/ $/.test(le);return ve&&ye&&(le=le.substring(1,le.length-1)),le=U(le,!0),{type:"codespan",raw:ie[0],text:le}}},oe.br=function(Z){var ie=this.rules.inline.br.exec(Z);if(ie)return{type:"br",raw:ie[0]}},oe.del=function(Z){var ie=this.rules.inline.del.exec(Z);if(ie)return{type:"del",raw:ie[0],text:ie[2]}},oe.autolink=function(Z,ie){var le=this.rules.inline.autolink.exec(Z);if(le){var ve,ye;return le[2]==="@"?(ve=U(this.options.mangle?ie(le[1]):le[1]),ye="mailto:"+ve):(ve=U(le[1]),ye=ve),{type:"link",raw:le[0],text:ve,href:ye,tokens:[{type:"text",raw:ve,text:ve}]}}},oe.url=function(Z,ie){var le;if(le=this.rules.inline.url.exec(Z)){var ve,ye;if(le[2]==="@")ve=U(this.options.mangle?ie(le[0]):le[0]),ye="mailto:"+ve;else{var We;do We=le[0],le[0]=this.rules.inline._backpedal.exec(le[0])[0];while(We!==le[0]);ve=U(le[0]),le[1]==="www."?ye="http://"+ve:ye=ve}return{type:"link",raw:le[0],text:ve,href:ye,tokens:[{type:"text",raw:ve,text:ve}]}}},oe.inlineText=function(Z,ie,le){var ve=this.rules.inline.text.exec(Z);if(ve){var ye;return ie?ye=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ve[0]):U(ve[0]):ve[0]:ye=U(this.options.smartypants?le(ve[0]):ve[0]),{type:"text",raw:ve[0],text:ye}}},K}(),x=L.noopTest,O=L.edit,V=L.merge,q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:x,table:x,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};q._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,q.def=O(q.def).replace("label",q._label).replace("title",q._title).getRegex(),q.bullet=/(?:[*+-]|\d{1,9}[.)])/,q.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,q.item=O(q.item,"gm").replace(/bull/g,q.bullet).getRegex(),q.listItemStart=O(/^( *)(bull)/).replace("bull",q.bullet).getRegex(),q.list=O(q.list).replace(/bull/g,q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+q.def.source+")").getRegex(),q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,q.html=O(q.html,"i").replace("comment",q._comment).replace("tag",q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),q.paragraph=O(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",q._tag).getRegex(),q.blockquote=O(q.blockquote).replace("paragraph",q.paragraph).getRegex(),q.normal=V({},q),q.gfm=V({},q.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),q.gfm.nptable=O(q.gfm.nptable).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",q._tag).getRegex(),q.gfm.table=O(q.gfm.table).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",q._tag).getRegex(),q.pedantic=V({},q.normal,{html:O(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:x,paragraph:O(q.normal._paragraph).replace("hr",q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var X={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:x,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:x,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};X._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",X.punctuation=O(X.punctuation).replace(/punctuation/g,X._punctuation).getRegex(),X.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,X.escapedEmSt=/\\\*|\\_/g,X._comment=O(q._comment).replace("(?:-->|$)","-->").getRegex(),X.emStrong.lDelim=O(X.emStrong.lDelim).replace(/punct/g,X._punctuation).getRegex(),X.emStrong.rDelimAst=O(X.emStrong.rDelimAst,"g").replace(/punct/g,X._punctuation).getRegex(),X.emStrong.rDelimUnd=O(X.emStrong.rDelimUnd,"g").replace(/punct/g,X._punctuation).getRegex(),X._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,X._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,X._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,X.autolink=O(X.autolink).replace("scheme",X._scheme).replace("email",X._email).getRegex(),X._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,X.tag=O(X.tag).replace("comment",X._comment).replace("attribute",X._attribute).getRegex(),X._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,X._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,X._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,X.link=O(X.link).replace("label",X._label).replace("href",X._href).replace("title",X._title).getRegex(),X.reflink=O(X.reflink).replace("label",X._label).getRegex(),X.reflinkSearch=O(X.reflinkSearch,"g").replace("reflink",X.reflink).replace("nolink",X.nolink).getRegex(),X.normal=V({},X),X.pedantic=V({},X.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:O(/^!?\[(label)\]\((.*?)\)/).replace("label",X._label).getRegex(),reflink:O(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",X._label).getRegex()}),X.gfm=V({},X.normal,{escape:O(X.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),X.gfm.url=O(X.gfm.url,"i").replace("email",X.gfm._extended_email).getRegex(),X.breaks=V({},X.gfm,{br:O(X.br).replace("{2,}","*").getRegex(),text:O(X.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var me={block:q,inline:X},we=D.defaults,Te=me.block,Pe=me.inline,Fe=L.repeatString;function z(K){return K.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Y(K){var oe="",de,Z,ie=K.length;for(de=0;de<ie;de++)Z=K.charCodeAt(de),Math.random()>.5&&(Z="x"+Z.toString(16)),oe+="&#"+Z+";";return oe}var te=function(){function K(de){this.tokens=[],this.tokens.links=Object.create(null),this.options=de||we,this.options.tokenizer=this.options.tokenizer||new M,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var Z={block:Te.normal,inline:Pe.normal};this.options.pedantic?(Z.block=Te.pedantic,Z.inline=Pe.pedantic):this.options.gfm&&(Z.block=Te.gfm,this.options.breaks?Z.inline=Pe.breaks:Z.inline=Pe.gfm),this.tokenizer.rules=Z}K.lex=function(Z,ie){var le=new K(ie);return le.lex(Z)},K.lexInline=function(Z,ie){var le=new K(ie);return le.inlineTokens(Z)};var oe=K.prototype;return oe.lex=function(Z){return Z=Z.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(Z,this.tokens,!0),this.inline(this.tokens),this.tokens},oe.blockTokens=function(Z,ie,le){ie===void 0&&(ie=[]),le===void 0&&(le=!0),this.options.pedantic&&(Z=Z.replace(/^ +$/gm,""));for(var ve,ye,We,Ne;Z;){if(ve=this.tokenizer.space(Z)){Z=Z.substring(ve.raw.length),ve.type&&ie.push(ve);continue}if(ve=this.tokenizer.code(Z)){Z=Z.substring(ve.raw.length),Ne=ie[ie.length-1],Ne&&Ne.type==="paragraph"?(Ne.raw+=`
`+ve.raw,Ne.text+=`
`+ve.text):ie.push(ve);continue}if(ve=this.tokenizer.fences(Z)){Z=Z.substring(ve.raw.length),ie.push(ve);continue}if(ve=this.tokenizer.heading(Z)){Z=Z.substring(ve.raw.length),ie.push(ve);continue}if(ve=this.tokenizer.nptable(Z)){Z=Z.substring(ve.raw.length),ie.push(ve);continue}if(ve=this.tokenizer.hr(Z)){Z=Z.substring(ve.raw.length),ie.push(ve);continue}if(ve=this.tokenizer.blockquote(Z)){Z=Z.substring(ve.raw.length),ve.tokens=this.blockTokens(ve.text,[],le),ie.push(ve);continue}if(ve=this.tokenizer.list(Z)){for(Z=Z.substring(ve.raw.length),We=ve.items.length,ye=0;ye<We;ye++)ve.items[ye].tokens=this.blockTokens(ve.items[ye].text,[],!1);ie.push(ve);continue}if(ve=this.tokenizer.html(Z)){Z=Z.substring(ve.raw.length),ie.push(ve);continue}if(le&&(ve=this.tokenizer.def(Z))){Z=Z.substring(ve.raw.length),this.tokens.links[ve.tag]||(this.tokens.links[ve.tag]={href:ve.href,title:ve.title});continue}if(ve=this.tokenizer.table(Z)){Z=Z.substring(ve.raw.length),ie.push(ve);continue}if(ve=this.tokenizer.lheading(Z)){Z=Z.substring(ve.raw.length),ie.push(ve);continue}if(le&&(ve=this.tokenizer.paragraph(Z))){Z=Z.substring(ve.raw.length),ie.push(ve);continue}if(ve=this.tokenizer.text(Z)){Z=Z.substring(ve.raw.length),Ne=ie[ie.length-1],Ne&&Ne.type==="text"?(Ne.raw+=`
`+ve.raw,Ne.text+=`
`+ve.text):ie.push(ve);continue}if(Z){var qe="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(qe);break}else throw new Error(qe)}}return ie},oe.inline=function(Z){var ie,le,ve,ye,We,Ne,qe=Z.length;for(ie=0;ie<qe;ie++)switch(Ne=Z[ie],Ne.type){case"paragraph":case"text":case"heading":{Ne.tokens=[],this.inlineTokens(Ne.text,Ne.tokens);break}case"table":{for(Ne.tokens={header:[],cells:[]},ye=Ne.header.length,le=0;le<ye;le++)Ne.tokens.header[le]=[],this.inlineTokens(Ne.header[le],Ne.tokens.header[le]);for(ye=Ne.cells.length,le=0;le<ye;le++)for(We=Ne.cells[le],Ne.tokens.cells[le]=[],ve=0;ve<We.length;ve++)Ne.tokens.cells[le][ve]=[],this.inlineTokens(We[ve],Ne.tokens.cells[le][ve]);break}case"blockquote":{this.inline(Ne.tokens);break}case"list":{for(ye=Ne.items.length,le=0;le<ye;le++)this.inline(Ne.items[le].tokens);break}}return Z},oe.inlineTokens=function(Z,ie,le,ve){ie===void 0&&(ie=[]),le===void 0&&(le=!1),ve===void 0&&(ve=!1);var ye,We,Ne=Z,qe,Je,et;if(this.tokens.links){var nt=Object.keys(this.tokens.links);if(nt.length>0)for(;(qe=this.tokenizer.rules.inline.reflinkSearch.exec(Ne))!=null;)nt.includes(qe[0].slice(qe[0].lastIndexOf("[")+1,-1))&&(Ne=Ne.slice(0,qe.index)+"["+Fe("a",qe[0].length-2)+"]"+Ne.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(qe=this.tokenizer.rules.inline.blockSkip.exec(Ne))!=null;)Ne=Ne.slice(0,qe.index)+"["+Fe("a",qe[0].length-2)+"]"+Ne.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(qe=this.tokenizer.rules.inline.escapedEmSt.exec(Ne))!=null;)Ne=Ne.slice(0,qe.index)+"++"+Ne.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Z;){if(Je||(et=""),Je=!1,ye=this.tokenizer.escape(Z)){Z=Z.substring(ye.raw.length),ie.push(ye);continue}if(ye=this.tokenizer.tag(Z,le,ve)){Z=Z.substring(ye.raw.length),le=ye.inLink,ve=ye.inRawBlock;var st=ie[ie.length-1];st&&ye.type==="text"&&st.type==="text"?(st.raw+=ye.raw,st.text+=ye.text):ie.push(ye);continue}if(ye=this.tokenizer.link(Z)){Z=Z.substring(ye.raw.length),ye.type==="link"&&(ye.tokens=this.inlineTokens(ye.text,[],!0,ve)),ie.push(ye);continue}if(ye=this.tokenizer.reflink(Z,this.tokens.links)){Z=Z.substring(ye.raw.length);var it=ie[ie.length-1];ye.type==="link"?(ye.tokens=this.inlineTokens(ye.text,[],!0,ve),ie.push(ye)):it&&ye.type==="text"&&it.type==="text"?(it.raw+=ye.raw,it.text+=ye.text):ie.push(ye);continue}if(ye=this.tokenizer.emStrong(Z,Ne,et)){Z=Z.substring(ye.raw.length),ye.tokens=this.inlineTokens(ye.text,[],le,ve),ie.push(ye);continue}if(ye=this.tokenizer.codespan(Z)){Z=Z.substring(ye.raw.length),ie.push(ye);continue}if(ye=this.tokenizer.br(Z)){Z=Z.substring(ye.raw.length),ie.push(ye);continue}if(ye=this.tokenizer.del(Z)){Z=Z.substring(ye.raw.length),ye.tokens=this.inlineTokens(ye.text,[],le,ve),ie.push(ye);continue}if(ye=this.tokenizer.autolink(Z,Y)){Z=Z.substring(ye.raw.length),ie.push(ye);continue}if(!le&&(ye=this.tokenizer.url(Z,Y))){Z=Z.substring(ye.raw.length),ie.push(ye);continue}if(ye=this.tokenizer.inlineText(Z,ve,z)){Z=Z.substring(ye.raw.length),ye.raw.slice(-1)!=="_"&&(et=ye.raw.slice(-1)),Je=!0,We=ie[ie.length-1],We&&We.type==="text"?(We.raw+=ye.raw,We.text+=ye.text):ie.push(ye);continue}if(Z){var Ee="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(Ee);break}else throw new Error(Ee)}}return ie},e(K,null,[{key:"rules",get:function(){return{block:Te,inline:Pe}}}]),K}(),ae=D.defaults,he=L.cleanUrl,Ce=L.escape,Oe=function(){function K(de){this.options=de||ae}var oe=K.prototype;return oe.code=function(Z,ie,le){var ve=(ie||"").match(/\S*/)[0];if(this.options.highlight){var ye=this.options.highlight(Z,ve);ye!=null&&ye!==Z&&(le=!0,Z=ye)}return Z=Z.replace(/\n$/,"")+`
`,ve?'<pre><code class="'+this.options.langPrefix+Ce(ve,!0)+'">'+(le?Z:Ce(Z,!0))+`</code></pre>
`:"<pre><code>"+(le?Z:Ce(Z,!0))+`</code></pre>
`},oe.blockquote=function(Z){return`<blockquote>
`+Z+`</blockquote>
`},oe.html=function(Z){return Z},oe.heading=function(Z,ie,le,ve){return this.options.headerIds?"<h"+ie+' id="'+this.options.headerPrefix+ve.slug(le)+'">'+Z+"</h"+ie+`>
`:"<h"+ie+">"+Z+"</h"+ie+`>
`},oe.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},oe.list=function(Z,ie,le){var ve=ie?"ol":"ul",ye=ie&&le!==1?' start="'+le+'"':"";return"<"+ve+ye+`>
`+Z+"</"+ve+`>
`},oe.listitem=function(Z){return"<li>"+Z+`</li>
`},oe.checkbox=function(Z){return"<input "+(Z?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},oe.paragraph=function(Z){return"<p>"+Z+`</p>
`},oe.table=function(Z,ie){return ie&&(ie="<tbody>"+ie+"</tbody>"),`<table>
<thead>
`+Z+`</thead>
`+ie+`</table>
`},oe.tablerow=function(Z){return`<tr>
`+Z+`</tr>
`},oe.tablecell=function(Z,ie){var le=ie.header?"th":"td",ve=ie.align?"<"+le+' align="'+ie.align+'">':"<"+le+">";return ve+Z+"</"+le+`>
`},oe.strong=function(Z){return"<strong>"+Z+"</strong>"},oe.em=function(Z){return"<em>"+Z+"</em>"},oe.codespan=function(Z){return"<code>"+Z+"</code>"},oe.br=function(){return this.options.xhtml?"<br/>":"<br>"},oe.del=function(Z){return"<del>"+Z+"</del>"},oe.link=function(Z,ie,le){if(Z=he(this.options.sanitize,this.options.baseUrl,Z),Z===null)return le;var ve='<a href="'+Ce(Z)+'"';return ie&&(ve+=' title="'+ie+'"'),ve+=">"+le+"</a>",ve},oe.image=function(Z,ie,le){if(Z=he(this.options.sanitize,this.options.baseUrl,Z),Z===null)return le;var ve='<img src="'+Z+'" alt="'+le+'"';return ie&&(ve+=' title="'+ie+'"'),ve+=this.options.xhtml?"/>":">",ve},oe.text=function(Z){return Z},K}(),be=function(){function K(){}var oe=K.prototype;return oe.strong=function(Z){return Z},oe.em=function(Z){return Z},oe.codespan=function(Z){return Z},oe.del=function(Z){return Z},oe.html=function(Z){return Z},oe.text=function(Z){return Z},oe.link=function(Z,ie,le){return""+le},oe.image=function(Z,ie,le){return""+le},oe.br=function(){return""},K}(),ke=function(){function K(){this.seen={}}var oe=K.prototype;return oe.serialize=function(Z){return Z.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},oe.getNextSafeSlug=function(Z,ie){var le=Z,ve=0;if(this.seen.hasOwnProperty(le)){ve=this.seen[Z];do ve++,le=Z+"-"+ve;while(this.seen.hasOwnProperty(le))}return ie||(this.seen[Z]=ve,this.seen[le]=0),le},oe.slug=function(Z,ie){ie===void 0&&(ie={});var le=this.serialize(Z);return this.getNextSafeSlug(le,ie.dryrun)},K}(),Re=D.defaults,Be=L.unescape,Se=function(){function K(de){this.options=de||Re,this.options.renderer=this.options.renderer||new Oe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new be,this.slugger=new ke}K.parse=function(Z,ie){var le=new K(ie);return le.parse(Z)},K.parseInline=function(Z,ie){var le=new K(ie);return le.parseInline(Z)};var oe=K.prototype;return oe.parse=function(Z,ie){ie===void 0&&(ie=!0);var le="",ve,ye,We,Ne,qe,Je,et,nt,st,it,Ee,fe,ce,ee,Ae,Le,Qe,Ge,rt=Z.length;for(ve=0;ve<rt;ve++)switch(it=Z[ve],it.type){case"space":continue;case"hr":{le+=this.renderer.hr();continue}case"heading":{le+=this.renderer.heading(this.parseInline(it.tokens),it.depth,Be(this.parseInline(it.tokens,this.textRenderer)),this.slugger);continue}case"code":{le+=this.renderer.code(it.text,it.lang,it.escaped);continue}case"table":{for(nt="",et="",Ne=it.header.length,ye=0;ye<Ne;ye++)et+=this.renderer.tablecell(this.parseInline(it.tokens.header[ye]),{header:!0,align:it.align[ye]});for(nt+=this.renderer.tablerow(et),st="",Ne=it.cells.length,ye=0;ye<Ne;ye++){for(Je=it.tokens.cells[ye],et="",qe=Je.length,We=0;We<qe;We++)et+=this.renderer.tablecell(this.parseInline(Je[We]),{header:!1,align:it.align[We]});st+=this.renderer.tablerow(et)}le+=this.renderer.table(nt,st);continue}case"blockquote":{st=this.parse(it.tokens),le+=this.renderer.blockquote(st);continue}case"list":{for(Ee=it.ordered,fe=it.start,ce=it.loose,Ne=it.items.length,st="",ye=0;ye<Ne;ye++)Ae=it.items[ye],Le=Ae.checked,Qe=Ae.task,ee="",Ae.task&&(Ge=this.renderer.checkbox(Le),ce?Ae.tokens.length>0&&Ae.tokens[0].type==="text"?(Ae.tokens[0].text=Ge+" "+Ae.tokens[0].text,Ae.tokens[0].tokens&&Ae.tokens[0].tokens.length>0&&Ae.tokens[0].tokens[0].type==="text"&&(Ae.tokens[0].tokens[0].text=Ge+" "+Ae.tokens[0].tokens[0].text)):Ae.tokens.unshift({type:"text",text:Ge}):ee+=Ge),ee+=this.parse(Ae.tokens,ce),st+=this.renderer.listitem(ee,Qe,Le);le+=this.renderer.list(st,Ee,fe);continue}case"html":{le+=this.renderer.html(it.text);continue}case"paragraph":{le+=this.renderer.paragraph(this.parseInline(it.tokens));continue}case"text":{for(st=it.tokens?this.parseInline(it.tokens):it.text;ve+1<rt&&Z[ve+1].type==="text";)it=Z[++ve],st+=`
`+(it.tokens?this.parseInline(it.tokens):it.text);le+=ie?this.renderer.paragraph(st):st;continue}default:{var ut='Token with "'+it.type+'" type was not found.';if(this.options.silent){console.error(ut);return}else throw new Error(ut)}}return le},oe.parseInline=function(Z,ie){ie=ie||this.renderer;var le="",ve,ye,We=Z.length;for(ve=0;ve<We;ve++)switch(ye=Z[ve],ye.type){case"escape":{le+=ie.text(ye.text);break}case"html":{le+=ie.html(ye.text);break}case"link":{le+=ie.link(ye.href,ye.title,this.parseInline(ye.tokens,ie));break}case"image":{le+=ie.image(ye.href,ye.title,ye.text);break}case"strong":{le+=ie.strong(this.parseInline(ye.tokens,ie));break}case"em":{le+=ie.em(this.parseInline(ye.tokens,ie));break}case"codespan":{le+=ie.codespan(ye.text);break}case"br":{le+=ie.br();break}case"del":{le+=ie.del(this.parseInline(ye.tokens,ie));break}case"text":{le+=ie.text(ye.text);break}default:{var Ne='Token with "'+ye.type+'" type was not found.';if(this.options.silent){console.error(Ne);return}else throw new Error(Ne)}}return le},K}(),Ke=L.merge,Q=L.checkSanitizeDeprecation,se=L.escape,_e=D.getDefaults,xe=D.changeDefaults,Ve=D.defaults;function $e(K,oe,de){if(typeof K=="undefined"||K===null)throw new Error("marked(): input parameter is undefined or null");if(typeof K!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(K)+", string expected");if(typeof oe=="function"&&(de=oe,oe=null),oe=Ke({},$e.defaults,oe||{}),Q(oe),de){var Z=oe.highlight,ie;try{ie=te.lex(K,oe)}catch(We){return de(We)}var le=function(Ne){var qe;if(!Ne)try{qe=Se.parse(ie,oe)}catch(Je){Ne=Je}return oe.highlight=Z,Ne?de(Ne):de(null,qe)};if(!Z||Z.length<3||(delete oe.highlight,!ie.length))return le();var ve=0;$e.walkTokens(ie,function(We){We.type==="code"&&(ve++,setTimeout(function(){Z(We.text,We.lang,function(Ne,qe){if(Ne)return le(Ne);qe!=null&&qe!==We.text&&(We.text=qe,We.escaped=!0),ve--,ve===0&&le()})},0))}),ve===0&&le();return}try{var ye=te.lex(K,oe);return oe.walkTokens&&$e.walkTokens(ye,oe.walkTokens),Se.parse(ye,oe)}catch(We){if(We.message+=`
Please report this to https://github.com/markedjs/marked.`,oe.silent)return"<p>An error occurred:</p><pre>"+se(We.message+"",!0)+"</pre>";throw We}}$e.options=$e.setOptions=function(K){return Ke($e.defaults,K),xe($e.defaults),$e},$e.getDefaults=_e,$e.defaults=Ve,$e.use=function(K){var oe=Ke({},K);if(K.renderer&&function(){var Z=$e.defaults.renderer||new Oe,ie=function(ye){var We=Z[ye];Z[ye]=function(){for(var Ne=arguments.length,qe=new Array(Ne),Je=0;Je<Ne;Je++)qe[Je]=arguments[Je];var et=K.renderer[ye].apply(Z,qe);return et===!1&&(et=We.apply(Z,qe)),et}};for(var le in K.renderer)ie(le);oe.renderer=Z}(),K.tokenizer&&function(){var Z=$e.defaults.tokenizer||new M,ie=function(ye){var We=Z[ye];Z[ye]=function(){for(var Ne=arguments.length,qe=new Array(Ne),Je=0;Je<Ne;Je++)qe[Je]=arguments[Je];var et=K.tokenizer[ye].apply(Z,qe);return et===!1&&(et=We.apply(Z,qe)),et}};for(var le in K.tokenizer)ie(le);oe.tokenizer=Z}(),K.walkTokens){var de=$e.defaults.walkTokens;oe.walkTokens=function(Z){K.walkTokens(Z),de&&de(Z)}}$e.setOptions(oe)},$e.walkTokens=function(K,oe){for(var de=T(K),Z;!(Z=de()).done;){var ie=Z.value;switch(oe(ie),ie.type){case"table":{for(var le=T(ie.tokens.header),ve;!(ve=le()).done;){var ye=ve.value;$e.walkTokens(ye,oe)}for(var We=T(ie.tokens.cells),Ne;!(Ne=We()).done;)for(var qe=Ne.value,Je=T(qe),et;!(et=Je()).done;){var nt=et.value;$e.walkTokens(nt,oe)}break}case"list":{$e.walkTokens(ie.items,oe);break}default:ie.tokens&&$e.walkTokens(ie.tokens,oe)}}},$e.parseInline=function(K,oe){if(typeof K=="undefined"||K===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof K!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(K)+", string expected");oe=Ke({},$e.defaults,oe||{}),Q(oe);try{var de=te.lexInline(K,oe);return oe.walkTokens&&$e.walkTokens(de,oe.walkTokens),Se.parseInline(de,oe)}catch(Z){if(Z.message+=`
Please report this to https://github.com/markedjs/marked.`,oe.silent)return"<p>An error occurred:</p><pre>"+se(Z.message+"",!0)+"</pre>";throw Z}},$e.Parser=Se,$e.parser=Se.parse,$e.Renderer=Oe,$e.TextRenderer=be,$e.Lexer=te,$e.lexer=te.lex,$e.Tokenizer=M,$e.Slugger=ke,$e.parse=$e;var Ze=$e;return Ze}),define(ge[72],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function E(D,k,y){return Math.min(Math.max(D,k),y)}e.clamp=E;function P(D,k){return(k+D%k)%k}e.rot=P;class T{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=T;class I{constructor(){this._n=1,this._val=0}update(k){return this._val=this._val+(k-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=I});"use strict";(function(){function G(T){const I=[];typeof T=="number"&&I.push("code/timeOrigin",T);function D(y){I.push(y,Date.now())}function k(){const y=[];for(let n=0;n<I.length;n+=2)y.push({name:I[n],startTime:I[n+1]});return y}return{mark:D,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?G():{mark(T){performance.mark(T)},getMarks(){let T=performance.timeOrigin;typeof T!="number"&&(T=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const I=[{name:"code/timeOrigin",startTime:Math.round(T)}];for(const D of performance.getEntriesByType("mark"))I.push({name:D.name,startTime:Math.round(T+D.startTime)});return I}};if(typeof process=="object"){const T=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return G(T)}else return console.trace("perf-util loaded in UNKNOWN environment"),G()}function E(T){return T.MonacoPerformanceMarks||(T.MonacoPerformanceMarks=e()),T.MonacoPerformanceMarks}var P;typeof global=="object"?P=global:typeof self=="object"?P=self:P={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(P)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(P):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),P.perf=E(P))})(),define(ge[9],pe([0,1]),function(G,e){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const P="en";let T=!1,I=!1,D=!1,k=!1,y=!1,n=!1,R=!1,C,w=P,g,s;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode!="undefined"?u=e.globals.vscode.process:typeof process!="undefined"&&(u=process);const S=typeof((E=u==null?void 0:u.versions)===null||E===void 0?void 0:E.electron)=="string"&&u.type==="renderer";if(e.isElectronSandboxed=S&&(u==null?void 0:u.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const r=u==null?void 0:u.env.VSCODE_BROWSER_CODE_LOADING;if(typeof r=="string")return r==="none"||r==="code"||r==="bypassHeatCheck"||r==="bypassHeatCheckAndEagerCompile"?r:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!S)s=navigator.userAgent,T=s.indexOf("Windows")>=0,I=s.indexOf("Macintosh")>=0,R=(s.indexOf("Macintosh")>=0||s.indexOf("iPad")>=0||s.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,D=s.indexOf("Linux")>=0,n=!0,C=navigator.language,w=C;else if(typeof u=="object"){T=u.platform==="win32",I=u.platform==="darwin",D=u.platform==="linux",k=D&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,C=P,w=P;const r=u.env.VSCODE_NLS_CONFIG;if(r)try{const a=JSON.parse(r),h=a.availableLanguages["*"];C=a.locale,w=h||P,g=a._translationsConfigFile}catch(a){}y=!0}else console.error("Unable to resolve platform.");var v;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(v=e.Platform||(e.Platform={}));function _(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=_;let p=0;I?p=1:T?p=3:D&&(p=2),e.isWindows=T,e.isMacintosh=I,e.isLinux=D,e.isLinuxSnap=k,e.isNative=y,e.isWeb=n,e.isIOS=R,e.platform=p,e.userAgent=s,e.language=w;var c;(function(r){function a(){return e.language}r.value=a;function h(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=h;function m(){return e.language==="en"}r.isDefault=m})(c=e.Language||(e.Language={})),e.locale=C,e.translationsConfigFile=g,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let h=[];e.globals.addEventListener("message",b=>{if(b.data&&b.data.vscodeSetImmediateId)for(let f=0,d=h.length;f<d;f++){const A=h[f];if(A.id===b.data.vscodeSetImmediateId){h.splice(f,1),A.callback();return}}});let m=0;return b=>{const f=++m;h.push({id:f,callback:b}),e.globals.postMessage({vscodeSetImmediateId:f},"*")}}if(typeof(u==null?void 0:u.nextTick)=="function")return u.nextTick.bind(u);const a=Promise.resolve();return h=>a.then(h)}();var l;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(l=e.OperatingSystem||(e.OperatingSystem={})),e.OS=I||R?2:T?1:3;let t=!0,i=!1;function o(){if(!i){i=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,t=new Uint16Array(r.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=o}),define(ge[36],pe([0,1,9]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let P;if(typeof E.globals.vscode!="undefined"){const T=E.globals.vscode.process;P={get platform(){return T.platform},get env(){return T.env},cwd(){return T.cwd()},nextTick(I){return(0,E.setImmediate)(I)}}}else typeof process!="undefined"?P={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(T){return process.nextTick(T)}}:P={get platform(){return E.isWindows?"win32":E.isMacintosh?"darwin":"linux"},nextTick(T){return(0,E.setImmediate)(T)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=P.cwd,e.env=P.env,e.platform=P.platform,e.nextTick=P.nextTick}),define(ge[8],pe([0,1,36]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const P=65,T=97,I=90,D=122,k=46,y=47,n=92,R=58,C=63;class w extends Error{constructor(c,l,t){let i;typeof l=="string"&&l.indexOf("not ")===0?(i="must not be",l=l.replace(/^not /,"")):i="must be";const o=c.indexOf(".")!==-1?"property":"argument";let r=`The "${c}" ${o} ${i} of type ${l}`;r+=`. Received type ${typeof t}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function g(p,c){if(typeof p!="string")throw new w(c,"string",p)}function s(p){return p===y||p===n}function u(p){return p===y}function S(p){return p>=P&&p<=I||p>=T&&p<=D}function v(p,c,l,t){let i="",o=0,r=-1,a=0,h=0;for(let m=0;m<=p.length;++m){if(m<p.length)h=p.charCodeAt(m);else{if(t(h))break;h=y}if(t(h)){if(!(r===m-1||a===1))if(a===2){if(i.length<2||o!==2||i.charCodeAt(i.length-1)!==k||i.charCodeAt(i.length-2)!==k){if(i.length>2){const b=i.lastIndexOf(l);b===-1?(i="",o=0):(i=i.slice(0,b),o=i.length-1-i.lastIndexOf(l)),r=m,a=0;continue}else if(i.length!==0){i="",o=0,r=m,a=0;continue}}c&&(i+=i.length>0?`${l}..`:"..",o=2)}else i.length>0?i+=`${l}${p.slice(r+1,m)}`:i=p.slice(r+1,m),o=m-r-1;r=m,a=0}else h===k&&a!==-1?++a:a=-1}return i}function _(p,c){if(c===null||typeof c!="object")throw new w("pathObject","Object",c);const l=c.dir||c.root,t=c.base||`${c.name||""}${c.ext||""}`;return l?l===c.root?`${l}${t}`:`${l}${p}${t}`:t}e.win32={resolve(...p){let c="",l="",t=!1;for(let i=p.length-1;i>=-1;i--){let o;if(i>=0){if(o=p[i],g(o,"path"),o.length===0)continue}else c.length===0?o=E.cwd():(o=E.env[`=${c}`]||E.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==c.toLowerCase()&&o.charCodeAt(2)===n)&&(o=`${c}\\`));const r=o.length;let a=0,h="",m=!1;const b=o.charCodeAt(0);if(r===1)s(b)&&(a=1,m=!0);else if(s(b))if(m=!0,s(o.charCodeAt(1))){let f=2,d=f;for(;f<r&&!s(o.charCodeAt(f));)f++;if(f<r&&f!==d){const A=o.slice(d,f);for(d=f;f<r&&s(o.charCodeAt(f));)f++;if(f<r&&f!==d){for(d=f;f<r&&!s(o.charCodeAt(f));)f++;(f===r||f!==d)&&(h=`\\\\${A}\\${o.slice(d,f)}`,a=f)}}}else a=1;else S(b)&&o.charCodeAt(1)===R&&(h=o.slice(0,2),a=2,r>2&&s(o.charCodeAt(2))&&(m=!0,a=3));if(h.length>0)if(c.length>0){if(h.toLowerCase()!==c.toLowerCase())continue}else c=h;if(t){if(c.length>0)break}else if(l=`${o.slice(a)}\\${l}`,t=m,m&&c.length>0)break}return l=v(l,!t,"\\",s),t?`${c}\\${l}`:`${c}${l}`||"."},normalize(p){g(p,"path");const c=p.length;if(c===0)return".";let l=0,t,i=!1;const o=p.charCodeAt(0);if(c===1)return u(o)?"\\":p;if(s(o))if(i=!0,s(p.charCodeAt(1))){let a=2,h=a;for(;a<c&&!s(p.charCodeAt(a));)a++;if(a<c&&a!==h){const m=p.slice(h,a);for(h=a;a<c&&s(p.charCodeAt(a));)a++;if(a<c&&a!==h){for(h=a;a<c&&!s(p.charCodeAt(a));)a++;if(a===c)return`\\\\${m}\\${p.slice(h)}\\`;a!==h&&(t=`\\\\${m}\\${p.slice(h,a)}`,l=a)}}}else l=1;else S(o)&&p.charCodeAt(1)===R&&(t=p.slice(0,2),l=2,c>2&&s(p.charCodeAt(2))&&(i=!0,l=3));let r=l<c?v(p.slice(l),!i,"\\",s):"";return r.length===0&&!i&&(r="."),r.length>0&&s(p.charCodeAt(c-1))&&(r+="\\"),t===void 0?i?`\\${r}`:r:i?`${t}\\${r}`:`${t}${r}`},isAbsolute(p){g(p,"path");const c=p.length;if(c===0)return!1;const l=p.charCodeAt(0);return s(l)||c>2&&S(l)&&p.charCodeAt(1)===R&&s(p.charCodeAt(2))},join(...p){if(p.length===0)return".";let c,l;for(let o=0;o<p.length;++o){const r=p[o];g(r,"path"),r.length>0&&(c===void 0?c=l=r:c+=`\\${r}`)}if(c===void 0)return".";let t=!0,i=0;if(typeof l=="string"&&s(l.charCodeAt(0))){++i;const o=l.length;o>1&&s(l.charCodeAt(1))&&(++i,o>2&&(s(l.charCodeAt(2))?++i:t=!1))}if(t){for(;i<c.length&&s(c.charCodeAt(i));)i++;i>=2&&(c=`\\${c.slice(i)}`)}return e.win32.normalize(c)},relative(p,c){if(g(p,"from"),g(c,"to"),p===c)return"";const l=e.win32.resolve(p),t=e.win32.resolve(c);if(l===t||(p=l.toLowerCase(),c=t.toLowerCase(),p===c))return"";let i=0;for(;i<p.length&&p.charCodeAt(i)===n;)i++;let o=p.length;for(;o-1>i&&p.charCodeAt(o-1)===n;)o--;const r=o-i;let a=0;for(;a<c.length&&c.charCodeAt(a)===n;)a++;let h=c.length;for(;h-1>a&&c.charCodeAt(h-1)===n;)h--;const m=h-a,b=r<m?r:m;let f=-1,d=0;for(;d<b;d++){const L=p.charCodeAt(i+d);if(L!==c.charCodeAt(a+d))break;L===n&&(f=d)}if(d!==b){if(f===-1)return t}else{if(m>b){if(c.charCodeAt(a+d)===n)return t.slice(a+d+1);if(d===2)return t.slice(a+d)}r>b&&(p.charCodeAt(i+d)===n?f=d:d===2&&(f=3)),f===-1&&(f=0)}let A="";for(d=i+f+1;d<=o;++d)(d===o||p.charCodeAt(d)===n)&&(A+=A.length===0?"..":"\\..");return a+=f,A.length>0?`${A}${t.slice(a,h)}`:(t.charCodeAt(a)===n&&++a,t.slice(a,h))},toNamespacedPath(p){if(typeof p!="string")return p;if(p.length===0)return"";const c=e.win32.resolve(p);if(c.length<=2)return p;if(c.charCodeAt(0)===n){if(c.charCodeAt(1)===n){const l=c.charCodeAt(2);if(l!==C&&l!==k)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(S(c.charCodeAt(0))&&c.charCodeAt(1)===R&&c.charCodeAt(2)===n)return`\\\\?\\${c}`;return p},dirname(p){g(p,"path");const c=p.length;if(c===0)return".";let l=-1,t=0;const i=p.charCodeAt(0);if(c===1)return s(i)?p:".";if(s(i)){if(l=t=1,s(p.charCodeAt(1))){let a=2,h=a;for(;a<c&&!s(p.charCodeAt(a));)a++;if(a<c&&a!==h){for(h=a;a<c&&s(p.charCodeAt(a));)a++;if(a<c&&a!==h){for(h=a;a<c&&!s(p.charCodeAt(a));)a++;if(a===c)return p;a!==h&&(l=t=a+1)}}}}else S(i)&&p.charCodeAt(1)===R&&(l=c>2&&s(p.charCodeAt(2))?3:2,t=l);let o=-1,r=!0;for(let a=c-1;a>=t;--a)if(s(p.charCodeAt(a))){if(!r){o=a;break}}else r=!1;if(o===-1){if(l===-1)return".";o=l}return p.slice(0,o)},basename(p,c){c!==void 0&&g(c,"ext"),g(p,"path");let l=0,t=-1,i=!0,o;if(p.length>=2&&S(p.charCodeAt(0))&&p.charCodeAt(1)===R&&(l=2),c!==void 0&&c.length>0&&c.length<=p.length){if(c===p)return"";let r=c.length-1,a=-1;for(o=p.length-1;o>=l;--o){const h=p.charCodeAt(o);if(s(h)){if(!i){l=o+1;break}}else a===-1&&(i=!1,a=o+1),r>=0&&(h===c.charCodeAt(r)?--r==-1&&(t=o):(r=-1,t=a))}return l===t?t=a:t===-1&&(t=p.length),p.slice(l,t)}for(o=p.length-1;o>=l;--o)if(s(p.charCodeAt(o))){if(!i){l=o+1;break}}else t===-1&&(i=!1,t=o+1);return t===-1?"":p.slice(l,t)},extname(p){g(p,"path");let c=0,l=-1,t=0,i=-1,o=!0,r=0;p.length>=2&&p.charCodeAt(1)===R&&S(p.charCodeAt(0))&&(c=t=2);for(let a=p.length-1;a>=c;--a){const h=p.charCodeAt(a);if(s(h)){if(!o){t=a+1;break}continue}i===-1&&(o=!1,i=a+1),h===k?l===-1?l=a:r!==1&&(r=1):l!==-1&&(r=-1)}return l===-1||i===-1||r===0||r===1&&l===i-1&&l===t+1?"":p.slice(l,i)},format:_.bind(null,"\\"),parse(p){g(p,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(p.length===0)return c;const l=p.length;let t=0,i=p.charCodeAt(0);if(l===1)return s(i)?(c.root=c.dir=p,c):(c.base=c.name=p,c);if(s(i)){if(t=1,s(p.charCodeAt(1))){let f=2,d=f;for(;f<l&&!s(p.charCodeAt(f));)f++;if(f<l&&f!==d){for(d=f;f<l&&s(p.charCodeAt(f));)f++;if(f<l&&f!==d){for(d=f;f<l&&!s(p.charCodeAt(f));)f++;f===l?t=f:f!==d&&(t=f+1)}}}}else if(S(i)&&p.charCodeAt(1)===R){if(l<=2)return c.root=c.dir=p,c;if(t=2,s(p.charCodeAt(2))){if(l===3)return c.root=c.dir=p,c;t=3}}t>0&&(c.root=p.slice(0,t));let o=-1,r=t,a=-1,h=!0,m=p.length-1,b=0;for(;m>=t;--m){if(i=p.charCodeAt(m),s(i)){if(!h){r=m+1;break}continue}a===-1&&(h=!1,a=m+1),i===k?o===-1?o=m:b!==1&&(b=1):o!==-1&&(b=-1)}return a!==-1&&(o===-1||b===0||b===1&&o===a-1&&o===r+1?c.base=c.name=p.slice(r,a):(c.name=p.slice(r,o),c.base=p.slice(r,a),c.ext=p.slice(o,a))),r>0&&r!==t?c.dir=p.slice(0,r-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...p){let c="",l=!1;for(let t=p.length-1;t>=-1&&!l;t--){const i=t>=0?p[t]:E.cwd();g(i,"path"),i.length!==0&&(c=`${i}/${c}`,l=i.charCodeAt(0)===y)}return c=v(c,!l,"/",u),l?`/${c}`:c.length>0?c:"."},normalize(p){if(g(p,"path"),p.length===0)return".";const c=p.charCodeAt(0)===y,l=p.charCodeAt(p.length-1)===y;return p=v(p,!c,"/",u),p.length===0?c?"/":l?"./":".":(l&&(p+="/"),c?`/${p}`:p)},isAbsolute(p){return g(p,"path"),p.length>0&&p.charCodeAt(0)===y},join(...p){if(p.length===0)return".";let c;for(let l=0;l<p.length;++l){const t=p[l];g(t,"path"),t.length>0&&(c===void 0?c=t:c+=`/${t}`)}return c===void 0?".":e.posix.normalize(c)},relative(p,c){if(g(p,"from"),g(c,"to"),p===c||(p=e.posix.resolve(p),c=e.posix.resolve(c),p===c))return"";const l=1,t=p.length,i=t-l,o=1,r=c.length-o,a=i<r?i:r;let h=-1,m=0;for(;m<a;m++){const f=p.charCodeAt(l+m);if(f!==c.charCodeAt(o+m))break;f===y&&(h=m)}if(m===a)if(r>a){if(c.charCodeAt(o+m)===y)return c.slice(o+m+1);if(m===0)return c.slice(o+m)}else i>a&&(p.charCodeAt(l+m)===y?h=m:m===0&&(h=0));let b="";for(m=l+h+1;m<=t;++m)(m===t||p.charCodeAt(m)===y)&&(b+=b.length===0?"..":"/..");return`${b}${c.slice(o+h)}`},toNamespacedPath(p){return p},dirname(p){if(g(p,"path"),p.length===0)return".";const c=p.charCodeAt(0)===y;let l=-1,t=!0;for(let i=p.length-1;i>=1;--i)if(p.charCodeAt(i)===y){if(!t){l=i;break}}else t=!1;return l===-1?c?"/":".":c&&l===1?"//":p.slice(0,l)},basename(p,c){c!==void 0&&g(c,"ext"),g(p,"path");let l=0,t=-1,i=!0,o;if(c!==void 0&&c.length>0&&c.length<=p.length){if(c===p)return"";let r=c.length-1,a=-1;for(o=p.length-1;o>=0;--o){const h=p.charCodeAt(o);if(h===y){if(!i){l=o+1;break}}else a===-1&&(i=!1,a=o+1),r>=0&&(h===c.charCodeAt(r)?--r==-1&&(t=o):(r=-1,t=a))}return l===t?t=a:t===-1&&(t=p.length),p.slice(l,t)}for(o=p.length-1;o>=0;--o)if(p.charCodeAt(o)===y){if(!i){l=o+1;break}}else t===-1&&(i=!1,t=o+1);return t===-1?"":p.slice(l,t)},extname(p){g(p,"path");let c=-1,l=0,t=-1,i=!0,o=0;for(let r=p.length-1;r>=0;--r){const a=p.charCodeAt(r);if(a===y){if(!i){l=r+1;break}continue}t===-1&&(i=!1,t=r+1),a===k?c===-1?c=r:o!==1&&(o=1):c!==-1&&(o=-1)}return c===-1||t===-1||o===0||o===1&&c===t-1&&c===l+1?"":p.slice(c,t)},format:_.bind(null,"/"),parse(p){g(p,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(p.length===0)return c;const l=p.charCodeAt(0)===y;let t;l?(c.root="/",t=1):t=0;let i=-1,o=0,r=-1,a=!0,h=p.length-1,m=0;for(;h>=t;--h){const b=p.charCodeAt(h);if(b===y){if(!a){o=h+1;break}continue}r===-1&&(a=!1,r=h+1),b===k?i===-1?i=h:m!==1&&(m=1):i!==-1&&(m=-1)}if(r!==-1){const b=o===0&&l?1:o;i===-1||m===0||m===1&&i===r-1&&i===o+1?c.base=c.name=p.slice(b,r):(c.name=p.slice(b,i),c.base=p.slice(b,r),c.ext=p.slice(i,r))}return o>0?c.dir=p.slice(0,o-1):l&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=E.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=E.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=E.platform==="win32"?e.win32.join:e.posix.join,e.resolve=E.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=E.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=E.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=E.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=E.platform==="win32"?e.win32.extname:e.posix.extname,e.format=E.platform==="win32"?e.win32.format:e.posix.format,e.parse=E.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=E.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=E.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=E.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ge[134],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var E;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(E=e.Source||(e.Source={}));var P;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(P=e.TerminateResponseCode||(e.TerminateResponseCode={}));function T(I,...D){const k=D.reduce((R,C)=>(R[C]=!0,R),{}),y=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(R=>!k[R]).forEach(R=>{for(let C=0;C<y.length;C++)if(R.search(y[C])!==-1){delete I[R];break}})}e.sanitizeProcessEnvironment=T}),define(ge[47],pe([0,1,9]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const P=E.globals.performance&&typeof E.globals.performance.now=="function";class T{constructor(D){this._highResolution=P&&D,this._startTime=this._now(),this._stopTime=-1}static create(D=!0){return new T(D)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?E.globals.performance.now():Date.now()}}e.StopWatch=T}),define(ge[3],pe([0,1,18,69,6,55,47]),function(G,e,E,P,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var k;(function(v){v.None=()=>T.Disposable.None;function _(j){return(U,$=null,F)=>{let N=!1,M;return M=j(x=>{if(!N)return M?M.dispose():N=!0,U.call($,x)},null,F),N&&M.dispose(),M}}v.once=_;function p(j,U){return r(($,F=null,N)=>j(M=>$.call(F,U(M)),null,N))}v.map=p;function c(j,U){return r(($,F=null,N)=>j(M=>{U(M),$.call(F,M)},null,N))}v.forEach=c;function l(j,U){return r(($,F=null,N)=>j(M=>U(M)&&$.call(F,M),null,N))}v.filter=l;function t(j){return j}v.signal=t;function i(...j){return(U,$=null,F)=>(0,T.combinedDisposable)(...j.map(N=>N(M=>U.call($,M),null,F)))}v.any=i;function o(j,U,$){let F=$;return p(j,N=>(F=U(F,N),F))}v.reduce=o;function r(j){let U;const $=new w({onFirstListenerAdd(){U=j($.fire,$)},onLastListenerRemove(){U.dispose()}});return $.event}v.snapshot=r;function a(j,U,$=100,F=!1,N){let M,x,O,V=0;const q=new w({leakWarningThreshold:N,onFirstListenerAdd(){M=j(X=>{V++,x=U(x,X),F&&!O&&(q.fire(x),x=void 0),clearTimeout(O),O=setTimeout(()=>{const me=x;x=void 0,O=void 0,(!F||V>1)&&q.fire(me),V=0},$)})},onLastListenerRemove(){M.dispose()}});return q.event}v.debounce=a;function h(j){const U=new Date().getTime();return p(_(j),$=>new Date().getTime()-U)}v.stopwatch=h;function m(j){let U=!0,$;return l(j,F=>{const N=U||F!==$;return U=!1,$=F,N})}v.latch=m;function b(j,U=!1,$=[]){let F=$.slice(),N=j(O=>{F?F.push(O):x.fire(O)});const M=()=>{F&&F.forEach(O=>x.fire(O)),F=null},x=new w({onFirstListenerAdd(){N||(N=j(O=>x.fire(O)))},onFirstListenerDidAdd(){F&&(U?setTimeout(M):M())},onLastListenerRemove(){N&&N.dispose(),N=null}});return x.event}v.buffer=b;class f{constructor(U){this.event=U}map(U){return new f(p(this.event,U))}forEach(U){return new f(c(this.event,U))}filter(U){return new f(l(this.event,U))}reduce(U,$){return new f(o(this.event,U,$))}latch(){return new f(m(this.event))}debounce(U,$=100,F=!1,N){return new f(a(this.event,U,$,F,N))}on(U,$,F){return this.event(U,$,F)}once(U,$,F){return _(this.event)(U,$,F)}}function d(j){return new f(j)}v.chain=d;function A(j,U,$=F=>F){const F=(...O)=>x.fire($(...O)),N=()=>j.on(U,F),M=()=>j.removeListener(U,F),x=new w({onFirstListenerAdd:N,onLastListenerRemove:M});return x.event}v.fromNodeEventEmitter=A;function L(j,U,$=F=>F){const F=(...O)=>x.fire($(...O)),N=()=>j.addEventListener(U,F),M=()=>j.removeEventListener(U,F),x=new w({onFirstListenerAdd:N,onLastListenerRemove:M});return x.event}v.fromDOMEventEmitter=L;function B(j){const U=new w;let $=!1;return j.then(void 0,()=>null).then(()=>{$?U.fire(void 0):setTimeout(()=>U.fire(void 0),0)}),$=!0,U.event}v.fromPromise=B;function J(j){return new Promise(U=>_(j)(U))}v.toPromise=J})(k=e.Event||(e.Event={}));class y{constructor(_){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${_}_${y._idPool++}`}start(_){this._stopWatch=new D.StopWatch(!0),this._listenerCount=_}stop(){if(this._stopWatch){const _=this._stopWatch.elapsed();this._elapsedOverall+=_,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${_.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}y._idPool=0;let n=-1;function R(v){const _=n;return n=v,{dispose(){n=_}}}e.setGlobalLeakWarningThreshold=R;class C{constructor(_,p=Math.random().toString(18).slice(2,5)){this.customThreshold=_,this.name=p,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(_){let p=n;if(typeof this.customThreshold=="number"&&(p=this.customThreshold),!(p<=0||_<p)){this._stacks||(this._stacks=new Map);const c=new Error().stack.split(`
`).slice(3).join(`
`),l=this._stacks.get(c)||0;if(this._stacks.set(c,l+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=p*.5;let t,i=0;for(const[o,r]of this._stacks)(!t||i<r)&&(t=o,i=r);console.warn(`[${this.name}] potential listener LEAK detected, having ${_} listeners already. MOST frequent listener (${i}):`),console.warn(t)}return()=>{const t=this._stacks.get(c)||0;this._stacks.set(c,t-1)}}}}class w{constructor(_){var p;this._disposed=!1,this._options=_,this._leakageMon=n>0?new C(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((p=this._options)===null||p===void 0?void 0:p._profName)?new y(this._options._profName):void 0}get event(){return this._event||(this._event=(_,p,c)=>{var l;this._listeners||(this._listeners=new I.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(p?[_,p]:_);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,_,p);const o=(l=this._leakageMon)===null||l===void 0?void 0:l.check(this._listeners.size);let r;return r={dispose:()=>{o&&o(),r.dispose=w._noop,this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},c instanceof T.DisposableStore?c.add(r):Array.isArray(c)&&c.push(r),r}),this._event}fire(_){var p,c;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new I.LinkedList);for(let l of this._listeners)this._deliveryQueue.push([l,_]);for((p=this._perfMon)===null||p===void 0||p.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[l,t]=this._deliveryQueue.shift();try{typeof l=="function"?l.call(void 0,t):l[0].call(l[1],t)}catch(i){(0,E.onUnexpectedError)(i)}}(c=this._perfMon)===null||c===void 0||c.stop()}}dispose(){var _,p,c;(_=this._listeners)===null||_===void 0||_.clear(),(p=this._deliveryQueue)===null||p===void 0||p.clear(),(c=this._leakageMon)===null||c===void 0||c.dispose(),this._disposed=!0}}e.Emitter=w,w._noop=function(){};class g extends w{constructor(_){super(_);this._isPaused=0,this._eventQueue=new I.LinkedList,this._mergeFn=_==null?void 0:_.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const _=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(_))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(_){this._listeners&&(this._isPaused!==0?this._eventQueue.push(_):super.fire(_))}}e.PauseableEmitter=g;class s{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new w({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(_){const p={event:_,listener:null};this.events.push(p),this.hasListeners&&this.hook(p);const c=()=>{this.hasListeners&&this.unhook(p);const l=this.events.indexOf(p);this.events.splice(l,1)};return(0,T.toDisposable)((0,P.once)(c))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(_=>this.hook(_))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(_=>this.unhook(_))}hook(_){_.listener=_.event(p=>this.emitter.fire(p))}unhook(_){_.listener&&_.listener.dispose(),_.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=s;class u{constructor(){this.buffers=[]}wrapEvent(_){return(p,c,l)=>_(t=>{const i=this.buffers[this.buffers.length-1];i?i.push(()=>p.call(c,t)):p.call(c,t)},void 0,l)}bufferEvents(_){const p=[];this.buffers.push(p);const c=_();return this.buffers.pop(),p.forEach(l=>l()),c}}e.EventBufferer=u;class S{constructor(){this.listening=!1,this.inputEvent=k.None,this.inputEventListener=T.Disposable.None,this.emitter=new w({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(_){this.inputEvent=_,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=_(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=S}),define(ge[21],pe([0,1,3]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const P=Object.freeze(function(k,y){const n=setTimeout(k.bind(y),0);return{dispose(){clearTimeout(n)}}});var T;(function(k){function y(n){return n===k.None||n===k.Cancelled||n instanceof I?!0:!n||typeof n!="object"?!1:typeof n.isCancellationRequested=="boolean"&&typeof n.onCancellationRequested=="function"}k.isCancellationToken=y,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:P})})(T=e.CancellationToken||(e.CancellationToken={}));class I{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?P:(this._emitter||(this._emitter=new E.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class D{constructor(y){this._token=void 0,this._parentListener=void 0,this._parentListener=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new I),this._token}cancel(){this._token?this._token instanceof I&&this._token.cancel():this._token=T.Cancelled}dispose(y=!1){y&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof I&&this._token.dispose():this._token=T.None}}e.CancellationTokenSource=D}),define(ge[43],pe([0,1,3]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.registerCodicon=e.iconRegistry=void 0;class P{constructor(){this._icons=new Map,this._onDidRegister=new E.Emitter}add(R){const C=this._icons.get(R.id);C?R.description?C.description=R.description:console.error(`Duplicate registration of codicon ${R.id}`):(this._icons.set(R.id,R),this._onDidRegister.fire(R))}get(R){return this._icons.get(R)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const T=new P;e.iconRegistry=T;function I(n,R){return new D(n,R)}e.registerCodicon=I;class D{constructor(R,C,w){this.id=R,this.definition=C,this.description=w,T.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=D;function k(n,R){const C=["codicon","codicon-"+n];return R&&C.push("codicon-modifier-"+R),C}e.getClassNamesArray=k;var y;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const R=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function C(s){if(s instanceof D)return["codicon","codicon-"+s.id];const u=R.exec(s.id);if(!u)return C(D.error);let[,S,v]=u;const _=["codicon","codicon-"+S];return v&&_.push("codicon-modifier-"+v.substr(1)),_}n.asClassNameArray=C;function w(s){return C(s).join(" ")}n.asClassName=w;function g(s){return"."+C(s).join(".")}n.asCSSSelector=g})(y=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personAdd=new n("person-add",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eb0a"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(D=e.Codicon||(e.Codicon={}))}),define(ge[91],pe([0,1,18,6]),function(G,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function T(v){const _=v;return _&&[_.on,_.pause,_.resume,_.destroy].every(p=>typeof p=="function")}e.isReadableStream=T;function I(v){const _=v;return _&&T(_.stream)&&Array.isArray(_.buffer)&&typeof _.ended=="boolean"}e.isReadableBufferedStream=I;function D(v,_){return new k(v,_)}e.newWriteableStream=D;class k{constructor(_,p){this.reducer=_,this.options=p,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(_){var p;if(!this.state.destroyed){if(this.state.flowing)this.emitData(_);else if(this.buffer.data.push(_),typeof((p=this.options)===null||p===void 0?void 0:p.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(c=>this.pendingWritePromises.push(c))}}error(_){this.state.destroyed||(this.state.flowing?this.emitError(_):this.buffer.error.push(_))}end(_){this.state.destroyed||(typeof _!="undefined"&&this.write(_),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(_){this.listeners.data.slice(0).forEach(p=>p(_))}emitError(_){this.listeners.error.length===0?(0,E.onUnexpectedError)(_):this.listeners.error.slice(0).forEach(p=>p(_))}emitEnd(){this.listeners.end.slice(0).forEach(_=>_())}on(_,p){if(!this.state.destroyed)switch(_){case"data":this.listeners.data.push(p),this.resume();break;case"end":this.listeners.end.push(p),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(p),this.state.flowing&&this.flowErrors();break}}removeListener(_,p){if(!this.state.destroyed){let c;switch(_){case"data":c=this.listeners.data;break;case"end":c=this.listeners.end;break;case"error":c=this.listeners.error;break}if(c){const l=c.indexOf(p);l>=0&&c.splice(l,1)}}}flowData(){if(this.buffer.data.length>0){const _=this.reducer(this.buffer.data);this.emitData(_),this.buffer.data.length=0;const p=[...this.pendingWritePromises];this.pendingWritePromises.length=0,p.forEach(c=>c())}}flowErrors(){if(this.listeners.error.length>0){for(const _ of this.buffer.error)this.emitError(_);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function y(v,_){const p=[];let c;for(;(c=v.read())!==null;)p.push(c);return _(p)}e.consumeReadable=y;function n(v,_,p){const c=[];let l;for(;(l=v.read())!==null&&c.length<p;)c.push(l);return l===null&&c.length>0?_(c):{read:()=>{if(c.length>0)return c.shift();if(typeof l!="undefined"){const t=l;return l=void 0,t}return v.read()}}}e.peekReadable=n;function R(v,_){return new Promise((p,c)=>{const l=[];C(v,{onData:t=>{_&&l.push(t)},onError:t=>{_?c(t):p(void 0)},onEnd:()=>{p(_?_(l):void 0)}})})}e.consumeStream=R;function C(v,_){v.on("error",p=>_.onError(p)),v.on("end",()=>_.onEnd()),v.on("data",p=>_.onData(p))}e.listenStream=C;function w(v,_){return new Promise((p,c)=>{const l=new P.DisposableStore,t=[],i=a=>{if(t.push(a),t.length>_)return l.dispose(),v.pause(),p({stream:v,buffer:t,ended:!1})},o=a=>c(a),r=()=>p({stream:v,buffer:t,ended:!0});l.add((0,P.toDisposable)(()=>v.removeListener("error",o))),v.on("error",o),l.add((0,P.toDisposable)(()=>v.removeListener("end",r))),v.on("end",r),l.add((0,P.toDisposable)(()=>v.removeListener("data",i))),v.on("data",i)})}e.peekStream=w;function g(v,_){const p=D(_);return p.end(v),p}e.toStream=g;function s(){const v=D(()=>{throw new Error("not supported")});return v.end(),v}e.emptyStream=s;function u(v){let _=!1;return{read:()=>_?null:(_=!0,v)}}e.toReadable=u;function S(v,_,p){const c=D(p);return C(v,{onData:l=>c.write(_.data(l)),onError:l=>c.error(_.error?_.error(l):l),onEnd:()=>c.end()}),c}e.transform=S}),define(ge[10],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function E(K){return!K||typeof K!="string"?!0:K.trim().length===0}e.isFalsyOrWhitespace=E;const P=/{(\d+)}/g;function T(K,...oe){return oe.length===0?K:K.replace(P,function(de,Z){const ie=parseInt(Z,10);return isNaN(ie)||ie<0||ie>=oe.length?de:oe[ie]})}e.format=T;function I(K){return K.replace(/[<>&]/g,function(oe){switch(oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return oe}})}e.escape=I;function D(K){return K.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=D;function k(K,oe){let de=0;const Z=oe.charCodeAt(0);for(let ie=K.length-1;ie>=0;ie--)K.charCodeAt(ie)===Z&&de++;return de}e.count=k;function y(K,oe,de="\u2026"){return K.length<=oe?K:`${K.substr(0,oe)}${de}`}e.truncate=y;function n(K,oe=" "){const de=R(K,oe);return C(de,oe)}e.trim=n;function R(K,oe){if(!K||!oe)return K;const de=oe.length;if(de===0||K.length===0)return K;let Z=0;for(;K.indexOf(oe,Z)===Z;)Z=Z+de;return K.substring(Z)}e.ltrim=R;function C(K,oe){if(!K||!oe)return K;const de=oe.length,Z=K.length;if(de===0||Z===0)return K;let ie=Z,le=-1;for(;le=K.lastIndexOf(oe,ie-1),!(le===-1||le+de!==ie);){if(le===0)return"";ie=le}return K.substring(0,ie)}e.rtrim=C;function w(K){return K.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=w;function g(K){return K.replace(/\*/g,"")}e.stripWildcards=g;function s(K,oe,de={}){if(!K)throw new Error("Cannot create regex from empty string");oe||(K=D(K)),de.wholeWord&&(/\B/.test(K.charAt(0))||(K="\\b"+K),/\B/.test(K.charAt(K.length-1))||(K=K+"\\b"));let Z="";return de.global&&(Z+="g"),de.matchCase||(Z+="i"),de.multiline&&(Z+="m"),de.unicode&&(Z+="u"),new RegExp(K,Z)}e.createRegExp=s;function u(K){return K.source==="^"||K.source==="^$"||K.source==="$"||K.source==="^\\s*$"?!1:!!(K.exec("")&&K.lastIndex===0)}e.regExpLeadsToEndlessLoop=u;function S(K){return!!K.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=S;function v(K){return(K.global?"g":"")+(K.ignoreCase?"i":"")+(K.multiline?"m":"")+(K.unicode?"u":"")}e.regExpFlags=v;function _(K){return K.split(/\r\n|\r|\n/)}e.splitLines=_;function p(K){for(let oe=0,de=K.length;oe<de;oe++){const Z=K.charCodeAt(oe);if(Z!==32&&Z!==9)return oe}return-1}e.firstNonWhitespaceIndex=p;function c(K,oe=0,de=K.length){for(let Z=oe;Z<de;Z++){const ie=K.charCodeAt(Z);if(ie!==32&&ie!==9)return K.substring(oe,Z)}return K.substring(oe,de)}e.getLeadingWhitespace=c;function l(K,oe=K.length-1){for(let de=oe;de>=0;de--){const Z=K.charCodeAt(de);if(Z!==32&&Z!==9)return de}return-1}e.lastNonWhitespaceIndex=l;function t(K,oe){return K<oe?-1:K>oe?1:0}e.compare=t;function i(K,oe,de=0,Z=K.length,ie=0,le=oe.length){for(;de<Z&&ie<le;de++,ie++){let We=K.charCodeAt(de),Ne=oe.charCodeAt(ie);if(We<Ne)return-1;if(We>Ne)return 1}const ve=Z-de,ye=le-ie;return ve<ye?-1:ve>ye?1:0}e.compareSubstring=i;function o(K,oe){return r(K,oe,0,K.length,0,oe.length)}e.compareIgnoreCase=o;function r(K,oe,de=0,Z=K.length,ie=0,le=oe.length){for(;de<Z&&ie<le;de++,ie++){let We=K.charCodeAt(de),Ne=oe.charCodeAt(ie);if(We!==Ne){const qe=We-Ne;if(!(qe===32&&h(Ne))&&!(qe===-32&&h(We)))return a(We)&&a(Ne)?qe:i(K.toLowerCase(),oe.toLowerCase(),de,Z,ie,le)}}const ve=Z-de,ye=le-ie;return ve<ye?-1:ve>ye?1:0}e.compareSubstringIgnoreCase=r;function a(K){return K>=97&&K<=122}e.isLowerAsciiLetter=a;function h(K){return K>=65&&K<=90}e.isUpperAsciiLetter=h;function m(K){return a(K)||h(K)}function b(K,oe){return K.length===oe.length&&f(K,oe)}e.equalsIgnoreCase=b;function f(K,oe,de=K.length){for(let Z=0;Z<de;Z++){const ie=K.charCodeAt(Z),le=oe.charCodeAt(Z);if(ie!==le){if(m(ie)&&m(le)){const ve=Math.abs(ie-le);if(ve!==0&&ve!==32)return!1}else if(String.fromCharCode(ie).toLowerCase()!==String.fromCharCode(le).toLowerCase())return!1}}return!0}function d(K,oe){const de=oe.length;return oe.length>K.length?!1:f(K,oe,de)}e.startsWithIgnoreCase=d;function A(K,oe){let de,Z=Math.min(K.length,oe.length);for(de=0;de<Z;de++)if(K.charCodeAt(de)!==oe.charCodeAt(de))return de;return Z}e.commonPrefixLength=A;function L(K,oe){let de,Z=Math.min(K.length,oe.length);const ie=K.length-1,le=oe.length-1;for(de=0;de<Z;de++)if(K.charCodeAt(ie-de)!==oe.charCodeAt(le-de))return de;return Z}e.commonSuffixLength=L;function B(K){return 55296<=K&&K<=56319}e.isHighSurrogate=B;function J(K){return 56320<=K&&K<=57343}e.isLowSurrogate=J;function j(K,oe){return(K-55296<<10)+(oe-56320)+65536}e.computeCodePoint=j;function U(K,oe,de){const Z=K.charCodeAt(de);if(B(Z)&&de+1<oe){const ie=K.charCodeAt(de+1);if(J(ie))return j(Z,ie)}return Z}e.getNextCodePoint=U;function $(K,oe){const de=K.charCodeAt(oe-1);if(J(de)&&oe>1){const Z=K.charCodeAt(oe-2);if(B(Z))return j(Z,de)}return de}function F(K,oe){const de=$e.getInstance(),Z=oe,ie=K.length,le=U(K,ie,oe);oe+=le>=65536?2:1;let ve=de.getGraphemeBreakType(le);for(;oe<ie;){const ye=U(K,ie,oe),We=de.getGraphemeBreakType(ye);if(xe(ve,We))break;oe+=ye>=65536?2:1,ve=We}return oe-Z}e.nextCharLength=F;function N(K,oe){const de=$e.getInstance(),Z=oe,ie=$(K,oe);oe-=ie>=65536?2:1;let le=de.getGraphemeBreakType(ie);for(;oe>0;){const ve=$(K,oe),ye=de.getGraphemeBreakType(ve);if(xe(ye,le))break;oe-=ve>=65536?2:1,le=ye}return Z-oe}e.prevCharLength=N;function M(K,oe){const de=$e.getInstance(),Z=K.length,ie=oe,le=U(K,Z,oe),ve=de.getGraphemeBreakType(le);oe+=le>=65536?2:1;let ye=ve;for(;oe<Z;){const Ne=U(K,Z,oe),qe=de.getGraphemeBreakType(Ne);if(xe(ye,qe))break;oe+=Ne>=65536?2:1,ye=qe}const We=oe;for(oe=ie,ye=ve;oe>0;){const Ne=$(K,oe),qe=de.getGraphemeBreakType(Ne);if(xe(qe,ye))break;oe-=Ne>=65536?2:1,ye=qe}return[oe,We]}function x(K,oe){return oe>0&&J(K.charCodeAt(oe))?M(K,oe-1):M(K,oe)}e.getCharContainingOffset=x;function O(K){const oe=K.length;let de=0,Z=0;for(;Z<oe;){const ve=U(K,oe,Z);Z+=ve>=65536?2:1,ve<128?de+=1:ve<2048?de+=2:ve<65536?de+=3:de+=4}const ie=new Uint8Array(de);Z=0;let le=0;for(;Z<oe;){const ve=U(K,oe,Z);Z+=ve>=65536?2:1,ve<128?ie[le++]=ve:ve<2048?(ie[le++]=192|(ve&1984)>>>6,ie[le++]=128|(ve&63)>>>0):ve<65536?(ie[le++]=224|(ve&61440)>>>12,ie[le++]=128|(ve&4032)>>>6,ie[le++]=128|(ve&63)>>>0):(ie[le++]=240|(ve&1835008)>>>18,ie[le++]=128|(ve&258048)>>>12,ie[le++]=128|(ve&4032)>>>6,ie[le++]=128|(ve&63)>>>0)}return ie}e.encodeUTF8=O;function V(K){const oe=K.byteLength,de=[];let Z=0;for(;Z<oe;){const ie=K[Z];let le;if(ie>=240&&Z+3<oe?le=(K[Z++]&7)<<18>>>0|(K[Z++]&63)<<12>>>0|(K[Z++]&63)<<6>>>0|(K[Z++]&63)<<0>>>0:ie>=224&&Z+2<oe?le=(K[Z++]&15)<<12>>>0|(K[Z++]&63)<<6>>>0|(K[Z++]&63)<<0>>>0:ie>=192&&Z+1<oe?le=(K[Z++]&31)<<6>>>0|(K[Z++]&63)<<0>>>0:le=K[Z++],le>=0&&le<=55295||le>=57344&&le<=65535)de.push(String.fromCharCode(le));else if(le>=65536&&le<=1114111){const ve=le-65536,ye=55296+((ve&1047552)>>>10),We=56320+((ve&1023)>>>0);de.push(String.fromCharCode(ye)),de.push(String.fromCharCode(We))}else de.push(String.fromCharCode(65533))}return de.join("")}e.decodeUTF8=V;const q=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function X(K){return q.test(K)}e.containsRTL=X;const me=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function we(K){return me.test(K)}e.containsEmoji=we;const Te=/^[\t\n\r\x20-\x7E]*$/;function Pe(K){return Te.test(K)}e.isBasicASCII=Pe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Fe(K){return e.UNUSUAL_LINE_TERMINATORS.test(K)}e.containsUnusualLineTerminators=Fe;function z(K){for(let oe=0,de=K.length;oe<de;oe++)if(Y(K.charCodeAt(oe)))return!0;return!1}e.containsFullWidthCharacter=z;function Y(K){return K=+K,K>=11904&&K<=55215||K>=63744&&K<=64255||K>=65281&&K<=65374}e.isFullWidthCharacter=Y;function te(K){return K>=127462&&K<=127487||K===8986||K===8987||K===9200||K===9203||K>=9728&&K<=10175||K===11088||K===11093||K>=127744&&K<=128591||K>=128640&&K<=128764||K>=128992&&K<=129003||K>=129280&&K<=129535||K>=129648&&K<=129750}e.isEmojiImprecise=te;function ae(K,oe){if(K.length<oe)return K;const de=/\b/g;let Z=0;for(;de.test(K)&&!(K.length-de.lastIndex<oe);)Z=de.lastIndex,de.lastIndex+=1;return K.substring(Z).replace(/^\s/,"")}e.lcut=ae;const he=/\x1B\x5B[12]?K/g,Ce=/\x1b\[\d+m/g,Oe=/\x1b\[0?m/g;function be(K){return K&&(K=K.replace(he,""),K=K.replace(Ce,""),K=K.replace(Oe,"")),K}e.removeAnsiEscapeCodes=be,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ke(K){return!!(K&&K.length>0&&K.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ke;function Re(K){return ke(K)?K.substr(1):K}e.stripUTF8BOM=Re;function Be(K,oe){if(!K||!oe||K.length<oe.length)return!1;const de=oe.length,Z=K.toLowerCase();let ie=0,le=-1;for(;ie<de;){const ve=Z.indexOf(oe[ie],le+1);if(ve<0)return!1;le=ve,ie++}return!0}e.fuzzyContains=Be;function Se(K,oe=!1){return K?(oe&&(K=K.replace(/\\./g,"")),K.toLowerCase()!==K):!1}e.containsUppercaseCharacter=Se;function Ke(K){return K.charAt(0).toUpperCase()+K.slice(1)}e.uppercaseFirstLetter=Ke;function Q(K,oe=1){if(oe===0)return"";let de=-1;do de=K.indexOf(`
`,de+1),oe--;while(oe>0&&de>=0);return de===-1?K:(K[de-1]==="\r"&&de--,K.substr(0,de))}e.getNLines=Q;function se(K){const oe=90-65+1;return K=K%(2*oe),K<oe?String.fromCharCode(97+K):String.fromCharCode(65+K-oe)}e.singleLetterHash=se;function _e(K){return $e.getInstance().getGraphemeBreakType(K)}e.getGraphemeBreakType=_e;function xe(K,oe){return K===0?oe!==5&&oe!==7:K===2&&oe===3?!1:K===4||K===2||K===3||oe===4||oe===2||oe===3?!0:!(K===8&&(oe===8||oe===9||oe===11||oe===12)||(K===11||K===9)&&(oe===9||oe===10)||(K===12||K===10)&&oe===10||oe===5||oe===13||oe===7||K===1||K===13&&oe===14||K===6&&oe===6)}e.breakBetweenGraphemeBreakType=xe;var Ve;(function(K){K[K.Other=0]="Other",K[K.Prepend=1]="Prepend",K[K.CR=2]="CR",K[K.LF=3]="LF",K[K.Control=4]="Control",K[K.Extend=5]="Extend",K[K.Regional_Indicator=6]="Regional_Indicator",K[K.SpacingMark=7]="SpacingMark",K[K.L=8]="L",K[K.V=9]="V",K[K.T=10]="T",K[K.LV=11]="LV",K[K.LVT=12]="LVT",K[K.ZWJ=13]="ZWJ",K[K.Extended_Pictographic=14]="Extended_Pictographic"})(Ve=e.GraphemeBreakType||(e.GraphemeBreakType={}));class $e{constructor(){this._data=Ze()}static getInstance(){return $e._INSTANCE||($e._INSTANCE=new $e),$e._INSTANCE}getGraphemeBreakType(oe){if(oe<32)return oe===10?3:oe===13?2:4;if(oe<127)return 0;const de=this._data,Z=de.length/3;let ie=1;for(;ie<=Z;)if(oe<de[3*ie])ie=2*ie;else if(oe>de[3*ie+1])ie=2*ie+1;else return de[3*ie+2];return 0}}$e._INSTANCE=null;function Ze(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(ge[22],pe([0,1,10,91]),function(G,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const T=typeof Buffer!="undefined",I=typeof TextEncoder!="undefined",D=typeof TextDecoder!="undefined";let k,y;class n{constructor(a){this.buffer=a,this.byteLength=this.buffer.byteLength}static alloc(a){return T?new n(Buffer.allocUnsafe(a)):new n(new Uint8Array(a))}static wrap(a){return T&&!Buffer.isBuffer(a)&&(a=Buffer.from(a.buffer,a.byteOffset,a.byteLength)),new n(a)}static fromString(a,h){return!((h==null?void 0:h.dontUseNodeBuffer)||!1)&&T?new n(Buffer.from(a)):I?(k||(k=new TextEncoder),new n(k.encode(a))):new n(E.encodeUTF8(a))}static concat(a,h){if(typeof h=="undefined"){h=0;for(let f=0,d=a.length;f<d;f++)h+=a[f].byteLength}const m=n.alloc(h);let b=0;for(let f=0,d=a.length;f<d;f++){const A=a[f];m.set(A,b),b+=A.byteLength}return m}toString(){return T?this.buffer.toString():D?(y||(y=new TextDecoder),y.decode(this.buffer)):E.decodeUTF8(this.buffer)}slice(a,h){return new n(this.buffer.subarray(a,h))}set(a,h){a instanceof n?this.buffer.set(a.buffer,h):this.buffer.set(a,h)}readUInt32BE(a){return w(this.buffer,a)}writeUInt32BE(a,h){g(this.buffer,a,h)}readUInt32LE(a){return s(this.buffer,a)}writeUInt32LE(a,h){u(this.buffer,a,h)}readUInt8(a){return S(this.buffer,a)}writeUInt8(a,h){v(this.buffer,a,h)}}e.VSBuffer=n;function R(r,a){return r[a+0]<<0>>>0|r[a+1]<<8>>>0}e.readUInt16LE=R;function C(r,a,h){r[h+0]=a&255,a=a>>>8,r[h+1]=a&255}e.writeUInt16LE=C;function w(r,a){return r[a]*2**24+r[a+1]*2**16+r[a+2]*2**8+r[a+3]}e.readUInt32BE=w;function g(r,a,h){r[h+3]=a,a=a>>>8,r[h+2]=a,a=a>>>8,r[h+1]=a,a=a>>>8,r[h]=a}e.writeUInt32BE=g;function s(r,a){return r[a+0]<<0>>>0|r[a+1]<<8>>>0|r[a+2]<<16>>>0|r[a+3]<<24>>>0}e.readUInt32LE=s;function u(r,a,h){r[h+0]=a&255,a=a>>>8,r[h+1]=a&255,a=a>>>8,r[h+2]=a&255,a=a>>>8,r[h+3]=a&255}e.writeUInt32LE=u;function S(r,a){return r[a]}e.readUInt8=S;function v(r,a,h){r[h]=a}e.writeUInt8=v;function _(r){return P.consumeReadable(r,a=>n.concat(a))}e.readableToBuffer=_;function p(r){return P.toReadable(r)}e.bufferToReadable=p;function c(r){return P.consumeStream(r,a=>n.concat(a))}e.streamToBuffer=c;async function l(r){return r.ended?n.concat(r.buffer):n.concat([...r.buffer,await c(r.stream)])}e.bufferedStreamToBuffer=l;function t(r){return P.toStream(r,a=>n.concat(a))}e.bufferToStream=t;function i(r){return P.transform(r,{data:a=>typeof a=="string"?n.fromString(a):n.wrap(a)},a=>n.concat(a))}e.streamToBufferReadableStream=i;function o(r){return P.newWriteableStream(a=>n.concat(a),r)}e.newWriteableBufferStream=o}),define(ge[73],pe([0,1,10]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function P(v){return T(v,0)}e.hash=P;function T(v,_){switch(typeof v){case"object":return v===null?I(349,_):Array.isArray(v)?y(v,_):n(v,_);case"string":return k(v,_);case"boolean":return D(v,_);case"number":return I(v,_);case"undefined":return I(937,_);default:return I(617,_)}}e.doHash=T;function I(v,_){return(_<<5)-_+v|0}function D(v,_){return I(v?433:863,_)}function k(v,_){_=I(149417,_);for(let p=0,c=v.length;p<c;p++)_=I(v.charCodeAt(p),_);return _}e.stringHash=k;function y(v,_){return _=I(104579,_),v.reduce((p,c)=>T(c,p),_)}function n(v,_){return _=I(181387,_),Object.keys(v).sort().reduce((p,c)=>(p=k(c,p),T(v[c],p)),_)}class R{constructor(){this._value=0}get value(){return this._value}hash(_){return this._value=T(_,this._value),this._value}}e.Hasher=R;var C;(function(v){v[v.BLOCK_SIZE=64]="BLOCK_SIZE",v[v.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function w(v,_,p=32){const c=p-_,l=~((1<<c)-1);return(v<<_|(l&v)>>>c)>>>0}function g(v,_=0,p=v.byteLength,c=0){for(let l=0;l<p;l++)v[_+l]=c}function s(v,_,p="0"){for(;v.length<_;)v=p+v;return v}function u(v,_=32){return v instanceof ArrayBuffer?Array.from(new Uint8Array(v)).map(p=>p.toString(16).padStart(2,"0")).join(""):s((v>>>0).toString(16),_/4)}e.toHexString=u;class S{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(_){const p=_.length;if(p!==0){const c=this._buff;let l=this._buffLen,t=this._leftoverHighSurrogate,i,o;for(t!==0?(i=t,o=-1,t=0):(i=_.charCodeAt(0),o=0);;){let r=i;if(E.isHighSurrogate(i))if(o+1<p){const a=_.charCodeAt(o+1);E.isLowSurrogate(a)?(o++,r=E.computeCodePoint(i,a)):r=65533}else{t=i;break}else E.isLowSurrogate(i)&&(r=65533);if(l=this._push(c,l,r),o++,o<p)i=_.charCodeAt(o);else break}this._buffLen=l,this._leftoverHighSurrogate=t}}_push(_,p,c){return c<128?_[p++]=c:c<2048?(_[p++]=192|(c&1984)>>>6,_[p++]=128|(c&63)>>>0):c<65536?(_[p++]=224|(c&61440)>>>12,_[p++]=128|(c&4032)>>>6,_[p++]=128|(c&63)>>>0):(_[p++]=240|(c&1835008)>>>18,_[p++]=128|(c&258048)>>>12,_[p++]=128|(c&4032)>>>6,_[p++]=128|(c&63)>>>0),p>=64&&(this._step(),p-=64,this._totalLen+=64,_[0]=_[64+0],_[1]=_[64+1],_[2]=_[64+2]),p}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),u(this._h0)+u(this._h1)+u(this._h2)+u(this._h3)+u(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,g(this._buff,this._buffLen),this._buffLen>56&&(this._step(),g(this._buff));const _=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(_/4294967296),!1),this._buffDV.setUint32(60,_%4294967296,!1),this._step()}_step(){const _=S._bigBlock32,p=this._buffDV;for(let m=0;m<64;m+=4)_.setUint32(m,p.getUint32(m,!1),!1);for(let m=64;m<320;m+=4)_.setUint32(m,w(_.getUint32(m-12,!1)^_.getUint32(m-32,!1)^_.getUint32(m-56,!1)^_.getUint32(m-64,!1),1),!1);let c=this._h0,l=this._h1,t=this._h2,i=this._h3,o=this._h4,r,a,h;for(let m=0;m<80;m++)m<20?(r=l&t|~l&i,a=1518500249):m<40?(r=l^t^i,a=1859775393):m<60?(r=l&t|l&i|t&i,a=2400959708):(r=l^t^i,a=3395469782),h=w(c,5)+r+o+a+_.getUint32(m*4,!1)&4294967295,o=i,i=t,t=w(l,30),l=c,c=h;this._h0=this._h0+c&4294967295,this._h1=this._h1+l&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+i&4294967295,this._h4=this._h4+o&4294967295}}e.StringSHA1=S,S._bigBlock32=new DataView(new ArrayBuffer(320))}),define(ge[56],pe([0,1,10]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var P;(function(T){T[T.Ignore=0]="Ignore",T[T.Info=1]="Info",T[T.Warning=2]="Warning",T[T.Error=3]="Error"})(P||(P={})),function(T){const I="error",D="warning",k="warn",y="info";function n(R){return R?E.equalsIgnoreCase(I,R)?T.Error:E.equalsIgnoreCase(D,R)||E.equalsIgnoreCase(k,R)?T.Warning:E.equalsIgnoreCase(y,R)?T.Info:T.Ignore:T.Ignore}T.fromValue=n}(P||(P={})),e.default=P}),define(ge[15],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function E(h){return Array.isArray(h)}e.isArray=E;function P(h){return typeof h=="string"}e.isString=P;function T(h){return Array.isArray(h)&&h.every(m=>P(m))}e.isStringArray=T;function I(h){return typeof h=="object"&&h!==null&&!Array.isArray(h)&&!(h instanceof RegExp)&&!(h instanceof Date)}e.isObject=I;function D(h){return typeof h=="number"&&!isNaN(h)}e.isNumber=D;function k(h){return!!h&&typeof h[Symbol.iterator]=="function"}e.isIterable=k;function y(h){return h===!0||h===!1}e.isBoolean=y;function n(h){return typeof h=="undefined"}e.isUndefined=n;function R(h){return!C(h)}e.isDefined=R;function C(h){return n(h)||h===null}e.isUndefinedOrNull=C;function w(h,m){if(!h)throw new Error(m?`Unexpected type, expected '${m}'`:"Unexpected type")}e.assertType=w;function g(h){if(C(h))throw new Error("Assertion Failed: argument is undefined or null");return h}e.assertIsDefined=g;function s(...h){const m=[];for(let b=0;b<h.length;b++){const f=h[b];if(C(f))throw new Error(`Assertion Failed: argument at index ${b} is undefined or null`);m.push(f)}return m}e.assertAllDefined=s;const u=Object.prototype.hasOwnProperty;function S(h){if(!I(h))return!1;for(let m in h)if(u.call(h,m))return!1;return!0}e.isEmptyObject=S;function v(h){return typeof h=="function"}e.isFunction=v;function _(...h){return h.length>0&&h.every(v)}e.areFunctions=_;function p(h,m){const b=Math.min(h.length,m.length);for(let f=0;f<b;f++)c(h[f],m[f])}e.validateConstraints=p;function c(h,m){if(P(m)){if(typeof h!==m)throw new Error(`argument does not match constraint: typeof ${m}`)}else if(v(m)){try{if(h instanceof m)return}catch(b){}if(!C(h)&&h.constructor===m||m.length===1&&m.call(void 0,h)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=c;function l(h){let m=[],b=Object.getPrototypeOf(h);for(;Object.prototype!==b;)m=m.concat(Object.getOwnPropertyNames(b)),b=Object.getPrototypeOf(b);return m}e.getAllPropertyNames=l;function t(h){const m=[];for(const b of l(h))typeof h[b]=="function"&&m.push(b);return m}e.getAllMethodNames=t;function i(h,m){const b=d=>function(){const A=Array.prototype.slice.call(arguments,0);return m(d,A)};let f={};for(const d of h)f[d]=b(d);return f}e.createProxyObject=i;function o(h){return h===null?void 0:h}e.withNullAsUndefined=o;function r(h){return typeof h=="undefined"?null:h}e.withUndefinedAsNull=r;function a(h){return class{constructor(){return new Proxy({},{get(m,b){if(m[b])return m[b];throw new Error(`Not Implemented: ${h}->${String(b)}`)}})}}}e.NotImplementedProxy=a}),define(ge[30],pe([0,1,9,10,8,15]),function(G,e,E,P,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function D(i){return i===47||i===92}e.isPathSeparator=D;function k(i){return i.replace(/[\\/]/g,T.posix.sep)}e.toSlashes=k;function y(i,o=T.posix.sep){if(!i)return"";const r=i.length,a=i.charCodeAt(0);if(D(a)){if(D(i.charCodeAt(1))&&!D(i.charCodeAt(2))){let m=3;const b=m;for(;m<r&&!D(i.charCodeAt(m));m++);if(b!==m&&!D(i.charCodeAt(m+1))){for(m+=1;m<r;m++)if(D(i.charCodeAt(m)))return i.slice(0,m+1).replace(/[\\/]/g,o)}}return o}else if(S(a)&&i.charCodeAt(1)===58)return D(i.charCodeAt(2))?i.slice(0,2)+o:i.slice(0,2);let h=i.indexOf("://");if(h!==-1){for(h+=3;h<r;h++)if(D(i.charCodeAt(h)))return i.slice(0,h+1)}return""}e.getRoot=y;function n(i){if(!E.isWindows||!i||i.length<5)return!1;let o=i.charCodeAt(0);if(o!==92||(o=i.charCodeAt(1),o!==92))return!1;let r=2;const a=r;for(;r<i.length&&(o=i.charCodeAt(r),o!==92);r++);return!(a===r||(o=i.charCodeAt(r+1),isNaN(o)||o===92))}e.isUNC=n;const R=/[\\/:\*\?"<>\|]/g,C=/[\\/]/g,w=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(i,o=E.isWindows){const r=o?R:C;return!(!i||i.length===0||/^\s+$/.test(i)||(r.lastIndex=0,r.test(i))||o&&w.test(i)||i==="."||i===".."||o&&i[i.length-1]==="."||o&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=g;function s(i,o,r){const a=i===o;return!r||a?a:!i||!o?!1:(0,P.equalsIgnoreCase)(i,o)}e.isEqual=s;function u(i,o,r,a=T.sep){if(i===o)return!0;if(!i||!o||o.length>i.length)return!1;if(r){if(!(0,P.startsWithIgnoreCase)(i,o))return!1;if(o.length===i.length)return!0;let m=o.length;return o.charAt(o.length-1)===a&&m--,i.charAt(m)===a}return o.charAt(o.length-1)!==a&&(o+=a),i.indexOf(o)===0}e.isEqualOrParent=u;function S(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=S;function v(i,o){return E.isWindows&&i.endsWith(":")&&(i+=T.sep),(0,T.isAbsolute)(i)||(i=(0,T.join)(o,i)),i=(0,T.normalize)(i),E.isWindows?(i=(0,P.rtrim)(i,T.sep),i.endsWith(":")&&(i+=T.sep)):(i=(0,P.rtrim)(i,T.sep),i||(i=T.sep)),i}e.sanitizeFilePath=v;function _(i){const o=(0,T.normalize)(i);return E.isWindows?i.length>3?!1:p(o)&&(i.length===2||o.charCodeAt(2)===92):o===T.posix.sep}e.isRootOrDriveLetter=_;function p(i){return E.isWindows?S(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=p;function c(i){return p(i)?i[0]:void 0}e.getDriveLetter=c;function l(i,o,r){return o.length>i.length?-1:i===o?0:(r&&(i=i.toLowerCase(),o=o.toLowerCase()),i.indexOf(o))}e.indexOfPath=l;function t(i){const o=i.split(":");let r,a,h;if(o.forEach(m=>{const b=Number(m);(0,I.isNumber)(b)?a===void 0?a=b:h===void 0&&(h=b):r=r?[r,m].join(":"):m}),!r)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:r,line:a!==void 0?a:void 0,column:h!==void 0?h:a!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(ge[23],pe([0,1,15]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function P(s){if(!s||typeof s!="object"||s instanceof RegExp)return s;const u=Array.isArray(s)?[]:{};return Object.keys(s).forEach(S=>{s[S]&&typeof s[S]=="object"?u[S]=P(s[S]):u[S]=s[S]}),u}e.deepClone=P;function T(s){if(!s||typeof s!="object")return s;const u=[s];for(;u.length>0;){const S=u.shift();Object.freeze(S);for(const v in S)if(I.call(S,v)){const _=S[v];typeof _=="object"&&!Object.isFrozen(_)&&u.push(_)}}return s}e.deepFreeze=T;const I=Object.prototype.hasOwnProperty;function D(s,u){return k(s,u,new Set)}e.cloneAndChange=D;function k(s,u,S){if((0,E.isUndefinedOrNull)(s))return s;const v=u(s);if(typeof v!="undefined")return v;if((0,E.isArray)(s)){const _=[];for(const p of s)_.push(k(p,u,S));return _}if((0,E.isObject)(s)){if(S.has(s))throw new Error("Cannot clone recursive data-structure");S.add(s);const _={};for(let p in s)I.call(s,p)&&(_[p]=k(s[p],u,S));return S.delete(s),_}return s}function y(s,u,S=!0){return(0,E.isObject)(s)?((0,E.isObject)(u)&&Object.keys(u).forEach(v=>{v in s?S&&((0,E.isObject)(s[v])&&(0,E.isObject)(u[v])?y(s[v],u[v],S):s[v]=u[v]):s[v]=u[v]}),s):u}e.mixin=y;function n(s,u){if(s===u)return!0;if(s==null||u===null||u===void 0||typeof s!=typeof u||typeof s!="object"||Array.isArray(s)!==Array.isArray(u))return!1;let S,v;if(Array.isArray(s)){if(s.length!==u.length)return!1;for(S=0;S<s.length;S++)if(!n(s[S],u[S]))return!1}else{const _=[];for(v in s)_.push(v);_.sort();const p=[];for(v in u)p.push(v);if(p.sort(),!n(_,p))return!1;for(S=0;S<_.length;S++)if(!n(s[_[S]],u[_[S]]))return!1}return!0}e.equals=n;function R(s){const u=new Set;return JSON.stringify(s,(S,v)=>{if((0,E.isObject)(v)||Array.isArray(v)){if(u.has(v))return"[Circular]";u.add(v)}return v})}e.safeStringify=R;function C(s,u,S){const v=u(s);return typeof v=="undefined"?S:v}e.getOrDefault=C;function w(s,u){const S=Object.create(null);return!s||!u||Object.keys(u).forEach(_=>{const p=s[_],c=u[_];n(p,c)||(S[_]=c)}),S}e.distinct=w;function g(s,u){const S=u.toLowerCase(),v=Object.keys(s).find(_=>_.toLowerCase()===S);return v?s[v]:s[u]}e.getCaseInsensitive=g}),define(ge[92],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var E;(function(I){I[I.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",I[I.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",I[I.MAX_UINT_8=255]="MAX_UINT_8",I[I.MAX_UINT_16=65535]="MAX_UINT_16",I[I.MAX_UINT_32=4294967295]="MAX_UINT_32",I[I.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(E=e.Constants||(e.Constants={}));function P(I){return I<0?0:I>255?255:I|0}e.toUint8=P;function T(I){return I<0?0:I>4294967295?4294967295:I|0}e.toUint32=T}),define(ge[2],pe([0,1,9,8]),function(G,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const T=/^\w[\w\d+.-]*$/,I=/^\//,D=/^\/\//;function k(o,r){if(!o.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${o.authority}", path: "${o.path}", query: "${o.query}", fragment: "${o.fragment}"}`);if(o.scheme&&!T.test(o.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(o.path){if(o.authority){if(!I.test(o.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(o.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(o,r){return!o&&!r?"file":o}function n(o,r){switch(o){case"https":case"http":case"file":r?r[0]!==C&&(r=C+r):r=C;break}return r}const R="",C="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{constructor(r,a,h,m,b,f=!1){typeof r=="object"?(this.scheme=r.scheme||R,this.authority=r.authority||R,this.path=r.path||R,this.query=r.query||R,this.fragment=r.fragment||R):(this.scheme=y(r,f),this.authority=a||R,this.path=n(this.scheme,h||R),this.query=m||R,this.fragment=b||R,k(this,f))}static isUri(r){return r instanceof g?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}get fsPath(){return p(this,!1)}with(r){if(!r)return this;let{scheme:a,authority:h,path:m,query:b,fragment:f}=r;return a===void 0?a=this.scheme:a===null&&(a=R),h===void 0?h=this.authority:h===null&&(h=R),m===void 0?m=this.path:m===null&&(m=R),b===void 0?b=this.query:b===null&&(b=R),f===void 0?f=this.fragment:f===null&&(f=R),a===this.scheme&&h===this.authority&&m===this.path&&b===this.query&&f===this.fragment?this:new u(a,h,m,b,f)}static parse(r,a=!1){const h=w.exec(r);return h?new u(h[2]||R,i(h[4]||R),i(h[5]||R),i(h[7]||R),i(h[9]||R),a):new u(R,R,R,R,R)}static file(r){let a=R;if(E.isWindows&&(r=r.replace(/\\/g,C)),r[0]===C&&r[1]===C){const h=r.indexOf(C,2);h===-1?(a=r.substring(2),r=C):(a=r.substring(2,h),r=r.substring(h)||C)}return new u("file",a,r,R,R)}static from(r){return new u(r.scheme,r.authority,r.path,r.query,r.fragment)}static joinPath(r,...a){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let h;return E.isWindows&&r.scheme==="file"?h=g.file(P.win32.join(p(r,!0),...a)).path:h=P.posix.join(r.path,...a),r.with({path:h})}toString(r=!1){return c(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof g)return r;{const a=new u(r);return a._formatted=r.external,a._fsPath=r._sep===s?r.fsPath:null,a}}else return r}}e.URI=g;const s=E.isWindows?1:void 0;class u extends g{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=p(this,!1)),this._fsPath}toString(r=!1){return r?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=s),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const S={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function v(o,r){let a,h=-1;for(let m=0;m<o.length;m++){const b=o.charCodeAt(m);if(b>=97&&b<=122||b>=65&&b<=90||b>=48&&b<=57||b===45||b===46||b===95||b===126||r&&b===47)h!==-1&&(a+=encodeURIComponent(o.substring(h,m)),h=-1),a!==void 0&&(a+=o.charAt(m));else{a===void 0&&(a=o.substr(0,m));const f=S[b];f!==void 0?(h!==-1&&(a+=encodeURIComponent(o.substring(h,m)),h=-1),a+=f):h===-1&&(h=m)}}return h!==-1&&(a+=encodeURIComponent(o.substring(h))),a!==void 0?a:o}function _(o){let r;for(let a=0;a<o.length;a++){const h=o.charCodeAt(a);h===35||h===63?(r===void 0&&(r=o.substr(0,a)),r+=S[h]):r!==void 0&&(r+=o[a])}return r!==void 0?r:o}function p(o,r){let a;return o.authority&&o.path.length>1&&o.scheme==="file"?a=`//${o.authority}${o.path}`:o.path.charCodeAt(0)===47&&(o.path.charCodeAt(1)>=65&&o.path.charCodeAt(1)<=90||o.path.charCodeAt(1)>=97&&o.path.charCodeAt(1)<=122)&&o.path.charCodeAt(2)===58?r?a=o.path.substr(1):a=o.path[1].toLowerCase()+o.path.substr(2):a=o.path,E.isWindows&&(a=a.replace(/\//g,"\\")),a}e.uriToFsPath=p;function c(o,r){const a=r?_:v;let h="",{scheme:m,authority:b,path:f,query:d,fragment:A}=o;if(m&&(h+=m,h+=":"),(b||m==="file")&&(h+=C,h+=C),b){let L=b.indexOf("@");if(L!==-1){const B=b.substr(0,L);b=b.substr(L+1),L=B.indexOf(":"),L===-1?h+=a(B,!1):(h+=a(B.substr(0,L),!1),h+=":",h+=a(B.substr(L+1),!1)),h+="@"}b=b.toLowerCase(),L=b.indexOf(":"),L===-1?h+=a(b,!1):(h+=a(b.substr(0,L),!1),h+=b.substr(L))}if(f){if(f.length>=3&&f.charCodeAt(0)===47&&f.charCodeAt(2)===58){const L=f.charCodeAt(1);L>=65&&L<=90&&(f=`/${String.fromCharCode(L+32)}:${f.substr(3)}`)}else if(f.length>=2&&f.charCodeAt(1)===58){const L=f.charCodeAt(0);L>=65&&L<=90&&(f=`${String.fromCharCode(L+32)}:${f.substr(2)}`)}h+=a(f,!0)}return d&&(h+="?",h+=a(d,!1)),A&&(h+="#",h+=r?A:v(A,!1)),h}function l(o){try{return decodeURIComponent(o)}catch(r){return o.length>3?o.substr(0,3)+l(o.substr(3)):o}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function i(o){return o.match(t)?o.replace(t,r=>l(r)):o}}),define(ge[24],pe([0,1,2,10]),function(G,e,E,P){"use strict";var T,I;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function D(c,l,t){let i=c.get(l);return i===void 0&&(i=t,c.set(l,i)),i}e.getOrSet=D;function k(c){const l=[];return c.forEach((t,i)=>{l.push(`${i} => ${t}`)}),`Map(${c.size}) {${l.join(", ")}}`}e.mapToString=k;function y(c){const l=[];return c.forEach(t=>{l.push(t)}),`Set(${c.size}) {${l.join(", ")}}`}e.setToString=y;class n{constructor(){this._value="",this._pos=0}reset(l){return this._value=l,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(l){const t=l.charCodeAt(0),i=this._value.charCodeAt(this._pos);return t-i}value(){return this._value[this._pos]}}e.StringIterator=n;class R{constructor(l=!0){this._caseSensitive=l}reset(l){return this._value=l,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let l=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(l)this._from++;else break;else l=!1;return this}cmp(l){return this._caseSensitive?(0,P.compareSubstring)(l,this._value,0,l.length,this._from,this._to):(0,P.compareSubstringIgnoreCase)(l,this._value,0,l.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=R;class C{constructor(l=!0,t=!0){this._splitOnBackslash=l,this._caseSensitive=t}reset(l){return this._value=l.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let l=!0;for(;this._to<this._value.length;this._to++){const t=this._value.charCodeAt(this._to);if(t===47||this._splitOnBackslash&&t===92)if(l)this._from++;else break;else l=!1}return this}cmp(l){return this._caseSensitive?(0,P.compareSubstring)(l,this._value,0,l.length,this._from,this._to):(0,P.compareSubstringIgnoreCase)(l,this._value,0,l.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=C;var w;(function(c){c[c.Scheme=1]="Scheme",c[c.Authority=2]="Authority",c[c.Path=3]="Path",c[c.Query=4]="Query",c[c.Fragment=5]="Fragment"})(w||(w={}));class g{constructor(l){this._ignorePathCasing=l,this._states=[],this._stateIdx=0}reset(l){return this._value=l,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new C(!1,!this._ignorePathCasing(l)),this._pathIterator.reset(l.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(l){if(this._states[this._stateIdx]===1)return(0,P.compareIgnoreCase)(l,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,P.compareIgnoreCase)(l,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(l);if(this._states[this._stateIdx]===4)return(0,P.compare)(l,this._value.query);if(this._states[this._stateIdx]===5)return(0,P.compare)(l,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=g;class s{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class u{constructor(l){this._iter=l}static forUris(l=()=>!1){return new u(new g(l))}static forPaths(){return new u(new C)}static forStrings(){return new u(new n)}static forConfigKeys(){return new u(new R)}clear(){this._root=void 0}set(l,t){const i=this._iter.reset(l);let o;for(this._root||(this._root=new s,this._root.segment=i.value()),o=this._root;;){const a=i.cmp(o.segment);if(a>0)o.left||(o.left=new s,o.left.segment=i.value()),o=o.left;else if(a<0)o.right||(o.right=new s,o.right.segment=i.value()),o=o.right;else if(i.hasNext())i.next(),o.mid||(o.mid=new s,o.mid.segment=i.value()),o=o.mid;else break}const r=o.value;return o.value=t,o.key=l,r}get(l){var t;return(t=this._getNode(l))===null||t===void 0?void 0:t.value}_getNode(l){const t=this._iter.reset(l);let i=this._root;for(;i;){const o=t.cmp(i.segment);if(o>0)i=i.left;else if(o<0)i=i.right;else if(t.hasNext())t.next(),i=i.mid;else break}return i}has(l){const t=this._getNode(l);return!((t==null?void 0:t.value)===void 0&&(t==null?void 0:t.mid)===void 0)}delete(l){return this._delete(l,!1)}deleteSuperstr(l){return this._delete(l,!0)}_delete(l,t){const i=this._iter.reset(l),o=[];let r=this._root;for(;r;){const a=i.cmp(r.segment);if(a>0)o.push([1,r]),r=r.left;else if(a<0)o.push([-1,r]),r=r.right;else if(i.hasNext())i.next(),o.push([0,r]),r=r.mid;else{for(t?(r.left=void 0,r.mid=void 0,r.right=void 0):r.value=void 0;o.length>0&&r.isEmpty();){let[h,m]=o.pop();switch(h){case 1:m.left=void 0;break;case 0:m.mid=void 0;break;case-1:m.right=void 0;break}r=m}break}}}findSubstr(l){const t=this._iter.reset(l);let i=this._root,o;for(;i;){const r=t.cmp(i.segment);if(r>0)i=i.left;else if(r<0)i=i.right;else if(t.hasNext())t.next(),o=i.value||o,i=i.mid;else break}return i&&i.value||o}findSuperstr(l){const t=this._iter.reset(l);let i=this._root;for(;i;){const o=t.cmp(i.segment);if(o>0)i=i.left;else if(o<0)i=i.right;else if(t.hasNext())t.next(),i=i.mid;else return i.mid?this._entries(i.mid):void 0}}forEach(l){for(const[t,i]of this)l(i,t)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(l){l&&(yield*this._entries(l.left),l.value&&(yield[l.key,l.value]),yield*this._entries(l.mid),yield*this._entries(l.right))}}e.TernarySearchTree=u;class S{constructor(l,t){this[T]="ResourceMap",l instanceof S?(this.map=new Map(l.map),this.toKey=t!=null?t:S.defaultToKey):(this.map=new Map,this.toKey=l!=null?l:S.defaultToKey)}set(l,t){return this.map.set(this.toKey(l),t),this}get(l){return this.map.get(this.toKey(l))}has(l){return this.map.has(this.toKey(l))}get size(){return this.map.size}clear(){this.map.clear()}delete(l){return this.map.delete(this.toKey(l))}forEach(l,t){typeof t!="undefined"&&(l=l.bind(t));for(let[i,o]of this.map)l(o,E.URI.parse(i),this)}values(){return this.map.values()}*keys(){for(let l of this.map.keys())yield E.URI.parse(l)}*entries(){for(let l of this.map.entries())yield[E.URI.parse(l[0]),l[1]]}*[(T=Symbol.toStringTag,Symbol.iterator)](){for(let l of this.map)yield[E.URI.parse(l[0]),l[1]]}}e.ResourceMap=S,S.defaultToKey=c=>c.toString();var v;(function(c){c[c.None=0]="None",c[c.AsOld=1]="AsOld",c[c.AsNew=2]="AsNew"})(v=e.Touch||(e.Touch={}));class _{constructor(){this[I]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var l;return(l=this._head)===null||l===void 0?void 0:l.value}get last(){var l;return(l=this._tail)===null||l===void 0?void 0:l.value}has(l){return this._map.has(l)}get(l,t=0){const i=this._map.get(l);if(!!i)return t!==0&&this.touch(i,t),i.value}set(l,t,i=0){let o=this._map.get(l);if(o)o.value=t,i!==0&&this.touch(o,i);else{switch(o={key:l,value:t,next:void 0,previous:void 0},i){case 0:this.addItemLast(o);break;case 1:this.addItemFirst(o);break;case 2:this.addItemLast(o);break;default:this.addItemLast(o);break}this._map.set(l,o),this._size++}return this}delete(l){return!!this.remove(l)}remove(l){const t=this._map.get(l);if(!!t)return this._map.delete(l),this.removeItem(t),this._size--,t.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const l=this._head;return this._map.delete(l.key),this.removeItem(l),this._size--,l.value}}forEach(l,t){const i=this._state;let o=this._head;for(;o;){if(t?l.bind(t)(o.value,o.key,this):l(o.value,o.key,this),this._state!==i)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const l=this,t=this._state;let i=this._head;const o={[Symbol.iterator](){return o},next(){if(l._state!==t)throw new Error("LinkedMap got modified during iteration.");if(i){const r={value:i.key,done:!1};return i=i.next,r}else return{value:void 0,done:!0}}};return o}values(){const l=this,t=this._state;let i=this._head;const o={[Symbol.iterator](){return o},next(){if(l._state!==t)throw new Error("LinkedMap got modified during iteration.");if(i){const r={value:i.value,done:!1};return i=i.next,r}else return{value:void 0,done:!0}}};return o}entries(){const l=this,t=this._state;let i=this._head;const o={[Symbol.iterator](){return o},next(){if(l._state!==t)throw new Error("LinkedMap got modified during iteration.");if(i){const r={value:[i.key,i.value],done:!1};return i=i.next,r}else return{value:void 0,done:!0}}};return o}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(l){if(!(l>=this.size)){if(l===0){this.clear();return}let t=this._head,i=this.size;for(;t&&i>l;)this._map.delete(t.key),t=t.next,i--;this._head=t,this._size=i,t&&(t.previous=void 0),this._state++}}addItemFirst(l){if(!this._head&&!this._tail)this._tail=l;else if(this._head)l.next=this._head,this._head.previous=l;else throw new Error("Invalid list");this._head=l,this._state++}addItemLast(l){if(!this._head&&!this._tail)this._head=l;else if(this._tail)l.previous=this._tail,this._tail.next=l;else throw new Error("Invalid list");this._tail=l,this._state++}removeItem(l){if(l===this._head&&l===this._tail)this._head=void 0,this._tail=void 0;else if(l===this._head){if(!l.next)throw new Error("Invalid list");l.next.previous=void 0,this._head=l.next}else if(l===this._tail){if(!l.previous)throw new Error("Invalid list");l.previous.next=void 0,this._tail=l.previous}else{const t=l.next,i=l.previous;if(!t||!i)throw new Error("Invalid list");t.previous=i,i.next=t}l.next=void 0,l.previous=void 0,this._state++}touch(l,t){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(t!==1&&t!==2)){if(t===1){if(l===this._head)return;const i=l.next,o=l.previous;l===this._tail?(o.next=void 0,this._tail=o):(i.previous=o,o.next=i),l.previous=void 0,l.next=this._head,this._head.previous=l,this._head=l,this._state++}else if(t===2){if(l===this._tail)return;const i=l.next,o=l.previous;l===this._head?(i.previous=void 0,this._head=i):(i.previous=o,o.next=i),l.next=void 0,l.previous=this._tail,this._tail.next=l,this._tail=l,this._state++}}}toJSON(){const l=[];return this.forEach((t,i)=>{l.push([i,t])}),l}fromJSON(l){this.clear();for(const[t,i]of l)this.set(t,i)}}e.LinkedMap=_;class p extends _{constructor(l,t=1){super();this._limit=l,this._ratio=Math.min(Math.max(0,t),1)}get limit(){return this._limit}set limit(l){this._limit=l,this.checkTrim()}get ratio(){return this._ratio}set ratio(l){this._ratio=Math.min(Math.max(0,l),1),this.checkTrim()}get(l,t=2){return super.get(l,t)}peek(l){return super.get(l,0)}set(l,t){return super.set(l,t,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=p}),define(ge[93],pe([0,1,24,10]),function(G,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function T(...be){return function(ke,Re){for(let Be=0,Se=be.length;Be<Se;Be++){const Ke=be[Be](ke,Re);if(Ke)return Ke}return null}}e.or=T,e.matchesStrictPrefix=I.bind(void 0,!1),e.matchesPrefix=I.bind(void 0,!0);function I(be,ke,Re){if(!Re||Re.length<ke.length)return null;let Be;return be?Be=P.startsWithIgnoreCase(Re,ke):Be=Re.indexOf(ke)===0,Be?ke.length>0?[{start:0,end:ke.length}]:[]:null}function D(be,ke){const Re=ke.toLowerCase().indexOf(be.toLowerCase());return Re===-1?null:[{start:Re,end:Re+be.length}]}e.matchesContiguousSubString=D;function k(be,ke){return y(be.toLowerCase(),ke.toLowerCase(),0,0)}e.matchesSubString=k;function y(be,ke,Re,Be){if(Re===be.length)return[];if(Be===ke.length)return null;if(be[Re]===ke[Be]){let Se=null;return(Se=y(be,ke,Re+1,Be+1))?v({start:Be,end:Be+1},Se):null}return y(be,ke,Re,Be+1)}function n(be){return 97<=be&&be<=122}function R(be){return 65<=be&&be<=90}e.isUpper=R;function C(be){return 48<=be&&be<=57}function w(be){return be===32||be===9||be===10||be===13}const g=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(be=>g.add(be.charCodeAt(0)));function s(be){return w(be)||g.has(be)}function u(be,ke){return be===ke||s(be)&&s(ke)}function S(be){return n(be)||R(be)||C(be)}function v(be,ke){return ke.length===0?ke=[be]:be.end===ke[0].start?ke[0].start=be.start:ke.unshift(be),ke}function _(be,ke){for(let Re=ke;Re<be.length;Re++){const Be=be.charCodeAt(Re);if(R(Be)||C(Be)||Re>0&&!S(be.charCodeAt(Re-1)))return Re}return be.length}function p(be,ke,Re,Be){if(Re===be.length)return[];if(Be===ke.length)return null;if(be[Re]!==ke[Be].toLowerCase())return null;{let Se=null,Ke=Be+1;for(Se=p(be,ke,Re+1,Be+1);!Se&&(Ke=_(ke,Ke))<ke.length;)Se=p(be,ke,Re+1,Ke),Ke++;return Se===null?null:v({start:Be,end:Be+1},Se)}}function c(be){let ke=0,Re=0,Be=0,Se=0,Ke=0;for(let Ve=0;Ve<be.length;Ve++)Ke=be.charCodeAt(Ve),R(Ke)&&ke++,n(Ke)&&Re++,S(Ke)&&Be++,C(Ke)&&Se++;const Q=ke/be.length,se=Re/be.length,_e=Be/be.length,xe=Se/be.length;return{upperPercent:Q,lowerPercent:se,alphaPercent:_e,numericPercent:xe}}function l(be){const{upperPercent:ke,lowerPercent:Re}=be;return Re===0&&ke>.6}function t(be){const{upperPercent:ke,lowerPercent:Re,alphaPercent:Be,numericPercent:Se}=be;return Re>.2&&ke<.8&&Be>.6&&Se<.2}function i(be){let ke=0,Re=0,Be=0,Se=0;for(let Ke=0;Ke<be.length;Ke++)Be=be.charCodeAt(Ke),R(Be)&&ke++,n(Be)&&Re++,w(Be)&&Se++;return(ke===0||Re===0)&&Se===0?be.length<=30:ke<=5}function o(be,ke){if(!ke||(ke=ke.trim(),ke.length===0)||!i(be)||ke.length>60)return null;const Re=c(ke);if(!t(Re)){if(!l(Re))return null;ke=ke.toLowerCase()}let Be=null,Se=0;for(be=be.toLowerCase();Se<ke.length&&(Be=p(be,ke,0,Se))===null;)Se=_(ke,Se+1);return Be}e.matchesCamelCase=o;function r(be,ke,Re=!1){if(!ke||ke.length===0)return null;let Be=null,Se=0;for(be=be.toLowerCase(),ke=ke.toLowerCase();Se<ke.length&&(Be=a(be,ke,0,Se,Re))===null;)Se=h(ke,Se+1);return Be}e.matchesWords=r;function a(be,ke,Re,Be,Se){if(Re===be.length)return[];if(Be===ke.length)return null;if(u(be.charCodeAt(Re),ke.charCodeAt(Be))){let Ke=null,Q=Be+1;if(Ke=a(be,ke,Re+1,Be+1,Se),!Se)for(;!Ke&&(Q=h(ke,Q))<ke.length;)Ke=a(be,ke,Re+1,Q,Se),Q++;return Ke===null?null:v({start:Be,end:Be+1},Ke)}else return null}function h(be,ke){for(let Re=ke;Re<be.length;Re++)if(s(be.charCodeAt(Re))||Re>0&&s(be.charCodeAt(Re-1)))return Re;return be.length}const m=T(e.matchesPrefix,o,D),b=T(e.matchesPrefix,o,k),f=new E.LRUCache(1e4);function d(be,ke,Re=!1){if(typeof be!="string"||typeof ke!="string")return null;let Be=f.get(be);Be||(Be=new RegExp(P.convertSimple2RegExpPattern(be),"i"),f.set(be,Be));const Se=Be.exec(ke);return Se?[{start:Se.index,end:Se.index+Se[0].length}]:Re?b(be,ke):m(be,ke)}e.matchesFuzzy=d;function A(be,ke){const Re=z(be,be.toLowerCase(),0,ke,ke.toLowerCase(),0,!0);return Re?B(Re):null}e.matchesFuzzy2=A;function L(be,ke,Re,Be,Se,Ke){const Q=Math.min(13,be.length);for(;Re<Q;Re++){const se=z(be,ke,Re,Be,Se,Ke,!1);if(se)return se}return[0,Ke]}e.anyScore=L;function B(be){if(typeof be=="undefined")return[];const ke=[],Re=be[1];for(let Be=be.length-1;Be>1;Be--){const Se=be[Be]+Re,Ke=ke[ke.length-1];Ke&&Ke.end===Se?Ke.end=Se+1:ke.push({start:Se,end:Se+1})}return ke}e.createMatches=B;const J=128;function j(){const be=[],ke=[];for(let Re=0;Re<=J;Re++)ke[Re]=0;for(let Re=0;Re<=J;Re++)be.push(ke.slice(0));return be}function U(be){const ke=[];for(let Re=0;Re<=be;Re++)ke[Re]=0;return ke}const $=U(2*J),F=U(2*J),N=j(),M=j(),x=j(),O=!1;function V(be,ke,Re,Be,Se){function Ke(se,_e,xe=" "){for(;se.length<_e;)se=xe+se;return se}let Q=` |   |${Be.split("").map(se=>Ke(se,3)).join("|")}
`;for(let se=0;se<=Re;se++)se===0?Q+=" |":Q+=`${ke[se-1]}|`,Q+=be[se].slice(0,Se+1).map(_e=>Ke(_e.toString(),3)).join("|")+`
`;return Q}function q(be,ke,Re,Be){be=be.substr(ke),Re=Re.substr(Be),console.log(V(M,be,be.length,Re,Re.length)),console.log(V(x,be,be.length,Re,Re.length)),console.log(V(N,be,be.length,Re,Re.length))}function X(be,ke){if(ke<0||ke>=be.length)return!1;const Re=be.codePointAt(ke);switch(Re){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!P.isEmojiImprecise(Re)}}function me(be,ke){if(ke<0||ke>=be.length)return!1;switch(be.charCodeAt(ke)){case 32:case 9:return!0;default:return!1}}function we(be,ke,Re){return ke[be]!==Re[be]}function Te(be,ke,Re,Be,Se,Ke,Q=!1){for(;ke<Re&&Se<Ke;)be[ke]===Be[Se]&&(Q&&($[ke]=Se),ke+=1),Se+=1;return ke===Re}e.isPatternInWord=Te;var Pe;(function(be){be[be.Diag=1]="Diag",be[be.Left=2]="Left",be[be.LeftLeft=3]="LeftLeft"})(Pe||(Pe={}));var Fe;(function(be){be.Default=[-100,0];function ke(Re){return!Re||Re.length===2&&Re[0]===-100&&Re[1]===0}be.isDefault=ke})(Fe=e.FuzzyScore||(e.FuzzyScore={}));function z(be,ke,Re,Be,Se,Ke,Q){const se=be.length>J?J:be.length,_e=Be.length>J?J:Be.length;if(!(Re>=se||Ke>=_e||se-Re>_e-Ke)&&!!Te(ke,Re,se,Se,Ke,_e,!0)){Y(se,_e,Re,Ke,ke,Se);let xe=1,Ve=1,$e=Re,Ze=Ke;const K=[!1];for(xe=1,$e=Re;$e<se;xe++,$e++){const le=$[$e],ve=F[$e],ye=$e+1<se?F[$e+1]:_e;for(Ve=le-Ke+1,Ze=le;Ze<ye;Ve++,Ze++){let We=Number.MIN_SAFE_INTEGER,Ne=!1;Ze<=ve&&(We=te(be,ke,$e,Re,Be,Se,Ze,_e,Ke,N[xe-1][Ve-1]===0,K));let qe=0;We!==Number.MAX_SAFE_INTEGER&&(Ne=!0,qe=We+M[xe-1][Ve-1]);const Je=Ze>le,et=Je?M[xe][Ve-1]+(N[xe][Ve-1]>0?-5:0):0,nt=Ze>le+1&&N[xe][Ve-1]>0,st=nt?M[xe][Ve-2]+(N[xe][Ve-2]>0?-5:0):0;if(nt&&(!Je||st>=et)&&(!Ne||st>=qe))M[xe][Ve]=st,x[xe][Ve]=3,N[xe][Ve]=0;else if(Je&&(!Ne||et>=qe))M[xe][Ve]=et,x[xe][Ve]=2,N[xe][Ve]=0;else if(Ne)M[xe][Ve]=qe,x[xe][Ve]=1,N[xe][Ve]=N[xe-1][Ve-1]+1;else throw new Error("not possible")}}if(O&&q(be,Re,Be,Ke),!(!K[0]&&!Q)){xe--,Ve--;const oe=[M[xe][Ve],Ke];let de=0,Z=0;for(;xe>=1;){let le=Ve;do{const ve=x[xe][le];if(ve===3)le=le-2;else if(ve===2)le=le-1;else break}while(le>=1);de>1&&ke[Re+xe-1]===Se[Ke+Ve-1]&&!we(le+Ke-1,Be,Se)&&de+1>N[xe][le]&&(le=Ve),le===Ve?de++:de=1,Z||(Z=le),xe--,Ve=le-1,oe.push(Ve)}_e===se&&(oe[0]+=2);const ie=Z-se;return oe[0]-=ie,oe}}}e.fuzzyScore=z;function Y(be,ke,Re,Be,Se,Ke){let Q=be-1,se=ke-1;for(;Q>=Re&&se>=Be;)Se[Q]===Ke[se]&&(F[Q]=se,Q--),se--}function te(be,ke,Re,Be,Se,Ke,Q,se,_e,xe,Ve){if(ke[Re]!==Ke[Q])return Number.MIN_SAFE_INTEGER;let $e=1,Ze=!1;return Q===Re-Be?$e=be[Re]===Se[Q]?7:5:we(Q,Se,Ke)&&(Q===0||!we(Q-1,Se,Ke))?($e=be[Re]===Se[Q]?7:5,Ze=!0):X(Ke,Q)&&(Q===0||!X(Ke,Q-1))?$e=5:(X(Ke,Q-1)||me(Ke,Q-1))&&($e=5,Ze=!0),$e>1&&Re===Be&&(Ve[0]=!0),Ze||(Ze=we(Q,Se,Ke)||X(Ke,Q-1)||me(Ke,Q-1)),Re===Be?Q>_e&&($e-=Ze?3:5):xe?$e+=Ze?2:0:$e+=Ze?0:1,Q+1===se&&($e-=Ze?3:5),$e}function ae(be,ke,Re,Be,Se,Ke,Q){return Ce(be,ke,Re,Be,Se,Ke,!0,Q)}e.fuzzyScoreGracefulAggressive=ae;function he(be,ke,Re,Be,Se,Ke,Q){return Ce(be,ke,Re,Be,Se,Ke,!1,Q)}e.fuzzyScoreGraceful=he;function Ce(be,ke,Re,Be,Se,Ke,Q,se){let _e=z(be,ke,Re,Be,Se,Ke,se);if(_e&&!Q)return _e;if(be.length>=3){const xe=Math.min(7,be.length-1);for(let Ve=Re+1;Ve<xe;Ve++){const $e=Oe(be,Ve);if($e){const Ze=z($e,$e.toLowerCase(),Re,Be,Se,Ke,se);Ze&&(Ze[0]-=3,(!_e||Ze[0]>_e[0])&&(_e=Ze))}}}return _e}function Oe(be,ke){if(!(ke+1>=be.length)){const Re=be[ke],Be=be[ke+1];if(Re!==Be)return be.slice(0,ke)+Be+Re+be.slice(ke+2)}}}),define(ge[135],pe([0,1,43,93,10]),function(G,e,E,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const I=new RegExp(`\\$\\(${E.CSSIcon.iconNameExpression}(?:${E.CSSIcon.iconModifierExpression})?\\)`,"g"),D=new RegExp(`(\\\\)?${I.source}`,"g");function k(u){return u.replace(D,(S,v)=>v?S:`\\${S}`)}e.escapeIcons=k;const y=new RegExp(`\\\\${I.source}`,"g");function n(u){return u.replace(y,S=>`\\${S}`)}e.markdownEscapeEscapedIcons=n;const R=new RegExp(`(\\s)?(\\\\)?${I.source}(\\s)?`,"g");function C(u){return u.indexOf(e.iconStartMarker)===-1?u:u.replace(R,(S,v,_,p)=>_?S:v||p||"")}e.stripIcons=C;function w(u){const S=u.indexOf(e.iconStartMarker);return S===-1?{text:u}:g(u,S)}e.parseLabelWithIcons=w;function g(u,S){const v=[];let _="";function p(h){if(h){_+=h;for(const m of h)v.push(t)}}let c=-1,l="",t=0,i,o,r=S;const a=u.length;for(p(u.substr(0,S));r<a;)i=u[r],o=u[r+1],i===e.iconStartMarker[0]&&o===e.iconStartMarker[1]?(c=r,p(l),l=e.iconStartMarker,r++):i===")"&&c!==-1?(t+=r-c+1,c=-1,l=""):c!==-1?/^[a-z0-9\-]$/i.test(i)?l+=i:(p(l),c=-1,l=""):p(i),r++;return p(l),{text:_,iconOffsets:v}}function s(u,S,v=!1){const{text:_,iconOffsets:p}=S;if(!p||p.length===0)return(0,P.matchesFuzzy)(u,_,v);const c=(0,T.ltrim)(_," "),l=_.length-c.length,t=(0,P.matchesFuzzy)(u,c,v);if(t)for(const i of t){const o=p[i.start+l]+l;i.start+=o,i.end+=o}return t}e.matchesFuzzyIconAware=s}),define(ge[94],pe([0,1,14,135,18]),function(G,e,E,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markedStringsEquals=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var I;(function(s){s[s.Paragraph=0]="Paragraph",s[s.Break=1]="Break"})(I=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class D{constructor(u="",S=!1){var v,_;if(this.value=u,typeof this.value!="string")throw(0,T.illegalArgument)("value");typeof S=="boolean"?(this.isTrusted=S,this.supportThemeIcons=!1):(this.isTrusted=(v=S.isTrusted)!==null&&v!==void 0?v:void 0,this.supportThemeIcons=(_=S.supportThemeIcons)!==null&&_!==void 0?_:!1)}appendText(u,S=0){return this.value+=C(this.supportThemeIcons?(0,P.escapeIcons)(u):u).replace(/([ \t]+)/g,(v,_)=>"&nbsp;".repeat(_.length)).replace(/^>/gm,"\\>").replace(/\n/g,S===1?`\\
`:`

`),this}appendMarkdown(u){return this.value+=u,this}appendCodeblock(u,S){return this.value+="\n```",this.value+=u,this.value+=`
`,this.value+=S,this.value+="\n```\n",this}}e.MarkdownString=D;function k(s){return y(s)?!s.value:Array.isArray(s)?s.every(k):!0}e.isEmptyMarkdownString=k;function y(s){return s instanceof D?!0:s&&typeof s=="object"?typeof s.value=="string"&&(typeof s.isTrusted=="boolean"||s.isTrusted===void 0)&&(typeof s.supportThemeIcons=="boolean"||s.supportThemeIcons===void 0):!1}e.isMarkdownString=y;function n(s,u){return!s&&!u?!0:!s||!u?!1:Array.isArray(s)&&Array.isArray(u)?(0,E.equals)(s,u,R):y(s)&&y(u)?R(s,u):!1}e.markedStringsEquals=n;function R(s,u){return s===u?!0:!s||!u?!1:s.value===u.value&&s.isTrusted===u.isTrusted&&s.supportThemeIcons===u.supportThemeIcons}function C(s){return s.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=C;function w(s){return s&&s.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=w;function g(s){const u=[],S=s.split("|").map(_=>_.trim());s=S[0];const v=S[1];if(v){const _=/height=(\d+)/.exec(v),p=/width=(\d+)/.exec(v),c=_?_[1]:"",l=p?p[1]:"",t=isFinite(parseInt(l)),i=isFinite(parseInt(c));t&&u.push(`width="${l}"`),i&&u.push(`height="${c}"`)}return{href:s,dimensions:u}}e.parseHrefAndDimensions=g}),define(ge[57],pe([0,1,22,10,2]),function(G,e,E,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function I(n){return JSON.stringify(n,k)}e.stringify=I;function D(n){let R=JSON.parse(n);return R=y(R),R}e.parse=D;function k(n,R){return R instanceof RegExp?{$mid:2,source:R.source,flags:(0,P.regExpFlags)(R)}:R}function y(n,R=0){if(!n||R>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return T.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof E.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let C=0;C<n.length;++C)n[C]=y(n[C],R+1);else for(const C in n)Object.hasOwnProperty.call(n,C)&&(n[C]=y(n[C],R+1))}return n}e.revive=y}),define(ge[11],pe([0,1,2,9]),function(G,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var T;(function(k){k.inMemory="inmemory",k.vscode="vscode",k.internal="private",k.walkThrough="walkThrough",k.walkThroughSnippet="walkThroughSnippet",k.http="http",k.https="https",k.file="file",k.mailto="mailto",k.untitled="untitled",k.data="data",k.command="command",k.vscodeRemote="vscode-remote",k.vscodeRemoteResource="vscode-remote-resource",k.userData="vscode-userdata",k.vscodeCustomEditor="vscode-custom-editor",k.vscodeNotebook="vscode-notebook",k.vscodeNotebookCell="vscode-notebook-cell",k.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",k.vscodeSettings="vscode-settings",k.vscodeWorkspaceTrust="vscode-workspace-trust",k.webviewPanel="webview-panel",k.vscodeWebview="vscode-webview",k.extension="extension",k.vscodeFileResource="vscode-file"})(T=e.Schemas||(e.Schemas={}));class I{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(y){this._preferredWebSchema=y}setDelegate(y){this._delegate=y}set(y,n,R){this._hosts[y]=n,this._ports[y]=R}setConnectionToken(y,n){this._connectionTokens[y]=n}rewrite(y){if(this._delegate)return this._delegate(y);const n=y.authority;let R=this._hosts[n];R&&R.indexOf(":")!==-1&&(R=`[${R}]`);const C=this._ports[n],w=this._connectionTokens[n];let g=`path=${encodeURIComponent(y.path)}`;return typeof w=="string"&&(g+=`&tkn=${encodeURIComponent(w)}`),E.URI.from({scheme:P.isWeb?this._preferredWebSchema:T.vscodeRemoteResource,authority:`${R}:${C}`,path:"/vscode-remote-resource",query:g})}}e.RemoteAuthorities=new I;class D{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(y,n,R){const C=this.toUri(y,n);return C.scheme===T.vscodeRemote?e.RemoteAuthorities.rewrite(C):P.isNative&&(R||P.isPreferringBrowserCodeLoad)&&C.scheme===T.file?C.with({scheme:T.vscodeFileResource,authority:C.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):C}asFileUri(y,n){const R=this.toUri(y,n);return R.scheme===T.vscodeFileResource?R.with({scheme:T.file,authority:R.authority!==this.FALLBACK_AUTHORITY?R.authority:null,query:null,fragment:null}):R}toUri(y,n){return E.URI.isUri(y)?y:E.URI.parse(n.toUrl(y))}}e.FileAccess=new D}),define(ge[74],pe([0,1,24]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const P=new E.LRUCache(1e4);function T(n){return y(n,"NFC",P)}e.normalizeNFC=T;const I=new E.LRUCache(1e4);function D(n){return y(n,"NFD",I)}e.normalizeNFD=D;const k=/[^\u0000-\u0080]/;function y(n,R,C){if(!e.canNormalize||!n)return n;const w=C.get(n);if(w)return w;let g;return k.test(n)?g=n.normalize(R):g=n,C.set(n,g),g}e.removeAccents=function(){if(e.canNormalize){const n=/[\u0300-\u036f]/g;return function(R){return D(R).replace(n,"")}}else return function(n){return n}}()}),define(ge[25],pe([0,1,30,8,2,10,11,9]),function(G,e,E,P,T,I,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(g){return(0,T.uriToFsPath)(g,!0)}e.originalFSPath=y;class n{constructor(s){this._ignorePathCasing=s}compare(s,u,S=!1){return s===u?0:(0,I.compare)(this.getComparisonKey(s,S),this.getComparisonKey(u,S))}isEqual(s,u,S=!1){return s===u?!0:!s||!u?!1:this.getComparisonKey(s,S)===this.getComparisonKey(u,S)}getComparisonKey(s,u=!1){return s.with({path:this._ignorePathCasing(s)?s.path.toLowerCase():void 0,fragment:u?null:void 0}).toString()}ignorePathCasing(s){return this._ignorePathCasing(s)}isEqualOrParent(s,u,S=!1){if(s.scheme===u.scheme){if(s.scheme===D.Schemas.file)return E.isEqualOrParent(y(s),y(u),this._ignorePathCasing(s))&&s.query===u.query&&(S||s.fragment===u.fragment);if((0,e.isEqualAuthority)(s.authority,u.authority))return E.isEqualOrParent(s.path,u.path,this._ignorePathCasing(s),"/")&&s.query===u.query&&(S||s.fragment===u.fragment)}return!1}joinPath(s,...u){return T.URI.joinPath(s,...u)}basenameOrAuthority(s){return(0,e.basename)(s)||s.authority}basename(s){return P.posix.basename(s.path)}extname(s){return P.posix.extname(s.path)}dirname(s){if(s.path.length===0)return s;let u;return s.scheme===D.Schemas.file?u=T.URI.file(P.dirname(y(s))).path:(u=P.posix.dirname(s.path),s.authority&&u.length&&u.charCodeAt(0)!==47&&(console.error(`dirname("${s.toString})) resulted in a relative path`),u="/")),s.with({path:u})}normalizePath(s){if(!s.path.length)return s;let u;return s.scheme===D.Schemas.file?u=T.URI.file(P.normalize(y(s))).path:u=P.posix.normalize(s.path),s.with({path:u})}relativePath(s,u){if(!(s.scheme!==u.scheme||!(0,e.isEqualAuthority)(s.authority,u.authority))){if(s.scheme===D.Schemas.file){const _=P.relative(y(s),y(u));return k.isWindows?E.toSlashes(_):_}let S=s.path||"/",v=u.path||"/";if(this._ignorePathCasing(s)){let _=0;for(const p=Math.min(S.length,v.length);_<p&&!(S.charCodeAt(_)!==v.charCodeAt(_)&&S.charAt(_).toLowerCase()!==v.charAt(_).toLowerCase());_++);S=v.substr(0,_)+S.substr(_)}return P.posix.relative(S,v)}}resolvePath(s,u){if(s.scheme===D.Schemas.file){const S=T.URI.file(P.resolve(y(s),u));return s.with({authority:S.authority,path:S.path})}return u.indexOf("/")===-1&&(u=E.toSlashes(u),/^[a-zA-Z]:(\/|$)/.test(u)&&(u="/"+u)),s.with({path:P.posix.resolve(s.path,u)})}isAbsolutePath(s){return!!s.path&&s.path[0]==="/"}isEqualAuthority(s,u){return s===u||(0,I.equalsIgnoreCase)(s,u)}hasTrailingPathSeparator(s,u=P.sep){if(s.scheme===D.Schemas.file){const S=y(s);return S.length>E.getRoot(S).length&&S[S.length-1]===u}else{const S=s.path;return S.length>1&&S.charCodeAt(S.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(s.fsPath)}}removeTrailingPathSeparator(s,u=P.sep){return(0,e.hasTrailingPathSeparator)(s,u)?s.with({path:s.path.substr(0,s.path.length-1)}):s}addTrailingPathSeparator(s,u=P.sep){let S=!1;if(s.scheme===D.Schemas.file){const v=y(s);S=v!==void 0&&v.length===E.getRoot(v).length&&v[v.length-1]===u}else{u="/";const v=s.path;S=v.length===1&&v.charCodeAt(v.length-1)===47}return!S&&!(0,e.hasTrailingPathSeparator)(s,u)?s.with({path:s.path+"/"}):s}}e.ExtUri=n,e.extUri=new n(()=>!1),e.extUriBiasedIgnorePathCase=new n(g=>g.scheme===D.Schemas.file?!k.isLinux:!0),e.extUriIgnorePathCase=new n(g=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(g,s){const u=[];for(let S=0;S<g.length;S++){const v=s(g[S]);g.some((_,p)=>p===S?!1:(0,e.isEqualOrParent)(v,s(_)))||u.push(g[S])}return u}e.distinctParents=R;var C;(function(g){g.META_DATA_LABEL="label",g.META_DATA_DESCRIPTION="description",g.META_DATA_SIZE="size",g.META_DATA_MIME="mime";function s(u){const S=new Map;u.path.substring(u.path.indexOf(";")+1,u.path.lastIndexOf(";")).split(";").forEach(p=>{const[c,l]=p.split(":");c&&l&&S.set(c,l)});const _=u.path.substring(0,u.path.indexOf(";"));return _&&S.set(g.META_DATA_MIME,_),S}g.parseMetaData=s})(C=e.DataUri||(e.DataUri={}));function w(g,s,u){if(s){let S=g.path;return S&&S[0]!==P.posix.sep&&(S=P.posix.sep+S),g.with({scheme:u,authority:s,path:S})}return g.with({scheme:u})}e.toLocalResource=w}),define(ge[19],pe([0,1,21,18,3,6,55,25]),function(G,e,E,P,T,I,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y(M){return!!M&&typeof M.then=="function"}e.isThenable=y;function n(M){const x=new E.CancellationTokenSource,O=M(x.token),V=new Promise((q,X)=>{x.token.onCancellationRequested(()=>{X((0,P.canceled)())}),Promise.resolve(O).then(me=>{x.dispose(),q(me)},me=>{x.dispose(),X(me)})});return new class{cancel(){x.cancel()}then(q,X){return V.then(q,X)}catch(q){return this.then(void 0,q)}finally(q){return V.finally(q)}}}e.createCancelablePromise=n;function R(M,x,O){return Promise.race([M,new Promise(V=>x.onCancellationRequested(()=>V(O)))])}e.raceCancellation=R;async function C(M){let x=-1;const O=M.map((q,X)=>q.then(me=>(x=X,me))),V=await Promise.race(O);return M.forEach((q,X)=>{X!==x&&q.cancel()}),V}e.raceCancellablePromises=C;function w(M,x,O){let V;const q=setTimeout(()=>{V==null||V(void 0),O==null||O()},x);return Promise.race([M.finally(()=>clearTimeout(q)),new Promise(X=>V=X)])}e.raceTimeout=w;function g(M){return new Promise((x,O)=>{const V=M();y(V)?V.then(x,O):x(V)})}e.asPromise=g;class s{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(x){if(this.activePromise){if(this.queuedPromiseFactory=x,!this.queuedPromise){const O=()=>{this.queuedPromise=null;const V=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,V};this.queuedPromise=new Promise(V=>{this.activePromise.then(O,O).then(V)})}return new Promise((O,V)=>{this.queuedPromise.then(O,V)})}return this.activePromise=x(),new Promise((O,V)=>{this.activePromise.then(q=>{this.activePromise=null,O(q)},q=>{this.activePromise=null,V(q)})})}}e.Throttler=s;class u{constructor(){this.current=Promise.resolve(null)}queue(x){return this.current=this.current.then(()=>x(),()=>x())}}e.Sequencer=u;class S{constructor(){this.promiseMap=new Map}queue(x,O){var V;const X=((V=this.promiseMap.get(x))!==null&&V!==void 0?V:Promise.resolve()).catch(()=>{}).then(O).finally(()=>{this.promiseMap.get(x)===X&&this.promiseMap.delete(x)});return this.promiseMap.set(x,X),X}}e.SequencerByKey=S;class v{constructor(x){this.defaultDelay=x,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(x,O=this.defaultDelay){return this.task=x,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((V,q)=>{this.doResolve=V,this.doReject=q}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const V=this.task;return this.task=null,V()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},O),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,P.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=v;class _{constructor(x){this.delayer=new v(x),this.throttler=new s}trigger(x,O){return this.delayer.trigger(()=>this.throttler.queue(x),O)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=_;class p{constructor(){this._isOpen=!1,this._promise=new Promise((x,O)=>{this._completePromise=x})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=p;class c extends p{constructor(x){super();this._timeout=setTimeout(()=>this.open(),x)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=c;function l(M,x){return x?new Promise((O,V)=>{const q=setTimeout(O,M);x.onCancellationRequested(()=>{clearTimeout(q),V((0,P.canceled)())})}):n(O=>l(M,O))}e.timeout=l;function t(M,x=0){const O=setTimeout(M,x);return(0,I.toDisposable)(()=>clearTimeout(O))}e.disposableTimeout=t;function i(M){return M.then(void 0,x=>{})}e.ignoreErrors=i;function o(M){const x=[];let O=0;const V=M.length;function q(){return O<V?M[O++]():null}function X(me){me!=null&&x.push(me);const we=q();return we?we.then(X):Promise.resolve(x)}return Promise.resolve(null).then(X)}e.sequence=o;function r(M,x=V=>!!V,O=null){let V=0;const q=M.length,X=()=>{if(V>=q)return Promise.resolve(O);const me=M[V++];return Promise.resolve(me()).then(Te=>x(Te)?Promise.resolve(Te):X())};return X()}e.first=r;function a(M,x=V=>!!V,O=null){if(M.length===0)return Promise.resolve(O);let V=M.length;const q=()=>{var X,me;V=-1;for(const we of M)(me=(X=we).cancel)===null||me===void 0||me.call(X)};return new Promise((X,me)=>{for(const we of M)we.then(Te=>{--V>=0&&x(Te)?(q(),X(Te)):V===0&&X(O)}).catch(Te=>{--V>=0&&(q(),me(Te))})})}e.firstParallel=a;class h{constructor(x){this._size=0,this.maxDegreeOfParalellism=x,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new T.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(x){return this._size++,new Promise((O,V)=>{this.outstandingPromises.push({factory:x,c:O,e:V}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const x=this.outstandingPromises.shift();this.runningPromises++;const O=x.factory();O.then(x.c,x.e),O.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=h;class m extends h{constructor(){super(1)}}e.Queue=m;class b{constructor(){this.queues=new Map}queueFor(x,O=k.extUri){const V=O.getComparisonKey(x);let q=this.queues.get(V);return q||(q=new m,T.Event.once(q.onFinished)(()=>{q==null||q.dispose(),this.queues.delete(V)}),this.queues.set(V,q)),q}dispose(){this.queues.forEach(x=>x.dispose()),this.queues.clear()}}e.ResourceQueue=b;class f{constructor(x,O){this._token=-1,typeof x=="function"&&typeof O=="number"&&this.setIfNotSet(x,O)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(x,O){this.cancel(),this._token=setTimeout(()=>{this._token=-1,x()},O)}setIfNotSet(x,O){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,x()},O))}}e.TimeoutTimer=f;class d{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(x,O){this.cancel(),this._token=setInterval(()=>{x()},O)}}e.IntervalTimer=d;class A{constructor(x,O){this.timeoutToken=-1,this.runner=x,this.timeout=O,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(x=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,x)}get delay(){return this.timeout}set delay(x){this.timeout=x}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=A;class L extends A{constructor(x,O){super(x,O);this.units=[]}work(x){this.units.push(x),this.isScheduled()||this.schedule()}doRun(){const x=this.units;this.units=[],this.runner&&this.runner(x)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=L,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const M=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=x=>{const O=setTimeout(()=>x(M));let V=!1;return{dispose(){V||(V=!0,clearTimeout(O))}}}}else e.runWhenIdle=(M,x)=>{const O=requestIdleCallback(M,typeof x=="number"?{timeout:x}:void 0);let V=!1;return{dispose(){V||(V=!0,cancelIdleCallback(O))}}}}();class B{constructor(x){this._didRun=!1,this._executor=()=>{try{this._value=x()}catch(O){this._error=O}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=B;async function J(M,x,O){let V;for(let q=0;q<O;q++)try{return await M()}catch(X){V=X,await l(x)}throw V}e.retry=J;class j{hasPending(x){return this._pending?typeof x=="number"?this._pending.taskId===x:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var x;(x=this._pending)===null||x===void 0||x.cancel()}setPending(x,O,V){return this._pending={taskId:x,cancel:()=>V==null?void 0:V(),promise:O},O.then(()=>this.donePending(x),()=>this.donePending(x)),O}donePending(x){this._pending&&x===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const x=this._next;this._next=void 0,x.run().then(x.promiseResolve,x.promiseReject)}}setNext(x){if(this._next)this._next.run=x;else{let O,V;const q=new Promise((X,me)=>{O=X,V=me});this._next={run:x,promise:q,promiseResolve:O,promiseReject:V}}return this._next.promise}}e.TaskSequentializer=j;class U{constructor(x){this.interval=x,this.lastIncrementTime=0,this.value=0}increment(){const x=Date.now();return x-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=x,this.value=0),this.value++,this.value}}e.IntervalCounter=U;class ${constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((x,O)=>{this.completeCallback=x,this.errorCallback=O})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(x){return new Promise(O=>{this.completeCallback(x),this.resolved=!0,O()})}error(x){return new Promise(O=>{this.errorCallback(x),this.rejected=!0,O()})}cancel(){new Promise(x=>{this.errorCallback((0,P.canceled)()),this.rejected=!0,x()})}}e.DeferredPromise=$;class F extends T.Emitter{async fireAsync(x,O,V){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new D.LinkedList);for(const q of this._listeners)this._asyncDeliveryQueue.push([q,x]);for(;this._asyncDeliveryQueue.size>0&&!O.isCancellationRequested;){const[q,X]=this._asyncDeliveryQueue.shift(),me=[],we=Object.assign(Object.assign({},X),{waitUntil:Te=>{if(Object.isFrozen(me))throw new Error("waitUntil can NOT be called asynchronous");V&&(Te=V(Te,typeof q=="function"?q:q[0])),me.push(Te)}});try{typeof q=="function"?q.call(void 0,we):q[0].call(q[1],we)}catch(Te){(0,P.onUnexpectedError)(Te);continue}Object.freeze(me),await N.settled(me).catch(Te=>(0,P.onUnexpectedError)(Te))}}}}e.AsyncEmitter=F;var N;(function(M){async function x(X){return typeof Promise.allSettled=="function"?O(X):V(X)}M.allSettled=x;async function O(X){return Promise.allSettled(X)}async function V(X){return Promise.all(X.map(me=>me.then(we=>({status:"fulfilled",value:we}),we=>({status:"rejected",reason:we}))))}async function q(X){let me;const we=await Promise.all(X.map(Te=>Te.then(Pe=>Pe,Pe=>{me||(me=Pe)})));if(typeof me!="undefined")throw me;return we}M.settled=q})(N=e.Promises||(e.Promises={}))}),define(ge[95],pe([0,1,8,19]),function(G,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesDefault=e.compareFileNames=void 0;const T=new P.IdleValue(()=>{const c=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:c,collatorIsNumeric:c.resolvedOptions().numeric}}),I=new P.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),D=new P.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function k(c,l,t=!1){const i=c||"",o=l||"",r=T.value.collator.compare(i,o);return T.value.collatorIsNumeric&&r===0&&i!==o?i<o?-1:1:r}e.compareFileNames=k;function y(c,l){const t=I.value.collator;return c=c||"",l=l||"",u(t,c,l)}e.compareFileNamesDefault=y;function n(c,l,t=!1){t||(c=c&&c.toLowerCase(),l=l&&l.toLowerCase());const[i,o]=g(c),[r,a]=g(l);return i!==r?i<r?-1:1:o===a?0:o<a?-1:1}e.noIntlCompareFileNames=n;function R(c,l){const[t,i]=g(c),[o,r]=g(l);let a=T.value.collator.compare(i,r);if(a===0){if(T.value.collatorIsNumeric&&i!==r)return i<r?-1:1;if(a=T.value.collator.compare(t,o),T.value.collatorIsNumeric&&a===0&&t!==o)return t<o?-1:1}return a}e.compareFileExtensions=R;function C(c,l){c=c||"",l=l||"";const t=s(c),i=s(l),o=I.value.collator,r=D.value.collator;let a;return a=u(r,t,i),a!==0?a:u(o,c,l)}e.compareFileExtensionsDefault=C;const w=/^(.*?)(\.([^.]*))?$/;function g(c,l=!1){const t=c?w.exec(c):[];let i=[t&&t[1]||"",t&&t[3]||""];return l&&(!i[0]&&i[1]||i[0]&&i[0].charAt(0)===".")&&(i=[i[0]+"."+i[1],""]),i}function s(c){const l=c?w.exec(c):[];return l&&l[1]&&l[1].charAt(0)!=="."&&l[3]||""}function u(c,l,t){let i=c.compare(l,t);return i!==0?i:l.length!==t.length?l.length<t.length?-1:1:0}function S(c,l,t=!1){return t||(c=c&&c.toLowerCase(),l=l&&l.toLowerCase()),c===l?0:c<l?-1:1}function v(c,l,t=!1){const i=c.split(E.sep),o=l.split(E.sep),r=i.length-1,a=o.length-1;let h,m;for(let b=0;;b++){if(h=r===b,m=a===b,h&&m)return k(i[b],o[b],t);if(h)return-1;if(m)return 1;const f=S(i[b],o[b],t);if(f!==0)return f}}e.comparePaths=v;function _(c,l,t){const i=c.toLowerCase(),o=l.toLowerCase(),r=p(c,l,t);if(r)return r;const a=i.endsWith(t),h=o.endsWith(t);if(a!==h)return a?-1:1;const m=k(i,o);return m!==0?m:i.localeCompare(o)}e.compareAnything=_;function p(c,l,t){const i=c.toLowerCase(),o=l.toLowerCase(),r=i.startsWith(t),a=o.startsWith(t);if(r!==a)return r?-1:1;if(r&&a){if(i.length<o.length)return-1;if(i.length>o.length)return 1}return 0}e.compareByPrefix=p}),define(ge[96],pe([0,1,95,93,8,9,10]),function(G,e,E,P,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const k=0,y=[k,[]];function n(U,$,F,N){if(!U||!$)return y;const M=U.length,x=$.length;if(M<x)return y;const O=U.toLowerCase();return!N&&!O.includes(F)?y:R($,F,x,U,O,M)}e.scoreFuzzy=n;function R(U,$,F,N,M,x){const O=[],V=[];for(let we=0;we<F;we++){const Te=we*x,Pe=Te-x,Fe=we>0,z=U[we],Y=$[we];for(let te=0;te<x;te++){const ae=te>0,he=Te+te,Ce=he-1,Oe=Pe+te-1,be=ae?O[Ce]:0,ke=Fe&&ae?O[Oe]:0,Re=Fe&&ae?V[Oe]:0;let Be;!ke&&Fe?Be=0:Be=C(z,Y,N,M,te,Re),Be&&ke+Be>=be?(V[he]=Re+1,O[he]=ke+Be):(V[he]=k,O[he]=be)}}const q=[];let X=F-1,me=x-1;for(;X>=0&&me>=0;){const we=X*x+me;V[we]===k||(q.push(me),X--),me--}return[O[F*x-1],q.reverse()]}function C(U,$,F,N,M,x){let O=0;if(!w($,N[M]))return O;if(O+=1,x>0&&(O+=x*5),U===F[M]&&(O+=1),M===0)O+=8;else{const V=g(F.charCodeAt(M-1));V?O+=V:(0,P.isUpper)(F.charCodeAt(M))&&(O+=2)}return O}function w(U,$){return U===$?!0:U==="/"||U==="\\"?$==="/"||$==="\\":!1}function g(U){switch(U){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const s=[void 0,[]];function u(U,$,F=0,N=0){const M=$;return M.values&&M.values.length>1?S(U,M.values,F,N):v(U,$,F,N)}e.scoreFuzzy2=u;function S(U,$,F,N){let M=0;const x=[];for(const O of $){const[V,q]=v(U,O,F,N);if(typeof V!="number")return s;M+=V,x.push(...q)}return[M,h(x)]}function v(U,$,F,N){const M=(0,P.fuzzyScore)($.original,$.originalLowercase,F,U,U.toLowerCase(),N,!0);return M?[M[0],(0,P.createMatches)(M)]:s}const _=Object.freeze({score:0}),p=1<<18,c=1<<17,l=1<<16;function t(U,$,F,N,M){if(!U||!$.normalized)return _;const x=N.getItemLabel(U);if(!x)return _;const O=N.getItemDescription(U);let V;O?V=`${x}${O}${$.normalized}${Array.isArray($.values)?$.values.length:""}${F}`:V=`${x}${$.normalized}${Array.isArray($.values)?$.values.length:""}${F}`;const q=M[V];if(q)return q;const X=i(x,O,N.getItemPath(U),$,F);return M[V]=X,X}e.scoreItemFuzzy=t;function i(U,$,F,N,M){const x=!F||!N.containsPathSeparator;return F&&(I.isLinux?N.pathNormalized===F:(0,D.equalsIgnoreCase)(N.pathNormalized,F))?{score:p,labelMatch:[{start:0,end:U.length}],descriptionMatch:$?[{start:0,end:$.length}]:void 0}:N.values&&N.values.length>1?o(U,$,F,N.values,x,M):r(U,$,F,N,x,M)}function o(U,$,F,N,M,x){let O=0;const V=[],q=[];for(const X of N){const{score:me,labelMatch:we,descriptionMatch:Te}=r(U,$,F,X,M,x);if(me===k)return _;O+=me,we&&V.push(...we),Te&&q.push(...Te)}return{score:O,labelMatch:h(V),descriptionMatch:h(q)}}function r(U,$,F,N,M,x){if(M||!$){const[O,V]=n(U,N.normalized,N.normalizedLowercase,x);if(O){const q=(0,P.matchesPrefix)(N.normalized,U);let X;return q?(X=c,X+=Math.round(N.normalized.length/U.length*100)):X=l,{score:X+O,labelMatch:q||a(V)}}}if($){let O=$;F&&(O=`${$}${T.sep}`);const V=O.length,q=`${O}${U}`,[X,me]=n(q,N.normalized,N.normalizedLowercase,x);if(X){const we=a(me),Te=[],Pe=[];return we.forEach(Fe=>{Fe.start<V&&Fe.end>V?(Te.push({start:0,end:Fe.end-V}),Pe.push({start:Fe.start,end:V})):Fe.start>=V?Te.push({start:Fe.start-V,end:Fe.end-V}):Pe.push(Fe)}),{score:X,labelMatch:Te,descriptionMatch:Pe}}}return _}function a(U){const $=[];if(!U)return $;let F;for(const N of U)F&&F.end===N?F.end+=1:(F={start:N,end:N+1},$.push(F));return $}function h(U){const $=U.sort((M,x)=>M.start-x.start),F=[];let N;for(const M of $)!N||!m(N,M)?(N=M,F.push(M)):(N.start=Math.min(N.start,M.start),N.end=Math.max(N.end,M.end));return F}function m(U,$){return!(U.end<$.start||$.end<U.start)}function b(U,$,F,N,M,x){const O=t(U,F,N,M,x),V=t($,F,N,M,x),q=O.score,X=V.score;if((q===p||X===p)&&q!==X)return q===p?-1:1;if(q>l||X>l){if(q!==X)return q>X?-1:1;if(q<c&&X<c){const Y=d(O.labelMatch,V.labelMatch);if(Y!==0)return Y}const Fe=M.getItemLabel(U)||"",z=M.getItemLabel($)||"";if(Fe.length!==z.length)return Fe.length-z.length}if(q!==X)return q>X?-1:1;const me=Array.isArray(O.labelMatch)&&O.labelMatch.length>0,we=Array.isArray(V.labelMatch)&&V.labelMatch.length>0;if(me&&!we)return-1;if(we&&!me)return 1;const Te=f(U,O,M),Pe=f($,V,M);return Te&&Pe&&Te!==Pe?Pe>Te?-1:1:A(U,$,F,M)}e.compareItemsByFuzzyScore=b;function f(U,$,F){let N=-1,M=-1;if($.descriptionMatch&&$.descriptionMatch.length?N=$.descriptionMatch[0].start:$.labelMatch&&$.labelMatch.length&&(N=$.labelMatch[0].start),$.labelMatch&&$.labelMatch.length){if(M=$.labelMatch[$.labelMatch.length-1].end,$.descriptionMatch&&$.descriptionMatch.length){const x=F.getItemDescription(U);x&&(M+=x.length)}}else $.descriptionMatch&&$.descriptionMatch.length&&(M=$.descriptionMatch[$.descriptionMatch.length-1].end);return M-N}function d(U,$){if(!U&&!$||(!U||!U.length)&&(!$||!$.length))return 0;if(!$||!$.length)return-1;if(!U||!U.length)return 1;const F=U[0].start,M=U[U.length-1].end-F,x=$[0].start,V=$[$.length-1].end-x;return M===V?0:V<M?1:-1}function A(U,$,F,N){const M=N.getItemLabel(U)||"",x=N.getItemLabel($)||"",O=N.getItemDescription(U),V=N.getItemDescription($),q=M.length+(O?O.length:0),X=x.length+(V?V.length:0);if(q!==X)return q-X;const me=N.getItemPath(U),we=N.getItemPath($);return me&&we&&me.length!==we.length?me.length-we.length:M!==x?(0,E.compareAnything)(M,x,F.normalized):O&&V&&O!==V?(0,E.compareAnything)(O,V,F.normalized):me&&we&&me!==we?(0,E.compareAnything)(me,we,F.normalized):0}const L=" ";function B(U){typeof U!="string"&&(U="");const $=U.toLowerCase(),{pathNormalized:F,normalized:N,normalizedLowercase:M}=J(U),x=F.indexOf(T.sep)>=0;let O;const V=U.split(L);if(V.length>1)for(const q of V){const{pathNormalized:X,normalized:me,normalizedLowercase:we}=J(q);me&&(O||(O=[]),O.push({original:q,originalLowercase:q.toLowerCase(),pathNormalized:X,normalized:me,normalizedLowercase:we}))}return{original:U,originalLowercase:$,pathNormalized:F,normalized:N,normalizedLowercase:M,values:O,containsPathSeparator:x}}e.prepareQuery=B;function J(U){let $;I.isWindows?$=U.replace(/\//g,T.sep):$=U.replace(/\\/g,T.sep);const F=(0,D.stripWildcards)($).replace(/\s/g,"");return{pathNormalized:$,normalized:F,normalizedLowercase:F.toLowerCase()}}function j(U){return Array.isArray(U)?B(U.map($=>$.original).join(L)):B(U.original)}e.pieceToQuery=j}),define(ge[33],pe([0,1,10,30,8,24,19]),function(G,e,E,P,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function k(){return Object.create(null)}e.getEmptyExpression=k;const y="**",n="/",R="[/\\\\]",C="[^/\\\\]",w=/\//g;function g(O){switch(O){case 0:return"";case 1:return`${C}*?`;default:return`(?:${R}|${C}+${R}|${R}${C}+)*?`}}function s(O,V){if(!O)return[];const q=[];let X=!1,me=!1,we="";for(const Te of O){switch(Te){case V:if(!X&&!me){q.push(we),we="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":me=!0;break;case"]":me=!1;break}we+=Te}return we&&q.push(we),q}e.splitGlobAware=s;function u(O){if(!O)return"";let V="";const q=s(O,n);if(q.every(X=>X===y))V=".*";else{let X=!1;q.forEach((me,we)=>{if(me===y){X||(V+=g(2),X=!0);return}let Te=!1,Pe="",Fe=!1,z="";for(const Y of me){if(Y!=="}"&&Te){Pe+=Y;continue}if(Fe&&(Y!=="]"||!z)){let te;Y==="-"?te=Y:(Y==="^"||Y==="!")&&!z?te="^":Y===n?te="":te=E.escapeRegExpCharacters(Y),z+=te;continue}switch(Y){case"{":Te=!0;continue;case"[":Fe=!0;continue;case"}":V+=`(?:${s(Pe,",").map(he=>u(he)).join("|")})`,Te=!1,Pe="";break;case"]":V+="["+z+"]",Fe=!1,z="";break;case"?":V+=C;continue;case"*":V+=g(1);continue;default:V+=E.escapeRegExpCharacters(Y)}}we<q.length-1&&(q[we+1]!==y||we+2<q.length)&&(V+=R),X=!1})}return V}const S=/^\*\*\/\*\.[\w\.-]+$/,v=/^\*\*\/([\w\.-]+)\/?$/,_=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,p=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new I.LRUCache(1e4),i=function(){return!1},o=function(){return null};function r(O,V){if(!O)return o;let q;typeof O!="string"?q=O.pattern:q=O,q=q.trim();const X=`${q}_${!!V.trimForExclusions}`;let me=t.get(X);if(me)return a(me,O);let we;if(S.test(q)){const Te=q.substr(4);me=function(Pe,Fe){return typeof Pe=="string"&&Pe.endsWith(Te)?q:null}}else(we=v.exec(h(q,V)))?me=m(we[1],q):(V.trimForExclusions?p:_).test(q)?me=b(q,V):(we=c.exec(h(q,V)))?me=f(we[1].substr(1),q,!0):(we=l.exec(h(q,V)))?me=f(we[1],q,!1):me=d(q);return t.set(X,me),a(me,O)}function a(O,V){return typeof V=="string"?O:function(q,X){return P.isEqualOrParent(q,V.base)?O(T.relative(V.base,q),X):null}}function h(O,V){return V.trimForExclusions&&O.endsWith("/**")?O.substr(0,O.length-2):O}function m(O,V){const q=`/${O}`,X=`\\${O}`,me=function(Te,Pe){return typeof Te!="string"?null:Pe?Pe===O?V:null:Te===O||Te.endsWith(q)||Te.endsWith(X)?V:null},we=[O];return me.basenames=we,me.patterns=[V],me.allBasenames=we,me}function b(O,V){const q=x(O.slice(1,-1).split(",").map(Pe=>r(Pe,V)).filter(Pe=>Pe!==o),O),X=q.length;if(!X)return o;if(X===1)return q[0];const me=function(Pe,Fe){for(let z=0,Y=q.length;z<Y;z++)if(q[z](Pe,Fe))return O;return null},we=q.find(Pe=>!!Pe.allBasenames);we&&(me.allBasenames=we.allBasenames);const Te=q.reduce((Pe,Fe)=>Fe.allPaths?Pe.concat(Fe.allPaths):Pe,[]);return Te.length&&(me.allPaths=Te),me}function f(O,V,q){const X=T.sep===T.posix.sep,me=X?O:O.replace(w,T.sep),we=T.sep+me,Te=T.posix.sep+O,Pe=q?function(Fe,z){return typeof Fe=="string"&&(Fe===me||Fe.endsWith(we)||!X&&(Fe===O||Fe.endsWith(Te)))?V:null}:function(Fe,z){return typeof Fe=="string"&&(Fe===me||!X&&Fe===O)?V:null};return Pe.allPaths=[(q?"*/":"./")+O],Pe}function d(O){try{const V=new RegExp(`^${u(O)}$`);return function(q){return V.lastIndex=0,typeof q=="string"&&V.test(q)?O:null}}catch(V){return o}}function A(O,V,q){return!O||typeof V!="string"?!1:L(O)(V,void 0,q)}e.match=A;function L(O,V={}){if(!O)return i;if(typeof O=="string"||U(O)){const q=r(O,V);if(q===o)return i;const X=function(me,we){return!!q(me,we)};return q.allBasenames&&(X.allBasenames=q.allBasenames),q.allPaths&&(X.allPaths=q.allPaths),X}return N(O,V)}e.parse=L;function B(O){if(!!O){let V;return q=>(V||(V=(O()||Promise.resolve([])).then(X=>X?j(X):{})),V.then(X=>!!X[q]))}}e.hasSiblingPromiseFn=B;function J(O){if(!!O){let V;return q=>{if(!V){const X=O();V=X?j(X):{}}return!!V[q]}}}e.hasSiblingFn=J;function j(O){const V={};for(const q of O)V[q]=!0;return V}function U(O){const V=O;return V&&typeof V.base=="string"&&typeof V.pattern=="string"}e.isRelativePattern=U;function $(O){return O.allBasenames||[]}e.getBasenameTerms=$;function F(O){return O.allPaths||[]}e.getPathTerms=F;function N(O,V){const q=x(Object.getOwnPropertyNames(O).map(Pe=>M(Pe,O[Pe],V)).filter(Pe=>Pe!==o)),X=q.length;if(!X)return o;if(!q.some(Pe=>!!Pe.requiresSiblings)){if(X===1)return q[0];const Pe=function(Y,te){for(let ae=0,he=q.length;ae<he;ae++){const Ce=q[ae](Y,te);if(Ce)return Ce}return null},Fe=q.find(Y=>!!Y.allBasenames);Fe&&(Pe.allBasenames=Fe.allBasenames);const z=q.reduce((Y,te)=>te.allPaths?Y.concat(te.allPaths):Y,[]);return z.length&&(Pe.allPaths=z),Pe}const me=function(Pe,Fe,z){let Y;for(let te=0,ae=q.length;te<ae;te++){const he=q[te];he.requiresSiblings&&z&&(Fe||(Fe=T.basename(Pe)),Y||(Y=Fe.substr(0,Fe.length-T.extname(Pe).length)));const Ce=he(Pe,Fe,Y,z);if(Ce)return Ce}return null},we=q.find(Pe=>!!Pe.allBasenames);we&&(me.allBasenames=we.allBasenames);const Te=q.reduce((Pe,Fe)=>Fe.allPaths?Pe.concat(Fe.allPaths):Pe,[]);return Te.length&&(me.allPaths=Te),me}function M(O,V,q){if(V===!1)return o;const X=r(O,q);if(X===o)return o;if(typeof V=="boolean")return X;if(V){const me=V.when;if(typeof me=="string"){const we=(Te,Pe,Fe,z)=>{if(!z||!X(Te,Pe))return null;const Y=me.replace("$(basename)",Fe),te=z(Y);return(0,D.isThenable)(te)?te.then(ae=>ae?O:null):te?O:null};return we.requiresSiblings=!0,we}}return X}function x(O,V){const q=O.filter(Pe=>!!Pe.basenames);if(q.length<2)return O;const X=q.reduce((Pe,Fe)=>{const z=Fe.basenames;return z?Pe.concat(z):Pe},[]);let me;if(V){me=[];for(let Pe=0,Fe=X.length;Pe<Fe;Pe++)me.push(V)}else me=q.reduce((Pe,Fe)=>{const z=Fe.patterns;return z?Pe.concat(z):Pe},[]);const we=function(Pe,Fe){if(typeof Pe!="string")return null;if(!Fe){let Y;for(Y=Pe.length;Y>0;Y--){const te=Pe.charCodeAt(Y-1);if(te===47||te===92)break}Fe=Pe.substr(Y)}const z=X.indexOf(Fe);return z!==-1?me[z]:null};we.basenames=X,we.patterns=me,we.allBasenames=X;const Te=O.filter(Pe=>!Pe.basenames);return Te.push(we),Te}}),define(ge[75],pe([0,1,2,8,10,11,9,25,30]),function(G,e,E,P,T,I,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function n(r,a,h){if(typeof r=="string"&&(r=E.URI.file(r)),h){const b=h.getWorkspaceFolder(r);if(b){const f=h.getWorkspace().folders.length>1;let d;if((0,k.isEqual)(b.uri,r)?d="":d=(0,k.relativePath)(b.uri,r),f){const A=b.name?b.name:(0,k.basename)(b.uri);d=d?A+" \u2022 "+d:A}return d}}if(r.scheme!==I.Schemas.file&&r.scheme!==I.Schemas.untitled)return r.with({query:null,fragment:null}).toString(!0);if((0,y.hasDriveLetter)(r.fsPath))return(0,P.normalize)(C(r.fsPath));let m=(0,P.normalize)(r.fsPath);return!D.isWindows&&(a==null?void 0:a.userHome)&&(m=g(m,a.userHome.fsPath)),m}e.getPathLabel=n;function R(r){if(!!r){typeof r=="string"&&(r=E.URI.file(r));const a=(0,k.basename)(r)||(r.scheme===I.Schemas.file?r.fsPath:r.path);return D.isWindows&&(0,y.isRootOrDriveLetter)(a)?C(a):a}}e.getBaseLabel=R;function C(r){return(0,y.hasDriveLetter)(r)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=C;let w=Object.create(null);function g(r,a){if(D.isWindows||!r||!a)return r;let h=w.original===a?w.normalized:void 0;return h||(h=`${(0,T.rtrim)(a,P.posix.sep)}${P.posix.sep}`,w={original:a,normalized:h}),(D.isLinux?r.startsWith(h):(0,T.startsWithIgnoreCase)(r,h))&&(r=`~/${r.substr(h.length)}`),r}e.tildify=g;function s(r,a){return r.replace(/^~($|\/|\\)/,`${a}$1`)}e.untildify=s;const u="\u2026",S="\\\\",v="~";function _(r,a=P.sep){const h=new Array(r.length);let m=!1;for(let b=0;b<r.length;b++){let f=r[b];if(f===""){h[b]=`.${a}`;continue}if(!f){h[b]=f;continue}m=!0;let d="";f.indexOf(S)===0?(d=f.substr(0,f.indexOf(S)+S.length),f=f.substr(f.indexOf(S)+S.length)):f.indexOf(a)===0?(d=f.substr(0,f.indexOf(a)+a.length),f=f.substr(f.indexOf(a)+a.length)):f.indexOf(v)===0&&(d=f.substr(0,f.indexOf(v)+v.length),f=f.substr(f.indexOf(v)+v.length));const A=f.split(a);for(let L=1;m&&L<=A.length;L++)for(let B=A.length-L;m&&B>=0;B--){m=!1;let J=A.slice(B,B+L).join(a);for(let j=0;!m&&j<r.length;j++)if(j!==b&&r[j]&&r[j].indexOf(J)>-1){const U=B+L===A.length,$=B>0&&r[j].indexOf(a)>-1?a+J:J,F=r[j].endsWith($);m=!U||F}if(!m){let j="";(A[0].endsWith(":")||d!=="")&&(B===1&&(B=0,L++,J=A[0]+a+J),B>0&&(j=A[0]+a),j=d+j),B>0&&(j=j+u+a),j=j+J,B+L<A.length&&(j=j+a+u),h[b]=j}}m&&(h[b]=f)}return h}e.shorten=_;var p;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(p||(p={}));function c(r,a=Object.create(null)){const h=[];let m=!1,b="";for(const f of r)if(f==="$"||m&&f==="{")b&&h.push({value:b,type:p.TEXT}),b="",m=!0;else if(f==="}"&&m){const d=a[b];if(typeof d=="string")d.length&&h.push({value:d,type:p.VARIABLE});else if(d){const A=h[h.length-1];(!A||A.type!==p.SEPARATOR)&&h.push({value:d.label,type:p.SEPARATOR})}b="",m=!1}else b+=f;return b&&!m&&h.push({value:b,type:p.TEXT}),h.filter((f,d)=>{if(f.type===p.SEPARATOR){const A=h[d-1],L=h[d+1];return[A,L].every(B=>B&&(B.type===p.VARIABLE||B.type===p.TEXT)&&B.value.length>0)}return!0}).map(f=>f.value).join("")}e.template=c;function l(r,a){return D.isMacintosh||a?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,D.isMacintosh?"&":"&&"):r.replace(/&&|&/g,h=>h==="&"?"&&":"&")}e.mnemonicMenuLabel=l;function t(r,a){return D.isMacintosh||a?r.replace(/\(&&\w\)|&&/g,""):D.isWindows?r.replace(/&&|&/g,h=>h==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function i(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=i;function o(r){const a=r.indexOf("/")!==-1?P.posix:P.win32,h=a.basename(r),m=a.dirname(r);return h.length?{name:h,parentPath:m}:{name:m,parentPath:""}}e.splitName=o}),define(ge[97],pe([0,1,2]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function P(R){return R.toJSON()}class T{constructor(C){this._uriTransformer=C}transformIncoming(C){const w=this._uriTransformer.transformIncoming(C);return w===C?C:P(E.URI.from(w))}transformOutgoing(C){const w=this._uriTransformer.transformOutgoing(C);return w===C?C:P(E.URI.from(w))}transformOutgoingURI(C){const w=this._uriTransformer.transformOutgoing(C);return w===C?C:E.URI.from(w)}transformOutgoingScheme(C){return this._uriTransformer.transformOutgoingScheme(C)}}e.URITransformer=T,e.DefaultURITransformer=new class{transformIncoming(R){return R}transformOutgoing(R){return R}transformOutgoingURI(R){return R}transformOutgoingScheme(R){return R}};function I(R,C,w){if(!R||w>200)return null;if(typeof R=="object"){if(R instanceof E.URI)return C.transformOutgoing(R);for(let g in R)if(Object.hasOwnProperty.call(R,g)){const s=I(R[g],C,w+1);s!==null&&(R[g]=s)}}return null}function D(R,C){const w=I(R,C,0);return w===null?R:w}e.transformOutgoingURIs=D;function k(R,C,w,g){if(!R||g>200)return null;if(typeof R=="object"){if(R.$mid===1)return w?E.URI.revive(C.transformIncoming(R)):C.transformIncoming(R);for(let s in R)if(Object.hasOwnProperty.call(R,s)){const u=k(R[s],C,w,g+1);u!==null&&(R[s]=u)}}return null}function y(R,C){const w=k(R,C,!1,0);return w===null?R:w}e.transformIncomingURIs=y;function n(R,C){const w=k(R,C,!0,0);return w===null?R:w}e.transformAndReviveIncomingURIs=n}),define(ge[28],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function P(y){return E.test(y)}e.isUUID=P;const T=new Uint8Array(16),I=[];for(let y=0;y<256;y++)I.push(y.toString(16).padStart(2,"0"));let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(y){for(let n=0;n<y.length;n++)y[n]=Math.floor(Math.random()*256);return y};function k(){D(T),T[6]=T[6]&15|64,T[8]=T[8]&63|128;let y=0,n="";return n+=I[T[y++]],n+=I[T[y++]],n+=I[T[y++]],n+=I[T[y++]],n+="-",n+=I[T[y++]],n+=I[T[y++]],n+="-",n+=I[T[y++]],n+=I[T[y++]],n+="-",n+=I[T[y++]],n+=I[T[y++]],n+="-",n+=I[T[y++]],n+=I[T[y++]],n+=I[T[y++]],n+=I[T[y++]],n+=I[T[y++]],n+=I[T[y++]],n}e.generateUuid=k}),define(ge[136],pe([0,1,98]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class P{constructor(I="utf8"){this.stringDecoder=new E.StringDecoder(I),this.remaining=null}write(I){const D=[],k=this.remaining?this.remaining+this.stringDecoder.write(I):this.stringDecoder.write(I);if(k.length<1)return D;let y=0,n,R=y;for(;R<k.length;)if(n=k.charCodeAt(R),n===13||n===10){if(D.push(k.substring(y,R)),R++,R<k.length){const C=n;n=k.charCodeAt(R),(C===13&&n===10||C===10&&n===13)&&R++}y=R}else R++;return this.remaining=y<k.length?k.substr(y):null,D}end(){return this.remaining}}e.LineDecoder=P}),define(ge[26],pe([0,1,37,48,8,19,9,30,28,74,25,2]),function(G,e,E,P,T,I,D,k,y,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.exists=e.copy=e.move=e.writeFileSync=e.writeFile=e.SymlinkSupport=e.whenDeleted=e.readDirsInDir=e.readdirSync=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=void 0;var w;(function($){$[$.UNLINK=0]="UNLINK",$[$.MOVE=1]="MOVE"})(w=e.RimRafMode||(e.RimRafMode={}));async function g($,F=w.UNLINK){if((0,k.isRootOrDriveLetter)($))throw new Error("rimraf - will refuse to recursively delete root");return F===w.UNLINK?u($):s($)}e.rimraf=g;async function s($){try{const F=(0,T.join)((0,P.tmpdir)(),(0,y.generateUuid)());try{await E.promises.rename($,F)}catch(N){return u($)}u(F).catch(N=>{})}catch(F){if(F.code!=="ENOENT")throw F}}async function u($){return E.promises.rmdir($,{recursive:!0,maxRetries:3})}function S($){if((0,k.isRootOrDriveLetter)($))throw new Error("rimraf - will refuse to recursively delete root");E.rmdirSync($,{recursive:!0})}e.rimrafSync=S;async function v($,F){return c(await(F?_($):E.promises.readdir($)))}e.readdir=v;async function _($){try{return await E.promises.readdir($,{withFileTypes:!0})}catch(M){console.warn("[node.js fs] readdir with filetypes failed with error: ",M)}const F=[],N=await v($);for(const M of N){let x=!1,O=!1,V=!1;try{const q=await E.promises.lstat((0,T.join)($,M));x=q.isFile(),O=q.isDirectory(),V=q.isSymbolicLink()}catch(q){console.warn("[node.js fs] unexpected error from lstat after readdir: ",q)}F.push({name:M,isFile:()=>x,isDirectory:()=>O,isSymbolicLink:()=>V})}return F}function p($){return c(E.readdirSync($))}e.readdirSync=p;function c($){return $.map(F=>typeof F=="string"?D.isMacintosh?(0,n.normalizeNFC)(F):F:(F.name=D.isMacintosh?(0,n.normalizeNFC)(F.name):F.name,F))}async function l($){const F=await v($),N=[];for(const M of F)await i.existsDirectory((0,T.join)($,M))&&N.push(M);return N}e.readDirsInDir=l;function t($,F=1e3){return new Promise(N=>{let M=!1;const x=setInterval(()=>{M||(M=!0,E.access($,O=>{M=!1,O&&(clearInterval(x),N(void 0))}))},F)})}e.whenDeleted=t;var i;(function($){async function F(x){let O;try{if(O=await E.promises.lstat(x),!O.isSymbolicLink())return{stat:O}}catch(V){}try{return{stat:await E.promises.stat(x),symbolicLink:(O==null?void 0:O.isSymbolicLink())?{dangling:!1}:void 0}}catch(V){if(V.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};if(D.isWindows&&V.code==="EACCES")try{return{stat:await E.promises.stat(await E.promises.readlink(x)),symbolicLink:{dangling:!1}}}catch(q){if(q.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};throw q}throw V}}$.stat=F;async function N(x){try{const{stat:O,symbolicLink:V}=await $.stat(x);return O.isFile()&&(V==null?void 0:V.dangling)!==!0}catch(O){}return!1}$.existsFile=N;async function M(x){try{const{stat:O,symbolicLink:V}=await $.stat(x);return O.isDirectory()&&(V==null?void 0:V.dangling)!==!0}catch(O){}return!1}$.existsDirectory=M})(i=e.SymlinkSupport||(e.SymlinkSupport={}));const o=new I.ResourceQueue;function r($,F,N){return o.queueFor(C.URI.file($),R.extUriBiasedIgnorePathCase).queue(()=>{const M=b(N);return new Promise((x,O)=>h($,F,M,V=>V?O(V):x()))})}e.writeFile=r;let a=!0;function h($,F,N,M){if(!a)return E.writeFile($,F,{mode:N.mode,flag:N.flag},M);E.open($,N.flag,N.mode,(x,O)=>{if(x)return M(x);E.writeFile(O,F,V=>{if(V)return E.close(O,()=>M(V));E.fdatasync(O,q=>(q&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",q),a=!1),E.close(O,X=>M(X))))})})}function m($,F,N){const M=b(N);if(!a)return E.writeFileSync($,F,{mode:M.mode,flag:M.flag});const x=E.openSync($,M.flag,M.mode);try{E.writeFileSync(x,F);try{E.fdatasyncSync(x)}catch(O){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",O),a=!1}}finally{E.closeSync(x)}}e.writeFileSync=m;function b($){return $?{mode:typeof $.mode=="number"?$.mode:438,flag:typeof $.flag=="string"?$.flag:"w"}:{mode:438,flag:"w"}}async function f($,F){if($!==F){async function N(M){try{const x=await E.promises.lstat(M);if(x.isDirectory()||x.isSymbolicLink())return;const O=await E.promises.open(M,"a");try{await O.utimes(x.atime,new Date)}finally{await O.close()}}catch(x){}}try{await E.promises.rename($,F),await N(F)}catch(M){if($.toLowerCase()!==F.toLowerCase()&&M.code==="EXDEV"||$.endsWith("."))await d($,F,{preserveSymlinks:!1}),await g($,w.MOVE),await N(F);else throw M}}}e.move=f;async function d($,F,N){return L($,F,{root:{source:$,target:F},options:N,handledSourcePaths:new Set})}e.copy=d;const A=511;async function L($,F,N){if(!N.handledSourcePaths.has($)){N.handledSourcePaths.add($);const{stat:M,symbolicLink:x}=await i.stat($);if(x){if(N.options.preserveSymlinks)try{return await j($,F,N)}catch(O){console.warn("[node.js fs] copy of symlink failed: ",O)}if(x.dangling)return}return M.isDirectory()?B($,F,M.mode&A,N):J($,F,M.mode&A)}}async function B($,F,N,M){await E.promises.mkdir(F,{recursive:!0,mode:N});const x=await v($);for(const O of x)await L((0,T.join)($,O),(0,T.join)(F,O),M)}async function J($,F,N){await E.promises.copyFile($,F),await E.promises.chmod(F,N)}async function j($,F,N){let M=await E.promises.readlink($);(0,k.isEqualOrParent)(M,N.root.source,!D.isLinux)&&(M=(0,T.join)(N.root.target,M.substr(N.root.source.length+1))),await E.promises.symlink(M,F)}async function U($){try{return await E.promises.access($),!0}catch(F){return!1}}e.exists=U}),define(ge[99],pe([0,1,37,284,10,8,26]),function(G,e,E,P,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function k(C){const w=(0,I.dirname)(C);if(C===w)return C;const g=((0,I.basename)(C)||C).toLowerCase();try{const u=(0,D.readdirSync)(w).filter(S=>S.toLowerCase()===g);if(u.length===1){const S=k(w);if(S)return(0,I.join)(S,u[0])}else if(u.length>1){const S=u.indexOf(g);if(S>=0){const v=k(w);if(v)return(0,I.join)(v,u[S])}}}catch(s){}return null}e.realcaseSync=k;async function y(C){try{return await(0,P.promisify)(E.realpath)(C)}catch(w){const g=R(C);return await E.promises.access(g,E.constants.R_OK),g}}e.realpath=y;function n(C){try{return E.realpathSync(C)}catch(w){const g=R(C);return E.accessSync(g,E.constants.R_OK),g}}e.realpathSync=n;function R(C){return(0,T.rtrim)((0,I.normalize)(C),I.sep)}});var pt=this&&this.__await||function(G){return this instanceof pt?(this.v=G,this):new pt(G)},An=this&&this.__asyncGenerator||function(G,e,E){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var P=E.apply(G,e||[]),T,I=[];return T={},D("next"),D("throw"),D("return"),T[Symbol.asyncIterator]=function(){return this},T;function D(w){P[w]&&(T[w]=function(g){return new Promise(function(s,u){I.push([w,g,s,u])>1||k(w,g)})})}function k(w,g){try{y(P[w](g))}catch(s){C(I[0][3],s)}}function y(w){w.value instanceof pt?Promise.resolve(w.value.v).then(n,R):C(I[0][2],w)}function n(w){k("next",w)}function R(w){k("throw",w)}function C(w,g){w(g),I.shift(),I.length&&k(I[0][0],I[0][1])}},rn=this&&this.__asyncValues||function(G){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=G[Symbol.asyncIterator],E;return e?e.call(G):(G=typeof __values=="function"?__values(G):G[Symbol.iterator](),E={},P("next"),P("throw"),P("return"),E[Symbol.asyncIterator]=function(){return this},E);function P(I){E[I]=G[I]&&function(D){return new Promise(function(k,y){D=G[I](D),T(k,y,D.done,D.value)})}}function T(I,D,k,y){Promise.resolve(y).then(function(n){I({value:n,done:k})},D)}};define(ge[100],pe([0,1,26,48,8]),function(G,e,E,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const I=/^\d+$/,D=/^Microsoft.PowerShell_.*/,k=/^Microsoft.PowerShellPreview_.*/;var y;(function(c){c[c.x64=0]="x64",c[c.x86=1]="x86",c[c.ARM=2]="ARM"})(y||(y={}));let n;switch(process.arch){case"ia32":case"x32":n=1;break;case"arm":case"arm64":n=2;break;default:n=0;break}let R;process.env.PROCESSOR_ARCHITEW6432?R=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?R=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?R=1:R=0;class C{constructor(l,t,i){this.exePath=l,this.displayName=t,this.knownToExist=i}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await E.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function w({useAlternateBitness:c=!1}={}){return c?n===0?process.env["ProgramFiles(x86)"]||null:R===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function g({useAlternateBitness:c=!1,findPreview:l=!1}={}){const t=w({useAlternateBitness:c});if(!t)return null;const i=T.join(t,"PowerShell");if(!await E.SymlinkSupport.existsDirectory(i))return null;let o=-1,r=null;for(const m of await E.readdir(i)){let b=-1;if(l){const d=m.indexOf("-");if(d<0)continue;const A=m.substring(0,d);if(!I.test(A)||m.substring(d+1)!=="preview")continue;b=parseInt(A,10)}else{if(!I.test(m))continue;b=parseInt(m,10)}if(!(b<=o)){const f=T.join(i,m,"pwsh.exe");!await E.SymlinkSupport.existsFile(f)||(r=f,o=b)}}if(!r)return null;const a=t.includes("x86")?" (x86)":"",h=l?" Preview":"";return new C(r,`PowerShell${h}${a}`,!0)}async function s({findPreview:c}={}){if(!process.env.LOCALAPPDATA)return null;const l=T.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await E.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:t,pwshMsixName:i}=c?{pwshMsixDirRegex:k,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const o of await E.readdir(l))if(t.test(o)){const r=T.join(l,o,"pwsh.exe");return new C(r,i)}return null}function u(){const c=T.join(P.homedir(),".dotnet","tools","pwsh.exe");return new C(c,".NET Core PowerShell Global Tool")}function S(){const c=T.join(process.env.windir,n===1&&R!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new C(c,"Windows PowerShell",!0)}function v(){return An(this,arguments,function*(){let l=yield pt(g());l&&(yield yield pt(l)),l=yield pt(g({useAlternateBitness:!0})),l&&(yield yield pt(l)),l=yield pt(s()),l&&(yield yield pt(l)),l=u(),l&&(yield yield pt(l)),l=yield pt(g({findPreview:!0})),l&&(yield yield pt(l)),l=yield pt(s({findPreview:!0})),l&&(yield yield pt(l)),l=yield pt(g({useAlternateBitness:!0,findPreview:!0})),l&&(yield yield pt(l)),l=S(),l&&(yield yield pt(l))})}function _(){return An(this,arguments,function*(){var l,t;try{for(var i=rn(v()),o;o=yield pt(i.next()),!o.done;){const r=o.value;(yield pt(r.exists()))&&(yield yield pt(r))}}catch(r){l={error:r}}finally{try{o&&!o.done&&(t=i.return)&&(yield pt(t.call(i)))}finally{if(l)throw l.error}}})}e.enumeratePowerShellInstallations=_;async function p(){var c,l;try{for(var t=rn(_()),i;i=await t.next(),!i.done;)return i.value}catch(o){c={error:o}}finally{try{i&&!i.done&&(l=t.return)&&await l.call(t)}finally{if(c)throw c.error}}return null}e.getFirstAvailablePowerShellInstallation=p}),define(ge[101],pe([0,1,3,6,19,21,18,22,14,15,57,10]),function(G,e,E,P,T,I,D,k,y,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var w;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(w=e.RequestType||(e.RequestType={}));function g(M){switch(M){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var s;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(s=e.ResponseType||(e.ResponseType={}));function u(M){switch(M){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var S;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(S||(S={}));class v{constructor(x){this.buffer=x,this.pos=0}read(x){const O=this.buffer.slice(this.pos,this.pos+x);return this.pos+=O.byteLength,O}}class _{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(x){this.buffers.push(x)}}var p;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object"})(p||(p={}));function c(M){const x=k.VSBuffer.alloc(4);return x.writeUInt32BE(M,0),x}function l(M){return M.read(4).readUInt32BE(0)}function t(M){const x=k.VSBuffer.alloc(1);return x.writeUInt8(M,0),x}const i={Undefined:t(p.Undefined),String:t(p.String),Buffer:t(p.Buffer),VSBuffer:t(p.VSBuffer),Array:t(p.Array),Object:t(p.Object)},o=typeof Buffer!="undefined";function r(M,x){if(typeof x=="undefined")M.write(i.Undefined);else if(typeof x=="string"){const O=k.VSBuffer.fromString(x);M.write(i.String),M.write(c(O.byteLength)),M.write(O)}else if(o&&Buffer.isBuffer(x)){const O=k.VSBuffer.wrap(x);M.write(i.Buffer),M.write(c(O.byteLength)),M.write(O)}else if(x instanceof k.VSBuffer)M.write(i.VSBuffer),M.write(c(x.byteLength)),M.write(x);else if(Array.isArray(x)){M.write(i.Array),M.write(c(x.length));for(const O of x)r(M,O)}else{const O=k.VSBuffer.fromString(JSON.stringify(x));M.write(i.Object),M.write(c(O.byteLength)),M.write(O)}}function a(M){switch(M.read(1).readUInt8(0)){case p.Undefined:return;case p.String:return M.read(l(M)).toString();case p.Buffer:return M.read(l(M)).buffer;case p.VSBuffer:return M.read(l(M));case p.Array:{const O=l(M),V=[];for(let q=0;q<O;q++)V.push(a(M));return V}case p.Object:return JSON.parse(M.read(l(M)).toString())}}class h{constructor(x,O,V=null,q=1e3){this.protocol=x,this.ctx=O,this.logger=V,this.timeoutDelay=q,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(X=>this.onRawMessage(X)),this.sendResponse({type:200})}registerChannel(x,O){this.channels.set(x,O),setTimeout(()=>this.flushPendingRequests(x),0)}sendResponse(x){switch(x.type){case 200:{const O=this.send([x.type]);this.logger&&this.logger.logOutgoing(O,0,1,u(x.type));return}case 201:case 202:case 204:case 203:{const O=this.send([x.type,x.id],x.data);this.logger&&this.logger.logOutgoing(O,x.id,1,u(x.type),x.data);return}}}send(x,O=void 0){const V=new _;return r(V,x),r(V,O),this.sendBuffer(V.buffer)}sendBuffer(x){try{return this.protocol.send(x),x.byteLength}catch(O){return 0}}onRawMessage(x){const O=new v(x),V=a(O),q=a(O),X=V[0];switch(X){case 100:return this.logger&&this.logger.logIncoming(x.byteLength,V[1],1,`${g(X)}: ${V[2]}.${V[3]}`,q),this.onPromise({type:X,id:V[1],channelName:V[2],name:V[3],arg:q});case 102:return this.logger&&this.logger.logIncoming(x.byteLength,V[1],1,`${g(X)}: ${V[2]}.${V[3]}`,q),this.onEventListen({type:X,id:V[1],channelName:V[2],name:V[3],arg:q});case 101:return this.logger&&this.logger.logIncoming(x.byteLength,V[1],1,`${g(X)}`),this.disposeActiveRequest({type:X,id:V[1]});case 103:return this.logger&&this.logger.logIncoming(x.byteLength,V[1],1,`${g(X)}`),this.disposeActiveRequest({type:X,id:V[1]})}}onPromise(x){const O=this.channels.get(x.channelName);if(!O){this.collectPendingRequest(x);return}const V=new I.CancellationTokenSource;let q;try{q=O.call(this.ctx,x.name,x.arg,V.token)}catch(we){q=Promise.reject(we)}const X=x.id;q.then(we=>{this.sendResponse({id:X,data:we,type:201}),this.activeRequests.delete(x.id)},we=>{we instanceof Error?this.sendResponse({id:X,data:{message:we.message,name:we.name,stack:we.stack?we.stack.split?we.stack.split(`
`):we.stack:void 0},type:202}):this.sendResponse({id:X,data:we,type:203}),this.activeRequests.delete(x.id)});const me=(0,P.toDisposable)(()=>V.cancel());this.activeRequests.set(x.id,me)}onEventListen(x){const O=this.channels.get(x.channelName);if(!O){this.collectPendingRequest(x);return}const V=x.id,X=O.listen(this.ctx,x.name,x.arg)(me=>this.sendResponse({id:V,data:me,type:204}));this.activeRequests.set(x.id,X)}disposeActiveRequest(x){const O=this.activeRequests.get(x.id);O&&(O.dispose(),this.activeRequests.delete(x.id))}collectPendingRequest(x){let O=this.pendingRequests.get(x.channelName);O||(O=[],this.pendingRequests.set(x.channelName,O));const V=setTimeout(()=>{console.error(`Unknown channel: ${x.channelName}`),x.type===100&&this.sendResponse({id:x.id,data:{name:"Unknown channel",message:`Channel name '${x.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);O.push({request:x,timeoutTimer:V})}flushPendingRequests(x){const O=this.pendingRequests.get(x);if(O){for(const V of O)switch(clearTimeout(V.timeoutTimer),V.request.type){case 100:this.onPromise(V.request);break;case 102:this.onEventListen(V.request);break}this.pendingRequests.delete(x)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(x=>x.dispose()),this.activeRequests.clear()}}e.ChannelServer=h;var m;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(m=e.RequestInitiator||(e.RequestInitiator={}));class b{constructor(x,O=null){this.protocol=x,this.isDisposed=!1,this.state=S.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new E.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(V=>this.onBuffer(V)),this.logger=O}getChannel(x){const O=this;return{call(V,q,X){return O.isDisposed?Promise.reject(D.canceled()):O.requestPromise(x,V,q,X)},listen(V,q){return O.isDisposed?Promise.reject(D.canceled()):O.requestEvent(x,V,q)}}}requestPromise(x,O,V,q=I.CancellationToken.None){const X=this.lastRequestId++,we={id:X,type:100,channelName:x,name:O,arg:V};if(q.isCancellationRequested)return Promise.reject(D.canceled());let Te;return new Promise((Fe,z)=>{if(q.isCancellationRequested)return z(D.canceled());const Y=()=>{const Ce=Oe=>{switch(Oe.type){case 201:this.handlers.delete(X),Fe(Oe.data);break;case 202:this.handlers.delete(X);const be=new Error(Oe.data.message);be.stack=Oe.data.stack,be.name=Oe.data.name,z(be);break;case 203:this.handlers.delete(X),z(Oe.data);break}};this.handlers.set(X,Ce),this.sendRequest(we)};let te=null;this.state===S.Idle?Y():(te=(0,T.createCancelablePromise)(Ce=>this.whenInitialized()),te.then(()=>{te=null,Y()}));const ae=()=>{te?(te.cancel(),te=null):this.sendRequest({id:X,type:101}),z(D.canceled())},he=q.onCancellationRequested(ae);Te=(0,P.combinedDisposable)((0,P.toDisposable)(ae),he),this.activeRequests.add(Te)}).finally(()=>{this.activeRequests.delete(Te)})}requestEvent(x,O,V){const q=this.lastRequestId++,me={id:q,type:102,channelName:x,name:O,arg:V};let we=null;const Te=new E.Emitter({onFirstListenerAdd:()=>{we=(0,T.createCancelablePromise)(Fe=>this.whenInitialized()),we.then(()=>{we=null,this.activeRequests.add(Te),this.sendRequest(me)})},onLastListenerRemove:()=>{we?(we.cancel(),we=null):(this.activeRequests.delete(Te),this.sendRequest({id:q,type:103}))}}),Pe=Fe=>Te.fire(Fe.data);return this.handlers.set(q,Pe),Te.event}sendRequest(x){switch(x.type){case 100:case 102:{const O=this.send([x.type,x.id,x.channelName,x.name],x.arg);this.logger&&this.logger.logOutgoing(O,x.id,0,`${g(x.type)}: ${x.channelName}.${x.name}`,x.arg);return}case 101:case 103:{const O=this.send([x.type,x.id]);this.logger&&this.logger.logOutgoing(O,x.id,0,g(x.type));return}}}send(x,O=void 0){const V=new _;return r(V,x),r(V,O),this.sendBuffer(V.buffer)}sendBuffer(x){try{return this.protocol.send(x),x.byteLength}catch(O){return 0}}onBuffer(x){const O=new v(x),V=a(O),q=a(O),X=V[0];switch(X){case 200:return this.logger&&this.logger.logIncoming(x.byteLength,0,0,u(X)),this.onResponse({type:V[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(x.byteLength,V[1],0,u(X),q),this.onResponse({type:V[0],id:V[1],data:q})}}onResponse(x){if(x.type===200){this.state=S.Idle,this._onDidInitialize.fire();return}const O=this.handlers.get(x.id);O&&O(x)}whenInitialized(){return this.state===S.Idle?Promise.resolve():E.Event.toPromise(this.onDidInitialize)}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(x=>x.dispose()),this.activeRequests.clear()}}e.ChannelClient=b;class f{constructor(x){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new E.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new E.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,x(({protocol:O,onDidClientDisconnect:V})=>{E.Event.once(O.onMessage)(X=>{const me=new v(X),we=a(me),Te=new h(O,we),Pe=new b(O);this.channels.forEach((z,Y)=>Te.registerChannel(Y,z));const Fe={channelServer:Te,channelClient:Pe,ctx:we};this._connections.add(Fe),this._onDidAddConnection.fire(Fe),V(()=>{Te.dispose(),Pe.dispose(),this._connections.delete(Fe),this._onDidRemoveConnection.fire(Fe)})})})}get connections(){const x=[];return this._connections.forEach(O=>x.push(O)),x}getChannel(x,O){const V=this;return{call(q,X,me){let we;if((0,n.isFunction)(O)){let Pe=(0,y.getRandomElement)(V.connections.filter(O));we=Pe?Promise.resolve(Pe):E.Event.toPromise(E.Event.filter(V.onDidAddConnection,O))}else we=O.routeCall(V,q,X);const Te=we.then(Pe=>Pe.channelClient.getChannel(x));return A(Te).call(q,X,me)},listen(q,X){if((0,n.isFunction)(O))return V.getMulticastEvent(x,O,q,X);const me=O.routeEvent(V,q,X).then(we=>we.channelClient.getChannel(x));return A(me).listen(q,X)}}}getMulticastEvent(x,O,V,q){const X=this;let me=new P.DisposableStore;const we=new E.Emitter({onFirstListenerAdd:()=>{me=new P.DisposableStore;const Te=new E.EventMultiplexer,Pe=new Map,Fe=Y=>{const ae=Y.channelClient.getChannel(x).listen(V,q),he=Te.add(ae);Pe.set(Y,he)},z=Y=>{const te=Pe.get(Y);!te||(te.dispose(),Pe.delete(Y))};X.connections.filter(O).forEach(Fe),E.Event.filter(X.onDidAddConnection,O)(Fe,void 0,me),X.onDidRemoveConnection(z,void 0,me),Te.event(we.fire,we,me),me.add(Te)},onLastListenerRemove:()=>{me.dispose()}});return we.event}registerChannel(x,O){this.channels.set(x,O),this._connections.forEach(V=>{V.channelServer.registerChannel(x,O)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=f;class d{constructor(x,O,V=null){const q=new _;r(q,O),x.send(q.buffer),this.channelClient=new b(x,V),this.channelServer=new h(x,O,V)}getChannel(x){return this.channelClient.getChannel(x)}registerChannel(x,O){this.channelServer.registerChannel(x,O)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=d;function A(M){return{call(x,O,V){return M.then(q=>q.call(x,O,V))},listen(x,O){const V=new E.Relay;return M.then(q=>V.input=q.listen(x,O)),V.event}}}e.getDelayedChannel=A;function L(M){let x=!1;return{call(O,V,q){return x?M.call(O,V,q):(0,T.timeout)(0).then(()=>x=!0).then(()=>M.call(O,V,q))},listen(O,V){if(x)return M.listen(O,V);const q=new E.Relay;return(0,T.timeout)(0).then(()=>x=!0).then(()=>q.input=M.listen(O,V)),q.event}}}e.getNextTickChannel=L;class B{constructor(x){this.fn=x}routeCall(x){return this.route(x)}routeEvent(x){return this.route(x)}async route(x){for(const O of x.connections)if(await Promise.resolve(this.fn(O.ctx)))return Promise.resolve(O);return await E.Event.toPromise(x.onDidAddConnection),await this.route(x)}}e.StaticRouter=B;var J;(function(M){function x(q,X){const me=q,we=X&&X.disableMarshalling,Te=new Map;for(const Pe in me)V(Pe)&&Te.set(Pe,E.Event.buffer(me[Pe],!0));return new class{listen(Pe,Fe){const z=Te.get(Fe);if(z)return z;throw new Error(`Event not found: ${Fe}`)}call(Pe,Fe,z){const Y=me[Fe];if(typeof Y=="function"){if(!we&&Array.isArray(z))for(let te=0;te<z.length;te++)z[te]=(0,R.revive)(z[te]);return Y.apply(me,z)}throw new Error(`Method not found: ${Fe}`)}}}M.fromService=x;function O(q,X){const me=X&&X.disableMarshalling;return new Proxy({},{get(we,Te){var Pe;if(typeof Te=="string")return((Pe=X==null?void 0:X.properties)===null||Pe===void 0?void 0:Pe.has(Te))?X.properties.get(Te):V(Te)?q.listen(Te):async function(...Fe){let z;X&&!(0,n.isUndefinedOrNull)(X.context)?z=[X.context,...Fe]:z=Fe;const Y=await q.call(Te,z);return me?Y:(0,R.revive)(Y)};throw new Error(`Property not found: ${String(Te)}`)}})}M.toService=O;function V(q){return q[0]==="o"&&q[1]==="n"&&C.isUpperAsciiLetter(q.charCodeAt(2))}})(J=e.ProxyChannel||(e.ProxyChannel={}));const j=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function U(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){let x=M.toString();if(x!=="[object Object]")return x}return M}function $(M){return Array.isArray(M)?M.map(U):U(M)}function F(M,x,O,V,q,X,me){me=$(me);const we=j[q],Te=we[V%we.length];let Pe=[`%c[${M}]%c[${String(x).padStart(7," ")}]%c[len: ${String(O).padStart(5," ")}]%c${String(V).padStart(5," ")} - ${X}`,"color: darkgreen","color: grey","color: grey",`color: ${Te}`];/\($/.test(X)?(Pe=Pe.concat(me),Pe.push(")")):Pe.push(me),console.log.apply(console,Pe)}e.logWithColors=F;class N{constructor(x,O){this._outgoingPrefix=x,this._incomingPrefix=O,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(x,O,V,q,X){this._totalOutgoing+=x,F(this._outgoingPrefix,this._totalOutgoing,x,O,V,q,X)}logIncoming(x,O,V,q,X){this._totalIncoming+=x,F(this._incomingPrefix,this._totalIncoming,x,O,V,q,X)}}e.IPCLogger=N}),define(ge[102],pe([0,1,3,101,6,22,9,36]),function(G,e,E,P,T,I,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=void 0;let y=null;function n(){return y||(y=I.VSBuffer.alloc(0)),y}class R{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(o){this._chunks.push(o),this._totalLength+=o.byteLength}read(o){return this._read(o,!0)}peek(o){return this._read(o,!1)}_read(o,r){if(o===0)return n();if(o>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===o){const b=this._chunks[0];return r&&(this._chunks.shift(),this._totalLength-=o),b}if(this._chunks[0].byteLength>o){const b=this._chunks[0].slice(0,o);return r&&(this._chunks[0]=this._chunks[0].slice(o),this._totalLength-=o),b}let a=I.VSBuffer.alloc(o),h=0,m=0;for(;o>0;){const b=this._chunks[m];if(b.byteLength>o){const f=b.slice(0,o);a.set(f,h),h+=o,r&&(this._chunks[m]=b.slice(o),this._totalLength-=o),o-=o}else a.set(b,h),h+=b.byteLength,r?(this._chunks.shift(),this._totalLength-=b.byteLength):m++,o-=b.byteLength}return a}}e.ChunkStream=R;var C;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.KeepAlive=4]="KeepAlive",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest"})(C||(C={}));var w;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",i[i.KeepAliveTime=5e3]="KeepAliveTime",i[i.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(w=e.ProtocolConstants||(e.ProtocolConstants={}));class g{constructor(o,r,a,h){this.type=o,this.id=r,this.ack=a,this.data=h,this.writtenTime=0}get size(){return this.data.byteLength}}class s extends T.Disposable{constructor(o){super();this._onMessage=this._register(new E.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=o,this._isDisposed=!1,this._incomingData=new R,this._register(this._socket.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;){const r=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=r.readUInt32BE(9),this._state.messageType=r.readUInt8(0),this._state.id=r.readUInt32BE(1),this._state.ack=r.readUInt32BE(5);else{const a=this._state.messageType,h=this._state.id,m=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new g(a,h,m,r)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class u{constructor(o){this._isDisposed=!1,this._socket=o,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(o){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(o){if(!this._isDisposed){o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=I.VSBuffer.alloc(13);r.writeUInt8(o.type,0),r.writeUInt32BE(o.id,1),r.writeUInt32BE(o.ack,5),r.writeUInt32BE(o.data.byteLength,9),this._writeSoon(r,o.data)}}_bufferAdd(o,r){const a=this._totalLength===0;return this._data.push(o,r),this._totalLength+=o.byteLength+r.byteLength,a}_bufferTake(){const o=I.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,o}_writeSoon(o,r){this._bufferAdd(o,r)&&D.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class S extends T.Disposable{constructor(o){super();this._onMessage=new E.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new E.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=o,this._socketWriter=this._register(new u(this._socket)),this._socketReader=this._register(new s(this._socket)),this._register(this._socketReader.onMessage(r=>{r.type===1&&this._onMessage.fire(r.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(o){this._socketWriter.write(new g(1,0,0,o))}}e.Protocol=S;class v extends P.IPCClient{constructor(o,r,a=null){super(o,r,a);this.protocol=o}static fromSocket(o,r){return new v(new S(o),r)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const o=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),o.end()}}e.Client=v;class _{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new E.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,k.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(o){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(o):this._emitter.fire(o):this._bufferedMessages.push(o)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=_;class p{constructor(o){this.data=o,this.next=null}}class c{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let o=[],r=0,a=this._first;for(;a;)o[r++]=a.data,a=a.next;return o}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(o){const r=new p(o);if(!this._first){this._first=r,this._last=r;return}this._last.next=r,this._last=r}}class l{constructor(){this.lastRuns=[];const o=Date.now();for(let r=0;r<l._HISTORY_LENGTH;r++)this.lastRuns[r]=o-1e3*r;setInterval(()=>{for(let r=l._HISTORY_LENGTH;r>=1;r--)this.lastRuns[r]=this.lastRuns[r-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return l._INSTANCE||(l._INSTANCE=new l),l._INSTANCE}load(){const o=Date.now(),r=(1+l._HISTORY_LENGTH)*1e3;let a=0;for(let h=0;h<l._HISTORY_LENGTH;h++)o-this.lastRuns[h]<=r&&a++;return 1-a/l._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}l._HISTORY_LENGTH=10,l._INSTANCE=null;class t{constructor(o,r=null){this._loadEstimator=l.getInstance(),this._onControlMessage=new _,this.onControlMessage=this._onControlMessage.event,this._onMessage=new _,this.onMessage=this._onMessage.event,this._onDidDispose=new _,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new _,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new _,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new c,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=o,this._socketWriter=new u(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new s(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),r&&this._socketReader.acceptChunk(r),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,T.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const o=new g(5,0,0,n());this._socketWriter.write(o),this._socketWriter.flush()}_sendKeepAliveCheck(){if(!this._outgoingKeepAliveTimeout){const o=Date.now()-this._socketWriter.lastWriteTime;if(o>=5e3){const r=new g(4,0,0,n());this._socketWriter.write(r),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-o+5)}}_recvKeepAliveCheck(){if(!this._incomingKeepAliveTimeout){const o=Date.now()-this._socketReader.lastReadTime;if(o>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-o,0)+5)}}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(o,r){this._isReconnecting=!0,this._socketDisposables=(0,T.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=o,this._socketWriter=new u(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new s(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(r)}endAcceptReconnection(){this._isReconnecting=!1;const o=this._outgoingUnackMsg.toArray();for(let r=0,a=o.length;r<a;r++)this._socketWriter.write(o[r]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(o){if(o.ack>this._outgoingAckId){this._outgoingAckId=o.ack;do{const r=this._outgoingUnackMsg.peek();if(r&&r.id<=o.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(o.type===1){if(o.id>this._incomingMsgId)if(o.id!==this._incomingMsgId+1){const r=Date.now();r-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=r,this._socketWriter.write(new g(6,0,0,n())))}else this._incomingMsgId=o.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(o.data)}else if(o.type===2)this._onControlMessage.fire(o.data);else if(o.type===5)this._onDidDispose.fire();else if(o.type===6){const r=this._outgoingUnackMsg.toArray();for(let a=0,h=r.length;a<h;a++)this._socketWriter.write(r[a]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(o){const r=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const a=new g(1,r,this._incomingAckId,o);this._outgoingUnackMsg.push(a),this._isReconnecting||(this._socketWriter.write(a),this._recvAckCheck())}sendControl(o){const r=new g(2,0,0,o);this._socketWriter.write(r)}_sendAckCheck(){if(!(this._incomingMsgId<=this._incomingAckId)&&!this._incomingAckTimeout){const o=Date.now()-this._incomingMsgLastTime;if(o>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-o+5)}}_recvAckCheck(){if(!(this._outgoingMsgId<=this._outgoingAckId)&&!this._outgoingAckTimeout){const o=this._outgoingUnackMsg.peek(),r=Date.now()-o.writtenTime;if(r>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-r,0)+5)}}_sendAck(){if(!(this._incomingMsgId<=this._incomingAckId)){this._incomingAckId=this._incomingMsgId;const o=new g(3,0,this._incomingAckId,n());this._socketWriter.write(o)}}}e.PersistentProtocol=t}),define(ge[103],pe([0,1,92]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class P{constructor(k){let y=(0,E.toUint8)(k);this._defaultValue=y,this._asciiMap=P._createAsciiMap(y),this._map=new Map}static _createAsciiMap(k){let y=new Uint8Array(256);for(let n=0;n<256;n++)y[n]=k;return y}set(k,y){let n=(0,E.toUint8)(y);k>=0&&k<256?this._asciiMap[k]=n:this._map.set(k,n)}get(k){return k>=0&&k<256?this._asciiMap[k]:this._map.get(k)||this._defaultValue}}e.CharacterClassifier=P;var T;(function(D){D[D.False=0]="False",D[D.True=1]="True"})(T||(T={}));class I{constructor(){this._actual=new P(0)}add(k){this._actual.set(k,1)}has(k){return this._actual.get(k)===1}}e.CharacterSet=I}),define(ge[137],pe([0,1,103]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var P;(function(D){D[D.Regular=0]="Regular",D[D.Whitespace=1]="Whitespace",D[D.WordSeparator=2]="WordSeparator"})(P=e.WordCharacterClass||(e.WordCharacterClass={}));class T extends E.CharacterClassifier{constructor(k){super(0);for(let y=0,n=k.length;y<n;y++)this.set(k.charCodeAt(y),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=T;function I(D){let k={};return y=>(k.hasOwnProperty(y)||(k[y]=D(y)),k[y])}e.getMapForWordSeparators=I(D=>new T(D))}),define(ge[49],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class E{constructor(T,I){this.lineNumber=T,this.column=I}with(T=this.lineNumber,I=this.column){return T===this.lineNumber&&I===this.column?this:new E(T,I)}delta(T=0,I=0){return this.with(this.lineNumber+T,this.column+I)}equals(T){return E.equals(this,T)}static equals(T,I){return!T&&!I?!0:!!T&&!!I&&T.lineNumber===I.lineNumber&&T.column===I.column}isBefore(T){return E.isBefore(this,T)}static isBefore(T,I){return T.lineNumber<I.lineNumber?!0:I.lineNumber<T.lineNumber?!1:T.column<I.column}isBeforeOrEqual(T){return E.isBeforeOrEqual(this,T)}static isBeforeOrEqual(T,I){return T.lineNumber<I.lineNumber?!0:I.lineNumber<T.lineNumber?!1:T.column<=I.column}static compare(T,I){let D=T.lineNumber|0,k=I.lineNumber|0;if(D===k){let y=T.column|0,n=I.column|0;return y-n}return D-k}clone(){return new E(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(T){return new E(T.lineNumber,T.column)}static isIPosition(T){return T&&typeof T.lineNumber=="number"&&typeof T.column=="number"}}e.Position=E}),define(ge[44],pe([0,1,49]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class P{constructor(I,D,k,y){I>k||I===k&&D>y?(this.startLineNumber=k,this.startColumn=y,this.endLineNumber=I,this.endColumn=D):(this.startLineNumber=I,this.startColumn=D,this.endLineNumber=k,this.endColumn=y)}isEmpty(){return P.isEmpty(this)}static isEmpty(I){return I.startLineNumber===I.endLineNumber&&I.startColumn===I.endColumn}containsPosition(I){return P.containsPosition(this,I)}static containsPosition(I,D){return!(D.lineNumber<I.startLineNumber||D.lineNumber>I.endLineNumber||D.lineNumber===I.startLineNumber&&D.column<I.startColumn||D.lineNumber===I.endLineNumber&&D.column>I.endColumn)}containsRange(I){return P.containsRange(this,I)}static containsRange(I,D){return!(D.startLineNumber<I.startLineNumber||D.endLineNumber<I.startLineNumber||D.startLineNumber>I.endLineNumber||D.endLineNumber>I.endLineNumber||D.startLineNumber===I.startLineNumber&&D.startColumn<I.startColumn||D.endLineNumber===I.endLineNumber&&D.endColumn>I.endColumn)}strictContainsRange(I){return P.strictContainsRange(this,I)}static strictContainsRange(I,D){return!(D.startLineNumber<I.startLineNumber||D.endLineNumber<I.startLineNumber||D.startLineNumber>I.endLineNumber||D.endLineNumber>I.endLineNumber||D.startLineNumber===I.startLineNumber&&D.startColumn<=I.startColumn||D.endLineNumber===I.endLineNumber&&D.endColumn>=I.endColumn)}plusRange(I){return P.plusRange(this,I)}static plusRange(I,D){let k,y,n,R;return D.startLineNumber<I.startLineNumber?(k=D.startLineNumber,y=D.startColumn):D.startLineNumber===I.startLineNumber?(k=D.startLineNumber,y=Math.min(D.startColumn,I.startColumn)):(k=I.startLineNumber,y=I.startColumn),D.endLineNumber>I.endLineNumber?(n=D.endLineNumber,R=D.endColumn):D.endLineNumber===I.endLineNumber?(n=D.endLineNumber,R=Math.max(D.endColumn,I.endColumn)):(n=I.endLineNumber,R=I.endColumn),new P(k,y,n,R)}intersectRanges(I){return P.intersectRanges(this,I)}static intersectRanges(I,D){let k=I.startLineNumber,y=I.startColumn,n=I.endLineNumber,R=I.endColumn,C=D.startLineNumber,w=D.startColumn,g=D.endLineNumber,s=D.endColumn;return k<C?(k=C,y=w):k===C&&(y=Math.max(y,w)),n>g?(n=g,R=s):n===g&&(R=Math.min(R,s)),k>n||k===n&&y>R?null:new P(k,y,n,R)}equalsRange(I){return P.equalsRange(this,I)}static equalsRange(I,D){return!!I&&!!D&&I.startLineNumber===D.startLineNumber&&I.startColumn===D.startColumn&&I.endLineNumber===D.endLineNumber&&I.endColumn===D.endColumn}getEndPosition(){return P.getEndPosition(this)}static getEndPosition(I){return new E.Position(I.endLineNumber,I.endColumn)}getStartPosition(){return P.getStartPosition(this)}static getStartPosition(I){return new E.Position(I.startLineNumber,I.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(I,D){return new P(this.startLineNumber,this.startColumn,I,D)}setStartPosition(I,D){return new P(I,D,this.endLineNumber,this.endColumn)}collapseToStart(){return P.collapseToStart(this)}static collapseToStart(I){return new P(I.startLineNumber,I.startColumn,I.startLineNumber,I.startColumn)}static fromPositions(I,D=I){return new P(I.lineNumber,I.column,D.lineNumber,D.column)}static lift(I){return I?new P(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn):null}static isIRange(I){return I&&typeof I.startLineNumber=="number"&&typeof I.startColumn=="number"&&typeof I.endLineNumber=="number"&&typeof I.endColumn=="number"}static areIntersectingOrTouching(I,D){return!(I.endLineNumber<D.startLineNumber||I.endLineNumber===D.startLineNumber&&I.endColumn<D.startColumn||D.endLineNumber<I.startLineNumber||D.endLineNumber===I.startLineNumber&&D.endColumn<I.startColumn)}static areIntersecting(I,D){return!(I.endLineNumber<D.startLineNumber||I.endLineNumber===D.startLineNumber&&I.endColumn<=D.startColumn||D.endLineNumber<I.startLineNumber||D.endLineNumber===I.startLineNumber&&D.endColumn<=I.startColumn)}static compareRangesUsingStarts(I,D){if(I&&D){const n=I.startLineNumber|0,R=D.startLineNumber|0;if(n===R){const C=I.startColumn|0,w=D.startColumn|0;if(C===w){const g=I.endLineNumber|0,s=D.endLineNumber|0;if(g===s){const u=I.endColumn|0,S=D.endColumn|0;return u-S}return g-s}return C-w}return n-R}return(I?1:0)-(D?1:0)}static compareRangesUsingEnds(I,D){return I.endLineNumber===D.endLineNumber?I.endColumn===D.endColumn?I.startLineNumber===D.startLineNumber?I.startColumn-D.startColumn:I.startLineNumber-D.startLineNumber:I.endColumn-D.endColumn:I.endLineNumber-D.endLineNumber}static spansMultipleLines(I){return I.endLineNumber>I.startLineNumber}}e.Range=P}),define(ge[138],pe([0,1,49,44]),function(G,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var T;(function(D){D[D.LTR=0]="LTR",D[D.RTL=1]="RTL"})(T=e.SelectionDirection||(e.SelectionDirection={}));class I extends P.Range{constructor(k,y,n,R){super(k,y,n,R);this.selectionStartLineNumber=k,this.selectionStartColumn=y,this.positionLineNumber=n,this.positionColumn=R}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(k){return I.selectionsEqual(this,k)}static selectionsEqual(k,y){return k.selectionStartLineNumber===y.selectionStartLineNumber&&k.selectionStartColumn===y.selectionStartColumn&&k.positionLineNumber===y.positionLineNumber&&k.positionColumn===y.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(k,y){return this.getDirection()===0?new I(this.startLineNumber,this.startColumn,k,y):new I(k,y,this.startLineNumber,this.startColumn)}getPosition(){return new E.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(k,y){return this.getDirection()===0?new I(k,y,this.endLineNumber,this.endColumn):new I(this.endLineNumber,this.endColumn,k,y)}static fromPositions(k,y=k){return new I(k.lineNumber,k.column,y.lineNumber,y.column)}static liftSelection(k){return new I(k.selectionStartLineNumber,k.selectionStartColumn,k.positionLineNumber,k.positionColumn)}static selectionsArrEqual(k,y){if(k&&!y||!k&&y)return!1;if(!k&&!y)return!0;if(k.length!==y.length)return!1;for(let n=0,R=k.length;n<R;n++)if(!this.selectionsEqual(k[n],y[n]))return!1;return!0}static isISelection(k){return k&&typeof k.selectionStartLineNumber=="number"&&typeof k.selectionStartColumn=="number"&&typeof k.positionLineNumber=="number"&&typeof k.positionColumn=="number"}static createWithDirection(k,y,n,R,C){return C===0?new I(k,y,n,R):new I(n,R,k,y)}}e.Selection=I}),define(ge[104],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var E;(function(g){g[g.Left=1]="Left",g[g.Center=2]="Center",g[g.Right=4]="Right",g[g.Full=7]="Full"})(E=e.OverviewRulerLane||(e.OverviewRulerLane={}));var P;(function(g){g[g.Inline=1]="Inline",g[g.Gutter=2]="Gutter"})(P=e.MinimapPosition||(e.MinimapPosition={}));var T;(function(g){g[g.TextDefined=0]="TextDefined",g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(T=e.EndOfLinePreference||(e.EndOfLinePreference={}));var I;(function(g){g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(I=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var D;(function(g){g[g.LF=0]="LF",g[g.CRLF=1]="CRLF"})(D=e.EndOfLineSequence||(e.EndOfLineSequence={}));class k{constructor(s){this.tabSize=Math.max(1,s.tabSize|0),this.indentSize=s.tabSize|0,this.insertSpaces=Boolean(s.insertSpaces),this.defaultEOL=s.defaultEOL|0,this.trimAutoWhitespace=Boolean(s.trimAutoWhitespace)}equals(s){return this.tabSize===s.tabSize&&this.indentSize===s.indentSize&&this.insertSpaces===s.insertSpaces&&this.defaultEOL===s.defaultEOL&&this.trimAutoWhitespace===s.trimAutoWhitespace}createChangeEvent(s){return{tabSize:this.tabSize!==s.tabSize,indentSize:this.indentSize!==s.indentSize,insertSpaces:this.insertSpaces!==s.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==s.trimAutoWhitespace}}}e.TextModelResolvedOptions=k;class y{constructor(s,u){this.range=s,this.matches=u}}e.FindMatch=y;var n;(function(g){g[g.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",g[g.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",g[g.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",g[g.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(n=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var R;(function(g){g[g.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(R=e.ModelConstants||(e.ModelConstants={}));class C{constructor(s,u,S,v,_,p){this.identifier=s,this.range=u,this.text=S,this.forceMoveMarkers=v,this.isAutoWhitespaceEdit=_,this._isTracked=p}}e.ValidAnnotatedEditOperation=C;class w{constructor(s,u,S){this.reverseEdits=s,this.changes=u,this.trimAutoWhitespaceLineNumbers=S}}e.ApplyEditsResult=w}),define(ge[139],pe([0,1,10,137,49,44,104]),function(G,e,E,P,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const k=999;class y{constructor(p,c,l,t){this.searchString=p,this.isRegex=c,this.matchCase=l,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let p;this.isRegex?p=n(this.searchString):p=this.searchString.indexOf(`
`)>=0;let c=null;try{c=E.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:p,global:!0,unicode:!0})}catch(t){return null}if(!c)return null;let l=!this.isRegex&&!p;return l&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(l=this.matchCase),new R(c,this.wordSeparators?(0,P.getMapForWordSeparators)(this.wordSeparators):null,l?this.searchString:null)}}e.SearchParams=y;function n(_){if(!_||_.length===0)return!1;for(let p=0,c=_.length;p<c;p++)if(_.charCodeAt(p)===92){if(p++,p>=c)break;const t=_.charCodeAt(p);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=n;class R{constructor(p,c,l){this.regex=p,this.wordSeparators=c,this.simpleSearch=l}}e.SearchData=R;function C(_,p,c){if(!c)return new D.FindMatch(_,null);let l=[];for(let t=0,i=p.length;t<i;t++)l[t]=p[t];return new D.FindMatch(_,l)}e.createFindMatch=C;class w{constructor(p){let c=[],l=0;for(let t=0,i=p.length;t<i;t++)p.charCodeAt(t)===10&&(c[l++]=t);this._lineFeedsOffsets=c}findLineFeedCountBeforeOffset(p){const c=this._lineFeedsOffsets;let l=0,t=c.length-1;if(t===-1||p<=c[0])return 0;for(;l<t;){const i=l+((t-l)/2>>0);c[i]>=p?t=i-1:c[i+1]>=p?(l=i,t=i):l=i+1}return l+1}}class g{static findMatches(p,c,l,t,i){const o=c.parseSearchRequest();return o?o.regex.multiline?this._doFindMatchesMultiline(p,l,new v(o.wordSeparators,o.regex),t,i):this._doFindMatchesLineByLine(p,l,o,t,i):[]}static _getMultilineMatchRange(p,c,l,t,i,o){let r,a=0;t?(a=t.findLineFeedCountBeforeOffset(i),r=c+i+a):r=c+i;let h;if(t){let d=t.findLineFeedCountBeforeOffset(i+o.length)-a;h=r+o.length+d}else h=r+o.length;const m=p.getPositionAt(r),b=p.getPositionAt(h);return new I.Range(m.lineNumber,m.column,b.lineNumber,b.column)}static _doFindMatchesMultiline(p,c,l,t,i){const o=p.getOffsetAt(c.getStartPosition()),r=p.getValueInRange(c,1),a=p.getEOL()===`\r
`?new w(r):null,h=[];let m=0,b;for(l.reset(0);b=l.next(r);)if(h[m++]=C(this._getMultilineMatchRange(p,o,r,a,b.index,b[0]),b,t),m>=i)return h;return h}static _doFindMatchesLineByLine(p,c,l,t,i){const o=[];let r=0;if(c.startLineNumber===c.endLineNumber){const h=p.getLineContent(c.startLineNumber).substring(c.startColumn-1,c.endColumn-1);return r=this._findMatchesInLine(l,h,c.startLineNumber,c.startColumn-1,r,o,t,i),o}const a=p.getLineContent(c.startLineNumber).substring(c.startColumn-1);r=this._findMatchesInLine(l,a,c.startLineNumber,c.startColumn-1,r,o,t,i);for(let h=c.startLineNumber+1;h<c.endLineNumber&&r<i;h++)r=this._findMatchesInLine(l,p.getLineContent(h),h,0,r,o,t,i);if(r<i){const h=p.getLineContent(c.endLineNumber).substring(0,c.endColumn-1);r=this._findMatchesInLine(l,h,c.endLineNumber,0,r,o,t,i)}return o}static _findMatchesInLine(p,c,l,t,i,o,r,a){const h=p.wordSeparators;if(!r&&p.simpleSearch){const f=p.simpleSearch,d=f.length,A=c.length;let L=-d;for(;(L=c.indexOf(f,L+d))!==-1;)if((!h||S(h,c,A,L,d))&&(o[i++]=new D.FindMatch(new I.Range(l,L+1+t,l,L+1+d+t),null),i>=a))return i;return i}const m=new v(p.wordSeparators,p.regex);let b;m.reset(0);do if(b=m.next(c),b&&(o[i++]=C(new I.Range(l,b.index+1+t,l,b.index+1+b[0].length+t),b,r),i>=a))return i;while(b);return i}static findNextMatch(p,c,l,t){const i=c.parseSearchRequest();if(!i)return null;const o=new v(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindNextMatchMultiline(p,l,o,t):this._doFindNextMatchLineByLine(p,l,o,t)}static _doFindNextMatchMultiline(p,c,l,t){const i=new T.Position(c.lineNumber,1),o=p.getOffsetAt(i),r=p.getLineCount(),a=p.getValueInRange(new I.Range(i.lineNumber,i.column,r,p.getLineMaxColumn(r)),1),h=p.getEOL()===`\r
`?new w(a):null;l.reset(c.column-1);let m=l.next(a);return m?C(this._getMultilineMatchRange(p,o,a,h,m.index,m[0]),m,t):c.lineNumber!==1||c.column!==1?this._doFindNextMatchMultiline(p,new T.Position(1,1),l,t):null}static _doFindNextMatchLineByLine(p,c,l,t){const i=p.getLineCount(),o=c.lineNumber,r=p.getLineContent(o),a=this._findFirstMatchInLine(l,r,o,c.column,t);if(a)return a;for(let h=1;h<=i;h++){const m=(o+h-1)%i,b=p.getLineContent(m+1),f=this._findFirstMatchInLine(l,b,m+1,1,t);if(f)return f}return null}static _findFirstMatchInLine(p,c,l,t,i){p.reset(t-1);const o=p.next(c);return o?C(new I.Range(l,o.index+1,l,o.index+1+o[0].length),o,i):null}static findPreviousMatch(p,c,l,t){const i=c.parseSearchRequest();if(!i)return null;const o=new v(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindPreviousMatchMultiline(p,l,o,t):this._doFindPreviousMatchLineByLine(p,l,o,t)}static _doFindPreviousMatchMultiline(p,c,l,t){const i=this._doFindMatchesMultiline(p,new I.Range(1,1,c.lineNumber,c.column),l,t,10*k);if(i.length>0)return i[i.length-1];const o=p.getLineCount();return c.lineNumber!==o||c.column!==p.getLineMaxColumn(o)?this._doFindPreviousMatchMultiline(p,new T.Position(o,p.getLineMaxColumn(o)),l,t):null}static _doFindPreviousMatchLineByLine(p,c,l,t){const i=p.getLineCount(),o=c.lineNumber,r=p.getLineContent(o).substring(0,c.column-1),a=this._findLastMatchInLine(l,r,o,t);if(a)return a;for(let h=1;h<=i;h++){const m=(i+o-h-1)%i,b=p.getLineContent(m+1),f=this._findLastMatchInLine(l,b,m+1,t);if(f)return f}return null}static _findLastMatchInLine(p,c,l,t){let i=null,o;for(p.reset(0);o=p.next(c);)i=C(new I.Range(l,o.index+1,l,o.index+1+o[0].length),o,t);return i}}e.TextModelSearch=g;function s(_,p,c,l,t){if(l===0)return!0;const i=p.charCodeAt(l-1);if(_.get(i)!==0||i===13||i===10)return!0;if(t>0){const o=p.charCodeAt(l);if(_.get(o)!==0)return!0}return!1}function u(_,p,c,l,t){if(l+t===c)return!0;const i=p.charCodeAt(l+t);if(_.get(i)!==0||i===13||i===10)return!0;if(t>0){const o=p.charCodeAt(l+t-1);if(_.get(o)!==0)return!0}return!1}function S(_,p,c,l,t){return s(_,p,c,l,t)&&u(_,p,c,l,t)}e.isValidMatch=S;class v{constructor(p,c){this._wordSeparators=p,this._searchRegex=c,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(p){this._searchRegex.lastIndex=p,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(p){const c=p.length;let l;do{if(this._prevMatchStartIndex+this._prevMatchLength===c||(l=this._searchRegex.exec(p),!l))return null;const t=l.index,i=l[0].length;if(t===this._prevMatchStartIndex&&i===this._prevMatchLength){if(i===0){E.getNextCodePoint(p,c,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=i,!this._wordSeparators||S(this._wordSeparators,p,c,t,i))return l}while(l);return null}}e.Searcher=v}),define(ge[105],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function E(k=""){let y="(-?\\d*\\.\\d\\w*)|([^";for(const n of e.USUAL_WORD_SEPARATORS)k.indexOf(n)>=0||(y+="\\"+n);return y+="\\s]+)",new RegExp(y,"g")}e.DEFAULT_WORD_REGEXP=E();function P(k){let y=e.DEFAULT_WORD_REGEXP;if(k&&k instanceof RegExp)if(k.global)y=k;else{let n="g";k.ignoreCase&&(n+="i"),k.multiline&&(n+="m"),k.unicode&&(n+="u"),y=new RegExp(k.source,n)}return y.lastIndex=0,y}e.ensureValidWordDefinition=P;const T={maxLen:1e3,windowSize:15,timeBudget:150};function I(k,y,n,R,C=T){if(n.length>C.maxLen){let S=k-C.maxLen/2;return S<0?S=0:R+=S,n=n.substring(S,k+C.maxLen/2),I(k,y,n,R,C)}const w=Date.now(),g=k-1-R;let s=-1,u=null;for(let S=1;!(Date.now()-w>=C.timeBudget);S++){const v=g-C.windowSize*S;y.lastIndex=Math.max(0,v);const _=D(y,n,g,s);if(!_&&u||(u=_,v<=0))break;s=v}if(u){let S={word:u[0],startColumn:R+1+u.index,endColumn:R+1+u.index+u[0].length};return y.lastIndex=0,S}return null}e.getWordAtText=I;function D(k,y,n,R){let C;for(;C=k.exec(y);){const w=C.index||0;if(w<=n&&k.lastIndex>=n)return C;if(R>0&&w>R)return null}return null}}),define(ge[140],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var E;(function(D){D[D.None=0]="None",D[D.Indent=1]="Indent",D[D.IndentOutdent=2]="IndentOutdent",D[D.Outdent=3]="Outdent"})(E=e.IndentAction||(e.IndentAction={}));class P{constructor(k){if(this.open=k.open,this.close=k.close,this._standardTokenMask=0,Array.isArray(k.notIn))for(let y=0,n=k.notIn.length;y<n;y++)switch(k.notIn[y]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(k){return(this._standardTokenMask&k)==0}}e.StandardAutoClosingPairConditional=P;class T{constructor(k){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of k)I(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),I(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),I(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),I(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&I(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=T;function I(D,k,y){D.has(k)?D.get(k).push(y):D.set(k,[y])}}),define(ge[76],pe([0,1,33,8]),function(G,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function T(I,D,k,y){if(Array.isArray(I)){let n=0;for(const R of I){const C=T(R,D,k,y);if(C===10)return C;C>n&&(n=C)}return n}else{if(typeof I=="string")return y?I==="*"?5:I===k?10:0:0;if(I){const{language:n,pattern:R,scheme:C,hasAccessToAllModels:w}=I;if(!y&&!w)return 0;let g=0;if(C)if(C===D.scheme)g=10;else if(C==="*")g=5;else return 0;if(n)if(n===k)g=10;else if(n==="*")g=Math.max(g,5);else return 0;if(R){let s;if(typeof R=="string"?s=R:s=Object.assign(Object.assign({},R),{base:(0,P.normalize)(R.base)}),s===D.fsPath||(0,E.match)(s,D.fsPath))g=10;else return 0}return g}else return 0}}e.score=T}),define(ge[141],pe([0,1,103]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var P;(function(g){g[g.Invalid=0]="Invalid",g[g.Start=1]="Start",g[g.H=2]="H",g[g.HT=3]="HT",g[g.HTT=4]="HTT",g[g.HTTP=5]="HTTP",g[g.F=6]="F",g[g.FI=7]="FI",g[g.FIL=8]="FIL",g[g.BeforeColon=9]="BeforeColon",g[g.AfterColon=10]="AfterColon",g[g.AlmostThere=11]="AlmostThere",g[g.End=12]="End",g[g.Accept=13]="Accept",g[g.LastKnownState=14]="LastKnownState"})(P=e.State||(e.State={}));class T{constructor(s,u,S){const v=new Uint8Array(s*u);for(let _=0,p=s*u;_<p;_++)v[_]=S;this._data=v,this.rows=s,this.cols=u}get(s,u){return this._data[s*this.cols+u]}set(s,u,S){this._data[s*this.cols+u]=S}}e.Uint8Matrix=T;class I{constructor(s){let u=0,S=0;for(let _=0,p=s.length;_<p;_++){let[c,l,t]=s[_];l>u&&(u=l),c>S&&(S=c),t>S&&(S=t)}u++,S++;let v=new T(S,u,0);for(let _=0,p=s.length;_<p;_++){let[c,l,t]=s[_];v.set(c,l,t)}this._states=v,this._maxCharCode=u}nextState(s,u){return u<0||u>=this._maxCharCode?0:this._states.get(s,u)}}e.StateMachine=I;let D=null;function k(){return D===null&&(D=new I([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),D}var y;(function(g){g[g.None=0]="None",g[g.ForceTermination=1]="ForceTermination",g[g.CannotEndIn=2]="CannotEndIn"})(y||(y={}));let n=null;function R(){if(n===null){n=new E.CharacterClassifier(0);const g=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u3011\u300F\u300D\u300B\u3009\u201D\u2019\uFF40\uFF5E\u2026`;for(let u=0;u<g.length;u++)n.set(g.charCodeAt(u),1);const s=".,;";for(let u=0;u<s.length;u++)n.set(s.charCodeAt(u),2)}return n}class C{static _createLink(s,u,S,v,_){let p=_-1;do{const c=u.charCodeAt(p);if(s.get(c)!==2)break;p--}while(p>v);if(v>0){const c=u.charCodeAt(v-1),l=u.charCodeAt(p);(c===40&&l===41||c===91&&l===93||c===123&&l===125)&&p--}return{range:{startLineNumber:S,startColumn:v+1,endLineNumber:S,endColumn:p+2},url:u.substring(v,p+1)}}static computeLinks(s,u=k()){const S=R();let v=[];for(let _=1,p=s.getLineCount();_<=p;_++){const c=s.getLineContent(_),l=c.length;let t=0,i=0,o=0,r=1,a=!1,h=!1,m=!1,b=!1;for(;t<l;){let f=!1;const d=c.charCodeAt(t);if(r===13){let A;switch(d){case 40:a=!0,A=0;break;case 41:A=a?0:1;break;case 91:m=!0,h=!0,A=0;break;case 93:m=!1,A=h?0:1;break;case 123:b=!0,A=0;break;case 125:A=b?0:1;break;case 39:A=o===34||o===96?0:1;break;case 34:A=o===39||o===96?0:1;break;case 96:A=o===39||o===34?0:1;break;case 42:A=o===42?1:0;break;case 124:A=o===124?1:0;break;case 32:A=m?0:1;break;default:A=S.get(d)}A===1&&(v.push(C._createLink(S,c,_,i,t)),f=!0)}else if(r===12){let A;d===91?(h=!0,A=0):A=S.get(d),A===1?f=!0:r=13}else r=u.nextState(r,d),r===0&&(f=!0);f&&(r=1,a=!1,h=!1,b=!1,i=t+1,o=d),t++}r===13&&v.push(C._createLink(S,c,_,i,l))}return v}}e.LinkComputer=C;function w(g){return!g||typeof g.getLineCount!="function"||typeof g.getLineContent!="function"?[]:C.computeLinks(g)}e.computeLinks=w}),define(ge[142],pe([0,1,3,6]),function(G,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class T{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new E.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(D){this._onDidChange.fire({changedLanguages:D,changedColorMap:!1})}register(D,k){return this._map.set(D,k),this.fire([D]),(0,P.toDisposable)(()=>{this._map.get(D)===k&&(this._map.delete(D),this.fire([D]))})}registerPromise(D,k){let y=null,n=!1;return this._promises.set(D,k.then(R=>{this._promises.delete(D),!(n||!R)&&(y=this.register(D,R))})),(0,P.toDisposable)(()=>{n=!0,y&&y.dispose()})}getPromise(D){const k=this.get(D);if(k)return Promise.resolve(k);const y=this._promises.get(D);return y?y.then(n=>this.get(D)):null}get(D){return this._map.get(D)||null}setColorMap(D){this._colorMap=D,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=T}),define(ge[106],pe([0,1,22,9]),function(G,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var T;(function(C){C[C.Full=1]="Full",C[C.Delta=2]="Delta"})(T||(T={}));function I(C){for(let w=0,g=C.length;w<g;w+=4){const s=C[w+0],u=C[w+1],S=C[w+2],v=C[w+3];C[w+0]=v,C[w+1]=S,C[w+2]=u,C[w+3]=s}}function D(C){const w=new Uint8Array(C.buffer,C.byteOffset,C.length*4);return P.isLittleEndian()||I(w),E.VSBuffer.wrap(w)}function k(C){const w=C.buffer;if(P.isLittleEndian()||I(w),w.byteOffset%4==0)return new Uint32Array(w.buffer,w.byteOffset,w.length/4);{const g=new Uint8Array(w.byteLength);return g.set(w),new Uint32Array(g.buffer,g.byteOffset,g.length/4)}}function y(C){const w=new Uint32Array(n(C));let g=0;if(w[g++]=C.id,C.type==="full")w[g++]=1,w[g++]=C.data.length,w.set(C.data,g),g+=C.data.length;else{w[g++]=2,w[g++]=C.deltas.length;for(const s of C.deltas)w[g++]=s.start,w[g++]=s.deleteCount,s.data?(w[g++]=s.data.length,w.set(s.data,g),g+=s.data.length):w[g++]=0}return D(w)}e.encodeSemanticTokensDto=y;function n(C){let w=0;if(w+=1+1,C.type==="full")w+=1+C.data.length;else{w+=1,w+=(1+1+1)*C.deltas.length;for(const g of C.deltas)g.data&&(w+=g.data.length)}return w}function R(C){const w=k(C);let g=0;const s=w[g++];if(w[g++]===1){const _=w[g++],p=w.subarray(g,g+_);return g+=_,{id:s,type:"full",data:p}}const S=w[g++];let v=[];for(let _=0;_<S;_++){const p=w[g++],c=w[g++],l=w[g++];let t;l>0&&(t=w.subarray(g,g+l),g+=l),v[_]={start:p,deleteCount:c,data:t}}return{id:s,type:"delta",deltas:v}}e.decodeSemanticTokensDto=R}),define(ge[107],pe([0,1,92]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class P{constructor(D,k){this.index=D,this.remainder=k}}e.PrefixSumIndexOfResult=P;class T{constructor(D){this.values=D,this.prefixSum=new Uint32Array(D.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(D,k){D=(0,E.toUint32)(D);const y=this.values,n=this.prefixSum,R=k.length;return R===0?!1:(this.values=new Uint32Array(y.length+R),this.values.set(y.subarray(0,D),0),this.values.set(y.subarray(D),D+R),this.values.set(k,D),D-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=D-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(n.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(D,k){return D=(0,E.toUint32)(D),k=(0,E.toUint32)(k),this.values[D]===k?!1:(this.values[D]=k,D-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=D-1),!0)}removeValues(D,k){D=(0,E.toUint32)(D),k=(0,E.toUint32)(k);const y=this.values,n=this.prefixSum;if(D>=y.length)return!1;let R=y.length-D;return k>=R&&(k=R),k===0?!1:(this.values=new Uint32Array(y.length-k),this.values.set(y.subarray(0,D),0),this.values.set(y.subarray(D+k),D),this.prefixSum=new Uint32Array(this.values.length),D-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=D-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(n.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(D){return D<0?0:(D=(0,E.toUint32)(D),this._getAccumulatedValue(D))}_getAccumulatedValue(D){if(D<=this.prefixSumValidIndex[0])return this.prefixSum[D];let k=this.prefixSumValidIndex[0]+1;k===0&&(this.prefixSum[0]=this.values[0],k++),D>=this.values.length&&(D=this.values.length-1);for(let y=k;y<=D;y++)this.prefixSum[y]=this.prefixSum[y-1]+this.values[y];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],D),this.prefixSum[D]}getIndexOf(D){D=Math.floor(D),this.getTotalValue();let k=0,y=this.values.length-1,n=0,R=0,C=0;for(;k<=y;)if(n=k+(y-k)/2|0,R=this.prefixSum[n],C=R-this.values[n],D<C)y=n-1;else if(D>=R)k=n+1;else break;return new P(n,D-C)}}e.PrefixSumComputer=T}),define(ge[143],pe([0,1,10,49,107]),function(G,e,E,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class I{constructor(k,y,n,R){this._uri=k,this._lines=y,this._eol=n,this._versionId=R,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(k){k.eol&&k.eol!==this._eol&&(this._eol=k.eol,this._lineStarts=null);const y=k.changes;for(const n of y)this._acceptDeleteRange(n.range),this._acceptInsertText(new P.Position(n.range.startLineNumber,n.range.startColumn),n.text);this._versionId=k.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const k=this._eol.length,y=this._lines.length,n=new Uint32Array(y);for(let R=0;R<y;R++)n[R]=this._lines[R].length+k;this._lineStarts=new T.PrefixSumComputer(n)}}_setLineText(k,y){this._lines[k]=y,this._lineStarts&&this._lineStarts.changeValue(k,this._lines[k].length+this._eol.length)}_acceptDeleteRange(k){if(k.startLineNumber===k.endLineNumber){if(k.startColumn===k.endColumn)return;this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.startLineNumber-1].substring(k.endColumn-1));return}this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.endLineNumber-1].substring(k.endColumn-1)),this._lines.splice(k.startLineNumber,k.endLineNumber-k.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(k.startLineNumber,k.endLineNumber-k.startLineNumber)}_acceptInsertText(k,y){if(y.length!==0){let n=(0,E.splitLines)(y);if(n.length===1){this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+n[0]+this._lines[k.lineNumber-1].substring(k.column-1));return}n[n.length-1]+=this._lines[k.lineNumber-1].substring(k.column-1),this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+n[0]);let R=new Uint32Array(n.length-1);for(let C=1;C<n.length;C++)this._lines.splice(k.lineNumber+C-1,0,n[C]),R[C-1]=n[C].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(k.lineNumber,R)}}}e.MirrorTextModel=I}),define(ge[144],pe([16,17]),function(G,e){return G.create("vs/base/common/date",e)}),define(ge[145],pe([0,1,144]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const P=60,T=P*60,I=T*24,D=I*7,k=I*30,y=I*365;function n(C,w){typeof C!="number"&&(C=C.getTime());const g=Math.round((new Date().getTime()-C)/1e3);if(g<-30)return(0,E.localize)(0,null,n(new Date().getTime()+g*1e3,!1));if(g<30)return(0,E.localize)(1,null);let s;return g<P?(s=g,w?s===1?(0,E.localize)(2,null,s):(0,E.localize)(3,null,s):s===1?(0,E.localize)(4,null,s):(0,E.localize)(5,null,s)):g<T?(s=Math.floor(g/P),w?s===1?(0,E.localize)(6,null,s):(0,E.localize)(7,null,s):s===1?(0,E.localize)(8,null,s):(0,E.localize)(9,null,s)):g<I?(s=Math.floor(g/T),w?s===1?(0,E.localize)(10,null,s):(0,E.localize)(11,null,s):s===1?(0,E.localize)(12,null,s):(0,E.localize)(13,null,s)):g<D?(s=Math.floor(g/I),w?s===1?(0,E.localize)(14,null,s):(0,E.localize)(15,null,s):s===1?(0,E.localize)(16,null,s):(0,E.localize)(17,null,s)):g<k?(s=Math.floor(g/D),w?s===1?(0,E.localize)(18,null,s):(0,E.localize)(19,null,s):s===1?(0,E.localize)(20,null,s):(0,E.localize)(21,null,s)):g<y?(s=Math.floor(g/k),w?s===1?(0,E.localize)(22,null,s):(0,E.localize)(23,null,s):s===1?(0,E.localize)(24,null,s):(0,E.localize)(25,null,s)):(s=Math.floor(g/y),w?s===1?(0,E.localize)(26,null,s):(0,E.localize)(27,null,s):s===1?(0,E.localize)(28,null,s):(0,E.localize)(29,null,s))}e.fromNow=n;function R(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(ge[146],pe([16,17]),function(G,e){return G.create("vs/base/common/errorMessage",e)}),define(ge[58],pe([0,1,146,15,14]),function(G,e,E,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function I(n,R){return R&&(n.stack||n.stacktrace)?E.localize(0,null,k(n),D(n.stack)||D(n.stacktrace)):k(n)}function D(n){return Array.isArray(n)?n.join(`
`):n}function k(n){return typeof n.code=="string"&&typeof n.errno=="number"&&typeof n.syscall=="string"?E.localize(1,null,n.message):n.message||E.localize(2,null)}function y(n=null,R=!1){if(!n)return E.localize(3,null);if(Array.isArray(n)){const C=T.coalesce(n),w=y(C[0],R);return C.length>1?E.localize(4,null,w,C.length):w}if(P.isString(n))return n;if(n.detail){const C=n.detail;if(C.error)return I(C.error,R);if(C.exception)return I(C.exception,R)}return n.stack?I(n,R):n.message?n.message:E.localize(5,null)}e.toErrorMessage=y}),define(ge[147],pe([16,17]),function(G,e){return G.create("vs/base/node/processes",e)}),define(ge[77],pe([0,1,8,37,26,38,147,36,15,23,30,9,136,11]),function(G,e,E,P,T,I,D,k,y,n,R,C,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function s(l){switch(l){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function u(l,t){if(C.isWindows)try{const i={stdio:["pipe","pipe","ignore"]};t&&(i.cwd=t);const o=I.execFile("taskkill",["/T","/F","/PID",l.pid.toString()],i);return new Promise(r=>{o.once("error",a=>{r({success:!1,error:a})}),o.once("exit",(a,h)=>{r(a===0?{success:!0}:{success:!1,code:a!==null?a:1})})})}catch(i){return Promise.resolve({success:!1,error:i,code:i.status?s(i.status):1})}else if(C.isLinux||C.isMacintosh)try{const i=g.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",G).fsPath;return new Promise(o=>{I.execFile(i,[l.pid.toString()],{encoding:"utf8",shell:!0},(r,a,h)=>{o(r?{success:!1,error:r}:{success:!0})})})}catch(i){return Promise.resolve({success:!1,error:i})}else l.kill("SIGKILL");return Promise.resolve({success:!0})}function S(l=k.env){return l.comspec||"cmd.exe"}e.getWindowsShell=S;class v{constructor(t,i,o,r){if(i!==void 0&&o!==void 0&&r!==void 0)this.cmd=t,this.args=i,this.shell=o,this.options=r;else{const a=t;this.cmd=a.command,this.shell=a.isShellCommand,this.args=a.args.slice(0),this.options=a.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const a=Object.create(null);Object.keys(k.env).forEach(h=>{a[h]=k.env[h]}),Object.keys(this.options.env).forEach(h=>{a[h]=this.options.env[h]}),this.options.env=a}}getSanitizedCommand(){let t=this.cmd.toLowerCase();const i=t.lastIndexOf(E.sep);return i!==-1&&(t=t.substring(i+1)),v.WellKnowCommands[t]?t:"other"}start(t){return C.isWindows&&(this.options&&this.options.cwd&&R.isUNC(this.options.cwd)||!this.options&&R.isUNC(k.cwd()))?Promise.reject(new Error(D.localize(0,null))):this.useExec().then(i=>{let o,r;const a=new Promise((h,m)=>{o=h,r=m});if(i){let h=this.cmd;this.args&&(h=h+" "+this.args.join(" ")),this.childProcess=I.exec(h,this.options,(m,b,f)=>{this.childProcess=null;const d=m;d&&d.killed?r({killed:this.terminateRequested,stdout:b.toString(),stderr:f.toString()}):this.handleExec(o,t,m,b,f)})}else{let h=null;const m=b=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(b,o,t,r);const f={terminated:this.terminateRequested};y.isNumber(b)&&(f.cmdCode=b),o(f)};if(this.shell&&C.isWindows){const b=n.deepClone(this.options);b.windowsVerbatimArguments=!0,b.detached=!1;let f=!1,d=!1;const A=[];let L=this.ensureQuotes(this.cmd);A.push(L.value),f=L.quoted,this.args&&this.args.forEach(J=>{L=this.ensureQuotes(J),A.push(L.value),d=d&&L.quoted});const B=["/s","/c"];f?d?B.push('"'+A.join(" ")+'"'):A.length>1?B.push('"'+A[0]+'" '+A.slice(1).join(" ")):B.push('"'+A[0]+'"'):B.push(A.join(" ")),h=I.spawn(S(),B,b)}else this.cmd&&(h=I.spawn(this.cmd,this.args,this.options));h&&(this.childProcess=h,this.childProcessPromise=Promise.resolve(h),this.pidResolve&&(this.pidResolve(y.isNumber(h.pid)?h.pid:-1),this.pidResolve=void 0),h.on("error",b=>{this.childProcess=null,r({terminated:this.terminateRequested,error:b})}),h.pid&&(this.childProcess.on("close",m),this.handleSpawn(h,o,t,r,!0)))}return a})}handleClose(t,i,o,r){}ensureQuotes(t){return v.regexp.test(t)?{value:'"'+t+'"',quoted:!0}:{value:t,quoted:t.length>0&&t[0]==='"'&&t[t.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(t=>t.pid,t=>-1):new Promise(t=>{this.pidResolve=t})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,u(t,this.options.cwd).then(i=>(i.success&&(this.childProcess=null),i))),t=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(t=>{if(!this.shell||!C.isWindows)return t(!1);const i=I.spawn(S(),["/s","/c"]);i.on("error",o=>t(!0)),i.on("exit",o=>t(!1))})}}e.AbstractProcess=v,v.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},v.regexp=/^[^"].* .*[^"]/;class _ extends v{constructor(t,i,o,r){super(t,i,o,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(t,i,o,r,a){[r,a].forEach((h,m)=>{const b=new w.LineDecoder;b.write(h).forEach(A=>{i({line:A,source:m===0?0:1})});const d=b.end();d&&i({line:d,source:m===0?0:1})}),t({terminated:this.terminateRequested,error:o})}handleSpawn(t,i,o,r,a){const h=new w.LineDecoder,m=new w.LineDecoder;t.stdout.on("data",b=>{h.write(b).forEach(d=>o({line:d,source:0}))}),t.stderr.on("data",b=>{m.write(b).forEach(d=>o({line:d,source:1}))}),this.stdoutLineDecoder=h,this.stderrLineDecoder=m}handleClose(t,i,o,r){const a=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;a&&o({line:a,source:0});const h=this.stderrLineDecoder?this.stderrLineDecoder.end():null;h&&o({line:h,source:1})}}e.LineProcess=_;function p(l){let t=[],i=!1;const o=function(r){if(i){t.push(r);return}(!l.send(r,h=>{if(h&&console.error(h),i=!1,t.length>0){const m=t.slice(0);t=[],m.forEach(b=>o(b))}})||C.isWindows)&&(i=!0)};return{send:o}}e.createQueuedSender=p;var c;(function(l){async function t(i,o,r){if(E.isAbsolute(i))return i;if(o===void 0&&(o=k.cwd()),E.dirname(i)!=="."||(r===void 0&&y.isString(k.env.PATH)&&(r=k.env.PATH.split(E.delimiter)),r===void 0||r.length===0))return E.join(o,i);async function h(m){return await T.exists(m)?!(await P.promises.stat(m)).isDirectory():!1}for(let m of r){let b;if(E.isAbsolute(m)?b=E.join(m,i):b=E.join(o,m,i),await h(b))return b;let f=b+".com";if(await h(f)||(f=b+".exe",await h(f)))return f}return E.join(o,i)}l.findExecutable=t})(c=e.win32||(e.win32={}))}),define(ge[148],pe([0,1,48,9,100,77]),function(G,e,E,P,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function D(g,s){return g===3?P.isWindows?C():I.getWindowsShell(s):n(g,s)}e.getSystemShell=D;function k(g,s){return g===3?P.isWindows?w(s):I.getWindowsShell(s):n(g,s)}e.getSystemShellSync=k;let y=null;function n(g,s){if(P.isLinux&&g===1||P.isMacintosh&&g===2)return"/bin/bash";if(!y){let u;if(P.isWindows)u="/bin/bash";else{if(u=s.SHELL,!u)try{u=E.userInfo().shell}catch(S){}u||(u="sh"),u==="/bin/false"&&(u="/bin/bash")}y=u}return y}let R=null;async function C(){return R||(R=(await(0,T.getFirstAvailablePowerShellInstallation)()).exePath),R}function w(g){if(R)return R;const s=P.isWindows&&parseFloat(E.release())>=10,u=g.hasOwnProperty("PROCESSOR_ARCHITEW6432"),S=`${g.windir}\\${u?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return s?S:I.getWindowsShell(g)}}),define(ge[149],pe([16,17]),function(G,e){return G.create("vs/editor/common/config/editorOptions",e)}),define(ge[150],pe([0,1,149,9,105]),function(G,e,E,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var I;(function(Q){Q[Q.None=0]="None",Q[Q.Keep=1]="Keep",Q[Q.Brackets=2]="Brackets",Q[Q.Advanced=3]="Advanced",Q[Q.Full=4]="Full"})(I=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class D{constructor(se){this._values=se}hasChanged(se){return this._values[se]}}e.ConfigurationChangedEvent=D;class k{constructor(){this._values=[]}_read(se){return this._values[se]}get(se){return this._values[se]}_write(se,_e){this._values[se]=_e}}e.ValidatedEditorOptions=k;class y{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=y;class n{constructor(se,_e,xe,Ve){this.id=se,this.name=_e,this.defaultValue=xe,this.schema=Ve}compute(se,_e,xe){return xe}}class R{constructor(se,_e=null){this.schema=void 0,this.id=se,this.name="_never_",this.defaultValue=void 0,this.deps=_e}validate(se){return this.defaultValue}}class C{constructor(se,_e,xe,Ve){this.id=se,this.name=_e,this.defaultValue=xe,this.schema=Ve}validate(se){return typeof se=="undefined"?this.defaultValue:se}compute(se,_e,xe){return xe}}function w(Q,se){return typeof Q=="undefined"?se:Q==="false"?!1:Boolean(Q)}e.boolean=w;class g extends C{constructor(se,_e,xe,Ve=void 0){typeof Ve!="undefined"&&(Ve.type="boolean",Ve.default=xe),super(se,_e,xe,Ve)}validate(se){return w(se,this.defaultValue)}}class s extends C{constructor(se,_e,xe,Ve,$e,Ze=void 0){typeof Ze!="undefined"&&(Ze.type="integer",Ze.default=xe,Ze.minimum=Ve,Ze.maximum=$e),super(se,_e,xe,Ze),this.minimum=Ve,this.maximum=$e}static clampedInt(se,_e,xe,Ve){if(typeof se=="undefined")return _e;let $e=parseInt(se,10);return isNaN($e)?_e:($e=Math.max(xe,$e),$e=Math.min(Ve,$e),$e|0)}validate(se){return s.clampedInt(se,this.defaultValue,this.minimum,this.maximum)}}class u extends C{constructor(se,_e,xe,Ve,$e){typeof $e!="undefined"&&($e.type="number",$e.default=xe),super(se,_e,xe,$e),this.validationFn=Ve}static clamp(se,_e,xe){return se<_e?_e:se>xe?xe:se}static float(se,_e){if(typeof se=="number")return se;if(typeof se=="undefined")return _e;const xe=parseFloat(se);return isNaN(xe)?_e:xe}validate(se){return this.validationFn(u.float(se,this.defaultValue))}}class S extends C{static string(se,_e){return typeof se!="string"?_e:se}constructor(se,_e,xe,Ve=void 0){typeof Ve!="undefined"&&(Ve.type="string",Ve.default=xe),super(se,_e,xe,Ve)}validate(se){return S.string(se,this.defaultValue)}}function v(Q,se,_e){return typeof Q!="string"||_e.indexOf(Q)===-1?se:Q}e.stringSet=v;class _ extends C{constructor(se,_e,xe,Ve,$e=void 0){typeof $e!="undefined"&&($e.type="string",$e.enum=Ve,$e.default=xe),super(se,_e,xe,$e),this._allowedValues=Ve}validate(se){return v(se,this.defaultValue,this._allowedValues)}}class p extends n{constructor(se,_e,xe,Ve,$e,Ze,K=void 0){typeof K!="undefined"&&(K.type="string",K.enum=$e,K.default=Ve),super(se,_e,xe,K),this._allowedValues=$e,this._convert=Ze}validate(se){return typeof se!="string"?this.defaultValue:this._allowedValues.indexOf(se)===-1?this.defaultValue:this._convert(se)}}function c(Q){switch(Q){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class l extends n{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[E.localize(0,null),E.localize(1,null),E.localize(2,null)],default:"auto",description:E.localize(3,null)})}validate(se){switch(se){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(se,_e,xe){return xe===0?se.accessibilitySupport:xe}}class t extends n{constructor(){const se={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",se,{"editor.comments.insertSpace":{type:"boolean",default:se.insertSpace,description:E.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:se.ignoreEmptyLines,description:E.localize(5,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const _e=se;return{insertSpace:w(_e.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:w(_e.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var i;(function(Q){Q[Q.Hidden=0]="Hidden",Q[Q.Blink=1]="Blink",Q[Q.Smooth=2]="Smooth",Q[Q.Phase=3]="Phase",Q[Q.Expand=4]="Expand",Q[Q.Solid=5]="Solid"})(i=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function o(Q){switch(Q){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var r;(function(Q){Q[Q.Line=1]="Line",Q[Q.Block=2]="Block",Q[Q.Underline=3]="Underline",Q[Q.LineThin=4]="LineThin",Q[Q.BlockOutline=5]="BlockOutline",Q[Q.UnderlineThin=6]="UnderlineThin"})(r=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function a(Q){switch(Q){case r.Line:return"line";case r.Block:return"block";case r.Underline:return"underline";case r.LineThin:return"line-thin";case r.BlockOutline:return"block-outline";case r.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=a;function h(Q){switch(Q){case"line":return r.Line;case"block":return r.Block;case"underline":return r.Underline;case"line-thin":return r.LineThin;case"block-outline":return r.BlockOutline;case"underline-thin":return r.UnderlineThin}}class m extends R{constructor(){super(123,[62,31])}compute(se,_e,xe){const Ve=["monaco-editor"];return _e.get(31)&&Ve.push(_e.get(31)),se.extraEditorClassName&&Ve.push(se.extraEditorClassName),_e.get(62)==="default"?Ve.push("mouse-default"):_e.get(62)==="copy"&&Ve.push("mouse-copy"),_e.get(97)&&Ve.push("showUnused"),_e.get(121)&&Ve.push("showDeprecated"),Ve.join(" ")}}class b extends g{constructor(){super(30,"emptySelectionClipboard",!0,{description:E.localize(6,null)})}compute(se,_e,xe){return xe&&se.emptySelectionClipboard}}class f extends n{constructor(){const se={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",se,{"editor.find.cursorMoveOnType":{type:"boolean",default:se.cursorMoveOnType,description:E.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:se.seedSearchStringFromSelection,description:E.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:se.autoFindInSelection,enumDescriptions:[E.localize(9,null),E.localize(10,null),E.localize(11,null)],description:E.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:se.globalFindClipboard,description:E.localize(13,null),included:P.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:se.addExtraSpaceOnTop,description:E.localize(14,null)},"editor.find.loop":{type:"boolean",default:se.loop,description:E.localize(15,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const _e=se;return{cursorMoveOnType:w(_e.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:w(_e.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof se.autoFindInSelection=="boolean"?se.autoFindInSelection?"always":"never":v(_e.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:w(_e.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:w(_e.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:w(_e.loop,this.defaultValue.loop)}}}class d extends n{constructor(){super(41,"fontLigatures",d.OFF,{anyOf:[{type:"boolean",description:E.localize(16,null)},{type:"string",description:E.localize(17,null)}],description:E.localize(18,null),default:!1})}validate(se){return typeof se=="undefined"?this.defaultValue:typeof se=="string"?se==="false"?d.OFF:se==="true"?d.ON:se:Boolean(se)?d.ON:d.OFF}}e.EditorFontLigatures=d,d.OFF='"liga" off, "calt" off',d.ON='"liga" on, "calt" on';class A extends R{constructor(){super(40)}compute(se,_e,xe){return se.fontInfo}}class L extends C{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:E.localize(19,null)})}validate(se){let _e=u.float(se,this.defaultValue);return _e===0?e.EDITOR_FONT_DEFAULTS.fontSize:u.clamp(_e,6,100)}compute(se,_e,xe){return se.fontInfo.fontSize}}class B extends n{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:B.MINIMUM_VALUE,maximum:B.MAXIMUM_VALUE,errorMessage:E.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:B.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:E.localize(21,null)})}validate(se){return se==="normal"||se==="bold"?se:String(s.clampedInt(se,e.EDITOR_FONT_DEFAULTS.fontWeight,B.MINIMUM_VALUE,B.MAXIMUM_VALUE))}}B.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],B.MINIMUM_VALUE=1,B.MAXIMUM_VALUE=1e3;class J extends n{constructor(){const se={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},_e={type:"string",enum:["peek","gotoAndPeek","goto"],default:se.multiple,enumDescriptions:[E.localize(22,null),E.localize(23,null),E.localize(24,null)]};super(47,"gotoLocation",se,{"editor.gotoLocation.multiple":{deprecationMessage:E.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:E.localize(26,null)},_e),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:E.localize(27,null)},_e),"editor.gotoLocation.multipleDeclarations":Object.assign({description:E.localize(28,null)},_e),"editor.gotoLocation.multipleImplementations":Object.assign({description:E.localize(29,null)},_e),"editor.gotoLocation.multipleReferences":Object.assign({description:E.localize(30,null)},_e),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:se.alternativeDefinitionCommand,description:E.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:se.alternativeTypeDefinitionCommand,description:E.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:se.alternativeDeclarationCommand,description:E.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:se.alternativeImplementationCommand,description:E.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:se.alternativeReferenceCommand,description:E.localize(35,null)}})}validate(se){var _e,xe,Ve,$e,Ze;if(!se||typeof se!="object")return this.defaultValue;const K=se;return{multiple:v(K.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(_e=K.multipleDefinitions)!==null&&_e!==void 0?_e:v(K.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(xe=K.multipleTypeDefinitions)!==null&&xe!==void 0?xe:v(K.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(Ve=K.multipleDeclarations)!==null&&Ve!==void 0?Ve:v(K.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:($e=K.multipleImplementations)!==null&&$e!==void 0?$e:v(K.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(Ze=K.multipleReferences)!==null&&Ze!==void 0?Ze:v(K.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:S.string(K.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:S.string(K.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:S.string(K.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:S.string(K.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:S.string(K.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class j extends n{constructor(){const se={enabled:!0,delay:300,sticky:!0};super(50,"hover",se,{"editor.hover.enabled":{type:"boolean",default:se.enabled,description:E.localize(36,null)},"editor.hover.delay":{type:"number",default:se.delay,description:E.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:se.sticky,description:E.localize(38,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const _e=se;return{enabled:w(_e.enabled,this.defaultValue.enabled),delay:s.clampedInt(_e.delay,this.defaultValue.delay,0,1e4),sticky:w(_e.sticky,this.defaultValue.sticky)}}}var U;(function(Q){Q[Q.None=0]="None",Q[Q.Text=1]="Text",Q[Q.Blocks=2]="Blocks"})(U=e.RenderMinimap||(e.RenderMinimap={}));class $ extends R{constructor(){super(126,[46,54,35,61,89,56,57,91,113,116,117,118,2])}compute(se,_e,xe){return $.computeLayout(_e,{memory:se.memory,outerWidth:se.outerWidth,outerHeight:se.outerHeight,isDominatedByLongLines:se.isDominatedByLongLines,lineHeight:se.fontInfo.lineHeight,viewLineCount:se.viewLineCount,lineNumbersDigitCount:se.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:se.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:se.fontInfo.maxDigitWidth,pixelRatio:se.pixelRatio})}static computeContainedMinimapLineCount(se){const _e=se.height/se.lineHeight,xe=se.scrollBeyondLastLine?_e-1:0,Ve=(se.viewLineCount+xe)/(se.pixelRatio*se.height),$e=Math.floor(se.viewLineCount/Ve);return{typicalViewportLineCount:_e,extraLinesBeyondLastLine:xe,desiredRatio:Ve,minimapLineCount:$e}}static _computeMinimapLayout(se,_e){const xe=se.outerWidth,Ve=se.outerHeight,$e=se.pixelRatio;if(!se.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor($e*Ve),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ve};const Ze=_e.stableMinimapLayoutInput,K=Ze&&se.outerHeight===Ze.outerHeight&&se.lineHeight===Ze.lineHeight&&se.typicalHalfwidthCharacterWidth===Ze.typicalHalfwidthCharacterWidth&&se.pixelRatio===Ze.pixelRatio&&se.scrollBeyondLastLine===Ze.scrollBeyondLastLine&&se.minimap.enabled===Ze.minimap.enabled&&se.minimap.side===Ze.minimap.side&&se.minimap.size===Ze.minimap.size&&se.minimap.showSlider===Ze.minimap.showSlider&&se.minimap.renderCharacters===Ze.minimap.renderCharacters&&se.minimap.maxColumn===Ze.minimap.maxColumn&&se.minimap.scale===Ze.minimap.scale&&se.verticalScrollbarWidth===Ze.verticalScrollbarWidth&&se.isViewportWrapping===Ze.isViewportWrapping,oe=se.lineHeight,de=se.typicalHalfwidthCharacterWidth,Z=se.scrollBeyondLastLine,ie=se.minimap.renderCharacters;let le=$e>=2?Math.round(se.minimap.scale*2):se.minimap.scale;const ve=se.minimap.maxColumn,ye=se.minimap.size,We=se.minimap.side,Ne=se.verticalScrollbarWidth,qe=se.viewLineCount,Je=se.remainingWidth,et=se.isViewportWrapping,nt=ie?2:3;let st=Math.floor($e*Ve);const it=st/$e;let Ee=!1,fe=!1,ce=nt*le,ee=le/$e,Ae=1;if(ye==="fill"||ye==="fit"){const{typicalViewportLineCount:at,extraLinesBeyondLastLine:ct,desiredRatio:ot,minimapLineCount:yt}=$.computeContainedMinimapLineCount({viewLineCount:qe,scrollBeyondLastLine:Z,height:Ve,lineHeight:oe,pixelRatio:$e});if(qe/yt>1)Ee=!0,fe=!0,le=1,ce=1,ee=le/$e;else{let wt=!1,bt=le+1;if(ye==="fit"){const Et=Math.ceil((qe+ct)*ce);et&&K&&Je<=_e.stableFitRemainingWidth?(wt=!0,bt=_e.stableFitMaxMinimapScale):(wt=Et>st,et&&wt?(_e.stableMinimapLayoutInput=se,_e.stableFitRemainingWidth=Je):(_e.stableMinimapLayoutInput=null,_e.stableFitRemainingWidth=0))}if(ye==="fill"||wt){Ee=!0;const Et=le;ce=Math.min(oe*$e,Math.max(1,Math.floor(1/ot))),le=Math.min(bt,Math.max(1,Math.floor(ce/nt))),le>Et&&(Ae=Math.min(2,le/Et)),ee=le/$e/Ae,st=Math.ceil(Math.max(at,qe+ct)*ce),et&&wt&&(_e.stableFitMaxMinimapScale=le)}}}const Le=Math.floor(ve*ee),Qe=Math.min(Le,Math.max(0,Math.floor((Je-Ne-2)*ee/(de+ee)))+e.MINIMAP_GUTTER_WIDTH);let Ge=Math.floor($e*Qe);const rt=Ge/$e;Ge=Math.floor(Ge*Ae);const ut=ie?1:2,Ye=We==="left"?0:xe-Qe-Ne;return{renderMinimap:ut,minimapLeft:Ye,minimapWidth:Qe,minimapHeightIsEditorHeight:Ee,minimapIsSampling:fe,minimapScale:le,minimapLineHeight:ce,minimapCanvasInnerWidth:Ge,minimapCanvasInnerHeight:st,minimapCanvasOuterWidth:rt,minimapCanvasOuterHeight:it}}static computeLayout(se,_e){const xe=_e.outerWidth|0,Ve=_e.outerHeight|0,$e=_e.lineHeight|0,Ze=_e.lineNumbersDigitCount|0,K=_e.typicalHalfwidthCharacterWidth,oe=_e.maxDigitWidth,de=_e.pixelRatio,Z=_e.viewLineCount,ie=se.get(118),le=ie==="inherit"?se.get(117):ie,ve=le==="inherit"?se.get(113):le,ye=se.get(116),We=se.get(2),Ne=_e.isDominatedByLongLines,qe=se.get(46),Je=se.get(56).renderType!==0,et=se.get(57),nt=se.get(91),st=se.get(61),it=se.get(89),Ee=it.verticalScrollbarSize,fe=it.verticalHasArrows,ce=it.arrowSize,ee=it.horizontalScrollbarSize,Ae=se.get(54),Le=se.get(35);let Qe;if(typeof Ae=="string"&&/^\d+(\.\d+)?ch$/.test(Ae)){const Tt=parseFloat(Ae.substr(0,Ae.length-2));Qe=s.clampedInt(Tt*K,0,0,1e3)}else Qe=s.clampedInt(Ae,0,0,1e3);Le&&(Qe+=16);let Ge=0;if(Je){const Tt=Math.max(Ze,et);Ge=Math.round(Tt*oe)}let rt=0;qe&&(rt=$e);let ut=0,Ye=ut+rt,at=Ye+Ge,ct=at+Qe;const ot=xe-rt-Ge-Qe;let yt=!1,gt=!1,wt=-1;We!==2&&(le==="inherit"&&Ne?(yt=!0,gt=!0):ve==="on"||ve==="bounded"?gt=!0:ve==="wordWrapColumn"&&(wt=ye));const bt=$._computeMinimapLayout({outerWidth:xe,outerHeight:Ve,lineHeight:$e,typicalHalfwidthCharacterWidth:K,pixelRatio:de,scrollBeyondLastLine:nt,minimap:st,verticalScrollbarWidth:Ee,viewLineCount:Z,remainingWidth:ot,isViewportWrapping:gt},_e.memory||new y);bt.renderMinimap!==0&&bt.minimapLeft===0&&(ut+=bt.minimapWidth,Ye+=bt.minimapWidth,at+=bt.minimapWidth,ct+=bt.minimapWidth);const Et=ot-bt.minimapWidth,vt=Math.max(1,Math.floor((Et-Ee-2)/K)),Mt=fe?ce:0;return gt&&(wt=Math.max(1,vt),ve==="bounded"&&(wt=Math.min(wt,ye))),{width:xe,height:Ve,glyphMarginLeft:ut,glyphMarginWidth:rt,lineNumbersLeft:Ye,lineNumbersWidth:Ge,decorationsLeft:at,decorationsWidth:Qe,contentLeft:ct,contentWidth:Et,minimap:bt,viewportColumn:vt,isWordWrapMinified:yt,isViewportWrapping:gt,wrappingColumn:wt,verticalScrollbarWidth:Ee,horizontalScrollbarHeight:ee,overviewRuler:{top:Mt,width:Ee,height:Ve-2*Mt,right:0}}}}e.EditorLayoutInfoComputer=$;class F extends n{constructor(){const se={enabled:!0};super(53,"lightbulb",se,{"editor.lightbulb.enabled":{type:"boolean",default:se.enabled,description:E.localize(39,null)}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{enabled:w(se.enabled,this.defaultValue.enabled)}}}class N extends n{constructor(){const se={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(122,"inlineHints",se,{"editor.inlineHints.enabled":{type:"boolean",default:se.enabled,description:E.localize(40,null)},"editor.inlineHints.fontSize":{type:"number",default:se.fontSize,description:E.localize(41,null)},"editor.inlineHints.fontFamily":{type:"string",default:se.fontFamily,description:E.localize(42,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const _e=se;return{enabled:w(_e.enabled,this.defaultValue.enabled),fontSize:s.clampedInt(_e.fontSize,this.defaultValue.fontSize,0,100),fontFamily:S.string(_e.fontFamily,this.defaultValue.fontFamily)}}}class M extends s{constructor(){super(55,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:E.localize(43,null)})}compute(se,_e,xe){return se.fontInfo.lineHeight}}class x extends n{constructor(){const se={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(61,"minimap",se,{"editor.minimap.enabled":{type:"boolean",default:se.enabled,description:E.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[E.localize(45,null),E.localize(46,null),E.localize(47,null)],default:se.size,description:E.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:se.side,description:E.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:se.showSlider,description:E.localize(50,null)},"editor.minimap.scale":{type:"number",default:se.scale,minimum:1,maximum:3,enum:[1,2,3],description:E.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:se.renderCharacters,description:E.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:se.maxColumn,description:E.localize(53,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const _e=se;return{enabled:w(_e.enabled,this.defaultValue.enabled),size:v(_e.size,this.defaultValue.size,["proportional","fill","fit"]),side:v(_e.side,this.defaultValue.side,["right","left"]),showSlider:v(_e.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:w(_e.renderCharacters,this.defaultValue.renderCharacters),scale:s.clampedInt(_e.scale,1,1,3),maxColumn:s.clampedInt(_e.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function O(Q){return Q==="ctrlCmd"?P.isMacintosh?"metaKey":"ctrlKey":"altKey"}class V extends n{constructor(){super(71,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:E.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:E.localize(55,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const _e=se;return{top:s.clampedInt(_e.top,0,0,1e3),bottom:s.clampedInt(_e.bottom,0,0,1e3)}}}class q extends n{constructor(){const se={enabled:!0,cycle:!1};super(72,"parameterHints",se,{"editor.parameterHints.enabled":{type:"boolean",default:se.enabled,description:E.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:se.cycle,description:E.localize(57,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const _e=se;return{enabled:w(_e.enabled,this.defaultValue.enabled),cycle:w(_e.cycle,this.defaultValue.cycle)}}}class X extends R{constructor(){super(124)}compute(se,_e,xe){return se.pixelRatio}}class me extends n{constructor(){const se={other:!0,comments:!1,strings:!1};super(75,"quickSuggestions",se,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:se.strings,description:E.localize(58,null)},comments:{type:"boolean",default:se.comments,description:E.localize(59,null)},other:{type:"boolean",default:se.other,description:E.localize(60,null)}}}],default:se,description:E.localize(61,null)});this.defaultValue=se}validate(se){if(typeof se=="boolean")return se;if(se&&typeof se=="object"){const _e=se,xe={other:w(_e.other,this.defaultValue.other),comments:w(_e.comments,this.defaultValue.comments),strings:w(_e.strings,this.defaultValue.strings)};return xe.other&&xe.comments&&xe.strings?!0:!xe.other&&!xe.comments&&!xe.strings?!1:xe}return this.defaultValue}}var we;(function(Q){Q[Q.Off=0]="Off",Q[Q.On=1]="On",Q[Q.Relative=2]="Relative",Q[Q.Interval=3]="Interval",Q[Q.Custom=4]="Custom"})(we=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Te extends n{constructor(){super(56,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[E.localize(62,null),E.localize(63,null),E.localize(64,null),E.localize(65,null)],default:"on",description:E.localize(66,null)})}validate(se){let _e=this.defaultValue.renderType,xe=this.defaultValue.renderFn;return typeof se!="undefined"&&(typeof se=="function"?(_e=4,xe=se):se==="interval"?_e=3:se==="relative"?_e=2:se==="on"?_e=1:_e=0),{renderType:_e,renderFn:xe}}}function Pe(Q){const se=Q.get(84);return se==="editable"?Q.get(77):se!=="on"}e.filterValidationDecorations=Pe;class Fe extends n{constructor(){const se=[],_e={type:"number",description:E.localize(67,null)};super(88,"rulers",se,{type:"array",items:{anyOf:[_e,{type:["object"],properties:{column:_e,color:{type:"string",description:E.localize(68,null),format:"color-hex"}}}]},default:se,description:E.localize(69,null)})}validate(se){if(Array.isArray(se)){let _e=[];for(let xe of se)if(typeof xe=="number")_e.push({column:s.clampedInt(xe,0,0,1e4),color:null});else if(xe&&typeof xe=="object"){const Ve=xe;_e.push({column:s.clampedInt(Ve.column,0,0,1e4),color:Ve.color})}return _e.sort((xe,Ve)=>xe.column-Ve.column),_e}return this.defaultValue}}function z(Q,se){if(typeof Q!="string")return se;switch(Q){case"hidden":return 2;case"visible":return 3;default:return 1}}class Y extends n{constructor(){super(89,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const _e=se,xe=s.clampedInt(_e.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ve=s.clampedInt(_e.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:s.clampedInt(_e.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:z(_e.vertical,this.defaultValue.vertical),horizontal:z(_e.horizontal,this.defaultValue.horizontal),useShadows:w(_e.useShadows,this.defaultValue.useShadows),verticalHasArrows:w(_e.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:w(_e.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:w(_e.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:w(_e.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:xe,horizontalSliderSize:s.clampedInt(_e.horizontalSliderSize,xe,0,1e3),verticalScrollbarSize:Ve,verticalSliderSize:s.clampedInt(_e.verticalSliderSize,Ve,0,1e3),scrollByPage:w(_e.scrollByPage,this.defaultValue.scrollByPage)}}}class te extends n{constructor(){const se={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(103,"suggest",se,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[E.localize(70,null),E.localize(71,null)],default:se.insertMode,description:E.localize(72,null)},"editor.suggest.filterGraceful":{type:"boolean",default:se.filterGraceful,description:E.localize(73,null)},"editor.suggest.localityBonus":{type:"boolean",default:se.localityBonus,description:E.localize(74,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:se.shareSuggestSelections,markdownDescription:E.localize(75,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:se.snippetsPreventQuickSuggestions,description:E.localize(76,null)},"editor.suggest.showIcons":{type:"boolean",default:se.showIcons,description:E.localize(77,null)},"editor.suggest.showStatusBar":{type:"boolean",default:se.showStatusBar,description:E.localize(78,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:se.showInlineDetails,description:E.localize(79,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:E.localize(80,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:E.localize(81,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:E.localize(82,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:E.localize(83,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:E.localize(84,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:E.localize(85,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:E.localize(86,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:E.localize(87,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:E.localize(88,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:E.localize(89,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:E.localize(90,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:E.localize(91,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:E.localize(92,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:E.localize(93,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:E.localize(94,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:E.localize(95,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:E.localize(96,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:E.localize(97,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:E.localize(98,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:E.localize(99,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:E.localize(100,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:E.localize(101,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:E.localize(102,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:E.localize(103,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:E.localize(104,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:E.localize(105,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:E.localize(106,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:E.localize(107,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:E.localize(108,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:E.localize(109,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const _e=se;return{insertMode:v(_e.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:w(_e.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:w(_e.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:w(_e.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:w(_e.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:w(_e.showIcons,this.defaultValue.showIcons),showStatusBar:w(_e.showStatusBar,this.defaultValue.showStatusBar),showInlineDetails:w(_e.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:w(_e.showMethods,this.defaultValue.showMethods),showFunctions:w(_e.showFunctions,this.defaultValue.showFunctions),showConstructors:w(_e.showConstructors,this.defaultValue.showConstructors),showFields:w(_e.showFields,this.defaultValue.showFields),showVariables:w(_e.showVariables,this.defaultValue.showVariables),showClasses:w(_e.showClasses,this.defaultValue.showClasses),showStructs:w(_e.showStructs,this.defaultValue.showStructs),showInterfaces:w(_e.showInterfaces,this.defaultValue.showInterfaces),showModules:w(_e.showModules,this.defaultValue.showModules),showProperties:w(_e.showProperties,this.defaultValue.showProperties),showEvents:w(_e.showEvents,this.defaultValue.showEvents),showOperators:w(_e.showOperators,this.defaultValue.showOperators),showUnits:w(_e.showUnits,this.defaultValue.showUnits),showValues:w(_e.showValues,this.defaultValue.showValues),showConstants:w(_e.showConstants,this.defaultValue.showConstants),showEnums:w(_e.showEnums,this.defaultValue.showEnums),showEnumMembers:w(_e.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:w(_e.showKeywords,this.defaultValue.showKeywords),showWords:w(_e.showWords,this.defaultValue.showWords),showColors:w(_e.showColors,this.defaultValue.showColors),showFiles:w(_e.showFiles,this.defaultValue.showFiles),showReferences:w(_e.showReferences,this.defaultValue.showReferences),showFolders:w(_e.showFolders,this.defaultValue.showFolders),showTypeParameters:w(_e.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:w(_e.showSnippets,this.defaultValue.showSnippets),showUsers:w(_e.showUsers,this.defaultValue.showUsers),showIssues:w(_e.showIssues,this.defaultValue.showIssues)}}}class ae extends n{constructor(){super(99,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:E.localize(110,null),default:!0,type:"boolean"}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:w(se.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class he extends R{constructor(){super(125,[77])}compute(se,_e,xe){return _e.get(77)?!0:se.tabFocusMode}}var Ce;(function(Q){Q[Q.None=0]="None",Q[Q.Same=1]="Same",Q[Q.Indent=2]="Indent",Q[Q.DeepIndent=3]="DeepIndent"})(Ce=e.WrappingIndent||(e.WrappingIndent={}));function Oe(Q){switch(Q){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class be extends R{constructor(){super(127,[126])}compute(se,_e,xe){const Ve=_e.get(126);return{isDominatedByLongLines:se.isDominatedByLongLines,isWordWrapMinified:Ve.isWordWrapMinified,isViewportWrapping:Ve.isViewportWrapping,wrappingColumn:Ve.wrappingColumn}}}const ke="Consolas, 'Courier New', monospace",Re="Menlo, Monaco, 'Courier New', monospace",Be="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:P.isMacintosh?Re:P.isLinux?Be:ke,fontWeight:"normal",fontSize:P.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function Se(Q){return e.editorOptionsRegistry[Q.id]=Q,Q}var Ke;(function(Q){Q[Q.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Q[Q.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Q[Q.accessibilitySupport=2]="accessibilitySupport",Q[Q.accessibilityPageSize=3]="accessibilityPageSize",Q[Q.ariaLabel=4]="ariaLabel",Q[Q.autoClosingBrackets=5]="autoClosingBrackets",Q[Q.autoClosingDelete=6]="autoClosingDelete",Q[Q.autoClosingOvertype=7]="autoClosingOvertype",Q[Q.autoClosingQuotes=8]="autoClosingQuotes",Q[Q.autoIndent=9]="autoIndent",Q[Q.automaticLayout=10]="automaticLayout",Q[Q.autoSurround=11]="autoSurround",Q[Q.codeLens=12]="codeLens",Q[Q.codeLensFontFamily=13]="codeLensFontFamily",Q[Q.codeLensFontSize=14]="codeLensFontSize",Q[Q.colorDecorators=15]="colorDecorators",Q[Q.columnSelection=16]="columnSelection",Q[Q.comments=17]="comments",Q[Q.contextmenu=18]="contextmenu",Q[Q.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",Q[Q.cursorBlinking=20]="cursorBlinking",Q[Q.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",Q[Q.cursorStyle=22]="cursorStyle",Q[Q.cursorSurroundingLines=23]="cursorSurroundingLines",Q[Q.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",Q[Q.cursorWidth=25]="cursorWidth",Q[Q.disableLayerHinting=26]="disableLayerHinting",Q[Q.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",Q[Q.domReadOnly=28]="domReadOnly",Q[Q.dragAndDrop=29]="dragAndDrop",Q[Q.emptySelectionClipboard=30]="emptySelectionClipboard",Q[Q.extraEditorClassName=31]="extraEditorClassName",Q[Q.fastScrollSensitivity=32]="fastScrollSensitivity",Q[Q.find=33]="find",Q[Q.fixedOverflowWidgets=34]="fixedOverflowWidgets",Q[Q.folding=35]="folding",Q[Q.foldingStrategy=36]="foldingStrategy",Q[Q.foldingHighlight=37]="foldingHighlight",Q[Q.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",Q[Q.fontFamily=39]="fontFamily",Q[Q.fontInfo=40]="fontInfo",Q[Q.fontLigatures=41]="fontLigatures",Q[Q.fontSize=42]="fontSize",Q[Q.fontWeight=43]="fontWeight",Q[Q.formatOnPaste=44]="formatOnPaste",Q[Q.formatOnType=45]="formatOnType",Q[Q.glyphMargin=46]="glyphMargin",Q[Q.gotoLocation=47]="gotoLocation",Q[Q.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",Q[Q.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",Q[Q.hover=50]="hover",Q[Q.inDiffEditor=51]="inDiffEditor",Q[Q.letterSpacing=52]="letterSpacing",Q[Q.lightbulb=53]="lightbulb",Q[Q.lineDecorationsWidth=54]="lineDecorationsWidth",Q[Q.lineHeight=55]="lineHeight",Q[Q.lineNumbers=56]="lineNumbers",Q[Q.lineNumbersMinChars=57]="lineNumbersMinChars",Q[Q.linkedEditing=58]="linkedEditing",Q[Q.links=59]="links",Q[Q.matchBrackets=60]="matchBrackets",Q[Q.minimap=61]="minimap",Q[Q.mouseStyle=62]="mouseStyle",Q[Q.mouseWheelScrollSensitivity=63]="mouseWheelScrollSensitivity",Q[Q.mouseWheelZoom=64]="mouseWheelZoom",Q[Q.multiCursorMergeOverlapping=65]="multiCursorMergeOverlapping",Q[Q.multiCursorModifier=66]="multiCursorModifier",Q[Q.multiCursorPaste=67]="multiCursorPaste",Q[Q.occurrencesHighlight=68]="occurrencesHighlight",Q[Q.overviewRulerBorder=69]="overviewRulerBorder",Q[Q.overviewRulerLanes=70]="overviewRulerLanes",Q[Q.padding=71]="padding",Q[Q.parameterHints=72]="parameterHints",Q[Q.peekWidgetDefaultFocus=73]="peekWidgetDefaultFocus",Q[Q.definitionLinkOpensInPeek=74]="definitionLinkOpensInPeek",Q[Q.quickSuggestions=75]="quickSuggestions",Q[Q.quickSuggestionsDelay=76]="quickSuggestionsDelay",Q[Q.readOnly=77]="readOnly",Q[Q.renameOnType=78]="renameOnType",Q[Q.renderControlCharacters=79]="renderControlCharacters",Q[Q.renderIndentGuides=80]="renderIndentGuides",Q[Q.renderFinalNewline=81]="renderFinalNewline",Q[Q.renderLineHighlight=82]="renderLineHighlight",Q[Q.renderLineHighlightOnlyWhenFocus=83]="renderLineHighlightOnlyWhenFocus",Q[Q.renderValidationDecorations=84]="renderValidationDecorations",Q[Q.renderWhitespace=85]="renderWhitespace",Q[Q.revealHorizontalRightPadding=86]="revealHorizontalRightPadding",Q[Q.roundedSelection=87]="roundedSelection",Q[Q.rulers=88]="rulers",Q[Q.scrollbar=89]="scrollbar",Q[Q.scrollBeyondLastColumn=90]="scrollBeyondLastColumn",Q[Q.scrollBeyondLastLine=91]="scrollBeyondLastLine",Q[Q.scrollPredominantAxis=92]="scrollPredominantAxis",Q[Q.selectionClipboard=93]="selectionClipboard",Q[Q.selectionHighlight=94]="selectionHighlight",Q[Q.selectOnLineNumbers=95]="selectOnLineNumbers",Q[Q.showFoldingControls=96]="showFoldingControls",Q[Q.showUnused=97]="showUnused",Q[Q.snippetSuggestions=98]="snippetSuggestions",Q[Q.smartSelect=99]="smartSelect",Q[Q.smoothScrolling=100]="smoothScrolling",Q[Q.stickyTabStops=101]="stickyTabStops",Q[Q.stopRenderingLineAfter=102]="stopRenderingLineAfter",Q[Q.suggest=103]="suggest",Q[Q.suggestFontSize=104]="suggestFontSize",Q[Q.suggestLineHeight=105]="suggestLineHeight",Q[Q.suggestOnTriggerCharacters=106]="suggestOnTriggerCharacters",Q[Q.suggestSelection=107]="suggestSelection",Q[Q.tabCompletion=108]="tabCompletion",Q[Q.tabIndex=109]="tabIndex",Q[Q.unusualLineTerminators=110]="unusualLineTerminators",Q[Q.useTabStops=111]="useTabStops",Q[Q.wordSeparators=112]="wordSeparators",Q[Q.wordWrap=113]="wordWrap",Q[Q.wordWrapBreakAfterCharacters=114]="wordWrapBreakAfterCharacters",Q[Q.wordWrapBreakBeforeCharacters=115]="wordWrapBreakBeforeCharacters",Q[Q.wordWrapColumn=116]="wordWrapColumn",Q[Q.wordWrapOverride1=117]="wordWrapOverride1",Q[Q.wordWrapOverride2=118]="wordWrapOverride2",Q[Q.wrappingIndent=119]="wrappingIndent",Q[Q.wrappingStrategy=120]="wrappingStrategy",Q[Q.showDeprecated=121]="showDeprecated",Q[Q.inlineHints=122]="inlineHints",Q[Q.editorClassName=123]="editorClassName",Q[Q.pixelRatio=124]="pixelRatio",Q[Q.tabFocusMode=125]="tabFocusMode",Q[Q.layoutInfo=126]="layoutInfo",Q[Q.wrappingInfo=127]="wrappingInfo"})(Ke=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Se(new g(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:E.localize(111,null)})),acceptSuggestionOnEnter:Se(new _(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",E.localize(112,null),""],markdownDescription:E.localize(113,null)})),accessibilitySupport:Se(new l),accessibilityPageSize:Se(new s(3,"accessibilityPageSize",10,1,1073741824,{description:E.localize(114,null)})),ariaLabel:Se(new S(4,"ariaLabel",E.localize(115,null))),autoClosingBrackets:Se(new _(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",E.localize(116,null),E.localize(117,null),""],description:E.localize(118,null)})),autoClosingDelete:Se(new _(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",E.localize(119,null),""],description:E.localize(120,null)})),autoClosingOvertype:Se(new _(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",E.localize(121,null),""],description:E.localize(122,null)})),autoClosingQuotes:Se(new _(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",E.localize(123,null),E.localize(124,null),""],description:E.localize(125,null)})),autoIndent:Se(new p(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],c,{enumDescriptions:[E.localize(126,null),E.localize(127,null),E.localize(128,null),E.localize(129,null),E.localize(130,null)],description:E.localize(131,null)})),automaticLayout:Se(new g(10,"automaticLayout",!1)),autoSurround:Se(new _(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[E.localize(132,null),E.localize(133,null),E.localize(134,null),""],description:E.localize(135,null)})),stickyTabStops:Se(new g(101,"stickyTabStops",!1,{description:E.localize(136,null)})),codeLens:Se(new g(12,"codeLens",!0,{description:E.localize(137,null)})),codeLensFontFamily:Se(new S(13,"codeLensFontFamily","",{description:E.localize(138,null)})),codeLensFontSize:Se(new s(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,description:E.localize(139,null)})),colorDecorators:Se(new g(15,"colorDecorators",!0,{description:E.localize(140,null)})),columnSelection:Se(new g(16,"columnSelection",!1,{description:E.localize(141,null)})),comments:Se(new t),contextmenu:Se(new g(18,"contextmenu",!0)),copyWithSyntaxHighlighting:Se(new g(19,"copyWithSyntaxHighlighting",!0,{description:E.localize(142,null)})),cursorBlinking:Se(new p(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],o,{description:E.localize(143,null)})),cursorSmoothCaretAnimation:Se(new g(21,"cursorSmoothCaretAnimation",!1,{description:E.localize(144,null)})),cursorStyle:Se(new p(22,"cursorStyle",r.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],h,{description:E.localize(145,null)})),cursorSurroundingLines:Se(new s(23,"cursorSurroundingLines",0,0,1073741824,{description:E.localize(146,null)})),cursorSurroundingLinesStyle:Se(new _(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[E.localize(147,null),E.localize(148,null)],description:E.localize(149,null)})),cursorWidth:Se(new s(25,"cursorWidth",0,0,1073741824,{markdownDescription:E.localize(150,null)})),disableLayerHinting:Se(new g(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:Se(new g(27,"disableMonospaceOptimizations",!1)),domReadOnly:Se(new g(28,"domReadOnly",!1)),dragAndDrop:Se(new g(29,"dragAndDrop",!0,{description:E.localize(151,null)})),emptySelectionClipboard:Se(new b),extraEditorClassName:Se(new S(31,"extraEditorClassName","")),fastScrollSensitivity:Se(new u(32,"fastScrollSensitivity",5,Q=>Q<=0?5:Q,{markdownDescription:E.localize(152,null)})),find:Se(new f),fixedOverflowWidgets:Se(new g(34,"fixedOverflowWidgets",!1)),folding:Se(new g(35,"folding",!0,{description:E.localize(153,null)})),foldingStrategy:Se(new _(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[E.localize(154,null),E.localize(155,null)],description:E.localize(156,null)})),foldingHighlight:Se(new g(37,"foldingHighlight",!0,{description:E.localize(157,null)})),unfoldOnClickAfterEndOfLine:Se(new g(38,"unfoldOnClickAfterEndOfLine",!1,{description:E.localize(158,null)})),fontFamily:Se(new S(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:E.localize(159,null)})),fontInfo:Se(new A),fontLigatures2:Se(new d),fontSize:Se(new L),fontWeight:Se(new B),formatOnPaste:Se(new g(44,"formatOnPaste",!1,{description:E.localize(160,null)})),formatOnType:Se(new g(45,"formatOnType",!1,{description:E.localize(161,null)})),glyphMargin:Se(new g(46,"glyphMargin",!0,{description:E.localize(162,null)})),gotoLocation:Se(new J),hideCursorInOverviewRuler:Se(new g(48,"hideCursorInOverviewRuler",!1,{description:E.localize(163,null)})),highlightActiveIndentGuide:Se(new g(49,"highlightActiveIndentGuide",!0,{description:E.localize(164,null)})),hover:Se(new j),inDiffEditor:Se(new g(51,"inDiffEditor",!1)),letterSpacing:Se(new u(52,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Q=>u.clamp(Q,-5,20),{description:E.localize(165,null)})),lightbulb:Se(new F),lineDecorationsWidth:Se(new C(54,"lineDecorationsWidth",10)),lineHeight:Se(new M),lineNumbers:Se(new Te),lineNumbersMinChars:Se(new s(57,"lineNumbersMinChars",5,1,300)),linkedEditing:Se(new g(58,"linkedEditing",!1,{description:E.localize(166,null)})),links:Se(new g(59,"links",!0,{description:E.localize(167,null)})),matchBrackets:Se(new _(60,"matchBrackets","always",["always","near","never"],{description:E.localize(168,null)})),minimap:Se(new x),mouseStyle:Se(new _(62,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Se(new u(63,"mouseWheelScrollSensitivity",1,Q=>Q===0?1:Q,{markdownDescription:E.localize(169,null)})),mouseWheelZoom:Se(new g(64,"mouseWheelZoom",!1,{markdownDescription:E.localize(170,null)})),multiCursorMergeOverlapping:Se(new g(65,"multiCursorMergeOverlapping",!0,{description:E.localize(171,null)})),multiCursorModifier:Se(new p(66,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],O,{markdownEnumDescriptions:[E.localize(172,null),E.localize(173,null)],markdownDescription:E.localize(174,null)})),multiCursorPaste:Se(new _(67,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[E.localize(175,null),E.localize(176,null)],markdownDescription:E.localize(177,null)})),occurrencesHighlight:Se(new g(68,"occurrencesHighlight",!0,{description:E.localize(178,null)})),overviewRulerBorder:Se(new g(69,"overviewRulerBorder",!0,{description:E.localize(179,null)})),overviewRulerLanes:Se(new s(70,"overviewRulerLanes",3,0,3)),padding:Se(new V),parameterHints:Se(new q),peekWidgetDefaultFocus:Se(new _(73,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[E.localize(180,null),E.localize(181,null)],description:E.localize(182,null)})),definitionLinkOpensInPeek:Se(new g(74,"definitionLinkOpensInPeek",!1,{description:E.localize(183,null)})),quickSuggestions:Se(new me),quickSuggestionsDelay:Se(new s(76,"quickSuggestionsDelay",10,0,1073741824,{description:E.localize(184,null)})),readOnly:Se(new g(77,"readOnly",!1)),renameOnType:Se(new g(78,"renameOnType",!1,{description:E.localize(185,null),markdownDeprecationMessage:E.localize(186,null)})),renderControlCharacters:Se(new g(79,"renderControlCharacters",!1,{description:E.localize(187,null)})),renderIndentGuides:Se(new g(80,"renderIndentGuides",!0,{description:E.localize(188,null)})),renderFinalNewline:Se(new g(81,"renderFinalNewline",!0,{description:E.localize(189,null)})),renderLineHighlight:Se(new _(82,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",E.localize(190,null)],description:E.localize(191,null)})),renderLineHighlightOnlyWhenFocus:Se(new g(83,"renderLineHighlightOnlyWhenFocus",!1,{description:E.localize(192,null)})),renderValidationDecorations:Se(new _(84,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Se(new _(85,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",E.localize(193,null),E.localize(194,null),E.localize(195,null),""],description:E.localize(196,null)})),revealHorizontalRightPadding:Se(new s(86,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Se(new g(87,"roundedSelection",!0,{description:E.localize(197,null)})),rulers:Se(new Fe),scrollbar:Se(new Y),scrollBeyondLastColumn:Se(new s(90,"scrollBeyondLastColumn",5,0,1073741824,{description:E.localize(198,null)})),scrollBeyondLastLine:Se(new g(91,"scrollBeyondLastLine",!0,{description:E.localize(199,null)})),scrollPredominantAxis:Se(new g(92,"scrollPredominantAxis",!0,{description:E.localize(200,null)})),selectionClipboard:Se(new g(93,"selectionClipboard",!0,{description:E.localize(201,null),included:P.isLinux})),selectionHighlight:Se(new g(94,"selectionHighlight",!0,{description:E.localize(202,null)})),selectOnLineNumbers:Se(new g(95,"selectOnLineNumbers",!0)),showFoldingControls:Se(new _(96,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[E.localize(203,null),E.localize(204,null)],description:E.localize(205,null)})),showUnused:Se(new g(97,"showUnused",!0,{description:E.localize(206,null)})),showDeprecated:Se(new g(121,"showDeprecated",!0,{description:E.localize(207,null)})),inlineHints:Se(new N),snippetSuggestions:Se(new _(98,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[E.localize(208,null),E.localize(209,null),E.localize(210,null),E.localize(211,null)],description:E.localize(212,null)})),smartSelect:Se(new ae),smoothScrolling:Se(new g(100,"smoothScrolling",!1,{description:E.localize(213,null)})),stopRenderingLineAfter:Se(new s(102,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Se(new te),suggestFontSize:Se(new s(104,"suggestFontSize",0,0,1e3,{markdownDescription:E.localize(214,null)})),suggestLineHeight:Se(new s(105,"suggestLineHeight",0,0,1e3,{markdownDescription:E.localize(215,null)})),suggestOnTriggerCharacters:Se(new g(106,"suggestOnTriggerCharacters",!0,{description:E.localize(216,null)})),suggestSelection:Se(new _(107,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[E.localize(217,null),E.localize(218,null),E.localize(219,null)],description:E.localize(220,null)})),tabCompletion:Se(new _(108,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[E.localize(221,null),E.localize(222,null),E.localize(223,null)],description:E.localize(224,null)})),tabIndex:Se(new s(109,"tabIndex",0,-1,1073741824)),unusualLineTerminators:Se(new _(110,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[E.localize(225,null),E.localize(226,null),E.localize(227,null)],description:E.localize(228,null)})),useTabStops:Se(new g(111,"useTabStops",!0,{description:E.localize(229,null)})),wordSeparators:Se(new S(112,"wordSeparators",T.USUAL_WORD_SEPARATORS,{description:E.localize(230,null)})),wordWrap:Se(new _(113,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[E.localize(231,null),E.localize(232,null),E.localize(233,null),E.localize(234,null)],description:E.localize(235,null)})),wordWrapBreakAfterCharacters:Se(new S(114,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Se(new S(115,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Se(new s(116,"wordWrapColumn",80,1,1073741824,{markdownDescription:E.localize(236,null)})),wordWrapOverride1:Se(new _(117,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Se(new _(118,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Se(new p(119,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Oe,{enumDescriptions:[E.localize(237,null),E.localize(238,null),E.localize(239,null),E.localize(240,null)],description:E.localize(241,null)})),wrappingStrategy:Se(new _(120,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[E.localize(242,null),E.localize(243,null)],description:E.localize(244,null)})),editorClassName:Se(new m),pixelRatio:Se(new X),tabFocusMode:Se(new he),layoutInfo:Se(new $),wrappingInfo:Se(new be)}}),define(ge[151],pe([16,17]),function(G,e){return G.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ge[152],pe([16,17]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ge[153],pe([16,17]),function(G,e){return G.create("vs/platform/extensions/common/extensionValidator",e)}),define(ge[154],pe([16,17]),function(G,e){return G.create("vs/platform/files/common/files",e)}),define(ge[155],pe([16,17]),function(G,e){return G.create("vs/platform/markers/common/markers",e)}),define(ge[156],pe([16,17]),function(G,e){return G.create("vs/platform/theme/common/iconRegistry",e)}),define(ge[157],pe([16,17]),function(G,e){return G.create("vs/platform/workspaces/common/workspaces",e)}),define(ge[158],pe([16,17]),function(G,e){return G.create("vs/workbench/api/common/extHost.api.impl",e)}),define(ge[159],pe([16,17]),function(G,e){return G.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ge[160],pe([16,17]),function(G,e){return G.create("vs/workbench/api/common/extHostExtensionActivator",e)}),define(ge[161],pe([16,17]),function(G,e){return G.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ge[162],pe([16,17]),function(G,e){return G.create("vs/workbench/api/common/extHostProgress",e)}),define(ge[163],pe([16,17]),function(G,e){return G.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ge[164],pe([16,17]),function(G,e){return G.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ge[165],pe([16,17]),function(G,e){return G.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ge[166],pe([16,17]),function(G,e){return G.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ge[167],pe([16,17]),function(G,e){return G.create("vs/workbench/api/node/extHostDebugService",e)}),define(ge[168],pe([16,17]),function(G,e){return G.create("vs/workbench/common/views",e)}),define(ge[169],pe([16,17]),function(G,e){return G.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ge[170],pe([16,17]),function(G,e){return G.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ge[171],pe([16,17]),function(G,e){return G.create("vs/workbench/contrib/externalTerminal/node/externalTerminalService",e)}),define(ge[172],pe([16,17]),function(G,e){return G.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(ge[173],pe([16,17]),function(G,e){return G.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(ge[174],pe([16,17]),function(G,e){return G.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ge[175],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var E;(function(D){D[D.ACTIVATE=0]="ACTIVATE",D[D.RESTORE=1]="RESTORE",D[D.PRESERVE=2]="PRESERVE"})(E=e.EditorActivation||(e.EditorActivation={}));var P;(function(D){D[D.PICK=1]="PICK",D[D.DISABLED=2]="DISABLED"})(P=e.EditorOverride||(e.EditorOverride={}));var T;(function(D){D[D.API=0]="API",D[D.USER=1]="USER"})(T=e.EditorOpenContext||(e.EditorOpenContext={}));var I;(function(D){D[D.Center=0]="Center",D[D.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",D[D.NearTop=2]="NearTop",D[D.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(I=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(ge[176],pe([0,1,153]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVersionValid=e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const P=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function T(C){return C=C.trim(),C==="*"||P.test(C)}e.isValidVersionStr=T;function I(C){if(!T(C))return null;if(C=C.trim(),C==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let w=C.match(P);return w?{hasCaret:w[1]==="^",hasGreaterEquals:w[1]===">=",majorBase:w[2]==="x"?0:parseInt(w[2],10),majorMustEqual:w[2]!=="x",minorBase:w[4]==="x"?0:parseInt(w[4],10),minorMustEqual:w[4]!=="x",patchBase:w[6]==="x"?0:parseInt(w[6],10),patchMustEqual:w[6]!=="x",preRelease:w[8]||null}:null}e.parseVersion=I;function D(C){if(!C)return null;let w=C.majorBase,g=C.majorMustEqual,s=C.minorBase,u=C.minorMustEqual,S=C.patchBase,v=C.patchMustEqual;return C.hasCaret&&(w===0||(u=!1),v=!1),{majorBase:w,majorMustEqual:g,minorBase:s,minorMustEqual:u,patchBase:S,patchMustEqual:v,isMinimum:C.hasGreaterEquals}}e.normalizeVersion=D;function k(C,w){let g;typeof C=="string"?g=D(I(C)):g=C;let s;if(typeof w=="string"?s=D(I(w)):s=w,!g||!s)return!1;let u=g.majorBase,S=g.minorBase,v=g.patchBase,_=s.majorBase,p=s.minorBase,c=s.patchBase,l=s.majorMustEqual,t=s.minorMustEqual,i=s.patchMustEqual;return s.isMinimum?u>_?!0:u<_?!1:S>p?!0:S<p?!1:v>=c:(u===1&&_===0&&(!l||!t||!i)&&(_=1,p=0,c=0,l=!0,t=!1,i=!1),u<_?!1:u>_?!l:S<p?!1:S>p?!t:v<c?!1:v>c?!i:!0)}e.isValidVersion=k;function y(C,w,g){return w.isBuiltin||typeof w.main=="undefined"?!0:R(C,w.engines.vscode,g)}e.isValidExtensionVersion=y;function n(C,w){return C==="*"||R(w,C)}e.isEngineValid=n;function R(C,w,g=[]){let s=D(I(w));if(!s)return g.push(E.localize(0,null,w)),!1;if(s.majorBase===0){if(!s.majorMustEqual||!s.minorMustEqual)return g.push(E.localize(1,null,w)),!1}else if(!s.majorMustEqual)return g.push(E.localize(2,null,w)),!1;return k(C,s)?!0:(g.push(E.localize(3,null,C,w)),!1)}e.isVersionValid=R}),define(ge[108],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class E{constructor(I,D=[],k=!1){this.ctor=I,this.staticArguments=D,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=E;const P=(T,...I)=>new E(T,I);e.createSyncDescriptor=P}),define(ge[78],pe([0,1,108]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const P=[];function T(D,k,y){k instanceof E.SyncDescriptor||(k=new E.SyncDescriptor(k,[],y)),P.push([D,k])}e.registerSingleton=T;function I(){return P}e.getSingletonServiceDescriptors=I}),define(ge[177],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class E{constructor(I){this.incoming=new Map,this.outgoing=new Map,this.data=I}}e.Node=E;class P{constructor(I){this._hashFn=I,this._nodes=new Map}roots(){const I=[];for(let D of this._nodes.values())D.outgoing.size===0&&I.push(D);return I}insertEdge(I,D){const k=this.lookupOrInsertNode(I),y=this.lookupOrInsertNode(D);k.outgoing.set(this._hashFn(D),y),y.incoming.set(this._hashFn(I),k)}removeNode(I){const D=this._hashFn(I);this._nodes.delete(D);for(let k of this._nodes.values())k.outgoing.delete(D),k.incoming.delete(D)}lookupOrInsertNode(I){const D=this._hashFn(I);let k=this._nodes.get(D);return k||(k=new E(I),this._nodes.set(D,k)),k}lookup(I){return this._nodes.get(this._hashFn(I))}isEmpty(){return this._nodes.size===0}toString(){let I=[];for(let[D,k]of this._nodes)I.push(`${D}, (incoming)[${[...k.incoming.keys()].join(", ")}], (outgoing)[${[...k.outgoing.keys()].join(",")}]`);return I.join(`
`)}}e.Graph=P}),define(ge[4],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var E;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function y(n){return n[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=y})(E=e._util||(e._util={})),e.IInstantiationService=T("instantiationService");function P(k,y,n,R){y[E.DI_TARGET]===y?y[E.DI_DEPENDENCIES].push({id:k,index:n,optional:R}):(y[E.DI_DEPENDENCIES]=[{id:k,index:n,optional:R}],y[E.DI_TARGET]=y)}function T(k){if(E.serviceIds.has(k))return E.serviceIds.get(k);const y=function(n,R,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");P(y,n,C,!1)};return y.toString=()=>k,E.serviceIds.set(k,y),y}e.createDecorator=T;function I(k){return k}e.refineServiceDecorator=I;function D(k){return function(y,n,R){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");P(k,y,R,!0)}}e.optional=D}),define(ge[178],pe([0,1,4]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,E.createDecorator)("modelService");function P(T){return!T.isTooLargeForSyncing()&&!T.isForSimpleWidget}e.shouldSynchronizeModel=P}),define(ge[179],pe([0,1,3,73,6,24,72,76,178]),function(G,e,E,P,T,I,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function n(w){return typeof w=="string"?!1:Array.isArray(w)?w.every(n):!!w.exclusive}class R{constructor(){this._clock=0,this._entries=[],this._onDidChange=new E.Emitter}get onDidChange(){return this._onDidChange.event}register(g,s){let u={selector:g,provider:s,_score:-1,_time:this._clock++};return this._entries.push(u),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,T.toDisposable)(()=>{if(u){let S=this._entries.indexOf(u);S>=0&&(this._entries.splice(S,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),u=void 0)}})}has(g){return this.all(g).length>0}all(g){if(!g)return[];this._updateScores(g);const s=[];for(let u of this._entries)u._score>0&&s.push(u.provider);return s}ordered(g){const s=[];return this._orderedForEach(g,u=>s.push(u.provider)),s}orderedGroups(g){const s=[];let u,S;return this._orderedForEach(g,v=>{u&&S===v._score?u.push(v.provider):(S=v._score,u=[v.provider],s.push(u))}),s}_orderedForEach(g,s){if(!!g){this._updateScores(g);for(const u of this._entries)u._score>0&&s(u)}}_updateScores(g){let s={uri:g.uri.toString(),language:g.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===s.language&&this._lastCandidate.uri===s.uri)){this._lastCandidate=s;for(let u of this._entries)if(u._score=(0,k.score)(u.selector,g.uri,g.getLanguageIdentifier().language,(0,y.shouldSynchronizeModel)(g)),n(u.selector)&&u._score>0){for(let S of this._entries)S._score=0;u._score=1e3;break}this._entries.sort(R._compareByScoreAndTime)}}static _compareByScoreAndTime(g,s){return g._score<s._score?1:g._score>s._score?-1:g._time<s._time?1:g._time>s._time?-1:0}}e.LanguageFeatureRegistry=R;class C{constructor(g,s,u=Number.MAX_SAFE_INTEGER){this._registry=g,this.min=s,this.max=u,this._cache=new I.LRUCache(50,.7)}_key(g){return g.id+(0,P.hash)(this._registry.all(g))}_clamp(g){return g===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(g*1.3)))}get(g){const s=this._key(g),u=this._cache.get(s);return this._clamp(u==null?void 0:u.value)}update(g,s){const u=this._key(g);let S=this._cache.get(u);return S||(S=new D.MovingAverage,this._cache.set(u,S)),S.update(s),this.get(g)}}e.LanguageFeatureRequestDelays=C}),define(ge[79],pe([0,1,2,44,179,142,43]),function(G,e,E,P,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlineHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlineHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var k;(function(f){f[f.Null=0]="Null",f[f.PlainText=1]="PlainText"})(k=e.LanguageId||(e.LanguageId={}));class y{constructor(d,A){this.language=d,this.id=A}}e.LanguageIdentifier=y;var n;(function(f){f[f.NotSet=-1]="NotSet",f[f.None=0]="None",f[f.Italic=1]="Italic",f[f.Bold=2]="Bold",f[f.Underline=4]="Underline"})(n=e.FontStyle||(e.FontStyle={}));var R;(function(f){f[f.None=0]="None",f[f.DefaultForeground=1]="DefaultForeground",f[f.DefaultBackground=2]="DefaultBackground"})(R=e.ColorId||(e.ColorId={}));var C;(function(f){f[f.Other=0]="Other",f[f.Comment=1]="Comment",f[f.String=2]="String",f[f.RegEx=4]="RegEx"})(C=e.StandardTokenType||(e.StandardTokenType={}));var w;(function(f){f[f.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",f[f.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",f[f.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",f[f.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",f[f.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",f[f.ITALIC_MASK=2048]="ITALIC_MASK",f[f.BOLD_MASK=4096]="BOLD_MASK",f[f.UNDERLINE_MASK=8192]="UNDERLINE_MASK",f[f.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",f[f.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",f[f.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",f[f.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",f[f.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",f[f.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",f[f.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",f[f.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",f[f.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",f[f.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(w=e.MetadataConsts||(e.MetadataConsts={}));class g{static getLanguageId(d){return(d&255)>>>0}static getTokenType(d){return(d&1792)>>>8}static getFontStyle(d){return(d&14336)>>>11}static getForeground(d){return(d&8372224)>>>14}static getBackground(d){return(d&4286578688)>>>23}static getClassNameFromMetadata(d){let A=this.getForeground(d),L="mtk"+A,B=this.getFontStyle(d);return B&1&&(L+=" mtki"),B&2&&(L+=" mtkb"),B&4&&(L+=" mtku"),L}static getInlineStyleFromMetadata(d,A){const L=this.getForeground(d),B=this.getFontStyle(d);let J=`color: ${A[L]};`;return B&1&&(J+="font-style: italic;"),B&2&&(J+="font-weight: bold;"),B&4&&(J+="text-decoration: underline;"),J}}e.TokenMetadata=g;var s;(function(f){f[f.Method=0]="Method",f[f.Function=1]="Function",f[f.Constructor=2]="Constructor",f[f.Field=3]="Field",f[f.Variable=4]="Variable",f[f.Class=5]="Class",f[f.Struct=6]="Struct",f[f.Interface=7]="Interface",f[f.Module=8]="Module",f[f.Property=9]="Property",f[f.Event=10]="Event",f[f.Operator=11]="Operator",f[f.Unit=12]="Unit",f[f.Value=13]="Value",f[f.Constant=14]="Constant",f[f.Enum=15]="Enum",f[f.EnumMember=16]="EnumMember",f[f.Keyword=17]="Keyword",f[f.Text=18]="Text",f[f.Color=19]="Color",f[f.File=20]="File",f[f.Reference=21]="Reference",f[f.Customcolor=22]="Customcolor",f[f.Folder=23]="Folder",f[f.TypeParameter=24]="TypeParameter",f[f.User=25]="User",f[f.Issue=26]="Issue",f[f.Snippet=27]="Snippet"})(s=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let f=Object.create(null);return f[0]="symbol-method",f[1]="symbol-function",f[2]="symbol-constructor",f[3]="symbol-field",f[4]="symbol-variable",f[5]="symbol-class",f[6]="symbol-struct",f[7]="symbol-interface",f[8]="symbol-module",f[9]="symbol-property",f[10]="symbol-event",f[11]="symbol-operator",f[12]="symbol-unit",f[13]="symbol-value",f[14]="symbol-constant",f[15]="symbol-enum",f[16]="symbol-enum-member",f[17]="symbol-keyword",f[27]="symbol-snippet",f[18]="symbol-text",f[19]="symbol-color",f[20]="symbol-file",f[21]="symbol-reference",f[22]="symbol-customcolor",f[23]="symbol-folder",f[24]="symbol-type-parameter",f[25]="account",f[26]="issues",function(d){const A=f[d];let L=A&&D.iconRegistry.get(A);return L||(console.info("No codicon found for CompletionItemKind "+d),L=D.Codicon.symbolProperty),L.classNames}}(),e.completionKindFromString=function(){let f=Object.create(null);return f.method=0,f.function=1,f.constructor=2,f.field=3,f.variable=4,f.class=5,f.struct=6,f.interface=7,f.module=8,f.property=9,f.event=10,f.operator=11,f.unit=12,f.value=13,f.constant=14,f.enum=15,f["enum-member"]=16,f.enumMember=16,f.keyword=17,f.snippet=27,f.text=18,f.color=19,f.file=20,f.reference=21,f.customcolor=22,f.folder=23,f["type-parameter"]=24,f.typeParameter=24,f.account=25,f.issue=26,function(d,A){let L=f[d];return typeof L=="undefined"&&!A&&(L=9),L}}();var u;(function(f){f[f.Deprecated=1]="Deprecated"})(u=e.CompletionItemTag||(e.CompletionItemTag={}));var S;(function(f){f[f.KeepWhitespace=1]="KeepWhitespace",f[f.InsertAsSnippet=4]="InsertAsSnippet"})(S=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var v;(function(f){f[f.Invoke=0]="Invoke",f[f.TriggerCharacter=1]="TriggerCharacter",f[f.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(v=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var _;(function(f){f[f.Invoke=1]="Invoke",f[f.Auto=2]="Auto"})(_=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var p;(function(f){f[f.Invoke=1]="Invoke",f[f.TriggerCharacter=2]="TriggerCharacter",f[f.ContentChange=3]="ContentChange"})(p=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var c;(function(f){f[f.Text=0]="Text",f[f.Read=1]="Read",f[f.Write=2]="Write"})(c=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function l(f){return f&&E.URI.isUri(f.uri)&&P.Range.isIRange(f.range)&&(P.Range.isIRange(f.originSelectionRange)||P.Range.isIRange(f.targetSelectionRange))}e.isLocationLink=l;var t;(function(f){f[f.File=0]="File",f[f.Module=1]="Module",f[f.Namespace=2]="Namespace",f[f.Package=3]="Package",f[f.Class=4]="Class",f[f.Method=5]="Method",f[f.Property=6]="Property",f[f.Field=7]="Field",f[f.Constructor=8]="Constructor",f[f.Enum=9]="Enum",f[f.Interface=10]="Interface",f[f.Function=11]="Function",f[f.Variable=12]="Variable",f[f.Constant=13]="Constant",f[f.String=14]="String",f[f.Number=15]="Number",f[f.Boolean=16]="Boolean",f[f.Array=17]="Array",f[f.Object=18]="Object",f[f.Key=19]="Key",f[f.Null=20]="Null",f[f.EnumMember=21]="EnumMember",f[f.Struct=22]="Struct",f[f.Event=23]="Event",f[f.Operator=24]="Operator",f[f.TypeParameter=25]="TypeParameter"})(t=e.SymbolKind||(e.SymbolKind={}));var i;(function(f){f[f.Deprecated=1]="Deprecated"})(i=e.SymbolTag||(e.SymbolTag={}));var o;(function(f){const d=new Map;d.set("file",0),d.set("module",1),d.set("namespace",2),d.set("package",3),d.set("class",4),d.set("method",5),d.set("property",6),d.set("field",7),d.set("constructor",8),d.set("enum",9),d.set("interface",10),d.set("function",11),d.set("variable",12),d.set("constant",13),d.set("string",14),d.set("number",15),d.set("boolean",16),d.set("array",17),d.set("object",18),d.set("key",19),d.set("null",20),d.set("enum-member",21),d.set("struct",22),d.set("event",23),d.set("operator",24),d.set("type-parameter",25);const A=new Map;A.set(0,"file"),A.set(1,"module"),A.set(2,"namespace"),A.set(3,"package"),A.set(4,"class"),A.set(5,"method"),A.set(6,"property"),A.set(7,"field"),A.set(8,"constructor"),A.set(9,"enum"),A.set(10,"interface"),A.set(11,"function"),A.set(12,"variable"),A.set(13,"constant"),A.set(14,"string"),A.set(15,"number"),A.set(16,"boolean"),A.set(17,"array"),A.set(18,"object"),A.set(19,"key"),A.set(20,"null"),A.set(21,"enum-member"),A.set(22,"struct"),A.set(23,"event"),A.set(24,"operator"),A.set(25,"type-parameter");function L(j){return d.get(j)}f.fromString=L;function B(j){return A.get(j)}f.toString=B;function J(j,U){const $=A.get(j);let F=$&&D.iconRegistry.get("symbol-"+$);return F||(console.info("No codicon found for SymbolKind "+j),F=D.Codicon.symbolProperty),`${U?"inline":"block"} ${F.classNames}`}f.toCssClassName=J})(o=e.SymbolKinds||(e.SymbolKinds={}));class r{constructor(d){this.value=d}}e.FoldingRangeKind=r,r.Comment=new r("comment"),r.Imports=new r("imports"),r.Region=new r("region");var a;(function(f){f[f.Collapsed=0]="Collapsed",f[f.Expanded=1]="Expanded"})(a=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var h;(function(f){f[f.Editing=0]="Editing",f[f.Preview=1]="Preview"})(h=e.CommentMode||(e.CommentMode={}));var m;(function(f){f[f.Other=0]="Other",f[f.Type=1]="Type",f[f.Parameter=2]="Parameter"})(m=e.InlineHintKind||(e.InlineHintKind={})),e.ReferenceProviderRegistry=new T.LanguageFeatureRegistry,e.RenameProviderRegistry=new T.LanguageFeatureRegistry,e.CompletionProviderRegistry=new T.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new T.LanguageFeatureRegistry,e.HoverProviderRegistry=new T.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new T.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new T.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new T.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new T.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new T.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new T.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new T.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new T.LanguageFeatureRegistry,e.InlineHintsProviderRegistry=new T.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new T.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new T.LanguageFeatureRegistry,e.LinkProviderRegistry=new T.LanguageFeatureRegistry,e.ColorProviderRegistry=new T.LanguageFeatureRegistry,e.SelectionRangeRegistry=new T.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new T.LanguageFeatureRegistry,e.TokenizationRegistry=new I.TokenizationRegistryImpl;var b;(function(f){f[f.None=0]="None",f[f.Option=1]="Option",f[f.Default=2]="Default",f[f.Preferred=3]="Preferred"})(b=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ge[180],pe([0,1,6,15,4,3,55,71]),function(G,e,E,P,T,I,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullCommandService=e.CommandsRegistry=e.ICommandService=void 0,e.ICommandService=(0,T.createDecorator)("commandService"),e.CommandsRegistry=new class{constructor(){this._commands=new Map,this._onDidRegisterCommand=new I.Emitter,this.onDidRegisterCommand=this._onDidRegisterCommand.event}registerCommand(y,n){if(!y)throw new Error("invalid command");if(typeof y=="string"){if(!n)throw new Error("invalid command");return this.registerCommand({id:y,handler:n})}if(y.description){const s=[];for(let S of y.description.args)s.push(S.constraint);const u=y.handler;y.handler=function(S,...v){return(0,P.validateConstraints)(v,s),u(S,...v)}}const{id:R}=y;let C=this._commands.get(R);C||(C=new D.LinkedList,this._commands.set(R,C));let w=C.unshift(y),g=(0,E.toDisposable)(()=>{w();const s=this._commands.get(R);(s==null?void 0:s.isEmpty())&&this._commands.delete(R)});return this._onDidRegisterCommand.fire(R),g}registerCommandAlias(y,n){return e.CommandsRegistry.registerCommand(y,(R,...C)=>R.get(e.ICommandService).executeCommand(n,...C))}getCommand(y){const n=this._commands.get(y);if(!(!n||n.isEmpty()))return k.Iterable.first(n)}getCommands(){const y=new Map;for(const n of this._commands.keys()){const R=this.getCommand(n);R&&y.set(n,R)}return y}},e.NullCommandService={_serviceBrand:void 0,onWillExecuteCommand:()=>E.Disposable.None,onDidExecuteCommand:()=>E.Disposable.None,executeCommand(){return Promise.resolve(void 0)}}}),define(ge[80],pe([0,1,10,4,9]),function(G,e,E,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let I=T.userAgent||"";const D=new Map;D.set("false",!1),D.set("true",!0),D.set("isMac",T.isMacintosh),D.set("isLinux",T.isLinux),D.set("isWindows",T.isWindows),D.set("isWeb",T.isWeb),D.set("isMacNative",T.isMacintosh&&!T.isWeb),D.set("isEdge",I.indexOf("Edg/")>=0),D.set("isFirefox",I.indexOf("Firefox")>=0),D.set("isChrome",I.indexOf("Chrome")>=0),D.set("isSafari",I.indexOf("Safari")>=0),D.set("isIPad",I.indexOf("iPad")>=0);const k=Object.prototype.hasOwnProperty;var y;(function(f){f[f.False=0]="False",f[f.True=1]="True",f[f.Defined=2]="Defined",f[f.Not=3]="Not",f[f.Equals=4]="Equals",f[f.NotEquals=5]="NotEquals",f[f.And=6]="And",f[f.Regex=7]="Regex",f[f.NotRegex=8]="NotRegex",f[f.Or=9]="Or",f[f.In=10]="In",f[f.NotIn=11]="NotIn",f[f.Greater=12]="Greater",f[f.GreaterEquals=13]="GreaterEquals",f[f.Smaller=14]="Smaller",f[f.SmallerEquals=15]="SmallerEquals"})(y=e.ContextKeyExprType||(e.ContextKeyExprType={}));class n{static false(){return C.INSTANCE}static true(){return w.INSTANCE}static has(d){return g.create(d)}static equals(d,A){return s.create(d,A)}static notEquals(d,A){return v.create(d,A)}static regex(d,A){return i.create(d,A)}static in(d,A){return u.create(d,A)}static not(d){return _.create(d)}static and(...d){return r.create(d)}static or(...d){return a.create(d)}static greater(d,A){return p.create(d,A)}static less(d,A){return l.create(d,A)}static deserialize(d,A=!1){if(!!d)return this._deserializeOrExpression(d,A)}static _deserializeOrExpression(d,A){let L=d.split("||");return a.create(L.map(B=>this._deserializeAndExpression(B,A)))}static _deserializeAndExpression(d,A){let L=d.split("&&");return r.create(L.map(B=>this._deserializeOne(B,A)))}static _deserializeOne(d,A){if(d=d.trim(),d.indexOf("!=")>=0){let L=d.split("!=");return v.create(L[0].trim(),this._deserializeValue(L[1],A))}if(d.indexOf("==")>=0){let L=d.split("==");return s.create(L[0].trim(),this._deserializeValue(L[1],A))}if(d.indexOf("=~")>=0){let L=d.split("=~");return i.create(L[0].trim(),this._deserializeRegexValue(L[1],A))}if(d.indexOf(" in ")>=0){let L=d.split(" in ");return u.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(d)){const L=d.split(">=");return c.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(d)){const L=d.split(">");return p.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(d)){const L=d.split("<=");return t.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(d)){const L=d.split("<");return l.create(L[0].trim(),L[1].trim())}return/^\!\s*/.test(d)?_.create(d.substr(1).trim()):g.create(d)}static _deserializeValue(d,A){if(d=d.trim(),d==="true")return!0;if(d==="false")return!1;let L=/^'([^']*)'$/.exec(d);return L?L[1].trim():d}static _deserializeRegexValue(d,A){if((0,E.isFalsyOrWhitespace)(d)){if(A)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let L=d.indexOf("/"),B=d.lastIndexOf("/");if(L===B||L<0){if(A)throw new Error(`bad regexp-value '${d}', missing /-enclosure`);return console.warn(`bad regexp-value '${d}', missing /-enclosure`),null}let J=d.slice(L+1,B),j=d[B+1]==="i"?"i":"";try{return new RegExp(J,j)}catch(U){if(A)throw new Error(`bad regexp-value '${d}', parse error: ${U}`);return console.warn(`bad regexp-value '${d}', parse error: ${U}`),null}}}e.ContextKeyExpr=n;function R(f,d){return f.cmp(d)}class C{constructor(){this.type=0}cmp(d){return this.type-d.type}equals(d){return d.type===this.type}evaluate(d){return!1}serialize(){return"false"}keys(){return[]}map(d){return this}negate(){return w.INSTANCE}}e.ContextKeyFalseExpr=C,C.INSTANCE=new C;class w{constructor(){this.type=1}cmp(d){return this.type-d.type}equals(d){return d.type===this.type}evaluate(d){return!0}serialize(){return"true"}keys(){return[]}map(d){return this}negate(){return C.INSTANCE}}e.ContextKeyTrueExpr=w,w.INSTANCE=new w;class g{constructor(d){this.key=d,this.type=2}static create(d){const A=D.get(d);return typeof A=="boolean"?A?w.INSTANCE:C.INSTANCE:new g(d)}cmp(d){return d.type!==this.type?this.type-d.type:m(this.key,d.key)}equals(d){return d.type===this.type?this.key===d.key:!1}evaluate(d){return!!d.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(d){return d.mapDefined(this.key)}negate(){return _.create(this.key)}}e.ContextKeyDefinedExpr=g;class s{constructor(d,A){this.key=d,this.value=A,this.type=4}static create(d,A){if(typeof A=="boolean")return A?g.create(d):_.create(d);const L=D.get(d);return typeof L=="boolean"?A===(L?"true":"false")?w.INSTANCE:C.INSTANCE:new s(d,A)}cmp(d){return d.type!==this.type?this.type-d.type:b(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}evaluate(d){return d.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(d){return d.mapEquals(this.key,this.value)}negate(){return v.create(this.key,this.value)}}e.ContextKeyEqualsExpr=s;class u{constructor(d,A){this.key=d,this.valueKey=A,this.type=10}static create(d,A){return new u(d,A)}cmp(d){return d.type!==this.type?this.type-d.type:b(this.key,this.valueKey,d.key,d.valueKey)}equals(d){return d.type===this.type?this.key===d.key&&this.valueKey===d.valueKey:!1}evaluate(d){const A=d.getValue(this.valueKey),L=d.getValue(this.key);return Array.isArray(A)?A.indexOf(L)>=0:typeof L=="string"&&typeof A=="object"&&A!==null?k.call(A,L):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(d){return d.mapIn(this.key,this.valueKey)}negate(){return S.create(this)}}e.ContextKeyInExpr=u;class S{constructor(d){this._actual=d,this.type=11}static create(d){return new S(d)}cmp(d){return d.type!==this.type?this.type-d.type:this._actual.cmp(d._actual)}equals(d){return d.type===this.type?this._actual.equals(d._actual):!1}evaluate(d){return!this._actual.evaluate(d)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(d){return new S(this._actual.map(d))}negate(){return this._actual}}e.ContextKeyNotInExpr=S;class v{constructor(d,A){this.key=d,this.value=A,this.type=5}static create(d,A){if(typeof A=="boolean")return A?_.create(d):g.create(d);const L=D.get(d);return typeof L=="boolean"?A===(L?"true":"false")?C.INSTANCE:w.INSTANCE:new v(d,A)}cmp(d){return d.type!==this.type?this.type-d.type:b(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}evaluate(d){return d.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(d){return d.mapNotEquals(this.key,this.value)}negate(){return s.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=v;class _{constructor(d){this.key=d,this.type=3}static create(d){const A=D.get(d);return typeof A=="boolean"?A?C.INSTANCE:w.INSTANCE:new _(d)}cmp(d){return d.type!==this.type?this.type-d.type:m(this.key,d.key)}equals(d){return d.type===this.type?this.key===d.key:!1}evaluate(d){return!d.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(d){return d.mapNot(this.key)}negate(){return g.create(this.key)}}e.ContextKeyNotExpr=_;class p{constructor(d,A){this.key=d,this.value=A,this.type=12}static create(d,A){return new p(d,A)}cmp(d){return d.type!==this.type?this.type-d.type:b(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}evaluate(d){return parseFloat(d.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(d){return d.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=p;class c{constructor(d,A){this.key=d,this.value=A,this.type=13}static create(d,A){return new c(d,A)}cmp(d){return d.type!==this.type?this.type-d.type:b(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}evaluate(d){return parseFloat(d.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(d){return d.mapGreaterEquals(this.key,this.value)}negate(){return l.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=c;class l{constructor(d,A){this.key=d,this.value=A,this.type=14}static create(d,A){return new l(d,A)}cmp(d){return d.type!==this.type?this.type-d.type:b(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}evaluate(d){return parseFloat(d.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(d){return d.mapSmaller(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeySmallerExpr=l;class t{constructor(d,A){this.key=d,this.value=A,this.type=15}static create(d,A){return new t(d,A)}cmp(d){return d.type!==this.type?this.type-d.type:b(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}evaluate(d){return parseFloat(d.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(d){return d.mapSmallerEquals(this.key,this.value)}negate(){return p.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class i{constructor(d,A){this.key=d,this.regexp=A,this.type=7}static create(d,A){return new i(d,A)}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.key<d.key)return-1;if(this.key>d.key)return 1;const A=this.regexp?this.regexp.source:"",L=d.regexp?d.regexp.source:"";return A<L?-1:A>L?1:0}equals(d){if(d.type===this.type){const A=this.regexp?this.regexp.source:"",L=d.regexp?d.regexp.source:"";return this.key===d.key&&A===L}return!1}evaluate(d){let A=d.getValue(this.key);return this.regexp?this.regexp.test(A):!1}serialize(){const d=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${d}`}keys(){return[this.key]}map(d){return d.mapRegex(this.key,this.regexp)}negate(){return o.create(this)}}e.ContextKeyRegexExpr=i;class o{constructor(d){this._actual=d,this.type=8}static create(d){return new o(d)}cmp(d){return d.type!==this.type?this.type-d.type:this._actual.cmp(d._actual)}equals(d){return d.type===this.type?this._actual.equals(d._actual):!1}evaluate(d){return!this._actual.evaluate(d)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(d){return new o(this._actual.map(d))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=o;class r{constructor(d){this.expr=d,this.type=6}static create(d){return r._normalizeArr(d)}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.expr.length<d.expr.length)return-1;if(this.expr.length>d.expr.length)return 1;for(let A=0,L=this.expr.length;A<L;A++){const B=R(this.expr[A],d.expr[A]);if(B!==0)return B}return 0}equals(d){if(d.type===this.type){if(this.expr.length!==d.expr.length)return!1;for(let A=0,L=this.expr.length;A<L;A++)if(!this.expr[A].equals(d.expr[A]))return!1;return!0}return!1}evaluate(d){for(let A=0,L=this.expr.length;A<L;A++)if(!this.expr[A].evaluate(d))return!1;return!0}static _normalizeArr(d){const A=[];let L=!1;for(const B of d)if(!!B){if(B.type===1){L=!0;continue}if(B.type===0)return C.INSTANCE;if(B.type===6){A.push(...B.expr);continue}A.push(B)}if(A.length===0&&L)return w.INSTANCE;if(A.length!==0){if(A.length===1)return A[0];for(A.sort(R);A.length>1;){const B=A[A.length-1];if(B.type!==9)break;A.pop();const J=A.pop(),j=a.create(B.expr.map(U=>r.create([U,J])));j&&(A.push(j),A.sort(R))}return A.length===1?A[0]:new r(A)}}serialize(){return this.expr.map(d=>d.serialize()).join(" && ")}keys(){const d=[];for(let A of this.expr)d.push(...A.keys());return d}map(d){return new r(this.expr.map(A=>A.map(d)))}negate(){let d=[];for(let A of this.expr)d.push(A.negate());return a.create(d)}}e.ContextKeyAndExpr=r;class a{constructor(d){this.expr=d,this.type=9}static create(d){const A=a._normalizeArr(d);if(A.length!==0)return A.length===1?A[0]:new a(A)}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.expr.length<d.expr.length)return-1;if(this.expr.length>d.expr.length)return 1;for(let A=0,L=this.expr.length;A<L;A++){const B=R(this.expr[A],d.expr[A]);if(B!==0)return B}return 0}equals(d){if(d.type===this.type){if(this.expr.length!==d.expr.length)return!1;for(let A=0,L=this.expr.length;A<L;A++)if(!this.expr[A].equals(d.expr[A]))return!1;return!0}return!1}evaluate(d){for(let A=0,L=this.expr.length;A<L;A++)if(this.expr[A].evaluate(d))return!0;return!1}static _normalizeArr(d){let A=[],L=!1;if(d){for(let B=0,J=d.length;B<J;B++){const j=d[B];if(!!j){if(j.type===0){L=!0;continue}if(j.type===1)return[w.INSTANCE];if(j.type===9){A=A.concat(j.expr);continue}A.push(j)}}if(A.length===0&&L)return[C.INSTANCE];A.sort(R)}return A}serialize(){return this.expr.map(d=>d.serialize()).join(" || ")}keys(){const d=[];for(let A of this.expr)d.push(...A.keys());return d}map(d){return new a(this.expr.map(A=>A.map(d)))}negate(){let d=[];for(let L of this.expr)d.push(L.negate());const A=L=>L.type===9?L.expr:[L];for(;d.length>1;){const L=d.shift(),B=d.shift(),J=[];for(const j of A(L))for(const U of A(B))J.push(n.and(j,U));d.unshift(n.or(...J))}return d[0]}}e.ContextKeyOrExpr=a;class h extends g{constructor(d,A,L){super(d);this._defaultValue=A,typeof L=="object"?h._info.push(Object.assign(Object.assign({},L),{key:d})):L!==!0&&h._info.push({key:d,description:L,type:A!=null?typeof A:void 0})}static all(){return h._info.values()}bindTo(d){return d.createKey(this.key,this._defaultValue)}getValue(d){return d.getContextKeyValue(this.key)}toNegated(){return n.not(this.key)}isEqualTo(d){return n.equals(this.key,d)}notEqualsTo(d){return n.notEquals(this.key,d)}}e.RawContextKey=h,h._info=[],e.IContextKeyService=(0,P.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function m(f,d){return f<d?-1:f>d?1:0}function b(f,d,A,L){return f<A?-1:f>A?1:d<L?-1:d>L?1:0}}),define(ge[181],pe([0,1,4]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,E.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,E.refineServiceDecorator)(e.IEnvironmentService)}),define(ge[182],pe([0,1,152,4,11]),function(G,e,E,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function I(C){return C&&typeof C=="object"&&typeof C.id=="string"&&(!C.uuid||typeof C.uuid=="string")}e.isIExtensionIdentifier=I;var D;(function(C){C[C.NoneOrRelevance=0]="NoneOrRelevance",C[C.LastUpdatedDate=1]="LastUpdatedDate",C[C.Title=2]="Title",C[C.PublisherName=3]="PublisherName",C[C.InstallCount=4]="InstallCount",C[C.PublishedDate=5]="PublishedDate",C[C.AverageRating=6]="AverageRating",C[C.WeightedRating=12]="WeightedRating"})(D=e.SortBy||(e.SortBy={}));var k;(function(C){C[C.Default=0]="Default",C[C.Ascending=1]="Ascending",C[C.Descending=2]="Descending"})(k=e.SortOrder||(e.SortOrder={}));var y;(function(C){C.Uninstall="uninstall"})(y=e.StatisticType||(e.StatisticType={}));var n;(function(C){C[C.None=0]="None",C[C.Install=1]="Install",C[C.Update=2]="Update"})(n=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,P.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class R extends Error{constructor(w,g){super(w);this.code=g}}e.ExtensionManagementError=R,e.IExtensionManagementService=(0,P.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,P.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,P.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=T.FileAccess.asBrowserUri("./media/defaultIcon.png",G).toString(!0),e.ExtensionsLabel=(0,E.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,E.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,P.createDecorator)("IExtensionManagementCLIService")}),define(ge[29],pe([0,1,10,4]),function(G,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function T(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(I=e.ExtensionType||(e.ExtensionType={}));class D{constructor(R){this.value=R,this._lower=R.toLowerCase()}static equals(R,C){if(typeof R=="undefined"||R===null)return typeof C=="undefined"||C===null;if(typeof C=="undefined"||C===null)return!1;if(typeof R=="string"||typeof C=="string"){let w=typeof R=="string"?R:R.value,g=typeof C=="string"?C:C.value;return E.equalsIgnoreCase(w,g)}return R._lower===C._lower}static toKey(R){return typeof R=="string"?R.toLowerCase():R._lower}}e.ExtensionIdentifier=D;function k(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=k;function y(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=y,e.IBuiltinExtensionsScannerService=(0,P.createDecorator)("IBuiltinExtensionsScannerService")}),define(ge[183],pe([0,1,10,29]),function(G,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function T(g,s){return g.uuid&&s.uuid?g.uuid===s.uuid:g.id===s.id?!0:(0,E.compareIgnoreCase)(g.id,s.id)===0}e.areSameExtensions=T;class I{constructor(s,u){this.version=u,this.id=s.id,this.uuid=s.uuid}key(){return`${this.id}-${this.version}`}equals(s){return s instanceof I?T(this,s)&&this.version===s.version:!1}}e.ExtensionIdentifierWithVersion=I;function D(g,s){return`${g}.${s}`}e.getExtensionId=D;function k(g){return g.toLocaleLowerCase()}e.adoptToGalleryExtensionId=k;function y(g,s){return k(D(g,s))}e.getGalleryExtensionId=y;function n(g,s){const u=[],S=v=>{for(const _ of u)if(_.some(p=>T(s(p),s(v))))return _;return null};for(const v of g){const _=S(v);_?_.push(v):u.push([v])}return u}e.groupByExtension=n;function R(g){return{id:g.identifier.id,name:g.manifest.name,galleryId:null,publisherId:g.publisherId,publisherName:g.manifest.publisher,publisherDisplayName:g.publisherDisplayName,dependencies:g.manifest.extensionDependencies&&g.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=R;function C(g){return Object.assign({id:g.identifier.id,name:g.name,galleryId:g.identifier.uuid,publisherId:g.publisherId,publisherName:g.publisher,publisherDisplayName:g.publisherDisplayName,dependencies:!!(g.properties.dependencies&&g.properties.dependencies.length>0)},g.telemetryData)}e.getGalleryExtensionTelemetryData=C,e.BetterMergeId=new P.ExtensionIdentifier("pprice.better-merge");function w(g){const s=new Set;for(const u of g)u.malicious&&s.add(u.id.id);return s}e.getMaliciousExtensionsSet=w}),define(ge[45],pe([0,1,154,8,2,4,10,15,24]),function(G,e,E,P,T,I,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,I.createDecorator)("fileService");function n(j){return j.create===!0}e.isFileOpenForWriteOptions=n;var R;(function(j){j[j.Unknown=0]="Unknown",j[j.File=1]="File",j[j.Directory=2]="Directory",j[j.SymbolicLink=64]="SymbolicLink"})(R=e.FileType||(e.FileType={}));var C;(function(j){j[j.FileReadWrite=2]="FileReadWrite",j[j.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",j[j.FileReadStream=16]="FileReadStream",j[j.FileFolderCopy=8]="FileFolderCopy",j[j.PathCaseSensitive=1024]="PathCaseSensitive",j[j.Readonly=2048]="Readonly",j[j.Trash=4096]="Trash",j[j.FileWriteUnlock=8192]="FileWriteUnlock"})(C=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function w(j){return!!(j.capabilities&2)}e.hasReadWriteCapability=w;function g(j){return!!(j.capabilities&8)}e.hasFileFolderCopyCapability=g;function s(j){return!!(j.capabilities&4)}e.hasOpenReadWriteCloseCapability=s;function u(j){return!!(j.capabilities&16)}e.hasFileReadStreamCapability=u;var S;(function(j){j.FileExists="EntryExists",j.FileNotFound="EntryNotFound",j.FileNotADirectory="EntryNotADirectory",j.FileIsADirectory="EntryIsADirectory",j.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",j.FileTooLarge="EntryTooLarge",j.FileWriteLocked="EntryWriteLocked",j.NoPermissions="NoPermissions",j.Unavailable="Unavailable",j.Unknown="Unknown"})(S=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class v extends Error{constructor(U,$){super(U);this.code=$}}e.FileSystemProviderError=v;function _(j,U){const $=new v(j.toString(),U);return c($,U),$}e.createFileSystemProviderError=_;function p(j){return j||_((0,E.localize)(0,null),S.Unknown)}e.ensureFileSystemProviderError=p;function c(j,U){return j.name=U?`${U} (FileSystemError)`:"FileSystemError",j}e.markAsFileSystemProviderError=c;function l(j){if(!j)return S.Unknown;if(j instanceof v)return j.code;const U=/^(.+) \(FileSystemError\)$/.exec(j.name);if(!U)return S.Unknown;switch(U[1]){case S.FileExists:return S.FileExists;case S.FileIsADirectory:return S.FileIsADirectory;case S.FileNotADirectory:return S.FileNotADirectory;case S.FileNotFound:return S.FileNotFound;case S.FileExceedsMemoryLimit:return S.FileExceedsMemoryLimit;case S.FileTooLarge:return S.FileTooLarge;case S.FileWriteLocked:return S.FileWriteLocked;case S.NoPermissions:return S.NoPermissions;case S.Unavailable:return S.Unavailable}return S.Unknown}e.toFileSystemProviderErrorCode=l;function t(j){if(j instanceof m)return j.fileOperationResult;switch(l(j)){case S.FileNotFound:return 1;case S.FileIsADirectory:return 0;case S.FileNotADirectory:return 10;case S.FileWriteLocked:return 5;case S.NoPermissions:return 6;case S.FileExists:return 4;case S.FileExceedsMemoryLimit:return 9;case S.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=t;var i;(function(j){j[j.CREATE=0]="CREATE",j[j.DELETE=1]="DELETE",j[j.MOVE=2]="MOVE",j[j.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class o{constructor(U,$,F){this.resource=U,this.operation=$,this.target=F}isOperation(U){return this.operation===U}}e.FileOperationEvent=o;var r;(function(j){j[j.UPDATED=0]="UPDATED",j[j.ADDED=1]="ADDED",j[j.DELETED=2]="DELETED"})(r=e.FileChangeType||(e.FileChangeType={}));class a{constructor(U,$){this.ignorePathCasing=$,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=U;for(const F of U)switch(F.type){case 1:this.added||(this.added=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(F.resource,F);break;case 0:this.updated||(this.updated=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(F.resource,F);break;case 2:this.deleted||(this.deleted=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(F.resource,F);break}}contains(U,...$){return this.doContains(U,{includeChildren:!1},...$)}affects(U,...$){return this.doContains(U,{includeChildren:!0},...$)}doContains(U,$,...F){var N,M,x,O,V,q;if(!U)return!1;const X=F.length>0;return!!((!X||F.includes(1))&&(((N=this.added)===null||N===void 0?void 0:N.get(U))||$.includeChildren&&((M=this.added)===null||M===void 0?void 0:M.findSuperstr(U)))||(!X||F.includes(0))&&(((x=this.updated)===null||x===void 0?void 0:x.get(U))||$.includeChildren&&((O=this.updated)===null||O===void 0?void 0:O.findSuperstr(U)))||(!X||F.includes(2))&&(((V=this.deleted)===null||V===void 0?void 0:V.findSubstr(U))||$.includeChildren&&((q=this.deleted)===null||q===void 0?void 0:q.findSuperstr(U))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(U){const $=[],F=U===1?this.added:U===0?this.updated:this.deleted;if(F)for(const[,N]of F)$.push(N);return $}filter(U){return new a(this.changes.filter($=>U($)),this.ignorePathCasing)}}e.FileChangesEvent=a;function h(j,U,$){return!j||!U||j===U||U.length>j.length?!1:(U.charAt(U.length-1)!==P.sep&&(U+=P.sep),$?(0,D.startsWithIgnoreCase)(j,U):j.indexOf(U)===0)}e.isParent=h;class m extends Error{constructor(U,$,F){super(U);this.fileOperationResult=$,this.options=F}static isFileOperationError(U){return U instanceof Error&&!(0,k.isUndefinedOrNull)(U.fileOperationResult)}}e.FileOperationError=m;var b;(function(j){j[j.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",j[j.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",j[j.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",j[j.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",j[j.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",j[j.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",j[j.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",j[j.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",j[j.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",j[j.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",j[j.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",j[j.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(b=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var f;(function(j){j[j.FILE=0]="FILE",j[j.FOLDER=1]="FOLDER",j[j.ROOT_FOLDER=2]="ROOT_FOLDER"})(f=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function d(j){if(!(typeof j.size!="number"||typeof j.mtime!="number"))return j.mtime.toString(29)+j.size.toString(31)}e.etag=d;async function A(j,U){if(!U.canHandleResource(T.URI.from({scheme:j.scheme})))return new Promise($=>{const F=U.onDidChangeFileSystemProviderRegistrations(N=>{N.scheme===j.scheme&&N.added&&(F.dispose(),$())})})}e.whenProviderRegistered=A,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class L{static formatSize(U){return(0,k.isNumber)(U)||(U=0),U<L.KB?(0,E.localize)(1,null,U.toFixed(0)):U<L.MB?(0,E.localize)(2,null,(U/L.KB).toFixed(2)):U<L.GB?(0,E.localize)(3,null,(U/L.MB).toFixed(2)):U<L.TB?(0,E.localize)(4,null,(U/L.GB).toFixed(2)):(0,E.localize)(5,null,(U/L.TB).toFixed(2))}}e.ByteSize=L,L.KB=1024,L.MB=L.KB*L.KB,L.GB=L.MB*L.KB,L.TB=L.GB*L.KB;var B;(function(j){j[j.IA32=0]="IA32",j[j.OTHER=1]="OTHER"})(B=e.Arch||(e.Arch={}));function J(j){return{maxFileSize:j===0?300*L.MB:16*L.GB,maxHeapSize:j===0?700*L.MB:2*700*L.MB}}e.getPlatformLimits=J}),define(ge[81],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class E{constructor(...T){this._entries=new Map;for(let[I,D]of T)this.set(I,D)}set(T,I){const D=this._entries.get(T);return this._entries.set(T,I),D}has(T){return this._entries.has(T)}get(T){return this._entries.get(T)}}e.ServiceCollection=E}),define(ge[184],pe([0,1,18,177,108,4,81,19]),function(G,e,E,P,T,I,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const y=!1;class n extends Error{constructor(s){super("cyclic dependency between services");this.message=s.toString()}}class R{constructor(s=new D.ServiceCollection,u=!1,S){this._activeInstantiations=new Set,this._services=s,this._strict=u,this._parent=S,this._services.set(I.IInstantiationService,this)}createChild(s){return new R(s,this._strict,this)}invokeFunction(s,...u){let S=w.traceInvocation(s),v=!1;try{return s({get:(p,c)=>{if(v)throw(0,E.illegalState)("service accessor is only valid during the invocation of its target method");const l=this._getOrCreateServiceInstance(p,S);if(!l&&c!==I.optional)throw new Error(`[invokeFunction] unknown service '${p}'`);return l}},...u)}finally{v=!0,S.stop()}}createInstance(s,...u){let S,v;return s instanceof T.SyncDescriptor?(S=w.traceCreation(s.ctor),v=this._createInstance(s.ctor,s.staticArguments.concat(u),S)):(S=w.traceCreation(s),v=this._createInstance(s,u,S)),S.stop(),v}_createInstance(s,u=[],S){let v=I._util.getServiceDependencies(s).sort((c,l)=>c.index-l.index),_=[];for(const c of v){let l=this._getOrCreateServiceInstance(c.id,S);if(!l&&this._strict&&!c.optional)throw new Error(`[createInstance] ${s.name} depends on UNKNOWN service ${c.id}.`);_.push(l)}let p=v.length>0?v[0].index:u.length;if(u.length!==p){console.warn(`[createInstance] First service dependency of ${s.name} at position ${p+1} conflicts with ${u.length} static arguments`);let c=p-u.length;c>0?u=u.concat(new Array(c)):u=u.slice(0,p)}return new s(...[...u,..._])}_setServiceInstance(s,u){if(this._services.get(s)instanceof T.SyncDescriptor)this._services.set(s,u);else if(this._parent)this._parent._setServiceInstance(s,u);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(s){let u=this._services.get(s);return!u&&this._parent?this._parent._getServiceInstanceOrDescriptor(s):u}_getOrCreateServiceInstance(s,u){let S=this._getServiceInstanceOrDescriptor(s);return S instanceof T.SyncDescriptor?this._safeCreateAndCacheServiceInstance(s,S,u.branch(s,!0)):(u.branch(s,!1),S)}_safeCreateAndCacheServiceInstance(s,u,S){if(this._activeInstantiations.has(s))throw new Error(`illegal state - RECURSIVELY instantiating service '${s}'`);this._activeInstantiations.add(s);try{return this._createAndCacheServiceInstance(s,u,S)}finally{this._activeInstantiations.delete(s)}}_createAndCacheServiceInstance(s,u,S){const v=new P.Graph(c=>c.id.toString());let _=0;const p=[{id:s,desc:u,_trace:S}];for(;p.length;){const c=p.pop();if(v.lookupOrInsertNode(c),_++>1e3)throw new n(v);for(let l of I._util.getServiceDependencies(c.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(l.id);if(!t&&!l.optional&&console.warn(`[createInstance] ${s} depends on ${l.id} which is NOT registered.`),t instanceof T.SyncDescriptor){const i={id:l.id,desc:t,_trace:c._trace.branch(l.id,!0)};v.insertEdge(c,i),p.push(i)}}}for(;;){const c=v.roots();if(c.length===0){if(!v.isEmpty())throw new n(v);break}for(const{data:l}of c){if(this._getServiceInstanceOrDescriptor(l.id)instanceof T.SyncDescriptor){const i=this._createServiceInstanceWithOwner(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this._setServiceInstance(l.id,i)}v.removeNode(l)}}return this._getServiceInstanceOrDescriptor(s)}_createServiceInstanceWithOwner(s,u,S=[],v,_){if(this._services.get(s)instanceof T.SyncDescriptor)return this._createServiceInstance(u,S,v,_);if(this._parent)return this._parent._createServiceInstanceWithOwner(s,u,S,v,_);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}_createServiceInstance(s,u=[],S,v){if(S){const _=new k.IdleValue(()=>this._createInstance(s,u,v));return new Proxy(Object.create(null),{get(p,c){if(c in p)return p[c];let l=_.value,t=l[c];return typeof t!="function"||(t=t.bind(l),p[c]=t),t},set(p,c,l){return _.value[c]=l,!0}})}else return this._createInstance(s,u,v)}}e.InstantiationService=R;var C;(function(g){g[g.Creation=0]="Creation",g[g.Invocation=1]="Invocation",g[g.Branch=2]="Branch"})(C||(C={}));class w{constructor(s,u){this.type=s,this.name=u,this._start=Date.now(),this._dep=[]}static traceInvocation(s){return y?new w(1,s.name||s.toString().substring(0,42).replace(/\n/g,"")):w._None}static traceCreation(s){return y?new w(0,s.name):w._None}branch(s,u){let S=new w(2,s.toString());return this._dep.push([s,u,S]),S}stop(){let s=Date.now()-this._start;w._totals+=s;let u=!1;function S(_,p){let c=[],l=new Array(_+1).join("	");for(const[t,i,o]of p._dep)if(i&&o){u=!0,c.push(`${l}CREATES -> ${t}`);let r=S(_+1,o);r&&c.push(r)}else c.push(`${l}uses -> ${t}`);return c.join(`
`)}let v=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${S(1,this)}`,`DONE, took ${s.toFixed(2)}ms (grand total ${w._totals.toFixed(2)}ms)`];(s>2||u)&&console.log(v.join(`
`))}}w._None=new class extends w{constructor(){super(-1,null)}stop(){}branch(){return this}},w._totals=0}),define(ge[12],pe([0,1,4,6,9,3,58]),function(G,e,E,P,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,E.createDecorator)("logService"),e.ILoggerService=(0,E.createDecorator)("loggerService");function k(){return new Date().toISOString()}var y;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;class n extends P.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new I.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=n;class R extends n{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...i){this.checkLogLevel(y.Trace)&&this.log(y.Trace,this.format([t,...i]))}debug(t,...i){this.checkLogLevel(y.Debug)&&this.log(y.Debug,this.format([t,...i]))}info(t,...i){this.checkLogLevel(y.Info)&&this.log(y.Info,this.format([t,...i]))}warn(t,...i){this.checkLogLevel(y.Warning)&&this.log(y.Warning,this.format([t,...i]))}error(t,...i){if(this.checkLogLevel(y.Error))if(t instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=t.stack,this.log(y.Error,this.format(o))}else this.log(y.Error,this.format([t,...i]))}critical(t,...i){this.checkLogLevel(y.Critical)&&this.log(y.Critical,this.format([t,...i]))}flush(){}format(t){let i="";for(let o=0;o<t.length;o++){let r=t[o];if(typeof r=="object")try{r=JSON.stringify(r)}catch(a){}i+=(o>0?" ":"")+r}return i}}e.AbstractMessageLogger=R;class C extends n{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!T.isWindows}trace(t,...i){this.getLevel()<=y.Trace&&(this.useColors?console.log(`[90m[main ${k()}][0m`,t,...i):console.log(`[main ${k()}]`,t,...i))}debug(t,...i){this.getLevel()<=y.Debug&&(this.useColors?console.log(`[90m[main ${k()}][0m`,t,...i):console.log(`[main ${k()}]`,t,...i))}info(t,...i){this.getLevel()<=y.Info&&(this.useColors?console.log(`[90m[main ${k()}][0m`,t,...i):console.log(`[main ${k()}]`,t,...i))}warn(t,...i){this.getLevel()<=y.Warning&&(this.useColors?console.warn(`[93m[main ${k()}][0m`,t,...i):console.warn(`[main ${k()}]`,t,...i))}error(t,...i){this.getLevel()<=y.Error&&(this.useColors?console.error(`[91m[main ${k()}][0m`,t,...i):console.error(`[main ${k()}]`,t,...i))}critical(t,...i){this.getLevel()<=y.Critical&&(this.useColors?console.error(`[90m[main ${k()}][0m`,t,...i):console.error(`[main ${k()}]`,t,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=C;class w extends n{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...i){this.getLevel()<=y.Trace&&console.log("%cTRACE","color: #888",t,...i)}debug(t,...i){this.getLevel()<=y.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...i)}info(t,...i){this.getLevel()<=y.Info&&console.log("%c INFO","color: #33f",t,...i)}warn(t,...i){this.getLevel()<=y.Warning&&console.log("%c WARN","color: #993",t,...i)}error(t,...i){this.getLevel()<=y.Error&&console.log("%c  ERR","color: #f33",t,...i)}critical(t,...i){this.getLevel()<=y.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...i)}dispose(){}flush(){}}e.ConsoleLogger=w;class g extends n{constructor(t,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(i)}trace(t,...i){this.getLevel()<=y.Trace&&this.adapter.log(y.Trace,[this.extractMessage(t),...i])}debug(t,...i){this.getLevel()<=y.Debug&&this.adapter.log(y.Debug,[this.extractMessage(t),...i])}info(t,...i){this.getLevel()<=y.Info&&this.adapter.log(y.Info,[this.extractMessage(t),...i])}warn(t,...i){this.getLevel()<=y.Warning&&this.adapter.log(y.Warning,[this.extractMessage(t),...i])}error(t,...i){this.getLevel()<=y.Error&&this.adapter.log(y.Error,[this.extractMessage(t),...i])}critical(t,...i){this.getLevel()<=y.Critical&&this.adapter.log(y.Critical,[this.extractMessage(t),...i])}extractMessage(t){return typeof t=="string"?t:(0,D.toErrorMessage)(t,this.getLevel()<=y.Trace)}dispose(){}flush(){}}e.AdapterLogger=g;class s extends n{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const i of this.logServices)i.setLevel(t);super.setLevel(t)}trace(t,...i){for(const o of this.logServices)o.trace(t,...i)}debug(t,...i){for(const o of this.logServices)o.debug(t,...i)}info(t,...i){for(const o of this.logServices)o.info(t,...i)}warn(t,...i){for(const o of this.logServices)o.warn(t,...i)}error(t,...i){for(const o of this.logServices)o.error(t,...i)}critical(t,...i){for(const o of this.logServices)o.critical(t,...i)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=s;class u extends P.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...i){this.logger.trace(t,...i)}debug(t,...i){this.logger.debug(t,...i)}info(t,...i){this.logger.info(t,...i)}warn(t,...i){this.logger.warn(t,...i)}error(t,...i){this.logger.error(t,...i)}critical(t,...i){this.logger.critical(t,...i)}flush(){this.logger.flush()}}e.LogService=u;class S extends P.Disposable{constructor(t,i){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(o))}))}createLogger(t,i){let o=this.loggers.get(t.toString());return o||(o=this.doCreateLogger(t,(i==null?void 0:i.always)?y.Trace:this.logLevel,i),this.loggers.set(t.toString(),o),(i==null?void 0:i.always)||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=S;class v{constructor(){this.onDidChangeLogLevel=new I.Emitter().event}setLevel(t){}getLevel(){return y.Info}trace(t,...i){}debug(t,...i){}info(t,...i){}warn(t,...i){}error(t,...i){}critical(t,...i){}dispose(){}flush(){}}e.NullLogService=v;function _(l){if(l.verbose)return y.Trace;if(typeof l.logLevel=="string"){const t=p(l.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=_;function p(l){switch(l){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Critical;case"off":return y.Off}}e.parseLogLevel=p;function c(l){switch(l){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Critical:return"critical";case y.Off:return"off"}}e.LogLevelToString=c}),define(ge[109],pe([0,1,12,45]),function(G,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function T(y,n,R,C){try{const w=await new Promise((g,s)=>{G(["spdlog"],g,s)});return w.setAsyncMode(8192,500),w.createRotatingLoggerAsync(y,n,R,C)}catch(w){console.error(w)}return null}function I(y,n,R,C){return G.__$__nodeRequire("spdlog").createRotatingLogger(y,n,R,C)}e.createRotatingLogger=I;function D(y,n,R){switch(n){case E.LogLevel.Trace:y.trace(R);break;case E.LogLevel.Debug:y.debug(R);break;case E.LogLevel.Info:y.info(R);break;case E.LogLevel.Warning:y.warn(R);break;case E.LogLevel.Error:y.error(R);break;case E.LogLevel.Critical:y.critical(R);break;default:throw new Error("Invalid log level")}}class k extends E.AbstractMessageLogger{constructor(n,R,C,w){super();this.name=n,this.filepath=R,this.rotating=C,this.buffer=[],this.setLevel(w),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(g=>{this._logger&&this._logger.setLevel(g)}))}_createSpdLogLogger(){const n=this.rotating?6:1,R=30/n*P.ByteSize.MB;return T(this.name,this.filepath,R,n).then(C=>{if(C){this._logger=C,this._logger.setLevel(this.getLevel());for(const{level:w,message:g}of this.buffer)D(this._logger,w,g);this.buffer=[]}})}log(n,R){this._logger?D(this._logger,n,R):this.getLevel()<=n&&this.buffer.push({level:n,message:R})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=k}),define(ge[110],pe([0,1,4,155,56]),function(G,e,E,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var I;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(I=e.MarkerTag||(e.MarkerTag={}));var D;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(D=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function n(s,u){return u-s}y.compare=n;const R=Object.create(null);R[y.Error]=(0,P.localize)(0,null),R[y.Warning]=(0,P.localize)(1,null),R[y.Info]=(0,P.localize)(2,null);function C(s){return R[s]||""}y.toString=C;function w(s){switch(s){case T.default.Error:return y.Error;case T.default.Warning:return y.Warning;case T.default.Info:return y.Info;case T.default.Ignore:return y.Hint}}y.fromSeverity=w;function g(s){switch(s){case y.Error:return T.default.Error;case y.Warning:return T.default.Warning;case y.Info:return T.default.Info;case y.Hint:return T.default.Ignore}}y.toSeverity=g}(D=e.MarkerSeverity||(e.MarkerSeverity={}));var k;(function(y){const n="";function R(w){return C(w,!0)}y.makeKey=R;function C(w,g){let s=[n];return w.source?s.push(w.source.replace("\xA6","\\\xA6")):s.push(n),w.code?typeof w.code=="string"?s.push(w.code.replace("\xA6","\\\xA6")):s.push(w.code.value.replace("\xA6","\\\xA6")):s.push(n),w.severity!==void 0&&w.severity!==null?s.push(D.toString(w.severity)):s.push(n),w.message&&g?s.push(w.message.replace("\xA6","\\\xA6")):s.push(n),w.startLineNumber!==void 0&&w.startLineNumber!==null?s.push(w.startLineNumber.toString()):s.push(n),w.startColumn!==void 0&&w.startColumn!==null?s.push(w.startColumn.toString()):s.push(n),w.endLineNumber!==void 0&&w.endLineNumber!==null?s.push(w.endLineNumber.toString()):s.push(n),w.endColumn!==void 0&&w.endColumn!==null?s.push(w.endColumn.toString()):s.push(n),s.push(n),s.join("\xA6")}y.makeKeyOptionalMessage=C})(k=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,E.createDecorator)("markerService")}),define(ge[185],pe([0,1,56,4,3]),function(G,e,E,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=E.default,e.INotificationService=(0,P.createDecorator)("notificationService");var I;(function(n){n[n.WORKSPACE=0]="WORKSPACE",n[n.GLOBAL=1]="GLOBAL"})(I=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var D;(function(n){n[n.OFF=0]="OFF",n[n.SILENT=1]="SILENT",n[n.ERROR=2]="ERROR"})(D=e.NotificationsFilter||(e.NotificationsFilter={}));class k{constructor(){this.progress=new y,this.onDidClose=T.Event.None,this.onDidChangeVisibility=T.Event.None}updateSeverity(R){}updateMessage(R){}updateActions(R){}close(){}}e.NoOpNotification=k;class y{infinite(){}done(){}total(R){}worked(R){}}e.NoOpProgress=y}),define(ge[186],pe([0,1,11,9,36,25]),function(G,e,E,P,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let D;if(typeof P.globals.vscode!="undefined"){const k=P.globals.vscode.context.configuration();if(k)D=k.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof(G==null?void 0:G.__$__nodeRequire)=="function"){const k=(0,I.dirname)(E.FileAccess.asFileUri("",G));D=G.__$__nodeRequire((0,I.joinPath)(k,"product.json").fsPath);const y=G.__$__nodeRequire((0,I.joinPath)(k,"package.json").fsPath);T.env.VSCODE_DEV&&Object.assign(D,{nameShort:`${D.nameShort} Dev`,nameLong:`${D.nameLong} Dev`,dataFolderName:`${D.dataFolderName}-dev`}),Object.assign(D,{version:y.version})}else D={},Object.keys(D).length===0&&Object.assign(D,{version:"1.56.0-dev",nameShort:P.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:P.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser","ms-vscode.github-richnav","ms-vscode.remotehub","ms-vscode.remotehub-insiders"]});e.default=D});var je=this&&this.__decorate||function(G,e,E,P){var T=arguments.length,I=T<3?e:P===null?P=Object.getOwnPropertyDescriptor(e,E):P,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")I=Reflect.decorate(G,e,E,P);else for(var k=G.length-1;k>=0;k--)(D=G[k])&&(I=(T<3?D(I):T>3?D(e,E,I):D(e,E))||I);return T>3&&I&&Object.defineProperty(e,E,I),I},Ue=this&&this.__param||function(G,e){return function(E,P){e(E,P,G)}};define(ge[111],pe([0,1,4,21,6,19]),function(G,e,E,P,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,E.createDecorator)("progressService");var D;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(D=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class k{constructor(C){this.callback=C}get value(){return this._value}report(C){this._value=C,this.callback(this._value)}}e.Progress=k,k.None=Object.freeze({report(){}});let y=class extends T.Disposable{constructor(C,w){super();this.deferred=new I.DeferredPromise,w.withProgress(C,g=>(this.reporter=g,this.lastStep&&g.report(this.lastStep),this.deferred.p)),this._register((0,T.toDisposable)(()=>this.deferred.complete()))}report(C){this.reporter?this.reporter.report(C):this.lastStep=C}};y=je([Ue(1,e.IProgressService)],y),e.UnmanagedProgress=y;class n extends T.Disposable{constructor(C){super();this.progressIndicator=C,this.currentOperationId=0,this.currentOperationDisposables=this._register(new T.DisposableStore)}start(C){this.stop();const w=++this.currentOperationId,g=new P.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{w===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},C),this.currentOperationDisposables.add((0,T.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,T.toDisposable)(()=>g.cancel())),this.currentOperationDisposables.add((0,T.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:w,token:g.token,stop:()=>this.doStop(w),isCurrent:()=>this.currentOperationId===w}}stop(){this.doStop(this.currentOperationId)}doStop(C){this.currentOperationId===C&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=n,e.IEditorProgressService=(0,E.createDecorator)("editorProgressService")}),define(ge[40],pe([0,1,15,52]),function(G,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class T{constructor(){this.data=new Map}add(D,k){P.ok(E.isString(D)),P.ok(E.isObject(k)),P.ok(!this.data.has(D),"There is already an extension with this id"),this.data.set(D,k)}knows(D){return this.data.has(D)}as(D){return this.data.get(D)||null}}e.Registry=new T}),define(ge[112],pe([0,1,40,3]),function(G,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function T(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class I{constructor(){this._onDidChangeSchema=new P.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,n){this.schemasById[T(y)]=n,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const D=new I;E.Registry.add(e.Extensions.JSONContribution,D)}),define(ge[82],pe([0,1,151,3,40,15,112]),function(G,e,E,P,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var k;(function(S){S[S.APPLICATION=1]="APPLICATION",S[S.MACHINE=2]="MACHINE",S[S.WINDOW=3]="WINDOW",S[S.RESOURCE=4]="RESOURCE",S[S.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",S[S.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(k=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const y=T.Registry.as(D.Extensions.JSONContribution);class n{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new P.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new P.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:E.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(v,_=!0){this.registerConfigurations([v],_)}registerConfigurations(v,_=!0){const p=[];v.forEach(c=>{p.push(...this.validateAndRegisterProperties(c,_,c.extensionInfo)),this.configurationContributors.push(c),this.registerJSONConfiguration(c)}),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(p)}deregisterConfigurations(v){const _=[],p=c=>{if(c.properties)for(const l in c.properties)_.push(l),delete this.configurationProperties[l],this.removeFromSchema(l,c.properties[l]);c.allOf&&c.allOf.forEach(l=>p(l))};for(const c of v){p(c);const l=this.configurationContributors.indexOf(c);l!==-1&&this.configurationContributors.splice(l,1)}y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(_)}registerDefaultConfigurations(v){const _=[],p=[];for(const c of v)for(const l in c)if(_.push(l),e.OVERRIDE_PROPERTY_PATTERN.test(l)){this.defaultValues[l]=Object.assign(Object.assign({},this.defaultValues[l]||{}),c[l]);const t={type:"object",default:this.defaultValues[l],description:E.localize(1,null,l),$ref:e.resourceLanguageSettingsSchemaId};p.push(C(l)),this.configurationProperties[l]=t,this.defaultLanguageConfigurationOverridesNode.properties[l]=t}else{this.defaultValues[l]=c[l];const t=this.configurationProperties[l];t&&(this.updatePropertyDefaultValue(l,t),this.updateSchema(l,t))}this.registerOverrideIdentifiers(p),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(_)}deregisterDefaultConfigurations(v){const _=[];for(const p of v)for(const c in p)if(_.push(c),delete this.defaultValues[c],e.OVERRIDE_PROPERTY_PATTERN.test(c))delete this.configurationProperties[c],delete this.defaultLanguageConfigurationOverridesNode.properties[c];else{const l=this.configurationProperties[c];l&&(this.updatePropertyDefaultValue(c,l),this.updateSchema(c,l))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(_)}notifyConfigurationSchemaUpdated(...v){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(v){for(const _ of v)this.overrideIdentifiers.add(_);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(v,_=!0,p,c=3){var l;c=I.isUndefinedOrNull(v.scope)?c:v.scope;let t=[],i=v.properties;if(i)for(let r in i){if(_&&s(r)){delete i[r];continue}const a=i[r];if(this.updatePropertyDefaultValue(r,a),e.OVERRIDE_PROPERTY_PATTERN.test(r)?a.scope=void 0:(a.scope=I.isUndefinedOrNull(a.scope)?c:a.scope,a.requireTrust=I.isUndefinedOrNull(a.requireTrust)?!!((l=p==null?void 0:p.requireTrustForConfigurations)===null||l===void 0?void 0:l.includes(r)):a.requireTrust),i[r].hasOwnProperty("included")&&!i[r].included){this.excludedConfigurationProperties[r]=i[r],delete i[r];continue}else this.configurationProperties[r]=i[r];!i[r].deprecationMessage&&i[r].markdownDeprecationMessage&&(i[r].deprecationMessage=i[r].markdownDeprecationMessage),t.push(r)}let o=v.allOf;if(o)for(let r of o)t.push(...this.validateAndRegisterProperties(r,_,p,c));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(v){const _=p=>{let c=p.properties;if(c)for(const t in c)this.updateSchema(t,c[t]);let l=p.allOf;l&&l.forEach(_)};_(v)}updateSchema(v,_){switch(e.allSettings.properties[v]=_,_.scope){case 1:e.applicationSettings.properties[v]=_;break;case 2:e.machineSettings.properties[v]=_;break;case 6:e.machineOverridableSettings.properties[v]=_;break;case 3:e.windowSettings.properties[v]=_;break;case 4:e.resourceSettings.properties[v]=_;break;case 5:e.resourceSettings.properties[v]=_,this.resourceLanguageSettingsSchema.properties[v]=_;break}}removeFromSchema(v,_){switch(delete e.allSettings.properties[v],_.scope){case 1:delete e.applicationSettings.properties[v];break;case 2:delete e.machineSettings.properties[v];break;case 6:delete e.machineOverridableSettings.properties[v];break;case 3:delete e.windowSettings.properties[v];break;case 4:case 5:delete e.resourceSettings.properties[v];break}}updateOverridePropertyPatternKey(){for(const v of this.overrideIdentifiers.values()){const _=`[${v}]`,p={type:"object",description:E.localize(2,null),errorMessage:E.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(_,p),e.allSettings.properties[_]=p,e.applicationSettings.properties[_]=p,e.machineSettings.properties[_]=p,e.machineOverridableSettings.properties[_]=p,e.windowSettings.properties[_]=p,e.resourceSettings.properties[_]=p}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(v,_){let p=this.defaultValues[v];I.isUndefined(p)&&(p=_.default),I.isUndefined(p)&&(p=w(_.type)),_.default=p}}const R="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(R);function C(S){return S.substring(1,S.length-1)}e.overrideIdentifierFromKey=C;function w(S){switch(Array.isArray(S)?S[0]:S){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=w;const g=new n;T.Registry.add(e.Extensions.Configuration,g);function s(S){return S.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(S)?E.localize(5,null,S):g.getConfigurationProperties()[S]!==void 0?E.localize(6,null,S):null:E.localize(4,null)}e.validateProperty=s;function u(){const S=[],v=g.getConfigurationProperties();for(const _ of Object.keys(v))S.push([_,v[_].scope]);return S.push(["launch",4]),S.push(["task",4]),S}e.getScopes=u}),define(ge[83],pe([0,1,23,15,2,40,4,82]),function(G,e,E,P,T,I,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function y(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof T.URI)}e.isConfigurationOverrides=y;var n;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(n=e.ConfigurationTarget||(e.ConfigurationTarget={}));function R(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=R;function C(i,o){const r=o?i?o.keys.filter(A=>i.keys.indexOf(A)===-1):[...o.keys]:[],a=i?o?i.keys.filter(A=>o.keys.indexOf(A)===-1):[...i.keys]:[],h=[];if(o&&i){for(const A of i.keys)if(o.keys.indexOf(A)!==-1){const L=v(i.contents,A),B=v(o.contents,A);E.equals(L,B)||h.push(A)}}const m=[],b=A=>{const L={};for(const B of A)for(const J of B.identifiers)L[l(J)]=B;return L},f=o?b(o.overrides):{},d=i?b(i.overrides):{};if(Object.keys(f).length)for(const A of r){const L=f[A];L&&m.push([(0,k.overrideIdentifierFromKey)(A),L.keys])}if(Object.keys(d).length)for(const A of a){const L=d[A];L&&m.push([(0,k.overrideIdentifierFromKey)(A),L.keys])}if(Object.keys(f).length&&Object.keys(d).length)for(const A of h){const L=d[A],B=f[A];if(L&&B){const J=C({contents:L.contents,keys:L.keys,overrides:[]},{contents:B.contents,keys:B.keys,overrides:[]});m.push([(0,k.overrideIdentifierFromKey)(A),[...J.added,...J.removed,...J.updated]])}}return{added:r,removed:a,updated:h,overrides:m}}e.compare=C;function w(i,o){const r=[];for(const a of Object.keys(i))if(k.OVERRIDE_PROPERTY_PATTERN.test(a)){const h={};for(const m in i[a])h[m]=i[a][m];r.push({identifiers:[(0,k.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(h),contents:g(h,o)})}return r}e.toOverrides=w;function g(i,o){const r=Object.create(null);for(let a in i)s(r,a,i[a],o);return r}e.toValuesTree=g;function s(i,o,r,a){const h=o.split("."),m=h.pop();let b=i;for(let f=0;f<h.length;f++){let d=h[f],A=b[d];switch(typeof A){case"undefined":A=b[d]=Object.create(null);break;case"object":break;default:a(`Ignoring ${o} as ${h.slice(0,f+1).join(".")} is ${JSON.stringify(A)}`);return}b=A}if(typeof b=="object"&&b!==null)try{b[m]=r}catch(f){a(`Ignoring ${o} as ${h.join(".")} is ${JSON.stringify(b)}`)}else a(`Ignoring ${o} as ${h.join(".")} is ${JSON.stringify(b)}`)}e.addToValueTree=s;function u(i,o){const r=o.split(".");S(i,r)}e.removeFromValueTree=u;function S(i,o){const r=o.shift();if(o.length===0){delete i[r];return}if(Object.keys(i).indexOf(r)!==-1){const a=i[r];typeof a=="object"&&!Array.isArray(a)&&(S(a,o),Object.keys(a).length===0&&delete i[r])}}function v(i,o,r){function a(b,f){let d=b;for(const A of f){if(typeof d!="object"||d===null)return;d=d[A]}return d}const h=o.split("."),m=a(i,h);return typeof m=="undefined"?r:m}e.getConfigurationValue=v;function _(i,o,r){Object.keys(o).forEach(a=>{a!=="__proto__"&&(a in i?P.isObject(i[a])&&P.isObject(o[a])?_(i[a],o[a],r):r&&(i[a]=o[a]):i[a]=o[a])})}e.merge=_;function p(){const i=I.Registry.as(k.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}e.getConfigurationKeys=p;function c(){const i=Object.create(null),o=I.Registry.as(k.Extensions.Configuration).getConfigurationProperties();for(let r in o){let a=o[r].default;s(i,r,a,h=>console.error(`Conflict in default settings: ${h}`))}return i}e.getDefaultValues=c;function l(i){return`[${i}]`}e.keyFromOverrideIdentifier=l;function t(i,o,r){const a=i.inspect(o),h=i.inspect(r);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof h.userValue!="undefined"||typeof h.workspaceValue!="undefined"||typeof h.workspaceFolderValue!="undefined"?h.value:a.defaultValue}e.getMigratedSettingValue=t}),define(ge[187],pe([0,1,54,24,14,15,23,2,82,83,40,6,3]),function(G,e,E,P,T,I,D,k,y,n,R,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class g{constructor(t={},i=[],o=[]){this._contents=t,this._keys=i,this._overrides=o,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,n.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,i){const o=this.getContentsForOverrideIdentifer(i);return o?t?(0,n.getConfigurationValue)(o,t):o:void 0}getKeysForOverrideIdentifier(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.keys;return[]}override(t){const i=this.getContentsForOverrideIdentifer(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let o={};for(const r of T.distinct([...Object.keys(this.contents),...Object.keys(i)])){let a=this.contents[r],h=i[r];h&&(typeof a=="object"&&typeof h=="object"?(a=D.deepClone(a),this.mergeContents(a,h)):a=h),o[r]=a}return new g(o,this.keys,this.overrides)}merge(...t){const i=D.deepClone(this.contents),o=D.deepClone(this.overrides),r=[...this.keys];for(const a of t){this.mergeContents(i,a.contents);for(const h of a.overrides){const[m]=o.filter(b=>T.equals(b.identifiers,h.identifiers));m?this.mergeContents(m.contents,h.contents):o.push(D.deepClone(h))}for(const h of a.keys)r.indexOf(h)===-1&&r.push(h)}return new g(i,r,o)}freeze(){return this.isFrozen=!0,this}mergeContents(t,i){for(const o of Object.keys(i)){if(o in t&&I.isObject(t[o])&&I.isObject(i[o])){this.mergeContents(t[o],i[o]);continue}t[o]=D.deepClone(i[o])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?D.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,i){this.addKey(t),(0,n.addToValueTree)(this.contents,t,i,o=>{throw new Error(o)})}removeValue(t){this.removeKey(t)&&(0,n.removeFromValueTree)(this.contents,t)}addKey(t){let i=this.keys.length;for(let o=0;o<i;o++)t.indexOf(this.keys[o])===0&&(i=o);this.keys.splice(i,1,t)}removeKey(t){let i=this.keys.indexOf(t);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=g;class s extends g{constructor(){const t=(0,n.getDefaultValues)(),i=(0,n.getConfigurationKeys)(),o=[];for(const r of Object.keys(t))y.OVERRIDE_PROPERTY_PATTERN.test(r)&&o.push({identifiers:[(0,y.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(t[r]),contents:(0,n.toValuesTree)(t[r],a=>console.error(`Conflict in default settings file: ${a}`))});super(t,i,o)}}e.DefaultConfigurationModel=s;class u{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._untrustedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new g}get untrustedConfigurations(){return this._untrustedConfigurations}get errors(){return this._parseErrors}parse(t,i){if(!I.isUndefinedOrNull(t)){const o=this.doParseContent(t);this.parseRaw(o,i)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,i){this._raw=t;const{contents:o,keys:r,overrides:a,untrusted:h}=this.doParseRaw(t,i);this._configurationModel=new g(o,r,a),this._untrustedConfigurations=h||[]}doParseContent(t){let i={},o=null,r=[],a=[],h=[];function m(f){Array.isArray(r)?r.push(f):o&&(r[o]=f)}let b={onObjectBegin:()=>{let f={};m(f),a.push(r),r=f,o=null},onObjectProperty:f=>{o=f},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{let f=[];m(f),a.push(r),r=f,o=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:m,onError:(f,d,A)=>{h.push({error:f,offset:d,length:A})}};if(t)try{E.visit(t,b),i=r[0]||{}}catch(f){console.error(`Error while parsing settings file ${this._name}: ${f}`),this._parseErrors=[f]}return i}doParseRaw(t,i){const o=R.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),r=this.filter(t,o,!0,i);t=r.raw;const a=(0,n.toValuesTree)(t,b=>console.error(`Conflict in settings file ${this._name}: ${b}`)),h=Object.keys(t),m=(0,n.toOverrides)(t,b=>console.error(`Conflict in settings file ${this._name}: ${b}`));return{contents:a,keys:h,overrides:m,untrusted:r.untrusted}}filter(t,i,o,r){if(!(r==null?void 0:r.scopes)&&!(r==null?void 0:r.isUntrusted))return{raw:t,untrusted:[]};const a={},h=[];for(let m in t)if(y.OVERRIDE_PROPERTY_PATTERN.test(m)&&o){const b=this.filter(t[m],i,!1,r);a[m]=b.raw,h.push(...b.untrusted)}else{const b=i[m],f=b?typeof b.scope!="undefined"?b.scope:3:void 0;(f===void 0||r.scopes===void 0||r.scopes.includes(f))&&(r.isUntrusted&&(b==null?void 0:b.requireTrust)?h.push(m):a[m]=t[m])}return{raw:a,untrusted:h}}}e.ConfigurationModelParser=u;class S extends C.Disposable{constructor(t,i,o,r){super();this.userSettingsResource=t,this.scopes=i,this.fileService=r,this._onDidChange=this._register(new w.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new u(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(w.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new g}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getUntrustedSettings(){return this.parser.untrustedConfigurations}}e.UserSettings=S;class v{constructor(t,i,o=new g,r=new g,a=new P.ResourceMap,h=new g,m=new P.ResourceMap,b=!0){this._defaultConfiguration=t,this._localUserConfiguration=i,this._remoteUserConfiguration=o,this._workspaceConfiguration=r,this._folderConfigurations=a,this._memoryConfiguration=h,this._memoryConfigurationByResource=m,this._freeze=b,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new P.ResourceMap,this._userConfiguration=null}getValue(t,i,o){return this.getConsolidateConfigurationModel(i,o).getValue(t)}updateValue(t,i,o={}){let r;o.resource?(r=this._memoryConfigurationByResource.get(o.resource),r||(r=new g,this._memoryConfigurationByResource.set(o.resource,r))):r=this._memoryConfiguration,i===void 0?r.removeValue(t):r.setValue(t,i),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,i,o){const r=this.getConsolidateConfigurationModel(i,o),a=this.getFolderConfigurationModelForResource(i.resource,o),h=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,m=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),b=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),f=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),d=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),A=o?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,L=a?i.overrideIdentifier?a.freeze().override(i.overrideIdentifier).getValue(t):a.freeze().getValue(t):void 0,B=i.overrideIdentifier?h.override(i.overrideIdentifier).getValue(t):h.getValue(t),J=r.getValue(t),j=T.distinct(T.flatten(r.overrides.map(U=>U.identifiers))).filter(U=>r.getOverrideValue(t,U)!==void 0);return{defaultValue:m,userValue:b,userLocalValue:f,userRemoteValue:d,workspaceValue:A,workspaceFolderValue:L,memoryValue:B,value:J,default:m!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,user:b!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userLocal:f!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userRemote:d!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspace:A!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspaceFolder:L!==void 0?{value:a==null?void 0:a.freeze().getValue(t),override:i.overrideIdentifier?a==null?void 0:a.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,memory:B!==void 0?{value:h.getValue(t),override:i.overrideIdentifier?h.getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:j.length?j:void 0}}keys(t){const i=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,i){this._folderConfigurations.set(t,i),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const o=i.filter(r=>y.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const a=(0,y.overrideIdentifierFromKey)(r),h=this._defaultConfiguration.getKeysForOverrideIdentifier(a),m=t.getKeysForOverrideIdentifier(a),b=[...m.filter(f=>h.indexOf(f)===-1),...h.filter(f=>m.indexOf(f)===-1),...h.filter(f=>!D.equals(this._defaultConfiguration.override(a).getValue(f),t.override(a).getValue(f)))];return[a,b]});return this.updateDefaultConfiguration(t),{keys:i,overrides:o}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:o,removed:r,overrides:a}=(0,n.compare)(this.localUserConfiguration,t),h=[...i,...o,...r];return h.length&&this.updateLocalUserConfiguration(t),{keys:h,overrides:a}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:o,removed:r,overrides:a}=(0,n.compare)(this.remoteUserConfiguration,t);let h=[...i,...o,...r];return h.length&&this.updateRemoteUserConfiguration(t),{keys:h,overrides:a}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:o,removed:r,overrides:a}=(0,n.compare)(this.workspaceConfiguration,t);let h=[...i,...o,...r];return h.length&&this.updateWorkspaceConfiguration(t),{keys:h,overrides:a}}compareAndUpdateFolderConfiguration(t,i){const o=this.folderConfigurations.get(t),{added:r,updated:a,removed:h,overrides:m}=(0,n.compare)(o,i);let b=[...r,...a,...h];return(b.length||!o)&&this.updateFolderConfiguration(t,i),{keys:b,overrides:m}}compareAndDeleteFolderConfiguration(t){const i=this.folderConfigurations.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:o,updated:r,removed:a,overrides:h}=(0,n.compare)(i,void 0);return{keys:[...o,...r,...a],overrides:h}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,i){let o=this.getConsolidatedConfigurationModelForResource(t,i);return t.overrideIdentifier?o.override(t.overrideIdentifier):o}getConsolidatedConfigurationModelForResource({resource:t},i){let o=this.getWorkspaceConsolidatedConfiguration();if(i&&t){const r=i.getFolder(t);r&&(o=this.getFolderConsolidatedConfiguration(r.uri)||o);const a=this._memoryConfigurationByResource.get(t);a&&(o=o.merge(a))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let i=this._foldersConsolidatedConfigurations.get(t);if(!i){const o=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(t);r?(i=o.merge(r),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(t,i)):i=o}return i}getFolderConfigurationModelForResource(t,i){if(i&&t){const o=i.getFolder(t);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,i)=>{const{contents:o,overrides:r,keys:a}=this._folderConfigurations.get(i);return t.push([i,{contents:o,overrides:r,keys:a}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>t.add(i)),this.userConfiguration.freeze().keys.forEach(i=>t.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>t.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(o=>t.add(o))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>i.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>i.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>i.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(t).forEach(r=>i.add(r))),[...i.values()]}static parse(t){const i=this.parseConfigurationModel(t.defaults),o=this.parseConfigurationModel(t.user),r=this.parseConfigurationModel(t.workspace),a=t.folders.reduce((h,m)=>(h.set(k.URI.revive(m[0]),this.parseConfigurationModel(m[1])),h),new P.ResourceMap);return new v(i,o,new g,r,a,new g,new P.ResourceMap,!1)}static parseConfigurationModel(t){return new g(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=v;function _(...l){if(l.length===0)return{keys:[],overrides:[]};if(l.length===1)return l[0];const t=new Set,i=new Map;for(const r of l)r.keys.forEach(a=>t.add(a)),r.overrides.forEach(([a,h])=>{const m=(0,P.getOrSet)(i,a,new Set);h.forEach(b=>m.add(b))});const o=[];return i.forEach((r,a)=>o.push([a,[...r.values()]])),{keys:[...t.values()],overrides:o}}e.mergeChanges=_;class p{constructor(t,i,o,r){this.change=t,this.previous=i,this.currentConfiguraiton=o,this.currentWorkspace=r,this._previousConfiguration=void 0;const a=new Set;t.keys.forEach(m=>a.add(m)),t.overrides.forEach(([,m])=>m.forEach(b=>a.add(b))),this.affectedKeys=[...a.values()];const h=new g;this.affectedKeys.forEach(m=>h.setValue(m,{})),this.affectedKeysTree=h.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=v.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,i){var o;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(i){const r=this.previousConfiguration?this.previousConfiguration.getValue(t,i,(o=this.previous)===null||o===void 0?void 0:o.workspace):void 0,a=this.currentConfiguraiton.getValue(t,i,this.currentWorkspace);return!D.equals(r,a)}return!0}return!1}doesAffectedKeysTreeContains(t,i){let o=(0,n.toValuesTree)({[i]:!0},()=>{}),r;for(;typeof o=="object"&&(r=Object.keys(o)[0]);){if(t=t[r],!t)return!1;o=o[r]}return!0}}e.ConfigurationChangeEvent=p;class c extends p{constructor(t,i,o,r){super({keys:t.allKeys(),overrides:[]},void 0,t,i);this.source=o,this.sourceConfig=r}}e.AllKeysConfigurationChangeEvent=c}),define(ge[113],pe([0,1,4]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,E.createDecorator)("remoteAuthorityResolverService");var P;(function(I){I.Unknown="Unknown",I.NotAvailable="NotAvailable",I.TemporarilyNotAvailable="TemporarilyNotAvailable",I.NoResolverFound="NoResolverFound"})(P=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class T extends Error{constructor(D,k=P.Unknown,y){super(D);this._message=D,this._code=k,this._detail=y,this.isHandled=k===P.NotAvailable&&y===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,T.prototype)}static isTemporarilyNotAvailable(D){return D instanceof T&&D._code===P.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof T&&D._code===P.NoResolverFound}static isHandled(D){return D instanceof T&&D.isHandled}}e.RemoteAuthorityResolverError=T}),define(ge[114],pe([0,1,11]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.getRemoteName=e.getRemoteAuthority=void 0;function P(y){return y.scheme===E.Schemas.vscodeRemote?y.authority:void 0}e.getRemoteAuthority=P;function T(y){if(!!y){const n=y.indexOf("+");return n<0?y:y.substr(0,n)}}e.getRemoteName=T;function I(y){return y.scheme!==E.Schemas.file&&y.scheme!==E.Schemas.vscodeRemote}function D(y){const n=y.configuration;if(n&&I(n))return n;if(y.folders.length){const R=y.folders[0].uri;if(I(R))return R}}e.getVirtualWorkspaceLocation=D;function k(y){var n;return(n=D(y))===null||n===void 0?void 0:n.scheme}e.getVirtualWorkspaceScheme=k}),define(ge[188],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class E{vsda(){return new Promise((T,I)=>G(["vsda"],T,I))}async sign(T){try{const I=await this.vsda(),D=new I.signer;if(D)return D.sign(T)}catch(I){}return T}}e.SignService=E}),define(ge[189],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class E{constructor(T){this._callback=T,this._terminalBufferMap=new Map}dispose(){for(const T of this._terminalBufferMap.values())T.dispose()}startBuffering(T,I,D=5){let k;return k=I(y=>{const n=typeof y=="string"?y:y.data;let R=this._terminalBufferMap.get(T);if(R){R.data.push(n);return}const C=setTimeout(()=>this.flushBuffer(T),D);R={data:[n],timeoutId:C,dispose:()=>{clearTimeout(C),this.flushBuffer(T),k.dispose()}},this._terminalBufferMap.set(T,R)}),k}stopBuffering(T){const I=this._terminalBufferMap.get(T);I&&I.dispose()}flushBuffer(T){const I=this._terminalBufferMap.get(T);I&&(this._terminalBufferMap.delete(T),this._callback(T,I.data.join("")))}}e.TerminalDataBufferer=E}),define(ge[190],pe([0,1,48,8,36,26,15,23,9]),function(G,e,E,P,T,I,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function n(){const C=/(\d+)\.(\d+)\.(\d+)/g.exec(E.release());let w=0;return C&&C.length===4&&(w=parseInt(C[3])),w}e.getWindowsBuildNumber=n;async function R(C,w,g,s=T.env,u=I.exists){if(P.isAbsolute(C))return await u(C)?C:void 0;if(w===void 0&&(w=T.cwd()),P.dirname(C)!=="."){const p=P.join(w,C);return await u(p)?p:void 0}const v=(0,k.getCaseInsensitive)(s,"PATH");if(g===void 0&&(0,D.isString)(v)&&(g=v.split(P.delimiter)),g===void 0||g.length===0){const p=P.join(w,C);return await u(p)?p:void 0}for(let p of g){let c;if(P.isAbsolute(p)?c=P.join(p,C):c=P.join(w,p,C),await u(c))return c;if(y.isWindows){let l=c+".com";if(await u(l)||(l=c+".exe",await u(l)))return l}}const _=P.join(w,C);return await u(_)?_:void 0}e.findExecutable=R}),define(ge[191],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var E;(function(P){P.DARK="dark",P.LIGHT="light",P.HIGH_CONTRAST="hc"})(E=e.ColorScheme||(e.ColorScheme={}))}),define(ge[192],pe([0,1,4,6,40,3,191,43]),function(G,e,E,P,T,I,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,E.createDecorator)("themeService");var y;(function(S){function v(_){return _&&typeof _=="object"&&typeof _.id=="string"}S.isThemeColor=v})(y=e.ThemeColor||(e.ThemeColor={}));function n(S){return{id:S}}e.themeColorFromId=n;var R;(function(S){function v(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||y.isThemeColor(t.color))}S.isThemeIcon=v;const _=new RegExp(`^\\$\\((${k.CSSIcon.iconNameExpression}(?:${k.CSSIcon.iconModifierExpression})?)\\)$`);function p(t){const i=_.exec(t);if(!!i){let[,o]=i;return{id:o}}}S.fromString=p;function c(t,i){let o=t.id;const r=o.lastIndexOf("~");return r!==-1&&(o=o.substring(0,r)),i&&(o=`${o}~${i}`),{id:o}}S.modify=c;function l(t,i){var o,r;return t.id===i.id&&((o=t.color)===null||o===void 0?void 0:o.id)===((r=i.color)===null||r===void 0?void 0:r.id)}S.isEqual=l,S.asClassNameArray=k.CSSIcon.asClassNameArray,S.asClassName=k.CSSIcon.asClassName,S.asCSSSelector=k.CSSIcon.asCSSSelector})(R=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=k.Codicon.file,e.FolderThemeIcon=k.Codicon.folder;function C(S){switch(S){case D.ColorScheme.DARK:return"vs-dark";case D.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=C,e.Extensions={ThemingContribution:"base.contributions.theming"};class w{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new I.Emitter}onColorThemeChange(v){return this.themingParticipants.push(v),this.onThemingParticipantAddedEmitter.fire(v),(0,P.toDisposable)(()=>{const _=this.themingParticipants.indexOf(v);this.themingParticipants.splice(_,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let g=new w;T.Registry.add(e.Extensions.ThemingContribution,g);function s(S){return g.onColorThemeChange(S)}e.registerThemingParticipant=s;class u extends P.Disposable{constructor(v){super();this.themeService=v,this.theme=v.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(_=>this.onThemeChange(_)))}onThemeChange(v){this.theme=v,this.updateStyles()}updateStyles(){}getColor(v,_){let p=this.theme.getColor(v);return p&&_&&(p=_(p,this.theme)),p?p.toString():null}}e.Themable=u}),define(ge[193],pe([0,1,40,192,3,156,112,19,43]),function(G,e,E,P,T,I,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class n{constructor(){this._onDidChange=new T.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,I.localize)(0,null)},fontCharacter:{type:"string",description:(0,I.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${y.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(v,_,p,c){const l=this.iconsById[v];if(l){if(p&&!l.description){l.description=p,this.iconSchema.properties[v].markdownDescription=`${p} $(${v})`;const o=this.iconReferenceSchema.enum.indexOf(v);o!==-1&&(this.iconReferenceSchema.enumDescriptions[o]=p),this._onDidChange.fire()}return l}let t={id:v,description:p,defaults:_,deprecationMessage:c};this.iconsById[v]=t;let i={$ref:"#/definitions/icons"};return c&&(i.deprecationMessage=c),p&&(i.markdownDescription=`${p}: $(${v})`),this.iconSchema.properties[v]=i,this.iconReferenceSchema.enum.push(v),this.iconReferenceSchema.enumDescriptions.push(p||""),this._onDidChange.fire(),{id:v}}deregisterIcon(v){delete this.iconsById[v],delete this.iconSchema.properties[v];const _=this.iconReferenceSchema.enum.indexOf(v);_!==-1&&(this.iconReferenceSchema.enum.splice(_,1),this.iconReferenceSchema.enumDescriptions.splice(_,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(v=>this.iconsById[v])}getIcon(v){return this.iconsById[v]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(v,_){const p=this.iconFontsById[v];if(p)return p;let c={id:v,definition:_};return this.iconFontsById[v]=c,this._onDidChange.fire(),c}deregisterIconFont(v){delete this.iconFontsById[v]}getIconFonts(){return Object.keys(this.iconFontsById).map(v=>this.iconFontsById[v])}getIconFont(v){return this.iconFontsById[v]}toString(){const v=(l,t)=>l.id.localeCompare(t.id),_=l=>{for(;P.ThemeIcon.isThemeIcon(l.defaults);)l=this.iconsById[l.defaults.id];return`codicon codicon-${l?l.id:""}`};let p=[];p.push("| preview     | identifier                        | default codicon ID                | description"),p.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const c=Object.keys(this.iconsById).map(l=>this.iconsById[l]);for(const l of c.filter(t=>!!t.description).sort(v))p.push(`|<i class="${_(l)}"></i>|${l.id}|${P.ThemeIcon.isThemeIcon(l.defaults)?l.defaults.id:l.id}|${l.description||""}|`);p.push("| preview     | identifier                        "),p.push("| ----------- | --------------------------------- |");for(const l of c.filter(t=>!P.ThemeIcon.isThemeIcon(t.defaults)).sort(v))p.push(`|<i class="${_(l)}"></i>|${l.id}|`);return p.join(`
`)}}const R=new n;E.Registry.add(e.Extensions.IconContribution,R);function C(S,v,_,p){return R.registerIcon(S,v,_,p)}e.registerIcon=C;function w(){return R}e.getIconRegistry=w;function g(){for(const S of y.iconRegistry.all)R.registerIcon(S.id,S.definition,S.description);y.iconRegistry.onDidRegister(S=>R.registerIcon(S.id,S.definition,S.description))}g(),e.iconsSchemaId="vscode://schemas/icons";let s=E.Registry.as(D.Extensions.JSONContribution);s.registerSchema(e.iconsSchemaId,R.getIconSchema());const u=new k.RunOnceScheduler(()=>s.notifySchemaChanged(e.iconsSchemaId),200);R.onDidChange(()=>{u.isScheduled()||u.schedule()}),e.widgetClose=C("widget-close",y.Codicon.close,(0,I.localize)(2,null)),e.gotoPreviousLocation=C("goto-previous-location",y.Codicon.arrowUp,(0,I.localize)(3,null)),e.gotoNextLocation=C("goto-next-location",y.Codicon.arrowDown,(0,I.localize)(4,null)),e.syncing=P.ThemeIcon.modify(y.Codicon.sync,"spin")}),define(ge[59],pe([0,1,2,25,4,24]),function(G,e,E,P,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,T.createDecorator)("contextService");var D;(function(w){w[w.EMPTY=1]="EMPTY",w[w.FOLDER=2]="FOLDER",w[w.WORKSPACE=3]="WORKSPACE"})(D=e.WorkbenchState||(e.WorkbenchState={}));function k(w){const g=w;return!!(g&&typeof g=="object"&&typeof g.id=="string"&&Array.isArray(g.folders))}e.isWorkspace=k;function y(w){const g=w;return!!(g&&typeof g=="object"&&E.URI.isUri(g.uri)&&typeof g.name=="string"&&typeof g.toResource=="function")}e.isWorkspaceFolder=y;class n{constructor(g,s,u,S){this._id=g,this._configuration=u,this._ignorePathCasing=S,this._foldersMap=I.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=s}update(g){this._id=g.id,this._configuration=g.configuration,this._ignorePathCasing=g._ignorePathCasing,this.folders=g.folders}get folders(){return this._folders}set folders(g){this._folders=g,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(g){this._configuration=g}getFolder(g){return g&&this._foldersMap.findSubstr(g.with({scheme:g.scheme,authority:g.authority,path:g.path}))||null}updateFoldersMap(){this._foldersMap=I.TernarySearchTree.forUris(this._ignorePathCasing);for(const g of this.folders)this._foldersMap.set(g.uri,g)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=n;class R{constructor(g,s){this.raw=s,this.uri=g.uri,this.index=g.index,this.name=g.name}toResource(g){return(0,P.joinPath)(this.uri,g)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=R;function C(w){return new R({uri:w,index:0,name:(0,P.basenameOrAuthority)(w)},{uri:w.toString()})}e.toWorkspaceFolder=C}),define(ge[115],pe([0,1,4,157,59,2,9,8,25,132,54,11,75,30,114]),function(G,e,E,P,T,I,D,k,y,n,R,C,w,g,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const u=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,P.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function S($){return(typeof $=="string"?(0,k.extname)($):(0,y.extname)($))===u}e.hasWorkspaceFileExtension=S,e.IWorkspacesService=(0,E.createDecorator)("workspacesService");function v($){return $.hasOwnProperty("workspace")}e.isRecentWorkspace=v;function _($){return $.hasOwnProperty("folderUri")}e.isRecentFolder=_;function p($){return $.hasOwnProperty("fileUri")}e.isRecentFile=p;function c($){const F=$;return typeof(F==null?void 0:F.id)=="string"&&I.URI.isUri(F.uri)}e.isSingleFolderWorkspaceIdentifier=c;function l($){if($.configuration)return{id:$.id,configPath:$.configuration};if($.folders.length===1)return{id:$.id,uri:$.folders[0].uri}}e.toWorkspaceIdentifier=l;function t($){const F=$;return typeof(F==null?void 0:F.id)=="string"&&I.URI.isUri(F.configPath)}e.isWorkspaceIdentifier=t;function i($){const F=$;if(F==null?void 0:F.uri)return{id:F.id,uri:I.URI.revive(F.uri)};const N=$;if(N==null?void 0:N.configPath)return{id:N.id,configPath:I.URI.revive(N.configPath)};if($==null?void 0:$.id)return{id:$.id}}e.reviveIdentifier=i;function o($,F){return y.extUriBiasedIgnorePathCase.isEqualOrParent($,F.untitledWorkspacesHome)}e.isUntitledWorkspace=o;function r($){return a($)||h($)}e.isStoredWorkspaceFolder=r;function a($){const F=$;return typeof(F==null?void 0:F.path)=="string"&&(!F.name||typeof F.name=="string")}e.isRawFileWorkspaceFolder=a;function h($){const F=$;return typeof(F==null?void 0:F.uri)=="string"&&(!F.name||typeof F.name=="string")}e.isRawUriWorkspaceFolder=h;function m($,F,N,M,x=!D.isWindows,O){if($.scheme!==M.scheme)return{name:N,uri:$.toString(!0)};let V=F?void 0:O.relativePath(M,$);if(V!==void 0)V.length===0?V=".":D.isWindows&&$.scheme===C.Schemas.file&&!x&&(V=V.replace(/\//g,"\\"));else if($.scheme===C.Schemas.file)V=$.fsPath,D.isWindows&&(V=(0,w.normalizeDriveLetter)(V),x&&(V=(0,g.toSlashes)(V)));else{if(!O.isEqualAuthority($.authority,M.authority))return{name:N,uri:$.toString(!0)};V=$.path}return{name:N,path:V}}e.getStoredWorkspaceFolder=m;function b($,F,N){let M=[],x=new Set;const O=N.dirname(F);for(let V of $){let q=null;if(a(V))V.path&&(q=N.resolvePath(O,V.path));else if(h(V))try{q=I.URI.parse(V.uri),q.path[0]!=="/"&&(q=q.with({path:"/"+q.path}))}catch(X){console.warn(X)}if(q){let X=N.getComparisonKey(q);if(!x.has(X)){x.add(X);const me=V.name||N.basenameOrAuthority(q);M.push(new T.WorkspaceFolder({uri:q,name:me,index:M.length},V))}}}return M}e.toWorkspaceFolders=b;function f($,F,N,M,x){let O=d(F,$);const V=x.dirname(F),q=x.dirname(M),X=[],me=A(O.folders);for(const Fe of O.folders){const z=a(Fe)?x.resolvePath(V,Fe.path):I.URI.parse(Fe.uri);let Y;N?Y=!1:Y=!a(Fe)||(0,k.isAbsolute)(Fe.path),X.push(m(z,Y,Fe.name,q,me,x))}const we={insertSpaces:!1,tabSize:4,eol:D.isLinux||D.isMacintosh?`
`:`\r
`},Te=n.setProperty($,["folders"],X,we);let Pe=n.applyEdits($,Te);return O.remoteAuthority===(0,s.getRemoteAuthority)(M)&&(Pe=n.applyEdits(Pe,n.removeProperty(Pe,["remoteAuthority"],we))),Pe}e.rewriteWorkspaceFileForNewLocation=f;function d($,F){let N=R.parse(F);if(N&&Array.isArray(N.folders))N.folders=N.folders.filter(M=>r(M));else throw new Error(`${$} looks like an invalid workspace file.`);return N}function A($){return D.isWindows?$.some(F=>a(F)&&F.path.indexOf("/")>=0):!0}e.useSlashForPath=A;function L($){return $.workspace&&typeof $.workspace=="object"&&typeof $.workspace.id=="string"&&typeof $.workspace.configPath=="string"}function B($){return typeof $.folderUri=="string"}function J($){return typeof $.fileUri=="string"}function j($,F){const N={workspaces:[],files:[]};if($){const M=function(O,V){for(let q=0;q<O.length;q++)try{V(O[q],q)}catch(X){F.warn(`Error restoring recent entry ${JSON.stringify(O[q])}: ${X.toString()}. Skip entry.`)}},x=$;if(Array.isArray(x.entries))M(x.entries,O=>{const V=O.label,q=O.remoteAuthority;L(O)?N.workspaces.push({label:V,remoteAuthority:q,workspace:{id:O.workspace.id,configPath:I.URI.parse(O.workspace.configPath)}}):B(O)?N.workspaces.push({label:V,remoteAuthority:q,folderUri:I.URI.parse(O.folderUri)}):J(O)&&N.files.push({label:V,remoteAuthority:q,fileUri:I.URI.parse(O.fileUri)})});else{const O=$;Array.isArray(O.workspaces3)&&M(O.workspaces3,(V,q)=>{const X=Array.isArray(O.workspaceLabels)&&O.workspaceLabels[q]||void 0;typeof V=="object"&&typeof V.id=="string"&&typeof V.configURIPath=="string"?N.workspaces.push({label:X,workspace:{id:V.id,configPath:I.URI.parse(V.configURIPath)}}):typeof V=="string"&&N.workspaces.push({label:X,folderUri:I.URI.parse(V)})}),Array.isArray(O.files2)&&M(O.files2,(V,q)=>{const X=Array.isArray(O.fileLabels)&&O.fileLabels[q]||void 0;typeof V=="string"&&N.files.push({label:X,fileUri:I.URI.parse(V)})})}}return N}e.restoreRecentlyOpened=j;function U($){const F={entries:[]};for(const N of $.workspaces)_(N)?F.entries.push({folderUri:N.folderUri.toString(),label:N.label,remoteAuthority:N.remoteAuthority}):F.entries.push({workspace:{id:N.workspace.id,configPath:N.workspace.configPath.toString()},label:N.label,remoteAuthority:N.remoteAuthority});for(const N of $.files)F.entries.push({fileUri:N.fileUri.toString(),label:N.label,remoteAuthority:N.remoteAuthority});return F}e.toStoreData=U}),define(ge[116],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class E{constructor(T){this.id=T,this._data=new Map,this._idPool=1}add(T){const I=this._idPool++;return this._data.set(I,T),this.logDebugInfo(),I}get(T,I){return this._data.has(T)?this._data.get(T)[I]:void 0}delete(T){this._data.delete(T),this.logDebugInfo()}logDebugInfo(){!E.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=E,E.enableDebugLogging=!1}),define(ge[194],pe([0,1,2,3]),function(G,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=void 0;class T{constructor(){this._onDidChangeTabs=new P.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(D){this._tabs=D.map(k=>({name:k.name,group:k.group,resource:E.URI.revive(k.resource)})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=T}),define(ge[60],pe([0,1,11,4]),function(G,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class T{constructor(){this._systemSchemes=new Set(Object.keys(E.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(D,k){k===null?this._providerInfo.delete(D):this._providerInfo.set(D,k)}isFreeScheme(D){return!this._providerInfo.has(D)&&!this._systemSchemes.has(D)}getCapabilities(D){return this._providerInfo.get(D)}}e.ExtHostFileSystemInfo=T,e.IExtHostFileSystemInfo=(0,P.createDecorator)("IExtHostFileSystemInfo")}),define(ge[27],pe([0,1,4]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,E.createDecorator)("IExtHostInitDataService")}),define(ge[195],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class E{constructor(I,D,k){this._id=I,this._shared=D,this._storage=k,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(y=>(this._value=y,this)),this._storageListener=this._storage.onDidChangeStorage(y=>{y.shared===this._shared&&y.key===this._id&&(this._value=y.value)})}get whenReady(){return this._init}get(I,D){let k=this._value[I];return typeof k=="undefined"&&(k=D),k}update(I,D){return this._value[I]=D,this._storage.setValue(this._shared,this._id,this._value)}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=E;class P extends E{constructor(I,D){super(I.identifier.value,!0,D);this._extension=I}setKeysForSync(I){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},I)}}e.ExtensionGlobalMemento=P}),define(ge[13],pe([0,1,4]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,E.createDecorator)("IExtHostRpcService");class P{constructor(I){this.getProxy=I.getProxy.bind(I),this.set=I.set.bind(I),this.assertRegistered=I.assertRegistered.bind(I),this.drain=I.drain.bind(I)}}e.ExtHostRpcService=P});var tt=this&&this.__classPrivateFieldSet||function(G,e,E,P,T){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!T:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?T.call(G,E):T?T.value=E:e.set(G,E),E},He=this&&this.__classPrivateFieldGet||function(G,e,E,P){if(E==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!P:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?P:E==="a"?P.call(G):P?P.value:e.get(G)};define(ge[196],pe([0,1,29,3]),function(G,e,E,P){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class I{constructor(k,y){T.set(this,void 0),this._onDidChange=new P.Emitter,this.onDidChange=this._onDidChange.event,this._id=E.ExtensionIdentifier.toKey(k.identifier),tt(this,T,y,"f"),He(this,T,"f").onDidChangePassword(n=>{n.extensionId===this._id&&this._onDidChange.fire({key:n.key})})}get(k){return He(this,T,"f").get(this._id,k)}store(k,y){return He(this,T,"f").store(this._id,k,y)}delete(k){return He(this,T,"f").delete(this._id,k)}}e.ExtensionSecrets=I,T=new WeakMap}),define(ge[117],pe([0,1,4,3]),function(G,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class T{constructor(){this._onDidChangeTelemetryEnabled=new P.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(D){this._enabled=D}$onDidChangeTelemetryEnabled(D){this._enabled=D,this._onDidChangeTelemetryEnabled.fire(D)}}e.ExtHostTelemetry=T,e.IExtHostTelemetry=(0,E.createDecorator)("IExtHostTelemetry")}),define(ge[50],pe([0,1,4,3,13]),function(G,e,E,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var I;(function(k){function y(R){return{remoteAddress:R.remoteAddress,localAddress:R.localAddress,public:!!R.public}}k.fromApiTunnel=y;function n(R){return{remoteAddress:{host:R.tunnelRemoteHost,port:R.tunnelRemotePort},localAddress:R.localAddress,public:R.public}}k.fromServiceTunnel=n})(I=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,E.createDecorator)("IExtHostTunnelService");let D=class{constructor(y){this.onDidChangeTunnels=new P.Emitter().event}async $applyCandidateFilter(y){return y}async openTunnel(y,n){}async getTunnels(){return[]}async setTunnelExtensionFunctions(y){return{dispose:()=>{}}}registerPortsAttributesProvider(y,n){return{dispose:()=>{}}}async $providePortAttributes(y,n,R,C,w){return[]}async $forwardPort(y,n){}async $closeTunnel(y){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};D=je([Ue(0,T.IExtHostRpcService)],D),e.ExtHostTunnelService=D});var tt=this&&this.__classPrivateFieldSet||function(G,e,E,P,T){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!T:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?T.call(G,E):T?T.value=E:e.set(G,E),E},He=this&&this.__classPrivateFieldGet||function(G,e,E,P){if(E==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!P:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?P:E==="a"?P.call(G):P?P.value:e.get(G)};define(ge[7],pe([0,1,14,18,94,24,15,2,28,45,113]),function(G,e,E,P,T,I,D,k,y,n,R){"use strict";var C,w,g,s,u,S,v,_,p,c,l,t,i,o,r,a,h,m;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestItem=e.TestChildrenCollection=e.TestItemHookProperty=e.TestMessageSeverity=e.TestResultState=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookCellRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlineHint=e.InlineHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function b(H){function W(){return Reflect.construct(H,arguments,this.constructor)}return Object.defineProperty(W,"name",Object.getOwnPropertyDescriptor(H,"name")),Object.setPrototypeOf(W,H),Object.setPrototypeOf(W.prototype,H.prototype),W}let f=u=class{constructor(W){C.set(this,void 0),tt(this,C,W,"f")}static from(...W){let ne=W;return new u(function(){if(ne){for(const De of ne)De&&typeof De.dispose=="function"&&De.dispose();ne=void 0}})}dispose(){typeof He(this,C,"f")=="function"&&(He(this,C,"f").call(this),tt(this,C,void 0,"f"))}};C=new WeakMap,f=u=je([b],f),e.Disposable=f;let d=S=class{constructor(W,ne){if(W<0)throw(0,P.illegalArgument)("line must be non-negative");if(ne<0)throw(0,P.illegalArgument)("character must be non-negative");this._line=W,this._character=ne}static Min(...W){if(W.length===0)throw new TypeError;let ne=W[0];for(let De=1;De<W.length;De++){const ze=W[De];ze.isBefore(ne)&&(ne=ze)}return ne}static Max(...W){if(W.length===0)throw new TypeError;let ne=W[0];for(let De=1;De<W.length;De++){const ze=W[De];ze.isAfter(ne)&&(ne=ze)}return ne}static isPosition(W){if(!W)return!1;if(W instanceof S)return!0;let{line:ne,character:De}=W;return typeof ne=="number"&&typeof De=="number"}get line(){return this._line}get character(){return this._character}isBefore(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<W._character}isBeforeOrEqual(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<=W._character}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this._line===W._line&&this._character===W._character}compareTo(W){return this._line<W._line?-1:this._line>W.line?1:this._character<W._character?-1:this._character>W._character?1:0}translate(W,ne=0){if(W===null||ne===null)throw(0,P.illegalArgument)();let De;return typeof W=="undefined"?De=0:typeof W=="number"?De=W:(De=typeof W.lineDelta=="number"?W.lineDelta:0,ne=typeof W.characterDelta=="number"?W.characterDelta:0),De===0&&ne===0?this:new S(this.line+De,this.character+ne)}with(W,ne=this.character){if(W===null||ne===null)throw(0,P.illegalArgument)();let De;return typeof W=="undefined"?De=this.line:typeof W=="number"?De=W:(De=typeof W.line=="number"?W.line:this.line,ne=typeof W.character=="number"?W.character:this.character),De===this.line&&ne===this.character?this:new S(De,ne)}toJSON(){return{line:this.line,character:this.character}}};d=S=je([b],d),e.Position=d;let A=v=class{constructor(W,ne,De,ze){let Xe,lt;if(typeof W=="number"&&typeof ne=="number"&&typeof De=="number"&&typeof ze=="number"?(Xe=new d(W,ne),lt=new d(De,ze)):W instanceof d&&ne instanceof d&&(Xe=W,lt=ne),!Xe||!lt)throw new Error("Invalid arguments");Xe.isBefore(lt)?(this._start=Xe,this._end=lt):(this._start=lt,this._end=Xe)}static isRange(W){return W instanceof v?!0:W?d.isPosition(W.start)&&d.isPosition(W.end):!1}get start(){return this._start}get end(){return this._end}contains(W){return W instanceof v?this.contains(W._start)&&this.contains(W._end):W instanceof d?!(W.isBefore(this._start)||this._end.isBefore(W)):!1}isEqual(W){return this._start.isEqual(W._start)&&this._end.isEqual(W._end)}intersection(W){const ne=d.Max(W.start,this._start),De=d.Min(W.end,this._end);if(!ne.isAfter(De))return new v(ne,De)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const ne=d.Min(W.start,this._start),De=d.Max(W.end,this.end);return new v(ne,De)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(W,ne=this.end){if(W===null||ne===null)throw(0,P.illegalArgument)();let De;return W?d.isPosition(W)?De=W:(De=W.start||this.start,ne=W.end||this.end):De=this.start,De.isEqual(this._start)&&ne.isEqual(this.end)?this:new v(De,ne)}toJSON(){return[this.start,this.end]}};A=v=je([b],A),e.Range=A;let L=_=class extends A{constructor(W,ne,De,ze){let Xe,lt;if(typeof W=="number"&&typeof ne=="number"&&typeof De=="number"&&typeof ze=="number"?(Xe=new d(W,ne),lt=new d(De,ze)):W instanceof d&&ne instanceof d&&(Xe=W,lt=ne),!Xe||!lt)throw new Error("Invalid arguments");super(Xe,lt);this._anchor=Xe,this._active=lt}static isSelection(W){return W instanceof _?!0:W?A.isRange(W)&&d.isPosition(W.anchor)&&d.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};L=_=je([b],L),e.Selection=L;class B{constructor(W,ne,De){if(typeof W!="string"||W.length===0)throw(0,P.illegalArgument)("host");if(typeof ne!="number"||ne===0||Math.round(ne)!==ne)throw(0,P.illegalArgument)("port");if(typeof De!="undefined"&&(typeof De!="string"||De.length===0||!/^[0-9A-Za-z\-]+$/.test(De)))throw(0,P.illegalArgument)("connectionToken");this.host=W,this.port=Math.round(ne),this.connectionToken=De}}e.ResolvedAuthority=B;class J extends Error{constructor(W,ne=R.RemoteAuthorityResolverErrorCode.Unknown,De){super(W);this._message=W,this._code=ne,this._detail=De,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,J.prototype)}static NotAvailable(W,ne){return new J(W,R.RemoteAuthorityResolverErrorCode.NotAvailable,ne)}static TemporarilyNotAvailable(W){return new J(W,R.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=J;var j;(function(H){H[H.LF=1]="LF",H[H.CRLF=2]="CRLF"})(j=e.EndOfLine||(e.EndOfLine={}));var U;(function(H){H[H.Replace=1]="Replace",H[H.Append=2]="Append",H[H.Prepend=3]="Prepend"})(U=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let $=p=class{constructor(W,ne){this._range=W,this._newText=ne}static isTextEdit(W){return W instanceof p?!0:W?A.isRange(W)&&typeof W.newText=="string":!1}static replace(W,ne){return new p(W,ne)}static insert(W,ne){return p.replace(new A(W,W),ne)}static delete(W){return p.replace(W,"")}static setEndOfLine(W){const ne=new p(new A(new d(0,0),new d(0,0)),"");return ne.newEol=W,ne}get range(){return this._range}set range(W){if(W&&!A.isRange(W))throw(0,P.illegalArgument)("range");this._range=W}get newText(){return this._newText||""}set newText(W){if(W&&typeof W!="string")throw(0,P.illegalArgument)("newText");this._newText=W}get newEol(){return this._newEol}set newEol(W){if(W&&typeof W!="number")throw(0,P.illegalArgument)("newEol");this._newEol=W}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};$=p=je([b],$),e.TextEdit=$;var F;(function(H){H[H.File=1]="File",H[H.Text=2]="Text",H[H.Cell=3]="Cell",H[H.CellOutput=4]="CellOutput",H[H.CellReplace=5]="CellReplace",H[H.CellOutputItem=6]="CellOutputItem"})(F=e.FileEditType||(e.FileEditType={}));let N=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(W,ne,De,ze){this._edits.push({_type:1,from:W,to:ne,options:De,metadata:ze})}createFile(W,ne,De){this._edits.push({_type:1,from:void 0,to:W,options:ne,metadata:De})}deleteFile(W,ne,De){this._edits.push({_type:1,from:W,to:void 0,options:ne,metadata:De})}replaceNotebookMetadata(W,ne,De){this._edits.push({_type:3,metadata:De,uri:W,edit:{editType:5,metadata:ne},notebookMetadata:ne})}replaceNotebookCells(W,ne,De,ze,Xe){(ne!==De||ze.length>0)&&this._edits.push({_type:5,uri:W,index:ne,count:De-ne,cells:ze,metadata:Xe})}replaceNotebookCellOutput(W,ne,De,ze){this._editNotebookCellOutput(W,ne,!1,De,ze)}appendNotebookCellOutput(W,ne,De,ze){this._editNotebookCellOutput(W,ne,!0,De,ze)}replaceNotebookCellOutputItems(W,ne,De,ze,Xe){this._editNotebookCellOutputItems(W,ne,De,!1,ze,Xe)}appendNotebookCellOutputItems(W,ne,De,ze,Xe){this._editNotebookCellOutputItems(W,ne,De,!0,ze,Xe)}_editNotebookCellOutputItems(W,ne,De,ze,Xe,lt){this._edits.push({_type:6,metadata:lt,uri:W,index:ne,outputId:De,append:ze,newOutputItems:Xe})}_editNotebookCellOutput(W,ne,De,ze,Xe){this._edits.push({_type:4,metadata:Xe,uri:W,index:ne,append:De,newOutputs:ze,newMetadata:void 0})}replaceNotebookCellMetadata(W,ne,De,ze){this._edits.push({_type:3,metadata:ze,uri:W,edit:{editType:11,index:ne,metadata:De}})}replace(W,ne,De,ze){this._edits.push({_type:2,uri:W,edit:new $(ne,De),metadata:ze})}insert(W,ne,De,ze){this.replace(W,new A(ne,ne),De,ze)}delete(W,ne,De){this.replace(W,ne,"",De)}has(W){return this._edits.some(ne=>ne._type===2&&ne.uri.toString()===W.toString())}set(W,ne){if(ne)for(const De of ne)De&&this._edits.push({_type:2,uri:W,edit:De});else{for(let De=0;De<this._edits.length;De++){const ze=this._edits[De];ze._type===2&&ze.uri.toString()===W.toString()&&(this._edits[De]=void 0)}(0,E.coalesceInPlace)(this._edits)}}get(W){const ne=[];for(let De of this._edits)De._type===2&&De.uri.toString()===W.toString()&&ne.push(De.edit);return ne}entries(){const W=new I.ResourceMap;for(let ne of this._edits)if(ne._type===2){let De=W.get(ne.uri);De||(De=[ne.uri,[]],W.set(ne.uri,De)),De[1].push(ne.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};N=je([b],N),e.WorkspaceEdit=N;let M=c=class{constructor(W){this._tabstop=1,this.value=W||""}static isSnippetString(W){return W instanceof c?!0:W?typeof W.value=="string":!1}static _escape(W){return W.replace(/\$|}|\\/g,"\\$&")}appendText(W){return this.value+=c._escape(W),this}appendTabstop(W=this._tabstop++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,ne=this._tabstop++){if(typeof W=="function"){const De=new c;De._tabstop=this._tabstop,W(De),this._tabstop=De._tabstop,W=De.value}else W=c._escape(W);return this.value+="${",this.value+=ne,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,ne=this._tabstop++){const De=W.map(ze=>ze.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ne,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable(W,ne){if(typeof ne=="function"){const De=new c;De._tabstop=this._tabstop,ne(De),this._tabstop=De._tabstop,ne=De.value}else typeof ne=="string"&&(ne=ne.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,ne&&(this.value+=":",this.value+=ne),this.value+="}",this}};M=c=je([b],M),e.SnippetString=M;var x;(function(H){H[H.Unnecessary=1]="Unnecessary",H[H.Deprecated=2]="Deprecated"})(x=e.DiagnosticTag||(e.DiagnosticTag={}));var O;(function(H){H[H.Hint=3]="Hint",H[H.Information=2]="Information",H[H.Warning=1]="Warning",H[H.Error=0]="Error"})(O=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let V=l=class{constructor(W,ne){if(this.uri=W,ne)if(ne instanceof A)this.range=ne;else if(ne instanceof d)this.range=new A(ne,ne);else throw new Error("Illegal argument")}static isLocation(W){return W instanceof l?!0:W?A.isRange(W.range)&&k.URI.isUri(W.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};V=l=je([b],V),e.Location=V;let q=class{constructor(W,ne){this.location=W,this.message=ne}static is(W){return W?typeof W.message=="string"&&W.location&&A.isRange(W.location.range)&&k.URI.isUri(W.location.uri):!1}static isEqual(W,ne){return W===ne?!0:!W||!ne?!1:W.message===ne.message&&W.location.range.isEqual(ne.location.range)&&W.location.uri.toString()===ne.location.uri.toString()}};q=je([b],q),e.DiagnosticRelatedInformation=q;let X=class{constructor(W,ne,De=O.Error){if(!A.isRange(W))throw new TypeError("range must be set");if(!ne)throw new TypeError("message must be set");this.range=W,this.message=ne,this.severity=De}toJSON(){return{severity:O[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,ne){return W===ne?!0:!W||!ne?!1:W.message===ne.message&&W.severity===ne.severity&&W.code===ne.code&&W.severity===ne.severity&&W.source===ne.source&&W.range.isEqual(ne.range)&&(0,E.equals)(W.tags,ne.tags)&&(0,E.equals)(W.relatedInformation,ne.relatedInformation,q.isEqual)}};X=je([b],X),e.Diagnostic=X;let me=class{constructor(W,ne){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:(0,T.isMarkdownString)(W)?this.contents=[W]:this.contents=[W],this.range=ne}};me=je([b],me),e.Hover=me;var we;(function(H){H[H.Text=0]="Text",H[H.Read=1]="Read",H[H.Write=2]="Write"})(we=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Te=class{constructor(W,ne=we.Text){this.range=W,this.kind=ne}toJSON(){return{range:this.range,kind:we[this.kind]}}};Te=je([b],Te),e.DocumentHighlight=Te;var Pe;(function(H){H[H.File=0]="File",H[H.Module=1]="Module",H[H.Namespace=2]="Namespace",H[H.Package=3]="Package",H[H.Class=4]="Class",H[H.Method=5]="Method",H[H.Property=6]="Property",H[H.Field=7]="Field",H[H.Constructor=8]="Constructor",H[H.Enum=9]="Enum",H[H.Interface=10]="Interface",H[H.Function=11]="Function",H[H.Variable=12]="Variable",H[H.Constant=13]="Constant",H[H.String=14]="String",H[H.Number=15]="Number",H[H.Boolean=16]="Boolean",H[H.Array=17]="Array",H[H.Object=18]="Object",H[H.Key=19]="Key",H[H.Null=20]="Null",H[H.EnumMember=21]="EnumMember",H[H.Struct=22]="Struct",H[H.Event=23]="Event",H[H.Operator=24]="Operator",H[H.TypeParameter=25]="TypeParameter"})(Pe=e.SymbolKind||(e.SymbolKind={}));var Fe;(function(H){H[H.Deprecated=1]="Deprecated"})(Fe=e.SymbolTag||(e.SymbolTag={}));let z=t=class{constructor(W,ne,De,ze,Xe){this.name=W,this.kind=ne,this.containerName=Xe,typeof De=="string"&&(this.containerName=De),ze instanceof V?this.location=ze:De instanceof A&&(this.location=new V(ze,De)),t.validate(this)}static validate(W){if(!W.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Pe[this.kind],location:this.location,containerName:this.containerName}}};z=t=je([b],z),e.SymbolInformation=z;let Y=i=class{constructor(W,ne,De,ze,Xe){this.name=W,this.detail=ne,this.kind=De,this.range=ze,this.selectionRange=Xe,this.children=[],i.validate(this)}static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children&&W.children.forEach(i.validate)}};Y=i=je([b],Y),e.DocumentSymbol=Y;var te;(function(H){H[H.Invoke=1]="Invoke",H[H.Automatic=2]="Automatic"})(te=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ae=class{constructor(W,ne){this.title=W,this.kind=ne}};ae=je([b],ae),e.CodeAction=ae;let he=o=class{constructor(W){this.value=W}append(W){return new o(this.value?this.value+o.sep+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+o.sep)}};he.sep=".",he=o=je([b],he),e.CodeActionKind=he,he.Empty=new he(""),he.QuickFix=he.Empty.append("quickfix"),he.Refactor=he.Empty.append("refactor"),he.RefactorExtract=he.Refactor.append("extract"),he.RefactorInline=he.Refactor.append("inline"),he.RefactorRewrite=he.Refactor.append("rewrite"),he.Source=he.Empty.append("source"),he.SourceOrganizeImports=he.Source.append("organizeImports"),he.SourceFixAll=he.Source.append("fixAll");let Ce=class{constructor(W,ne){if(this.range=W,this.parent=ne,ne&&!ne.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Ce=je([b],Ce),e.SelectionRange=Ce;class Oe{constructor(W,ne,De,ze,Xe,lt){this.kind=W,this.name=ne,this.detail=De,this.uri=ze,this.range=Xe,this.selectionRange=lt}}e.CallHierarchyItem=Oe;class be{constructor(W,ne){this.fromRanges=ne,this.from=W}}e.CallHierarchyIncomingCall=be;class ke{constructor(W,ne){this.fromRanges=ne,this.to=W}}e.CallHierarchyOutgoingCall=ke;let Re=class{constructor(W,ne){this.range=W,this.command=ne}get isResolved(){return!!this.command}};Re=je([b],Re),e.CodeLens=Re;let Be=r=class{constructor(W,ne=!1){w.set(this,void 0),tt(this,w,new T.MarkdownString(W,{supportThemeIcons:ne}),"f")}static isMarkdownString(W){return W instanceof r?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}get value(){return He(this,w,"f").value}set value(W){He(this,w,"f").value=W}get isTrusted(){return He(this,w,"f").isTrusted}set isTrusted(W){He(this,w,"f").isTrusted=W}get supportThemeIcons(){return He(this,w,"f").supportThemeIcons}appendText(W){return He(this,w,"f").appendText(W),this}appendMarkdown(W){return He(this,w,"f").appendMarkdown(W),this}appendCodeblock(W,ne){return He(this,w,"f").appendCodeblock(ne!=null?ne:"",W),this}};w=new WeakMap,Be=r=je([b],Be),e.MarkdownString=Be;let Se=class{constructor(W,ne){this.label=W,this.documentation=ne}};Se=je([b],Se),e.ParameterInformation=Se;let Ke=class{constructor(W,ne){this.label=W,this.documentation=ne,this.parameters=[]}};Ke=je([b],Ke),e.SignatureInformation=Ke;let Q=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Q=je([b],Q),e.SignatureHelp=Q;var se;(function(H){H[H.Invoke=1]="Invoke",H[H.TriggerCharacter=2]="TriggerCharacter",H[H.ContentChange=3]="ContentChange"})(se=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var _e;(function(H){H[H.Other=0]="Other",H[H.Type=1]="Type",H[H.Parameter=2]="Parameter"})(_e=e.InlineHintKind||(e.InlineHintKind={}));let xe=class{constructor(W,ne,De){this.text=W,this.range=ne,this.kind=De}};xe=je([b],xe),e.InlineHint=xe;var Ve;(function(H){H[H.Invoke=0]="Invoke",H[H.TriggerCharacter=1]="TriggerCharacter",H[H.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ve=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var $e;(function(H){H[H.Text=0]="Text",H[H.Method=1]="Method",H[H.Function=2]="Function",H[H.Constructor=3]="Constructor",H[H.Field=4]="Field",H[H.Variable=5]="Variable",H[H.Class=6]="Class",H[H.Interface=7]="Interface",H[H.Module=8]="Module",H[H.Property=9]="Property",H[H.Unit=10]="Unit",H[H.Value=11]="Value",H[H.Enum=12]="Enum",H[H.Keyword=13]="Keyword",H[H.Snippet=14]="Snippet",H[H.Color=15]="Color",H[H.File=16]="File",H[H.Reference=17]="Reference",H[H.Folder=18]="Folder",H[H.EnumMember=19]="EnumMember",H[H.Constant=20]="Constant",H[H.Struct=21]="Struct",H[H.Event=22]="Event",H[H.Operator=23]="Operator",H[H.TypeParameter=24]="TypeParameter",H[H.User=25]="User",H[H.Issue=26]="Issue"})($e=e.CompletionItemKind||(e.CompletionItemKind={}));var Ze;(function(H){H[H.Deprecated=1]="Deprecated"})(Ze=e.CompletionItemTag||(e.CompletionItemTag={}));let K=class{constructor(W,ne){this.label=W,this.kind=ne}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&$e[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};K=je([b],K),e.CompletionItem=K;let oe=class{constructor(W=[],ne=!1){this.items=W,this.isIncomplete=ne}};oe=je([b],oe),e.CompletionList=oe;var de;(function(H){H[H.Active=-1]="Active",H[H.Beside=-2]="Beside",H[H.One=1]="One",H[H.Two=2]="Two",H[H.Three=3]="Three",H[H.Four=4]="Four",H[H.Five=5]="Five",H[H.Six=6]="Six",H[H.Seven=7]="Seven",H[H.Eight=8]="Eight",H[H.Nine=9]="Nine"})(de=e.ViewColumn||(e.ViewColumn={}));var Z;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(Z=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ie;(function(H){H[H.Off=0]="Off",H[H.On=1]="On",H[H.Relative=2]="Relative"})(ie=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var le;(function(H){H[H.Manual=1]="Manual",H[H.AfterDelay=2]="AfterDelay",H[H.FocusOut=3]="FocusOut"})(le=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ve;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(ve=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ye;(function(H){H[H.Keyboard=1]="Keyboard",H[H.Mouse=2]="Mouse",H[H.Command=3]="Command"})(ye=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var We;(function(H){H[H.OpenOpen=0]="OpenOpen",H[H.ClosedClosed=1]="ClosedClosed",H[H.OpenClosed=2]="OpenClosed",H[H.ClosedOpen=3]="ClosedOpen"})(We=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(H){function W(ne){switch(ne){case"keyboard":return H.Keyboard;case"mouse":return H.Mouse;case"api":return H.Command}}H.fromValue=W}(ye=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ne=class{constructor(W,ne){if(ne&&!k.URI.isUri(ne))throw(0,P.illegalArgument)("target");if(!A.isRange(W)||W.isEmpty)throw(0,P.illegalArgument)("range");this.range=W,this.target=ne}};Ne=je([b],Ne),e.DocumentLink=Ne;let qe=class{constructor(W,ne,De,ze){this.red=W,this.green=ne,this.blue=De,this.alpha=ze}};qe=je([b],qe),e.Color=qe;let Je=class{constructor(W,ne){if(ne&&!(ne instanceof qe))throw(0,P.illegalArgument)("color");if(!A.isRange(W)||W.isEmpty)throw(0,P.illegalArgument)("range");this.range=W,this.color=ne}};Je=je([b],Je),e.ColorInformation=Je;let et=class{constructor(W){if(!W||typeof W!="string")throw(0,P.illegalArgument)("label");this.label=W}};et=je([b],et),e.ColorPresentation=et;var nt;(function(H){H[H.RGB=0]="RGB",H[H.HEX=1]="HEX",H[H.HSL=2]="HSL"})(nt=e.ColorFormat||(e.ColorFormat={}));var st;(function(H){H[H.Error=0]="Error",H[H.Warning=1]="Warning",H[H.Information=2]="Information"})(st=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var it;(function(H){H[H.Always=1]="Always",H[H.Silent=2]="Silent",H[H.Never=3]="Never"})(it=e.TaskRevealKind||(e.TaskRevealKind={}));var Ee;(function(H){H[H.Shared=1]="Shared",H[H.Dedicated=2]="Dedicated",H[H.New=3]="New"})(Ee=e.TaskPanelKind||(e.TaskPanelKind={}));let fe=a=class{constructor(W,ne){if(typeof W!="string"||typeof ne!="string")throw(0,P.illegalArgument)("name");this._id=W}static from(W){switch(W){case"clean":return a.Clean;case"build":return a.Build;case"rebuild":return a.Rebuild;case"test":return a.Test;default:return}}get id(){return this._id}};fe.Clean=new a("clean","Clean"),fe.Build=new a("build","Build"),fe.Rebuild=new a("rebuild","Rebuild"),fe.Test=new a("test","Test"),fe=a=je([b],fe),e.TaskGroup=fe;function ce(H){let W="";for(let ne=0;ne<H.length;ne++)W+=H[ne].replace(/,/g,",,")+",";return W}let ee=class{constructor(W,ne,De){if(typeof W!="string")throw(0,P.illegalArgument)("process");this._args=[],this._process=W,ne!==void 0&&(Array.isArray(ne)?(this._args=ne,this._options=De):this._options=ne)}get process(){return this._process}set process(W){if(typeof W!="string")throw(0,P.illegalArgument)("process");this._process=W}get args(){return this._args}set args(W){Array.isArray(W)||(W=[]),this._args=W}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("process"),this._process!==void 0&&W.push(this._process),this._args&&this._args.length>0)for(let ne of this._args)W.push(ne);return ce(W)}};ee=je([b],ee),e.ProcessExecution=ee;let Ae=class{constructor(W,ne,De){if(this._args=[],Array.isArray(ne)){if(!W)throw(0,P.illegalArgument)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,P.illegalArgument)("command");this._command=W,this._args=ne,this._options=De}else{if(typeof W!="string")throw(0,P.illegalArgument)("commandLine");this._commandLine=W,this._options=ne}}get commandLine(){return this._commandLine}set commandLine(W){if(typeof W!="string")throw(0,P.illegalArgument)("commandLine");this._commandLine=W}get command(){return this._command?this._command:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,P.illegalArgument)("command");this._command=W}get args(){return this._args}set args(W){this._args=W||[]}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("shell"),this._commandLine!==void 0&&W.push(this._commandLine),this._command!==void 0&&W.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ne of this._args)W.push(typeof ne=="string"?ne:ne.value);return ce(W)}};Ae=je([b],Ae),e.ShellExecution=Ae;var Le;(function(H){H[H.Escape=1]="Escape",H[H.Strong=2]="Strong",H[H.Weak=3]="Weak"})(Le=e.ShellQuoting||(e.ShellQuoting={}));var Qe;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace"})(Qe=e.TaskScope||(e.TaskScope={}));class Ge{constructor(W){this._callback=W}computeId(){return"customExecution"+(0,y.generateUuid)()}set callback(W){this._callback=W}get callback(){return this._callback}}e.CustomExecution=Ge;let rt=h=class{constructor(W,ne,De,ze,Xe,lt){this.__deprecated=!1,this._definition=this.definition=W;let ht;typeof ne=="string"?(this._name=this.name=ne,this._source=this.source=De,this.execution=ze,ht=Xe,this.__deprecated=!0):ne===Qe.Global||ne===Qe.Workspace?(this.target=ne,this._name=this.name=De,this._source=this.source=ze,this.execution=Xe,ht=lt):(this.target=ne,this._name=this.name=De,this._source=this.source=ze,this.execution=Xe,ht=lt),typeof ht=="string"?(this._problemMatchers=[ht],this._hasDefinedMatchers=!0):Array.isArray(ht)?(this._problemMatchers=ht,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(W){this.__id=W}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof ee?this._definition={type:h.ProcessType,id:this._execution.computeId()}:this._execution instanceof Ae?this._definition={type:h.ShellType,id:this._execution.computeId()}:this._execution instanceof Ge?this._definition={type:h.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:h.EmptyType,id:(0,y.generateUuid)()}}get definition(){return this._definition}set definition(W){if(W==null)throw(0,P.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=W}get scope(){return this._scope}set target(W){this.clear(),this._scope=W}get name(){return this._name}set name(W){if(typeof W!="string")throw(0,P.illegalArgument)("name");this.clear(),this._name=W}get execution(){return this._execution}set execution(W){W===null&&(W=void 0),this.clear(),this._execution=W;const ne=this._definition.type;(h.EmptyType===ne||h.ProcessType===ne||h.ShellType===ne||h.ExtensionCallbackType===ne)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(W){if(Array.isArray(W))this.clear(),this._problemMatchers=W,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.clear(),this._isBackground=W}get source(){return this._source}set source(W){if(typeof W!="string"||W.length===0)throw(0,P.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=W}get group(){return this._group}set group(W){W===null&&(W=void 0),this.clear(),this._group=W}get detail(){return this._detail}set detail(W){W===null&&(W=void 0),this._detail=W}get presentationOptions(){return this._presentationOptions}set presentationOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._presentationOptions=W}get runOptions(){return this._runOptions}set runOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._runOptions=W}};rt.ExtensionCallbackType="customExecution",rt.ProcessType="process",rt.ShellType="shell",rt.EmptyType="$empty",rt=h=je([b],rt),e.Task=rt;var ut;(function(H){H[H.SourceControl=1]="SourceControl",H[H.Window=10]="Window",H[H.Notification=15]="Notification"})(ut=e.ProgressLocation||(e.ProgressLocation={}));let Ye=class{constructor(W,ne=at.None){this.collapsibleState=ne,k.URI.isUri(W)?this.resourceUri=W:this.label=W}};Ye=je([b],Ye),e.TreeItem=Ye;var at;(function(H){H[H.None=0]="None",H[H.Collapsed=1]="Collapsed",H[H.Expanded=2]="Expanded"})(at=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let ct=class{constructor(W,ne){this.id=W,this.color=ne}};ct=je([b],ct),e.ThemeIcon=ct,ct.File=new ct("file"),ct.Folder=new ct("folder");let ot=class{constructor(W){this.id=W}};ot=je([b],ot),e.ThemeColor=ot;var yt;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace",H[H.WorkspaceFolder=3]="WorkspaceFolder"})(yt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let gt=class{constructor(W,ne){if(typeof W!="string"&&(!W||!k.URI.isUri(W)&&!k.URI.isUri(W.uri)))throw(0,P.illegalArgument)("base");if(typeof ne!="string")throw(0,P.illegalArgument)("pattern");typeof W=="string"?(this.baseFolder=k.URI.file(W),this.base=W):k.URI.isUri(W)?(this.baseFolder=W,this.base=W.fsPath):(this.baseFolder=W.uri,this.base=W.uri.fsPath),this.pattern=ne}};gt=je([b],gt),e.RelativePattern=gt;let wt=class{constructor(W,ne,De,ze){this.enabled=typeof W=="boolean"?W:!0,typeof ne=="string"&&(this.condition=ne),typeof De=="string"&&(this.hitCondition=De),typeof ze=="string"&&(this.logMessage=ze)}get id(){return this._id||(this._id=(0,y.generateUuid)()),this._id}};wt=je([b],wt),e.Breakpoint=wt;let bt=class extends wt{constructor(W,ne,De,ze,Xe){super(ne,De,ze,Xe);if(W===null)throw(0,P.illegalArgument)("location");this.location=W}};bt=je([b],bt),e.SourceBreakpoint=bt;let Et=class extends wt{constructor(W,ne,De,ze,Xe){super(ne,De,ze,Xe);this.functionName=W}};Et=je([b],Et),e.FunctionBreakpoint=Et;let vt=class extends wt{constructor(W,ne,De,ze,Xe,lt,ht){super(ze,Xe,lt,ht);if(!ne)throw(0,P.illegalArgument)("dataId");this.label=W,this.dataId=ne,this.canPersist=De}};vt=je([b],vt),e.DataBreakpoint=vt;let Mt=class{constructor(W,ne,De){this.command=W,this.args=ne||[],this.options=De}};Mt=je([b],Mt),e.DebugAdapterExecutable=Mt;let Tt=class{constructor(W,ne){this.port=W,this.host=ne}};Tt=je([b],Tt),e.DebugAdapterServer=Tt;let ft=class{constructor(W){this.path=W}};ft=je([b],ft),e.DebugAdapterNamedPipeServer=ft;let qt=class{constructor(W){this.implementation=W}};qt=je([b],qt),e.DebugAdapterInlineImplementation=qt;let _t=class{constructor(W,ne){this.range=W,this.expression=ne}};_t=je([b],_t),e.EvaluatableExpression=_t;let Ht=class{constructor(W,ne){this.range=W,this.text=ne}};Ht=je([b],Ht),e.InlineValueText=Ht;let Kt=class{constructor(W,ne,De=!0){this.range=W,this.variableName=ne,this.caseSensitiveLookup=De}};Kt=je([b],Kt),e.InlineValueVariableLookup=Kt;let Ot=class{constructor(W,ne){this.range=W,this.expression=ne}};Ot=je([b],Ot),e.InlineValueEvaluatableExpression=Ot;let dt=class{constructor(W,ne){this.frameId=W,this.stoppedLocation=ne}};dt=je([b],dt),e.InlineValueContext=dt;var mn;(function(H){H[H.Changed=1]="Changed",H[H.Created=2]="Created",H[H.Deleted=3]="Deleted"})(mn=e.FileChangeType||(e.FileChangeType={}));let kt=m=class extends Error{constructor(W,ne=n.FileSystemProviderErrorCode.Unknown,De){var ze;super(k.URI.isUri(W)?W.toString(!0):W);this.code=(ze=De==null?void 0:De.name)!==null&&ze!==void 0?ze:"Unknown",(0,n.markAsFileSystemProviderError)(this,ne),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,m.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}static FileExists(W){return new m(W,n.FileSystemProviderErrorCode.FileExists,m.FileExists)}static FileNotFound(W){return new m(W,n.FileSystemProviderErrorCode.FileNotFound,m.FileNotFound)}static FileNotADirectory(W){return new m(W,n.FileSystemProviderErrorCode.FileNotADirectory,m.FileNotADirectory)}static FileIsADirectory(W){return new m(W,n.FileSystemProviderErrorCode.FileIsADirectory,m.FileIsADirectory)}static NoPermissions(W){return new m(W,n.FileSystemProviderErrorCode.NoPermissions,m.NoPermissions)}static Unavailable(W){return new m(W,n.FileSystemProviderErrorCode.Unavailable,m.Unavailable)}};kt=m=je([b],kt),e.FileSystemError=kt;let Rt=class{constructor(W,ne,De){this.start=W,this.end=ne,this.kind=De}};Rt=je([b],Rt),e.FoldingRange=Rt;var sn;(function(H){H[H.Comment=1]="Comment",H[H.Imports=2]="Imports",H[H.Region=3]="Region"})(sn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var gn;(function(H){H[H.Collapsed=0]="Collapsed",H[H.Expanded=1]="Expanded"})(gn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var on;(function(H){H[H.Editing=0]="Editing",H[H.Preview=1]="Preview"})(on=e.CommentMode||(e.CommentMode={}));class pn{constructor(W,ne=[]){this.tokenTypes=W,this.tokenModifiers=ne}}e.SemanticTokensLegend=pn;function an(H){return typeof H=="undefined"||(0,D.isStringArray)(H)}class It{constructor(W){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,W){this._hasLegend=!0;for(let ne=0,De=W.tokenTypes.length;ne<De;ne++)this._tokenTypeStrToInt.set(W.tokenTypes[ne],ne);for(let ne=0,De=W.tokenModifiers.length;ne<De;ne++)this._tokenModifierStrToInt.set(W.tokenModifiers[ne],ne)}}push(W,ne,De,ze,Xe){if(typeof W=="number"&&typeof ne=="number"&&typeof De=="number"&&typeof ze=="number"&&(typeof Xe=="number"||typeof Xe=="undefined"))return typeof Xe=="undefined"&&(Xe=0),this._pushEncoded(W,ne,De,ze,Xe);if(A.isRange(W)&&typeof ne=="string"&&an(De))return this._push(W,ne,De);throw(0,P.illegalArgument)()}_push(W,ne,De){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ne))throw new Error("`tokenType` is not in the provided legend");const ze=W.start.line,Xe=W.start.character,lt=W.end.character-W.start.character,ht=this._tokenTypeStrToInt.get(ne);let St=0;if(De)for(const Ct of De){if(!this._tokenModifierStrToInt.has(Ct))throw new Error("`tokenModifier` is not in the provided legend");const Pt=this._tokenModifierStrToInt.get(Ct);St|=1<<Pt>>>0}this._pushEncoded(ze,Xe,lt,ht,St)}_pushEncoded(W,ne,De,ze,Xe){if(this._dataIsSortedAndDeltaEncoded&&(W<this._prevLine||W===this._prevLine&&ne<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const St=this._data.length/5|0;let Ct=0,Pt=0;for(let At=0;At<St;At++){let Lt=this._data[5*At],tn=this._data[5*At+1];Lt===0?(Lt=Ct,tn+=Pt):Lt+=Ct,this._data[5*At]=Lt,this._data[5*At+1]=tn,Ct=Lt,Pt=tn}}let lt=W,ht=ne;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(lt-=this._prevLine,lt===0&&(ht-=this._prevChar)),this._data[this._dataLen++]=lt,this._data[this._dataLen++]=ht,this._data[this._dataLen++]=De,this._data[this._dataLen++]=ze,this._data[this._dataLen++]=Xe,this._prevLine=W,this._prevChar=ne}static _sortAndDeltaEncode(W){let ne=[];const De=W.length/5|0;for(let ht=0;ht<De;ht++)ne[ht]=ht;ne.sort((ht,St)=>{const Ct=W[5*ht],Pt=W[5*St];if(Ct===Pt){const At=W[5*ht+1],Lt=W[5*St+1];return At-Lt}return Ct-Pt});const ze=new Uint32Array(W.length);let Xe=0,lt=0;for(let ht=0;ht<De;ht++){const St=5*ne[ht],Ct=W[St+0],Pt=W[St+1],At=W[St+2],Lt=W[St+3],tn=W[St+4],Tn=Ct-Xe,On=Tn===0?Pt-lt:Pt,nn=5*ht;ze[nn+0]=Tn,ze[nn+1]=On,ze[nn+2]=At,ze[nn+3]=Lt,ze[nn+4]=tn,Xe=Ct,lt=Pt}return ze}build(W){return this._dataIsSortedAndDeltaEncoded?new Gt(new Uint32Array(this._data),W):new Gt(It._sortAndDeltaEncode(this._data),W)}}e.SemanticTokensBuilder=It;class Gt{constructor(W,ne){this.resultId=ne,this.data=W}}e.SemanticTokens=Gt;class Qt{constructor(W,ne,De){this.start=W,this.deleteCount=ne,this.data=De}}e.SemanticTokensEdit=Qt;class Xt{constructor(W,ne){this.resultId=ne,this.edits=W}}e.SemanticTokensEdits=Xt;var vn;(function(H){H[H.Separate=0]="Separate",H[H.MergeWithParent=1]="MergeWithParent"})(vn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var wn;(function(H){H[H.Initial=1]="Initial",H[H.Dynamic=2]="Dynamic"})(wn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Dt=class{constructor(){}};Dt.Back={iconPath:new ct("arrow-left")},Dt=je([b],Dt),e.QuickInputButtons=Dt;var bn;(function(H){H[H.UI=1]="UI",H[H.Workspace=2]="Workspace"})(bn=e.ExtensionKind||(e.ExtensionKind={}));class _n{constructor(W,ne,De){this.badge=W,this.tooltip=ne,this.color=De}static validate(W){if(W.badge&&W.badge.length!==1&&W.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=_n;let Jt=class{constructor(W){this.kind=W}};Jt=je([b],Jt),e.ColorTheme=Jt;var En;(function(H){H[H.Light=1]="Light",H[H.Dark=2]="Dark",H[H.HighContrast=3]="HighContrast"})(En=e.ColorThemeKind||(e.ColorThemeKind={}));class Nt{constructor(W,ne){if(W<0)throw(0,P.illegalArgument)("start must be positive");if(ne<W)throw(0,P.illegalArgument)("end cannot be smaller than start");this._start=W,this._end=ne}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(W){let ne=this._start,De=this._end;return W.start!==void 0&&(ne=W.start),W.end!==void 0&&(De=W.end),ne===this._start&&De===this._end?this:new Nt(ne,De)}}e.NotebookCellRange=Nt;class zt{constructor(W,ne,De,ze,Xe,lt){this.editable=W,this.breakpointMargin=ne,this.statusMessage=De,this.inputCollapsed=ze,this.outputCollapsed=Xe,this.custom=lt}with(W){let{editable:ne,breakpointMargin:De,statusMessage:ze,inputCollapsed:Xe,outputCollapsed:lt,custom:ht}=W;return ne===void 0?ne=this.editable:ne===null&&(ne=void 0),De===void 0?De=this.breakpointMargin:De===null&&(De=void 0),ze===void 0?ze=this.statusMessage:ze===null&&(ze=void 0),Xe===void 0?Xe=this.inputCollapsed:Xe===null&&(Xe=void 0),lt===void 0?lt=this.outputCollapsed:lt===null&&(lt=void 0),ht===void 0?ht=this.custom:ht===null&&(ht=void 0),ne===this.editable&&De===this.breakpointMargin&&ze===this.statusMessage&&Xe===this.inputCollapsed&&lt===this.outputCollapsed&&ht===this.custom?this:new zt(ne,De,ze,Xe,lt,ht)}}e.NotebookCellMetadata=zt;class xt{constructor(W=!0,ne=!0,De={},ze=!0){this.editable=W,this.cellEditable=ne,this.custom=De,this.trusted=ze}with(W){let{editable:ne,cellEditable:De,custom:ze,trusted:Xe}=W;return ne===void 0?ne=this.editable:ne===null&&(ne=void 0),De===void 0?De=this.cellEditable:De===null&&(De=void 0),ze===void 0?ze=this.custom:ze===null&&(ze=void 0),Xe===void 0?Xe=this.trusted:Xe===null&&(Xe=void 0),ne===this.editable&&De===this.cellEditable&&ze===this.custom&&Xe===this.trusted?this:new xt(ne,De,ze,Xe)}}e.NotebookDocumentMetadata=xt;class Yt{constructor(W,ne,De,ze,Xe,lt){this.kind=W,this.source=ne,this.language=De,this.outputs=ze!=null?ze:[],this.metadata=Xe,this.latestExecutionSummary=lt}}e.NotebookCellData=Yt;class Me{constructor(W,ne){this.cells=W,this.metadata=ne!=null?ne:new xt}}e.NotebookData=Me;class Ut{constructor(W,ne,De){this.mime=W,this.value=ne,this.metadata=De}static isNotebookCellOutputItem(W){return W instanceof Ut}}e.NotebookCellOutputItem=Ut;class Zt{constructor(W,ne,De){this.outputs=W,typeof ne=="string"?(this.id=ne,this.metadata=De):(this.id=(0,y.generateUuid)(),this.metadata=ne!=null?ne:De)}}e.NotebookCellOutput=Zt;var mt;(function(H){H[H.Markdown=1]="Markdown",H[H.Code=2]="Code"})(mt=e.NotebookCellKind||(e.NotebookCellKind={}));var Sn;(function(H){H[H.Idle=1]="Idle",H[H.Pending=2]="Pending",H[H.Executing=3]="Executing"})(Sn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var yn;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(yn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var ln;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(ln=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));let Vt=class{constructor(W,ne){this.label=W,this.timestamp=ne}};Vt=je([b],Vt),e.TimelineItem=Vt;var Dn;(function(H){H[H.Production=1]="Production",H[H.Development=2]="Development",H[H.Test=3]="Test"})(Dn=e.ExtensionMode||(e.ExtensionMode={}));var Cn;(function(H){H[H.Node=1]="Node",H[H.Webworker=2]="Webworker"})(Cn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var kn;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=4]="RegEx"})(kn=e.StandardTokenType||(e.StandardTokenType={}));class Pn{constructor(W,ne){this.ranges=W,this.wordPattern=ne}}e.LinkedEditingRanges=Pn;var cn;(function(H){H[H.Unset=0]="Unset",H[H.Queued=1]="Queued",H[H.Running=2]="Running",H[H.Passed=3]="Passed",H[H.Failed=4]="Failed",H[H.Skipped=5]="Skipped",H[H.Errored=6]="Errored"})(cn=e.TestResultState||(e.TestResultState={}));var un;(function(H){H[H.Error=0]="Error",H[H.Warning=1]="Warning",H[H.Information=2]="Information",H[H.Hint=3]="Hint"})(un=e.TestMessageSeverity||(e.TestMessageSeverity={})),e.TestItemHookProperty=Symbol("TestItemHookProperty");const jt=(H,W,ne)=>{let De=ne;return{enumerable:!0,configurable:!1,get(){return De},set(ze){var Xe;(Xe=H[e.TestItemHookProperty])===null||Xe===void 0||Xe.setProp(W,ze),De=ze}}};class dn{constructor(W){g.set(this,new Map),s.set(this,void 0),tt(this,s,W,"f")}get size(){return He(this,g,"f").size}add(W){const ne=He(this,g,"f"),De=He(this,s,"f").call(this),ze=ne.get(W.id);ze!==W&&(ze&&(De==null||De.delete(W.id)),ne.set(W.id,W),De==null||De.created(W))}get(W){return He(this,g,"f").get(W)}clear(){for(const W of He(this,g,"f").keys())this.delete(W)}delete(W){var ne;const De=typeof W=="string"?W:W.id;He(this,g,"f").has(De)&&(He(this,g,"f").delete(De),(ne=He(this,s,"f").call(this))===null||ne===void 0||ne.delete(De))}toJSON(){return[...He(this,g,"f").values()]}[(g=new WeakMap,s=new WeakMap,Symbol.iterator)](){return He(this,g,"f").values()}}e.TestChildrenCollection=dn;class In{constructor(W,ne,De,ze){this.label=ne,this.expandable=ze,Object.defineProperties(this,{id:{value:W,enumerable:!0,writable:!1},uri:{value:De,enumerable:!0,writable:!1},children:{value:new dn(()=>this[e.TestItemHookProperty]),enumerable:!0,writable:!1},[e.TestItemHookProperty]:{enumerable:!1,writable:!0,configurable:!1},range:jt(this,"range",void 0),description:jt(this,"description",void 0),runnable:jt(this,"runnable",!0),debuggable:jt(this,"debuggable",!0)})}invalidate(){var W;(W=this[e.TestItemHookProperty])===null||W===void 0||W.invalidate(this.id)}discoverChildren(W,ne){W.report({busy:!1})}}e.TestItem=In;class en{constructor(W){this.message=W,this.severity=un.Error}static diff(W,ne,De){const ze=new en(W);return ze.expectedOutput=ne,ze.actualOutput=De,ze}}e.TestMessage=en;var re;(function(H){H[H.None=0]="None",H[H.Option=1]="Option",H[H.Default=2]="Default",H[H.Preferred=3]="Preferred"})(re=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var ue;(function(H){H[H.Untrusted=0]="Untrusted",H[H.Trusted=1]="Trusted",H[H.Unspecified=2]="Unspecified"})(ue=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Ie;(function(H){H[H.Notify=1]="Notify",H[H.OpenBrowser=2]="OpenBrowser",H[H.OpenPreview=3]="OpenPreview",H[H.Silent=4]="Silent",H[H.Ignore=5]="Ignore"})(Ie=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(ge[118],pe([0,1,52,11,10,143,105,7,14]),function(G,e,E,P,T,I,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const n=new Map;function R(s,u){u?n.set(s,u):n.delete(s)}e.setWordDefinitionFor=R;function C(s){return n.get(s)}e.getWordDefinitionFor=C;class w extends I.MirrorTextModel{constructor(u,S,v,_,p,c,l,t){super(S,v,_,p);this._proxy=u,this._languageId=c,this._isDirty=l,this._notebook=t,this._isDisposed=!1}dispose(){(0,E.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(u){return(0,y.equals)(this._lines,u)}get document(){if(!this._document){const u=this;this._document={get uri(){return u._uri},get fileName(){return u._uri.fsPath},get isUntitled(){return u._uri.scheme===P.Schemas.untitled},get languageId(){return u._languageId},get version(){return u._versionId},get isClosed(){return u._isDisposed},get isDirty(){return u._isDirty},get notebook(){return u._notebook},save(){return u._save()},getText(S){return S?u._getTextInRange(S):u.getText()},get eol(){return u._eol===`
`?k.EndOfLine.LF:k.EndOfLine.CRLF},get lineCount(){return u._lines.length},lineAt(S){return u._lineAt(S)},offsetAt(S){return u._offsetAt(S)},positionAt(S){return u._positionAt(S)},validateRange(S){return u._validateRange(S)},validatePosition(S){return u._validatePosition(S)},getWordRangeAtPosition(S,v){return u._getWordRangeAtPosition(S,v)}}}return Object.freeze(this._document)}_acceptLanguageId(u){(0,E.ok)(!this._isDisposed),this._languageId=u}_acceptIsDirty(u){(0,E.ok)(!this._isDisposed),this._isDirty=u}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(u){const S=this._validateRange(u);if(S.isEmpty)return"";if(S.isSingleLine)return this._lines[S.start.line].substring(S.start.character,S.end.character);const v=this._eol,_=S.start.line,p=S.end.line,c=[];c.push(this._lines[_].substring(S.start.character));for(let l=_+1;l<p;l++)c.push(this._lines[l]);return c.push(this._lines[p].substring(0,S.end.character)),c.join(v)}_lineAt(u){let S;if(u instanceof k.Position?S=u.line:typeof u=="number"&&(S=u),typeof S!="number"||S<0||S>=this._lines.length||Math.floor(S)!==S)throw new Error("Illegal value for `line`");return new g(S,this._lines[S],S===this._lines.length-1)}_offsetAt(u){return u=this._validatePosition(u),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(u.line-1)+u.character}_positionAt(u){u=Math.floor(u),u=Math.max(0,u),this._ensureLineStarts();const S=this._lineStarts.getIndexOf(u),v=this._lines[S.index].length;return new k.Position(S.index,Math.min(S.remainder,v))}_validateRange(u){if(!(u instanceof k.Range))throw new Error("Invalid argument");const S=this._validatePosition(u.start),v=this._validatePosition(u.end);return S===u.start&&v===u.end?u:new k.Range(S.line,S.character,v.line,v.character)}_validatePosition(u){if(!(u instanceof k.Position))throw new Error("Invalid argument");if(this._lines.length===0)return u.with(0,0);let{line:S,character:v}=u,_=!1;if(S<0)S=0,v=0,_=!0;else if(S>=this._lines.length)S=this._lines.length-1,v=this._lines[S].length,_=!0;else{const p=this._lines[S].length;v<0?(v=0,_=!0):v>p&&(v=p,_=!0)}return _?new k.Position(S,v):u}_getWordRangeAtPosition(u,S){const v=this._validatePosition(u);if(!S)S=C(this._languageId);else if((0,T.regExpLeadsToEndlessLoop)(S))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${S.source}' because it matches the empty string.`);const _=(0,D.getWordAtText)(v.character+1,(0,D.ensureValidWordDefinition)(S),this._lines[v.line],0);if(_)return new k.Range(v.line,_.startColumn-1,v.line,_.endColumn-1)}}e.ExtHostDocumentData=w;class g{constructor(u,S,v){this._line=u,this._text=S,this._isLastLine=v}get lineNumber(){return this._line}get text(){return this._text}get range(){return new k.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new k.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=g}),define(ge[197],pe([0,1,7,3,107,6,76,24,2,28]),function(G,e,E,P,T,I,D,k,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class R{constructor(w,g,s,u){this._notebook=s,this._selector=u,this._disposables=new I.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new P.Emitter,this.onDidChange=this._onDidChange.event,this.uri=y.URI.from({scheme:"vscode-concat-doc",path:(0,n.generateUuid)()}),this._init(),this._disposables.add(g.onDidChangeDocument(v=>{const _=this._cellUris.get(v.document.uri);_!==void 0&&(this._cellLengths.changeValue(_,this._cells[_].document.getText().length+1),this._cellLines.changeValue(_,this._cells[_].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const S=v=>{v===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(w.onDidChangeNotebookCells(v=>S(v.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new k.ResourceMap;const w=[],g=[];for(const s of this._notebook.getCells())s.kind===E.NotebookCellKind.Code&&(!this._selector||(0,D.score)(this._selector,s.document.uri,s.document.languageId,!0))&&(this._cellUris.set(s.document.uri,this._cells.length),this._cells.push(s),w.push(s.document.getText().length+1),g.push(s.document.lineCount));this._cellLengths=new T.PrefixSumComputer(new Uint32Array(w)),this._cellLines=new T.PrefixSumComputer(new Uint32Array(g))}get version(){return this._versionId}getText(w){var g,s;if(!w){let p="";for(const c of this._cells)p+=c.document.getText()+`
`;return p=p.slice(0,-1),p}if(w.isEmpty)return"";const u=this.locationAt(w.start),S=this.locationAt(w.end),v=this._cells[(g=this._cellUris.get(u.uri))!==null&&g!==void 0?g:-1],_=this._cells[(s=this._cellUris.get(S.uri))!==null&&s!==void 0?s:-1];if(!v||!_)return"";if(v===_)return v.document.getText(new E.Range(u.range.start,S.range.end));{const p=v.document.getText(new E.Range(u.range.start,new E.Position(v.document.lineCount,0))),c=_.document.getText(new E.Range(new E.Position(0,0),S.range.end));return p+`
`+c}}offsetAt(w){const g=this._cellLines.getIndexOf(w.line),s=this._cellLengths.getAccumulatedValue(g.index-1),u=this._cells[g.index].document.offsetAt(w.with(g.remainder));return s+u}positionAt(w){if(typeof w=="number"){const s=this._cellLengths.getIndexOf(w),u=this._cellLines.getAccumulatedValue(s.index-1);return this._cells[s.index].document.positionAt(s.remainder).translate(u)}const g=this._cellUris.get(w.uri);if(g!==void 0){const s=this._cellLines.getAccumulatedValue(g-1);return new E.Position(s+w.range.start.line,w.range.start.character)}return new E.Position(0,0)}locationAt(w){E.Range.isRange(w)||(w=new E.Range(w,w));const g=this._cellLines.getIndexOf(w.start.line);let s=g;w.isEmpty||(s=this._cellLines.getIndexOf(w.end.line));const u=new E.Position(g.remainder,w.start.character),S=new E.Position(s.remainder,w.end.character),v=new E.Range(u,S),_=this._cells[g.index];return new E.Location(_.document.uri,_.document.validateRange(v))}contains(w){return this._cellUris.has(w)}validateRange(w){const g=this.validatePosition(w.start),s=this.validatePosition(w.end);return w.with(g,s)}validatePosition(w){const g=this._cellLines.getIndexOf(w.line),s=new E.Position(g.remainder,w.character),u=this._cells[g.index].document.validatePosition(s),S=this._cellLines.getAccumulatedValue(g.index-1);return new E.Position(S+u.line,u.character)}}e.ExtHostNotebookConcatDocument=R}),define(ge[198],pe([0,1,7,13,3]),function(G,e,E,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let I=class{constructor(k){this._actual=new E.ColorTheme(E.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new T.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(k){let y=k==="light"?E.ColorThemeKind.Light:k==="dark"?E.ColorThemeKind.Dark:E.ColorThemeKind.HighContrast;this._actual=new E.ColorTheme(y),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};I=je([Ue(0,P.IExtHostRpcService)],I),e.ExtHostTheming=I}),define(ge[61],pe([0,1,4]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,E.createDecorator)("IURITransformerService");class P{constructor(I){I?(this.transformIncoming=I.transformIncoming.bind(I),this.transformOutgoing=I.transformOutgoing.bind(I),this.transformOutgoingURI=I.transformOutgoingURI.bind(I),this.transformOutgoingScheme=I.transformOutgoingScheme.bind(I)):(this.transformIncoming=D=>D,this.transformOutgoing=D=>D,this.transformOutgoingURI=D=>D,this.transformOutgoingScheme=D=>D)}}e.URITransformerService=P}),define(ge[199],pe([0,1,22]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class P{constructor(){this.buffers=[]}add(y){let n=this.buffers.indexOf(y);return n<0&&(n=this.buffers.length,this.buffers.push(y)),n}}function T(k,y){if(y){const n=new P,R=(g,s)=>{if(s instanceof ArrayBuffer){const u=n.add(s);return{$$vscode_array_buffer_reference$$:!0,index:u}}else if(ArrayBuffer.isView(s)){const u=I(s);if(u){const S=n.add(s.buffer);return{$$vscode_array_buffer_reference$$:!0,index:S,view:{type:u,byteLength:s.byteLength,byteOffset:s.byteOffset}}}}return s},C=JSON.stringify(k,R),w=n.buffers.map(g=>{const s=new Uint8Array(g);return E.VSBuffer.wrap(s)});return{message:C,buffers:w}}else return{message:JSON.stringify(k),buffers:[]}}e.serializeWebviewMessage=T;function I(k){switch(k.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function D(k,y){const n=y.map(w=>{const g=new ArrayBuffer(w.byteLength);return new Uint8Array(g).set(w.buffer),g}),R=y.length?(w,g)=>{if(typeof g=="object"&&g.$$vscode_array_buffer_reference$$){const s=g,{index:u}=s,S=n[u];if(s.view)switch(s.view.type){case 1:return new Int8Array(S,s.view.byteOffset,s.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(S,s.view.byteOffset,s.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(S,s.view.byteOffset,s.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(S,s.view.byteOffset,s.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(S,s.view.byteOffset,s.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(S,s.view.byteOffset,s.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(S,s.view.byteOffset,s.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(S,s.view.byteOffset,s.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(S,s.view.byteOffset,s.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(S,s.view.byteOffset,s.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(S,s.view.byteOffset,s.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return S}return g}:void 0;return{message:JSON.parse(k,R),arrayBuffers:n}}e.deserializeWebviewMessage=D}),define(ge[84],pe([0,1,2]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=void 0;function P(I,D,k){const y=I.webviewResourceRoot.replace("{{resource}}",k.scheme+T(k)).replace("{{uuid}}",D);return E.URI.parse(y)}e.asWebviewUri=P;function T(I){return I.toString().replace(/^\S+?:/,"")}}),define(ge[200],pe([0,1,3,6,84,28]),function(G,e,E,P,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class D{constructor(y,n,R){this._proxy=y,this._editors=n,this._initData=R,this._handlePool=0,this._disposables=new P.DisposableStore,this._insets=new Map,this._disposables.add(n.onDidChangeVisibleTextEditors(()=>{const C=n.getVisibleTextEditors();for(const w of this._insets.values())C.indexOf(w.editor)<0&&w.inset.dispose()}))}dispose(){this._insets.forEach(y=>y.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(y,n,R,C,w){let g;for(const c of this._editors.getVisibleTextEditors(!0))if(c.value===y){g=c;break}if(!g)throw new Error("not a visible editor");const s=this,u=this._handlePool++,S=new E.Emitter,v=new E.Emitter,_=new class{constructor(){this._uuid=(0,I.generateUuid)(),this._html="",this._options=Object.create(null)}asWebviewUri(c){return(0,T.asWebviewUri)(s._initData,this._uuid,c)}get cspSource(){return s._initData.webviewCspSource}set options(c){this._options=c,s._proxy.$setOptions(u,c)}get options(){return this._options}set html(c){this._html=c,s._proxy.$setHtml(u,c)}get html(){return this._html}get onDidReceiveMessage(){return S.event}postMessage(c){return s._proxy.$postMessage(u,c)}},p=new class{constructor(){this.editor=y,this.line=n,this.height=R,this.webview=_,this.onDidDispose=v.event}dispose(){s._insets.has(u)&&(s._insets.delete(u),s._proxy.$disposeEditorInset(u),v.fire(),v.dispose(),S.dispose())}};return this._proxy.$createEditorInset(u,g.id,g.value.document.uri,n+1,R,C||{},w.identifier,w.extensionLocation),this._insets.set(u,{editor:y,inset:p,onDidReceiveMessage:S}),p}$onDidDispose(y){const n=this._insets.get(y);n&&n.inset.dispose()}$onDidReceiveMessage(y,n){const R=this._insets.get(y);R&&R.onDidReceiveMessage.fire(n)}}e.ExtHostEditorInsets=D}),define(ge[201],pe([0,1,3,80,168,4,6,24,40,14,53,23,43,193]),function(G,e,E,P,T,I,D,k,y,n,R,C,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,g.registerIcon)("default-view-icon",w.Codicon.window,(0,T.localize)(0,null));var s;(function(a){a.ViewContainersRegistry="workbench.registry.view.containers",a.ViewsRegistry="workbench.registry.view"})(s=e.Extensions||(e.Extensions={}));var u;(function(a){a[a.Sidebar=0]="Sidebar",a[a.Panel=1]="Panel"})(u=e.ViewContainerLocation||(e.ViewContainerLocation={}));function S(a){switch(a){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=S;function v(a){return`viewContainer.${a}.enabled`}e.getEnabledViewContainerContextKey=v;class _ extends D.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new E.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new E.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,n.flatten)([...this.viewContainers.values()])}registerViewContainer(h,m,b){var f;const d=this.get(h.id);if(d)return d;const A=h;return A.openCommandActionDescriptor=(b==null?void 0:b.donotRegisterOpenCommand)?void 0:(f=A.openCommandActionDescriptor)!==null&&f!==void 0?f:{id:A.id},(0,k.getOrSet)(this.viewContainers,m,[]).push(A),(b==null?void 0:b.isDefault)&&this.defaultViewContainers.push(A),this._onDidRegister.fire({viewContainer:A,viewContainerLocation:m}),A}deregisterViewContainer(h){for(const m of this.viewContainers.keys()){const b=this.viewContainers.get(m),f=b==null?void 0:b.indexOf(h);if(f!==-1){b==null||b.splice(f,1),b.length===0&&this.viewContainers.delete(m),this._onDidDeregister.fire({viewContainer:h,viewContainerLocation:m});return}}}get(h){return this.all.filter(m=>m.id===h)[0]}getViewContainers(h){return[...this.viewContainers.get(h)||[]]}getViewContainerLocation(h){return[...this.viewContainers.keys()].filter(m=>this.getViewContainers(m).filter(b=>(b==null?void 0:b.id)===h.id).length>0)[0]}getDefaultViewContainer(h){return this.defaultViewContainers.find(m=>this.getViewContainerLocation(m)===h)}}y.Registry.add(s.ViewContainersRegistry,new _);var p;(function(a){a.Open="2_open",a.Debug="4_debug",a.SCM="5_scm",a.More="9_more"})(p=e.ViewContentGroups||(e.ViewContentGroups={}));function c(a,h){var m,b,f,d;const A=(m=a.group)!==null&&m!==void 0?m:p.More,L=(b=h.group)!==null&&b!==void 0?b:p.More;return A!==L?A.localeCompare(L):((f=a.order)!==null&&f!==void 0?f:5)-((d=h.order)!==null&&d!==void 0?d:5)}class l extends D.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new E.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new E.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new E.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new E.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new R.SetMap}registerViews(h,m){this.registerViews2([{views:h,viewContainer:m}])}registerViews2(h){h.forEach(({views:m,viewContainer:b})=>this.addViews(m,b)),this._onViewsRegistered.fire(h)}deregisterViews(h,m){const b=this.removeViews(h,m);b.length&&this._onViewsDeregistered.fire({views:b,viewContainer:m})}moveViews(h,m){for(const b of this._views.keys())if(b!==m){const f=this.removeViews(h,b);f.length&&(this.addViews(f,m),this._onDidChangeContainer.fire({views:f,from:b,to:m}))}}getViews(h){return this._views.get(h)||[]}getView(h){for(const m of this._viewContainers){const b=(this._views.get(m)||[]).filter(f=>f.id===h)[0];if(b)return b}return null}getViewContainer(h){for(const m of this._viewContainers)if((this._views.get(m)||[]).filter(f=>f.id===h)[0])return m;return null}registerViewWelcomeContent(h,m){return this._viewWelcomeContents.add(h,m),this._onDidChangeViewWelcomeContent.fire(h),(0,D.toDisposable)(()=>{this._viewWelcomeContents.delete(h,m),this._onDidChangeViewWelcomeContent.fire(h)})}registerViewWelcomeContent2(h,m){const b=new Map;for(const[f,d]of m)this._viewWelcomeContents.add(h,d),b.set(f,(0,D.toDisposable)(()=>{this._viewWelcomeContents.delete(h,d),this._onDidChangeViewWelcomeContent.fire(h)}));return this._onDidChangeViewWelcomeContent.fire(h),b}getViewWelcomeContent(h){const m=[];return this._viewWelcomeContents.forEach(h,b=>m.push(b)),m.sort(c)}addViews(h,m){let b=this._views.get(m);b||(b=[],this._views.set(m,b),this._viewContainers.push(m));for(const f of h){if(this.getView(f.id)!==null)throw new Error((0,T.localize)(1,null,f.id));b.push(f)}}removeViews(h,m){const b=this._views.get(m);if(!b)return[];const f=[],d=[];for(const A of b)h.includes(A)?f.push(A):d.push(A);return f.length&&(d.length?this._views.set(m,d):(this._views.delete(m),this._viewContainers.splice(this._viewContainers.indexOf(m),1))),f}}y.Registry.add(s.ViewsRegistry,new l),e.IViewsService=(0,I.createDecorator)("viewsService"),e.FocusedViewContext=new P.RawContextKey("focusedView","",(0,T.localize)(2,null));function t(a){return`view.${a}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,I.createDecorator)("viewDescriptorService");var i;(function(a){a[a.Default=0]="Default",a[a.Expand=1]="Expand"})(i=e.ViewVisibilityState||(e.ViewVisibilityState={}));var o;(function(a){a[a.None=0]="None",a[a.Collapsed=1]="Collapsed",a[a.Expanded=2]="Expanded"})(o=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class r{constructor(h,m){this.resolved=!1,this._hasResolve=!1,(0,C.mixin)(this,h),this._hasResolve=!!m,this.resolve=async b=>{var f,d;if(m&&!this.resolved){const A=await m(b);A&&(this.tooltip=(f=this.tooltip)!==null&&f!==void 0?f:A.tooltip,this.command=(d=this.command)!==null&&d!==void 0?d:A.command)}b.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=r}),define(ge[202],pe([0,1,2,180,115,12,181,201]),function(G,e,E,P,T,I,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MoveViewsAPICommand=e.OpenIssueReporter=e.RemoveFromRecentlyOpenedAPICommand=e.NewWindowAPICommand=void 0;function y(u){return(S,...v)=>u(S.get(P.ICommandService),...v)}class n{static execute(S,v){const _={forceReuseWindow:v&&v.reuseWindow,remoteAuthority:v&&v.remoteAuthority};return S.executeCommand("_files.newWindow",_)}}e.NewWindowAPICommand=n,n.ID="vscode.newWindow",P.CommandsRegistry.registerCommand({id:n.ID,handler:y(n.execute),description:{description:"Opens an new window",args:[]}}),P.CommandsRegistry.registerCommand("_workbench.removeFromRecentlyOpened",function(u,S){return u.get(T.IWorkspacesService).removeRecentlyOpened([S])});class R{static execute(S,v){return typeof v=="string"?v=v.match(/^[^:/?#]+:\/\//)?E.URI.parse(v):E.URI.file(v):v=E.URI.revive(v),S.executeCommand("_workbench.removeFromRecentlyOpened",v)}}e.RemoveFromRecentlyOpenedAPICommand=R,R.ID="vscode.removeFromRecentlyOpened",P.CommandsRegistry.registerCommand(R.ID,y(R.execute));class C{static execute(S,v){const _=typeof v=="string"?{extensionId:v}:v;return S.executeCommand("workbench.action.openIssueReporter",_)}}e.OpenIssueReporter=C,C.ID="vscode.openIssueReporter",P.CommandsRegistry.registerCommand("_workbench.addToRecentlyOpened",async function(u,S){const v=u.get(T.IWorkspacesService);let _;const p=S.uri,c=S.label,l=S.remoteAuthority;return S.type==="workspace"?_={workspace:await v.getWorkspaceIdentifier(p),label:c,remoteAuthority:l}:S.type==="folder"?_={folderUri:p,label:c,remoteAuthority:l}:_={fileUri:p,label:c,remoteAuthority:l},v.addRecentlyOpened([_])}),P.CommandsRegistry.registerCommand("_workbench.getRecentlyOpened",async function(u){return u.get(T.IWorkspacesService).getRecentlyOpened()}),P.CommandsRegistry.registerCommand("_extensionTests.setLogLevel",function(u,S){const v=u.get(I.ILogService),_=u.get(D.IEnvironmentService);_.isExtensionDevelopment&&!!_.extensionTestsLocationURI&&v.setLevel(S)}),P.CommandsRegistry.registerCommand("_extensionTests.getLogLevel",function(u){return u.get(I.ILogService).getLevel()}),P.CommandsRegistry.registerCommand("_workbench.action.moveViews",async function(u,S){const v=u.get(k.IViewDescriptorService),_=v.getViewContainerById(S.destinationId);if(!!_){for(const p of S.viewIds){const c=v.getViewDescriptorById(p);(c==null?void 0:c.canMoveView)&&v.moveViewsToContainer([c],_,k.ViewVisibilityState.Default)}await u.get(k.IViewsService).openViewContainer(_.id,!0)}});class w{static execute(S,v){return!Array.isArray(v==null?void 0:v.viewIds)||typeof(v==null?void 0:v.destinationId)!="string"?Promise.reject("Invalid arguments"):S.executeCommand("_workbench.action.moveViews",v)}}e.MoveViewsAPICommand=w,w.ID="vscode.moveViews",P.CommandsRegistry.registerCommand({id:w.ID,handler:y(w.execute),description:{description:"Move Views",args:[]}});class g{static execute(S,v){return S.executeCommand("_workbench.open",v)}}g.ID="vscode.open",P.CommandsRegistry.registerCommand(g.ID,y(g.execute));class s{static execute(S,v,_,p,c){return S.executeCommand("_workbench.diff",[v,_,p])}}s.ID="vscode.diff",P.CommandsRegistry.registerCommand(s.ID,y(s.execute))}),define(ge[119],pe([0,1,3,19,169]),function(G,e,E,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class I{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new E.Emitter,this._onExit=new E.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(k){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=k}onEvent(k){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=k}onRequest(k){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=k}sendResponse(k){k.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${k.command}`)):this.internalSend("response",k)}sendRequest(k,y,n,R){const C={command:k};if(y&&Object.keys(y).length>0&&(C.arguments=y),this.internalSend("request",C),typeof R=="number"){const w=setTimeout(()=>{clearTimeout(w);const g=this.pendingRequests.get(C.seq);if(g){this.pendingRequests.delete(C.seq);const s={type:"response",seq:0,request_seq:C.seq,success:!1,command:k,message:(0,T.localize)(0,null,R,k)};g(s)}},R)}return n&&this.pendingRequests.set(C.seq,n),C.seq}acceptMessage(k){this.messageCallback?this.messageCallback(k):(this.queue.push(k),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(k,y){return k.type!=="event"||y.type!=="event"}async processQueue(){let k;for(;this.queue.length;){if((!k||this.needsTaskBoundaryBetween(this.queue[0],k))&&await(0,P.timeout)(0),k=this.queue.shift(),!k)return;switch(k.type){case"event":this.eventCallback&&this.eventCallback(k);break;case"request":this.requestCallback&&this.requestCallback(k);break;case"response":const y=k,n=this.pendingRequests.get(y.request_seq);n&&(this.pendingRequests.delete(y.request_seq),n(y));break}}}internalSend(k,y){y.type=k,y.seq=this.sequence++,this.sendMessage(y)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const k=new Map;this.pendingRequests.forEach((y,n)=>k.set(n,y)),await(0,P.timeout)(500),k.forEach((y,n)=>{y({type:"response",seq:0,request_seq:n,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(n)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=I}),define(ge[203],pe([0,1,10,2,8,23,11]),function(G,e,E,P,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const k=/{([^}]+)}/g;function y(i,o,r){return i.replace(k,function(a,h){return o&&h.length>0&&h[0]!=="_"?a:r&&r.hasOwnProperty(h)?r[h]:a})}e.formatPII=y;function n(i){const o={};for(const r of Object.keys(i))r.startsWith("!")||(o[r]=i[r]);return o}e.filterExceptionsFromTelemetry=n;function R(i){return i.configuration.request==="attach"&&!C(i)}e.isSessionAttach=R;function C(i){let o=i.configuration.type;if(!!o)return o==="vslsShare"&&(o=i.configuration.adapterProxy.configuration.type),(0,E.equalsIgnoreCase)(o,"extensionhost")||(0,E.equalsIgnoreCase)(o,"pwa-extensionhost")?i:i.parentSession?C(i.parentSession):void 0}e.getExtensionHostDebugSession=C;function w(i){return i.type&&(i.label||i.program||i.runtime)}e.isDebuggerMainContribution=w;function g(i,o,r){let a,h=0,m=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,b=null;for(;b=m.exec(i);){let f=b.index+1,d=f+b[0].length;if(f<=o&&d>=r){a=b[0],h=f;break}}if(a){let f=/\w+/g,d=null;for(;(d=f.exec(a))&&!(d.index+1+h+d[0].length>=r););d&&(a=a.substring(0,f.lastIndex))}return a?{start:h,end:h+a.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=g;const s=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function u(i){return!!(i&&i.match(s))}e.isUri=u;function S(i){if(typeof i.path=="string"&&!(typeof i.sourceReference=="number"&&i.sourceReference>0)){if(u(i.path))return P.URI.parse(i.path);if((0,T.isAbsolute)(i.path))return P.URI.file(i.path)}return i.path}function v(i){if(typeof i.path=="object"){const o=P.URI.revive(i.path);if(o)return o.scheme===D.Schemas.file?o.fsPath:o.toString()}return i.path}function _(i,o){const r=o?S:v,a=(0,I.deepClone)(i);return c(a,(h,m)=>{h&&m&&(m.path=r(m))}),a}e.convertToDAPaths=_;function p(i,o){const r=o?S:v,a=(0,I.deepClone)(i);return c(a,(h,m)=>{!h&&m&&(m.path=r(m))}),a}e.convertToVSCPaths=p;function c(i,o){switch(i.type){case"event":const r=i;switch(r.event){case"output":o(!1,r.body.source);break;case"loadedSource":o(!1,r.body.source);break;case"breakpoint":o(!1,r.body.breakpoint.source);break;default:break}break;case"request":const a=i;switch(a.command){case"setBreakpoints":o(!0,a.arguments.source);break;case"breakpointLocations":o(!0,a.arguments.source);break;case"source":o(!0,a.arguments.source);break;case"gotoTargets":o(!0,a.arguments.source);break;case"launchVSCode":a.arguments.args.forEach(m=>o(!1,m));break;default:break}break;case"response":const h=i;if(h.success&&h.body)switch(h.command){case"stackTrace":h.body.stackFrames.forEach(m=>o(!1,m.source));break;case"loadedSources":h.body.sources.forEach(m=>o(!1,m));break;case"scopes":h.body.scopes.forEach(m=>o(!1,m.source));break;case"setFunctionBreakpoints":h.body.breakpoints.forEach(m=>o(!1,m.source));break;case"setBreakpoints":h.body.breakpoints.forEach(m=>o(!1,m.source));break;default:break}break}}function l(i){return i.filter(o=>{var r;return!((r=o.presentation)===null||r===void 0?void 0:r.hidden)}).sort((o,r)=>o.presentation?r.presentation?o.presentation.group?r.presentation.group?o.presentation.group!==r.presentation.group?o.presentation.group.localeCompare(r.presentation.group):t(o.presentation.order,r.presentation.order):-1:r.presentation.group?1:t(o.presentation.order,r.presentation.order):-1:r.presentation?1:0)}e.getVisibleAndSorted=l;function t(i,o){return typeof i!="number"?typeof o!="number"?0:1:typeof o!="number"?-1:i-o}}),define(ge[204],pe([0,1,26,38,170,120,8,10,23,9,182,119]),function(G,e,E,P,T,I,D,k,y,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class w extends C.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(_,p){this.outputStream=p,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,_.on("data",c=>this.handleData(c))}sendMessage(_){if(this.outputStream){const p=JSON.stringify(_);this.outputStream.write(`Content-Length: ${Buffer.byteLength(p,"utf8")}${w.TWO_CRLF}${p}`,"utf8")}}handleData(_){for(this.rawData=Buffer.concat([this.rawData,_]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const p=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,p.length>0)try{this.acceptMessage(JSON.parse(p))}catch(c){this._onError.fire(new Error((c.message||c)+`
`+p))}continue}}else{const p=this.rawData.indexOf(w.TWO_CRLF);if(p!==-1){const l=this.rawData.toString("utf8",0,p).split(w.HEADER_LINESEPARATOR);for(const t of l){const i=t.split(w.HEADER_FIELDSEPARATOR);i[0]==="Content-Length"&&(this.contentLength=Number(i[1]))}this.rawData=this.rawData.slice(p+w.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=w,w.TWO_CRLF=`\r
\r
`,w.HEADER_LINESEPARATOR=/\r?\n/,w.HEADER_FIELDSEPARATOR=/: */;class g extends w{startSession(){return new Promise((_,p)=>{let c=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),_(),c=!0}),this.socket.on("close",()=>{c?this._onError.fire(new Error("connection closed")):p(new Error("connection closed"))}),this.socket.on("error",l=>{c?this._onError.fire(l):p(l)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=g;class s extends g{constructor(_){super();this.adapterServer=_}createConnection(_){return I.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",_)}}e.SocketDebugAdapter=s;class u extends g{constructor(_){super();this.adapterServer=_}createConnection(_){return I.createConnection(this.adapterServer.path,_)}}e.NamedPipeDebugAdapter=u;class S extends w{constructor(_,p,c){super();this.adapterExecutable=_,this.debugType=p,this.outputService=c}async startSession(){const _=this.adapterExecutable.command,p=this.adapterExecutable.args,c=this.adapterExecutable.options||{};try{if(_)if(D.isAbsolute(_)){if(!await(0,E.exists)(_))throw new Error(T.localize(0,null,_))}else _.indexOf("/")<0&&_.indexOf("\\")<0;else throw new Error(T.localize(1,null,this.debugType));let l=process.env;if(c.env&&Object.keys(c.env).length>0&&(l=y.mixin(y.deepClone(process.env),c.env)),_==="node")if(Array.isArray(p)&&p.length>0){const i=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,o={env:l,execArgv:i?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};c.cwd&&(o.cwd=c.cwd);const r=P.fork(p[0],p.slice(1),o);if(!r.pid)throw new Error(T.localize(2,null,p[0]));this.serverProcess=r}else throw new Error(T.localize(3,null));else{const i={env:l};c.cwd&&(i.cwd=c.cwd),this.serverProcess=P.spawn(_,p,i)}this.serverProcess.on("error",i=>{this._onError.fire(i)}),this.serverProcess.on("exit",(i,o)=>{this._onExit.fire(i)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",i=>{this._onError.fire(i)}),this.serverProcess.stdin.on("error",i=>{this._onError.fire(i)});const t=this.outputService;if(t){const i=o=>o.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",o=>{const r=t.getChannel(R.ExtensionsChannelId);r&&r.append(i(o))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(l){this._onError.fire(l)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),n.isWindows?new Promise((_,p)=>{const c=P.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(l,t,i){if(l)return p(l)});c.on("exit",_),c.on("error",p)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(_,p){if(!!_){const c=Object.create(null);_.runtime&&(_.runtime.indexOf("./")===0?c.runtime=D.join(p,_.runtime):c.runtime=_.runtime),_.runtimeArgs&&(c.runtimeArgs=_.runtimeArgs),_.program&&(D.isAbsolute(_.program)?c.program=_.program:c.program=D.join(p,_.program)),_.args&&(c.args=_.args);const l=_;return l.win&&(c.win=S.extract(l.win,p)),l.winx86&&(c.winx86=S.extract(l.winx86,p)),l.windows&&(c.windows=S.extract(l.windows,p)),l.osx&&(c.osx=S.extract(l.osx,p)),l.linux&&(c.linux=S.extract(l.linux,p)),c}}static platformAdapterExecutable(_,p){let c=Object.create(null);p=p.toLowerCase();for(const a of _)if(a.contributes){const h=a.contributes.debuggers;h&&h.length>0&&h.filter(m=>typeof m.type=="string"&&k.equalsIgnoreCase(m.type,p)).forEach(m=>{const b=S.extract(m,a.extensionLocation.fsPath);c=y.mixin(c,b,a.isBuiltin)})}let l;n.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?l=c.winx86||c.win||c.windows:n.isWindows?l=c.win||c.windows:n.isMacintosh?l=c.osx:n.isLinux&&(l=c.linux),l=l||c;let t=l.program||c.program;const i=l.args||c.args;let o=l.runtime||c.runtime;const r=l.runtimeArgs||c.runtimeArgs;if(o)return{type:"executable",command:o,args:(r||[]).concat(typeof t=="string"?[t]:[]).concat(i||[])};if(t)return{type:"executable",command:t,args:i||[]}}}e.ExecutableDebugAdapter=S}),define(ge[205],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DEFAULT_TERMINAL_OSX=void 0,e.DEFAULT_TERMINAL_OSX="Terminal.app"}),define(ge[206],pe([0,1,38,8,77,171,26,9,83,4,205,11]),function(G,e,E,P,T,I,D,k,y,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const w=I.localize(0,null);let g=class Bt{constructor(p){this._configurationService=p}openTerminal(p){if(this._configurationService){const c=this._configurationService.getValue();this.spawnTerminal(E,c,T.getWindowsShell(),p)}}runInTerminal(p,c,l,t,i){const o=i.windowsExec||Bt.getDefaultTerminalWindows();return new Promise((r,a)=>{const h=`"${c} - ${w}"`,m=`""${l.join('" "')}" & pause"`,b=["/c","start",h,"/wait",o,"/c",m],f=Object.assign({},process.env,t);Object.keys(f).filter(L=>f[L]===null).forEach(L=>delete f[L]);const d={cwd:c,env:f,windowsVerbatimArguments:!0};E.spawn(Bt.CMD,b,d).on("error",L=>{a(S(L))}),r(void 0)})}spawnTerminal(p,c,l,t){const o=c.terminal.external.windowsExec||Bt.getDefaultTerminalWindows();t&&t[1]===":"&&(t=t[0].toUpperCase()+t.substr(1));const r=P.basename(o).toLowerCase();if(r==="cmder"||r==="cmder.exe")return p.spawn(o,t?[t]:void 0),Promise.resolve(void 0);const a=["/c","start","/wait"];return o.indexOf(" ")>=0&&a.push('""'),a.push(o),(r==="wt"||r==="wt.exe")&&a.push("-d ."),new Promise((h,m)=>{const b=t?{cwd:t}:void 0,f=p.spawn(l,a,b);f.on("error",m),f.on("exit",()=>h())})}static getDefaultTerminalWindows(){if(!Bt._DEFAULT_TERMINAL_WINDOWS){const p=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");Bt._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${p?"Sysnative":"System32"}\\cmd.exe`}return Bt._DEFAULT_TERMINAL_WINDOWS}};g.CMD="cmd.exe",g=je([Ue(0,(0,n.optional)(y.IConfigurationService))],g),e.WindowsExternalTerminalService=g;let s=class Rn{constructor(p){this._configurationService=p}openTerminal(p){if(this._configurationService){const c=this._configurationService.getValue();this.spawnTerminal(E,c,p)}}runInTerminal(p,c,l,t,i){const o=i.osxExec||R.DEFAULT_TERMINAL_OSX;return new Promise((r,a)=>{if(o===R.DEFAULT_TERMINAL_OSX||o==="iTerm.app"){const h=o===R.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",b=[C.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${h}.scpt`,G).fsPath,"-t",p||w,"-w",c];for(let A of l)b.push("-a"),b.push(A);if(t)for(let A in t){const L=t[A];L===null?(b.push("-u"),b.push(A)):(b.push("-e"),b.push(`${A}=${L}`))}let f="";const d=E.spawn(Rn.OSASCRIPT,b);d.on("error",A=>{a(S(A))}),d.stderr.on("data",A=>{f+=A.toString()}),d.on("exit",A=>{if(A===0)r(void 0);else if(f){const L=f.split(`
`,1);a(new Error(L[0]))}else a(new Error(I.localize(1,null,h,A)))})}else a(new Error(I.localize(2,null,o)))})}spawnTerminal(p,c,l){const i=c.terminal.external.osxExec||R.DEFAULT_TERMINAL_OSX;return new Promise((o,r)=>{const a=["-a",i];l&&a.push(l);const h=p.spawn("/usr/bin/open",a);h.on("error",r),h.on("exit",()=>o())})}};s.OSASCRIPT="/usr/bin/osascript",s=je([Ue(0,(0,n.optional)(y.IConfigurationService))],s),e.MacExternalTerminalService=s;let u=class Wt{constructor(p){this._configurationService=p}openTerminal(p){if(this._configurationService){const c=this._configurationService.getValue();this.spawnTerminal(E,c,p)}}runInTerminal(p,c,l,t,i){const o=i.linuxExec?Promise.resolve(i.linuxExec):Wt.getDefaultTerminalLinuxReady();return new Promise((r,a)=>{let h=[];o.then(m=>{m.indexOf("gnome-terminal")>=0?h.push("-x"):h.push("-e"),h.push("bash"),h.push("-c");const b=`${v(l)}; echo; read -p "${Wt.WAIT_MESSAGE}" -n1;`;h.push(`''${b}''`);const f=Object.assign({},process.env,t);Object.keys(f).filter(B=>f[B]===null).forEach(B=>delete f[B]);const d={cwd:c,env:f};let A="";const L=E.spawn(m,h,d);L.on("error",B=>{a(S(B))}),L.stderr.on("data",B=>{A+=B.toString()}),L.on("exit",B=>{if(B===0)r(void 0);else if(A){const J=A.split(`
`,1);a(new Error(J[0]))}else a(new Error(I.localize(4,null,m,B)))})})})}spawnTerminal(p,c,l){const t=c.terminal.external,i=t.linuxExec?Promise.resolve(t.linuxExec):Wt.getDefaultTerminalLinuxReady();return new Promise((o,r)=>{i.then(a=>{const h=l?{cwd:l}:void 0,m=p.spawn(a,[],h);m.on("error",r),m.on("exit",()=>o())})})}static async getDefaultTerminalLinuxReady(){return Wt._DEFAULT_TERMINAL_LINUX_READY||(Wt._DEFAULT_TERMINAL_LINUX_READY=new Promise(async p=>{k.isLinux?await D.exists("/etc/debian_version")?p("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?p("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?p("konsole"):process.env.COLORTERM?p(process.env.COLORTERM):process.env.TERM?p(process.env.TERM):p("xterm"):p("xterm")})),Wt._DEFAULT_TERMINAL_LINUX_READY}};u.WAIT_MESSAGE=I.localize(3,null),u=je([Ue(0,(0,n.optional)(y.IConfigurationService))],u),e.LinuxExternalTerminalService=u;function S(_){return"errno"in _&&_.errno==="ENOENT"&&"path"in _&&typeof _.path=="string"?new Error(I.localize(5,null,_.path)):_}function v(_){let p="";for(let c of _)c.indexOf(" ")>=0?p+='"'+c+'"':p+=c,p+=" ";return p}}),define(ge[207],pe([0,1,38,9,206,30]),function(G,e,E,P,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;let D;function k(w,g){if(!D)if(P.isWindows)D=new T.WindowsExternalTerminalService(void 0);else if(P.isMacintosh)D=new T.MacExternalTerminalService(void 0);else if(P.isLinux)D=new T.LinuxExternalTerminalService(void 0);else throw new Error("external terminals not supported on this platform");const s=g.getConfiguration("terminal");return D.runInTerminal(w.title,w.cwd,w.args,w.env||{},s.external||{})}e.runInExternalTerminal=k;function y(w,g){return new Promise((s,u)=>{let S="";const v=E.spawn(w,g);v.pid&&v.stdout.on("data",_=>{S+=_.toString()}),v.on("error",_=>{u(_)}),v.on("close",_=>{s(S)})})}function n(w){return w?P.isWindows?y("wmic",["process","get","ParentProcessId"]).then(g=>g.split(`\r
`).some(u=>parseInt(u)===w),g=>!0):y("/usr/bin/pgrep",["-lP",String(w)]).then(g=>{const s=g.trim();return!(s.length===0||s.indexOf(" tmux")>=0)},g=>!0):Promise.resolve(!0)}e.hasChildProcesses=n;var R;(function(w){w[w.cmd=0]="cmd",w[w.powershell=1]="powershell",w[w.bash=2]="bash"})(R||(R={}));function C(w,g,s,u){w=w.trim().toLowerCase();let S;w.indexOf("powershell")>=0||w.indexOf("pwsh")>=0?S=1:w.indexOf("cmd.exe")>=0?S=0:w.indexOf("bash")>=0?S=2:P.isWindows?S=0:S=2;let v,_=" ";switch(S){case 1:if(v=c=>(c=c.replace(/\'/g,"''"),c.length>0&&c.charAt(c.length-1)==="\\"?`'${c}\\'`:`'${c}'`),s){const c=(0,I.getDriveLetter)(s);c&&(_+=`${c}:; `),_+=`cd ${v(s)}; `}if(u)for(let c in u){const l=u[c];l===null?_+=`Remove-Item env:${c}; `:_+=`\${env:${c}}='${l}'; `}if(g.length>0){const c=v(g.shift());_+=c[0]==="'"?`& ${c} `:`${c} `;for(let l of g)_+=`${v(l)} `}break;case 0:if(v=c=>(c=c.replace(/\"/g,'""'),c.indexOf(" ")>=0||c.indexOf('"')>=0||c.length===0?`"${c}"`:c),s){const c=(0,I.getDriveLetter)(s);c&&(_+=`${c}: && `),_+=`cd ${v(s)} && `}if(u){_+='cmd /C "';for(let c in u){let l=u[c];l===null?_+=`set "${c}=" && `:(l=l.replace(/[\^\&\|\<\>]/g,t=>`^${t}`),_+=`set "${c}=${l}" && `)}}for(let c of g)_+=`${v(c)} `;u&&(_+='"');break;case 2:v=c=>(c=c.replace(/(["'\\\$])/g,"\\$1"),c.indexOf(" ")>=0||c.indexOf(";")>=0||c.length===0?`"${c}"`:c);const p=c=>/[^\w@%\/+=,.:^-]/.test(c)?`'${c.replace(/'/g,"'\\''")}'`:c;if(s&&(_+=`cd ${v(s)} ; `),u){_+="/usr/bin/env";for(let c in u){const l=u[c];l===null?_+=` -u ${p(c)}`:_+=` ${p(`${c}=${l}`)}`}_+=" "}for(let c of g)_+=`${v(c)} `;break}return _}e.prepareCommand=C}),define(ge[85],pe([0,1,33,11,8,9,80]),function(G,e,E,P,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cellRangeContains=e.reduceRanges=e.cellRangesToIndexes=e.cellIndexesToRanges=e.CellStatusbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBarKey=e.CellToolbarLocKey=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.NotebookRendererMatch=e.AnyRendererApi=e.NotebookCellExecutionState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var k;(function(L){L[L.Markdown=1]="Markdown",L[L.Code=2]="Code"})(k=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var y;(function(L){L[L.Running=1]="Running",L[L.Idle=2]="Idle"})(y=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={editable:!0,cellEditable:!0,custom:{},trusted:!0};var n;(function(L){L[L.Idle=1]="Idle",L[L.Pending=2]="Pending",L[L.Executing=3]="Executing"})(n=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={})),e.AnyRendererApi=Symbol("AnyRendererApi");var R;(function(L){L[L.WithHardKernelDependency=0]="WithHardKernelDependency",L[L.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",L[L.Pure=2]="Pure",L[L.Never=3]="Never"})(R=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var C;(function(L){L[L.ModelChange=1]="ModelChange",L[L.Move=2]="Move",L[L.CellClearOutput=3]="CellClearOutput",L[L.CellsClearOutput=4]="CellsClearOutput",L[L.ChangeLanguage=5]="ChangeLanguage",L[L.Initialize=6]="Initialize",L[L.ChangeCellMetadata=7]="ChangeCellMetadata",L[L.Output=8]="Output",L[L.OutputItem=9]="OutputItem",L[L.ChangeCellContent=10]="ChangeCellContent",L[L.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",L[L.Unknown=12]="Unknown"})(C=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var w;(function(L){L[L.Handle=0]="Handle",L[L.Index=1]="Index"})(w=e.SelectionStateType||(e.SelectionStateType={}));var g;(function(L){L[L.Replace=1]="Replace",L[L.Output=2]="Output",L[L.Metadata=3]="Metadata",L[L.CellLanguage=4]="CellLanguage",L[L.DocumentMetadata=5]="DocumentMetadata",L[L.OutputsSplice=6]="OutputsSplice",L[L.Move=7]="Move",L[L.Unknown=8]="Unknown",L[L.CellContent=9]="CellContent",L[L.OutputItems=10]="OutputItems",L[L.PartialMetadata=11]="PartialMetadata"})(g=e.CellEditType||(e.CellEditType={}));function s(L){const B=u.parse(L);return B?B.notebook.toString():L.toString()}e.getCellUndoRedoComparisonKey=s;var u;(function(L){L.scheme=P.Schemas.vscodeNotebookCell;const B=/^ch(\d{7,})/;function J(F,N){return F.with({scheme:L.scheme,fragment:`ch${N.toString().padStart(7,"0")}${F.scheme!==P.Schemas.file?F.scheme:""}`})}L.generate=J;function j(F){if(F.scheme===L.scheme){const N=B.exec(F.fragment);if(!!N)return{handle:Number(N[1]),notebook:F.with({scheme:F.fragment.substr(N[0].length)||P.Schemas.file,fragment:null})}}}L.parse=j;function U(F,N){return F.with({scheme:P.Schemas.vscodeNotebookCellMetadata,fragment:`ch${N.toString().padStart(7,"0")}${F.scheme!==P.Schemas.file?F.scheme:""}`})}L.generateCellMetadataUri=U;function $(F){if(F.scheme===P.Schemas.vscodeNotebookCellMetadata){const N=B.exec(F.fragment);if(!!N)return{handle:Number(N[1]),notebook:F.with({scheme:F.fragment.substr(N[0].length)||P.Schemas.file,fragment:null})}}}L.parseCellMetadataUri=$})(u=e.CellUri||(e.CellUri={}));const S=new Map([["application/json",{alwaysSecure:!0,supportedByCore:!0}],["text/markdown",{alwaysSecure:!0,supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["text/plain",{alwaysSecure:!0,supportedByCore:!0}],["application/javascript",{supportedByCore:!0}],["text/html",{supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["image/jpeg",{supportedByCore:!0}],["text/x-javascript",{supportedByCore:!0}],["application/x.notebook.error-traceback",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.stream",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function v(L){var B,J;return(J=(B=S.get(L))===null||B===void 0?void 0:B.alwaysSecure)!==null&&J!==void 0?J:!1}e.mimeTypeIsAlwaysSecure=v;function _(L){var B,J;return(J=(B=S.get(L))===null||B===void 0?void 0:B.supportedByCore)!==null&&J!==void 0?J:!1}e.mimeTypeSupportedByCore=_;function p(L){var B,J;return(J=(B=S.get(L))===null||B===void 0?void 0:B.mergeable)!==null&&J!==void 0?J:!1}e.mimeTypeIsMergeable=p;function c(L,B){return I.isWindows&&(L=L.replace(/\//g,"\\"),B=B.replace(/\//g,"\\")),E.match(L,B)}function l(L,B,J){let j=0;for(let U=0;U<B.length;U++){if(c(B[U],L))return j;j++}for(let U=0;U<J.length;U++){if(c(J[U],L))return j;j++}return j}function t(L,B,J){return L.sort((j,U)=>l(j,B,J)-l(U,B,J))}e.sortMimeTypes=t;function i(L,B,J,j=(U,$)=>U===$){const U=[];function $(M,x,O){if(!(x===0&&O.length===0)){const V=U[U.length-1];V&&V.start+V.deleteCount===M?(V.deleteCount+=x,V.toInsert.push(...O)):U.push({start:M,deleteCount:x,toInsert:O})}}let F=0,N=0;for(;;){if(F===L.length){$(F,0,B.slice(N));break}if(N===B.length){$(F,L.length-F,[]);break}const M=L[F],x=B[N];if(j(M,x)){F+=1,N+=1;continue}J(x)?($(F,1,[]),F+=1):($(F,0,[x]),N+=1)}return U}e.diff=i,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new D.RawContextKey("notebookEditorCursorAtBoundary","none");var o;(function(L){L.default="default",L.option="option"})(o=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function r(L){const B=L;return!!((typeof B.include=="string"||E.isRelativePattern(B.include))&&(typeof B.exclude=="string"||E.isRelativePattern(B.exclude)))}e.isDocumentExcludePattern=r;function a(L,B,J){if(Array.isArray(L.viewType)&&L.viewType.indexOf(B)>=0||L.viewType===B)return!0;if(L.filenamePattern){let j=r(L.filenamePattern)?L.filenamePattern.include:L.filenamePattern,U=r(L.filenamePattern)?L.filenamePattern.exclude:void 0;if(E.match(j,(0,T.basename)(J.fsPath).toLowerCase()))return!(U&&E.match(U,(0,T.basename)(J.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=a;class h{constructor(B){this.textModel=B}getElements(){const B=new Int32Array(this.textModel.cells.length);for(let J=0;J<this.textModel.cells.length;J++)B[J]=this.textModel.cells[J].getHashValue();return B}}e.CellSequence=h,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocKey="notebook.cellToolbarLocation",e.ShowCellStatusBarKey="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer";var m;(function(L){L[L.LEFT=0]="LEFT",L[L.RIGHT=1]="RIGHT"})(m=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));function b(L){L.sort((J,j)=>J-j);const B=L.shift();return B===void 0?[]:L.reduce(function(J,j){return j<=J[0][1]?J[0][1]=j+1:J.unshift([j,j+1]),J},[[B,B+1]]).reverse().map(J=>({start:J[0],end:J[1]}))}e.cellIndexesToRanges=b;function f(L){return L.reduce((J,j)=>{for(let U=j.start;U<j.end;U++)J.push(U);return J},[])}e.cellRangesToIndexes=f;function d(L){const B=L.sort((j,U)=>j.start-U.start),J=B[0];return J?B.reduce((j,U)=>{const $=j[j.length-1];return $.end>=U.start?$.end=Math.max($.end,U.end):j.push(U),j},[J]):[]}e.reduceRanges=d;function A(L,B){return B.start>=L.start&&B.end<=L.end}e.cellRangeContains=A}),define(ge[208],pe([0,1,173,4,80]),function(G,e,E,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new T.RawContextKey("customExecutionSupported",!0,E.localize(0,null)),e.ShellExecutionSupportedContext=new T.RawContextKey("shellExecutionSupported",!1,E.localize(1,null)),e.ProcessExecutionSupportedContext=new T.RawContextKey("processExecutionSupported",!1,E.localize(2,null)),e.ITaskService=(0,P.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(ge[209],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function E(T){return[...T.entries()]}e.serializeEnvironmentVariableCollection=E;function P(T){return new Map(T)}e.deserializeEnvironmentVariableCollection=P}),define(ge[210],pe([0,1,8,9,134]),function(G,e,E,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTerminalEnvironment=e.getDefaultShellArgs=e.getDefaultShell=e.createVariableResolver=e.escapeNonWindowsPath=e.getCwd=e.getLangEnvVariable=e.shouldSetLangEnvVariable=e.addTerminalEnvironmentKeys=e.mergeEnvironments=void 0;function I(l,t){if(!!t)if(P.isWindows)for(const i in t){let o=i;for(const a in l)if(i.toLowerCase()===a.toLowerCase()){o=a;break}const r=t[i];r!==void 0&&D(l,o,r)}else Object.keys(t).forEach(i=>{const o=t[i];o!==void 0&&D(l,i,o)})}e.mergeEnvironments=I;function D(l,t,i){typeof i=="string"?l[t]=i:delete l[t]}function k(l,t,i,o){l.TERM_PROGRAM="vscode",t&&(l.TERM_PROGRAM_VERSION=t),R(l,o)&&(l.LANG=C(i)),l.COLORTERM="truecolor"}e.addTerminalEnvironmentKeys=k;function y(l,t){if(!!t)for(const i of Object.keys(t)){const o=t[i];o&&(l[i]=o)}}function n(l,t){return Object.keys(t).forEach(i=>{const o=t[i];if(typeof o=="string")try{t[i]=l(o)}catch(r){t[i]=o}}),t}function R(l,t){if(t==="on")return!0;if(t==="auto"){const i=l.LANG;return!i||i.search(/\.UTF\-8$/)===-1&&i.search(/\.utf8$/)===-1&&i.search(/\.euc.+/)===-1}return!1}e.shouldSetLangEnvVariable=R;function C(l){const t=l?l.split("-"):[],i=t.length;if(i===0)return"en_US.UTF-8";if(i===1){const o={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};t[0]in o&&t.push(o[t[0]])}else t[1]=t[1].toUpperCase();return t.join("_")+".UTF-8"}e.getLangEnvVariable=C;function w(l,t,i,o,r,a){if(l.cwd){const m=typeof l.cwd=="object"?l.cwd.fsPath:l.cwd,b=g(m,i);return s(b||m)}let h;return!l.ignoreConfigurationCwd&&r&&(i&&(r=g(r,i,a)),r&&(E.isAbsolute(r)?h=r:o&&(h=E.join(o.fsPath,r)))),h||(h=o?o.fsPath:t||""),s(h)}e.getCwd=w;function g(l,t,i){if(t)try{return t(l)}catch(o){i==null||i.error("Could not resolve terminal cwd",o);return}return l}function s(l){return P.platform===3&&l&&l[1]===":"?l[0].toUpperCase()+l.substr(1):l}function u(l){let t=l;t.indexOf("\\")!==0&&(t=t.replace(/\\/g,"\\\\"));const i=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return t=t.replace(i,""),`'${t}'`}e.escapeNonWindowsPath=u;function S(l,t){if(!!t)return i=>t.resolve(l,i)}e.createVariableResolver=S;function v(l,t,i,o,r,a,h,m,b=P.platform){let f=null;m&&(f=p(l,t,"automationShell",b)),f||(f=p(l,t,"shell",b));let d=f||i;if(b===3&&!o&&r){const A=E.join(r,"Sysnative").replace(/\//g,"\\").toLowerCase();d&&d.toLowerCase().indexOf(A)===0&&(d=E.join(r,"System32",d.substr(A.length+1)))}if(d&&b===3&&(d=d.replace(/\//g,"\\")),a)try{d=a(d)}catch(A){h.error("Could not resolve shell",A)}return d}e.getDefaultShell=v;function _(l,t,i,o,r,a=P.platform){if(i&&p(l,t,"automationShell",a))return[];const h=a===3?"windows":a===1?"osx":"linux",m=l(`terminal.integrated.shellArgs.${h}`);let b=(t?m.value:m.userValue)||m.defaultValue;if(!b)return[];if(typeof b=="string"&&a===3)return o?o(b):b;if(o){const f=[];for(const d of b)try{f.push(o(d))}catch(A){r.error(`Could not resolve terminal.integrated.shellArgs.${h}`,A),f.push(d)}b=f}return b}e.getDefaultShellArgs=_;function p(l,t,i,o=P.platform){const a=l(`terminal.integrated.${i}.${o===3?"windows":o===1?"osx":"linux"}`);return(t?a.value:a.userValue)||a.defaultValue}function c(l,t,i,o,r,a,h){let m={};if(l.strictEnv)y(m,l.env);else{y(m,h);const b=Object.assign({},o?t.value:t.userValue);i&&(b&&n(i,b),l.env&&n(i,l.env)),(0,T.sanitizeProcessEnvironment)(m,"VSCODE_IPC_HOOK_CLI"),I(m,b),I(m,l.env),k(m,r,P.locale,a)}return m}e.createTerminalEnvironment=c});var rn=this&&this.__asyncValues||function(G){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=G[Symbol.asyncIterator],E;return e?e.call(G):(G=typeof __values=="function"?__values(G):G[Symbol.iterator](),E={},P("next"),P("throw"),P("return"),E[Symbol.asyncIterator]=function(){return this},E);function P(I){E[I]=G[I]&&function(D){return new Promise(function(k,y){D=G[I](D),T(k,y,D.done,D.value)})}}function T(I,D,k,y){Promise.resolve(y).then(function(n){I({value:n,done:k})},D)}};define(ge[211],pe([0,1,37,9,8,100,190,38,26,43]),function(G,e,E,P,T,I,D,k,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let R;function C(c,l,t,i,o,r,a){return l=l||{existsFile:y.SymlinkSupport.existsFile,readFile:E.promises.readFile},P.isWindows?w(c,l,t,i==null?void 0:i.useWslProfiles,i==null?void 0:i.profiles.windows,o,r):v(l,t,c,P.isMacintosh?i==null?void 0:i.profiles.osx:i==null?void 0:i.profiles.linux,a,o,r)}e.detectAvailableProfiles=C;async function w(c,l,t,i,o,r,a){const h=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),m=`${process.env.windir}\\${h?"Sysnative":"System32"}`;let b=!1;(0,D.getWindowsBuildNumber)()>=16299&&(b=!0),await s();const f=new Map;c||(f.set("PowerShell",{source:"PowerShell",icon:n.Codicon.terminalPowershell.id,isAutoDetected:!0}),f.set("Windows PowerShell",{path:`${m}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:n.Codicon.terminalPowershell.id,isAutoDetected:!0}),f.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),f.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),f.set("Command Prompt",{path:`${m}\\cmd.exe`,icon:n.Codicon.terminalCmd.id,isAutoDetected:!0})),_(o,f);const d=await g(f.entries(),l,t,r,a);if(!c||c&&i)try{const A=await S(`${m}\\${b?"wsl.exe":"bash.exe"}`,i);A&&d.push(...A)}catch(A){t==null||t.info("WSL is not installed, so could not detect WSL profiles")}return d}async function g(c,l,t,i,o){const r=[];for(const[a,h]of c)if(h!==null){let m,b,f;if("source"in h){const L=R==null?void 0:R.get(h.source);if(!L)continue;m=L.paths,b=h.args||L.args,f=h.icon||L.icon}else m=Array.isArray(h.path)?h.path:[h.path],b=P.isWindows||Array.isArray(h.args)?h.args:void 0,f=h.icon;const d=m.slice();for(let L=0;L<d.length;L++)d[L]=await(i==null?void 0:i.resolveAsync(o,d[L]))||d[L];const A=await p(a,d,l,b,h.env,h.overrideName,h.isAutoDetected,t);A?(A.isAutoDetected=h.isAutoDetected,A.icon=f,r.push(A)):t==null||t.trace("profile not validated",a,m)}return r}async function s(){R||(R=new Map,R.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`],args:["--login"]}),R.set("PowerShell",{profileName:"PowerShell",paths:await u(),icon:"terminal-powershell"}))}async function u(){var c,l;const t=[];try{for(var i=rn((0,I.enumeratePowerShellInstallations)()),o;o=await i.next(),!o.done;){const r=o.value;t.push(r.exePath)}}catch(r){c={error:r}}finally{try{o&&!o.done&&(l=i.return)&&await l.call(i)}finally{if(c)throw c.error}}return t}async function S(c,l){const t=[];if(l){const i=await new Promise((o,r)=>{k.exec("wsl.exe -l -q",{encoding:"utf16le"},(a,h)=>{if(a)return r("Problem occurred when getting wsl distros");o(h)})});if(i){const o=new RegExp(/[\r?\n]/),r=i.split(o).filter(a=>a.trim().length>0&&a!=="");for(let a of r)if(a!==""&&!a.startsWith("docker-desktop")){const h={profileName:`${a} (WSL)`,path:c,args:["-d",`${a}`]};a.includes("Debian")?h.icon="terminal-debian":h.icon="terminal-linux",t.push(h)}return t}}return[]}async function v(c,l,t,i,o,r,a){const h=new Map;if(!t){const m=await c.readFile("/etc/shells","utf8"),b=o||m.split(`
`).filter(d=>d.trim().indexOf("#")!==0&&d.trim().length>0),f=new Map;for(const d of b){let A=(0,T.basename)(d),L=f.get(A)||0;L++,L>1&&(A=`${A} (${L})`),f.set(A,L),h.set(A,{path:d,isAutoDetected:!0})}}return _(i,h),await g(h.entries(),c,l,r,a)}function _(c,l){if(!!c)for(const[t,i]of Object.entries(c))i===null||!("path"in i)&&!("source"in i)?l.delete(t):l.set(t,i)}async function p(c,l,t,i,o,r,a,h){if(l.length===0)return Promise.resolve(void 0);const m=l.shift();if(m==="")return p(c,l,t,i,o,r,a);const b={profileName:c,path:m,args:i,env:o,overrideName:r,isAutoDetected:a};if((0,T.basename)(m)===m){const d=process.env.PATH?process.env.PATH.split(T.delimiter):void 0;return await(0,D.findExecutable)(m,void 0,d,void 0,t.existsFile)?b:p(c,l,t,i)}return await t.existsFile((0,T.normalize)(m))?b:p(c,l,t,i,o,r,a)}}),define(ge[121],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=e.applyTestItemUpdate=e.TestItemExpandState=void 0;var E;(function(y){y[y.NotExpandable=0]="NotExpandable",y[y.Expandable=1]="Expandable",y[y.BusyExpanding=2]="BusyExpanding",y[y.Expanded=3]="Expanded"})(E=e.TestItemExpandState||(e.TestItemExpandState={}));const P=(y,n)=>{n.expand!==void 0&&(y.expand=n.expand),n.item!==void 0&&Object.assign(y.item,n.item)};e.applyTestItemUpdate=P;var T;(function(y){y[y.Add=0]="Add",y[y.Update=1]="Update",y[y.Remove=2]="Remove",y[y.DeltaRootsComplete=3]="DeltaRootsComplete",y[y.Retire=4]="Retire"})(T=e.TestDiffOpType||(e.TestDiffOpType={}));const I=(y,n)=>`${y}:${n.toString()}`;e.getTestSubscriptionKey=I;class D{add(n){}update(n){}remove(n,R){}complete(){}}e.IncrementalChangeCollector=D;class k{constructor(){this.items=new Map,this.roots=new Set,this.busyProviderCount=0,this.pendingRootCount=0}apply(n){const R=this.createChangeCollector();for(const C of n)switch(C[0]){case 0:{const w=C[1];if(w.parent){if(this.items.has(w.parent)){const g=this.items.get(w.parent);g.children.add(w.item.extId);const s=this.createItem(w,g);this.items.set(w.item.extId,s),R.add(s)}}else{this.roots.add(w.item.extId);const g=this.createItem(w);this.items.set(w.item.extId,g),R.add(g)}w.expand===2&&this.updateBusyProviders(1);break}case 1:{const w=C[1],g=this.items.get(w.extId);if(!g)break;(0,e.applyTestItemUpdate)(g,w),R.update(g),w.expand!==void 0&&g.expand===2&&w.expand!==2&&this.updateBusyProviders(-1);break}case 2:{const w=this.items.get(C[1]);if(!w)break;w.parent?this.items.get(w.parent).children.delete(w.item.extId):this.roots.delete(w.item.extId);const g=[[C[1]]];for(;g.length;)for(const s of g.pop()){const u=this.items.get(s);u&&(g.push(u.children),this.items.delete(s),R.remove(u,u!==w),u.expand===2&&this.updateBusyProviders(-1))}break}case 4:this.retireTest(C[1]);break;case 3:this.updatePendingRoots(C[1]);break}R.complete()}retireTest(n){}updateBusyProviders(n){this.busyProviderCount+=n}updatePendingRoots(n){this.pendingRootCount+=n}createChangeCollector(){return new D}}e.AbstractIncrementalTestCollection=k}),define(ge[212],pe([0,1,8,36,15,23,9,75,174]),function(G,e,E,P,T,I,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class n{constructor(C,w,g,s){if(this._contributedVariables=new Map,this._context=C,this._labelService=w,g)if(D.isWindows){const u=Object.create(null);this._envVariables=u,Object.keys(g).forEach(S=>{u[S.toLowerCase()]=g[S]})}else this._envVariables=g}resolveWithEnvironment(C,w,g){return this.recursiveResolve(C,w?w.uri:void 0,g)}async resolveAsync(C,w){return this.recursiveResolve(this._envVariables,C?C.uri:void 0,w)}resolve(C,w){return this.recursiveResolve(this._envVariables,C?C.uri:void 0,w)}resolveAnyBase(C,w,g,s){const u=I.deepClone(w);return D.isWindows&&u.windows?Object.keys(u.windows).forEach(S=>u[S]=u.windows[S]):D.isMacintosh&&u.osx?Object.keys(u.osx).forEach(S=>u[S]=u.osx[S]):D.isLinux&&u.linux&&Object.keys(u.linux).forEach(S=>u[S]=u.linux[S]),delete u.windows,delete u.osx,delete u.linux,this.recursiveResolve(this._envVariables,C?C.uri:void 0,u,g,s)}resolveAny(C,w,g){return this.resolveAnyBase(C,w,g)}async resolveAnyAsync(C,w,g){return this.resolveAnyBase(C,w,g)}resolveAnyMap(C,w,g){const s=new Map;return{newConfig:this.resolveAnyBase(C,w,g,s),resolvedVariables:s}}resolveWithInteractionReplace(C,w,g,s){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(C,w,g,s){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(C,w){if(this._contributedVariables.has(C))throw new Error("Variable "+C+" is contributed twice.");this._contributedVariables.set(C,w)}recursiveResolve(C,w,g,s,u){if(T.isString(g))return this.resolveString(C,w,g,s,u);if(T.isArray(g))return g.map(S=>this.recursiveResolve(C,w,S,s,u));if(T.isObject(g)){let S=Object.create(null);return Object.keys(g).forEach(v=>{const _=this.resolveString(C,w,v,s,u);S[_]=this.recursiveResolve(C,w,g[v],s,u)}),S}return g}resolveString(C,w,g,s,u){return g.replace(n.VARIABLE_REGEXP,(v,_)=>{if(_.includes(n.VARIABLE_LHS))return v;let p=this.evaluateSingleVariable(C,v,_,w,s);return u&&u.set(_,p),p})}fsPath(C){return this._labelService?this._labelService.getUriLabel(C,{noPrefix:!0}):C.fsPath}evaluateSingleVariable(C,w,g,s,u){let S;const v=g.split(":");v.length>1&&(g=v[0],S=v[1]);const _=()=>{const l=this._context.getFilePath();if(l)return l;throw new Error((0,y.localize)(0,null,w))},p=()=>{const l=_();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,y.localize)(1,null,w,E.basename(l)))},c=()=>{if(S){const l=this._context.getFolderUri(S);if(l)return l;throw new Error((0,y.localize)(2,null,w,S))}if(s)return s;throw this._context.getWorkspaceFolderCount()>1?new Error((0,y.localize)(3,null,w)):new Error((0,y.localize)(4,null,w))};switch(g){case"env":if(S){if(C){const l=C[D.isWindows?S.toLowerCase():S];if(T.isString(l))return l}return""}throw new Error((0,y.localize)(5,null,w));case"config":if(S){const l=this._context.getConfigurationValue(s,S);if(T.isUndefinedOrNull(l))throw new Error((0,y.localize)(6,null,w,S));if(T.isObject(l))throw new Error((0,y.localize)(7,null,w,S));return l}throw new Error((0,y.localize)(8,null,w));case"command":return this.resolveFromMap(w,S,u,"command");case"input":return this.resolveFromMap(w,S,u,"input");default:switch(g){case"workspaceRoot":case"workspaceFolder":return(0,k.normalizeDriveLetter)(this.fsPath(c()));case"cwd":return s||S?(0,k.normalizeDriveLetter)(this.fsPath(c())):P.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return E.basename(this.fsPath(c()));case"lineNumber":const l=this._context.getLineNumber();if(l)return l;throw new Error((0,y.localize)(9,null,w));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,y.localize)(10,null,w));case"file":return _();case"fileWorkspaceFolder":return p();case"relativeFile":return s||S?E.relative(this.fsPath(c()),_()):_();case"relativeFileDirname":const i=E.dirname(_());if(s||S){const h=E.relative(this.fsPath(c()),i);return h.length===0?".":h}return i;case"fileDirname":return E.dirname(_());case"fileExtname":return E.extname(_());case"fileBasename":return E.basename(_());case"fileBasenameNoExtension":const o=E.basename(_());return o.slice(0,o.length-E.extname(o).length);case"fileDirnameBasename":return E.basename(E.dirname(_()));case"execPath":const r=this._context.getExecPath();return r||w;case"execInstallFolder":const a=this._context.getAppRoot();return a||w;case"pathSeparator":return E.sep;default:try{const h=S?`${g}:${S}`:g;return this.resolveFromMap(w,h,u,void 0)}catch(h){return w}}}}resolveFromMap(C,w,g,s){if(w&&g){const u=s===void 0?g[w]:g[s+":"+w];if(typeof u=="string")return u;throw new Error((0,y.localize)(11,null,C))}return C}}e.AbstractVariableResolverService=n,n.VARIABLE_LHS="${",n.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ge[213],pe([0,1,4]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,E.createDecorator)("editorGroupsService");var P;(function(w){w[w.UP=0]="UP",w[w.DOWN=1]="DOWN",w[w.LEFT=2]="LEFT",w[w.RIGHT=3]="RIGHT"})(P=e.GroupDirection||(e.GroupDirection={}));var T;(function(w){w[w.HORIZONTAL=0]="HORIZONTAL",w[w.VERTICAL=1]="VERTICAL"})(T=e.GroupOrientation||(e.GroupOrientation={}));var I;(function(w){w[w.FIRST=0]="FIRST",w[w.LAST=1]="LAST",w[w.NEXT=2]="NEXT",w[w.PREVIOUS=3]="PREVIOUS"})(I=e.GroupLocation||(e.GroupLocation={}));var D;(function(w){w[w.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",w[w.EVEN=1]="EVEN",w[w.TOGGLE=2]="TOGGLE"})(D=e.GroupsArrangement||(e.GroupsArrangement={}));var k;(function(w){w[w.COPY_EDITORS=0]="COPY_EDITORS",w[w.MOVE_EDITORS=1]="MOVE_EDITORS"})(k=e.MergeGroupMode||(e.MergeGroupMode={}));var y;(function(w){w[w.CREATION_TIME=0]="CREATION_TIME",w[w.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",w[w.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(y=e.GroupsOrder||(e.GroupsOrder={}));var n;(function(w){w[w.GROUP_ACTIVE=0]="GROUP_ACTIVE",w[w.GROUP_INDEX=1]="GROUP_INDEX",w[w.EDITOR_OPEN=2]="EDITOR_OPEN",w[w.EDITOR_CLOSE=3]="EDITOR_CLOSE",w[w.EDITOR_MOVE=4]="EDITOR_MOVE",w[w.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",w[w.EDITOR_LABEL=6]="EDITOR_LABEL",w[w.EDITOR_PIN=7]="EDITOR_PIN",w[w.EDITOR_STICKY=8]="EDITOR_STICKY",w[w.EDITOR_DIRTY=9]="EDITOR_DIRTY"})(n=e.GroupChangeKind||(e.GroupChangeKind={}));var R;(function(w){w[w.NEW_EDITOR=1]="NEW_EDITOR",w[w.MOVE_EDITOR=2]="MOVE_EDITOR",w[w.COPY_EDITOR=3]="COPY_EDITOR"})(R=e.OpenEditorContext||(e.OpenEditorContext={}));function C(w){return w.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=C}),define(ge[214],pe([0,1,4]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,E.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(ge[20],pe([0,1,14,94,285,57,23,15,2,44,79,175,110,85,214,7]),function(G,e,E,P,T,I,D,k,y,n,R,C,w,g,s,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.NotebookDocumentContentOptions=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookCellKind=e.NotebookCellPreviousExecutionResult=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookCellRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlineHintKind=e.InlineHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var S;(function(Ee){function fe(ee){const{selectionStartLineNumber:Ae,selectionStartColumn:Le,positionLineNumber:Qe,positionColumn:Ge}=ee,rt=new u.Position(Ae-1,Le-1),ut=new u.Position(Qe-1,Ge-1);return new u.Selection(rt,ut)}Ee.to=fe;function ce(ee){const{anchor:Ae,active:Le}=ee;return{selectionStartLineNumber:Ae.line+1,selectionStartColumn:Ae.character+1,positionLineNumber:Le.line+1,positionColumn:Le.character+1}}Ee.from=ce})(S=e.Selection||(e.Selection={}));var v;(function(Ee){function fe(ee){if(!!ee){const{start:Ae,end:Le}=ee;return{startLineNumber:Ae.line+1,startColumn:Ae.character+1,endLineNumber:Le.line+1,endColumn:Le.character+1}}}Ee.from=fe;function ce(ee){if(!!ee){const{startLineNumber:Ae,startColumn:Le,endLineNumber:Qe,endColumn:Ge}=ee;return new u.Range(Ae-1,Le-1,Qe-1,Ge-1)}}Ee.to=ce})(v=e.Range||(e.Range={}));var _;(function(Ee){function fe(ce){switch(ce){case 1:return u.StandardTokenType.Comment;case 0:return u.StandardTokenType.Other;case 4:return u.StandardTokenType.RegEx;case 2:return u.StandardTokenType.String}}Ee.to=fe})(_=e.TokenType||(e.TokenType={}));var p;(function(Ee){function fe(ee){return new u.Position(ee.lineNumber-1,ee.column-1)}Ee.to=fe;function ce(ee){return{lineNumber:ee.line+1,column:ee.character+1}}Ee.from=ce})(p=e.Position||(e.Position={}));var c;(function(Ee){function fe(ee){switch(ee){case u.DiagnosticTag.Unnecessary:return 1;case u.DiagnosticTag.Deprecated:return 2}}Ee.from=fe;function ce(ee){switch(ee){case 1:return u.DiagnosticTag.Unnecessary;case 2:return u.DiagnosticTag.Deprecated;default:return}}Ee.to=ce})(c=e.DiagnosticTag||(e.DiagnosticTag={}));var l;(function(Ee){function fe(ee){let Ae;return ee.code&&((0,k.isString)(ee.code)||(0,k.isNumber)(ee.code)?Ae=String(ee.code):Ae={value:String(ee.code.value),target:ee.code.target}),Object.assign(Object.assign({},v.from(ee.range)),{message:ee.message,source:ee.source,code:Ae,severity:i.from(ee.severity),relatedInformation:ee.relatedInformation&&ee.relatedInformation.map(t.from),tags:Array.isArray(ee.tags)?(0,E.coalesce)(ee.tags.map(c.from)):void 0})}Ee.from=fe;function ce(ee){var Ae;const Le=new u.Diagnostic(v.to(ee),ee.message,i.to(ee.severity));return Le.source=ee.source,Le.code=(0,k.isString)(ee.code)?ee.code:(Ae=ee.code)===null||Ae===void 0?void 0:Ae.value,Le.relatedInformation=ee.relatedInformation&&ee.relatedInformation.map(t.to),Le.tags=ee.tags&&(0,E.coalesce)(ee.tags.map(c.to)),Le}Ee.to=ce})(l=e.Diagnostic||(e.Diagnostic={}));var t;(function(Ee){function fe(ee){return Object.assign(Object.assign({},v.from(ee.location.range)),{message:ee.message,resource:ee.location.uri})}Ee.from=fe;function ce(ee){return new u.DiagnosticRelatedInformation(new u.Location(ee.resource,v.to(ee)),ee.message)}Ee.to=ce})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var i;(function(Ee){function fe(ee){switch(ee){case u.DiagnosticSeverity.Error:return w.MarkerSeverity.Error;case u.DiagnosticSeverity.Warning:return w.MarkerSeverity.Warning;case u.DiagnosticSeverity.Information:return w.MarkerSeverity.Info;case u.DiagnosticSeverity.Hint:return w.MarkerSeverity.Hint}return w.MarkerSeverity.Error}Ee.from=fe;function ce(ee){switch(ee){case w.MarkerSeverity.Info:return u.DiagnosticSeverity.Information;case w.MarkerSeverity.Warning:return u.DiagnosticSeverity.Warning;case w.MarkerSeverity.Error:return u.DiagnosticSeverity.Error;case w.MarkerSeverity.Hint:return u.DiagnosticSeverity.Hint;default:return u.DiagnosticSeverity.Error}}Ee.to=ce})(i=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var o;(function(Ee){function fe(ee){return typeof ee=="number"&&ee>=u.ViewColumn.One?ee-1:ee===u.ViewColumn.Beside?s.SIDE_GROUP:s.ACTIVE_GROUP}Ee.from=fe;function ce(ee){if(typeof ee=="number"&&ee>=0)return ee+1;throw new Error("invalid 'EditorGroupColumn'")}Ee.to=ce})(o=e.ViewColumn||(e.ViewColumn={}));function r(Ee){return typeof Ee.range!="undefined"}function a(Ee){return Ee.length===0?!0:!!r(Ee[0])}e.isDecorationOptionsArr=a;var h;(function(Ee){function fe(Ge){return Ge.map(Ee.from)}Ee.fromMany=fe;function ce(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function ee(Ge){let rt;if(ce(Ge)){const{language:ct,value:ot}=Ge;rt={value:"```"+ct+`
`+ot+"\n```\n"}}else u.MarkdownString.isMarkdownString(Ge)?rt={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons}:typeof Ge=="string"?rt={value:Ge}:rt={value:""};const ut=Object.create(null);rt.uris=ut;const Ye=ct=>{try{let ot=y.URI.parse(ct,!0);ot=ot.with({query:Ae(ot.query,ut)}),ut[ct]=ot}catch(ot){}return""},at=new T.Renderer;return at.link=Ye,at.image=ct=>Ye(P.parseHrefAndDimensions(ct).href),T(rt.value,{renderer:at}),rt}Ee.from=ee;function Ae(Ge,rt){if(!Ge)return Ge;let ut;try{ut=(0,I.parse)(Ge)}catch(at){}if(!ut)return Ge;let Ye=!1;return ut=(0,D.cloneAndChange)(ut,at=>{if(y.URI.isUri(at)){const ct=`__uri_${Math.random().toString(16).slice(2,8)}`;return rt[ct]=at,Ye=!0,ct}else return}),Ye?JSON.stringify(ut):Ge}function Le(Ge){const rt=new u.MarkdownString(Ge.value,Ge.supportThemeIcons);return rt.isTrusted=Ge.isTrusted,rt}Ee.to=Le;function Qe(Ge){if(!!Ge)return typeof Ge=="string"?Ge:Ee.from(Ge)}Ee.fromStrict=Qe})(h=e.MarkdownString||(e.MarkdownString={}));function m(Ee){return a(Ee)?Ee.map(fe=>({range:v.from(fe.range),hoverMessage:Array.isArray(fe.hoverMessage)?h.fromMany(fe.hoverMessage):fe.hoverMessage?h.from(fe.hoverMessage):void 0,renderOptions:fe.renderOptions})):Ee.map(fe=>({range:v.from(fe)}))}e.fromRangeOrRangeWithMessage=m;function b(Ee){return typeof Ee=="undefined"?Ee:typeof Ee=="string"?y.URI.file(Ee):Ee}e.pathOrURIToURI=b;var f;(function(Ee){function fe(ce){return typeof ce=="undefined"?ce:{contentText:ce.contentText,contentIconPath:ce.contentIconPath?b(ce.contentIconPath):void 0,border:ce.border,borderColor:ce.borderColor,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,color:ce.color,backgroundColor:ce.backgroundColor,margin:ce.margin,width:ce.width,height:ce.height}}Ee.from=fe})(f=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var d;(function(Ee){function fe(ce){return typeof ce=="undefined"?ce:{backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?b(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?f.from(ce.before):void 0,after:ce.after?f.from(ce.after):void 0}}Ee.from=fe})(d=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var A;(function(Ee){function fe(ce){if(typeof ce=="undefined")return ce;switch(ce){case u.DecorationRangeBehavior.OpenOpen:return 0;case u.DecorationRangeBehavior.ClosedClosed:return 1;case u.DecorationRangeBehavior.OpenClosed:return 2;case u.DecorationRangeBehavior.ClosedOpen:return 3}}Ee.from=fe})(A=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var L;(function(Ee){function fe(ce){return{isWholeLine:ce.isWholeLine,rangeBehavior:ce.rangeBehavior?A.from(ce.rangeBehavior):void 0,overviewRulerLane:ce.overviewRulerLane,light:ce.light?d.from(ce.light):void 0,dark:ce.dark?d.from(ce.dark):void 0,backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?b(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?f.from(ce.before):void 0,after:ce.after?f.from(ce.after):void 0}}Ee.from=fe})(L=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var B;(function(Ee){function fe(ee){return{text:ee.newText,eol:ee.newEol&&se.from(ee.newEol),range:v.from(ee.range)}}Ee.from=fe;function ce(ee){const Ae=new u.TextEdit(v.to(ee.range),ee.text);return Ae.newEol=typeof ee.eol=="undefined"?void 0:se.to(ee.eol),Ae}Ee.to=ce})(B=e.TextEdit||(e.TextEdit={}));var J;(function(Ee){function fe(ee,Ae,Le){var Qe,Ge,rt;const ut={edits:[]};if(ee instanceof u.WorkspaceEdit)for(let Ye of ee._allEntries())if(Ye._type===1)ut.edits.push({_type:1,oldUri:Ye.from,newUri:Ye.to,options:Ye.options,metadata:Ye.metadata});else if(Ye._type===2){const at=Ae==null?void 0:Ae.getDocument(Ye.uri);ut.edits.push({_type:2,resource:Ye.uri,edit:B.from(Ye.edit),modelVersionId:at==null?void 0:at.version,metadata:Ye.metadata})}else Ye._type===3?ut.edits.push({_type:3,metadata:Ye.metadata,resource:Ye.uri,edit:Ye.edit,notebookMetadata:Ye.notebookMetadata,notebookVersionId:(Qe=Le==null?void 0:Le.lookupNotebookDocument(Ye.uri))===null||Qe===void 0?void 0:Qe.notebookDocument.version}):Ye._type===4?(Ye.newOutputs&&ut.edits.push({_type:3,metadata:Ye.metadata,resource:Ye.uri,edit:{editType:2,index:Ye.index,append:Ye.append,outputs:Ye.newOutputs.map(We.from)}}),Ye.newMetadata&&ut.edits.push({_type:3,metadata:Ye.metadata,resource:Ye.uri,edit:{editType:11,index:Ye.index,metadata:Ye.newMetadata}})):Ye._type===5?ut.edits.push({_type:3,metadata:Ye.metadata,resource:Ye.uri,notebookVersionId:(Ge=Le==null?void 0:Le.lookupNotebookDocument(Ye.uri))===null||Ge===void 0?void 0:Ge.notebookDocument.version,edit:{editType:1,index:Ye.index,count:Ye.count,cells:Ye.cells.map(ve.from)}}):Ye._type===6&&ut.edits.push({_type:3,metadata:Ye.metadata,resource:Ye.uri,edit:{editType:10,outputId:Ye.outputId,items:((rt=Ye.newOutputItems)===null||rt===void 0?void 0:rt.map(ye.from))||[],append:Ye.append}});return ut}Ee.from=fe;function ce(ee){const Ae=new u.WorkspaceEdit;for(const Le of ee.edits)Le.edit?Ae.replace(y.URI.revive(Le.resource),v.to(Le.edit.range),Le.edit.text):Ae.renameFile(y.URI.revive(Le.oldUri),y.URI.revive(Le.newUri),Le.options);return Ae}Ee.to=ce})(J=e.WorkspaceEdit||(e.WorkspaceEdit={}));var j;(function(Ee){const fe=Object.create(null);fe[u.SymbolKind.File]=0,fe[u.SymbolKind.Module]=1,fe[u.SymbolKind.Namespace]=2,fe[u.SymbolKind.Package]=3,fe[u.SymbolKind.Class]=4,fe[u.SymbolKind.Method]=5,fe[u.SymbolKind.Property]=6,fe[u.SymbolKind.Field]=7,fe[u.SymbolKind.Constructor]=8,fe[u.SymbolKind.Enum]=9,fe[u.SymbolKind.Interface]=10,fe[u.SymbolKind.Function]=11,fe[u.SymbolKind.Variable]=12,fe[u.SymbolKind.Constant]=13,fe[u.SymbolKind.String]=14,fe[u.SymbolKind.Number]=15,fe[u.SymbolKind.Boolean]=16,fe[u.SymbolKind.Array]=17,fe[u.SymbolKind.Object]=18,fe[u.SymbolKind.Key]=19,fe[u.SymbolKind.Null]=20,fe[u.SymbolKind.EnumMember]=21,fe[u.SymbolKind.Struct]=22,fe[u.SymbolKind.Event]=23,fe[u.SymbolKind.Operator]=24,fe[u.SymbolKind.TypeParameter]=25;function ce(Ae){return typeof fe[Ae]=="number"?fe[Ae]:6}Ee.from=ce;function ee(Ae){for(const Le in fe)if(fe[Le]===Ae)return Number(Le);return u.SymbolKind.Property}Ee.to=ee})(j=e.SymbolKind||(e.SymbolKind={}));var U;(function(Ee){function fe(ee){switch(ee){case u.SymbolTag.Deprecated:return 1}}Ee.from=fe;function ce(ee){switch(ee){case 1:return u.SymbolTag.Deprecated}}Ee.to=ce})(U=e.SymbolTag||(e.SymbolTag={}));var $;(function(Ee){function fe(ee){return{name:ee.name,kind:j.from(ee.kind),tags:ee.tags&&ee.tags.map(U.from),containerName:ee.containerName,location:O.from(ee.location)}}Ee.from=fe;function ce(ee){const Ae=new u.SymbolInformation(ee.name,j.to(ee.kind),ee.containerName,O.to(ee.location));return Ae.tags=ee.tags&&ee.tags.map(U.to),Ae}Ee.to=ce})($=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var F;(function(Ee){function fe(ee){var Ae,Le;const Qe={name:ee.name||"!!MISSING: name!!",detail:ee.detail,range:v.from(ee.range),selectionRange:v.from(ee.selectionRange),kind:j.from(ee.kind),tags:(Le=(Ae=ee.tags)===null||Ae===void 0?void 0:Ae.map(U.from))!==null&&Le!==void 0?Le:[]};return ee.children&&(Qe.children=ee.children.map(fe)),Qe}Ee.from=fe;function ce(ee){const Ae=new u.DocumentSymbol(ee.name,ee.detail,j.to(ee.kind),v.to(ee.range),v.to(ee.selectionRange));return(0,E.isNonEmptyArray)(ee.tags)&&(Ae.tags=ee.tags.map(U.to)),ee.children&&(Ae.children=ee.children.map(ce)),Ae}Ee.to=ce})(F=e.DocumentSymbol||(e.DocumentSymbol={}));var N;(function(Ee){function fe(ce){const ee=new u.CallHierarchyItem(j.to(ce.kind),ce.name,ce.detail||"",y.URI.revive(ce.uri),v.to(ce.range),v.to(ce.selectionRange));return ee._sessionId=ce._sessionId,ee._itemId=ce._itemId,ee}Ee.to=fe})(N=e.CallHierarchyItem||(e.CallHierarchyItem={}));var M;(function(Ee){function fe(ce){return new u.CallHierarchyIncomingCall(N.to(ce.from),ce.fromRanges.map(ee=>v.to(ee)))}Ee.to=fe})(M=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var x;(function(Ee){function fe(ce){return new u.CallHierarchyOutgoingCall(N.to(ce.to),ce.fromRanges.map(ee=>v.to(ee)))}Ee.to=fe})(x=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var O;(function(Ee){function fe(ee){return{range:ee.range&&v.from(ee.range),uri:ee.uri}}Ee.from=fe;function ce(ee){return new u.Location(y.URI.revive(ee.uri),v.to(ee.range))}Ee.to=ce})(O=e.location||(e.location={}));var V;(function(Ee){function fe(ee){const Ae=ee,Le=ee;return{originSelectionRange:Ae.originSelectionRange?v.from(Ae.originSelectionRange):void 0,uri:Ae.targetUri?Ae.targetUri:Le.uri,range:v.from(Ae.targetRange?Ae.targetRange:Le.range),targetSelectionRange:Ae.targetSelectionRange?v.from(Ae.targetSelectionRange):void 0}}Ee.from=fe;function ce(ee){return{targetUri:y.URI.revive(ee.uri),targetRange:v.to(ee.range),targetSelectionRange:ee.targetSelectionRange?v.to(ee.targetSelectionRange):void 0,originSelectionRange:ee.originSelectionRange?v.to(ee.originSelectionRange):void 0}}Ee.to=ce})(V=e.DefinitionLink||(e.DefinitionLink={}));var q;(function(Ee){function fe(ee){return{range:v.from(ee.range),contents:h.fromMany(ee.contents)}}Ee.from=fe;function ce(ee){return new u.Hover(ee.contents.map(h.to),v.to(ee.range))}Ee.to=ce})(q=e.Hover||(e.Hover={}));var X;(function(Ee){function fe(ee){return{range:v.from(ee.range),expression:ee.expression}}Ee.from=fe;function ce(ee){return new u.EvaluatableExpression(v.to(ee.range),ee.expression)}Ee.to=ce})(X=e.EvaluatableExpression||(e.EvaluatableExpression={}));var me;(function(Ee){function fe(ee){if(ee instanceof u.InlineValueText)return{type:"text",range:v.from(ee.range),text:ee.text};if(ee instanceof u.InlineValueVariableLookup)return{type:"variable",range:v.from(ee.range),variableName:ee.variableName,caseSensitiveLookup:ee.caseSensitiveLookup};if(ee instanceof u.InlineValueEvaluatableExpression)return{type:"expression",range:v.from(ee.range),expression:ee.expression};throw new Error("Unknown 'InlineValue' type")}Ee.from=fe;function ce(ee){switch(ee.type){case"text":return{range:v.to(ee.range),text:ee.text};case"variable":return{range:v.to(ee.range),variableName:ee.variableName,caseSensitiveLookup:ee.caseSensitiveLookup};case"expression":return{range:v.to(ee.range),expression:ee.expression}}}Ee.to=ce})(me=e.InlineValue||(e.InlineValue={}));var we;(function(Ee){function fe(ee){return{frameId:ee.frameId,stoppedLocation:v.from(ee.stoppedLocation)}}Ee.from=fe;function ce(ee){return new u.InlineValueContext(ee.frameId,v.to(ee.stoppedLocation))}Ee.to=ce})(we=e.InlineValueContext||(e.InlineValueContext={}));var Te;(function(Ee){function fe(ee){return{range:v.from(ee.range),kind:ee.kind}}Ee.from=fe;function ce(ee){return new u.DocumentHighlight(v.to(ee.range),ee.kind)}Ee.to=ce})(Te=e.DocumentHighlight||(e.DocumentHighlight={}));var Pe;(function(Ee){function fe(ce){switch(ce){case 1:return u.CompletionTriggerKind.TriggerCharacter;case 2:return u.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return u.CompletionTriggerKind.Invoke}}Ee.to=fe})(Pe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Fe;(function(Ee){function fe(ce){return{triggerKind:Pe.to(ce.triggerKind),triggerCharacter:ce.triggerCharacter}}Ee.to=fe})(Fe=e.CompletionContext||(e.CompletionContext={}));var z;(function(Ee){function fe(ee){switch(ee){case u.CompletionItemTag.Deprecated:return 1}}Ee.from=fe;function ce(ee){switch(ee){case 1:return u.CompletionItemTag.Deprecated}}Ee.to=ce})(z=e.CompletionItemTag||(e.CompletionItemTag={}));var Y;(function(Ee){const fe=new Map([[u.CompletionItemKind.Method,0],[u.CompletionItemKind.Function,1],[u.CompletionItemKind.Constructor,2],[u.CompletionItemKind.Field,3],[u.CompletionItemKind.Variable,4],[u.CompletionItemKind.Class,5],[u.CompletionItemKind.Interface,7],[u.CompletionItemKind.Struct,6],[u.CompletionItemKind.Module,8],[u.CompletionItemKind.Property,9],[u.CompletionItemKind.Unit,12],[u.CompletionItemKind.Value,13],[u.CompletionItemKind.Constant,14],[u.CompletionItemKind.Enum,15],[u.CompletionItemKind.EnumMember,16],[u.CompletionItemKind.Keyword,17],[u.CompletionItemKind.Snippet,27],[u.CompletionItemKind.Text,18],[u.CompletionItemKind.Color,19],[u.CompletionItemKind.File,20],[u.CompletionItemKind.Reference,21],[u.CompletionItemKind.Folder,23],[u.CompletionItemKind.Event,10],[u.CompletionItemKind.Operator,11],[u.CompletionItemKind.TypeParameter,24],[u.CompletionItemKind.Issue,26],[u.CompletionItemKind.User,25]]);function ce(Le){var Qe;return(Qe=fe.get(Le))!==null&&Qe!==void 0?Qe:9}Ee.from=ce;const ee=new Map([[0,u.CompletionItemKind.Method],[1,u.CompletionItemKind.Function],[2,u.CompletionItemKind.Constructor],[3,u.CompletionItemKind.Field],[4,u.CompletionItemKind.Variable],[5,u.CompletionItemKind.Class],[7,u.CompletionItemKind.Interface],[6,u.CompletionItemKind.Struct],[8,u.CompletionItemKind.Module],[9,u.CompletionItemKind.Property],[12,u.CompletionItemKind.Unit],[13,u.CompletionItemKind.Value],[14,u.CompletionItemKind.Constant],[15,u.CompletionItemKind.Enum],[16,u.CompletionItemKind.EnumMember],[17,u.CompletionItemKind.Keyword],[27,u.CompletionItemKind.Snippet],[18,u.CompletionItemKind.Text],[19,u.CompletionItemKind.Color],[20,u.CompletionItemKind.File],[21,u.CompletionItemKind.Reference],[23,u.CompletionItemKind.Folder],[10,u.CompletionItemKind.Event],[11,u.CompletionItemKind.Operator],[24,u.CompletionItemKind.TypeParameter],[25,u.CompletionItemKind.User],[26,u.CompletionItemKind.Issue]]);function Ae(Le){var Qe;return(Qe=ee.get(Le))!==null&&Qe!==void 0?Qe:u.CompletionItemKind.Property}Ee.to=Ae})(Y=e.CompletionItemKind||(e.CompletionItemKind={}));var te;(function(Ee){function fe(ce,ee){var Ae;const Le=new u.CompletionItem(typeof ce.label=="string"?ce.label:ce.label.name);return typeof ce.label!="string"&&(Le.label2=ce.label),Le.insertText=ce.insertText,Le.kind=Y.to(ce.kind),Le.tags=(Ae=ce.tags)===null||Ae===void 0?void 0:Ae.map(z.to),Le.detail=ce.detail,Le.documentation=P.isMarkdownString(ce.documentation)?h.to(ce.documentation):ce.documentation,Le.sortText=ce.sortText,Le.filterText=ce.filterText,Le.preselect=ce.preselect,Le.commitCharacters=ce.commitCharacters,n.Range.isIRange(ce.range)?Le.range=v.to(ce.range):typeof ce.range=="object"&&(Le.range={inserting:v.to(ce.range.insert),replacing:v.to(ce.range.replace)}),Le.keepWhitespace=typeof ce.insertTextRules=="undefined"?!1:Boolean(ce.insertTextRules&1),typeof ce.insertTextRules!="undefined"&&ce.insertTextRules&4?Le.insertText=new u.SnippetString(ce.insertText):(Le.insertText=ce.insertText,Le.textEdit=Le.range instanceof u.Range?new u.TextEdit(Le.range,Le.insertText):void 0),ce.additionalTextEdits&&ce.additionalTextEdits.length>0&&(Le.additionalTextEdits=ce.additionalTextEdits.map(Qe=>B.to(Qe))),Le.command=ee&&ce.command?ee.fromInternal(ce.command):void 0,Le}Ee.to=fe})(te=e.CompletionItem||(e.CompletionItem={}));var ae;(function(Ee){function fe(ee){return{label:ee.label,documentation:ee.documentation?h.fromStrict(ee.documentation):void 0}}Ee.from=fe;function ce(ee){return{label:ee.label,documentation:P.isMarkdownString(ee.documentation)?h.to(ee.documentation):ee.documentation}}Ee.to=ce})(ae=e.ParameterInformation||(e.ParameterInformation={}));var he;(function(Ee){function fe(ee){return{label:ee.label,documentation:ee.documentation?h.fromStrict(ee.documentation):void 0,parameters:Array.isArray(ee.parameters)?ee.parameters.map(ae.from):[],activeParameter:ee.activeParameter}}Ee.from=fe;function ce(ee){return{label:ee.label,documentation:P.isMarkdownString(ee.documentation)?h.to(ee.documentation):ee.documentation,parameters:Array.isArray(ee.parameters)?ee.parameters.map(ae.to):[],activeParameter:ee.activeParameter}}Ee.to=ce})(he=e.SignatureInformation||(e.SignatureInformation={}));var Ce;(function(Ee){function fe(ee){return{activeSignature:ee.activeSignature,activeParameter:ee.activeParameter,signatures:Array.isArray(ee.signatures)?ee.signatures.map(he.from):[]}}Ee.from=fe;function ce(ee){return{activeSignature:ee.activeSignature,activeParameter:ee.activeParameter,signatures:Array.isArray(ee.signatures)?ee.signatures.map(he.to):[]}}Ee.to=ce})(Ce=e.SignatureHelp||(e.SignatureHelp={}));var Oe;(function(Ee){function fe(ee){var Ae;return{text:ee.text,range:v.from(ee.range),kind:be.from((Ae=ee.kind)!==null&&Ae!==void 0?Ae:u.InlineHintKind.Other),description:ee.description&&h.fromStrict(ee.description),whitespaceBefore:ee.whitespaceBefore,whitespaceAfter:ee.whitespaceAfter}}Ee.from=fe;function ce(ee){const Ae=new u.InlineHint(ee.text,v.to(ee.range),be.to(ee.kind));return Ae.whitespaceAfter=ee.whitespaceAfter,Ae.whitespaceBefore=ee.whitespaceBefore,Ae.description=P.isMarkdownString(ee.description)?h.to(ee.description):ee.description,Ae}Ee.to=ce})(Oe=e.InlineHint||(e.InlineHint={}));var be;(function(Ee){function fe(ee){return ee}Ee.from=fe;function ce(ee){return ee}Ee.to=ce})(be=e.InlineHintKind||(e.InlineHintKind={}));var ke;(function(Ee){function fe(ee){return{range:v.from(ee.range),url:ee.target,tooltip:ee.tooltip}}Ee.from=fe;function ce(ee){let Ae;if(ee.url)try{Ae=typeof ee.url=="string"?y.URI.parse(ee.url,!0):y.URI.revive(ee.url)}catch(Le){}return new u.DocumentLink(v.to(ee.range),Ae)}Ee.to=ce})(ke=e.DocumentLink||(e.DocumentLink={}));var Re;(function(Ee){function fe(ee){const Ae=new u.ColorPresentation(ee.label);return ee.textEdit&&(Ae.textEdit=B.to(ee.textEdit)),ee.additionalTextEdits&&(Ae.additionalTextEdits=ee.additionalTextEdits.map(Le=>B.to(Le))),Ae}Ee.to=fe;function ce(ee){return{label:ee.label,textEdit:ee.textEdit?B.from(ee.textEdit):void 0,additionalTextEdits:ee.additionalTextEdits?ee.additionalTextEdits.map(Ae=>B.from(Ae)):void 0}}Ee.from=ce})(Re=e.ColorPresentation||(e.ColorPresentation={}));var Be;(function(Ee){function fe(ee){return new u.Color(ee[0],ee[1],ee[2],ee[3])}Ee.to=fe;function ce(ee){return[ee.red,ee.green,ee.blue,ee.alpha]}Ee.from=ce})(Be=e.Color||(e.Color={}));var Se;(function(Ee){function fe(ee){return{range:v.from(ee.range)}}Ee.from=fe;function ce(ee){return new u.SelectionRange(v.to(ee.range))}Ee.to=ce})(Se=e.SelectionRange||(e.SelectionRange={}));var Ke;(function(Ee){function fe(ce){switch(ce){case 2:return u.TextDocumentSaveReason.AfterDelay;case 1:return u.TextDocumentSaveReason.Manual;case 3:case 4:return u.TextDocumentSaveReason.FocusOut}}Ee.to=fe})(Ke=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Q;(function(Ee){function fe(ee){switch(ee){case u.TextEditorLineNumbersStyle.Off:return 0;case u.TextEditorLineNumbersStyle.Relative:return 2;case u.TextEditorLineNumbersStyle.On:default:return 1}}Ee.from=fe;function ce(ee){switch(ee){case 0:return u.TextEditorLineNumbersStyle.Off;case 2:return u.TextEditorLineNumbersStyle.Relative;case 1:default:return u.TextEditorLineNumbersStyle.On}}Ee.to=ce})(Q=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var se;(function(Ee){function fe(ee){if(ee===u.EndOfLine.CRLF)return 1;if(ee===u.EndOfLine.LF)return 0}Ee.from=fe;function ce(ee){if(ee===1)return u.EndOfLine.CRLF;if(ee===0)return u.EndOfLine.LF}Ee.to=ce})(se=e.EndOfLine||(e.EndOfLine={}));var _e;(function(Ee){function fe(ce){if(typeof ce=="object")return ce.viewId;switch(ce){case u.ProgressLocation.SourceControl:return 3;case u.ProgressLocation.Window:return 10;case u.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ee.from=fe})(_e=e.ProgressLocation||(e.ProgressLocation={}));var xe;(function(Ee){function fe(ce){const ee={start:ce.start+1,end:ce.end+1};return ce.kind&&(ee.kind=Ve.from(ce.kind)),ee}Ee.from=fe})(xe=e.FoldingRange||(e.FoldingRange={}));var Ve;(function(Ee){function fe(ce){if(ce)switch(ce){case u.FoldingRangeKind.Comment:return R.FoldingRangeKind.Comment;case u.FoldingRangeKind.Imports:return R.FoldingRangeKind.Imports;case u.FoldingRangeKind.Region:return R.FoldingRangeKind.Region}}Ee.from=fe})(Ve=e.FoldingRangeKind||(e.FoldingRangeKind={}));var $e;(function(Ee){function fe(ce){if(ce)return{pinned:typeof ce.preview=="boolean"?!ce.preview:void 0,inactive:ce.background,preserveFocus:ce.preserveFocus,selection:typeof ce.selection=="object"?v.from(ce.selection):void 0,override:typeof ce.override=="boolean"?C.EditorOverride.DISABLED:void 0}}Ee.from=fe})($e=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Ze;(function(Ee){function fe(ee){return ee instanceof u.RelativePattern||typeof ee=="string"?ee:ce(ee)?new u.RelativePattern(ee.base,ee.pattern):ee}Ee.from=fe;function ce(ee){const Ae=ee;return Ae&&typeof Ae.base=="string"&&typeof Ae.pattern=="string"}})(Ze=e.GlobPattern||(e.GlobPattern={}));var K;(function(Ee){function fe(ce){if(ce){if(Array.isArray(ce))return ce.map(fe);if(typeof ce=="string")return ce;{const ee=ce;return{language:ee.language,scheme:ee.scheme,pattern:typeof ee.pattern=="undefined"?void 0:Ze.from(ee.pattern),exclusive:ee.exclusive}}}else return}Ee.from=fe})(K=e.LanguageSelector||(e.LanguageSelector={}));var oe;(function(Ee){function fe(ee){return{start:ee.start,end:ee.end}}Ee.from=fe;function ce(ee){return new u.NotebookCellRange(ee.start,ee.end)}Ee.to=ce})(oe=e.NotebookCellRange||(e.NotebookCellRange={}));var de;(function(Ee){function fe(ce){return new u.NotebookCellMetadata(ce.editable,ce.breakpointMargin,ce.statusMessage,ce.inputCollapsed,ce.outputCollapsed,ce.custom)}Ee.to=fe})(de=e.NotebookCellMetadata||(e.NotebookCellMetadata={}));var Z;(function(Ee){function fe(ee){return ee}Ee.from=fe;function ce(ee){return new u.NotebookDocumentMetadata(ee.editable,ee.cellEditable,ee.custom,ee.trusted)}Ee.to=ce})(Z=e.NotebookDocumentMetadata||(e.NotebookDocumentMetadata={}));var ie;(function(Ee){function fe(ee){return{duration:ee.lastRunDuration,executionOrder:ee.executionOrder,success:ee.lastRunSuccess}}Ee.to=fe;function ce(ee){return{lastRunSuccess:ee.success,lastRunDuration:ee.duration,executionOrder:ee.executionOrder}}Ee.from=ce})(ie=e.NotebookCellPreviousExecutionResult||(e.NotebookCellPreviousExecutionResult={}));var le;(function(Ee){function fe(ee){switch(ee){case u.NotebookCellKind.Markdown:return g.CellKind.Markdown;case u.NotebookCellKind.Code:default:return g.CellKind.Code}}Ee.from=fe;function ce(ee){switch(ee){case g.CellKind.Markdown:return u.NotebookCellKind.Markdown;case g.CellKind.Code:default:return u.NotebookCellKind.Code}}Ee.to=ce})(le=e.NotebookCellKind||(e.NotebookCellKind={}));var ve;(function(Ee){function fe(ee){var Ae;return{cellKind:le.from(ee.kind),language:ee.language,source:ee.source,metadata:Object.assign(Object.assign({},ee.metadata),ie.from((Ae=ee.latestExecutionSummary)!==null&&Ae!==void 0?Ae:{})),outputs:ee.outputs?ee.outputs.map(We.from):[]}}Ee.from=fe;function ce(ee){return new u.NotebookCellData(le.to(ee.cellKind),ee.source,ee.language,ee.outputs?ee.outputs.map(We.to):void 0,ee.metadata?de.to(ee.metadata):void 0)}Ee.to=ce})(ve=e.NotebookCellData||(e.NotebookCellData={}));var ye;(function(Ee){function fe(ee){return{mime:ee.mime,value:ee.value,metadata:ee.metadata}}Ee.from=fe;function ce(ee){return new u.NotebookCellOutputItem(ee.mime,ee.value,ee.metadata)}Ee.to=ce})(ye=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var We;(function(Ee){function fe(ee){return{outputId:ee.id,outputs:ee.outputs.map(ye.from),metadata:ee.metadata}}Ee.from=fe;function ce(ee){const Ae=ee.outputs.map(ye.to);return new u.NotebookCellOutput(Ae,ee.outputId,ee.metadata)}Ee.to=ce})(We=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Ne;(function(Ee){function fe(Le){if(Le!=null){if(Le instanceof u.RelativePattern||typeof Le=="string")return Le;if(Ae(Le))return new u.RelativePattern(Le.base,Le.pattern);if(ee(Le))return{include:Ze.from(Le.include)||void 0,exclude:Ze.from(Le.exclude)||void 0}}}Ee.from=fe;function ce(Le){return typeof Le=="string"?Le:Ae(Le)?{base:Le.base,pattern:Le.pattern}:{include:Le.include,exclude:Le.exclude}}Ee.to=ce;function ee(Le){const Qe=Le,Ge=Ze.from(Qe.include);if(!(Ge&&Ge instanceof u.RelativePattern||typeof Ge=="string"))return!1;const rt=Ze.from(Qe.exclude);return!!(rt&&rt instanceof u.RelativePattern||typeof rt=="string")}function Ae(Le){const Qe=Le;return Qe&&typeof Qe.base=="string"&&typeof Qe.pattern=="string"}})(Ne=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var qe;(function(Ee){function fe(ce){return{backgroundColor:ce.backgroundColor,borderColor:ce.borderColor,top:ce.top?f.from(ce.top):void 0}}Ee.from=fe})(qe=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Je;(function(Ee){function fe(ce){var ee;return{transientOutputs:(ee=ce==null?void 0:ce.transientOutputs)!==null&&ee!==void 0?ee:!1,transientMetadata:Object.assign(Object.assign({},ce==null?void 0:ce.transientMetadata),{executionOrder:!0,lastRunDuration:!0,runState:!0,runStartTime:!0,lastRunSuccess:!0})}}Ee.from=fe})(Je=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var et;(function(Ee){function fe(ee){return{message:h.fromStrict(ee.message)||"",severity:ee.severity,expectedOutput:ee.expectedOutput,actualOutput:ee.actualOutput,location:ee.location?O.from(ee.location):void 0}}Ee.from=fe;function ce(ee){const Ae=new u.TestMessage(typeof ee.message=="string"?ee.message:h.to(ee.message));return Ae.severity=ee.severity,Ae.actualOutput=ee.actualOutput,Ae.expectedOutput=ee.expectedOutput,Ae}Ee.to=ce})(et=e.TestMessage||(e.TestMessage={}));var nt;(function(Ee){function fe(Le){var Qe,Ge;return{extId:Le.id,label:Le.label,uri:Le.uri,range:v.from(Le.range),debuggable:(Qe=Le.debuggable)!==null&&Qe!==void 0?Qe:!1,description:Le.description,runnable:(Ge=Le.runnable)!==null&&Ge!==void 0?Ge:!0,expandable:Le.expandable}}Ee.from=fe;function ce(Le){return{extId:Le.id,label:Le.label,uri:Le.uri,range:v.from(Le.range),debuggable:!1,description:Le.description,runnable:!0,expandable:!0}}Ee.fromResultSnapshot=ce;function ee(Le){return{id:Le.extId,label:Le.label,uri:y.URI.revive(Le.uri),range:v.to(Le.range),expandable:Le.expandable,debuggable:Le.debuggable,description:Le.description,runnable:Le.runnable}}Ee.toPlain=ee;function Ae(Le){const Qe=new u.TestItem(Le.extId,Le.label,y.URI.revive(Le.uri),Le.expandable);return Qe.range=v.to(Le.range),Qe.debuggable=Le.debuggable,Qe.description=Le.description,Qe.runnable=Le.runnable,Qe}Ee.to=Ae})(nt=e.TestItem||(e.TestItem={}));var st;(function(Ee){function fe(Ae,Le){var Qe,Ge,rt;const ut={completedAt:Le.completedAt,id:Ae,output:Le.output,items:[]},Ye=[[null,Le.results]];for(;Ye.length;){const[at,ct]=Ye.pop();for(const ot of ct){const yt={children:(Ge=(Qe=ot.children)===null||Qe===void 0?void 0:Qe.map(gt=>gt.id))!==null&&Ge!==void 0?Ge:[],computedState:ot.state,item:nt.fromResultSnapshot(ot),state:{state:ot.state,duration:ot.duration,messages:ot.messages.map(et.from)},retired:void 0,expand:3,parent:(rt=at==null?void 0:at.item.extId)!==null&&rt!==void 0?rt:null,src:{provider:"",tree:-1},direct:!at};ut.items.push(yt),ot.children&&Ye.push([yt,ot.children])}}return ut}Ee.from=fe;const ce=(Ae,Le)=>Object.assign(Object.assign({},nt.toPlain(Ae.item)),{state:Ae.state.state,duration:Ae.state.duration,messages:Ae.state.messages.map(et.to),children:Ae.children.map(Qe=>Le.get(Qe)).filter(k.isDefined).map(Qe=>ce(Qe,Le))});function ee(Ae){const Le=[],Qe=new Map;for(const Ge of Ae.items)Qe.set(Ge.item.extId,Ge),Ge.direct&&Le.push(Ge);return{completedAt:Ae.completedAt,results:Le.map(Ge=>ce(Ge,Qe))}}Ee.to=ee})(st=e.TestResults||(e.TestResults={}));var it;(function(Ee){function fe(ce){switch(ce){case 1:return u.CodeActionTriggerKind.Invoke;case 2:return u.CodeActionTriggerKind.Automatic}}Ee.to=fe})(it=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(ge[215],pe([0,1,2,18,7,20,55]),function(G,e,E,P,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class k{constructor(n,R,C,w={timeout:1500,errors:3}){this._logService=n,this._documents=R,this._mainThreadBulkEdits=C,this._thresholds=w,this._callbacks=new D.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(n){return(R,C,w)=>{const s={dispose:this._callbacks.push([R,C,n])};return Array.isArray(w)&&w.push(s),s}}async $participateInSave(n,R){const C=E.URI.revive(n);let w=!1;const g=setTimeout(()=>w=!0,this._thresholds.timeout),s=[];try{for(let u of[...this._callbacks]){if(w)break;const S=this._documents.getDocument(C),v=await this._deliverEventAsyncAndBlameBadListeners(u,{document:S,reason:I.TextDocumentSaveReason.to(R)});s.push(v)}}finally{clearTimeout(g)}return s}_deliverEventAsyncAndBlameBadListeners([n,R,C],w){const g=this._badListeners.get(n);return typeof g=="number"&&g>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(C,n,R,w).then(()=>!0,s=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' threw ERROR`),this._logService.error(s),!(s instanceof Error)||s.message!=="concurrent_edits"){const u=this._badListeners.get(n);this._badListeners.set(n,u?u+1:1),typeof u=="number"&&u>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(n,R,C,w){const g=[],s=Date.now(),{document:u,reason:S}=w,{version:v}=u,_=Object.freeze({document:u,reason:S,waitUntil(p){if(Object.isFrozen(g))throw(0,P.illegalState)("waitUntil can not be called async");g.push(Promise.resolve(p))}});try{R.apply(C,[_])}catch(p){return Promise.reject(p)}return Object.freeze(g),new Promise((p,c)=>{const l=setTimeout(()=>c(new Error("timeout")),this._thresholds.timeout);return Promise.all(g).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${n.identifier.value}' finished after ${Date.now()-s}ms`),clearTimeout(l),p(t)}).catch(t=>{clearTimeout(l),c(t)})}).then(p=>{const c={edits:[]};for(const l of p)if(Array.isArray(l)&&l.every(t=>t instanceof T.TextEdit))for(const{newText:t,newEol:i,range:o}of l)c.edits.push({_type:2,resource:u.uri,edit:{range:o&&I.Range.from(o),text:t,eol:i&&I.EndOfLine.from(i)}});if(c.edits.length!==0)return v===u.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(c):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=k}),define(ge[216],pe([0,1,3,19,33,2,20,7]),function(G,e,E,P,T,I,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{constructor(C,w,g,s,u){this._onDidCreate=new E.Emitter,this._onDidChange=new E.Emitter,this._onDidDelete=new E.Emitter,this._config=0,g&&(this._config+=1),s&&(this._config+=2),u&&(this._config+=4);const S=(0,T.parse)(w),v=C(_=>{if(!g)for(let p of _.created){const c=I.URI.revive(p);S(c.fsPath)&&this._onDidCreate.fire(c)}if(!s)for(let p of _.changed){const c=I.URI.revive(p);S(c.fsPath)&&this._onDidChange.fire(c)}if(!u)for(let p of _.deleted){const c=I.URI.revive(p);S(c.fsPath)&&this._onDidDelete.fire(c)}});this._disposable=k.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,v)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class n{constructor(C,w,g){this._logService=w,this._extHostDocumentsAndEditors=g,this._onFileSystemEvent=new E.Emitter,this._onDidRenameFile=new E.Emitter,this._onDidCreateFile=new E.Emitter,this._onDidDeleteFile=new E.Emitter,this._onWillRenameFile=new P.AsyncEmitter,this._onWillCreateFile=new P.AsyncEmitter,this._onWillDeleteFile=new P.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(C,w,g,s){return new y(this._onFileSystemEvent.event,C,w,g,s)}$onFileEvent(C){this._onFileSystemEvent.fire(C)}$onDidRunFileOperation(C,w){switch(C){case 2:this._onDidRenameFile.fire(Object.freeze({files:w.map(g=>({oldUri:I.URI.revive(g.source),newUri:I.URI.revive(g.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:w.map(g=>I.URI.revive(g.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:w.map(g=>I.URI.revive(g.target))}));break;default:}}getOnWillRenameFileEvent(C){return this._createWillExecuteEvent(C,this._onWillRenameFile)}getOnWillCreateFileEvent(C){return this._createWillExecuteEvent(C,this._onWillCreateFile)}getOnWillDeleteFileEvent(C){return this._createWillExecuteEvent(C,this._onWillDeleteFile)}_createWillExecuteEvent(C,w){return(g,s,u)=>{const S=function(_){g.call(s,_)};return S.extension=C,w.event(S,void 0,u)}}async $onWillRunFileOperation(C,w,g,s){switch(C){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:w.map(u=>({oldUri:I.URI.revive(u.source),newUri:I.URI.revive(u.target)}))},g,s);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:w.map(u=>I.URI.revive(u.target))},g,s);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:w.map(u=>I.URI.revive(u.target))},g,s)}}async _fireWillEvent(C,w,g,s){const u=new Set,S=[];if(await C.fireAsync(w,s,async(_,p)=>{var c;const l=Date.now(),t=await Promise.resolve(_);t instanceof k.WorkspaceEdit&&(S.push(t),u.add((c=p.extension.displayName)!==null&&c!==void 0?c:p.extension.identifier.value)),Date.now()-l>g&&this._logService.warn("SLOW file-participant",p.extension.identifier)}),!s.isCancellationRequested&&S.length!==0){const v={edits:[]};for(let _ of S){let{edits:p}=D.WorkspaceEdit.from(_,this._extHostDocumentsAndEditors);v.edits=v.edits.concat(p)}return{edit:v,extensionNames:Array.from(u)}}}}e.ExtHostFileSystemEventService=n}),define(ge[217],pe([0,1,3,6,11,23,2,20,7,85]),function(G,e,E,P,T,I,D,k,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class R{constructor(s,u,S,v){this.start=s,this.deletedCount=u,this.deletedItems=S,this.items=v}static asApiEvents(s){return s.map(u=>({start:u.start,deletedCount:u.deletedCount,deletedItems:u.deletedItems,items:u.items.map(S=>S.cell)}))}}class C{constructor(s,u,S){var v;this._notebook=s,this._extHostDocument=u,this._cellData=S,this._onDidDispose=new E.Emitter,this.onDidDispose=this._onDidDispose.event,this.handle=S.handle,this.uri=D.URI.revive(S.uri),this.cellKind=S.cellKind,this._outputs=S.outputs.map(k.NotebookCellOutput.to),this._internalMetadata=(v=S.metadata)!==null&&v!==void 0?v:{},this._metadata=k.NotebookCellMetadata.to(this._internalMetadata),this._previousResult=k.NotebookCellPreviousExecutionResult.to(this._internalMetadata)}static asModelAddData(s,u){return{EOL:u.eol,lines:u.source,modeId:u.language,uri:u.uri,isDirty:!1,versionId:1,notebook:s}}dispose(){this._onDidDispose.fire(),this._onDidDispose.dispose()}get internalMetadata(){return this._internalMetadata}get cell(){if(!this._cell){const s=this,u=this._extHostDocument.getDocument(this.uri);if(!u)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._cell=Object.freeze({get index(){return s._notebook.getCellIndex(s)},notebook:s._notebook.notebookDocument,kind:k.NotebookCellKind.to(this._cellData.cellKind),document:u.document,get outputs(){return s._outputs.slice(0)},get metadata(){return s._metadata},get latestExecutionSummary(){return s._previousResult}})}return this._cell}setOutputs(s){this._outputs=s.map(k.NotebookCellOutput.to)}setOutputItems(s,u,S){const v=S.map(k.NotebookCellOutputItem.to),_=this._outputs.find(p=>p.id===s);_&&(u||(_.outputs.length=0),_.outputs.push(...v))}setMetadata(s){this._internalMetadata=s,this._metadata=k.NotebookCellMetadata.to(s),this._previousResult=k.NotebookCellPreviousExecutionResult.to(s)}}e.ExtHostCell=C;class w extends P.Disposable{constructor(s,u,S,v,_,p,c){super();this._proxy=s,this._textDocumentsAndEditors=u,this._textDocuments=S,this._emitter=v,this._viewType=_,this._metadata=p,this.uri=c,this.handle=w._handlePool++,this._cells=[],this._cellDisposableMapping=new Map,this._versionId=0,this._isDirty=!1,this._disposed=!1}dispose(){this._disposed=!0,super.dispose(),(0,P.dispose)(this._cellDisposableMapping.values())}get notebookDocument(){if(!this._notebook){const s=this;this._notebook=Object.freeze({get uri(){return s.uri},get version(){return s._versionId},get fileName(){return s.uri.fsPath},get viewType(){return s._viewType},get isDirty(){return s._isDirty},get isUntitled(){return s.uri.scheme===T.Schemas.untitled},get isClosed(){return s._disposed},get metadata(){return s._metadata},get cellCount(){return s._cells.length},cellAt(u){return u=s._validateIndex(u),s._cells[u].cell},getCells(u){return(u?s._getCells(u):s._cells).map(v=>v.cell)},save(){return s._save()}})}return this._notebook}updateBackup(s){var u;(u=this._backup)===null||u===void 0||u.delete(),this._backup=s}disposeBackup(){var s;(s=this._backup)===null||s===void 0||s.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(s){s.metadata&&(this._metadata=this._metadata.with(s.metadata))}acceptModelChanged(s,u){this._versionId=s.versionId,this._isDirty=u;for(const S of s.rawEvents)S.kind===n.NotebookCellsChangeType.Initialize&&this._spliceNotebookCells(S.changes,!0),S.kind===n.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(S.changes,!1):S.kind===n.NotebookCellsChangeType.Move?this._moveCell(S.index,S.newIdx):S.kind===n.NotebookCellsChangeType.Output?this._setCellOutputs(S.index,S.outputs):S.kind===n.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(S.index,S.outputId,S.append,S.outputItems):S.kind===n.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(S.index,S.language):S.kind===n.NotebookCellsChangeType.ChangeCellMetadata&&this._changeCellMetadata(S.index,S.metadata)}_validateIndex(s){return s<0?0:s>=this._cells.length?this._cells.length-1:s}_validateRange(s){return s.start<0&&(s=s.with({start:0})),s.end>this._cells.length&&(s=s.with({end:this._cells.length})),s}_getCells(s){s=this._validateRange(s);const u=[];for(let S=s.start;S<s.end;S++)u.push(this._cells[S]);return u}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveDocument(this.uri)}_spliceNotebookCells(s,u){if(!this._disposed){const S=[],v=[],_=[];s.reverse().forEach(p=>{var c;const t=p[2].map(r=>{const a=new C(this,this._textDocumentsAndEditors,r);if(u||v.push(C.asModelAddData(this.notebookDocument,r)),!this._cellDisposableMapping.has(a.handle)){const h=new P.DisposableStore;h.add(a),this._cellDisposableMapping.set(a.handle,h)}return a});for(let r=p[0];r<p[0]+p[1];r++)(c=this._cellDisposableMapping.get(this._cells[r].handle))===null||c===void 0||c.dispose(),this._cellDisposableMapping.delete(this._cells[r].handle);const i=new R(p[0],p[1],[],t),o=this._cells.splice(p[0],p[1],...t);for(let r of o)_.push(r.uri),i.deletedItems.push(r.cell);S.push(i)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:v,removedDocuments:_}),u||this._emitter.emitModelChange((0,I.deepFreeze)({document:this.notebookDocument,changes:R.asApiEvents(S)}))}}_moveCell(s,u){const S=this._cells.splice(s,1);this._cells.splice(u,0,...S);const v=[new R(s,1,S.map(_=>_.cell),[]),new R(u,0,[],S)];this._emitter.emitModelChange((0,I.deepFreeze)({document:this.notebookDocument,changes:R.asApiEvents(v)}))}_setCellOutputs(s,u){const S=this._cells[s];S.setOutputs(u),this._emitter.emitCellOutputsChange((0,I.deepFreeze)({document:this.notebookDocument,cells:[S.cell]}))}_setCellOutputItems(s,u,S,v){const _=this._cells[s];_.setOutputItems(u,S,v),this._emitter.emitCellOutputsChange((0,I.deepFreeze)({document:this.notebookDocument,cells:[_.cell]}))}_changeCellLanguage(s,u){const S=this._cells[s];S.cell.document.languageId!==u&&this._textDocuments.$acceptModelModeChanged(S.uri,u)}_changeCellMetadata(s,u){var S;const v=this._cells[s],_=v.internalMetadata,p=v.cell.metadata;v.setMetadata(u);const c=v.cell.metadata;if((0,I.equals)(p,c)||this._emitter.emitCellMetadataChange((0,I.deepFreeze)({document:this.notebookDocument,cell:v.cell})),_.runState!==u.runState){const l=(S=u.runState)!==null&&S!==void 0?S:y.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,I.deepFreeze)({document:this.notebookDocument,cell:v.cell,executionState:l}))}}getCellFromIndex(s){return this._cells[s]}getCell(s){return this._cells.find(u=>u.handle===s)}getCellIndex(s){return this._cells.indexOf(s)}}e.ExtHostNotebookDocument=w,w._handlePool=0}),define(ge[218],pe([0,1,7,20]),function(G,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class T{constructor(k){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=k}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(k){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:k})}replaceCellMetadata(k,y){this._throwIfFinalized(),this._collectedEdits.push({editType:3,index:k,metadata:y})}replaceCellOutput(k,y){this._throwIfFinalized(),this._collectedEdits.push({editType:2,index:k,outputs:y.map(n=>P.NotebookCellOutput.from(n))})}replaceCells(k,y,n){this._throwIfFinalized(),!(k===y&&n.length===0)&&this._collectedEdits.push({editType:1,index:k,count:y-k,cells:n.map(P.NotebookCellData.from)})}}class I{constructor(k,y,n,R,C,w){this.id=k,this._proxy=y,this.notebookData=n,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=C,this._visibleRanges=R,this._viewColumn=w}get editor(){if(!this._editor){const k=this;this._editor={get document(){return k.notebookData.notebookDocument},get selections(){return k._selections},get visibleRanges(){return k._visibleRanges},revealRange(y,n){k._proxy.$tryRevealRange(k.id,P.NotebookCellRange.from(y),n!=null?n:E.NotebookEditorRevealType.Default)},get viewColumn(){return k._viewColumn},edit(y){const n=new T(this.document.version);return y(n),k._applyEdit(n.finalize())},get kernel(){return k._kernel},setDecorations(y,n){return k.setDecorations(y,n)}}}return this._editor}_acceptKernel(k){this._kernel=k}get visible(){return this._visible}_acceptVisibility(k){this._visible=k}_acceptVisibleRanges(k){this._visibleRanges=k}_acceptSelections(k){this._selections=k}_acceptViewColumn(k){this._viewColumn=k}_applyEdit(k){if(k.cellEdits.length===0)return Promise.resolve(!0);const y=[];let n=-1;for(let R=0;R<k.cellEdits.length;R++){if(n<0){y.push(k.cellEdits[R]),n++;continue}const w=y[n],g=k.cellEdits[R];if(w.editType===1&&g.editType===1&&w.index===g.index){w.cells.push(...k.cellEdits[R].cells),w.count+=k.cellEdits[R].count;continue}y.push(k.cellEdits[R]),n++}return this._proxy.$tryApplyEdits(this.id,k.documentVersionId,y)}setDecorations(k,y){if(!(y.isEmpty&&!this._hasDecorationsForKey.has(k.key)))return y.isEmpty?this._hasDecorationsForKey.delete(k.key):this._hasDecorationsForKey.add(k.key),this._proxy.$trySetDecorations(this.id,P.NotebookCellRange.from(y),k.key)}}e.ExtHostNotebookEditor=I}),define(ge[219],pe([0,1,20,111,162,21,68]),function(G,e,E,P,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class k{constructor(C){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=C}withProgress(C,w,g){const s=this._handles++,{title:u,location:S,cancellable:v}=w,_={label:(0,T.localize)(0,null,C.displayName||C.name),id:C.identifier.value};return this._proxy.$startProgress(s,{location:E.ProgressLocation.from(S),title:u,source:_,cancellable:v},C),this._withProgress(s,g,!!v)}_withProgress(C,w,g){let s;g&&(s=new I.CancellationTokenSource,this._mapHandleToCancellationSource.set(C,s));const u=v=>{this._proxy.$progressEnd(v),this._mapHandleToCancellationSource.delete(v),s&&s.dispose()};let S;try{S=w(new n(this._proxy,C),g&&s?s.token:I.CancellationToken.None)}catch(v){throw u(C),v}return S.then(v=>u(C),v=>u(C)),S}$acceptProgressCanceled(C){const w=this._mapHandleToCancellationSource.get(C);w&&(w.cancel(),this._mapHandleToCancellationSource.delete(C))}}e.ExtHostProgress=k;function y(R,C){return R.message=C.message,typeof C.increment=="number"&&(typeof R.increment=="number"?R.increment+=C.increment:R.increment=C.increment),R}class n extends P.Progress{constructor(C,w){super(g=>this.throttledReport(g));this._proxy=C,this._handle=w}throttledReport(C){this._proxy.$progressReport(this._handle,C)}}je([(0,D.throttle)(100,(R,C)=>y(R,C),()=>Object.create(null))],n.prototype,"throttledReport",null)}),define(ge[122],pe([0,1,52,18,70,20,7]),function(G,e,E,P,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class k{constructor(w,g){const s=k._Keys.nextId();w.$registerTextEditorDecorationType(s,I.DecorationRenderOptions.from(g)),this.value=Object.freeze({key:s,dispose(){w.$removeTextEditorDecorationType(s)}})}}e.TextEditorDecorationType=k,k._Keys=new T.IdGenerator("TextEditorDecorationType");class y{constructor(w,g){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=w,this._documentVersionId=w.version,this._undoStopBefore=g.undoStopBefore,this._undoStopAfter=g.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(w,g){this._throwIfFinalized();let s=null;if(w instanceof D.Position)s=new D.Range(w,w);else if(w instanceof D.Range)s=w;else throw new Error("Unrecognized location");this._pushEdit(s,g,!1)}insert(w,g){this._throwIfFinalized(),this._pushEdit(new D.Range(w,w),g,!0)}delete(w){this._throwIfFinalized();let g=null;if(w instanceof D.Range)g=w;else throw new Error("Unrecognized location");this._pushEdit(g,null,!0)}_pushEdit(w,g,s){const u=this._document.validateRange(w);this._collectedEdits.push({range:u,text:g,forceMoveMarkers:s})}setEndOfLine(w){if(this._throwIfFinalized(),w!==D.EndOfLine.LF&&w!==D.EndOfLine.CRLF)throw(0,P.illegalArgument)("endOfLine");this._setEndOfLine=w}}e.TextEditorEdit=y;class n{constructor(w,g,s,u){this._proxy=w,this._id=g,this._accept(s),this._logService=u;const S=this;this.value={get tabSize(){return S._tabSize},set tabSize(v){S._setTabSize(v)},get insertSpaces(){return S._insertSpaces},set insertSpaces(v){S._setInsertSpaces(v)},get cursorStyle(){return S._cursorStyle},set cursorStyle(v){S._setCursorStyle(v)},get lineNumbers(){return S._lineNumbers},set lineNumbers(v){S._setLineNumbers(v)}}}_accept(w){this._tabSize=w.tabSize,this._insertSpaces=w.insertSpaces,this._cursorStyle=w.cursorStyle,this._lineNumbers=I.TextEditorLineNumbersStyle.to(w.lineNumbers)}_validateTabSize(w){if(w==="auto")return"auto";if(typeof w=="number"){const g=Math.floor(w);return g>0?g:null}if(typeof w=="string"){const g=parseInt(w,10);return isNaN(g)?null:g>0?g:null}return null}_setTabSize(w){const g=this._validateTabSize(w);if(g!==null){if(typeof g=="number"){if(this._tabSize===g)return;this._tabSize=g}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:g}))}}_validateInsertSpaces(w){return w==="auto"?"auto":w==="false"?!1:Boolean(w)}_setInsertSpaces(w){const g=this._validateInsertSpaces(w);if(typeof g=="boolean"){if(this._insertSpaces===g)return;this._insertSpaces=g}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:g}))}_setCursorStyle(w){this._cursorStyle!==w&&(this._cursorStyle=w,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:w})))}_setLineNumbers(w){this._lineNumbers!==w&&(this._lineNumbers=w,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:I.TextEditorLineNumbersStyle.from(w)})))}assign(w){const g={};let s=!1;if(typeof w.tabSize!="undefined"){const u=this._validateTabSize(w.tabSize);u==="auto"?(s=!0,g.tabSize=u):typeof u=="number"&&this._tabSize!==u&&(this._tabSize=u,s=!0,g.tabSize=u)}if(typeof w.insertSpaces!="undefined"){const u=this._validateInsertSpaces(w.insertSpaces);u==="auto"?(s=!0,g.insertSpaces=u):this._insertSpaces!==u&&(this._insertSpaces=u,s=!0,g.insertSpaces=u)}typeof w.cursorStyle!="undefined"&&this._cursorStyle!==w.cursorStyle&&(this._cursorStyle=w.cursorStyle,s=!0,g.cursorStyle=w.cursorStyle),typeof w.lineNumbers!="undefined"&&this._lineNumbers!==w.lineNumbers&&(this._lineNumbers=w.lineNumbers,s=!0,g.lineNumbers=I.TextEditorLineNumbersStyle.from(w.lineNumbers)),s&&this._warnOnError(this._proxy.$trySetOptions(this._id,g))}_warnOnError(w){w.catch(g=>this._logService.warn(g))}}e.ExtHostTextEditorOptions=n;class R{constructor(w,g,s,u,S,v,_,p){this.id=w,this._proxy=g,this._logService=s,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=S,this._options=new n(this._proxy,this.id,v,s),this._visibleRanges=_,this._viewColumn=p;const c=this;this.value=Object.freeze({get document(){return u.getValue()},set document(l){throw(0,P.readonly)("document")},get selection(){return c._selections&&c._selections[0]},set selection(l){if(!(l instanceof D.Selection))throw(0,P.illegalArgument)("selection");c._selections=[l],c._trySetSelection()},get selections(){return c._selections},set selections(l){if(!Array.isArray(l)||l.some(t=>!(t instanceof D.Selection)))throw(0,P.illegalArgument)("selections");c._selections=l,c._trySetSelection()},get visibleRanges(){return c._visibleRanges},set visibleRanges(l){throw(0,P.readonly)("visibleRanges")},get options(){return c._options.value},set options(l){c._disposed||c._options.assign(l)},get viewColumn(){return c._viewColumn},set viewColumn(l){throw(0,P.readonly)("viewColumn")},edit(l,t={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const i=new y(u.getValue(),t);return l(i),c._applyEdit(i)},insertSnippet(l,t,i={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let o;if(!t||Array.isArray(t)&&t.length===0)o=c._selections.map(r=>I.Range.from(r));else if(t instanceof D.Position){const{lineNumber:r,column:a}=I.Position.from(t);o=[{startLineNumber:r,startColumn:a,endLineNumber:r,endColumn:a}]}else if(t instanceof D.Range)o=[I.Range.from(t)];else{o=[];for(const r of t)if(r instanceof D.Range)o.push(I.Range.from(r));else{const{lineNumber:a,column:h}=I.Position.from(r);o.push({startLineNumber:a,startColumn:h,endLineNumber:a,endColumn:h})}}return g.$tryInsertSnippet(w,l.value,o,i)},setDecorations(l,t){const i=t.length===0;i&&!c._hasDecorationsForKey.has(l.key)||(i?c._hasDecorationsForKey.delete(l.key):c._hasDecorationsForKey.add(l.key),c._runOnProxy(()=>{if(I.isDecorationOptionsArr(t))return g.$trySetDecorations(w,l.key,I.fromRangeOrRangeWithMessage(t));{const o=new Array(4*t.length);for(let r=0,a=t.length;r<a;r++){const h=t[r];o[4*r]=h.start.line+1,o[4*r+1]=h.start.character+1,o[4*r+2]=h.end.line+1,o[4*r+3]=h.end.character+1}return g.$trySetDecorationsFast(w,l.key,o)}}))},revealRange(l,t){c._runOnProxy(()=>g.$tryRevealRange(w,I.Range.from(l),t||D.TextEditorRevealType.Default))},show(l){g.$tryShowEditor(w,I.ViewColumn.from(l))},hide(){g.$tryHideEditor(w)}})}dispose(){(0,E.ok)(!this._disposed),this._disposed=!0}_acceptOptions(w){(0,E.ok)(!this._disposed),this._options._accept(w)}_acceptVisibleRanges(w){(0,E.ok)(!this._disposed),this._visibleRanges=w}_acceptViewColumn(w){(0,E.ok)(!this._disposed),this._viewColumn=w}_acceptSelections(w){(0,E.ok)(!this._disposed),this._selections=w}async _trySetSelection(){const w=this._selections.map(I.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,w)),this.value}_applyEdit(w){const g=w.finalize();if(g.edits.length===0&&!g.setEndOfLine)return Promise.resolve(!0);const s=g.edits.map(S=>S.range);s.sort((S,v)=>S.end.line===v.end.line?S.end.character===v.end.character?S.start.line===v.start.line?S.start.character-v.start.character:S.start.line-v.start.line:S.end.character-v.end.character:S.end.line-v.end.line);for(let S=0,v=s.length-1;S<v;S++){const _=s[S].end;if(s[S+1].start.isBefore(_))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const u=g.edits.map(S=>({range:I.Range.from(S.range),text:S.text,forceMoveMarkers:S.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,g.documentVersionId,u,{setEndOfLine:typeof g.setEndOfLine=="number"?I.EndOfLine.from(g.setEndOfLine):void 0,undoStopBefore:g.undoStopBefore,undoStopAfter:g.undoStopAfter})}_runOnProxy(w){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):w().then(()=>this,g=>(g instanceof Error&&g.name==="DISPOSED"||this._logService.warn(g),null))}}e.ExtHostTextEditor=R}),define(ge[220],pe([0,1,165,25,2,3,6,19,7,15,14,20,21]),function(G,e,E,P,T,I,D,k,y,n,R,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function g(S,v){if((0,n.isString)(S))return{label:S};if(S&&typeof S=="object"&&typeof S.label=="string"){let _;return Array.isArray(S.highlights)&&(_=S.highlights.filter(p=>p.length===2&&typeof p[0]=="number"&&typeof p[1]=="number"),_=_.length?_:void 0),{label:S.label,highlights:_}}}class s{constructor(v,_,p){this._proxy=v,this.commands=_,this.logService=p,this.treeViews=new Map;function c(l){return l&&l.$treeViewId&&l.$treeItemHandle}_.registerArgumentProcessor({processArgument:l=>c(l)?this.convertArgument(l):Array.isArray(l)&&l.length>0?l.map(t=>c(t)?this.convertArgument(t):t):l})}registerTreeDataProvider(v,_,p){const c=this.createTreeView(v,{treeDataProvider:_},p);return{dispose:()=>c.dispose()}}createTreeView(v,_,p){if(!_||!_.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const c=this._proxy.$registerTreeViewDataProvider(v,{showCollapseAll:!!_.showCollapseAll,canSelectMany:!!_.canSelectMany}),l=this.createExtHostTreeView(v,_,p);return{get onDidCollapseElement(){return l.onDidCollapseElement},get onDidExpandElement(){return l.onDidExpandElement},get selection(){return l.selectedElements},get onDidChangeSelection(){return l.onDidChangeSelection},get visible(){return l.visible},get onDidChangeVisibility(){return l.onDidChangeVisibility},get message(){return l.message},set message(t){l.message=t},get title(){return l.title},set title(t){l.title=t},get description(){return l.description},set description(t){l.description=t},reveal:(t,i)=>l.reveal(t,i),dispose:async()=>{await c,this.treeViews.delete(v),l.dispose()}}}$getChildren(v,_){const p=this.treeViews.get(v);return p?p.getChildren(_):Promise.reject(new Error((0,E.localize)(0,null,v)))}async $hasResolve(v){const _=this.treeViews.get(v);if(!_)throw new Error((0,E.localize)(1,null,v));return _.hasResolve}$resolve(v,_,p){const c=this.treeViews.get(v);if(!c)throw new Error((0,E.localize)(2,null,v));return c.resolveTreeItem(_,p)}$setExpanded(v,_,p){const c=this.treeViews.get(v);if(!c)throw new Error((0,E.localize)(3,null,v));c.setExpanded(_,p)}$setSelection(v,_){const p=this.treeViews.get(v);if(!p)throw new Error((0,E.localize)(4,null,v));p.setSelection(_)}$setVisible(v,_){const p=this.treeViews.get(v);if(!p)throw new Error((0,E.localize)(5,null,v));p.setVisible(_)}createExtHostTreeView(v,_,p){const c=new u(v,_,this._proxy,this.commands.converter,this.logService,p);return this.treeViews.set(v,c),c}convertArgument(v){const _=this.treeViews.get(v.$treeViewId);return _?_.getExtensionElement(v.$treeItemHandle):null}}e.ExtHostTreeViews=s;class u extends D.Disposable{constructor(v,_,p,c,l,t){super();if(this.viewId=v,this.proxy=p,this.commands=c,this.logService=l,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new I.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new I.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new I.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new I.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new I.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new w.CancellationTokenSource,t.contributes&&t.contributes.views)for(const r in t.contributes.views)for(const a of t.contributes.views[r])a.id===v&&(this._title=a.name);this.dataProvider=_.treeDataProvider,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(r=>this._onDidChangeData.fire({message:!1,element:r})));let i,o;this._register(I.Event.debounce(this._onDidChangeData.event,(r,a)=>(r||(r={message:!1,elements:[]}),a.element!==!1&&(i||(i=new Promise(h=>o=h),this.refreshPromise=this.refreshPromise.then(()=>i)),r.elements.push(a.element)),a.message&&(r.message=!0),r),200,!0)(({message:r,elements:a})=>{a.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const h=o;return i=null,this.refresh(a).then(()=>h())})),r&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(v=>this.getExtensionElement(v)).filter(v=>!(0,n.isUndefinedOrNull)(v))}getChildren(v){const _=v?this.getExtensionElement(v):void 0;if(v&&!_)return this.logService.error(`No tree item with id '${v}' found.`),Promise.resolve([]);const p=this.getChildrenNodes(v);return(p?Promise.resolve(p):this.fetchChildrenNodes(_)).then(c=>c.map(l=>l.item))}getExtensionElement(v){return this.elements.get(v)}reveal(v,_){_=_||{select:!0,focus:!1};const p=(0,n.isUndefinedOrNull)(_.select)?!0:_.select,c=(0,n.isUndefinedOrNull)(_.focus)?!1:_.focus,l=(0,n.isUndefinedOrNull)(_.expand)?!1:_.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):v?this.refreshPromise.then(()=>this.resolveUnknownParentChain(v)).then(t=>this.resolveTreeNode(v,t[t.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:t.map(o=>o.item)},{select:p,focus:c,expand:l})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:p,focus:c,expand:l})}get message(){return this._message}set message(v){this._message=v,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(v){this._title=v,this.proxy.$setTitle(this.viewId,v,this._description)}get description(){return this._description}set description(v){this._description=v,this.proxy.$setTitle(this.viewId,this._title,v)}setExpanded(v,_){const p=this.getExtensionElement(v);p&&(_?this._onDidExpandElement.fire(Object.freeze({element:p})):this._onDidCollapseElement.fire(Object.freeze({element:p})))}setSelection(v){(0,R.equals)(this._selectedHandles,v)||(this._selectedHandles=v,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(v){v!==this._visible&&(this._visible=v,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(v,_){var p;if(!!this.dataProvider.resolveTreeItem){const c=this.elements.get(v);if(c){const l=this.nodes.get(c);if(l){const t=(p=await this.dataProvider.resolveTreeItem(l.extensionItem,c,_))!==null&&p!==void 0?p:l.extensionItem;return l.item.tooltip=this.getTooltip(t.tooltip),l.item.command=this.getCommand(l.disposableStore,t.command),l.item}}}}resolveUnknownParentChain(v){return this.resolveParent(v).then(_=>_?this.resolveUnknownParentChain(_).then(p=>this.resolveTreeNode(_,p[p.length-1]).then(c=>(p.push(c),p))):Promise.resolve([]))}resolveParent(v){const _=this.nodes.get(v);return _?Promise.resolve(_.parent?this.elements.get(_.parent.item.handle):void 0):(0,k.asPromise)(()=>this.dataProvider.getParent(v))}resolveTreeNode(v,_){const p=this.nodes.get(v);return p?Promise.resolve(p):(0,k.asPromise)(()=>this.dataProvider.getTreeItem(v)).then(c=>this.createHandle(v,c,_,!0)).then(c=>this.getChildren(_?_.item.handle:void 0).then(()=>{const l=this.getExtensionElement(c);if(l){const t=this.nodes.get(l);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${c}`)}))}getChildrenNodes(v){if(v){let _;if(typeof v=="string"){const p=this.getExtensionElement(v);_=p?this.nodes.get(p):void 0}else _=v;return _&&_.children||null}return this.roots}async fetchChildrenNodes(v){this.clearChildren(v);const _=new w.CancellationTokenSource(this._refreshCancellationSource.token);try{const p=v?this.nodes.get(v):void 0,c=await this.dataProvider.getChildren(v);if(_.token.isCancellationRequested)return[];const l=await Promise.all((0,R.coalesce)(c||[]).map(async t=>{const i=await this.dataProvider.getTreeItem(t);return i&&!_.token.isCancellationRequested?this.createAndRegisterTreeNode(t,i,p):null}));return _.token.isCancellationRequested?[]:(0,R.coalesce)(l)}finally{_.dispose()}}refresh(v){if(v.some(p=>!p))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new w.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const p=this.getHandlesToRefresh(v);if(p.length)return this.refreshHandles(p)}return Promise.resolve(void 0)}getHandlesToRefresh(v){const _=new Set,p=v.map(l=>this.nodes.get(l));for(const l of p)if(l&&!_.has(l.item.handle)){let t=l;for(;t&&t.parent&&p.findIndex(i=>t&&t.parent&&i&&i.item.handle===t.parent.item.handle)===-1;){const i=this.elements.get(t.parent.item.handle);t=i?this.nodes.get(i):void 0}t&&!t.parent&&_.add(l.item.handle)}const c=[];return _.forEach(l=>{const t=this.elements.get(l);if(t){const i=this.nodes.get(t);i&&(!i.parent||!_.has(i.parent.item.handle))&&c.push(l)}}),c}refreshHandles(v){const _={};return Promise.all(v.map(p=>this.refreshNode(p).then(c=>{c&&(_[p]=c.item)}))).then(()=>Object.keys(_).length?this.proxy.$refresh(this.viewId,_):void 0)}refreshNode(v){const _=this.getExtensionElement(v);if(_){const p=this.nodes.get(_);if(p)return this.clearChildren(_),(0,k.asPromise)(()=>this.dataProvider.getTreeItem(_)).then(c=>{if(c){const l=this.createTreeNode(_,c,p.parent);return this.updateNodeCache(_,l,p,p.parent),p.dispose(),l}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(v,_,p){const c=this.createTreeNode(v,_,p);if(_.id&&this.elements.has(c.item.handle))throw new Error((0,E.localize)(6,null,_.id));return this.addNodeToCache(v,c),this.addNodeToParentCache(c,p),c}getTooltip(v){return y.MarkdownString.isMarkdownString(v)?C.MarkdownString.from(v):v}getCommand(v,_){return _?this.commands.toInternal(_,v):void 0}createTreeNode(v,_,p){const c=new D.DisposableStore,l=this.createHandle(v,_,p),t=this.getLightIconPath(_);return{item:{handle:l,parentHandle:p?p.item.handle:void 0,label:g(_.label,this.extension),description:_.description,resourceUri:_.resourceUri,tooltip:this.getTooltip(_.tooltip),command:this.getCommand(c,_.command),contextValue:_.contextValue,icon:t,iconDark:this.getDarkIconPath(_)||t,themeIcon:this.getThemeIcon(_),collapsibleState:(0,n.isUndefinedOrNull)(_.collapsibleState)?y.TreeItemCollapsibleState.None:_.collapsibleState,accessibilityInformation:_.accessibilityInformation},extensionItem:_,parent:p,children:void 0,disposableStore:c,dispose(){c.dispose()}}}getThemeIcon(v){return v.iconPath instanceof y.ThemeIcon?v.iconPath:void 0}createHandle(v,{id:_,label:p,resourceUri:c},l,t){if(_)return`${u.ID_HANDLE_PREFIX}/${_}`;const i=g(p,this.extension),o=l?l.item.handle:u.LABEL_HANDLE_PREFIX;let r=i?i.label:c?(0,P.basename)(c):"";r=r.indexOf("/")!==-1?r.replace("/","//"):r;const a=this.nodes.has(v)?this.nodes.get(v).item.handle:void 0,h=this.getChildrenNodes(l)||[];let m,b=0;do{if(m=`${o}/${b}:${r}`,t||!this.elements.has(m)||a===m)break;b++}while(b<=h.length);return m}getLightIconPath(v){if(v.iconPath&&!(v.iconPath instanceof y.ThemeIcon))return typeof v.iconPath=="string"||T.URI.isUri(v.iconPath)?this.getIconPath(v.iconPath):this.getIconPath(v.iconPath.light)}getDarkIconPath(v){if(v.iconPath&&!(v.iconPath instanceof y.ThemeIcon)&&v.iconPath.dark)return this.getIconPath(v.iconPath.dark)}getIconPath(v){return T.URI.isUri(v)?v:T.URI.file(v)}addNodeToCache(v,_){this.elements.set(_.item.handle,v),this.nodes.set(v,_)}updateNodeCache(v,_,p,c){this.elements.delete(_.item.handle),this.nodes.delete(v),_.item.handle!==p.item.handle&&this.elements.delete(p.item.handle),this.addNodeToCache(v,_);const l=this.getChildrenNodes(c)||[],t=l.filter(i=>i.item.handle===p.item.handle)[0];t&&l.splice(l.indexOf(t),1,_)}addNodeToParentCache(v,_){_?(_.children||(_.children=[]),_.children.push(v)):(this.roots||(this.roots=[]),this.roots.push(v))}clearChildren(v){if(v){const _=this.nodes.get(v);if(_){if(_.children)for(const p of _.children){const c=this.elements.get(p.item.handle);c&&this.clear(c)}_.children=void 0}}else this.clearAll()}clear(v){const _=this.nodes.get(v);if(_){if(_.children)for(const p of _.children){const c=this.elements.get(p.item.handle);c&&this.clear(c)}this.nodes.delete(v),this.elements.delete(_.item.handle),_.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(v=>v.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}u.LABEL_HANDLE_PREFIX="0",u.ID_HANDLE_PREFIX="1"}),define(ge[221],pe([0,1,14,19,21,20,7,121]),function(G,e,E,P,T,I,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class y{constructor(){this.testIdsToInternal=new Map}getTestById(s,u){if(u!==void 0){const S=this.testIdsToInternal.get(u),v=S==null?void 0:S.get(s);if(v)return[S,v]}return(0,E.mapFind)(this.testIdsToInternal.values(),S=>{const v=S.get(s);return v&&[S,v]})}createForHierarchy(s=()=>{}){return new w(this.createIdMap(R++),s)}createIdMap(s){const u=new C(s);return this.testIdsToInternal.set(u.id,u),{object:u,dispose:()=>this.testIdsToInternal.delete(u.id)}}}e.OwnedTestCollection=y;var n;(function(g){g[g.Disconnected=0]="Disconnected",g[g.IsChild=1]="IsChild",g[g.IsParent=2]="IsParent",g[g.IsSame=3]="IsSame"})(n=e.TestPosition||(e.TestPosition={}));let R=0;class C{constructor(s){this.id=s,this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(s){if(this.map.has(s.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${s.item.extId}`);this.map.set(s.item.extId,s),s.parent||this._roots.add(s)}has(s){return this.map.has(s)}delete(s){const u=this.map.get(s);return u?(this.map.delete(s),this._roots.delete(u),!0):!1}get(s){return this.map.get(s)}comparePositions(s,u){const S=typeof s=="string"?this.map.get(s):s,v=typeof u=="string"?this.map.get(u):u;if(!S||!v)return 0;if(S===v)return 3;for(let _=this.map.get(v.parent);_;_=this.map.get(_.parent))if(_===S)return 1;for(let _=this.map.get(S.parent);_;_=this.map.get(_.parent))if(_===v)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=C;class w{constructor(s,u){this.testIdToInternal=s,this.publishDiff=u,this.testItemToInternal=new Map,this.diff=[],this.debounceSendDiff=new P.RunOnceScheduler(()=>this.flushDiff(),200)}get treeId(){return this.testIdToInternal.object.id}addRoot(s,u){this.addItem(s,u,null)}getTestByReference(s){return this.testItemToInternal.get(s)}collectDiff(){const s=this.diff;return this.diff=[],s}pushDiff(s){const u=this.diff[this.diff.length-1];if(u&&s[0]===1){if(u[0]===1&&u[1].extId===s[1].extId){(0,k.applyTestItemUpdate)(u[1],s[1]);return}if(u[0]===0&&u[1].item.extId===s[1].extId){(0,k.applyTestItemUpdate)(u[1],s[1]);return}}this.diff.push(s),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(s,u){var S;const v=this.testIdToInternal.object.get(s);if(!!v){if((v.expandLevels===void 0||u>v.expandLevels)&&(v.expandLevels=u),v.expand===1){const _=this.refreshChildren(v);return _.isSettled?this.expandChildren(v,u-1):_.p.then(()=>this.expandChildren(v,u-1))}else if(v.expand===3)return((S=v.initialExpand)===null||S===void 0?void 0:S.isSettled)===!1?v.initialExpand.p.then(()=>this.expandChildren(v,u-1)):this.expandChildren(v,u-1)}}dispose(){var s;for(const u of this.testItemToInternal.values())(s=u.discoverCts)===null||s===void 0||s.dispose(!0),u.actual[D.TestItemHookProperty]=void 0;this.diff=[],this.testIdToInternal.dispose(),this.debounceSendDiff.dispose()}addItem(s,u,S){if(!(s instanceof D.TestItem))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${s.id} did not`);if(this.testItemToInternal.has(s))throw new Error(`Attempted to add a single TestItem ${s.id} multiple times to the tree`);if(this.testIdToInternal.object.has(s.id))throw new Error(`Attempted to insert a duplicate test item ID ${s.id}`);const v=S?S.item.extId:null,_=s.expandable?1:0,p=S==null?void 0:S.expandLevels,c={provider:u,tree:this.testIdToInternal.object.id},l={actual:s,parent:v,item:I.TestItem.from(s),expandLevels:p&&_===1?p-1:void 0,expand:_,src:c};this.testIdToInternal.object.add(l),this.testItemToInternal.set(s,l),this.pushDiff([0,{parent:v,src:c,expand:_,item:l.item}]),s[D.TestItemHookProperty]={created:t=>this.addItem(t,u,l),delete:t=>this.removeItembyId(t),invalidate:t=>this.pushDiff([4,t]),setProp:(t,i)=>this.pushDiff([1,{extId:s.id,item:{[t]:t==="range"?I.Range.from(i):i}}])};for(const t of s.children)this.addItem(t,u,l)}expandChildren(s,u){if(!(u<0)){const S=[...s.actual.children].map(v=>this.expand(v.id,u-1)).filter(P.isThenable);if(S.length)return Promise.all(S).then(()=>{})}}refreshChildren(s){s.discoverCts&&s.discoverCts.dispose(!0),s.expand=2,s.discoverCts=new T.CancellationTokenSource,this.pushExpandStateUpdate(s);const u=new P.DeferredPromise;return s.initialExpand=u,s.actual.discoverChildren({report:S=>{S.busy?(s.expand=2,this.pushExpandStateUpdate(s)):(s.expand=3,u.isSettled||u.complete(),this.pushExpandStateUpdate(s))}},s.discoverCts.token),u}pushExpandStateUpdate(s){this.pushDiff([1,{extId:s.actual.id,expand:s.expand}])}removeItembyId(s){var u;this.pushDiff([2,s]);const S=[this.testIdToInternal.object.get(s)];for(;S.length;){const v=S.pop();if(!!v){(u=v.discoverCts)===null||u===void 0||u.dispose(!0),this.testIdToInternal.object.delete(v.item.extId),this.testItemToInternal.delete(v.actual);for(const _ of v.actual.children)S.push(this.testIdToInternal.object.get(_.id))}}}flushDiff(){const s=this.collectDiff();s.length&&this.publishDiff(s)}}e.SingleUseTestCollection=w}),define(ge[222],pe([0,1,29,3,8]),function(G,e,E,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class I{constructor(R){this.removedDueToLooping=R}}e.DeltaExtensionsResult=I;class D{constructor(R){this._onDidChange=new P.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=R,this._initialize()}_initialize(){this._extensionDescriptions.sort(y),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const R of this._extensionDescriptions){if(this._extensionsMap.has(E.ExtensionIdentifier.toKey(R.identifier))){console.error("Extension `"+R.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(E.ExtensionIdentifier.toKey(R.identifier),R),this._extensionsArr.push(R),Array.isArray(R.activationEvents))for(let C of R.activationEvents)C==="onUri"&&(C=`onUri:${E.ExtensionIdentifier.toKey(R.identifier)}`),this._activationMap.has(C)||this._activationMap.set(C,[]),this._activationMap.get(C).push(R)}}keepOnly(R){const C=new Set;R.forEach(w=>C.add(E.ExtensionIdentifier.toKey(w))),this._extensionDescriptions=this._extensionDescriptions.filter(w=>C.has(E.ExtensionIdentifier.toKey(w.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(R,C){R.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(R));const w=D._findLoopingExtensions(this._extensionDescriptions);if(C=C.concat(w.map(g=>g.identifier)),C.length>0){const g=new Set;C.forEach(s=>g.add(E.ExtensionIdentifier.toKey(s))),this._extensionDescriptions=this._extensionDescriptions.filter(s=>!g.has(E.ExtensionIdentifier.toKey(s.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new I(w)}static _findLoopingExtensions(R){const C=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(S){this._nodesSet.has(S)||(this._nodesSet.add(S),this._nodesArr.push(S))}addArc(S,v){this.addNode(S),this.addNode(v),this._arcs.has(S)?this._arcs.get(S).push(v):this._arcs.set(S,[v])}getArcs(S){return this._arcs.has(S)?this._arcs.get(S):[]}hasOnlyGoodArcs(S,v){const _=C.getArcs(S);for(let p=0;p<_.length;p++)if(!v.has(_[p]))return!1;return!0}getNodes(){return this._nodesArr}};let w=new Map;for(let S of R){const v=E.ExtensionIdentifier.toKey(S.identifier);if(w.set(v,S),S.extensionDependencies)for(let _ of S.extensionDependencies){const p=E.ExtensionIdentifier.toKey(_);C.addArc(v,p)}}let g=new Set;C.getNodes().filter(S=>C.getArcs(S).length===0).forEach(S=>g.add(S));let s=C.getNodes().filter(S=>!g.has(S)),u;do{u=!1;for(let S=0;S<s.length;S++){const v=s[S];C.hasOnlyGoodArcs(v,g)&&(s.splice(S,1),S--,g.add(v),u=!0)}}while(u);return s.map(S=>w.get(S))}containsActivationEvent(R){return this._activationMap.has(R)}containsExtension(R){return this._extensionsMap.has(E.ExtensionIdentifier.toKey(R))}getExtensionDescriptionsForActivationEvent(R){const C=this._activationMap.get(R);return C?C.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(R){const C=this._extensionsMap.get(E.ExtensionIdentifier.toKey(R));return C||void 0}}e.ExtensionDescriptionRegistry=D;var k;(function(n){n[n.Builtin=0]="Builtin",n[n.User=1]="User",n[n.Dev=2]="Dev"})(k||(k={}));function y(n,R){const C=n.isBuiltin?0:n.isUnderDevelopment?2:1,w=R.isBuiltin?0:R.isUnderDevelopment?2:1;if(C!==w)return C-w;const g=T.posix.basename(n.extensionLocation.path),s=T.posix.basename(R.extensionLocation.path);return g<s?-1:g>s?1:0}}),define(ge[223],pe([0,1,22]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var P;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(P=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var T;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(T=e.MessageType||(e.MessageType={}));function I(k){const y=E.VSBuffer.alloc(1);switch(k){case 0:y.writeUInt8(1,0);break;case 1:y.writeUInt8(2,0);break;case 2:y.writeUInt8(3,0);break}return y}e.createMessageOfType=I;function D(k,y){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return y===0;case 2:return y===1;case 3:return y===2;default:return!1}}e.isMessageOfType=D}),define(ge[41],pe([0,1,3,2,4,29,183]),function(G,e,E,P,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingDependencyError=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new I.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:P.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,T.createDecorator)("extensionService");class k{constructor(_){this.dependency=_}}e.MissingDependencyError=k;var y;(function(v){v[v.LocalProcess=0]="LocalProcess",v[v.LocalWebWorker=1]="LocalWebWorker",v[v.Remote=2]="Remote"})(y=e.ExtensionHostKind||(e.ExtensionHostKind={}));class n{constructor(_,p,c,l){this.codeLoadingTime=_,this.activateCallTime=p,this.activateResolvedTime=c,this.activationReason=l}}e.ActivationTimes=n;class R{constructor(_,p){this.description=_,this.value=p}}e.ExtensionPointContribution=R,e.ExtensionHostLogFileName="exthost";var C;(function(v){v[v.Normal=0]="Normal",v[v.Immediate=1]="Immediate"})(C=e.ActivationKind||(e.ActivationKind={}));function w(v){v.enableProposedApi||g(v)}e.checkProposedApiEnabled=w;function g(v){throw new Error(`[${v.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${v.identifier.value}`)}e.throwProposedApiError=g;function s(v){return{type:v.isBuiltin?0:1,isBuiltin:v.isBuiltin||v.isUserBuiltin,identifier:{id:(0,D.getGalleryExtensionId)(v.publisher,v.name),uuid:v.uuid},manifest:v,location:v.extensionLocation}}e.toExtension=s;function u(v){return Object.assign(Object.assign({identifier:new I.ExtensionIdentifier(v.identifier.id),isBuiltin:v.type===0,isUserBuiltin:v.type===1&&v.isBuiltin,isUnderDevelopment:!1,extensionLocation:v.location},v.manifest),{uuid:v.identifier.uuid})}e.toExtensionDescription=u;class S{constructor(){this.onDidRegisterExtensions=E.Event.None,this.onDidChangeExtensionsStatus=E.Event.None,this.onDidChangeExtensions=E.Event.None,this.onWillActivateByEvent=E.Event.None,this.onDidChangeResponsiveChange=E.Event.None}activateByEvent(_){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(_){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(_){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(_){}canAddExtension(){return!1}canRemoveExtension(){return!1}_logOrShowMessage(_,p){}_activateById(_,p){return Promise.resolve()}_onWillActivateExtension(_){}_onDidActivateExtension(_,p,c,l,t){}_onExtensionRuntimeError(_,p){}_onExtensionHostExit(_){}}e.NullExtensionService=S}),define(ge[224],pe([0,1,160,29,41,12]),function(G,e,E,P,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const D=Promise.resolve(void 0);class k{constructor(u,S,v,_){this.startup=u,this.codeLoadingTime=S,this.activateCallTime=v,this.activateResolvedTime=_}}e.ExtensionActivationTimes=k,k.NONE=new k(!1,-1,-1,-1);class y{constructor(u){this._startup=u,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(u,S){return u===-1||S===-1?-1:S-u}build(){return new k(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=y;class n{constructor(u,S,v,_,p,c){this.activationFailed=u,this.activationFailedError=S,this.activationTimes=v,this.module=_,this.exports=p,this.subscriptions=c}}e.ActivatedExtension=n;class R extends n{constructor(u){super(!1,null,u,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=R;class C extends n{constructor(){super(!1,null,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=C;class w extends n{constructor(u){super(!0,u,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=w;let g=class{constructor(u,S,v,_,p){this._logService=p,this._registry=u,this._resolvedExtensionsSet=new Set,S.forEach(c=>this._resolvedExtensionsSet.add(P.ExtensionIdentifier.toKey(c))),this._hostExtensionsMap=new Map,v.forEach(c=>this._hostExtensionsMap.set(P.ExtensionIdentifier.toKey(c),c)),this._host=_,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(u){const S=P.ExtensionIdentifier.toKey(u);return this._activatedExtensions.has(S)}getActivatedExtension(u){const S=P.ExtensionIdentifier.toKey(u),v=this._activatedExtensions.get(S);if(!v)throw new Error("Extension `"+u.value+"` is not known or not activated");return v}activateByEvent(u,S){if(this._alreadyActivatedEvents[u])return D;const v=this._registry.getExtensionDescriptionsForActivationEvent(u);return this._activateExtensions(v.map(_=>({id:_.identifier,reason:{startup:S,extensionId:_.identifier,activationEvent:u}}))).then(()=>{this._alreadyActivatedEvents[u]=!0})}activateById(u,S){const v=this._registry.getExtensionDescription(u);if(!v)throw new Error("Extension `"+u+"` is not known");return this._activateExtensions([{id:v.identifier,reason:S}])}_handleActivateRequest(u,S,v){if(this._hostExtensionsMap.has(P.ExtensionIdentifier.toKey(u.id))){S[P.ExtensionIdentifier.toKey(u.id)]=u;return}const _=this._registry.getExtensionDescription(u.id);if(!_){this._host.onExtensionActivationError(u.id,new T.MissingDependencyError(u.id.value));const l=new Error(`Unknown dependency '${u.id.value}'`);this._activatedExtensions.set(P.ExtensionIdentifier.toKey(u.id),new w(l));return}const p=typeof _.extensionDependencies=="undefined"?[]:_.extensionDependencies;let c=!0;for(let l=0,t=p.length;l<t;l++){const i=p[l];if(!this._resolvedExtensionsSet.has(P.ExtensionIdentifier.toKey(i))){const o=this._activatedExtensions.get(P.ExtensionIdentifier.toKey(i));if(!(o&&!o.activationFailed)){if(o&&o.activationFailed){this._host.onExtensionActivationError(_.identifier,E.localize(0,null,_.displayName||_.identifier.value,i));const h=new Error(`Dependency ${i} failed to activate`);h.detail=o.activationFailedError,this._activatedExtensions.set(P.ExtensionIdentifier.toKey(_.identifier),new w(h));return}if(this._hostExtensionsMap.has(P.ExtensionIdentifier.toKey(i))){c=!1,S[P.ExtensionIdentifier.toKey(i)]={id:this._hostExtensionsMap.get(P.ExtensionIdentifier.toKey(i)),reason:u.reason};continue}const r=this._registry.getExtensionDescription(i);if(r){c=!1,S[P.ExtensionIdentifier.toKey(i)]={id:r.identifier,reason:u.reason};continue}this._host.onExtensionActivationError(_.identifier,new T.MissingDependencyError(i));const a=new Error(`Unknown dependency '${i}'`);this._activatedExtensions.set(P.ExtensionIdentifier.toKey(_.identifier),new w(a));return}}}c?S[P.ExtensionIdentifier.toKey(_.identifier)]=u:v.push(u)}_activateExtensions(u){if(u.length===0||(u=u.filter(p=>!this._activatedExtensions.has(P.ExtensionIdentifier.toKey(p.id))),u.length===0))return Promise.resolve(void 0);const S=Object.create(null),v=[];for(let p=0,c=u.length;p<c;p++)this._handleActivateRequest(u[p],S,v);for(let p=0,c=v.length;p<c;p++){const l=P.ExtensionIdentifier.toKey(v[p].id);S[l]&&delete S[l]}const _=Object.keys(S).map(p=>S[p]);return v.length===0?Promise.all(_.map(p=>this._activateExtension(p.id,p.reason))).then(p=>{}):this._activateExtensions(_).then(p=>this._activateExtensions(v))}_activateExtension(u,S){const v=P.ExtensionIdentifier.toKey(u);if(this._activatedExtensions.has(v))return Promise.resolve(void 0);const _=this._activatingExtensions.get(v);if(_)return _;const p=this._host.actualActivateExtension(u,S).then(void 0,c=>(this._host.onExtensionActivationError(u,E.localize(1,null,u.value,c.message)),this._logService.error(`Activating extension ${u.value} failed due to an error:`),this._logService.error(c),new w(c))).then(c=>{this._activatedExtensions.set(v,c),this._activatingExtensions.delete(v)});return this._activatingExtensions.set(v,p),p}};g=je([Ue(4,I.ILogService)],g),e.ExtensionsActivator=g}),define(ge[225],pe([0,1,12,41,27,11,109]),function(G,e,E,P,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let k=class extends E.LogService{constructor(n){if(n.logFile.scheme!==I.Schemas.file)throw new Error("Only file-logging supported");super(new D.SpdLogLogger(P.ExtensionHostLogFileName,n.logFile.fsPath,!0,n.logLevel))}$setLevel(n){this.setLevel(n)}};k=je([Ue(0,T.IExtHostInitDataService)],k),e.ExtHostLogService=k}),define(ge[226],pe([0,1,18]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class P{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((I,D)=>{this._actualOk=I,this._actualErr=D,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(I){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=I,this._actual&&this._actualOk(I))}resolveErr(I){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=I,this._actual?this._actualErr(I):(0,E.onUnexpectedError)(I))}then(I,D){return this._ensureActual().then(I,D)}catch(I){return this._ensureActual().then(void 0,I)}finally(I){return this._ensureActual().finally(I)}}e.LazyPromise=P}),define(ge[123],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class E{constructor(y,n){this.isMain=y,this.sid=n,this.nid=++E.count}}e.ProxyIdentifier=E,E.count=0;const P=[];function T(k){const y=new E(!0,k);return P[y.nid]=y,y}e.createMainContextProxyIdentifier=T;function I(k){const y=new E(!1,k);return P[y.nid]=y,y}e.createExtHostContextProxyIdentifier=I;function D(k){return P[k].sid}e.getStringIdentifierForProxy=D}),define(ge[5],pe([0,1,2,123,57]),function(G,e,E,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.CellKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var I;(function(c){c[c.Desktop=1]="Desktop",c[c.Web=2]="Web"})(I=e.UIKind||(e.UIKind={}));var D;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(D=e.TextEditorRevealType||(e.TextEditorRevealType={}));var k;(function(c){c[c.Editable=0]="Editable",c[c.SupportsHotExit=1]="SupportsHotExit"})(k=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var y;(function(c){c[c.Int8Array=1]="Int8Array",c[c.Uint8Array=2]="Uint8Array",c[c.Uint8ClampedArray=3]="Uint8ClampedArray",c[c.Int16Array=4]="Int16Array",c[c.Uint16Array=5]="Uint16Array",c[c.Int32Array=6]="Int32Array",c[c.Uint32Array=7]="Uint32Array",c[c.Float32Array=8]="Float32Array",c[c.Float64Array=9]="Float64Array",c[c.BigInt64Array=10]="BigInt64Array",c[c.BigUint64Array=11]="BigUint64Array"})(y=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var n;(function(c){c[c.Markdown=1]="Markdown",c[c.Code=2]="Code"})(n=e.CellKind||(e.CellKind={}));var R;(function(c){c[c.Text=1]="Text",c[c.Error=2]="Error",c[c.Rich=3]="Rich"})(R=e.CellOutputKind||(e.CellOutputKind={}));var C;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(C=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var w;(function(c){c[c.None=0]="None",c[c.Process=1]="Process",c[c.Output=2]="Output"})(w=e.CandidatePortSource||(e.CandidatePortSource={}));var g;(function(c){c.name="$ident";function l(i,o){return Object.defineProperty(i,c.name,{value:o,enumerable:!0}),i}c.mixin=l;function t(i){return i[c.name]}c.of=t})(g=e.ObjectIdentifier||(e.ObjectIdentifier={}));class s{static mixin(l){return l._id=s._n++,l}}e.IdObject=s,s._n=0;var u;(function(c){c.label="a",c.kind="b",c.detail="c",c.documentation="d",c.sortText="e",c.filterText="f",c.preselect="g",c.insertText="h",c.insertTextRules="i",c.range="j",c.commitCharacters="k",c.additionalTextEdits="l",c.command="m",c.kindModifier="n",c.label2="o"})(u=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var S;(function(c){c.defaultRanges="a",c.completions="b",c.isIncomplete="c",c.duration="d"})(S=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var v;(function(c){c[c.File=1]="File",c[c.Text=2]="Text",c[c.Cell=3]="Cell"})(v=e.WorkspaceEditType||(e.WorkspaceEditType={}));function _(c){if(c&&c.edits)for(const l of c.edits)typeof l.resource=="object"?l.resource=E.URI.revive(l.resource):(l.newUri=E.URI.revive(l.newUri),l.oldUri=E.URI.revive(l.oldUri)),l.metadata&&l.metadata.iconPath&&(l.metadata=(0,T.revive)(l.metadata));return c}e.reviveWorkspaceEditDto=_;var p;(function(c){c[c.Workspace=0]="Workspace",c[c.TextDocument=1]="TextDocument"})(p=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,P.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,P.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,P.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,P.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,P.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,P.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,P.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,P.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,P.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,P.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,P.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,P.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,P.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,P.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,P.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,P.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,P.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,P.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,P.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,P.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,P.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,P.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,P.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,P.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,P.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,P.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,P.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,P.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,P.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,P.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,P.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,P.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,P.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,P.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,P.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,P.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,P.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,P.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,P.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,P.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,P.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,P.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,P.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,P.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,P.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,P.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,P.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,P.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,P.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,P.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadTheming:(0,P.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,P.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,P.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,P.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,P.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,P.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,P.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,P.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,P.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,P.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,P.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,P.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,P.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,P.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,P.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,P.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,P.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,P.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,P.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,P.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,P.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,P.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,P.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,P.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,P.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,P.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,P.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,P.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,P.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,P.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,P.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,P.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,P.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,P.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,P.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,P.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,P.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,P.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,P.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,P.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,P.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,P.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,P.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookKernels:(0,P.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostTheming:(0,P.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,P.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,P.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,P.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,P.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,P.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(ge[86],pe([0,1,5,3,4]),function(G,e,E,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class I{constructor(k){this._onDidChangePassword=new P.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=k.getProxy(E.MainContext.MainThreadSecretState)}async $onDidChangePassword(k){this._onDidChangePassword.fire(k)}get(k,y){return this._proxy.$getPassword(k,y)}store(k,y,n){return this._proxy.$setPassword(k,y,n)}delete(k,y){return this._proxy.$deletePassword(k,y)}}e.ExtHostSecretState=I,e.IExtHostSecretState=(0,T.createDecorator)("IExtHostSecretState")}),define(ge[62],pe([0,1,4,12,5,13]),function(G,e,E,P,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,E.createDecorator)("IExtHostApiDeprecationService");let D=class{constructor(y,n){this._extHostLogService=n,this._reportedUsages=new Set,this._telemetryShape=y.getProxy(T.MainContext.MainThreadTelemetry)}report(y,n,R){const C=this.getUsageKey(y,n);this._reportedUsages.has(C)||(this._reportedUsages.add(C),n.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${y}' is deprecated. ${R}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:n.identifier.value,apiId:y}))}getUsageKey(y,n){return`${y}-${n.identifier.value}`}};D=je([Ue(0,I.IExtHostRpcService),Ue(1,P.ILogService)],D),e.ExtHostApiDeprecationService=D,e.NullApiDeprecationService=Object.freeze(new class{report(k,y,n){}})}),define(ge[227],pe([0,1,3,5,7,29]),function(G,e,E,P,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class D{constructor(y){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new E.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new E.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=y.getProxy(P.MainContext.MainThreadAuthentication)}$setProviders(y){return this._providers=y,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(y,n,R,C={}){const w=I.ExtensionIdentifier.toKey(y.identifier),g=this._inFlightRequests.get(w)||[],s=R.sort().join(" ");let u=g.find(S=>S.scopes===s);if(u)return u.result;{const S=this._getSession(y,w,n,R,C);u={scopes:s,result:S},g.push(u),this._inFlightRequests.set(w,g);try{await S}finally{const v=g.findIndex(_=>_.scopes===s);v>-1&&(g.splice(v),this._inFlightRequests.set(w,g))}return S}}async _getSession(y,n,R,C,w={}){await this._proxy.$ensureProvider(R);const g=y.displayName||y.name;return this._proxy.$getSession(R,C,n,g,w)}async removeSession(y,n){const R=this._authenticationProviders.get(y);return R?R.provider.removeSession(n):this._proxy.$removeSession(y,n)}registerAuthenticationProvider(y,n,R,C){var w;if(this._authenticationProviders.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this._authenticationProviders.set(y,{label:n,provider:R,options:C!=null?C:{supportsMultipleAccounts:!1}}),this._providers.find(s=>s.id===y)||this._providers.push({id:y,label:n});const g=R.onDidChangeSessions(s=>{var u,S,v;this._proxy.$sendDidChangeSessions(y,{added:(u=s.added)!==null&&u!==void 0?u:[],changed:(S=s.changed)!==null&&S!==void 0?S:[],removed:(v=s.removed)!==null&&v!==void 0?v:[]})});return this._proxy.$registerAuthenticationProvider(y,n,(w=C==null?void 0:C.supportsMultipleAccounts)!==null&&w!==void 0?w:!1),new T.Disposable(()=>{g.dispose(),this._authenticationProviders.delete(y);const s=this._providers.findIndex(u=>u.id===y);s>-1&&this._providers.splice(s),this._proxy.$unregisterAuthenticationProvider(y)})}$createSession(y,n){const R=this._authenticationProviders.get(y);if(R)return Promise.resolve(R.provider.createSession(n));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,n){const R=this._authenticationProviders.get(y);if(R)return Promise.resolve(R.provider.removeSession(n));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,n){const R=this._authenticationProviders.get(y);if(R)return Promise.resolve(R.provider.getSessions(n));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,n){return this._onDidChangeSessions.fire({provider:{id:y,label:n}}),Promise.resolve()}$onDidChangeAuthenticationProviders(y,n){return y.forEach(R=>{this._providers.some(C=>C.id===R.id)||this._providers.push(R)}),n.forEach(R=>{const C=this._providers.findIndex(w=>w.id===R.id);C>-1&&this._providers.splice(C)}),this._onDidChangeAuthenticationProviders.fire({added:y,removed:n}),Promise.resolve()}}e.ExtHostAuthentication=D}),define(ge[228],pe([0,1,5,13,20]),function(G,e,E,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let I=class{constructor(k,y){this._extHostDocumentsAndEditors=y,this._proxy=k.getProxy(E.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(k){const y=T.WorkspaceEdit.from(k,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(y)}};I=je([Ue(0,P.IExtHostRpcService)],I),e.ExtHostBulkEdits=I}),define(ge[229],pe([0,1,5]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class P{constructor(I){const D=I.getProxy(E.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return D.$readText()},writeText(k){return D.$writeText(k)}})}}e.ExtHostClipboard=P}),define(ge[51],pe([0,1,15,7,20,23,5,14,12,57,44,49,2,6,4,13]),function(G,e,E,P,T,I,D,k,y,n,R,C,w,g,s,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let S=class{constructor(t,i){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(D.MainContext.MainThreadCommands),this._logService=i,this.converter=new v(this,o=>{const r=this._apiCommands.get(o);return(r==null?void 0:r.result)===p.Void?r:void 0},i),this._argumentProcessors=[{processArgument(o){return(0,n.revive)(o)}},{processArgument(o){return(0,I.cloneAndChange)(o,function(r){if(R.Range.isIRange(r))return T.Range.to(r);if(C.Position.isIPosition(r))return T.Position.to(r);if(R.Range.isIRange(r.range)&&w.URI.isUri(r.uri))return T.location.to(r);if(!Array.isArray(r))return r})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const i=this.registerCommand(!1,t.id,async(...o)=>{const r=t.args.map((h,m)=>{if(!h.validate(o[m]))throw new Error(`Invalid argument '${h.name}' when running '${t.id}', received: ${o[m]}`);return h.convert(o[m])}),a=await this.executeCommand(t.internalId,...r);return t.result.convert(a,o,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new P.Disposable(()=>{i.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,i,o,r,a){if(this._logService.trace("ExtHostCommands#registerCommand",i),!i.trim().length)throw new Error("invalid id");if(this._commands.has(i))throw new Error(`command '${i}' already exists`);return this._commands.set(i,{callback:o,thisArg:r,description:a}),t&&this._proxy.$registerCommand(i),new P.Disposable(()=>{this._commands.delete(i)&&t&&this._proxy.$unregisterCommand(i)})}executeCommand(t,...i){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,i,!0)}async _doExecuteCommand(t,i,o){if(this._commands.has(t))return this._executeContributedCommand(t,i);{const r=(0,I.cloneAndChange)(i,function(a){if(a instanceof P.Position)return T.Position.from(a);if(a instanceof P.Range)return T.Range.from(a);if(a instanceof P.Location)return T.location.from(a);if(!Array.isArray(a))return a});try{const a=await this._proxy.$executeCommand(t,r,o);return(0,n.revive)(a)}catch(a){if(a instanceof Error&&a.message==="$executeCommand:retry")return this._doExecuteCommand(t,i,!1);throw a}}}async _executeContributedCommand(t,i){const o=this._commands.get(t);if(!o)throw new Error("Unknown command");let{callback:r,thisArg:a,description:h}=o;if(h)for(let m=0;m<h.args.length;m++)try{(0,E.validateConstraint)(i[m],h.args[m].constraint)}catch(b){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${h.args[m].name}' - ${h.args[m].description}`)}try{return await r.apply(a,i)}catch(m){if(t===this.converter.delegatingCommandId){const b=this.converter.getActualCommand(...i);b&&(t=b.command)}throw this._logService.error(m,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...i){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(i=i.map(o=>this._argumentProcessors.reduce((r,a)=>a.processArgument(r),o)),this._executeContributedCommand(t,i)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(i=>(t&&(i=i.filter(o=>o[0]!=="_")),i))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[i,o]of this._commands){let{description:r}=o;r&&(t[i]=r)}return Promise.resolve(t)}};S=je([Ue(0,u.IExtHostRpcService),Ue(1,y.ILogService)],S),e.ExtHostCommands=S,e.IExtHostCommands=(0,s.createDecorator)("IExtHostCommands");class v{constructor(t,i,o){this._commands=t,this._lookupApiCommand=i,this._logService=o,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,i){if(!!t){const o={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return o;const r=this._lookupApiCommand(t.command);if(r)o.id=r.internalId,o.arguments=r.args.map((a,h)=>a.convert(t.arguments&&t.arguments[h]));else if((0,k.isNonEmptyArray)(t.arguments)){const a=++this._cachIdPool;this._cache.set(a,t),i.add((0,g.toDisposable)(()=>{this._cache.delete(a),this._logService.trace("CommandsConverter#DISPOSE",a)})),o.$ident=a,o.id=this.delegatingCommandId,o.arguments=[a],this._logService.trace("CommandsConverter#CREATE",t.command,a)}return o}}fromInternal(t){const i=D.ObjectIdentifier.of(t);return typeof i=="number"?this._cache.get(i):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const i=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],i?i.command:"MISSING"),i?this._commands.executeCommand(i.command,...i.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=v;class _{constructor(t,i,o,r){this.name=t,this.description=i,this.validate=o,this.convert=r}optional(){return new _(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,i){return new _(t!=null?t:this.name,i!=null?i:this.description,this.validate,this.convert)}}e.ApiCommandArgument=_,_.Uri=new _("uri","Uri of a text document",l=>w.URI.isUri(l),l=>l),_.Position=new _("position","A position in a text document",l=>P.Position.isPosition(l),T.Position.from),_.Range=new _("range","A range in a text document",l=>P.Range.isRange(l),T.Range.from),_.Selection=new _("selection","A selection in a text document",l=>P.Selection.isSelection(l),T.Selection.from),_.Number=new _("number","",l=>typeof l=="number",l=>l),_.String=new _("string","",l=>typeof l=="string",l=>l),_.CallHierarchyItem=new _("item","A call hierarchy item",l=>l instanceof P.CallHierarchyItem,T.CallHierarchyItem.to);class p{constructor(t,i){this.description=t,this.convert=i}}e.ApiCommandResult=p,p.Void=new p("no result",l=>l);class c{constructor(t,i,o,r,a){this.id=t,this.internalId=i,this.description=o,this.args=r,this.result=a}}e.ApiCommand=c}),define(ge[230],pe([0,1,6,20,7,79,51,202,14,106]),function(G,e,E,P,T,I,D,k,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const R=[new D.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",w(P.DocumentHighlight.to))),new D.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",(s,u)=>{if(!(0,y.isFalsyOrEmpty)(s)){class S extends T.SymbolInformation{static to(_){const p=new S(_.name,P.SymbolKind.to(_.kind),_.containerName||"",new T.Location(u[0],P.Range.to(_.range)));return p.detail=_.detail,p.range=p.location.range,p.selectionRange=P.Range.to(_.selectionRange),p.children=_.children?_.children.map(S.to):[],p}}return s.map(S.to)}})),new D.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("options","Formatting options",s=>!0,s=>s)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",w(P.TextEdit.to))),new D.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range,new D.ApiCommandArgument("options","Formatting options",s=>!0,s=>s)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",w(P.TextEdit.to))),new D.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,new D.ApiCommandArgument("ch","Trigger character",s=>typeof s=="string",s=>s),new D.ApiCommandArgument("options","Formatting options",s=>!0,s=>s)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",w(P.TextEdit.to))),new D.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new D.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new D.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new D.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new D.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location-instances.",w(P.location.to))),new D.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Hover-instances.",w(P.Hover.to))),new D.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("position","A position in a text document",s=>Array.isArray(s)&&s.every(u=>T.Position.isPosition(u)),s=>s.map(P.Position.from))],new D.ApiCommandResult("A promise that resolves to an array of ranges.",s=>s.map(u=>{let S;for(const v of u.reverse())S=new T.SelectionRange(P.Range.to(v),S);return S}))),new D.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[D.ApiCommandArgument.String.with("query","Search string")],new D.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",s=>{const u=[];if(Array.isArray(s))for(let S of s)u.push(...S[1].map(P.WorkspaceSymbol.to));return u})),new D.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A CallHierarchyItem or undefined",s=>s.map(P.CallHierarchyItem.to))),new D.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[D.ApiCommandArgument.CallHierarchyItem],new D.ApiCommandResult("A CallHierarchyItem or undefined",s=>s.map(P.CallHierarchyIncomingCall.to))),new D.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[D.ApiCommandArgument.CallHierarchyItem],new D.ApiCommandResult("A CallHierarchyItem or undefined",s=>s.map(P.CallHierarchyOutgoingCall.to))),new D.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("newName","The new symbol name")],new D.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",s=>{if(!!s){if(s.rejectReason)throw new Error(s.rejectReason);return P.WorkspaceEdit.to(s)}})),new D.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new D.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",s=>s.map(P.DocumentLink.to))),new D.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",s=>{if(!!s)return new T.SemanticTokensLegend(s.tokenTypes,s.tokenModifiers)})),new D.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokens.",s=>{if(!!s){const u=(0,n.decodeSemanticTokensDto)(s);if(u.type==="full")return new T.SemanticTokens(u.data,void 0)}})),new D.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",s=>{if(!!s)return new T.SemanticTokensLegend(s.tokenTypes,s.tokenModifiers)})),new D.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to SemanticTokens.",s=>{if(!!s){const u=(0,n.decodeSemanticTokensDto)(s);if(u.type==="full")return new T.SemanticTokens(u.data,void 0)}})),new D.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),D.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new D.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(s,u,S)=>{if(!s)return new T.CompletionList([]);const v=s.suggestions.map(_=>P.CompletionItem.to(_,S));return new T.CompletionList(v,s.incomplete)})),new D.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new D.ApiCommandResult("A promise that resolves to SignatureHelp.",s=>{if(s)return P.SignatureHelp.to(s)})),new D.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new D.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(s,u,S)=>w(v=>new T.CodeLens(P.Range.to(v.range),v.command&&S.fromInternal(v.command)))(s))),new D.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",s=>T.Range.isRange(s),s=>T.Selection.isSelection(s)?P.Selection.from(s):P.Range.from(s)),D.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),D.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new D.ApiCommandResult("A promise that resolves to an array of Command-instances.",(s,u,S)=>w(v=>{if(v._isSynthetic){if(!v.command)throw new Error("Synthetic code actions must have a command");return S.fromInternal(v.command)}else{const _=new T.CodeAction(v.title,v.kind?new T.CodeActionKind(v.kind):void 0);return v.edit&&(_.edit=P.WorkspaceEdit.to(v.edit)),v.command&&(_.command=S.fromInternal(v.command)),_.isPreferred=v.isPreferred,_}})(s))),new D.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",s=>s?s.map(u=>new T.ColorInformation(P.Range.to(u.range),P.Color.to(u.color))):[])),new D.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new D.ApiCommandArgument("color","The color to show and insert",s=>s instanceof T.Color,P.Color.from),new D.ApiCommandArgument("context","Context object with uri and range",s=>!0,s=>({uri:s.uri,range:P.Range.from(s.range)}))],new D.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",s=>s?s.map(P.ColorPresentation.to):[])),new D.ApiCommand("vscode.executeInlineHintProvider","_executeInlineHintProvider","Execute inline hints provider",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to an array of InlineHint objects",s=>s.map(P.InlineHint.to))),new D.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new D.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",w(s=>({viewType:s.viewType,displayName:s.displayName,options:{transientOutputs:s.options.transientOutputs,transientMetadata:s.options.transientMetadata},filenamePattern:s.filenamePattern.map(u=>P.NotebookExclusiveDocumentPattern.to(u))})))),new D.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to an array of InlineValue objects",s=>s.map(P.InlineValue.to))),new D.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[s,void 0]:[P.ViewColumn.from(s.viewColumn),P.TextEditorOpenOptions.from(s)])).optional(),D.ApiCommandArgument.String.with("label","").optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[D.ApiCommandArgument.Uri.with("resource","Resource to open"),D.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[s,void 0]:[P.ViewColumn.from(s.viewColumn),P.TextEditorOpenOptions.from(s)])).optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[D.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),D.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),D.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="object",s=>s&&[P.ViewColumn.from(s.viewColumn),P.TextEditorOpenOptions.from(s)]).optional()],D.ApiCommandResult.Void)];class C{constructor(u){this._disposables=new E.DisposableStore,this._commands=u}static register(u){return R.forEach(u.registerApiCommand,u),new C(u).registerCommands()}registerCommands(){const u=S=>(...v)=>S(this._commands,...v);this._register(k.RemoveFromRecentlyOpenedAPICommand.ID,u(k.RemoveFromRecentlyOpenedAPICommand.execute),{description:"Removes an entry with the given path from the recently opened list.",args:[{name:"path",description:"Path to remove from recently opened.",constraint:S=>typeof S=="string"}]}),this._register(k.OpenIssueReporter.ID,u(k.OpenIssueReporter.execute),{description:"Opens the issue reporter with the provided extension id as the selected source",args:[{name:"extensionId",description:"extensionId to report an issue on",constraint:S=>typeof S=="string"||typeof S=="object"&&typeof S.extensionId=="string"}]})}_register(u,S,v){const _=this._commands.registerCommand(!1,u,S,this,v);this._disposables.add(_)}}e.ExtHostApiCommands=C;function w(s){return u=>{if(Array.isArray(u))return u.map(s)}}function g(s){if(!!Array.isArray(s)){const u=[];for(const S of s)I.isLocationLink(S)?u.push(P.DefinitionLink.to(S)):u.push(P.location.to(S));return u}}}),define(ge[231],pe([0,1,19,68,3,6,2,79,29,20,7,5]),function(G,e,E,P,T,I,D,k,y,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class w{constructor(c,l,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=c.getProxy(C.MainContext.MainThreadComments),l.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const o=this._commentControllers.get(i.handle);return o||i}else if(i&&i.$mid===7){const o=this._commentControllers.get(i.commentControlHandle);if(!o)return i;const r=o.getCommentThread(i.commentThreadHandle);return r||i}else if(i&&i.$mid===8){const o=this._commentControllers.get(i.thread.commentControlHandle);if(!o)return i;const r=o.getCommentThread(i.thread.commentThreadHandle);return r?{thread:r,text:i.text}:i}else if(i&&i.$mid===9){const o=this._commentControllers.get(i.thread.commentControlHandle);if(!o)return i;const r=o.getCommentThread(i.thread.commentThreadHandle);if(!r)return i;let a=i.commentUniqueId,h=r.getCommentByUniqueId(a);return h||i}else if(i&&i.$mid===10){const o=this._commentControllers.get(i.thread.commentControlHandle);if(!o)return i;const r=o.getCommentThread(i.thread.commentThreadHandle);if(!r)return i;let a=i.text,h=i.commentUniqueId,m=r.getCommentByUniqueId(h);return m?(m.body=a,m):i}return i}})}createCommentController(c,l,t){const i=w.handlePool++,o=new s(c,i,this._proxy,l,t);this._commentControllers.set(o.handle,o);const r=this._commentControllersByExtension.get(y.ExtensionIdentifier.toKey(c.identifier))||[];return r.push(o),this._commentControllersByExtension.set(y.ExtensionIdentifier.toKey(c.identifier),r),o}$createCommentThreadTemplate(c,l,t){const i=this._commentControllers.get(c);!i||i.$createCommentThreadTemplate(l,t)}async $updateCommentThreadTemplate(c,l,t){const i=this._commentControllers.get(c);!i||i.$updateCommentThreadTemplate(l,t)}$deleteCommentThread(c,l){const t=this._commentControllers.get(c);t&&t.$deleteCommentThread(l)}$provideCommentingRanges(c,l,t){const i=this._commentControllers.get(c);if(!i||!i.commentingRangeProvider)return Promise.resolve(void 0);const o=this._documents.getDocument(D.URI.revive(l));return(0,E.asPromise)(()=>i.commentingRangeProvider.provideCommentingRanges(o,t)).then(r=>r?r.map(a=>n.Range.from(a)):void 0)}$toggleReaction(c,l,t,i,o){const r=this._commentControllers.get(c);return!r||!r.reactionHandler?Promise.resolve(void 0):(0,E.asPromise)(()=>{const a=r.getCommentThread(l);if(a){const h=a.getCommentByUniqueId(i.uniqueIdInThread);if(r!==void 0&&h&&r.reactionHandler)return r.reactionHandler(h,v(o))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=w,w.handlePool=0;class g{constructor(c,l,t,i,o,r,a){this._proxy=c,this._commentController=l,this._id=t,this._uri=i,this._range=o,this._comments=r,this.handle=g._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new T.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new I.MutableDisposable,this._acceptInputDisposables.value=new I.DisposableStore,this._id===void 0&&(this._id=`${l.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,n.Range.from(this._range),a),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=r}set threadId(c){this._id=c}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(c){c.isEqual(this._range)||(this._range=c,this.modifications.range=c,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(c){this._canReply!==c&&(this._canReply=c,this.modifications.canReply=c,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(c){this._label=c,this.modifications.label=c,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(c){this._contextValue=c,this.modifications.contextValue=c,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(c){this._comments=c,this.modifications.comments=c,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(c){this._collapseState=c,this.modifications.collapsibleState=c,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(!this._isDiposed){this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new I.DisposableStore);const c=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),l={};c("range")&&(l.range=n.Range.from(this._range)),c("label")&&(l.label=this.label),c("contextValue")&&(l.contextValue=this.contextValue),c("comments")&&(l.comments=this._comments.map(t=>u(this,this._commentController,t,this._commentsMap))),c("collapsibleState")&&(l.collapseState=_(this._collapseState)),c("canReply")&&(l.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,l)}}getCommentByUniqueId(c){for(let l of this._commentsMap){let t=l[0],i=l[1];if(c===i)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(c=>c.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}g._handlePool=0,je([(0,P.debounce)(100)],g.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=g;class s{constructor(c,l,t,i,o){this._extension=c,this._handle=l,this._proxy=t,this._id=i,this._label=o,this._threads=new Map,this._proxy.$registerCommentController(this.handle,i,o)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(c){this._reactionHandler=c,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!c})}get options(){return this._options}set options(c){this._options=c,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(c,l,t,i){if(typeof c=="string"){const o=new g(this._proxy,this,c,l,t,i,this._extension.identifier);return this._threads.set(o.handle,o),o}else{const o=new g(this._proxy,this,void 0,c,l,t,this._extension.identifier);return this._threads.set(o.handle,o),o}}$createCommentThreadTemplate(c,l){const t=new g(this._proxy,this,void 0,D.URI.revive(c),n.Range.to(l),[],this._extension.identifier);return t.collapsibleState=k.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(c,l){let t=this._threads.get(c);t&&(t.range=n.Range.to(l))}$deleteCommentThread(c){let l=this._threads.get(c);l&&l.dispose(),this._threads.delete(c)}getCommentThread(c){return this._threads.get(c)}dispose(){this._threads.forEach(c=>{c.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function u(p,c,l,t){let i=t.get(l);i||(i=++p.commentHandle,t.set(l,i));const o=l.author&&l.author.iconPath?l.author.iconPath.toString():void 0;return{mode:l.mode,contextValue:l.contextValue,uniqueIdInThread:i,body:n.MarkdownString.from(l.body),userName:l.author.name,userIconPath:o,label:l.label,commentReactions:l.reactions?l.reactions.map(r=>S(r)):void 0}}function S(p){return{label:p.label,iconPath:p.iconPath?n.pathOrURIToURI(p.iconPath):void 0,count:p.count,hasReacted:p.authorHasReacted}}function v(p){return{label:p.label||"",count:p.count||0,iconPath:p.iconPath?D.URI.revive(p.iconPath):"",authorHasReacted:p.hasReacted||!1}}function _(p){if(p!==void 0)switch(p){case R.CommentThreadCollapsibleState.Expanded:return k.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return k.CommentThreadCollapsibleState.Collapsed}return k.CommentThreadCollapsibleState.Collapsed}}),define(ge[124],pe([0,1,2,5,7,4,13,12,14,10,8]),function(G,e,E,P,T,I,D,k,y,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let C=class hn{constructor(g,s){this._logService=s,this._provider=new Map,this._proxy=g.getProxy(P.MainContext.MainThreadDecorations)}registerFileDecorationProvider(g,s){const u=hn._handlePool++;this._provider.set(u,{provider:g,extensionId:s}),this._proxy.$registerDecorationProvider(u,s.value);const S=g.onDidChangeFileDecorations&&g.onDidChangeFileDecorations(v=>{if(!v){this._proxy.$onDidChange(u,null);return}let _=(0,y.asArray)(v);if(_.length<=hn._maxEventSize){this._proxy.$onDidChange(u,_);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",s.value,_.length);const p=_.map(t=>({uri:t,rank:(0,n.count)(t.path,"/")})),c=(0,y.groupBy)(p,(t,i)=>t.rank-i.rank||(0,n.compare)(t.uri.path,i.uri.path));let l=[];e:for(let t of c){let i;for(let o of t){let r=(0,R.dirname)(o.uri.path);if(i!==r&&(i=r,l.push(o.uri)>=hn._maxEventSize))break e}}this._proxy.$onDidChange(u,l)});return new T.Disposable(()=>{S==null||S.dispose(),this._proxy.$unregisterDecorationProvider(u),this._provider.delete(u)})}async $provideDecorations(g,s,u){if(!this._provider.has(g))return Object.create(null);const S=Object.create(null),{provider:v,extensionId:_}=this._provider.get(g);return await Promise.all(s.map(async p=>{try{const{uri:c,id:l}=p,t=await Promise.resolve(v.provideFileDecoration(E.URI.revive(c),u));if(!t)return;try{T.FileDecoration.validate(t),S[l]=[t.propagate,t.tooltip,t.badge,t.color]}catch(i){this._logService.warn(`INVALID decoration from extension '${_.value}': ${i}`)}}catch(c){this._logService.error(c)}})),S}};C._handlePool=0,C._maxEventSize=250,C=je([Ue(0,D.IExtHostRpcService),Ue(1,k.ILogService)],C),e.ExtHostDecorations=C,e.IExtHostDecorations=(0,I.createDecorator)("IExtHostDecorations")}),define(ge[232],pe([0,1,159,110,2,5,7,20,3,12,24]),function(G,e,E,P,T,I,D,k,y,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class C{constructor(s,u,S,v,_){this._name=s,this._owner=u,this._maxDiagnosticsPerFile=S,this._proxy=v,this._onDidChangeDiagnostics=_,this._isDisposed=!1,this._data=new R.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(s,u){if(!s){this.clear();return}this._checkDisposed();let S=[];if(T.URI.isUri(s)){if(!u){this.delete(s);return}this._data.set(s,u.slice()),S=[s]}else if(Array.isArray(s)){S=[];let _;s=[...s].sort(C._compareIndexedTuplesByUri);for(const p of s){const[c,l]=p;if((!_||c.toString()!==_.toString())&&(_&&this._data.get(_).length===0&&this._data.delete(_),_=c,S.push(c),this._data.set(c,[])),l){const t=this._data.get(c);t&&t.push(...l)}else{const t=this._data.get(c);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(S),!!this._proxy){const v=[];for(let _ of S){let p=[];const c=this._data.get(_);if(c)if(c.length>this._maxDiagnosticsPerFile){p=[];const l=[D.DiagnosticSeverity.Error,D.DiagnosticSeverity.Warning,D.DiagnosticSeverity.Information,D.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let i of c)if(i.severity===l[t]&&p.push(k.Diagnostic.from(i))===this._maxDiagnosticsPerFile)break e;p.push({severity:P.MarkerSeverity.Info,message:(0,E.localize)(0,null,c.length-this._maxDiagnosticsPerFile),startLineNumber:p[p.length-1].startLineNumber,startColumn:p[p.length-1].startColumn,endLineNumber:p[p.length-1].endLineNumber,endColumn:p[p.length-1].endColumn})}else p=c.map(l=>k.Diagnostic.from(l));v.push([_,p])}this._proxy.$changeMany(this._owner,v)}}delete(s){this._checkDisposed(),this._onDidChangeDiagnostics.fire([s]),this._data.delete(s),this._proxy&&this._proxy.$changeMany(this._owner,[[s,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(s,u){this._checkDisposed();for(let S of this._data.keys())s.apply(u,[S,this.get(S),this])}get(s){this._checkDisposed();const u=this._data.get(s);return Array.isArray(u)?Object.freeze(u.slice(0)):[]}has(s){return this._checkDisposed(),Array.isArray(this._data.get(s))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(s,u){return s[0].toString()<u[0].toString()?-1:s[0].toString()>u[0].toString()?1:0}}e.DiagnosticCollection=C;let w=class $t{constructor(s,u){this._logService=u,this._collections=new Map,this._onDidChangeDiagnostics=new y.Emitter,this.onDidChangeDiagnostics=y.Event.map(y.Event.debounce(this._onDidChangeDiagnostics.event,$t._debouncer,50),$t._mapper),this._proxy=s.getProxy(I.MainContext.MainThreadDiagnostics)}static _debouncer(s,u){return s?s.concat(u):u}static _mapper(s){const u=[],S=new Set;for(const v of s)typeof v=="string"?S.has(v)||(S.add(v),u.push(T.URI.parse(v))):S.has(v.toString())||(S.add(v.toString()),u.push(v));return Object.freeze(u),{uris:u}}createDiagnosticCollection(s,u){const{_collections:S,_proxy:v,_onDidChangeDiagnostics:_,_logService:p}=this,c=new class{$changeMany(i,o){v.$changeMany(i,o),p.trace("[DiagnosticCollection] change many (extension, owner, uris)",s.value,i,o.length===0?"CLEARING":o)}$clear(i){v.$clear(i),p.trace("[DiagnosticCollection] remove all (extension, owner)",s.value,i)}dispose(){v.dispose()}};let l;if(!u)u="_generated_diagnostic_collection_name_#"+$t._idPool++,l=u;else if(!S.has(u))l=u;else{this._logService.warn(`DiagnosticCollection with name '${u}' does already exist.`);do l=u+$t._idPool++;while(S.has(l))}return new class extends C{constructor(){super(u,l,$t._maxDiagnosticsPerFile,c,_);S.set(l,this)}dispose(){super.dispose(),S.delete(l)}}}getDiagnostics(s){if(s)return this._getDiagnostics(s);{const u=new Map,S=[];for(const v of this._collections.values())v.forEach((_,p)=>{let c=u.get(_.toString());typeof c=="undefined"&&(c=S.length,u.set(_.toString(),c),S.push([_,[]])),S[c][1]=S[c][1].concat(...p)});return S}}_getDiagnostics(s){let u=[];for(let S of this._collections.values())S.has(s)&&(u=u.concat(S.get(s)));return u}$acceptMarkersChange(s){if(!this._mirrorCollection){const u="_generated_mirror",S=new C(u,u,$t._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(u,S),this._mirrorCollection=S}for(const[u,S]of s)this._mirrorCollection.set(T.URI.revive(u),S.map(k.Diagnostic.to))}};w._idPool=0,w._maxDiagnosticsPerFile=1e3,w=je([Ue(1,n.ILogService)],w),e.ExtHostDiagnostics=w}),define(ge[233],pe([0,1,2,5]),function(G,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class T{constructor(D){this._proxy=D.getProxy(P.MainContext.MainThreadDialogs)}showOpenDialog(D){return this._proxy.$showOpenDialog(D).then(k=>k?k.map(y=>E.URI.revive(y)):void 0)}showSaveDialog(D){return this._proxy.$showSaveDialog(D).then(k=>k?E.URI.revive(k):void 0)}}e.ExtHostDialogs=T}),define(ge[234],pe([0,1,18,2,7,5,11,21,10]),function(G,e,E,P,T,I,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class n{constructor(C,w,g){this._documentsAndEditors=w,this._logService=g,this._documentContentProviders=new Map,this._proxy=C.getProxy(I.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(C,w){if(Object.keys(D.Schemas).indexOf(C)>=0)throw new Error(`scheme '${C}' already registered`);const g=n._handlePool++;this._documentContentProviders.set(g,w),this._proxy.$registerTextContentProvider(g,C);let s;return typeof w.onDidChange=="function"&&(s=w.onDidChange(u=>{if(u.scheme!==C){this._logService.warn(`Provider for scheme '${C}' is firing event for schema '${u.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(u)&&this.$provideTextDocumentContent(g,u).then(S=>{if(!(!S&&typeof S!="string")){const v=this._documentsAndEditors.getDocument(u);if(!!v){const _=(0,y.splitLines)(S);if(!v.equalLines(_))return this._proxy.$onVirtualDocumentChange(u,S)}}},E.onUnexpectedError)})),new T.Disposable(()=>{this._documentContentProviders.delete(g)&&this._proxy.$unregisterTextContentProvider(g),s&&(s.dispose(),s=void 0)})}$provideTextDocumentContent(C,w){const g=this._documentContentProviders.get(C);return g?Promise.resolve(g.provideTextDocumentContent(P.URI.revive(w),k.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${w.scheme}`))}}e.ExtHostDocumentContentProvider=n,n._handlePool=0}),define(ge[235],pe([0,1,3,6,2,5,118,20,15,23]),function(G,e,E,P,T,I,D,k,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class R{constructor(w,g){this._onDidAddDocument=new E.Emitter,this._onDidRemoveDocument=new E.Emitter,this._onDidChangeDocument=new E.Emitter,this._onDidSaveDocument=new E.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new P.DisposableStore,this._documentLoader=new Map,this._proxy=w.getProxy(I.MainContext.MainThreadDocuments),this._documentsAndEditors=g,this._documentsAndEditors.onDidRemoveDocuments(s=>{for(const u of s)this._onDidRemoveDocument.fire(u.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(s=>{for(const u of s)this._onDidAddDocument.fire(u.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(w){if(!!w){const g=this._documentsAndEditors.getDocument(w);if(g)return g}}getDocument(w){const g=this.getDocumentData(w);if(!(g==null?void 0:g.document))throw new Error(`Unable to retrieve document from URI '${w}'`);return g.document}ensureDocumentData(w){const g=this._documentsAndEditors.getDocument(w);if(g)return Promise.resolve(g);let s=this._documentLoader.get(w.toString());return s||(s=this._proxy.$tryOpenDocument(w).then(u=>{this._documentLoader.delete(w.toString());const S=T.URI.revive(u);return(0,y.assertIsDefined)(this._documentsAndEditors.getDocument(S))},u=>(this._documentLoader.delete(w.toString()),Promise.reject(u))),this._documentLoader.set(w.toString(),s)),s}createDocumentData(w){return this._proxy.$tryCreateDocument(w).then(g=>T.URI.revive(g))}$acceptModelModeChanged(w,g){const s=T.URI.revive(w),u=this._documentsAndEditors.getDocument(s);if(!u)throw new Error("unknown document");this._onDidRemoveDocument.fire(u.document),u._acceptLanguageId(g),this._onDidAddDocument.fire(u.document)}$acceptModelSaved(w){const g=T.URI.revive(w),s=this._documentsAndEditors.getDocument(g);if(!s)throw new Error("unknown document");this.$acceptDirtyStateChanged(w,!1),this._onDidSaveDocument.fire(s.document)}$acceptDirtyStateChanged(w,g){const s=T.URI.revive(w),u=this._documentsAndEditors.getDocument(s);if(!u)throw new Error("unknown document");u._acceptIsDirty(g),this._onDidChangeDocument.fire({document:u.document,contentChanges:[]})}$acceptModelChanged(w,g,s){const u=T.URI.revive(w),S=this._documentsAndEditors.getDocument(u);if(!S)throw new Error("unknown document");S._acceptIsDirty(s),S.onEvents(g),this._onDidChangeDocument.fire((0,n.deepFreeze)({document:S.document,contentChanges:g.changes.map(v=>({range:k.Range.to(v.range),rangeOffset:v.rangeOffset,rangeLength:v.rangeLength,text:v.text}))}))}setWordDefinitionFor(w,g){(0,D.setWordDefinitionFor)(w,g)}}e.ExtHostDocuments=R}),define(ge[39],pe([0,1,52,3,6,2,4,5,118,13,122,20,12,24,11,71,133]),function(G,e,E,P,T,I,D,k,y,n,R,C,w,g,s,u,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class v{constructor(c){this.value=c,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let _=class{constructor(c,l){this._extHostRpc=c,this._logService=l,this._activeEditorId=null,this._editors=new Map,this._documents=new g.ResourceMap,this._onDidAddDocuments=new P.Emitter,this._onDidRemoveDocuments=new P.Emitter,this._onDidChangeVisibleTextEditors=new P.Emitter,this._onDidChangeActiveTextEditor=new P.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const l=[],t=[],i=[];if(c.removedDocuments)for(const o of c.removedDocuments){const r=I.URI.revive(o),a=this._documents.get(r);(a==null?void 0:a.unref())&&(this._documents.delete(r),l.push(a.value))}if(c.addedDocuments)for(const o of c.addedDocuments){const r=I.URI.revive(o.uri);let a=this._documents.get(r);if(a&&r.scheme!==s.Schemas.vscodeNotebookCell)throw new Error(`document '${r} already exists!'`);a||(a=new v(new y.ExtHostDocumentData(this._extHostRpc.getProxy(k.MainContext.MainThreadDocuments),r,o.lines,o.EOL,o.versionId,o.modeId,o.isDirty,o.notebook)),this._documents.set(r,a),t.push(a.value)),a.ref()}if(c.removedEditors)for(const o of c.removedEditors){const r=this._editors.get(o);this._editors.delete(o),r&&i.push(r)}if(c.addedEditors)for(const o of c.addedEditors){const r=I.URI.revive(o.documentUri);E.ok(this._documents.has(r),`document '${r}' does not exist`),E.ok(!this._editors.has(o.id),`editor '${o.id}' already exists!`);const a=this._documents.get(r).value,h=new R.ExtHostTextEditor(o.id,this._extHostRpc.getProxy(k.MainContext.MainThreadTextEditors),this._logService,new S.Lazy(()=>a.document),o.selections.map(C.Selection.to),o.options,o.visibleRanges.map(m=>C.Range.to(m)),typeof o.editorPosition=="number"?C.ViewColumn.to(o.editorPosition):void 0);this._editors.set(o.id,h)}c.newActiveEditor!==void 0&&(E.ok(c.newActiveEditor===null||this._editors.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this._activeEditorId=c.newActiveEditor),(0,T.dispose)(l),(0,T.dispose)(i),c.removedDocuments&&this._onDidRemoveDocuments.fire(l),c.addedDocuments&&this._onDidAddDocuments.fire(t),(c.removedEditors||c.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(o=>o.value)),c.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(c){var l;return(l=this._documents.get(c))===null||l===void 0?void 0:l.value}allDocuments(){return u.Iterable.map(this._documents.values(),c=>c.value)}getEditor(c){return this._editors.get(c)}activeEditor(c){if(!!this._activeEditorId){const l=this._editors.get(this._activeEditorId);return c?l:l==null?void 0:l.value}}allEditors(){return[...this._editors.values()]}};_=je([Ue(0,n.IExtHostRpcService),Ue(1,w.ILogService)],_),e.ExtHostDocumentsAndEditors=_,e.IExtHostDocumentsAndEditors=(0,D.createDecorator)("IExtHostDocumentsAndEditors")}),define(ge[236],pe([0,1,2,5,6,7,20,141,10,22]),function(G,e,E,P,T,I,D,k,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class R{constructor(){this._schemes=[]}add(g){this._stateMachine=void 0,this._schemes.push(g)}delete(g){const s=this._schemes.indexOf(g);s>=0&&(this._schemes.splice(s,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const g=this._schemes.sort(),s=[];let u,S,v=14,_=14;for(const p of g){let c=u?(0,y.commonPrefixLength)(u,p):0;for(c===0?S=1:S=_;c<p.length;c++)c+1===p.length?(v=_,_=9):_+=1,s.push([S,p.toUpperCase().charCodeAt(c),_]),s.push([S,p.toLowerCase().charCodeAt(c),_]),S=_;u=p,_=v}s.push([9,58,10]),s.push([10,47,12]),this._stateMachine=new k.StateMachine(s)}}provideDocumentLinks(g){this._initStateMachine();const s=[],u=k.LinkComputer.computeLinks({getLineContent(S){return g.lineAt(S-1).text},getLineCount(){return g.lineCount}},this._stateMachine);for(const S of u){const v=D.DocumentLink.to(S);v.target&&s.push(v)}return s}}class C{constructor(g,s){this._extHostLanguageFeatures=s,this._linkProvider=new R,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=g.getProxy(P.MainContext.MainThreadFileSystem)}dispose(){var g;(g=this._linkProviderRegistration)===null||g===void 0||g.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(g,s,u,S={}){if(this._registeredSchemes.has(s))throw new Error(`a provider for the scheme '${s}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const v=this._handlePool++;this._linkProvider.add(s),this._registeredSchemes.add(s),this._fsProvider.set(v,u);let _=2;S.isCaseSensitive&&(_+=1024),S.isReadonly&&(_+=2048),typeof u.copy=="function"&&(_+=8),typeof u.open=="function"&&typeof u.close=="function"&&typeof u.read=="function"&&typeof u.write=="function"&&(_+=4),this._proxy.$registerFileSystemProvider(v,s,_).catch(c=>{console.error(`FAILED to register filesystem provider of ${g.value}-extension for the scheme ${s}`),console.error(c)});const p=u.onDidChangeFile(c=>{const l=[];for(const t of c){let{uri:i,type:o}=t;if(i.scheme===s){let r;switch(o){case I.FileChangeType.Changed:r=0;break;case I.FileChangeType.Created:r=1;break;case I.FileChangeType.Deleted:r=2;break;default:throw new Error("Unknown FileChangeType")}l.push({resource:i,type:r})}}this._proxy.$onFileSystemChange(v,l)});return(0,T.toDisposable)(()=>{p.dispose(),this._linkProvider.delete(s),this._registeredSchemes.delete(s),this._fsProvider.delete(v),this._proxy.$unregisterProvider(v)})}static _asIStat(g){const{type:s,ctime:u,mtime:S,size:v}=g;return{type:s,ctime:u,mtime:S,size:v}}$stat(g,s){return Promise.resolve(this._getFsProvider(g).stat(E.URI.revive(s))).then(C._asIStat)}$readdir(g,s){return Promise.resolve(this._getFsProvider(g).readDirectory(E.URI.revive(s)))}$readFile(g,s){return Promise.resolve(this._getFsProvider(g).readFile(E.URI.revive(s))).then(u=>n.VSBuffer.wrap(u))}$writeFile(g,s,u,S){return Promise.resolve(this._getFsProvider(g).writeFile(E.URI.revive(s),u.buffer,S))}$delete(g,s,u){return Promise.resolve(this._getFsProvider(g).delete(E.URI.revive(s),u))}$rename(g,s,u,S){return Promise.resolve(this._getFsProvider(g).rename(E.URI.revive(s),E.URI.revive(u),S))}$copy(g,s,u,S){const v=this._getFsProvider(g);if(!v.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(v.copy(E.URI.revive(s),E.URI.revive(u),S))}$mkdir(g,s){return Promise.resolve(this._getFsProvider(g).createDirectory(E.URI.revive(s)))}$watch(g,s,u,S){const v=this._getFsProvider(g).watch(E.URI.revive(u),S);this._watches.set(s,v)}$unwatch(g,s){const u=this._watches.get(s);u&&(u.dispose(),this._watches.delete(s))}$open(g,s,u){const S=this._getFsProvider(g);if(!S.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(S.open(E.URI.revive(s),u))}$close(g,s){const u=this._getFsProvider(g);if(!u.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(u.close(s))}$read(g,s,u,S){const v=this._getFsProvider(g);if(!v.read)throw new Error('FileSystemProvider does not implement "read"');const _=n.VSBuffer.alloc(S);return Promise.resolve(v.read(s,u,_.buffer,0,S)).then(p=>_.slice(0,p))}$write(g,s,u,S){const v=this._getFsProvider(g);if(!v.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(v.write(s,u,S.buffer,0,S.byteLength))}_getFsProvider(g){const s=this._fsProvider.get(g);if(!s){const u=new Error;throw u.name="ENOPRO",u.message="no provider",u}return s}}e.ExtHostFileSystem=C}),define(ge[87],pe([0,1,5,45,7,22,4,13,60]),function(G,e,E,P,T,I,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let n=class Ft{constructor(C,w){const g=C.getProxy(E.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(s){return g.$stat(s).catch(Ft._handleError)},readDirectory(s){return g.$readdir(s).catch(Ft._handleError)},createDirectory(s){return g.$mkdir(s).catch(Ft._handleError)},async readFile(s){return g.$readFile(s).then(u=>u.buffer).catch(Ft._handleError)},writeFile(s,u){return g.$writeFile(s,I.VSBuffer.wrap(u)).catch(Ft._handleError)},delete(s,u){return g.$delete(s,Object.assign({recursive:!1,useTrash:!1},u)).catch(Ft._handleError)},rename(s,u,S){return g.$rename(s,u,Object.assign({overwrite:!1},S)).catch(Ft._handleError)},copy(s,u,S){return g.$copy(s,u,Object.assign({overwrite:!1},S)).catch(Ft._handleError)},isWritableFileSystem(s){const u=w.getCapabilities(s);if(typeof u=="number")return!(u&2048)}})}static _handleError(C){if(!(C instanceof Error))throw new T.FileSystemError(String(C));if(C.name==="ENOPRO")throw T.FileSystemError.Unavailable(C.message);switch(C.name){case P.FileSystemProviderErrorCode.FileExists:throw T.FileSystemError.FileExists(C.message);case P.FileSystemProviderErrorCode.FileNotFound:throw T.FileSystemError.FileNotFound(C.message);case P.FileSystemProviderErrorCode.FileNotADirectory:throw T.FileSystemError.FileNotADirectory(C.message);case P.FileSystemProviderErrorCode.FileIsADirectory:throw T.FileSystemError.FileIsADirectory(C.message);case P.FileSystemProviderErrorCode.NoPermissions:throw T.FileSystemError.NoPermissions(C.message);case P.FileSystemProviderErrorCode.Unavailable:throw T.FileSystemError.Unavailable(C.message);default:throw new T.FileSystemError(C.message,C.name)}}};n=je([Ue(0,k.IExtHostRpcService),Ue(1,y.IExtHostFileSystemInfo)],n),e.ExtHostConsumerFileSystem=n,e.IExtHostConsumerFileSystem=(0,D.createDecorator)("IExtHostConsumerFileSystem")}),define(ge[237],pe([0,1,6,5]),function(G,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class T{constructor(D){this._handlePool=0,this._proxy=D.getProxy(P.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(D){const k=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(k,D),(0,E.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(k)})}}e.ExtHostLabelService=T}),define(ge[238],pe([0,1,2,23,20,7,19,5,10,44,14,15,138,6,106,70,116,47,18]),function(G,e,E,P,T,I,D,k,y,n,R,C,w,g,s,u,S,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class p{constructor(z,Y){this._documents=z,this._provider=Y}provideDocumentSymbols(z,Y){const te=this._documents.getDocument(z);return(0,D.asPromise)(()=>this._provider.provideDocumentSymbols(te,Y)).then(ae=>{if(!(0,R.isFalsyOrEmpty)(ae))return ae[0]instanceof I.DocumentSymbol?ae.map(T.DocumentSymbol.from):p._asDocumentSymbolTree(ae)})}static _asDocumentSymbolTree(z){var Y;z=z.slice(0).sort((he,Ce)=>{let Oe=he.location.range.start.compareTo(Ce.location.range.start);return Oe===0&&(Oe=Ce.location.range.end.compareTo(he.location.range.end)),Oe});const te=[],ae=[];for(const he of z){const Ce={name:he.name||"!!MISSING: name!!",kind:T.SymbolKind.from(he.kind),tags:((Y=he.tags)===null||Y===void 0?void 0:Y.map(T.SymbolTag.from))||[],detail:"",containerName:he.containerName,range:T.Range.from(he.location.range),selectionRange:T.Range.from(he.location.range),children:[]};for(;;){if(ae.length===0){ae.push(Ce),te.push(Ce);break}const Oe=ae[ae.length-1];if(n.Range.containsRange(Oe.range,Ce.range)&&!n.Range.equalsRange(Oe.range,Ce.range)){Oe.children&&Oe.children.push(Ce),ae.push(Ce);break}ae.pop()}}return te}}class c{constructor(z,Y,te){this._documents=z,this._commands=Y,this._provider=te,this._cache=new S.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(z,Y){const te=this._documents.getDocument(z),ae=await this._provider.provideCodeLenses(te,Y);if(!(!ae||Y.isCancellationRequested)){const he=this._cache.add(ae),Ce=new g.DisposableStore;this._disposables.set(he,Ce);const Oe={cacheId:he,lenses:[]};for(let be=0;be<ae.length;be++)Oe.lenses.push({cacheId:[he,be],range:T.Range.from(ae[be].range),command:this._commands.toInternal(ae[be].command,Ce)});return Oe}}async resolveCodeLens(z,Y){var te;const ae=z.cacheId&&this._cache.get(...z.cacheId);if(!!ae){let he;if(typeof this._provider.resolveCodeLens!="function"||ae.isResolved?he=ae:he=await this._provider.resolveCodeLens(ae,Y),he||(he=ae),!Y.isCancellationRequested){const Ce=z.cacheId&&this._disposables.get(z.cacheId[0]);if(!!Ce)return z.command=this._commands.toInternal((te=he.command)!==null&&te!==void 0?te:c._badCmd,Ce),z}}}releaseCodeLenses(z){var Y;(Y=this._disposables.get(z))===null||Y===void 0||Y.dispose(),this._disposables.delete(z),this._cache.delete(z)}}c._badCmd={command:"missing",title:"!!MISSING: command!!"};function l(Fe){return Array.isArray(Fe)?Fe.map(T.DefinitionLink.from):Fe?[T.DefinitionLink.from(Fe)]:[]}class t{constructor(z,Y){this._documents=z,this._provider=Y}provideDefinition(z,Y,te){const ae=this._documents.getDocument(z),he=T.Position.to(Y);return(0,D.asPromise)(()=>this._provider.provideDefinition(ae,he,te)).then(l)}}class i{constructor(z,Y){this._documents=z,this._provider=Y}provideDeclaration(z,Y,te){const ae=this._documents.getDocument(z),he=T.Position.to(Y);return(0,D.asPromise)(()=>this._provider.provideDeclaration(ae,he,te)).then(l)}}class o{constructor(z,Y){this._documents=z,this._provider=Y}provideImplementation(z,Y,te){const ae=this._documents.getDocument(z),he=T.Position.to(Y);return(0,D.asPromise)(()=>this._provider.provideImplementation(ae,he,te)).then(l)}}class r{constructor(z,Y){this._documents=z,this._provider=Y}provideTypeDefinition(z,Y,te){const ae=this._documents.getDocument(z),he=T.Position.to(Y);return(0,D.asPromise)(()=>this._provider.provideTypeDefinition(ae,he,te)).then(l)}}class a{constructor(z,Y){this._documents=z,this._provider=Y}provideHover(z,Y,te){const ae=this._documents.getDocument(z),he=T.Position.to(Y);return(0,D.asPromise)(()=>this._provider.provideHover(ae,he,te)).then(Ce=>{if(!(!Ce||(0,R.isFalsyOrEmpty)(Ce.contents)))return Ce.range||(Ce.range=ae.getWordRangeAtPosition(he)),Ce.range||(Ce.range=new I.Range(he,he)),T.Hover.from(Ce)})}}class h{constructor(z,Y){this._documents=z,this._provider=Y}provideEvaluatableExpression(z,Y,te){const ae=this._documents.getDocument(z),he=T.Position.to(Y);return(0,D.asPromise)(()=>this._provider.provideEvaluatableExpression(ae,he,te)).then(Ce=>{if(Ce)return T.EvaluatableExpression.from(Ce)})}}class m{constructor(z,Y){this._documents=z,this._provider=Y}provideInlineValues(z,Y,te,ae){const he=this._documents.getDocument(z);return(0,D.asPromise)(()=>this._provider.provideInlineValues(he,T.Range.to(Y),T.InlineValueContext.to(te),ae)).then(Ce=>{if(Array.isArray(Ce))return Ce.map(Oe=>T.InlineValue.from(Oe))})}}class b{constructor(z,Y){this._documents=z,this._provider=Y}provideDocumentHighlights(z,Y,te){const ae=this._documents.getDocument(z),he=T.Position.to(Y);return(0,D.asPromise)(()=>this._provider.provideDocumentHighlights(ae,he,te)).then(Ce=>{if(Array.isArray(Ce))return Ce.map(T.DocumentHighlight.from)})}}class f{constructor(z,Y){this._documents=z,this._provider=Y}provideLinkedEditingRanges(z,Y,te){const ae=this._documents.getDocument(z),he=T.Position.to(Y);return(0,D.asPromise)(()=>this._provider.provideLinkedEditingRanges(ae,he,te)).then(Ce=>{if(Ce&&Array.isArray(Ce.ranges))return{ranges:(0,R.coalesce)(Ce.ranges.map(T.Range.from)),wordPattern:Ce.wordPattern}})}}class d{constructor(z,Y){this._documents=z,this._provider=Y}provideReferences(z,Y,te,ae){const he=this._documents.getDocument(z),Ce=T.Position.to(Y);return(0,D.asPromise)(()=>this._provider.provideReferences(he,Ce,te,ae)).then(Oe=>{if(Array.isArray(Oe))return Oe.map(T.location.from)})}}class A{constructor(z,Y,te,ae,he,Ce,Oe){this._documents=z,this._commands=Y,this._diagnostics=te,this._provider=ae,this._logService=he,this._extension=Ce,this._apiDeprecation=Oe,this._cache=new S.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(z,Y,te,ae){const he=this._documents.getDocument(z),Ce=w.Selection.isISelection(Y)?T.Selection.to(Y):T.Range.to(Y),Oe=[];for(const ke of this._diagnostics.getDiagnostics(z))if(Ce.intersection(ke.range)&&Oe.push(ke)>A._maxCodeActionsPerFile)break;const be={diagnostics:Oe,only:te.only?new I.CodeActionKind(te.only):void 0,triggerKind:T.CodeActionTriggerKind.to(te.trigger)};return(0,D.asPromise)(()=>this._provider.provideCodeActions(he,Ce,be,ae)).then(ke=>{var Re;if(!(!(0,R.isNonEmptyArray)(ke)||ae.isCancellationRequested)){const Be=this._cache.add(ke),Se=new g.DisposableStore;this._disposables.set(Be,Se);const Ke=[];for(let Q=0;Q<ke.length;Q++){const se=ke[Q];!se||(A._isCommand(se)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ke.push({_isSynthetic:!0,title:se.title,command:this._commands.toInternal(se,Se)})):(be.only&&(se.kind?be.only.contains(se.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${be.only.value} 'requested but returned code action is of kind '${se.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${be.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ke.push({cacheId:[Be,Q],title:se.title,command:se.command&&this._commands.toInternal(se.command,Se),diagnostics:se.diagnostics&&se.diagnostics.map(T.Diagnostic.from),edit:se.edit&&T.WorkspaceEdit.from(se.edit),kind:se.kind&&se.kind.value,isPreferred:se.isPreferred,disabled:(Re=se.disabled)===null||Re===void 0?void 0:Re.reason})))}return{cacheId:Be,actions:Ke}}})}async resolveCodeAction(z,Y){var te;const[ae,he]=z,Ce=this._cache.get(ae,he);if(!(!Ce||A._isCommand(Ce))&&!!this._provider.resolveCodeAction){const Oe=(te=await this._provider.resolveCodeAction(Ce,Y))!==null&&te!==void 0?te:Ce;return(Oe==null?void 0:Oe.edit)?T.WorkspaceEdit.from(Oe.edit):void 0}}releaseCodeActions(z){var Y;(Y=this._disposables.get(z))===null||Y===void 0||Y.dispose(),this._disposables.delete(z),this._cache.delete(z)}static _isCommand(z){return typeof z.command=="string"&&typeof z.title=="string"}}A._maxCodeActionsPerFile=1e3;class L{constructor(z,Y){this._documents=z,this._provider=Y}provideDocumentFormattingEdits(z,Y,te){const ae=this._documents.getDocument(z);return(0,D.asPromise)(()=>this._provider.provideDocumentFormattingEdits(ae,Y,te)).then(he=>{if(Array.isArray(he))return he.map(T.TextEdit.from)})}}class B{constructor(z,Y){this._documents=z,this._provider=Y}provideDocumentRangeFormattingEdits(z,Y,te,ae){const he=this._documents.getDocument(z),Ce=T.Range.to(Y);return(0,D.asPromise)(()=>this._provider.provideDocumentRangeFormattingEdits(he,Ce,te,ae)).then(Oe=>{if(Array.isArray(Oe))return Oe.map(T.TextEdit.from)})}}class J{constructor(z,Y){this._documents=z,this._provider=Y,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(z,Y,te,ae,he){const Ce=this._documents.getDocument(z),Oe=T.Position.to(Y);return(0,D.asPromise)(()=>this._provider.provideOnTypeFormattingEdits(Ce,Oe,te,ae,he)).then(be=>{if(Array.isArray(be))return be.map(T.TextEdit.from)})}}class j{constructor(z,Y){this._provider=z,this._logService=Y,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(z,Y){const te=k.IdObject.mixin({symbols:[]});return(0,D.asPromise)(()=>this._provider.provideWorkspaceSymbols(z,Y)).then(ae=>{if((0,R.isNonEmptyArray)(ae)){for(const he of ae)if(!!he){if(!he.name){this._logService.warn("INVALID SymbolInformation, lacks name",he);continue}const Ce=k.IdObject.mixin(T.WorkspaceSymbol.from(he));this._symbolCache.set(Ce._id,he),te.symbols.push(Ce)}}}).then(()=>(te.symbols.length>0&&this._resultCache.set(te._id,[te.symbols[0]._id,te.symbols[te.symbols.length-1]._id]),te))}async resolveWorkspaceSymbol(z,Y){if(typeof this._provider.resolveWorkspaceSymbol!="function")return z;const te=this._symbolCache.get(z._id);if(te){const ae=await(0,D.asPromise)(()=>this._provider.resolveWorkspaceSymbol(te,Y));return ae&&(0,P.mixin)(z,T.WorkspaceSymbol.from(ae),!0)}}releaseWorkspaceSymbols(z){const Y=this._resultCache.get(z);if(Y){for(let[te,ae]=Y;te<=ae;te++)this._symbolCache.delete(te);this._resultCache.delete(z)}}}class U{constructor(z,Y,te){this._documents=z,this._provider=Y,this._logService=te}static supportsResolving(z){return typeof z.prepareRename=="function"}provideRenameEdits(z,Y,te,ae){const he=this._documents.getDocument(z),Ce=T.Position.to(Y);return(0,D.asPromise)(()=>this._provider.provideRenameEdits(he,Ce,te,ae)).then(Oe=>{if(!!Oe)return T.WorkspaceEdit.from(Oe)},Oe=>{const be=U._asMessage(Oe);return be?{rejectReason:be,edits:void 0}:Promise.reject(Oe)})}resolveRenameLocation(z,Y,te){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ae=this._documents.getDocument(z),he=T.Position.to(Y);return(0,D.asPromise)(()=>this._provider.prepareRename(ae,he,te)).then(Ce=>{let Oe,be;if(I.Range.isRange(Ce)?(Oe=Ce,be=ae.getText(Ce)):(0,C.isObject)(Ce)&&(Oe=Ce.range,be=Ce.placeholder),!!Oe){if(Oe.start.line>he.line||Oe.end.line<he.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:T.Range.from(Oe),text:be}}},Ce=>{const Oe=U._asMessage(Ce);return Oe?{rejectReason:Oe,range:void 0,text:void 0}:Promise.reject(Ce)})}static _asMessage(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class ${constructor(z,Y){this.resultId=z,this.tokens=Y}}class F{constructor(z,Y){this._documents=z,this._provider=Y,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(z,Y,te){const ae=this._documents.getDocument(z),he=Y!==0?this._previousResults.get(Y):null;return(0,D.asPromise)(()=>he&&typeof he.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(ae,he.resultId,te):this._provider.provideDocumentSemanticTokens(ae,te)).then(Ce=>(he&&this._previousResults.delete(Y),Ce?(Ce=F._fixProvidedSemanticTokens(Ce),this._send(F._convertToEdits(he,Ce),Ce)):null))}async releaseDocumentSemanticColoring(z){this._previousResults.delete(z)}static _fixProvidedSemanticTokens(z){return F._isSemanticTokens(z)?F._isCorrectSemanticTokens(z)?z:new I.SemanticTokens(new Uint32Array(z.data),z.resultId):F._isSemanticTokensEdits(z)?F._isCorrectSemanticTokensEdits(z)?z:new I.SemanticTokensEdits(z.edits.map(Y=>new I.SemanticTokensEdit(Y.start,Y.deleteCount,Y.data?new Uint32Array(Y.data):Y.data)),z.resultId):z}static _isSemanticTokens(z){return z&&!!z.data}static _isCorrectSemanticTokens(z){return z.data instanceof Uint32Array}static _isSemanticTokensEdits(z){return z&&Array.isArray(z.edits)}static _isCorrectSemanticTokensEdits(z){for(const Y of z.edits)if(!(Y.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(z,Y){if(!F._isSemanticTokens(Y)||!z||!z.tokens)return Y;const te=z.tokens,ae=te.length,he=Y.data,Ce=he.length;let Oe=0;const be=Math.min(ae,Ce);for(;Oe<be&&te[Oe]===he[Oe];)Oe++;if(Oe===ae&&Oe===Ce)return new I.SemanticTokensEdits([],Y.resultId);let ke=0;const Re=be-Oe;for(;ke<Re&&te[ae-ke-1]===he[Ce-ke-1];)ke++;return new I.SemanticTokensEdits([{start:Oe,deleteCount:ae-Oe-ke,data:he.subarray(Oe,Ce-ke)}],Y.resultId)}_send(z,Y){if(F._isSemanticTokens(z)){const te=this._nextResultId++;return this._previousResults.set(te,new $(z.resultId,z.data)),(0,s.encodeSemanticTokensDto)({id:te,type:"full",data:z.data})}if(F._isSemanticTokensEdits(z)){const te=this._nextResultId++;return F._isSemanticTokens(Y)?this._previousResults.set(te,new $(Y.resultId,Y.data)):this._previousResults.set(te,new $(z.resultId)),(0,s.encodeSemanticTokensDto)({id:te,type:"delta",deltas:(z.edits||[]).map(ae=>({start:ae.start,deleteCount:ae.deleteCount,data:ae.data}))})}return null}}e.DocumentSemanticTokensAdapter=F;class N{constructor(z,Y){this._documents=z,this._provider=Y}provideDocumentRangeSemanticTokens(z,Y,te){const ae=this._documents.getDocument(z);return(0,D.asPromise)(()=>this._provider.provideDocumentRangeSemanticTokens(ae,T.Range.to(Y),te)).then(he=>he?this._send(he):null)}_send(z){return(0,s.encodeSemanticTokensDto)({id:0,type:"full",data:z.data})}}e.DocumentRangeSemanticTokensAdapter=N;class M{constructor(z,Y,te,ae,he){this._documents=z,this._commands=Y,this._provider=te,this._apiDeprecation=ae,this._extension=he,this._cache=new S.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(z){return typeof z.resolveCompletionItem=="function"}async provideCompletionItems(z,Y,te,ae){const he=this._documents.getDocument(z),Ce=T.Position.to(Y),Oe=he.getWordRangeAtPosition(Ce)||new I.Range(Ce,Ce),be=Oe.with({end:Ce}),ke=new v.StopWatch(!0),Re=await(0,D.asPromise)(()=>this._provider.provideCompletionItems(he,Ce,ae,T.CompletionContext.to(te)));if(!!Re&&!ae.isCancellationRequested){const Be=Array.isArray(Re)?new I.CompletionList(Re):Re,Se=M.supportsResolving(this._provider)?this._cache.add(Be.items):this._cache.add([]),Ke=new g.DisposableStore;this._disposables.set(Se,Ke);const Q=[],se={x:Se,b:Q,a:{replace:T.Range.from(Oe),insert:T.Range.from(be)},c:Be.isIncomplete||void 0,d:ke.elapsed()};for(let _e=0;_e<Be.items.length;_e++){const xe=Be.items[_e],Ve=this._convertCompletionItem(xe,[Se,_e],be,Oe);Q.push(Ve)}return se}}async resolveCompletionItem(z,Y){if(typeof this._provider.resolveCompletionItem=="function"){const te=this._cache.get(...z);if(!!te){const ae=await(0,D.asPromise)(()=>this._provider.resolveCompletionItem(te,Y));if(!!ae)return this._convertCompletionItem(ae,z)}}}releaseCompletionItems(z){var Y;(Y=this._disposables.get(z))===null||Y===void 0||Y.dispose(),this._disposables.delete(z),this._cache.delete(z)}_convertCompletionItem(z,Y,te,ae){var he;const Ce=this._disposables.get(Y[0]);if(!Ce)throw Error("DisposableStore is missing...");const Oe={x:Y,a:(he=z.label)!==null&&he!==void 0?he:"",o:z.label2,b:z.kind!==void 0?T.CompletionItemKind.from(z.kind):void 0,n:z.tags&&z.tags.map(T.CompletionItemTag.from),c:z.detail,d:typeof z.documentation=="undefined"?void 0:T.MarkdownString.fromStrict(z.documentation),e:z.sortText!==z.label?z.sortText:void 0,f:z.filterText!==z.label?z.filterText:void 0,g:z.preselect||void 0,i:z.keepWhitespace?1:0,k:z.commitCharacters,l:z.additionalTextEdits&&z.additionalTextEdits.map(T.TextEdit.from),m:this._commands.toInternal(z.command,Ce)};z.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Oe.h=z.textEdit.newText):typeof z.insertText=="string"?Oe.h=z.insertText:z.insertText instanceof I.SnippetString&&(Oe.h=z.insertText.value,Oe.i|=4);let be;return z.textEdit?be=z.textEdit.range:z.range&&(be=z.range),I.Range.isRange(be)?Oe.j=T.Range.from(be):be&&(!(te==null?void 0:te.isEqual(be.inserting))||!(ae==null?void 0:ae.isEqual(be.replacing)))&&(Oe.j={insert:T.Range.from(be.inserting),replace:T.Range.from(be.replacing)}),Oe}}class x{constructor(z,Y){this._documents=z,this._provider=Y,this._cache=new S.Cache("SignatureHelp")}provideSignatureHelp(z,Y,te,ae){const he=this._documents.getDocument(z),Ce=T.Position.to(Y),Oe=this.reviveContext(te);return(0,D.asPromise)(()=>this._provider.provideSignatureHelp(he,Ce,ae,Oe)).then(be=>{if(be){const ke=this._cache.add([be]);return Object.assign(Object.assign({},T.SignatureHelp.from(be)),{id:ke})}})}reviveContext(z){let Y;if(z.activeSignatureHelp){const te=T.SignatureHelp.to(z.activeSignatureHelp),ae=this._cache.get(z.activeSignatureHelp.id,0);ae?(Y=ae,Y.activeSignature=te.activeSignature,Y.activeParameter=te.activeParameter):Y=te}return Object.assign(Object.assign({},z),{activeSignatureHelp:Y})}releaseSignatureHelp(z){this._cache.delete(z)}}class O{constructor(z,Y){this._documents=z,this._provider=Y}provideInlineHints(z,Y,te){const ae=this._documents.getDocument(z);return(0,D.asPromise)(()=>this._provider.provideInlineHints(ae,T.Range.to(Y),te)).then(he=>he?{hints:he.map(T.InlineHint.from)}:void 0)}}class V{constructor(z,Y){this._documents=z,this._provider=Y,this._cache=new S.Cache("DocumentLink")}provideLinks(z,Y){const te=this._documents.getDocument(z);return(0,D.asPromise)(()=>this._provider.provideDocumentLinks(te,Y)).then(ae=>{if(!(!Array.isArray(ae)||ae.length===0)&&!Y.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ae.map(T.DocumentLink.from)};{const he=this._cache.add(ae),Ce={links:[],id:he};for(let Oe=0;Oe<ae.length;Oe++){const be=T.DocumentLink.from(ae[Oe]);be.cacheId=[he,Oe],Ce.links.push(be)}return Ce}}})}resolveLink(z,Y){if(typeof this._provider.resolveDocumentLink!="function")return Promise.resolve(void 0);const te=this._cache.get(...z);return te?(0,D.asPromise)(()=>this._provider.resolveDocumentLink(te,Y)).then(ae=>ae&&T.DocumentLink.from(ae)||void 0):Promise.resolve(void 0)}releaseLinks(z){this._cache.delete(z)}}class q{constructor(z,Y){this._documents=z,this._provider=Y}provideColors(z,Y){const te=this._documents.getDocument(z);return(0,D.asPromise)(()=>this._provider.provideDocumentColors(te,Y)).then(ae=>Array.isArray(ae)?ae.map(Ce=>({color:T.Color.from(Ce.color),range:T.Range.from(Ce.range)})):[])}provideColorPresentations(z,Y,te){const ae=this._documents.getDocument(z),he=T.Range.to(Y.range),Ce=T.Color.to(Y.color);return(0,D.asPromise)(()=>this._provider.provideColorPresentations(Ce,{document:ae,range:he},te)).then(Oe=>{if(!!Array.isArray(Oe))return Oe.map(T.ColorPresentation.from)})}}class X{constructor(z,Y){this._documents=z,this._provider=Y}provideFoldingRanges(z,Y,te){const ae=this._documents.getDocument(z);return(0,D.asPromise)(()=>this._provider.provideFoldingRanges(ae,Y,te)).then(he=>{if(!!Array.isArray(he))return he.map(T.FoldingRange.from)})}}class me{constructor(z,Y,te){this._documents=z,this._provider=Y,this._logService=te}provideSelectionRanges(z,Y,te){const ae=this._documents.getDocument(z),he=Y.map(T.Position.to);return(0,D.asPromise)(()=>this._provider.provideSelectionRanges(ae,he,te)).then(Ce=>{if(!(0,R.isNonEmptyArray)(Ce))return[];if(Ce.length!==he.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Oe=[];for(let be=0;be<he.length;be++){const ke=[];Oe.push(ke);let Re=he[be],Be=Ce[be];for(;;){if(!Be.range.contains(Re))throw new Error("INVALID selection range, must contain the previous range");if(ke.push(T.SelectionRange.from(Be)),!Be.parent)break;Re=Be.range,Be=Be.parent}}return Oe})}}class we{constructor(z,Y){this._documents=z,this._provider=Y,this._idPool=new u.IdGenerator(""),this._cache=new Map}async prepareSession(z,Y,te){const ae=this._documents.getDocument(z),he=T.Position.to(Y),Ce=await this._provider.prepareCallHierarchy(ae,he,te);if(!!Ce){const Oe=this._idPool.nextId();return this._cache.set(Oe,new Map),Array.isArray(Ce)?Ce.map(be=>this._cacheAndConvertItem(Oe,be)):[this._cacheAndConvertItem(Oe,Ce)]}}async provideCallsTo(z,Y,te){const ae=this._itemFromCache(z,Y);if(!ae)throw new Error("missing call hierarchy item");const he=await this._provider.provideCallHierarchyIncomingCalls(ae,te);if(!!he)return he.map(Ce=>({from:this._cacheAndConvertItem(z,Ce.from),fromRanges:Ce.fromRanges.map(Oe=>T.Range.from(Oe))}))}async provideCallsFrom(z,Y,te){const ae=this._itemFromCache(z,Y);if(!ae)throw new Error("missing call hierarchy item");const he=await this._provider.provideCallHierarchyOutgoingCalls(ae,te);if(!!he)return he.map(Ce=>({to:this._cacheAndConvertItem(z,Ce.to),fromRanges:Ce.fromRanges.map(Oe=>T.Range.from(Oe))}))}releaseSession(z){this._cache.delete(z)}_cacheAndConvertItem(z,Y){var te;const ae=this._cache.get(z),he={_sessionId:z,_itemId:ae.size.toString(36),name:Y.name,detail:Y.detail,kind:T.SymbolKind.from(Y.kind),uri:Y.uri,range:T.Range.from(Y.range),selectionRange:T.Range.from(Y.selectionRange),tags:(te=Y.tags)===null||te===void 0?void 0:te.map(T.SymbolTag.from)};return ae.set(he._itemId,Y),he}_itemFromCache(z,Y){const te=this._cache.get(z);return te==null?void 0:te.get(Y)}}class Te{constructor(z,Y){this.adapter=z,this.extension=Y}}class Pe{constructor(z,Y,te,ae,he,Ce,Oe){this._adapter=new Map,this._uriTransformer=Y,this._proxy=z.getProxy(k.MainContext.MainThreadLanguageFeatures),this._documents=te,this._commands=ae,this._diagnostics=he,this._logService=Ce,this._apiDeprecation=Oe}_transformDocumentSelector(z){return(0,R.coalesce)((0,R.asArray)(z).map(Y=>this._doTransformDocumentSelector(Y)))}_doTransformDocumentSelector(z){if(typeof z=="string")return{$serialized:!0,language:z};if(z)return{$serialized:!0,language:z.language,scheme:this._transformScheme(z.scheme),pattern:typeof z.pattern=="undefined"?void 0:T.GlobPattern.from(z.pattern),exclusive:z.exclusive}}_transformScheme(z){return this._uriTransformer&&typeof z=="string"?this._uriTransformer.transformOutgoingScheme(z):z}_createDisposable(z){return new I.Disposable(()=>{this._adapter.delete(z),this._proxy.$unregister(z)})}_nextHandle(){return Pe._handlePool++}_withAdapter(z,Y,te,ae,he=!1){const Ce=this._adapter.get(z);if(!Ce)return Promise.resolve(ae);if(Ce.adapter instanceof Y){let Oe;Ce.extension&&(Oe=Date.now(),this._logService.trace(`[${Ce.extension.identifier.value}] INVOKE provider '${Y.name}'`));const be=te(Ce.adapter,Ce.extension),ke=Ce.extension;return ke&&Promise.resolve(be).then(()=>this._logService.trace(`[${ke.identifier.value}] provider DONE after ${Date.now()-Oe}ms`),Re=>{he&&Re instanceof _.CancellationError||(this._logService.error(`[${ke.identifier.value}] provider FAILED`),this._logService.error(Re))}),be}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(z,Y){const te=this._nextHandle();return this._adapter.set(te,new Te(z,Y)),te}static _extLabel(z){return z.displayName||z.name}registerDocumentSymbolProvider(z,Y,te,ae){const he=this._addNewAdapter(new p(this._documents,te),z),Ce=ae&&ae.label||Pe._extLabel(z);return this._proxy.$registerDocumentSymbolProvider(he,this._transformDocumentSelector(Y),Ce),this._createDisposable(he)}$provideDocumentSymbols(z,Y,te){return this._withAdapter(z,p,ae=>ae.provideDocumentSymbols(E.URI.revive(Y),te),void 0)}registerCodeLensProvider(z,Y,te){const ae=this._nextHandle(),he=typeof te.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Te(new c(this._documents,this._commands.converter,te),z)),this._proxy.$registerCodeLensSupport(ae,this._transformDocumentSelector(Y),he);let Ce=this._createDisposable(ae);if(he!==void 0){const Oe=te.onDidChangeCodeLenses(be=>this._proxy.$emitCodeLensEvent(he));Ce=I.Disposable.from(Ce,Oe)}return Ce}$provideCodeLenses(z,Y,te){return this._withAdapter(z,c,ae=>ae.provideCodeLenses(E.URI.revive(Y),te),void 0)}$resolveCodeLens(z,Y,te){return this._withAdapter(z,c,ae=>ae.resolveCodeLens(Y,te),void 0)}$releaseCodeLenses(z,Y){this._withAdapter(z,c,te=>Promise.resolve(te.releaseCodeLenses(Y)),void 0)}registerDefinitionProvider(z,Y,te){const ae=this._addNewAdapter(new t(this._documents,te),z);return this._proxy.$registerDefinitionSupport(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideDefinition(z,Y,te,ae){return this._withAdapter(z,t,he=>he.provideDefinition(E.URI.revive(Y),te,ae),[])}registerDeclarationProvider(z,Y,te){const ae=this._addNewAdapter(new i(this._documents,te),z);return this._proxy.$registerDeclarationSupport(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideDeclaration(z,Y,te,ae){return this._withAdapter(z,i,he=>he.provideDeclaration(E.URI.revive(Y),te,ae),[])}registerImplementationProvider(z,Y,te){const ae=this._addNewAdapter(new o(this._documents,te),z);return this._proxy.$registerImplementationSupport(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideImplementation(z,Y,te,ae){return this._withAdapter(z,o,he=>he.provideImplementation(E.URI.revive(Y),te,ae),[])}registerTypeDefinitionProvider(z,Y,te){const ae=this._addNewAdapter(new r(this._documents,te),z);return this._proxy.$registerTypeDefinitionSupport(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideTypeDefinition(z,Y,te,ae){return this._withAdapter(z,r,he=>he.provideTypeDefinition(E.URI.revive(Y),te,ae),[])}registerHoverProvider(z,Y,te,ae){const he=this._addNewAdapter(new a(this._documents,te),z);return this._proxy.$registerHoverProvider(he,this._transformDocumentSelector(Y)),this._createDisposable(he)}$provideHover(z,Y,te,ae){return this._withAdapter(z,a,he=>he.provideHover(E.URI.revive(Y),te,ae),void 0)}registerEvaluatableExpressionProvider(z,Y,te,ae){const he=this._addNewAdapter(new h(this._documents,te),z);return this._proxy.$registerEvaluatableExpressionProvider(he,this._transformDocumentSelector(Y)),this._createDisposable(he)}$provideEvaluatableExpression(z,Y,te,ae){return this._withAdapter(z,h,he=>he.provideEvaluatableExpression(E.URI.revive(Y),te,ae),void 0)}registerInlineValuesProvider(z,Y,te,ae){const he=typeof te.onDidChangeInlineValues=="function"?this._nextHandle():void 0,Ce=this._addNewAdapter(new m(this._documents,te),z);this._proxy.$registerInlineValuesProvider(Ce,this._transformDocumentSelector(Y),he);let Oe=this._createDisposable(Ce);if(he!==void 0){const be=te.onDidChangeInlineValues(ke=>this._proxy.$emitInlineValuesEvent(he));Oe=I.Disposable.from(Oe,be)}return Oe}$provideInlineValues(z,Y,te,ae,he){return this._withAdapter(z,m,Ce=>Ce.provideInlineValues(E.URI.revive(Y),te,ae,he),void 0)}registerDocumentHighlightProvider(z,Y,te){const ae=this._addNewAdapter(new b(this._documents,te),z);return this._proxy.$registerDocumentHighlightProvider(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideDocumentHighlights(z,Y,te,ae){return this._withAdapter(z,b,he=>he.provideDocumentHighlights(E.URI.revive(Y),te,ae),void 0)}registerLinkedEditingRangeProvider(z,Y,te){const ae=this._addNewAdapter(new f(this._documents,te),z);return this._proxy.$registerLinkedEditingRangeProvider(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideLinkedEditingRanges(z,Y,te,ae){return this._withAdapter(z,f,async he=>{const Ce=await he.provideLinkedEditingRanges(E.URI.revive(Y),te,ae);if(Ce)return{ranges:Ce.ranges,wordPattern:Ce.wordPattern?Pe._serializeRegExp(Ce.wordPattern):void 0}},void 0)}registerReferenceProvider(z,Y,te){const ae=this._addNewAdapter(new d(this._documents,te),z);return this._proxy.$registerReferenceSupport(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideReferences(z,Y,te,ae,he){return this._withAdapter(z,d,Ce=>Ce.provideReferences(E.URI.revive(Y),te,ae,he),void 0)}registerCodeActionProvider(z,Y,te,ae){var he,Ce;const Oe=new g.DisposableStore,be=this._addNewAdapter(new A(this._documents,this._commands.converter,this._diagnostics,te,this._logService,z,this._apiDeprecation),z);return this._proxy.$registerQuickFixSupport(be,this._transformDocumentSelector(Y),{providedKinds:(he=ae==null?void 0:ae.providedCodeActionKinds)===null||he===void 0?void 0:he.map(ke=>ke.value),documentation:(Ce=ae==null?void 0:ae.documentation)===null||Ce===void 0?void 0:Ce.map(ke=>({kind:ke.kind.value,command:this._commands.converter.toInternal(ke.command,Oe)}))},Pe._extLabel(z),Boolean(te.resolveCodeAction)),Oe.add(this._createDisposable(be)),Oe}$provideCodeActions(z,Y,te,ae,he){return this._withAdapter(z,A,Ce=>Ce.provideCodeActions(E.URI.revive(Y),te,ae,he),void 0)}$resolveCodeAction(z,Y,te){return this._withAdapter(z,A,ae=>ae.resolveCodeAction(Y,te),void 0)}$releaseCodeActions(z,Y){this._withAdapter(z,A,te=>Promise.resolve(te.releaseCodeActions(Y)),void 0)}registerDocumentFormattingEditProvider(z,Y,te){const ae=this._addNewAdapter(new L(this._documents,te),z);return this._proxy.$registerDocumentFormattingSupport(ae,this._transformDocumentSelector(Y),z.identifier,z.displayName||z.name),this._createDisposable(ae)}$provideDocumentFormattingEdits(z,Y,te,ae){return this._withAdapter(z,L,he=>he.provideDocumentFormattingEdits(E.URI.revive(Y),te,ae),void 0)}registerDocumentRangeFormattingEditProvider(z,Y,te){const ae=this._addNewAdapter(new B(this._documents,te),z);return this._proxy.$registerRangeFormattingSupport(ae,this._transformDocumentSelector(Y),z.identifier,z.displayName||z.name),this._createDisposable(ae)}$provideDocumentRangeFormattingEdits(z,Y,te,ae,he){return this._withAdapter(z,B,Ce=>Ce.provideDocumentRangeFormattingEdits(E.URI.revive(Y),te,ae,he),void 0)}registerOnTypeFormattingEditProvider(z,Y,te,ae){const he=this._addNewAdapter(new J(this._documents,te),z);return this._proxy.$registerOnTypeFormattingSupport(he,this._transformDocumentSelector(Y),ae,z.identifier),this._createDisposable(he)}$provideOnTypeFormattingEdits(z,Y,te,ae,he,Ce){return this._withAdapter(z,J,Oe=>Oe.provideOnTypeFormattingEdits(E.URI.revive(Y),te,ae,he,Ce),void 0)}registerWorkspaceSymbolProvider(z,Y){const te=this._addNewAdapter(new j(Y,this._logService),z);return this._proxy.$registerNavigateTypeSupport(te),this._createDisposable(te)}$provideWorkspaceSymbols(z,Y,te){return this._withAdapter(z,j,ae=>ae.provideWorkspaceSymbols(Y,te),{symbols:[]})}$resolveWorkspaceSymbol(z,Y,te){return this._withAdapter(z,j,ae=>ae.resolveWorkspaceSymbol(Y,te),void 0)}$releaseWorkspaceSymbols(z,Y){this._withAdapter(z,j,te=>te.releaseWorkspaceSymbols(Y),void 0)}registerRenameProvider(z,Y,te){const ae=this._addNewAdapter(new U(this._documents,te,this._logService),z);return this._proxy.$registerRenameSupport(ae,this._transformDocumentSelector(Y),U.supportsResolving(te)),this._createDisposable(ae)}$provideRenameEdits(z,Y,te,ae,he){return this._withAdapter(z,U,Ce=>Ce.provideRenameEdits(E.URI.revive(Y),te,ae,he),void 0)}$resolveRenameLocation(z,Y,te,ae){return this._withAdapter(z,U,he=>he.resolveRenameLocation(E.URI.revive(Y),te,ae),void 0)}registerDocumentSemanticTokensProvider(z,Y,te,ae){const he=this._nextHandle(),Ce=typeof te.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(he,new Te(new F(this._documents,te),z)),this._proxy.$registerDocumentSemanticTokensProvider(he,this._transformDocumentSelector(Y),ae,Ce);let Oe=this._createDisposable(he);if(Ce){const be=te.onDidChangeSemanticTokens(ke=>this._proxy.$emitDocumentSemanticTokensEvent(Ce));Oe=I.Disposable.from(Oe,be)}return Oe}$provideDocumentSemanticTokens(z,Y,te,ae){return this._withAdapter(z,F,he=>he.provideDocumentSemanticTokens(E.URI.revive(Y),te,ae),null,!0)}$releaseDocumentSemanticTokens(z,Y){this._withAdapter(z,F,te=>te.releaseDocumentSemanticColoring(Y),void 0)}registerDocumentRangeSemanticTokensProvider(z,Y,te,ae){const he=this._addNewAdapter(new N(this._documents,te),z);return this._proxy.$registerDocumentRangeSemanticTokensProvider(he,this._transformDocumentSelector(Y),ae),this._createDisposable(he)}$provideDocumentRangeSemanticTokens(z,Y,te,ae){return this._withAdapter(z,N,he=>he.provideDocumentRangeSemanticTokens(E.URI.revive(Y),te,ae),null,!0)}registerCompletionItemProvider(z,Y,te,ae){const he=this._addNewAdapter(new M(this._documents,this._commands.converter,te,this._apiDeprecation,z),z);return this._proxy.$registerSuggestSupport(he,this._transformDocumentSelector(Y),ae,M.supportsResolving(te),`${z.identifier.value}(${ae.join("")})`),this._createDisposable(he)}$provideCompletionItems(z,Y,te,ae,he){return this._withAdapter(z,M,Ce=>Ce.provideCompletionItems(E.URI.revive(Y),te,ae,he),void 0)}$resolveCompletionItem(z,Y,te){return this._withAdapter(z,M,ae=>ae.resolveCompletionItem(Y,te),void 0)}$releaseCompletionItems(z,Y){this._withAdapter(z,M,te=>te.releaseCompletionItems(Y),void 0)}registerSignatureHelpProvider(z,Y,te,ae){const he=Array.isArray(ae)?{triggerCharacters:ae,retriggerCharacters:[]}:ae,Ce=this._addNewAdapter(new x(this._documents,te),z);return this._proxy.$registerSignatureHelpProvider(Ce,this._transformDocumentSelector(Y),he),this._createDisposable(Ce)}$provideSignatureHelp(z,Y,te,ae,he){return this._withAdapter(z,x,Ce=>Ce.provideSignatureHelp(E.URI.revive(Y),te,ae,he),void 0)}$releaseSignatureHelp(z,Y){this._withAdapter(z,x,te=>te.releaseSignatureHelp(Y),void 0)}registerInlineHintsProvider(z,Y,te){const ae=typeof te.onDidChangeInlineHints=="function"?this._nextHandle():void 0,he=this._addNewAdapter(new O(this._documents,te),z);this._proxy.$registerInlineHintsProvider(he,this._transformDocumentSelector(Y),ae);let Ce=this._createDisposable(he);if(ae!==void 0){const Oe=te.onDidChangeInlineHints(be=>this._proxy.$emitInlineHintsEvent(ae));Ce=I.Disposable.from(Ce,Oe)}return Ce}$provideInlineHints(z,Y,te,ae){return this._withAdapter(z,O,he=>he.provideInlineHints(E.URI.revive(Y),te,ae),void 0)}registerDocumentLinkProvider(z,Y,te){const ae=this._addNewAdapter(new V(this._documents,te),z);return this._proxy.$registerDocumentLinkProvider(ae,this._transformDocumentSelector(Y),typeof te.resolveDocumentLink=="function"),this._createDisposable(ae)}$provideDocumentLinks(z,Y,te){return this._withAdapter(z,V,ae=>ae.provideLinks(E.URI.revive(Y),te),void 0)}$resolveDocumentLink(z,Y,te){return this._withAdapter(z,V,ae=>ae.resolveLink(Y,te),void 0)}$releaseDocumentLinks(z,Y){this._withAdapter(z,V,te=>te.releaseLinks(Y),void 0)}registerColorProvider(z,Y,te){const ae=this._addNewAdapter(new q(this._documents,te),z);return this._proxy.$registerDocumentColorProvider(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideDocumentColors(z,Y,te){return this._withAdapter(z,q,ae=>ae.provideColors(E.URI.revive(Y),te),[])}$provideColorPresentations(z,Y,te,ae){return this._withAdapter(z,q,he=>he.provideColorPresentations(E.URI.revive(Y),te,ae),void 0)}registerFoldingRangeProvider(z,Y,te){const ae=this._nextHandle(),he=typeof te.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Te(new X(this._documents,te),z)),this._proxy.$registerFoldingRangeProvider(ae,this._transformDocumentSelector(Y),he);let Ce=this._createDisposable(ae);if(he!==void 0){const Oe=te.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(he));Ce=I.Disposable.from(Ce,Oe)}return Ce}$provideFoldingRanges(z,Y,te,ae){return this._withAdapter(z,X,he=>he.provideFoldingRanges(E.URI.revive(Y),te,ae),void 0)}registerSelectionRangeProvider(z,Y,te){const ae=this._addNewAdapter(new me(this._documents,te,this._logService),z);return this._proxy.$registerSelectionRangeProvider(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideSelectionRanges(z,Y,te,ae){return this._withAdapter(z,me,he=>he.provideSelectionRanges(E.URI.revive(Y),te,ae),[])}registerCallHierarchyProvider(z,Y,te){const ae=this._addNewAdapter(new we(this._documents,te),z);return this._proxy.$registerCallHierarchyProvider(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$prepareCallHierarchy(z,Y,te,ae){return this._withAdapter(z,we,he=>Promise.resolve(he.prepareSession(E.URI.revive(Y),te,ae)),void 0)}$provideCallHierarchyIncomingCalls(z,Y,te,ae){return this._withAdapter(z,we,he=>he.provideCallsTo(Y,te,ae),void 0)}$provideCallHierarchyOutgoingCalls(z,Y,te,ae){return this._withAdapter(z,we,he=>he.provideCallsFrom(Y,te,ae),void 0)}$releaseCallHierarchy(z,Y){this._withAdapter(z,we,te=>Promise.resolve(te.releaseSession(Y)),void 0)}static _serializeRegExp(z){return{pattern:z.source,flags:(0,y.regExpFlags)(z)}}static _serializeIndentationRule(z){return{decreaseIndentPattern:Pe._serializeRegExp(z.decreaseIndentPattern),increaseIndentPattern:Pe._serializeRegExp(z.increaseIndentPattern),indentNextLinePattern:z.indentNextLinePattern?Pe._serializeRegExp(z.indentNextLinePattern):void 0,unIndentedLinePattern:z.unIndentedLinePattern?Pe._serializeRegExp(z.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(z){return{beforeText:Pe._serializeRegExp(z.beforeText),afterText:z.afterText?Pe._serializeRegExp(z.afterText):void 0,previousLineText:z.previousLineText?Pe._serializeRegExp(z.previousLineText):void 0,action:z.action}}static _serializeOnEnterRules(z){return z.map(Pe._serializeOnEnterRule)}setLanguageConfiguration(z,Y,te){let{wordPattern:ae}=te;if(ae&&(0,y.regExpLeadsToEndlessLoop)(ae))throw new Error(`Invalid language configuration: wordPattern '${ae}' is not allowed to match the empty string.`);ae?this._documents.setWordDefinitionFor(Y,ae):this._documents.setWordDefinitionFor(Y,void 0),te.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",z,"Do not use."),te.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",z,"Do not use.");const he=this._nextHandle(),Ce={comments:te.comments,brackets:te.brackets,wordPattern:te.wordPattern?Pe._serializeRegExp(te.wordPattern):void 0,indentationRules:te.indentationRules?Pe._serializeIndentationRule(te.indentationRules):void 0,onEnterRules:te.onEnterRules?Pe._serializeOnEnterRules(te.onEnterRules):void 0,__electricCharacterSupport:te.__electricCharacterSupport,__characterPairSupport:te.__characterPairSupport};return this._proxy.$setLanguageConfiguration(he,Y,Ce),this._createDisposable(he)}$setWordDefinitions(z){for(const Y of z)this._documents.setWordDefinitionFor(Y.languageId,new RegExp(Y.regexSource,Y.regexFlags))}}e.ExtHostLanguageFeatures=Pe,Pe._handlePool=0}),define(ge[239],pe([0,1,5,20,7]),function(G,e,E,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class I{constructor(k,y){this._proxy=k.getProxy(E.MainContext.MainThreadLanguages),this._documents=y}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(k,y){await this._proxy.$changeLanguage(k,y);const n=this._documents.getDocumentData(k);if(!n)throw new Error(`document '${k.toString}' NOT found`);return n.document}async tokenAtPosition(k,y){var n;const R=k.version,C=P.Position.from(y),w=await this._proxy.$tokensAtPosition(k.uri,C),g={type:T.StandardTokenType.Other,range:(n=k.getWordRangeAtPosition(y))!==null&&n!==void 0?n:new T.Range(y.line,y.character,y.line,y.character)};if(!w)return g;const s={range:P.Range.to(w.range),type:P.TokenType.to(w.type)};return!s.range.contains(y)||R!==k.version?g:s}}e.ExtHostLanguages=I}),define(ge[240],pe([0,1,5,12,41]),function(G,e,E,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function I(k){return k&&k.title}let D=class{constructor(y,n){this._logService=n,this._proxy=y.getProxy(E.MainContext.MainThreadMessageService)}showMessage(y,n,R,C,w){const g={extension:y};let s;typeof C=="string"||I(C)?s=[C,...w]:(g.modal=C&&C.modal,g.useCustom=C&&C.useCustom,s=w),g.useCustom&&(0,T.checkProposedApiEnabled)(y);const u=[];for(let S=0;S<s.length;S++){const v=s[S];if(typeof v=="string")u.push({title:v,handle:S,isCloseAffordance:!1});else if(typeof v=="object"){let{title:_,isCloseAffordance:p}=v;u.push({title:_,isCloseAffordance:!!p,handle:S})}else this._logService.warn("Invalid message item:",v)}return this._proxy.$showMessage(n,R,g,u).then(S=>{if(typeof S=="number")return s[S]})}};D=je([Ue(1,P.ILogService)],D),e.ExtHostMessageService=D}),define(ge[241],pe([0,1,21,3,6,2,28,5,20,7,84,85,24,217,218,70,15,22,73]),function(G,e,E,P,T,I,D,k,y,n,R,C,w,g,s,u,S,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookCellStatusBarItemInternal=e.ExtHostNotebookController=e.NotebookEditorDecorationType=e.ExtHostNotebookKernelProviderAdapter=void 0;class p extends T.Disposable{constructor(m,b,f,d,A){super();this._editorId=m,this.uri=b,this._proxy=f,this._webviewInitData=d,this.document=A,this._onDidReceiveDocumentMessage=new P.Emitter,this._rendererIdToEmitters=new Map,this.contentProviderComm={editorId:this._editorId,onDidReceiveMessage:this._onDidReceiveDocumentMessage.event,postMessage:L=>this._proxy.$postMessage(this._editorId,void 0,L),asWebviewUri:L=>this._asWebviewUri(L)}}onDidReceiveMessage(m,b){var f;this._onDidReceiveDocumentMessage.fire(b),m!==void 0&&((f=this._rendererIdToEmitters.get(m))===null||f===void 0||f.fire(b))}getRendererComm(m){const b=new P.Emitter;return this._rendererIdToEmitters.set(m,b),{editorId:this._editorId,onDidReceiveMessage:b.event,postMessage:f=>this._proxy.$postMessage(this._editorId,m,f),asWebviewUri:f=>this._asWebviewUri(f)}}_asWebviewUri(m){return(0,R.asWebviewUri)(this._webviewInitData,this._editorId,m)}}class c extends T.Disposable{constructor(m,b,f,d){super();this._proxy=m,this._handle=b,this._extension=f,this._provider=d,this._kernelToFriendlyId=new w.ResourceMap,this._friendlyIdToKernel=new w.ResourceMap,this._provider.onDidChangeKernels&&this._register(this._provider.onDidChangeKernels(A=>{const L=A==null?void 0:A.uri;this._proxy.$onNotebookKernelChange(this._handle,L)}))}async provideKernels(m,b){const f=await this._provider.provideKernels(m.notebookDocument,b)||[],d=new Map;let A=0;const L=new Set,B=this._kernelToFriendlyId.get(m.uri),J=f.map(U=>{var $;let F=B==null?void 0:B.get(U);return F===void 0&&(U.id&&L.has(U.id)?F=`${this._extension.identifier.value}_${U.id}_${A++}`:F=`${this._extension.identifier.value}_${U.id||D.generateUuid()}`),d.set(U,F),{id:U.id,friendlyId:F,label:U.label,extension:this._extension.identifier,extensionLocation:this._extension.extensionLocation,providerHandle:this._handle,description:U.description,detail:U.detail,isPreferred:U.isPreferred,preloads:($=U.preloads)===null||$===void 0?void 0:$.map(N=>(I.URI.isUri(N)&&(N={uri:N,provides:[]}),{uri:N.uri,provides:typeof N.provides=="string"?[N.provides]:N.provides===void 0?[]:N.provides})),supportedLanguages:U.supportedLanguages,implementsInterrupt:!!U.interrupt}});this._kernelToFriendlyId.set(m.uri,d);const j=new Map;return d.forEach((U,$)=>{j.set(U,$)}),this._friendlyIdToKernel.set(m.uri,j),J}getKernelByFriendlyId(m,b){var f;return(f=this._friendlyIdToKernel.get(m))===null||f===void 0?void 0:f.get(b)}async resolveNotebook(m,b,f,d){var A;const L=(A=this._friendlyIdToKernel.get(b.uri))===null||A===void 0?void 0:A.get(m);if(L&&this._provider.resolveKernel)return this._provider.resolveKernel(L,b.notebookDocument,f,d)}async executeNotebook(m,b,f){var d;const A=(d=this._friendlyIdToKernel.get(b.uri))===null||d===void 0?void 0:d.get(m);if(!!A){const L=f.map(B=>y.NotebookCellRange.to(B));return A.executeCellsRequest(b.notebookDocument,L)}}async interruptNotebookExecution(m,b){var f;const d=(f=this._friendlyIdToKernel.get(b.uri))===null||f===void 0?void 0:f.get(m);if(!(!d||!d.interrupt))return d.interrupt(b.notebookDocument)}}e.ExtHostNotebookKernelProviderAdapter=c;class l{constructor(m,b){const f=l._Keys.nextId();m.$registerNotebookEditorDecorationType(f,y.NotebookDecorationRenderOptions.from(b)),this.value={key:f,dispose(){m.$removeNotebookEditorDecorationType(f)}}}}e.NotebookEditorDecorationType=l,l._Keys=new u.IdGenerator("NotebookEditorDecorationType");class t{constructor(m,b,f,d,A,L,B){this._textDocumentsAndEditors=f,this._textDocuments=d,this._webviewInitData=A,this.logService=L,this._extensionStoragePaths=B,this._notebookContentProviders=new Map,this._notebookKernelProviders=new Map,this._documents=new w.ResourceMap,this._editors=new Map,this._webviewComm=new Map,this._onDidChangeNotebookEditorSelection=new P.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this._onDidChangeNotebookEditorVisibleRanges=new P.Emitter,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event,this._onDidChangeNotebookDocumentMetadata=new P.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidChangeNotebookCells=new P.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new P.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new P.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new P.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new P.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new P.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new P.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidSaveNotebookDocument=new P.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeActiveNotebookKernel=new P.Emitter,this.onDidChangeActiveNotebookKernel=this._onDidChangeActiveNotebookKernel.event,this._onDidChangeVisibleNotebookEditors=new P.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._activeExecutions=new w.ResourceMap,this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=m.getProxy(k.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=m.getProxy(k.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=m.getProxy(k.MainContext.MainThreadNotebookEditors),this._commandsConverter=b.converter,b.registerArgumentProcessor({processArgument:J=>{var j;if(J&&J.$mid===12){const U=(j=J.notebookEditor)===null||j===void 0?void 0:j.notebookUri,$=J.cell.handle,F=this._documents.get(U),N=F==null?void 0:F.getCell($);if(N)return N.cell}return J}})}get activeNotebookEditor(){var m;return(m=this._activeNotebookEditor)===null||m===void 0?void 0:m.editor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(m=>m.editor)}get notebookDocuments(){return[...this._documents.values()]}lookupNotebookDocument(m){return this._documents.get(m)}_getNotebookDocument(m){const b=this._documents.get(m);if(!b)throw new Error(`NO notebook document for '${m}'`);return b}_getProviderData(m){const b=this._notebookContentProviders.get(m);if(!b)throw new Error(`NO provider for '${m}'`);return b}registerNotebookContentProvider(m,b,f,d){var A,L,B;if(this._notebookContentProviders.has(b))throw new Error(`Notebook provider for '${b}' already registered`);this._notebookContentProviders.set(b,{extension:m,provider:f});let J;f.onDidChangeNotebookContentOptions&&(J=f.onDidChangeNotebookContentOptions(()=>{const $=y.NotebookDocumentContentOptions.from(f.options);this._notebookProxy.$updateNotebookProviderOptions(b,$)}));const j=(A=d==null?void 0:d.viewOptions)===null||A===void 0?void 0:A.filenamePattern.map($=>y.NotebookExclusiveDocumentPattern.from($)).filter($=>$!==void 0);((L=d==null?void 0:d.viewOptions)===null||L===void 0?void 0:L.filenamePattern)&&!j&&console.warn(`Notebook content provider view options file name pattern is invalid ${(B=d==null?void 0:d.viewOptions)===null||B===void 0?void 0:B.filenamePattern}`);const U=y.NotebookDocumentContentOptions.from(d);return this._notebookProxy.$registerNotebookProvider({id:m.identifier,location:m.extensionLocation,description:m.description},b,{transientOutputs:U.transientOutputs,transientMetadata:U.transientMetadata,viewOptions:(d==null?void 0:d.viewOptions)&&j?{displayName:d.viewOptions.displayName,filenamePattern:j,exclusive:d.viewOptions.exclusive||!1}:void 0}),new n.Disposable(()=>{J==null||J.dispose(),this._notebookContentProviders.delete(b),this._notebookProxy.$unregisterNotebookProvider(b)})}registerNotebookKernelProvider(m,b,f){const d=t._notebookKernelProviderHandlePool++,A=new c(this._notebookProxy,d,m,f);return this._notebookKernelProviders.set(d,A),this._notebookProxy.$registerNotebookKernelProvider({id:m.identifier,location:m.extensionLocation,description:m.description},d,{viewType:b.viewType,filenamePattern:b.filenamePattern?y.NotebookExclusiveDocumentPattern.from(b.filenamePattern):void 0}),new n.Disposable(()=>{A.dispose(),this._notebookKernelProviders.delete(d),this._notebookProxy.$unregisterNotebookKernelProvider(d)})}createNotebookEditorDecorationType(m){return new l(this._notebookEditorsProxy,m).value}async openNotebookDocument(m){const b=this._documents.get(m);if(b)return b.notebookDocument;const f=await this._notebookDocumentsProxy.$tryOpenDocument(m),d=this._documents.get(I.URI.revive(f));return(0,S.assertIsDefined)(d==null?void 0:d.notebookDocument)}_withAdapter(m,b,f){const d=this._documents.get(I.URI.revive(b));if(!d)return[];const A=this._notebookKernelProviders.get(m);return A?f(A,d):[]}async showNotebookDocument(m,b){var f;I.URI.isUri(m)&&(m=await this.openNotebookDocument(m));let d;typeof b=="object"?d={position:y.ViewColumn.from(b.viewColumn),preserveFocus:b.preserveFocus,selections:b.selections&&b.selections.map(y.NotebookCellRange.from),pinned:typeof b.preview=="boolean"?!b.preview:void 0}:d={preserveFocus:!1};const A=await this._notebookEditorsProxy.$tryShowNotebookDocument(m.uri,m.viewType,d),L=A&&((f=this._editors.get(A))===null||f===void 0?void 0:f.editor);if(L)return L.editor;throw A?new Error(`Could NOT open editor for "${m.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${m.toString()}".`)}async $provideNotebookKernels(m,b,f){return this._withAdapter(m,b,(d,A)=>d.provideKernels(A,f))}async $resolveNotebookKernel(m,b,f,d,A){await this._withAdapter(m,f,async(L,B)=>{const J=this._webviewComm.get(b);J&&await L.resolveNotebook(d,B,J.contentProviderComm,A)})}async $resolveNotebookEditor(m,b,f){const d=this._notebookContentProviders.get(m),A=I.URI.revive(b),L=this._documents.get(A);if(!(!L||!d)){let B=this._webviewComm.get(f);B||(B=new p(f,A,this._notebookProxy,this._webviewInitData,L),this._webviewComm.set(f,B))}}async $executeNotebookKernelFromProvider(m,b,f,d){await this._withAdapter(m,b,async(A,L)=>A.executeNotebook(f,L,d))}registerNotebookSerializer(m,b,f,d){const A=this._handlePool++;this._notebookSerializer.set(A,f);const L=y.NotebookDocumentContentOptions.from(d);return this._notebookProxy.$registerNotebookSerializer(A,{id:m.identifier,location:m.extensionLocation,description:m.description},b,L),(0,T.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(A)})}async $dataToNotebook(m,b){const f=this._notebookSerializer.get(m);if(!f)throw new Error("NO serializer found");const d=await f.dataToNotebook(b.buffer);return{metadata:y.NotebookDocumentMetadata.from(d.metadata),cells:d.cells.map(y.NotebookCellData.from)}}async $notebookToData(m,b){const f=this._notebookSerializer.get(m);if(!f)throw new Error("NO serializer found");const d=await f.notebookToData({metadata:y.NotebookDocumentMetadata.to(b.metadata),cells:b.cells.map(y.NotebookCellData.to)});return v.VSBuffer.wrap(d)}async $cancelNotebookCellExecution(m,b,f,d){await this._withAdapter(m,b,async(L,B)=>L.interruptNotebookExecution(f,B));const A=this._documents.get(I.URI.revive(b));if(!!A)for(let L of d)for(let B=L.start;B<L.end;B++){const J=A.getCellFromIndex(B);J&&this.cancelOneNotebookCellExecution(J)}}cancelOneNotebookCellExecution(m){const b=this._activeExecutions.get(m.uri);b==null||b.cancel()}async $openNotebook(m,b,f,d,A){const{provider:L}=this._getProviderData(m),B=await L.openNotebook(I.URI.revive(b),{backupId:f,untitledDocumentData:d==null?void 0:d.buffer},A);return{metadata:y.NotebookDocumentMetadata.from(B.metadata),cells:B.cells.map(y.NotebookCellData.from)}}async $saveNotebook(m,b,f){const d=this._getNotebookDocument(I.URI.revive(b)),{provider:A}=this._getProviderData(m);return await A.saveNotebook(d.notebookDocument,f),!0}async $saveNotebookAs(m,b,f,d){const A=this._getNotebookDocument(I.URI.revive(b)),{provider:L}=this._getProviderData(m);return await L.saveNotebookAs(I.URI.revive(f),A.notebookDocument,d),!0}async $backupNotebook(m,b,f){var d;const A=this._getNotebookDocument(I.URI.revive(b)),L=this._getProviderData(m),B=(d=this._extensionStoragePaths.workspaceValue(L.extension))!==null&&d!==void 0?d:this._extensionStoragePaths.globalValue(L.extension),J=String((0,_.hash)([A.uri.toString(),this._backupIdPool++])),j=I.URI.joinPath(B,J),U=await L.provider.backupNotebook(A.notebookDocument,{destination:j},f);return A.updateBackup(U),U.id}$acceptNotebookActiveKernelChange(m){m.providerHandle!==void 0&&this._withAdapter(m.providerHandle,m.uri,async(b,f)=>{const d=m.kernelFriendlyId?b.getKernelByFriendlyId(I.URI.revive(m.uri),m.kernelFriendlyId):void 0;this._editors.forEach(A=>{A.editor.notebookData===f&&A.editor._acceptKernel(d)}),this._onDidChangeActiveNotebookKernel.fire({document:f.notebookDocument,kernel:d})})}$onDidReceiveMessage(m,b,f){var d;(d=this._webviewComm.get(m))===null||d===void 0||d.onDidReceiveMessage(b,f)}$acceptModelChanged(m,b,f){this._getNotebookDocument(I.URI.revive(m)).acceptModelChanged(b,f)}$acceptDirtyStateChanged(m,b){const f=this._getNotebookDocument(I.URI.revive(m));f.acceptModelChanged({rawEvents:[],versionId:f.notebookDocument.version},b)}$acceptModelSaved(m){const b=this._getNotebookDocument(I.URI.revive(m));this._onDidSaveNotebookDocument.fire(b.notebookDocument)}$acceptEditorPropertiesChanged(m,b){this.logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",m,b);const f=this._editors.get(m);if(!f)throw new Error(`unknown text editor: ${m}. known editors: ${[...this._editors.keys()]} `);b.visibleRanges&&f.editor._acceptVisibleRanges(b.visibleRanges.ranges.map(y.NotebookCellRange.to)),b.selections&&f.editor._acceptSelections(b.selections.selections.map(y.NotebookCellRange.to)),b.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:f.editor.editor,visibleRanges:f.editor.editor.visibleRanges}),b.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:f.editor.editor,selections:f.editor.editor.selections}))}$acceptEditorViewColumns(m){for(const b in m){const f=this._editors.get(b);if(!f)throw new Error(`unknown text editor: ${b}. known editors: ${[...this._editors.keys()]} `);f.editor._acceptViewColumn(y.ViewColumn.to(m[b]))}}$acceptDocumentPropertiesChanged(m,b){this.logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",m.path,b);const f=this._getNotebookDocument(I.URI.revive(m));f.acceptDocumentPropertiesChanged(b),b.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:f.notebookDocument})}_createExtHostEditor(m,b,f){if(this._editors.has(b))throw new Error(`editor with id ALREADY EXSIST: ${b}`);const d=m.uri;let A=this._webviewComm.get(b);A||(A=new p(b,d,this._notebookProxy,this._webviewInitData,m),this._webviewComm.set(b,A));const L=new s.ExtHostNotebookEditor(b,this._notebookEditorsProxy,m,f.visibleRanges.map(y.NotebookCellRange.to),f.selections.map(y.NotebookCellRange.to),typeof f.viewColumn=="number"?y.ViewColumn.to(f.viewColumn):void 0);this._editors.set(b,{editor:L})}$acceptDocumentAndEditorsDelta(m){var b,f,d,A;if(m.removedDocuments)for(const B of m.removedDocuments){const J=I.URI.revive(B),j=this._documents.get(J);j&&(j.dispose(),this._documents.delete(J),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:j.notebookDocument.getCells().map(U=>U.document.uri)}),this._onDidCloseNotebookDocument.fire(j.notebookDocument));for(const U of this._editors.values())U.editor.notebookData.uri.toString()===J.toString()&&this._editors.delete(U.editor.id)}if(m.addedDocuments){const B=[];for(const J of m.addedDocuments){const j=I.URI.revive(J.uri),U=J.viewType;if(this._documents.has(j))throw new Error(`adding EXISTING notebook ${j} `);const $=this,F=new g.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(N){$._onDidChangeNotebookCells.fire(N)},emitCellOutputsChange(N){$._onDidChangeCellOutputs.fire(N)},emitCellMetadataChange(N){$._onDidChangeCellMetadata.fire(N)},emitCellExecutionStateChange(N){$._onDidChangeCellExecutionState.fire(N)}},U,J.metadata?y.NotebookDocumentMetadata.to(J.metadata):new n.NotebookDocumentMetadata,j);F.acceptModelChanged({versionId:J.versionId,rawEvents:[{kind:C.NotebookCellsChangeType.Initialize,changes:[[0,0,J.cells]]}]},!1),B.push(...J.cells.map(N=>g.ExtHostCell.asModelAddData(F.notebookDocument,N))),(b=this._documents.get(j))===null||b===void 0||b.dispose(),this._documents.set(j,F),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:B}),this._onDidOpenNotebookDocument.fire(F.notebookDocument)}}if(m.addedEditors)for(const B of m.addedEditors){if(this._editors.has(B.id))return;const J=I.URI.revive(B.documentUri),j=this._documents.get(J);j&&this._createExtHostEditor(j,B.id,B)}const L=[];if(m.removedEditors)for(const B of m.removedEditors){const J=this._editors.get(B);J&&(this._editors.delete(B),((f=this._activeNotebookEditor)===null||f===void 0?void 0:f.id)===J.editor.id&&(this._activeNotebookEditor=void 0),L.push(J))}if(m.visibleEditors){this._visibleNotebookEditors=m.visibleEditors.map(J=>this._editors.get(J).editor).filter(J=>!!J);const B=new Set;this._visibleNotebookEditors.forEach(J=>B.add(J.id));for(const J of this._editors.values()){const j=B.has(J.editor.id);J.editor._acceptVisibility(j)}this._visibleNotebookEditors=[...this._editors.values()].map(J=>J.editor).filter(J=>J.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}m.newActiveEditor===null?this._activeNotebookEditor=void 0:m.newActiveEditor&&(this._activeNotebookEditor=(d=this._editors.get(m.newActiveEditor))===null||d===void 0?void 0:d.editor),m.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((A=this._activeNotebookEditor)===null||A===void 0?void 0:A.editor)}createNotebookCellStatusBarItemInternal(m,b,f){const d=new i(this._notebookProxy,this._commandsConverter,m,b,f),A=C.CellUri.parse(m.document.uri);if(A){const L=this._documents.get(A.notebook);if(L){const B=L.getCell(A.handle);B&&P.Event.once(B.onDidDispose)(()=>d.dispose())}}return d}createNotebookCellExecution(m,b,f){const d=this.lookupNotebookDocument(m);if(!d)throw new Error(`Invalid cell uri / index: ${m}, ${b} `);const A=d.getCellFromIndex(b);if(!A)throw new Error(`Invalid cell uri / index: ${m}, ${b} `);if(!this._activeExecutions.has(A.uri)){const L=new a(m,d,A,this._notebookDocumentsProxy);this._activeExecutions.set(A.uri,L);const B=L.onDidChangeState(()=>{L.state===r.Resolved&&(L.dispose(),B.dispose(),this._activeExecutions.delete(A.uri))});return L.asApiObject()}}}e.ExtHostNotebookController=t,t._notebookKernelProviderHandlePool=0;class i extends T.Disposable{constructor(m,b,f,d,A){super();this._proxy=m,this._commands=b,this._cell=f,this._priority=A,this._id=i.NEXT_ID++,this._isDisposed=!1,this._text="",this._visible=!1,this._internalCommandRegistration=this._register(new T.DisposableStore),this._alignment=d!=null?d:n.NotebookCellStatusBarAlignment.Left}get apiItem(){return this._apiItem||(this._apiItem=o(this)),this._apiItem}get cell(){return this._cell}get alignment(){return this._alignment}set alignment(m){this._alignment=m,this.update()}get priority(){return this._priority}set priority(m){this._priority=m,this.update()}get text(){return this._text}set text(m){this._text=m,this.update()}get tooltip(){return this._tooltip}set tooltip(m){this._tooltip=m,this.update()}get command(){var m;return(m=this._command)===null||m===void 0?void 0:m.fromApi}set command(m){var b;((b=this._command)===null||b===void 0?void 0:b.fromApi)!==m&&(this._internalCommandRegistration.clear(),typeof m=="string"?this._command={fromApi:m,internal:this._commands.toInternal({title:"",command:m},this._internalCommandRegistration)}:m?this._command={fromApi:m,internal:this._commands.toInternal(m,this._internalCommandRegistration)}:this._command=void 0,this.update())}get accessibilityInformation(){return this._accessibilityInformation}set accessibilityInformation(m){this._accessibilityInformation=m,this.update()}show(){this._visible=!0,this.update()}hide(){this._visible=!1,this.update()}dispose(){this.hide(),this._isDisposed=!0,this._internalCommandRegistration.dispose()}update(){var m;if(!this._isDisposed){const b={alignment:this.alignment===n.NotebookCellStatusBarAlignment.Left?0:1,cellResource:this.cell.document.uri,command:(m=this._command)===null||m===void 0?void 0:m.internal,text:this.text,tooltip:this.tooltip,accessibilityInformation:this.accessibilityInformation,priority:this.priority,visible:this._visible};this._proxy.$setStatusBarEntry(this._id,b)}}}e.NotebookCellStatusBarItemInternal=i,i.NEXT_ID=0;function o(h){return Object.freeze({cell:h.cell,get alignment(){return h.alignment},set alignment(m){h.alignment=m},get priority(){return h.priority},set priority(m){h.priority=m},get text(){return h.text},set text(m){h.text=m},get tooltip(){return h.tooltip},set tooltip(m){h.tooltip=m},get command(){return h.command},set command(m){h.command=m},get accessibilityInformation(){return h.accessibilityInformation},set accessibilityInformation(m){h.accessibilityInformation=m},show(){h.show()},hide(){h.hide()},dispose(){h.dispose()}})}var r;(function(h){h[h.Init=0]="Init",h[h.Started=1]="Started",h[h.Resolved=2]="Resolved"})(r||(r={}));class a extends T.Disposable{constructor(m,b,f,d){super();this._uri=m,this._document=b,this._cell=f,this._proxy=d,this._onDidChangeState=new P.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=r.Init,this._tokenSource=this._register(new E.CancellationTokenSource),this._executionOrder=f.internalMetadata.executionOrder,this.mixinMetadata({runState:C.NotebookCellExecutionState.Pending,lastRunDuration:null,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEdits(m){return this._proxy.$applyEdits(this._uri,m,!1)}verifyStateForOutput(){if(this._state===r.Init)throw new Error("Must call start before modifying cell output");if(this._state===r.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(m){const b=[{editType:11,handle:this._cell.handle,metadata:m}];this.applyEdits(b)}cellIndexToHandle(m){const b=typeof m=="number"?this._document.getCellFromIndex(m):this._cell;if(!!b)return b.handle}asApiObject(){const m=this;return Object.freeze({get document(){return m._document.notebookDocument},get cell(){return m._cell.cell},get executionOrder(){return m._executionOrder},set executionOrder(b){m._executionOrder=b,m.mixinMetadata({executionOrder:b})},start(b){if(m._state===r.Resolved||m._state===r.Started)throw new Error("Cannot call start again");m._state=r.Started,m._onDidChangeState.fire(),m.mixinMetadata({runState:C.NotebookCellExecutionState.Executing,runStartTime:b==null?void 0:b.startTime})},end(b){var f,d;if(m._state===r.Resolved)throw new Error("Cannot call resolve twice");m._state=r.Resolved,m._onDidChangeState.fire(),m.mixinMetadata({runState:C.NotebookCellExecutionState.Idle,lastRunSuccess:(f=b==null?void 0:b.success)!==null&&f!==void 0?f:null,lastRunDuration:(d=b==null?void 0:b.duration)!==null&&d!==void 0?d:null})},clearOutput(b){return m.verifyStateForOutput(),this.replaceOutput([],b)},async appendOutput(b,f){m.verifyStateForOutput();const d=m.cellIndexToHandle(f);if(typeof d=="number")return b=Array.isArray(b)?b:[b],m.applyEdits([{editType:2,handle:d,append:!0,outputs:b.map(y.NotebookCellOutput.from)}])},async replaceOutput(b,f){m.verifyStateForOutput();const d=m.cellIndexToHandle(f);if(typeof d=="number")return b=Array.isArray(b)?b:[b],m.applyEdits([{editType:2,handle:d,outputs:b.map(y.NotebookCellOutput.from)}])},async appendOutputItems(b,f){return m.verifyStateForOutput(),b=Array.isArray(b)?b:[b],m.applyEdits([{editType:10,append:!0,items:b.map(y.NotebookCellOutputItem.from),outputId:f}])},async replaceOutputItems(b,f){return m.verifyStateForOutput(),b=Array.isArray(b)?b:[b],m.applyEdits([{editType:10,items:b.map(y.NotebookCellOutputItem.from),outputId:f}])},token:m._tokenSource.token})}}}),define(ge[242],pe([0,1,3,6,5,2,20,14]),function(G,e,E,P,T,I,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;class y{constructor(R,C){this._extHostNotebook=C,this._kernelData=new Map,this._handlePool=0,this._proxy=R.getProxy(T.MainContext.MainThreadNotebookKernels)}createKernel(R,C){const w=this._handlePool++,g=this;let s=!1;const u=new P.DisposableStore,S=new E.Emitter;this._kernelData.set(w,{id:C.id,executeHandler:C.executeHandler,onDidChangeSelection:S});const v={id:C.id,selector:C.selector,extensionId:R.identifier,extensionLocation:R.extensionLocation,label:C.label,supportedLanguages:(0,k.isNonEmptyArray)(C.supportedLanguages)?C.supportedLanguages:["plaintext"],supportsInterrupt:Boolean(C.interruptHandler),hasExecutionOrder:C.hasExecutionOrder};this._proxy.$addKernel(w,v);let _=0;const p=()=>{if(!s){const c=++_;Promise.resolve().then(()=>{c===_&&this._proxy.$updateKernel(w,v)})}};return{get id(){return v.id},get selector(){return v.selector},onDidChangeNotebookAssociation:S.event,get label(){return v.label},set label(c){v.label=c,p()},get description(){var c;return(c=v.description)!==null&&c!==void 0?c:""},set description(c){v.description=c,p()},get supportedLanguages(){return v.supportedLanguages},set supportedLanguages(c){v.supportedLanguages=(0,k.isNonEmptyArray)(c)?c:["plaintext"],p()},get hasExecutionOrder(){var c;return(c=v.hasExecutionOrder)!==null&&c!==void 0?c:!1},set hasExecutionOrder(c){v.hasExecutionOrder=c,p()},get executeHandler(){return g._kernelData.get(w).executeHandler},get interruptHandler(){return g._kernelData.get(w).interruptHandler},set interruptHandler(c){g._kernelData.get(w).interruptHandler=c,v.supportsInterrupt=Boolean(c),p()},createNotebookCellExecutionTask(c){return g._extHostNotebook.createNotebookCellExecution(c.document.uri,c.index,v.id)},dispose:()=>{s=!0,this._kernelData.delete(w),u.dispose(),S.dispose(),this._proxy.$removeKernel(w)}}}$acceptSelection(R,C,w){const g=this._kernelData.get(R);g&&g.onDidChangeSelection.fire({selected:w,notebook:this._extHostNotebook.lookupNotebookDocument(I.URI.revive(C)).notebookDocument})}$executeCells(R,C,w){const g=this._kernelData.get(R);if(!!g){const s=this._extHostNotebook.lookupNotebookDocument(I.URI.revive(C));if(!s)throw new Error("MISSING notebook");const u=[];for(let S of w){const v=s.notebookDocument.getCells(D.NotebookCellRange.to(S));for(let _ of v){const p=this._extHostNotebook.createNotebookCellExecution(s.uri,_.index,g.id);p?u.push(p):console.warn("could NOT create notebook cell execution task for: "+_.document.uri)}}try{g.executeHandler(u)}catch(S){console.error(S)}}}$cancelCells(R,C,w){const g=this._kernelData.get(R);if(!!g){const s=this._extHostNotebook.lookupNotebookDocument(I.URI.revive(C));if(!s)throw new Error("MISSING notebook");g.interruptHandler&&g.interruptHandler(s.notebookDocument)}}}e.ExtHostNotebookKernels=y}),define(ge[63],pe([0,1,5,3,6,22,4,13]),function(G,e,E,P,T,I,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class y extends T.Disposable{constructor(s,u,S,v){super();this._onDidAppend=this._register(new P.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=s,this._proxy=v,this._id=v.$register(this.name,u,S),this._disposed=!1,this._offset=0}get name(){return this._name}append(s){this.validate(),this._offset+=s?I.VSBuffer.fromString(s).byteLength:0}update(){this._id.then(s=>this._proxy.$update(s))}appendLine(s){this.validate(),this.append(s+`
`)}clear(){this.validate();const s=this._offset;this._id.then(u=>this._proxy.$clear(u,s))}show(s,u){this.validate(),this._id.then(S=>this._proxy.$reveal(S,!!(typeof s=="boolean"?s:u)))}hide(){this.validate(),this._id.then(s=>this._proxy.$close(s))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(s=>this._proxy.$dispose(s)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=y;class n extends y{constructor(s,u){super(s,!1,void 0,u)}append(s){super.append(s),this._id.then(u=>this._proxy.$append(u,s)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=n;class R extends y{constructor(s,u,S){super(s,!0,u,S)}append(s){throw new Error("Not supported")}}class C{constructor(s,u){this.name=s,this._channel=u}append(s){this._channel.then(u=>u.append(s))}appendLine(s){this._channel.then(u=>u.appendLine(s))}clear(){this._channel.then(s=>s.clear())}show(s,u){this._channel.then(S=>S.show(s,u))}hide(){this._channel.then(s=>s.hide())}dispose(){this._channel.then(s=>s.dispose())}}e.LazyOutputChannel=C;let w=class{constructor(s){this._proxy=s.getProxy(E.MainContext.MainThreadOutputService)}$setVisibleChannel(s){}createOutputChannel(s){if(s=s.trim(),!s)throw new Error("illegal argument `name`. must not be falsy");return new n(s,this._proxy)}createOutputChannelFromLogFile(s,u){if(s=s.trim(),!s)throw new Error("illegal argument `name`. must not be falsy");if(!u)throw new Error("illegal argument `file`. must not be falsy");return new R(s,u,this._proxy)}};w=je([Ue(0,k.IExtHostRpcService)],w),e.ExtHostOutputService=w,e.IExtHostOutputService=(0,D.createDecorator)("IExtHostOutputService")}),define(ge[243],pe([0,1,19,21,3,6,5,2,7,18,14,56]),function(G,e,E,P,T,I,D,k,y,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function w(g,s,u){const S=g.getProxy(D.MainContext.MainThreadQuickOpen);class v{constructor(r,a){this._sessions=new Map,this._instances=0,this._workspace=r,this._commands=a}showQuickPick(r,a,h,m=P.CancellationToken.None){this._onDidSelectItem=void 0;const b=Promise.resolve(r),f=++this._instances,d=S.$show(f,{title:h==null?void 0:h.title,placeHolder:h==null?void 0:h.placeHolder,matchOnDescription:h==null?void 0:h.matchOnDescription,matchOnDetail:h==null?void 0:h.matchOnDetail,ignoreFocusLost:h==null?void 0:h.ignoreFocusOut,canPickMany:h==null?void 0:h.canPickMany},m),A={},L=d.then(()=>A);return Promise.race([L,b]).then(B=>{if(B!==A)return b.then(J=>{const j=[];for(let U=0;U<J.length;U++){const $=J[U];let F,N,M,x,O;typeof $=="string"?F=$:(F=$.label,N=$.description,M=$.detail,x=$.picked,O=$.alwaysShow),j.push({label:F,description:N,handle:U,detail:M,picked:x,alwaysShow:O})}return h&&typeof h.onDidSelectItem=="function"&&(this._onDidSelectItem=U=>{h.onDidSelectItem(J[U])}),S.$setItems(f,j),d.then(U=>{if(typeof U=="number")return J[U];if(Array.isArray(U))return U.map($=>J[$])})})}).then(void 0,B=>{if(!(0,n.isPromiseCanceledError)(B))return S.$setError(f,B),Promise.reject(B)})}$onItemSelected(r){this._onDidSelectItem&&this._onDidSelectItem(r)}showInput(r,a=P.CancellationToken.None){return this._validateInput=r?r.validateInput:void 0,S.$input(r,typeof this._validateInput=="function",a).then(void 0,h=>{if(!(0,n.isPromiseCanceledError)(h))return Promise.reject(h)})}$validateInput(r){return this._validateInput?(0,E.asPromise)(()=>this._validateInput(r)):Promise.resolve(void 0)}async showWorkspaceFolderPick(r,a=P.CancellationToken.None){const h=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[r]);if(!!h){const m=await this._workspace.getWorkspaceFolders2();if(!!m)return m.find(b=>b.uri.toString()===h.uri.toString())}}createQuickPick(r,a){const h=new t(r,a,()=>this._sessions.delete(h._id));return this._sessions.set(h._id,h),h}createInputBox(r){const a=new i(r,()=>this._sessions.delete(a._id));return this._sessions.set(a._id,a),a}$onDidChangeValue(r,a){const h=this._sessions.get(r);h&&h._fireDidChangeValue(a)}$onDidAccept(r){const a=this._sessions.get(r);a&&a._fireDidAccept()}$onDidChangeActive(r,a){const h=this._sessions.get(r);h instanceof t&&h._fireDidChangeActive(a)}$onDidChangeSelection(r,a){const h=this._sessions.get(r);h instanceof t&&h._fireDidChangeSelection(a)}$onDidTriggerButton(r,a){const h=this._sessions.get(r);h&&h._fireDidTriggerButton(a)}$onDidHide(r){const a=this._sessions.get(r);a&&a._fireDidHide()}}class _{constructor(r,a){this._extensionId=r,this._onDidDispose=a,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new T.Emitter,this._onDidChangeValueEmitter=new T.Emitter,this._onDidTriggerButtonEmitter=new T.Emitter,this._onDidHideEmitter=new T.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(r){this._title=r,this.update({title:r})}get step(){return this._steps}set step(r){this._steps=r,this.update({step:r})}get totalSteps(){return this._totalSteps}set totalSteps(r){this._totalSteps=r,this.update({totalSteps:r})}get enabled(){return this._enabled}set enabled(r){this._enabled=r,this.update({enabled:r})}get busy(){return this._busy}set busy(r){this._busy=r,this.update({busy:r})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(r){this._ignoreFocusOut=r,this.update({ignoreFocusOut:r})}get value(){return this._value}set value(r){this._value=r,this.update({value:r})}get placeholder(){return this._placeholder}set placeholder(r){this._placeholder=r,this.update({placeholder:r})}get buttons(){return this._buttons}set buttons(r){this._buttons=r.slice(),this._handlesToButtons.clear(),r.forEach((a,h)=>{const m=a===y.QuickInputButtons.Back?-1:h;this._handlesToButtons.set(m,a)}),this.update({buttons:r.map((a,h)=>({iconPath:p(a.iconPath),tooltip:a.tooltip,handle:a===y.QuickInputButtons.Back?-1:h}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(r){this._value=r,this._onDidChangeValueEmitter.fire(r)}_fireDidTriggerButton(r){const a=this._handlesToButtons.get(r);a&&this._onDidTriggerButtonEmitter.fire(a)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,I.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),S.$dispose(this._id))}update(r){if(!this._disposed){for(const a of Object.keys(r)){const h=r[a];this._pendingUpdate[a]=h===void 0?null:h}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){S.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}_._nextId=1;function p(o){if(o instanceof y.ThemeIcon)return{id:o.id};const r=l(o),a=c(o);return{dark:typeof r=="string"?k.URI.file(r):r,light:typeof a=="string"?k.URI.file(a):a}}function c(o){return typeof o=="object"&&"light"in o?o.light:o}function l(o){return typeof o=="object"&&"dark"in o?o.dark:o}class t extends _{constructor(r,a,h){super(r,h);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new T.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new T.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(r){this._items=r.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),r.forEach((a,h)=>{this._handlesToItems.set(h,a),this._itemsToHandles.set(a,h)}),this.update({items:r.map((a,h)=>({label:a.label,description:a.description,handle:h,detail:a.detail,picked:a.picked,alwaysShow:a.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(r){this._canSelectMany=r,this.update({canSelectMany:r})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(r){this._matchOnDescription=r,this.update({matchOnDescription:r})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(r){this._matchOnDetail=r,this.update({matchOnDetail:r})}get sortByLabel(){return this._sortByLabel}set sortByLabel(r){this._sortByLabel=r,this.update({sortByLabel:r})}get activeItems(){return this._activeItems}set activeItems(r){this._activeItems=r.filter(a=>this._itemsToHandles.has(a)),this.update({activeItems:this._activeItems.map(a=>this._itemsToHandles.get(a))})}get selectedItems(){return this._selectedItems}set selectedItems(r){this._selectedItems=r.filter(a=>this._itemsToHandles.has(a)),this.update({selectedItems:this._selectedItems.map(a=>this._itemsToHandles.get(a))})}_fireDidChangeActive(r){const a=(0,R.coalesce)(r.map(h=>this._handlesToItems.get(h)));this._activeItems=a,this._onDidChangeActiveEmitter.fire(a)}_fireDidChangeSelection(r){const a=(0,R.coalesce)(r.map(h=>this._handlesToItems.get(h)));this._selectedItems=a,this._onDidChangeSelectionEmitter.fire(a)}}class i extends _{constructor(r,a){super(r,a);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(r){this._password=r,this.update({password:r})}get prompt(){return this._prompt}set prompt(r){this._prompt=r,this.update({prompt:r})}get validationMessage(){return this._validationMessage}set validationMessage(r){this._validationMessage=r,this.update({validationMessage:r,severity:r?C.default.Error:C.default.Ignore})}}return new v(s,u)}e.createExtHostQuickOpen=w}),define(ge[244],pe([0,1,2,3,68,6,19,5,14,95,12,29,41]),function(G,e,E,P,T,I,D,k,y,n,R,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function g(r){if(r)return typeof r.iconPath=="string"?E.URI.file(r.iconPath):r.iconPath}function s(r,a){if(!r.iconPath&&!a.iconPath)return 0;if(r.iconPath){if(!a.iconPath)return 1}else return-1;const h=typeof r.iconPath=="string"?r.iconPath:r.iconPath.fsPath,m=typeof a.iconPath=="string"?a.iconPath:a.iconPath.fsPath;return(0,n.comparePaths)(h,m)}function u(r,a){let h=0;if(r.strikeThrough!==a.strikeThrough)return r.strikeThrough?1:-1;if(r.faded!==a.faded)return r.faded?1:-1;if(r.tooltip!==a.tooltip)return(r.tooltip||"").localeCompare(a.tooltip||"");if(h=s(r,a),h!==0)return h;if(r.light&&a.light)h=s(r.light,a.light);else{if(r.light)return 1;if(a.light)return-1}if(h!==0)return h;if(r.dark&&a.dark)h=s(r.dark,a.dark);else{if(r.dark)return 1;if(a.dark)return-1}return h}function S(r,a){if(r.command!==a.command)return r.command<a.command?-1:1;if(r.title!==a.title)return r.title<a.title?-1:1;if(r.tooltip!==a.tooltip){if(r.tooltip!==void 0&&a.tooltip!==void 0)return r.tooltip<a.tooltip?-1:1;if(r.tooltip!==void 0)return 1;if(a.tooltip!==void 0)return-1}if(r.arguments===a.arguments)return 0;if(r.arguments)if(a.arguments){if(r.arguments.length!==a.arguments.length)return r.arguments.length-a.arguments.length}else return 1;else return-1;for(let h=0;h<r.arguments.length;h++){const m=r.arguments[h],b=a.arguments[h];if(m!==b)return m<b?-1:1}return 0}function v(r,a){let h=(0,n.comparePaths)(r.resourceUri.fsPath,a.resourceUri.fsPath,!0);if(h!==0)return h;if(r.command&&a.command)h=S(r.command,a.command);else{if(r.command)return 1;if(a.command)return-1}if(h!==0)return h;if(r.decorations&&a.decorations)h=u(r.decorations,a.decorations);else{if(r.decorations)return 1;if(a.decorations)return-1}return h}function _(r,a){for(let h=0;h<r.length;h++)if(r[h]!==a[h])return!1;return!0}function p(r,a){return r.command===a.command&&r.title===a.title&&r.tooltip===a.tooltip&&(r.arguments&&a.arguments?_(r.arguments,a.arguments):r.arguments===a.arguments)}function c(r,a){return(0,y.equals)(r,a,p)}class l{constructor(a,h,m){this._extension=a,this._proxy=h,this._sourceControlHandle=m,this._value="",this._onDidChange=new P.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(a){this._proxy.$setInputBoxValue(this._sourceControlHandle,a),this.updateValue(a)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(a){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,a),this._placeholder=a}get validateInput(){return(0,w.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(a){if((0,w.checkProposedApiEnabled)(this._extension),a&&typeof a!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=a,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!a)}get visible(){return this._visible}set visible(a){a=!!a,this._visible!==a&&(this._visible=a,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,a))}focus(){(0,w.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(a,h){(0,w.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,a,h)}$onInputBoxValueChange(a){this.updateValue(a)}updateValue(a){this._value=a,this._onDidChange.fire(a)}}e.ExtHostSCMInputBox=l;class t{constructor(a,h,m,b,f){this._proxy=a,this._commands=h,this._sourceControlHandle=m,this._id=b,this._label=f,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new P.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new P.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(a){this._label=a,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,a)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(a){this._hideWhenEmpty=a,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(a){this._resourceStates=[...a],this._onDidUpdateResourceStates.fire()}getResourceState(a){return this._resourceStatesMap.get(a)}$executeResourceCommand(a,h){const m=this._resourceStatesCommandsMap.get(a);return m?(0,D.asPromise)(()=>this._commands.executeCommand(m.command,...m.arguments||[],h)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var a;const h=[...this._resourceStates].sort(v),b=(0,y.sortedDiff)(this._resourceSnapshot,h,v).map(A=>{const L=A.toInsert.map(B=>{const J=this._resourceHandlePool++;this._resourceStatesMap.set(J,B);const j=B.resourceUri,U=g(B.decorations),$=B.decorations&&g(B.decorations.light)||U,F=B.decorations&&g(B.decorations.dark)||U,N=[];let M;if(B.command)if(B.command.command==="vscode.open"||B.command.command==="vscode.diff"){const me=new I.DisposableStore;M=this._commands.converter.toInternal(B.command,me),this._resourceStatesDisposablesMap.set(J,me)}else this._resourceStatesCommandsMap.set(J,B.command);$&&N.push($),F&&F.toString()!==($==null?void 0:$.toString())&&N.push(F);const x=B.decorations&&B.decorations.tooltip||"",O=B.decorations&&!!B.decorations.strikeThrough,V=B.decorations&&!!B.decorations.faded,q=B.contextValue||"";return{rawResource:[J,j,N,x,O,V,q,M],handle:J}});return{start:A.start,deleteCount:A.deleteCount,toInsert:L}}),f=b.map(({start:A,deleteCount:L,toInsert:B})=>[A,L,B.map(J=>J.rawResource)]),d=b.reverse();for(const{start:A,deleteCount:L,toInsert:B}of d){const J=B.map(U=>U.handle),j=this._handlesSnapshot.splice(A,L,...J);for(const U of j)this._resourceStatesMap.delete(U),this._resourceStatesCommandsMap.delete(U),(a=this._resourceStatesDisposablesMap.get(U))===null||a===void 0||a.dispose(),this._resourceStatesDisposablesMap.delete(U)}return this._resourceSnapshot=h,f}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class i{constructor(a,h,m,b,f,d){this._proxy=h,this._commands=m,this._id=b,this._label=f,this._rootUri=d,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new I.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new I.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new P.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=i._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new l(a,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,b,f,d)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(a){this._count!==a&&(this._count=a,this._proxy.$updateSourceControl(this.handle,{count:a}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(a){this._quickDiffProvider=a,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!a})}get commitTemplate(){return this._commitTemplate}set commitTemplate(a){a!==this._commitTemplate&&(this._commitTemplate=a,this._proxy.$updateSourceControl(this.handle,{commitTemplate:a}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(a){this._acceptInputDisposables.value=new I.DisposableStore,this._acceptInputCommand=a;const h=this._commands.converter.toInternal(a,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:h})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(a){if(!(this._statusBarCommands&&a&&c(this._statusBarCommands,a))){this._statusBarDisposables.value=new I.DisposableStore,this._statusBarCommands=a;const h=(a||[]).map(m=>this._commands.converter.toInternal(m,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:h})}}get selected(){return this._selected}createResourceGroup(a,h){const m=new t(this._proxy,this._commands,this.handle,a,h),b=P.Event.once(m.onDidDispose)(()=>this.createdResourceGroups.delete(m));return this.createdResourceGroups.set(m,b),this.eventuallyAddResourceGroups(),m}eventuallyAddResourceGroups(){const a=[],h=[];for(const[m,b]of this.createdResourceGroups){b.dispose();const f=m.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(m),this.eventuallyUpdateResourceStates()});P.Event.once(m.onDidDispose)(()=>{this.updatedResourceGroups.delete(m),f.dispose(),this._groups.delete(m.handle),this._proxy.$unregisterGroup(this.handle,m.handle)}),a.push([m.handle,m.id,m.label,m.features]);const d=m._takeResourceStateSnapshot();d.length>0&&h.push([m.handle,d]),this._groups.set(m.handle,m)}this._proxy.$registerGroups(this.handle,a,h),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const a=[];this.updatedResourceGroups.forEach(h=>{const m=h._takeResourceStateSnapshot();m.length!==0&&a.push([h.handle,m])}),a.length>0&&this._proxy.$spliceResourceStates(this.handle,a),this.updatedResourceGroups.clear()}getResourceGroup(a){return this._groups.get(a)}setSelectionState(a){this._selected=a,this._onDidChangeSelection.fire(a)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(a=>a.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}i._handlePool=0,je([(0,T.debounce)(100)],i.prototype,"eventuallyAddResourceGroups",null),je([(0,T.debounce)(100)],i.prototype,"eventuallyUpdateResourceStates",null);let o=class Ln{constructor(a,h,m){this._commands=h,this.logService=m,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new P.Emitter,this._proxy=a.getProxy(k.MainContext.MainThreadSCM),this._telemetry=a.getProxy(k.MainContext.MainThreadTelemetry),h.registerArgumentProcessor({processArgument:b=>{if(b&&b.$mid===3){const f=this._sourceControls.get(b.sourceControlHandle);if(!f)return b;const d=f.getResourceGroup(b.groupHandle);return d?d.getResourceState(b.handle):b}else if(b&&b.$mid===4){const f=this._sourceControls.get(b.sourceControlHandle);return f?f.getResourceGroup(b.groupHandle):b}else if(b&&b.$mid===5){const f=this._sourceControls.get(b.handle);return f||b}return b}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(a,h,m,b){this.logService.trace("ExtHostSCM#createSourceControl",a.identifier.value,h,m,b),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:a.identifier.value});const f=Ln._handlePool++,d=new i(a,this._proxy,this._commands,h,m,b);this._sourceControls.set(f,d);const A=this._sourceControlsByExtension.get(C.ExtensionIdentifier.toKey(a.identifier))||[];return A.push(d),this._sourceControlsByExtension.set(C.ExtensionIdentifier.toKey(a.identifier),A),d}getLastInputBox(a){this.logService.trace("ExtHostSCM#getLastInputBox",a.identifier.value);const h=this._sourceControlsByExtension.get(C.ExtensionIdentifier.toKey(a.identifier)),m=h&&h[h.length-1];return m&&m.inputBox}$provideOriginalResource(a,h,m){const b=E.URI.revive(h);this.logService.trace("ExtHostSCM#$provideOriginalResource",a,b.toString());const f=this._sourceControls.get(a);return!f||!f.quickDiffProvider||!f.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,D.asPromise)(()=>f.quickDiffProvider.provideOriginalResource(b,m)).then(d=>d||null)}$onInputBoxValueChange(a,h){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",a);const m=this._sourceControls.get(a);return m&&m.inputBox.$onInputBoxValueChange(h),Promise.resolve(void 0)}$executeResourceCommand(a,h,m,b){this.logService.trace("ExtHostSCM#$executeResourceCommand",a,h,m);const f=this._sourceControls.get(a);if(!f)return Promise.resolve(void 0);const d=f.getResourceGroup(h);return d?d.$executeResourceCommand(m,b):Promise.resolve(void 0)}$validateInput(a,h,m){this.logService.trace("ExtHostSCM#$validateInput",a);const b=this._sourceControls.get(a);return!b||!b.inputBox.validateInput?Promise.resolve(void 0):(0,D.asPromise)(()=>b.inputBox.validateInput(h,m)).then(f=>f?Promise.resolve([f.message,f.type]):Promise.resolve(void 0))}$setSelectedSourceControl(a){var h,m;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",a),a!==void 0&&((h=this._sourceControls.get(a))===null||h===void 0||h.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((m=this._sourceControls.get(this._selectedSourceControlHandle))===null||m===void 0||m.setSelectionState(!1)),this._selectedSourceControlHandle=a,Promise.resolve(void 0)}};o._handlePool=0,o=je([Ue(2,R.ILogService)],o),e.ExtHostSCM=o});var tt=this&&this.__classPrivateFieldSet||function(G,e,E,P,T){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!T:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?T.call(G,E):T?T.value=E:e.set(G,E),E},He=this&&this.__classPrivateFieldGet||function(G,e,E,P){if(E==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!P:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?P:E==="a"?P.call(G):P?P.value:e.get(G)};define(ge[245],pe([0,1,7,5,163,6]),function(G,e,E,P,T,I){"use strict";var D,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class y{constructor(w,g,s,u,S=E.StatusBarAlignment.Left,v,_){D.set(this,void 0),k.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new I.DisposableStore,tt(this,D,w,"f"),tt(this,k,g,"f"),this._id=y.ID_GEN++,this._statusId=s,this._statusName=u,this._alignment=S,this._priority=v,this._accessibilityInformation=_}get id(){return this._id}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var w;return(w=this._command)===null||w===void 0?void 0:w.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(w){this._text=w,this.update()}set tooltip(w){this._tooltip=w,this.update()}set color(w){this._color=w,this.update()}set backgroundColor(w){w&&!y.ALLOWED_BACKGROUND_COLORS.has(w.id)&&(w=void 0),this._backgroundColor=w,this.update()}set command(w){var g;((g=this._command)===null||g===void 0?void 0:g.fromApi)!==w&&(this._internalCommandRegistration.clear(),typeof w=="string"?this._command={fromApi:w,internal:He(this,k,"f").toInternal({title:"",command:w},this._internalCommandRegistration)}:w?this._command={fromApi:w,internal:He(this,k,"f").toInternal(w,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(w){this._accessibilityInformation=w,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,He(this,D,"f").$dispose(this.id)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var w;this._timeoutHandle=void 0;let g=this._color;this._backgroundColor&&(g=y.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),He(this,D,"f").$setEntry(this.id,this._statusId,this._statusName,this._text,this._tooltip,(w=this._command)===null||w===void 0?void 0:w.internal,g,this._backgroundColor,this._alignment===E.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=y,D=new WeakMap,k=new WeakMap,y.ID_GEN=0,y.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new E.ThemeColor("statusBarItem.errorForeground")]]);class n{constructor(w){this._messages=[],this._item=w.createStatusBarEntry("status.extensionMessage",(0,T.localize)(0,null),E.StatusBarAlignment.Left,Number.MIN_VALUE)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(w){const g={message:w};return this._messages.unshift(g),this._update(),new E.Disposable(()=>{const s=this._messages.indexOf(g);s>=0&&(this._messages.splice(s,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class R{constructor(w,g){this._proxy=w.getProxy(P.MainContext.MainThreadStatusBar),this._commands=g,this._statusMessage=new n(this)}createStatusBarEntry(w,g,s,u,S){return new y(this._proxy,this._commands,w,g,s,u,S)}setStatusBarMessage(w,g){const s=this._statusMessage.setMessage(w);let u;return typeof g=="number"?u=setTimeout(()=>s.dispose(),g):typeof g!="undefined"&&g.then(()=>s.dispose(),()=>s.dispose()),new E.Disposable(()=>{s.dispose(),clearTimeout(u)})}}e.ExtHostStatusBar=R}),define(ge[88],pe([0,1,5,3,4]),function(G,e,E,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class I{constructor(k){this._onDidChangeStorage=new P.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=k.getProxy(E.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(k,y){this._proxy.$registerExtensionStorageKeysToSync(k,y)}getValue(k,y,n){return this._proxy.$getValue(k,y).then(R=>R||n)}setValue(k,y,n){return this._proxy.$setValue(k,y,n)}$acceptValue(k,y,n){this._onDidChangeStorage.fire({shared:k,key:y,value:n})}}e.ExtHostStorage=I,e.IExtHostStorage=(0,T.createDecorator)("IExtHostStorage")}),define(ge[89],pe([0,1,4,27,12,87,2]),function(G,e,E,P,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,E.createDecorator)("IExtensionStoragePaths");let k=class{constructor(n,R,C){var w;this._logService=R,this._extHostFileSystem=C,this._workspace=(w=n.workspace)!==null&&w!==void 0?w:void 0,this._environment=n.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(g=>this._value=g)}async _getOrCreateWorkspaceStoragePath(){var n;if(!this._workspace)return Promise.resolve(void 0);const R=this._workspace.id,C=D.URI.joinPath(this._environment.workspaceStorageHome,R);try{return await this._extHostFileSystem.value.stat(C),this._logService.trace("[ExtHostStorage] storage dir already exists",C),C}catch(w){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",C),await this._extHostFileSystem.value.createDirectory(C),await this._extHostFileSystem.value.writeFile(D.URI.joinPath(C,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(n=D.URI.revive(this._workspace.configuration))===null||n===void 0?void 0:n.toString(),name:this._workspace.name},void 0,2))),C}catch(w){this._logService.error("[ExtHostStorage]",w);return}}workspaceValue(n){if(this._value)return D.URI.joinPath(this._value,n.identifier.value)}globalValue(n){return D.URI.joinPath(this._environment.globalStorageHome,n.identifier.value.toLowerCase())}};k=je([Ue(0,P.IExtHostInitDataService),Ue(1,T.ILogService),Ue(2,I.IExtHostConsumerFileSystem)],k),e.ExtensionStoragePaths=k}),define(ge[34],pe([0,1,3,5,4,2,13,6,7,164,18,209,21,28,189]),function(G,e,E,P,T,I,D,k,y,n,R,C,w,g,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,T.createDecorator)("IExtHostTerminalService");class u{constructor(t,i,o,r){this._proxy=t,this._id=i,this._creationOptions=o,this._name=r,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(h=>this._pidPromiseComplete=h);const a=this;this.value={get name(){return a._name||""},get processId(){return a._pidPromise},get creationOptions(){return a._creationOptions},get exitStatus(){return a._exitStatus},sendText(h,m=!0){a._checkDisposed(),a._proxy.$sendText(a._id,h,m)},show(h){a._checkDisposed(),a._proxy.$show(a._id,h)},hide(){a._checkDisposed(),a._proxy.$hide(a._id)},dispose(){a._disposed||(a._disposed=!0,a._proxy.$dispose(a._id))},get dimensions(){if(!(a._cols===void 0||a._rows===void 0))return{columns:a._cols,rows:a._rows}}}}async create(t,i,o,r,a,h,m,b,f,d,A){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:this._name,shellPath:t,shellArgs:i,cwd:o,env:r,icon:a,initialText:h,waitOnExit:m,strictEnv:b,hideFromUser:f,isFeatureTerminal:d,isExtensionOwnedTerminal:A})}async createExtensionTerminal(){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,i){return t===this._cols&&i===this._rows||t===0||i===0?!1:(this._cols=t,this._rows=i,!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(i=>{i!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=u;class S{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new E.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new E.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new E.Emitter,this._onProcessTitleChanged=new E.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new E.Emitter,this._onProcessShellTypeChanged=new E.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput&&this._pty.handleInput(t)}resize(t,i){this._pty.setDimensions&&this._pty.setDimensions({columns:t,rows:i})}async processBinary(t){}acknowledgeDataEvent(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(i=>this._onProcessData.fire(i)),this._pty.onDidClose&&this._pty.onDidClose((i=void 0)=>{this._onProcessExit.fire(i===void 0?void 0:i)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(i=>this._onProcessOverrideDimensions.fire(i&&{cols:i.columns,rows:i.rows})),this._pty.open(t||void 0),this._pty.setDimensions&&t&&this._pty.setDimensions(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=S;let v=1,_=class extends k.Disposable{constructor(t,i){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new E.Emitter,this._onDidOpenTerminal=new E.Emitter,this._onDidChangeActiveTerminal=new E.Emitter,this._onDidChangeTerminalDimensions=new E.Emitter,this._proxy=i.getProxy(P.MainContext.MainThreadTerminalService),this._bufferer=new s.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new E.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[o,r]of this._terminalProcesses)r.shutdown(!0)}})}get activeTerminal(){var t;return(t=this._activeTerminal)===null||t===void 0?void 0:t.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}createExtensionTerminal(t){const i=new u(this._proxy,(0,g.generateUuid)(),t,t.name),o=new S(t.pty);return i.createExtensionTerminal().then(r=>{const a=this._setupExtHostProcessListeners(r,o);this._terminalProcessDisposables[r]=a}),this._terminals.push(i),i.value}attachPtyToTerminal(t,i){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const r=new S(i),a=this._setupExtHostProcessListeners(t,r);this._terminalProcessDisposables[t]=a}async $acceptActiveTerminalChanged(t){const i=this._activeTerminal;if(t===null){this._activeTerminal=void 0,i!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const o=this._getTerminalById(t);o&&(this._activeTerminal=o,i!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,i){const o=this._getTerminalById(t);o&&this._onDidWriteTerminalData.fire({terminal:o.value,data:i})}async $acceptTerminalDimensions(t,i,o){const r=this._getTerminalById(t);r&&r.setDimensions(i,o)&&this._onDidChangeTerminalDimensions.fire({terminal:r.value,dimensions:r.value.dimensions})}async $acceptTerminalMaximumDimensions(t,i,o){var r;(r=this._terminalProcesses.get(t))===null||r===void 0||r.resize(i,o)}async $acceptTerminalTitleChange(t,i){const o=this._getTerminalById(t);o&&(o.name=i)}async $acceptTerminalClosed(t,i){const o=this._getTerminalObjectIndexById(this._terminals,t);if(o!==null){const r=this._terminals.splice(o,1)[0];r.setExitCode(i),this._onDidCloseTerminal.fire(r.value)}}$acceptTerminalOpened(t,i,o,r){if(i){const m=this._getTerminalObjectIndexById(this._terminals,i);if(m!==null){this._terminals[m]._id=t,this._onDidOpenTerminal.fire(this.terminals[m]),this._terminals[m].isOpen=!0;return}}const a={name:r.name,shellPath:r.executable,shellArgs:r.args,cwd:typeof r.cwd=="string"?r.cwd:I.URI.revive(r.cwd),env:r.env,hideFromUser:r.hideFromUser},h=new u(this._proxy,t,a,o);this._terminals.push(h),this._onDidOpenTerminal.fire(h.value),h.isOpen=!0}async $acceptTerminalProcessId(t,i){const o=this._getTerminalById(t);o&&o._setProcessId(i)}async $startExtensionTerminal(t,i){const o=this._getTerminalById(t);if(!o)return{message:(0,n.localize)(0,null,t)};o.isOpen||await new Promise(a=>{const h=this.onDidOpenTerminal(async m=>{m===o.value&&(h.dispose(),a())})});const r=this._terminalProcesses.get(t);r?r.startSendingEvents(i):this._extensionTerminalAwaitingStart[t]={initialDimensions:i}}_setupExtHostProcessListeners(t,i){const o=new k.DisposableStore;o.add(i.onProcessReady(a=>this._proxy.$sendProcessReady(t,a.pid,a.cwd))),o.add(i.onProcessTitleChanged(a=>this._proxy.$sendProcessTitle(t,a))),this._bufferer.startBuffering(t,i.onProcessData),o.add(i.onProcessExit(a=>this._onProcessExit(t,a))),i.onProcessOverrideDimensions&&o.add(i.onProcessOverrideDimensions(a=>this._proxy.$sendOverrideDimensions(t,a))),this._terminalProcesses.set(t,i);const r=this._extensionTerminalAwaitingStart[t];return r&&i instanceof S&&(i.startSendingEvents(r.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),o}$acceptProcessAckDataEvent(t,i){var o;(o=this._terminalProcesses.get(t))===null||o===void 0||o.acknowledgeDataEvent(i)}$acceptProcessInput(t,i){var o;(o=this._terminalProcesses.get(t))===null||o===void 0||o.input(i)}$acceptProcessResize(t,i,o){var r;try{(r=this._terminalProcesses.get(t))===null||r===void 0||r.resize(i,o)}catch(a){if(a.code!=="EPIPE"&&a.code!=="ERR_IPC_CHANNEL_CLOSED")throw a}}$acceptProcessShutdown(t,i){var o;(o=this._terminalProcesses.get(t))===null||o===void 0||o.shutdown(i)}$acceptProcessRequestInitialCwd(t){var i;(i=this._terminalProcesses.get(t))===null||i===void 0||i.getInitialCwd().then(o=>this._proxy.$sendProcessInitialCwd(t,o))}$acceptProcessRequestCwd(t){var i;(i=this._terminalProcesses.get(t))===null||i===void 0||i.getCwd().then(o=>this._proxy.$sendProcessCwd(t,o))}$acceptProcessRequestLatency(t){return t}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new y.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}async $provideLinks(t,i){const o=this._getTerminalById(t);if(!o)return[];this._terminalLinkCache.delete(t);const r=this._terminalLinkCancellationSource.get(t);r&&r.dispose(!0);const a=new w.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,a);const h=[],m={terminal:o.value,line:i},b=[];for(const A of this._linkProviders)b.push(new Promise(async L=>{a.token.onCancellationRequested(()=>L({provider:A,links:[]}));const B=await A.provideTerminalLinks(m,a.token)||[];a.token.isCancellationRequested||L({provider:A,links:B})}));const f=await Promise.all(b);if(a.token.isCancellationRequested)return[];const d=new Map;for(const A of f)A&&A.links.length>0&&h.push(...A.links.map(L=>{const B={id:v++,startIndex:L.startIndex,length:L.length,label:L.tooltip};return d.set(B.id,{provider:A.provider,link:L}),B}));return this._terminalLinkCache.set(t,d),h}$activateLink(t,i){var o;const r=(o=this._terminalLinkCache.get(t))===null||o===void 0?void 0:o.get(i);!r||r.provider.handleTerminalLink(r.link)}_onProcessExit(t,i){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const o=this._terminalProcessDisposables[t];o&&(o.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,i)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,i){const o=this._getTerminalObjectIndexById(t,i);return o!==null?t[o]:null}_getTerminalObjectIndexById(t,i){let o=null;return t.some((r,a)=>r._id===i?(o=a,!0):!1),o}getEnvironmentVariableCollection(t){let i=this._environmentVariableCollections.get(t.identifier.value);return i||(i=new p,this._setEnvironmentVariableCollection(t.identifier.value,i)),i}_syncEnvironmentVariableCollection(t,i){const o=(0,C.serializeEnvironmentVariableCollection)(i.map);this._proxy.$setEnvironmentVariableCollection(t,i.persistent,o.length===0?void 0:o)}$initEnvironmentVariableCollections(t){t.forEach(i=>{const o=i[0],r=new p(i[1]);this._setEnvironmentVariableCollection(o,r)})}_setEnvironmentVariableCollection(t,i){this._environmentVariableCollections.set(t,i),i.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,i)})}};_=je([Ue(1,D.IExtHostRpcService)],_),e.BaseExtHostTerminalService=_;class p{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new E.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,i){this._setIfDiffers(t,{value:i,type:y.EnvironmentVariableMutatorType.Replace})}append(t,i){this._setIfDiffers(t,{value:i,type:y.EnvironmentVariableMutatorType.Append})}prepend(t,i){this._setIfDiffers(t,{value:i,type:y.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,i){const o=this.map.get(t);(!o||o.value!==i.value||o.type!==i.type)&&(this.map.set(t,i),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,i){this.map.forEach((o,r)=>t.call(i,r,o,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=p;let c=class extends _{constructor(t){super(!1,t)}createTerminal(t,i,o){throw new R.NotSupportedError}createTerminalFromOptions(t){throw new R.NotSupportedError}getDefaultShell(t,i){throw new R.NotSupportedError}getDefaultShellArgs(t,i){throw new R.NotSupportedError}$getAvailableProfiles(t){throw new R.NotSupportedError}async $getDefaultShellAndArgs(t){throw new R.NotSupportedError}$acceptWorkspacePermissionsChanged(t){throw new R.NotSupportedError}};c=je([Ue(0,D.IExtHostRpcService)],c),e.WorkerExtHostTerminalService=c}),define(ge[246],pe([0,1,3,14,5,122,20,7]),function(G,e,E,P,T,I,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(R,C){this._extHostDocumentsAndEditors=C,this._onDidChangeTextEditorSelection=new E.Emitter,this._onDidChangeTextEditorOptions=new E.Emitter,this._onDidChangeTextEditorVisibleRanges=new E.Emitter,this._onDidChangeTextEditorViewColumn=new E.Emitter,this._onDidChangeActiveTextEditor=new E.Emitter,this._onDidChangeVisibleTextEditors=new E.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=R.getProxy(T.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(w=>this._onDidChangeVisibleTextEditors.fire(w)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(w=>this._onDidChangeActiveTextEditor.fire(w))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(R){const C=this._extHostDocumentsAndEditors.allEditors();return R?C:C.map(w=>w.value)}async showTextDocument(R,C,w){let g;typeof C=="number"?g={position:D.ViewColumn.from(C),preserveFocus:w}:typeof C=="object"?g={position:D.ViewColumn.from(C.viewColumn),preserveFocus:C.preserveFocus,selection:typeof C.selection=="object"?D.Range.from(C.selection):void 0,pinned:typeof C.preview=="boolean"?!C.preview:void 0}:g={preserveFocus:!1};const s=await this._proxy.$tryShowTextDocument(R.uri,g),u=s&&this._extHostDocumentsAndEditors.getEditor(s);if(u)return u.value;throw s?new Error(`Could NOT open editor for "${R.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${R.uri.toString()}".`)}createTextEditorDecorationType(R){return new I.TextEditorDecorationType(this._proxy,R).value}$acceptEditorPropertiesChanged(R,C){const w=this._extHostDocumentsAndEditors.getEditor(R);if(!w)throw new Error("unknown text editor");if(C.options&&w._acceptOptions(C.options),C.selections){const g=C.selections.selections.map(D.Selection.to);w._acceptSelections(g)}if(C.visibleRanges){const g=P.coalesce(C.visibleRanges.map(D.Range.to));w._acceptVisibleRanges(g)}if(C.options&&this._onDidChangeTextEditorOptions.fire({textEditor:w.value,options:Object.assign(Object.assign({},C.options),{lineNumbers:D.TextEditorLineNumbersStyle.to(C.options.lineNumbers)})}),C.selections){const g=k.TextEditorSelectionChangeKind.fromValue(C.selections.source),s=C.selections.selections.map(D.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:w.value,selections:s,kind:g})}if(C.visibleRanges){const g=P.coalesce(C.visibleRanges.map(D.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:w.value,visibleRanges:g})}}$acceptEditorPositionData(R){for(const C in R){const w=this._extHostDocumentsAndEditors.getEditor(C);if(!w)throw new Error("Unknown text editor");const g=D.ViewColumn.to(R[C]);w.value.viewColumn!==g&&(w._acceptViewColumn(g),this._onDidChangeTextEditorViewColumn.fire({textEditor:w.value,viewColumn:g}))}}getDiffInformation(R){return Promise.resolve(this._proxy.$getDiffInformation(R))}}e.ExtHostEditors=y});var fn=this&&this.__rest||function(G,e){var E={};for(var P in G)Object.prototype.hasOwnProperty.call(G,P)&&e.indexOf(P)<0&&(E[P]=G[P]);if(G!=null&&typeof Object.getOwnPropertySymbols=="function")for(var T=0,P=Object.getOwnPropertySymbols(G);T<P.length;T++)e.indexOf(P[T])<0&&Object.prototype.propertyIsEnumerable.call(G,P[T])&&(E[P[T]]=G[P[T]]);return E};define(ge[247],pe([0,1,2,4,5,6,7]),function(G,e,E,P,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,P.createDecorator)("IExtHostTimeline");class k{constructor(R,C){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=R.getProxy(T.MainContext.MainThreadTimeline),C.registerArgumentProcessor({processArgument:w=>{var g,s;if(w&&w.$mid===11){const u=w.uri===void 0?void 0:E.URI.revive(w.uri);return(s=(g=this._itemsBySourceAndUriMap.get(w.source))===null||g===void 0?void 0:g.get(y(u)))===null||s===void 0?void 0:s.get(w.handle)}return w}})}async $getTimeline(R,C,w,g,s){const u=this._providers.get(R);return u==null?void 0:u.provideTimeline(E.URI.revive(C),w,g,s)}registerTimelineProvider(R,C,w,g){const s=new I.DisposableStore,u=this.convertTimelineItem(C.id,g,s).bind(this);let S;C.onDidChange&&(S=C.onDidChange(_=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},_),{id:C.id})),this));const v=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},C),{scheme:R,onDidChange:void 0,async provideTimeline(_,p,c,l){var t;(l==null?void 0:l.resetCache)&&(s.clear(),(t=v.get(C.id))===null||t===void 0||t.clear());const i=await C.provideTimeline(_,p,c);if(i!=null){const o=u(_,l);return Object.assign(Object.assign({},i),{source:C.id,items:i.items.map(o)})}},dispose(){var _;for(const p of v.values())(_=p.get(C.id))===null||_===void 0||_.clear();S==null||S.dispose(),s.dispose()}}))}convertTimelineItem(R,C,w){return(g,s)=>{let u;if(s==null?void 0:s.cacheResults){let S=this._itemsBySourceAndUriMap.get(R);S===void 0&&(S=new Map,this._itemsBySourceAndUriMap.set(R,S));const v=y(g);u=S.get(v),u===void 0&&(u=new Map,S.set(v,u))}return S=>{var v,_;const{iconPath:p}=S,c=fn(S,["iconPath"]),l=`${R}|${(v=S.id)!==null&&v!==void 0?v:S.timestamp}`;u==null||u.set(l,S);let t,i,o;return S.iconPath&&(p instanceof D.ThemeIcon?o={id:p.id}:E.URI.isUri(p)?(t=p,i=p):{light:t,dark:i}=p),Object.assign(Object.assign({},c),{id:(_=c.id)!==null&&_!==void 0?_:void 0,handle:l,source:R,command:S.command?C.toInternal(S.command,w):void 0,icon:t,iconDark:i,themeIcon:o,accessibilityInformation:S.accessibilityInformation})}}}registerTimelineProviderCore(R){if(this._providers.get(R.id))throw new Error(`Timeline Provider ${R.id} already exists.`);return this._proxy.$registerTimelineProvider({id:R.id,label:R.label,scheme:R.scheme}),this._providers.set(R.id,R),(0,I.toDisposable)(()=>{var w;for(const g of this._itemsBySourceAndUriMap.values())(w=g.get(R.id))===null||w===void 0||w.clear();this._providers.delete(R.id),this._proxy.$unregisterTimelineProvider(R.id),R.dispose()})}}e.ExtHostTimeline=k;function y(n){return n==null?void 0:n.toString()}}),define(ge[248],pe([0,1,6,11,2,5]),function(G,e,E,P,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class D{constructor(y){this._openers=new Map,this._proxy=y.getProxy(I.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,n,R,C){if(this._openers.has(n))throw new Error(`Opener with id '${n}' already registered`);const w=C.schemes.find(g=>!D.supportedSchemes.has(g));if(w)throw new Error(`Scheme '${w}' is not supported. Only http and https are currently supported.`);return this._openers.set(n,R),this._proxy.$registerUriOpener(n,C.schemes,y,C.label),(0,E.toDisposable)(()=>{this._openers.delete(n),this._proxy.$unregisterUriOpener(n)})}async $canOpenUri(y,n,R){const C=this._openers.get(y);if(!C)throw new Error(`Unknown opener with id: ${y}`);const w=T.URI.revive(n);return C.canOpenExternalUri(w,R)}async $openUri(y,n,R){const C=this._openers.get(y);if(!C)throw new Error(`Unknown opener id: '${y}'`);return C.openExternalUri(T.URI.revive(n.resolvedUri),{sourceUri:T.URI.revive(n.sourceUri)},R)}}e.ExtHostUriOpeners=D,D.supportedSchemes=new Set([P.Schemas.http,P.Schemas.https])}),define(ge[249],pe([0,1,5,2,6,18,29]),function(G,e,E,P,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class k{constructor(n){this.handles=new Set,this.handlers=new Map,this._proxy=n.getProxy(E.MainContext.MainThreadUrls)}registerUriHandler(n,R){if(this.handles.has(D.ExtensionIdentifier.toKey(n)))throw new Error(`Protocol handler already registered for extension ${n}`);const C=k.HandlePool++;return this.handles.add(D.ExtensionIdentifier.toKey(n)),this.handlers.set(C,R),this._proxy.$registerUriHandler(C,n),(0,T.toDisposable)(()=>{this.handles.delete(D.ExtensionIdentifier.toKey(n)),this.handlers.delete(C),this._proxy.$unregisterUriHandler(C)})}$handleExternalUri(n,R){const C=this.handlers.get(n);if(!C)return Promise.resolve(void 0);try{C.handleUri(P.URI.revive(R))}catch(w){(0,I.onUnexpectedError)(w)}return Promise.resolve(void 0)}async createAppUri(n){return P.URI.revive(await this._proxy.$createAppUri(n))}}e.ExtHostUrls=k,k.HandlePool=0});var tt=this&&this.__classPrivateFieldSet||function(G,e,E,P,T){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!T:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?T.call(G,E):T?T.value=E:e.set(G,E),E},He=this&&this.__classPrivateFieldGet||function(G,e,E,P){if(E==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!P:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?P:E==="a"?P.call(G):P?P.value:e.get(G)};define(ge[64],pe([0,1,22,3,2,176,199,84,5]),function(G,e,E,P,T,I,D,k,y){"use strict";var n,R,C,w,g,s,u,S,v,_,p,c;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.serializeMessage=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class l{constructor(f,d,A,L,B,J,j){n.set(this,void 0),R.set(this,void 0),C.set(this,void 0),w.set(this,void 0),g.set(this,void 0),s.set(this,void 0),u.set(this,""),S.set(this,void 0),v.set(this,!1),_.set(this,!1),p.set(this,!1),this._onMessageEmitter=new P.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,c.set(this,new P.Emitter),this._onDidDispose=He(this,c,"f").event,tt(this,n,f,"f"),tt(this,R,d,"f"),tt(this,S,A,"f"),tt(this,w,L,"f"),tt(this,g,B,"f"),tt(this,s,J,"f"),tt(this,p,t(J),"f"),tt(this,C,j,"f")}dispose(){tt(this,v,!0,"f"),He(this,c,"f").fire(),He(this,c,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(f){return tt(this,_,!0,"f"),(0,k.asWebviewUri)(He(this,w,"f"),He(this,n,"f"),f)}get cspSource(){return He(this,w,"f").webviewCspSource.replace("{{uuid}}",He(this,n,"f"))}get html(){return this.assertNotDisposed(),He(this,u,"f")}set html(f){this.assertNotDisposed(),He(this,u,"f")!==f&&(tt(this,u,f,"f"),!He(this,_,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(f)&&(tt(this,_,!0,"f"),He(this,C,"f").report("Webview vscode-resource: uris",He(this,s,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),He(this,R,"f").$setHtml(He(this,n,"f"),f))}get options(){return this.assertNotDisposed(),He(this,S,"f")}set options(f){this.assertNotDisposed(),He(this,R,"f").$setOptions(He(this,n,"f"),a(He(this,s,"f"),He(this,g,"f"),f)),tt(this,S,f,"f")}async postMessage(f){if(He(this,v,"f"))return!1;const d=i(f,{serializeBuffersForPostMessage:He(this,p,"f")});return He(this,R,"f").$postMessage(He(this,n,"f"),d.message,...d.buffers)}assertNotDisposed(){if(He(this,v,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=l,n=new WeakMap,R=new WeakMap,C=new WeakMap,w=new WeakMap,g=new WeakMap,s=new WeakMap,u=new WeakMap,S=new WeakMap,v=new WeakMap,_=new WeakMap,p=new WeakMap,c=new WeakMap;function t(b){if(!b.enableProposedApi)return!1;try{const f=(0,I.normalizeVersion)((0,I.parseVersion)(b.engines.vscode));return!!f&&f.majorBase>=1&&f.minorBase>=56}catch(f){return!1}}e.shouldSerializeBuffersForPostMessage=t;function i(b,f){if(f.serializeBuffersForPostMessage){const d=[],A=(B,J)=>{if(J&&J instanceof ArrayBuffer){let j=d.findIndex(U=>U.original===J);if(j===-1){const U=new Uint8Array(J),$=E.VSBuffer.wrap(U);j=d.length,d.push({original:J,vsBuffer:$})}return{$$vscode_array_buffer_reference$$:!0,index:j}}return J};return{message:JSON.stringify(b,A),buffers:d.map(B=>B.vsBuffer)}}else return{message:JSON.stringify(b),buffers:[]}}e.serializeMessage=i;class o{constructor(f,d,A,L,B){this.initData=d,this.workspace=A,this._logService=L,this._deprecationService=B,this._webviews=new Map,this._webviewProxy=f.getProxy(y.MainContext.MainThreadWebviews)}$onMessage(f,d,...A){const L=this.getWebview(f);if(L){const{message:B}=(0,D.deserializeWebviewMessage)(d,A);L._onMessageEmitter.fire(B)}}$onMissingCsp(f,d){this._logService.warn(`${d} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(f,d,A){const L=new l(f,this._webviewProxy,h(d),this.initData,this.workspace,A,this._deprecationService);return this._webviews.set(f,L),L._onDidDispose(()=>{this._webviews.delete(f)}),L}deleteWebview(f){this._webviews.delete(f)}getWebview(f){return this._webviews.get(f)}}e.ExtHostWebviews=o;function r(b){return{id:b.identifier,location:b.extensionLocation}}e.toExtensionData=r;function a(b,f,d){return{enableCommandUris:d.enableCommandUris,enableScripts:d.enableScripts,portMapping:d.portMapping,localResourceRoots:d.localResourceRoots||m(b,f)}}e.serializeWebviewOptions=a;function h(b){var f;return{enableCommandUris:b.enableCommandUris,enableScripts:b.enableScripts,portMapping:b.portMapping,localResourceRoots:(f=b.localResourceRoots)===null||f===void 0?void 0:f.map(d=>T.URI.from(d))}}e.reviveOptions=h;function m(b,f){return[...((f==null?void 0:f.getWorkspaceFolders())||[]).map(d=>d.uri),b.extensionLocation]}}),define(ge[250],pe([0,1,21,73,6,11,25,2,20,64,116,5,7]),function(G,e,E,P,T,I,D,k,y,n,R,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class g{constructor(t,i){this.document=t,this._storagePath=i,this._backupCounter=1,this._edits=new R.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,i){await this.getEdit(t).undo(),i||this.disposeBackup()}async redo(t,i){await this.getEdit(t).redo(),i||this.disposeBackup()}disposeEdits(t){for(const i of t)this._edits.delete(i)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=c(this.document.uri)+this._backupCounter++;return(0,D.joinPath)(this._storagePath,t)}updateBackup(t){var i;(i=this._backup)===null||i===void 0||i.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const i=this._edits.get(t,0);if(!i)throw new Error("No edit found");return i}}class s{constructor(){this._documents=new Map}get(t,i){return this._documents.get(this.key(t,i))}add(t,i,o){const r=this.key(t,i.uri);if(this._documents.has(r))throw new Error(`Document already exists for viewType:${t} resource:${i.uri}`);const a=new g(i,o);return this._documents.set(r,a),a}delete(t,i){const o=this.key(t,i.uri);this._documents.delete(o)}key(t,i){return`${t}@@@${i}`}}var u;(function(l){l[l.Text=0]="Text",l[l.Custom=1]="Custom"})(u||(u={}));class S{constructor(){this._providers=new Map}addTextProvider(t,i,o){return this.add(0,t,i,o)}addCustomProvider(t,i,o){return this.add(1,t,i,o)}get(t){return this._providers.get(t)}add(t,i,o,r){if(this._providers.has(i))throw new Error(`Provider for viewType:${i} already registered`);return this._providers.set(i,{type:t,extension:o,provider:r}),new w.Disposable(()=>this._providers.delete(i))}}class v{constructor(t,i,o,r,a){this._extHostDocuments=i,this._extensionStoragePaths=o,this._extHostWebview=r,this._extHostWebviewPanels=a,this._editorProviders=new S,this._documents=new s,this._proxy=t.getProxy(C.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,i,o,r){const a=new T.DisposableStore;return _(o)?(a.add(this._editorProviders.addTextProvider(i,t,o)),this._proxy.$registerTextEditorProvider((0,n.toExtensionData)(t),i,r.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,n.shouldSerializeBuffersForPostMessage)(t))):(a.add(this._editorProviders.addCustomProvider(i,t,o)),this.supportEditing(o)&&a.add(o.onDidChangeCustomDocument(h=>{const m=this.getCustomDocumentEntry(i,h.document.uri);if(p(h)){const b=m.addEdit(h);this._proxy.$onDidEdit(h.document.uri,i,b,h.label)}else this._proxy.$onContentChange(h.document.uri,i)})),this._proxy.$registerCustomEditorProvider((0,n.toExtensionData)(t),i,r.webviewOptions||{},!!r.supportsMultipleEditorsPerDocument,(0,n.shouldSerializeBuffersForPostMessage)(t))),w.Disposable.from(a,new w.Disposable(()=>{this._proxy.$unregisterEditorProvider(i)}))}async $createCustomDocument(t,i,o,r,a){var h;const m=this._editorProviders.get(i);if(!m)throw new Error(`No provider found for '${i}'`);if(m.type!==1)throw new Error(`Invalid provide type for '${i}'`);const b=k.URI.revive(t),f=await m.provider.openCustomDocument(b,{backupId:o,untitledDocumentData:r==null?void 0:r.buffer},a);let d;return this.supportEditing(m.provider)&&this._extensionStoragePaths&&(d=(h=this._extensionStoragePaths.workspaceValue(m.extension))!==null&&h!==void 0?h:this._extensionStoragePaths.globalValue(m.extension)),this._documents.add(i,f,d),{editable:this.supportEditing(m.provider)}}async $disposeCustomDocument(t,i){const o=this._editorProviders.get(i);if(!o)throw new Error(`No provider found for '${i}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${i}'`);const r=k.URI.revive(t),{document:a}=this.getCustomDocumentEntry(i,r);this._documents.delete(i,a),a.dispose()}async $resolveWebviewEditor(t,i,o,r,a,h){const m=this._editorProviders.get(o);if(!m)throw new Error(`No provider found for '${o}'`);const b=y.ViewColumn.to(a),f=this._extHostWebview.createNewWebview(i,r.webviewOptions,m.extension),d=this._extHostWebviewPanels.createNewWebviewPanel(i,o,r.title,b,r.panelOptions,f),A=k.URI.revive(t);switch(m.type){case 1:{const{document:L}=this.getCustomDocumentEntry(o,A);return m.provider.resolveCustomEditor(L,d,h)}case 0:{const L=this._extHostDocuments.getDocument(A);return m.provider.resolveCustomTextEditor(L,d,h)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,i,o){this.getCustomDocumentEntry(i,t).disposeEdits(o)}async $onMoveCustomEditor(t,i,o){const r=this._editorProviders.get(o);if(!r)throw new Error(`No provider found for '${o}'`);if(!r.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const a=this._extHostWebviewPanels.getWebviewPanel(t);if(!a)throw new Error("No webview found");const h=k.URI.revive(i),m=this._extHostDocuments.getDocument(h);await r.provider.moveCustomTextEditor(m,a,E.CancellationToken.None)}async $undo(t,i,o,r){return this.getCustomDocumentEntry(i,t).undo(o,r)}async $redo(t,i,o,r){return this.getCustomDocumentEntry(i,t).redo(o,r)}async $revert(t,i,o){const r=this.getCustomDocumentEntry(i,t);await this.getCustomEditorProvider(i).revertCustomDocument(r.document,o),r.disposeBackup()}async $onSave(t,i,o){const r=this.getCustomDocumentEntry(i,t);await this.getCustomEditorProvider(i).saveCustomDocument(r.document,o),r.disposeBackup()}async $onSaveAs(t,i,o,r){const a=this.getCustomDocumentEntry(i,t);return this.getCustomEditorProvider(i).saveCustomDocumentAs(a.document,k.URI.revive(o),r)}async $backup(t,i,o){const r=this.getCustomDocumentEntry(i,t),h=await this.getCustomEditorProvider(i).backupCustomDocument(r.document,{destination:r.getNewBackupUri()},o);return r.updateBackup(h),h.id}getCustomDocumentEntry(t,i){const o=this._documents.get(t,k.URI.revive(i));if(!o)throw new Error("No custom document found");return o}getCustomEditorProvider(t){const i=this._editorProviders.get(t),o=i==null?void 0:i.provider;if(!o||!this.supportEditing(o))throw new Error("Custom document is not editable");return o}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=v;function _(l){return typeof l.resolveCustomTextEditor=="function"}function p(l){return typeof l.undo=="function"&&typeof l.redo=="function"}function c(l){const t=l.scheme===I.Schemas.file||l.scheme===I.Schemas.untitled?l.fsPath:l.toString();return(0,P.hash)(t)+""}});var tt=this&&this.__classPrivateFieldSet||function(G,e,E,P,T){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!T:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?T.call(G,E):T?T.value=E:e.set(G,E),E},He=this&&this.__classPrivateFieldGet||function(G,e,E,P){if(E==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!P:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?P:E==="a"?P.call(G):P?P.value:e.get(G)};define(ge[251],pe([0,1,3,6,2,28,20,64,5,7]),function(G,e,E,P,T,I,D,k,y,n){"use strict";var R,C,w,g,s,u,S,v,_,p,c,l,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class i extends P.Disposable{constructor(h,m,b,f,d,A,L){super();R.set(this,void 0),C.set(this,void 0),w.set(this,void 0),g.set(this,void 0),s.set(this,void 0),u.set(this,void 0),S.set(this,void 0),v.set(this,void 0),_.set(this,!0),p.set(this,!0),c.set(this,!1),l.set(this,this._register(new E.Emitter)),this.onDidDispose=He(this,l,"f").event,t.set(this,this._register(new E.Emitter)),this.onDidChangeViewState=He(this,t,"f").event,tt(this,R,h,"f"),tt(this,C,m,"f"),tt(this,w,b,"f"),tt(this,s,A,"f"),tt(this,v,d,"f"),tt(this,u,f,"f"),tt(this,g,L,"f")}dispose(){He(this,c,"f")||(tt(this,c,!0,"f"),He(this,l,"f").fire(),He(this,C,"f").$disposeWebview(He(this,R,"f")),He(this,g,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),He(this,g,"f")}get viewType(){return this.assertNotDisposed(),He(this,w,"f")}get title(){return this.assertNotDisposed(),He(this,u,"f")}set title(h){this.assertNotDisposed(),He(this,u,"f")!==h&&(tt(this,u,h,"f"),He(this,C,"f").$setTitle(He(this,R,"f"),h))}get iconPath(){return this.assertNotDisposed(),He(this,S,"f")}set iconPath(h){this.assertNotDisposed(),He(this,S,"f")!==h&&(tt(this,S,h,"f"),He(this,C,"f").$setIconPath(He(this,R,"f"),T.URI.isUri(h)?{light:h,dark:h}:h))}get options(){return He(this,s,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof He(this,v,"f")=="number"&&He(this,v,"f")<0))return He(this,v,"f")}get active(){return this.assertNotDisposed(),He(this,p,"f")}get visible(){return this.assertNotDisposed(),He(this,_,"f")}_updateViewState(h){He(this,c,"f")||(this.active!==h.active||this.visible!==h.visible||this.viewColumn!==h.viewColumn)&&(tt(this,p,h.active,"f"),tt(this,_,h.visible,"f"),tt(this,v,h.viewColumn,"f"),He(this,t,"f").fire({webviewPanel:this}))}reveal(h,m){this.assertNotDisposed(),He(this,C,"f").$reveal(He(this,R,"f"),{viewColumn:h?D.ViewColumn.from(h):void 0,preserveFocus:!!m})}assertNotDisposed(){if(He(this,c,"f"))throw new Error("Webview is disposed")}}R=new WeakMap,C=new WeakMap,w=new WeakMap,g=new WeakMap,s=new WeakMap,u=new WeakMap,S=new WeakMap,v=new WeakMap,_=new WeakMap,p=new WeakMap,c=new WeakMap,l=new WeakMap,t=new WeakMap;class o{constructor(h,m,b){this.webviews=m,this.workspace=b,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=h.getProxy(y.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,I.generateUuid)()}createWebviewPanel(h,m,b,f,d={}){const A=typeof f=="object"?f.viewColumn:f,L={viewColumn:D.ViewColumn.from(A),preserveFocus:typeof f=="object"&&!!f.preserveFocus},B=(0,k.shouldSerializeBuffersForPostMessage)(h),J=o.newHandle();this._proxy.$createWebviewPanel((0,k.toExtensionData)(h),J,m,{title:b,panelOptions:r(d),webviewOptions:(0,k.serializeWebviewOptions)(h,this.workspace,d),serializeBuffersForPostMessage:B},L);const j=this.webviews.createNewWebview(J,d,h);return this.createNewWebviewPanel(J,m,b,A,d,j)}$onDidChangeWebviewPanelViewStates(h){const m=Object.keys(h);m.sort((b,f)=>{const d=h[b],A=h[f];return d.active?1:A.active?-1:+d.visible-+A.visible});for(const b of m){const f=this.getWebviewPanel(b);if(!!f){const d=h[b];f._updateViewState({active:d.active,visible:d.visible,viewColumn:D.ViewColumn.to(d.position)})}}}async $onDidDisposeWebviewPanel(h){const m=this.getWebviewPanel(h);m==null||m.dispose(),this._webviewPanels.delete(h),this.webviews.deleteWebview(h)}registerWebviewPanelSerializer(h,m,b){if(this._serializers.has(m))throw new Error(`Serializer for '${m}' already registered`);return this._serializers.set(m,{serializer:b,extension:h}),this._proxy.$registerSerializer(m,{serializeBuffersForPostMessage:(0,k.shouldSerializeBuffersForPostMessage)(h)}),new n.Disposable(()=>{this._serializers.delete(m),this._proxy.$unregisterSerializer(m)})}async $deserializeWebviewPanel(h,m,b,f){const d=this._serializers.get(m);if(!d)throw new Error(`No serializer found for '${m}'`);const{serializer:A,extension:L}=d,B=this.webviews.createNewWebview(h,b.webviewOptions,L),J=this.createNewWebviewPanel(h,m,b.title,f,b.panelOptions,B);await A.deserializeWebviewPanel(J,b.state)}createNewWebviewPanel(h,m,b,f,d,A){const L=new i(h,this._proxy,m,b,f,d,A);return this._webviewPanels.set(h,L),L}getWebviewPanel(h){return this._webviewPanels.get(h)}}e.ExtHostWebviewPanels=o;function r(a){return{enableFindWidget:a.enableFindWidget,retainContextWhenHidden:a.retainContextWhenHidden}}});var tt=this&&this.__classPrivateFieldSet||function(G,e,E,P,T){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!T:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?T.call(G,E):T?T.value=E:e.set(G,E),E},He=this&&this.__classPrivateFieldGet||function(G,e,E,P){if(E==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!P:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?P:E==="a"?P.call(G):P?P.value:e.get(G)};define(ge[252],pe([0,1,3,6,64,5,7]),function(G,e,E,P,T,I,D){"use strict";var k,y,n,R,C,w,g,s,u,S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class v extends P.Disposable{constructor(c,l,t,i,o,r){super();k.set(this,void 0),y.set(this,void 0),n.set(this,void 0),R.set(this,void 0),C.set(this,!1),w.set(this,void 0),g.set(this,void 0),s.set(this,void 0),u.set(this,this._register(new E.Emitter)),this.onDidChangeVisibility=He(this,u,"f").event,S.set(this,this._register(new E.Emitter)),this.onDidDispose=He(this,S,"f").event,tt(this,n,t,"f"),tt(this,g,i,"f"),tt(this,k,c,"f"),tt(this,y,l,"f"),tt(this,R,o,"f"),tt(this,w,r,"f")}dispose(){He(this,C,"f")||(tt(this,C,!0,"f"),He(this,S,"f").fire(),He(this,R,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),He(this,g,"f")}set title(c){this.assertNotDisposed(),He(this,g,"f")!==c&&(tt(this,g,c,"f"),He(this,y,"f").$setWebviewViewTitle(He(this,k,"f"),c))}get description(){return this.assertNotDisposed(),He(this,s,"f")}set description(c){this.assertNotDisposed(),He(this,s,"f")!==c&&(tt(this,s,c,"f"),He(this,y,"f").$setWebviewViewDescription(He(this,k,"f"),c))}get visible(){return He(this,w,"f")}get webview(){return He(this,R,"f")}get viewType(){return He(this,n,"f")}_setVisible(c){c===He(this,w,"f")||He(this,C,"f")||(tt(this,w,c,"f"),He(this,u,"f").fire())}show(c){this.assertNotDisposed(),He(this,y,"f").$show(He(this,k,"f"),!!c)}assertNotDisposed(){if(He(this,C,"f"))throw new Error("Webview is disposed")}}k=new WeakMap,y=new WeakMap,n=new WeakMap,R=new WeakMap,C=new WeakMap,w=new WeakMap,g=new WeakMap,s=new WeakMap,u=new WeakMap,S=new WeakMap;class _{constructor(c,l){this._extHostWebview=l,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=c.getProxy(I.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(c,l,t,i){if(this._viewProviders.has(l))throw new Error(`View provider for '${l}' already registered`);return this._viewProviders.set(l,{provider:t,extension:c}),this._proxy.$registerWebviewViewProvider((0,T.toExtensionData)(c),l,{retainContextWhenHidden:i==null?void 0:i.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new D.Disposable(()=>{this._viewProviders.delete(l),this._proxy.$unregisterWebviewViewProvider(l)})}async $resolveWebviewView(c,l,t,i,o){const r=this._viewProviders.get(l);if(!r)throw new Error(`No view provider found for '${l}'`);const{provider:a,extension:h}=r,m=this._extHostWebview.createNewWebview(c,{},h),b=new v(c,this._proxy,l,t,m,!0);this._webviewViews.set(c,b),await a.resolveWebviewView(b,{state:i},o)}async $onDidChangeWebviewViewVisibility(c,l){this.getWebviewView(c)._setVisible(l)}async $disposeWebviewView(c){const l=this.getWebviewView(c);this._webviewViews.delete(c),l.dispose(),this._extHostWebview.deleteWebview(c)}getWebviewView(c){const l=this._webviewViews.get(c);if(!l)throw new Error("No webview found");return l}}e.ExtHostWebviewViews=_}),define(ge[125],pe([0,1,3,5,2,11,10,4,13]),function(G,e,E,P,T,I,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let n=class Fn{constructor(C){this._onDidChangeWindowState=new E.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Fn.InitialState,this._proxy=C.getProxy(P.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(w=>this.$onDidChangeWindowFocus(w))}get state(){return this._state}$onDidChangeWindowFocus(C){C!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:C}),this._onDidChangeWindowState.fire(this._state))}openUri(C,w){let g;if(typeof C=="string"){g=C;try{C=T.URI.parse(C)}catch(s){return Promise.reject(`Invalid uri - '${C}'`)}}return(0,D.isFalsyOrWhitespace)(C.scheme)?Promise.reject("Invalid scheme - cannot be empty"):C.scheme===I.Schemas.command?Promise.reject(`Invalid scheme '${C.scheme}'`):this._proxy.$openUri(C,g,w)}async asExternalUri(C,w){if((0,D.isFalsyOrWhitespace)(C.scheme))return Promise.reject("Invalid scheme - cannot be empty");if(!new Set([I.Schemas.http,I.Schemas.https]).has(C.scheme))return Promise.reject(`Invalid scheme '${C.scheme}'`);const g=await this._proxy.$asExternalUri(C,w);return T.URI.from(g)}};n.InitialState={focused:!0},n=je([Ue(0,y.IExtHostRpcService)],n),e.ExtHostWindow=n,e.IExtHostWindow=(0,k.createDecorator)("IExtHostWindow")}),define(ge[253],pe([0,1,8,48,28,51,6,5,2,13]),function(G,e,E,P,T,I,D,k,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let R=class extends D.Disposable{constructor(w,g){super();const s=w.getProxy(k.MainContext.MainThreadDownloadService);g.registerCommand(!1,"_workbench.downloadResource",async u=>{const S=y.URI.file((0,E.join)((0,P.tmpdir)(),(0,T.generateUuid)()));return await s.$download(u,S),S})}};R=je([Ue(0,n.IExtHostRpcService),Ue(1,I.IExtHostCommands)],R),e.ExtHostDownloadService=R}),define(ge[254],pe([0,1,2,8,145,26,37,63,27,13,6,12,109,45]),function(G,e,E,P,T,I,D,k,y,n,R,C,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostOutputService2=e.ExtHostOutputChannelBackedByFile=void 0;class s{constructor(_,p){this.file=p,this.appender=(0,w.createRotatingLogger)(_,p,30*g.ByteSize.MB,1),this.appender.clearFormatters()}append(_){this.appender.critical(_)}flush(){this.appender.flush()}}class u extends k.AbstractExtHostOutputChannel{constructor(_,p,c){super(_,!1,E.URI.file(p.file),c);this._appender=p}append(_){super.append(_),this._appender.append(_),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(_,p){this._appender.flush(),super.show(_,p)}clear(){this._appender.flush(),super.clear()}}e.ExtHostOutputChannelBackedByFile=u;let S=class extends k.ExtHostOutputService{constructor(_,p,c){super(_);this.logService=p,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new R.MutableDisposable,this._logsLocation=c.logsLocation}$setVisibleChannel(_){if(_){const p=this._channels.get(_);p&&(this._visibleChannelDisposable.value=p.onDidAppend(()=>p.update()))}}createOutputChannel(_){if(_=_.trim(),!_)throw new Error("illegal argument `name`. must not be falsy");const p=this._doCreateOutChannel(_);return p.then(c=>c._id.then(l=>this._channels.set(l,c))),new k.LazyOutputChannel(_,p)}async _doCreateOutChannel(_){try{const p=(0,P.join)(this._logsLocation.fsPath,`output_logging_${(0,T.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`);await I.SymlinkSupport.existsDirectory(p)||await D.promises.mkdir(p,{recursive:!0});const l=`${this._namePool++}-${_.replace(/[\\/:\*\?"<>\|]/g,"")}`,t=E.URI.file((0,P.join)(p,`${l}.log`)),i=new s(l,t.fsPath);return new u(_,i,this._proxy)}catch(p){return this.logService.error(p),new k.ExtHostPushOutputChannel(_,this._proxy)}}};S=je([Ue(0,n.IExtHostRpcService),Ue(1,C.ILogService),Ue(2,y.IExtHostInitDataService)],S),e.ExtHostOutputService2=S}),define(ge[255],pe([0,1,5,13,6,27,2,38,25,37,26,7,9,50,3,72,12]),function(G,e,E,P,T,I,D,k,y,n,R,C,w,g,s,u,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class v{constructor(m,b,f){this.remoteAddress=m,this.localAddress=b,this._dispose=f,this._onDispose=new s.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function _(h){const m=h.trim().split(`
`),b=[];return m.forEach(d=>{const A=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(d);A&&A.length>=3&&b.push({pid:parseInt(A[1],10),socket:parseInt(A[2],10)})}),b.reduce((d,A)=>(d[A.socket]=A,d),{})}e.getSockets=_;function p(...h){const m=[].concat(...h.map(l));return[...new Map(m.filter(b=>b.st==="0A").map(b=>{const f=b.local_address.split(":");return{socket:parseInt(b.inode,10),ip:c(f[0]),port:parseInt(f[1],16)}}).map(b=>[b.ip+":"+b.port,b])).values()]}e.loadListeningPorts=p;function c(h){let m="";if(h.length===8)for(let b=h.length-2;b>=0;b-=2)m+=parseInt(h.substr(b,2),16),b!==0&&(m+=".");else for(let b=h.length-4;b>=0;b-=4)m+=parseInt(h.substr(b,4),16).toString(16),b!==0&&(m+=":");return m}e.parseIpAddress=c;function l(h){const m=h.trim().split(`
`),b=m.shift().trim().split(/\s+/).filter(d=>d!=="rx_queue"&&d!=="tm->when");return m.map(d=>d.trim().split(/\s+/).reduce((A,L,B)=>(A[b[B]||B]=L,A),{}))}e.loadConnectionTable=l;function t(h){return!!h.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||h.indexOf("out/vs/server/main.js")!==-1||h.indexOf("_productName=VSCode")!==-1}function i(h){const m=h.trim().split(`
`),b=[];return m.forEach(f=>{const d=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(f);d&&d.length>=4&&b.push({pid:parseInt(d[1],10),ppid:parseInt(d[2]),cmd:d[3]})}),b}e.getRootProcesses=i;async function o(h,m,b){const f=b.reduce((A,L)=>(A[L.pid]=L,A),{}),d=[];return h.forEach(({socket:A,ip:L,port:B})=>{var J;const j=m[A]?m[A].pid:void 0,U=j?(J=f[j])===null||J===void 0?void 0:J.cmd:void 0;j&&U&&!t(U)&&d.push({host:L,port:B,detail:U,pid:j})}),d}e.findPorts=o;function r(h,m,b){const f=new Map,d=i(m);for(const A of h){const L=b.get(A.port);if(L){f.set(A.port,L);continue}const B=d.find(J=>J.cmd.includes(`${A.port}`));if(B){let J=B,j;do j=d.find(U=>U.ppid===J.pid),j&&(J=j);while(j);f.set(A.port,{host:A.ip,port:A.port,pid:J.pid,detail:J.cmd,ppid:J.ppid})}else f.set(A.port,{host:A.ip,port:A.port,ppid:Number.MAX_VALUE})}return f}e.tryFindRootPorts=r;let a=class extends T.Disposable{constructor(m,b,f){super();this.logService=f,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new s.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=m.getProxy(E.MainContext.MainThreadTunnelService),w.isLinux&&b.remote.isRemote&&b.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(m,b){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${m.identifier} called openTunnel API for ${b.remoteAddress.port}.`);const f=await this._proxy.$openTunnel(b,m.displayName);if(f){const d=new v(f.remoteAddress,f.localAddress,()=>this._proxy.$closeTunnel(f.remoteAddress));return this._register(d),d}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(m){return Math.max(m*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(m,b){const f=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(f,{selector:m,provider:b}),this._proxy.$registerPortsAttributesProvider(m,f),new C.Disposable(()=>{this._portAttributesProviders.delete(f),this._proxy.$unregisterPortsAttributesProvider(f)})}async $providePortAttributes(m,b,f,d,A){const L=[];for(const J of m){const j=this._portAttributesProviders.get(J);if(!j)return[];L.push(...await Promise.all(b.map(async U=>j.provider.providePortAttributes(U,f,d,A))))}const B=L.filter(J=>!!J);return B.length>0?B.map(J=>({autoForwardAction:J.autoForwardAction,port:J.port})):[]}async $registerCandidateFinder(m){if(!(m&&this._candidateFindingEnabled)){this._candidateFindingEnabled=m;let b=new u.MovingAverage,f;for(;this._candidateFindingEnabled;){const d=new Date().getTime(),A=await this.findCandidatePorts();this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${A.map(B=>B.port).join(", ")}`);const L=new Date().getTime()-d;b.update(L),(!f||JSON.stringify(f)!==JSON.stringify(A))&&(f=A,await this._proxy.$onFoundNewCandidates(f)),await new Promise(B=>setTimeout(()=>B(),this.calculateDelay(b.value)))}}}async setTunnelExtensionFunctions(m){var b;return m?(m.candidatePortSource!==void 0&&await this._proxy.$setCandidatePortSource(m.candidatePortSource),m.showCandidatePort&&(this._showCandidatePort=m.showCandidatePort,await this._proxy.$setCandidateFilter()),m.tunnelFactory&&(this._forwardPortProvider=m.tunnelFactory,await this._proxy.$setTunnelProvider((b=m.tunnelFeatures)!==null&&b!==void 0?b:{elevation:!1,public:!1}))):this._forwardPortProvider=void 0,(0,T.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(m,b){if(this._extensionTunnels.has(m.host)){const f=this._extensionTunnels.get(m.host);f.has(m.port)&&(b&&f.get(m.port).disposeListener.dispose(),await f.get(m.port).tunnel.dispose(),f.delete(m.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(m,b){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const f=this._forwardPortProvider(m,b);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),f!==void 0){const d=await f;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(m.remoteAddress.host)||this._extensionTunnels.set(m.remoteAddress.host,new Map);const A=this._register(d.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(d.remoteAddress))));return this._extensionTunnels.get(m.remoteAddress.host).set(m.remoteAddress.port,{tunnel:d,disposeListener:A}),g.TunnelDto.fromApiTunnel(d)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(f){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(m){const b=await Promise.all(m.map(d=>{var A;return this._showCandidatePort(d.host,d.port,(A=d.detail)!==null&&A!==void 0?A:"")})),f=m.filter((d,A)=>b[A]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${m.map(d=>d.port).join(", ")} to ${f.map(d=>d.port).join(", ")}`),f}async findCandidatePorts(){let m="",b="";try{m=await n.promises.readFile("/proc/net/tcp","utf8"),b=await n.promises.readFile("/proc/net/tcp6","utf8")}catch(F){}const f=p(m,b),d=await new Promise(F=>{(0,k.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(N,M,x)=>{F(M)})}),A=_(d),L=await R.readdir("/proc"),B=[];for(let F of L)try{const N=Number(F),M=y.joinPath(D.URI.file("/proc"),F);if((await n.promises.stat(M.fsPath)).isDirectory()&&!isNaN(N)){const O=await n.promises.readlink(y.joinPath(M,"cwd").fsPath),V=await n.promises.readFile(y.joinPath(M,"cmdline").fsPath,"utf8");B.push({pid:N,cwd:O,cmd:V})}}catch(N){}const J=[],j=f.filter(F=>{const N=A[F.socket];return N||J.push(F),N}),U=o(j,A,B);let $;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${J.length}`),J.length>0){const F=await new Promise(N=>{(0,k.exec)("ps -F -A -l | grep root",(M,x,O)=>{N(x)})});this._foundRootPorts=r(J,F,this._foundRootPorts),$=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${$.join(", ")}`)}return U.then(F=>$?F.concat($):F)}};a=je([Ue(0,P.IExtHostRpcService),Ue(1,I.IExtHostInitDataService),Ue(2,S.ILogService)],a),e.ExtHostTunnelService=a}),define(ge[256],pe([0,1,19,21,18,3,6,97,226,123,22]),function(G,e,E,P,T,I,D,k,y,n,R){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function w(r,a){try{return JSON.stringify(r,a)}catch(h){return"null"}}function g(r,a){return JSON.stringify(r,a)}function s(r){return r?(a,h)=>h&&h.$mid===1?r.transformOutgoing(h):h:null}var u;(function(r){r[r.LocalSide=0]="LocalSide",r[r.OtherSide=1]="OtherSide"})(u=e.RequestInitiator||(e.RequestInitiator={}));var S;(function(r){r[r.Responsive=0]="Responsive",r[r.Unresponsive=1]="Unresponsive"})(S=e.ResponsiveState||(e.ResponsiveState={}));const v=()=>{},_=Symbol.for("rpcProtocol"),p=Symbol.for("rpcProxy");class c extends D.Disposable{constructor(a,h=null,m=null){super();this[C]=!0,this._onDidChangeResponsiveState=this._register(new I.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=a,this._logger=h,this._uriTransformer=m,this._uriReplacer=s(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let b=0,f=n.ProxyIdentifier.count;b<f;b++)this._locals[b]=null,this._proxies[b]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new E.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(b=>this._receiveOneMessage(b))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(a=>{this._pendingRPCReplies[a].resolveErr(T.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(a){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+c.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(a){this._unresponsiveTime=Date.now()+c.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(a){this._responsiveState!==a&&(this._responsiveState=a,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(a){return this._uriTransformer?(0,k.transformIncomingURIs)(a,this._uriTransformer):a}getProxy(a){const{nid:h,sid:m}=a;return this._proxies[h]||(this._proxies[h]=this._createProxy(h,m)),this._proxies[h]}_createProxy(a,h){let m={get:(b,f)=>(typeof f=="string"&&!b[f]&&f.charCodeAt(0)===36&&(b[f]=(...d)=>this._remoteCall(a,f,d)),f===p?h:b[f])};return new Proxy(Object.create(null),m)}set(a,h){return this._locals[a.nid]=h,h}assertRegistered(a){for(let h=0,m=a.length;h<m;h++){const b=a[h];if(!this._locals[b.nid])throw new Error(`Missing actor ${b.sid} (isMain: ${b.isMain})`)}}_receiveOneMessage(a){if(!this._isDisposed){const h=a.byteLength,m=l.read(a,0),b=m.readUInt8(),f=m.readUInt32();switch(b){case 1:case 2:{let{rpcId:d,method:A,args:L}=t.deserializeRequestJSONArgs(m);this._uriTransformer&&(L=(0,k.transformIncomingURIs)(L,this._uriTransformer)),this._receiveRequest(h,f,d,A,L,b===2);break}case 3:case 4:{let{rpcId:d,method:A,args:L}=t.deserializeRequestMixedArgs(m);this._uriTransformer&&(L=(0,k.transformIncomingURIs)(L,this._uriTransformer)),this._receiveRequest(h,f,d,A,L,b===4);break}case 5:{this._logger&&this._logger.logIncoming(h,f,0,"ack"),this._onDidReceiveAcknowledge(f);break}case 6:{this._receiveCancel(h,f);break}case 7:{this._receiveReply(h,f,void 0);break}case 9:{let d=t.deserializeReplyOKJSON(m);this._uriTransformer&&(d=(0,k.transformIncomingURIs)(d,this._uriTransformer)),this._receiveReply(h,f,d);break}case 8:{let d=t.deserializeReplyOKVSBuffer(m);this._receiveReply(h,f,d);break}case 10:{let d=t.deserializeReplyErrError(m);this._uriTransformer&&(d=(0,k.transformIncomingURIs)(d,this._uriTransformer)),this._receiveReplyErr(h,f,d);break}case 11:{this._receiveReplyErr(h,f,void 0);break}default:console.error("received unexpected message"),console.error(a)}}}_receiveRequest(a,h,m,b,f,d){this._logger&&this._logger.logIncoming(a,h,1,`receiveRequest ${(0,n.getStringIdentifierForProxy)(m)}.${b}(`,f);const A=String(h);let L,B;if(d){const j=new P.CancellationTokenSource;f.push(j.token),L=this._invokeHandler(m,b,f),B=()=>j.cancel()}else L=this._invokeHandler(m,b,f),B=v;this._cancelInvokedHandlers[A]=B;const J=t.serializeAcknowledged(h);this._logger&&this._logger.logOutgoing(J.byteLength,h,1,"ack"),this._protocol.send(J),L.then(j=>{delete this._cancelInvokedHandlers[A];const U=t.serializeReplyOK(h,j,this._uriReplacer);this._logger&&this._logger.logOutgoing(U.byteLength,h,1,"reply:",j),this._protocol.send(U)},j=>{delete this._cancelInvokedHandlers[A];const U=t.serializeReplyErr(h,j);this._logger&&this._logger.logOutgoing(U.byteLength,h,1,"replyErr:",j),this._protocol.send(U)})}_receiveCancel(a,h){this._logger&&this._logger.logIncoming(a,h,1,"receiveCancel");const m=String(h);this._cancelInvokedHandlers[m]&&this._cancelInvokedHandlers[m]()}_receiveReply(a,h,m){this._logger&&this._logger.logIncoming(a,h,0,"receiveReply:",m);const b=String(h);if(!!this._pendingRPCReplies.hasOwnProperty(b)){const f=this._pendingRPCReplies[b];delete this._pendingRPCReplies[b],f.resolveOk(m)}}_receiveReplyErr(a,h,m){this._logger&&this._logger.logIncoming(a,h,0,"receiveReplyErr:",m);const b=String(h);if(!!this._pendingRPCReplies.hasOwnProperty(b)){const f=this._pendingRPCReplies[b];delete this._pendingRPCReplies[b];let d;m&&(m.$isError?(d=new Error,d.name=m.name,d.message=m.message,d.stack=m.stack):d=m),f.resolveErr(d)}}_invokeHandler(a,h,m){try{return Promise.resolve(this._doInvokeHandler(a,h,m))}catch(b){return Promise.reject(b)}}_doInvokeHandler(a,h,m){const b=this._locals[a];if(!b)throw new Error("Unknown actor "+(0,n.getStringIdentifierForProxy)(a));let f=b[h];if(typeof f!="function")throw new Error("Unknown method "+h+" on actor "+(0,n.getStringIdentifierForProxy)(a));return f.apply(b,m)}_remoteCall(a,h,m){if(this._isDisposed)return Promise.reject(T.canceled());let b=null;if(m.length>0&&P.CancellationToken.isCancellationToken(m[m.length-1])&&(b=m.pop()),b&&b.isCancellationRequested)return Promise.reject(T.canceled());const f=t.serializeRequestArguments(m,this._uriReplacer),d=++this._lastMessageId,A=String(d),L=new y.LazyPromise;b&&b.onCancellationRequested(()=>{const J=t.serializeCancel(d);this._logger&&this._logger.logOutgoing(J.byteLength,d,0,"cancel"),this._protocol.send(t.serializeCancel(d))}),this._pendingRPCReplies[A]=L,this._onWillSendRequest(d);const B=t.serializeRequest(d,a,h,f,!!b);return this._logger&&this._logger.logOutgoing(B.byteLength,d,0,`request: ${(0,n.getStringIdentifierForProxy)(a)}.${h}(`,m),this._protocol.send(B),L}}e.RPCProtocol=c,C=_,c.UNRESPONSIVE_TIME=3*1e3;class l{constructor(a,h){this._buff=a,this._offset=h}static alloc(a,h,m){let b=new l(R.VSBuffer.alloc(m+1+4),0);return b.writeUInt8(a),b.writeUInt32(h),b}static read(a,h){return new l(a,h)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(a){this._buff.writeUInt8(a,this._offset),this._offset+=1}readUInt8(){const a=this._buff.readUInt8(this._offset);return this._offset+=1,a}writeUInt32(a){this._buff.writeUInt32BE(a,this._offset),this._offset+=4}readUInt32(){const a=this._buff.readUInt32BE(this._offset);return this._offset+=4,a}static sizeShortString(a){return 1+a.byteLength}writeShortString(a){this._buff.writeUInt8(a.byteLength,this._offset),this._offset+=1,this._buff.set(a,this._offset),this._offset+=a.byteLength}readShortString(){const a=this._buff.readUInt8(this._offset);this._offset+=1;const m=this._buff.slice(this._offset,this._offset+a).toString();return this._offset+=a,m}static sizeLongString(a){return 4+a.byteLength}writeLongString(a){this._buff.writeUInt32BE(a.byteLength,this._offset),this._offset+=4,this._buff.set(a,this._offset),this._offset+=a.byteLength}readLongString(){const a=this._buff.readUInt32BE(this._offset);this._offset+=4;const m=this._buff.slice(this._offset,this._offset+a).toString();return this._offset+=a,m}writeBuffer(a){this._buff.writeUInt32BE(a.byteLength,this._offset),this._offset+=4,this._buff.set(a,this._offset),this._offset+=a.byteLength}static sizeVSBuffer(a){return 4+a.byteLength}writeVSBuffer(a){this._buff.writeUInt32BE(a.byteLength,this._offset),this._offset+=4,this._buff.set(a,this._offset),this._offset+=a.byteLength}readVSBuffer(){const a=this._buff.readUInt32BE(this._offset);this._offset+=4;const h=this._buff.slice(this._offset,this._offset+a);return this._offset+=a,h}static sizeMixedArray(a,h){let m=0;m+=1;for(let b=0,f=a.length;b<f;b++){const d=a[b],A=h[b];switch(m+=1,A){case 1:m+=this.sizeLongString(d);break;case 2:m+=this.sizeVSBuffer(d);break;case 3:break}}return m}writeMixedArray(a,h){this._buff.writeUInt8(a.length,this._offset),this._offset+=1;for(let m=0,b=a.length;m<b;m++){const f=a[m];switch(h[m]){case 1:this.writeUInt8(1),this.writeLongString(f);break;case 2:this.writeUInt8(2),this.writeVSBuffer(f);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const a=this._buff.readUInt8(this._offset);this._offset+=1;let h=new Array(a);for(let m=0;m<a;m++)switch(this.readUInt8()){case 1:h[m]=this.readLongString();break;case 2:h[m]=this.readVSBuffer();break;case 3:h[m]=void 0;break}return h}}class t{static _arrayContainsBufferOrUndefined(a){for(let h=0,m=a.length;h<m;h++)if(a[h]instanceof R.VSBuffer||typeof a[h]=="undefined")return!0;return!1}static serializeRequestArguments(a,h){if(this._arrayContainsBufferOrUndefined(a)){let m=[],b=[];for(let f=0,d=a.length;f<d;f++){const A=a[f];A instanceof R.VSBuffer?(m[f]=A,b[f]=2):typeof A=="undefined"?(m[f]=R.VSBuffer.alloc(0),b[f]=3):(m[f]=R.VSBuffer.fromString(g(A,h)),b[f]=1)}return{type:"mixed",args:m,argsType:b}}return{type:"simple",args:g(a,h)}}static serializeRequest(a,h,m,b,f){return b.type==="mixed"?this._requestMixedArgs(a,h,m,b.args,b.argsType,f):this._requestJSONArgs(a,h,m,b.args,f)}static _requestJSONArgs(a,h,m,b,f){const d=R.VSBuffer.fromString(m),A=R.VSBuffer.fromString(b);let L=0;L+=l.sizeUInt8(),L+=l.sizeShortString(d),L+=l.sizeLongString(A);let B=l.alloc(f?2:1,a,L);return B.writeUInt8(h),B.writeShortString(d),B.writeLongString(A),B.buffer}static deserializeRequestJSONArgs(a){const h=a.readUInt8(),m=a.readShortString(),b=a.readLongString();return{rpcId:h,method:m,args:JSON.parse(b)}}static _requestMixedArgs(a,h,m,b,f,d){const A=R.VSBuffer.fromString(m);let L=0;L+=l.sizeUInt8(),L+=l.sizeShortString(A),L+=l.sizeMixedArray(b,f);let B=l.alloc(d?4:3,a,L);return B.writeUInt8(h),B.writeShortString(A),B.writeMixedArray(b,f),B.buffer}static deserializeRequestMixedArgs(a){const h=a.readUInt8(),m=a.readShortString(),b=a.readMixedArray(),f=new Array(b.length);for(let d=0,A=b.length;d<A;d++){const L=b[d];typeof L=="string"?f[d]=JSON.parse(L):f[d]=L}return{rpcId:h,method:m,args:f}}static serializeAcknowledged(a){return l.alloc(5,a,0).buffer}static serializeCancel(a){return l.alloc(6,a,0).buffer}static serializeReplyOK(a,h,m){return typeof h=="undefined"?this._serializeReplyOKEmpty(a):h instanceof R.VSBuffer?this._serializeReplyOKVSBuffer(a,h):this._serializeReplyOKJSON(a,w(h,m))}static _serializeReplyOKEmpty(a){return l.alloc(7,a,0).buffer}static _serializeReplyOKVSBuffer(a,h){let m=0;m+=l.sizeVSBuffer(h);let b=l.alloc(8,a,m);return b.writeVSBuffer(h),b.buffer}static deserializeReplyOKVSBuffer(a){return a.readVSBuffer()}static _serializeReplyOKJSON(a,h){const m=R.VSBuffer.fromString(h);let b=0;b+=l.sizeLongString(m);let f=l.alloc(9,a,b);return f.writeLongString(m),f.buffer}static deserializeReplyOKJSON(a){const h=a.readLongString();return JSON.parse(h)}static serializeReplyErr(a,h){return h?this._serializeReplyErrEror(a,h):this._serializeReplyErrEmpty(a)}static _serializeReplyErrEror(a,h){const m=R.VSBuffer.fromString(w(T.transformErrorForSerialization(h),null));let b=0;b+=l.sizeLongString(m);let f=l.alloc(10,a,b);return f.writeLongString(m),f.buffer}static deserializeReplyErrError(a){const h=a.readLongString();return JSON.parse(h)}static _serializeReplyErrEmpty(a){return l.alloc(11,a,0).buffer}}var i;(function(r){r[r.RequestJSONArgs=1]="RequestJSONArgs",r[r.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",r[r.RequestMixedArgs=3]="RequestMixedArgs",r[r.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",r[r.Acknowledged=5]="Acknowledged",r[r.Cancel=6]="Cancel",r[r.ReplyOKEmpty=7]="ReplyOKEmpty",r[r.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",r[r.ReplyOKJSON=9]="ReplyOKJSON",r[r.ReplyErrError=10]="ReplyErrError",r[r.ReplyErrEmpty=11]="ReplyErrEmpty"})(i||(i={}));var o;(function(r){r[r.String=1]="String",r[r.VSBuffer=2]="VSBuffer",r[r.Undefined=3]="Undefined"})(o||(o={}))}),define(ge[257],pe([0,1,4]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,E.createDecorator)("remoteAgentService")}),define(ge[258],pe([0,1,11,8,9,2,4,257]),function(G,e,E,P,T,I,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,D.createDecorator)("pathService");let y=class{constructor(R,C){this.localUserHome=R,this.remoteAgentService=C,this.resolveOS=(async()=>{const w=await this.remoteAgentService.getEnvironment();return(w==null?void 0:w.os)||T.OS})(),this.resolveUserHome=(async()=>{const w=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(w==null?void 0:w.userHome)||R})()}async userHome(R){return(R==null?void 0:R.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(R=>R===1?P.win32:P.posix)}async fileURI(R){let C="";if(await this.resolveOS===1&&(R=R.replace(/\\/g,"/")),R[0]==="/"&&R[1]==="/"){const g=R.indexOf("/",2);g===-1?(C=R.substring(2),R="/"):(C=R.substring(2,g),R=R.substring(g)||"/")}return I.URI.from({scheme:E.Schemas.file,authority:C,path:R,query:"",fragment:""})}};y=je([Ue(1,k.IRemoteAgentService)],y),e.AbstractPathService=y}),define(ge[31],pe([0,1,14,33,23,30,10,4,8,18]),function(G,e,E,P,T,I,D,k,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const R="\u27EA ",C=" characters skipped \u27EB",w=(R.length+C.length+5)*2;e.ISearchService=(0,k.createDecorator)("searchService");var g;(function(F){F[F.file=0]="file",F[F.text=1]="text"})(g=e.SearchProviderType||(e.SearchProviderType={}));var s;(function(F){F[F.File=1]="File",F[F.Text=2]="Text"})(s=e.QueryType||(e.QueryType={}));function u(F){return!!F.preview}e.resultIsMatch=u;function S(F){return!!F.resource}e.isFileMatch=S;function v(F){return!!F.message}e.isProgressMessage=v;var _;(function(F){F[F.Normal=0]="Normal",F[F.NewSearchStarted=1]="NewSearchStarted"})(_=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class p{constructor(N){this.resource=N,this.results=[]}}e.FileMatch=p;class c{constructor(N,M,x){this.ranges=M;const O=Array.isArray(M)?M:[M];if(x&&x.matchLines===1&&l(O)){N=(0,D.getNLines)(N,x.matchLines);let V="",q=0,X=0;const me=Math.floor(x.charsPerLine/5),we=[];for(const Te of O){const Pe=Math.max(Te.startColumn-me,0),Fe=Te.startColumn+x.charsPerLine;if(Pe>X+me+w){const z=R+(Pe-X)+C;V+=z+N.slice(Pe,Fe),q+=Pe-(X+z.length)}else V+=N.slice(X,Fe);we.push(new i(0,Te.startColumn-q,Te.endColumn-q)),X=Fe}this.preview={text:V,matches:Array.isArray(this.ranges)?we:we[0]}}else{const V=Array.isArray(M)?M[0].startLineNumber:M.startLineNumber;this.preview={text:N,matches:(0,E.mapArrayOrNot)(M,q=>new t(q.startLineNumber-V,q.startColumn,q.endLineNumber-V,q.endColumn))}}}}e.TextSearchMatch=c;function l(F){const N=F[0].startLineNumber;for(const M of F)if(M.startLineNumber!==N||M.endLineNumber!==N)return!1;return!0}class t{constructor(N,M,x,O){this.startLineNumber=N,this.startColumn=M,this.endLineNumber=x,this.endColumn=O}}e.SearchRange=t;class i extends t{constructor(N,M,x){super(N,M,N,x)}}e.OneLineRange=i;var o;(function(F){F.Default="default",F.FileNames="fileNames",F.Type="type",F.Modified="modified",F.CountDescending="countDescending",F.CountAscending="countAscending"})(o=e.SearchSortOrder||(e.SearchSortOrder={}));function r(F,N=!0){const M=F&&F.files&&F.files.exclude,x=N&&F&&F.search&&F.search.exclude;if(!(!M&&!x)){if(!M||!x)return M||x;let O=Object.create(null);return O=T.mixin(O,T.deepClone(M)),O=T.mixin(O,T.deepClone(x),!0),O}}e.getExcludes=r;function a(F,N){return F.excludePattern&&P.match(F.excludePattern,N)?!1:F.includePattern||F.usingSearchPaths?F.includePattern&&P.match(F.includePattern,N)?!0:F.usingSearchPaths?!!F.folderQueries&&F.folderQueries.some(M=>{const x=M.folder.fsPath;if(I.isEqualOrParent(N,x)){const O=y.relative(x,N);return!M.includePattern||!!P.match(M.includePattern,O)}else return!1}):!1:!0}e.pathIncludedInQuery=a;var h;(function(F){F[F.unknownEncoding=1]="unknownEncoding",F[F.regexParseError=2]="regexParseError",F[F.globParseError=3]="globParseError",F[F.invalidLiteral=4]="invalidLiteral",F[F.rgProcessError=5]="rgProcessError",F[F.other=6]="other",F[F.canceled=7]="canceled"})(h=e.SearchErrorCode||(e.SearchErrorCode={}));class m extends Error{constructor(N,M){super(N);this.code=M}}e.SearchError=m;function b(F){const N=F.message;if((0,n.isPromiseCanceledError)(F))return new m(N,h.canceled);try{const M=JSON.parse(N);return new m(M.message,M.code)}catch(M){return new m(N,h.other)}}e.deserializeSearchError=b;function f(F){const N={message:F.message,code:F.code};return new Error(JSON.stringify(N))}e.serializeSearchError=f;function d(F){return F.type==="error"?!0:F.type==="success"}e.isSerializedSearchComplete=d;function A(F){return F.type==="success"}e.isSerializedSearchSuccess=A;function L(F){return!!F.path}e.isSerializedFileMatch=L;function B(F,N){const M=F.searchPath?F.searchPath:F.relativePath;return(0,D.fuzzyContains)(M,N)}e.isFilePatternMatch=B;class J{constructor(N){this.path=N,this.results=[]}addMatch(N){this.results.push(N)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=J;function j(F,N){const M=Object.assign(Object.assign({},F||{}),N||{});return Object.keys(M).filter(x=>{const O=M[x];return typeof O=="boolean"&&O})}e.resolvePatternsForProvider=j;class U{constructor(N,M){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},N.excludePattern||{}),M.excludePattern||{}),this._parsedExcludeExpression=P.parse(this._excludeExpression);let x=N.includePattern;M.includePattern&&(x?x=Object.assign(Object.assign({},x),M.includePattern):x=M.includePattern),x&&(this._parsedIncludeExpression=P.parse(x))}includedInQuerySync(N,M,x){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(N,M,x)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(N,M,x))}includedInQuery(N,M,x){return Promise.resolve(this._parsedExcludeExpression(N,M,x)).then(V=>!!V).then(V=>V?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(N,M,x)).then(q=>!!q):Promise.resolve(!0)).then(V=>V)}hasSiblingExcludeClauses(){return $(this._excludeExpression)}}e.QueryGlobTester=U;function $(F){for(const N in F)if(typeof F[N]!="boolean")return!0;return!1}}),define(ge[32],pe([0,1,14,19,21,3,24,11,72,25,10,15,2,166,4,12,185,59,60,27,13,7,31,5]),function(G,e,E,P,T,I,D,k,y,n,R,C,w,g,s,u,S,v,_,p,c,l,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function o(A,L,B){return new n.ExtUri(J=>m(J,B)).isEqual(A,L)}function r(A,L,B){return o(A.uri,L.uri,B)?0:(0,R.compare)(A.uri.toString(),L.uri.toString())}function a(A,L,B){return A.index!==L.index?A.index<L.index?-1:1:o(A.uri,L.uri,B)?(0,R.compare)(A.name,L.name):(0,R.compare)(A.uri.toString(),L.uri.toString())}function h(A,L,B,J){const j=A.slice(0).sort(($,F)=>B($,F,J)),U=L.slice(0).sort(($,F)=>B($,F,J));return(0,E.delta)(j,U,($,F)=>B($,F,J))}function m(A,L){const B=L.getCapabilities(A.scheme);return!(B&&B&1024)}class b extends v.Workspace{constructor(L,B,J,j,U,$){super(L,J.map(F=>new v.WorkspaceFolder(F)),j,$);this._name=B,this._isUntitled=U,this._workspaceFolders=[],this._structure=D.TernarySearchTree.forUris($),J.forEach(F=>{this._workspaceFolders.push(F),this._structure.set(F.uri,F)})}static toExtHostWorkspace(L,B,J,j){if(!L)return{workspace:null,added:[],removed:[]};const{id:U,name:$,folders:F,configuration:N,isUntitled:M}=L,x=[],O=B;B?F.forEach((me,we)=>{const Te=w.URI.revive(me.uri),Pe=b._findFolder(J||B,Te,j);Pe?(Pe.name=me.name,Pe.index=me.index,x.push(Pe)):x.push({uri:Te,name:me.name,index:we})}):x.push(...F.map(({uri:me,name:we,index:Te})=>({uri:w.URI.revive(me),name:we,index:Te}))),x.sort((me,we)=>me.index<we.index?-1:1);const V=new b(U,$,x,N?w.URI.revive(N):null,!!M,me=>m(me,j)),{added:q,removed:X}=h(O?O.workspaceFolders:[],V.workspaceFolders,r,j);return{workspace:V,added:q,removed:X}}static _findFolder(L,B,J){for(let j=0;j<L.folders.length;j++){const U=L.workspaceFolders[j];if(o(U.uri,B,J))return U}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(L,B){return B&&this._structure.get(L)&&(L=(0,n.dirname)(L)),this._structure.findSubstr(L)}resolveWorkspaceFolder(L){return this._structure.get(L)}}let f=class{constructor(L,B,J,j){this._onDidChangeWorkspace=new I.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidReceieveWorkspaceTrust=new I.Emitter,this.onDidReceiveWorkspaceTrust=this._onDidReceieveWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=j,this._extHostFileSystemInfo=J,this._requestIdProvider=new y.Counter,this._barrier=new P.Barrier,this._proxy=L.getProxy(i.MainContext.MainThreadWorkspace),this._messageService=L.getProxy(i.MainContext.MainThreadMessageService);const U=B.workspace;this._confirmedWorkspace=U?new b(U.id,U.name,[],U.configuration?w.URI.revive(U.configuration):null,!!U.isUntitled,$=>m($,J)):void 0}$initializeWorkspace(L,B){this._trusted=B,this.$acceptWorkspaceData(L),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?w.URI.from({scheme:k.Schemas.untitled,path:(0,n.basename)((0,n.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(L,B,J,...j){const U=[];if(Array.isArray(j)&&j.forEach(x=>{w.URI.isUri(x.uri)&&!U.some(O=>o(O.uri,x.uri,this._extHostFileSystemInfo))&&U.push({uri:x.uri,name:x.name||(0,n.basenameOrAuthority)(x.uri)})}),this._unconfirmedWorkspace||[B,J].some(x=>typeof x!="number"||x<0)||J===0&&U.length===0)return!1;const $=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(B+J>$.length)return!1;const F=$.slice(0);F.splice(B,J,...U.map(x=>({uri:x.uri,name:x.name||(0,n.basenameOrAuthority)(x.uri),index:void 0})));for(let x=0;x<F.length;x++){const O=F[x];if(F.some((V,q)=>q!==x&&o(O.uri,V.uri,this._extHostFileSystemInfo)))return!1}F.forEach((x,O)=>x.index=O);const{added:N,removed:M}=h($,F,a,this._extHostFileSystemInfo);if(N.length===0&&M.length===0)return!1;if(this._proxy){const x=L.displayName||L.name;this._proxy.$updateWorkspaceFolders(x,B,J,U).then(void 0,O=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(S.Severity.Error,(0,g.localize)(0,null,x,O.toString()),{extension:L},[])})}return this.trySetWorkspaceFolders(F),!0}getWorkspaceFolder(L,B){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,B)}async getWorkspaceFolder2(L,B){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,B)}async resolveWorkspaceFolder(L){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(L)}getPath(){if(!!this._actualWorkspace){const{folders:L}=this._actualWorkspace;if(L.length!==0)return L[0].uri.fsPath}}getRelativePath(L,B){let J,j="";if(typeof L=="string"?(J=w.URI.file(L),j=L):typeof L!="undefined"&&(J=L,j=L.fsPath),!J)return j;const U=this.getWorkspaceFolder(J,!0);if(!U)return j;typeof B=="undefined"&&this._actualWorkspace&&(B=this._actualWorkspace.folders.length>1);let $=(0,n.relativePath)(U.uri,J);return B&&U.name&&($=`${U.name}/${$}`),$}trySetWorkspaceFolders(L){this._actualWorkspace&&(this._unconfirmedWorkspace=b.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:L,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(L){const{workspace:B,added:J,removed:j}=b.toExtHostWorkspace(L,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=B||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:J,removed:j}))}findFiles(L,B,J,j,U=T.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${j.value}, entryPoint: findFiles`);let $;if(B===null?$=!1:B&&(typeof B=="string"?$=B:$=B.pattern),U&&U.isCancellationRequested)return Promise.resolve([]);const{includePattern:F,folder:N}=d(L);return this._proxy.$startFileSearch((0,C.withUndefinedAsNull)(F),(0,C.withUndefinedAsNull)(N),(0,C.withUndefinedAsNull)($),(0,C.withUndefinedAsNull)(J),U).then(M=>Array.isArray(M)?M.map(x=>w.URI.revive(x)):[])}async findTextInFiles(L,B,J,j,U=T.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${j.value}, entryPoint: findTextInFiles`);const $=this._requestIdProvider.getNext(),F=typeof B.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:B.previewOptions,{includePattern:N,folder:M}=d(B.include),x=typeof B.exclude=="string"?B.exclude:B.exclude?B.exclude.pattern:void 0,O={ignoreSymlinks:typeof B.followSymlinks=="boolean"?!B.followSymlinks:void 0,disregardIgnoreFiles:typeof B.useIgnoreFiles=="boolean"?!B.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof B.useGlobalIgnoreFiles=="boolean"?!B.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof B.useDefaultExcludes=="boolean"?!B.useDefaultExcludes:!0,fileEncoding:B.encoding,maxResults:B.maxResults,previewOptions:F,afterContext:B.afterContext,beforeContext:B.beforeContext,includePattern:N,excludePattern:x},V=!1;if(this._activeSearchCallbacks[$]=q=>{if(!V){const X=w.URI.revive(q.resource);q.results.forEach(me=>{(0,t.resultIsMatch)(me)?J({uri:X,preview:{text:me.preview.text,matches:(0,E.mapArrayOrNot)(me.preview.matches,we=>new l.Range(we.startLineNumber,we.startColumn,we.endLineNumber,we.endColumn))},ranges:(0,E.mapArrayOrNot)(me.ranges,we=>new l.Range(we.startLineNumber,we.startColumn,we.endLineNumber,we.endColumn))}):J({uri:X,text:me.text,lineNumber:me.lineNumber})})}},U.isCancellationRequested)return{};try{const q=await this._proxy.$startTextSearch(L,(0,C.withUndefinedAsNull)(M),O,$,U);return delete this._activeSearchCallbacks[$],q||{}}catch(q){throw delete this._activeSearchCallbacks[$],q}}$handleTextSearchResult(L,B){this._activeSearchCallbacks[B]&&this._activeSearchCallbacks[B](L)}saveAll(L){return this._proxy.$saveAll(L)}resolveProxy(L){return this._proxy.$resolveProxy(L)}get trusted(){return this._trusted}requestWorkspaceTrust(L){return this._proxy.$requestWorkspaceTrust(L)}$onDidReceiveWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidReceieveWorkspaceTrust.fire())}};f=je([Ue(0,c.IExtHostRpcService),Ue(1,p.IExtHostInitDataService),Ue(2,_.IExtHostFileSystemInfo),Ue(3,u.ILogService)],f),e.ExtHostWorkspace=f,e.IExtHostWorkspace=(0,s.createDecorator)("IExtHostWorkspace");function d(A){let L,B;return A&&(typeof A=="string"?L=A:(L=A.pattern,B=A.baseFolder||w.URI.file(A.base))),{includePattern:L,folder:B}}}),define(ge[35],pe([0,1,23,3,32,5,7,187,82,15,19,4,13,12,2]),function(G,e,E,P,T,I,D,k,y,n,R,C,w,g,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function u(i,o){if(o){const r=o.split(".");let a=i;for(let h=0;a&&h<r.length;h++)a=a[r[h]];return a}}function S(i){return i instanceof s.URI}function v(i){return i&&i.uri instanceof s.URI&&i.languageId&&typeof i.languageId=="string"}function _(i){return i&&!i.uri&&i.languageId&&typeof i.languageId=="string"}function p(i){return i&&i.uri instanceof s.URI&&(!i.name||typeof i.name=="string")&&(!i.index||typeof i.index=="number")}function c(i){if(S(i))return{resource:i};if(v(i))return{resource:i.uri,overrideIdentifier:i.languageId};if(_(i))return{overrideIdentifier:i.languageId};if(p(i))return{resource:i.uri};if(i===null)return{resource:null}}let l=class{constructor(o,r,a){this._proxy=o.getProxy(I.MainContext.MainThreadConfiguration),this._extHostWorkspace=r,this._logService=a,this._barrier=new R.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(o=>this._actual)}$initializeConfiguration(o){this._actual=new t(this._proxy,this._extHostWorkspace,o,this._logService),this._barrier.open()}$acceptConfigurationChanged(o,r){this.getConfigProvider().then(a=>a.$acceptConfigurationChanged(o,r))}};l=je([Ue(0,w.IExtHostRpcService),Ue(1,T.IExtHostWorkspace),Ue(2,g.ILogService)],l),e.ExtHostConfiguration=l;class t{constructor(o,r,a,h){this._onDidChangeConfiguration=new P.Emitter,this._proxy=o,this._logService=h,this._extHostWorkspace=r,this._configuration=k.Configuration.parse(a),this._configurationScopes=this._toMap(a.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(o,r){const a={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=k.Configuration.parse(o),this._configurationScopes=this._toMap(o.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(r,a))}getConfiguration(o,r,a){const h=c(r)||{},m=this._toReadonlyValue(o?u(this._configuration.getValue(void 0,h,this._extHostWorkspace.workspace),o):this._configuration.getValue(void 0,h,this._extHostWorkspace.workspace));o&&this._validateConfigurationAccess(o,h,a==null?void 0:a.identifier);function b(d){if(d==null)return null;if(typeof d=="boolean")return d?1:4;switch(d){case D.ConfigurationTarget.Global:return 1;case D.ConfigurationTarget.Workspace:return 4;case D.ConfigurationTarget.WorkspaceFolder:return 5}}const f={has(d){return typeof u(m,d)!="undefined"},get:(d,A)=>{this._validateConfigurationAccess(o?`${o}.${d}`:d,h,a==null?void 0:a.identifier);let L=u(m,d);if(typeof L=="undefined")L=A;else{let B;const J=(j,U)=>{let $;const F=()=>{B=B||(0,E.deepClone)(m),$=$||u(B,U)};return(0,n.isObject)(j)?new Proxy(j,{get:(N,M)=>{if(typeof M=="string"&&M.toLowerCase()==="tojson")return F(),()=>$;if(B)return $=$||u(B,U),$[M];const x=N[M];return typeof M=="string"?J(x,`${U}.${M}`):x},set:(N,M,x)=>(F(),$&&($[M]=x),!0),deleteProperty:(N,M)=>(F(),$&&delete $[M],!0),defineProperty:(N,M,x)=>(F(),$&&Object.defineProperty($,M,x),!0)}):j};L=J(L,d)}return L},update:(d,A,L,B)=>{d=o?`${o}.${d}`:d;const J=b(L);return A!==void 0?this._proxy.$updateConfigurationOption(J,d,A,h,B):this._proxy.$removeConfigurationOption(J,d,h,B)},inspect:d=>{var A,L,B,J,j,U,$,F;d=o?`${o}.${d}`:d;const N=(0,E.deepClone)(this._configuration.inspect(d,h,this._extHostWorkspace.workspace));if(N)return{key:d,defaultValue:(A=N.default)===null||A===void 0?void 0:A.value,globalValue:(L=N.user)===null||L===void 0?void 0:L.value,workspaceValue:(B=N.workspace)===null||B===void 0?void 0:B.value,workspaceFolderValue:(J=N.workspaceFolder)===null||J===void 0?void 0:J.value,defaultLanguageValue:(j=N.default)===null||j===void 0?void 0:j.override,globalLanguageValue:(U=N.user)===null||U===void 0?void 0:U.override,workspaceLanguageValue:($=N.workspace)===null||$===void 0?void 0:$.override,workspaceFolderLanguageValue:(F=N.workspaceFolder)===null||F===void 0?void 0:F.override,languageIds:N.overrideIdentifiers}}};return typeof m=="object"&&(0,E.mixin)(f,m,!1),Object.freeze(f)}_toReadonlyValue(o){const r=a=>(0,n.isObject)(a)?new Proxy(a,{get:(h,m)=>r(h[m]),set:(h,m,b)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(m)}' of object`)},deleteProperty:(h,m)=>{throw new Error(`TypeError: Cannot delete read only property '${String(m)}' of object`)},defineProperty:(h,m)=>{throw new Error(`TypeError: Cannot define property '${String(m)}' for a readonly object`)},setPrototypeOf:h=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):a;return r(o)}_validateConfigurationAccess(o,r,a){const h=y.OVERRIDE_PROPERTY_PATTERN.test(o)?4:this._configurationScopes.get(o),m=a?`[${a.value}] `:"";if(h===4){typeof(r==null?void 0:r.resource)=="undefined"&&this._logService.warn(`${m}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${o}', provide the URI of a resource or 'null' for any resource.`);return}if(h===3){(r==null?void 0:r.resource)&&this._logService.warn(`${m}Accessing a window scoped configuration for a resource is not expected. To associate '${o}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(o,r){const a=new k.ConfigurationChangeEvent(o,r,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(h,m)=>a.affectsConfiguration(h,c(m))})}_toMap(o){return o.reduce((r,a)=>(r.set(a[0],a[1]),r),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,C.createDecorator)("IExtHostConfiguration")});var tt=this&&this.__classPrivateFieldSet||function(G,e,E,P,T){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!T:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?T.call(G,E):T?T.value=E:e.set(G,E),E},He=this&&this.__classPrivateFieldGet||function(G,e,E,P){if(E==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!P:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?P:E==="a"?P.call(G):P?P.value:e.get(G)};define(ge[65],pe([0,1,2,19,3,5,7,32,39,35,21,34,13,27,4,11,9,12,62,208,18]),function(G,e,E,P,T,I,D,k,y,n,R,C,w,g,s,u,S,v,_,p,c){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(j){function U(F){if(F!=null)return F}j.from=U;function $(F){if(F!=null)return F}j.to=$})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var i;(function(j){function U(F){if(F!=null)return F}j.from=U;function $(F){if(F!=null)return F}j.to=$})(i=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var o;(function(j){function U(F){if(F!=null)return F}j.from=U;function $(F){if(F!=null)return F}j.to=$})(o=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var r;(function(j){function U(N){if(N){const M=N;return M&&!!M.process}else return!1}j.is=U;function $(N){if(N!=null){const M={process:N.process,args:N.args};return N.options&&(M.options=o.from(N.options)),M}}j.from=$;function F(N){if(N!=null)return new D.ProcessExecution(N.process,N.args,N.options)}j.to=F})(r=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var a;(function(j){function U(F){if(F!=null)return F}j.from=U;function $(F){if(F!=null)return F}j.to=$})(a=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var h;(function(j){function U(N){if(N){const M=N;return M&&(!!M.commandLine||!!M.command)}else return!1}j.is=U;function $(N){if(N!=null){const M={};return N.commandLine!==void 0?M.commandLine=N.commandLine:(M.command=N.command,M.args=N.args),N.options&&(M.options=a.from(N.options)),M}}j.from=$;function F(N){if(!(N==null||N.command===void 0&&N.commandLine===void 0))return N.commandLine?new D.ShellExecution(N.commandLine,N.options):new D.ShellExecution(N.command,N.args?N.args:[],N.options)}j.to=F})(h=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var m;(function(j){function U(N){if(N){let M=N;return M&&M.customExecution==="customExecution"}else return!1}j.is=U;function $(N){return{customExecution:"customExecution"}}j.from=$;function F(N,M){return M.get(N)}j.to=F})(m=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var b;(function(j){function U($,F){let N;return $.scope!==void 0&&typeof $.scope!="number"?N=$.scope.uri:$.scope!==void 0&&typeof $.scope=="number"&&($.scope===D.TaskScope.Workspace&&F&&F.workspaceFile?N=F.workspaceFile:N=p.USER_TASKS_GROUP_KEY),{id:$._id,workspaceFolder:N}}j.from=U})(b=e.TaskHandleDTO||(e.TaskHandleDTO={}));var f;(function(j){function U(N,M){if(N==null)return[];const x=[];for(let O of N){const V=$(O,M);V&&x.push(V)}return x}j.fromMany=U;function $(N,M){if(N!=null){let x;N.execution instanceof D.ProcessExecution?x=r.from(N.execution):N.execution instanceof D.ShellExecution?x=h.from(N.execution):N.execution&&N.execution instanceof D.CustomExecution&&(x=m.from(N.execution));const O=t.from(N.definition);let V;if(N.scope?typeof N.scope=="number"?V=N.scope:V=N.scope.uri:V=D.TaskScope.Workspace,!(!O||!V)){const q=N.group?N.group.id:void 0;return{_id:N._id,definition:O,name:N.name,source:{extensionId:M.identifier.value,label:N.source,scope:V},execution:x,isBackground:N.isBackground,group:q,presentationOptions:i.from(N.presentationOptions),problemMatchers:N.problemMatchers,hasDefinedMatchers:N.hasDefinedMatchers,runOptions:N.runOptions?N.runOptions:{reevaluateOnRerun:!0},detail:N.detail}}}}j.from=$;async function F(N,M,x){if(N!=null){let O;r.is(N.execution)?O=r.to(N.execution):h.is(N.execution)?O=h.to(N.execution):m.is(N.execution)&&(O=m.to(N._id,x));const V=t.to(N.definition);let q;if(N.source&&(N.source.scope!==void 0?typeof N.source.scope=="number"?q=N.source.scope:q=await M.resolveWorkspaceFolder(E.URI.revive(N.source.scope)):q=D.TaskScope.Workspace),!(!V||!q)){const X=new D.Task(V,q,N.name,N.source.label,O,N.problemMatchers);return N.isBackground!==void 0&&(X.isBackground=N.isBackground),N.group!==void 0&&(X.group=D.TaskGroup.from(N.group)),N.presentationOptions&&(X.presentationOptions=i.to(N.presentationOptions)),N._id&&(X._id=N._id),N.detail&&(X.detail=N.detail),X}}}j.to=F})(f=e.TaskDTO||(e.TaskDTO={}));var d;(function(j){function U(F){return F}j.from=U;function $(F){if(!!F)return Object.assign(Object.create(null),F)}j.to=$})(d=e.TaskFilterDTO||(e.TaskFilterDTO={}));class A{constructor(U,$,F){this._id=$,this._task=F,l.set(this,void 0),tt(this,l,U,"f")}get task(){return this._task}terminate(){He(this,l,"f").terminateTask(this)}fireDidStartProcess(U){}fireDidEndProcess(U){}}l=new WeakMap;var L;(function(j){function U($){return{id:$._id,task:void 0}}j.from=U})(L=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let B=class{constructor(U,$,F,N,M,x,O,V){this._onDidExecuteTask=new T.Emitter,this._onDidTerminateTask=new T.Emitter,this._onDidTaskProcessStarted=new T.Emitter,this._onDidTaskProcessEnded=new T.Emitter,this._proxy=U.getProxy(I.MainContext.MainThreadTask),this._workspaceProvider=F,this._editorService=N,this._configurationService=M,this._terminalService=x,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=O,this._deprecationService=V,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(U,$,F){if(!F)return new D.Disposable(()=>{});const N=this.nextHandle();return this._handlers.set(N,{type:$,provider:F,extension:U}),this._proxy.$registerTaskProvider(N,$),new D.Disposable(()=>{this._handlers.delete(N),this._proxy.$unregisterTaskProvider(N)})}registerTaskSystem(U,$){this._proxy.$registerTaskSystem(U,$)}fetchTasks(U){return this._proxy.$fetchTasks(d.from(U)).then(async $=>{const F=[];for(let N of $){const M=await f.to(N,this._workspaceProvider,this._providedCustomExecutions2);M&&F.push(M)}return F})}get taskExecutions(){const U=[];return this._taskExecutions.forEach($=>U.push($)),U}terminateTask(U){if(!(U instanceof A))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(U._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(U,$,F){const N=this._providedCustomExecutions2.get(U.id);if(N){if(this._activeCustomExecutions2.get(U.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(U.id,N),this._terminalService.attachPtyToTerminal($,await N.callback(F))}this._lastStartedTask=U.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(U)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(U){const $=await this.getTaskExecution(U);this._taskExecutionPromises.delete(U.id),this._taskExecutions.delete(U.id),this.customExecutionComplete(U),this._onDidTerminateTask.fire({execution:$})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(U){const $=await this.getTaskExecution(U.id);this._onDidTaskProcessStarted.fire({execution:$,processId:U.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(U){const $=await this.getTaskExecution(U.id);this._onDidTaskProcessEnded.fire({execution:$,exitCode:U.exitCode})}$provideTasks(U,$){const F=this._handlers.get(U);if(!F)return Promise.reject(new Error("no handler found"));const N=[],M=(0,P.asPromise)(()=>F.provider.provideTasks(R.CancellationToken.None)).then(x=>this.provideTasksInternal($,N,F,x));return new Promise(x=>{M.then(O=>{Promise.all(N).then(()=>{x(O)})})})}async $resolveTask(U,$){const F=this._handlers.get(U);if(!F)return Promise.reject(new Error("no handler found"));if($.definition.type!==F.type)throw new Error(`Unexpected: Task of type [${$.definition.type}] cannot be resolved by provider of type [${F.type}].`);const N=await f.to($,this._workspaceProvider,this._providedCustomExecutions2);if(!N)throw new Error("Unexpected: Task cannot be resolved.");const M=await F.provider.resolveTask(N,R.CancellationToken.None);if(!!M){this.checkDeprecation(M,F);const x=f.from(M,F.extension);if(!x)throw new Error("Unexpected: Task cannot be resolved.");if(M.definition!==N.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return m.is(x.execution)&&await this.addCustomExecution(x,M,!0),await this.resolveTaskInternal(x)}}nextHandle(){return this._handleCounter++}async addCustomExecution(U,$,F){const N=await this._proxy.$createTaskId(U);!F&&!this._providedCustomExecutions2.has(N)&&this._notProvidedCustomExecutions.add(N),this._providedCustomExecutions2.set(N,$.execution)}async getTaskExecution(U,$){if(typeof U=="string"){const M=this._taskExecutionPromises.get(U);if(!M)throw new Error("Unexpected: The specified task is missing an execution");return M}let F=this._taskExecutionPromises.get(U.id);if(F)return F;const N=new Promise(async(M,x)=>{const O=$||await f.to(U.task,this._workspaceProvider,this._providedCustomExecutions2);O?M(new A(this,U.id,O)):x("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(U.id,N),N.then(M=>(this._taskExecutions.set(U.id,M),M),M=>Promise.reject(M))}checkDeprecation(U,$){U._deprecated&&this._deprecationService.report("Task.constructor",$.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(U){this._activeCustomExecutions2.get(U.id)&&this._activeCustomExecutions2.delete(U.id),this._notProvidedCustomExecutions.has(U.id)&&this._lastStartedTask!==U.id&&(this._providedCustomExecutions2.delete(U.id),this._notProvidedCustomExecutions.delete(U.id));let F=this._notProvidedCustomExecutions.values(),N=F.next();for(;!N.done;)!this._activeCustomExecutions2.has(N.value)&&this._lastStartedTask!==N.value&&(this._providedCustomExecutions2.delete(N.value),this._notProvidedCustomExecutions.delete(N.value)),N=F.next()}};B=je([Ue(0,w.IExtHostRpcService),Ue(1,g.IExtHostInitDataService),Ue(2,k.IExtHostWorkspace),Ue(3,y.IExtHostDocumentsAndEditors),Ue(4,n.IExtHostConfiguration),Ue(5,C.IExtHostTerminalService),Ue(6,v.ILogService),Ue(7,_.IExtHostApiDeprecationService)],B),e.ExtHostTaskBase=B;let J=class extends B{constructor(U,$,F,N,M,x,O,V){super(U,$,F,N,M,x,O,V);this.registerTaskSystem(u.Schemas.vscodeRemote,{scheme:u.Schemas.vscodeRemote,authority:"",platform:S.PlatformToString(0)})}async executeTask(U,$){if(!$.execution)throw new Error("Tasks to execute must include an execution");const F=f.from($,U);if(F===void 0)throw new Error("Task is not valid");if(m.is(F.execution))await this.addCustomExecution(F,$,!1);else throw new c.NotSupportedError;const N=await this.getTaskExecution(await this._proxy.$getTaskExecution(F),$);return this._proxy.$executeTask(F).catch(M=>{throw new Error(M)}),N}provideTasksInternal(U,$,F,N){const M=[];if(N)for(let x of N){this.checkDeprecation(x,F),(!x.definition||!U[x.definition.type])&&this._logService.warn(`The task [${x.source}, ${x.name}] uses an undefined task type. The task will be ignored in the future.`);const O=f.from(x,F.extension);O&&m.is(O.execution)?(M.push(O),$.push(this.addCustomExecution(O,x,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:M,extension:F.extension}}async resolveTaskInternal(U){if(m.is(U.execution))return U;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(U,$){return{process:void 0,variables:Object.create(null)}}$getDefaultShellAndArgs(){throw new Error("Not implemented")}async $jsonTasksSupported(){return!1}async $findExecutable(U,$,F){}};J=je([Ue(0,w.IExtHostRpcService),Ue(1,g.IExtHostInitDataService),Ue(2,k.IExtHostWorkspace),Ue(3,y.IExtHostDocumentsAndEditors),Ue(4,n.IExtHostConfiguration),Ue(5,C.IExtHostTerminalService),Ue(6,v.ILogService),Ue(7,_.IExtHostApiDeprecationService)],J),e.WorkerExtHostTask=J,e.IExtHostTask=(0,s.createDecorator)("IExtHostTask")});var fn=this&&this.__rest||function(G,e){var E={};for(var P in G)Object.prototype.hasOwnProperty.call(G,P)&&e.indexOf(P)<0&&(E[P]=G[P]);if(G!=null&&typeof Object.getOwnPropertySymbols=="function")for(var T=0,P=Object.getOwnPropertySymbols(G);T<P.length;T++)e.indexOf(P[T])<0&&Object.prototype.propertyIsEnumerable.call(G,P[T])&&(E[P[T]]=G[P[T]]);return E};define(ge[259],pe([0,1,14,19,22,21,3,69,6,23,15,2,28,5,39,13,20,7,32,221,121]),function(G,e,E,P,T,I,D,k,y,n,R,C,w,g,s,u,S,v,_,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.createDefaultDocumentTestRoot=e.ExtHostTesting=void 0;const l=(f,d)=>`${f}:${d.toString()}`;let t=class{constructor(d,A,L){this.documents=A,this.workspace=L,this.resultsChangedEmitter=new D.Emitter,this.providers=new Map,this.ownedTests=new p.OwnedTestCollection,this.testSubscriptions=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=d.getProxy(g.MainContext.MainThreadTesting),this.workspaceObservers=new m(this.proxy),this.textDocumentObservers=new b(this.proxy,A)}registerTestProvider(d){const A=(0,w.generateUuid)();this.providers.set(A,d),this.proxy.$registerTestProvider(A);const L=[...this.testSubscriptions.keys()];return setTimeout(()=>{var B;for(const J of L)(B=this.testSubscriptions.get(J))===null||B===void 0||B.subscribeFn(A,d)},0),new v.Disposable(()=>{this.providers.delete(A),this.proxy.$unregisterTestProvider(A)})}createTextDocumentTestObserver(d){return this.textDocumentObservers.checkout(d.uri)}createWorkspaceTestObserver(d){return this.workspaceObservers.checkout(d.uri)}async runTests(d,A=I.CancellationToken.None){const L=B=>B.map(this.getInternalTestForReference,this).filter(R.isDefined).map(J=>({src:J.src,testId:J.item.extId}));await this.proxy.$runTests({exclude:d.exclude?L(d.exclude).map(B=>B.testId):void 0,tests:L(d.tests),debug:d.debug},A)}publishExtensionProvidedResults(d,A){this.proxy.$publishExtensionProvidedResults(S.TestResults.from((0,w.generateUuid)(),d),A)}$publishTestResults(d){this.results=Object.freeze(d.map(A=>(0,n.deepFreeze)(S.TestResults.to(A))).concat(this.results).sort((A,L)=>L.completedAt-A.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(d,A){const L=C.URI.revive(A),B=l(d,L);if(!this.testSubscriptions.has(B)){const J=new I.CancellationTokenSource;let j;if(d===1){let N=this.documents.getDocument(L);if(!N){const M=new y.DisposableStore;N=await new Promise(x=>{M.add((0,P.disposableTimeout)(()=>x(void 0),5e3)),M.add(this.documents.onDidAddDocuments(O=>{const V=O.find(q=>q.document.uri.toString()===L.toString());V&&x(V)}))}).finally(()=>M.dispose())}if(N){const M=await this.workspace.getWorkspaceFolder2(L,!1);j=x=>x.provideDocumentTestRoot?x.provideDocumentTestRoot(N.document,J.token):(0,e.createDefaultDocumentTestRoot)(x,N.document,M,J.token)}}else{const N=await this.workspace.getWorkspaceFolder2(L,!1);N&&(j=M=>M.provideWorkspaceTestRoot(N,J.token))}if(!!j){const U=async(N,M)=>{try{const x=await j(M);x&&F.addRoot(x,N)}catch(x){console.error(x)}},$=new y.DisposableStore,F=$.add(this.ownedTests.createForHierarchy(N=>this.proxy.$publishDiff(d,A,N)));$.add((0,y.toDisposable)(()=>J.dispose(!0)));for(const[N,M]of this.providers)U(N,M);F.pushDiff([3,-1]),this.testSubscriptions.set(B,{store:$,collection:F,subscribeFn:U})}}}async $expandTest(d,A){const L=(0,E.mapFind)(this.testSubscriptions.values(),B=>B.collection.treeId===d.src.tree?B:void 0);await(L==null?void 0:L.collection.expand(d.testId,A<0?Infinity:A)),this.flushCollectionDiffs()}$unsubscribeFromTests(d,A){var L;const B=C.URI.revive(A),J=l(d,B);(L=this.testSubscriptions.get(J))===null||L===void 0||L.store.dispose(),this.testSubscriptions.delete(J)}$acceptDiff(d,A,L){d===1?this.textDocumentObservers.acceptDiff(C.URI.revive(A),L):this.workspaceObservers.acceptDiff(C.URI.revive(A),L)}async $runTestsForProvider(d,A){const L=this.providers.get(d.tests[0].src.provider);if(!!L){const B=d.tests.map(({testId:U,src:$})=>this.ownedTests.getTestById(U,$.tree)).filter(R.isDefined).map(([U,$])=>$),J=d.excludeExtIds.map(U=>this.ownedTests.getTestById(U)).filter(R.isDefined).filter(([U,$])=>B.some(F=>U.comparePositions(F,$)===1));if(!!B.length){const j=U=>{for(const[$,F]of J){const N=$.comparePositions(F,U.id);if(N===1||N===3)return!0}return!1};try{await L.runTests({appendOutput:U=>{this.proxy.$appendOutputToRun(d.runId,T.VSBuffer.fromString(U))},appendMessage:(U,$)=>{j(U)||(this.flushCollectionDiffs(),this.proxy.$appendTestMessageInRun(d.runId,U.id,S.TestMessage.from($)))},setState:(U,$,F)=>{j(U)||(this.flushCollectionDiffs(),this.proxy.$updateTestStateInRun(d.runId,U.id,$,F))},tests:B.map(U=>o.unwrap(U.actual)),exclude:J.map(([,U])=>o.unwrap(U.actual)),debug:d.debug},A);for(const{collection:U}of this.testSubscriptions.values())U.flushDiff();return}catch(U){throw console.error(U),U}}}}$lookupTest(d){const A=this.ownedTests.getTestById(d.testId);if(!A)return Promise.resolve(void 0);const L=A[1],{actual:B,discoverCts:J,expandLevels:j}=L,U=fn(L,["actual","discoverCts","expandLevels"]);return Promise.resolve(U)}flushCollectionDiffs(){for(const{collection:d}of this.testSubscriptions.values())d.flushDiff()}getInternalTestForReference(d){var A,L;return(L=(A=this.workspaceObservers.getMirroredTestDataByReference(d))!==null&&A!==void 0?A:(0,E.mapFind)(this.testSubscriptions.values(),B=>B.collection.getTestByReference(d)))!==null&&L!==void 0?L:this.textDocumentObservers.getMirroredTestDataByReference(d)}};t=je([Ue(0,u.IExtHostRpcService),Ue(1,s.IExtHostDocumentsAndEditors),Ue(2,_.IExtHostWorkspace)],t),e.ExtHostTesting=t;const i=async(f,d,A,L)=>{if(!!A){const B=await f.provideWorkspaceTestRoot(A,L);if(!!B)return L.onCancellationRequested(()=>{o.removeFilter(d)}),o.getWrapperForTestItem(B,d)}};e.createDefaultDocumentTestRoot=i;class o extends v.TestItem{constructor(d,A,L){super(d.id,d.label,d.uri,d.expandable);if(this.actual=d,this.filterDocument=A,this.parent=L,!(d instanceof v.TestItem))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${d.id} did not`);d[v.TestItemHookProperty]={setProp:(B,J)=>this[B]=J,created:B=>o.getWrapperForTestItem(B,this.filterDocument,this).refreshMatch(),invalidate:()=>this.invalidate(),delete:B=>this.children.delete(B)}}static removeFilter(d){this.wrapperMap.delete(d)}static getWrapperForTestItem(d,A,L){let B=this.wrapperMap.get(A);if(B==null?void 0:B.has(d))return B.get(d);B||(B=new WeakMap,this.wrapperMap.set(A,B));const J=new o(d,A,L);return B.set(d,J),J}static unwrap(d){return d instanceof o?d.actual:d}get hasNodeMatchingFilter(){return this._cachedMatchesFilter===void 0?this.refreshMatch():this._cachedMatchesFilter}refreshMatch(){var d;const A=this._cachedMatchesFilter;for(const B of this.actual.children){const J=o.getWrapperForTestItem(B,this.filterDocument,this);J.hasNodeMatchingFilter?this.children.add(J):this.children.delete(J)}const L=this.children.size>0||this.actual.uri.toString()===this.filterDocument.uri.toString();return this._cachedMatchesFilter=L,L!==A&&((d=this.parent)===null||d===void 0||d.refreshMatch()),this._cachedMatchesFilter}}e.TestItemFilteredWrapper=o,o.wrapperMap=new WeakMap;class r extends c.IncrementalChangeCollector{constructor(d){super();this.emitter=d,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(d){this.added.add(d)}update(d){Object.assign(d.revived,S.TestItem.toPlain(d.item)),this.added.has(d)||this.updated.add(d)}remove(d){if(this.added.has(d)){this.added.delete(d);return}if(this.updated.delete(d),d.parent&&this.alreadyRemoved.has(d.parent)){this.alreadyRemoved.add(d.item.extId);return}this.removed.add(d)}getChangeEvent(){const{added:d,updated:A,removed:L}=this;return{get added(){return[...d].map(B=>B.revived)},get updated(){return[...A].map(B=>B.revived)},get removed(){return[...L].map(B=>B.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class a extends c.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new D.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(d){let A=[];for(const L of d){const B=this.items.get(L);B&&A.push(B.revived)}return A}getMirroredTestDataById(d){return this.items.get(d)}getMirroredTestDataByReference(d){return this.items.get(d.id)}createItem(d,A){return Object.assign(Object.assign({},d),{revived:S.TestItem.toPlain(d.item),depth:A?A.depth+1:0,children:new Set})}createChangeCollector(){return new r(this.changeEmitter)}}e.MirroredTestCollection=a;class h{constructor(){this.resources=new Map}checkout(d){var A,L;const B=d.toString(),J=(A=this.resources.get(B))!==null&&A!==void 0?A:this.createObserverData(d);return(L=J.pendingDeletion)===null||L===void 0||L.dispose(),J.observers++,{onDidChangeTest:J.tests.onDidChangeTests,onDidDiscoverInitialTests:new D.Emitter().event,get tests(){return J.tests.rootTestItems},dispose:(0,k.once)(()=>{--J.observers||(J.pendingDeletion=this.eventuallyDispose(d))})}}getMirroredTestDataByReference(d){for(const{tests:A}of this.resources.values()){const L=A.getMirroredTestDataByReference(d);if(L)return L}}eventuallyDispose(d){return(0,P.disposableTimeout)(()=>this.unlisten(d),10*1e3)}createObserverData(d){const A=new a,L=this.listen(d,J=>A.apply(J)),B={observers:0,tests:A,listener:L};return this.resources.set(d.toString(),B),B}unlisten(d){var A;const L=d.toString(),B=this.resources.get(L);B&&(B.observers=-1,(A=B.pendingDeletion)===null||A===void 0||A.dispose(),B.listener.dispose(),this.resources.delete(L))}}class m extends h{constructor(d){super();this.proxy=d,this.diffListeners=new Map}acceptDiff(d,A){var L;(L=this.diffListeners.get(d.toString()))===null||L===void 0||L(A)}listen(d,A){this.proxy.$subscribeToDiffs(0,d);const L=d.toString();return this.diffListeners.set(L,A),new v.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,d),this.diffListeners.delete(L)})}}class b extends h{constructor(d,A){super();this.proxy=d,this.documents=A,this.diffListeners=new Map}acceptDiff(d,A){var L;(L=this.diffListeners.get(d.toString()))===null||L===void 0||L(A)}listen(d,A){if(!this.documents.getDocument(d))return new v.Disposable(()=>{});const B=d.toString();return this.diffListeners.set(B,A),this.proxy.$subscribeToDiffs(1,d),new v.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,d),this.diffListeners.delete(B)})}}}),define(ge[260],pe([0,1,14,53,33,75,24,11,8,25,10,15,2,139,172,83,59,213,258,31]),function(G,e,E,P,T,I,D,k,y,n,R,C,w,g,s,u,S,v,_,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let c=class{constructor(b,f,d,A){this.configurationService=b,this.workspaceContextService=f,this.editorGroupsService=d,this.pathService=A}text(b,f,d={}){b=this.getContentPattern(b,d);const A=this.configurationService.getValue(),L=f&&f.some(J=>!this.configurationService.getValue({resource:J}).search.useRipgrep),B=this.commonQuery(f==null?void 0:f.map(S.toWorkspaceFolder),d);return Object.assign(Object.assign({},B),{type:2,contentPattern:b,previewOptions:d.previewOptions,maxFileSize:d.maxFileSize,usePCRE2:A.search.usePCRE2||L||!1,beforeContext:d.beforeContext,afterContext:d.afterContext,userDisabledExcludesAndIgnoreFiles:d.disregardExcludeSettings&&d.disregardIgnoreFiles})}getContentPattern(b,f){const d=this.configurationService.getValue();b.isRegExp&&(b.pattern=b.pattern.replace(/\r?\n/g,"\\n"));const A=Object.assign(Object.assign({},b),{wordSeparators:d.editor.wordSeparators});return this.isCaseSensitive(b,f)&&(A.isCaseSensitive=!0),this.isMultiline(b)&&(A.isMultiline=!0),A}file(b,f={}){const d=this.commonQuery(b,f);return Object.assign(Object.assign({},d),{type:1,filePattern:f.filePattern?f.filePattern.trim():f.filePattern,exists:f.exists,sortByScore:f.sortByScore,cacheKey:f.cacheKey})}handleIncludeExclude(b,f){return b?(b=Array.isArray(b)?b.map(r):r(b),f?this.parseSearchPaths(b):{pattern:t(...Array.isArray(b)?b:[b])}):{}}commonQuery(b=[],f={}){const d=this.handleIncludeExclude(f.includePattern,f.expandPatterns),A=this.handleIncludeExclude(f.excludePattern,f.expandPatterns),L=b.length>1,B=(d.searchPaths&&d.searchPaths.length?d.searchPaths.map(U=>this.getFolderQueryForSearchPath(U,f,A)):b.map(U=>this.getFolderQueryForRoot(U,f,A,L))).filter(U=>!!U),J={_reason:f._reason,folderQueries:B,usingSearchPaths:!!(d.searchPaths&&d.searchPaths.length),extraFileResources:f.extraFileResources,excludePattern:A.pattern,includePattern:d.pattern,onlyOpenEditors:f.onlyOpenEditors,maxResults:f.maxResults};if(f.onlyOpenEditors){const $=E.coalesce(E.flatten(this.editorGroupsService.groups.map(N=>N.editors.map(M=>M.resource)))).filter(N=>(0,p.pathIncludedInQuery)(J,N.fsPath)),F=this.commonQueryFromFileList($);return Object.assign(Object.assign({},J),F)}const j=f.extraFileResources&&f.extraFileResources.filter(U=>(0,p.pathIncludedInQuery)(J,U.fsPath));return J.extraFileResources=j&&j.length?j:void 0,J}commonQueryFromFileList(b){const f=[],d=new D.ResourceMap,A={};let L=!1;return b.forEach(B=>{var J,j;if(B.scheme!==k.Schemas.walkThrough)if((0,n.isAbsolutePath)(B)){const $=(j=(J=this.workspaceContextService.getWorkspaceFolder(B))===null||J===void 0?void 0:J.uri)!==null&&j!==void 0?j:B.with({path:y.dirname(B.fsPath)});let F=d.get($);F||(L=!0,F={folder:$,includePattern:{}},f.push(F),d.set($,F));const N=y.relative($.fsPath,B.fsPath);(0,C.assertIsDefined)(F.includePattern)[N.replace(/\\/g,"/")]=!0}else B.fsPath&&(L=!0,A[B.fsPath]=!0)}),{folderQueries:f,includePattern:A,usingSearchPaths:!0,excludePattern:L?void 0:{"**/*":!0}}}isCaseSensitive(b,f){if(f.isSmartCase){if(b.isRegExp){if(R.containsUppercaseCharacter(b.pattern,!0))return!0}else if(R.containsUppercaseCharacter(b.pattern))return!0}return!!b.isCaseSensitive}isMultiline(b){return b.isMultiline||b.isRegExp&&(0,g.isMultilineRegexSource)(b.pattern)||b.pattern.indexOf(`
`)>=0?!0:!!b.isMultiline}parseSearchPaths(b){const f=F=>y.isAbsolute(F)||/^\.\.?([\/\\]|$)/.test(F),A=(Array.isArray(b)?b:i(b)).map(F=>{const N=this.pathService.resolvedUserHome;return N?(0,I.untildify)(F,N.scheme===k.Schemas.file?N.fsPath:N.path):F}),L=P.groupBy(A,F=>f(F)?"searchPaths":"exprSegments"),B=(L.exprSegments||[]).map(F=>R.rtrim(F,"/")).map(F=>R.rtrim(F,"\\")).map(F=>(F[0]==="."&&(F="*"+F),o(F))),J={},j=this.expandSearchPathPatterns(L.searchPaths||[]);j&&j.length&&(J.searchPaths=j);const U=E.flatten(B),$=t(...U);return $&&(J.pattern=$),J}getExcludesForFolder(b,f){return f.disregardExcludeSettings?void 0:(0,p.getExcludes)(b,!f.disregardSearchExcludeSettings)}expandSearchPathPatterns(b){if(!b||!b.length)return[];const f=E.flatten(b.map(A=>{let{pathPortion:L,globPortion:B}=l(A);B&&(B=a(B));const J=this.expandOneSearchPath(L);return E.flatten(J.map(j=>this.resolveOneSearchPathPattern(j,B)))})),d=new Map;return f.forEach(A=>{const L=A.searchPath.toString(),B=d.get(L);B?A.pattern&&(B.pattern=B.pattern||{},B.pattern[A.pattern]=!0):d.set(L,{searchPath:A.searchPath,pattern:A.pattern?t(A.pattern):void 0})}),Array.from(d.values())}expandOneSearchPath(b){if(y.isAbsolute(b)){const f=this.workspaceContextService.getWorkspace().folders;return f[0]&&f[0].uri.scheme!==k.Schemas.file?[{searchPath:f[0].uri.with({path:b})}]:[{searchPath:w.URI.file(y.normalize(b))}]}if(this.workspaceContextService.getWorkbenchState()===2){const f=this.workspaceContextService.getWorkspace().folders[0].uri;if(b=r(b),b.startsWith("../")||b===".."){const A=y.posix.resolve(f.path,b);return[{searchPath:f.with({path:A})}]}const d=a(b);return[{searchPath:f,pattern:d}]}else{if(b==="./"||b===".\\")return[];{const f=b.match(/\.[\/\\]([^\/\\]+)(?:[\/\\](.+))?/);if(f){const d=f[1],A=this.workspaceContextService.getWorkspace().folders.filter(L=>L.name===d);if(A.length)return A.map(L=>{const B=f[2];return{searchPath:L.uri,pattern:B&&a(B)}});{const L=s.localize(0,null,d);throw new Error(L)}}}}return[]}resolveOneSearchPathPattern(b,f){const d=b.pattern&&f?`${b.pattern}/${f}`:b.pattern||f,A=[{searchPath:b.searchPath,pattern:d}];return d&&!d.endsWith("**")&&A.push({searchPath:b.searchPath,pattern:d+"/**"}),A}getFolderQueryForSearchPath(b,f,d){const A=this.getFolderQueryForRoot((0,S.toWorkspaceFolder)(b.searchPath),f,d,!1);return A?Object.assign(Object.assign({},A),{includePattern:b.pattern}):null}getFolderQueryForRoot(b,f,d,A){let L;const B=w.URI.isUri(b)?b:b.uri;if(d.searchPaths){const F=d.searchPaths.filter(N=>(0,n.isEqual)(N.searchPath,B))[0];if(F&&!F.pattern)return null;F&&(L=F.pattern)}const J=this.configurationService.getValue({resource:B}),j=this.getExcludesForFolder(J,f),U=Object.assign(Object.assign({},j||{}),L||{}),$=w.URI.isUri(b)?(0,n.basename)(b):b.name;return{folder:B,folderName:A?$:void 0,excludePattern:Object.keys(U).length>0?U:void 0,fileEncoding:J.files&&J.files.encoding,disregardIgnoreFiles:typeof f.disregardIgnoreFiles=="boolean"?f.disregardIgnoreFiles:!J.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof f.disregardGlobalIgnoreFiles=="boolean"?f.disregardGlobalIgnoreFiles:!J.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof f.ignoreSymlinks=="boolean"?f.ignoreSymlinks:!J.search.followSymlinks}}};c=je([Ue(0,u.IConfigurationService),Ue(1,S.IWorkspaceContextService),Ue(2,v.IEditorGroupsService),Ue(3,_.IPathService)],c),e.QueryBuilder=c;function l(m){const b=m.match(/[\*\{\}\(\)\[\]\?]/);if(b){const f=b.index,d=m.substr(0,f).match(/[/|\\][^/\\]*$/);if(d){let A=m.substr(0,d.index);return A.match(/[/\\]/)||(A+="/"),{pathPortion:A,globPortion:m.substr((d.index||0)+1)}}}return{pathPortion:m}}function t(...m){return m.length?m.reduce((b,f)=>(b[f]=!0,b),Object.create(null)):void 0}function i(m){return T.splitGlobAware(m,",").map(b=>b.trim()).filter(b=>!!b.length)}function o(m){return[`**/${m}/**`,`**/${m}`].map(f=>f.replace(/\*\*\/\*\*/g,"**"))}function r(m){return m.replace(/\\/g,"/")}function a(m){return r(m).replace(/^\.\//,"").replace(/\/+$/g,"")}function h(m,b){m=E.distinct(m,A=>A.toString());const f=[],d=b.getWorkspace();return m&&m.forEach(A=>{let L;if(b.getWorkbenchState()===2)L=(0,n.relativePath)(d.folders[0].uri,A),L&&L!=="."&&(L="./"+L);else{const B=b.getWorkspaceFolder(A);if(B){const J=B.name;if(d.folders.filter(U=>U.name===J).length===1){const U=(0,n.relativePath)(B.uri,A);U===""?L=`./${B.name}`:L=`./${B.name}/${U}`}else L=A.fsPath}}L&&f.push(L)}),f}e.resolveResourcesForSearchIncludes=h}),define(ge[261],pe([0,1,25,2,21,18,4,260,31,59]),function(G,e,E,P,T,I,D,k,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const R=7e3;function C(u,S){const v=S.activationEvents;if(!v)return Promise.resolve(void 0);const _=[],p=[];for(const r of v)if(/^workspaceContains:/.test(r)){const a=r.substr("workspaceContains:".length);a.indexOf("*")>=0||a.indexOf("?")>=0||u.forceUsingSearch?p.push(a):_.push(a)}if(_.length===0&&p.length===0)return Promise.resolve(void 0);let c;const l=new Promise((r,a)=>{c=r}),t=r=>c({activationEvent:r}),i=Promise.all(_.map(r=>w(u,r,t))).then(()=>{}),o=g(u,S.identifier,p,t);return Promise.all([i,o]).then(()=>{c(void 0)}),l}e.checkActivateWorkspaceContainsExtension=C;async function w(u,S,v){for(const _ of u.folders)if(await u.exists(E.joinPath(P.URI.revive(_),S))){v(`workspaceContains:${S}`);return}}async function g(u,S,v,_){if(v.length===0)return Promise.resolve(void 0);const p=new T.CancellationTokenSource,c=u.checkExists(u.folders,v,p.token),l=setTimeout(async()=>{p.cancel(),_(`workspaceContainsTimeout:${v.join(",")}`)},R);let t=!1;try{t=await c}catch(i){I.isPromiseCanceledError(i)||I.onUnexpectedError(i)}p.dispose(),clearTimeout(l),t&&_(`workspaceContains:${v.join(",")}`)}function s(u,S,v,_){const p=u.get(D.IInstantiationService),c=u.get(y.ISearchService),t=p.createInstance(k.QueryBuilder).file(S.map(i=>(0,n.toWorkspaceFolder)(P.URI.revive(i))),{_reason:"checkExists",includePattern:v,exists:!0});return c.fileSearch(t,_).then(i=>!!i.limitHit,i=>I.isPromiseCanceledError(i)?!1:Promise.reject(i))}e.checkGlobFileExists=s});var tt=this&&this.__classPrivateFieldSet||function(G,e,E,P,T){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!T:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?T.call(G,E):T?T.value=E:e.set(G,E),E},He=this&&this.__classPrivateFieldGet||function(G,e,E,P){if(E==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!P:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?P:E==="a"?P.call(G):P?P.value:e.get(G)};define(ge[42],pe([0,1,161,8,66,25,19,6,24,2,12,5,35,224,88,32,41,222,18,29,11,22,195,7,113,4,27,89,13,81,50,34,3,261,86,196]),function(G,e,E,P,T,I,D,k,y,n,R,C,w,g,s,u,S,v,_,p,c,l,t,i,o,r,a,h,m,b,f,d,A,L,B,J){"use strict";var j,U,$;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let F=class Mn extends k.Disposable{constructor(O,V,q,X,me,we,Te,Pe,Fe,z){super();this._onDidChangeRemoteConnectionData=this._register(new A.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=V,this._extHostContext=q,this._initData=Te,this._extHostWorkspace=X,this._extHostConfiguration=me,this._logService=we,this._extHostTunnelService=Fe,this._extHostTerminalService=z,this._disposables=new k.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(C.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(C.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(C.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new D.Barrier,this._readyToStartExtensionHost=new D.Barrier,this._readyToRunExtensions=new D.Barrier,this._eagerExtensionsActivated=new D.Barrier,this._registry=new v.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new s.ExtHostStorage(this._extHostContext),this._secretState=new B.ExtHostSecretState(this._extHostContext),this._storagePath=Pe,this._instaService=O.createChild(new b.ServiceCollection([s.IExtHostStorage,this._storage],[B.IExtHostSecretState,this._secretState]));const Y=new Set;this._initData.hostExtensions.forEach(te=>Y.add(p.ExtensionIdentifier.toKey(te))),this._activator=new g.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(te,ae)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(te,ae)},actualActivateExtension:async(te,ae)=>{if(Y.has(p.ExtensionIdentifier.toKey(te)))return await this._mainThreadExtensionsProxy.$activateExtension(te,ae),new g.HostExtension;const he=this._registry.getExtensionDescription(te);return this._activateExtension(he,ae)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),T.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(O){_.onUnexpectedError(O)}}async deactivateAll(){let O=[];try{O=this._registry.getAllExtensionDescriptions().map(me=>me.identifier).filter(me=>this.isActivated(me)).map(me=>this._deactivate(me))}catch(V){}await Promise.all(O)}isActivated(O){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(O):!1}_activateByEvent(O,V){return this._activator.activateByEvent(O,V)}_activateById(O,V){return this._activator.activateById(O,V)}activateByIdWithErrors(O,V){return this._activateById(O,V).then(()=>{const q=this._activator.getActivatedExtension(O);if(q.activationFailed)return Promise.reject(q.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(O=>this._registry)}getExtensionExports(O){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(O).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const O=y.TernarySearchTree.forPaths(),V=this._registry.getAllExtensionDescriptions().map(q=>{if(!!this._getEntryPoint(q))return this._hostUtils.realpath(q.extensionLocation.fsPath).then(X=>O.set(n.URI.file(X).fsPath,q))});this._extensionPathIndex=Promise.all(V).then(()=>O)}return this._extensionPathIndex}_deactivate(O){let V=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(O))return V;const q=this._activator.getActivatedExtension(O);if(!q)return V;try{typeof q.module.deactivate=="function"&&(V=Promise.resolve(q.module.deactivate()).then(void 0,X=>Promise.resolve(void 0)))}catch(X){}try{(0,k.dispose)(q.subscriptions)}catch(X){}return V}async _activateExtension(O,V){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier),this._doActivateExtension(O,V).then(q=>{const X=q.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(O.identifier,X.codeLoadingTime,X.activateCallTime,X.activateResolvedTime,V),this._logExtensionActivationTimes(O,V,"success",X),q},q=>{throw this._logExtensionActivationTimes(O,V,"failure"),q})}_logExtensionActivationTimes(O,V,q,X){const me=N(O,V);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},me),X||{}),{outcome:q}))}_doActivateExtension(O,V){const q=N(O,V);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",q);const X=this._getEntryPoint(O);if(!X)return Promise.resolve(new g.EmptyExtension(g.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${O.identifier.value} ${JSON.stringify(V)}`),this._logService.flush();const me=new g.ExtensionActivationTimesBuilder(V.startup);return Promise.all([this._loadCommonJSModule(O.identifier,(0,I.joinPath)(O.extensionLocation,X),me),this._loadExtensionContext(O)]).then(we=>(T.mark(`code/extHost/willActivateExtension/${O.identifier.value}`),Mn._callActivate(this._logService,O.identifier,we[0],we[1],me))).then(we=>(T.mark(`code/extHost/didActivateExtension/${O.identifier.value}`),we))}_loadExtensionContext(O){const V=new t.ExtensionGlobalMemento(O,this._storage),q=new t.ExtensionMemento(O.identifier.value,!1,this._storage),X=new J.ExtensionSecrets(O,this._secretState),me=O.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,we=this._initData.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${O.identifier.value}`),Promise.all([V.whenReady,q.whenReady,this._storagePath.whenReady]).then(()=>{const Te=this;let Pe;return Object.freeze({globalState:V,workspaceState:q,secrets:X,subscriptions:[],get extensionUri(){return O.extensionLocation},get extensionPath(){return O.extensionLocation.fsPath},asAbsolutePath(Fe){return P.join(O.extensionLocation.fsPath,Fe)},get storagePath(){var Fe;return(Fe=Te._storagePath.workspaceValue(O))===null||Fe===void 0?void 0:Fe.fsPath},get globalStoragePath(){return Te._storagePath.globalValue(O).fsPath},get logPath(){return P.join(Te._initData.logsLocation.fsPath,O.identifier.value)},get logUri(){return n.URI.joinPath(Te._initData.logsLocation,O.identifier.value)},get storageUri(){return Te._storagePath.workspaceValue(O)},get globalStorageUri(){return Te._storagePath.globalValue(O)},get extensionMode(){return me},get extension(){return Pe===void 0&&(Pe=new M(Te,O.identifier,O,we)),Pe},get extensionRuntime(){return(0,S.checkProposedApiEnabled)(O),Te.extensionRuntime},get environmentVariableCollection(){return Te._extHostTerminalService.getEnvironmentVariableCollection(O)}})})}static _callActivate(O,V,q,X,me){return q=q||{activate:void 0,deactivate:void 0},this._callActivateOptional(O,V,q,X,me).then(we=>new g.ActivatedExtension(!1,null,me.build(),q,we,X.subscriptions))}static _callActivateOptional(O,V,q,X,me){if(typeof q.activate=="function")try{me.activateCallStart(),O.trace(`ExtensionService#_callActivateOptional ${V.value}`);const we=typeof global=="object"?global:self,Te=q.activate.apply(we,[X]);return me.activateCallStop(),me.activateResolveStart(),Promise.resolve(Te).then(Pe=>(me.activateResolveStop(),Pe))}catch(we){return Promise.reject(we)}else return Promise.resolve(q)}_activateOneStartupFinished(O,V){this._activateById(O.identifier,{startup:!1,extensionId:O.identifier,activationEvent:V}).then(void 0,q=>{this._logService.error(q)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(T.getMarks());for(const O of this._registry.getAllExtensionDescriptions())if(O.activationEvents)for(const V of O.activationEvents)V==="onStartupFinished"&&this._activateOneStartupFinished(O,V)}_handleEagerExtensions(){const O=this._activateByEvent("*",!0).then(void 0,me=>{this._logService.error(me)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(me=>this._handleWorkspaceContainsEagerExtensions(me.added)));const V=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],q=this._handleWorkspaceContainsEagerExtensions(V),X=Promise.all([O,q]).then(()=>{});return Promise.race([X,(0,D.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),X}_handleWorkspaceContainsEagerExtensions(O){return O.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(V=>this._handleWorkspaceContainsEagerExtension(O,V))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(O,V){if(!this.isActivated(V.identifier)){const q=!this._initData.remote.isRemote&&!!this._initData.remote.authority,X={folders:O.map(we=>we.uri),forceUsingSearch:q,exists:we=>this._hostUtils.exists(we.fsPath),checkExists:(we,Te,Pe)=>this._mainThreadWorkspaceProxy.$checkExists(we,Te,Pe)},me=await(0,L.checkActivateWorkspaceContainsExtension)(X,V);if(!!me)return this._activateById(V.identifier,{startup:!0,extensionId:V.identifier,activationEvent:me.activationEvent}).then(void 0,we=>this._logService.error(we))}}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return this._doHandleExtensionTests()}catch(O){throw console.error(O),O}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:O,extensionTestsLocationURI:V}=this._initData.environment;if(!O||!V||V.scheme!==c.Schemas.file)throw new Error(E.localize(0,null));const q=(0,I.originalFSPath)(V),X=await this._loadCommonJSModule(null,V,new g.ExtensionActivationTimesBuilder(!1));if(!X||typeof X.run!="function")throw new Error(E.localize(1,null,q));return new Promise((me,we)=>{const Te=(Fe,z)=>{Fe?we(Fe):me(typeof z=="number"&&z>0?1:0)},Pe=X.run(q,Te);Pe&&Pe.then&&Pe.then(()=>{me(0)}).catch(Fe=>{we(Fe.toString())})})}async $extensionTestsExit(O){this._logService.info(`extension host terminating: test runner requested exit with code ${O}`),this._logService.info(`exiting with code ${O}`),this._logService.flush(),this._hostUtils.exit(O)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(O,V){return this._resolvers[O]=V,(0,k.toDisposable)(()=>{delete this._resolvers[O]})}async $resolveAuthority(O,V){const q=O.indexOf("+");if(q===-1)throw new Error("Not an authority that can be resolved!");const X=O.substr(0,q);await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${X}`,!1);const me=this._resolvers[X];if(!me)return{type:"error",error:{code:o.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${X}.`,detail:void 0}};try{T.mark(`code/extHost/willResolveAuthority/${X}`);const we=await me.resolve(O,{resolveAttempt:V});T.mark(`code/extHost/didResolveAuthorityOK/${X}`),this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(me));const Te={authority:O,host:we.host,port:we.port,connectionToken:we.connectionToken},Pe={extensionHostEnv:we.extensionHostEnv};return{type:"ok",value:{authority:Te,options:Pe,tunnelInformation:{environmentTunnels:we.environmentTunnels}}}}catch(we){if(T.mark(`code/extHost/didResolveAuthorityError/${X}`),we instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:we._code,message:we._message,detail:we._detail}};throw we}}$startExtensionHost(O){return this._registry.keepOnly(O),this._startExtensionHost()}$activateByEvent(O,V){return V===1?this._activateByEvent(O,!1):this._readyToRunExtensions.wait().then(q=>this._activateByEvent(O,!1))}async $activate(O,V){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(O)?(await this._activateById(O,V),!0):!1}async $deltaExtensions(O,V){O.forEach(X=>X.extensionLocation=n.URI.revive(X.extensionLocation));const q=await this.getExtensionPathIndex();return await Promise.all(V.map(async X=>{const me=this._registry.getExtensionDescription(X);if(!!me){const we=await this._hostUtils.realpath(me.extensionLocation.fsPath);q.delete(n.URI.file(we).fsPath)}})),await Promise.all(O.map(async X=>{const me=await this._hostUtils.realpath(X.extensionLocation.fsPath);q.set(n.URI.file(me).fsPath,X)})),this._registry.deltaExtensions(O,V),Promise.resolve(void 0)}async $test_latency(O){return O}async $test_up(O){return O.byteLength}async $test_down(O){let V=l.VSBuffer.alloc(O),q=Math.random()%256;for(let X=0;X<O;X++)V.writeUInt8(q,X);return V}async $updateRemoteConnectionData(O){this._remoteConnectionData=O,this._onDidChangeRemoteConnectionData.fire()}};F=je([Ue(0,r.IInstantiationService),Ue(1,e.IHostUtils),Ue(2,m.IExtHostRpcService),Ue(3,u.IExtHostWorkspace),Ue(4,w.IExtHostConfiguration),Ue(5,R.ILogService),Ue(6,a.IExtHostInitDataService),Ue(7,h.IExtensionStoragePaths),Ue(8,f.IExtHostTunnelService),Ue(9,d.IExtHostTerminalService)],F),e.AbstractExtHostExtensionService=F;function N(x,O){return{id:x.identifier.value,name:x.name,extensionVersion:x.version,publisherDisplayName:x.publisher,activationEvents:x.activationEvents?x.activationEvents.join(","):null,isBuiltin:x.isBuiltin,reason:O.activationEvent,reasonId:O.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class M{constructor(O,V,q,X){j.set(this,void 0),U.set(this,void 0),$.set(this,void 0),tt(this,j,O,"f"),tt(this,U,V,"f"),tt(this,$,q.identifier,"f"),this.id=q.identifier.value,this.extensionUri=q.extensionLocation,this.extensionPath=P.normalize((0,I.originalFSPath)(q.extensionLocation)),this.packageJSON=q,this.extensionKind=X}get isActive(){return He(this,j,"f").isActivated(He(this,$,"f"))}get exports(){if(this.packageJSON.api!=="none")return He(this,j,"f").getExtensionExports(He(this,$,"f"))}activate(){return He(this,j,"f").activateByIdWithErrors(He(this,$,"f"),{startup:!1,extensionId:He(this,U,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=M,j=new WeakMap,U=new WeakMap,$=new WeakMap}),define(ge[46],pe([0,1,8,2,3,19,5,7,119,32,42,39,212,35,203,13,4,15,36]),function(G,e,E,P,T,I,D,k,y,n,R,C,w,g,s,u,S,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,S.createDecorator)("IExtHostDebugService");let p=class{constructor(h,m,b,f,d){this._workspaceService=m,this._extensionService=b,this._editorsService=f,this._configurationService=d,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new T.Emitter,this._onDidTerminateDebugSession=new T.Emitter,this._onDidChangeActiveDebugSession=new T.Emitter,this._onDidReceiveDebugSessionCustomEvent=new T.Emitter,this._debugServiceProxy=h.getProxy(D.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new T.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new l(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(A=>{A.onDidChange(L=>{this.registerAllDebugTypes(A)}),this.registerAllDebugTypes(A)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(h,m){const b=h;if(typeof b.sourceReference=="number"&&b.sourceReference>0){let f=`debug:${encodeURIComponent(b.path||"")}`,d="?";return m&&(f+=`${d}session=${encodeURIComponent(m.id)}`,d="&"),f+=`${d}ref=${b.sourceReference}`,P.URI.parse(f)}else{if(b.path)return P.URI.file(b.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(h){const m=[];for(const b of h.getAllExtensionDescriptions())if(b.contributes){const f=b.contributes.debuggers;if(f&&f.length>0)for(const d of f)(0,s.isDebuggerMainContribution)(d)&&m.push(d.type)}this._debugServiceProxy.$registerDebugTypes(m)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const h=[];return this._breakpoints.forEach(m=>h.push(m)),h}addBreakpoints(h){this.startBreakpoints();const m=h.filter(d=>{const A=d.id;return this._breakpoints.has(A)?!1:(this._breakpoints.set(A,d),!0)});this.fireBreakpointChanges(m,[],[]);const b=[],f=new Map;for(const d of m)if(d instanceof k.SourceBreakpoint){let A=f.get(d.location.uri.toString());A||(A={type:"sourceMulti",uri:d.location.uri,lines:[]},f.set(d.location.uri.toString(),A),b.push(A)),A.lines.push({id:d.id,enabled:d.enabled,condition:d.condition,hitCondition:d.hitCondition,logMessage:d.logMessage,line:d.location.range.start.line,character:d.location.range.start.character})}else d instanceof k.FunctionBreakpoint&&b.push({type:"function",id:d.id,enabled:d.enabled,hitCondition:d.hitCondition,logMessage:d.logMessage,condition:d.condition,functionName:d.functionName});return this._debugServiceProxy.$registerBreakpoints(b)}removeBreakpoints(h){this.startBreakpoints();const m=h.filter(A=>this._breakpoints.delete(A.id));this.fireBreakpointChanges([],m,[]);const b=m.filter(A=>A instanceof k.SourceBreakpoint).map(A=>A.id),f=m.filter(A=>A instanceof k.FunctionBreakpoint).map(A=>A.id),d=m.filter(A=>A instanceof k.DataBreakpoint).map(A=>A.id);return this._debugServiceProxy.$unregisterBreakpoints(b,f,d)}startDebugging(h,m,b){return this._debugServiceProxy.$startDebugging(h?h.uri:void 0,m,{parentSessionID:b.parentSession?b.parentSession.id:void 0,repl:b.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:b.noDebug,compact:b.compact})}stopDebugging(h){return this._debugServiceProxy.$stopDebugging(h?h.id:void 0)}registerDebugConfigurationProvider(h,m,b){if(!m)return new k.Disposable(()=>{});const f=this._configProviderHandleCounter++;return this._configProviders.push({type:h,handle:f,provider:m}),this._debugServiceProxy.$registerDebugConfigurationProvider(h,b,!!m.provideDebugConfigurations,!!m.resolveDebugConfiguration,!!m.resolveDebugConfigurationWithSubstitutedVariables,f),new k.Disposable(()=>{this._configProviders=this._configProviders.filter(d=>d.provider!==m),this._debugServiceProxy.$unregisterDebugConfigurationProvider(f)})}registerDebugAdapterDescriptorFactory(h,m,b){if(!b)return new k.Disposable(()=>{});if(!this.definesDebugType(h,m))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${m}' debugger.`);if(this.getAdapterDescriptorFactoryByType(m))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const f=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:m,handle:f,factory:b}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(m,f),new k.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(d=>d.factory!==b),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(f)})}registerDebugAdapterTrackerFactory(h,m){if(!m)return new k.Disposable(()=>{});const b=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:h,handle:b,factory:m}),new k.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(f=>f.factory!==m)})}async $runInTerminal(h,m){return Promise.resolve(void 0)}async $substituteVariables(h,m){if(!this._variableResolver){const[d,A]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(d||[],this._editorsService,A)}let b;const f=await this.getFolder(h);return f&&(b={uri:f.uri,name:f.name,index:f.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(b,m)}createDebugAdapter(h,m){if(h.type==="implementation")return new o(h.implementation)}createSignService(){}async $startDASession(h,m){const b=this,f=await this.getSession(m);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(f.type),f).then(d=>{if(!d)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${f.type}' (extension might have failed to activate)`);const A=this.convertToDto(d),L=this.createDebugAdapter(A,f);if(!L)throw new Error(`Couldn't create a debug adapter for type '${f.type}'.`);const B=L;return this._debugAdapters.set(h,B),this.getDebugAdapterTrackers(f).then(J=>(J&&this._debugAdaptersTrackers.set(h,J),B.onMessage(async j=>{if(j.type==="request"&&j.command==="handshake"){const U=j,$={type:"response",seq:0,command:U.command,request_seq:U.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const F=await this._signService.sign(U.arguments.value);$.body={signature:F},B.sendResponse($)}else throw new Error("no signer")}catch(F){$.success=!1,$.message=F.message,B.sendResponse($)}}else J&&J.onDidSendMessage&&J.onDidSendMessage(j),j=(0,s.convertToVSCPaths)(j,!0),b._debugServiceProxy.$acceptDAMessage(h,j)}),B.onError(j=>{J&&J.onError&&J.onError(j),this._debugServiceProxy.$acceptDAError(h,j.name,j.message,j.stack)}),B.onExit(j=>{J&&J.onExit&&J.onExit((0,v.withNullAsUndefined)(j),void 0),this._debugServiceProxy.$acceptDAExit(h,(0,v.withNullAsUndefined)(j),void 0)}),J&&J.onWillStartSession&&J.onWillStartSession(),B.startSession()))})}$sendDAMessage(h,m){m=(0,s.convertToDAPaths)(m,!1);const b=this._debugAdaptersTrackers.get(h);b&&b.onWillReceiveMessage&&b.onWillReceiveMessage(m);const f=this._debugAdapters.get(h);f&&f.sendMessage(m)}$stopDASession(h){const m=this._debugAdaptersTrackers.get(h);this._debugAdaptersTrackers.delete(h),m&&m.onWillStopSession&&m.onWillStopSession();const b=this._debugAdapters.get(h);return this._debugAdapters.delete(h),b?b.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(h){const m=[],b=[],f=[];if(h.added)for(const d of h.added){const A=d.id;if(A&&!this._breakpoints.has(A)){let L;if(d.type==="function")L=new k.FunctionBreakpoint(d.functionName,d.enabled,d.condition,d.hitCondition,d.logMessage);else if(d.type==="data")L=new k.DataBreakpoint(d.label,d.dataId,d.canPersist,d.enabled,d.hitCondition,d.condition,d.logMessage);else{const B=P.URI.revive(d.uri);L=new k.SourceBreakpoint(new k.Location(B,new k.Position(d.line,d.character)),d.enabled,d.condition,d.hitCondition,d.logMessage)}L._id=A,this._breakpoints.set(A,L),m.push(L)}}if(h.removed)for(const d of h.removed){const A=this._breakpoints.get(d);A&&(this._breakpoints.delete(d),b.push(A))}if(h.changed){for(const d of h.changed)if(d.id){const A=this._breakpoints.get(d.id);if(A){if(A instanceof k.FunctionBreakpoint&&d.type==="function"){const L=A;L.enabled=d.enabled,L.condition=d.condition,L.hitCondition=d.hitCondition,L.logMessage=d.logMessage,L.functionName=d.functionName}else if(A instanceof k.SourceBreakpoint&&d.type==="source"){const L=A;L.enabled=d.enabled,L.condition=d.condition,L.hitCondition=d.hitCondition,L.logMessage=d.logMessage,L.location=new k.Location(P.URI.revive(d.uri),new k.Position(d.line,d.character))}f.push(A)}}}this.fireBreakpointChanges(m,b,f)}$provideDebugConfigurations(h,m,b){return(0,I.asPromise)(async()=>{const f=this.getConfigProviderByHandle(h);if(!f)throw new Error("no DebugConfigurationProvider found");if(!f.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const d=await this.getFolder(m);return f.provideDebugConfigurations(d,b)}).then(f=>{if(!f)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return f})}$resolveDebugConfiguration(h,m,b,f){return(0,I.asPromise)(async()=>{const d=this.getConfigProviderByHandle(h);if(!d)throw new Error("no DebugConfigurationProvider found");if(!d.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const A=await this.getFolder(m);return d.resolveDebugConfiguration(A,b,f)})}$resolveDebugConfigurationWithSubstitutedVariables(h,m,b,f){return(0,I.asPromise)(async()=>{const d=this.getConfigProviderByHandle(h);if(!d)throw new Error("no DebugConfigurationProvider found");if(!d.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const A=await this.getFolder(m);return d.resolveDebugConfigurationWithSubstitutedVariables(A,b,f)})}async $provideDebugAdapter(h,m){const b=this.getAdapterDescriptorFactoryByHandle(h);if(!b)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const f=await this.getSession(m);return this.getAdapterDescriptor(b,f).then(d=>{if(!d)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${f.type}'`);return this.convertToDto(d)})}async $acceptDebugSessionStarted(h){const m=await this.getSession(h);this._onDidStartDebugSession.fire(m)}async $acceptDebugSessionTerminated(h){const m=await this.getSession(h);m&&(this._onDidTerminateDebugSession.fire(m),this._debugSessions.delete(m.id))}async $acceptDebugSessionActiveChanged(h){this._activeDebugSession=h?await this.getSession(h):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(h,m){const b=await this.getSession(h);b&&b._acceptNameChanged(m)}async $acceptDebugSessionCustomEvent(h,m){const f={session:await this.getSession(h),event:m.event,body:m.body};this._onDidReceiveDebugSessionCustomEvent.fire(f)}convertToDto(h){if(h instanceof k.DebugAdapterExecutable)return{type:"executable",command:h.command,args:h.args,options:h.options};if(h instanceof k.DebugAdapterServer)return{type:"server",port:h.port,host:h.host};if(h instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:h.path};if(h instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:h.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(h){const m=this._adapterFactories.filter(b=>b.type===h);if(m.length>0)return m[0].factory}getAdapterDescriptorFactoryByHandle(h){const m=this._adapterFactories.filter(b=>b.handle===h);if(m.length>0)return m[0].factory}getConfigProviderByHandle(h){const m=this._configProviders.filter(b=>b.handle===h);if(m.length>0)return m[0].provider}definesDebugType(h,m){if(h.contributes){const b=h.contributes.debuggers;if(b&&b.length>0){for(const f of b)if(f.label&&f.type&&f.type===m)return!0}}return!1}getDebugAdapterTrackers(h){const b=h.configuration.type,f=this._trackerFactories.filter(d=>d.type===b||d.type==="*").map(d=>(0,I.asPromise)(()=>d.factory.createDebugAdapterTracker(h)).then(A=>A,A=>null));return Promise.race([Promise.all(f).then(d=>{const A=d.filter(L=>!!L);if(A.length>0)return new i(A)}),new Promise((d,A)=>{const L=setTimeout(()=>{clearTimeout(L),A(new Error("timeout"))},1e3)})]).catch(d=>{})}async getAdapterDescriptor(h,m){const b=m.configuration.debugServer;if(typeof b=="number")return Promise.resolve(new k.DebugAdapterServer(b));if(h){const d=await this._extensionService.getExtensionRegistry();return(0,I.asPromise)(()=>h.createDebugAdapterDescriptor(m,this.daExecutableFromPackage(m,d))).then(A=>{if(A)return A})}const f=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(m,f))}daExecutableFromPackage(h,m){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(h,m,b){(h.length>0||m.length>0||b.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:h,removed:m,changed:b}))}async getSession(h){if(h)if(typeof h=="string"){const m=this._debugSessions.get(h);if(m)return m}else{let m=this._debugSessions.get(h.id);if(!m){const b=await this.getFolder(h.folderUri);m=new c(this._debugServiceProxy,h.id,h.type,h.name,b,h.configuration),this._debugSessions.set(m.id,m),this._debugServiceProxy.$sessionCached(m.id)}return m}throw new Error("cannot find session")}getFolder(h){if(h){const m=P.URI.revive(h);return this._workspaceService.resolveWorkspaceFolder(m)}return Promise.resolve(void 0)}};p=je([Ue(0,u.IExtHostRpcService),Ue(1,n.IExtHostWorkspace),Ue(2,R.IExtHostExtensionService),Ue(3,C.IExtHostDocumentsAndEditors),Ue(4,g.IExtHostConfiguration)],p),e.ExtHostDebugServiceBase=p;class c{constructor(h,m,b,f,d,A){this._debugServiceProxy=h,this._id=m,this._type=b,this._name=f,this._workspaceFolder=d,this._configuration=A}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(h){this._name=h,this._debugServiceProxy.$setDebugSessionName(this._id,h)}_acceptNameChanged(h){this._name=h}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(h,m){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,h,m)}getDebugProtocolBreakpoint(h){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,h.id)}}e.ExtHostDebugSession=c;class l{constructor(h){this.value=Object.freeze({append(m){h.$appendDebugConsole(m)},appendLine(m){this.append(m+`
`)}})}}e.ExtHostDebugConsole=l;class t extends w.AbstractVariableResolverService{constructor(h,m,b,f){super({getFolderUri:d=>{const A=h.filter(L=>L.name===d);if(A&&A.length>0)return A[0].uri},getWorkspaceFolderCount:()=>h.length,getConfigurationValue:(d,A)=>b.getConfiguration(void 0,d).get(A),getAppRoot:()=>_.cwd(),getExecPath:()=>_.env.VSCODE_EXEC_PATH,getFilePath:()=>{if(m){const d=m.activeEditor();if(d)return E.normalize(d.document.uri.fsPath)}},getWorkspaceFolderPathForFile:()=>{if(m&&f){const d=m.activeEditor();if(d){const A=f.getWorkspaceFolder(d.document.uri);if(A)return E.normalize(A.uri.fsPath)}}},getSelectedText:()=>{if(m){const d=m.activeEditor();if(d&&!d.selection.isEmpty)return d.document.getText(d.selection)}},getLineNumber:()=>{if(m){const d=m.activeEditor();if(d)return String(d.selection.end.line+1)}}},void 0,_.env)}}e.ExtHostVariableResolverService=t;class i{constructor(h){this.trackers=h}onWillStartSession(){this.trackers.forEach(h=>h.onWillStartSession?h.onWillStartSession():void 0)}onWillReceiveMessage(h){this.trackers.forEach(m=>m.onWillReceiveMessage?m.onWillReceiveMessage(h):void 0)}onDidSendMessage(h){this.trackers.forEach(m=>m.onDidSendMessage?m.onDidSendMessage(h):void 0)}onWillStopSession(){this.trackers.forEach(h=>h.onWillStopSession?h.onWillStopSession():void 0)}onError(h){this.trackers.forEach(m=>m.onError?m.onError(h):void 0)}onExit(h,m){this.trackers.forEach(b=>b.onExit?b.onExit(h,m):void 0)}}class o extends y.AbstractDebugAdapter{constructor(h){super();this.implementation=h,h.onDidSendMessage(m=>{this.acceptMessage(m)})}startSession(){return Promise.resolve(void 0)}sendMessage(h){this.implementation.handleMessage(h)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let r=class extends p{constructor(h,m,b,f,d){super(h,m,b,f,d)}createVariableResolver(h,m,b){return new t(h,m,b)}};r=je([Ue(0,u.IExtHostRpcService),Ue(1,n.IExtHostWorkspace),Ue(2,R.IExtHostExtensionService),Ue(3,C.IExtHostDocumentsAndEditors),Ue(4,g.IExtHostConfiguration)],r),e.WorkerExtHostDebugService=r}),define(ge[262],pe([0,1,66,2,5,35,41,29,13,27,4,42,36,12]),function(G,e,E,P,T,I,D,k,y,n,R,C,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let s=class{constructor(p,c,l,t,i,o,r){this._apiFactory=p,this._extensionRegistry=c,this._instaService=l,this._extHostConfiguration=t,this._extHostExtensionService=i,this._initData=o,this._logService=r,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),E.mark("code/extHost/willWaitForConfig");const p=await this._extHostConfiguration.getConfigProvider();E.mark("code/extHost/didWaitForConfig");const c=await this._extHostExtensionService.getExtensionPathIndex();this.register(new u(this._apiFactory,c,this._extensionRegistry,p,this._logService)),this.register(this._instaService.createInstance(S)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(v,c,this._initData.environment.appUriScheme))}register(p){if(Array.isArray(p.nodeModuleName))for(let c of p.nodeModuleName)this._factories.set(c,p);else this._factories.set(p.nodeModuleName,p);typeof p.alternativeModuleName=="function"&&this._alternatives.push(c=>p.alternativeModuleName(c))}};s=je([Ue(2,R.IInstantiationService),Ue(3,I.IExtHostConfiguration),Ue(4,C.IExtHostExtensionService),Ue(5,n.IExtHostInitDataService),Ue(6,g.ILogService)],s),e.RequireInterceptor=s;class u{constructor(p,c,l,t,i){this._apiFactory=p,this._extensionPaths=c,this._extensionRegistry=l,this._configProvider=t,this._logService=i,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(p,c){const l=this._extensionPaths.findSubstr(c.fsPath);if(l){let t=this._extApiImpl.get(k.ExtensionIdentifier.toKey(l.identifier));return t||(t=this._apiFactory(l,this._extensionRegistry,this._configProvider),this._extApiImpl.set(k.ExtensionIdentifier.toKey(l.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((i,o)=>t+=`	${o} -> ${i.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${c.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(D.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let S=class{constructor(p,c){this.nodeModuleName="keytar";const{environment:l}=c,t=p.getProxy(T.MainContext.MainThreadKeytar);if(l.appRoot){let i=l.appRoot.fsPath;w.platform==="win32"&&(i=i.replace(/\\/g,"/")),i[i.length-1]==="/"&&(i=i.substr(0,i.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${i}/node_modules.asar/keytar`),this.alternativeNames.add(`${i}/node_modules/keytar`)}this._impl={getPassword:(i,o)=>t.$getPassword(i,o),setPassword:(i,o,r)=>t.$setPassword(i,o,r),deletePassword:(i,o)=>t.$deletePassword(i,o),findPassword:i=>t.$findPassword(i),findCredentials(i){return t.$findCredentials(i)}}}load(p,c){return this._impl}alternativeModuleName(p){const c=p.length;if(!(c<=7||!this.alternativeNames)){const l=c-7;if((p.charAt(l)==="/"||p.charAt(l)==="\\")&&p.endsWith("keytar")&&(p=p.replace(/\\/g,"/"),this.alternativeNames.has(p)))return"keytar"}}};S=je([Ue(0,y.IExtHostRpcService),Ue(1,n.IExtHostInitDataService)],S);let v=class{constructor(p,c,l){this._extensionPaths=p,this._appUriScheme=c,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=l.getProxy(T.MainContext.MainThreadTelemetry);const t=l.getProxy(T.MainContext.MainThreadWindow);this._impl=(i,o)=>{const r=P.URI.parse(i);return o?this.callOriginal(i,o):r.scheme==="http"||r.scheme==="https"?t.$openUri(r,i,{allowTunneling:!0}):r.scheme==="mailto"||r.scheme===this._appUriScheme?t.$openUri(r,i,{}):this.callOriginal(i,o)}}load(p,c,l){const t=this._extensionPaths.findSubstr(c.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=l(p),this._impl}callOriginal(p,c){return this.sendNoForwardTelemetry(),this._original(p,c)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};v=je([Ue(2,y.IExtHostRpcService)],v)}),define(ge[263],pe([0,1,167,9,7,204,32,42,39,35,34,13,46,188,207,19]),function(G,e,E,P,T,I,D,k,y,n,R,C,w,g,s,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let S=class extends w.ExtHostDebugServiceBase{constructor(p,c,l,t,i,o){super(p,c,l,t,i);this._terminalService=o,this._integratedTerminalInstances=new v}createDebugAdapter(p,c){switch(p.type){case"server":return new I.SocketDebugAdapter(p);case"pipeServer":return new I.NamedPipeDebugAdapter(p);case"executable":return new I.ExecutableDebugAdapter(p,c.type)}return super.createDebugAdapter(p,c)}daExecutableFromPackage(p,c){const l=I.ExecutableDebugAdapter.platformAdapterExecutable(c.getAllExtensionDescriptions(),p.type);if(l)return new T.DebugAdapterExecutable(l.command,l.args,l.options)}createSignService(){return new g.SignService}async $runInTerminal(p,c){if(p.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(d=>{this._integratedTerminalInstances.onTerminalClosed(d)}));const l=await this._configurationService.getConfigProvider(),t=this._terminalService.getDefaultShell(!0,l),i=this._terminalService.getDefaultShellArgs(!0,l),o=JSON.stringify({shell:t,shellArgs:i});let r=await this._integratedTerminalInstances.checkout(o),a,h=!1;if(r)a=p.cwd;else{const d={shellPath:t,shellArgs:i,cwd:p.cwd,name:p.title||E.localize(0,null)};h=!0,r=this._terminalService.createTerminalFromOptions(d,!0),this._integratedTerminalInstances.insert(r,o)}r.show(!0);const m=await r.processId;h?await new Promise(d=>setTimeout(d,1e3)):l.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(t.indexOf("powershell")>=0||t.indexOf("pwsh")>=0||t.indexOf("cmd.exe")>=0?r.sendText("cls"):t.indexOf("bash")>=0?r.sendText("clear"):P.isWindows?r.sendText("cls"):r.sendText("clear"));const b=(0,s.prepareCommand)(t,p.args,a,p.env);r.sendText(b);const f=this.onDidTerminateDebugSession(d=>{d.id===c&&(this._integratedTerminalInstances.free(r),f.dispose())});return m}else if(p.kind==="external")return(0,s.runInExternalTerminal)(p,await this._configurationService.getConfigProvider());return super.$runInTerminal(p,c)}createVariableResolver(p,c,l){return new w.ExtHostVariableResolverService(p,c,l,this._workspaceService)}};S=je([Ue(0,C.IExtHostRpcService),Ue(1,D.IExtHostWorkspace),Ue(2,k.IExtHostExtensionService),Ue(3,y.IExtHostDocumentsAndEditors),Ue(4,n.IExtHostConfiguration),Ue(5,R.IExtHostTerminalService)],S),e.ExtHostDebugService=S;class v{constructor(){this._terminalInstances=new Map}async checkout(p){const l=[...this._terminalInstances.entries()].map(([t,i])=>(0,u.createCancelablePromise)(async o=>{if(i.lastUsedAt!==-1&&await(0,s.hasChildProcesses)(await t.processId))return null;const r=Date.now();return i.lastUsedAt+v.minUseDelay>r||o.isCancellationRequested||i.config!==p?null:(i.lastUsedAt=r,t)}));return await(0,u.firstParallel)(l,t=>!!t)}insert(p,c){this._terminalInstances.set(p,{lastUsedAt:Date.now(),config:c})}free(p){const c=this._terminalInstances.get(p);c&&(c.lastUsedAt=-1)}onTerminalClosed(p){this._terminalInstances.delete(p)}}v.minUseDelay=1e3}),define(ge[264],pe([0,1,8,2,77,32,46,39,35,34,13,27,65,11,12,62]),function(G,e,E,P,T,I,D,k,y,n,R,C,w,g,s,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let S=class extends w.ExtHostTaskBase{constructor(_,p,c,l,t,i,o,r){super(_,p,c,l,t,i,o,r);this.workspaceService=c,p.remote.isRemote&&p.remote.authority?this.registerTaskSystem(g.Schemas.vscodeRemote,{scheme:g.Schemas.vscodeRemote,authority:p.remote.authority,platform:process.platform}):this.registerTaskSystem(g.Schemas.file,{scheme:g.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(_,p){const c=p;if(!p.execution&&c._id===void 0)throw new Error("Tasks to execute must include an execution");if(c._id!==void 0){const l=w.TaskHandleDTO.from(c,this.workspaceService),t=await this._proxy.$getTaskExecution(l);if(t.task===void 0)throw new Error("Task from execution DTO is undefined");const i=await this.getTaskExecution(t,p);return this._proxy.$executeTask(l).catch(()=>{}),i}else{const l=w.TaskDTO.from(p,_);if(l===void 0)return Promise.reject(new Error("Task is not valid"));w.CustomExecutionDTO.is(l.execution)&&await this.addCustomExecution(l,p,!1);const t=await this.getTaskExecution(await this._proxy.$getTaskExecution(l),p);return this._proxy.$executeTask(l).catch(()=>{}),t}}provideTasksInternal(_,p,c,l){const t=[];if(l)for(let i of l){this.checkDeprecation(i,c),(!i.definition||!_[i.definition.type])&&this._logService.warn(`The task [${i.source}, ${i.name}] uses an undefined task type. The task will be ignored in the future.`);const o=w.TaskDTO.from(i,c.extension);o&&(t.push(o),w.CustomExecutionDTO.is(o.execution)&&p.push(this.addCustomExecution(o,i,!0)))}return{tasks:t,extension:c.extension}}async resolveTaskInternal(_){return _}async getVariableResolver(_){if(this._variableResolver===void 0){const p=await this._configurationService.getConfigProvider();this._variableResolver=new D.ExtHostVariableResolverService(_,this._editorService,p,this.workspaceService)}return this._variableResolver}async $resolveVariables(_,p){const c=P.URI.revive(_),l={process:void 0,variables:Object.create(null)},t=await this._workspaceProvider.resolveWorkspaceFolder(c),i=await this._workspaceProvider.getWorkspaceFolders2();if(!i||!t)throw new Error("Unexpected: Tasks can only be run in a workspace folder");const o=await this.getVariableResolver(i),r={uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}};for(let a of p.variables)l.variables[a]=await o.resolveAsync(r,a);if(p.process!==void 0){let a;if(p.process.path!==void 0){a=p.process.path.split(E.delimiter);for(let h=0;h<a.length;h++)a[h]=await o.resolveAsync(r,a[h])}l.process=await T.win32.findExecutable(await o.resolveAsync(r,p.process.name),p.process.cwd!==void 0?await o.resolveAsync(r,p.process.cwd):void 0,a)}return l}$getDefaultShellAndArgs(){return this._terminalService.$getDefaultShellAndArgs(!0)}async $jsonTasksSupported(){return!0}async $findExecutable(_,p,c){return T.win32.findExecutable(_,p,c)}};S=je([Ue(0,R.IExtHostRpcService),Ue(1,C.IExtHostInitDataService),Ue(2,I.IExtHostWorkspace),Ue(3,k.IExtHostDocumentsAndEditors),Ue(4,y.IExtHostConfiguration),Ue(5,n.IExtHostTerminalService),Ue(6,s.ILogService),Ue(7,u.IExtHostApiDeprecationService)],S),e.ExtHostTask=S}),define(ge[265],pe([0,1,9,15,28,148,12,35,46,39,13,34,32,210,211]),function(G,e,E,P,T,I,D,k,y,n,R,C,w,g,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let u=class extends C.BaseExtHostTerminalService{constructor(v,_,p,c,l){super(!0,v);this._extHostConfiguration=_,this._extHostWorkspace=p,this._extHostDocumentsAndEditors=c,this._logService=l,this._isWorkspaceShellAllowed=!1,(0,I.getSystemShell)(E.platform,process.env).then(t=>this._defaultShell=t),this._updateLastActiveWorkspace(),this._variableResolverPromise=this._updateVariableResolver(),this._registerListeners()}createTerminal(v,_,p){const c=new C.ExtHostTerminal(this._proxy,(0,T.generateUuid)(),{name:v,shellPath:_,shellArgs:p},v);return this._terminals.push(c),c.create(_,p),c.value}createTerminalFromOptions(v,_){const p=new C.ExtHostTerminal(this._proxy,(0,T.generateUuid)(),v,v.name);return this._terminals.push(p),p.create((0,P.withNullAsUndefined)(v.shellPath),(0,P.withNullAsUndefined)(v.shellArgs),(0,P.withNullAsUndefined)(v.cwd),(0,P.withNullAsUndefined)(v.env),(0,P.withNullAsUndefined)(v.icon),(0,P.withNullAsUndefined)(v.message),void 0,(0,P.withNullAsUndefined)(v.strictEnv),(0,P.withNullAsUndefined)(v.hideFromUser),(0,P.withNullAsUndefined)(_),!0),p.value}getDefaultShell(v,_){var p;const c=l=>{const t=_.getConfiguration(l.substr(0,l.lastIndexOf("."))).inspect(l.substr(l.lastIndexOf(".")+1));return this._apiInspectConfigToPlain(t)};return g.getDefaultShell(c,this._isWorkspaceShellAllowed,(p=this._defaultShell)!==null&&p!==void 0?p:(0,I.getSystemShellSync)(E.platform,process.env),process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),process.env.windir,g.createVariableResolver(this._lastActiveWorkspace,this._variableResolver),this._logService,v)}getDefaultShellArgs(v,_){const p=c=>{const l=_.getConfiguration(c.substr(0,c.lastIndexOf("."))).inspect(c.substr(c.lastIndexOf(".")+1));return this._apiInspectConfigToPlain(l)};return g.getDefaultShellArgs(p,this._isWorkspaceShellAllowed,v,g.createVariableResolver(this._lastActiveWorkspace,this._variableResolver),this._logService)}_apiInspectConfigToPlain(v){return{userValue:v?v.globalValue:void 0,value:v?v.workspaceValue:void 0,defaultValue:v?v.defaultValue:void 0}}_registerListeners(){this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(()=>this._updateLastActiveWorkspace()),this._extHostWorkspace.onDidChangeWorkspace(()=>{this._variableResolverPromise=this._updateVariableResolver()})}_updateLastActiveWorkspace(){const v=this._extHostDocumentsAndEditors.activeEditor();v&&(this._lastActiveWorkspace=this._extHostWorkspace.getWorkspaceFolder(v.document.uri))}async _updateVariableResolver(){const v=await this._extHostConfiguration.getConfigProvider(),_=await this._extHostWorkspace.getWorkspaceFolders2();return this._variableResolver=new y.ExtHostVariableResolverService(_||[],this._extHostDocumentsAndEditors,v),this._variableResolver}async $getAvailableProfiles(v){const _=await(await this._extHostConfiguration.getConfigProvider()).getConfiguration().get("terminal.integrated");return(0,s.detectAvailableProfiles)(v,void 0,this._logService,_,await this._variableResolverPromise,this._lastActiveWorkspace)}async $getDefaultShellAndArgs(v){const _=await this._extHostConfiguration.getConfigProvider();return{shell:this.getDefaultShell(v,_),args:this.getDefaultShellArgs(v,_)}}$acceptWorkspacePermissionsChanged(v){this._isWorkspaceShellAllowed=v}};u=je([Ue(0,R.IExtHostRpcService),Ue(1,k.IExtHostConfiguration),Ue(2,w.IExtHostWorkspace),Ue(3,n.IExtHostDocumentsAndEditors),Ue(4,D.ILogService)],u),e.ExtHostTerminalService=u}),define(ge[266],pe([0,1,19,18,66,6,2,5,256,12,78,81,27,184,13,61,42,34]),function(G,e,E,P,T,I,D,k,y,n,R,C,w,g,s,u,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class _{constructor(c,l,t,i){this._disposables=new I.DisposableStore,this._isTerminating=!1,this._hostUtils=t;const o=new y.RPCProtocol(c,null,i);l=_._transform(l,o);const r=new C.ServiceCollection(...(0,R.getSingletonServiceDescriptors)());r.set(w.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},l)),r.set(s.IExtHostRpcService,new s.ExtHostRpcService(o)),r.set(u.IURITransformerService,new u.URITransformerService(i)),r.set(S.IHostUtils,t);const a=new g.InstantiationService(r,!0),h=a.invokeFunction(d=>d.get(v.IExtHostTerminalService));this._disposables.add(h),this._logService=a.invokeFunction(d=>d.get(n.ILogService)),T.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",l),this._extensionService=a.invokeFunction(d=>d.get(S.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const m=new WeakMap;this._extensionService.getExtensionPathIndex().then(d=>{Error.prepareStackTrace=(A,L)=>{let B="",J,j;for(const U of L)B+=`
	at ${U.toString()}`,j=U.getFileName(),!J&&j&&(J=d.findSubstr(j));return m.set(A,J),`${A.name||"Error"}: ${A.message||""}${B}`}});const b=o.getProxy(k.MainContext.MainThreadExtensionService),f=o.getProxy(k.MainContext.MainThreadErrors);P.setUnexpectedErrorHandler(d=>{const A=P.transformErrorForSerialization(d),L=m.get(d);L?b.$onExtensionRuntimeError(L.identifier,A):f.$onUnexpectedError(A)})}terminate(c){if(!this._isTerminating){this._isTerminating=!0,this._logService.info(`extension host terminating: ${c}`),this._logService.flush(),this._disposables.dispose(),P.setUnexpectedErrorHandler(t=>{});const l=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,E.timeout)(4e3),l]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}}static _transform(c,l){c.extensions.forEach(i=>i.extensionLocation=D.URI.revive(l.transformIncomingURIs(i.extensionLocation))),c.environment.appRoot=D.URI.revive(l.transformIncomingURIs(c.environment.appRoot));const t=c.environment.extensionDevelopmentLocationURI;return t&&(c.environment.extensionDevelopmentLocationURI=t.map(i=>D.URI.revive(l.transformIncomingURIs(i)))),c.environment.extensionTestsLocationURI=D.URI.revive(l.transformIncomingURIs(c.environment.extensionTestsLocationURI)),c.environment.globalStorageHome=D.URI.revive(l.transformIncomingURIs(c.environment.globalStorageHome)),c.environment.workspaceStorageHome=D.URI.revive(l.transformIncomingURIs(c.environment.workspaceStorageHome)),c.logsLocation=D.URI.revive(l.transformIncomingURIs(c.logsLocation)),c.logFile=D.URI.revive(l.transformIncomingURIs(c.logFile)),c.workspace=l.transformIncomingURIs(c.workspace),c}}e.ExtensionHostMain=_}),define(ge[267],pe([0,1,8,21,58,33,25,47,31]),function(G,e,E,P,T,I,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class n{constructor(w,g,s){this.config=w,this.provider=g,this.sessionToken=s,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=w.filePattern,this.includePattern=w.includePattern&&I.parse(w.includePattern),this.maxResults=w.maxResults||void 0,this.exists=w.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=w.excludePattern&&I.parse(w.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(w=>w.cancel()),this.activeCancellationTokens=new Set}search(w){const g=this.config.folderQueries||[];return new Promise((s,u)=>{const S=v=>{this.resultCount++,w(v)};if(this.isCanceled)return s({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(v=>{const _=v.toString(),p=E.basename(_);this.globalExcludePattern&&this.globalExcludePattern(_,p)||this.matchFile(S,{base:v,basename:p})}),Promise.all(g.map(v=>this.searchInFolder(v,S))).then(v=>{s({limitHit:this.isLimitHit,stats:v[0]||void 0})},v=>{u(new Error((0,T.toErrorMessage)(v)))})})}async searchInFolder(w,g){const s=new P.CancellationTokenSource,u=this.getSearchOptionsForFolder(w),S=this.initDirectoryTree(),v=new y.QueryGlobTester(this.config,w),_=!v.hasSiblingExcludeClauses();let p;try{this.activeCancellationTokens.add(s),p=k.StopWatch.create();const c=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},u,s.token),l=p.elapsed(),t=k.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(c&&c.forEach(i=>{const o=E.posix.relative(w.folder.path,i.path);if(_){const r=E.basename(i.path);this.matchFile(g,{base:w.folder,relativePath:o,basename:r});return}this.addDirectoryEntries(S,w.folder,o,g)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(S,v,g),{providerTime:l,postProcessTime:t.elapsed()})}finally{s.dispose(),this.activeCancellationTokens.delete(s)}}getSearchOptionsForFolder(w){const g=(0,y.resolvePatternsForProvider)(this.config.includePattern,w.includePattern),s=(0,y.resolvePatternsForProvider)(this.config.excludePattern,w.excludePattern);return{folder:w.folder,excludes:s,includes:g,useIgnoreFiles:!w.disregardIgnoreFiles,useGlobalIgnoreFiles:!w.disregardGlobalIgnoreFiles,followSymlinks:!w.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const w={rootEntries:[],pathToEntries:Object.create(null)};return w.pathToEntries["."]=w.rootEntries,w}addDirectoryEntries({pathToEntries:w},g,s,u){if(s===this.filePattern){const v=E.basename(this.filePattern);this.matchFile(u,{base:g,relativePath:this.filePattern,basename:v})}function S(v){const _=E.basename(v),p=E.dirname(v);let c=w[p];c||(c=w[p]=[],S(p)),c.push({base:g,relativePath:v,basename:_})}S(s)}matchDirectoryTree({rootEntries:w,pathToEntries:g},s,u){const S=this,v=this.filePattern;function _(p){const c=I.hasSiblingFn(()=>p.map(l=>l.basename));for(let l=0,t=p.length;l<t;l++){const i=p[l],{relativePath:o,basename:r}=i;if(!!s.includedInQuerySync(o,r,v!==r?c:void 0)){const a=g[o];if(a)_(a);else{if(o===v)continue;S.matchFile(u,i)}if(S.isLimitHit)break}}}_(w)}matchFile(w,g){(!this.includePattern||g.relativePath&&this.includePattern(g.relativePath,g.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||w(g))}}class R{constructor(){this.sessions=new Map}fileSearch(w,g,s,u){const S=this.getSessionTokenSource(w.cacheKey),v=new n(w,g,S&&S.token);let _=0;const p=c=>{_+=c.length,s(c.map(l=>this.rawMatchToSearchItem(l)))};return this.doSearch(v,R.BATCH_SIZE,p,u).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:_,detailStats:c.stats}}))}clearCache(w){const g=this.getSessionTokenSource(w);g&&g.cancel()}getSessionTokenSource(w){if(!!w)return this.sessions.has(w)||this.sessions.set(w,new P.CancellationTokenSource),this.sessions.get(w)}rawMatchToSearchItem(w){return w.relativePath?{resource:D.joinPath(w.base,w.relativePath)}:{resource:w.base}}doSearch(w,g,s,u){u.onCancellationRequested(()=>{w.cancel()});const S=_=>{_&&(v.push(_),g>0&&v.length>=g&&(s(v),v=[]))};let v=[];return w.search(S).then(_=>(v.length&&s(v),_),_=>(v.length&&s(v),Promise.reject(_)))}}e.FileSearchManager=R,R.BATCH_SIZE=512}),define(ge[126],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=e.Position=void 0;class E{constructor(I,D){this.line=I,this.character=D}isBefore(I){return!1}isBeforeOrEqual(I){return!1}isAfter(I){return!1}isAfterOrEqual(I){return!1}isEqual(I){return!1}compareTo(I){return 0}translate(I,D){return new E(0,0)}with(I){return new E(0,0)}}e.Position=E;class P{constructor(I,D,k,y){this.isEmpty=!1,this.isSingleLine=!1,this.start=new E(I,D),this.end=new E(k,y)}contains(I){return!1}isEqual(I){return!1}intersection(I){}union(I){return new P(0,0,0,0)}with(I){return new P(0,0,0,0)}}e.Range=P}),define(ge[127],pe([0,1,8,14,21,58,25,33,2,31,11]),function(G,e,E,P,T,I,D,k,y,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class C{constructor(_,p,c){this.query=_,this.provider=p,this.fileUtils=c,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(_,p){const c=this.query.folderQueries||[],l=new T.CancellationTokenSource;return p.onCancellationRequested(()=>l.cancel()),new Promise((t,i)=>{this.collector=new g(_);let o=!1;const r=(a,h)=>{if(!o&&!this.isLimitHit){const m=this.resultSize(a);u(a)&&typeof this.query.maxResults=="number"&&this.resultCount+m>this.query.maxResults&&(this.isLimitHit=!0,o=!0,l.cancel(),a=this.trimResultToSize(a,this.query.maxResults-this.resultCount));const b=this.resultSize(a);this.resultCount+=b,(b>0||!u(a))&&this.collector.add(a,h)}};Promise.all(c.map((a,h)=>this.searchInFolder(a,m=>r(m,h),l.token))).then(a=>{l.dispose(),this.collector.flush();const h=a.some(m=>!!m&&!!m.limitHit);t({limitHit:this.isLimitHit||h,stats:{type:"textSearchProvider"}})},a=>{l.dispose();const h=(0,I.toErrorMessage)(a);i(new Error(h))})})}resultSize(_){return u(_)?Array.isArray(_.ranges)?_.ranges.length:1:0}trimResultToSize(_,p){const c=Array.isArray(_.ranges)?_.ranges:[_.ranges],l=Array.isArray(_.preview.matches)?_.preview.matches:[_.preview.matches];return{ranges:c.slice(0,p),preview:{matches:l.slice(0,p),text:_.preview.text},uri:_.uri}}async searchInFolder(_,p,c){const l=new n.QueryGlobTester(this.query,_),t=[],i={report:a=>{if(!!this.validateProviderResult(a)){const h=_.folder.scheme===R.Schemas.file?k.hasSiblingPromiseFn(()=>this.fileUtils.readdir(D.dirname(a.uri))):void 0,m=D.relativePath(_.folder,a.uri);m&&t.push(l.includedInQuery(m,E.basename(m),h).then(b=>{b&&p(a)}))}}},o=this.getSearchOptionsForFolder(_),r=await this.provider.provideTextSearchResults(w(this.query.contentPattern),o,i,c);return await Promise.all(t),r}validateProviderResult(_){if(u(_)){if(Array.isArray(_.ranges)){if(!Array.isArray(_.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(_.preview.matches.length!==_.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(_.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(_){const p=(0,n.resolvePatternsForProvider)(this.query.includePattern,_.includePattern),c=(0,n.resolvePatternsForProvider)(this.query.excludePattern,_.excludePattern),l={folder:y.URI.from(_.folder),excludes:c,includes:p,useIgnoreFiles:!_.disregardIgnoreFiles,useGlobalIgnoreFiles:!_.disregardGlobalIgnoreFiles,followSymlinks:!_.ignoreSymlinks,encoding:_.fileEncoding&&this.fileUtils.toCanonicalName(_.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return l.usePCRE2=this.query.usePCRE2,l}}e.TextSearchManager=C;function w(v){return{isCaseSensitive:v.isCaseSensitive||!1,isRegExp:v.isRegExp||!1,isWordMatch:v.isWordMatch||!1,isMultiline:v.isMultiline||!1,pattern:v.pattern}}class g{constructor(_){this._onResult=_,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new S(512,p=>this.sendItems(p))}add(_,p){this._currentFileMatch&&(this._currentFolderIdx!==p||!D.isEqual(this._currentUri,_.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=p,this._currentFileMatch={resource:_.uri,results:[]}),this._currentFileMatch.results.push(s(_))}pushToCollector(){const _=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,_)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(_){this._onResult(_)}}e.TextSearchResultsCollector=g;function s(v){return u(v)?{preview:{matches:(0,P.mapArrayOrNot)(v.preview.matches,_=>({startLineNumber:_.start.line,startColumn:_.start.character,endLineNumber:_.end.line,endColumn:_.end.character})),text:v.preview.text},ranges:(0,P.mapArrayOrNot)(v.ranges,_=>({startLineNumber:_.start.line,startColumn:_.start.character,endLineNumber:_.end.line,endColumn:_.end.character}))}:{text:v.text,lineNumber:v.lineNumber}}function u(v){return!!v.preview}e.extensionResultIsMatch=u;class S{constructor(_,p){this.maxBatchSize=_,this.cb=p,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(_,p){!_||this.addItemToBatch(_,p)}addItems(_,p){!_||this.addItemsToBatch(_,p)}addItemToBatch(_,p){this.batch.push(_),this.batchSize+=p,this.onUpdate()}addItemsToBatch(_,p){this.batch=this.batch.concat(_),this.batchSize+=p,this.onUpdate()}onUpdate(){this.totalNumberCompleted<S.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},S.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=S,S.TIMEOUT=4e3,S.START_BATCH_AFTER_COUNT=50}),define(ge[67],pe([0,1,6,5,4,267,13,61,12,2,127]),function(G,e,E,P,T,I,D,k,y,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,T.createDecorator)("IExtHostSearch");let C=class{constructor(u,S,v){this.extHostRpc=u,this._uriTransformer=S,this._logService=v,this._proxy=this.extHostRpc.getProxy(P.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new I.FileSearchManager}_transformScheme(u){return this._uriTransformer.transformOutgoingScheme(u)}registerTextSearchProvider(u,S){if(this._textSearchUsedSchemes.has(u))throw new Error(`a text search provider for the scheme '${u}' is already registered`);this._textSearchUsedSchemes.add(u);const v=this._handlePool++;return this._textSearchProvider.set(v,S),this._proxy.$registerTextSearchProvider(v,this._transformScheme(u)),(0,E.toDisposable)(()=>{this._textSearchUsedSchemes.delete(u),this._textSearchProvider.delete(v),this._proxy.$unregisterProvider(v)})}registerFileSearchProvider(u,S){if(this._fileSearchUsedSchemes.has(u))throw new Error(`a file search provider for the scheme '${u}' is already registered`);this._fileSearchUsedSchemes.add(u);const v=this._handlePool++;return this._fileSearchProvider.set(v,S),this._proxy.$registerFileSearchProvider(v,this._transformScheme(u)),(0,E.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(u),this._fileSearchProvider.delete(v),this._proxy.$unregisterProvider(v)})}$provideFileSearchResults(u,S,v,_){const p=w(v),c=this._fileSearchProvider.get(u);if(c)return this._fileSearchManager.fileSearch(p,c,l=>{this._proxy.$handleFileMatch(u,S,l.map(t=>t.resource))},_);throw new Error("unknown provider: "+u)}$clearCache(u){return this._fileSearchManager.clearCache(u),Promise.resolve(void 0)}$provideTextSearchResults(u,S,v,_){const p=this._textSearchProvider.get(u);if(!p||!p.provideTextSearchResults)throw new Error(`Unknown provider ${u}`);const c=w(v);return this.createTextSearchManager(c,p).search(t=>this._proxy.$handleTextMatch(u,S,t),_)}createTextSearchManager(u,S){return new R.TextSearchManager(u,S,{readdir:v=>Promise.resolve([]),toCanonicalName:v=>v})}};C=je([Ue(0,D.IExtHostRpcService),Ue(1,k.IURITransformerService),Ue(2,y.ILogService)],C),e.ExtHostSearch=C;function w(s){return Object.assign(Object.assign({},s),{folderQueries:s.folderQueries&&s.folderQueries.map(g),extraFileResources:s.extraFileResources&&s.extraFileResources.map(u=>n.URI.revive(u))})}e.reviveQuery=w;function g(s){return Object.assign(Object.assign({},s),{folder:n.URI.revive(s.folder)})}}),define(ge[268],pe([0,1,158,21,18,3,56,2,150,104,140,76,45,5,230,229,51,231,35,232,233,234,215,235,39,42,236,216,238,239,240,63,219,243,244,245,88,34,246,220,20,7,249,64,125,32,41,53,200,237,114,124,65,46,67,12,61,13,27,241,198,50,62,227,247,197,89,87,252,250,251,228,60,259,248,86,194,117,242]),function(G,e,E,P,T,I,D,k,y,n,R,C,w,g,s,u,S,v,_,p,c,l,t,i,o,r,a,h,m,b,f,d,A,L,B,J,j,U,$,F,N,M,x,O,V,q,X,me,we,Te,Pe,Fe,z,Y,te,ae,he,Ce,Oe,be,ke,Re,Be,Se,Ke,Q,se,_e,xe,Ve,$e,Ze,K,oe,de,Z,ie,le,ve){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function ye(We){const Ne=We.get(Oe.IExtHostInitDataService),qe=We.get(K.IExtHostFileSystemInfo),Je=We.get(_e.IExtHostConsumerFileSystem),et=We.get(r.IExtHostExtensionService),nt=We.get(q.IExtHostWorkspace),st=We.get(le.IExtHostTelemetry),it=We.get(_.IExtHostConfiguration),Ee=We.get(he.IURITransformerService),fe=We.get(Ce.IExtHostRpcService),ce=We.get(j.IExtHostStorage),ee=We.get(se.IExtensionStoragePaths),Ae=We.get(ae.ILogService),Le=We.get(Re.IExtHostTunnelService),Qe=We.get(Be.IExtHostApiDeprecationService),Ge=We.get(V.IExtHostWindow),rt=We.get(Z.IExtHostSecretState);fe.set(g.ExtHostContext.ExtHostFileSystemInfo,qe),fe.set(g.ExtHostContext.ExtHostLogService,Ae),fe.set(g.ExtHostContext.ExtHostWorkspace,nt),fe.set(g.ExtHostContext.ExtHostConfiguration,it),fe.set(g.ExtHostContext.ExtHostExtensionService,et),fe.set(g.ExtHostContext.ExtHostStorage,ce),fe.set(g.ExtHostContext.ExtHostTunnelService,Le),fe.set(g.ExtHostContext.ExtHostWindow,Ge),fe.set(g.ExtHostContext.ExtHostSecretState,rt),fe.set(g.ExtHostContext.ExtHostTelemetry,st);const ut=fe.set(g.ExtHostContext.ExtHostDecorations,We.get(Fe.IExtHostDecorations)),Ye=fe.set(g.ExtHostContext.ExtHostDocumentsAndEditors,We.get(o.IExtHostDocumentsAndEditors)),at=fe.set(g.ExtHostContext.ExtHostCommands,We.get(S.IExtHostCommands)),ct=fe.set(g.ExtHostContext.ExtHostTerminalService,We.get(U.IExtHostTerminalService)),ot=fe.set(g.ExtHostContext.ExtHostDebugService,We.get(Y.IExtHostDebugService)),yt=fe.set(g.ExtHostContext.ExtHostSearch,We.get(te.IExtHostSearch)),gt=fe.set(g.ExtHostContext.ExtHostTask,We.get(z.IExtHostTask)),wt=fe.set(g.ExtHostContext.ExtHostOutputService,We.get(d.IExtHostOutputService)),bt=fe.set(g.ExtHostContext.ExtHostEditorTabs,new ie.ExtHostEditorTabs),Et=fe.set(g.ExtHostContext.ExtHostUrls,new x.ExtHostUrls(fe)),vt=fe.set(g.ExtHostContext.ExtHostDocuments,new i.ExtHostDocuments(fe,Ye)),Mt=fe.set(g.ExtHostContext.ExtHostDocumentContentProviders,new l.ExtHostDocumentContentProvider(fe,Ye,Ae)),Tt=fe.set(g.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(Ae,vt,fe.getProxy(g.MainContext.MainThreadBulkEdits))),ft=fe.set(g.ExtHostContext.ExtHostNotebook,new be.ExtHostNotebookController(fe,at,Ye,vt,Ne.environment,Ae,ee)),qt=fe.set(g.ExtHostContext.ExtHostNotebookKernels,new ve.ExtHostNotebookKernels(fe,ft)),_t=fe.set(g.ExtHostContext.ExtHostEditors,new $.ExtHostEditors(fe,Ye)),Ht=fe.set(g.ExtHostContext.ExtHostTreeViews,new F.ExtHostTreeViews(fe.getProxy(g.MainContext.MainThreadTreeViews),at,Ae)),Kt=fe.set(g.ExtHostContext.ExtHostEditorInsets,new we.ExtHostEditorInsets(fe.getProxy(g.MainContext.MainThreadEditorInsets),_t,Ne.environment)),Ot=fe.set(g.ExtHostContext.ExtHostDiagnostics,new p.ExtHostDiagnostics(fe,Ae)),dt=fe.set(g.ExtHostContext.ExtHostLanguageFeatures,new m.ExtHostLanguageFeatures(fe,Ee,vt,at,Ot,Ae,Qe)),mn=fe.set(g.ExtHostContext.ExtHostFileSystem,new a.ExtHostFileSystem(fe,dt)),kt=fe.set(g.ExtHostContext.ExtHostFileSystemEventService,new h.ExtHostFileSystemEventService(fe,Ae,Ye)),Rt=fe.set(g.ExtHostContext.ExtHostQuickOpen,(0,L.createExtHostQuickOpen)(fe,nt,at)),sn=fe.set(g.ExtHostContext.ExtHostSCM,new B.ExtHostSCM(fe,at,Ae)),gn=fe.set(g.ExtHostContext.ExtHostComments,new v.ExtHostComments(fe,at,vt)),on=fe.set(g.ExtHostContext.ExtHostProgress,new A.ExtHostProgress(fe.getProxy(g.MainContext.MainThreadProgress))),pn=fe.set(g.ExtHostContext.ExtHosLabelService,new Te.ExtHostLabelService(fe)),an=fe.set(g.ExtHostContext.ExtHostTheming,new ke.ExtHostTheming(fe)),It=fe.set(g.ExtHostContext.ExtHostAuthentication,new Se.ExtHostAuthentication(fe)),Gt=fe.set(g.ExtHostContext.ExtHostTimeline,new Ke.ExtHostTimeline(fe,at)),Qt=fe.set(g.ExtHostContext.ExtHostWebviews,new O.ExtHostWebviews(fe,Ne.environment,nt,Ae,Qe)),Xt=fe.set(g.ExtHostContext.ExtHostWebviewPanels,new $e.ExtHostWebviewPanels(fe,Qt,nt)),vn=fe.set(g.ExtHostContext.ExtHostCustomEditors,new Ve.ExtHostCustomEditors(fe,vt,ee,Qt,Xt)),wn=fe.set(g.ExtHostContext.ExtHostWebviewViews,new xe.ExtHostWebviewViews(fe,Qt)),Dt=fe.set(g.ExtHostContext.ExtHostTesting,new oe.ExtHostTesting(fe,Ye,nt)),bn=fe.set(g.ExtHostContext.ExtHostUriOpeners,new de.ExtHostUriOpeners(fe)),_n=(0,me.values)(g.ExtHostContext);fe.assertRegistered(_n);const Jt=new Ze.ExtHostBulkEdits(fe,Ye),En=new u.ExtHostClipboard(fe),Nt=new f.ExtHostMessageService(fe,Ae),zt=new c.ExtHostDialogs(fe),xt=new J.ExtHostStatusBar(fe,at.converter),Yt=new b.ExtHostLanguages(fe,vt);return s.ExtHostApiCommands.register(at),function(Me,Ut,Zt){const mt=function(){let re=!Me.isUnderDevelopment;function ue(Ie){re||(Ae.info(`Extension '${Me.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),re=!0)}return function Ie(H){if(Array.isArray(H))H.forEach(Ie);else if(typeof H=="string")ue(H);else{const W=H;typeof W.scheme=="undefined"&&ue(H),!Me.enableProposedApi&&typeof W.exclusive=="boolean"&&(0,X.throwProposedApiError)(Me)}return H}}(),Sn={getSession(re,ue,Ie){return It.getSession(Me,re,ue,Ie)},get onDidChangeSessions(){return It.onDidChangeSessions},registerAuthenticationProvider(re,ue,Ie,H){return It.registerAuthenticationProvider(re,ue,Ie,H)},get onDidChangeAuthenticationProviders(){return(0,X.checkProposedApiEnabled)(Me),It.onDidChangeAuthenticationProviders},get providers(){return(0,X.checkProposedApiEnabled)(Me),It.providers},logout(re,ue){return(0,X.checkProposedApiEnabled)(Me),It.removeSession(re,ue)}},yn={registerCommand(re,ue,Ie){return at.registerCommand(!0,re,ue,Ie)},registerTextEditorCommand(re,ue,Ie){return at.registerCommand(!0,re,(...H)=>{const W=_t.getActiveTextEditor();if(!W){Ae.warn("Cannot execute "+re+" because there is no active text editor.");return}return W.edit(ne=>{ue.apply(Ie,[W,ne,...H])}).then(ne=>{ne||Ae.warn("Edits from command "+re+" were not applied.")},ne=>{Ae.warn("An error occurred while running command "+re,ne)})})},registerDiffInformationCommand:(re,ue,Ie)=>((0,X.checkProposedApiEnabled)(Me),at.registerCommand(!0,re,async(...H)=>{const W=Ye.activeEditor(!0);if(!W){Ae.warn("Cannot execute "+re+" because there is no active text editor.");return}const ne=await _t.getDiffInformation(W.id);ue.apply(Ie,[ne,...H])})),executeCommand(re,...ue){return at.executeCommand(re,...ue)},getCommands(re=!1){return at.getCommands(re)}},ln={get machineId(){return Ne.telemetryInfo.machineId},get sessionId(){return Ne.telemetryInfo.sessionId},get language(){return Ne.environment.appLanguage},get appName(){return Ne.environment.appName},get appRoot(){var re,ue;return(ue=(re=Ne.environment.appRoot)===null||re===void 0?void 0:re.fsPath)!==null&&ue!==void 0?ue:""},get uriScheme(){return Ne.environment.appUriScheme},get clipboard(){return En.value},get shell(){return ct.getDefaultShell(!1,Zt)},get isTelemetryEnabled(){return st.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return st.onDidChangeTelemetryEnabled},get isNewAppInstall(){const re=Date.now()-new Date(Ne.telemetryInfo.firstSessionDate).getTime();return isNaN(re)?!1:re<1e3*60*60*24},openExternal(re,ue){return Ge.openUri(re,{allowTunneling:!!Ne.remote.authority,allowContributedOpeners:ue==null?void 0:ue.allowContributedOpeners})},asExternalUri(re){return re.scheme===Ne.environment.appUriScheme?Et.createAppUri(re):Ge.asExternalUri(re,{allowTunneling:!!Ne.remote.authority})},get remoteName(){return(0,Pe.getRemoteName)(Ne.remote.authority)},get uiKind(){return Ne.uiKind}};Ne.environment.extensionTestsLocationURI||Object.freeze(ln);const Vt=Ne.remote.isRemote?M.ExtensionKind.Workspace:M.ExtensionKind.UI,Dn={registerTestProvider(re){return(0,X.checkProposedApiEnabled)(Me),Dt.registerTestProvider(re)},createDocumentTestObserver(re){return(0,X.checkProposedApiEnabled)(Me),Dt.createTextDocumentTestObserver(re)},createWorkspaceTestObserver(re){return(0,X.checkProposedApiEnabled)(Me),Dt.createWorkspaceTestObserver(re)},runTests(re){return(0,X.checkProposedApiEnabled)(Me),Dt.runTests(re)},publishTestResult(re,ue=!0){return(0,X.checkProposedApiEnabled)(Me),Dt.publishExtensionProvidedResults(re,ue)},get onDidChangeTestResults(){return(0,X.checkProposedApiEnabled)(Me),Dt.onResultsChanged},get testResults(){return(0,X.checkProposedApiEnabled)(Me),Dt.results}},Cn={getExtension(re){const ue=Ut.getExtensionDescription(re);if(ue)return new r.Extension(et,Me.identifier,ue,Vt)},get all(){return Ut.getAllExtensionDescriptions().map(re=>new r.Extension(et,Me.identifier,re,Vt))},get onDidChange(){return Ut.onDidChange}},kn={createDiagnosticCollection(re){return Ot.createDiagnosticCollection(Me.identifier,re)},get onDidChangeDiagnostics(){return Ot.onDidChangeDiagnostics},getDiagnostics:re=>Ot.getDiagnostics(re),getLanguages(){return Yt.getLanguages()},setTextDocumentLanguage(re,ue){return Yt.changeLanguage(re.uri,ue)},match(re,ue){return(0,C.score)(N.LanguageSelector.from(re),ue.uri,ue.languageId,!0)},registerCodeActionsProvider(re,ue,Ie){return dt.registerCodeActionProvider(Me,mt(re),ue,Ie)},registerCodeLensProvider(re,ue){return dt.registerCodeLensProvider(Me,mt(re),ue)},registerDefinitionProvider(re,ue){return dt.registerDefinitionProvider(Me,mt(re),ue)},registerDeclarationProvider(re,ue){return dt.registerDeclarationProvider(Me,mt(re),ue)},registerImplementationProvider(re,ue){return dt.registerImplementationProvider(Me,mt(re),ue)},registerTypeDefinitionProvider(re,ue){return dt.registerTypeDefinitionProvider(Me,mt(re),ue)},registerHoverProvider(re,ue){return dt.registerHoverProvider(Me,mt(re),ue,Me.identifier)},registerEvaluatableExpressionProvider(re,ue){return dt.registerEvaluatableExpressionProvider(Me,mt(re),ue,Me.identifier)},registerInlineValuesProvider(re,ue){return dt.registerInlineValuesProvider(Me,mt(re),ue,Me.identifier)},registerDocumentHighlightProvider(re,ue){return dt.registerDocumentHighlightProvider(Me,mt(re),ue)},registerLinkedEditingRangeProvider(re,ue){return dt.registerLinkedEditingRangeProvider(Me,mt(re),ue)},registerReferenceProvider(re,ue){return dt.registerReferenceProvider(Me,mt(re),ue)},registerRenameProvider(re,ue){return dt.registerRenameProvider(Me,mt(re),ue)},registerDocumentSymbolProvider(re,ue,Ie){return dt.registerDocumentSymbolProvider(Me,mt(re),ue,Ie)},registerWorkspaceSymbolProvider(re){return dt.registerWorkspaceSymbolProvider(Me,re)},registerDocumentFormattingEditProvider(re,ue){return dt.registerDocumentFormattingEditProvider(Me,mt(re),ue)},registerDocumentRangeFormattingEditProvider(re,ue){return dt.registerDocumentRangeFormattingEditProvider(Me,mt(re),ue)},registerOnTypeFormattingEditProvider(re,ue,Ie,...H){return dt.registerOnTypeFormattingEditProvider(Me,mt(re),ue,[Ie].concat(H))},registerDocumentSemanticTokensProvider(re,ue,Ie){return dt.registerDocumentSemanticTokensProvider(Me,mt(re),ue,Ie)},registerDocumentRangeSemanticTokensProvider(re,ue,Ie){return dt.registerDocumentRangeSemanticTokensProvider(Me,mt(re),ue,Ie)},registerSignatureHelpProvider(re,ue,Ie,...H){return typeof Ie=="object"?dt.registerSignatureHelpProvider(Me,mt(re),ue,Ie):dt.registerSignatureHelpProvider(Me,mt(re),ue,typeof Ie=="undefined"?[]:[Ie,...H])},registerCompletionItemProvider(re,ue,...Ie){return dt.registerCompletionItemProvider(Me,mt(re),ue,Ie)},registerDocumentLinkProvider(re,ue){return dt.registerDocumentLinkProvider(Me,mt(re),ue)},registerColorProvider(re,ue){return dt.registerColorProvider(Me,mt(re),ue)},registerFoldingRangeProvider(re,ue){return dt.registerFoldingRangeProvider(Me,mt(re),ue)},registerSelectionRangeProvider(re,ue){return dt.registerSelectionRangeProvider(Me,re,ue)},registerCallHierarchyProvider(re,ue){return dt.registerCallHierarchyProvider(Me,re,ue)},setLanguageConfiguration:(re,ue)=>dt.setLanguageConfiguration(Me,re,ue),getTokenInformationAtPosition(re,ue){return(0,X.checkProposedApiEnabled)(Me),Yt.tokenAtPosition(re,ue)},registerInlineHintsProvider(re,ue){return(0,X.checkProposedApiEnabled)(Me),dt.registerInlineHintsProvider(Me,re,ue)}},Pn={get activeTextEditor(){return _t.getActiveTextEditor()},get visibleTextEditors(){return _t.getVisibleTextEditors()},get activeTerminal(){return ct.activeTerminal},get terminals(){return ct.terminals},async showTextDocument(re,ue,Ie){const H=await(k.URI.isUri(re)?Promise.resolve(cn.openTextDocument(re)):Promise.resolve(re));return _t.showTextDocument(H,ue,Ie)},createTextEditorDecorationType(re){return _t.createTextEditorDecorationType(re)},onDidChangeActiveTextEditor(re,ue,Ie){return _t.onDidChangeActiveTextEditor(re,ue,Ie)},onDidChangeVisibleTextEditors(re,ue,Ie){return _t.onDidChangeVisibleTextEditors(re,ue,Ie)},onDidChangeTextEditorSelection(re,ue,Ie){return _t.onDidChangeTextEditorSelection(re,ue,Ie)},onDidChangeTextEditorOptions(re,ue,Ie){return _t.onDidChangeTextEditorOptions(re,ue,Ie)},onDidChangeTextEditorVisibleRanges(re,ue,Ie){return _t.onDidChangeTextEditorVisibleRanges(re,ue,Ie)},onDidChangeTextEditorViewColumn(re,ue,Ie){return _t.onDidChangeTextEditorViewColumn(re,ue,Ie)},onDidCloseTerminal(re,ue,Ie){return ct.onDidCloseTerminal(re,ue,Ie)},onDidOpenTerminal(re,ue,Ie){return ct.onDidOpenTerminal(re,ue,Ie)},onDidChangeActiveTerminal(re,ue,Ie){return ct.onDidChangeActiveTerminal(re,ue,Ie)},onDidChangeTerminalDimensions(re,ue,Ie){return(0,X.checkProposedApiEnabled)(Me),ct.onDidChangeTerminalDimensions(re,ue,Ie)},onDidWriteTerminalData(re,ue,Ie){return(0,X.checkProposedApiEnabled)(Me),ct.onDidWriteTerminalData(re,ue,Ie)},get state(){return Ge.state},onDidChangeWindowState(re,ue,Ie){return Ge.onDidChangeWindowState(re,ue,Ie)},showInformationMessage(re,...ue){return Nt.showMessage(Me,D.default.Info,re,ue[0],ue.slice(1))},showWarningMessage(re,...ue){return Nt.showMessage(Me,D.default.Warning,re,ue[0],ue.slice(1))},showErrorMessage(re,...ue){return Nt.showMessage(Me,D.default.Error,re,ue[0],ue.slice(1))},showQuickPick(re,ue,Ie){return Rt.showQuickPick(re,!!Me.enableProposedApi,ue,Ie)},showWorkspaceFolderPick(re){return Rt.showWorkspaceFolderPick(re)},showInputBox(re,ue){return Rt.showInput(re,ue)},showOpenDialog(re){return zt.showOpenDialog(re)},showSaveDialog(re){return zt.showSaveDialog(re)},createStatusBarItem(re,ue){let Ie,H,W,ne;return re&&typeof re!="number"?(Ie=re.id,H=re.name,W=re.alignment,ue=re.priority,ne=re.accessibilityInformation):(Ie=Me.identifier.value,H=E.localize(0,null,Me.displayName||Me.name),W=re),xt.createStatusBarEntry(Ie,H,W,ue,ne)},setStatusBarMessage(re,ue){return xt.setStatusBarMessage(re,ue)},withScmProgress(re){return Qe.report("window.withScmProgress",Me,"Use 'withProgress' instead."),on.withProgress(Me,{location:M.ProgressLocation.SourceControl},(ue,Ie)=>re({report(H){}}))},withProgress(re,ue){return on.withProgress(Me,re,ue)},createOutputChannel(re){return wt.createOutputChannel(re)},createWebviewPanel(re,ue,Ie,H){return Xt.createWebviewPanel(Me,re,ue,Ie,H)},createWebviewTextEditorInset(re,ue,Ie,H){return(0,X.checkProposedApiEnabled)(Me),Kt.createWebviewEditorInset(re,ue,Ie,H,Me)},createTerminal(re,ue,Ie){return typeof re=="object"?"pty"in re?ct.createExtensionTerminal(re):(re.message&&(0,X.checkProposedApiEnabled)(Me),re.icon&&(0,X.checkProposedApiEnabled)(Me),ct.createTerminalFromOptions(re)):ct.createTerminal(re,ue,Ie)},registerTerminalLinkProvider(re){return ct.registerLinkProvider(re)},registerTreeDataProvider(re,ue){return Ht.registerTreeDataProvider(re,ue,Me)},createTreeView(re,ue){return Ht.createTreeView(re,ue,Me)},registerWebviewPanelSerializer:(re,ue)=>Xt.registerWebviewPanelSerializer(Me,re,ue),registerCustomEditorProvider:(re,ue,Ie={})=>vn.registerCustomEditorProvider(Me,re,ue,Ie),registerFileDecorationProvider(re){return ut.registerFileDecorationProvider(re,Me.identifier)},registerUriHandler(re){return Et.registerUriHandler(Me.identifier,re)},createQuickPick(){return Rt.createQuickPick(Me.identifier,!!Me.enableProposedApi)},createInputBox(){return Rt.createInputBox(Me.identifier)},get activeColorTheme(){return an.activeColorTheme},onDidChangeActiveColorTheme(re,ue,Ie){return an.onDidChangeActiveColorTheme(re,ue,Ie)},registerWebviewViewProvider(re,ue,Ie){return wn.registerWebviewViewProvider(Me,re,ue,Ie==null?void 0:Ie.webviewOptions)},get activeNotebookEditor(){return(0,X.checkProposedApiEnabled)(Me),ft.activeNotebookEditor},onDidChangeActiveNotebookEditor(re,ue,Ie){return(0,X.checkProposedApiEnabled)(Me),ft.onDidChangeActiveNotebookEditor(re,ue,Ie)},get visibleNotebookEditors(){return(0,X.checkProposedApiEnabled)(Me),ft.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,X.checkProposedApiEnabled)(Me),ft.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(re,ue,Ie){return(0,X.checkProposedApiEnabled)(Me),ft.onDidChangeNotebookEditorSelection(re,ue,Ie)},onDidChangeNotebookEditorVisibleRanges(re,ue,Ie){return(0,X.checkProposedApiEnabled)(Me),ft.onDidChangeNotebookEditorVisibleRanges(re,ue,Ie)},showNotebookDocument(re,ue){return(0,X.checkProposedApiEnabled)(Me),ft.showNotebookDocument(re,ue)},registerExternalUriOpener(re,ue,Ie){return(0,X.checkProposedApiEnabled)(Me),bn.registerExternalUriOpener(Me.identifier,re,ue,Ie)},get openEditors(){return(0,X.checkProposedApiEnabled)(Me),bt.tabs},get onDidChangeOpenEditors(){return(0,X.checkProposedApiEnabled)(Me),bt.onDidChangeTabs}},cn={get rootPath(){return Qe.report("workspace.rootPath",Me,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),nt.getPath()},set rootPath(re){throw T.readonly()},getWorkspaceFolder(re){return nt.getWorkspaceFolder(re)},get workspaceFolders(){return nt.getWorkspaceFolders()},get name(){return nt.name},set name(re){throw T.readonly()},get workspaceFile(){return nt.workspaceFile},set workspaceFile(re){throw T.readonly()},updateWorkspaceFolders:(re,ue,...Ie)=>nt.updateWorkspaceFolders(Me,re,ue||0,...Ie),onDidChangeWorkspaceFolders:function(re,ue,Ie){return nt.onDidChangeWorkspace(re,ue,Ie)},asRelativePath:(re,ue)=>nt.getRelativePath(re,ue),findFiles:(re,ue,Ie,H)=>nt.findFiles(N.GlobPattern.from(re),N.GlobPattern.from(ue),Ie,Me.identifier,H),findTextInFiles:(re,ue,Ie,H)=>{let W,ne;return typeof ue=="object"?(W=ue,ne=Ie):(W={},ne=ue,H=Ie),nt.findTextInFiles(re,W||{},ne,Me.identifier,H)},saveAll:re=>nt.saveAll(re),applyEdit(re){return Jt.applyWorkspaceEdit(re)},createFileSystemWatcher:(re,ue,Ie,H)=>kt.createFileSystemWatcher(N.GlobPattern.from(re),ue,Ie,H),get textDocuments(){return vt.getAllDocumentData().map(re=>re.document)},set textDocuments(re){throw T.readonly()},openTextDocument(re){let ue;const Ie=re;if(typeof re=="string")ue=Promise.resolve(k.URI.file(re));else if(k.URI.isUri(re))ue=Promise.resolve(re);else if(!Ie||typeof Ie=="object")ue=vt.createDocumentData(Ie);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ue.then(H=>vt.ensureDocumentData(H).then(W=>W.document))},onDidOpenTextDocument:(re,ue,Ie)=>vt.onDidAddDocument(re,ue,Ie),onDidCloseTextDocument:(re,ue,Ie)=>vt.onDidRemoveDocument(re,ue,Ie),onDidChangeTextDocument:(re,ue,Ie)=>vt.onDidChangeDocument(re,ue,Ie),onDidSaveTextDocument:(re,ue,Ie)=>vt.onDidSaveDocument(re,ue,Ie),onWillSaveTextDocument:(re,ue,Ie)=>Tt.getOnWillSaveTextDocumentEvent(Me)(re,ue,Ie),onDidChangeConfiguration:(re,ue,Ie)=>Zt.onDidChangeConfiguration(re,ue,Ie),getConfiguration(re,ue){return ue=arguments.length===1?void 0:ue,Zt.getConfiguration(re,ue,Me)},registerTextDocumentContentProvider(re,ue){return Mt.registerTextDocumentContentProvider(re,ue)},registerTaskProvider:(re,ue)=>(Qe.report("window.registerTaskProvider",Me,"Use the corresponding function on the 'tasks' namespace instead"),gt.registerTaskProvider(Me,re,ue)),registerFileSystemProvider(re,ue,Ie){return mn.registerFileSystemProvider(Me.identifier,re,ue,Ie)},get fs(){return Je.value},registerFileSearchProvider:(re,ue)=>((0,X.checkProposedApiEnabled)(Me),yt.registerFileSearchProvider(re,ue)),registerTextSearchProvider:(re,ue)=>((0,X.checkProposedApiEnabled)(Me),yt.registerTextSearchProvider(re,ue)),registerRemoteAuthorityResolver:(re,ue)=>((0,X.checkProposedApiEnabled)(Me),et.registerRemoteAuthorityResolver(re,ue)),registerResourceLabelFormatter:re=>((0,X.checkProposedApiEnabled)(Me),pn.$registerResourceLabelFormatter(re)),onDidCreateFiles:(re,ue,Ie)=>kt.onDidCreateFile(re,ue,Ie),onDidDeleteFiles:(re,ue,Ie)=>kt.onDidDeleteFile(re,ue,Ie),onDidRenameFiles:(re,ue,Ie)=>kt.onDidRenameFile(re,ue,Ie),onWillCreateFiles:(re,ue,Ie)=>kt.getOnWillCreateFileEvent(Me)(re,ue,Ie),onWillDeleteFiles:(re,ue,Ie)=>kt.getOnWillDeleteFileEvent(Me)(re,ue,Ie),onWillRenameFiles:(re,ue,Ie)=>kt.getOnWillRenameFileEvent(Me)(re,ue,Ie),openTunnel:re=>((0,X.checkProposedApiEnabled)(Me),Le.openTunnel(Me,re).then(ue=>{if(!ue)throw new Error("cannot open tunnel");return ue})),get tunnels(){return(0,X.checkProposedApiEnabled)(Me),Le.getTunnels()},onDidChangeTunnels:(re,ue,Ie)=>((0,X.checkProposedApiEnabled)(Me),Le.onDidChangeTunnels(re,ue,Ie)),registerPortAttributesProvider:(re,ue)=>((0,X.checkProposedApiEnabled)(Me),Le.registerPortsAttributesProvider(re,ue)),registerTimelineProvider:(re,ue)=>((0,X.checkProposedApiEnabled)(Me),Gt.registerTimelineProvider(re,ue,Me.identifier,at.converter)),get isTrusted(){return(0,X.checkProposedApiEnabled)(Me),nt.trusted},requestWorkspaceTrust:re=>((0,X.checkProposedApiEnabled)(Me),nt.requestWorkspaceTrust(re)),onDidReceiveWorkspaceTrust:(re,ue,Ie)=>nt.onDidReceiveWorkspaceTrust(re,ue,Ie)},un={get inputBox(){return Qe.report("scm.inputBox",Me,"Use 'SourceControl.inputBox' instead"),sn.getLastInputBox(Me)},createSourceControl(re,ue,Ie){return sn.createSourceControl(Me,re,ue,Ie)}},jt={createCommentController(re,ue){return gn.createCommentController(Me,re,ue)}},dn={get activeDebugSession(){return ot.activeDebugSession},get activeDebugConsole(){return ot.activeDebugConsole},get breakpoints(){return ot.breakpoints},onDidStartDebugSession(re,ue,Ie){return ot.onDidStartDebugSession(re,ue,Ie)},onDidTerminateDebugSession(re,ue,Ie){return ot.onDidTerminateDebugSession(re,ue,Ie)},onDidChangeActiveDebugSession(re,ue,Ie){return ot.onDidChangeActiveDebugSession(re,ue,Ie)},onDidReceiveDebugSessionCustomEvent(re,ue,Ie){return ot.onDidReceiveDebugSessionCustomEvent(re,ue,Ie)},onDidChangeBreakpoints(re,ue,Ie){return ot.onDidChangeBreakpoints(re,ue,Ie)},registerDebugConfigurationProvider(re,ue,Ie){return ot.registerDebugConfigurationProvider(re,ue,Ie||M.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(re,ue){return ot.registerDebugAdapterDescriptorFactory(Me,re,ue)},registerDebugAdapterTrackerFactory(re,ue){return ot.registerDebugAdapterTrackerFactory(re,ue)},startDebugging(re,ue,Ie){return!Ie||typeof Ie=="object"&&"configuration"in Ie?ot.startDebugging(re,ue,{parentSession:Ie}):ot.startDebugging(re,ue,Ie||{})},stopDebugging(re){return ot.stopDebugging(re)},addBreakpoints(re){return ot.addBreakpoints(re)},removeBreakpoints(re){return ot.removeBreakpoints(re)},asDebugSourceUri(re,ue){return ot.asDebugSourceUri(re,ue)}},In={registerTaskProvider:(re,ue)=>gt.registerTaskProvider(Me,re,ue),fetchTasks:re=>gt.fetchTasks(re),executeTask:re=>gt.executeTask(Me,re),get taskExecutions(){return gt.taskExecutions},onDidStartTask:(re,ue,Ie)=>gt.onDidStartTask(re,ue,Ie),onDidEndTask:(re,ue,Ie)=>gt.onDidEndTask(re,ue,Ie),onDidStartTaskProcess:(re,ue,Ie)=>gt.onDidStartTaskProcess(re,ue,Ie),onDidEndTaskProcess:(re,ue,Ie)=>gt.onDidEndTaskProcess(re,ue,Ie)},en={openNotebookDocument:re=>((0,X.checkProposedApiEnabled)(Me),ft.openNotebookDocument(re)),get onDidOpenNotebookDocument(){return(0,X.checkProposedApiEnabled)(Me),ft.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return(0,X.checkProposedApiEnabled)(Me),ft.onDidCloseNotebookDocument},get onDidSaveNotebookDocument(){return(0,X.checkProposedApiEnabled)(Me),ft.onDidSaveNotebookDocument},get notebookDocuments(){return(0,X.checkProposedApiEnabled)(Me),ft.notebookDocuments.map(re=>re.notebookDocument)},get onDidChangeActiveNotebookKernel(){return(0,X.checkProposedApiEnabled)(Me),ft.onDidChangeActiveNotebookKernel},registerNotebookSerializer(re,ue,Ie){return(0,X.checkProposedApiEnabled)(Me),ft.registerNotebookSerializer(Me,re,ue,Ie)},registerNotebookContentProvider:(re,ue,Ie)=>((0,X.checkProposedApiEnabled)(Me),ft.registerNotebookContentProvider(Me,re,ue,Ie)),registerNotebookKernelProvider:(re,ue)=>((0,X.checkProposedApiEnabled)(Me),ft.registerNotebookKernelProvider(Me,re,ue)),createNotebookEditorDecorationType(re){return(0,X.checkProposedApiEnabled)(Me),ft.createNotebookEditorDecorationType(re)},onDidChangeNotebookDocumentMetadata(re,ue,Ie){return(0,X.checkProposedApiEnabled)(Me),ft.onDidChangeNotebookDocumentMetadata(re,ue,Ie)},onDidChangeNotebookCells(re,ue,Ie){return(0,X.checkProposedApiEnabled)(Me),ft.onDidChangeNotebookCells(re,ue,Ie)},onDidChangeCellExecutionState(re,ue,Ie){return(0,X.checkProposedApiEnabled)(Me),ft.onDidChangeNotebookCellExecutionState(re,ue,Ie)},onDidChangeCellOutputs(re,ue,Ie){return(0,X.checkProposedApiEnabled)(Me),ft.onDidChangeCellOutputs(re,ue,Ie)},onDidChangeCellMetadata(re,ue,Ie){return(0,X.checkProposedApiEnabled)(Me),ft.onDidChangeCellMetadata(re,ue,Ie)},createConcatTextDocument(re,ue){return(0,X.checkProposedApiEnabled)(Me),new Q.ExtHostNotebookConcatDocument(ft,vt,re,ue)},createCellStatusBarItem(re,ue,Ie){return(0,X.checkProposedApiEnabled)(Me),ft.createNotebookCellStatusBarItemInternal(re,ue,Ie)},createNotebookCellExecutionTask(re,ue,Ie){return(0,X.checkProposedApiEnabled)(Me),ft.createNotebookCellExecution(re,ue,Ie)},createNotebookKernel(re){return(0,X.checkProposedApiEnabled)(Me),qt.createKernel(Me,re)}};return{version:Ne.version,authentication:Sn,commands:yn,comments:jt,debug:dn,env:ln,extensions:Cn,languages:kn,notebook:en,scm:un,tasks:In,test:Dn,window:Pn,workspace:cn,Breakpoint:M.Breakpoint,CallHierarchyIncomingCall:M.CallHierarchyIncomingCall,CallHierarchyItem:M.CallHierarchyItem,CallHierarchyOutgoingCall:M.CallHierarchyOutgoingCall,CancellationError:T.CancellationError,CancellationTokenSource:P.CancellationTokenSource,CandidatePortSource:g.CandidatePortSource,CodeAction:M.CodeAction,CodeActionKind:M.CodeActionKind,CodeActionTriggerKind:M.CodeActionTriggerKind,CodeLens:M.CodeLens,Color:M.Color,ColorInformation:M.ColorInformation,ColorPresentation:M.ColorPresentation,ColorThemeKind:M.ColorThemeKind,CommentMode:M.CommentMode,CommentThreadCollapsibleState:M.CommentThreadCollapsibleState,CompletionItem:M.CompletionItem,CompletionItemKind:M.CompletionItemKind,CompletionItemTag:M.CompletionItemTag,CompletionList:M.CompletionList,CompletionTriggerKind:M.CompletionTriggerKind,ConfigurationTarget:M.ConfigurationTarget,CustomExecution:M.CustomExecution,DebugAdapterExecutable:M.DebugAdapterExecutable,DebugAdapterInlineImplementation:M.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:M.DebugAdapterNamedPipeServer,DebugAdapterServer:M.DebugAdapterServer,DebugConfigurationProviderTriggerKind:M.DebugConfigurationProviderTriggerKind,DebugConsoleMode:M.DebugConsoleMode,DecorationRangeBehavior:M.DecorationRangeBehavior,Diagnostic:M.Diagnostic,DiagnosticRelatedInformation:M.DiagnosticRelatedInformation,DiagnosticSeverity:M.DiagnosticSeverity,DiagnosticTag:M.DiagnosticTag,Disposable:M.Disposable,DocumentHighlight:M.DocumentHighlight,DocumentHighlightKind:M.DocumentHighlightKind,DocumentLink:M.DocumentLink,DocumentSymbol:M.DocumentSymbol,EndOfLine:M.EndOfLine,EnvironmentVariableMutatorType:M.EnvironmentVariableMutatorType,EvaluatableExpression:M.EvaluatableExpression,InlineValueText:M.InlineValueText,InlineValueVariableLookup:M.InlineValueVariableLookup,InlineValueEvaluatableExpression:M.InlineValueEvaluatableExpression,EventEmitter:I.Emitter,ExtensionKind:M.ExtensionKind,ExtensionMode:M.ExtensionMode,ExternalUriOpenerPriority:M.ExternalUriOpenerPriority,FileChangeType:M.FileChangeType,FileDecoration:M.FileDecoration,FileSystemError:M.FileSystemError,FileType:w.FileType,FoldingRange:M.FoldingRange,FoldingRangeKind:M.FoldingRangeKind,FunctionBreakpoint:M.FunctionBreakpoint,Hover:M.Hover,IndentAction:R.IndentAction,Location:M.Location,MarkdownString:M.MarkdownString,OverviewRulerLane:n.OverviewRulerLane,ParameterInformation:M.ParameterInformation,PortAutoForwardAction:M.PortAutoForwardAction,Position:M.Position,ProcessExecution:M.ProcessExecution,ProgressLocation:M.ProgressLocation,QuickInputButtons:M.QuickInputButtons,Range:M.Range,RelativePattern:M.RelativePattern,Selection:M.Selection,SelectionRange:M.SelectionRange,SemanticTokens:M.SemanticTokens,SemanticTokensBuilder:M.SemanticTokensBuilder,SemanticTokensEdit:M.SemanticTokensEdit,SemanticTokensEdits:M.SemanticTokensEdits,SemanticTokensLegend:M.SemanticTokensLegend,ShellExecution:M.ShellExecution,ShellQuoting:M.ShellQuoting,SignatureHelp:M.SignatureHelp,SignatureHelpTriggerKind:M.SignatureHelpTriggerKind,SignatureInformation:M.SignatureInformation,SnippetString:M.SnippetString,SourceBreakpoint:M.SourceBreakpoint,StandardTokenType:M.StandardTokenType,StatusBarAlignment:M.StatusBarAlignment,SymbolInformation:M.SymbolInformation,SymbolKind:M.SymbolKind,SymbolTag:M.SymbolTag,Task:M.Task,TaskGroup:M.TaskGroup,TaskPanelKind:M.TaskPanelKind,TaskRevealKind:M.TaskRevealKind,TaskScope:M.TaskScope,TextDocumentSaveReason:M.TextDocumentSaveReason,TextEdit:M.TextEdit,TextEditorCursorStyle:y.TextEditorCursorStyle,TextEditorLineNumbersStyle:M.TextEditorLineNumbersStyle,TextEditorRevealType:M.TextEditorRevealType,TextEditorSelectionChangeKind:M.TextEditorSelectionChangeKind,ThemeColor:M.ThemeColor,ThemeIcon:M.ThemeIcon,TreeItem:M.TreeItem,TreeItemCollapsibleState:M.TreeItemCollapsibleState,UIKind:g.UIKind,Uri:k.URI,ViewColumn:M.ViewColumn,WorkspaceEdit:M.WorkspaceEdit,InlineHint:M.InlineHint,InlineHintKind:M.InlineHintKind,RemoteAuthorityResolverError:M.RemoteAuthorityResolverError,ResolvedAuthority:M.ResolvedAuthority,SourceControlInputBoxValidationType:M.SourceControlInputBoxValidationType,ExtensionRuntime:M.ExtensionRuntime,TimelineItem:M.TimelineItem,NotebookCellRange:M.NotebookCellRange,NotebookCellKind:M.NotebookCellKind,NotebookCellExecutionState:M.NotebookCellExecutionState,NotebookDocumentMetadata:M.NotebookDocumentMetadata,NotebookCellMetadata:M.NotebookCellMetadata,NotebookCellData:M.NotebookCellData,NotebookData:M.NotebookData,NotebookCellStatusBarAlignment:M.NotebookCellStatusBarAlignment,NotebookEditorRevealType:M.NotebookEditorRevealType,NotebookCellOutput:M.NotebookCellOutput,NotebookCellOutputItem:M.NotebookCellOutputItem,LinkedEditingRanges:M.LinkedEditingRanges,TestItem:M.TestItem,TestResultState:M.TestResultState,TestMessage:M.TestMessage,TestMessageSeverity:M.TestMessageSeverity,WorkspaceTrustState:M.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=ye}),define(ge[269],pe([0,1,78,63,32,124,35,51,39,34,65,46,67,89,88,50,62,125,87,60,86,117]),function(G,e,E,P,T,I,D,k,y,n,R,C,w,g,s,u,S,v,_,p,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,E.registerSingleton)(g.IExtensionStoragePaths,g.ExtensionStoragePaths),(0,E.registerSingleton)(S.IExtHostApiDeprecationService,S.ExtHostApiDeprecationService),(0,E.registerSingleton)(k.IExtHostCommands,k.ExtHostCommands),(0,E.registerSingleton)(D.IExtHostConfiguration,D.ExtHostConfiguration),(0,E.registerSingleton)(_.IExtHostConsumerFileSystem,_.ExtHostConsumerFileSystem),(0,E.registerSingleton)(C.IExtHostDebugService,C.WorkerExtHostDebugService),(0,E.registerSingleton)(I.IExtHostDecorations,I.ExtHostDecorations),(0,E.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors),(0,E.registerSingleton)(p.IExtHostFileSystemInfo,p.ExtHostFileSystemInfo),(0,E.registerSingleton)(P.IExtHostOutputService,P.ExtHostOutputService),(0,E.registerSingleton)(w.IExtHostSearch,w.ExtHostSearch),(0,E.registerSingleton)(s.IExtHostStorage,s.ExtHostStorage),(0,E.registerSingleton)(R.IExtHostTask,R.WorkerExtHostTask),(0,E.registerSingleton)(n.IExtHostTerminalService,n.WorkerExtHostTerminalService),(0,E.registerSingleton)(u.IExtHostTunnelService,u.ExtHostTunnelService),(0,E.registerSingleton)(v.IExtHostWindow,v.ExtHostWindow),(0,E.registerSingleton)(T.IExtHostWorkspace,T.ExtHostWorkspace),(0,E.registerSingleton)(c.IExtHostSecretState,c.ExtHostSecretState),(0,E.registerSingleton)(l.IExtHostTelemetry,l.ExtHostTelemetry)}),define(ge[90],pe([0,1,14,12,31,126]),function(G,e,E,P,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function D(C){return C.startsWith("**")||C.startsWith("/")?C:`/${C}`}e.anchorGlob=D;function k(C,w,g,s){const u=(0,E.mapArrayOrNot)(g,y),S=new T.TextSearchMatch(w,u,s),v=S.preview.matches;return{ranges:(0,E.mapArrayOrNot)(u,n),uri:C,preview:{text:S.preview.text,matches:(0,E.mapArrayOrNot)(v,n)}}}e.createTextSearchResult=k;function y(C){return new T.SearchRange(C.start.line,C.start.character,C.end.line,C.end.character)}function n(C){return new I.Range(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn)}let R=class{constructor(w,g){this.prefix=w,this.logService=g}appendLine(w){this.logService.debug(`${this.prefix}#search`,w)}};R=je([Ue(1,P.ILogService)],R),e.OutputChannel=R}),define(ge[270],pe([0,1,91,22]),function(G,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function T(t){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(i=>i===t)}e.isUTFEncoding=T,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const I=512,D=512,k=512*8,y=512*128;class n{constructor(i){this.iconvLiteDecoder=i}static async create(i){let o;if(i!==e.UTF8)o=(await new Promise((a,h)=>{G(["iconv-lite-umd"],a,h)})).getDecoder(g(i));else{const r=new TextDecoder;o={write(a){return r.decode(a,{stream:!0})},end(){return r.decode()}}}return new n(o)}write(i){return this.iconvLiteDecoder.write(i)}end(){return this.iconvLiteDecoder.end()}}function R(t,i){var o;const r=((o=i.minBytesRequiredForDetection)!==null&&o!==void 0?o:i.guessEncoding)?k:D;return new Promise((a,h)=>{const m=(0,E.newWriteableStream)(L=>L.join("")),b=[];let f=0,d;const A=async()=>{try{const L=await l({buffer:P.VSBuffer.concat(b),bytesRead:f},i.guessEncoding);L.encoding=await i.overwriteEncoding(L.encoding),d=await n.create(L.encoding);const B=d.write(P.VSBuffer.concat(b).buffer);m.write(B),b.length=0,f=0,a({stream:m,detected:L})}catch(L){h(L)}};(0,E.listenStream)(t,{onData:async L=>{d?m.write(d.write(L.buffer)):(b.push(L),f+=L.byteLength,f>=r&&(t.pause(),await A(),setTimeout(()=>t.resume())))},onError:L=>m.error(L),onEnd:async()=>{d||await A(),m.end(d==null?void 0:d.end())}})})}e.toDecodeStream=R;async function C(t,i,o){const a=(await new Promise((b,f)=>{G(["iconv-lite-umd"],b,f)})).getEncoder(g(i),o);let h=!1,m=!1;return{read(){if(m)return null;const b=t.read();if(typeof b!="string"){if(m=!0,!h&&(o==null?void 0:o.addBOM))switch(i){case e.UTF8:case e.UTF8_with_bom:return P.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return P.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return P.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const f=a.end();return f&&f.length>0?(h=!0,P.VSBuffer.wrap(f)):null}return h=!0,P.VSBuffer.wrap(a.write(b))}}}e.toEncodeReadable=C;async function w(t){return(await new Promise((o,r)=>{G(["iconv-lite-umd"],o,r)})).encodingExists(g(t))}e.encodingExists=w;function g(t){return t===e.UTF8_with_bom||t===null?e.UTF8:t}e.toNodeEncoding=g;function s(t,i){if(!t||i<e.UTF16be_BOM.length)return null;const o=t.readUInt8(0),r=t.readUInt8(1);if(o===e.UTF16be_BOM[0]&&r===e.UTF16be_BOM[1])return e.UTF16be;if(o===e.UTF16le_BOM[0]&&r===e.UTF16le_BOM[1])return e.UTF16le;if(i<e.UTF8_BOM.length)return null;const a=t.readUInt8(2);return o===e.UTF8_BOM[0]&&r===e.UTF8_BOM[1]&&a===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=s;const u=["ascii","utf-16","utf-32"];async function S(t){const i=await new Promise((m,b)=>{G(["jschardet"],m,b)}),o=t.slice(0,y),r=p(o.buffer),a=i.detect(r);if(!a||!a.encoding)return null;const h=a.encoding.toLowerCase();return 0<=u.indexOf(h)?null:_(a.encoding)}const v={ibm866:"cp866",big5:"cp950"};function _(t){const i=t.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return v[i]||i}function p(t){let i="";for(let o=0;o<t.length;o++)i+=String.fromCharCode(t[o]);return i}function c(t){switch(t){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const i=t.match(/windows(\d+)/);return i?"windows-"+i[1]:t}}e.toCanonicalName=c;function l({buffer:t,bytesRead:i},o){let r=s(t,i),a=!1;if(r!==e.UTF16be&&r!==e.UTF16le&&t){let h=!0,m=!0,b=!1;for(let f=0;f<i&&f<I;f++){const d=f%2==1,A=t.readUInt8(f)===0;if(A&&(b=!0),h&&(d&&!A||!d&&A)&&(h=!1),m&&(d&&A||!d&&!A)&&(m=!1),A&&!h&&!m)break}b&&(h?r=e.UTF16le:m?r=e.UTF16be:a=!0)}return o&&!a&&!r&&t?S(t.slice(0,i)).then(h=>({seemsBinary:!1,encoding:h})):{seemsBinary:a,encoding:r}}e.detectEncodingFromBuffer=l,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ge[128],pe([0,1,270,26,127]),function(G,e,E,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class I extends T.TextSearchManager{constructor(k,y,n=P){super(k,y,{readdir:R=>n.readdir(R.fsPath),toCanonicalName:R=>(0,E.toCanonicalName)(R)})}}e.NativeTextSearchManager=I}),define(ge[271],pe([0,1,272,286,287,2,288]),function(G,e,E,P,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function k(C,w,g,s,u,S){const v=S.environment.useHostProxy,_=typeof v=="boolean"?v:!S.remote.isRemote,p=(0,D.createProxyResolver)({resolveProxy:l=>C.resolveProxy(l),getHttpProxySetting:()=>w.getConfiguration("http").get("proxy"),log:(l,t,...i)=>{switch(l){case D.LogLevel.Trace:s.trace(t,...i);break;case D.LogLevel.Debug:s.debug(t,...i);break;case D.LogLevel.Info:s.info(t,...i);break;case D.LogLevel.Warning:s.warn(t,...i);break;case D.LogLevel.Error:s.error(t,...i);break;case D.LogLevel.Critical:s.critical(t,...i);break;case D.LogLevel.Off:break;default:o(l,t,i);break}function o(r,a,...h){s.error("Unknown log level",r),s.error(a,...h)}},getLogLevel:()=>s.getLevel(),proxyResolveTelemetry:l=>{u.$publicLog2("resolveProxy",l)},useHostProxy:_,env:process.env}),c=y(w,p);return R(g,c)}e.connectProxyResolver=k;function y(C,w){const g={config:C.getConfiguration("http").get("proxySupport")||"off"};C.onDidChangeConfiguration(u=>{g.config=C.getConfiguration("http").get("proxySupport")||"off"});const s={config:!!C.getConfiguration("http").get("systemCertificates")};return C.onDidChangeConfiguration(u=>{s.config=!!C.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},E,(0,D.createHttpPatch)(E,w,{config:"off"},s,!0)),on:Object.assign({},E,(0,D.createHttpPatch)(E,w,{config:"on"},s,!0)),override:Object.assign({},E,(0,D.createHttpPatch)(E,w,{config:"override"},s,!0)),onRequest:Object.assign({},E,(0,D.createHttpPatch)(E,w,g,s,!0)),default:Object.assign(E,(0,D.createHttpPatch)(E,w,g,s,!1))},https:{off:Object.assign({},P,(0,D.createHttpPatch)(P,w,{config:"off"},s,!0)),on:Object.assign({},P,(0,D.createHttpPatch)(P,w,{config:"on"},s,!0)),override:Object.assign({},P,(0,D.createHttpPatch)(P,w,{config:"override"},s,!0)),onRequest:Object.assign({},P,(0,D.createHttpPatch)(P,w,g,s,!0)),default:Object.assign(P,(0,D.createHttpPatch)(P,w,g,s,!1))},tls:Object.assign(T,(0,D.createTlsPatch)(T))}}const n=new Map;function R(C,w){return C.getExtensionPathIndex().then(g=>{const s=G.__$__nodeRequire("module"),u=s._load;s._load=function(v,_,p){if(v==="tls")return w.tls;if(v!=="http"&&v!=="https")return u.apply(this,arguments);const c=w[v],l=g.findSubstr(I.URI.file(_.filename).fsPath);let t=n.get(l);if(t||n.set(l,t={}),!t[v]){let i=c.default;l&&l.enableProposedApi&&(i=c[l.proxySupport]||c.onRequest),t[v]=Object.assign({},i)}return t[v]}})}}),define(ge[273],pe([0,1,38,8,74,30,9,10,90,274]),function(G,e,E,P,T,I,D,k,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const R=n.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function C(p,c,l,t){const i=w(p,c,l,t),o=c.folder.fsPath;return{cmd:E.spawn(R,i.args,{cwd:o}),rgDiskPath:R,siblingClauses:i.siblingClauses,rgArgs:i,cwd:o}}e.spawnRipgrepCmd=C;function w(p,c,l,t){const i=["--files","--hidden","--case-sensitive"];s([c],l,!1).forEach(r=>{const a=(0,y.anchorGlob)(r);if(i.push("-g",a),D.isMacintosh){const h=(0,T.normalizeNFD)(a);h!==a&&i.push("-g",h)}});const o=g([c],t,void 0,!1);return o.globArgs.forEach(r=>{const a=`!${(0,y.anchorGlob)(r)}`;if(i.push("-g",a),D.isMacintosh){const h=(0,T.normalizeNFD)(a);h!==a&&i.push("-g",h)}}),c.disregardIgnoreFiles!==!1?i.push("--no-ignore"):i.push("--no-ignore-parent"),c.ignoreSymlinks||i.push("--follow"),p.exists&&i.push("--quiet"),i.push("--no-config"),c.disregardGlobalIgnoreFiles&&i.push("--no-ignore-global"),{args:i,siblingClauses:o.siblingClauses}}function g(p,c,l,t=!0){const i=[];let o={};return p.forEach(r=>{const a=Object.assign({},r.excludePattern||{},c||{}),h=u(a,t?r.folder.fsPath:void 0,l);i.push(...h.globArgs),h.siblingClauses&&(o=Object.assign(o,h.siblingClauses))}),{globArgs:i,siblingClauses:o}}e.foldersToRgExcludeGlobs=g;function s(p,c,l=!0){const t=[];return p.forEach(i=>{const o=Object.assign({},c||{},i.includePattern||{}),r=u(o,l?i.folder.fsPath:void 0);t.push(...r.globArgs)}),t}e.foldersToIncludeGlobs=s;function u(p,c,l){const t=[],i={};return Object.keys(p).forEach(o=>{if(!(l&&l.has(o))&&!!o){const r=p[o];o=v(c?S(c,o):o),o.startsWith("\\\\")?o="\\\\"+o.substr(2).replace(/\\/g,"/"):o=o.replace(/\\/g,"/"),typeof r=="boolean"&&r?(o.startsWith("\\\\")&&(o+="**"),t.push(_(o))):r&&r.when&&(i[o]=r)}}),{globArgs:t,siblingClauses:i}}function S(p,c){return P.isAbsolute(c)?c:P.join(p,c)}e.getAbsoluteGlob=S;function v(p){return p=k.rtrim(p,"\\"),k.rtrim(p,"/")}function _(p){return I.getRoot(p).toLowerCase()==="c:/"?p.replace(/^c:[/\\]/i,"/"):p}e.fixDriveC=_}),define(ge[275],pe([0,1,38,37,8,98,14,58,33,74,30,9,47,10,15,26,31,273,96]),function(G,e,E,P,T,I,D,k,y,n,R,C,w,g,s,u,S,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const p=new Set;process.on("exit",()=>{p.forEach(o=>o())});class c{constructor(r){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=r,this.filePattern=r.filePattern||"",this.includePattern=r.includePattern&&y.parse(r.includePattern),this.maxResults=r.maxResults||null,this.exists=!!r.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,_.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=r.excludePattern&&y.parse(r.excludePattern),this.folderExcludePatterns=new Map,r.folderQueries.forEach(a=>{const h=Object.assign({},a.excludePattern||{},this.config.excludePattern||{}),m=a.folder.fsPath;r.folderQueries.map(b=>b.folder.fsPath).filter(b=>b!==m).forEach(b=>{(0,R.isEqualOrParent)(b,m)&&(h[T.relative(m,b)]=!0)}),this.folderExcludePatterns.set(m,new t(h,m))})}cancel(){this.isCanceled=!0}walk(r,a,h,m,b){if(this.fileWalkSW=w.StopWatch.create(!1),this.isCanceled)return b(null,this.isLimitHit);a.forEach(f=>{const d=T.basename(f.fsPath);this.globalExcludePattern&&this.globalExcludePattern(f.fsPath,d)||this.matchFile(h,{relativePath:f.fsPath,searchPath:void 0})}),this.cmdSW=w.StopWatch.create(!1),this.parallel(r,(f,d)=>{this.call(this.cmdTraversal,this,f,h,m,A=>{if(A){const L=(0,k.toErrorMessage)(A);console.error(L),this.errors.push(L),d(A,void 0)}else d(null,void 0)})},(f,d)=>{this.fileWalkSW.stop();const A=f?D.coalesce(f)[0]:null;b(A,this.isLimitHit)})}parallel(r,a,h){const m=new Array(r.length),b=new Array(r.length);let f=!1,d=0;if(r.length===0)return h(null,[]);r.forEach((A,L)=>{a(A,(B,J)=>{if(B?(f=!0,m[L]=null,b[L]=B):(m[L]=J,b[L]=null),++d===r.length)return h(f?b:null,m)})})}call(r,a,...h){try{r.apply(a,h)}catch(m){h[h.length-1](m)}}cmdTraversal(r,a,h,m){const b=r.folder.fsPath,f=C.isMacintosh;let d;const A=()=>d&&d.kill();p.add(A);let L=N=>{p.delete(A),L=()=>{},m(N)},B="";const J=this.initDirectoryTree();let j;const U=(0,v.spawnRipgrepCmd)(this.config,r,this.config.includePattern,this.folderExcludePatterns.get(r.folder.fsPath).expression);d=U.cmd,j=!Object.keys(U.siblingClauses).length;const $=U.rgArgs.args.map(N=>N.match(/^-/)?N:`'${N}'`).join(" ");let F=`${U.rgDiskPath} ${$}
 - cwd: ${U.cwd}`;U.rgArgs.siblingClauses&&(F+=`
 - Sibling clauses: ${JSON.stringify(U.rgArgs.siblingClauses)}`),h({message:F}),this.cmdResultCount=0,this.collectStdout(d,"utf8",h,(N,M,x)=>{if(N){L(N);return}if(this.isLimitHit){L();return}const V=(B+(f?n.normalizeNFC(M||""):M)).split(`
`);if(x){const q=V.length;V[q-1]=V[q-1].trim(),V[q-1]||V.pop()}else B=V.pop()||"";if(V.length&&V[0].indexOf(`
`)!==-1){L(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=V.length,j){for(const q of V)if(this.matchFile(a,{base:b,relativePath:q,searchPath:this.getSearchPath(r,q)}),this.isLimitHit){A();break}(x||this.isLimitHit)&&L();return}this.addDirectoryEntries(r,J,b,V,a),x&&(this.matchDirectoryTree(J,b,a),L())})}spawnFindCmd(r){const a=this.folderExcludePatterns.get(r.folder.fsPath),h=a.getBasenameTerms(),m=a.getPathTerms(),b=["-L","."];if(h.length||m.length){b.push("-not","(","(");for(const f of h)b.push("-name",f),b.push("-o");for(const f of m)b.push("-path",f),b.push("-o");b.pop(),b.push(")","-prune",")")}return b.push("-type","f"),E.spawn("find",b,{cwd:r.folder.fsPath})}readStdout(r,a,h){let m="";this.collectStdout(r,a,()=>{},(b,f,d)=>{if(b){h(b);return}m+=f,d&&h(null,m)})}collectStdout(r,a,h,m){let b=(A,L,B)=>{(A||B)&&(b=()=>{},this.cmdSW&&this.cmdSW.stop()),m(A,L,B)},f=!1;r.stdout?(this.forwardData(r.stdout,a,b),r.stdout.once("data",()=>f=!0)):h({message:"stdout is null"});let d;r.stderr?d=this.collectData(r.stderr):h({message:"stderr is null"}),r.on("error",A=>{b(A)}),r.on("close",A=>{let L;!f&&(L=this.decodeData(d,a))&&i(L)?b(new Error(`command failed with error code ${A}: ${this.decodeData(d,a)}`)):(this.exists&&A===0&&(this.isLimitHit=!0),b(null,"",!0))})}forwardData(r,a,h){const m=new I.StringDecoder(a);return r.on("data",b=>{h(null,m.write(b))}),m}collectData(r){const a=[];return r.on("data",h=>{a.push(h)}),a}decodeData(r,a){const h=new I.StringDecoder(a);return r.map(m=>h.write(m)).join("")}initDirectoryTree(){const r={rootEntries:[],pathToEntries:Object.create(null)};return r.pathToEntries["."]=r.rootEntries,r}addDirectoryEntries(r,{pathToEntries:a},h,m,b){m.indexOf(this.filePattern)!==-1&&this.matchFile(b,{base:h,relativePath:this.filePattern,searchPath:this.getSearchPath(r,this.filePattern)});const f=d=>{const A=T.basename(d),L=T.dirname(d);let B=a[L];B||(B=a[L]=[],f(L)),B.push({base:h,relativePath:d,basename:A,searchPath:this.getSearchPath(r,d)})};m.forEach(f)}matchDirectoryTree({rootEntries:r,pathToEntries:a},h,m){const b=this,f=this.folderExcludePatterns.get(h),d=this.filePattern;function A(L){b.directoriesWalked++;const B=y.hasSiblingFn(()=>L.map(J=>J.basename));for(let J=0,j=L.length;J<j;J++){const U=L[J],{relativePath:$,basename:F}=U;if(!f.test($,F,d!==F?B:void 0)){const N=a[$];if(N)A(N);else{if(b.filesWalked++,$===d)continue;b.matchFile(m,U)}if(b.isLimitHit)break}}}A(r)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(r,a,h,m,b){const f=r.folder,d=y.hasSiblingFn(()=>h);this.parallel(h,(A,L)=>{if(this.isCanceled||this.isLimitHit)return L(null);const B=a?[a,A].join(T.sep):A;if(this.folderExcludePatterns.get(r.folder.fsPath).test(B,A,this.config.filePattern!==A?d:void 0))return L(null);const J=[f.fsPath,B].join(T.sep);P.lstat(J,(j,U)=>{if(j||this.isCanceled||this.isLimitHit)return L(null);this.statLinkIfNeeded(J,U,($,F)=>$||this.isCanceled||this.isLimitHit?L(null):F.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(J,U,(N,M)=>N||this.isCanceled||this.isLimitHit||(M=M||"",this.walkedPaths[M])?L(null):(this.walkedPaths[M]=!0,(0,u.readdir)(J).then(x=>{if(this.isCanceled||this.isLimitHit)return L(null);this.doWalk(r,B,x,m,O=>L(O||null))},x=>{L(null)})))):(this.filesWalked++,B===this.filePattern||this.maxFilesize&&s.isNumber(F.size)&&F.size>this.maxFilesize||this.matchFile(m,{base:f.fsPath,relativePath:B,searchPath:this.getSearchPath(r,B)}),L(null,void 0)))})},A=>{const L=A&&D.coalesce(A);return b(L&&L.length>0?L[0]:void 0)})}matchFile(r,a){this.isFileMatch(a)&&(!this.includePattern||this.includePattern(a.relativePath,T.basename(a.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||r(a))}isFileMatch(r){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,S.isFilePatternMatch)(r,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(r,a,h){return a.isSymbolicLink()?P.stat(r,h):h(null,a)}realPathIfNeeded(r,a,h){return a.isSymbolicLink()?P.realpath(r,(m,b)=>m?h(m):h(null,b)):h(null,r)}getSearchPath(r,a){return r.folderName?T.join(r.folderName,a):a}}e.FileWalker=c;class l{constructor(r){this.folderQueries=r.folderQueries,this.extraFiles=r.extraFileResources||[],this.walker=new c(r)}search(r,a,h){this.walker.walk(this.folderQueries,this.extraFiles,r,a,(m,b)=>{h(m,{limitHit:b,stats:this.walker.getStats()})})}cancel(){this.walker.cancel()}}e.Engine=l;class t{constructor(r,a){this.expression=r,this.root=a,this.init(r)}init(r){let a,h;Object.keys(r).filter(m=>r[m]).forEach(m=>{T.isAbsolute(m)?(a=a||y.getEmptyExpression(),a[m]=r[m]):(h=h||y.getEmptyExpression(),h[m]=r[m])}),this.absoluteParsedExpr=a&&y.parse(a,{trimForExclusions:!0}),this.relativeParsedExpr=h&&y.parse(h,{trimForExclusions:!0})}test(r,a,h){return this.relativeParsedExpr&&this.relativeParsedExpr(r,a,h)||this.absoluteParsedExpr&&this.absoluteParsedExpr(T.join(this.root,r),a,h)}getBasenameTerms(){const r=[];return this.absoluteParsedExpr&&r.push(...y.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&r.push(...y.getBasenameTerms(this.relativeParsedExpr)),r}getPathTerms(){const r=[];return this.absoluteParsedExpr&&r.push(...y.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&r.push(...y.getPathTerms(this.relativeParsedExpr)),r}}function i(o){const r=o.trim().split(`
`),a=r[0].trim();if(a.startsWith("Error parsing regex"))return a;if(a.startsWith("regex parse error"))return g.uppercaseFirstLetter(r[r.length-1].trim());if(a.startsWith("error parsing glob")||a.startsWith("unsupported encoding"))return a.charAt(0).toUpperCase()+a.substr(1);if(a==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(a.startsWith("Literal "))return a}e.rgErrorMsgForDisplay=i}),define(ge[129],pe([0,1,38,289,98,14,53,33,8,10,2,31,126,290,274,90]),function(G,e,E,P,T,I,D,k,y,n,R,C,w,g,s,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const S=s.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class v{constructor(f){this.outputChannel=f}provideTextSearchResults(f,d,A,L){return this.outputChannel.appendLine(`provideTextSearchResults ${f.pattern}, ${JSON.stringify(Object.assign(Object.assign({},d),{folder:d.folder.toString()}))}`),new Promise((B,J)=>{L.onCancellationRequested(()=>O());const j=i(f,d),U=d.folder.fsPath,$=j.map(we=>we.match(/^-/)?we:`'${we}'`).join(" ");this.outputChannel.appendLine(`${S} ${$}
 - cwd: ${U}`);let F=E.spawn(S,j,{cwd:U});F.on("error",we=>{console.error(we),this.outputChannel.appendLine("Error: "+(we&&we.message)),J((0,C.serializeSearchError)(new C.SearchError(we&&we.message,C.SearchErrorCode.rgProcessError)))});let N=!1;const M=new c(d.maxResults,U,d.previewOptions);M.on("result",we=>{N=!0,q="",A.report(we)});let x=!1;const O=()=>{x=!0,F&&F.kill(),M&&M.cancel()};let V=!1;M.on("hitLimit",()=>{V=!0,O()});let q="";F.stdout.on("data",we=>{M.handleData(we),N||(q+=we)});let X=!1;F.stdout.once("data",()=>X=!0);let me="";F.stderr.on("data",we=>{const Te=we.toString();this.outputChannel.appendLine(Te),me+=Te}),F.on("close",()=>{if(this.outputChannel.appendLine(X?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(N?"Got result from parser":"No result from parser"),q&&this.outputChannel.appendLine(`Got data without result: ${q}`),this.outputChannel.appendLine(""),x)B({limitHit:V});else{M.flush(),F=null;let we;me&&!X&&(we=_(me))?J((0,C.serializeSearchError)(new C.SearchError(we.message,we.code))):B({limitHit:V})}})})}}e.RipgrepTextSearchEngine=v;function _(b){const f=b.split(`
`),d=f[0].trim();if(f.some(L=>L.startsWith("regex parse error")))return new C.SearchError(p(f),C.SearchErrorCode.regexParseError);const A=d.match(/grep config error: unknown encoding: (.*)/);if(A)return new C.SearchError(`Unknown encoding: ${A[1]}`,C.SearchErrorCode.unknownEncoding);if(d.startsWith("error parsing glob"))return new C.SearchError(d.charAt(0).toUpperCase()+d.substr(1),C.SearchErrorCode.globParseError);if(d.startsWith("the literal"))return new C.SearchError(d.charAt(0).toUpperCase()+d.substr(1),C.SearchErrorCode.invalidLiteral);if(d.startsWith("PCRE2: error compiling pattern"))return new C.SearchError(d,C.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=_;function p(b){const f=["Regex parse error"],d=b.filter(A=>A.startsWith("PCRE2:"));if(d.length>=1){const A=d[0].replace("PCRE2:","");if(A.indexOf(":")!==-1&&A.split(":").length>=2){const L=A.split(":")[1];f.push(":"+L)}}return f.join("")}e.buildRegexParseError=p;class c extends P.EventEmitter{constructor(f,d,A){super();this.maxResults=f,this.rootFolder=d,this.previewOptions=A,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new T.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(f,d){return super.on(f,d),this}handleData(f){if(!this.isDone){const d=typeof f=="string"?f:this.stringDecoder.write(f);this.handleDecodedData(d)}}handleDecodedData(f){let d=f.indexOf(`
`);const A=this.remainder+f;if(d>=0)d+=this.remainder.length;else{this.remainder=A;return}let L=0;for(;d>=0;)this.handleLine(A.substring(L,d).trim()),L=d+1,d=A.indexOf(`
`,L);this.remainder=A.substring(L)}handleLine(f){if(!(this.isDone||!f)){let d;try{d=JSON.parse(f)}catch(A){throw new Error(`malformed line from rg: ${f}`)}if(d.type==="match"){const A=l(d.data.path),L=R.URI.file(y.join(this.rootFolder,A)),B=this.createTextSearchMatch(d.data,L);this.onResult(B),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(d.type==="context"){const A=l(d.data.path),L=R.URI.file(y.join(this.rootFolder,A));this.createTextSearchContext(d.data,L).forEach(J=>this.onResult(J))}}}createTextSearchMatch(f,d){const A=f.line_number-1;let L=!1,B=l(f.lines);A===0&&(0,n.startsWithUTF8BOM)(B)&&(L=!0,B=(0,n.stripUTF8BOM)(B));const J=Buffer.from(B);let j=0,U=0,$=A;f.submatches.length===0&&f.submatches.push(B.length?{start:0,end:1,match:{text:B[0]}}:{start:0,end:0,match:{text:""}});const F=(0,I.coalesce)(f.submatches.map((N,M)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);let x=l(N.match);A===0&&M===0&&L&&(x=(0,n.stripUTF8BOM)(x),N.start=N.start<=3?0:N.start-3,N.end=N.end<=3?0:N.end-3);const O=J.slice(j,N.start).toString().length,V=U+O,q=t(x),X=$,me=q.numLines+X,we=q.numLines>0?q.lastLineLength:q.lastLineLength+V;return j=N.end,U=we,$=me,new w.Range(X,V,me,we)}));return(0,u.createTextSearchResult)(d,B,F,this.previewOptions)}createTextSearchContext(f,d){const A=l(f.lines),L=f.line_number;return A.replace(/\r?\n$/,"").split(`
`).map((B,J)=>({text:B,uri:d,lineNumber:L+J}))}onResult(f){this.emit("result",f)}}e.RipgrepParser=c;function l(b){return b.bytes?Buffer.from(b.bytes,"base64").toString():b.text}function t(b){const f=/\n/g;let d=0,A=-1,L;for(;L=f.exec(b);)d++,A=L.index;const B=A>=0?b.length-A-1:b.length;return{numLines:d,lastLineLength:B}}function i(b,f){const d=["--hidden"];d.push(b.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:A,otherIncludes:L}=(0,D.groupBy)(f.includes,J=>J.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(L&&L.length){const J=new Set;L.forEach(j=>{J.add(j)}),d.push("-g","!*"),J.forEach(j=>{o(j).map(u.anchorGlob).forEach(U=>{d.push("-g",U)})})}A&&A.length&&A.forEach(J=>{d.push("-g",J)}),f.excludes.map(u.anchorGlob).forEach(J=>d.push("-g",`!${J}`)),f.maxFileSize&&d.push("--max-filesize",f.maxFileSize+""),f.useIgnoreFiles?d.push("--no-ignore-parent"):d.push("--no-ignore"),f.followSymlinks&&d.push("--follow"),f.encoding&&f.encoding!=="utf8"&&d.push("--encoding",f.encoding),b.pattern==="--"&&(b.isRegExp=!0,b.pattern="\\-\\-"),b.isMultiline&&!b.isRegExp&&(b.pattern=(0,n.escapeRegExpCharacters)(b.pattern),b.isRegExp=!0),f.usePCRE2&&d.push("--pcre2"),d.push("--crlf"),b.isRegExp&&(b.pattern=r(b.pattern),d.push("--auto-hybrid-regex"));let B;if(b.isWordMatch){const j=(0,n.createRegExp)(b.pattern,!!b.isRegExp,{wholeWord:b.isWordMatch}).source.replace(/\\\//g,"/");d.push("--regexp",j)}else if(b.isRegExp){let J=h(b.pattern);J=m(J),d.push("--regexp",J)}else B=b.pattern,d.push("--fixed-strings");return d.push("--no-config"),f.useGlobalIgnoreFiles||d.push("--no-ignore-global"),d.push("--json"),b.isMultiline&&d.push("--multiline"),f.beforeContext&&d.push("--before-context",f.beforeContext+""),f.afterContext&&d.push("--after-context",f.afterContext+""),d.push("--"),B&&d.push(B),d.push("."),d}function o(b){const f=(0,k.splitGlobAware)(b,"/");return f.map((d,A)=>f.slice(0,A+1).join("/"))}e.spreadGlobComponents=o;function r(b){const f=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;b.match(f);)b=b.replace(f,"$1\\x{$2}");const d=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;b.match(d);)b=b.replace(d,"$1\\x{$2}");return b}e.unicodeEscapesToPCRE2=r;const a=b=>b.type==="Assertion"&&b.kind==="lookbehind";function h(b){let f;try{f=new g.RegExpParser().parsePattern(b)}catch(j){return b}let d="",A=0;const L=(j,U,$)=>{d+=b.slice(A,j)+$,A=U},B=[];return new g.RegExpVisitor({onCharacterEnter(j){if(j.raw==="\\n"){const U=B[0];if(!U)L(j.start,j.end,"\\r?\\n");else if(!B.some(a))if(U.type==="CharacterClass"){const $=b.slice(U.start+1,j.start)+b.slice(j.end,U.end-1);L(U.start,U.end,$===""?"\\r?\\n":`(?:[${$}]|\\r?\\n)`)}else U.type==="Quantifier"&&L(j.start,j.end,"(?:\\r?\\n)")}},onQuantifierEnter(j){B.unshift(j)},onQuantifierLeave(){B.shift()},onCharacterClassRangeEnter(j){B.unshift(j)},onCharacterClassRangeLeave(){B.shift()},onCharacterClassEnter(j){B.unshift(j)},onCharacterClassLeave(){B.shift()},onAssertionEnter(j){a(j)&&B.push(j)},onAssertionLeave(j){B[0]===j&&B.shift()}}).visit(f),d+=b.slice(A),d}e.fixRegexNewline=h;function m(b){return b.replace(/\n/g,"\\r?\\n")}e.fixNewline=m}),define(ge[276],pe([0,1,21,129,111,11]),function(G,e,E,P,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class D{constructor(n){this.outputChannel=n,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(n,R,C,w){const g=new P.RipgrepTextSearchEngine(this.outputChannel);if(R.folder.scheme===I.Schemas.userData){const s=Object.assign(Object.assign({},R),{folder:R.folder.with({scheme:I.Schemas.file})}),u=new T.Progress(S=>C.report(Object.assign(Object.assign({},S),{uri:S.uri.with({scheme:R.folder.scheme})})));return this.withToken(w,S=>g.provideTextSearchResults(n,s,u,S))}else return this.withToken(w,s=>g.provideTextSearchResults(n,R,C,s))}async withToken(n,R){const C=k(n);this.inProgress.add(C);const w=await R(C.token);return this.inProgress.delete(C),w}dispose(){this.inProgress.forEach(n=>n.cancel())}}e.RipgrepSearchProvider=D;function k(y){const n=new E.CancellationTokenSource;return y.onCancellationRequested(()=>n.cancel()),n}}),define(ge[277],pe([0,1,26,129,128]),function(G,e,E,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class I{constructor(y){this.query=y}search(y,n,R){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const C={appendLine(g){R({message:g})}},w=new T.NativeTextSearchManager(this.query,new P.RipgrepTextSearchEngine(C),E);return new Promise((g,s)=>w.search(u=>{n(u.map(D))},y).then(u=>g({limitHit:u.limitHit,type:"success"}),s))}}e.TextSearchEngineAdapter=I;function D(k){return{path:k.resource&&k.resource.fsPath,results:k.results,numMatches:(k.results||[]).reduce((y,n)=>{if(n.ranges){const R=n;return y+(Array.isArray(R.ranges)?R.ranges.length:1)}else return y+1},0)}}}),define(ge[278],pe([0,1,37,291,14,19,18,3,96,8,47,2,45,31,275,277]),function(G,e,E,P,T,I,D,k,y,n,R,C,w,g,s,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,P.gracefulify(E);class S{constructor(){this.caches=Object.create(null)}fileSearch(t){let i;const o=p(t),r=new k.Emitter({onFirstListenerDidAdd:()=>{i=(0,I.createCancelablePromise)(a=>this.doFileSearchWithEngine(s.Engine,o,h=>r.fire(h),a)),i.then(a=>r.fire(a),a=>r.fire({type:"error",error:{message:a.message,stack:a.stack}}))},onLastListenerRemove:()=>{i.cancel()}});return r.event}textSearch(t){let i;const o=p(t),r=new k.Emitter({onFirstListenerDidAdd:()=>{i=(0,I.createCancelablePromise)(a=>this.ripgrepTextSearch(o,h=>r.fire(h),a)),i.then(a=>r.fire(a),a=>r.fire({type:"error",error:{message:a.message,stack:a.stack}}))},onLastListenerRemove:()=>{i.cancel()}});return r.event}ripgrepTextSearch(t,i,o){return t.maxFileSize=(0,w.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new u.TextSearchEngineAdapter(t).search(o,i,i)}doFileSearch(t,i,o){return this.doFileSearchWithEngine(s.Engine,t,i,o)}doFileSearchWithEngine(t,i,o,r,a=S.BATCH_SIZE){let h=0;const m=f=>{Array.isArray(f)?(h+=f.length,o(f.map(d=>this.rawMatchToSearchItem(d)))):f.relativePath?(h++,o(this.rawMatchToSearchItem(f))):o(f)};if(i.sortByScore){let f=this.trySortedSearchFromCache(i,m,r);if(!f){const d=i.maxResults?Object.assign({},i,{maxResults:null}):i,A=new t(d);f=this.doSortedSearch(A,i,o,m,r)}return new Promise((d,A)=>{f.then(([L,B])=>{const J=B.map(j=>this.rawMatchToSearchItem(j));this.sendProgress(J,o,a),d(L)},A)})}const b=new t(i);return this.doSearch(b,m,a,r).then(f=>({limitHit:f.limitHit,type:"success",stats:{detailStats:f.stats,type:"searchProcess",fromCache:!1,resultCount:h,sortingTime:void 0}}))}rawMatchToSearchItem(t){return{path:t.base?(0,n.join)(t.base,t.relativePath):t.relativePath}}doSortedSearch(t,i,o,r,a){const h=new k.Emitter;let m=(0,I.createCancelablePromise)(f=>{let d=[];const A=L=>{Array.isArray(L)?d=L:(r(L),h.fire(L))};return this.doSearch(t,A,-1,f).then(L=>[L,d])}),b;if(i.cacheKey){b=this.getOrCreateCache(i.cacheKey);const f={promise:m,event:h.event,resolved:!1};b.resultsToSearchCache[i.filePattern||""]=f,m.then(()=>{f.resolved=!0},d=>{delete b.resultsToSearchCache[i.filePattern||""]}),m=this.preventCancellation(m)}return m.then(([f,d])=>{const A=b?b.scorerCache:Object.create(null),L=(typeof i.maxResults!="number"||i.maxResults>0)&&R.StopWatch.create(!1);return this.sortResults(i,d,A,a).then(B=>{const J=L?L.elapsed():-1;return[{type:"success",stats:{detailStats:f.stats,sortingTime:J,fromCache:!1,type:"searchProcess",workspaceFolderCount:i.folderQueries.length,resultCount:B.length},limitHit:f.limitHit||typeof i.maxResults=="number"&&d.length>i.maxResults},B]})})}getOrCreateCache(t){const i=this.caches[t];return i||(this.caches[t]=new v)}trySortedSearchFromCache(t,i,o){const r=t.cacheKey&&this.caches[t.cacheKey];if(!!r){const a=this.getResultsFromCache(r,t.filePattern||"",i,o);if(a)return a.then(([h,m,b])=>{const f=R.StopWatch.create(!1);return this.sortResults(t,m,r.scorerCache,o).then(d=>{const A=f.elapsed(),L={fromCache:!0,detailStats:b,type:"searchProcess",resultCount:m.length,sortingTime:A};return[{type:"success",limitHit:h.limitHit||typeof t.maxResults=="number"&&m.length>t.maxResults,stats:L},d]})})}}sortResults(t,i,o,r){const a=(0,y.prepareQuery)(t.filePattern||""),h=(b,f)=>(0,y.compareItemsByFuzzyScore)(b,f,a,!0,_,o),m=typeof t.maxResults=="number"?t.maxResults:Number.MAX_VALUE;return T.topAsync(i,h,m,1e4,r)}sendProgress(t,i,o){if(o&&o>0)for(let r=0;r<t.length;r+=o)i(t.slice(r,r+o));else i(t)}getResultsFromCache(t,i,o,r){const a=R.StopWatch.create(!1),h=i.indexOf(n.sep)>=0;let m;for(const A in t.resultsToSearchCache)if(i.startsWith(A)){if(h&&A.indexOf(n.sep)<0&&A!=="")continue;const L=t.resultsToSearchCache[A];m={promise:this.preventCancellation(L.promise),event:L.event,resolved:L.resolved};break}if(!m)return null;const b=a.elapsed(),f=R.StopWatch.create(!1),d=m.event(o);return r&&r.onCancellationRequested(()=>{d.dispose()}),m.promise.then(([A,L])=>{if(r&&r.isCancellationRequested)throw(0,D.canceled)();const B=[],J=(0,y.prepareQuery)(i).normalizedLowercase;for(const j of L)!(0,g.isFilePatternMatch)(j,J)||B.push(j);return[A,B,{cacheWasResolved:m.resolved,cacheLookupTime:b,cacheFilterTime:f.elapsed(),cacheEntryCount:L.length}]})}doSearch(t,i,o,r){return new Promise((a,h)=>{let m=[];r&&r.onCancellationRequested(()=>t.cancel()),t.search(b=>{b&&(o?(m.push(b),o>0&&m.length>=o&&(i(m),m=[])):i(b))},b=>{i(b)},(b,f)=>{m.length&&i(m),b?h(b):a(f)})})}clearCache(t){return delete this.caches[t],Promise.resolve(void 0)}preventCancellation(t){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(i,o){return t.then(i,o)}catch(i){return this.then(void 0,i)}finally(i){return t.finally(i)}}}}e.SearchService=S,S.BATCH_SIZE=512;class v{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const _=new class{getItemLabel(l){return(0,n.basename)(l.relativePath)}getItemDescription(l){return(0,n.dirname)(l.relativePath)}getItemPath(l){return l.relativePath}};function p(l){return Object.assign(Object.assign({},l),{folderQueries:l.folderQueries&&l.folderQueries.map(c),extraFileResources:l.extraFileResources&&l.extraFileResources.map(t=>C.URI.revive(t))})}function c(l){return Object.assign(Object.assign({},l),{folder:C.URI.revive(l.folder)})}}),define(ge[279],pe([0,1,6,2,26,12,31,278,276,90,13,61,27,67,11,128]),function(G,e,E,P,T,I,D,k,y,n,R,C,w,g,s,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let S=class extends g.ExtHostSearch{constructor(_,p,c,l){super(_,c,l);this._pfs=T,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null;const t=new n.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(s.Schemas.userData,new y.RipgrepSearchProvider(t)),p.remote.isRemote&&p.remote.authority&&this._registerEHSearchProviders()}_registerEHSearchProviders(){const _=new n.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(s.Schemas.file,new y.RipgrepSearchProvider(_)),this.registerInternalFileSearchProvider(s.Schemas.file,new k.SearchService)}registerInternalFileSearchProvider(_,p){const c=this._handlePool++;return this._internalFileSearchProvider=p,this._internalFileSearchHandle=c,this._proxy.$registerFileSearchProvider(c,this._transformScheme(_)),(0,E.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(c)})}$provideFileSearchResults(_,p,c,l){const t=(0,g.reviveQuery)(c);return _===this._internalFileSearchHandle?this.doInternalFileSearch(_,p,t,l):super.$provideFileSearchResults(_,p,c,l)}doInternalFileSearch(_,p,c,l){const t=i=>{if((0,D.isSerializedFileMatch)(i)&&(i=[i]),Array.isArray(i)){this._proxy.$handleFileMatch(_,p,i.map(o=>P.URI.file(o.path)));return}i.message&&this._logService.debug("ExtHostSearch",i.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(c,t,l)}$clearCache(_){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(_),super.$clearCache(_)}createTextSearchManager(_,p){return new u.NativeTextSearchManager(_,p)}};S=je([Ue(0,R.IExtHostRpcService),Ue(1,w.IExtHostInitDataService),Ue(2,C.IURITransformerService),Ue(3,I.ILogService)],S),e.NativeExtHostSearch=S}),define(ge[130],pe([0,1,292,120,293,3,101,8,48,28,6,22,102,18,9]),function(G,e,E,P,T,I,D,k,y,n,R,C,w,g,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class u{constructor(m){this.socket=m,this._errorListener=b=>{if(b){if(b.code==="EPIPE")return;(0,g.onUnexpectedError)(b)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(m){const b=f=>m(C.VSBuffer.wrap(f));return this.socket.on("data",b),{dispose:()=>this.socket.off("data",b)}}onClose(m){return this.socket.on("close",m),{dispose:()=>this.socket.off("close",m)}}onEnd(m){return this.socket.on("end",m),{dispose:()=>this.socket.off("end",m)}}write(m){if(!this.socket.destroyed)try{this.socket.write(m.buffer,b=>{if(b){if(b.code==="EPIPE")return;(0,g.onUnexpectedError)(b)}})}catch(b){if(b.code==="EPIPE")return;(0,g.onUnexpectedError)(b)}}end(){this.socket.end()}drain(){return new Promise((m,b)=>{if(this.socket.bufferSize===0){m();return}const f=()=>{this.socket.off("close",f),this.socket.off("end",f),this.socket.off("error",f),this.socket.off("timeout",f),this.socket.off("drain",f),m()};this.socket.on("close",f),this.socket.on("end",f),this.socket.on("error",f),this.socket.on("timeout",f),this.socket.on("drain",f)})}}e.NodeSocket=u;var S;(function(h){h[h.MinHeaderByteSize=2]="MinHeaderByteSize"})(S||(S={}));var v;(function(h){h[h.PeekHeader=1]="PeekHeader",h[h.ReadHeader=2]="ReadHeader",h[h.ReadBody=3]="ReadBody",h[h.Fin=4]="Fin"})(v||(v={}));class _ extends R.Disposable{constructor(m,b,f,d){super();this._onDidZlibFlush=this._register(new I.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new I.Emitter),this._onClose=this._register(new I.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=m,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=b,this._recordInflateBytes=d,b?(this._zlibInflate=T.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",A=>{console.error(A),(0,g.onUnexpectedError)(A),this._onClose.fire()}),this._zlibInflate.on("data",A=>{this._pendingInflateData.push(A)}),f&&(this._zlibInflate.write(f.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=T.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",A=>{console.error(A),(0,g.onUnexpectedError)(A),this._onClose.fire()}),this._zlibDeflate.on("data",A=>{this._pendingDeflateData.push(A)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new w.ChunkStream,this._register(this.socket.onData(A=>this._acceptChunk(A))),this._register(this.socket.onClose(()=>this._onClose.fire()))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?C.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):C.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(m){return this._onData.event(m)}onClose(m){return this._onClose.event(m)}onEnd(m){return this.socket.onEnd(m)}write(m){this._totalOutgoingDataBytes+=m.byteLength,this._zlibDeflate?(this._zlibDeflate.write(m.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let b=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,b=b.slice(0,b.length-4),this._isEnded||this._write(C.VSBuffer.wrap(b),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(m,!1)}_write(m,b){let f=2;m.byteLength<126?f+=0:m.byteLength<2**16?f+=2:f+=8;const d=C.VSBuffer.alloc(f);if(b?d.writeUInt8(194,0):d.writeUInt8(130,0),m.byteLength<126)d.writeUInt8(m.byteLength,1);else if(m.byteLength<2**16){d.writeUInt8(126,1);let A=1;d.writeUInt8(m.byteLength>>>8&255,++A),d.writeUInt8(m.byteLength>>>0&255,++A)}else{d.writeUInt8(127,1);let A=1;d.writeUInt8(0,++A),d.writeUInt8(0,++A),d.writeUInt8(0,++A),d.writeUInt8(0,++A),d.writeUInt8(m.byteLength>>>24&255,++A),d.writeUInt8(m.byteLength>>>16&255,++A),d.writeUInt8(m.byteLength>>>8&255,++A),d.writeUInt8(m.byteLength>>>0&255,++A)}this._totalOutgoingWireBytes+=d.byteLength+m.byteLength,this.socket.write(C.VSBuffer.concat([d,m]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(m){if(m.byteLength!==0){for(this._totalIncomingWireBytes+=m.byteLength,this._incomingData.acceptChunk(m);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const b=this._incomingData.peek(this._state.readLen),d=(b.readUInt8(0)&128)>>>7,A=b.readUInt8(1),L=(A&128)>>>7,B=A&127;this._state.state=2,this._state.readLen=2+(L?4:0)+(B===126?2:0)+(B===127?8:0),this._state.fin=d,this._state.mask=0}else if(this._state.state===2){const b=this._incomingData.read(this._state.readLen),f=b.readUInt8(1),d=(f&128)>>>7;let A=f&127,L=1;A===126?A=b.readUInt8(++L)*2**8+b.readUInt8(++L):A===127&&(A=b.readUInt8(++L)*0+b.readUInt8(++L)*0+b.readUInt8(++L)*0+b.readUInt8(++L)*0+b.readUInt8(++L)*2**24+b.readUInt8(++L)*2**16+b.readUInt8(++L)*2**8+b.readUInt8(++L));let B=0;d&&(B=b.readUInt8(++L)*2**24+b.readUInt8(++L)*2**16+b.readUInt8(++L)*2**8+b.readUInt8(++L)),this._state.state=3,this._state.readLen=A,this._state.mask=B}else if(this._state.state===3){const b=this._incomingData.read(this._state.readLen);p(b,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(b.buffer)),this._zlibInflate.write(b.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const f=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=f.length,this._onData.fire(C.VSBuffer.wrap(f))})):(this._totalIncomingDataBytes+=b.byteLength,this._onData.fire(b))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await I.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=_;function p(h,m){if(m!==0){let b=h.byteLength>>>2;for(let J=0;J<b;J++){const j=h.readUInt32BE(J*4);h.writeUInt32BE(j^m,J*4)}let f=b*4,d=h.byteLength-f;const A=m>>>24&255,L=m>>>16&255,B=m>>>8&255;d>=1&&h.writeUInt8(h.readUInt8(f)^A,f),d>=2&&h.writeUInt8(h.readUInt8(f+1)^L,f+1),d>=3&&h.writeUInt8(h.readUInt8(f+2)^B,f+2)}}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const c={[2]:107,[1]:103};function l(){const h=(0,n.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${h}-sock`;let m;return e.XDG_RUNTIME_DIR?m=(0,k.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${h}.sock`):m=(0,k.join)((0,y.tmpdir)(),`vscode-ipc-${h}.sock`),i(m),m}e.createRandomIPCHandle=l;function t(h,m,b){const f=(0,E.createHash)("md5").update(h).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${f}-${b}-${m}-sock`;let d;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?d=(0,k.join)(e.XDG_RUNTIME_DIR,`vscode-${f.substr(0,8)}-${b}-${m}.sock`):d=(0,k.join)(h,`${b}-${m}.sock`),i(d),d}e.createStaticIPCHandle=t;function i(h){const m=c[s.platform];typeof m=="number"&&h.length>=m&&console.warn(`WARNING: IPC handle "${h}" is longer than ${m} chars, try a shorter --user-data-dir`)}class o extends D.IPCServer{constructor(m){super(o.toClientConnectionEvent(m));this.server=m}static toClientConnectionEvent(m){const b=I.Event.fromNodeEventEmitter(m,"connection");return I.Event.map(b,f=>({protocol:new w.Protocol(new u(f)),onDidClientDisconnect:I.Event.once(I.Event.fromNodeEventEmitter(f,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=o;function r(h){return new Promise((m,b)=>{const f=(0,P.createServer)();f.on("error",b),f.listen(h,()=>{f.removeListener("error",b),m(new o(f))})})}e.serve=r;function a(h,m){return new Promise((b,f)=>{const d=(0,P.createConnection)(h,()=>{d.removeListener("error",f),b(w.Client.fromSocket(new u(d),m))});d.once("error",f)})}e.connect=a}),define(ge[280],pe([0,1,130,272,37,51,2,115,12]),function(G,e,E,P,T,I,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class n{constructor(w,g,s){this._commands=w,this.logService=g,this._ipcHandlePath=s,this._server=P.createServer((u,S)=>this.onRequest(u,S)),this.setup().catch(u=>(g.error(u),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",w=>this.logService.error(w))}catch(w){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(w,g){const s=[];w.setEncoding("utf8"),w.on("data",u=>s.push(u)),w.on("end",()=>{const u=JSON.parse(s.join(""));switch(u.type){case"open":this.open(u,g);break;case"openExternal":this.openExternal(u,g);break;case"status":this.getStatus(u,g);break;case"extensionManagement":this.manageExtensions(u,g).catch(this.logService.error);break;default:g.writeHead(404),g.write(`Unknown message type: ${u.type}`,S=>{S&&this.logService.error(S)}),g.end();break}})}open(w,g){let{fileURIs:s,folderURIs:u,forceNewWindow:S,diffMode:v,addMode:_,forceReuseWindow:p,gotoLineMode:c,waitMarkerFilePath:l}=w;const t=[];if(Array.isArray(u))for(const i of u)try{t.push({folderUri:D.URI.parse(i)})}catch(o){}if(Array.isArray(s))for(const i of s)try{(0,k.hasWorkspaceFileExtension)(i)?t.push({workspaceUri:D.URI.parse(i)}):t.push({fileUri:D.URI.parse(i)})}catch(o){}if(t.length){const i=l?D.URI.file(l):void 0,r={forceNewWindow:S,diffMode:v,addMode:_,gotoLineMode:c,forceReuseWindow:p,preferNewWindow:!p&&!i&&!_,waitMarkerFileURI:i};this._commands.executeCommand("_remoteCLI.windowOpen",t,r)}g.writeHead(200),g.end()}async openExternal(w,g){for(const s of w.uris){const u=D.URI.parse(s),S=u.scheme==="file"?u:s;await this._commands.executeCommand("_remoteCLI.openExternal",S)}g.writeHead(200),g.end()}async manageExtensions(w,g){try{const s=v=>v==null?void 0:v.map(_=>/\.vsix$/i.test(_)?D.URI.parse(_):_),u={list:w.list,install:s(w.install),uninstall:s(w.uninstall),force:w.force},S=await this._commands.executeCommand("_remoteCLI.manageExtensions",u);g.writeHead(200),g.write(S)}catch(s){g.writeHead(500),g.write(String(s),u=>{u&&this.logService.error(u)})}g.end()}async getStatus(w,g){try{const s=await this._commands.executeCommand("_remoteCLI.getSystemStatus");g.writeHead(200),g.write(s),g.end()}catch(s){g.writeHead(500),g.write(String(s),u=>{u&&this.logService.error(u)}),g.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&T.existsSync(this._ipcHandlePath)&&T.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=n;let R=class extends n{constructor(w,g){super(w,g,(0,E.createRandomIPCHandle)())}};R=je([Ue(0,I.IExtHostCommands),Ue(1,y.ILogService)],R),e.CLIServer=R}),define(ge[281],pe([0,1,66,268,262,5,271,42,253,2,11,7,280,99]),function(G,e,E,P,T,I,D,k,y,n,R,C,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class s extends T.RequireInterceptor{_installInterceptor(){const v=this,_=G.__$__nodeRequire("module"),p=_._load;_._load=function(l,t,i){for(let o of v._alternatives){let r=o(l);if(r){l=r;break}}return v._factories.has(l)?v._factories.get(l).load(l,n.URI.file((0,g.realpathSync)(t.filename)),o=>p.apply(this,[o,t,i])):p.apply(this,arguments)}}}class u extends k.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=C.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const v=this._instaService.invokeFunction(P.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(y.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const t=this._instaService.createInstance(w.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}await this._instaService.createInstance(s,v,this._registry).install(),E.mark("code/extHost/didInitAPI");const p=await this._extHostConfiguration.getConfigProvider();await(0,D.connectProxyResolver)(this._extHostWorkspace,p,this,this._logService,this._mainThreadTelemetryProxy,this._initData),E.mark("code/extHost/didInitProxyResolver");const c=process.send,l=this._extHostContext.getProxy(I.MainContext.MainThreadConsole);process.send=(...t)=>t.length===0||!t[0]||t[0].type!=="__$console"?c.apply(process,t):(l.$logExtensionHostMessage(t[0]),!1)}_getEntryPoint(v){return v.main}_loadCommonJSModule(v,_,p){if(_.scheme!==R.Schemas.file)throw new Error(`Cannot load URI: '${_}', must be of file-scheme`);let c=null;p.codeLoadingStart(),this._logService.info(`ExtensionService#loadCommonJSModule ${_.toString(!0)}`),this._logService.flush();try{v&&E.mark(`code/extHost/willLoadExtensionCode/${v.value}`),c=G.__$__nodeRequire(_.fsPath)}catch(l){return Promise.reject(l)}finally{v&&E.mark(`code/extHost/didLoadExtensionCode/${v.value}`),p.codeLoadingStop()}return Promise.resolve(c)}async $setRemoteEnvironment(v){if(!!this._initData.remote.isRemote)for(const _ in v){const p=v[_];p===null?delete process.env[_]:process.env[_]=p}}}e.ExtHostExtensionService=u}),define(ge[282],pe([0,1,78,254,265,264,263,279,281,225,255,46,42,63,67,65,34,50,12]),function(G,e,E,P,T,I,D,k,y,n,R,C,w,g,s,u,S,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,E.registerSingleton)(w.IExtHostExtensionService,y.ExtHostExtensionService),(0,E.registerSingleton)(_.ILogService,n.ExtHostLogService),(0,E.registerSingleton)(C.IExtHostDebugService,D.ExtHostDebugService),(0,E.registerSingleton)(g.IExtHostOutputService,P.ExtHostOutputService2),(0,E.registerSingleton)(s.IExtHostSearch,k.NativeExtHostSearch),(0,E.registerSingleton)(u.IExtHostTask,I.ExtHostTask),(0,E.registerSingleton)(S.IExtHostTerminalService,T.ExtHostTerminalService),(0,E.registerSingleton)(v.IExtHostTunnelService,R.ExtHostTunnelService)}),define(ge[283],pe([0,1,120,294,66,18,102,130,186,223,266,22,97,26,99,19,269,282]),function(G,e,E,P,T,I,D,k,y,n,R,C,w,g,s,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let r=0;r<process.execArgv.length;r++)process.execArgv[r]==="--inspect-port=0"&&(process.execArgv.splice(r,1),r--)}();const S=P(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"]});(function(){const o=G.__$__nodeRequire("module"),r=o._load;o._load=function(a){if(a==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return r.apply(this,arguments)}})();const v=process.exit.bind(process);function _(o){process.exit=function(r){if(o)v(r);else{const a=new Error("An extension called process.exit() and this was prevented.");console.warn(a.stack)}},process.crash=function(){const r=new Error("An extension called process.crash() and this was prevented.");console.warn(r.stack)}}let p=function(o){v()};function c(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((o,r)=>{let a=null,h=setTimeout(()=>{r(new Error("VSCODE_EXTHOST_IPC_SOCKET timeout"))},6e4);const m=108e5,b=3e5,f=new u.RunOnceScheduler(()=>p("renderer disconnected for too long (1)"),m),d=new u.RunOnceScheduler(()=>p("renderer disconnected for too long (2)"),b);process.on("message",(L,B)=>{if(L&&L.type==="VSCODE_EXTHOST_IPC_SOCKET"){const J=C.VSBuffer.wrap(Buffer.from(L.initialDataChunk,"base64"));let j;if(L.skipWebSocketFrames)j=new k.NodeSocket(B);else{const U=C.VSBuffer.wrap(Buffer.from(L.inflateBytes,"base64"));j=new k.WebSocketNodeSocket(new k.NodeSocket(B),L.permessageDeflate,U,!1)}a?(f.cancel(),d.cancel(),a.beginAcceptReconnection(j,J),a.endAcceptReconnection()):(clearTimeout(h),a=new D.PersistentProtocol(j,J),a.onDidDispose(()=>p("renderer disconnected")),o(a),a.onSocketClose(()=>{f.schedule()}))}if(L&&L.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(d.isScheduled())return;f.isScheduled()&&d.schedule()}});const A={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(A)});{const o=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((r,a)=>{const h=E.createConnection(o,()=>{h.removeListener("error",a),r(new D.PersistentProtocol(new k.NodeSocket(h)))});h.once("error",a)})}}async function l(){const o=await c();return new class{constructor(){this._onMessage=new D.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,o.onMessage(r=>{(0,n.isMessageOfType)(r,2)?(this._terminating=!0,p("received terminate message from renderer")):this._onMessage.fire(r)})}send(r){this._terminating||o.send(r)}drain(){return o.drain()}}}function t(o){return new Promise(r=>{const a=o.onMessage(h=>{a.dispose();const m=JSON.parse(h.toString()),b=m.commit,f=y.default.commit;b&&f&&b!==f&&v(55);const d=[];process.on("unhandledRejection",(B,J)=>{d.push(J),setTimeout(()=>{const j=d.indexOf(J);j>=0&&J.catch(U=>{d.splice(j,1),console.warn(`rejected promise not handled within 1 second: ${U}`),U&&U.stack&&console.warn(`stack trace: ${U.stack}`),(0,I.onUnexpectedError)(B)})},1e3)}),process.on("rejectionHandled",B=>{const J=d.indexOf(B);J>=0&&d.splice(J,1)}),process.on("uncaughtException",function(B){(0,I.onUnexpectedError)(B)});let A=0;setInterval(function(){try{process.kill(m.parentPid,0),A=0}catch(B){B&&B.code==="EPERM"?(A++,A>=3&&p(`parent process ${m.parentPid} does not exist anymore (3 x EPERM): ${B.message} (code: ${B.code}) (errno: ${B.errno})`)):p(`parent process ${m.parentPid} does not exist anymore: ${B.message} (code: ${B.code}) (errno: ${B.errno})`)}},1e3);let L;try{L=G.__$__nodeRequire("native-watchdog"),L.start(m.parentPid)}catch(B){(0,I.onUnexpectedError)(B)}o.send((0,n.createMessageOfType)(0)),r({protocol:o,initData:m})});o.send((0,n.createMessageOfType)(1))})}async function i(){T.mark("code/extHost/willConnectToRenderer");const o=await l();T.mark("code/extHost/didConnectToRenderer");const r=await t(o);T.mark("code/extHost/didWaitForInitData");const{initData:a}=r;_(!!a.environment.extensionTestsLocationURI),a.environment.useHostProxy=S.useHostProxy!==void 0?S.useHostProxy!=="false":void 0;const h=new class{exit(d){v(d)}exists(d){return(0,g.exists)(d)}realpath(d){return(0,s.realpath)(d)}};let m=null;if(a.remote.authority&&S.uriTransformerPath)try{const d=G.__$__nodeRequire(S.uriTransformerPath)(a.remote.authority);m=new w.URITransformer(d)}catch(f){console.error(f)}const b=new R.ExtensionHostMain(r.protocol,a,h,m);p=f=>b.terminate(f)}e.startExtensionHostProcess=i}),define(ge[295],pe([0,1,283]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,E.startExtensionHostProcess)().catch(P=>console.log(P))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/94d369e27d19f598228961e9feb0413f2edabe5d/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
