/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var _e=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/base/common/arrays","vs/base/common/path","vs/base/common/types","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/network","vs/platform/log/common/log","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/map","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/glob","vs/base/common/uuid","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/editor/common/core/range","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/base/common/extpath","vs/editor/common/core/position","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/json","vs/base/common/linkedList","vs/base/common/process","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/marshalling","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/numbers","vs/base/common/uint","vs/base/common/htmlContent","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/testing/common/testCollection","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHost.api.impl","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionActivator","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/commands/common/commands","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/theme/common/iconRegistry","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/views","vs/workbench/api/common/apiCommands","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/marked/marked","vs/workbench/services/extensions/worker/extensionHostWorker"],we=function(ie){for(var e=[],E=0,I=ie.length;E<I;E++)e[E]=_e[ie[E]];return e};define(_e[42],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function E(I,P){if(!I)throw new Error(P?`Assertion failed (${P})`:"Assertion Failed")}e.ok=E}),define(_e[50],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const E=Object.prototype.hasOwnProperty;function I(T){const k=[];for(let g in T)E.call(T,g)&&k.push(T[g]);return k}e.values=I;function P(T,k){for(let g in T)if(E.call(T,g)&&k({key:g,value:T[g]},function(){delete T[g]})===!1)return}e.forEach=P;function A(T,k){const g=Object.create(null);for(const m of T){const i=k(m);let s=g[i];s||(s=g[i]=[]),s.push(m)}return g}e.groupBy=A;function S(T){const k=Object.create(null);return T&&T.forEach((g,m)=>{k[m]=g}),k}e.fromMap=S;function C(T,k){const g=[],m=[];for(let i of T)k.has(i)||g.push(i);for(let i of k)T.has(i)||m.push(i);return{removed:g,added:m}}e.diffSets=C;function y(T,k){const g=[],m=[];for(let[i,s]of T)k.has(i)||g.push(s);for(let[i,s]of k)T.has(i)||m.push(s);return{removed:g,added:m}}e.diffMaps=y;class n{constructor(){this.map=new Map}add(k,g){let m=this.map.get(k);m||(m=new Set,this.map.set(k,m)),m.add(g)}delete(k,g){const m=this.map.get(k);!m||(m.delete(g),m.size===0&&this.map.delete(k))}forEach(k,g){const m=this.map.get(k);!m||m.forEach(g)}}e.SetMap=n}),define(_e[51],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function E(y){return(n,T,k)=>{let g=null,m=null;if(typeof k.value=="function"?(g="value",m=k.value):typeof k.get=="function"&&(g="get",m=k.get),!m)throw new Error("not supported");k[g]=y(m,T)}}e.createDecorator=E;let I=0;function P(){const y=`$memoize${I++}`;let n;const T=function(g,m,i){let s=null,_=null;if(typeof i.value=="function"?(s="value",_=i.value,_.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof i.get=="function"&&(s="get",_=i.get),!_)throw new Error("not supported");const d=`${y}:${m}`;i[s]=function(...b){return n=this,this.hasOwnProperty(d)||Object.defineProperty(this,d,{configurable:!0,enumerable:!1,writable:!0,value:_.apply(this,b)}),this[d]}};return T.clear=()=>{typeof n!="undefined"&&Object.getOwnPropertyNames(n).forEach(k=>{k.indexOf(y)===0&&delete n[k]})},T}e.createMemoizer=P;function A(y,n,T){return P()(y,n,T)}e.memoize=A;function S(y,n,T){return E((k,g)=>{const m=`$debounce$${g}`,i=`$debounce$result$${g}`;return function(...s){this[i]||(this[i]=T?T():void 0),clearTimeout(this[m]),n&&(this[i]=n(this[i],...s),s=[this[i]]),this[m]=setTimeout(()=>{k.apply(this,s),this[i]=T?T():void 0},y)}})}e.debounce=S;function C(y,n,T){return E((k,g)=>{const m=`$throttle$timer$${g}`,i=`$throttle$result$${g}`,s=`$throttle$lastRun$${g}`,_=`$throttle$pending$${g}`;return function(...d){if(this[i]||(this[i]=T?T():void 0),(this[s]===null||this[s]===void 0)&&(this[s]=-Number.MAX_VALUE),n&&(this[i]=n(this[i],...d)),!this[_]){const b=this[s]+y;b<=Date.now()?(this[s]=Date.now(),k.apply(this,[this[i]]),this[i]=T?T():void 0):(this[_]=!0,this[m]=setTimeout(()=>{this[_]=!1,this[s]=Date.now(),k.apply(this,[this[i]]),this[i]=T?T():void 0},b-Date.now()))}}})}e.throttle=C}),define(_e[10],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class E{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=E,e.errorHandler=new E;function I(u){e.errorHandler.setUnexpectedErrorHandler(u)}e.setUnexpectedErrorHandler=I;function P(u){y(u)||e.errorHandler.onUnexpectedError(u)}e.onUnexpectedError=P;function A(u){y(u)||e.errorHandler.onUnexpectedExternalError(u)}e.onUnexpectedExternalError=A;function S(u){if(u instanceof Error){let{name:t,message:r}=u;const c=u.stacktrace||u.stack;return{$isError:!0,name:t,message:r,stack:c}}return u}e.transformErrorForSerialization=S;const C="Canceled";function y(u){return u instanceof Error&&u.name===C&&u.message===C}e.isPromiseCanceledError=y;class n extends Error{constructor(){super(C);this.name=this.message}}e.CancellationError=n;function T(){const u=new Error(C);return u.name=u.message,u}e.canceled=T;function k(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}e.illegalArgument=k;function g(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}e.illegalState=g;function m(u){return u?new Error(`readonly property '${u} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=m;function i(u){const t=new Error(`${u} has been disposed`);return t.name="DISPOSED",t}e.disposed=i;function s(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}e.getErrorMessage=s;class _ extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=_;class d extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=d;class b extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=b;function v(u){const t=u;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=v;function l(u,t=Object.create(null)){const r=new Error(u);return t.actions&&(r.actions=t.actions),r}e.createErrorWithActions=l}),define(_e[11],we([0,1,10]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function I(M,N=0){return M[M.length-(1+N)]}e.tail=I;function P(M){if(M.length===0)throw new Error("Invalid tail call");return[M.slice(0,M.length-1),M[M.length-1]]}e.tail2=P;function A(M,N,B=(Q,W)=>Q===W){if(M===N)return!0;if(!M||!N||M.length!==N.length)return!1;for(let Q=0,W=M.length;Q<W;Q++)if(!B(M[Q],N[Q]))return!1;return!0}e.equals=A;function S(M,N,B){let Q=0,W=M.length-1;for(;Q<=W;){const ee=(Q+W)/2|0,re=B(M[ee],N);if(re<0)Q=ee+1;else if(re>0)W=ee-1;else return ee}return-(Q+1)}e.binarySearch=S;function C(M,N){let B=0,Q=M.length;if(Q===0)return 0;for(;B<Q;){const W=Math.floor((B+Q)/2);N(M[W])?Q=W:B=W+1}return B}e.findFirstInSorted=C;function y(M,N,B){if(M=M|0,M>=N.length)throw new TypeError("invalid index");let Q=N[Math.floor(N.length*Math.random())],W=[],ee=[],re=[];for(let oe of N){const Se=B(oe,Q);Se<0?W.push(oe):Se>0?ee.push(oe):re.push(oe)}return M<W.length?y(M,W,B):M<W.length+re.length?re[0]:y(M-(W.length+re.length),ee,B)}e.quickSelect=y;function n(M,N){const B=[];let Q;for(const W of M.slice(0).sort(N))!Q||N(Q[0],W)!==0?(Q=[W],B.push(Q)):Q.push(W);return B}e.groupBy=n;function T(M,N,B){const Q=[];function W(oe,Se,Pe){if(!(Se===0&&Pe.length===0)){const $e=Q[Q.length-1];$e&&$e.start+$e.deleteCount===oe?($e.deleteCount+=Se,$e.toInsert.push(...Pe)):Q.push({start:oe,deleteCount:Se,toInsert:Pe})}}let ee=0,re=0;for(;;){if(ee===M.length){W(ee,0,N.slice(re));break}if(re===N.length){W(ee,M.length-ee,[]);break}const oe=M[ee],Se=N[re],Pe=B(oe,Se);Pe===0?(ee+=1,re+=1):Pe<0?(W(ee,1,[]),ee+=1):Pe>0&&(W(ee,0,[Se]),re+=1)}return Q}e.sortedDiff=T;function k(M,N,B){const Q=T(M,N,B),W=[],ee=[];for(const re of Q)W.push(...M.slice(re.start,re.start+re.deleteCount)),ee.push(...re.toInsert);return{removed:W,added:ee}}e.delta=k;function g(M,N,B){if(B===0)return[];const Q=M.slice(0,B).sort(N);return i(M,N,Q,B,M.length),Q}e.top=g;function m(M,N,B,Q,W){return B===0?Promise.resolve([]):new Promise((ee,re)=>{(async()=>{const oe=M.length,Se=M.slice(0,B).sort(N);for(let Pe=B,$e=Math.min(B+Q,oe);Pe<oe;Pe=$e,$e=Math.min($e+Q,oe)){if(Pe>B&&await new Promise(Fe=>setTimeout(Fe)),W&&W.isCancellationRequested)throw(0,E.canceled)();i(M,N,Se,Pe,$e)}return Se})().then(ee,re)})}e.topAsync=m;function i(M,N,B,Q,W){for(const ee=B.length;Q<W;Q++){const re=M[Q];if(N(re,B[ee-1])<0){B.pop();const oe=C(B,Se=>N(re,Se)<0);B.splice(oe,0,re)}}}function s(M){return M.filter(N=>!!N)}e.coalesce=s;function _(M){let N=0;for(let B=0;B<M.length;B++)M[B]&&(M[N]=M[B],N+=1);M.length=N}e.coalesceInPlace=_;function d(M,N,B){M.splice(B,0,M.splice(N,1)[0])}e.move=d;function b(M){return!Array.isArray(M)||M.length===0}e.isFalsyOrEmpty=b;function v(M){return Array.isArray(M)&&M.length>0}e.isNonEmptyArray=v;function l(M,N){if(!N)return M.filter((Q,W)=>M.indexOf(Q)===W);const B=Object.create(null);return M.filter(Q=>{const W=N(Q);return B[W]?!1:(B[W]=!0,!0)})}e.distinct=l;function u(M){const N=new Set;return M.filter(B=>N.has(B)?!1:(N.add(B),!0))}e.distinctES6=u;function t(M){const N=Object.create(null);return B=>{const Q=M(B);return N[Q]?!1:(N[Q]=!0,!0)}}e.uniqueFilter=t;function r(M,N){for(let B=M.length-1;B>=0;B--){const Q=M[B];if(N(Q))return B}return-1}e.lastIndex=r;function c(M,N){return M.length>0?M[0]:N}e.firstOrDefault=c;function o(M,N,B=(Q,W)=>Q===W){let Q=0;for(let W=0,ee=Math.min(M.length,N.length);W<ee&&B(M[W],N[W]);W++)Q++;return Q}e.commonPrefixLength=o;function a(M){return[].concat(...M)}e.flatten=a;function f(M,N){let B=typeof N=="number"?M:0;typeof N=="number"?B=M:(B=0,N=M);const Q=[];if(B<=N)for(let W=B;W<N;W++)Q.push(W);else for(let W=B;W>N;W--)Q.push(W);return Q}e.range=f;function w(M,N,B){return M.reduce((Q,W)=>(Q[N(W)]=B?B(W):W,Q),Object.create(null))}e.index=w;function D(M,N){return M.push(N),()=>p(M,N)}e.insert=D;function p(M,N){const B=M.indexOf(N);if(B>-1)return M.splice(B,1),N}e.remove=p;function h(M,N,B){const Q=M.slice(0,N),W=M.slice(N);return Q.concat(B,W)}e.arrayInsert=h;function R(M,N){let B;if(typeof N=="number"){let Q=N;B=()=>{const W=Math.sin(Q++)*179426549;return W-Math.floor(W)}}else B=Math.random;for(let Q=M.length-1;Q>0;Q-=1){const W=Math.floor(B()*(Q+1)),ee=M[Q];M[Q]=M[W],M[W]=ee}}e.shuffle=R;function F(M,N){const B=M.indexOf(N);B>-1&&(M.splice(B,1),M.unshift(N))}e.pushToStart=F;function $(M,N){const B=M.indexOf(N);B>-1&&(M.splice(B,1),M.push(N))}e.pushToEnd=$;function se(M,N){return Array.isArray(M)?M.map(N):N(M)}e.mapArrayOrNot=se;function z(M){return Array.isArray(M)?M:[M]}e.asArray=z;function x(M){return M[Math.floor(Math.random()*M.length)]}e.getRandomElement=x;function G(M,N){for(const B of M){const Q=N(B);if(Q!==void 0)return Q}}e.mapFind=G}),define(_e[52],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function E(I){const P=this;let A=!1,S;return function(){return A||(A=!0,S=I.apply(P,arguments)),S}}e.once=E}),define(_e[53],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class E{constructor(P){this._prefix=P,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=E,e.defaultGenerator=new E("id#")}),define(_e[54],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var E;(function(I){function P(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}I.is=P;const A=Object.freeze([]);function S(){return A}I.empty=S;function*C(u){yield u}I.single=C;function y(u){return u||A}I.from=y;function n(u){return!u||u[Symbol.iterator]().next().done===!0}I.isEmpty=n;function T(u){return u[Symbol.iterator]().next().value}I.first=T;function k(u,t){for(const r of u)if(t(r))return!0;return!1}I.some=k;function g(u,t){for(const r of u)if(t(r))return r}I.find=g;function*m(u,t){for(const r of u)t(r)&&(yield r)}I.filter=m;function*i(u,t){for(const r of u)yield t(r)}I.map=i;function*s(...u){for(const t of u)for(const r of t)yield r}I.concat=s;function*_(u){for(const t of u)for(const r of t)yield r}I.concatNested=_;function d(u,t,r){let c=r;for(const o of u)c=t(c,o);return c}I.reduce=d;function*b(u,t,r=u.length){for(t<0&&(t+=u.length),r<0?r+=u.length:r>u.length&&(r=u.length);t<r;t++)yield u[t]}I.slice=b;function v(u,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,u];const c=u[Symbol.iterator]();for(let o=0;o<t;o++){const a=c.next();if(a.done)return[r,I.empty()];r.push(a.value)}return[r,{[Symbol.iterator](){return c}}]}I.consume=v;function l(u,t,r=(c,o)=>c===o){const c=u[Symbol.iterator](),o=t[Symbol.iterator]();for(;;){const a=c.next(),f=o.next();if(a.done!==f.done)return!1;if(a.done)return!0;if(!r(a.value,f.value))return!1}}I.equals=l})(E=e.Iterable||(e.Iterable={}))}),define(_e[43],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var E;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(E=e.ScanError||(e.ScanError={}));var I;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(I=e.SyntaxKind||(e.SyntaxKind={}));var P;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(P=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function S(t,r=!1){let c=0,o=t.length,a="",f=0,w=16,D=0;function p(x){let G=0,M=0;for(;G<x;){const N=t.charCodeAt(c);if(N>=48&&N<=57)M=M*16+N-48;else if(N>=65&&N<=70)M=M*16+N-65+10;else if(N>=97&&N<=102)M=M*16+N-97+10;else break;c++,G++}return G<x&&(M=-1),M}function h(x){c=x,a="",f=0,w=16,D=0}function R(){const x=c;if(t.charCodeAt(c)===48)c++;else for(c++;c<t.length&&n(t.charCodeAt(c));)c++;if(c<t.length&&t.charCodeAt(c)===46)if(c++,c<t.length&&n(t.charCodeAt(c)))for(c++;c<t.length&&n(t.charCodeAt(c));)c++;else return D=3,t.substring(x,c);let G=c;if(c<t.length&&(t.charCodeAt(c)===69||t.charCodeAt(c)===101))if(c++,(c<t.length&&t.charCodeAt(c)===43||t.charCodeAt(c)===45)&&c++,c<t.length&&n(t.charCodeAt(c))){for(c++;c<t.length&&n(t.charCodeAt(c));)c++;G=c}else D=3;return t.substring(x,G)}function F(){let x="",G=c;for(;;){if(c>=o){x+=t.substring(G,c),D=2;break}const M=t.charCodeAt(c);if(M===34){x+=t.substring(G,c),c++;break}if(M===92){if(x+=t.substring(G,c),c++,c>=o){D=2;break}switch(t.charCodeAt(c++)){case 34:x+='"';break;case 92:x+="\\";break;case 47:x+="/";break;case 98:x+="\b";break;case 102:x+="\f";break;case 110:x+=`
`;break;case 114:x+="\r";break;case 116:x+="	";break;case 117:const B=p(4);B>=0?x+=String.fromCharCode(B):D=4;break;default:D=5}G=c;continue}if(M>=0&&M<=31)if(y(M)){x+=t.substring(G,c),D=2;break}else D=6;c++}return x}function $(){if(a="",D=0,f=c,c>=o)return f=o,w=17;let x=t.charCodeAt(c);if(C(x)){do c++,a+=String.fromCharCode(x),x=t.charCodeAt(c);while(C(x));return w=15}if(y(x))return c++,a+=String.fromCharCode(x),x===13&&t.charCodeAt(c)===10&&(c++,a+=`
`),w=14;switch(x){case 123:return c++,w=1;case 125:return c++,w=2;case 91:return c++,w=3;case 93:return c++,w=4;case 58:return c++,w=6;case 44:return c++,w=5;case 34:return c++,a=F(),w=10;case 47:const G=c-1;if(t.charCodeAt(c+1)===47){for(c+=2;c<o&&!y(t.charCodeAt(c));)c++;return a=t.substring(G,c),w=12}if(t.charCodeAt(c+1)===42){c+=2;const M=o-1;let N=!1;for(;c<M;){if(t.charCodeAt(c)===42&&t.charCodeAt(c+1)===47){c+=2,N=!0;break}c++}return N||(c++,D=1),a=t.substring(G,c),w=13}return a+=String.fromCharCode(x),c++,w=16;case 45:if(a+=String.fromCharCode(x),c++,c===o||!n(t.charCodeAt(c)))return w=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=R(),w=11;default:for(;c<o&&se(x);)c++,x=t.charCodeAt(c);if(f!==c){switch(a=t.substring(f,c),a){case"true":return w=8;case"false":return w=9;case"null":return w=7}return w=16}return a+=String.fromCharCode(x),c++,w=16}}function se(x){if(C(x)||y(x))return!1;switch(x){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function z(){let x;do x=$();while(x>=12&&x<=15);return x}return{setPosition:h,getPosition:()=>c,scan:r?z:$,getToken:()=>w,getTokenValue:()=>a,getTokenOffset:()=>f,getTokenLength:()=>c-f,getTokenError:()=>D}}e.createScanner=S;function C(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function y(t){return t===10||t===13||t===8232||t===8233}function n(t){return t>=48&&t<=57}var T;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(T||(T={}));function k(t,r){const c=[],o=new Object;let a;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let w=!1;function D(p,h,R,F){f.value=p,f.offset=h,f.length=R,f.type=F,f.colonOffset=void 0,a=f}try{v(t,{onObjectBegin:(p,h)=>{if(r<=p)throw o;a=void 0,w=r>p,c.push("")},onObjectProperty:(p,h,R)=>{if(r<h||(D(p,h,R,"property"),c[c.length-1]=p,r<=h+R))throw o},onObjectEnd:(p,h)=>{if(r<=p)throw o;a=void 0,c.pop()},onArrayBegin:(p,h)=>{if(r<=p)throw o;a=void 0,c.push(0)},onArrayEnd:(p,h)=>{if(r<=p)throw o;a=void 0,c.pop()},onLiteralValue:(p,h,R)=>{if(r<h||(D(p,h,R,u(p)),r<=h+R))throw o},onSeparator:(p,h,R)=>{if(r<=h)throw o;if(p===":"&&a&&a.type==="property")a.colonOffset=h,w=!1,a=void 0;else if(p===","){const F=c[c.length-1];typeof F=="number"?c[c.length-1]=F+1:(w=!0,c[c.length-1]=""),a=void 0}}})}catch(p){if(p!==o)throw p}return{path:c,previousNode:a,isAtPropertyKey:w,matches:p=>{let h=0;for(let R=0;h<p.length&&R<c.length;R++)if(p[h]===c[R]||p[h]==="*")h++;else if(p[h]!=="**")return!1;return h===p.length}}}e.getLocation=k;function g(t,r=[],c=A.DEFAULT){let o=null,a=[];const f=[];function w(p){Array.isArray(a)?a.push(p):o!==null&&(a[o]=p)}return v(t,{onObjectBegin:()=>{const p={};w(p),f.push(a),a=p,o=null},onObjectProperty:p=>{o=p},onObjectEnd:()=>{a=f.pop()},onArrayBegin:()=>{const p=[];w(p),f.push(a),a=p,o=null},onArrayEnd:()=>{a=f.pop()},onLiteralValue:w,onError:(p,h,R)=>{r.push({error:p,offset:h,length:R})}},c),a[0]}e.parse=g;function m(t,r=[],c=A.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(p){o.type==="property"&&(o.length=p-o.offset,o=o.parent)}function f(p){return o.children.push(p),p}v(t,{onObjectBegin:p=>{o=f({type:"object",offset:p,length:-1,parent:o,children:[]})},onObjectProperty:(p,h,R)=>{o=f({type:"property",offset:h,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:p,offset:h,length:R,parent:o})},onObjectEnd:(p,h)=>{o.length=p+h-o.offset,o=o.parent,a(p+h)},onArrayBegin:(p,h)=>{o=f({type:"array",offset:p,length:-1,parent:o,children:[]})},onArrayEnd:(p,h)=>{o.length=p+h-o.offset,o=o.parent,a(p+h)},onLiteralValue:(p,h,R)=>{f({type:u(p),offset:h,length:R,parent:o,value:p}),a(h+R)},onSeparator:(p,h,R)=>{o.type==="property"&&(p===":"?o.colonOffset=h:p===","&&a(h))},onError:(p,h,R)=>{r.push({error:p,offset:h,length:R})}},c);const D=o.children[0];return D&&delete D.parent,D}e.parseTree=m;function i(t,r){if(!!t){let c=t;for(let o of r)if(typeof o=="string"){if(c.type!=="object"||!Array.isArray(c.children))return;let a=!1;for(const f of c.children)if(Array.isArray(f.children)&&f.children[0].value===o){c=f.children[1],a=!0;break}if(!a)return}else{const a=o;if(c.type!=="array"||a<0||!Array.isArray(c.children)||a>=c.children.length)return;c=c.children[a]}return c}}e.findNodeAtLocation=i;function s(t){if(!t.parent||!t.parent.children)return[];const r=s(t.parent);if(t.parent.type==="property"){const c=t.parent.children[0].value;r.push(c)}else if(t.parent.type==="array"){const c=t.parent.children.indexOf(t);c!==-1&&r.push(c)}return r}e.getNodePath=s;function _(t){switch(t.type){case"array":return t.children.map(_);case"object":const r=Object.create(null);for(let c of t.children){const o=c.children[1];o&&(r[c.children[0].value]=_(o))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=_;function d(t,r,c=!1){return r>=t.offset&&r<t.offset+t.length||c&&r===t.offset+t.length}e.contains=d;function b(t,r,c=!1){if(d(t,r,c)){const o=t.children;if(Array.isArray(o))for(let a=0;a<o.length&&o[a].offset<=r;a++){const f=b(o[a],r,c);if(f)return f}return t}}e.findNodeAtOffset=b;function v(t,r,c=A.DEFAULT){const o=S(t,!1);function a(Se){return Se?()=>Se(o.getTokenOffset(),o.getTokenLength()):()=>!0}function f(Se){return Se?Pe=>Se(Pe,o.getTokenOffset(),o.getTokenLength()):()=>!0}const w=a(r.onObjectBegin),D=f(r.onObjectProperty),p=a(r.onObjectEnd),h=a(r.onArrayBegin),R=a(r.onArrayEnd),F=f(r.onLiteralValue),$=f(r.onSeparator),se=a(r.onComment),z=f(r.onError),x=c&&c.disallowComments,G=c&&c.allowTrailingComma;function M(){for(;;){const Se=o.scan();switch(o.getTokenError()){case 4:N(14);break;case 5:N(15);break;case 3:N(13);break;case 1:x||N(11);break;case 2:N(12);break;case 6:N(16);break}switch(Se){case 12:case 13:x?N(10):se();break;case 16:N(1);break;case 15:case 14:break;default:return Se}}}function N(Se,Pe=[],$e=[]){if(z(Se),Pe.length+$e.length>0){let Fe=o.getToken();for(;Fe!==17;){if(Pe.indexOf(Fe)!==-1){M();break}else if($e.indexOf(Fe)!==-1)break;Fe=M()}}}function B(Se){const Pe=o.getTokenValue();return Se?F(Pe):D(Pe),M(),!0}function Q(){switch(o.getToken()){case 11:let Se=0;try{Se=JSON.parse(o.getTokenValue()),typeof Se!="number"&&(N(2),Se=0)}catch(Pe){N(2)}F(Se);break;case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return M(),!0}function W(){return o.getToken()!==10?(N(3,[],[2,5]),!1):(B(!1),o.getToken()===6?($(":"),M(),oe()||N(4,[],[2,5])):N(5,[],[2,5]),!0)}function ee(){w(),M();let Se=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(Se||N(4,[],[]),$(","),M(),o.getToken()===2&&G)break}else Se&&N(6,[],[]);W()||N(4,[],[2,5]),Se=!0}return p(),o.getToken()!==2?N(7,[2],[]):M(),!0}function re(){h(),M();let Se=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(Se||N(4,[],[]),$(","),M(),o.getToken()===4&&G)break}else Se&&N(6,[],[]);oe()||N(4,[],[4,5]),Se=!0}return R(),o.getToken()!==4?N(8,[4],[]):M(),!0}function oe(){switch(o.getToken()){case 3:return re();case 1:return ee();case 10:return B(!0);default:return Q()}}return M(),o.getToken()===17?c.allowEmptyContent?!0:(N(4,[],[]),!1):oe()?(o.getToken()!==17&&N(9,[],[]),!0):(N(4,[],[]),!1)}e.visit=v;function l(t,r){let c=S(t),o=[],a,f=0,w;do switch(w=c.getPosition(),a=c.scan(),a){case 12:case 13:case 17:f!==w&&o.push(t.substring(f,w)),r!==void 0&&o.push(c.getTokenValue().replace(/[^\r\n]/g,r)),f=c.getPosition();break}while(a!==17);return o.join("")}e.stripComments=l;function u(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=u}),define(_e[104],we([0,1,43]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function I(y,n,T){let k,g,m,i,s;if(n){for(i=n.offset,s=i+n.length,m=i;m>0&&!C(y,m-1);)m--;let f=s;for(;f<y.length&&!C(y,f);)f++;g=y.substring(m,f),k=A(g,T)}else g=y,k=0,m=0,i=0,s=y.length;const _=S(T,y);let d=!1,b=0,v;T.insertSpaces?v=P(" ",T.tabSize||4):v="	";const l=(0,E.createScanner)(g,!1);let u=!1;function t(){return _+P(v,k+b)}function r(){let f=l.scan();for(d=!1;f===15||f===14;)d=d||f===14,f=l.scan();return u=f===16||l.getTokenError()!==0,f}const c=[];function o(f,w,D){!u&&w<s&&D>i&&y.substring(w,D)!==f&&c.push({offset:w,length:D-w,content:f})}let a=r();if(a!==17){const f=l.getTokenOffset()+m,w=P(v,k);o(w,m,f)}for(;a!==17;){let f=l.getTokenOffset()+l.getTokenLength()+m,w=r(),D="";for(;!d&&(w===12||w===13);){const h=l.getTokenOffset()+m;o(" ",f,h),f=l.getTokenOffset()+l.getTokenLength()+m,D=w===12?t():"",w=r()}if(w===2)a!==1&&(b--,D=t());else if(w===4)a!==3&&(b--,D=t());else{switch(a){case 3:case 1:b++,D=t();break;case 5:case 12:D=t();break;case 13:d?D=t():D=" ";break;case 6:D=" ";break;case 10:if(w===6){D="";break}case 7:case 8:case 9:case 11:case 2:case 4:w===12||w===13?D=" ":w!==5&&w!==17&&(u=!0);break;case 16:u=!0;break}d&&(w===12||w===13)&&(D=t())}const p=l.getTokenOffset()+m;o(D,f,p),a=w}return c}e.format=I;function P(y,n){let T="";for(let k=0;k<n;k++)T+=y;return T}function A(y,n){let T=0,k=0;const g=n.tabSize||4;for(;T<y.length;){const m=y.charAt(T);if(m===" ")k++;else if(m==="	")k+=g;else break;T++}return Math.floor(k/g)}function S(y,n){for(let T=0;T<n.length;T++){const k=n.charAt(T);if(k==="\r")return T+1<n.length&&n.charAt(T+1)===`
`?`\r
`:"\r";if(k===`
`)return`
`}return y&&y.eol||`
`}e.getEOL=S;function C(y,n){return`\r
`.indexOf(y.charAt(n))!==-1}e.isEOL=C}),define(_e[105],we([0,1,43,104]),function(ie,e,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function P(n,T,k){return A(n,T,void 0,k)}e.removeProperty=P;function A(n,T,k,g,m){const i=T.slice(),s=[],_=(0,E.parseTree)(n,s);let d,b;for(;i.length>0&&(b=i.pop(),d=(0,E.findNodeAtLocation)(_,i),d===void 0&&k!==void 0);)typeof b=="string"?k={[b]:k}:k=[k];if(d)if(d.type==="object"&&typeof b=="string"&&Array.isArray(d.children)){const v=(0,E.findNodeAtLocation)(d,[b]);if(v!==void 0)if(k===void 0){if(!v.parent)throw new Error("Malformed AST");const l=d.children.indexOf(v.parent);let u,t=v.parent.offset+v.parent.length;if(l>0){const r=d.children[l-1];u=r.offset+r.length}else u=d.offset+1,d.children.length>1&&(t=d.children[1].offset);return S(n,{offset:u,length:t-u,content:""},g)}else return S(n,{offset:v.offset,length:v.length,content:JSON.stringify(k)},g);else{if(k===void 0)return[];const l=`${JSON.stringify(b)}: ${JSON.stringify(k)}`,u=m?m(d.children.map(r=>r.children[0].value)):d.children.length;let t;if(u>0){const r=d.children[u-1];t={offset:r.offset+r.length,length:0,content:","+l}}else d.children.length===0?t={offset:d.offset+1,length:0,content:l}:t={offset:d.offset+1,length:0,content:l+","};return S(n,t,g)}}else if(d.type==="array"&&typeof b=="number"&&Array.isArray(d.children))if(k!==void 0){const v=`${JSON.stringify(k)}`;let l;if(d.children.length===0||b===0)l={offset:d.offset+1,length:0,content:d.children.length===0?v:v+","};else{const u=b===-1||b>d.children.length?d.children.length:b,t=d.children[u-1];l={offset:t.offset+t.length,length:0,content:","+v}}return S(n,l,g)}else{const v=b,l=d.children[v];let u;if(d.children.length===1)u={offset:d.offset+1,length:d.length-2,content:""};else if(d.children.length-1===v){const t=d.children[v-1],r=t.offset+t.length,c=d.offset+d.length;u={offset:r,length:c-2-r,content:""}}else u={offset:l.offset,length:d.children[v+1].offset-l.offset,content:""};return S(n,u,g)}else throw new Error(`Can not add ${typeof b!="number"?"index":"property"} to parent of type ${d.type}`);else{if(k===void 0)throw new Error("Can not delete in empty document");return S(n,{offset:_?_.offset:0,length:_?_.length:0,content:JSON.stringify(k)},g)}}e.setProperty=A;function S(n,T,k){let g=C(n,T),m=T.offset,i=T.offset+T.content.length;if(T.length===0||T.content.length===0){for(;m>0&&!(0,I.isEOL)(g,m-1);)m--;for(;i<g.length&&!(0,I.isEOL)(g,i);)i++}const s=(0,I.format)(g,{offset:m,length:i-m},k);for(let d=s.length-1;d>=0;d--){const b=s[d];g=C(g,b),m=Math.min(m,b.offset),i=Math.max(i,b.offset+b.length),i+=b.content.length-b.length}const _=n.length-(g.length-i)-m;return[{offset:m,length:_,content:g.substring(m,i)}]}e.withFormatting=S;function C(n,T){return n.substring(0,T.offset)+T.content+n.substring(T.offset+T.length)}e.applyEdit=C;function y(n,T){let k=T.slice(0).sort((m,i)=>{const s=m.offset-i.offset;return s===0?m.length-i.length:s}),g=n.length;for(let m=k.length-1;m>=0;m--){let i=k[m];if(i.offset+i.length<=g)n=C(n,i);else throw new Error("Overlapping edit");g=i.offset}return n}e.applyEdits=y}),define(_e[106],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class E{constructor(P){this.executor=P,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(P){this._error=P}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(P){return new E(()=>P(this.getValue()))}}e.Lazy=E}),define(_e[6],we([0,1,52,54]),function(ie,e,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const P=!1;let A=null;function S(v){A=v}if(e.setDisposableTracker=S,P){const v="__is_disposable_tracked__";A=new class{trackDisposable(l){const u=new Error("Potentially leaked disposable").stack;setTimeout(()=>{l[v]||console.log(u)},3e3)}markTracked(l){if(l&&l!==s.None)try{l[v]=!0}catch(u){}}}}function C(v){!A||A.markTracked(v)}function y(v){return A&&A.trackDisposable(v),v}e.trackDisposable=y;class n extends Error{constructor(l){super(`Encountered errors while disposing of store. Errors: [${l.join(", ")}]`);this.errors=l}}e.MultiDisposeError=n;function T(v){return typeof v.dispose=="function"&&v.dispose.length===0}e.isDisposable=T;function k(v){if(I.Iterable.is(v)){let l=[];for(const u of v)if(u){C(u);try{u.dispose()}catch(t){l.push(t)}}if(l.length===1)throw l[0];if(l.length>1)throw new n(l);return Array.isArray(v)?[]:v}else if(v)return C(v),v.dispose(),v}e.dispose=k;function g(...v){return v.forEach(C),m(()=>k(v))}e.combinedDisposable=g;function m(v){const l=y({dispose:()=>{C(l),v()}});return l}e.toDisposable=m;class i{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(C(this),this._isDisposed=!0,this.clear())}clear(){try{k(this._toDispose.values())}finally{this._toDispose.clear()}}add(l){if(!l)return l;if(l===this)throw new Error("Cannot register a disposable on itself!");return C(l),this._isDisposed?i.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(l),l}}e.DisposableStore=i,i.DISABLE_DISPOSED_WARNING=!1;class s{constructor(){this._store=new i,y(this)}dispose(){C(this),this._store.dispose()}_register(l){if(l===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(l)}}e.Disposable=s,s.None=Object.freeze({dispose(){}});class _{constructor(){this._isDisposed=!1,y(this)}get value(){return this._isDisposed?void 0:this._value}set value(l){var u;this._isDisposed||l===this._value||((u=this._value)===null||u===void 0||u.dispose(),l&&C(l),this._value=l)}clear(){this.value=void 0}dispose(){var l;this._isDisposed=!0,C(this),(l=this._value)===null||l===void 0||l.dispose(),this._value=void 0}}e.MutableDisposable=_;class d{constructor(){this.references=new Map}acquire(l,...u){let t=this.references.get(l);t||(t={counter:0,object:this.createReferencedObject(l,...u)},this.references.set(l,t));const{object:r}=t,c=(0,E.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(l,t.object),this.references.delete(l))});return t.counter++,{object:r,dispose:c}}}e.ReferenceCollection=d;class b{constructor(l){this.object=l}dispose(){}}e.ImmortalReference=b}),define(_e[44],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class E{constructor(A){this.element=A,this.next=E.Undefined,this.prev=E.Undefined}}E.Undefined=new E(void 0);class I{constructor(){this._first=E.Undefined,this._last=E.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===E.Undefined}clear(){this._first=E.Undefined,this._last=E.Undefined,this._size=0}unshift(A){return this._insert(A,!1)}push(A){return this._insert(A,!0)}_insert(A,S){const C=new E(A);if(this._first===E.Undefined)this._first=C,this._last=C;else if(S){const n=this._last;this._last=C,C.prev=n,n.next=C}else{const n=this._first;this._first=C,C.next=n,n.prev=C}this._size+=1;let y=!1;return()=>{y||(y=!0,this._remove(C))}}shift(){if(this._first!==E.Undefined){const A=this._first.element;return this._remove(this._first),A}}pop(){if(this._last!==E.Undefined){const A=this._last.element;return this._remove(this._last),A}}_remove(A){if(A.prev!==E.Undefined&&A.next!==E.Undefined){const S=A.prev;S.next=A.next,A.next.prev=S}else A.prev===E.Undefined&&A.next===E.Undefined?(this._first=E.Undefined,this._last=E.Undefined):A.next===E.Undefined?(this._last=this._last.prev,this._last.next=E.Undefined):A.prev===E.Undefined&&(this._first=this._first.next,this._first.prev=E.Undefined);this._size-=1}*[Symbol.iterator](){let A=this._first;for(;A!==E.Undefined;)yield A.element,A=A.next}}e.LinkedList=I}),function(ie,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(ie=typeof globalThis!="undefined"?globalThis:ie||self,ie.marked=e())}(this,function(){"use strict";function ie(H,ne){for(var de=0;de<ne.length;de++){var j=ne[de];j.enumerable=j.enumerable||!1,j.configurable=!0,"value"in j&&(j.writable=!0),Object.defineProperty(H,j.key,j)}}function e(H,ne,de){return ne&&ie(H.prototype,ne),de&&ie(H,de),H}function E(H,ne){if(!!H){if(typeof H=="string")return I(H,ne);var de=Object.prototype.toString.call(H).slice(8,-1);if(de==="Object"&&H.constructor&&(de=H.constructor.name),de==="Map"||de==="Set")return Array.from(H);if(de==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(de))return I(H,ne)}}function I(H,ne){(ne==null||ne>H.length)&&(ne=H.length);for(var de=0,j=new Array(ne);de<ne;de++)j[de]=H[de];return j}function P(H,ne){var de;if(typeof Symbol=="undefined"||H[Symbol.iterator]==null){if(Array.isArray(H)||(de=E(H))||ne&&H&&typeof H.length=="number"){de&&(H=de);var j=0;return function(){return j>=H.length?{done:!0}:{done:!1,value:H[j++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return de=H[Symbol.iterator](),de.next.bind(de)}function A(H){var ne={exports:{}};return H(ne,ne.exports),ne.exports}var S=A(function(H){function ne(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function de(j){H.exports.defaults=j}H.exports={defaults:ne(),getDefaults:ne,changeDefaults:de}}),C=/[&<>"']/,y=/[&<>"']/g,n=/[<>"']|&(?!#?\w+;)/,T=/[<>"']|&(?!#?\w+;)/g,k={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},g=function(ne){return k[ne]};function m(H,ne){if(ne){if(C.test(H))return H.replace(y,g)}else if(n.test(H))return H.replace(T,g);return H}var i=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function s(H){return H.replace(i,function(ne,de){return de=de.toLowerCase(),de==="colon"?":":de.charAt(0)==="#"?de.charAt(1)==="x"?String.fromCharCode(parseInt(de.substring(2),16)):String.fromCharCode(+de.substring(1)):""})}var _=/(^|[^\[])\^/g;function d(H,ne){H=H.source||H,ne=ne||"";var de={replace:function(Y,ae){return ae=ae.source||ae,ae=ae.replace(_,"$1"),H=H.replace(Y,ae),de},getRegex:function(){return new RegExp(H,ne)}};return de}var b=/[^\w:]/g,v=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function l(H,ne,de){if(H){var j;try{j=decodeURIComponent(s(de)).replace(b,"").toLowerCase()}catch(Y){return null}if(j.indexOf("javascript:")===0||j.indexOf("vbscript:")===0||j.indexOf("data:")===0)return null}ne&&!v.test(de)&&(de=o(ne,de));try{de=encodeURI(de).replace(/%25/g,"%")}catch(Y){return null}return de}var u={},t=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,c=/^([^:]+:\/*[^/]*)[\s\S]*$/;function o(H,ne){u[" "+H]||(t.test(H)?u[" "+H]=H+"/":u[" "+H]=D(H,"/",!0)),H=u[" "+H];var de=H.indexOf(":")===-1;return ne.substring(0,2)==="//"?de?ne:H.replace(r,"$1")+ne:ne.charAt(0)==="/"?de?ne:H.replace(c,"$1")+ne:H+ne}var a={exec:function(){}};function f(H){for(var ne=1,de,j;ne<arguments.length;ne++){de=arguments[ne];for(j in de)Object.prototype.hasOwnProperty.call(de,j)&&(H[j]=de[j])}return H}function w(H,ne){var de=H.replace(/\|/g,function(ae,fe,Ee){for(var Ne=!1,Le=fe;--Le>=0&&Ee[Le]==="\\";)Ne=!Ne;return Ne?"|":" |"}),j=de.split(/ \|/),Y=0;if(j.length>ne)j.splice(ne);else for(;j.length<ne;)j.push("");for(;Y<j.length;Y++)j[Y]=j[Y].trim().replace(/\\\|/g,"|");return j}function D(H,ne,de){var j=H.length;if(j===0)return"";for(var Y=0;Y<j;){var ae=H.charAt(j-Y-1);if(ae===ne&&!de)Y++;else if(ae!==ne&&de)Y++;else break}return H.substr(0,j-Y)}function p(H,ne){if(H.indexOf(ne[1])===-1)return-1;for(var de=H.length,j=0,Y=0;Y<de;Y++)if(H[Y]==="\\")Y++;else if(H[Y]===ne[0])j++;else if(H[Y]===ne[1]&&(j--,j<0))return Y;return-1}function h(H){H&&H.sanitize&&!H.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function R(H,ne){if(ne<1)return"";for(var de="";ne>1;)ne&1&&(de+=H),ne>>=1,H+=H;return de+H}var F={escape:m,unescape:s,edit:d,cleanUrl:l,resolveUrl:o,noopTest:a,merge:f,splitCells:w,rtrim:D,findClosingBracket:p,checkSanitizeDeprecation:h,repeatString:R},$=S.defaults,se=F.rtrim,z=F.splitCells,x=F.escape,G=F.findClosingBracket;function M(H,ne,de){var j=ne.href,Y=ne.title?x(ne.title):null,ae=H[1].replace(/\\([\[\]])/g,"$1");return H[0].charAt(0)!=="!"?{type:"link",raw:de,href:j,title:Y,text:ae}:{type:"image",raw:de,href:j,title:Y,text:x(ae)}}function N(H,ne){var de=H.match(/^(\s+)(?:```)/);if(de===null)return ne;var j=de[1];return ne.split(`
`).map(function(Y){var ae=Y.match(/^\s+/);if(ae===null)return Y;var fe=ae[0];return fe.length>=j.length?Y.slice(j.length):Y}).join(`
`)}var B=function(){function H(de){this.options=de||$}var ne=H.prototype;return ne.space=function(j){var Y=this.rules.block.newline.exec(j);if(Y)return Y[0].length>1?{type:"space",raw:Y[0]}:{raw:`
`}},ne.code=function(j){var Y=this.rules.block.code.exec(j);if(Y){var ae=Y[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:Y[0],codeBlockStyle:"indented",text:this.options.pedantic?ae:se(ae,`
`)}}},ne.fences=function(j){var Y=this.rules.block.fences.exec(j);if(Y){var ae=Y[0],fe=N(ae,Y[3]||"");return{type:"code",raw:ae,lang:Y[2]?Y[2].trim():Y[2],text:fe}}},ne.heading=function(j){var Y=this.rules.block.heading.exec(j);if(Y){var ae=Y[2].trim();if(/#$/.test(ae)){var fe=se(ae,"#");(this.options.pedantic||!fe||/ $/.test(fe))&&(ae=fe.trim())}return{type:"heading",raw:Y[0],depth:Y[1].length,text:ae}}},ne.nptable=function(j){var Y=this.rules.block.nptable.exec(j);if(Y){var ae={type:"table",header:z(Y[1].replace(/^ *| *\| *$/g,"")),align:Y[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:Y[3]?Y[3].replace(/\n$/,"").split(`
`):[],raw:Y[0]};if(ae.header.length===ae.align.length){var fe=ae.align.length,Ee;for(Ee=0;Ee<fe;Ee++)/^ *-+: *$/.test(ae.align[Ee])?ae.align[Ee]="right":/^ *:-+: *$/.test(ae.align[Ee])?ae.align[Ee]="center":/^ *:-+ *$/.test(ae.align[Ee])?ae.align[Ee]="left":ae.align[Ee]=null;for(fe=ae.cells.length,Ee=0;Ee<fe;Ee++)ae.cells[Ee]=z(ae.cells[Ee],ae.header.length);return ae}}},ne.hr=function(j){var Y=this.rules.block.hr.exec(j);if(Y)return{type:"hr",raw:Y[0]}},ne.blockquote=function(j){var Y=this.rules.block.blockquote.exec(j);if(Y){var ae=Y[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:Y[0],text:ae}}},ne.list=function(j){var Y=this.rules.block.list.exec(j);if(Y){var ae=Y[0],fe=Y[2],Ee=fe.length>1,Ne={type:"list",raw:ae,ordered:Ee,start:Ee?+fe.slice(0,-1):"",loose:!1,items:[]},Le=Y[0].match(this.rules.block.item),Ve=!1,Ye,et,nt,st,it,ve,he,ue,q=Le.length;nt=this.rules.block.listItemStart.exec(Le[0]);for(var Ie=0;Ie<q;Ie++){if(Ye=Le[Ie],ae=Ye,Ie!==q-1){if(st=this.rules.block.listItemStart.exec(Le[Ie+1]),this.options.pedantic?st[1].length>nt[1].length:st[1].length>nt[0].length||st[1].length>3){Le.splice(Ie,2,Le[Ie]+`
`+Le[Ie+1]),Ie--,q--;continue}else(!this.options.pedantic||this.options.smartLists?st[2][st[2].length-1]!==fe[fe.length-1]:Ee===(st[2].length===1))&&(it=Le.slice(Ie+1).join(`
`),Ne.raw=Ne.raw.substring(0,Ne.raw.length-it.length),Ie=q-1);nt=st}et=Ye.length,Ye=Ye.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Ye.indexOf(`
 `)&&(et-=Ye.length,Ye=this.options.pedantic?Ye.replace(/^ {1,4}/gm,""):Ye.replace(new RegExp("^ {1,"+et+"}","gm"),"")),ve=Ve||/\n\n(?!\s*$)/.test(Ye),Ie!==q-1&&(Ve=Ye.charAt(Ye.length-1)===`
`,ve||(ve=Ve)),ve&&(Ne.loose=!0),this.options.gfm&&(he=/^\[[ xX]\] /.test(Ye),ue=void 0,he&&(ue=Ye[1]!==" ",Ye=Ye.replace(/^\[[ xX]\] +/,""))),Ne.items.push({type:"list_item",raw:ae,task:he,checked:ue,loose:ve,text:Ye})}return Ne}},ne.html=function(j){var Y=this.rules.block.html.exec(j);if(Y)return{type:this.options.sanitize?"paragraph":"html",raw:Y[0],pre:!this.options.sanitizer&&(Y[1]==="pre"||Y[1]==="script"||Y[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Y[0]):x(Y[0]):Y[0]}},ne.def=function(j){var Y=this.rules.block.def.exec(j);if(Y){Y[3]&&(Y[3]=Y[3].substring(1,Y[3].length-1));var ae=Y[1].toLowerCase().replace(/\s+/g," ");return{tag:ae,raw:Y[0],href:Y[2],title:Y[3]}}},ne.table=function(j){var Y=this.rules.block.table.exec(j);if(Y){var ae={type:"table",header:z(Y[1].replace(/^ *| *\| *$/g,"")),align:Y[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:Y[3]?Y[3].replace(/\n$/,"").split(`
`):[]};if(ae.header.length===ae.align.length){ae.raw=Y[0];var fe=ae.align.length,Ee;for(Ee=0;Ee<fe;Ee++)/^ *-+: *$/.test(ae.align[Ee])?ae.align[Ee]="right":/^ *:-+: *$/.test(ae.align[Ee])?ae.align[Ee]="center":/^ *:-+ *$/.test(ae.align[Ee])?ae.align[Ee]="left":ae.align[Ee]=null;for(fe=ae.cells.length,Ee=0;Ee<fe;Ee++)ae.cells[Ee]=z(ae.cells[Ee].replace(/^ *\| *| *\| *$/g,""),ae.header.length);return ae}}},ne.lheading=function(j){var Y=this.rules.block.lheading.exec(j);if(Y)return{type:"heading",raw:Y[0],depth:Y[2].charAt(0)==="="?1:2,text:Y[1]}},ne.paragraph=function(j){var Y=this.rules.block.paragraph.exec(j);if(Y)return{type:"paragraph",raw:Y[0],text:Y[1].charAt(Y[1].length-1)===`
`?Y[1].slice(0,-1):Y[1]}},ne.text=function(j){var Y=this.rules.block.text.exec(j);if(Y)return{type:"text",raw:Y[0],text:Y[0]}},ne.escape=function(j){var Y=this.rules.inline.escape.exec(j);if(Y)return{type:"escape",raw:Y[0],text:x(Y[1])}},ne.tag=function(j,Y,ae){var fe=this.rules.inline.tag.exec(j);if(fe)return!Y&&/^<a /i.test(fe[0])?Y=!0:Y&&/^<\/a>/i.test(fe[0])&&(Y=!1),!ae&&/^<(pre|code|kbd|script)(\s|>)/i.test(fe[0])?ae=!0:ae&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(fe[0])&&(ae=!1),{type:this.options.sanitize?"text":"html",raw:fe[0],inLink:Y,inRawBlock:ae,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):x(fe[0]):fe[0]}},ne.link=function(j){var Y=this.rules.inline.link.exec(j);if(Y){var ae=Y[2].trim();if(!this.options.pedantic&&/^</.test(ae)){if(!/>$/.test(ae))return;var fe=se(ae.slice(0,-1),"\\");if((ae.length-fe.length)%2==0)return}else{var Ee=G(Y[2],"()");if(Ee>-1){var Ne=Y[0].indexOf("!")===0?5:4,Le=Ne+Y[1].length+Ee;Y[2]=Y[2].substring(0,Ee),Y[0]=Y[0].substring(0,Le).trim(),Y[3]=""}}var Ve=Y[2],Ye="";if(this.options.pedantic){var et=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ve);et&&(Ve=et[1],Ye=et[3])}else Ye=Y[3]?Y[3].slice(1,-1):"";return Ve=Ve.trim(),/^</.test(Ve)&&(this.options.pedantic&&!/>$/.test(ae)?Ve=Ve.slice(1):Ve=Ve.slice(1,-1)),M(Y,{href:Ve&&Ve.replace(this.rules.inline._escapes,"$1"),title:Ye&&Ye.replace(this.rules.inline._escapes,"$1")},Y[0])}},ne.reflink=function(j,Y){var ae;if((ae=this.rules.inline.reflink.exec(j))||(ae=this.rules.inline.nolink.exec(j))){var fe=(ae[2]||ae[1]).replace(/\s+/g," ");if(fe=Y[fe.toLowerCase()],!fe||!fe.href){var Ee=ae[0].charAt(0);return{type:"text",raw:Ee,text:Ee}}return M(ae,fe,ae[0])}},ne.emStrong=function(j,Y,ae){ae===void 0&&(ae="");var fe=this.rules.inline.emStrong.lDelim.exec(j);if(!!fe&&!(fe[3]&&ae.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ee=fe[1]||fe[2]||"";if(!Ee||Ee&&(ae===""||this.rules.inline.punctuation.exec(ae))){var Ne=fe[0].length-1,Le,Ve,Ye=Ne,et=0,nt=fe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(nt.lastIndex=0,Y=Y.slice(-1*j.length+Ne);(fe=nt.exec(Y))!=null;)if(Le=fe[1]||fe[2]||fe[3]||fe[4]||fe[5]||fe[6],!!Le){if(Ve=Le.length,fe[3]||fe[4]){Ye+=Ve;continue}else if((fe[5]||fe[6])&&Ne%3&&!((Ne+Ve)%3)){et+=Ve;continue}if(Ye-=Ve,!(Ye>0)){if(Ye+et-Ve<=0&&!Y.slice(nt.lastIndex).match(nt)&&(Ve=Math.min(Ve,Ve+Ye+et)),Math.min(Ne,Ve)%2)return{type:"em",raw:j.slice(0,Ne+fe.index+Ve+1),text:j.slice(1,Ne+fe.index+Ve)};if(Math.min(Ne,Ve)%2==0)return{type:"strong",raw:j.slice(0,Ne+fe.index+Ve+1),text:j.slice(2,Ne+fe.index+Ve-1)}}}}}},ne.codespan=function(j){var Y=this.rules.inline.code.exec(j);if(Y){var ae=Y[2].replace(/\n/g," "),fe=/[^ ]/.test(ae),Ee=/^ /.test(ae)&&/ $/.test(ae);return fe&&Ee&&(ae=ae.substring(1,ae.length-1)),ae=x(ae,!0),{type:"codespan",raw:Y[0],text:ae}}},ne.br=function(j){var Y=this.rules.inline.br.exec(j);if(Y)return{type:"br",raw:Y[0]}},ne.del=function(j){var Y=this.rules.inline.del.exec(j);if(Y)return{type:"del",raw:Y[0],text:Y[2]}},ne.autolink=function(j,Y){var ae=this.rules.inline.autolink.exec(j);if(ae){var fe,Ee;return ae[2]==="@"?(fe=x(this.options.mangle?Y(ae[1]):ae[1]),Ee="mailto:"+fe):(fe=x(ae[1]),Ee=fe),{type:"link",raw:ae[0],text:fe,href:Ee,tokens:[{type:"text",raw:fe,text:fe}]}}},ne.url=function(j,Y){var ae;if(ae=this.rules.inline.url.exec(j)){var fe,Ee;if(ae[2]==="@")fe=x(this.options.mangle?Y(ae[0]):ae[0]),Ee="mailto:"+fe;else{var Ne;do Ne=ae[0],ae[0]=this.rules.inline._backpedal.exec(ae[0])[0];while(Ne!==ae[0]);fe=x(ae[0]),ae[1]==="www."?Ee="http://"+fe:Ee=fe}return{type:"link",raw:ae[0],text:fe,href:Ee,tokens:[{type:"text",raw:fe,text:fe}]}}},ne.inlineText=function(j,Y,ae){var fe=this.rules.inline.text.exec(j);if(fe){var Ee;return Y?Ee=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):x(fe[0]):fe[0]:Ee=x(this.options.smartypants?ae(fe[0]):fe[0]),{type:"text",raw:fe[0],text:Ee}}},H}(),Q=F.noopTest,W=F.edit,ee=F.merge,re={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:Q,table:Q,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};re._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,re._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,re.def=W(re.def).replace("label",re._label).replace("title",re._title).getRegex(),re.bullet=/(?:[*+-]|\d{1,9}[.)])/,re.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,re.item=W(re.item,"gm").replace(/bull/g,re.bullet).getRegex(),re.listItemStart=W(/^( *)(bull)/).replace("bull",re.bullet).getRegex(),re.list=W(re.list).replace(/bull/g,re.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+re.def.source+")").getRegex(),re._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",re._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,re.html=W(re.html,"i").replace("comment",re._comment).replace("tag",re._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),re.paragraph=W(re._paragraph).replace("hr",re.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",re._tag).getRegex(),re.blockquote=W(re.blockquote).replace("paragraph",re.paragraph).getRegex(),re.normal=ee({},re),re.gfm=ee({},re.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),re.gfm.nptable=W(re.gfm.nptable).replace("hr",re.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",re._tag).getRegex(),re.gfm.table=W(re.gfm.table).replace("hr",re.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",re._tag).getRegex(),re.pedantic=ee({},re.normal,{html:W(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",re._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:Q,paragraph:W(re.normal._paragraph).replace("hr",re.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",re.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var oe={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:Q,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:Q,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};oe._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",oe.punctuation=W(oe.punctuation).replace(/punctuation/g,oe._punctuation).getRegex(),oe.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,oe.escapedEmSt=/\\\*|\\_/g,oe._comment=W(re._comment).replace("(?:-->|$)","-->").getRegex(),oe.emStrong.lDelim=W(oe.emStrong.lDelim).replace(/punct/g,oe._punctuation).getRegex(),oe.emStrong.rDelimAst=W(oe.emStrong.rDelimAst,"g").replace(/punct/g,oe._punctuation).getRegex(),oe.emStrong.rDelimUnd=W(oe.emStrong.rDelimUnd,"g").replace(/punct/g,oe._punctuation).getRegex(),oe._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,oe._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,oe._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,oe.autolink=W(oe.autolink).replace("scheme",oe._scheme).replace("email",oe._email).getRegex(),oe._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,oe.tag=W(oe.tag).replace("comment",oe._comment).replace("attribute",oe._attribute).getRegex(),oe._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,oe._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,oe._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,oe.link=W(oe.link).replace("label",oe._label).replace("href",oe._href).replace("title",oe._title).getRegex(),oe.reflink=W(oe.reflink).replace("label",oe._label).getRegex(),oe.reflinkSearch=W(oe.reflinkSearch,"g").replace("reflink",oe.reflink).replace("nolink",oe.nolink).getRegex(),oe.normal=ee({},oe),oe.pedantic=ee({},oe.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:W(/^!?\[(label)\]\((.*?)\)/).replace("label",oe._label).getRegex(),reflink:W(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",oe._label).getRegex()}),oe.gfm=ee({},oe.normal,{escape:W(oe.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),oe.gfm.url=W(oe.gfm.url,"i").replace("email",oe.gfm._extended_email).getRegex(),oe.breaks=ee({},oe.gfm,{br:W(oe.br).replace("{2,}","*").getRegex(),text:W(oe.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var Se={block:re,inline:oe},Pe=S.defaults,$e=Se.block,Fe=Se.inline,ze=F.repeatString;function U(H){return H.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function K(H){var ne="",de,j,Y=H.length;for(de=0;de<Y;de++)j=H.charCodeAt(de),Math.random()>.5&&(j="x"+j.toString(16)),ne+="&#"+j+";";return ne}var te=function(){function H(de){this.tokens=[],this.tokens.links=Object.create(null),this.options=de||Pe,this.options.tokenizer=this.options.tokenizer||new B,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var j={block:$e.normal,inline:Fe.normal};this.options.pedantic?(j.block=$e.pedantic,j.inline=Fe.pedantic):this.options.gfm&&(j.block=$e.gfm,this.options.breaks?j.inline=Fe.breaks:j.inline=Fe.gfm),this.tokenizer.rules=j}H.lex=function(j,Y){var ae=new H(Y);return ae.lex(j)},H.lexInline=function(j,Y){var ae=new H(Y);return ae.inlineTokens(j)};var ne=H.prototype;return ne.lex=function(j){return j=j.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(j,this.tokens,!0),this.inline(this.tokens),this.tokens},ne.blockTokens=function(j,Y,ae){Y===void 0&&(Y=[]),ae===void 0&&(ae=!0),this.options.pedantic&&(j=j.replace(/^ +$/gm,""));for(var fe,Ee,Ne,Le;j;){if(fe=this.tokenizer.space(j)){j=j.substring(fe.raw.length),fe.type&&Y.push(fe);continue}if(fe=this.tokenizer.code(j)){j=j.substring(fe.raw.length),Le=Y[Y.length-1],Le&&Le.type==="paragraph"?(Le.raw+=`
`+fe.raw,Le.text+=`
`+fe.text):Y.push(fe);continue}if(fe=this.tokenizer.fences(j)){j=j.substring(fe.raw.length),Y.push(fe);continue}if(fe=this.tokenizer.heading(j)){j=j.substring(fe.raw.length),Y.push(fe);continue}if(fe=this.tokenizer.nptable(j)){j=j.substring(fe.raw.length),Y.push(fe);continue}if(fe=this.tokenizer.hr(j)){j=j.substring(fe.raw.length),Y.push(fe);continue}if(fe=this.tokenizer.blockquote(j)){j=j.substring(fe.raw.length),fe.tokens=this.blockTokens(fe.text,[],ae),Y.push(fe);continue}if(fe=this.tokenizer.list(j)){for(j=j.substring(fe.raw.length),Ne=fe.items.length,Ee=0;Ee<Ne;Ee++)fe.items[Ee].tokens=this.blockTokens(fe.items[Ee].text,[],!1);Y.push(fe);continue}if(fe=this.tokenizer.html(j)){j=j.substring(fe.raw.length),Y.push(fe);continue}if(ae&&(fe=this.tokenizer.def(j))){j=j.substring(fe.raw.length),this.tokens.links[fe.tag]||(this.tokens.links[fe.tag]={href:fe.href,title:fe.title});continue}if(fe=this.tokenizer.table(j)){j=j.substring(fe.raw.length),Y.push(fe);continue}if(fe=this.tokenizer.lheading(j)){j=j.substring(fe.raw.length),Y.push(fe);continue}if(ae&&(fe=this.tokenizer.paragraph(j))){j=j.substring(fe.raw.length),Y.push(fe);continue}if(fe=this.tokenizer.text(j)){j=j.substring(fe.raw.length),Le=Y[Y.length-1],Le&&Le.type==="text"?(Le.raw+=`
`+fe.raw,Le.text+=`
`+fe.text):Y.push(fe);continue}if(j){var Ve="Infinite loop on byte: "+j.charCodeAt(0);if(this.options.silent){console.error(Ve);break}else throw new Error(Ve)}}return Y},ne.inline=function(j){var Y,ae,fe,Ee,Ne,Le,Ve=j.length;for(Y=0;Y<Ve;Y++)switch(Le=j[Y],Le.type){case"paragraph":case"text":case"heading":{Le.tokens=[],this.inlineTokens(Le.text,Le.tokens);break}case"table":{for(Le.tokens={header:[],cells:[]},Ee=Le.header.length,ae=0;ae<Ee;ae++)Le.tokens.header[ae]=[],this.inlineTokens(Le.header[ae],Le.tokens.header[ae]);for(Ee=Le.cells.length,ae=0;ae<Ee;ae++)for(Ne=Le.cells[ae],Le.tokens.cells[ae]=[],fe=0;fe<Ne.length;fe++)Le.tokens.cells[ae][fe]=[],this.inlineTokens(Ne[fe],Le.tokens.cells[ae][fe]);break}case"blockquote":{this.inline(Le.tokens);break}case"list":{for(Ee=Le.items.length,ae=0;ae<Ee;ae++)this.inline(Le.items[ae].tokens);break}}return j},ne.inlineTokens=function(j,Y,ae,fe){Y===void 0&&(Y=[]),ae===void 0&&(ae=!1),fe===void 0&&(fe=!1);var Ee,Ne,Le=j,Ve,Ye,et;if(this.tokens.links){var nt=Object.keys(this.tokens.links);if(nt.length>0)for(;(Ve=this.tokenizer.rules.inline.reflinkSearch.exec(Le))!=null;)nt.includes(Ve[0].slice(Ve[0].lastIndexOf("[")+1,-1))&&(Le=Le.slice(0,Ve.index)+"["+ze("a",Ve[0].length-2)+"]"+Le.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ve=this.tokenizer.rules.inline.blockSkip.exec(Le))!=null;)Le=Le.slice(0,Ve.index)+"["+ze("a",Ve[0].length-2)+"]"+Le.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ve=this.tokenizer.rules.inline.escapedEmSt.exec(Le))!=null;)Le=Le.slice(0,Ve.index)+"++"+Le.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;j;){if(Ye||(et=""),Ye=!1,Ee=this.tokenizer.escape(j)){j=j.substring(Ee.raw.length),Y.push(Ee);continue}if(Ee=this.tokenizer.tag(j,ae,fe)){j=j.substring(Ee.raw.length),ae=Ee.inLink,fe=Ee.inRawBlock;var st=Y[Y.length-1];st&&Ee.type==="text"&&st.type==="text"?(st.raw+=Ee.raw,st.text+=Ee.text):Y.push(Ee);continue}if(Ee=this.tokenizer.link(j)){j=j.substring(Ee.raw.length),Ee.type==="link"&&(Ee.tokens=this.inlineTokens(Ee.text,[],!0,fe)),Y.push(Ee);continue}if(Ee=this.tokenizer.reflink(j,this.tokens.links)){j=j.substring(Ee.raw.length);var it=Y[Y.length-1];Ee.type==="link"?(Ee.tokens=this.inlineTokens(Ee.text,[],!0,fe),Y.push(Ee)):it&&Ee.type==="text"&&it.type==="text"?(it.raw+=Ee.raw,it.text+=Ee.text):Y.push(Ee);continue}if(Ee=this.tokenizer.emStrong(j,Le,et)){j=j.substring(Ee.raw.length),Ee.tokens=this.inlineTokens(Ee.text,[],ae,fe),Y.push(Ee);continue}if(Ee=this.tokenizer.codespan(j)){j=j.substring(Ee.raw.length),Y.push(Ee);continue}if(Ee=this.tokenizer.br(j)){j=j.substring(Ee.raw.length),Y.push(Ee);continue}if(Ee=this.tokenizer.del(j)){j=j.substring(Ee.raw.length),Ee.tokens=this.inlineTokens(Ee.text,[],ae,fe),Y.push(Ee);continue}if(Ee=this.tokenizer.autolink(j,K)){j=j.substring(Ee.raw.length),Y.push(Ee);continue}if(!ae&&(Ee=this.tokenizer.url(j,K))){j=j.substring(Ee.raw.length),Y.push(Ee);continue}if(Ee=this.tokenizer.inlineText(j,fe,U)){j=j.substring(Ee.raw.length),Ee.raw.slice(-1)!=="_"&&(et=Ee.raw.slice(-1)),Ye=!0,Ne=Y[Y.length-1],Ne&&Ne.type==="text"?(Ne.raw+=Ee.raw,Ne.text+=Ee.text):Y.push(Ee);continue}if(j){var ve="Infinite loop on byte: "+j.charCodeAt(0);if(this.options.silent){console.error(ve);break}else throw new Error(ve)}}return Y},e(H,null,[{key:"rules",get:function(){return{block:$e,inline:Fe}}}]),H}(),le=S.defaults,me=F.cleanUrl,De=F.escape,Oe=function(){function H(de){this.options=de||le}var ne=H.prototype;return ne.code=function(j,Y,ae){var fe=(Y||"").match(/\S*/)[0];if(this.options.highlight){var Ee=this.options.highlight(j,fe);Ee!=null&&Ee!==j&&(ae=!0,j=Ee)}return j=j.replace(/\n$/,"")+`
`,fe?'<pre><code class="'+this.options.langPrefix+De(fe,!0)+'">'+(ae?j:De(j,!0))+`</code></pre>
`:"<pre><code>"+(ae?j:De(j,!0))+`</code></pre>
`},ne.blockquote=function(j){return`<blockquote>
`+j+`</blockquote>
`},ne.html=function(j){return j},ne.heading=function(j,Y,ae,fe){return this.options.headerIds?"<h"+Y+' id="'+this.options.headerPrefix+fe.slug(ae)+'">'+j+"</h"+Y+`>
`:"<h"+Y+">"+j+"</h"+Y+`>
`},ne.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ne.list=function(j,Y,ae){var fe=Y?"ol":"ul",Ee=Y&&ae!==1?' start="'+ae+'"':"";return"<"+fe+Ee+`>
`+j+"</"+fe+`>
`},ne.listitem=function(j){return"<li>"+j+`</li>
`},ne.checkbox=function(j){return"<input "+(j?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ne.paragraph=function(j){return"<p>"+j+`</p>
`},ne.table=function(j,Y){return Y&&(Y="<tbody>"+Y+"</tbody>"),`<table>
<thead>
`+j+`</thead>
`+Y+`</table>
`},ne.tablerow=function(j){return`<tr>
`+j+`</tr>
`},ne.tablecell=function(j,Y){var ae=Y.header?"th":"td",fe=Y.align?"<"+ae+' align="'+Y.align+'">':"<"+ae+">";return fe+j+"</"+ae+`>
`},ne.strong=function(j){return"<strong>"+j+"</strong>"},ne.em=function(j){return"<em>"+j+"</em>"},ne.codespan=function(j){return"<code>"+j+"</code>"},ne.br=function(){return this.options.xhtml?"<br/>":"<br>"},ne.del=function(j){return"<del>"+j+"</del>"},ne.link=function(j,Y,ae){if(j=me(this.options.sanitize,this.options.baseUrl,j),j===null)return ae;var fe='<a href="'+De(j)+'"';return Y&&(fe+=' title="'+Y+'"'),fe+=">"+ae+"</a>",fe},ne.image=function(j,Y,ae){if(j=me(this.options.sanitize,this.options.baseUrl,j),j===null)return ae;var fe='<img src="'+j+'" alt="'+ae+'"';return Y&&(fe+=' title="'+Y+'"'),fe+=this.options.xhtml?"/>":">",fe},ne.text=function(j){return j},H}(),ge=function(){function H(){}var ne=H.prototype;return ne.strong=function(j){return j},ne.em=function(j){return j},ne.codespan=function(j){return j},ne.del=function(j){return j},ne.html=function(j){return j},ne.text=function(j){return j},ne.link=function(j,Y,ae){return""+ae},ne.image=function(j,Y,ae){return""+ae},ne.br=function(){return""},H}(),Ce=function(){function H(){this.seen={}}var ne=H.prototype;return ne.serialize=function(j){return j.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ne.getNextSafeSlug=function(j,Y){var ae=j,fe=0;if(this.seen.hasOwnProperty(ae)){fe=this.seen[j];do fe++,ae=j+"-"+fe;while(this.seen.hasOwnProperty(ae))}return Y||(this.seen[j]=fe,this.seen[ae]=0),ae},ne.slug=function(j,Y){Y===void 0&&(Y={});var ae=this.serialize(j);return this.getNextSafeSlug(ae,Y.dryrun)},H}(),Ae=S.defaults,We=F.unescape,be=function(){function H(de){this.options=de||Ae,this.options.renderer=this.options.renderer||new Oe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ge,this.slugger=new Ce}H.parse=function(j,Y){var ae=new H(Y);return ae.parse(j)},H.parseInline=function(j,Y){var ae=new H(Y);return ae.parseInline(j)};var ne=H.prototype;return ne.parse=function(j,Y){Y===void 0&&(Y=!0);var ae="",fe,Ee,Ne,Le,Ve,Ye,et,nt,st,it,ve,he,ue,q,Ie,Te,Qe,Ge,rt=j.length;for(fe=0;fe<rt;fe++)switch(it=j[fe],it.type){case"space":continue;case"hr":{ae+=this.renderer.hr();continue}case"heading":{ae+=this.renderer.heading(this.parseInline(it.tokens),it.depth,We(this.parseInline(it.tokens,this.textRenderer)),this.slugger);continue}case"code":{ae+=this.renderer.code(it.text,it.lang,it.escaped);continue}case"table":{for(nt="",et="",Le=it.header.length,Ee=0;Ee<Le;Ee++)et+=this.renderer.tablecell(this.parseInline(it.tokens.header[Ee]),{header:!0,align:it.align[Ee]});for(nt+=this.renderer.tablerow(et),st="",Le=it.cells.length,Ee=0;Ee<Le;Ee++){for(Ye=it.tokens.cells[Ee],et="",Ve=Ye.length,Ne=0;Ne<Ve;Ne++)et+=this.renderer.tablecell(this.parseInline(Ye[Ne]),{header:!1,align:it.align[Ne]});st+=this.renderer.tablerow(et)}ae+=this.renderer.table(nt,st);continue}case"blockquote":{st=this.parse(it.tokens),ae+=this.renderer.blockquote(st);continue}case"list":{for(ve=it.ordered,he=it.start,ue=it.loose,Le=it.items.length,st="",Ee=0;Ee<Le;Ee++)Ie=it.items[Ee],Te=Ie.checked,Qe=Ie.task,q="",Ie.task&&(Ge=this.renderer.checkbox(Te),ue?Ie.tokens.length>0&&Ie.tokens[0].type==="text"?(Ie.tokens[0].text=Ge+" "+Ie.tokens[0].text,Ie.tokens[0].tokens&&Ie.tokens[0].tokens.length>0&&Ie.tokens[0].tokens[0].type==="text"&&(Ie.tokens[0].tokens[0].text=Ge+" "+Ie.tokens[0].tokens[0].text)):Ie.tokens.unshift({type:"text",text:Ge}):q+=Ge),q+=this.parse(Ie.tokens,ue),st+=this.renderer.listitem(q,Qe,Te);ae+=this.renderer.list(st,ve,he);continue}case"html":{ae+=this.renderer.html(it.text);continue}case"paragraph":{ae+=this.renderer.paragraph(this.parseInline(it.tokens));continue}case"text":{for(st=it.tokens?this.parseInline(it.tokens):it.text;fe+1<rt&&j[fe+1].type==="text";)it=j[++fe],st+=`
`+(it.tokens?this.parseInline(it.tokens):it.text);ae+=Y?this.renderer.paragraph(st):st;continue}default:{var ct='Token with "'+it.type+'" type was not found.';if(this.options.silent){console.error(ct);return}else throw new Error(ct)}}return ae},ne.parseInline=function(j,Y){Y=Y||this.renderer;var ae="",fe,Ee,Ne=j.length;for(fe=0;fe<Ne;fe++)switch(Ee=j[fe],Ee.type){case"escape":{ae+=Y.text(Ee.text);break}case"html":{ae+=Y.html(Ee.text);break}case"link":{ae+=Y.link(Ee.href,Ee.title,this.parseInline(Ee.tokens,Y));break}case"image":{ae+=Y.image(Ee.href,Ee.title,Ee.text);break}case"strong":{ae+=Y.strong(this.parseInline(Ee.tokens,Y));break}case"em":{ae+=Y.em(this.parseInline(Ee.tokens,Y));break}case"codespan":{ae+=Y.codespan(Ee.text);break}case"br":{ae+=Y.br();break}case"del":{ae+=Y.del(this.parseInline(Ee.tokens,Y));break}case"text":{ae+=Y.text(Ee.text);break}default:{var Le='Token with "'+Ee.type+'" type was not found.';if(this.options.silent){console.error(Le);return}else throw new Error(Le)}}return ae},H}(),qe=F.merge,V=F.checkSanitizeDeprecation,Z=F.escape,pe=S.getDefaults,Me=S.changeDefaults,He=S.defaults;function Ue(H,ne,de){if(typeof H=="undefined"||H===null)throw new Error("marked(): input parameter is undefined or null");if(typeof H!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(H)+", string expected");if(typeof ne=="function"&&(de=ne,ne=null),ne=qe({},Ue.defaults,ne||{}),V(ne),de){var j=ne.highlight,Y;try{Y=te.lex(H,ne)}catch(Ne){return de(Ne)}var ae=function(Le){var Ve;if(!Le)try{Ve=be.parse(Y,ne)}catch(Ye){Le=Ye}return ne.highlight=j,Le?de(Le):de(null,Ve)};if(!j||j.length<3||(delete ne.highlight,!Y.length))return ae();var fe=0;Ue.walkTokens(Y,function(Ne){Ne.type==="code"&&(fe++,setTimeout(function(){j(Ne.text,Ne.lang,function(Le,Ve){if(Le)return ae(Le);Ve!=null&&Ve!==Ne.text&&(Ne.text=Ve,Ne.escaped=!0),fe--,fe===0&&ae()})},0))}),fe===0&&ae();return}try{var Ee=te.lex(H,ne);return ne.walkTokens&&Ue.walkTokens(Ee,ne.walkTokens),be.parse(Ee,ne)}catch(Ne){if(Ne.message+=`
Please report this to https://github.com/markedjs/marked.`,ne.silent)return"<p>An error occurred:</p><pre>"+Z(Ne.message+"",!0)+"</pre>";throw Ne}}Ue.options=Ue.setOptions=function(H){return qe(Ue.defaults,H),Me(Ue.defaults),Ue},Ue.getDefaults=pe,Ue.defaults=He,Ue.use=function(H){var ne=qe({},H);if(H.renderer&&function(){var j=Ue.defaults.renderer||new Oe,Y=function(Ee){var Ne=j[Ee];j[Ee]=function(){for(var Le=arguments.length,Ve=new Array(Le),Ye=0;Ye<Le;Ye++)Ve[Ye]=arguments[Ye];var et=H.renderer[Ee].apply(j,Ve);return et===!1&&(et=Ne.apply(j,Ve)),et}};for(var ae in H.renderer)Y(ae);ne.renderer=j}(),H.tokenizer&&function(){var j=Ue.defaults.tokenizer||new B,Y=function(Ee){var Ne=j[Ee];j[Ee]=function(){for(var Le=arguments.length,Ve=new Array(Le),Ye=0;Ye<Le;Ye++)Ve[Ye]=arguments[Ye];var et=H.tokenizer[Ee].apply(j,Ve);return et===!1&&(et=Ne.apply(j,Ve)),et}};for(var ae in H.tokenizer)Y(ae);ne.tokenizer=j}(),H.walkTokens){var de=Ue.defaults.walkTokens;ne.walkTokens=function(j){H.walkTokens(j),de&&de(j)}}Ue.setOptions(ne)},Ue.walkTokens=function(H,ne){for(var de=P(H),j;!(j=de()).done;){var Y=j.value;switch(ne(Y),Y.type){case"table":{for(var ae=P(Y.tokens.header),fe;!(fe=ae()).done;){var Ee=fe.value;Ue.walkTokens(Ee,ne)}for(var Ne=P(Y.tokens.cells),Le;!(Le=Ne()).done;)for(var Ve=Le.value,Ye=P(Ve),et;!(et=Ye()).done;){var nt=et.value;Ue.walkTokens(nt,ne)}break}case"list":{Ue.walkTokens(Y.items,ne);break}default:Y.tokens&&Ue.walkTokens(Y.tokens,ne)}}},Ue.parseInline=function(H,ne){if(typeof H=="undefined"||H===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof H!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(H)+", string expected");ne=qe({},Ue.defaults,ne||{}),V(ne);try{var de=te.lexInline(H,ne);return ne.walkTokens&&Ue.walkTokens(de,ne.walkTokens),be.parseInline(de,ne)}catch(j){if(j.message+=`
Please report this to https://github.com/markedjs/marked.`,ne.silent)return"<p>An error occurred:</p><pre>"+Z(j.message+"",!0)+"</pre>";throw j}},Ue.Parser=be,Ue.parser=be.parse,Ue.Renderer=Oe,Ue.TextRenderer=ge,Ue.Lexer=te,Ue.lexer=te.lex,Ue.Tokenizer=B,Ue.Slugger=Ce,Ue.parse=Ue;var Ze=Ue;return Ze}),define(_e[78],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function E(S,C,y){return Math.min(Math.max(S,C),y)}e.clamp=E;function I(S,C){return(C+S%C)%C}e.rot=I;class P{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=P;class A{constructor(){this._n=1,this._val=0}update(C){return this._val=this._val+(C-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=A});"use strict";(function(){function ie(P){const A=[];typeof P=="number"&&A.push("code/timeOrigin",P);function S(y){A.push(y,Date.now())}function C(){const y=[];for(let n=0;n<A.length;n+=2)y.push({name:A[n],startTime:A[n+1]});return y}return{mark:S,getMarks:C}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?ie():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const S of performance.getEntriesByType("mark"))A.push({name:S.name,startTime:Math.round(P+S.startTime)});return A}};if(typeof process=="object"){const P=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return ie(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),ie()}function E(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var I;typeof global=="object"?I=global:typeof self=="object"?I=self:I={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(I)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(I):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),I.perf=E(I))})(),define(_e[21],we([0,1]),function(ie,e){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const I="en";let P=!1,A=!1,S=!1,C=!1,y=!1,n=!1,T=!1,k,g=I,m,i;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let s;typeof e.globals.vscode!="undefined"?s=e.globals.vscode.process:typeof process!="undefined"&&(s=process);const _=typeof((E=s==null?void 0:s.versions)===null||E===void 0?void 0:E.electron)=="string"&&s.type==="renderer";if(e.isElectronSandboxed=_&&(s==null?void 0:s.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const o=s==null?void 0:s.env.VSCODE_BROWSER_CODE_LOADING;if(typeof o=="string")return o==="none"||o==="code"||o==="bypassHeatCheck"||o==="bypassHeatCheckAndEagerCompile"?o:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!_)i=navigator.userAgent,P=i.indexOf("Windows")>=0,A=i.indexOf("Macintosh")>=0,T=(i.indexOf("Macintosh")>=0||i.indexOf("iPad")>=0||i.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,S=i.indexOf("Linux")>=0,n=!0,k=navigator.language,g=k;else if(typeof s=="object"){P=s.platform==="win32",A=s.platform==="darwin",S=s.platform==="linux",C=S&&!!s.env.SNAP&&!!s.env.SNAP_REVISION,k=I,g=I;const o=s.env.VSCODE_NLS_CONFIG;if(o)try{const a=JSON.parse(o),f=a.availableLanguages["*"];k=a.locale,g=f||I,m=a._translationsConfigFile}catch(a){}y=!0}else console.error("Unable to resolve platform.");var d;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(d=e.Platform||(e.Platform={}));function b(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=b;let v=0;A?v=1:P?v=3:S&&(v=2),e.isWindows=P,e.isMacintosh=A,e.isLinux=S,e.isLinuxSnap=C,e.isNative=y,e.isWeb=n,e.isIOS=T,e.platform=v,e.userAgent=i,e.language=g;var l;(function(o){function a(){return e.language}o.value=a;function f(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=f;function w(){return e.language==="en"}o.isDefault=w})(l=e.Language||(e.Language={})),e.locale=k,e.translationsConfigFile=m,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let f=[];e.globals.addEventListener("message",D=>{if(D.data&&D.data.vscodeSetImmediateId)for(let p=0,h=f.length;p<h;p++){const R=f[p];if(R.id===D.data.vscodeSetImmediateId){f.splice(p,1),R.callback();return}}});let w=0;return D=>{const p=++w;f.push({id:p,callback:D}),e.globals.postMessage({vscodeSetImmediateId:p},"*")}}if(typeof(s==null?void 0:s.nextTick)=="function")return s.nextTick.bind(s);const a=Promise.resolve();return f=>a.then(f)}();var u;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(u=e.OperatingSystem||(e.OperatingSystem={})),e.OS=A||T?2:P?1:3;let t=!0,r=!1;function c(){if(!r){r=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,t=new Uint16Array(o.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=c}),define(_e[45],we([0,1,21]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let I;if(typeof E.globals.vscode!="undefined"){const P=E.globals.vscode.process;I={get platform(){return P.platform},get env(){return P.env},cwd(){return P.cwd()},nextTick(A){return(0,E.setImmediate)(A)}}}else typeof process!="undefined"?I={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(P){return process.nextTick(P)}}:I={get platform(){return E.isWindows?"win32":E.isMacintosh?"darwin":"linux"},nextTick(P){return(0,E.setImmediate)(P)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=I.cwd,e.env=I.env,e.platform=I.platform,e.nextTick=I.nextTick}),define(_e[12],we([0,1,45]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const I=65,P=97,A=90,S=122,C=46,y=47,n=92,T=58,k=63;class g extends Error{constructor(l,u,t){let r;typeof u=="string"&&u.indexOf("not ")===0?(r="must not be",u=u.replace(/^not /,"")):r="must be";const c=l.indexOf(".")!==-1?"property":"argument";let o=`The "${l}" ${c} ${r} of type ${u}`;o+=`. Received type ${typeof t}`,super(o),this.code="ERR_INVALID_ARG_TYPE"}}function m(v,l){if(typeof v!="string")throw new g(l,"string",v)}function i(v){return v===y||v===n}function s(v){return v===y}function _(v){return v>=I&&v<=A||v>=P&&v<=S}function d(v,l,u,t){let r="",c=0,o=-1,a=0,f=0;for(let w=0;w<=v.length;++w){if(w<v.length)f=v.charCodeAt(w);else{if(t(f))break;f=y}if(t(f)){if(!(o===w-1||a===1))if(a===2){if(r.length<2||c!==2||r.charCodeAt(r.length-1)!==C||r.charCodeAt(r.length-2)!==C){if(r.length>2){const D=r.lastIndexOf(u);D===-1?(r="",c=0):(r=r.slice(0,D),c=r.length-1-r.lastIndexOf(u)),o=w,a=0;continue}else if(r.length!==0){r="",c=0,o=w,a=0;continue}}l&&(r+=r.length>0?`${u}..`:"..",c=2)}else r.length>0?r+=`${u}${v.slice(o+1,w)}`:r=v.slice(o+1,w),c=w-o-1;o=w,a=0}else f===C&&a!==-1?++a:a=-1}return r}function b(v,l){if(l===null||typeof l!="object")throw new g("pathObject","Object",l);const u=l.dir||l.root,t=l.base||`${l.name||""}${l.ext||""}`;return u?u===l.root?`${u}${t}`:`${u}${v}${t}`:t}e.win32={resolve(...v){let l="",u="",t=!1;for(let r=v.length-1;r>=-1;r--){let c;if(r>=0){if(c=v[r],m(c,"path"),c.length===0)continue}else l.length===0?c=E.cwd():(c=E.env[`=${l}`]||E.cwd(),(c===void 0||c.slice(0,2).toLowerCase()!==l.toLowerCase()&&c.charCodeAt(2)===n)&&(c=`${l}\\`));const o=c.length;let a=0,f="",w=!1;const D=c.charCodeAt(0);if(o===1)i(D)&&(a=1,w=!0);else if(i(D))if(w=!0,i(c.charCodeAt(1))){let p=2,h=p;for(;p<o&&!i(c.charCodeAt(p));)p++;if(p<o&&p!==h){const R=c.slice(h,p);for(h=p;p<o&&i(c.charCodeAt(p));)p++;if(p<o&&p!==h){for(h=p;p<o&&!i(c.charCodeAt(p));)p++;(p===o||p!==h)&&(f=`\\\\${R}\\${c.slice(h,p)}`,a=p)}}}else a=1;else _(D)&&c.charCodeAt(1)===T&&(f=c.slice(0,2),a=2,o>2&&i(c.charCodeAt(2))&&(w=!0,a=3));if(f.length>0)if(l.length>0){if(f.toLowerCase()!==l.toLowerCase())continue}else l=f;if(t){if(l.length>0)break}else if(u=`${c.slice(a)}\\${u}`,t=w,w&&l.length>0)break}return u=d(u,!t,"\\",i),t?`${l}\\${u}`:`${l}${u}`||"."},normalize(v){m(v,"path");const l=v.length;if(l===0)return".";let u=0,t,r=!1;const c=v.charCodeAt(0);if(l===1)return s(c)?"\\":v;if(i(c))if(r=!0,i(v.charCodeAt(1))){let a=2,f=a;for(;a<l&&!i(v.charCodeAt(a));)a++;if(a<l&&a!==f){const w=v.slice(f,a);for(f=a;a<l&&i(v.charCodeAt(a));)a++;if(a<l&&a!==f){for(f=a;a<l&&!i(v.charCodeAt(a));)a++;if(a===l)return`\\\\${w}\\${v.slice(f)}\\`;a!==f&&(t=`\\\\${w}\\${v.slice(f,a)}`,u=a)}}}else u=1;else _(c)&&v.charCodeAt(1)===T&&(t=v.slice(0,2),u=2,l>2&&i(v.charCodeAt(2))&&(r=!0,u=3));let o=u<l?d(v.slice(u),!r,"\\",i):"";return o.length===0&&!r&&(o="."),o.length>0&&i(v.charCodeAt(l-1))&&(o+="\\"),t===void 0?r?`\\${o}`:o:r?`${t}\\${o}`:`${t}${o}`},isAbsolute(v){m(v,"path");const l=v.length;if(l===0)return!1;const u=v.charCodeAt(0);return i(u)||l>2&&_(u)&&v.charCodeAt(1)===T&&i(v.charCodeAt(2))},join(...v){if(v.length===0)return".";let l,u;for(let c=0;c<v.length;++c){const o=v[c];m(o,"path"),o.length>0&&(l===void 0?l=u=o:l+=`\\${o}`)}if(l===void 0)return".";let t=!0,r=0;if(typeof u=="string"&&i(u.charCodeAt(0))){++r;const c=u.length;c>1&&i(u.charCodeAt(1))&&(++r,c>2&&(i(u.charCodeAt(2))?++r:t=!1))}if(t){for(;r<l.length&&i(l.charCodeAt(r));)r++;r>=2&&(l=`\\${l.slice(r)}`)}return e.win32.normalize(l)},relative(v,l){if(m(v,"from"),m(l,"to"),v===l)return"";const u=e.win32.resolve(v),t=e.win32.resolve(l);if(u===t||(v=u.toLowerCase(),l=t.toLowerCase(),v===l))return"";let r=0;for(;r<v.length&&v.charCodeAt(r)===n;)r++;let c=v.length;for(;c-1>r&&v.charCodeAt(c-1)===n;)c--;const o=c-r;let a=0;for(;a<l.length&&l.charCodeAt(a)===n;)a++;let f=l.length;for(;f-1>a&&l.charCodeAt(f-1)===n;)f--;const w=f-a,D=o<w?o:w;let p=-1,h=0;for(;h<D;h++){const F=v.charCodeAt(r+h);if(F!==l.charCodeAt(a+h))break;F===n&&(p=h)}if(h!==D){if(p===-1)return t}else{if(w>D){if(l.charCodeAt(a+h)===n)return t.slice(a+h+1);if(h===2)return t.slice(a+h)}o>D&&(v.charCodeAt(r+h)===n?p=h:h===2&&(p=3)),p===-1&&(p=0)}let R="";for(h=r+p+1;h<=c;++h)(h===c||v.charCodeAt(h)===n)&&(R+=R.length===0?"..":"\\..");return a+=p,R.length>0?`${R}${t.slice(a,f)}`:(t.charCodeAt(a)===n&&++a,t.slice(a,f))},toNamespacedPath(v){if(typeof v!="string")return v;if(v.length===0)return"";const l=e.win32.resolve(v);if(l.length<=2)return v;if(l.charCodeAt(0)===n){if(l.charCodeAt(1)===n){const u=l.charCodeAt(2);if(u!==k&&u!==C)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(_(l.charCodeAt(0))&&l.charCodeAt(1)===T&&l.charCodeAt(2)===n)return`\\\\?\\${l}`;return v},dirname(v){m(v,"path");const l=v.length;if(l===0)return".";let u=-1,t=0;const r=v.charCodeAt(0);if(l===1)return i(r)?v:".";if(i(r)){if(u=t=1,i(v.charCodeAt(1))){let a=2,f=a;for(;a<l&&!i(v.charCodeAt(a));)a++;if(a<l&&a!==f){for(f=a;a<l&&i(v.charCodeAt(a));)a++;if(a<l&&a!==f){for(f=a;a<l&&!i(v.charCodeAt(a));)a++;if(a===l)return v;a!==f&&(u=t=a+1)}}}}else _(r)&&v.charCodeAt(1)===T&&(u=l>2&&i(v.charCodeAt(2))?3:2,t=u);let c=-1,o=!0;for(let a=l-1;a>=t;--a)if(i(v.charCodeAt(a))){if(!o){c=a;break}}else o=!1;if(c===-1){if(u===-1)return".";c=u}return v.slice(0,c)},basename(v,l){l!==void 0&&m(l,"ext"),m(v,"path");let u=0,t=-1,r=!0,c;if(v.length>=2&&_(v.charCodeAt(0))&&v.charCodeAt(1)===T&&(u=2),l!==void 0&&l.length>0&&l.length<=v.length){if(l===v)return"";let o=l.length-1,a=-1;for(c=v.length-1;c>=u;--c){const f=v.charCodeAt(c);if(i(f)){if(!r){u=c+1;break}}else a===-1&&(r=!1,a=c+1),o>=0&&(f===l.charCodeAt(o)?--o==-1&&(t=c):(o=-1,t=a))}return u===t?t=a:t===-1&&(t=v.length),v.slice(u,t)}for(c=v.length-1;c>=u;--c)if(i(v.charCodeAt(c))){if(!r){u=c+1;break}}else t===-1&&(r=!1,t=c+1);return t===-1?"":v.slice(u,t)},extname(v){m(v,"path");let l=0,u=-1,t=0,r=-1,c=!0,o=0;v.length>=2&&v.charCodeAt(1)===T&&_(v.charCodeAt(0))&&(l=t=2);for(let a=v.length-1;a>=l;--a){const f=v.charCodeAt(a);if(i(f)){if(!c){t=a+1;break}continue}r===-1&&(c=!1,r=a+1),f===C?u===-1?u=a:o!==1&&(o=1):u!==-1&&(o=-1)}return u===-1||r===-1||o===0||o===1&&u===r-1&&u===t+1?"":v.slice(u,r)},format:b.bind(null,"\\"),parse(v){m(v,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(v.length===0)return l;const u=v.length;let t=0,r=v.charCodeAt(0);if(u===1)return i(r)?(l.root=l.dir=v,l):(l.base=l.name=v,l);if(i(r)){if(t=1,i(v.charCodeAt(1))){let p=2,h=p;for(;p<u&&!i(v.charCodeAt(p));)p++;if(p<u&&p!==h){for(h=p;p<u&&i(v.charCodeAt(p));)p++;if(p<u&&p!==h){for(h=p;p<u&&!i(v.charCodeAt(p));)p++;p===u?t=p:p!==h&&(t=p+1)}}}}else if(_(r)&&v.charCodeAt(1)===T){if(u<=2)return l.root=l.dir=v,l;if(t=2,i(v.charCodeAt(2))){if(u===3)return l.root=l.dir=v,l;t=3}}t>0&&(l.root=v.slice(0,t));let c=-1,o=t,a=-1,f=!0,w=v.length-1,D=0;for(;w>=t;--w){if(r=v.charCodeAt(w),i(r)){if(!f){o=w+1;break}continue}a===-1&&(f=!1,a=w+1),r===C?c===-1?c=w:D!==1&&(D=1):c!==-1&&(D=-1)}return a!==-1&&(c===-1||D===0||D===1&&c===a-1&&c===o+1?l.base=l.name=v.slice(o,a):(l.name=v.slice(o,c),l.base=v.slice(o,a),l.ext=v.slice(c,a))),o>0&&o!==t?l.dir=v.slice(0,o-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...v){let l="",u=!1;for(let t=v.length-1;t>=-1&&!u;t--){const r=t>=0?v[t]:E.cwd();m(r,"path"),r.length!==0&&(l=`${r}/${l}`,u=r.charCodeAt(0)===y)}return l=d(l,!u,"/",s),u?`/${l}`:l.length>0?l:"."},normalize(v){if(m(v,"path"),v.length===0)return".";const l=v.charCodeAt(0)===y,u=v.charCodeAt(v.length-1)===y;return v=d(v,!l,"/",s),v.length===0?l?"/":u?"./":".":(u&&(v+="/"),l?`/${v}`:v)},isAbsolute(v){return m(v,"path"),v.length>0&&v.charCodeAt(0)===y},join(...v){if(v.length===0)return".";let l;for(let u=0;u<v.length;++u){const t=v[u];m(t,"path"),t.length>0&&(l===void 0?l=t:l+=`/${t}`)}return l===void 0?".":e.posix.normalize(l)},relative(v,l){if(m(v,"from"),m(l,"to"),v===l||(v=e.posix.resolve(v),l=e.posix.resolve(l),v===l))return"";const u=1,t=v.length,r=t-u,c=1,o=l.length-c,a=r<o?r:o;let f=-1,w=0;for(;w<a;w++){const p=v.charCodeAt(u+w);if(p!==l.charCodeAt(c+w))break;p===y&&(f=w)}if(w===a)if(o>a){if(l.charCodeAt(c+w)===y)return l.slice(c+w+1);if(w===0)return l.slice(c+w)}else r>a&&(v.charCodeAt(u+w)===y?f=w:w===0&&(f=0));let D="";for(w=u+f+1;w<=t;++w)(w===t||v.charCodeAt(w)===y)&&(D+=D.length===0?"..":"/..");return`${D}${l.slice(c+f)}`},toNamespacedPath(v){return v},dirname(v){if(m(v,"path"),v.length===0)return".";const l=v.charCodeAt(0)===y;let u=-1,t=!0;for(let r=v.length-1;r>=1;--r)if(v.charCodeAt(r)===y){if(!t){u=r;break}}else t=!1;return u===-1?l?"/":".":l&&u===1?"//":v.slice(0,u)},basename(v,l){l!==void 0&&m(l,"ext"),m(v,"path");let u=0,t=-1,r=!0,c;if(l!==void 0&&l.length>0&&l.length<=v.length){if(l===v)return"";let o=l.length-1,a=-1;for(c=v.length-1;c>=0;--c){const f=v.charCodeAt(c);if(f===y){if(!r){u=c+1;break}}else a===-1&&(r=!1,a=c+1),o>=0&&(f===l.charCodeAt(o)?--o==-1&&(t=c):(o=-1,t=a))}return u===t?t=a:t===-1&&(t=v.length),v.slice(u,t)}for(c=v.length-1;c>=0;--c)if(v.charCodeAt(c)===y){if(!r){u=c+1;break}}else t===-1&&(r=!1,t=c+1);return t===-1?"":v.slice(u,t)},extname(v){m(v,"path");let l=-1,u=0,t=-1,r=!0,c=0;for(let o=v.length-1;o>=0;--o){const a=v.charCodeAt(o);if(a===y){if(!r){u=o+1;break}continue}t===-1&&(r=!1,t=o+1),a===C?l===-1?l=o:c!==1&&(c=1):l!==-1&&(c=-1)}return l===-1||t===-1||c===0||c===1&&l===t-1&&l===u+1?"":v.slice(l,t)},format:b.bind(null,"/"),parse(v){m(v,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(v.length===0)return l;const u=v.charCodeAt(0)===y;let t;u?(l.root="/",t=1):t=0;let r=-1,c=0,o=-1,a=!0,f=v.length-1,w=0;for(;f>=t;--f){const D=v.charCodeAt(f);if(D===y){if(!a){c=f+1;break}continue}o===-1&&(a=!1,o=f+1),D===C?r===-1?r=f:w!==1&&(w=1):r!==-1&&(w=-1)}if(o!==-1){const D=c===0&&u?1:c;r===-1||w===0||w===1&&r===o-1&&r===c+1?l.base=l.name=v.slice(D,o):(l.name=v.slice(D,r),l.base=v.slice(D,o),l.ext=v.slice(r,o))}return c>0?l.dir=v.slice(0,c-1):u&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=E.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=E.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=E.platform==="win32"?e.win32.join:e.posix.join,e.resolve=E.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=E.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=E.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=E.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=E.platform==="win32"?e.win32.extname:e.posix.extname,e.format=E.platform==="win32"?e.win32.format:e.posix.format,e.parse=E.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=E.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=E.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=E.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(_e[55],we([0,1,21]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const I=E.globals.performance&&typeof E.globals.performance.now=="function";class P{constructor(S){this._highResolution=I&&S,this._startTime=this._now(),this._stopTime=-1}static create(S=!0){return new P(S)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?E.globals.performance.now():Date.now()}}e.StopWatch=P}),define(_e[3],we([0,1,10,52,6,44,55]),function(ie,e,E,I,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var C;(function(d){d.None=()=>P.Disposable.None;function b(z){return(x,G=null,M)=>{let N=!1,B;return B=z(Q=>{if(!N)return B?B.dispose():N=!0,x.call(G,Q)},null,M),N&&B.dispose(),B}}d.once=b;function v(z,x){return o((G,M=null,N)=>z(B=>G.call(M,x(B)),null,N))}d.map=v;function l(z,x){return o((G,M=null,N)=>z(B=>{x(B),G.call(M,B)},null,N))}d.forEach=l;function u(z,x){return o((G,M=null,N)=>z(B=>x(B)&&G.call(M,B),null,N))}d.filter=u;function t(z){return z}d.signal=t;function r(...z){return(x,G=null,M)=>(0,P.combinedDisposable)(...z.map(N=>N(B=>x.call(G,B),null,M)))}d.any=r;function c(z,x,G){let M=G;return v(z,N=>(M=x(M,N),M))}d.reduce=c;function o(z){let x;const G=new g({onFirstListenerAdd(){x=z(G.fire,G)},onLastListenerRemove(){x.dispose()}});return G.event}d.snapshot=o;function a(z,x,G=100,M=!1,N){let B,Q,W,ee=0;const re=new g({leakWarningThreshold:N,onFirstListenerAdd(){B=z(oe=>{ee++,Q=x(Q,oe),M&&!W&&(re.fire(Q),Q=void 0),clearTimeout(W),W=setTimeout(()=>{const Se=Q;Q=void 0,W=void 0,(!M||ee>1)&&re.fire(Se),ee=0},G)})},onLastListenerRemove(){B.dispose()}});return re.event}d.debounce=a;function f(z){const x=new Date().getTime();return v(b(z),G=>new Date().getTime()-x)}d.stopwatch=f;function w(z){let x=!0,G;return u(z,M=>{const N=x||M!==G;return x=!1,G=M,N})}d.latch=w;function D(z,x=!1,G=[]){let M=G.slice(),N=z(W=>{M?M.push(W):Q.fire(W)});const B=()=>{M&&M.forEach(W=>Q.fire(W)),M=null},Q=new g({onFirstListenerAdd(){N||(N=z(W=>Q.fire(W)))},onFirstListenerDidAdd(){M&&(x?setTimeout(B):B())},onLastListenerRemove(){N&&N.dispose(),N=null}});return Q.event}d.buffer=D;class p{constructor(x){this.event=x}map(x){return new p(v(this.event,x))}forEach(x){return new p(l(this.event,x))}filter(x){return new p(u(this.event,x))}reduce(x,G){return new p(c(this.event,x,G))}latch(){return new p(w(this.event))}debounce(x,G=100,M=!1,N){return new p(a(this.event,x,G,M,N))}on(x,G,M){return this.event(x,G,M)}once(x,G,M){return b(this.event)(x,G,M)}}function h(z){return new p(z)}d.chain=h;function R(z,x,G=M=>M){const M=(...W)=>Q.fire(G(...W)),N=()=>z.on(x,M),B=()=>z.removeListener(x,M),Q=new g({onFirstListenerAdd:N,onLastListenerRemove:B});return Q.event}d.fromNodeEventEmitter=R;function F(z,x,G=M=>M){const M=(...W)=>Q.fire(G(...W)),N=()=>z.addEventListener(x,M),B=()=>z.removeEventListener(x,M),Q=new g({onFirstListenerAdd:N,onLastListenerRemove:B});return Q.event}d.fromDOMEventEmitter=F;function $(z){const x=new g;let G=!1;return z.then(void 0,()=>null).then(()=>{G?x.fire(void 0):setTimeout(()=>x.fire(void 0),0)}),G=!0,x.event}d.fromPromise=$;function se(z){return new Promise(x=>b(z)(x))}d.toPromise=se})(C=e.Event||(e.Event={}));class y{constructor(b){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${b}_${y._idPool++}`}start(b){this._stopWatch=new S.StopWatch(!0),this._listenerCount=b}stop(){if(this._stopWatch){const b=this._stopWatch.elapsed();this._elapsedOverall+=b,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${b.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}y._idPool=0;let n=-1;function T(d){const b=n;return n=d,{dispose(){n=b}}}e.setGlobalLeakWarningThreshold=T;class k{constructor(b,v=Math.random().toString(18).slice(2,5)){this.customThreshold=b,this.name=v,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(b){let v=n;if(typeof this.customThreshold=="number"&&(v=this.customThreshold),!(v<=0||b<v)){this._stacks||(this._stacks=new Map);const l=new Error().stack.split(`
`).slice(3).join(`
`),u=this._stacks.get(l)||0;if(this._stacks.set(l,u+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=v*.5;let t,r=0;for(const[c,o]of this._stacks)(!t||r<o)&&(t=c,r=o);console.warn(`[${this.name}] potential listener LEAK detected, having ${b} listeners already. MOST frequent listener (${r}):`),console.warn(t)}return()=>{const t=this._stacks.get(l)||0;this._stacks.set(l,t-1)}}}}class g{constructor(b){var v;this._disposed=!1,this._options=b,this._leakageMon=n>0?new k(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((v=this._options)===null||v===void 0?void 0:v._profName)?new y(this._options._profName):void 0}get event(){return this._event||(this._event=(b,v,l)=>{var u;this._listeners||(this._listeners=new A.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const r=this._listeners.push(v?[b,v]:b);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,b,v);const c=(u=this._leakageMon)===null||u===void 0?void 0:u.check(this._listeners.size);let o;return o={dispose:()=>{c&&c(),o.dispose=g._noop,this._disposed||(r(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},l instanceof P.DisposableStore?l.add(o):Array.isArray(l)&&l.push(o),o}),this._event}fire(b){var v,l;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new A.LinkedList);for(let u of this._listeners)this._deliveryQueue.push([u,b]);for((v=this._perfMon)===null||v===void 0||v.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[u,t]=this._deliveryQueue.shift();try{typeof u=="function"?u.call(void 0,t):u[0].call(u[1],t)}catch(r){(0,E.onUnexpectedError)(r)}}(l=this._perfMon)===null||l===void 0||l.stop()}}dispose(){var b,v,l;(b=this._listeners)===null||b===void 0||b.clear(),(v=this._deliveryQueue)===null||v===void 0||v.clear(),(l=this._leakageMon)===null||l===void 0||l.dispose(),this._disposed=!0}}e.Emitter=g,g._noop=function(){};class m extends g{constructor(b){super(b);this._isPaused=0,this._eventQueue=new A.LinkedList,this._mergeFn=b==null?void 0:b.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const b=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(b))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(b){this._listeners&&(this._isPaused!==0?this._eventQueue.push(b):super.fire(b))}}e.PauseableEmitter=m;class i{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new g({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(b){const v={event:b,listener:null};this.events.push(v),this.hasListeners&&this.hook(v);const l=()=>{this.hasListeners&&this.unhook(v);const u=this.events.indexOf(v);this.events.splice(u,1)};return(0,P.toDisposable)((0,I.once)(l))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(b=>this.hook(b))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(b=>this.unhook(b))}hook(b){b.listener=b.event(v=>this.emitter.fire(v))}unhook(b){b.listener&&b.listener.dispose(),b.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=i;class s{constructor(){this.buffers=[]}wrapEvent(b){return(v,l,u)=>b(t=>{const r=this.buffers[this.buffers.length-1];r?r.push(()=>v.call(l,t)):v.call(l,t)},void 0,u)}bufferEvents(b){const v=[];this.buffers.push(v);const l=b();return this.buffers.pop(),v.forEach(u=>u()),l}}e.EventBufferer=s;class _{constructor(){this.listening=!1,this.inputEvent=C.None,this.inputEventListener=P.Disposable.None,this.emitter=new g({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(b){this.inputEvent=b,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=b(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=_}),define(_e[20],we([0,1,3]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const I=Object.freeze(function(C,y){const n=setTimeout(C.bind(y),0);return{dispose(){clearTimeout(n)}}});var P;(function(C){function y(n){return n===C.None||n===C.Cancelled||n instanceof A?!0:!n||typeof n!="object"?!1:typeof n.isCancellationRequested=="boolean"&&typeof n.onCancellationRequested=="function"}C.isCancellationToken=y,C.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),C.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:I})})(P=e.CancellationToken||(e.CancellationToken={}));class A{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?I:(this._emitter||(this._emitter=new E.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class S{constructor(y){this._token=void 0,this._parentListener=void 0,this._parentListener=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new A),this._token}cancel(){this._token?this._token instanceof A&&this._token.cancel():this._token=P.Cancelled}dispose(y=!1){y&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof A&&this._token.dispose():this._token=P.None}}e.CancellationTokenSource=S}),define(_e[36],we([0,1,3]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.registerCodicon=e.iconRegistry=void 0;class I{constructor(){this._icons=new Map,this._onDidRegister=new E.Emitter}add(T){const k=this._icons.get(T.id);k?T.description?k.description=T.description:console.error(`Duplicate registration of codicon ${T.id}`):(this._icons.set(T.id,T),this._onDidRegister.fire(T))}get(T){return this._icons.get(T)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const P=new I;e.iconRegistry=P;function A(n,T){return new S(n,T)}e.registerCodicon=A;class S{constructor(T,k,g){this.id=T,this.definition=k,this.description=g,P.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=S;function C(n,T){const k=["codicon","codicon-"+n];return T&&k.push("codicon-modifier-"+T),k}e.getClassNamesArray=C;var y;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const T=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function k(i){if(i instanceof S)return["codicon","codicon-"+i.id];const s=T.exec(i.id);if(!s)return k(S.error);let[,_,d]=s;const b=["codicon","codicon-"+_];return d&&b.push("codicon-modifier-"+d.substr(1)),b}n.asClassNameArray=k;function g(i){return k(i).join(" ")}n.asClassName=g;function m(i){return"."+k(i).join(".")}n.asCSSSelector=m})(y=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personAdd=new n("person-add",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eb0a"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(S=e.Codicon||(e.Codicon={}))}),define(_e[107],we([0,1,10,6]),function(ie,e,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function P(d){const b=d;return b&&[b.on,b.pause,b.resume,b.destroy].every(v=>typeof v=="function")}e.isReadableStream=P;function A(d){const b=d;return b&&P(b.stream)&&Array.isArray(b.buffer)&&typeof b.ended=="boolean"}e.isReadableBufferedStream=A;function S(d,b){return new C(d,b)}e.newWriteableStream=S;class C{constructor(b,v){this.reducer=b,this.options=v,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(b){var v;if(!this.state.destroyed){if(this.state.flowing)this.emitData(b);else if(this.buffer.data.push(b),typeof((v=this.options)===null||v===void 0?void 0:v.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(l=>this.pendingWritePromises.push(l))}}error(b){this.state.destroyed||(this.state.flowing?this.emitError(b):this.buffer.error.push(b))}end(b){this.state.destroyed||(typeof b!="undefined"&&this.write(b),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(b){this.listeners.data.slice(0).forEach(v=>v(b))}emitError(b){this.listeners.error.length===0?(0,E.onUnexpectedError)(b):this.listeners.error.slice(0).forEach(v=>v(b))}emitEnd(){this.listeners.end.slice(0).forEach(b=>b())}on(b,v){if(!this.state.destroyed)switch(b){case"data":this.listeners.data.push(v),this.resume();break;case"end":this.listeners.end.push(v),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(v),this.state.flowing&&this.flowErrors();break}}removeListener(b,v){if(!this.state.destroyed){let l;switch(b){case"data":l=this.listeners.data;break;case"end":l=this.listeners.end;break;case"error":l=this.listeners.error;break}if(l){const u=l.indexOf(v);u>=0&&l.splice(u,1)}}}flowData(){if(this.buffer.data.length>0){const b=this.reducer(this.buffer.data);this.emitData(b),this.buffer.data.length=0;const v=[...this.pendingWritePromises];this.pendingWritePromises.length=0,v.forEach(l=>l())}}flowErrors(){if(this.listeners.error.length>0){for(const b of this.buffer.error)this.emitError(b);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function y(d,b){const v=[];let l;for(;(l=d.read())!==null;)v.push(l);return b(v)}e.consumeReadable=y;function n(d,b,v){const l=[];let u;for(;(u=d.read())!==null&&l.length<v;)l.push(u);return u===null&&l.length>0?b(l):{read:()=>{if(l.length>0)return l.shift();if(typeof u!="undefined"){const t=u;return u=void 0,t}return d.read()}}}e.peekReadable=n;function T(d,b){return new Promise((v,l)=>{const u=[];k(d,{onData:t=>{b&&u.push(t)},onError:t=>{b?l(t):v(void 0)},onEnd:()=>{v(b?b(u):void 0)}})})}e.consumeStream=T;function k(d,b){d.on("error",v=>b.onError(v)),d.on("end",()=>b.onEnd()),d.on("data",v=>b.onData(v))}e.listenStream=k;function g(d,b){return new Promise((v,l)=>{const u=new I.DisposableStore,t=[],r=a=>{if(t.push(a),t.length>b)return u.dispose(),d.pause(),v({stream:d,buffer:t,ended:!1})},c=a=>l(a),o=()=>v({stream:d,buffer:t,ended:!0});u.add((0,I.toDisposable)(()=>d.removeListener("error",c))),d.on("error",c),u.add((0,I.toDisposable)(()=>d.removeListener("end",o))),d.on("end",o),u.add((0,I.toDisposable)(()=>d.removeListener("data",r))),d.on("data",r)})}e.peekStream=g;function m(d,b){const v=S(b);return v.end(d),v}e.toStream=m;function i(){const d=S(()=>{throw new Error("not supported")});return d.end(),d}e.emptyStream=i;function s(d){let b=!1;return{read:()=>b?null:(b=!0,d)}}e.toReadable=s;function _(d,b,v){const l=S(v);return k(d,{onData:u=>l.write(b.data(u)),onError:u=>l.error(b.error?b.error(u):u),onEnd:()=>l.end()}),l}e.transform=_}),define(_e[8],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function E(H){return!H||typeof H!="string"?!0:H.trim().length===0}e.isFalsyOrWhitespace=E;const I=/{(\d+)}/g;function P(H,...ne){return ne.length===0?H:H.replace(I,function(de,j){const Y=parseInt(j,10);return isNaN(Y)||Y<0||Y>=ne.length?de:ne[Y]})}e.format=P;function A(H){return H.replace(/[<>&]/g,function(ne){switch(ne){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ne}})}e.escape=A;function S(H){return H.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=S;function C(H,ne){let de=0;const j=ne.charCodeAt(0);for(let Y=H.length-1;Y>=0;Y--)H.charCodeAt(Y)===j&&de++;return de}e.count=C;function y(H,ne,de="\u2026"){return H.length<=ne?H:`${H.substr(0,ne)}${de}`}e.truncate=y;function n(H,ne=" "){const de=T(H,ne);return k(de,ne)}e.trim=n;function T(H,ne){if(!H||!ne)return H;const de=ne.length;if(de===0||H.length===0)return H;let j=0;for(;H.indexOf(ne,j)===j;)j=j+de;return H.substring(j)}e.ltrim=T;function k(H,ne){if(!H||!ne)return H;const de=ne.length,j=H.length;if(de===0||j===0)return H;let Y=j,ae=-1;for(;ae=H.lastIndexOf(ne,Y-1),!(ae===-1||ae+de!==Y);){if(ae===0)return"";Y=ae}return H.substring(0,Y)}e.rtrim=k;function g(H){return H.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=g;function m(H){return H.replace(/\*/g,"")}e.stripWildcards=m;function i(H,ne,de={}){if(!H)throw new Error("Cannot create regex from empty string");ne||(H=S(H)),de.wholeWord&&(/\B/.test(H.charAt(0))||(H="\\b"+H),/\B/.test(H.charAt(H.length-1))||(H=H+"\\b"));let j="";return de.global&&(j+="g"),de.matchCase||(j+="i"),de.multiline&&(j+="m"),de.unicode&&(j+="u"),new RegExp(H,j)}e.createRegExp=i;function s(H){return H.source==="^"||H.source==="^$"||H.source==="$"||H.source==="^\\s*$"?!1:!!(H.exec("")&&H.lastIndex===0)}e.regExpLeadsToEndlessLoop=s;function _(H){return!!H.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=_;function d(H){return(H.global?"g":"")+(H.ignoreCase?"i":"")+(H.multiline?"m":"")+(H.unicode?"u":"")}e.regExpFlags=d;function b(H){return H.split(/\r\n|\r|\n/)}e.splitLines=b;function v(H){for(let ne=0,de=H.length;ne<de;ne++){const j=H.charCodeAt(ne);if(j!==32&&j!==9)return ne}return-1}e.firstNonWhitespaceIndex=v;function l(H,ne=0,de=H.length){for(let j=ne;j<de;j++){const Y=H.charCodeAt(j);if(Y!==32&&Y!==9)return H.substring(ne,j)}return H.substring(ne,de)}e.getLeadingWhitespace=l;function u(H,ne=H.length-1){for(let de=ne;de>=0;de--){const j=H.charCodeAt(de);if(j!==32&&j!==9)return de}return-1}e.lastNonWhitespaceIndex=u;function t(H,ne){return H<ne?-1:H>ne?1:0}e.compare=t;function r(H,ne,de=0,j=H.length,Y=0,ae=ne.length){for(;de<j&&Y<ae;de++,Y++){let Ne=H.charCodeAt(de),Le=ne.charCodeAt(Y);if(Ne<Le)return-1;if(Ne>Le)return 1}const fe=j-de,Ee=ae-Y;return fe<Ee?-1:fe>Ee?1:0}e.compareSubstring=r;function c(H,ne){return o(H,ne,0,H.length,0,ne.length)}e.compareIgnoreCase=c;function o(H,ne,de=0,j=H.length,Y=0,ae=ne.length){for(;de<j&&Y<ae;de++,Y++){let Ne=H.charCodeAt(de),Le=ne.charCodeAt(Y);if(Ne!==Le){const Ve=Ne-Le;if(!(Ve===32&&f(Le))&&!(Ve===-32&&f(Ne)))return a(Ne)&&a(Le)?Ve:r(H.toLowerCase(),ne.toLowerCase(),de,j,Y,ae)}}const fe=j-de,Ee=ae-Y;return fe<Ee?-1:fe>Ee?1:0}e.compareSubstringIgnoreCase=o;function a(H){return H>=97&&H<=122}e.isLowerAsciiLetter=a;function f(H){return H>=65&&H<=90}e.isUpperAsciiLetter=f;function w(H){return a(H)||f(H)}function D(H,ne){return H.length===ne.length&&p(H,ne)}e.equalsIgnoreCase=D;function p(H,ne,de=H.length){for(let j=0;j<de;j++){const Y=H.charCodeAt(j),ae=ne.charCodeAt(j);if(Y!==ae){if(w(Y)&&w(ae)){const fe=Math.abs(Y-ae);if(fe!==0&&fe!==32)return!1}else if(String.fromCharCode(Y).toLowerCase()!==String.fromCharCode(ae).toLowerCase())return!1}}return!0}function h(H,ne){const de=ne.length;return ne.length>H.length?!1:p(H,ne,de)}e.startsWithIgnoreCase=h;function R(H,ne){let de,j=Math.min(H.length,ne.length);for(de=0;de<j;de++)if(H.charCodeAt(de)!==ne.charCodeAt(de))return de;return j}e.commonPrefixLength=R;function F(H,ne){let de,j=Math.min(H.length,ne.length);const Y=H.length-1,ae=ne.length-1;for(de=0;de<j;de++)if(H.charCodeAt(Y-de)!==ne.charCodeAt(ae-de))return de;return j}e.commonSuffixLength=F;function $(H){return 55296<=H&&H<=56319}e.isHighSurrogate=$;function se(H){return 56320<=H&&H<=57343}e.isLowSurrogate=se;function z(H,ne){return(H-55296<<10)+(ne-56320)+65536}e.computeCodePoint=z;function x(H,ne,de){const j=H.charCodeAt(de);if($(j)&&de+1<ne){const Y=H.charCodeAt(de+1);if(se(Y))return z(j,Y)}return j}e.getNextCodePoint=x;function G(H,ne){const de=H.charCodeAt(ne-1);if(se(de)&&ne>1){const j=H.charCodeAt(ne-2);if($(j))return z(j,de)}return de}function M(H,ne){const de=Ue.getInstance(),j=ne,Y=H.length,ae=x(H,Y,ne);ne+=ae>=65536?2:1;let fe=de.getGraphemeBreakType(ae);for(;ne<Y;){const Ee=x(H,Y,ne),Ne=de.getGraphemeBreakType(Ee);if(Me(fe,Ne))break;ne+=Ee>=65536?2:1,fe=Ne}return ne-j}e.nextCharLength=M;function N(H,ne){const de=Ue.getInstance(),j=ne,Y=G(H,ne);ne-=Y>=65536?2:1;let ae=de.getGraphemeBreakType(Y);for(;ne>0;){const fe=G(H,ne),Ee=de.getGraphemeBreakType(fe);if(Me(Ee,ae))break;ne-=fe>=65536?2:1,ae=Ee}return j-ne}e.prevCharLength=N;function B(H,ne){const de=Ue.getInstance(),j=H.length,Y=ne,ae=x(H,j,ne),fe=de.getGraphemeBreakType(ae);ne+=ae>=65536?2:1;let Ee=fe;for(;ne<j;){const Le=x(H,j,ne),Ve=de.getGraphemeBreakType(Le);if(Me(Ee,Ve))break;ne+=Le>=65536?2:1,Ee=Ve}const Ne=ne;for(ne=Y,Ee=fe;ne>0;){const Le=G(H,ne),Ve=de.getGraphemeBreakType(Le);if(Me(Ve,Ee))break;ne-=Le>=65536?2:1,Ee=Ve}return[ne,Ne]}function Q(H,ne){return ne>0&&se(H.charCodeAt(ne))?B(H,ne-1):B(H,ne)}e.getCharContainingOffset=Q;function W(H){const ne=H.length;let de=0,j=0;for(;j<ne;){const fe=x(H,ne,j);j+=fe>=65536?2:1,fe<128?de+=1:fe<2048?de+=2:fe<65536?de+=3:de+=4}const Y=new Uint8Array(de);j=0;let ae=0;for(;j<ne;){const fe=x(H,ne,j);j+=fe>=65536?2:1,fe<128?Y[ae++]=fe:fe<2048?(Y[ae++]=192|(fe&1984)>>>6,Y[ae++]=128|(fe&63)>>>0):fe<65536?(Y[ae++]=224|(fe&61440)>>>12,Y[ae++]=128|(fe&4032)>>>6,Y[ae++]=128|(fe&63)>>>0):(Y[ae++]=240|(fe&1835008)>>>18,Y[ae++]=128|(fe&258048)>>>12,Y[ae++]=128|(fe&4032)>>>6,Y[ae++]=128|(fe&63)>>>0)}return Y}e.encodeUTF8=W;function ee(H){const ne=H.byteLength,de=[];let j=0;for(;j<ne;){const Y=H[j];let ae;if(Y>=240&&j+3<ne?ae=(H[j++]&7)<<18>>>0|(H[j++]&63)<<12>>>0|(H[j++]&63)<<6>>>0|(H[j++]&63)<<0>>>0:Y>=224&&j+2<ne?ae=(H[j++]&15)<<12>>>0|(H[j++]&63)<<6>>>0|(H[j++]&63)<<0>>>0:Y>=192&&j+1<ne?ae=(H[j++]&31)<<6>>>0|(H[j++]&63)<<0>>>0:ae=H[j++],ae>=0&&ae<=55295||ae>=57344&&ae<=65535)de.push(String.fromCharCode(ae));else if(ae>=65536&&ae<=1114111){const fe=ae-65536,Ee=55296+((fe&1047552)>>>10),Ne=56320+((fe&1023)>>>0);de.push(String.fromCharCode(Ee)),de.push(String.fromCharCode(Ne))}else de.push(String.fromCharCode(65533))}return de.join("")}e.decodeUTF8=ee;const re=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function oe(H){return re.test(H)}e.containsRTL=oe;const Se=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function Pe(H){return Se.test(H)}e.containsEmoji=Pe;const $e=/^[\t\n\r\x20-\x7E]*$/;function Fe(H){return $e.test(H)}e.isBasicASCII=Fe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ze(H){return e.UNUSUAL_LINE_TERMINATORS.test(H)}e.containsUnusualLineTerminators=ze;function U(H){for(let ne=0,de=H.length;ne<de;ne++)if(K(H.charCodeAt(ne)))return!0;return!1}e.containsFullWidthCharacter=U;function K(H){return H=+H,H>=11904&&H<=55215||H>=63744&&H<=64255||H>=65281&&H<=65374}e.isFullWidthCharacter=K;function te(H){return H>=127462&&H<=127487||H===8986||H===8987||H===9200||H===9203||H>=9728&&H<=10175||H===11088||H===11093||H>=127744&&H<=128591||H>=128640&&H<=128764||H>=128992&&H<=129003||H>=129280&&H<=129535||H>=129648&&H<=129750}e.isEmojiImprecise=te;function le(H,ne){if(H.length<ne)return H;const de=/\b/g;let j=0;for(;de.test(H)&&!(H.length-de.lastIndex<ne);)j=de.lastIndex,de.lastIndex+=1;return H.substring(j).replace(/^\s/,"")}e.lcut=le;const me=/\x1B\x5B[12]?K/g,De=/\x1b\[\d+m/g,Oe=/\x1b\[0?m/g;function ge(H){return H&&(H=H.replace(me,""),H=H.replace(De,""),H=H.replace(Oe,"")),H}e.removeAnsiEscapeCodes=ge,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ce(H){return!!(H&&H.length>0&&H.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ce;function Ae(H){return Ce(H)?H.substr(1):H}e.stripUTF8BOM=Ae;function We(H,ne){if(!H||!ne||H.length<ne.length)return!1;const de=ne.length,j=H.toLowerCase();let Y=0,ae=-1;for(;Y<de;){const fe=j.indexOf(ne[Y],ae+1);if(fe<0)return!1;ae=fe,Y++}return!0}e.fuzzyContains=We;function be(H,ne=!1){return H?(ne&&(H=H.replace(/\\./g,"")),H.toLowerCase()!==H):!1}e.containsUppercaseCharacter=be;function qe(H){return H.charAt(0).toUpperCase()+H.slice(1)}e.uppercaseFirstLetter=qe;function V(H,ne=1){if(ne===0)return"";let de=-1;do de=H.indexOf(`
`,de+1),ne--;while(ne>0&&de>=0);return de===-1?H:(H[de-1]==="\r"&&de--,H.substr(0,de))}e.getNLines=V;function Z(H){const ne=90-65+1;return H=H%(2*ne),H<ne?String.fromCharCode(97+H):String.fromCharCode(65+H-ne)}e.singleLetterHash=Z;function pe(H){return Ue.getInstance().getGraphemeBreakType(H)}e.getGraphemeBreakType=pe;function Me(H,ne){return H===0?ne!==5&&ne!==7:H===2&&ne===3?!1:H===4||H===2||H===3||ne===4||ne===2||ne===3?!0:!(H===8&&(ne===8||ne===9||ne===11||ne===12)||(H===11||H===9)&&(ne===9||ne===10)||(H===12||H===10)&&ne===10||ne===5||ne===13||ne===7||H===1||H===13&&ne===14||H===6&&ne===6)}e.breakBetweenGraphemeBreakType=Me;var He;(function(H){H[H.Other=0]="Other",H[H.Prepend=1]="Prepend",H[H.CR=2]="CR",H[H.LF=3]="LF",H[H.Control=4]="Control",H[H.Extend=5]="Extend",H[H.Regional_Indicator=6]="Regional_Indicator",H[H.SpacingMark=7]="SpacingMark",H[H.L=8]="L",H[H.V=9]="V",H[H.T=10]="T",H[H.LV=11]="LV",H[H.LVT=12]="LVT",H[H.ZWJ=13]="ZWJ",H[H.Extended_Pictographic=14]="Extended_Pictographic"})(He=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ue{constructor(){this._data=Ze()}static getInstance(){return Ue._INSTANCE||(Ue._INSTANCE=new Ue),Ue._INSTANCE}getGraphemeBreakType(ne){if(ne<32)return ne===10?3:ne===13?2:4;if(ne<127)return 0;const de=this._data,j=de.length/3;let Y=1;for(;Y<=j;)if(ne<de[3*Y])Y=2*Y;else if(ne>de[3*Y+1])Y=2*Y+1;else return de[3*Y+2];return 0}}Ue._INSTANCE=null;function Ze(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(_e[23],we([0,1,8,107]),function(ie,e,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const P=typeof Buffer!="undefined",A=typeof TextEncoder!="undefined",S=typeof TextDecoder!="undefined";let C,y;class n{constructor(a){this.buffer=a,this.byteLength=this.buffer.byteLength}static alloc(a){return P?new n(Buffer.allocUnsafe(a)):new n(new Uint8Array(a))}static wrap(a){return P&&!Buffer.isBuffer(a)&&(a=Buffer.from(a.buffer,a.byteOffset,a.byteLength)),new n(a)}static fromString(a,f){return!((f==null?void 0:f.dontUseNodeBuffer)||!1)&&P?new n(Buffer.from(a)):A?(C||(C=new TextEncoder),new n(C.encode(a))):new n(E.encodeUTF8(a))}static concat(a,f){if(typeof f=="undefined"){f=0;for(let p=0,h=a.length;p<h;p++)f+=a[p].byteLength}const w=n.alloc(f);let D=0;for(let p=0,h=a.length;p<h;p++){const R=a[p];w.set(R,D),D+=R.byteLength}return w}toString(){return P?this.buffer.toString():S?(y||(y=new TextDecoder),y.decode(this.buffer)):E.decodeUTF8(this.buffer)}slice(a,f){return new n(this.buffer.subarray(a,f))}set(a,f){a instanceof n?this.buffer.set(a.buffer,f):this.buffer.set(a,f)}readUInt32BE(a){return g(this.buffer,a)}writeUInt32BE(a,f){m(this.buffer,a,f)}readUInt32LE(a){return i(this.buffer,a)}writeUInt32LE(a,f){s(this.buffer,a,f)}readUInt8(a){return _(this.buffer,a)}writeUInt8(a,f){d(this.buffer,a,f)}}e.VSBuffer=n;function T(o,a){return o[a+0]<<0>>>0|o[a+1]<<8>>>0}e.readUInt16LE=T;function k(o,a,f){o[f+0]=a&255,a=a>>>8,o[f+1]=a&255}e.writeUInt16LE=k;function g(o,a){return o[a]*2**24+o[a+1]*2**16+o[a+2]*2**8+o[a+3]}e.readUInt32BE=g;function m(o,a,f){o[f+3]=a,a=a>>>8,o[f+2]=a,a=a>>>8,o[f+1]=a,a=a>>>8,o[f]=a}e.writeUInt32BE=m;function i(o,a){return o[a+0]<<0>>>0|o[a+1]<<8>>>0|o[a+2]<<16>>>0|o[a+3]<<24>>>0}e.readUInt32LE=i;function s(o,a,f){o[f+0]=a&255,a=a>>>8,o[f+1]=a&255,a=a>>>8,o[f+2]=a&255,a=a>>>8,o[f+3]=a&255}e.writeUInt32LE=s;function _(o,a){return o[a]}e.readUInt8=_;function d(o,a,f){o[f]=a}e.writeUInt8=d;function b(o){return I.consumeReadable(o,a=>n.concat(a))}e.readableToBuffer=b;function v(o){return I.toReadable(o)}e.bufferToReadable=v;function l(o){return I.consumeStream(o,a=>n.concat(a))}e.streamToBuffer=l;async function u(o){return o.ended?n.concat(o.buffer):n.concat([...o.buffer,await l(o.stream)])}e.bufferedStreamToBuffer=u;function t(o){return I.toStream(o,a=>n.concat(a))}e.bufferToStream=t;function r(o){return I.transform(o,{data:a=>typeof a=="string"?n.fromString(a):n.wrap(a)},a=>n.concat(a))}e.streamToBufferReadableStream=r;function c(o){return I.newWriteableStream(a=>n.concat(a),o)}e.newWriteableBufferStream=c}),define(_e[56],we([0,1,8]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function I(d){return P(d,0)}e.hash=I;function P(d,b){switch(typeof d){case"object":return d===null?A(349,b):Array.isArray(d)?y(d,b):n(d,b);case"string":return C(d,b);case"boolean":return S(d,b);case"number":return A(d,b);case"undefined":return A(937,b);default:return A(617,b)}}e.doHash=P;function A(d,b){return(b<<5)-b+d|0}function S(d,b){return A(d?433:863,b)}function C(d,b){b=A(149417,b);for(let v=0,l=d.length;v<l;v++)b=A(d.charCodeAt(v),b);return b}e.stringHash=C;function y(d,b){return b=A(104579,b),d.reduce((v,l)=>P(l,v),b)}function n(d,b){return b=A(181387,b),Object.keys(d).sort().reduce((v,l)=>(v=C(l,v),P(d[l],v)),b)}class T{constructor(){this._value=0}get value(){return this._value}hash(b){return this._value=P(b,this._value),this._value}}e.Hasher=T;var k;(function(d){d[d.BLOCK_SIZE=64]="BLOCK_SIZE",d[d.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function g(d,b,v=32){const l=v-b,u=~((1<<l)-1);return(d<<b|(u&d)>>>l)>>>0}function m(d,b=0,v=d.byteLength,l=0){for(let u=0;u<v;u++)d[b+u]=l}function i(d,b,v="0"){for(;d.length<b;)d=v+d;return d}function s(d,b=32){return d instanceof ArrayBuffer?Array.from(new Uint8Array(d)).map(v=>v.toString(16).padStart(2,"0")).join(""):i((d>>>0).toString(16),b/4)}e.toHexString=s;class _{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(b){const v=b.length;if(v!==0){const l=this._buff;let u=this._buffLen,t=this._leftoverHighSurrogate,r,c;for(t!==0?(r=t,c=-1,t=0):(r=b.charCodeAt(0),c=0);;){let o=r;if(E.isHighSurrogate(r))if(c+1<v){const a=b.charCodeAt(c+1);E.isLowSurrogate(a)?(c++,o=E.computeCodePoint(r,a)):o=65533}else{t=r;break}else E.isLowSurrogate(r)&&(o=65533);if(u=this._push(l,u,o),c++,c<v)r=b.charCodeAt(c);else break}this._buffLen=u,this._leftoverHighSurrogate=t}}_push(b,v,l){return l<128?b[v++]=l:l<2048?(b[v++]=192|(l&1984)>>>6,b[v++]=128|(l&63)>>>0):l<65536?(b[v++]=224|(l&61440)>>>12,b[v++]=128|(l&4032)>>>6,b[v++]=128|(l&63)>>>0):(b[v++]=240|(l&1835008)>>>18,b[v++]=128|(l&258048)>>>12,b[v++]=128|(l&4032)>>>6,b[v++]=128|(l&63)>>>0),v>=64&&(this._step(),v-=64,this._totalLen+=64,b[0]=b[64+0],b[1]=b[64+1],b[2]=b[64+2]),v}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),s(this._h0)+s(this._h1)+s(this._h2)+s(this._h3)+s(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,m(this._buff,this._buffLen),this._buffLen>56&&(this._step(),m(this._buff));const b=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(b/4294967296),!1),this._buffDV.setUint32(60,b%4294967296,!1),this._step()}_step(){const b=_._bigBlock32,v=this._buffDV;for(let w=0;w<64;w+=4)b.setUint32(w,v.getUint32(w,!1),!1);for(let w=64;w<320;w+=4)b.setUint32(w,g(b.getUint32(w-12,!1)^b.getUint32(w-32,!1)^b.getUint32(w-56,!1)^b.getUint32(w-64,!1),1),!1);let l=this._h0,u=this._h1,t=this._h2,r=this._h3,c=this._h4,o,a,f;for(let w=0;w<80;w++)w<20?(o=u&t|~u&r,a=1518500249):w<40?(o=u^t^r,a=1859775393):w<60?(o=u&t|u&r|t&r,a=2400959708):(o=u^t^r,a=3395469782),f=g(l,5)+o+c+a+b.getUint32(w*4,!1)&4294967295,c=r,r=t,t=g(u,30),u=l,l=f;this._h0=this._h0+l&4294967295,this._h1=this._h1+u&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+c&4294967295}}e.StringSHA1=_,_._bigBlock32=new DataView(new ArrayBuffer(320))}),define(_e[46],we([0,1,8]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var I;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(I||(I={})),function(P){const A="error",S="warning",C="warn",y="info";function n(T){return T?E.equalsIgnoreCase(A,T)?P.Error:E.equalsIgnoreCase(S,T)||E.equalsIgnoreCase(C,T)?P.Warning:E.equalsIgnoreCase(y,T)?P.Info:P.Ignore:P.Ignore}P.fromValue=n}(I||(I={})),e.default=I}),define(_e[13],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function E(f){return Array.isArray(f)}e.isArray=E;function I(f){return typeof f=="string"}e.isString=I;function P(f){return Array.isArray(f)&&f.every(w=>I(w))}e.isStringArray=P;function A(f){return typeof f=="object"&&f!==null&&!Array.isArray(f)&&!(f instanceof RegExp)&&!(f instanceof Date)}e.isObject=A;function S(f){return typeof f=="number"&&!isNaN(f)}e.isNumber=S;function C(f){return!!f&&typeof f[Symbol.iterator]=="function"}e.isIterable=C;function y(f){return f===!0||f===!1}e.isBoolean=y;function n(f){return typeof f=="undefined"}e.isUndefined=n;function T(f){return!k(f)}e.isDefined=T;function k(f){return n(f)||f===null}e.isUndefinedOrNull=k;function g(f,w){if(!f)throw new Error(w?`Unexpected type, expected '${w}'`:"Unexpected type")}e.assertType=g;function m(f){if(k(f))throw new Error("Assertion Failed: argument is undefined or null");return f}e.assertIsDefined=m;function i(...f){const w=[];for(let D=0;D<f.length;D++){const p=f[D];if(k(p))throw new Error(`Assertion Failed: argument at index ${D} is undefined or null`);w.push(p)}return w}e.assertAllDefined=i;const s=Object.prototype.hasOwnProperty;function _(f){if(!A(f))return!1;for(let w in f)if(s.call(f,w))return!1;return!0}e.isEmptyObject=_;function d(f){return typeof f=="function"}e.isFunction=d;function b(...f){return f.length>0&&f.every(d)}e.areFunctions=b;function v(f,w){const D=Math.min(f.length,w.length);for(let p=0;p<D;p++)l(f[p],w[p])}e.validateConstraints=v;function l(f,w){if(I(w)){if(typeof f!==w)throw new Error(`argument does not match constraint: typeof ${w}`)}else if(d(w)){try{if(f instanceof w)return}catch(D){}if(!k(f)&&f.constructor===w||w.length===1&&w.call(void 0,f)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=l;function u(f){let w=[],D=Object.getPrototypeOf(f);for(;Object.prototype!==D;)w=w.concat(Object.getOwnPropertyNames(D)),D=Object.getPrototypeOf(D);return w}e.getAllPropertyNames=u;function t(f){const w=[];for(const D of u(f))typeof f[D]=="function"&&w.push(D);return w}e.getAllMethodNames=t;function r(f,w){const D=h=>function(){const R=Array.prototype.slice.call(arguments,0);return w(h,R)};let p={};for(const h of f)p[h]=D(h);return p}e.createProxyObject=r;function c(f){return f===null?void 0:f}e.withNullAsUndefined=c;function o(f){return typeof f=="undefined"?null:f}e.withUndefinedAsNull=o;function a(f){return class{constructor(){return new Proxy({},{get(w,D){if(w[D])return w[D];throw new Error(`Not Implemented: ${f}->${String(D)}`)}})}}}e.NotImplementedProxy=a}),define(_e[37],we([0,1,21,8,12,13]),function(ie,e,E,I,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function S(r){return r===47||r===92}e.isPathSeparator=S;function C(r){return r.replace(/[\\/]/g,P.posix.sep)}e.toSlashes=C;function y(r,c=P.posix.sep){if(!r)return"";const o=r.length,a=r.charCodeAt(0);if(S(a)){if(S(r.charCodeAt(1))&&!S(r.charCodeAt(2))){let w=3;const D=w;for(;w<o&&!S(r.charCodeAt(w));w++);if(D!==w&&!S(r.charCodeAt(w+1))){for(w+=1;w<o;w++)if(S(r.charCodeAt(w)))return r.slice(0,w+1).replace(/[\\/]/g,c)}}return c}else if(_(a)&&r.charCodeAt(1)===58)return S(r.charCodeAt(2))?r.slice(0,2)+c:r.slice(0,2);let f=r.indexOf("://");if(f!==-1){for(f+=3;f<o;f++)if(S(r.charCodeAt(f)))return r.slice(0,f+1)}return""}e.getRoot=y;function n(r){if(!E.isWindows||!r||r.length<5)return!1;let c=r.charCodeAt(0);if(c!==92||(c=r.charCodeAt(1),c!==92))return!1;let o=2;const a=o;for(;o<r.length&&(c=r.charCodeAt(o),c!==92);o++);return!(a===o||(c=r.charCodeAt(o+1),isNaN(c)||c===92))}e.isUNC=n;const T=/[\\/:\*\?"<>\|]/g,k=/[\\/]/g,g=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(r,c=E.isWindows){const o=c?T:k;return!(!r||r.length===0||/^\s+$/.test(r)||(o.lastIndex=0,o.test(r))||c&&g.test(r)||r==="."||r===".."||c&&r[r.length-1]==="."||c&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=m;function i(r,c,o){const a=r===c;return!o||a?a:!r||!c?!1:(0,I.equalsIgnoreCase)(r,c)}e.isEqual=i;function s(r,c,o,a=P.sep){if(r===c)return!0;if(!r||!c||c.length>r.length)return!1;if(o){if(!(0,I.startsWithIgnoreCase)(r,c))return!1;if(c.length===r.length)return!0;let w=c.length;return c.charAt(c.length-1)===a&&w--,r.charAt(w)===a}return c.charAt(c.length-1)!==a&&(c+=a),r.indexOf(c)===0}e.isEqualOrParent=s;function _(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=_;function d(r,c){return E.isWindows&&r.endsWith(":")&&(r+=P.sep),(0,P.isAbsolute)(r)||(r=(0,P.join)(c,r)),r=(0,P.normalize)(r),E.isWindows?(r=(0,I.rtrim)(r,P.sep),r.endsWith(":")&&(r+=P.sep)):(r=(0,I.rtrim)(r,P.sep),r||(r=P.sep)),r}e.sanitizeFilePath=d;function b(r){const c=(0,P.normalize)(r);return E.isWindows?r.length>3?!1:v(c)&&(r.length===2||c.charCodeAt(2)===92):c===P.posix.sep}e.isRootOrDriveLetter=b;function v(r){return E.isWindows?_(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=v;function l(r){return v(r)?r[0]:void 0}e.getDriveLetter=l;function u(r,c,o){return c.length>r.length?-1:r===c?0:(o&&(r=r.toLowerCase(),c=c.toLowerCase()),r.indexOf(c))}e.indexOfPath=u;function t(r){const c=r.split(":");let o,a,f;if(c.forEach(w=>{const D=Number(w);(0,A.isNumber)(D)?a===void 0?a=D:f===void 0&&(f=D):o=o?[o,w].join(":"):w}),!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:a!==void 0?a:void 0,column:f!==void 0?f:a!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(_e[24],we([0,1,13]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function I(i){if(!i||typeof i!="object"||i instanceof RegExp)return i;const s=Array.isArray(i)?[]:{};return Object.keys(i).forEach(_=>{i[_]&&typeof i[_]=="object"?s[_]=I(i[_]):s[_]=i[_]}),s}e.deepClone=I;function P(i){if(!i||typeof i!="object")return i;const s=[i];for(;s.length>0;){const _=s.shift();Object.freeze(_);for(const d in _)if(A.call(_,d)){const b=_[d];typeof b=="object"&&!Object.isFrozen(b)&&s.push(b)}}return i}e.deepFreeze=P;const A=Object.prototype.hasOwnProperty;function S(i,s){return C(i,s,new Set)}e.cloneAndChange=S;function C(i,s,_){if((0,E.isUndefinedOrNull)(i))return i;const d=s(i);if(typeof d!="undefined")return d;if((0,E.isArray)(i)){const b=[];for(const v of i)b.push(C(v,s,_));return b}if((0,E.isObject)(i)){if(_.has(i))throw new Error("Cannot clone recursive data-structure");_.add(i);const b={};for(let v in i)A.call(i,v)&&(b[v]=C(i[v],s,_));return _.delete(i),b}return i}function y(i,s,_=!0){return(0,E.isObject)(i)?((0,E.isObject)(s)&&Object.keys(s).forEach(d=>{d in i?_&&((0,E.isObject)(i[d])&&(0,E.isObject)(s[d])?y(i[d],s[d],_):i[d]=s[d]):i[d]=s[d]}),i):s}e.mixin=y;function n(i,s){if(i===s)return!0;if(i==null||s===null||s===void 0||typeof i!=typeof s||typeof i!="object"||Array.isArray(i)!==Array.isArray(s))return!1;let _,d;if(Array.isArray(i)){if(i.length!==s.length)return!1;for(_=0;_<i.length;_++)if(!n(i[_],s[_]))return!1}else{const b=[];for(d in i)b.push(d);b.sort();const v=[];for(d in s)v.push(d);if(v.sort(),!n(b,v))return!1;for(_=0;_<b.length;_++)if(!n(i[b[_]],s[b[_]]))return!1}return!0}e.equals=n;function T(i){const s=new Set;return JSON.stringify(i,(_,d)=>{if((0,E.isObject)(d)||Array.isArray(d)){if(s.has(d))return"[Circular]";s.add(d)}return d})}e.safeStringify=T;function k(i,s,_){const d=s(i);return typeof d=="undefined"?_:d}e.getOrDefault=k;function g(i,s){const _=Object.create(null);return!i||!s||Object.keys(s).forEach(b=>{const v=i[b],l=s[b];n(v,l)||(_[b]=l)}),_}e.distinct=g;function m(i,s){const _=s.toLowerCase(),d=Object.keys(i).find(b=>b.toLowerCase()===_);return d?i[d]:i[s]}e.getCaseInsensitive=m}),define(_e[79],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var E;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(E=e.Constants||(e.Constants={}));function I(A){return A<0?0:A>255?255:A|0}e.toUint8=I;function P(A){return A<0?0:A>4294967295?4294967295:A|0}e.toUint32=P}),define(_e[2],we([0,1,21,12]),function(ie,e,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const P=/^\w[\w\d+.-]*$/,A=/^\//,S=/^\/\//;function C(c,o){if(!c.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${c.authority}", path: "${c.path}", query: "${c.query}", fragment: "${c.fragment}"}`);if(c.scheme&&!P.test(c.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(c.path){if(c.authority){if(!A.test(c.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(S.test(c.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(c,o){return!c&&!o?"file":c}function n(c,o){switch(c){case"https":case"http":case"file":o?o[0]!==k&&(o=k+o):o=k;break}return o}const T="",k="/",g=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{constructor(o,a,f,w,D,p=!1){typeof o=="object"?(this.scheme=o.scheme||T,this.authority=o.authority||T,this.path=o.path||T,this.query=o.query||T,this.fragment=o.fragment||T):(this.scheme=y(o,p),this.authority=a||T,this.path=n(this.scheme,f||T),this.query=w||T,this.fragment=D||T,C(this,p))}static isUri(o){return o instanceof m?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}get fsPath(){return v(this,!1)}with(o){if(!o)return this;let{scheme:a,authority:f,path:w,query:D,fragment:p}=o;return a===void 0?a=this.scheme:a===null&&(a=T),f===void 0?f=this.authority:f===null&&(f=T),w===void 0?w=this.path:w===null&&(w=T),D===void 0?D=this.query:D===null&&(D=T),p===void 0?p=this.fragment:p===null&&(p=T),a===this.scheme&&f===this.authority&&w===this.path&&D===this.query&&p===this.fragment?this:new s(a,f,w,D,p)}static parse(o,a=!1){const f=g.exec(o);return f?new s(f[2]||T,r(f[4]||T),r(f[5]||T),r(f[7]||T),r(f[9]||T),a):new s(T,T,T,T,T)}static file(o){let a=T;if(E.isWindows&&(o=o.replace(/\\/g,k)),o[0]===k&&o[1]===k){const f=o.indexOf(k,2);f===-1?(a=o.substring(2),o=k):(a=o.substring(2,f),o=o.substring(f)||k)}return new s("file",a,o,T,T)}static from(o){return new s(o.scheme,o.authority,o.path,o.query,o.fragment)}static joinPath(o,...a){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let f;return E.isWindows&&o.scheme==="file"?f=m.file(I.win32.join(v(o,!0),...a)).path:f=I.posix.join(o.path,...a),o.with({path:f})}toString(o=!1){return l(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof m)return o;{const a=new s(o);return a._formatted=o.external,a._fsPath=o._sep===i?o.fsPath:null,a}}else return o}}e.URI=m;const i=E.isWindows?1:void 0;class s extends m{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=v(this,!1)),this._fsPath}toString(o=!1){return o?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=i),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const _={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function d(c,o){let a,f=-1;for(let w=0;w<c.length;w++){const D=c.charCodeAt(w);if(D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57||D===45||D===46||D===95||D===126||o&&D===47)f!==-1&&(a+=encodeURIComponent(c.substring(f,w)),f=-1),a!==void 0&&(a+=c.charAt(w));else{a===void 0&&(a=c.substr(0,w));const p=_[D];p!==void 0?(f!==-1&&(a+=encodeURIComponent(c.substring(f,w)),f=-1),a+=p):f===-1&&(f=w)}}return f!==-1&&(a+=encodeURIComponent(c.substring(f))),a!==void 0?a:c}function b(c){let o;for(let a=0;a<c.length;a++){const f=c.charCodeAt(a);f===35||f===63?(o===void 0&&(o=c.substr(0,a)),o+=_[f]):o!==void 0&&(o+=c[a])}return o!==void 0?o:c}function v(c,o){let a;return c.authority&&c.path.length>1&&c.scheme==="file"?a=`//${c.authority}${c.path}`:c.path.charCodeAt(0)===47&&(c.path.charCodeAt(1)>=65&&c.path.charCodeAt(1)<=90||c.path.charCodeAt(1)>=97&&c.path.charCodeAt(1)<=122)&&c.path.charCodeAt(2)===58?o?a=c.path.substr(1):a=c.path[1].toLowerCase()+c.path.substr(2):a=c.path,E.isWindows&&(a=a.replace(/\//g,"\\")),a}e.uriToFsPath=v;function l(c,o){const a=o?b:d;let f="",{scheme:w,authority:D,path:p,query:h,fragment:R}=c;if(w&&(f+=w,f+=":"),(D||w==="file")&&(f+=k,f+=k),D){let F=D.indexOf("@");if(F!==-1){const $=D.substr(0,F);D=D.substr(F+1),F=$.indexOf(":"),F===-1?f+=a($,!1):(f+=a($.substr(0,F),!1),f+=":",f+=a($.substr(F+1),!1)),f+="@"}D=D.toLowerCase(),F=D.indexOf(":"),F===-1?f+=a(D,!1):(f+=a(D.substr(0,F),!1),f+=D.substr(F))}if(p){if(p.length>=3&&p.charCodeAt(0)===47&&p.charCodeAt(2)===58){const F=p.charCodeAt(1);F>=65&&F<=90&&(p=`/${String.fromCharCode(F+32)}:${p.substr(3)}`)}else if(p.length>=2&&p.charCodeAt(1)===58){const F=p.charCodeAt(0);F>=65&&F<=90&&(p=`${String.fromCharCode(F+32)}:${p.substr(2)}`)}f+=a(p,!0)}return h&&(f+="?",f+=a(h,!1)),R&&(f+="#",f+=o?R:d(R,!1)),f}function u(c){try{return decodeURIComponent(c)}catch(o){return c.length>3?c.substr(0,3)+u(c.substr(3)):c}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(c){return c.match(t)?c.replace(t,o=>u(o)):c}}),define(_e[22],we([0,1,2,8]),function(ie,e,E,I){"use strict";var P,A;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function S(l,u,t){let r=l.get(u);return r===void 0&&(r=t,l.set(u,r)),r}e.getOrSet=S;function C(l){const u=[];return l.forEach((t,r)=>{u.push(`${r} => ${t}`)}),`Map(${l.size}) {${u.join(", ")}}`}e.mapToString=C;function y(l){const u=[];return l.forEach(t=>{u.push(t)}),`Set(${l.size}) {${u.join(", ")}}`}e.setToString=y;class n{constructor(){this._value="",this._pos=0}reset(u){return this._value=u,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(u){const t=u.charCodeAt(0),r=this._value.charCodeAt(this._pos);return t-r}value(){return this._value[this._pos]}}e.StringIterator=n;class T{constructor(u=!0){this._caseSensitive=u}reset(u){return this._value=u,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let u=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(u)this._from++;else break;else u=!1;return this}cmp(u){return this._caseSensitive?(0,I.compareSubstring)(u,this._value,0,u.length,this._from,this._to):(0,I.compareSubstringIgnoreCase)(u,this._value,0,u.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=T;class k{constructor(u=!0,t=!0){this._splitOnBackslash=u,this._caseSensitive=t}reset(u){return this._value=u.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let u=!0;for(;this._to<this._value.length;this._to++){const t=this._value.charCodeAt(this._to);if(t===47||this._splitOnBackslash&&t===92)if(u)this._from++;else break;else u=!1}return this}cmp(u){return this._caseSensitive?(0,I.compareSubstring)(u,this._value,0,u.length,this._from,this._to):(0,I.compareSubstringIgnoreCase)(u,this._value,0,u.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=k;var g;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})(g||(g={}));class m{constructor(u){this._ignorePathCasing=u,this._states=[],this._stateIdx=0}reset(u){return this._value=u,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new k(!1,!this._ignorePathCasing(u)),this._pathIterator.reset(u.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(u){if(this._states[this._stateIdx]===1)return(0,I.compareIgnoreCase)(u,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,I.compareIgnoreCase)(u,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(u);if(this._states[this._stateIdx]===4)return(0,I.compare)(u,this._value.query);if(this._states[this._stateIdx]===5)return(0,I.compare)(u,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=m;class i{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class s{constructor(u){this._iter=u}static forUris(u=()=>!1){return new s(new m(u))}static forPaths(){return new s(new k)}static forStrings(){return new s(new n)}static forConfigKeys(){return new s(new T)}clear(){this._root=void 0}set(u,t){const r=this._iter.reset(u);let c;for(this._root||(this._root=new i,this._root.segment=r.value()),c=this._root;;){const a=r.cmp(c.segment);if(a>0)c.left||(c.left=new i,c.left.segment=r.value()),c=c.left;else if(a<0)c.right||(c.right=new i,c.right.segment=r.value()),c=c.right;else if(r.hasNext())r.next(),c.mid||(c.mid=new i,c.mid.segment=r.value()),c=c.mid;else break}const o=c.value;return c.value=t,c.key=u,o}get(u){var t;return(t=this._getNode(u))===null||t===void 0?void 0:t.value}_getNode(u){const t=this._iter.reset(u);let r=this._root;for(;r;){const c=t.cmp(r.segment);if(c>0)r=r.left;else if(c<0)r=r.right;else if(t.hasNext())t.next(),r=r.mid;else break}return r}has(u){const t=this._getNode(u);return!((t==null?void 0:t.value)===void 0&&(t==null?void 0:t.mid)===void 0)}delete(u){return this._delete(u,!1)}deleteSuperstr(u){return this._delete(u,!0)}_delete(u,t){const r=this._iter.reset(u),c=[];let o=this._root;for(;o;){const a=r.cmp(o.segment);if(a>0)c.push([1,o]),o=o.left;else if(a<0)c.push([-1,o]),o=o.right;else if(r.hasNext())r.next(),c.push([0,o]),o=o.mid;else{for(t?(o.left=void 0,o.mid=void 0,o.right=void 0):o.value=void 0;c.length>0&&o.isEmpty();){let[f,w]=c.pop();switch(f){case 1:w.left=void 0;break;case 0:w.mid=void 0;break;case-1:w.right=void 0;break}o=w}break}}}findSubstr(u){const t=this._iter.reset(u);let r=this._root,c;for(;r;){const o=t.cmp(r.segment);if(o>0)r=r.left;else if(o<0)r=r.right;else if(t.hasNext())t.next(),c=r.value||c,r=r.mid;else break}return r&&r.value||c}findSuperstr(u){const t=this._iter.reset(u);let r=this._root;for(;r;){const c=t.cmp(r.segment);if(c>0)r=r.left;else if(c<0)r=r.right;else if(t.hasNext())t.next(),r=r.mid;else return r.mid?this._entries(r.mid):void 0}}forEach(u){for(const[t,r]of this)u(r,t)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(u){u&&(yield*this._entries(u.left),u.value&&(yield[u.key,u.value]),yield*this._entries(u.mid),yield*this._entries(u.right))}}e.TernarySearchTree=s;class _{constructor(u,t){this[P]="ResourceMap",u instanceof _?(this.map=new Map(u.map),this.toKey=t!=null?t:_.defaultToKey):(this.map=new Map,this.toKey=u!=null?u:_.defaultToKey)}set(u,t){return this.map.set(this.toKey(u),t),this}get(u){return this.map.get(this.toKey(u))}has(u){return this.map.has(this.toKey(u))}get size(){return this.map.size}clear(){this.map.clear()}delete(u){return this.map.delete(this.toKey(u))}forEach(u,t){typeof t!="undefined"&&(u=u.bind(t));for(let[r,c]of this.map)u(c,E.URI.parse(r),this)}values(){return this.map.values()}*keys(){for(let u of this.map.keys())yield E.URI.parse(u)}*entries(){for(let u of this.map.entries())yield[E.URI.parse(u[0]),u[1]]}*[(P=Symbol.toStringTag,Symbol.iterator)](){for(let u of this.map)yield[E.URI.parse(u[0]),u[1]]}}e.ResourceMap=_,_.defaultToKey=l=>l.toString();var d;(function(l){l[l.None=0]="None",l[l.AsOld=1]="AsOld",l[l.AsNew=2]="AsNew"})(d=e.Touch||(e.Touch={}));class b{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var u;return(u=this._head)===null||u===void 0?void 0:u.value}get last(){var u;return(u=this._tail)===null||u===void 0?void 0:u.value}has(u){return this._map.has(u)}get(u,t=0){const r=this._map.get(u);if(!!r)return t!==0&&this.touch(r,t),r.value}set(u,t,r=0){let c=this._map.get(u);if(c)c.value=t,r!==0&&this.touch(c,r);else{switch(c={key:u,value:t,next:void 0,previous:void 0},r){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(u,c),this._size++}return this}delete(u){return!!this.remove(u)}remove(u){const t=this._map.get(u);if(!!t)return this._map.delete(u),this.removeItem(t),this._size--,t.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const u=this._head;return this._map.delete(u.key),this.removeItem(u),this._size--,u.value}}forEach(u,t){const r=this._state;let c=this._head;for(;c;){if(t?u.bind(t)(c.value,c.key,this):u(c.value,c.key,this),this._state!==r)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const u=this,t=this._state;let r=this._head;const c={[Symbol.iterator](){return c},next(){if(u._state!==t)throw new Error("LinkedMap got modified during iteration.");if(r){const o={value:r.key,done:!1};return r=r.next,o}else return{value:void 0,done:!0}}};return c}values(){const u=this,t=this._state;let r=this._head;const c={[Symbol.iterator](){return c},next(){if(u._state!==t)throw new Error("LinkedMap got modified during iteration.");if(r){const o={value:r.value,done:!1};return r=r.next,o}else return{value:void 0,done:!0}}};return c}entries(){const u=this,t=this._state;let r=this._head;const c={[Symbol.iterator](){return c},next(){if(u._state!==t)throw new Error("LinkedMap got modified during iteration.");if(r){const o={value:[r.key,r.value],done:!1};return r=r.next,o}else return{value:void 0,done:!0}}};return c}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(u){if(!(u>=this.size)){if(u===0){this.clear();return}let t=this._head,r=this.size;for(;t&&r>u;)this._map.delete(t.key),t=t.next,r--;this._head=t,this._size=r,t&&(t.previous=void 0),this._state++}}addItemFirst(u){if(!this._head&&!this._tail)this._tail=u;else if(this._head)u.next=this._head,this._head.previous=u;else throw new Error("Invalid list");this._head=u,this._state++}addItemLast(u){if(!this._head&&!this._tail)this._head=u;else if(this._tail)u.previous=this._tail,this._tail.next=u;else throw new Error("Invalid list");this._tail=u,this._state++}removeItem(u){if(u===this._head&&u===this._tail)this._head=void 0,this._tail=void 0;else if(u===this._head){if(!u.next)throw new Error("Invalid list");u.next.previous=void 0,this._head=u.next}else if(u===this._tail){if(!u.previous)throw new Error("Invalid list");u.previous.next=void 0,this._tail=u.previous}else{const t=u.next,r=u.previous;if(!t||!r)throw new Error("Invalid list");t.previous=r,r.next=t}u.next=void 0,u.previous=void 0,this._state++}touch(u,t){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(t!==1&&t!==2)){if(t===1){if(u===this._head)return;const r=u.next,c=u.previous;u===this._tail?(c.next=void 0,this._tail=c):(r.previous=c,c.next=r),u.previous=void 0,u.next=this._head,this._head.previous=u,this._head=u,this._state++}else if(t===2){if(u===this._tail)return;const r=u.next,c=u.previous;u===this._head?(r.previous=void 0,this._head=r):(r.previous=c,c.next=r),u.next=void 0,u.previous=this._tail,this._tail.next=u,this._tail=u,this._state++}}}toJSON(){const u=[];return this.forEach((t,r)=>{u.push([r,t])}),u}fromJSON(u){this.clear();for(const[t,r]of u)this.set(t,r)}}e.LinkedMap=b;class v extends b{constructor(u,t=1){super();this._limit=u,this._ratio=Math.min(Math.max(0,t),1)}get limit(){return this._limit}set limit(u){this._limit=u,this.checkTrim()}get ratio(){return this._ratio}set ratio(u){this._ratio=Math.min(Math.max(0,u),1),this.checkTrim()}get(u,t=2){return super.get(u,t)}peek(u){return super.get(u,0)}set(u,t){return super.set(u,t,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=v}),define(_e[108],we([0,1,22,8]),function(ie,e,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function P(...ge){return function(Ce,Ae){for(let We=0,be=ge.length;We<be;We++){const qe=ge[We](Ce,Ae);if(qe)return qe}return null}}e.or=P,e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(ge,Ce,Ae){if(!Ae||Ae.length<Ce.length)return null;let We;return ge?We=I.startsWithIgnoreCase(Ae,Ce):We=Ae.indexOf(Ce)===0,We?Ce.length>0?[{start:0,end:Ce.length}]:[]:null}function S(ge,Ce){const Ae=Ce.toLowerCase().indexOf(ge.toLowerCase());return Ae===-1?null:[{start:Ae,end:Ae+ge.length}]}e.matchesContiguousSubString=S;function C(ge,Ce){return y(ge.toLowerCase(),Ce.toLowerCase(),0,0)}e.matchesSubString=C;function y(ge,Ce,Ae,We){if(Ae===ge.length)return[];if(We===Ce.length)return null;if(ge[Ae]===Ce[We]){let be=null;return(be=y(ge,Ce,Ae+1,We+1))?d({start:We,end:We+1},be):null}return y(ge,Ce,Ae,We+1)}function n(ge){return 97<=ge&&ge<=122}function T(ge){return 65<=ge&&ge<=90}e.isUpper=T;function k(ge){return 48<=ge&&ge<=57}function g(ge){return ge===32||ge===9||ge===10||ge===13}const m=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(ge=>m.add(ge.charCodeAt(0)));function i(ge){return g(ge)||m.has(ge)}function s(ge,Ce){return ge===Ce||i(ge)&&i(Ce)}function _(ge){return n(ge)||T(ge)||k(ge)}function d(ge,Ce){return Ce.length===0?Ce=[ge]:ge.end===Ce[0].start?Ce[0].start=ge.start:Ce.unshift(ge),Ce}function b(ge,Ce){for(let Ae=Ce;Ae<ge.length;Ae++){const We=ge.charCodeAt(Ae);if(T(We)||k(We)||Ae>0&&!_(ge.charCodeAt(Ae-1)))return Ae}return ge.length}function v(ge,Ce,Ae,We){if(Ae===ge.length)return[];if(We===Ce.length)return null;if(ge[Ae]!==Ce[We].toLowerCase())return null;{let be=null,qe=We+1;for(be=v(ge,Ce,Ae+1,We+1);!be&&(qe=b(Ce,qe))<Ce.length;)be=v(ge,Ce,Ae+1,qe),qe++;return be===null?null:d({start:We,end:We+1},be)}}function l(ge){let Ce=0,Ae=0,We=0,be=0,qe=0;for(let He=0;He<ge.length;He++)qe=ge.charCodeAt(He),T(qe)&&Ce++,n(qe)&&Ae++,_(qe)&&We++,k(qe)&&be++;const V=Ce/ge.length,Z=Ae/ge.length,pe=We/ge.length,Me=be/ge.length;return{upperPercent:V,lowerPercent:Z,alphaPercent:pe,numericPercent:Me}}function u(ge){const{upperPercent:Ce,lowerPercent:Ae}=ge;return Ae===0&&Ce>.6}function t(ge){const{upperPercent:Ce,lowerPercent:Ae,alphaPercent:We,numericPercent:be}=ge;return Ae>.2&&Ce<.8&&We>.6&&be<.2}function r(ge){let Ce=0,Ae=0,We=0,be=0;for(let qe=0;qe<ge.length;qe++)We=ge.charCodeAt(qe),T(We)&&Ce++,n(We)&&Ae++,g(We)&&be++;return(Ce===0||Ae===0)&&be===0?ge.length<=30:Ce<=5}function c(ge,Ce){if(!Ce||(Ce=Ce.trim(),Ce.length===0)||!r(ge)||Ce.length>60)return null;const Ae=l(Ce);if(!t(Ae)){if(!u(Ae))return null;Ce=Ce.toLowerCase()}let We=null,be=0;for(ge=ge.toLowerCase();be<Ce.length&&(We=v(ge,Ce,0,be))===null;)be=b(Ce,be+1);return We}e.matchesCamelCase=c;function o(ge,Ce,Ae=!1){if(!Ce||Ce.length===0)return null;let We=null,be=0;for(ge=ge.toLowerCase(),Ce=Ce.toLowerCase();be<Ce.length&&(We=a(ge,Ce,0,be,Ae))===null;)be=f(Ce,be+1);return We}e.matchesWords=o;function a(ge,Ce,Ae,We,be){if(Ae===ge.length)return[];if(We===Ce.length)return null;if(s(ge.charCodeAt(Ae),Ce.charCodeAt(We))){let qe=null,V=We+1;if(qe=a(ge,Ce,Ae+1,We+1,be),!be)for(;!qe&&(V=f(Ce,V))<Ce.length;)qe=a(ge,Ce,Ae+1,V,be),V++;return qe===null?null:d({start:We,end:We+1},qe)}else return null}function f(ge,Ce){for(let Ae=Ce;Ae<ge.length;Ae++)if(i(ge.charCodeAt(Ae))||Ae>0&&i(ge.charCodeAt(Ae-1)))return Ae;return ge.length}const w=P(e.matchesPrefix,c,S),D=P(e.matchesPrefix,c,C),p=new E.LRUCache(1e4);function h(ge,Ce,Ae=!1){if(typeof ge!="string"||typeof Ce!="string")return null;let We=p.get(ge);We||(We=new RegExp(I.convertSimple2RegExpPattern(ge),"i"),p.set(ge,We));const be=We.exec(Ce);return be?[{start:be.index,end:be.index+be[0].length}]:Ae?D(ge,Ce):w(ge,Ce)}e.matchesFuzzy=h;function R(ge,Ce){const Ae=U(ge,ge.toLowerCase(),0,Ce,Ce.toLowerCase(),0,!0);return Ae?$(Ae):null}e.matchesFuzzy2=R;function F(ge,Ce,Ae,We,be,qe){const V=Math.min(13,ge.length);for(;Ae<V;Ae++){const Z=U(ge,Ce,Ae,We,be,qe,!1);if(Z)return Z}return[0,qe]}e.anyScore=F;function $(ge){if(typeof ge=="undefined")return[];const Ce=[],Ae=ge[1];for(let We=ge.length-1;We>1;We--){const be=ge[We]+Ae,qe=Ce[Ce.length-1];qe&&qe.end===be?qe.end=be+1:Ce.push({start:be,end:be+1})}return Ce}e.createMatches=$;const se=128;function z(){const ge=[],Ce=[];for(let Ae=0;Ae<=se;Ae++)Ce[Ae]=0;for(let Ae=0;Ae<=se;Ae++)ge.push(Ce.slice(0));return ge}function x(ge){const Ce=[];for(let Ae=0;Ae<=ge;Ae++)Ce[Ae]=0;return Ce}const G=x(2*se),M=x(2*se),N=z(),B=z(),Q=z(),W=!1;function ee(ge,Ce,Ae,We,be){function qe(Z,pe,Me=" "){for(;Z.length<pe;)Z=Me+Z;return Z}let V=` |   |${We.split("").map(Z=>qe(Z,3)).join("|")}
`;for(let Z=0;Z<=Ae;Z++)Z===0?V+=" |":V+=`${Ce[Z-1]}|`,V+=ge[Z].slice(0,be+1).map(pe=>qe(pe.toString(),3)).join("|")+`
`;return V}function re(ge,Ce,Ae,We){ge=ge.substr(Ce),Ae=Ae.substr(We),console.log(ee(B,ge,ge.length,Ae,Ae.length)),console.log(ee(Q,ge,ge.length,Ae,Ae.length)),console.log(ee(N,ge,ge.length,Ae,Ae.length))}function oe(ge,Ce){if(Ce<0||Ce>=ge.length)return!1;const Ae=ge.codePointAt(Ce);switch(Ae){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!I.isEmojiImprecise(Ae)}}function Se(ge,Ce){if(Ce<0||Ce>=ge.length)return!1;switch(ge.charCodeAt(Ce)){case 32:case 9:return!0;default:return!1}}function Pe(ge,Ce,Ae){return Ce[ge]!==Ae[ge]}function $e(ge,Ce,Ae,We,be,qe,V=!1){for(;Ce<Ae&&be<qe;)ge[Ce]===We[be]&&(V&&(G[Ce]=be),Ce+=1),be+=1;return Ce===Ae}e.isPatternInWord=$e;var Fe;(function(ge){ge[ge.Diag=1]="Diag",ge[ge.Left=2]="Left",ge[ge.LeftLeft=3]="LeftLeft"})(Fe||(Fe={}));var ze;(function(ge){ge.Default=[-100,0];function Ce(Ae){return!Ae||Ae.length===2&&Ae[0]===-100&&Ae[1]===0}ge.isDefault=Ce})(ze=e.FuzzyScore||(e.FuzzyScore={}));function U(ge,Ce,Ae,We,be,qe,V){const Z=ge.length>se?se:ge.length,pe=We.length>se?se:We.length;if(!(Ae>=Z||qe>=pe||Z-Ae>pe-qe)&&!!$e(Ce,Ae,Z,be,qe,pe,!0)){K(Z,pe,Ae,qe,Ce,be);let Me=1,He=1,Ue=Ae,Ze=qe;const H=[!1];for(Me=1,Ue=Ae;Ue<Z;Me++,Ue++){const ae=G[Ue],fe=M[Ue],Ee=Ue+1<Z?M[Ue+1]:pe;for(He=ae-qe+1,Ze=ae;Ze<Ee;He++,Ze++){let Ne=Number.MIN_SAFE_INTEGER,Le=!1;Ze<=fe&&(Ne=te(ge,Ce,Ue,Ae,We,be,Ze,pe,qe,N[Me-1][He-1]===0,H));let Ve=0;Ne!==Number.MAX_SAFE_INTEGER&&(Le=!0,Ve=Ne+B[Me-1][He-1]);const Ye=Ze>ae,et=Ye?B[Me][He-1]+(N[Me][He-1]>0?-5:0):0,nt=Ze>ae+1&&N[Me][He-1]>0,st=nt?B[Me][He-2]+(N[Me][He-2]>0?-5:0):0;if(nt&&(!Ye||st>=et)&&(!Le||st>=Ve))B[Me][He]=st,Q[Me][He]=3,N[Me][He]=0;else if(Ye&&(!Le||et>=Ve))B[Me][He]=et,Q[Me][He]=2,N[Me][He]=0;else if(Le)B[Me][He]=Ve,Q[Me][He]=1,N[Me][He]=N[Me-1][He-1]+1;else throw new Error("not possible")}}if(W&&re(ge,Ae,We,qe),!(!H[0]&&!V)){Me--,He--;const ne=[B[Me][He],qe];let de=0,j=0;for(;Me>=1;){let ae=He;do{const fe=Q[Me][ae];if(fe===3)ae=ae-2;else if(fe===2)ae=ae-1;else break}while(ae>=1);de>1&&Ce[Ae+Me-1]===be[qe+He-1]&&!Pe(ae+qe-1,We,be)&&de+1>N[Me][ae]&&(ae=He),ae===He?de++:de=1,j||(j=ae),Me--,He=ae-1,ne.push(He)}pe===Z&&(ne[0]+=2);const Y=j-Z;return ne[0]-=Y,ne}}}e.fuzzyScore=U;function K(ge,Ce,Ae,We,be,qe){let V=ge-1,Z=Ce-1;for(;V>=Ae&&Z>=We;)be[V]===qe[Z]&&(M[V]=Z,V--),Z--}function te(ge,Ce,Ae,We,be,qe,V,Z,pe,Me,He){if(Ce[Ae]!==qe[V])return Number.MIN_SAFE_INTEGER;let Ue=1,Ze=!1;return V===Ae-We?Ue=ge[Ae]===be[V]?7:5:Pe(V,be,qe)&&(V===0||!Pe(V-1,be,qe))?(Ue=ge[Ae]===be[V]?7:5,Ze=!0):oe(qe,V)&&(V===0||!oe(qe,V-1))?Ue=5:(oe(qe,V-1)||Se(qe,V-1))&&(Ue=5,Ze=!0),Ue>1&&Ae===We&&(He[0]=!0),Ze||(Ze=Pe(V,be,qe)||oe(qe,V-1)||Se(qe,V-1)),Ae===We?V>pe&&(Ue-=Ze?3:5):Me?Ue+=Ze?2:0:Ue+=Ze?0:1,V+1===Z&&(Ue-=Ze?3:5),Ue}function le(ge,Ce,Ae,We,be,qe,V){return De(ge,Ce,Ae,We,be,qe,!0,V)}e.fuzzyScoreGracefulAggressive=le;function me(ge,Ce,Ae,We,be,qe,V){return De(ge,Ce,Ae,We,be,qe,!1,V)}e.fuzzyScoreGraceful=me;function De(ge,Ce,Ae,We,be,qe,V,Z){let pe=U(ge,Ce,Ae,We,be,qe,Z);if(pe&&!V)return pe;if(ge.length>=3){const Me=Math.min(7,ge.length-1);for(let He=Ae+1;He<Me;He++){const Ue=Oe(ge,He);if(Ue){const Ze=U(Ue,Ue.toLowerCase(),Ae,We,be,qe,Z);Ze&&(Ze[0]-=3,(!pe||Ze[0]>pe[0])&&(pe=Ze))}}}return pe}function Oe(ge,Ce){if(!(Ce+1>=ge.length)){const Ae=ge[Ce],We=ge[Ce+1];if(Ae!==We)return ge.slice(0,Ce)+We+Ae+ge.slice(Ce+2)}}}),define(_e[109],we([0,1,36,108,8]),function(ie,e,E,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const A=new RegExp(`\\$\\(${E.CSSIcon.iconNameExpression}(?:${E.CSSIcon.iconModifierExpression})?\\)`,"g"),S=new RegExp(`(\\\\)?${A.source}`,"g");function C(s){return s.replace(S,(_,d)=>d?_:`\\${_}`)}e.escapeIcons=C;const y=new RegExp(`\\\\${A.source}`,"g");function n(s){return s.replace(y,_=>`\\${_}`)}e.markdownEscapeEscapedIcons=n;const T=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function k(s){return s.indexOf(e.iconStartMarker)===-1?s:s.replace(T,(_,d,b,v)=>b?_:d||v||"")}e.stripIcons=k;function g(s){const _=s.indexOf(e.iconStartMarker);return _===-1?{text:s}:m(s,_)}e.parseLabelWithIcons=g;function m(s,_){const d=[];let b="";function v(f){if(f){b+=f;for(const w of f)d.push(t)}}let l=-1,u="",t=0,r,c,o=_;const a=s.length;for(v(s.substr(0,_));o<a;)r=s[o],c=s[o+1],r===e.iconStartMarker[0]&&c===e.iconStartMarker[1]?(l=o,v(u),u=e.iconStartMarker,o++):r===")"&&l!==-1?(t+=o-l+1,l=-1,u=""):l!==-1?/^[a-z0-9\-]$/i.test(r)?u+=r:(v(u),l=-1,u=""):v(r),o++;return v(u),{text:b,iconOffsets:d}}function i(s,_,d=!1){const{text:b,iconOffsets:v}=_;if(!v||v.length===0)return(0,I.matchesFuzzy)(s,b,d);const l=(0,P.ltrim)(b," "),u=b.length-l.length,t=(0,I.matchesFuzzy)(s,l,d);if(t)for(const r of t){const c=v[r.start+u]+u;r.start+=c,r.end+=c}return t}e.matchesFuzzyIconAware=i}),define(_e[80],we([0,1,11,109,10]),function(ie,e,E,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markedStringsEquals=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var A;(function(i){i[i.Paragraph=0]="Paragraph",i[i.Break=1]="Break"})(A=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class S{constructor(s="",_=!1){var d,b;if(this.value=s,typeof this.value!="string")throw(0,P.illegalArgument)("value");typeof _=="boolean"?(this.isTrusted=_,this.supportThemeIcons=!1):(this.isTrusted=(d=_.isTrusted)!==null&&d!==void 0?d:void 0,this.supportThemeIcons=(b=_.supportThemeIcons)!==null&&b!==void 0?b:!1)}appendText(s,_=0){return this.value+=k(this.supportThemeIcons?(0,I.escapeIcons)(s):s).replace(/([ \t]+)/g,(d,b)=>"&nbsp;".repeat(b.length)).replace(/^>/gm,"\\>").replace(/\n/g,_===1?`\\
`:`

`),this}appendMarkdown(s){return this.value+=s,this}appendCodeblock(s,_){return this.value+="\n```",this.value+=s,this.value+=`
`,this.value+=_,this.value+="\n```\n",this}}e.MarkdownString=S;function C(i){return y(i)?!i.value:Array.isArray(i)?i.every(C):!0}e.isEmptyMarkdownString=C;function y(i){return i instanceof S?!0:i&&typeof i=="object"?typeof i.value=="string"&&(typeof i.isTrusted=="boolean"||i.isTrusted===void 0)&&(typeof i.supportThemeIcons=="boolean"||i.supportThemeIcons===void 0):!1}e.isMarkdownString=y;function n(i,s){return!i&&!s?!0:!i||!s?!1:Array.isArray(i)&&Array.isArray(s)?(0,E.equals)(i,s,T):y(i)&&y(s)?T(i,s):!1}e.markedStringsEquals=n;function T(i,s){return i===s?!0:!i||!s?!1:i.value===s.value&&i.isTrusted===s.isTrusted&&i.supportThemeIcons===s.supportThemeIcons}function k(i){return i.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=k;function g(i){return i&&i.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=g;function m(i){const s=[],_=i.split("|").map(b=>b.trim());i=_[0];const d=_[1];if(d){const b=/height=(\d+)/.exec(d),v=/width=(\d+)/.exec(d),l=b?b[1]:"",u=v?v[1]:"",t=isFinite(parseInt(u)),r=isFinite(parseInt(l));t&&s.push(`width="${u}"`),r&&s.push(`height="${l}"`)}return{href:i,dimensions:s}}e.parseHrefAndDimensions=m}),define(_e[57],we([0,1,23,8,2]),function(ie,e,E,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function A(n){return JSON.stringify(n,C)}e.stringify=A;function S(n){let T=JSON.parse(n);return T=y(T),T}e.parse=S;function C(n,T){return T instanceof RegExp?{$mid:2,source:T.source,flags:(0,I.regExpFlags)(T)}:T}function y(n,T=0){if(!n||T>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return P.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof E.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let k=0;k<n.length;++k)n[k]=y(n[k],T+1);else for(const k in n)Object.hasOwnProperty.call(n,k)&&(n[k]=y(n[k],T+1))}return n}e.revive=y}),define(_e[18],we([0,1,2,21]),function(ie,e,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var P;(function(C){C.inMemory="inmemory",C.vscode="vscode",C.internal="private",C.walkThrough="walkThrough",C.walkThroughSnippet="walkThroughSnippet",C.http="http",C.https="https",C.file="file",C.mailto="mailto",C.untitled="untitled",C.data="data",C.command="command",C.vscodeRemote="vscode-remote",C.vscodeRemoteResource="vscode-remote-resource",C.userData="vscode-userdata",C.vscodeCustomEditor="vscode-custom-editor",C.vscodeNotebook="vscode-notebook",C.vscodeNotebookCell="vscode-notebook-cell",C.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",C.vscodeSettings="vscode-settings",C.vscodeWorkspaceTrust="vscode-workspace-trust",C.webviewPanel="webview-panel",C.vscodeWebview="vscode-webview",C.extension="extension",C.vscodeFileResource="vscode-file"})(P=e.Schemas||(e.Schemas={}));class A{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(y){this._preferredWebSchema=y}setDelegate(y){this._delegate=y}set(y,n,T){this._hosts[y]=n,this._ports[y]=T}setConnectionToken(y,n){this._connectionTokens[y]=n}rewrite(y){if(this._delegate)return this._delegate(y);const n=y.authority;let T=this._hosts[n];T&&T.indexOf(":")!==-1&&(T=`[${T}]`);const k=this._ports[n],g=this._connectionTokens[n];let m=`path=${encodeURIComponent(y.path)}`;return typeof g=="string"&&(m+=`&tkn=${encodeURIComponent(g)}`),E.URI.from({scheme:I.isWeb?this._preferredWebSchema:P.vscodeRemoteResource,authority:`${T}:${k}`,path:"/vscode-remote-resource",query:m})}}e.RemoteAuthorities=new A;class S{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(y,n,T){const k=this.toUri(y,n);return k.scheme===P.vscodeRemote?e.RemoteAuthorities.rewrite(k):I.isNative&&(T||I.isPreferringBrowserCodeLoad)&&k.scheme===P.file?k.with({scheme:P.vscodeFileResource,authority:k.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):k}asFileUri(y,n){const T=this.toUri(y,n);return T.scheme===P.vscodeFileResource?T.with({scheme:P.file,authority:T.authority!==this.FALLBACK_AUTHORITY?T.authority:null,query:null,fragment:null}):T}toUri(y,n){return E.URI.isUri(y)?y:E.URI.parse(n.toUrl(y))}}e.FileAccess=new S}),define(_e[25],we([0,1,37,12,2,8,18,21]),function(ie,e,E,I,P,A,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(m){return(0,P.uriToFsPath)(m,!0)}e.originalFSPath=y;class n{constructor(i){this._ignorePathCasing=i}compare(i,s,_=!1){return i===s?0:(0,A.compare)(this.getComparisonKey(i,_),this.getComparisonKey(s,_))}isEqual(i,s,_=!1){return i===s?!0:!i||!s?!1:this.getComparisonKey(i,_)===this.getComparisonKey(s,_)}getComparisonKey(i,s=!1){return i.with({path:this._ignorePathCasing(i)?i.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(i){return this._ignorePathCasing(i)}isEqualOrParent(i,s,_=!1){if(i.scheme===s.scheme){if(i.scheme===S.Schemas.file)return E.isEqualOrParent(y(i),y(s),this._ignorePathCasing(i))&&i.query===s.query&&(_||i.fragment===s.fragment);if((0,e.isEqualAuthority)(i.authority,s.authority))return E.isEqualOrParent(i.path,s.path,this._ignorePathCasing(i),"/")&&i.query===s.query&&(_||i.fragment===s.fragment)}return!1}joinPath(i,...s){return P.URI.joinPath(i,...s)}basenameOrAuthority(i){return(0,e.basename)(i)||i.authority}basename(i){return I.posix.basename(i.path)}extname(i){return I.posix.extname(i.path)}dirname(i){if(i.path.length===0)return i;let s;return i.scheme===S.Schemas.file?s=P.URI.file(I.dirname(y(i))).path:(s=I.posix.dirname(i.path),i.authority&&s.length&&s.charCodeAt(0)!==47&&(console.error(`dirname("${i.toString})) resulted in a relative path`),s="/")),i.with({path:s})}normalizePath(i){if(!i.path.length)return i;let s;return i.scheme===S.Schemas.file?s=P.URI.file(I.normalize(y(i))).path:s=I.posix.normalize(i.path),i.with({path:s})}relativePath(i,s){if(!(i.scheme!==s.scheme||!(0,e.isEqualAuthority)(i.authority,s.authority))){if(i.scheme===S.Schemas.file){const b=I.relative(y(i),y(s));return C.isWindows?E.toSlashes(b):b}let _=i.path||"/",d=s.path||"/";if(this._ignorePathCasing(i)){let b=0;for(const v=Math.min(_.length,d.length);b<v&&!(_.charCodeAt(b)!==d.charCodeAt(b)&&_.charAt(b).toLowerCase()!==d.charAt(b).toLowerCase());b++);_=d.substr(0,b)+_.substr(b)}return I.posix.relative(_,d)}}resolvePath(i,s){if(i.scheme===S.Schemas.file){const _=P.URI.file(I.resolve(y(i),s));return i.with({authority:_.authority,path:_.path})}return s.indexOf("/")===-1&&(s=E.toSlashes(s),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s)),i.with({path:I.posix.resolve(i.path,s)})}isAbsolutePath(i){return!!i.path&&i.path[0]==="/"}isEqualAuthority(i,s){return i===s||(0,A.equalsIgnoreCase)(i,s)}hasTrailingPathSeparator(i,s=I.sep){if(i.scheme===S.Schemas.file){const _=y(i);return _.length>E.getRoot(_).length&&_[_.length-1]===s}else{const _=i.path;return _.length>1&&_.charCodeAt(_.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(i.fsPath)}}removeTrailingPathSeparator(i,s=I.sep){return(0,e.hasTrailingPathSeparator)(i,s)?i.with({path:i.path.substr(0,i.path.length-1)}):i}addTrailingPathSeparator(i,s=I.sep){let _=!1;if(i.scheme===S.Schemas.file){const d=y(i);_=d!==void 0&&d.length===E.getRoot(d).length&&d[d.length-1]===s}else{s="/";const d=i.path;_=d.length===1&&d.charCodeAt(d.length-1)===47}return!_&&!(0,e.hasTrailingPathSeparator)(i,s)?i.with({path:i.path+"/"}):i}}e.ExtUri=n,e.extUri=new n(()=>!1),e.extUriBiasedIgnorePathCase=new n(m=>m.scheme===S.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new n(m=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function T(m,i){const s=[];for(let _=0;_<m.length;_++){const d=i(m[_]);m.some((b,v)=>v===_?!1:(0,e.isEqualOrParent)(d,i(b)))||s.push(m[_])}return s}e.distinctParents=T;var k;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function i(s){const _=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach(v=>{const[l,u]=v.split(":");l&&u&&_.set(l,u)});const b=s.path.substring(0,s.path.indexOf(";"));return b&&_.set(m.META_DATA_MIME,b),_}m.parseMetaData=i})(k=e.DataUri||(e.DataUri={}));function g(m,i,s){if(i){let _=m.path;return _&&_[0]!==I.posix.sep&&(_=I.posix.sep+_),m.with({scheme:s,authority:i,path:_})}return m.with({scheme:s})}e.toLocalResource=g}),define(_e[14],we([0,1,20,10,3,6,44,25]),function(ie,e,E,I,P,A,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y(B){return!!B&&typeof B.then=="function"}e.isThenable=y;function n(B){const Q=new E.CancellationTokenSource,W=B(Q.token),ee=new Promise((re,oe)=>{Q.token.onCancellationRequested(()=>{oe((0,I.canceled)())}),Promise.resolve(W).then(Se=>{Q.dispose(),re(Se)},Se=>{Q.dispose(),oe(Se)})});return new class{cancel(){Q.cancel()}then(re,oe){return ee.then(re,oe)}catch(re){return this.then(void 0,re)}finally(re){return ee.finally(re)}}}e.createCancelablePromise=n;function T(B,Q,W){return Promise.race([B,new Promise(ee=>Q.onCancellationRequested(()=>ee(W)))])}e.raceCancellation=T;async function k(B){let Q=-1;const W=B.map((re,oe)=>re.then(Se=>(Q=oe,Se))),ee=await Promise.race(W);return B.forEach((re,oe)=>{oe!==Q&&re.cancel()}),ee}e.raceCancellablePromises=k;function g(B,Q,W){let ee;const re=setTimeout(()=>{ee==null||ee(void 0),W==null||W()},Q);return Promise.race([B.finally(()=>clearTimeout(re)),new Promise(oe=>ee=oe)])}e.raceTimeout=g;function m(B){return new Promise((Q,W)=>{const ee=B();y(ee)?ee.then(Q,W):Q(ee)})}e.asPromise=m;class i{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(Q){if(this.activePromise){if(this.queuedPromiseFactory=Q,!this.queuedPromise){const W=()=>{this.queuedPromise=null;const ee=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,ee};this.queuedPromise=new Promise(ee=>{this.activePromise.then(W,W).then(ee)})}return new Promise((W,ee)=>{this.queuedPromise.then(W,ee)})}return this.activePromise=Q(),new Promise((W,ee)=>{this.activePromise.then(re=>{this.activePromise=null,W(re)},re=>{this.activePromise=null,ee(re)})})}}e.Throttler=i;class s{constructor(){this.current=Promise.resolve(null)}queue(Q){return this.current=this.current.then(()=>Q(),()=>Q())}}e.Sequencer=s;class _{constructor(){this.promiseMap=new Map}queue(Q,W){var ee;const oe=((ee=this.promiseMap.get(Q))!==null&&ee!==void 0?ee:Promise.resolve()).catch(()=>{}).then(W).finally(()=>{this.promiseMap.get(Q)===oe&&this.promiseMap.delete(Q)});return this.promiseMap.set(Q,oe),oe}}e.SequencerByKey=_;class d{constructor(Q){this.defaultDelay=Q,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(Q,W=this.defaultDelay){return this.task=Q,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((ee,re)=>{this.doResolve=ee,this.doReject=re}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const ee=this.task;return this.task=null,ee()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},W),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,I.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=d;class b{constructor(Q){this.delayer=new d(Q),this.throttler=new i}trigger(Q,W){return this.delayer.trigger(()=>this.throttler.queue(Q),W)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=b;class v{constructor(){this._isOpen=!1,this._promise=new Promise((Q,W)=>{this._completePromise=Q})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=v;class l extends v{constructor(Q){super();this._timeout=setTimeout(()=>this.open(),Q)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=l;function u(B,Q){return Q?new Promise((W,ee)=>{const re=setTimeout(W,B);Q.onCancellationRequested(()=>{clearTimeout(re),ee((0,I.canceled)())})}):n(W=>u(B,W))}e.timeout=u;function t(B,Q=0){const W=setTimeout(B,Q);return(0,A.toDisposable)(()=>clearTimeout(W))}e.disposableTimeout=t;function r(B){return B.then(void 0,Q=>{})}e.ignoreErrors=r;function c(B){const Q=[];let W=0;const ee=B.length;function re(){return W<ee?B[W++]():null}function oe(Se){Se!=null&&Q.push(Se);const Pe=re();return Pe?Pe.then(oe):Promise.resolve(Q)}return Promise.resolve(null).then(oe)}e.sequence=c;function o(B,Q=ee=>!!ee,W=null){let ee=0;const re=B.length,oe=()=>{if(ee>=re)return Promise.resolve(W);const Se=B[ee++];return Promise.resolve(Se()).then($e=>Q($e)?Promise.resolve($e):oe())};return oe()}e.first=o;function a(B,Q=ee=>!!ee,W=null){if(B.length===0)return Promise.resolve(W);let ee=B.length;const re=()=>{var oe,Se;ee=-1;for(const Pe of B)(Se=(oe=Pe).cancel)===null||Se===void 0||Se.call(oe)};return new Promise((oe,Se)=>{for(const Pe of B)Pe.then($e=>{--ee>=0&&Q($e)?(re(),oe($e)):ee===0&&oe(W)}).catch($e=>{--ee>=0&&(re(),Se($e))})})}e.firstParallel=a;class f{constructor(Q){this._size=0,this.maxDegreeOfParalellism=Q,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new P.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(Q){return this._size++,new Promise((W,ee)=>{this.outstandingPromises.push({factory:Q,c:W,e:ee}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const Q=this.outstandingPromises.shift();this.runningPromises++;const W=Q.factory();W.then(Q.c,Q.e),W.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=f;class w extends f{constructor(){super(1)}}e.Queue=w;class D{constructor(){this.queues=new Map}queueFor(Q,W=C.extUri){const ee=W.getComparisonKey(Q);let re=this.queues.get(ee);return re||(re=new w,P.Event.once(re.onFinished)(()=>{re==null||re.dispose(),this.queues.delete(ee)}),this.queues.set(ee,re)),re}dispose(){this.queues.forEach(Q=>Q.dispose()),this.queues.clear()}}e.ResourceQueue=D;class p{constructor(Q,W){this._token=-1,typeof Q=="function"&&typeof W=="number"&&this.setIfNotSet(Q,W)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(Q,W){this.cancel(),this._token=setTimeout(()=>{this._token=-1,Q()},W)}setIfNotSet(Q,W){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,Q()},W))}}e.TimeoutTimer=p;class h{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(Q,W){this.cancel(),this._token=setInterval(()=>{Q()},W)}}e.IntervalTimer=h;class R{constructor(Q,W){this.timeoutToken=-1,this.runner=Q,this.timeout=W,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(Q=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,Q)}get delay(){return this.timeout}set delay(Q){this.timeout=Q}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class F extends R{constructor(Q,W){super(Q,W);this.units=[]}work(Q){this.units.push(Q),this.isScheduled()||this.schedule()}doRun(){const Q=this.units;this.units=[],this.runner&&this.runner(Q)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=F,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const B=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=Q=>{const W=setTimeout(()=>Q(B));let ee=!1;return{dispose(){ee||(ee=!0,clearTimeout(W))}}}}else e.runWhenIdle=(B,Q)=>{const W=requestIdleCallback(B,typeof Q=="number"?{timeout:Q}:void 0);let ee=!1;return{dispose(){ee||(ee=!0,cancelIdleCallback(W))}}}}();class ${constructor(Q){this._didRun=!1,this._executor=()=>{try{this._value=Q()}catch(W){this._error=W}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=$;async function se(B,Q,W){let ee;for(let re=0;re<W;re++)try{return await B()}catch(oe){ee=oe,await u(Q)}throw ee}e.retry=se;class z{hasPending(Q){return this._pending?typeof Q=="number"?this._pending.taskId===Q:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var Q;(Q=this._pending)===null||Q===void 0||Q.cancel()}setPending(Q,W,ee){return this._pending={taskId:Q,cancel:()=>ee==null?void 0:ee(),promise:W},W.then(()=>this.donePending(Q),()=>this.donePending(Q)),W}donePending(Q){this._pending&&Q===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const Q=this._next;this._next=void 0,Q.run().then(Q.promiseResolve,Q.promiseReject)}}setNext(Q){if(this._next)this._next.run=Q;else{let W,ee;const re=new Promise((oe,Se)=>{W=oe,ee=Se});this._next={run:Q,promise:re,promiseResolve:W,promiseReject:ee}}return this._next.promise}}e.TaskSequentializer=z;class x{constructor(Q){this.interval=Q,this.lastIncrementTime=0,this.value=0}increment(){const Q=Date.now();return Q-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=Q,this.value=0),this.value++,this.value}}e.IntervalCounter=x;class G{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((Q,W)=>{this.completeCallback=Q,this.errorCallback=W})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(Q){return new Promise(W=>{this.completeCallback(Q),this.resolved=!0,W()})}error(Q){return new Promise(W=>{this.errorCallback(Q),this.rejected=!0,W()})}cancel(){new Promise(Q=>{this.errorCallback((0,I.canceled)()),this.rejected=!0,Q()})}}e.DeferredPromise=G;class M extends P.Emitter{async fireAsync(Q,W,ee){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new S.LinkedList);for(const re of this._listeners)this._asyncDeliveryQueue.push([re,Q]);for(;this._asyncDeliveryQueue.size>0&&!W.isCancellationRequested;){const[re,oe]=this._asyncDeliveryQueue.shift(),Se=[],Pe=Object.assign(Object.assign({},oe),{waitUntil:$e=>{if(Object.isFrozen(Se))throw new Error("waitUntil can NOT be called asynchronous");ee&&($e=ee($e,typeof re=="function"?re:re[0])),Se.push($e)}});try{typeof re=="function"?re.call(void 0,Pe):re[0].call(re[1],Pe)}catch($e){(0,I.onUnexpectedError)($e);continue}Object.freeze(Se),await N.settled(Se).catch($e=>(0,I.onUnexpectedError)($e))}}}}e.AsyncEmitter=M;var N;(function(B){async function Q(oe){return typeof Promise.allSettled=="function"?W(oe):ee(oe)}B.allSettled=Q;async function W(oe){return Promise.allSettled(oe)}async function ee(oe){return Promise.all(oe.map(Se=>Se.then(Pe=>({status:"fulfilled",value:Pe}),Pe=>({status:"rejected",reason:Pe}))))}async function re(oe){let Se;const Pe=await Promise.all(oe.map($e=>$e.then(Fe=>Fe,Fe=>{Se||(Se=Fe)})));if(typeof Se!="undefined")throw Se;return Pe}B.settled=re})(N=e.Promises||(e.Promises={}))}),define(_e[110],we([0,1,12,14]),function(ie,e,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesDefault=e.compareFileNames=void 0;const P=new I.IdleValue(()=>{const l=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:l,collatorIsNumeric:l.resolvedOptions().numeric}}),A=new I.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),S=new I.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function C(l,u,t=!1){const r=l||"",c=u||"",o=P.value.collator.compare(r,c);return P.value.collatorIsNumeric&&o===0&&r!==c?r<c?-1:1:o}e.compareFileNames=C;function y(l,u){const t=A.value.collator;return l=l||"",u=u||"",s(t,l,u)}e.compareFileNamesDefault=y;function n(l,u,t=!1){t||(l=l&&l.toLowerCase(),u=u&&u.toLowerCase());const[r,c]=m(l),[o,a]=m(u);return r!==o?r<o?-1:1:c===a?0:c<a?-1:1}e.noIntlCompareFileNames=n;function T(l,u){const[t,r]=m(l),[c,o]=m(u);let a=P.value.collator.compare(r,o);if(a===0){if(P.value.collatorIsNumeric&&r!==o)return r<o?-1:1;if(a=P.value.collator.compare(t,c),P.value.collatorIsNumeric&&a===0&&t!==c)return t<c?-1:1}return a}e.compareFileExtensions=T;function k(l,u){l=l||"",u=u||"";const t=i(l),r=i(u),c=A.value.collator,o=S.value.collator;let a;return a=s(o,t,r),a!==0?a:s(c,l,u)}e.compareFileExtensionsDefault=k;const g=/^(.*?)(\.([^.]*))?$/;function m(l,u=!1){const t=l?g.exec(l):[];let r=[t&&t[1]||"",t&&t[3]||""];return u&&(!r[0]&&r[1]||r[0]&&r[0].charAt(0)===".")&&(r=[r[0]+"."+r[1],""]),r}function i(l){const u=l?g.exec(l):[];return u&&u[1]&&u[1].charAt(0)!=="."&&u[3]||""}function s(l,u,t){let r=l.compare(u,t);return r!==0?r:u.length!==t.length?u.length<t.length?-1:1:0}function _(l,u,t=!1){return t||(l=l&&l.toLowerCase(),u=u&&u.toLowerCase()),l===u?0:l<u?-1:1}function d(l,u,t=!1){const r=l.split(E.sep),c=u.split(E.sep),o=r.length-1,a=c.length-1;let f,w;for(let D=0;;D++){if(f=o===D,w=a===D,f&&w)return C(r[D],c[D],t);if(f)return-1;if(w)return 1;const p=_(r[D],c[D],t);if(p!==0)return p}}e.comparePaths=d;function b(l,u,t){const r=l.toLowerCase(),c=u.toLowerCase(),o=v(l,u,t);if(o)return o;const a=r.endsWith(t),f=c.endsWith(t);if(a!==f)return a?-1:1;const w=C(r,c);return w!==0?w:r.localeCompare(c)}e.compareAnything=b;function v(l,u,t){const r=l.toLowerCase(),c=u.toLowerCase(),o=r.startsWith(t),a=c.startsWith(t);if(o!==a)return o?-1:1;if(o&&a){if(r.length<c.length)return-1;if(r.length>c.length)return 1}return 0}e.compareByPrefix=v}),define(_e[28],we([0,1,8,37,12,22,14]),function(ie,e,E,I,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function C(){return Object.create(null)}e.getEmptyExpression=C;const y="**",n="/",T="[/\\\\]",k="[^/\\\\]",g=/\//g;function m(W){switch(W){case 0:return"";case 1:return`${k}*?`;default:return`(?:${T}|${k}+${T}|${T}${k}+)*?`}}function i(W,ee){if(!W)return[];const re=[];let oe=!1,Se=!1,Pe="";for(const $e of W){switch($e){case ee:if(!oe&&!Se){re.push(Pe),Pe="";continue}break;case"{":oe=!0;break;case"}":oe=!1;break;case"[":Se=!0;break;case"]":Se=!1;break}Pe+=$e}return Pe&&re.push(Pe),re}e.splitGlobAware=i;function s(W){if(!W)return"";let ee="";const re=i(W,n);if(re.every(oe=>oe===y))ee=".*";else{let oe=!1;re.forEach((Se,Pe)=>{if(Se===y){oe||(ee+=m(2),oe=!0);return}let $e=!1,Fe="",ze=!1,U="";for(const K of Se){if(K!=="}"&&$e){Fe+=K;continue}if(ze&&(K!=="]"||!U)){let te;K==="-"?te=K:(K==="^"||K==="!")&&!U?te="^":K===n?te="":te=E.escapeRegExpCharacters(K),U+=te;continue}switch(K){case"{":$e=!0;continue;case"[":ze=!0;continue;case"}":ee+=`(?:${i(Fe,",").map(me=>s(me)).join("|")})`,$e=!1,Fe="";break;case"]":ee+="["+U+"]",ze=!1,U="";break;case"?":ee+=k;continue;case"*":ee+=m(1);continue;default:ee+=E.escapeRegExpCharacters(K)}}Pe<re.length-1&&(re[Pe+1]!==y||Pe+2<re.length)&&(ee+=T),oe=!1})}return ee}const _=/^\*\*\/\*\.[\w\.-]+$/,d=/^\*\*\/([\w\.-]+)\/?$/,b=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,v=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new A.LRUCache(1e4),r=function(){return!1},c=function(){return null};function o(W,ee){if(!W)return c;let re;typeof W!="string"?re=W.pattern:re=W,re=re.trim();const oe=`${re}_${!!ee.trimForExclusions}`;let Se=t.get(oe);if(Se)return a(Se,W);let Pe;if(_.test(re)){const $e=re.substr(4);Se=function(Fe,ze){return typeof Fe=="string"&&Fe.endsWith($e)?re:null}}else(Pe=d.exec(f(re,ee)))?Se=w(Pe[1],re):(ee.trimForExclusions?v:b).test(re)?Se=D(re,ee):(Pe=l.exec(f(re,ee)))?Se=p(Pe[1].substr(1),re,!0):(Pe=u.exec(f(re,ee)))?Se=p(Pe[1],re,!1):Se=h(re);return t.set(oe,Se),a(Se,W)}function a(W,ee){return typeof ee=="string"?W:function(re,oe){return I.isEqualOrParent(re,ee.base)?W(P.relative(ee.base,re),oe):null}}function f(W,ee){return ee.trimForExclusions&&W.endsWith("/**")?W.substr(0,W.length-2):W}function w(W,ee){const re=`/${W}`,oe=`\\${W}`,Se=function($e,Fe){return typeof $e!="string"?null:Fe?Fe===W?ee:null:$e===W||$e.endsWith(re)||$e.endsWith(oe)?ee:null},Pe=[W];return Se.basenames=Pe,Se.patterns=[ee],Se.allBasenames=Pe,Se}function D(W,ee){const re=Q(W.slice(1,-1).split(",").map(Fe=>o(Fe,ee)).filter(Fe=>Fe!==c),W),oe=re.length;if(!oe)return c;if(oe===1)return re[0];const Se=function(Fe,ze){for(let U=0,K=re.length;U<K;U++)if(re[U](Fe,ze))return W;return null},Pe=re.find(Fe=>!!Fe.allBasenames);Pe&&(Se.allBasenames=Pe.allBasenames);const $e=re.reduce((Fe,ze)=>ze.allPaths?Fe.concat(ze.allPaths):Fe,[]);return $e.length&&(Se.allPaths=$e),Se}function p(W,ee,re){const oe=P.sep===P.posix.sep,Se=oe?W:W.replace(g,P.sep),Pe=P.sep+Se,$e=P.posix.sep+W,Fe=re?function(ze,U){return typeof ze=="string"&&(ze===Se||ze.endsWith(Pe)||!oe&&(ze===W||ze.endsWith($e)))?ee:null}:function(ze,U){return typeof ze=="string"&&(ze===Se||!oe&&ze===W)?ee:null};return Fe.allPaths=[(re?"*/":"./")+W],Fe}function h(W){try{const ee=new RegExp(`^${s(W)}$`);return function(re){return ee.lastIndex=0,typeof re=="string"&&ee.test(re)?W:null}}catch(ee){return c}}function R(W,ee,re){return!W||typeof ee!="string"?!1:F(W)(ee,void 0,re)}e.match=R;function F(W,ee={}){if(!W)return r;if(typeof W=="string"||x(W)){const re=o(W,ee);if(re===c)return r;const oe=function(Se,Pe){return!!re(Se,Pe)};return re.allBasenames&&(oe.allBasenames=re.allBasenames),re.allPaths&&(oe.allPaths=re.allPaths),oe}return N(W,ee)}e.parse=F;function $(W){if(!!W){let ee;return re=>(ee||(ee=(W()||Promise.resolve([])).then(oe=>oe?z(oe):{})),ee.then(oe=>!!oe[re]))}}e.hasSiblingPromiseFn=$;function se(W){if(!!W){let ee;return re=>{if(!ee){const oe=W();ee=oe?z(oe):{}}return!!ee[re]}}}e.hasSiblingFn=se;function z(W){const ee={};for(const re of W)ee[re]=!0;return ee}function x(W){const ee=W;return ee&&typeof ee.base=="string"&&typeof ee.pattern=="string"}e.isRelativePattern=x;function G(W){return W.allBasenames||[]}e.getBasenameTerms=G;function M(W){return W.allPaths||[]}e.getPathTerms=M;function N(W,ee){const re=Q(Object.getOwnPropertyNames(W).map(Fe=>B(Fe,W[Fe],ee)).filter(Fe=>Fe!==c)),oe=re.length;if(!oe)return c;if(!re.some(Fe=>!!Fe.requiresSiblings)){if(oe===1)return re[0];const Fe=function(K,te){for(let le=0,me=re.length;le<me;le++){const De=re[le](K,te);if(De)return De}return null},ze=re.find(K=>!!K.allBasenames);ze&&(Fe.allBasenames=ze.allBasenames);const U=re.reduce((K,te)=>te.allPaths?K.concat(te.allPaths):K,[]);return U.length&&(Fe.allPaths=U),Fe}const Se=function(Fe,ze,U){let K;for(let te=0,le=re.length;te<le;te++){const me=re[te];me.requiresSiblings&&U&&(ze||(ze=P.basename(Fe)),K||(K=ze.substr(0,ze.length-P.extname(Fe).length)));const De=me(Fe,ze,K,U);if(De)return De}return null},Pe=re.find(Fe=>!!Fe.allBasenames);Pe&&(Se.allBasenames=Pe.allBasenames);const $e=re.reduce((Fe,ze)=>ze.allPaths?Fe.concat(ze.allPaths):Fe,[]);return $e.length&&(Se.allPaths=$e),Se}function B(W,ee,re){if(ee===!1)return c;const oe=o(W,re);if(oe===c)return c;if(typeof ee=="boolean")return oe;if(ee){const Se=ee.when;if(typeof Se=="string"){const Pe=($e,Fe,ze,U)=>{if(!U||!oe($e,Fe))return null;const K=Se.replace("$(basename)",ze),te=U(K);return(0,S.isThenable)(te)?te.then(le=>le?W:null):te?W:null};return Pe.requiresSiblings=!0,Pe}}return oe}function Q(W,ee){const re=W.filter(Fe=>!!Fe.basenames);if(re.length<2)return W;const oe=re.reduce((Fe,ze)=>{const U=ze.basenames;return U?Fe.concat(U):Fe},[]);let Se;if(ee){Se=[];for(let Fe=0,ze=oe.length;Fe<ze;Fe++)Se.push(ee)}else Se=re.reduce((Fe,ze)=>{const U=ze.patterns;return U?Fe.concat(U):Fe},[]);const Pe=function(Fe,ze){if(typeof Fe!="string")return null;if(!ze){let K;for(K=Fe.length;K>0;K--){const te=Fe.charCodeAt(K-1);if(te===47||te===92)break}ze=Fe.substr(K)}const U=oe.indexOf(ze);return U!==-1?Se[U]:null};Pe.basenames=oe,Pe.patterns=Se,Pe.allBasenames=oe;const $e=W.filter(Fe=>!Fe.basenames);return $e.push(Pe),$e}}),define(_e[58],we([0,1,2,12,8,18,21,25,37]),function(ie,e,E,I,P,A,S,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function n(o,a,f){if(typeof o=="string"&&(o=E.URI.file(o)),f){const D=f.getWorkspaceFolder(o);if(D){const p=f.getWorkspace().folders.length>1;let h;if((0,C.isEqual)(D.uri,o)?h="":h=(0,C.relativePath)(D.uri,o),p){const R=D.name?D.name:(0,C.basename)(D.uri);h=h?R+" \u2022 "+h:R}return h}}if(o.scheme!==A.Schemas.file&&o.scheme!==A.Schemas.untitled)return o.with({query:null,fragment:null}).toString(!0);if((0,y.hasDriveLetter)(o.fsPath))return(0,I.normalize)(k(o.fsPath));let w=(0,I.normalize)(o.fsPath);return!S.isWindows&&(a==null?void 0:a.userHome)&&(w=m(w,a.userHome.fsPath)),w}e.getPathLabel=n;function T(o){if(!!o){typeof o=="string"&&(o=E.URI.file(o));const a=(0,C.basename)(o)||(o.scheme===A.Schemas.file?o.fsPath:o.path);return S.isWindows&&(0,y.isRootOrDriveLetter)(a)?k(a):a}}e.getBaseLabel=T;function k(o){return(0,y.hasDriveLetter)(o)?o.charAt(0).toUpperCase()+o.slice(1):o}e.normalizeDriveLetter=k;let g=Object.create(null);function m(o,a){if(S.isWindows||!o||!a)return o;let f=g.original===a?g.normalized:void 0;return f||(f=`${(0,P.rtrim)(a,I.posix.sep)}${I.posix.sep}`,g={original:a,normalized:f}),(S.isLinux?o.startsWith(f):(0,P.startsWithIgnoreCase)(o,f))&&(o=`~/${o.substr(f.length)}`),o}e.tildify=m;function i(o,a){return o.replace(/^~($|\/|\\)/,`${a}$1`)}e.untildify=i;const s="\u2026",_="\\\\",d="~";function b(o,a=I.sep){const f=new Array(o.length);let w=!1;for(let D=0;D<o.length;D++){let p=o[D];if(p===""){f[D]=`.${a}`;continue}if(!p){f[D]=p;continue}w=!0;let h="";p.indexOf(_)===0?(h=p.substr(0,p.indexOf(_)+_.length),p=p.substr(p.indexOf(_)+_.length)):p.indexOf(a)===0?(h=p.substr(0,p.indexOf(a)+a.length),p=p.substr(p.indexOf(a)+a.length)):p.indexOf(d)===0&&(h=p.substr(0,p.indexOf(d)+d.length),p=p.substr(p.indexOf(d)+d.length));const R=p.split(a);for(let F=1;w&&F<=R.length;F++)for(let $=R.length-F;w&&$>=0;$--){w=!1;let se=R.slice($,$+F).join(a);for(let z=0;!w&&z<o.length;z++)if(z!==D&&o[z]&&o[z].indexOf(se)>-1){const x=$+F===R.length,G=$>0&&o[z].indexOf(a)>-1?a+se:se,M=o[z].endsWith(G);w=!x||M}if(!w){let z="";(R[0].endsWith(":")||h!=="")&&($===1&&($=0,F++,se=R[0]+a+se),$>0&&(z=R[0]+a),z=h+z),$>0&&(z=z+s+a),z=z+se,$+F<R.length&&(z=z+a+s),f[D]=z}}w&&(f[D]=p)}return f}e.shorten=b;var v;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(v||(v={}));function l(o,a=Object.create(null)){const f=[];let w=!1,D="";for(const p of o)if(p==="$"||w&&p==="{")D&&f.push({value:D,type:v.TEXT}),D="",w=!0;else if(p==="}"&&w){const h=a[D];if(typeof h=="string")h.length&&f.push({value:h,type:v.VARIABLE});else if(h){const R=f[f.length-1];(!R||R.type!==v.SEPARATOR)&&f.push({value:h.label,type:v.SEPARATOR})}D="",w=!1}else D+=p;return D&&!w&&f.push({value:D,type:v.TEXT}),f.filter((p,h)=>{if(p.type===v.SEPARATOR){const R=f[h-1],F=f[h+1];return[R,F].every($=>$&&($.type===v.VARIABLE||$.type===v.TEXT)&&$.value.length>0)}return!0}).map(p=>p.value).join("")}e.template=l;function u(o,a){return S.isMacintosh||a?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,S.isMacintosh?"&":"&&"):o.replace(/&&|&/g,f=>f==="&"?"&&":"&")}e.mnemonicMenuLabel=u;function t(o,a){return S.isMacintosh||a?o.replace(/\(&&\w\)|&&/g,""):S.isWindows?o.replace(/&&|&/g,f=>f==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function r(o){return o.replace(/&/g,"&&")}e.unmnemonicLabel=r;function c(o){const a=o.indexOf("/")!==-1?I.posix:I.win32,f=a.basename(o),w=a.dirname(o);return f.length?{name:f,parentPath:w}:{name:w,parentPath:""}}e.splitName=c}),define(_e[111],we([0,1,2]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function I(T){return T.toJSON()}class P{constructor(k){this._uriTransformer=k}transformIncoming(k){const g=this._uriTransformer.transformIncoming(k);return g===k?k:I(E.URI.from(g))}transformOutgoing(k){const g=this._uriTransformer.transformOutgoing(k);return g===k?k:I(E.URI.from(g))}transformOutgoingURI(k){const g=this._uriTransformer.transformOutgoing(k);return g===k?k:E.URI.from(g)}transformOutgoingScheme(k){return this._uriTransformer.transformOutgoingScheme(k)}}e.URITransformer=P,e.DefaultURITransformer=new class{transformIncoming(T){return T}transformOutgoing(T){return T}transformOutgoingURI(T){return T}transformOutgoingScheme(T){return T}};function A(T,k,g){if(!T||g>200)return null;if(typeof T=="object"){if(T instanceof E.URI)return k.transformOutgoing(T);for(let m in T)if(Object.hasOwnProperty.call(T,m)){const i=A(T[m],k,g+1);i!==null&&(T[m]=i)}}return null}function S(T,k){const g=A(T,k,0);return g===null?T:g}e.transformOutgoingURIs=S;function C(T,k,g,m){if(!T||m>200)return null;if(typeof T=="object"){if(T.$mid===1)return g?E.URI.revive(k.transformIncoming(T)):k.transformIncoming(T);for(let i in T)if(Object.hasOwnProperty.call(T,i)){const s=C(T[i],k,g,m+1);s!==null&&(T[i]=s)}}return null}function y(T,k){const g=C(T,k,!1,0);return g===null?T:g}e.transformIncomingURIs=y;function n(T,k){const g=C(T,k,!0,0);return g===null?T:g}e.transformAndReviveIncomingURIs=n}),define(_e[29],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function I(y){return E.test(y)}e.isUUID=I;const P=new Uint8Array(16),A=[];for(let y=0;y<256;y++)A.push(y.toString(16).padStart(2,"0"));let S;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?S=crypto.getRandomValues.bind(crypto):S=function(y){for(let n=0;n<y.length;n++)y[n]=Math.floor(Math.random()*256);return y};function C(){S(P),P[6]=P[6]&15|64,P[8]=P[8]&63|128;let y=0,n="";return n+=A[P[y++]],n+=A[P[y++]],n+=A[P[y++]],n+=A[P[y++]],n+="-",n+=A[P[y++]],n+=A[P[y++]],n+="-",n+=A[P[y++]],n+=A[P[y++]],n+="-",n+=A[P[y++]],n+=A[P[y++]],n+="-",n+=A[P[y++]],n+=A[P[y++]],n+=A[P[y++]],n+=A[P[y++]],n+=A[P[y++]],n+=A[P[y++]],n}e.generateUuid=C}),define(_e[81],we([0,1,79]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class I{constructor(C){let y=(0,E.toUint8)(C);this._defaultValue=y,this._asciiMap=I._createAsciiMap(y),this._map=new Map}static _createAsciiMap(C){let y=new Uint8Array(256);for(let n=0;n<256;n++)y[n]=C;return y}set(C,y){let n=(0,E.toUint8)(y);C>=0&&C<256?this._asciiMap[C]=n:this._map.set(C,n)}get(C){return C>=0&&C<256?this._asciiMap[C]:this._map.get(C)||this._defaultValue}}e.CharacterClassifier=I;var P;(function(S){S[S.False=0]="False",S[S.True=1]="True"})(P||(P={}));class A{constructor(){this._actual=new I(0)}add(C){this._actual.set(C,1)}has(C){return this._actual.get(C)===1}}e.CharacterSet=A}),define(_e[112],we([0,1,81]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var I;(function(S){S[S.Regular=0]="Regular",S[S.Whitespace=1]="Whitespace",S[S.WordSeparator=2]="WordSeparator"})(I=e.WordCharacterClass||(e.WordCharacterClass={}));class P extends E.CharacterClassifier{constructor(C){super(0);for(let y=0,n=C.length;y<n;y++)this.set(C.charCodeAt(y),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=P;function A(S){let C={};return y=>(C.hasOwnProperty(y)||(C[y]=S(y)),C[y])}e.getMapForWordSeparators=A(S=>new P(S))}),define(_e[38],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class E{constructor(P,A){this.lineNumber=P,this.column=A}with(P=this.lineNumber,A=this.column){return P===this.lineNumber&&A===this.column?this:new E(P,A)}delta(P=0,A=0){return this.with(this.lineNumber+P,this.column+A)}equals(P){return E.equals(this,P)}static equals(P,A){return!P&&!A?!0:!!P&&!!A&&P.lineNumber===A.lineNumber&&P.column===A.column}isBefore(P){return E.isBefore(this,P)}static isBefore(P,A){return P.lineNumber<A.lineNumber?!0:A.lineNumber<P.lineNumber?!1:P.column<A.column}isBeforeOrEqual(P){return E.isBeforeOrEqual(this,P)}static isBeforeOrEqual(P,A){return P.lineNumber<A.lineNumber?!0:A.lineNumber<P.lineNumber?!1:P.column<=A.column}static compare(P,A){let S=P.lineNumber|0,C=A.lineNumber|0;if(S===C){let y=P.column|0,n=A.column|0;return y-n}return S-C}clone(){return new E(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(P){return new E(P.lineNumber,P.column)}static isIPosition(P){return P&&typeof P.lineNumber=="number"&&typeof P.column=="number"}}e.Position=E}),define(_e[32],we([0,1,38]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class I{constructor(A,S,C,y){A>C||A===C&&S>y?(this.startLineNumber=C,this.startColumn=y,this.endLineNumber=A,this.endColumn=S):(this.startLineNumber=A,this.startColumn=S,this.endLineNumber=C,this.endColumn=y)}isEmpty(){return I.isEmpty(this)}static isEmpty(A){return A.startLineNumber===A.endLineNumber&&A.startColumn===A.endColumn}containsPosition(A){return I.containsPosition(this,A)}static containsPosition(A,S){return!(S.lineNumber<A.startLineNumber||S.lineNumber>A.endLineNumber||S.lineNumber===A.startLineNumber&&S.column<A.startColumn||S.lineNumber===A.endLineNumber&&S.column>A.endColumn)}containsRange(A){return I.containsRange(this,A)}static containsRange(A,S){return!(S.startLineNumber<A.startLineNumber||S.endLineNumber<A.startLineNumber||S.startLineNumber>A.endLineNumber||S.endLineNumber>A.endLineNumber||S.startLineNumber===A.startLineNumber&&S.startColumn<A.startColumn||S.endLineNumber===A.endLineNumber&&S.endColumn>A.endColumn)}strictContainsRange(A){return I.strictContainsRange(this,A)}static strictContainsRange(A,S){return!(S.startLineNumber<A.startLineNumber||S.endLineNumber<A.startLineNumber||S.startLineNumber>A.endLineNumber||S.endLineNumber>A.endLineNumber||S.startLineNumber===A.startLineNumber&&S.startColumn<=A.startColumn||S.endLineNumber===A.endLineNumber&&S.endColumn>=A.endColumn)}plusRange(A){return I.plusRange(this,A)}static plusRange(A,S){let C,y,n,T;return S.startLineNumber<A.startLineNumber?(C=S.startLineNumber,y=S.startColumn):S.startLineNumber===A.startLineNumber?(C=S.startLineNumber,y=Math.min(S.startColumn,A.startColumn)):(C=A.startLineNumber,y=A.startColumn),S.endLineNumber>A.endLineNumber?(n=S.endLineNumber,T=S.endColumn):S.endLineNumber===A.endLineNumber?(n=S.endLineNumber,T=Math.max(S.endColumn,A.endColumn)):(n=A.endLineNumber,T=A.endColumn),new I(C,y,n,T)}intersectRanges(A){return I.intersectRanges(this,A)}static intersectRanges(A,S){let C=A.startLineNumber,y=A.startColumn,n=A.endLineNumber,T=A.endColumn,k=S.startLineNumber,g=S.startColumn,m=S.endLineNumber,i=S.endColumn;return C<k?(C=k,y=g):C===k&&(y=Math.max(y,g)),n>m?(n=m,T=i):n===m&&(T=Math.min(T,i)),C>n||C===n&&y>T?null:new I(C,y,n,T)}equalsRange(A){return I.equalsRange(this,A)}static equalsRange(A,S){return!!A&&!!S&&A.startLineNumber===S.startLineNumber&&A.startColumn===S.startColumn&&A.endLineNumber===S.endLineNumber&&A.endColumn===S.endColumn}getEndPosition(){return I.getEndPosition(this)}static getEndPosition(A){return new E.Position(A.endLineNumber,A.endColumn)}getStartPosition(){return I.getStartPosition(this)}static getStartPosition(A){return new E.Position(A.startLineNumber,A.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(A,S){return new I(this.startLineNumber,this.startColumn,A,S)}setStartPosition(A,S){return new I(A,S,this.endLineNumber,this.endColumn)}collapseToStart(){return I.collapseToStart(this)}static collapseToStart(A){return new I(A.startLineNumber,A.startColumn,A.startLineNumber,A.startColumn)}static fromPositions(A,S=A){return new I(A.lineNumber,A.column,S.lineNumber,S.column)}static lift(A){return A?new I(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):null}static isIRange(A){return A&&typeof A.startLineNumber=="number"&&typeof A.startColumn=="number"&&typeof A.endLineNumber=="number"&&typeof A.endColumn=="number"}static areIntersectingOrTouching(A,S){return!(A.endLineNumber<S.startLineNumber||A.endLineNumber===S.startLineNumber&&A.endColumn<S.startColumn||S.endLineNumber<A.startLineNumber||S.endLineNumber===A.startLineNumber&&S.endColumn<A.startColumn)}static areIntersecting(A,S){return!(A.endLineNumber<S.startLineNumber||A.endLineNumber===S.startLineNumber&&A.endColumn<=S.startColumn||S.endLineNumber<A.startLineNumber||S.endLineNumber===A.startLineNumber&&S.endColumn<=A.startColumn)}static compareRangesUsingStarts(A,S){if(A&&S){const n=A.startLineNumber|0,T=S.startLineNumber|0;if(n===T){const k=A.startColumn|0,g=S.startColumn|0;if(k===g){const m=A.endLineNumber|0,i=S.endLineNumber|0;if(m===i){const s=A.endColumn|0,_=S.endColumn|0;return s-_}return m-i}return k-g}return n-T}return(A?1:0)-(S?1:0)}static compareRangesUsingEnds(A,S){return A.endLineNumber===S.endLineNumber?A.endColumn===S.endColumn?A.startLineNumber===S.startLineNumber?A.startColumn-S.startColumn:A.startLineNumber-S.startLineNumber:A.endColumn-S.endColumn:A.endLineNumber-S.endLineNumber}static spansMultipleLines(A){return A.endLineNumber>A.startLineNumber}}e.Range=I}),define(_e[113],we([0,1,38,32]),function(ie,e,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var P;(function(S){S[S.LTR=0]="LTR",S[S.RTL=1]="RTL"})(P=e.SelectionDirection||(e.SelectionDirection={}));class A extends I.Range{constructor(C,y,n,T){super(C,y,n,T);this.selectionStartLineNumber=C,this.selectionStartColumn=y,this.positionLineNumber=n,this.positionColumn=T}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(C){return A.selectionsEqual(this,C)}static selectionsEqual(C,y){return C.selectionStartLineNumber===y.selectionStartLineNumber&&C.selectionStartColumn===y.selectionStartColumn&&C.positionLineNumber===y.positionLineNumber&&C.positionColumn===y.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(C,y){return this.getDirection()===0?new A(this.startLineNumber,this.startColumn,C,y):new A(C,y,this.startLineNumber,this.startColumn)}getPosition(){return new E.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(C,y){return this.getDirection()===0?new A(C,y,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,C,y)}static fromPositions(C,y=C){return new A(C.lineNumber,C.column,y.lineNumber,y.column)}static liftSelection(C){return new A(C.selectionStartLineNumber,C.selectionStartColumn,C.positionLineNumber,C.positionColumn)}static selectionsArrEqual(C,y){if(C&&!y||!C&&y)return!1;if(!C&&!y)return!0;if(C.length!==y.length)return!1;for(let n=0,T=C.length;n<T;n++)if(!this.selectionsEqual(C[n],y[n]))return!1;return!0}static isISelection(C){return C&&typeof C.selectionStartLineNumber=="number"&&typeof C.selectionStartColumn=="number"&&typeof C.positionLineNumber=="number"&&typeof C.positionColumn=="number"}static createWithDirection(C,y,n,T,k){return k===0?new A(C,y,n,T):new A(n,T,C,y)}}e.Selection=A}),define(_e[82],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var E;(function(m){m[m.Left=1]="Left",m[m.Center=2]="Center",m[m.Right=4]="Right",m[m.Full=7]="Full"})(E=e.OverviewRulerLane||(e.OverviewRulerLane={}));var I;(function(m){m[m.Inline=1]="Inline",m[m.Gutter=2]="Gutter"})(I=e.MinimapPosition||(e.MinimapPosition={}));var P;(function(m){m[m.TextDefined=0]="TextDefined",m[m.LF=1]="LF",m[m.CRLF=2]="CRLF"})(P=e.EndOfLinePreference||(e.EndOfLinePreference={}));var A;(function(m){m[m.LF=1]="LF",m[m.CRLF=2]="CRLF"})(A=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var S;(function(m){m[m.LF=0]="LF",m[m.CRLF=1]="CRLF"})(S=e.EndOfLineSequence||(e.EndOfLineSequence={}));class C{constructor(i){this.tabSize=Math.max(1,i.tabSize|0),this.indentSize=i.tabSize|0,this.insertSpaces=Boolean(i.insertSpaces),this.defaultEOL=i.defaultEOL|0,this.trimAutoWhitespace=Boolean(i.trimAutoWhitespace)}equals(i){return this.tabSize===i.tabSize&&this.indentSize===i.indentSize&&this.insertSpaces===i.insertSpaces&&this.defaultEOL===i.defaultEOL&&this.trimAutoWhitespace===i.trimAutoWhitespace}createChangeEvent(i){return{tabSize:this.tabSize!==i.tabSize,indentSize:this.indentSize!==i.indentSize,insertSpaces:this.insertSpaces!==i.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==i.trimAutoWhitespace}}}e.TextModelResolvedOptions=C;class y{constructor(i,s){this.range=i,this.matches=s}}e.FindMatch=y;var n;(function(m){m[m.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",m[m.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",m[m.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",m[m.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(n=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var T;(function(m){m[m.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(T=e.ModelConstants||(e.ModelConstants={}));class k{constructor(i,s,_,d,b,v){this.identifier=i,this.range=s,this.text=_,this.forceMoveMarkers=d,this.isAutoWhitespaceEdit=b,this._isTracked=v}}e.ValidAnnotatedEditOperation=k;class g{constructor(i,s,_){this.reverseEdits=i,this.changes=s,this.trimAutoWhitespaceLineNumbers=_}}e.ApplyEditsResult=g}),define(_e[114],we([0,1,8,112,38,32,82]),function(ie,e,E,I,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const C=999;class y{constructor(v,l,u,t){this.searchString=v,this.isRegex=l,this.matchCase=u,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let v;this.isRegex?v=n(this.searchString):v=this.searchString.indexOf(`
`)>=0;let l=null;try{l=E.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:v,global:!0,unicode:!0})}catch(t){return null}if(!l)return null;let u=!this.isRegex&&!v;return u&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(u=this.matchCase),new T(l,this.wordSeparators?(0,I.getMapForWordSeparators)(this.wordSeparators):null,u?this.searchString:null)}}e.SearchParams=y;function n(b){if(!b||b.length===0)return!1;for(let v=0,l=b.length;v<l;v++)if(b.charCodeAt(v)===92){if(v++,v>=l)break;const t=b.charCodeAt(v);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=n;class T{constructor(v,l,u){this.regex=v,this.wordSeparators=l,this.simpleSearch=u}}e.SearchData=T;function k(b,v,l){if(!l)return new S.FindMatch(b,null);let u=[];for(let t=0,r=v.length;t<r;t++)u[t]=v[t];return new S.FindMatch(b,u)}e.createFindMatch=k;class g{constructor(v){let l=[],u=0;for(let t=0,r=v.length;t<r;t++)v.charCodeAt(t)===10&&(l[u++]=t);this._lineFeedsOffsets=l}findLineFeedCountBeforeOffset(v){const l=this._lineFeedsOffsets;let u=0,t=l.length-1;if(t===-1||v<=l[0])return 0;for(;u<t;){const r=u+((t-u)/2>>0);l[r]>=v?t=r-1:l[r+1]>=v?(u=r,t=r):u=r+1}return u+1}}class m{static findMatches(v,l,u,t,r){const c=l.parseSearchRequest();return c?c.regex.multiline?this._doFindMatchesMultiline(v,u,new d(c.wordSeparators,c.regex),t,r):this._doFindMatchesLineByLine(v,u,c,t,r):[]}static _getMultilineMatchRange(v,l,u,t,r,c){let o,a=0;t?(a=t.findLineFeedCountBeforeOffset(r),o=l+r+a):o=l+r;let f;if(t){let h=t.findLineFeedCountBeforeOffset(r+c.length)-a;f=o+c.length+h}else f=o+c.length;const w=v.getPositionAt(o),D=v.getPositionAt(f);return new A.Range(w.lineNumber,w.column,D.lineNumber,D.column)}static _doFindMatchesMultiline(v,l,u,t,r){const c=v.getOffsetAt(l.getStartPosition()),o=v.getValueInRange(l,1),a=v.getEOL()===`\r
`?new g(o):null,f=[];let w=0,D;for(u.reset(0);D=u.next(o);)if(f[w++]=k(this._getMultilineMatchRange(v,c,o,a,D.index,D[0]),D,t),w>=r)return f;return f}static _doFindMatchesLineByLine(v,l,u,t,r){const c=[];let o=0;if(l.startLineNumber===l.endLineNumber){const f=v.getLineContent(l.startLineNumber).substring(l.startColumn-1,l.endColumn-1);return o=this._findMatchesInLine(u,f,l.startLineNumber,l.startColumn-1,o,c,t,r),c}const a=v.getLineContent(l.startLineNumber).substring(l.startColumn-1);o=this._findMatchesInLine(u,a,l.startLineNumber,l.startColumn-1,o,c,t,r);for(let f=l.startLineNumber+1;f<l.endLineNumber&&o<r;f++)o=this._findMatchesInLine(u,v.getLineContent(f),f,0,o,c,t,r);if(o<r){const f=v.getLineContent(l.endLineNumber).substring(0,l.endColumn-1);o=this._findMatchesInLine(u,f,l.endLineNumber,0,o,c,t,r)}return c}static _findMatchesInLine(v,l,u,t,r,c,o,a){const f=v.wordSeparators;if(!o&&v.simpleSearch){const p=v.simpleSearch,h=p.length,R=l.length;let F=-h;for(;(F=l.indexOf(p,F+h))!==-1;)if((!f||_(f,l,R,F,h))&&(c[r++]=new S.FindMatch(new A.Range(u,F+1+t,u,F+1+h+t),null),r>=a))return r;return r}const w=new d(v.wordSeparators,v.regex);let D;w.reset(0);do if(D=w.next(l),D&&(c[r++]=k(new A.Range(u,D.index+1+t,u,D.index+1+D[0].length+t),D,o),r>=a))return r;while(D);return r}static findNextMatch(v,l,u,t){const r=l.parseSearchRequest();if(!r)return null;const c=new d(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindNextMatchMultiline(v,u,c,t):this._doFindNextMatchLineByLine(v,u,c,t)}static _doFindNextMatchMultiline(v,l,u,t){const r=new P.Position(l.lineNumber,1),c=v.getOffsetAt(r),o=v.getLineCount(),a=v.getValueInRange(new A.Range(r.lineNumber,r.column,o,v.getLineMaxColumn(o)),1),f=v.getEOL()===`\r
`?new g(a):null;u.reset(l.column-1);let w=u.next(a);return w?k(this._getMultilineMatchRange(v,c,a,f,w.index,w[0]),w,t):l.lineNumber!==1||l.column!==1?this._doFindNextMatchMultiline(v,new P.Position(1,1),u,t):null}static _doFindNextMatchLineByLine(v,l,u,t){const r=v.getLineCount(),c=l.lineNumber,o=v.getLineContent(c),a=this._findFirstMatchInLine(u,o,c,l.column,t);if(a)return a;for(let f=1;f<=r;f++){const w=(c+f-1)%r,D=v.getLineContent(w+1),p=this._findFirstMatchInLine(u,D,w+1,1,t);if(p)return p}return null}static _findFirstMatchInLine(v,l,u,t,r){v.reset(t-1);const c=v.next(l);return c?k(new A.Range(u,c.index+1,u,c.index+1+c[0].length),c,r):null}static findPreviousMatch(v,l,u,t){const r=l.parseSearchRequest();if(!r)return null;const c=new d(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindPreviousMatchMultiline(v,u,c,t):this._doFindPreviousMatchLineByLine(v,u,c,t)}static _doFindPreviousMatchMultiline(v,l,u,t){const r=this._doFindMatchesMultiline(v,new A.Range(1,1,l.lineNumber,l.column),u,t,10*C);if(r.length>0)return r[r.length-1];const c=v.getLineCount();return l.lineNumber!==c||l.column!==v.getLineMaxColumn(c)?this._doFindPreviousMatchMultiline(v,new P.Position(c,v.getLineMaxColumn(c)),u,t):null}static _doFindPreviousMatchLineByLine(v,l,u,t){const r=v.getLineCount(),c=l.lineNumber,o=v.getLineContent(c).substring(0,l.column-1),a=this._findLastMatchInLine(u,o,c,t);if(a)return a;for(let f=1;f<=r;f++){const w=(r+c-f-1)%r,D=v.getLineContent(w+1),p=this._findLastMatchInLine(u,D,w+1,t);if(p)return p}return null}static _findLastMatchInLine(v,l,u,t){let r=null,c;for(v.reset(0);c=v.next(l);)r=k(new A.Range(u,c.index+1,u,c.index+1+c[0].length),c,t);return r}}e.TextModelSearch=m;function i(b,v,l,u,t){if(u===0)return!0;const r=v.charCodeAt(u-1);if(b.get(r)!==0||r===13||r===10)return!0;if(t>0){const c=v.charCodeAt(u);if(b.get(c)!==0)return!0}return!1}function s(b,v,l,u,t){if(u+t===l)return!0;const r=v.charCodeAt(u+t);if(b.get(r)!==0||r===13||r===10)return!0;if(t>0){const c=v.charCodeAt(u+t-1);if(b.get(c)!==0)return!0}return!1}function _(b,v,l,u,t){return i(b,v,l,u,t)&&s(b,v,l,u,t)}e.isValidMatch=_;class d{constructor(v,l){this._wordSeparators=v,this._searchRegex=l,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(v){this._searchRegex.lastIndex=v,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(v){const l=v.length;let u;do{if(this._prevMatchStartIndex+this._prevMatchLength===l||(u=this._searchRegex.exec(v),!u))return null;const t=u.index,r=u[0].length;if(t===this._prevMatchStartIndex&&r===this._prevMatchLength){if(r===0){E.getNextCodePoint(v,l,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=r,!this._wordSeparators||_(this._wordSeparators,v,l,t,r))return u}while(u);return null}}e.Searcher=d}),define(_e[83],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function E(C=""){let y="(-?\\d*\\.\\d\\w*)|([^";for(const n of e.USUAL_WORD_SEPARATORS)C.indexOf(n)>=0||(y+="\\"+n);return y+="\\s]+)",new RegExp(y,"g")}e.DEFAULT_WORD_REGEXP=E();function I(C){let y=e.DEFAULT_WORD_REGEXP;if(C&&C instanceof RegExp)if(C.global)y=C;else{let n="g";C.ignoreCase&&(n+="i"),C.multiline&&(n+="m"),C.unicode&&(n+="u"),y=new RegExp(C.source,n)}return y.lastIndex=0,y}e.ensureValidWordDefinition=I;const P={maxLen:1e3,windowSize:15,timeBudget:150};function A(C,y,n,T,k=P){if(n.length>k.maxLen){let _=C-k.maxLen/2;return _<0?_=0:T+=_,n=n.substring(_,C+k.maxLen/2),A(C,y,n,T,k)}const g=Date.now(),m=C-1-T;let i=-1,s=null;for(let _=1;!(Date.now()-g>=k.timeBudget);_++){const d=m-k.windowSize*_;y.lastIndex=Math.max(0,d);const b=S(y,n,m,i);if(!b&&s||(s=b,d<=0))break;i=d}if(s){let _={word:s[0],startColumn:T+1+s.index,endColumn:T+1+s.index+s[0].length};return y.lastIndex=0,_}return null}e.getWordAtText=A;function S(C,y,n,T){let k;for(;k=C.exec(y);){const g=k.index||0;if(g<=n&&C.lastIndex>=n)return k;if(T>0&&g>T)return null}return null}}),define(_e[115],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var E;(function(S){S[S.None=0]="None",S[S.Indent=1]="Indent",S[S.IndentOutdent=2]="IndentOutdent",S[S.Outdent=3]="Outdent"})(E=e.IndentAction||(e.IndentAction={}));class I{constructor(C){if(this.open=C.open,this.close=C.close,this._standardTokenMask=0,Array.isArray(C.notIn))for(let y=0,n=C.notIn.length;y<n;y++)switch(C.notIn[y]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(C){return(this._standardTokenMask&C)==0}}e.StandardAutoClosingPairConditional=I;class P{constructor(C){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of C)A(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),A(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),A(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),A(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&A(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=P;function A(S,C,y){S.has(C)?S.get(C).push(y):S.set(C,[y])}}),define(_e[59],we([0,1,28,12]),function(ie,e,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function P(A,S,C,y){if(Array.isArray(A)){let n=0;for(const T of A){const k=P(T,S,C,y);if(k===10)return k;k>n&&(n=k)}return n}else{if(typeof A=="string")return y?A==="*"?5:A===C?10:0:0;if(A){const{language:n,pattern:T,scheme:k,hasAccessToAllModels:g}=A;if(!y&&!g)return 0;let m=0;if(k)if(k===S.scheme)m=10;else if(k==="*")m=5;else return 0;if(n)if(n===C)m=10;else if(n==="*")m=Math.max(m,5);else return 0;if(T){let i;if(typeof T=="string"?i=T:i=Object.assign(Object.assign({},T),{base:(0,I.normalize)(T.base)}),i===S.fsPath||(0,E.match)(i,S.fsPath))m=10;else return 0}return m}else return 0}}e.score=P}),define(_e[116],we([0,1,81]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var I;(function(m){m[m.Invalid=0]="Invalid",m[m.Start=1]="Start",m[m.H=2]="H",m[m.HT=3]="HT",m[m.HTT=4]="HTT",m[m.HTTP=5]="HTTP",m[m.F=6]="F",m[m.FI=7]="FI",m[m.FIL=8]="FIL",m[m.BeforeColon=9]="BeforeColon",m[m.AfterColon=10]="AfterColon",m[m.AlmostThere=11]="AlmostThere",m[m.End=12]="End",m[m.Accept=13]="Accept",m[m.LastKnownState=14]="LastKnownState"})(I=e.State||(e.State={}));class P{constructor(i,s,_){const d=new Uint8Array(i*s);for(let b=0,v=i*s;b<v;b++)d[b]=_;this._data=d,this.rows=i,this.cols=s}get(i,s){return this._data[i*this.cols+s]}set(i,s,_){this._data[i*this.cols+s]=_}}e.Uint8Matrix=P;class A{constructor(i){let s=0,_=0;for(let b=0,v=i.length;b<v;b++){let[l,u,t]=i[b];u>s&&(s=u),l>_&&(_=l),t>_&&(_=t)}s++,_++;let d=new P(_,s,0);for(let b=0,v=i.length;b<v;b++){let[l,u,t]=i[b];d.set(l,u,t)}this._states=d,this._maxCharCode=s}nextState(i,s){return s<0||s>=this._maxCharCode?0:this._states.get(i,s)}}e.StateMachine=A;let S=null;function C(){return S===null&&(S=new A([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),S}var y;(function(m){m[m.None=0]="None",m[m.ForceTermination=1]="ForceTermination",m[m.CannotEndIn=2]="CannotEndIn"})(y||(y={}));let n=null;function T(){if(n===null){n=new E.CharacterClassifier(0);const m=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u3011\u300F\u300D\u300B\u3009\u201D\u2019\uFF40\uFF5E\u2026`;for(let s=0;s<m.length;s++)n.set(m.charCodeAt(s),1);const i=".,;";for(let s=0;s<i.length;s++)n.set(i.charCodeAt(s),2)}return n}class k{static _createLink(i,s,_,d,b){let v=b-1;do{const l=s.charCodeAt(v);if(i.get(l)!==2)break;v--}while(v>d);if(d>0){const l=s.charCodeAt(d-1),u=s.charCodeAt(v);(l===40&&u===41||l===91&&u===93||l===123&&u===125)&&v--}return{range:{startLineNumber:_,startColumn:d+1,endLineNumber:_,endColumn:v+2},url:s.substring(d,v+1)}}static computeLinks(i,s=C()){const _=T();let d=[];for(let b=1,v=i.getLineCount();b<=v;b++){const l=i.getLineContent(b),u=l.length;let t=0,r=0,c=0,o=1,a=!1,f=!1,w=!1,D=!1;for(;t<u;){let p=!1;const h=l.charCodeAt(t);if(o===13){let R;switch(h){case 40:a=!0,R=0;break;case 41:R=a?0:1;break;case 91:w=!0,f=!0,R=0;break;case 93:w=!1,R=f?0:1;break;case 123:D=!0,R=0;break;case 125:R=D?0:1;break;case 39:R=c===34||c===96?0:1;break;case 34:R=c===39||c===96?0:1;break;case 96:R=c===39||c===34?0:1;break;case 42:R=c===42?1:0;break;case 124:R=c===124?1:0;break;case 32:R=w?0:1;break;default:R=_.get(h)}R===1&&(d.push(k._createLink(_,l,b,r,t)),p=!0)}else if(o===12){let R;h===91?(f=!0,R=0):R=_.get(h),R===1?p=!0:o=13}else o=s.nextState(o,h),o===0&&(p=!0);p&&(o=1,a=!1,f=!1,D=!1,r=t+1,c=h),t++}o===13&&d.push(k._createLink(_,l,b,r,u))}return d}}e.LinkComputer=k;function g(m){return!m||typeof m.getLineCount!="function"||typeof m.getLineContent!="function"?[]:k.computeLinks(m)}e.computeLinks=g}),define(_e[117],we([0,1,3,6]),function(ie,e,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class P{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new E.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(S){this._onDidChange.fire({changedLanguages:S,changedColorMap:!1})}register(S,C){return this._map.set(S,C),this.fire([S]),(0,I.toDisposable)(()=>{this._map.get(S)===C&&(this._map.delete(S),this.fire([S]))})}registerPromise(S,C){let y=null,n=!1;return this._promises.set(S,C.then(T=>{this._promises.delete(S),!(n||!T)&&(y=this.register(S,T))})),(0,I.toDisposable)(()=>{n=!0,y&&y.dispose()})}getPromise(S){const C=this.get(S);if(C)return Promise.resolve(C);const y=this._promises.get(S);return y?y.then(n=>this.get(S)):null}get(S){return this._map.get(S)||null}setColorMap(S){this._colorMap=S,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=P}),define(_e[84],we([0,1,23,21]),function(ie,e,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var P;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(P||(P={}));function A(k){for(let g=0,m=k.length;g<m;g+=4){const i=k[g+0],s=k[g+1],_=k[g+2],d=k[g+3];k[g+0]=d,k[g+1]=_,k[g+2]=s,k[g+3]=i}}function S(k){const g=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return I.isLittleEndian()||A(g),E.VSBuffer.wrap(g)}function C(k){const g=k.buffer;if(I.isLittleEndian()||A(g),g.byteOffset%4==0)return new Uint32Array(g.buffer,g.byteOffset,g.length/4);{const m=new Uint8Array(g.byteLength);return m.set(g),new Uint32Array(m.buffer,m.byteOffset,m.length/4)}}function y(k){const g=new Uint32Array(n(k));let m=0;if(g[m++]=k.id,k.type==="full")g[m++]=1,g[m++]=k.data.length,g.set(k.data,m),m+=k.data.length;else{g[m++]=2,g[m++]=k.deltas.length;for(const i of k.deltas)g[m++]=i.start,g[m++]=i.deleteCount,i.data?(g[m++]=i.data.length,g.set(i.data,m),m+=i.data.length):g[m++]=0}return S(g)}e.encodeSemanticTokensDto=y;function n(k){let g=0;if(g+=1+1,k.type==="full")g+=1+k.data.length;else{g+=1,g+=(1+1+1)*k.deltas.length;for(const m of k.deltas)m.data&&(g+=m.data.length)}return g}function T(k){const g=C(k);let m=0;const i=g[m++];if(g[m++]===1){const b=g[m++],v=g.subarray(m,m+b);return m+=b,{id:i,type:"full",data:v}}const _=g[m++];let d=[];for(let b=0;b<_;b++){const v=g[m++],l=g[m++],u=g[m++];let t;u>0&&(t=g.subarray(m,m+u),m+=u),d[b]={start:v,deleteCount:l,data:t}}return{id:i,type:"delta",deltas:d}}e.decodeSemanticTokensDto=T}),define(_e[85],we([0,1,79]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class I{constructor(S,C){this.index=S,this.remainder=C}}e.PrefixSumIndexOfResult=I;class P{constructor(S){this.values=S,this.prefixSum=new Uint32Array(S.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(S,C){S=(0,E.toUint32)(S);const y=this.values,n=this.prefixSum,T=C.length;return T===0?!1:(this.values=new Uint32Array(y.length+T),this.values.set(y.subarray(0,S),0),this.values.set(y.subarray(S),S+T),this.values.set(C,S),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(n.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(S,C){return S=(0,E.toUint32)(S),C=(0,E.toUint32)(C),this.values[S]===C?!1:(this.values[S]=C,S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),!0)}removeValues(S,C){S=(0,E.toUint32)(S),C=(0,E.toUint32)(C);const y=this.values,n=this.prefixSum;if(S>=y.length)return!1;let T=y.length-S;return C>=T&&(C=T),C===0?!1:(this.values=new Uint32Array(y.length-C),this.values.set(y.subarray(0,S),0),this.values.set(y.subarray(S+C),S),this.prefixSum=new Uint32Array(this.values.length),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(n.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(S){return S<0?0:(S=(0,E.toUint32)(S),this._getAccumulatedValue(S))}_getAccumulatedValue(S){if(S<=this.prefixSumValidIndex[0])return this.prefixSum[S];let C=this.prefixSumValidIndex[0]+1;C===0&&(this.prefixSum[0]=this.values[0],C++),S>=this.values.length&&(S=this.values.length-1);for(let y=C;y<=S;y++)this.prefixSum[y]=this.prefixSum[y-1]+this.values[y];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],S),this.prefixSum[S]}getIndexOf(S){S=Math.floor(S),this.getTotalValue();let C=0,y=this.values.length-1,n=0,T=0,k=0;for(;C<=y;)if(n=C+(y-C)/2|0,T=this.prefixSum[n],k=T-this.values[n],S<k)y=n-1;else if(S>=T)C=n+1;else break;return new I(n,S-k)}}e.PrefixSumComputer=P}),define(_e[118],we([0,1,8,38,85]),function(ie,e,E,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class A{constructor(C,y,n,T){this._uri=C,this._lines=y,this._eol=n,this._versionId=T,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(C){C.eol&&C.eol!==this._eol&&(this._eol=C.eol,this._lineStarts=null);const y=C.changes;for(const n of y)this._acceptDeleteRange(n.range),this._acceptInsertText(new I.Position(n.range.startLineNumber,n.range.startColumn),n.text);this._versionId=C.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const C=this._eol.length,y=this._lines.length,n=new Uint32Array(y);for(let T=0;T<y;T++)n[T]=this._lines[T].length+C;this._lineStarts=new P.PrefixSumComputer(n)}}_setLineText(C,y){this._lines[C]=y,this._lineStarts&&this._lineStarts.changeValue(C,this._lines[C].length+this._eol.length)}_acceptDeleteRange(C){if(C.startLineNumber===C.endLineNumber){if(C.startColumn===C.endColumn)return;this._setLineText(C.startLineNumber-1,this._lines[C.startLineNumber-1].substring(0,C.startColumn-1)+this._lines[C.startLineNumber-1].substring(C.endColumn-1));return}this._setLineText(C.startLineNumber-1,this._lines[C.startLineNumber-1].substring(0,C.startColumn-1)+this._lines[C.endLineNumber-1].substring(C.endColumn-1)),this._lines.splice(C.startLineNumber,C.endLineNumber-C.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(C.startLineNumber,C.endLineNumber-C.startLineNumber)}_acceptInsertText(C,y){if(y.length!==0){let n=(0,E.splitLines)(y);if(n.length===1){this._setLineText(C.lineNumber-1,this._lines[C.lineNumber-1].substring(0,C.column-1)+n[0]+this._lines[C.lineNumber-1].substring(C.column-1));return}n[n.length-1]+=this._lines[C.lineNumber-1].substring(C.column-1),this._setLineText(C.lineNumber-1,this._lines[C.lineNumber-1].substring(0,C.column-1)+n[0]);let T=new Uint32Array(n.length-1);for(let k=1;k<n.length;k++)this._lines.splice(C.lineNumber+k-1,0,n[k]),T[k-1]=n[k].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(C.lineNumber,T)}}}e.MirrorTextModel=A}),define(_e[119],we([16,17]),function(ie,e){return ie.create("vs/base/common/errorMessage",e)}),define(_e[60],we([0,1,119,13,11]),function(ie,e,E,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function A(n,T){return T&&(n.stack||n.stacktrace)?E.localize(0,null,C(n),S(n.stack)||S(n.stacktrace)):C(n)}function S(n){return Array.isArray(n)?n.join(`
`):n}function C(n){return typeof n.code=="string"&&typeof n.errno=="number"&&typeof n.syscall=="string"?E.localize(1,null,n.message):n.message||E.localize(2,null)}function y(n=null,T=!1){if(!n)return E.localize(3,null);if(Array.isArray(n)){const k=P.coalesce(n),g=y(k[0],T);return k.length>1?E.localize(4,null,g,k.length):g}if(I.isString(n))return n;if(n.detail){const k=n.detail;if(k.error)return A(k.error,T);if(k.exception)return A(k.exception,T)}return n.stack?A(n,T):n.message?n.message:E.localize(5,null)}e.toErrorMessage=y}),define(_e[120],we([16,17]),function(ie,e){return ie.create("vs/editor/common/config/editorOptions",e)}),define(_e[121],we([0,1,120,21,83]),function(ie,e,E,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var A;(function(V){V[V.None=0]="None",V[V.Keep=1]="Keep",V[V.Brackets=2]="Brackets",V[V.Advanced=3]="Advanced",V[V.Full=4]="Full"})(A=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class S{constructor(Z){this._values=Z}hasChanged(Z){return this._values[Z]}}e.ConfigurationChangedEvent=S;class C{constructor(){this._values=[]}_read(Z){return this._values[Z]}get(Z){return this._values[Z]}_write(Z,pe){this._values[Z]=pe}}e.ValidatedEditorOptions=C;class y{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=y;class n{constructor(Z,pe,Me,He){this.id=Z,this.name=pe,this.defaultValue=Me,this.schema=He}compute(Z,pe,Me){return Me}}class T{constructor(Z,pe=null){this.schema=void 0,this.id=Z,this.name="_never_",this.defaultValue=void 0,this.deps=pe}validate(Z){return this.defaultValue}}class k{constructor(Z,pe,Me,He){this.id=Z,this.name=pe,this.defaultValue=Me,this.schema=He}validate(Z){return typeof Z=="undefined"?this.defaultValue:Z}compute(Z,pe,Me){return Me}}function g(V,Z){return typeof V=="undefined"?Z:V==="false"?!1:Boolean(V)}e.boolean=g;class m extends k{constructor(Z,pe,Me,He=void 0){typeof He!="undefined"&&(He.type="boolean",He.default=Me),super(Z,pe,Me,He)}validate(Z){return g(Z,this.defaultValue)}}class i extends k{constructor(Z,pe,Me,He,Ue,Ze=void 0){typeof Ze!="undefined"&&(Ze.type="integer",Ze.default=Me,Ze.minimum=He,Ze.maximum=Ue),super(Z,pe,Me,Ze),this.minimum=He,this.maximum=Ue}static clampedInt(Z,pe,Me,He){if(typeof Z=="undefined")return pe;let Ue=parseInt(Z,10);return isNaN(Ue)?pe:(Ue=Math.max(Me,Ue),Ue=Math.min(He,Ue),Ue|0)}validate(Z){return i.clampedInt(Z,this.defaultValue,this.minimum,this.maximum)}}class s extends k{constructor(Z,pe,Me,He,Ue){typeof Ue!="undefined"&&(Ue.type="number",Ue.default=Me),super(Z,pe,Me,Ue),this.validationFn=He}static clamp(Z,pe,Me){return Z<pe?pe:Z>Me?Me:Z}static float(Z,pe){if(typeof Z=="number")return Z;if(typeof Z=="undefined")return pe;const Me=parseFloat(Z);return isNaN(Me)?pe:Me}validate(Z){return this.validationFn(s.float(Z,this.defaultValue))}}class _ extends k{static string(Z,pe){return typeof Z!="string"?pe:Z}constructor(Z,pe,Me,He=void 0){typeof He!="undefined"&&(He.type="string",He.default=Me),super(Z,pe,Me,He)}validate(Z){return _.string(Z,this.defaultValue)}}function d(V,Z,pe){return typeof V!="string"||pe.indexOf(V)===-1?Z:V}e.stringSet=d;class b extends k{constructor(Z,pe,Me,He,Ue=void 0){typeof Ue!="undefined"&&(Ue.type="string",Ue.enum=He,Ue.default=Me),super(Z,pe,Me,Ue),this._allowedValues=He}validate(Z){return d(Z,this.defaultValue,this._allowedValues)}}class v extends n{constructor(Z,pe,Me,He,Ue,Ze,H=void 0){typeof H!="undefined"&&(H.type="string",H.enum=Ue,H.default=He),super(Z,pe,Me,H),this._allowedValues=Ue,this._convert=Ze}validate(Z){return typeof Z!="string"?this.defaultValue:this._allowedValues.indexOf(Z)===-1?this.defaultValue:this._convert(Z)}}function l(V){switch(V){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class u extends n{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[E.localize(0,null),E.localize(1,null),E.localize(2,null)],default:"auto",description:E.localize(3,null)})}validate(Z){switch(Z){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Z,pe,Me){return Me===0?Z.accessibilitySupport:Me}}class t extends n{constructor(){const Z={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",Z,{"editor.comments.insertSpace":{type:"boolean",default:Z.insertSpace,description:E.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Z.ignoreEmptyLines,description:E.localize(5,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{insertSpace:g(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:g(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var r;(function(V){V[V.Hidden=0]="Hidden",V[V.Blink=1]="Blink",V[V.Smooth=2]="Smooth",V[V.Phase=3]="Phase",V[V.Expand=4]="Expand",V[V.Solid=5]="Solid"})(r=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function c(V){switch(V){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var o;(function(V){V[V.Line=1]="Line",V[V.Block=2]="Block",V[V.Underline=3]="Underline",V[V.LineThin=4]="LineThin",V[V.BlockOutline=5]="BlockOutline",V[V.UnderlineThin=6]="UnderlineThin"})(o=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function a(V){switch(V){case o.Line:return"line";case o.Block:return"block";case o.Underline:return"underline";case o.LineThin:return"line-thin";case o.BlockOutline:return"block-outline";case o.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=a;function f(V){switch(V){case"line":return o.Line;case"block":return o.Block;case"underline":return o.Underline;case"line-thin":return o.LineThin;case"block-outline":return o.BlockOutline;case"underline-thin":return o.UnderlineThin}}class w extends T{constructor(){super(123,[62,31])}compute(Z,pe,Me){const He=["monaco-editor"];return pe.get(31)&&He.push(pe.get(31)),Z.extraEditorClassName&&He.push(Z.extraEditorClassName),pe.get(62)==="default"?He.push("mouse-default"):pe.get(62)==="copy"&&He.push("mouse-copy"),pe.get(97)&&He.push("showUnused"),pe.get(121)&&He.push("showDeprecated"),He.join(" ")}}class D extends m{constructor(){super(30,"emptySelectionClipboard",!0,{description:E.localize(6,null)})}compute(Z,pe,Me){return Me&&Z.emptySelectionClipboard}}class p extends n{constructor(){const Z={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",Z,{"editor.find.cursorMoveOnType":{type:"boolean",default:Z.cursorMoveOnType,description:E.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:Z.seedSearchStringFromSelection,description:E.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Z.autoFindInSelection,enumDescriptions:[E.localize(9,null),E.localize(10,null),E.localize(11,null)],description:E.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Z.globalFindClipboard,description:E.localize(13,null),included:I.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Z.addExtraSpaceOnTop,description:E.localize(14,null)},"editor.find.loop":{type:"boolean",default:Z.loop,description:E.localize(15,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{cursorMoveOnType:g(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:g(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof Z.autoFindInSelection=="boolean"?Z.autoFindInSelection?"always":"never":d(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:g(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:g(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:g(pe.loop,this.defaultValue.loop)}}}class h extends n{constructor(){super(41,"fontLigatures",h.OFF,{anyOf:[{type:"boolean",description:E.localize(16,null)},{type:"string",description:E.localize(17,null)}],description:E.localize(18,null),default:!1})}validate(Z){return typeof Z=="undefined"?this.defaultValue:typeof Z=="string"?Z==="false"?h.OFF:Z==="true"?h.ON:Z:Boolean(Z)?h.ON:h.OFF}}e.EditorFontLigatures=h,h.OFF='"liga" off, "calt" off',h.ON='"liga" on, "calt" on';class R extends T{constructor(){super(40)}compute(Z,pe,Me){return Z.fontInfo}}class F extends k{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:E.localize(19,null)})}validate(Z){let pe=s.float(Z,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:s.clamp(pe,6,100)}compute(Z,pe,Me){return Z.fontInfo.fontSize}}class $ extends n{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:$.MINIMUM_VALUE,maximum:$.MAXIMUM_VALUE,errorMessage:E.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:$.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:E.localize(21,null)})}validate(Z){return Z==="normal"||Z==="bold"?Z:String(i.clampedInt(Z,e.EDITOR_FONT_DEFAULTS.fontWeight,$.MINIMUM_VALUE,$.MAXIMUM_VALUE))}}$.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],$.MINIMUM_VALUE=1,$.MAXIMUM_VALUE=1e3;class se extends n{constructor(){const Z={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:Z.multiple,enumDescriptions:[E.localize(22,null),E.localize(23,null),E.localize(24,null)]};super(47,"gotoLocation",Z,{"editor.gotoLocation.multiple":{deprecationMessage:E.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:E.localize(26,null)},pe),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:E.localize(27,null)},pe),"editor.gotoLocation.multipleDeclarations":Object.assign({description:E.localize(28,null)},pe),"editor.gotoLocation.multipleImplementations":Object.assign({description:E.localize(29,null)},pe),"editor.gotoLocation.multipleReferences":Object.assign({description:E.localize(30,null)},pe),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Z.alternativeDefinitionCommand,description:E.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Z.alternativeTypeDefinitionCommand,description:E.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Z.alternativeDeclarationCommand,description:E.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Z.alternativeImplementationCommand,description:E.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Z.alternativeReferenceCommand,description:E.localize(35,null)}})}validate(Z){var pe,Me,He,Ue,Ze;if(!Z||typeof Z!="object")return this.defaultValue;const H=Z;return{multiple:d(H.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(pe=H.multipleDefinitions)!==null&&pe!==void 0?pe:d(H.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(Me=H.multipleTypeDefinitions)!==null&&Me!==void 0?Me:d(H.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(He=H.multipleDeclarations)!==null&&He!==void 0?He:d(H.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:(Ue=H.multipleImplementations)!==null&&Ue!==void 0?Ue:d(H.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(Ze=H.multipleReferences)!==null&&Ze!==void 0?Ze:d(H.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:_.string(H.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:_.string(H.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:_.string(H.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:_.string(H.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:_.string(H.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class z extends n{constructor(){const Z={enabled:!0,delay:300,sticky:!0};super(50,"hover",Z,{"editor.hover.enabled":{type:"boolean",default:Z.enabled,description:E.localize(36,null)},"editor.hover.delay":{type:"number",default:Z.delay,description:E.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:Z.sticky,description:E.localize(38,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:g(pe.enabled,this.defaultValue.enabled),delay:i.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:g(pe.sticky,this.defaultValue.sticky)}}}var x;(function(V){V[V.None=0]="None",V[V.Text=1]="Text",V[V.Blocks=2]="Blocks"})(x=e.RenderMinimap||(e.RenderMinimap={}));class G extends T{constructor(){super(126,[46,54,35,61,89,56,57,91,113,116,117,118,2])}compute(Z,pe,Me){return G.computeLayout(pe,{memory:Z.memory,outerWidth:Z.outerWidth,outerHeight:Z.outerHeight,isDominatedByLongLines:Z.isDominatedByLongLines,lineHeight:Z.fontInfo.lineHeight,viewLineCount:Z.viewLineCount,lineNumbersDigitCount:Z.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Z.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Z.fontInfo.maxDigitWidth,pixelRatio:Z.pixelRatio})}static computeContainedMinimapLineCount(Z){const pe=Z.height/Z.lineHeight,Me=Z.scrollBeyondLastLine?pe-1:0,He=(Z.viewLineCount+Me)/(Z.pixelRatio*Z.height),Ue=Math.floor(Z.viewLineCount/He);return{typicalViewportLineCount:pe,extraLinesBeyondLastLine:Me,desiredRatio:He,minimapLineCount:Ue}}static _computeMinimapLayout(Z,pe){const Me=Z.outerWidth,He=Z.outerHeight,Ue=Z.pixelRatio;if(!Z.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ue*He),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:He};const Ze=pe.stableMinimapLayoutInput,H=Ze&&Z.outerHeight===Ze.outerHeight&&Z.lineHeight===Ze.lineHeight&&Z.typicalHalfwidthCharacterWidth===Ze.typicalHalfwidthCharacterWidth&&Z.pixelRatio===Ze.pixelRatio&&Z.scrollBeyondLastLine===Ze.scrollBeyondLastLine&&Z.minimap.enabled===Ze.minimap.enabled&&Z.minimap.side===Ze.minimap.side&&Z.minimap.size===Ze.minimap.size&&Z.minimap.showSlider===Ze.minimap.showSlider&&Z.minimap.renderCharacters===Ze.minimap.renderCharacters&&Z.minimap.maxColumn===Ze.minimap.maxColumn&&Z.minimap.scale===Ze.minimap.scale&&Z.verticalScrollbarWidth===Ze.verticalScrollbarWidth&&Z.isViewportWrapping===Ze.isViewportWrapping,ne=Z.lineHeight,de=Z.typicalHalfwidthCharacterWidth,j=Z.scrollBeyondLastLine,Y=Z.minimap.renderCharacters;let ae=Ue>=2?Math.round(Z.minimap.scale*2):Z.minimap.scale;const fe=Z.minimap.maxColumn,Ee=Z.minimap.size,Ne=Z.minimap.side,Le=Z.verticalScrollbarWidth,Ve=Z.viewLineCount,Ye=Z.remainingWidth,et=Z.isViewportWrapping,nt=Y?2:3;let st=Math.floor(Ue*He);const it=st/Ue;let ve=!1,he=!1,ue=nt*ae,q=ae/Ue,Ie=1;if(Ee==="fill"||Ee==="fit"){const{typicalViewportLineCount:at,extraLinesBeyondLastLine:ut,desiredRatio:ot,minimapLineCount:yt}=G.computeContainedMinimapLineCount({viewLineCount:Ve,scrollBeyondLastLine:j,height:He,lineHeight:ne,pixelRatio:Ue});if(Ve/yt>1)ve=!0,he=!0,ae=1,ue=1,q=ae/Ue;else{let vt=!1,_t=ae+1;if(Ee==="fit"){const wt=Math.ceil((Ve+ut)*ue);et&&H&&Ye<=pe.stableFitRemainingWidth?(vt=!0,_t=pe.stableFitMaxMinimapScale):(vt=wt>st,et&&vt?(pe.stableMinimapLayoutInput=Z,pe.stableFitRemainingWidth=Ye):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0))}if(Ee==="fill"||vt){ve=!0;const wt=ae;ue=Math.min(ne*Ue,Math.max(1,Math.floor(1/ot))),ae=Math.min(_t,Math.max(1,Math.floor(ue/nt))),ae>wt&&(Ie=Math.min(2,ae/wt)),q=ae/Ue/Ie,st=Math.ceil(Math.max(at,Ve+ut)*ue),et&&vt&&(pe.stableFitMaxMinimapScale=ae)}}}const Te=Math.floor(fe*q),Qe=Math.min(Te,Math.max(0,Math.floor((Ye-Le-2)*q/(de+q)))+e.MINIMAP_GUTTER_WIDTH);let Ge=Math.floor(Ue*Qe);const rt=Ge/Ue;Ge=Math.floor(Ge*Ie);const ct=Y?1:2,Xe=Ne==="left"?0:Me-Qe-Le;return{renderMinimap:ct,minimapLeft:Xe,minimapWidth:Qe,minimapHeightIsEditorHeight:ve,minimapIsSampling:he,minimapScale:ae,minimapLineHeight:ue,minimapCanvasInnerWidth:Ge,minimapCanvasInnerHeight:st,minimapCanvasOuterWidth:rt,minimapCanvasOuterHeight:it}}static computeLayout(Z,pe){const Me=pe.outerWidth|0,He=pe.outerHeight|0,Ue=pe.lineHeight|0,Ze=pe.lineNumbersDigitCount|0,H=pe.typicalHalfwidthCharacterWidth,ne=pe.maxDigitWidth,de=pe.pixelRatio,j=pe.viewLineCount,Y=Z.get(118),ae=Y==="inherit"?Z.get(117):Y,fe=ae==="inherit"?Z.get(113):ae,Ee=Z.get(116),Ne=Z.get(2),Le=pe.isDominatedByLongLines,Ve=Z.get(46),Ye=Z.get(56).renderType!==0,et=Z.get(57),nt=Z.get(91),st=Z.get(61),it=Z.get(89),ve=it.verticalScrollbarSize,he=it.verticalHasArrows,ue=it.arrowSize,q=it.horizontalScrollbarSize,Ie=Z.get(54),Te=Z.get(35);let Qe;if(typeof Ie=="string"&&/^\d+(\.\d+)?ch$/.test(Ie)){const At=parseFloat(Ie.substr(0,Ie.length-2));Qe=i.clampedInt(At*H,0,0,1e3)}else Qe=i.clampedInt(Ie,0,0,1e3);Te&&(Qe+=16);let Ge=0;if(Ye){const At=Math.max(Ze,et);Ge=Math.round(At*ne)}let rt=0;Ve&&(rt=Ue);let ct=0,Xe=ct+rt,at=Xe+Ge,ut=at+Qe;const ot=Me-rt-Ge-Qe;let yt=!1,gt=!1,vt=-1;Ne!==2&&(ae==="inherit"&&Le?(yt=!0,gt=!0):fe==="on"||fe==="bounded"?gt=!0:fe==="wordWrapColumn"&&(vt=Ee));const _t=G._computeMinimapLayout({outerWidth:Me,outerHeight:He,lineHeight:Ue,typicalHalfwidthCharacterWidth:H,pixelRatio:de,scrollBeyondLastLine:nt,minimap:st,verticalScrollbarWidth:ve,viewLineCount:j,remainingWidth:ot,isViewportWrapping:gt},pe.memory||new y);_t.renderMinimap!==0&&_t.minimapLeft===0&&(ct+=_t.minimapWidth,Xe+=_t.minimapWidth,at+=_t.minimapWidth,ut+=_t.minimapWidth);const wt=ot-_t.minimapWidth,pt=Math.max(1,Math.floor((wt-ve-2)/H)),Lt=he?ue:0;return gt&&(vt=Math.max(1,pt),fe==="bounded"&&(vt=Math.min(vt,Ee))),{width:Me,height:He,glyphMarginLeft:ct,glyphMarginWidth:rt,lineNumbersLeft:Xe,lineNumbersWidth:Ge,decorationsLeft:at,decorationsWidth:Qe,contentLeft:ut,contentWidth:wt,minimap:_t,viewportColumn:pt,isWordWrapMinified:yt,isViewportWrapping:gt,wrappingColumn:vt,verticalScrollbarWidth:ve,horizontalScrollbarHeight:q,overviewRuler:{top:Lt,width:ve,height:He-2*Lt,right:0}}}}e.EditorLayoutInfoComputer=G;class M extends n{constructor(){const Z={enabled:!0};super(53,"lightbulb",Z,{"editor.lightbulb.enabled":{type:"boolean",default:Z.enabled,description:E.localize(39,null)}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{enabled:g(Z.enabled,this.defaultValue.enabled)}}}class N extends n{constructor(){const Z={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(122,"inlineHints",Z,{"editor.inlineHints.enabled":{type:"boolean",default:Z.enabled,description:E.localize(40,null)},"editor.inlineHints.fontSize":{type:"number",default:Z.fontSize,description:E.localize(41,null)},"editor.inlineHints.fontFamily":{type:"string",default:Z.fontFamily,description:E.localize(42,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:g(pe.enabled,this.defaultValue.enabled),fontSize:i.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:_.string(pe.fontFamily,this.defaultValue.fontFamily)}}}class B extends i{constructor(){super(55,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:E.localize(43,null)})}compute(Z,pe,Me){return Z.fontInfo.lineHeight}}class Q extends n{constructor(){const Z={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(61,"minimap",Z,{"editor.minimap.enabled":{type:"boolean",default:Z.enabled,description:E.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[E.localize(45,null),E.localize(46,null),E.localize(47,null)],default:Z.size,description:E.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Z.side,description:E.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Z.showSlider,description:E.localize(50,null)},"editor.minimap.scale":{type:"number",default:Z.scale,minimum:1,maximum:3,enum:[1,2,3],description:E.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Z.renderCharacters,description:E.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:Z.maxColumn,description:E.localize(53,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:g(pe.enabled,this.defaultValue.enabled),size:d(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:d(pe.side,this.defaultValue.side,["right","left"]),showSlider:d(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:g(pe.renderCharacters,this.defaultValue.renderCharacters),scale:i.clampedInt(pe.scale,1,1,3),maxColumn:i.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function W(V){return V==="ctrlCmd"?I.isMacintosh?"metaKey":"ctrlKey":"altKey"}class ee extends n{constructor(){super(71,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:E.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:E.localize(55,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{top:i.clampedInt(pe.top,0,0,1e3),bottom:i.clampedInt(pe.bottom,0,0,1e3)}}}class re extends n{constructor(){const Z={enabled:!0,cycle:!1};super(72,"parameterHints",Z,{"editor.parameterHints.enabled":{type:"boolean",default:Z.enabled,description:E.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:Z.cycle,description:E.localize(57,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:g(pe.enabled,this.defaultValue.enabled),cycle:g(pe.cycle,this.defaultValue.cycle)}}}class oe extends T{constructor(){super(124)}compute(Z,pe,Me){return Z.pixelRatio}}class Se extends n{constructor(){const Z={other:!0,comments:!1,strings:!1};super(75,"quickSuggestions",Z,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:Z.strings,description:E.localize(58,null)},comments:{type:"boolean",default:Z.comments,description:E.localize(59,null)},other:{type:"boolean",default:Z.other,description:E.localize(60,null)}}}],default:Z,description:E.localize(61,null)});this.defaultValue=Z}validate(Z){if(typeof Z=="boolean")return Z;if(Z&&typeof Z=="object"){const pe=Z,Me={other:g(pe.other,this.defaultValue.other),comments:g(pe.comments,this.defaultValue.comments),strings:g(pe.strings,this.defaultValue.strings)};return Me.other&&Me.comments&&Me.strings?!0:!Me.other&&!Me.comments&&!Me.strings?!1:Me}return this.defaultValue}}var Pe;(function(V){V[V.Off=0]="Off",V[V.On=1]="On",V[V.Relative=2]="Relative",V[V.Interval=3]="Interval",V[V.Custom=4]="Custom"})(Pe=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class $e extends n{constructor(){super(56,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[E.localize(62,null),E.localize(63,null),E.localize(64,null),E.localize(65,null)],default:"on",description:E.localize(66,null)})}validate(Z){let pe=this.defaultValue.renderType,Me=this.defaultValue.renderFn;return typeof Z!="undefined"&&(typeof Z=="function"?(pe=4,Me=Z):Z==="interval"?pe=3:Z==="relative"?pe=2:Z==="on"?pe=1:pe=0),{renderType:pe,renderFn:Me}}}function Fe(V){const Z=V.get(84);return Z==="editable"?V.get(77):Z!=="on"}e.filterValidationDecorations=Fe;class ze extends n{constructor(){const Z=[],pe={type:"number",description:E.localize(67,null)};super(88,"rulers",Z,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:E.localize(68,null),format:"color-hex"}}}]},default:Z,description:E.localize(69,null)})}validate(Z){if(Array.isArray(Z)){let pe=[];for(let Me of Z)if(typeof Me=="number")pe.push({column:i.clampedInt(Me,0,0,1e4),color:null});else if(Me&&typeof Me=="object"){const He=Me;pe.push({column:i.clampedInt(He.column,0,0,1e4),color:He.color})}return pe.sort((Me,He)=>Me.column-He.column),pe}return this.defaultValue}}function U(V,Z){if(typeof V!="string")return Z;switch(V){case"hidden":return 2;case"visible":return 3;default:return 1}}class K extends n{constructor(){super(89,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z,Me=i.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),He=i.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:i.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:U(pe.vertical,this.defaultValue.vertical),horizontal:U(pe.horizontal,this.defaultValue.horizontal),useShadows:g(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:g(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:g(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:g(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:g(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Me,horizontalSliderSize:i.clampedInt(pe.horizontalSliderSize,Me,0,1e3),verticalScrollbarSize:He,verticalSliderSize:i.clampedInt(pe.verticalSliderSize,He,0,1e3),scrollByPage:g(pe.scrollByPage,this.defaultValue.scrollByPage)}}}class te extends n{constructor(){const Z={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(103,"suggest",Z,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[E.localize(70,null),E.localize(71,null)],default:Z.insertMode,description:E.localize(72,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Z.filterGraceful,description:E.localize(73,null)},"editor.suggest.localityBonus":{type:"boolean",default:Z.localityBonus,description:E.localize(74,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Z.shareSuggestSelections,markdownDescription:E.localize(75,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Z.snippetsPreventQuickSuggestions,description:E.localize(76,null)},"editor.suggest.showIcons":{type:"boolean",default:Z.showIcons,description:E.localize(77,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Z.showStatusBar,description:E.localize(78,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Z.showInlineDetails,description:E.localize(79,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:E.localize(80,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:E.localize(81,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:E.localize(82,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:E.localize(83,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:E.localize(84,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:E.localize(85,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:E.localize(86,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:E.localize(87,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:E.localize(88,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:E.localize(89,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:E.localize(90,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:E.localize(91,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:E.localize(92,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:E.localize(93,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:E.localize(94,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:E.localize(95,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:E.localize(96,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:E.localize(97,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:E.localize(98,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:E.localize(99,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:E.localize(100,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:E.localize(101,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:E.localize(102,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:E.localize(103,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:E.localize(104,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:E.localize(105,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:E.localize(106,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:E.localize(107,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:E.localize(108,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:E.localize(109,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{insertMode:d(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:g(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:g(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:g(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:g(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:g(pe.showIcons,this.defaultValue.showIcons),showStatusBar:g(pe.showStatusBar,this.defaultValue.showStatusBar),showInlineDetails:g(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:g(pe.showMethods,this.defaultValue.showMethods),showFunctions:g(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:g(pe.showConstructors,this.defaultValue.showConstructors),showFields:g(pe.showFields,this.defaultValue.showFields),showVariables:g(pe.showVariables,this.defaultValue.showVariables),showClasses:g(pe.showClasses,this.defaultValue.showClasses),showStructs:g(pe.showStructs,this.defaultValue.showStructs),showInterfaces:g(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:g(pe.showModules,this.defaultValue.showModules),showProperties:g(pe.showProperties,this.defaultValue.showProperties),showEvents:g(pe.showEvents,this.defaultValue.showEvents),showOperators:g(pe.showOperators,this.defaultValue.showOperators),showUnits:g(pe.showUnits,this.defaultValue.showUnits),showValues:g(pe.showValues,this.defaultValue.showValues),showConstants:g(pe.showConstants,this.defaultValue.showConstants),showEnums:g(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:g(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:g(pe.showKeywords,this.defaultValue.showKeywords),showWords:g(pe.showWords,this.defaultValue.showWords),showColors:g(pe.showColors,this.defaultValue.showColors),showFiles:g(pe.showFiles,this.defaultValue.showFiles),showReferences:g(pe.showReferences,this.defaultValue.showReferences),showFolders:g(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:g(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:g(pe.showSnippets,this.defaultValue.showSnippets),showUsers:g(pe.showUsers,this.defaultValue.showUsers),showIssues:g(pe.showIssues,this.defaultValue.showIssues)}}}class le extends n{constructor(){super(99,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:E.localize(110,null),default:!0,type:"boolean"}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:g(Z.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class me extends T{constructor(){super(125,[77])}compute(Z,pe,Me){return pe.get(77)?!0:Z.tabFocusMode}}var De;(function(V){V[V.None=0]="None",V[V.Same=1]="Same",V[V.Indent=2]="Indent",V[V.DeepIndent=3]="DeepIndent"})(De=e.WrappingIndent||(e.WrappingIndent={}));function Oe(V){switch(V){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ge extends T{constructor(){super(127,[126])}compute(Z,pe,Me){const He=pe.get(126);return{isDominatedByLongLines:Z.isDominatedByLongLines,isWordWrapMinified:He.isWordWrapMinified,isViewportWrapping:He.isViewportWrapping,wrappingColumn:He.wrappingColumn}}}const Ce="Consolas, 'Courier New', monospace",Ae="Menlo, Monaco, 'Courier New', monospace",We="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:I.isMacintosh?Ae:I.isLinux?We:Ce,fontWeight:"normal",fontSize:I.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function be(V){return e.editorOptionsRegistry[V.id]=V,V}var qe;(function(V){V[V.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",V[V.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",V[V.accessibilitySupport=2]="accessibilitySupport",V[V.accessibilityPageSize=3]="accessibilityPageSize",V[V.ariaLabel=4]="ariaLabel",V[V.autoClosingBrackets=5]="autoClosingBrackets",V[V.autoClosingDelete=6]="autoClosingDelete",V[V.autoClosingOvertype=7]="autoClosingOvertype",V[V.autoClosingQuotes=8]="autoClosingQuotes",V[V.autoIndent=9]="autoIndent",V[V.automaticLayout=10]="automaticLayout",V[V.autoSurround=11]="autoSurround",V[V.codeLens=12]="codeLens",V[V.codeLensFontFamily=13]="codeLensFontFamily",V[V.codeLensFontSize=14]="codeLensFontSize",V[V.colorDecorators=15]="colorDecorators",V[V.columnSelection=16]="columnSelection",V[V.comments=17]="comments",V[V.contextmenu=18]="contextmenu",V[V.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",V[V.cursorBlinking=20]="cursorBlinking",V[V.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",V[V.cursorStyle=22]="cursorStyle",V[V.cursorSurroundingLines=23]="cursorSurroundingLines",V[V.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",V[V.cursorWidth=25]="cursorWidth",V[V.disableLayerHinting=26]="disableLayerHinting",V[V.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",V[V.domReadOnly=28]="domReadOnly",V[V.dragAndDrop=29]="dragAndDrop",V[V.emptySelectionClipboard=30]="emptySelectionClipboard",V[V.extraEditorClassName=31]="extraEditorClassName",V[V.fastScrollSensitivity=32]="fastScrollSensitivity",V[V.find=33]="find",V[V.fixedOverflowWidgets=34]="fixedOverflowWidgets",V[V.folding=35]="folding",V[V.foldingStrategy=36]="foldingStrategy",V[V.foldingHighlight=37]="foldingHighlight",V[V.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",V[V.fontFamily=39]="fontFamily",V[V.fontInfo=40]="fontInfo",V[V.fontLigatures=41]="fontLigatures",V[V.fontSize=42]="fontSize",V[V.fontWeight=43]="fontWeight",V[V.formatOnPaste=44]="formatOnPaste",V[V.formatOnType=45]="formatOnType",V[V.glyphMargin=46]="glyphMargin",V[V.gotoLocation=47]="gotoLocation",V[V.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",V[V.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",V[V.hover=50]="hover",V[V.inDiffEditor=51]="inDiffEditor",V[V.letterSpacing=52]="letterSpacing",V[V.lightbulb=53]="lightbulb",V[V.lineDecorationsWidth=54]="lineDecorationsWidth",V[V.lineHeight=55]="lineHeight",V[V.lineNumbers=56]="lineNumbers",V[V.lineNumbersMinChars=57]="lineNumbersMinChars",V[V.linkedEditing=58]="linkedEditing",V[V.links=59]="links",V[V.matchBrackets=60]="matchBrackets",V[V.minimap=61]="minimap",V[V.mouseStyle=62]="mouseStyle",V[V.mouseWheelScrollSensitivity=63]="mouseWheelScrollSensitivity",V[V.mouseWheelZoom=64]="mouseWheelZoom",V[V.multiCursorMergeOverlapping=65]="multiCursorMergeOverlapping",V[V.multiCursorModifier=66]="multiCursorModifier",V[V.multiCursorPaste=67]="multiCursorPaste",V[V.occurrencesHighlight=68]="occurrencesHighlight",V[V.overviewRulerBorder=69]="overviewRulerBorder",V[V.overviewRulerLanes=70]="overviewRulerLanes",V[V.padding=71]="padding",V[V.parameterHints=72]="parameterHints",V[V.peekWidgetDefaultFocus=73]="peekWidgetDefaultFocus",V[V.definitionLinkOpensInPeek=74]="definitionLinkOpensInPeek",V[V.quickSuggestions=75]="quickSuggestions",V[V.quickSuggestionsDelay=76]="quickSuggestionsDelay",V[V.readOnly=77]="readOnly",V[V.renameOnType=78]="renameOnType",V[V.renderControlCharacters=79]="renderControlCharacters",V[V.renderIndentGuides=80]="renderIndentGuides",V[V.renderFinalNewline=81]="renderFinalNewline",V[V.renderLineHighlight=82]="renderLineHighlight",V[V.renderLineHighlightOnlyWhenFocus=83]="renderLineHighlightOnlyWhenFocus",V[V.renderValidationDecorations=84]="renderValidationDecorations",V[V.renderWhitespace=85]="renderWhitespace",V[V.revealHorizontalRightPadding=86]="revealHorizontalRightPadding",V[V.roundedSelection=87]="roundedSelection",V[V.rulers=88]="rulers",V[V.scrollbar=89]="scrollbar",V[V.scrollBeyondLastColumn=90]="scrollBeyondLastColumn",V[V.scrollBeyondLastLine=91]="scrollBeyondLastLine",V[V.scrollPredominantAxis=92]="scrollPredominantAxis",V[V.selectionClipboard=93]="selectionClipboard",V[V.selectionHighlight=94]="selectionHighlight",V[V.selectOnLineNumbers=95]="selectOnLineNumbers",V[V.showFoldingControls=96]="showFoldingControls",V[V.showUnused=97]="showUnused",V[V.snippetSuggestions=98]="snippetSuggestions",V[V.smartSelect=99]="smartSelect",V[V.smoothScrolling=100]="smoothScrolling",V[V.stickyTabStops=101]="stickyTabStops",V[V.stopRenderingLineAfter=102]="stopRenderingLineAfter",V[V.suggest=103]="suggest",V[V.suggestFontSize=104]="suggestFontSize",V[V.suggestLineHeight=105]="suggestLineHeight",V[V.suggestOnTriggerCharacters=106]="suggestOnTriggerCharacters",V[V.suggestSelection=107]="suggestSelection",V[V.tabCompletion=108]="tabCompletion",V[V.tabIndex=109]="tabIndex",V[V.unusualLineTerminators=110]="unusualLineTerminators",V[V.useTabStops=111]="useTabStops",V[V.wordSeparators=112]="wordSeparators",V[V.wordWrap=113]="wordWrap",V[V.wordWrapBreakAfterCharacters=114]="wordWrapBreakAfterCharacters",V[V.wordWrapBreakBeforeCharacters=115]="wordWrapBreakBeforeCharacters",V[V.wordWrapColumn=116]="wordWrapColumn",V[V.wordWrapOverride1=117]="wordWrapOverride1",V[V.wordWrapOverride2=118]="wordWrapOverride2",V[V.wrappingIndent=119]="wrappingIndent",V[V.wrappingStrategy=120]="wrappingStrategy",V[V.showDeprecated=121]="showDeprecated",V[V.inlineHints=122]="inlineHints",V[V.editorClassName=123]="editorClassName",V[V.pixelRatio=124]="pixelRatio",V[V.tabFocusMode=125]="tabFocusMode",V[V.layoutInfo=126]="layoutInfo",V[V.wrappingInfo=127]="wrappingInfo"})(qe=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:be(new m(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:E.localize(111,null)})),acceptSuggestionOnEnter:be(new b(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",E.localize(112,null),""],markdownDescription:E.localize(113,null)})),accessibilitySupport:be(new u),accessibilityPageSize:be(new i(3,"accessibilityPageSize",10,1,1073741824,{description:E.localize(114,null)})),ariaLabel:be(new _(4,"ariaLabel",E.localize(115,null))),autoClosingBrackets:be(new b(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",E.localize(116,null),E.localize(117,null),""],description:E.localize(118,null)})),autoClosingDelete:be(new b(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",E.localize(119,null),""],description:E.localize(120,null)})),autoClosingOvertype:be(new b(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",E.localize(121,null),""],description:E.localize(122,null)})),autoClosingQuotes:be(new b(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",E.localize(123,null),E.localize(124,null),""],description:E.localize(125,null)})),autoIndent:be(new v(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],l,{enumDescriptions:[E.localize(126,null),E.localize(127,null),E.localize(128,null),E.localize(129,null),E.localize(130,null)],description:E.localize(131,null)})),automaticLayout:be(new m(10,"automaticLayout",!1)),autoSurround:be(new b(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[E.localize(132,null),E.localize(133,null),E.localize(134,null),""],description:E.localize(135,null)})),stickyTabStops:be(new m(101,"stickyTabStops",!1,{description:E.localize(136,null)})),codeLens:be(new m(12,"codeLens",!0,{description:E.localize(137,null)})),codeLensFontFamily:be(new _(13,"codeLensFontFamily","",{description:E.localize(138,null)})),codeLensFontSize:be(new i(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,description:E.localize(139,null)})),colorDecorators:be(new m(15,"colorDecorators",!0,{description:E.localize(140,null)})),columnSelection:be(new m(16,"columnSelection",!1,{description:E.localize(141,null)})),comments:be(new t),contextmenu:be(new m(18,"contextmenu",!0)),copyWithSyntaxHighlighting:be(new m(19,"copyWithSyntaxHighlighting",!0,{description:E.localize(142,null)})),cursorBlinking:be(new v(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],c,{description:E.localize(143,null)})),cursorSmoothCaretAnimation:be(new m(21,"cursorSmoothCaretAnimation",!1,{description:E.localize(144,null)})),cursorStyle:be(new v(22,"cursorStyle",o.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],f,{description:E.localize(145,null)})),cursorSurroundingLines:be(new i(23,"cursorSurroundingLines",0,0,1073741824,{description:E.localize(146,null)})),cursorSurroundingLinesStyle:be(new b(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[E.localize(147,null),E.localize(148,null)],description:E.localize(149,null)})),cursorWidth:be(new i(25,"cursorWidth",0,0,1073741824,{markdownDescription:E.localize(150,null)})),disableLayerHinting:be(new m(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:be(new m(27,"disableMonospaceOptimizations",!1)),domReadOnly:be(new m(28,"domReadOnly",!1)),dragAndDrop:be(new m(29,"dragAndDrop",!0,{description:E.localize(151,null)})),emptySelectionClipboard:be(new D),extraEditorClassName:be(new _(31,"extraEditorClassName","")),fastScrollSensitivity:be(new s(32,"fastScrollSensitivity",5,V=>V<=0?5:V,{markdownDescription:E.localize(152,null)})),find:be(new p),fixedOverflowWidgets:be(new m(34,"fixedOverflowWidgets",!1)),folding:be(new m(35,"folding",!0,{description:E.localize(153,null)})),foldingStrategy:be(new b(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[E.localize(154,null),E.localize(155,null)],description:E.localize(156,null)})),foldingHighlight:be(new m(37,"foldingHighlight",!0,{description:E.localize(157,null)})),unfoldOnClickAfterEndOfLine:be(new m(38,"unfoldOnClickAfterEndOfLine",!1,{description:E.localize(158,null)})),fontFamily:be(new _(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:E.localize(159,null)})),fontInfo:be(new R),fontLigatures2:be(new h),fontSize:be(new F),fontWeight:be(new $),formatOnPaste:be(new m(44,"formatOnPaste",!1,{description:E.localize(160,null)})),formatOnType:be(new m(45,"formatOnType",!1,{description:E.localize(161,null)})),glyphMargin:be(new m(46,"glyphMargin",!0,{description:E.localize(162,null)})),gotoLocation:be(new se),hideCursorInOverviewRuler:be(new m(48,"hideCursorInOverviewRuler",!1,{description:E.localize(163,null)})),highlightActiveIndentGuide:be(new m(49,"highlightActiveIndentGuide",!0,{description:E.localize(164,null)})),hover:be(new z),inDiffEditor:be(new m(51,"inDiffEditor",!1)),letterSpacing:be(new s(52,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,V=>s.clamp(V,-5,20),{description:E.localize(165,null)})),lightbulb:be(new M),lineDecorationsWidth:be(new k(54,"lineDecorationsWidth",10)),lineHeight:be(new B),lineNumbers:be(new $e),lineNumbersMinChars:be(new i(57,"lineNumbersMinChars",5,1,300)),linkedEditing:be(new m(58,"linkedEditing",!1,{description:E.localize(166,null)})),links:be(new m(59,"links",!0,{description:E.localize(167,null)})),matchBrackets:be(new b(60,"matchBrackets","always",["always","near","never"],{description:E.localize(168,null)})),minimap:be(new Q),mouseStyle:be(new b(62,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:be(new s(63,"mouseWheelScrollSensitivity",1,V=>V===0?1:V,{markdownDescription:E.localize(169,null)})),mouseWheelZoom:be(new m(64,"mouseWheelZoom",!1,{markdownDescription:E.localize(170,null)})),multiCursorMergeOverlapping:be(new m(65,"multiCursorMergeOverlapping",!0,{description:E.localize(171,null)})),multiCursorModifier:be(new v(66,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],W,{markdownEnumDescriptions:[E.localize(172,null),E.localize(173,null)],markdownDescription:E.localize(174,null)})),multiCursorPaste:be(new b(67,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[E.localize(175,null),E.localize(176,null)],markdownDescription:E.localize(177,null)})),occurrencesHighlight:be(new m(68,"occurrencesHighlight",!0,{description:E.localize(178,null)})),overviewRulerBorder:be(new m(69,"overviewRulerBorder",!0,{description:E.localize(179,null)})),overviewRulerLanes:be(new i(70,"overviewRulerLanes",3,0,3)),padding:be(new ee),parameterHints:be(new re),peekWidgetDefaultFocus:be(new b(73,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[E.localize(180,null),E.localize(181,null)],description:E.localize(182,null)})),definitionLinkOpensInPeek:be(new m(74,"definitionLinkOpensInPeek",!1,{description:E.localize(183,null)})),quickSuggestions:be(new Se),quickSuggestionsDelay:be(new i(76,"quickSuggestionsDelay",10,0,1073741824,{description:E.localize(184,null)})),readOnly:be(new m(77,"readOnly",!1)),renameOnType:be(new m(78,"renameOnType",!1,{description:E.localize(185,null),markdownDeprecationMessage:E.localize(186,null)})),renderControlCharacters:be(new m(79,"renderControlCharacters",!1,{description:E.localize(187,null)})),renderIndentGuides:be(new m(80,"renderIndentGuides",!0,{description:E.localize(188,null)})),renderFinalNewline:be(new m(81,"renderFinalNewline",!0,{description:E.localize(189,null)})),renderLineHighlight:be(new b(82,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",E.localize(190,null)],description:E.localize(191,null)})),renderLineHighlightOnlyWhenFocus:be(new m(83,"renderLineHighlightOnlyWhenFocus",!1,{description:E.localize(192,null)})),renderValidationDecorations:be(new b(84,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:be(new b(85,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",E.localize(193,null),E.localize(194,null),E.localize(195,null),""],description:E.localize(196,null)})),revealHorizontalRightPadding:be(new i(86,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:be(new m(87,"roundedSelection",!0,{description:E.localize(197,null)})),rulers:be(new ze),scrollbar:be(new K),scrollBeyondLastColumn:be(new i(90,"scrollBeyondLastColumn",5,0,1073741824,{description:E.localize(198,null)})),scrollBeyondLastLine:be(new m(91,"scrollBeyondLastLine",!0,{description:E.localize(199,null)})),scrollPredominantAxis:be(new m(92,"scrollPredominantAxis",!0,{description:E.localize(200,null)})),selectionClipboard:be(new m(93,"selectionClipboard",!0,{description:E.localize(201,null),included:I.isLinux})),selectionHighlight:be(new m(94,"selectionHighlight",!0,{description:E.localize(202,null)})),selectOnLineNumbers:be(new m(95,"selectOnLineNumbers",!0)),showFoldingControls:be(new b(96,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[E.localize(203,null),E.localize(204,null)],description:E.localize(205,null)})),showUnused:be(new m(97,"showUnused",!0,{description:E.localize(206,null)})),showDeprecated:be(new m(121,"showDeprecated",!0,{description:E.localize(207,null)})),inlineHints:be(new N),snippetSuggestions:be(new b(98,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[E.localize(208,null),E.localize(209,null),E.localize(210,null),E.localize(211,null)],description:E.localize(212,null)})),smartSelect:be(new le),smoothScrolling:be(new m(100,"smoothScrolling",!1,{description:E.localize(213,null)})),stopRenderingLineAfter:be(new i(102,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:be(new te),suggestFontSize:be(new i(104,"suggestFontSize",0,0,1e3,{markdownDescription:E.localize(214,null)})),suggestLineHeight:be(new i(105,"suggestLineHeight",0,0,1e3,{markdownDescription:E.localize(215,null)})),suggestOnTriggerCharacters:be(new m(106,"suggestOnTriggerCharacters",!0,{description:E.localize(216,null)})),suggestSelection:be(new b(107,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[E.localize(217,null),E.localize(218,null),E.localize(219,null)],description:E.localize(220,null)})),tabCompletion:be(new b(108,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[E.localize(221,null),E.localize(222,null),E.localize(223,null)],description:E.localize(224,null)})),tabIndex:be(new i(109,"tabIndex",0,-1,1073741824)),unusualLineTerminators:be(new b(110,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[E.localize(225,null),E.localize(226,null),E.localize(227,null)],description:E.localize(228,null)})),useTabStops:be(new m(111,"useTabStops",!0,{description:E.localize(229,null)})),wordSeparators:be(new _(112,"wordSeparators",P.USUAL_WORD_SEPARATORS,{description:E.localize(230,null)})),wordWrap:be(new b(113,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[E.localize(231,null),E.localize(232,null),E.localize(233,null),E.localize(234,null)],description:E.localize(235,null)})),wordWrapBreakAfterCharacters:be(new _(114,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:be(new _(115,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:be(new i(116,"wordWrapColumn",80,1,1073741824,{markdownDescription:E.localize(236,null)})),wordWrapOverride1:be(new b(117,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:be(new b(118,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:be(new v(119,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Oe,{enumDescriptions:[E.localize(237,null),E.localize(238,null),E.localize(239,null),E.localize(240,null)],description:E.localize(241,null)})),wrappingStrategy:be(new b(120,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[E.localize(242,null),E.localize(243,null)],description:E.localize(244,null)})),editorClassName:be(new w),pixelRatio:be(new oe),tabFocusMode:be(new me),layoutInfo:be(new G),wrappingInfo:be(new ge)}}),define(_e[122],we([16,17]),function(ie,e){return ie.create("vs/platform/configuration/common/configurationRegistry",e)}),define(_e[123],we([16,17]),function(ie,e){return ie.create("vs/platform/extensions/common/extensionValidator",e)}),define(_e[124],we([16,17]),function(ie,e){return ie.create("vs/platform/files/common/files",e)}),define(_e[125],we([16,17]),function(ie,e){return ie.create("vs/platform/markers/common/markers",e)}),define(_e[126],we([16,17]),function(ie,e){return ie.create("vs/platform/theme/common/iconRegistry",e)}),define(_e[127],we([16,17]),function(ie,e){return ie.create("vs/platform/workspaces/common/workspaces",e)}),define(_e[128],we([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHost.api.impl",e)}),define(_e[129],we([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(_e[130],we([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostExtensionActivator",e)}),define(_e[131],we([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostExtensionService",e)}),define(_e[132],we([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostProgress",e)}),define(_e[133],we([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostStatusBar",e)}),define(_e[134],we([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTerminalService",e)}),define(_e[135],we([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTreeViews",e)}),define(_e[136],we([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostWorkspace",e)}),define(_e[137],we([16,17]),function(ie,e){return ie.create("vs/workbench/common/views",e)}),define(_e[138],we([16,17]),function(ie,e){return ie.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(_e[139],we([16,17]),function(ie,e){return ie.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(_e[140],we([16,17]),function(ie,e){return ie.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(_e[141],we([16,17]),function(ie,e){return ie.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(_e[142],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var E;(function(S){S[S.ACTIVATE=0]="ACTIVATE",S[S.RESTORE=1]="RESTORE",S[S.PRESERVE=2]="PRESERVE"})(E=e.EditorActivation||(e.EditorActivation={}));var I;(function(S){S[S.PICK=1]="PICK",S[S.DISABLED=2]="DISABLED"})(I=e.EditorOverride||(e.EditorOverride={}));var P;(function(S){S[S.API=0]="API",S[S.USER=1]="USER"})(P=e.EditorOpenContext||(e.EditorOpenContext={}));var A;(function(S){S[S.Center=0]="Center",S[S.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",S[S.NearTop=2]="NearTop",S[S.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(A=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(_e[143],we([0,1,123]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVersionValid=e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const I=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function P(k){return k=k.trim(),k==="*"||I.test(k)}e.isValidVersionStr=P;function A(k){if(!P(k))return null;if(k=k.trim(),k==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let g=k.match(I);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=A;function S(k){if(!k)return null;let g=k.majorBase,m=k.majorMustEqual,i=k.minorBase,s=k.minorMustEqual,_=k.patchBase,d=k.patchMustEqual;return k.hasCaret&&(g===0||(s=!1),d=!1),{majorBase:g,majorMustEqual:m,minorBase:i,minorMustEqual:s,patchBase:_,patchMustEqual:d,isMinimum:k.hasGreaterEquals}}e.normalizeVersion=S;function C(k,g){let m;typeof k=="string"?m=S(A(k)):m=k;let i;if(typeof g=="string"?i=S(A(g)):i=g,!m||!i)return!1;let s=m.majorBase,_=m.minorBase,d=m.patchBase,b=i.majorBase,v=i.minorBase,l=i.patchBase,u=i.majorMustEqual,t=i.minorMustEqual,r=i.patchMustEqual;return i.isMinimum?s>b?!0:s<b?!1:_>v?!0:_<v?!1:d>=l:(s===1&&b===0&&(!u||!t||!r)&&(b=1,v=0,l=0,u=!0,t=!1,r=!1),s<b?!1:s>b?!u:_<v?!1:_>v?!t:d<l?!1:d>l?!r:!0)}e.isValidVersion=C;function y(k,g,m){return g.isBuiltin||typeof g.main=="undefined"?!0:T(k,g.engines.vscode,m)}e.isValidExtensionVersion=y;function n(k,g){return k==="*"||T(g,k)}e.isEngineValid=n;function T(k,g,m=[]){let i=S(A(g));if(!i)return m.push(E.localize(0,null,g)),!1;if(i.majorBase===0){if(!i.majorMustEqual||!i.minorMustEqual)return m.push(E.localize(1,null,g)),!1}else if(!i.majorMustEqual)return m.push(E.localize(2,null,g)),!1;return C(k,i)?!0:(m.push(E.localize(3,null,k,g)),!1)}e.isVersionValid=T}),define(_e[86],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class E{constructor(A,S=[],C=!1){this.ctor=A,this.staticArguments=S,this.supportsDelayedInstantiation=C}}e.SyncDescriptor=E;const I=(P,...A)=>new E(P,A);e.createSyncDescriptor=I}),define(_e[61],we([0,1,86]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const I=[];function P(S,C,y){C instanceof E.SyncDescriptor||(C=new E.SyncDescriptor(C,[],y)),I.push([S,C])}e.registerSingleton=P;function A(){return I}e.getSingletonServiceDescriptors=A}),define(_e[144],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class E{constructor(A){this.incoming=new Map,this.outgoing=new Map,this.data=A}}e.Node=E;class I{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(let S of this._nodes.values())S.outgoing.size===0&&A.push(S);return A}insertEdge(A,S){const C=this.lookupOrInsertNode(A),y=this.lookupOrInsertNode(S);C.outgoing.set(this._hashFn(S),y),y.incoming.set(this._hashFn(A),C)}removeNode(A){const S=this._hashFn(A);this._nodes.delete(S);for(let C of this._nodes.values())C.outgoing.delete(S),C.incoming.delete(S)}lookupOrInsertNode(A){const S=this._hashFn(A);let C=this._nodes.get(S);return C||(C=new E(A),this._nodes.set(S,C)),C}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){let A=[];for(let[S,C]of this._nodes)A.push(`${S}, (incoming)[${[...C.incoming.keys()].join(", ")}], (outgoing)[${[...C.outgoing.keys()].join(",")}]`);return A.join(`
`)}}e.Graph=I}),define(_e[4],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var E;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function y(n){return n[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=y})(E=e._util||(e._util={})),e.IInstantiationService=P("instantiationService");function I(C,y,n,T){y[E.DI_TARGET]===y?y[E.DI_DEPENDENCIES].push({id:C,index:n,optional:T}):(y[E.DI_DEPENDENCIES]=[{id:C,index:n,optional:T}],y[E.DI_TARGET]=y)}function P(C){if(E.serviceIds.has(C))return E.serviceIds.get(C);const y=function(n,T,k){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");I(y,n,k,!1)};return y.toString=()=>C,E.serviceIds.set(C,y),y}e.createDecorator=P;function A(C){return C}e.refineServiceDecorator=A;function S(C){return function(y,n,T){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");I(C,y,T,!0)}}e.optional=S}),define(_e[145],we([0,1,4]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,E.createDecorator)("modelService");function I(P){return!P.isTooLargeForSyncing()&&!P.isForSimpleWidget}e.shouldSynchronizeModel=I}),define(_e[146],we([0,1,3,56,6,22,78,59,145]),function(ie,e,E,I,P,A,S,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function n(g){return typeof g=="string"?!1:Array.isArray(g)?g.every(n):!!g.exclusive}class T{constructor(){this._clock=0,this._entries=[],this._onDidChange=new E.Emitter}get onDidChange(){return this._onDidChange.event}register(m,i){let s={selector:m,provider:i,_score:-1,_time:this._clock++};return this._entries.push(s),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,P.toDisposable)(()=>{if(s){let _=this._entries.indexOf(s);_>=0&&(this._entries.splice(_,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),s=void 0)}})}has(m){return this.all(m).length>0}all(m){if(!m)return[];this._updateScores(m);const i=[];for(let s of this._entries)s._score>0&&i.push(s.provider);return i}ordered(m){const i=[];return this._orderedForEach(m,s=>i.push(s.provider)),i}orderedGroups(m){const i=[];let s,_;return this._orderedForEach(m,d=>{s&&_===d._score?s.push(d.provider):(_=d._score,s=[d.provider],i.push(s))}),i}_orderedForEach(m,i){if(!!m){this._updateScores(m);for(const s of this._entries)s._score>0&&i(s)}}_updateScores(m){let i={uri:m.uri.toString(),language:m.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===i.language&&this._lastCandidate.uri===i.uri)){this._lastCandidate=i;for(let s of this._entries)if(s._score=(0,C.score)(s.selector,m.uri,m.getLanguageIdentifier().language,(0,y.shouldSynchronizeModel)(m)),n(s.selector)&&s._score>0){for(let _ of this._entries)_._score=0;s._score=1e3;break}this._entries.sort(T._compareByScoreAndTime)}}static _compareByScoreAndTime(m,i){return m._score<i._score?1:m._score>i._score?-1:m._time<i._time?1:m._time>i._time?-1:0}}e.LanguageFeatureRegistry=T;class k{constructor(m,i,s=Number.MAX_SAFE_INTEGER){this._registry=m,this.min=i,this.max=s,this._cache=new A.LRUCache(50,.7)}_key(m){return m.id+(0,I.hash)(this._registry.all(m))}_clamp(m){return m===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(m*1.3)))}get(m){const i=this._key(m),s=this._cache.get(i);return this._clamp(s==null?void 0:s.value)}update(m,i){const s=this._key(m);let _=this._cache.get(s);return _||(_=new S.MovingAverage,this._cache.set(s,_)),_.update(i),this.get(m)}}e.LanguageFeatureRequestDelays=k}),define(_e[62],we([0,1,2,32,146,117,36]),function(ie,e,E,I,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlineHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlineHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var C;(function(p){p[p.Null=0]="Null",p[p.PlainText=1]="PlainText"})(C=e.LanguageId||(e.LanguageId={}));class y{constructor(h,R){this.language=h,this.id=R}}e.LanguageIdentifier=y;var n;(function(p){p[p.NotSet=-1]="NotSet",p[p.None=0]="None",p[p.Italic=1]="Italic",p[p.Bold=2]="Bold",p[p.Underline=4]="Underline"})(n=e.FontStyle||(e.FontStyle={}));var T;(function(p){p[p.None=0]="None",p[p.DefaultForeground=1]="DefaultForeground",p[p.DefaultBackground=2]="DefaultBackground"})(T=e.ColorId||(e.ColorId={}));var k;(function(p){p[p.Other=0]="Other",p[p.Comment=1]="Comment",p[p.String=2]="String",p[p.RegEx=4]="RegEx"})(k=e.StandardTokenType||(e.StandardTokenType={}));var g;(function(p){p[p.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",p[p.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",p[p.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",p[p.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",p[p.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",p[p.ITALIC_MASK=2048]="ITALIC_MASK",p[p.BOLD_MASK=4096]="BOLD_MASK",p[p.UNDERLINE_MASK=8192]="UNDERLINE_MASK",p[p.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",p[p.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",p[p.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",p[p.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",p[p.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",p[p.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",p[p.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",p[p.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",p[p.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",p[p.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(g=e.MetadataConsts||(e.MetadataConsts={}));class m{static getLanguageId(h){return(h&255)>>>0}static getTokenType(h){return(h&1792)>>>8}static getFontStyle(h){return(h&14336)>>>11}static getForeground(h){return(h&8372224)>>>14}static getBackground(h){return(h&4286578688)>>>23}static getClassNameFromMetadata(h){let R=this.getForeground(h),F="mtk"+R,$=this.getFontStyle(h);return $&1&&(F+=" mtki"),$&2&&(F+=" mtkb"),$&4&&(F+=" mtku"),F}static getInlineStyleFromMetadata(h,R){const F=this.getForeground(h),$=this.getFontStyle(h);let se=`color: ${R[F]};`;return $&1&&(se+="font-style: italic;"),$&2&&(se+="font-weight: bold;"),$&4&&(se+="text-decoration: underline;"),se}}e.TokenMetadata=m;var i;(function(p){p[p.Method=0]="Method",p[p.Function=1]="Function",p[p.Constructor=2]="Constructor",p[p.Field=3]="Field",p[p.Variable=4]="Variable",p[p.Class=5]="Class",p[p.Struct=6]="Struct",p[p.Interface=7]="Interface",p[p.Module=8]="Module",p[p.Property=9]="Property",p[p.Event=10]="Event",p[p.Operator=11]="Operator",p[p.Unit=12]="Unit",p[p.Value=13]="Value",p[p.Constant=14]="Constant",p[p.Enum=15]="Enum",p[p.EnumMember=16]="EnumMember",p[p.Keyword=17]="Keyword",p[p.Text=18]="Text",p[p.Color=19]="Color",p[p.File=20]="File",p[p.Reference=21]="Reference",p[p.Customcolor=22]="Customcolor",p[p.Folder=23]="Folder",p[p.TypeParameter=24]="TypeParameter",p[p.User=25]="User",p[p.Issue=26]="Issue",p[p.Snippet=27]="Snippet"})(i=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let p=Object.create(null);return p[0]="symbol-method",p[1]="symbol-function",p[2]="symbol-constructor",p[3]="symbol-field",p[4]="symbol-variable",p[5]="symbol-class",p[6]="symbol-struct",p[7]="symbol-interface",p[8]="symbol-module",p[9]="symbol-property",p[10]="symbol-event",p[11]="symbol-operator",p[12]="symbol-unit",p[13]="symbol-value",p[14]="symbol-constant",p[15]="symbol-enum",p[16]="symbol-enum-member",p[17]="symbol-keyword",p[27]="symbol-snippet",p[18]="symbol-text",p[19]="symbol-color",p[20]="symbol-file",p[21]="symbol-reference",p[22]="symbol-customcolor",p[23]="symbol-folder",p[24]="symbol-type-parameter",p[25]="account",p[26]="issues",function(h){const R=p[h];let F=R&&S.iconRegistry.get(R);return F||(console.info("No codicon found for CompletionItemKind "+h),F=S.Codicon.symbolProperty),F.classNames}}(),e.completionKindFromString=function(){let p=Object.create(null);return p.method=0,p.function=1,p.constructor=2,p.field=3,p.variable=4,p.class=5,p.struct=6,p.interface=7,p.module=8,p.property=9,p.event=10,p.operator=11,p.unit=12,p.value=13,p.constant=14,p.enum=15,p["enum-member"]=16,p.enumMember=16,p.keyword=17,p.snippet=27,p.text=18,p.color=19,p.file=20,p.reference=21,p.customcolor=22,p.folder=23,p["type-parameter"]=24,p.typeParameter=24,p.account=25,p.issue=26,function(h,R){let F=p[h];return typeof F=="undefined"&&!R&&(F=9),F}}();var s;(function(p){p[p.Deprecated=1]="Deprecated"})(s=e.CompletionItemTag||(e.CompletionItemTag={}));var _;(function(p){p[p.KeepWhitespace=1]="KeepWhitespace",p[p.InsertAsSnippet=4]="InsertAsSnippet"})(_=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var d;(function(p){p[p.Invoke=0]="Invoke",p[p.TriggerCharacter=1]="TriggerCharacter",p[p.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(d=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var b;(function(p){p[p.Invoke=1]="Invoke",p[p.Auto=2]="Auto"})(b=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var v;(function(p){p[p.Invoke=1]="Invoke",p[p.TriggerCharacter=2]="TriggerCharacter",p[p.ContentChange=3]="ContentChange"})(v=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var l;(function(p){p[p.Text=0]="Text",p[p.Read=1]="Read",p[p.Write=2]="Write"})(l=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function u(p){return p&&E.URI.isUri(p.uri)&&I.Range.isIRange(p.range)&&(I.Range.isIRange(p.originSelectionRange)||I.Range.isIRange(p.targetSelectionRange))}e.isLocationLink=u;var t;(function(p){p[p.File=0]="File",p[p.Module=1]="Module",p[p.Namespace=2]="Namespace",p[p.Package=3]="Package",p[p.Class=4]="Class",p[p.Method=5]="Method",p[p.Property=6]="Property",p[p.Field=7]="Field",p[p.Constructor=8]="Constructor",p[p.Enum=9]="Enum",p[p.Interface=10]="Interface",p[p.Function=11]="Function",p[p.Variable=12]="Variable",p[p.Constant=13]="Constant",p[p.String=14]="String",p[p.Number=15]="Number",p[p.Boolean=16]="Boolean",p[p.Array=17]="Array",p[p.Object=18]="Object",p[p.Key=19]="Key",p[p.Null=20]="Null",p[p.EnumMember=21]="EnumMember",p[p.Struct=22]="Struct",p[p.Event=23]="Event",p[p.Operator=24]="Operator",p[p.TypeParameter=25]="TypeParameter"})(t=e.SymbolKind||(e.SymbolKind={}));var r;(function(p){p[p.Deprecated=1]="Deprecated"})(r=e.SymbolTag||(e.SymbolTag={}));var c;(function(p){const h=new Map;h.set("file",0),h.set("module",1),h.set("namespace",2),h.set("package",3),h.set("class",4),h.set("method",5),h.set("property",6),h.set("field",7),h.set("constructor",8),h.set("enum",9),h.set("interface",10),h.set("function",11),h.set("variable",12),h.set("constant",13),h.set("string",14),h.set("number",15),h.set("boolean",16),h.set("array",17),h.set("object",18),h.set("key",19),h.set("null",20),h.set("enum-member",21),h.set("struct",22),h.set("event",23),h.set("operator",24),h.set("type-parameter",25);const R=new Map;R.set(0,"file"),R.set(1,"module"),R.set(2,"namespace"),R.set(3,"package"),R.set(4,"class"),R.set(5,"method"),R.set(6,"property"),R.set(7,"field"),R.set(8,"constructor"),R.set(9,"enum"),R.set(10,"interface"),R.set(11,"function"),R.set(12,"variable"),R.set(13,"constant"),R.set(14,"string"),R.set(15,"number"),R.set(16,"boolean"),R.set(17,"array"),R.set(18,"object"),R.set(19,"key"),R.set(20,"null"),R.set(21,"enum-member"),R.set(22,"struct"),R.set(23,"event"),R.set(24,"operator"),R.set(25,"type-parameter");function F(z){return h.get(z)}p.fromString=F;function $(z){return R.get(z)}p.toString=$;function se(z,x){const G=R.get(z);let M=G&&S.iconRegistry.get("symbol-"+G);return M||(console.info("No codicon found for SymbolKind "+z),M=S.Codicon.symbolProperty),`${x?"inline":"block"} ${M.classNames}`}p.toCssClassName=se})(c=e.SymbolKinds||(e.SymbolKinds={}));class o{constructor(h){this.value=h}}e.FoldingRangeKind=o,o.Comment=new o("comment"),o.Imports=new o("imports"),o.Region=new o("region");var a;(function(p){p[p.Collapsed=0]="Collapsed",p[p.Expanded=1]="Expanded"})(a=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var f;(function(p){p[p.Editing=0]="Editing",p[p.Preview=1]="Preview"})(f=e.CommentMode||(e.CommentMode={}));var w;(function(p){p[p.Other=0]="Other",p[p.Type=1]="Type",p[p.Parameter=2]="Parameter"})(w=e.InlineHintKind||(e.InlineHintKind={})),e.ReferenceProviderRegistry=new P.LanguageFeatureRegistry,e.RenameProviderRegistry=new P.LanguageFeatureRegistry,e.CompletionProviderRegistry=new P.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new P.LanguageFeatureRegistry,e.HoverProviderRegistry=new P.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new P.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new P.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new P.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new P.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new P.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new P.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new P.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new P.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new P.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new P.LanguageFeatureRegistry,e.InlineHintsProviderRegistry=new P.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new P.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new P.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new P.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new P.LanguageFeatureRegistry,e.LinkProviderRegistry=new P.LanguageFeatureRegistry,e.ColorProviderRegistry=new P.LanguageFeatureRegistry,e.SelectionRangeRegistry=new P.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new P.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new P.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new P.LanguageFeatureRegistry,e.TokenizationRegistry=new A.TokenizationRegistryImpl;var D;(function(p){p[p.None=0]="None",p[p.Option=1]="Option",p[p.Default=2]="Default",p[p.Preferred=3]="Preferred"})(D=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(_e[147],we([0,1,6,13,4,3,44,54]),function(ie,e,E,I,P,A,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullCommandService=e.CommandsRegistry=e.ICommandService=void 0,e.ICommandService=(0,P.createDecorator)("commandService"),e.CommandsRegistry=new class{constructor(){this._commands=new Map,this._onDidRegisterCommand=new A.Emitter,this.onDidRegisterCommand=this._onDidRegisterCommand.event}registerCommand(y,n){if(!y)throw new Error("invalid command");if(typeof y=="string"){if(!n)throw new Error("invalid command");return this.registerCommand({id:y,handler:n})}if(y.description){const i=[];for(let _ of y.description.args)i.push(_.constraint);const s=y.handler;y.handler=function(_,...d){return(0,I.validateConstraints)(d,i),s(_,...d)}}const{id:T}=y;let k=this._commands.get(T);k||(k=new S.LinkedList,this._commands.set(T,k));let g=k.unshift(y),m=(0,E.toDisposable)(()=>{g();const i=this._commands.get(T);(i==null?void 0:i.isEmpty())&&this._commands.delete(T)});return this._onDidRegisterCommand.fire(T),m}registerCommandAlias(y,n){return e.CommandsRegistry.registerCommand(y,(T,...k)=>T.get(e.ICommandService).executeCommand(n,...k))}getCommand(y){const n=this._commands.get(y);if(!(!n||n.isEmpty()))return C.Iterable.first(n)}getCommands(){const y=new Map;for(const n of this._commands.keys()){const T=this.getCommand(n);T&&y.set(n,T)}return y}},e.NullCommandService={_serviceBrand:void 0,onWillExecuteCommand:()=>E.Disposable.None,onDidExecuteCommand:()=>E.Disposable.None,executeCommand(){return Promise.resolve(void 0)}}}),define(_e[63],we([0,1,8,4,21]),function(ie,e,E,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let A=P.userAgent||"";const S=new Map;S.set("false",!1),S.set("true",!0),S.set("isMac",P.isMacintosh),S.set("isLinux",P.isLinux),S.set("isWindows",P.isWindows),S.set("isWeb",P.isWeb),S.set("isMacNative",P.isMacintosh&&!P.isWeb),S.set("isEdge",A.indexOf("Edg/")>=0),S.set("isFirefox",A.indexOf("Firefox")>=0),S.set("isChrome",A.indexOf("Chrome")>=0),S.set("isSafari",A.indexOf("Safari")>=0),S.set("isIPad",A.indexOf("iPad")>=0);const C=Object.prototype.hasOwnProperty;var y;(function(p){p[p.False=0]="False",p[p.True=1]="True",p[p.Defined=2]="Defined",p[p.Not=3]="Not",p[p.Equals=4]="Equals",p[p.NotEquals=5]="NotEquals",p[p.And=6]="And",p[p.Regex=7]="Regex",p[p.NotRegex=8]="NotRegex",p[p.Or=9]="Or",p[p.In=10]="In",p[p.NotIn=11]="NotIn",p[p.Greater=12]="Greater",p[p.GreaterEquals=13]="GreaterEquals",p[p.Smaller=14]="Smaller",p[p.SmallerEquals=15]="SmallerEquals"})(y=e.ContextKeyExprType||(e.ContextKeyExprType={}));class n{static false(){return k.INSTANCE}static true(){return g.INSTANCE}static has(h){return m.create(h)}static equals(h,R){return i.create(h,R)}static notEquals(h,R){return d.create(h,R)}static regex(h,R){return r.create(h,R)}static in(h,R){return s.create(h,R)}static not(h){return b.create(h)}static and(...h){return o.create(h)}static or(...h){return a.create(h)}static greater(h,R){return v.create(h,R)}static less(h,R){return u.create(h,R)}static deserialize(h,R=!1){if(!!h)return this._deserializeOrExpression(h,R)}static _deserializeOrExpression(h,R){let F=h.split("||");return a.create(F.map($=>this._deserializeAndExpression($,R)))}static _deserializeAndExpression(h,R){let F=h.split("&&");return o.create(F.map($=>this._deserializeOne($,R)))}static _deserializeOne(h,R){if(h=h.trim(),h.indexOf("!=")>=0){let F=h.split("!=");return d.create(F[0].trim(),this._deserializeValue(F[1],R))}if(h.indexOf("==")>=0){let F=h.split("==");return i.create(F[0].trim(),this._deserializeValue(F[1],R))}if(h.indexOf("=~")>=0){let F=h.split("=~");return r.create(F[0].trim(),this._deserializeRegexValue(F[1],R))}if(h.indexOf(" in ")>=0){let F=h.split(" in ");return s.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(h)){const F=h.split(">=");return l.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(h)){const F=h.split(">");return v.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(h)){const F=h.split("<=");return t.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(h)){const F=h.split("<");return u.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(h)?b.create(h.substr(1).trim()):m.create(h)}static _deserializeValue(h,R){if(h=h.trim(),h==="true")return!0;if(h==="false")return!1;let F=/^'([^']*)'$/.exec(h);return F?F[1].trim():h}static _deserializeRegexValue(h,R){if((0,E.isFalsyOrWhitespace)(h)){if(R)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let F=h.indexOf("/"),$=h.lastIndexOf("/");if(F===$||F<0){if(R)throw new Error(`bad regexp-value '${h}', missing /-enclosure`);return console.warn(`bad regexp-value '${h}', missing /-enclosure`),null}let se=h.slice(F+1,$),z=h[$+1]==="i"?"i":"";try{return new RegExp(se,z)}catch(x){if(R)throw new Error(`bad regexp-value '${h}', parse error: ${x}`);return console.warn(`bad regexp-value '${h}', parse error: ${x}`),null}}}e.ContextKeyExpr=n;function T(p,h){return p.cmp(h)}class k{constructor(){this.type=0}cmp(h){return this.type-h.type}equals(h){return h.type===this.type}evaluate(h){return!1}serialize(){return"false"}keys(){return[]}map(h){return this}negate(){return g.INSTANCE}}e.ContextKeyFalseExpr=k,k.INSTANCE=new k;class g{constructor(){this.type=1}cmp(h){return this.type-h.type}equals(h){return h.type===this.type}evaluate(h){return!0}serialize(){return"true"}keys(){return[]}map(h){return this}negate(){return k.INSTANCE}}e.ContextKeyTrueExpr=g,g.INSTANCE=new g;class m{constructor(h){this.key=h,this.type=2}static create(h){const R=S.get(h);return typeof R=="boolean"?R?g.INSTANCE:k.INSTANCE:new m(h)}cmp(h){return h.type!==this.type?this.type-h.type:w(this.key,h.key)}equals(h){return h.type===this.type?this.key===h.key:!1}evaluate(h){return!!h.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(h){return h.mapDefined(this.key)}negate(){return b.create(this.key)}}e.ContextKeyDefinedExpr=m;class i{constructor(h,R){this.key=h,this.value=R,this.type=4}static create(h,R){if(typeof R=="boolean")return R?m.create(h):b.create(h);const F=S.get(h);return typeof F=="boolean"?R===(F?"true":"false")?g.INSTANCE:k.INSTANCE:new i(h,R)}cmp(h){return h.type!==this.type?this.type-h.type:D(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}evaluate(h){return h.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(h){return h.mapEquals(this.key,this.value)}negate(){return d.create(this.key,this.value)}}e.ContextKeyEqualsExpr=i;class s{constructor(h,R){this.key=h,this.valueKey=R,this.type=10}static create(h,R){return new s(h,R)}cmp(h){return h.type!==this.type?this.type-h.type:D(this.key,this.valueKey,h.key,h.valueKey)}equals(h){return h.type===this.type?this.key===h.key&&this.valueKey===h.valueKey:!1}evaluate(h){const R=h.getValue(this.valueKey),F=h.getValue(this.key);return Array.isArray(R)?R.indexOf(F)>=0:typeof F=="string"&&typeof R=="object"&&R!==null?C.call(R,F):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(h){return h.mapIn(this.key,this.valueKey)}negate(){return _.create(this)}}e.ContextKeyInExpr=s;class _{constructor(h){this._actual=h,this.type=11}static create(h){return new _(h)}cmp(h){return h.type!==this.type?this.type-h.type:this._actual.cmp(h._actual)}equals(h){return h.type===this.type?this._actual.equals(h._actual):!1}evaluate(h){return!this._actual.evaluate(h)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(h){return new _(this._actual.map(h))}negate(){return this._actual}}e.ContextKeyNotInExpr=_;class d{constructor(h,R){this.key=h,this.value=R,this.type=5}static create(h,R){if(typeof R=="boolean")return R?b.create(h):m.create(h);const F=S.get(h);return typeof F=="boolean"?R===(F?"true":"false")?k.INSTANCE:g.INSTANCE:new d(h,R)}cmp(h){return h.type!==this.type?this.type-h.type:D(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}evaluate(h){return h.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(h){return h.mapNotEquals(this.key,this.value)}negate(){return i.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=d;class b{constructor(h){this.key=h,this.type=3}static create(h){const R=S.get(h);return typeof R=="boolean"?R?k.INSTANCE:g.INSTANCE:new b(h)}cmp(h){return h.type!==this.type?this.type-h.type:w(this.key,h.key)}equals(h){return h.type===this.type?this.key===h.key:!1}evaluate(h){return!h.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(h){return h.mapNot(this.key)}negate(){return m.create(this.key)}}e.ContextKeyNotExpr=b;class v{constructor(h,R){this.key=h,this.value=R,this.type=12}static create(h,R){return new v(h,R)}cmp(h){return h.type!==this.type?this.type-h.type:D(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}evaluate(h){return parseFloat(h.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(h){return h.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=v;class l{constructor(h,R){this.key=h,this.value=R,this.type=13}static create(h,R){return new l(h,R)}cmp(h){return h.type!==this.type?this.type-h.type:D(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}evaluate(h){return parseFloat(h.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(h){return h.mapGreaterEquals(this.key,this.value)}negate(){return u.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=l;class u{constructor(h,R){this.key=h,this.value=R,this.type=14}static create(h,R){return new u(h,R)}cmp(h){return h.type!==this.type?this.type-h.type:D(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}evaluate(h){return parseFloat(h.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(h){return h.mapSmaller(this.key,this.value)}negate(){return l.create(this.key,this.value)}}e.ContextKeySmallerExpr=u;class t{constructor(h,R){this.key=h,this.value=R,this.type=15}static create(h,R){return new t(h,R)}cmp(h){return h.type!==this.type?this.type-h.type:D(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}evaluate(h){return parseFloat(h.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(h){return h.mapSmallerEquals(this.key,this.value)}negate(){return v.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class r{constructor(h,R){this.key=h,this.regexp=R,this.type=7}static create(h,R){return new r(h,R)}cmp(h){if(h.type!==this.type)return this.type-h.type;if(this.key<h.key)return-1;if(this.key>h.key)return 1;const R=this.regexp?this.regexp.source:"",F=h.regexp?h.regexp.source:"";return R<F?-1:R>F?1:0}equals(h){if(h.type===this.type){const R=this.regexp?this.regexp.source:"",F=h.regexp?h.regexp.source:"";return this.key===h.key&&R===F}return!1}evaluate(h){let R=h.getValue(this.key);return this.regexp?this.regexp.test(R):!1}serialize(){const h=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${h}`}keys(){return[this.key]}map(h){return h.mapRegex(this.key,this.regexp)}negate(){return c.create(this)}}e.ContextKeyRegexExpr=r;class c{constructor(h){this._actual=h,this.type=8}static create(h){return new c(h)}cmp(h){return h.type!==this.type?this.type-h.type:this._actual.cmp(h._actual)}equals(h){return h.type===this.type?this._actual.equals(h._actual):!1}evaluate(h){return!this._actual.evaluate(h)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(h){return new c(this._actual.map(h))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=c;class o{constructor(h){this.expr=h,this.type=6}static create(h){return o._normalizeArr(h)}cmp(h){if(h.type!==this.type)return this.type-h.type;if(this.expr.length<h.expr.length)return-1;if(this.expr.length>h.expr.length)return 1;for(let R=0,F=this.expr.length;R<F;R++){const $=T(this.expr[R],h.expr[R]);if($!==0)return $}return 0}equals(h){if(h.type===this.type){if(this.expr.length!==h.expr.length)return!1;for(let R=0,F=this.expr.length;R<F;R++)if(!this.expr[R].equals(h.expr[R]))return!1;return!0}return!1}evaluate(h){for(let R=0,F=this.expr.length;R<F;R++)if(!this.expr[R].evaluate(h))return!1;return!0}static _normalizeArr(h){const R=[];let F=!1;for(const $ of h)if(!!$){if($.type===1){F=!0;continue}if($.type===0)return k.INSTANCE;if($.type===6){R.push(...$.expr);continue}R.push($)}if(R.length===0&&F)return g.INSTANCE;if(R.length!==0){if(R.length===1)return R[0];for(R.sort(T);R.length>1;){const $=R[R.length-1];if($.type!==9)break;R.pop();const se=R.pop(),z=a.create($.expr.map(x=>o.create([x,se])));z&&(R.push(z),R.sort(T))}return R.length===1?R[0]:new o(R)}}serialize(){return this.expr.map(h=>h.serialize()).join(" && ")}keys(){const h=[];for(let R of this.expr)h.push(...R.keys());return h}map(h){return new o(this.expr.map(R=>R.map(h)))}negate(){let h=[];for(let R of this.expr)h.push(R.negate());return a.create(h)}}e.ContextKeyAndExpr=o;class a{constructor(h){this.expr=h,this.type=9}static create(h){const R=a._normalizeArr(h);if(R.length!==0)return R.length===1?R[0]:new a(R)}cmp(h){if(h.type!==this.type)return this.type-h.type;if(this.expr.length<h.expr.length)return-1;if(this.expr.length>h.expr.length)return 1;for(let R=0,F=this.expr.length;R<F;R++){const $=T(this.expr[R],h.expr[R]);if($!==0)return $}return 0}equals(h){if(h.type===this.type){if(this.expr.length!==h.expr.length)return!1;for(let R=0,F=this.expr.length;R<F;R++)if(!this.expr[R].equals(h.expr[R]))return!1;return!0}return!1}evaluate(h){for(let R=0,F=this.expr.length;R<F;R++)if(this.expr[R].evaluate(h))return!0;return!1}static _normalizeArr(h){let R=[],F=!1;if(h){for(let $=0,se=h.length;$<se;$++){const z=h[$];if(!!z){if(z.type===0){F=!0;continue}if(z.type===1)return[g.INSTANCE];if(z.type===9){R=R.concat(z.expr);continue}R.push(z)}}if(R.length===0&&F)return[k.INSTANCE];R.sort(T)}return R}serialize(){return this.expr.map(h=>h.serialize()).join(" || ")}keys(){const h=[];for(let R of this.expr)h.push(...R.keys());return h}map(h){return new a(this.expr.map(R=>R.map(h)))}negate(){let h=[];for(let F of this.expr)h.push(F.negate());const R=F=>F.type===9?F.expr:[F];for(;h.length>1;){const F=h.shift(),$=h.shift(),se=[];for(const z of R(F))for(const x of R($))se.push(n.and(z,x));h.unshift(n.or(...se))}return h[0]}}e.ContextKeyOrExpr=a;class f extends m{constructor(h,R,F){super(h);this._defaultValue=R,typeof F=="object"?f._info.push(Object.assign(Object.assign({},F),{key:h})):F!==!0&&f._info.push({key:h,description:F,type:R!=null?typeof R:void 0})}static all(){return f._info.values()}bindTo(h){return h.createKey(this.key,this._defaultValue)}getValue(h){return h.getContextKeyValue(this.key)}toNegated(){return n.not(this.key)}isEqualTo(h){return n.equals(this.key,h)}notEqualsTo(h){return n.notEquals(this.key,h)}}e.RawContextKey=f,f._info=[],e.IContextKeyService=(0,I.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function w(p,h){return p<h?-1:p>h?1:0}function D(p,h,R,F){return p<R?-1:p>R?1:h<F?-1:h>F?1:0}}),define(_e[148],we([0,1,4]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,E.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,E.refineServiceDecorator)(e.IEnvironmentService)}),define(_e[26],we([0,1,8,4]),function(ie,e,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function P(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=P,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));class S{constructor(T){this.value=T,this._lower=T.toLowerCase()}static equals(T,k){if(typeof T=="undefined"||T===null)return typeof k=="undefined"||k===null;if(typeof k=="undefined"||k===null)return!1;if(typeof T=="string"||typeof k=="string"){let g=typeof T=="string"?T:T.value,m=typeof k=="string"?k:k.value;return E.equalsIgnoreCase(g,m)}return T._lower===k._lower}static toKey(T){return typeof T=="string"?T.toLowerCase():T._lower}}e.ExtensionIdentifier=S;function C(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=C;function y(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=y,e.IBuiltinExtensionsScannerService=(0,I.createDecorator)("IBuiltinExtensionsScannerService")}),define(_e[149],we([0,1,8,26]),function(ie,e,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function P(m,i){return m.uuid&&i.uuid?m.uuid===i.uuid:m.id===i.id?!0:(0,E.compareIgnoreCase)(m.id,i.id)===0}e.areSameExtensions=P;class A{constructor(i,s){this.version=s,this.id=i.id,this.uuid=i.uuid}key(){return`${this.id}-${this.version}`}equals(i){return i instanceof A?P(this,i)&&this.version===i.version:!1}}e.ExtensionIdentifierWithVersion=A;function S(m,i){return`${m}.${i}`}e.getExtensionId=S;function C(m){return m.toLocaleLowerCase()}e.adoptToGalleryExtensionId=C;function y(m,i){return C(S(m,i))}e.getGalleryExtensionId=y;function n(m,i){const s=[],_=d=>{for(const b of s)if(b.some(v=>P(i(v),i(d))))return b;return null};for(const d of m){const b=_(d);b?b.push(d):s.push([d])}return s}e.groupByExtension=n;function T(m){return{id:m.identifier.id,name:m.manifest.name,galleryId:null,publisherId:m.publisherId,publisherName:m.manifest.publisher,publisherDisplayName:m.publisherDisplayName,dependencies:m.manifest.extensionDependencies&&m.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=T;function k(m){return Object.assign({id:m.identifier.id,name:m.name,galleryId:m.identifier.uuid,publisherId:m.publisherId,publisherName:m.publisher,publisherDisplayName:m.publisherDisplayName,dependencies:!!(m.properties.dependencies&&m.properties.dependencies.length>0)},m.telemetryData)}e.getGalleryExtensionTelemetryData=k,e.BetterMergeId=new I.ExtensionIdentifier("pprice.better-merge");function g(m){const i=new Set;for(const s of m)s.malicious&&i.add(s.id.id);return i}e.getMaliciousExtensionsSet=g}),define(_e[64],we([0,1,124,12,2,4,8,13,22]),function(ie,e,E,I,P,A,S,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,A.createDecorator)("fileService");function n(z){return z.create===!0}e.isFileOpenForWriteOptions=n;var T;(function(z){z[z.Unknown=0]="Unknown",z[z.File=1]="File",z[z.Directory=2]="Directory",z[z.SymbolicLink=64]="SymbolicLink"})(T=e.FileType||(e.FileType={}));var k;(function(z){z[z.FileReadWrite=2]="FileReadWrite",z[z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",z[z.FileReadStream=16]="FileReadStream",z[z.FileFolderCopy=8]="FileFolderCopy",z[z.PathCaseSensitive=1024]="PathCaseSensitive",z[z.Readonly=2048]="Readonly",z[z.Trash=4096]="Trash",z[z.FileWriteUnlock=8192]="FileWriteUnlock"})(k=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function g(z){return!!(z.capabilities&2)}e.hasReadWriteCapability=g;function m(z){return!!(z.capabilities&8)}e.hasFileFolderCopyCapability=m;function i(z){return!!(z.capabilities&4)}e.hasOpenReadWriteCloseCapability=i;function s(z){return!!(z.capabilities&16)}e.hasFileReadStreamCapability=s;var _;(function(z){z.FileExists="EntryExists",z.FileNotFound="EntryNotFound",z.FileNotADirectory="EntryNotADirectory",z.FileIsADirectory="EntryIsADirectory",z.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",z.FileTooLarge="EntryTooLarge",z.FileWriteLocked="EntryWriteLocked",z.NoPermissions="NoPermissions",z.Unavailable="Unavailable",z.Unknown="Unknown"})(_=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class d extends Error{constructor(x,G){super(x);this.code=G}}e.FileSystemProviderError=d;function b(z,x){const G=new d(z.toString(),x);return l(G,x),G}e.createFileSystemProviderError=b;function v(z){return z||b((0,E.localize)(0,null),_.Unknown)}e.ensureFileSystemProviderError=v;function l(z,x){return z.name=x?`${x} (FileSystemError)`:"FileSystemError",z}e.markAsFileSystemProviderError=l;function u(z){if(!z)return _.Unknown;if(z instanceof d)return z.code;const x=/^(.+) \(FileSystemError\)$/.exec(z.name);if(!x)return _.Unknown;switch(x[1]){case _.FileExists:return _.FileExists;case _.FileIsADirectory:return _.FileIsADirectory;case _.FileNotADirectory:return _.FileNotADirectory;case _.FileNotFound:return _.FileNotFound;case _.FileExceedsMemoryLimit:return _.FileExceedsMemoryLimit;case _.FileTooLarge:return _.FileTooLarge;case _.FileWriteLocked:return _.FileWriteLocked;case _.NoPermissions:return _.NoPermissions;case _.Unavailable:return _.Unavailable}return _.Unknown}e.toFileSystemProviderErrorCode=u;function t(z){if(z instanceof w)return z.fileOperationResult;switch(u(z)){case _.FileNotFound:return 1;case _.FileIsADirectory:return 0;case _.FileNotADirectory:return 10;case _.FileWriteLocked:return 5;case _.NoPermissions:return 6;case _.FileExists:return 4;case _.FileExceedsMemoryLimit:return 9;case _.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=t;var r;(function(z){z[z.CREATE=0]="CREATE",z[z.DELETE=1]="DELETE",z[z.MOVE=2]="MOVE",z[z.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class c{constructor(x,G,M){this.resource=x,this.operation=G,this.target=M}isOperation(x){return this.operation===x}}e.FileOperationEvent=c;var o;(function(z){z[z.UPDATED=0]="UPDATED",z[z.ADDED=1]="ADDED",z[z.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class a{constructor(x,G){this.ignorePathCasing=G,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=x;for(const M of x)switch(M.type){case 1:this.added||(this.added=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(M.resource,M);break;case 0:this.updated||(this.updated=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(M.resource,M);break;case 2:this.deleted||(this.deleted=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(M.resource,M);break}}contains(x,...G){return this.doContains(x,{includeChildren:!1},...G)}affects(x,...G){return this.doContains(x,{includeChildren:!0},...G)}doContains(x,G,...M){var N,B,Q,W,ee,re;if(!x)return!1;const oe=M.length>0;return!!((!oe||M.includes(1))&&(((N=this.added)===null||N===void 0?void 0:N.get(x))||G.includeChildren&&((B=this.added)===null||B===void 0?void 0:B.findSuperstr(x)))||(!oe||M.includes(0))&&(((Q=this.updated)===null||Q===void 0?void 0:Q.get(x))||G.includeChildren&&((W=this.updated)===null||W===void 0?void 0:W.findSuperstr(x)))||(!oe||M.includes(2))&&(((ee=this.deleted)===null||ee===void 0?void 0:ee.findSubstr(x))||G.includeChildren&&((re=this.deleted)===null||re===void 0?void 0:re.findSuperstr(x))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(x){const G=[],M=x===1?this.added:x===0?this.updated:this.deleted;if(M)for(const[,N]of M)G.push(N);return G}filter(x){return new a(this.changes.filter(G=>x(G)),this.ignorePathCasing)}}e.FileChangesEvent=a;function f(z,x,G){return!z||!x||z===x||x.length>z.length?!1:(x.charAt(x.length-1)!==I.sep&&(x+=I.sep),G?(0,S.startsWithIgnoreCase)(z,x):z.indexOf(x)===0)}e.isParent=f;class w extends Error{constructor(x,G,M){super(x);this.fileOperationResult=G,this.options=M}static isFileOperationError(x){return x instanceof Error&&!(0,C.isUndefinedOrNull)(x.fileOperationResult)}}e.FileOperationError=w;var D;(function(z){z[z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",z[z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",z[z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",z[z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",z[z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",z[z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",z[z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",z[z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",z[z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",z[z.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",z[z.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",z[z.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(D=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var p;(function(z){z[z.FILE=0]="FILE",z[z.FOLDER=1]="FOLDER",z[z.ROOT_FOLDER=2]="ROOT_FOLDER"})(p=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function h(z){if(!(typeof z.size!="number"||typeof z.mtime!="number"))return z.mtime.toString(29)+z.size.toString(31)}e.etag=h;async function R(z,x){if(!x.canHandleResource(P.URI.from({scheme:z.scheme})))return new Promise(G=>{const M=x.onDidChangeFileSystemProviderRegistrations(N=>{N.scheme===z.scheme&&N.added&&(M.dispose(),G())})})}e.whenProviderRegistered=R,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class F{static formatSize(x){return(0,C.isNumber)(x)||(x=0),x<F.KB?(0,E.localize)(1,null,x.toFixed(0)):x<F.MB?(0,E.localize)(2,null,(x/F.KB).toFixed(2)):x<F.GB?(0,E.localize)(3,null,(x/F.MB).toFixed(2)):x<F.TB?(0,E.localize)(4,null,(x/F.GB).toFixed(2)):(0,E.localize)(5,null,(x/F.TB).toFixed(2))}}e.ByteSize=F,F.KB=1024,F.MB=F.KB*F.KB,F.GB=F.MB*F.KB,F.TB=F.GB*F.KB;var $;(function(z){z[z.IA32=0]="IA32",z[z.OTHER=1]="OTHER"})($=e.Arch||(e.Arch={}));function se(z){return{maxFileSize:z===0?300*F.MB:16*F.GB,maxHeapSize:z===0?700*F.MB:2*700*F.MB}}e.getPlatformLimits=se}),define(_e[65],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class E{constructor(...P){this._entries=new Map;for(let[A,S]of P)this.set(A,S)}set(P,A){const S=this._entries.get(P);return this._entries.set(P,A),S}has(P){return this._entries.has(P)}get(P){return this._entries.get(P)}}e.ServiceCollection=E}),define(_e[150],we([0,1,10,144,86,4,65,14]),function(ie,e,E,I,P,A,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const y=!1;class n extends Error{constructor(i){super("cyclic dependency between services");this.message=i.toString()}}class T{constructor(i=new S.ServiceCollection,s=!1,_){this._activeInstantiations=new Set,this._services=i,this._strict=s,this._parent=_,this._services.set(A.IInstantiationService,this)}createChild(i){return new T(i,this._strict,this)}invokeFunction(i,...s){let _=g.traceInvocation(i),d=!1;try{return i({get:(v,l)=>{if(d)throw(0,E.illegalState)("service accessor is only valid during the invocation of its target method");const u=this._getOrCreateServiceInstance(v,_);if(!u&&l!==A.optional)throw new Error(`[invokeFunction] unknown service '${v}'`);return u}},...s)}finally{d=!0,_.stop()}}createInstance(i,...s){let _,d;return i instanceof P.SyncDescriptor?(_=g.traceCreation(i.ctor),d=this._createInstance(i.ctor,i.staticArguments.concat(s),_)):(_=g.traceCreation(i),d=this._createInstance(i,s,_)),_.stop(),d}_createInstance(i,s=[],_){let d=A._util.getServiceDependencies(i).sort((l,u)=>l.index-u.index),b=[];for(const l of d){let u=this._getOrCreateServiceInstance(l.id,_);if(!u&&this._strict&&!l.optional)throw new Error(`[createInstance] ${i.name} depends on UNKNOWN service ${l.id}.`);b.push(u)}let v=d.length>0?d[0].index:s.length;if(s.length!==v){console.warn(`[createInstance] First service dependency of ${i.name} at position ${v+1} conflicts with ${s.length} static arguments`);let l=v-s.length;l>0?s=s.concat(new Array(l)):s=s.slice(0,v)}return new i(...[...s,...b])}_setServiceInstance(i,s){if(this._services.get(i)instanceof P.SyncDescriptor)this._services.set(i,s);else if(this._parent)this._parent._setServiceInstance(i,s);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(i){let s=this._services.get(i);return!s&&this._parent?this._parent._getServiceInstanceOrDescriptor(i):s}_getOrCreateServiceInstance(i,s){let _=this._getServiceInstanceOrDescriptor(i);return _ instanceof P.SyncDescriptor?this._safeCreateAndCacheServiceInstance(i,_,s.branch(i,!0)):(s.branch(i,!1),_)}_safeCreateAndCacheServiceInstance(i,s,_){if(this._activeInstantiations.has(i))throw new Error(`illegal state - RECURSIVELY instantiating service '${i}'`);this._activeInstantiations.add(i);try{return this._createAndCacheServiceInstance(i,s,_)}finally{this._activeInstantiations.delete(i)}}_createAndCacheServiceInstance(i,s,_){const d=new I.Graph(l=>l.id.toString());let b=0;const v=[{id:i,desc:s,_trace:_}];for(;v.length;){const l=v.pop();if(d.lookupOrInsertNode(l),b++>1e3)throw new n(d);for(let u of A._util.getServiceDependencies(l.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(u.id);if(!t&&!u.optional&&console.warn(`[createInstance] ${i} depends on ${u.id} which is NOT registered.`),t instanceof P.SyncDescriptor){const r={id:u.id,desc:t,_trace:l._trace.branch(u.id,!0)};d.insertEdge(l,r),v.push(r)}}}for(;;){const l=d.roots();if(l.length===0){if(!d.isEmpty())throw new n(d);break}for(const{data:u}of l){if(this._getServiceInstanceOrDescriptor(u.id)instanceof P.SyncDescriptor){const r=this._createServiceInstanceWithOwner(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this._setServiceInstance(u.id,r)}d.removeNode(u)}}return this._getServiceInstanceOrDescriptor(i)}_createServiceInstanceWithOwner(i,s,_=[],d,b){if(this._services.get(i)instanceof P.SyncDescriptor)return this._createServiceInstance(s,_,d,b);if(this._parent)return this._parent._createServiceInstanceWithOwner(i,s,_,d,b);throw new Error(`illegalState - creating UNKNOWN service instance ${s.name}`)}_createServiceInstance(i,s=[],_,d){if(_){const b=new C.IdleValue(()=>this._createInstance(i,s,d));return new Proxy(Object.create(null),{get(v,l){if(l in v)return v[l];let u=b.value,t=u[l];return typeof t!="function"||(t=t.bind(u),v[l]=t),t},set(v,l,u){return b.value[l]=u,!0}})}else return this._createInstance(i,s,d)}}e.InstantiationService=T;var k;(function(m){m[m.Creation=0]="Creation",m[m.Invocation=1]="Invocation",m[m.Branch=2]="Branch"})(k||(k={}));class g{constructor(i,s){this.type=i,this.name=s,this._start=Date.now(),this._dep=[]}static traceInvocation(i){return y?new g(1,i.name||i.toString().substring(0,42).replace(/\n/g,"")):g._None}static traceCreation(i){return y?new g(0,i.name):g._None}branch(i,s){let _=new g(2,i.toString());return this._dep.push([i,s,_]),_}stop(){let i=Date.now()-this._start;g._totals+=i;let s=!1;function _(b,v){let l=[],u=new Array(b+1).join("	");for(const[t,r,c]of v._dep)if(r&&c){s=!0,l.push(`${u}CREATES -> ${t}`);let o=_(b+1,c);o&&l.push(o)}else l.push(`${u}uses -> ${t}`);return l.join(`
`)}let d=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${_(1,this)}`,`DONE, took ${i.toFixed(2)}ms (grand total ${g._totals.toFixed(2)}ms)`];(i>2||s)&&console.log(d.join(`
`))}}g._None=new class extends g{constructor(){super(-1,null)}stop(){}branch(){return this}},g._totals=0}),define(_e[19],we([0,1,4,6,21,3,60]),function(ie,e,E,I,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,E.createDecorator)("logService"),e.ILoggerService=(0,E.createDecorator)("loggerService");function C(){return new Date().toISOString()}var y;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;class n extends I.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new A.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=n;class T extends n{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...r){this.checkLogLevel(y.Trace)&&this.log(y.Trace,this.format([t,...r]))}debug(t,...r){this.checkLogLevel(y.Debug)&&this.log(y.Debug,this.format([t,...r]))}info(t,...r){this.checkLogLevel(y.Info)&&this.log(y.Info,this.format([t,...r]))}warn(t,...r){this.checkLogLevel(y.Warning)&&this.log(y.Warning,this.format([t,...r]))}error(t,...r){if(this.checkLogLevel(y.Error))if(t instanceof Error){const c=Array.prototype.slice.call(arguments);c[0]=t.stack,this.log(y.Error,this.format(c))}else this.log(y.Error,this.format([t,...r]))}critical(t,...r){this.checkLogLevel(y.Critical)&&this.log(y.Critical,this.format([t,...r]))}flush(){}format(t){let r="";for(let c=0;c<t.length;c++){let o=t[c];if(typeof o=="object")try{o=JSON.stringify(o)}catch(a){}r+=(c>0?" ":"")+o}return r}}e.AbstractMessageLogger=T;class k extends n{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!P.isWindows}trace(t,...r){this.getLevel()<=y.Trace&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...r):console.log(`[main ${C()}]`,t,...r))}debug(t,...r){this.getLevel()<=y.Debug&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...r):console.log(`[main ${C()}]`,t,...r))}info(t,...r){this.getLevel()<=y.Info&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...r):console.log(`[main ${C()}]`,t,...r))}warn(t,...r){this.getLevel()<=y.Warning&&(this.useColors?console.warn(`[93m[main ${C()}][0m`,t,...r):console.warn(`[main ${C()}]`,t,...r))}error(t,...r){this.getLevel()<=y.Error&&(this.useColors?console.error(`[91m[main ${C()}][0m`,t,...r):console.error(`[main ${C()}]`,t,...r))}critical(t,...r){this.getLevel()<=y.Critical&&(this.useColors?console.error(`[90m[main ${C()}][0m`,t,...r):console.error(`[main ${C()}]`,t,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=k;class g extends n{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...r){this.getLevel()<=y.Trace&&console.log("%cTRACE","color: #888",t,...r)}debug(t,...r){this.getLevel()<=y.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...r)}info(t,...r){this.getLevel()<=y.Info&&console.log("%c INFO","color: #33f",t,...r)}warn(t,...r){this.getLevel()<=y.Warning&&console.log("%c WARN","color: #993",t,...r)}error(t,...r){this.getLevel()<=y.Error&&console.log("%c  ERR","color: #f33",t,...r)}critical(t,...r){this.getLevel()<=y.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...r)}dispose(){}flush(){}}e.ConsoleLogger=g;class m extends n{constructor(t,r=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(r)}trace(t,...r){this.getLevel()<=y.Trace&&this.adapter.log(y.Trace,[this.extractMessage(t),...r])}debug(t,...r){this.getLevel()<=y.Debug&&this.adapter.log(y.Debug,[this.extractMessage(t),...r])}info(t,...r){this.getLevel()<=y.Info&&this.adapter.log(y.Info,[this.extractMessage(t),...r])}warn(t,...r){this.getLevel()<=y.Warning&&this.adapter.log(y.Warning,[this.extractMessage(t),...r])}error(t,...r){this.getLevel()<=y.Error&&this.adapter.log(y.Error,[this.extractMessage(t),...r])}critical(t,...r){this.getLevel()<=y.Critical&&this.adapter.log(y.Critical,[this.extractMessage(t),...r])}extractMessage(t){return typeof t=="string"?t:(0,S.toErrorMessage)(t,this.getLevel()<=y.Trace)}dispose(){}flush(){}}e.AdapterLogger=m;class i extends n{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const r of this.logServices)r.setLevel(t);super.setLevel(t)}trace(t,...r){for(const c of this.logServices)c.trace(t,...r)}debug(t,...r){for(const c of this.logServices)c.debug(t,...r)}info(t,...r){for(const c of this.logServices)c.info(t,...r)}warn(t,...r){for(const c of this.logServices)c.warn(t,...r)}error(t,...r){for(const c of this.logServices)c.error(t,...r)}critical(t,...r){for(const c of this.logServices)c.critical(t,...r)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=i;class s extends I.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...r){this.logger.trace(t,...r)}debug(t,...r){this.logger.debug(t,...r)}info(t,...r){this.logger.info(t,...r)}warn(t,...r){this.logger.warn(t,...r)}error(t,...r){this.logger.error(t,...r)}critical(t,...r){this.logger.critical(t,...r)}flush(){this.logger.flush()}}e.LogService=s;class _ extends I.Disposable{constructor(t,r){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(c=>{this.logLevel=c,this.logLevelChangeableLoggers.forEach(o=>o.setLevel(c))}))}createLogger(t,r){let c=this.loggers.get(t.toString());return c||(c=this.doCreateLogger(t,(r==null?void 0:r.always)?y.Trace:this.logLevel,r),this.loggers.set(t.toString(),c),(r==null?void 0:r.always)||this.logLevelChangeableLoggers.push(c)),c}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=_;class d{constructor(){this.onDidChangeLogLevel=new A.Emitter().event}setLevel(t){}getLevel(){return y.Info}trace(t,...r){}debug(t,...r){}info(t,...r){}warn(t,...r){}error(t,...r){}critical(t,...r){}dispose(){}flush(){}}e.NullLogService=d;function b(u){if(u.verbose)return y.Trace;if(typeof u.logLevel=="string"){const t=v(u.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=b;function v(u){switch(u){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Critical;case"off":return y.Off}}e.parseLogLevel=v;function l(u){switch(u){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Critical:return"critical";case y.Off:return"off"}}e.LogLevelToString=l}),define(_e[87],we([0,1,4,125,46]),function(ie,e,E,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(A=e.MarkerTag||(e.MarkerTag={}));var S;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(S=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function n(i,s){return s-i}y.compare=n;const T=Object.create(null);T[y.Error]=(0,I.localize)(0,null),T[y.Warning]=(0,I.localize)(1,null),T[y.Info]=(0,I.localize)(2,null);function k(i){return T[i]||""}y.toString=k;function g(i){switch(i){case P.default.Error:return y.Error;case P.default.Warning:return y.Warning;case P.default.Info:return y.Info;case P.default.Ignore:return y.Hint}}y.fromSeverity=g;function m(i){switch(i){case y.Error:return P.default.Error;case y.Warning:return P.default.Warning;case y.Info:return P.default.Info;case y.Hint:return P.default.Ignore}}y.toSeverity=m}(S=e.MarkerSeverity||(e.MarkerSeverity={}));var C;(function(y){const n="";function T(g){return k(g,!0)}y.makeKey=T;function k(g,m){let i=[n];return g.source?i.push(g.source.replace("\xA6","\\\xA6")):i.push(n),g.code?typeof g.code=="string"?i.push(g.code.replace("\xA6","\\\xA6")):i.push(g.code.value.replace("\xA6","\\\xA6")):i.push(n),g.severity!==void 0&&g.severity!==null?i.push(S.toString(g.severity)):i.push(n),g.message&&m?i.push(g.message.replace("\xA6","\\\xA6")):i.push(n),g.startLineNumber!==void 0&&g.startLineNumber!==null?i.push(g.startLineNumber.toString()):i.push(n),g.startColumn!==void 0&&g.startColumn!==null?i.push(g.startColumn.toString()):i.push(n),g.endLineNumber!==void 0&&g.endLineNumber!==null?i.push(g.endLineNumber.toString()):i.push(n),g.endColumn!==void 0&&g.endColumn!==null?i.push(g.endColumn.toString()):i.push(n),i.push(n),i.join("\xA6")}y.makeKeyOptionalMessage=k})(C=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,E.createDecorator)("markerService")}),define(_e[151],we([0,1,46,4,3]),function(ie,e,E,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=E.default,e.INotificationService=(0,I.createDecorator)("notificationService");var A;(function(n){n[n.WORKSPACE=0]="WORKSPACE",n[n.GLOBAL=1]="GLOBAL"})(A=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var S;(function(n){n[n.OFF=0]="OFF",n[n.SILENT=1]="SILENT",n[n.ERROR=2]="ERROR"})(S=e.NotificationsFilter||(e.NotificationsFilter={}));class C{constructor(){this.progress=new y,this.onDidClose=P.Event.None,this.onDidChangeVisibility=P.Event.None}updateSeverity(T){}updateMessage(T){}updateActions(T){}close(){}}e.NoOpNotification=C;class y{infinite(){}done(){}total(T){}worked(T){}}e.NoOpProgress=y});var je=this&&this.__decorate||function(ie,e,E,I){var P=arguments.length,A=P<3?e:I===null?I=Object.getOwnPropertyDescriptor(e,E):I,S;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(ie,e,E,I);else for(var C=ie.length-1;C>=0;C--)(S=ie[C])&&(A=(P<3?S(A):P>3?S(e,E,A):S(e,E))||A);return P>3&&A&&Object.defineProperty(e,E,A),A},Ke=this&&this.__param||function(ie,e){return function(E,I){e(E,I,ie)}};define(_e[152],we([0,1,4,20,6,14]),function(ie,e,E,I,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,E.createDecorator)("progressService");var S;(function(T){T[T.Explorer=1]="Explorer",T[T.Scm=3]="Scm",T[T.Extensions=5]="Extensions",T[T.Window=10]="Window",T[T.Notification=15]="Notification",T[T.Dialog=20]="Dialog"})(S=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class C{constructor(k){this.callback=k}get value(){return this._value}report(k){this._value=k,this.callback(this._value)}}e.Progress=C,C.None=Object.freeze({report(){}});let y=class extends P.Disposable{constructor(k,g){super();this.deferred=new A.DeferredPromise,g.withProgress(k,m=>(this.reporter=m,this.lastStep&&m.report(this.lastStep),this.deferred.p)),this._register((0,P.toDisposable)(()=>this.deferred.complete()))}report(k){this.reporter?this.reporter.report(k):this.lastStep=k}};y=je([Ke(1,e.IProgressService)],y),e.UnmanagedProgress=y;class n extends P.Disposable{constructor(k){super();this.progressIndicator=k,this.currentOperationId=0,this.currentOperationDisposables=this._register(new P.DisposableStore)}start(k){this.stop();const g=++this.currentOperationId,m=new I.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{g===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},k),this.currentOperationDisposables.add((0,P.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,P.toDisposable)(()=>m.cancel())),this.currentOperationDisposables.add((0,P.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:g,token:m.token,stop:()=>this.doStop(g),isCurrent:()=>this.currentOperationId===g}}stop(){this.doStop(this.currentOperationId)}doStop(k){this.currentOperationId===k&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=n,e.IEditorProgressService=(0,E.createDecorator)("editorProgressService")}),define(_e[30],we([0,1,13,42]),function(ie,e,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class P{constructor(){this.data=new Map}add(S,C){I.ok(E.isString(S)),I.ok(E.isObject(C)),I.ok(!this.data.has(S),"There is already an extension with this id"),this.data.set(S,C)}knows(S){return this.data.has(S)}as(S){return this.data.get(S)||null}}e.Registry=new P}),define(_e[88],we([0,1,30,3]),function(ie,e,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function P(C){return C.length>0&&C.charAt(C.length-1)==="#"?C.substring(0,C.length-1):C}class A{constructor(){this._onDidChangeSchema=new I.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,n){this.schemasById[P(y)]=n,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const S=new A;E.Registry.add(e.Extensions.JSONContribution,S)}),define(_e[66],we([0,1,122,3,30,13,88]),function(ie,e,E,I,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var C;(function(_){_[_.APPLICATION=1]="APPLICATION",_[_.MACHINE=2]="MACHINE",_[_.WINDOW=3]="WINDOW",_[_.RESOURCE=4]="RESOURCE",_[_.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",_[_.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const y=P.Registry.as(S.Extensions.JSONContribution);class n{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new I.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new I.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:E.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(d,b=!0){this.registerConfigurations([d],b)}registerConfigurations(d,b=!0){const v=[];d.forEach(l=>{v.push(...this.validateAndRegisterProperties(l,b,l.extensionInfo)),this.configurationContributors.push(l),this.registerJSONConfiguration(l)}),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(v)}deregisterConfigurations(d){const b=[],v=l=>{if(l.properties)for(const u in l.properties)b.push(u),delete this.configurationProperties[u],this.removeFromSchema(u,l.properties[u]);l.allOf&&l.allOf.forEach(u=>v(u))};for(const l of d){v(l);const u=this.configurationContributors.indexOf(l);u!==-1&&this.configurationContributors.splice(u,1)}y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(b)}registerDefaultConfigurations(d){const b=[],v=[];for(const l of d)for(const u in l)if(b.push(u),e.OVERRIDE_PROPERTY_PATTERN.test(u)){this.defaultValues[u]=Object.assign(Object.assign({},this.defaultValues[u]||{}),l[u]);const t={type:"object",default:this.defaultValues[u],description:E.localize(1,null,u),$ref:e.resourceLanguageSettingsSchemaId};v.push(k(u)),this.configurationProperties[u]=t,this.defaultLanguageConfigurationOverridesNode.properties[u]=t}else{this.defaultValues[u]=l[u];const t=this.configurationProperties[u];t&&(this.updatePropertyDefaultValue(u,t),this.updateSchema(u,t))}this.registerOverrideIdentifiers(v),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(b)}deregisterDefaultConfigurations(d){const b=[];for(const v of d)for(const l in v)if(b.push(l),delete this.defaultValues[l],e.OVERRIDE_PROPERTY_PATTERN.test(l))delete this.configurationProperties[l],delete this.defaultLanguageConfigurationOverridesNode.properties[l];else{const u=this.configurationProperties[l];u&&(this.updatePropertyDefaultValue(l,u),this.updateSchema(l,u))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(b)}notifyConfigurationSchemaUpdated(...d){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(d){for(const b of d)this.overrideIdentifiers.add(b);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(d,b=!0,v,l=3){var u;l=A.isUndefinedOrNull(d.scope)?l:d.scope;let t=[],r=d.properties;if(r)for(let o in r){if(b&&i(o)){delete r[o];continue}const a=r[o];if(this.updatePropertyDefaultValue(o,a),e.OVERRIDE_PROPERTY_PATTERN.test(o)?a.scope=void 0:(a.scope=A.isUndefinedOrNull(a.scope)?l:a.scope,a.requireTrust=A.isUndefinedOrNull(a.requireTrust)?!!((u=v==null?void 0:v.requireTrustForConfigurations)===null||u===void 0?void 0:u.includes(o)):a.requireTrust),r[o].hasOwnProperty("included")&&!r[o].included){this.excludedConfigurationProperties[o]=r[o],delete r[o];continue}else this.configurationProperties[o]=r[o];!r[o].deprecationMessage&&r[o].markdownDeprecationMessage&&(r[o].deprecationMessage=r[o].markdownDeprecationMessage),t.push(o)}let c=d.allOf;if(c)for(let o of c)t.push(...this.validateAndRegisterProperties(o,b,v,l));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(d){const b=v=>{let l=v.properties;if(l)for(const t in l)this.updateSchema(t,l[t]);let u=v.allOf;u&&u.forEach(b)};b(d)}updateSchema(d,b){switch(e.allSettings.properties[d]=b,b.scope){case 1:e.applicationSettings.properties[d]=b;break;case 2:e.machineSettings.properties[d]=b;break;case 6:e.machineOverridableSettings.properties[d]=b;break;case 3:e.windowSettings.properties[d]=b;break;case 4:e.resourceSettings.properties[d]=b;break;case 5:e.resourceSettings.properties[d]=b,this.resourceLanguageSettingsSchema.properties[d]=b;break}}removeFromSchema(d,b){switch(delete e.allSettings.properties[d],b.scope){case 1:delete e.applicationSettings.properties[d];break;case 2:delete e.machineSettings.properties[d];break;case 6:delete e.machineOverridableSettings.properties[d];break;case 3:delete e.windowSettings.properties[d];break;case 4:case 5:delete e.resourceSettings.properties[d];break}}updateOverridePropertyPatternKey(){for(const d of this.overrideIdentifiers.values()){const b=`[${d}]`,v={type:"object",description:E.localize(2,null),errorMessage:E.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(b,v),e.allSettings.properties[b]=v,e.applicationSettings.properties[b]=v,e.machineSettings.properties[b]=v,e.machineOverridableSettings.properties[b]=v,e.windowSettings.properties[b]=v,e.resourceSettings.properties[b]=v}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(d,b){let v=this.defaultValues[d];A.isUndefined(v)&&(v=b.default),A.isUndefined(v)&&(v=g(b.type)),b.default=v}}const T="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(T);function k(_){return _.substring(1,_.length-1)}e.overrideIdentifierFromKey=k;function g(_){switch(Array.isArray(_)?_[0]:_){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=g;const m=new n;P.Registry.add(e.Extensions.Configuration,m);function i(_){return _.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(_)?E.localize(5,null,_):m.getConfigurationProperties()[_]!==void 0?E.localize(6,null,_):null:E.localize(4,null)}e.validateProperty=i;function s(){const _=[],d=m.getConfigurationProperties();for(const b of Object.keys(d))_.push([b,d[b].scope]);return _.push(["launch",4]),_.push(["task",4]),_}e.getScopes=s}),define(_e[89],we([0,1,24,13,2,30,4,66]),function(ie,e,E,I,P,A,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,S.createDecorator)("configurationService");function y(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof P.URI)}e.isConfigurationOverrides=y;var n;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(n=e.ConfigurationTarget||(e.ConfigurationTarget={}));function T(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=T;function k(r,c){const o=c?r?c.keys.filter(R=>r.keys.indexOf(R)===-1):[...c.keys]:[],a=r?c?r.keys.filter(R=>c.keys.indexOf(R)===-1):[...r.keys]:[],f=[];if(c&&r){for(const R of r.keys)if(c.keys.indexOf(R)!==-1){const F=d(r.contents,R),$=d(c.contents,R);E.equals(F,$)||f.push(R)}}const w=[],D=R=>{const F={};for(const $ of R)for(const se of $.identifiers)F[u(se)]=$;return F},p=c?D(c.overrides):{},h=r?D(r.overrides):{};if(Object.keys(p).length)for(const R of o){const F=p[R];F&&w.push([(0,C.overrideIdentifierFromKey)(R),F.keys])}if(Object.keys(h).length)for(const R of a){const F=h[R];F&&w.push([(0,C.overrideIdentifierFromKey)(R),F.keys])}if(Object.keys(p).length&&Object.keys(h).length)for(const R of f){const F=h[R],$=p[R];if(F&&$){const se=k({contents:F.contents,keys:F.keys,overrides:[]},{contents:$.contents,keys:$.keys,overrides:[]});w.push([(0,C.overrideIdentifierFromKey)(R),[...se.added,...se.removed,...se.updated]])}}return{added:o,removed:a,updated:f,overrides:w}}e.compare=k;function g(r,c){const o=[];for(const a of Object.keys(r))if(C.OVERRIDE_PROPERTY_PATTERN.test(a)){const f={};for(const w in r[a])f[w]=r[a][w];o.push({identifiers:[(0,C.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(f),contents:m(f,c)})}return o}e.toOverrides=g;function m(r,c){const o=Object.create(null);for(let a in r)i(o,a,r[a],c);return o}e.toValuesTree=m;function i(r,c,o,a){const f=c.split("."),w=f.pop();let D=r;for(let p=0;p<f.length;p++){let h=f[p],R=D[h];switch(typeof R){case"undefined":R=D[h]=Object.create(null);break;case"object":break;default:a(`Ignoring ${c} as ${f.slice(0,p+1).join(".")} is ${JSON.stringify(R)}`);return}D=R}if(typeof D=="object"&&D!==null)try{D[w]=o}catch(p){a(`Ignoring ${c} as ${f.join(".")} is ${JSON.stringify(D)}`)}else a(`Ignoring ${c} as ${f.join(".")} is ${JSON.stringify(D)}`)}e.addToValueTree=i;function s(r,c){const o=c.split(".");_(r,o)}e.removeFromValueTree=s;function _(r,c){const o=c.shift();if(c.length===0){delete r[o];return}if(Object.keys(r).indexOf(o)!==-1){const a=r[o];typeof a=="object"&&!Array.isArray(a)&&(_(a,c),Object.keys(a).length===0&&delete r[o])}}function d(r,c,o){function a(D,p){let h=D;for(const R of p){if(typeof h!="object"||h===null)return;h=h[R]}return h}const f=c.split("."),w=a(r,f);return typeof w=="undefined"?o:w}e.getConfigurationValue=d;function b(r,c,o){Object.keys(c).forEach(a=>{a!=="__proto__"&&(a in r?I.isObject(r[a])&&I.isObject(c[a])?b(r[a],c[a],o):o&&(r[a]=c[a]):r[a]=c[a])})}e.merge=b;function v(){const r=A.Registry.as(C.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=v;function l(){const r=Object.create(null),c=A.Registry.as(C.Extensions.Configuration).getConfigurationProperties();for(let o in c){let a=c[o].default;i(r,o,a,f=>console.error(`Conflict in default settings: ${f}`))}return r}e.getDefaultValues=l;function u(r){return`[${r}]`}e.keyFromOverrideIdentifier=u;function t(r,c,o){const a=r.inspect(c),f=r.inspect(o);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:a.defaultValue}e.getMigratedSettingValue=t}),define(_e[153],we([0,1,43,22,11,13,24,2,66,89,30,6,3]),function(ie,e,E,I,P,A,S,C,y,n,T,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class m{constructor(t={},r=[],c=[]){this._contents=t,this._keys=r,this._overrides=c,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,n.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,r){const c=this.getContentsForOverrideIdentifer(r);return c?t?(0,n.getConfigurationValue)(c,t):c:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let c={};for(const o of P.distinct([...Object.keys(this.contents),...Object.keys(r)])){let a=this.contents[o],f=r[o];f&&(typeof a=="object"&&typeof f=="object"?(a=S.deepClone(a),this.mergeContents(a,f)):a=f),c[o]=a}return new m(c,this.keys,this.overrides)}merge(...t){const r=S.deepClone(this.contents),c=S.deepClone(this.overrides),o=[...this.keys];for(const a of t){this.mergeContents(r,a.contents);for(const f of a.overrides){const[w]=c.filter(D=>P.equals(D.identifiers,f.identifiers));w?this.mergeContents(w.contents,f.contents):c.push(S.deepClone(f))}for(const f of a.keys)o.indexOf(f)===-1&&o.push(f)}return new m(r,o,c)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const c of Object.keys(r)){if(c in t&&A.isObject(t[c])&&A.isObject(r[c])){this.mergeContents(t[c],r[c]);continue}t[c]=S.deepClone(r[c])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?S.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),(0,n.addToValueTree)(this.contents,t,r,c=>{throw new Error(c)})}removeValue(t){this.removeKey(t)&&(0,n.removeFromValueTree)(this.contents,t)}addKey(t){let r=this.keys.length;for(let c=0;c<r;c++)t.indexOf(this.keys[c])===0&&(r=c);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=m;class i extends m{constructor(){const t=(0,n.getDefaultValues)(),r=(0,n.getConfigurationKeys)(),c=[];for(const o of Object.keys(t))y.OVERRIDE_PROPERTY_PATTERN.test(o)&&c.push({identifiers:[(0,y.overrideIdentifierFromKey)(o).trim()],keys:Object.keys(t[o]),contents:(0,n.toValuesTree)(t[o],a=>console.error(`Conflict in default settings file: ${a}`))});super(t,r,c)}}e.DefaultConfigurationModel=i;class s{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._untrustedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new m}get untrustedConfigurations(){return this._untrustedConfigurations}get errors(){return this._parseErrors}parse(t,r){if(!A.isUndefinedOrNull(t)){const c=this.doParseContent(t);this.parseRaw(c,r)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,r){this._raw=t;const{contents:c,keys:o,overrides:a,untrusted:f}=this.doParseRaw(t,r);this._configurationModel=new m(c,o,a),this._untrustedConfigurations=f||[]}doParseContent(t){let r={},c=null,o=[],a=[],f=[];function w(p){Array.isArray(o)?o.push(p):c&&(o[c]=p)}let D={onObjectBegin:()=>{let p={};w(p),a.push(o),o=p,c=null},onObjectProperty:p=>{c=p},onObjectEnd:()=>{o=a.pop()},onArrayBegin:()=>{let p=[];w(p),a.push(o),o=p,c=null},onArrayEnd:()=>{o=a.pop()},onLiteralValue:w,onError:(p,h,R)=>{f.push({error:p,offset:h,length:R})}};if(t)try{E.visit(t,D),r=o[0]||{}}catch(p){console.error(`Error while parsing settings file ${this._name}: ${p}`),this._parseErrors=[p]}return r}doParseRaw(t,r){const c=T.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),o=this.filter(t,c,!0,r);t=o.raw;const a=(0,n.toValuesTree)(t,D=>console.error(`Conflict in settings file ${this._name}: ${D}`)),f=Object.keys(t),w=(0,n.toOverrides)(t,D=>console.error(`Conflict in settings file ${this._name}: ${D}`));return{contents:a,keys:f,overrides:w,untrusted:o.untrusted}}filter(t,r,c,o){if(!(o==null?void 0:o.scopes)&&!(o==null?void 0:o.isUntrusted))return{raw:t,untrusted:[]};const a={},f=[];for(let w in t)if(y.OVERRIDE_PROPERTY_PATTERN.test(w)&&c){const D=this.filter(t[w],r,!1,o);a[w]=D.raw,f.push(...D.untrusted)}else{const D=r[w],p=D?typeof D.scope!="undefined"?D.scope:3:void 0;(p===void 0||o.scopes===void 0||o.scopes.includes(p))&&(o.isUntrusted&&(D==null?void 0:D.requireTrust)?f.push(w):a[w]=t[w])}return{raw:a,untrusted:f}}}e.ConfigurationModelParser=s;class _ extends k.Disposable{constructor(t,r,c,o){super();this.userSettingsResource=t,this.scopes=r,this.fileService=o,this._onDidChange=this._register(new g.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new s(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(c.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(g.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new m}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getUntrustedSettings(){return this.parser.untrustedConfigurations}}e.UserSettings=_;class d{constructor(t,r,c=new m,o=new m,a=new I.ResourceMap,f=new m,w=new I.ResourceMap,D=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=c,this._workspaceConfiguration=o,this._folderConfigurations=a,this._memoryConfiguration=f,this._memoryConfigurationByResource=w,this._freeze=D,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new I.ResourceMap,this._userConfiguration=null}getValue(t,r,c){return this.getConsolidateConfigurationModel(r,c).getValue(t)}updateValue(t,r,c={}){let o;c.resource?(o=this._memoryConfigurationByResource.get(c.resource),o||(o=new m,this._memoryConfigurationByResource.set(c.resource,o))):o=this._memoryConfiguration,r===void 0?o.removeValue(t):o.setValue(t,r),c.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,c){const o=this.getConsolidateConfigurationModel(r,c),a=this.getFolderConfigurationModelForResource(r.resource,c),f=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,w=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),D=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),p=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),h=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),R=c?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,F=a?r.overrideIdentifier?a.freeze().override(r.overrideIdentifier).getValue(t):a.freeze().getValue(t):void 0,$=r.overrideIdentifier?f.override(r.overrideIdentifier).getValue(t):f.getValue(t),se=o.getValue(t),z=P.distinct(P.flatten(o.overrides.map(x=>x.identifiers))).filter(x=>o.getOverrideValue(t,x)!==void 0);return{defaultValue:w,userValue:D,userLocalValue:p,userRemoteValue:h,workspaceValue:R,workspaceFolderValue:F,memoryValue:$,value:se,default:w!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:D!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:p!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:h!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:R!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:F!==void 0?{value:a==null?void 0:a.freeze().getValue(t),override:r.overrideIdentifier?a==null?void 0:a.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:$!==void 0?{value:f.getValue(t),override:r.overrideIdentifier?f.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:z.length?z:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const c=r.filter(o=>y.OVERRIDE_PROPERTY_PATTERN.test(o)).map(o=>{const a=(0,y.overrideIdentifierFromKey)(o),f=this._defaultConfiguration.getKeysForOverrideIdentifier(a),w=t.getKeysForOverrideIdentifier(a),D=[...w.filter(p=>f.indexOf(p)===-1),...f.filter(p=>w.indexOf(p)===-1),...f.filter(p=>!S.equals(this._defaultConfiguration.override(a).getValue(p),t.override(a).getValue(p)))];return[a,D]});return this.updateDefaultConfiguration(t),{keys:r,overrides:c}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:c,removed:o,overrides:a}=(0,n.compare)(this.localUserConfiguration,t),f=[...r,...c,...o];return f.length&&this.updateLocalUserConfiguration(t),{keys:f,overrides:a}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:c,removed:o,overrides:a}=(0,n.compare)(this.remoteUserConfiguration,t);let f=[...r,...c,...o];return f.length&&this.updateRemoteUserConfiguration(t),{keys:f,overrides:a}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:c,removed:o,overrides:a}=(0,n.compare)(this.workspaceConfiguration,t);let f=[...r,...c,...o];return f.length&&this.updateWorkspaceConfiguration(t),{keys:f,overrides:a}}compareAndUpdateFolderConfiguration(t,r){const c=this.folderConfigurations.get(t),{added:o,updated:a,removed:f,overrides:w}=(0,n.compare)(c,r);let D=[...o,...a,...f];return(D.length||!c)&&this.updateFolderConfiguration(t,r),{keys:D,overrides:w}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:c,updated:o,removed:a,overrides:f}=(0,n.compare)(r,void 0);return{keys:[...c,...o,...a],overrides:f}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let c=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?c.override(t.overrideIdentifier):c}getConsolidatedConfigurationModelForResource({resource:t},r){let c=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const o=r.getFolder(t);o&&(c=this.getFolderConsolidatedConfiguration(o.uri)||c);const a=this._memoryConfigurationByResource.get(t);a&&(c=c.merge(a))}return c}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const c=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(t);o?(r=c.merge(o),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=c}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const c=r.getFolder(t);if(c)return this._folderConfigurations.get(c.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:c,overrides:o,keys:a}=this._folderConfigurations.get(r);return t.push([r,{contents:c,overrides:o,keys:a}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(c=>t.add(c))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(c=>r.add(c)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(c=>r.add(c)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(c=>r.add(c)),this._folderConfigurations.forEach(c=>c.getKeysForOverrideIdentifier(t).forEach(o=>r.add(o))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),c=this.parseConfigurationModel(t.user),o=this.parseConfigurationModel(t.workspace),a=t.folders.reduce((f,w)=>(f.set(C.URI.revive(w[0]),this.parseConfigurationModel(w[1])),f),new I.ResourceMap);return new d(r,c,new m,o,a,new m,new I.ResourceMap,!1)}static parseConfigurationModel(t){return new m(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=d;function b(...u){if(u.length===0)return{keys:[],overrides:[]};if(u.length===1)return u[0];const t=new Set,r=new Map;for(const o of u)o.keys.forEach(a=>t.add(a)),o.overrides.forEach(([a,f])=>{const w=(0,I.getOrSet)(r,a,new Set);f.forEach(D=>w.add(D))});const c=[];return r.forEach((o,a)=>c.push([a,[...o.values()]])),{keys:[...t.values()],overrides:c}}e.mergeChanges=b;class v{constructor(t,r,c,o){this.change=t,this.previous=r,this.currentConfiguraiton=c,this.currentWorkspace=o,this._previousConfiguration=void 0;const a=new Set;t.keys.forEach(w=>a.add(w)),t.overrides.forEach(([,w])=>w.forEach(D=>a.add(D))),this.affectedKeys=[...a.values()];const f=new m;this.affectedKeys.forEach(w=>f.setValue(w,{})),this.affectedKeysTree=f.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=d.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){var c;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const o=this.previousConfiguration?this.previousConfiguration.getValue(t,r,(c=this.previous)===null||c===void 0?void 0:c.workspace):void 0,a=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!S.equals(o,a)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let c=(0,n.toValuesTree)({[r]:!0},()=>{}),o;for(;typeof c=="object"&&(o=Object.keys(c)[0]);){if(t=t[o],!t)return!1;c=c[o]}return!0}}e.ConfigurationChangeEvent=v;class l extends v{constructor(t,r,c,o){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=c,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=l}),define(_e[90],we([0,1,4]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,E.createDecorator)("remoteAuthorityResolverService");var I;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(I=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class P extends Error{constructor(S,C=I.Unknown,y){super(S);this._message=S,this._code=C,this._detail=y,this.isHandled=C===I.NotAvailable&&y===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,P.prototype)}static isTemporarilyNotAvailable(S){return S instanceof P&&S._code===I.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof P&&S._code===I.NoResolverFound}static isHandled(S){return S instanceof P&&S.isHandled}}e.RemoteAuthorityResolverError=P}),define(_e[91],we([0,1,18]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.getRemoteName=e.getRemoteAuthority=void 0;function I(y){return y.scheme===E.Schemas.vscodeRemote?y.authority:void 0}e.getRemoteAuthority=I;function P(y){if(!!y){const n=y.indexOf("+");return n<0?y:y.substr(0,n)}}e.getRemoteName=P;function A(y){return y.scheme!==E.Schemas.file&&y.scheme!==E.Schemas.vscodeRemote}function S(y){const n=y.configuration;if(n&&A(n))return n;if(y.folders.length){const T=y.folders[0].uri;if(A(T))return T}}e.getVirtualWorkspaceLocation=S;function C(y){var n;return(n=S(y))===null||n===void 0?void 0:n.scheme}e.getVirtualWorkspaceScheme=C}),define(_e[154],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class E{constructor(P){this._callback=P,this._terminalBufferMap=new Map}dispose(){for(const P of this._terminalBufferMap.values())P.dispose()}startBuffering(P,A,S=5){let C;return C=A(y=>{const n=typeof y=="string"?y:y.data;let T=this._terminalBufferMap.get(P);if(T){T.data.push(n);return}const k=setTimeout(()=>this.flushBuffer(P),S);T={data:[n],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(P),C.dispose()}},this._terminalBufferMap.set(P,T)}),C}stopBuffering(P){const A=this._terminalBufferMap.get(P);A&&A.dispose()}flushBuffer(P){const A=this._terminalBufferMap.get(P);A&&(this._terminalBufferMap.delete(P),this._callback(P,A.data.join("")))}}e.TerminalDataBufferer=E}),define(_e[155],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var E;(function(I){I.DARK="dark",I.LIGHT="light",I.HIGH_CONTRAST="hc"})(E=e.ColorScheme||(e.ColorScheme={}))}),define(_e[156],we([0,1,4,6,30,3,155,36]),function(ie,e,E,I,P,A,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,E.createDecorator)("themeService");var y;(function(_){function d(b){return b&&typeof b=="object"&&typeof b.id=="string"}_.isThemeColor=d})(y=e.ThemeColor||(e.ThemeColor={}));function n(_){return{id:_}}e.themeColorFromId=n;var T;(function(_){function d(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||y.isThemeColor(t.color))}_.isThemeIcon=d;const b=new RegExp(`^\\$\\((${C.CSSIcon.iconNameExpression}(?:${C.CSSIcon.iconModifierExpression})?)\\)$`);function v(t){const r=b.exec(t);if(!!r){let[,c]=r;return{id:c}}}_.fromString=v;function l(t,r){let c=t.id;const o=c.lastIndexOf("~");return o!==-1&&(c=c.substring(0,o)),r&&(c=`${c}~${r}`),{id:c}}_.modify=l;function u(t,r){var c,o;return t.id===r.id&&((c=t.color)===null||c===void 0?void 0:c.id)===((o=r.color)===null||o===void 0?void 0:o.id)}_.isEqual=u,_.asClassNameArray=C.CSSIcon.asClassNameArray,_.asClassName=C.CSSIcon.asClassName,_.asCSSSelector=C.CSSIcon.asCSSSelector})(T=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=C.Codicon.file,e.FolderThemeIcon=C.Codicon.folder;function k(_){switch(_){case S.ColorScheme.DARK:return"vs-dark";case S.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=k,e.Extensions={ThemingContribution:"base.contributions.theming"};class g{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new A.Emitter}onColorThemeChange(d){return this.themingParticipants.push(d),this.onThemingParticipantAddedEmitter.fire(d),(0,I.toDisposable)(()=>{const b=this.themingParticipants.indexOf(d);this.themingParticipants.splice(b,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let m=new g;P.Registry.add(e.Extensions.ThemingContribution,m);function i(_){return m.onColorThemeChange(_)}e.registerThemingParticipant=i;class s extends I.Disposable{constructor(d){super();this.themeService=d,this.theme=d.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(b=>this.onThemeChange(b)))}onThemeChange(d){this.theme=d,this.updateStyles()}updateStyles(){}getColor(d,b){let v=this.theme.getColor(d);return v&&b&&(v=b(v,this.theme)),v?v.toString():null}}e.Themable=s}),define(_e[157],we([0,1,30,156,3,126,88,14,36]),function(ie,e,E,I,P,A,S,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class n{constructor(){this._onDidChange=new P.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,A.localize)(0,null)},fontCharacter:{type:"string",description:(0,A.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${y.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(d,b,v,l){const u=this.iconsById[d];if(u){if(v&&!u.description){u.description=v,this.iconSchema.properties[d].markdownDescription=`${v} $(${d})`;const c=this.iconReferenceSchema.enum.indexOf(d);c!==-1&&(this.iconReferenceSchema.enumDescriptions[c]=v),this._onDidChange.fire()}return u}let t={id:d,description:v,defaults:b,deprecationMessage:l};this.iconsById[d]=t;let r={$ref:"#/definitions/icons"};return l&&(r.deprecationMessage=l),v&&(r.markdownDescription=`${v}: $(${d})`),this.iconSchema.properties[d]=r,this.iconReferenceSchema.enum.push(d),this.iconReferenceSchema.enumDescriptions.push(v||""),this._onDidChange.fire(),{id:d}}deregisterIcon(d){delete this.iconsById[d],delete this.iconSchema.properties[d];const b=this.iconReferenceSchema.enum.indexOf(d);b!==-1&&(this.iconReferenceSchema.enum.splice(b,1),this.iconReferenceSchema.enumDescriptions.splice(b,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(d=>this.iconsById[d])}getIcon(d){return this.iconsById[d]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(d,b){const v=this.iconFontsById[d];if(v)return v;let l={id:d,definition:b};return this.iconFontsById[d]=l,this._onDidChange.fire(),l}deregisterIconFont(d){delete this.iconFontsById[d]}getIconFonts(){return Object.keys(this.iconFontsById).map(d=>this.iconFontsById[d])}getIconFont(d){return this.iconFontsById[d]}toString(){const d=(u,t)=>u.id.localeCompare(t.id),b=u=>{for(;I.ThemeIcon.isThemeIcon(u.defaults);)u=this.iconsById[u.defaults.id];return`codicon codicon-${u?u.id:""}`};let v=[];v.push("| preview     | identifier                        | default codicon ID                | description"),v.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const l=Object.keys(this.iconsById).map(u=>this.iconsById[u]);for(const u of l.filter(t=>!!t.description).sort(d))v.push(`|<i class="${b(u)}"></i>|${u.id}|${I.ThemeIcon.isThemeIcon(u.defaults)?u.defaults.id:u.id}|${u.description||""}|`);v.push("| preview     | identifier                        "),v.push("| ----------- | --------------------------------- |");for(const u of l.filter(t=>!I.ThemeIcon.isThemeIcon(t.defaults)).sort(d))v.push(`|<i class="${b(u)}"></i>|${u.id}|`);return v.join(`
`)}}const T=new n;E.Registry.add(e.Extensions.IconContribution,T);function k(_,d,b,v){return T.registerIcon(_,d,b,v)}e.registerIcon=k;function g(){return T}e.getIconRegistry=g;function m(){for(const _ of y.iconRegistry.all)T.registerIcon(_.id,_.definition,_.description);y.iconRegistry.onDidRegister(_=>T.registerIcon(_.id,_.definition,_.description))}m(),e.iconsSchemaId="vscode://schemas/icons";let i=E.Registry.as(S.Extensions.JSONContribution);i.registerSchema(e.iconsSchemaId,T.getIconSchema());const s=new C.RunOnceScheduler(()=>i.notifySchemaChanged(e.iconsSchemaId),200);T.onDidChange(()=>{s.isScheduled()||s.schedule()}),e.widgetClose=k("widget-close",y.Codicon.close,(0,A.localize)(2,null)),e.gotoPreviousLocation=k("goto-previous-location",y.Codicon.arrowUp,(0,A.localize)(3,null)),e.gotoNextLocation=k("goto-next-location",y.Codicon.arrowDown,(0,A.localize)(4,null)),e.syncing=I.ThemeIcon.modify(y.Codicon.sync,"spin")}),define(_e[47],we([0,1,2,25,4,22]),function(ie,e,E,I,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");var S;(function(g){g[g.EMPTY=1]="EMPTY",g[g.FOLDER=2]="FOLDER",g[g.WORKSPACE=3]="WORKSPACE"})(S=e.WorkbenchState||(e.WorkbenchState={}));function C(g){const m=g;return!!(m&&typeof m=="object"&&typeof m.id=="string"&&Array.isArray(m.folders))}e.isWorkspace=C;function y(g){const m=g;return!!(m&&typeof m=="object"&&E.URI.isUri(m.uri)&&typeof m.name=="string"&&typeof m.toResource=="function")}e.isWorkspaceFolder=y;class n{constructor(m,i,s,_){this._id=m,this._configuration=s,this._ignorePathCasing=_,this._foldersMap=A.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=i}update(m){this._id=m.id,this._configuration=m.configuration,this._ignorePathCasing=m._ignorePathCasing,this.folders=m.folders}get folders(){return this._folders}set folders(m){this._folders=m,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(m){this._configuration=m}getFolder(m){return m&&this._foldersMap.findSubstr(m.with({scheme:m.scheme,authority:m.authority,path:m.path}))||null}updateFoldersMap(){this._foldersMap=A.TernarySearchTree.forUris(this._ignorePathCasing);for(const m of this.folders)this._foldersMap.set(m.uri,m)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=n;class T{constructor(m,i){this.raw=i,this.uri=m.uri,this.index=m.index,this.name=m.name}toResource(m){return(0,I.joinPath)(this.uri,m)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=T;function k(g){return new T({uri:g,index:0,name:(0,I.basenameOrAuthority)(g)},{uri:g.toString()})}e.toWorkspaceFolder=k}),define(_e[158],we([0,1,4,127,47,2,21,12,25,105,43,18,58,37,91]),function(ie,e,E,I,P,A,S,C,y,n,T,k,g,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const s=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function _(G){return(typeof G=="string"?(0,C.extname)(G):(0,y.extname)(G))===s}e.hasWorkspaceFileExtension=_,e.IWorkspacesService=(0,E.createDecorator)("workspacesService");function d(G){return G.hasOwnProperty("workspace")}e.isRecentWorkspace=d;function b(G){return G.hasOwnProperty("folderUri")}e.isRecentFolder=b;function v(G){return G.hasOwnProperty("fileUri")}e.isRecentFile=v;function l(G){const M=G;return typeof(M==null?void 0:M.id)=="string"&&A.URI.isUri(M.uri)}e.isSingleFolderWorkspaceIdentifier=l;function u(G){if(G.configuration)return{id:G.id,configPath:G.configuration};if(G.folders.length===1)return{id:G.id,uri:G.folders[0].uri}}e.toWorkspaceIdentifier=u;function t(G){const M=G;return typeof(M==null?void 0:M.id)=="string"&&A.URI.isUri(M.configPath)}e.isWorkspaceIdentifier=t;function r(G){const M=G;if(M==null?void 0:M.uri)return{id:M.id,uri:A.URI.revive(M.uri)};const N=G;if(N==null?void 0:N.configPath)return{id:N.id,configPath:A.URI.revive(N.configPath)};if(G==null?void 0:G.id)return{id:G.id}}e.reviveIdentifier=r;function c(G,M){return y.extUriBiasedIgnorePathCase.isEqualOrParent(G,M.untitledWorkspacesHome)}e.isUntitledWorkspace=c;function o(G){return a(G)||f(G)}e.isStoredWorkspaceFolder=o;function a(G){const M=G;return typeof(M==null?void 0:M.path)=="string"&&(!M.name||typeof M.name=="string")}e.isRawFileWorkspaceFolder=a;function f(G){const M=G;return typeof(M==null?void 0:M.uri)=="string"&&(!M.name||typeof M.name=="string")}e.isRawUriWorkspaceFolder=f;function w(G,M,N,B,Q=!S.isWindows,W){if(G.scheme!==B.scheme)return{name:N,uri:G.toString(!0)};let ee=M?void 0:W.relativePath(B,G);if(ee!==void 0)ee.length===0?ee=".":S.isWindows&&G.scheme===k.Schemas.file&&!Q&&(ee=ee.replace(/\//g,"\\"));else if(G.scheme===k.Schemas.file)ee=G.fsPath,S.isWindows&&(ee=(0,g.normalizeDriveLetter)(ee),Q&&(ee=(0,m.toSlashes)(ee)));else{if(!W.isEqualAuthority(G.authority,B.authority))return{name:N,uri:G.toString(!0)};ee=G.path}return{name:N,path:ee}}e.getStoredWorkspaceFolder=w;function D(G,M,N){let B=[],Q=new Set;const W=N.dirname(M);for(let ee of G){let re=null;if(a(ee))ee.path&&(re=N.resolvePath(W,ee.path));else if(f(ee))try{re=A.URI.parse(ee.uri),re.path[0]!=="/"&&(re=re.with({path:"/"+re.path}))}catch(oe){console.warn(oe)}if(re){let oe=N.getComparisonKey(re);if(!Q.has(oe)){Q.add(oe);const Se=ee.name||N.basenameOrAuthority(re);B.push(new P.WorkspaceFolder({uri:re,name:Se,index:B.length},ee))}}}return B}e.toWorkspaceFolders=D;function p(G,M,N,B,Q){let W=h(M,G);const ee=Q.dirname(M),re=Q.dirname(B),oe=[],Se=R(W.folders);for(const ze of W.folders){const U=a(ze)?Q.resolvePath(ee,ze.path):A.URI.parse(ze.uri);let K;N?K=!1:K=!a(ze)||(0,C.isAbsolute)(ze.path),oe.push(w(U,K,ze.name,re,Se,Q))}const Pe={insertSpaces:!1,tabSize:4,eol:S.isLinux||S.isMacintosh?`
`:`\r
`},$e=n.setProperty(G,["folders"],oe,Pe);let Fe=n.applyEdits(G,$e);return W.remoteAuthority===(0,i.getRemoteAuthority)(B)&&(Fe=n.applyEdits(Fe,n.removeProperty(Fe,["remoteAuthority"],Pe))),Fe}e.rewriteWorkspaceFileForNewLocation=p;function h(G,M){let N=T.parse(M);if(N&&Array.isArray(N.folders))N.folders=N.folders.filter(B=>o(B));else throw new Error(`${G} looks like an invalid workspace file.`);return N}function R(G){return S.isWindows?G.some(M=>a(M)&&M.path.indexOf("/")>=0):!0}e.useSlashForPath=R;function F(G){return G.workspace&&typeof G.workspace=="object"&&typeof G.workspace.id=="string"&&typeof G.workspace.configPath=="string"}function $(G){return typeof G.folderUri=="string"}function se(G){return typeof G.fileUri=="string"}function z(G,M){const N={workspaces:[],files:[]};if(G){const B=function(W,ee){for(let re=0;re<W.length;re++)try{ee(W[re],re)}catch(oe){M.warn(`Error restoring recent entry ${JSON.stringify(W[re])}: ${oe.toString()}. Skip entry.`)}},Q=G;if(Array.isArray(Q.entries))B(Q.entries,W=>{const ee=W.label,re=W.remoteAuthority;F(W)?N.workspaces.push({label:ee,remoteAuthority:re,workspace:{id:W.workspace.id,configPath:A.URI.parse(W.workspace.configPath)}}):$(W)?N.workspaces.push({label:ee,remoteAuthority:re,folderUri:A.URI.parse(W.folderUri)}):se(W)&&N.files.push({label:ee,remoteAuthority:re,fileUri:A.URI.parse(W.fileUri)})});else{const W=G;Array.isArray(W.workspaces3)&&B(W.workspaces3,(ee,re)=>{const oe=Array.isArray(W.workspaceLabels)&&W.workspaceLabels[re]||void 0;typeof ee=="object"&&typeof ee.id=="string"&&typeof ee.configURIPath=="string"?N.workspaces.push({label:oe,workspace:{id:ee.id,configPath:A.URI.parse(ee.configURIPath)}}):typeof ee=="string"&&N.workspaces.push({label:oe,folderUri:A.URI.parse(ee)})}),Array.isArray(W.files2)&&B(W.files2,(ee,re)=>{const oe=Array.isArray(W.fileLabels)&&W.fileLabels[re]||void 0;typeof ee=="string"&&N.files.push({label:oe,fileUri:A.URI.parse(ee)})})}}return N}e.restoreRecentlyOpened=z;function x(G){const M={entries:[]};for(const N of G.workspaces)b(N)?M.entries.push({folderUri:N.folderUri.toString(),label:N.label,remoteAuthority:N.remoteAuthority}):M.entries.push({workspace:{id:N.workspace.id,configPath:N.workspace.configPath.toString()},label:N.label,remoteAuthority:N.remoteAuthority});for(const N of G.files)M.entries.push({fileUri:N.fileUri.toString(),label:N.label,remoteAuthority:N.remoteAuthority});return M}e.toStoreData=x}),define(_e[92],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class E{constructor(P){this.id=P,this._data=new Map,this._idPool=1}add(P){const A=this._idPool++;return this._data.set(A,P),this.logDebugInfo(),A}get(P,A){return this._data.has(P)?this._data.get(P)[A]:void 0}delete(P){this._data.delete(P),this.logDebugInfo()}logDebugInfo(){!E.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=E,E.enableDebugLogging=!1}),define(_e[159],we([0,1,2,3]),function(ie,e,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=void 0;class P{constructor(){this._onDidChangeTabs=new I.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(S){this._tabs=S.map(C=>({name:C.name,group:C.group,resource:E.URI.revive(C.resource)})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=P}),define(_e[48],we([0,1,18,4]),function(ie,e,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class P{constructor(){this._systemSchemes=new Set(Object.keys(E.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(S,C){C===null?this._providerInfo.delete(S):this._providerInfo.set(S,C)}isFreeScheme(S){return!this._providerInfo.has(S)&&!this._systemSchemes.has(S)}getCapabilities(S){return this._providerInfo.get(S)}}e.ExtHostFileSystemInfo=P,e.IExtHostFileSystemInfo=(0,I.createDecorator)("IExtHostFileSystemInfo")}),define(_e[27],we([0,1,4]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,E.createDecorator)("IExtHostInitDataService")}),define(_e[160],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class E{constructor(A,S,C){this._id=A,this._shared=S,this._storage=C,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(y=>(this._value=y,this)),this._storageListener=this._storage.onDidChangeStorage(y=>{y.shared===this._shared&&y.key===this._id&&(this._value=y.value)})}get whenReady(){return this._init}get(A,S){let C=this._value[A];return typeof C=="undefined"&&(C=S),C}update(A,S){return this._value[A]=S,this._storage.setValue(this._shared,this._id,this._value)}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=E;class I extends E{constructor(A,S){super(A.identifier.value,!0,S);this._extension=A}setKeysForSync(A){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},A)}}e.ExtensionGlobalMemento=I}),define(_e[15],we([0,1,4]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,E.createDecorator)("IExtHostRpcService");class I{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=I});var tt=this&&this.__classPrivateFieldSet||function(ie,e,E,I,P){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!P:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?P.call(ie,E):P?P.value=E:e.set(ie,E),E},xe=this&&this.__classPrivateFieldGet||function(ie,e,E,I){if(E==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!I:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?I:E==="a"?I.call(ie):I?I.value:e.get(ie)};define(_e[161],we([0,1,26,3]),function(ie,e,E,I){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class A{constructor(C,y){P.set(this,void 0),this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this._id=E.ExtensionIdentifier.toKey(C.identifier),tt(this,P,y,"f"),xe(this,P,"f").onDidChangePassword(n=>{n.extensionId===this._id&&this._onDidChange.fire({key:n.key})})}get(C){return xe(this,P,"f").get(this._id,C)}store(C,y){return xe(this,P,"f").store(this._id,C,y)}delete(C){return xe(this,P,"f").delete(this._id,C)}}e.ExtensionSecrets=A,P=new WeakMap}),define(_e[93],we([0,1,4,3]),function(ie,e,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class P{constructor(){this._onDidChangeTelemetryEnabled=new I.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(S){this._enabled=S}$onDidChangeTelemetryEnabled(S){this._enabled=S,this._onDidChangeTelemetryEnabled.fire(S)}}e.ExtHostTelemetry=P,e.IExtHostTelemetry=(0,E.createDecorator)("IExtHostTelemetry")}),define(_e[67],we([0,1,4,3,15]),function(ie,e,E,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var A;(function(C){function y(T){return{remoteAddress:T.remoteAddress,localAddress:T.localAddress,public:!!T.public}}C.fromApiTunnel=y;function n(T){return{remoteAddress:{host:T.tunnelRemoteHost,port:T.tunnelRemotePort},localAddress:T.localAddress,public:T.public}}C.fromServiceTunnel=n})(A=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,E.createDecorator)("IExtHostTunnelService");let S=class{constructor(y){this.onDidChangeTunnels=new I.Emitter().event}async $applyCandidateFilter(y){return y}async openTunnel(y,n){}async getTunnels(){return[]}async setTunnelExtensionFunctions(y){return{dispose:()=>{}}}registerPortsAttributesProvider(y,n){return{dispose:()=>{}}}async $providePortAttributes(y,n,T,k,g){return[]}async $forwardPort(y,n){}async $closeTunnel(y){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};S=je([Ke(0,P.IExtHostRpcService)],S),e.ExtHostTunnelService=S});var tt=this&&this.__classPrivateFieldSet||function(ie,e,E,I,P){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!P:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?P.call(ie,E):P?P.value=E:e.set(ie,E),E},xe=this&&this.__classPrivateFieldGet||function(ie,e,E,I){if(E==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!I:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?I:E==="a"?I.call(ie):I?I.value:e.get(ie)};define(_e[7],we([0,1,11,10,80,22,13,2,29,64,90]),function(ie,e,E,I,P,A,S,C,y,n,T){"use strict";var k,g,m,i,s,_,d,b,v,l,u,t,r,c,o,a,f,w;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestItem=e.TestChildrenCollection=e.TestItemHookProperty=e.TestMessageSeverity=e.TestResultState=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookCellRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlineHint=e.InlineHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function D(O){function L(){return Reflect.construct(O,arguments,this.constructor)}return Object.defineProperty(L,"name",Object.getOwnPropertyDescriptor(O,"name")),Object.setPrototypeOf(L,O),Object.setPrototypeOf(L.prototype,O.prototype),L}let p=s=class{constructor(L){k.set(this,void 0),tt(this,k,L,"f")}static from(...L){let J=L;return new s(function(){if(J){for(const ye of J)ye&&typeof ye.dispose=="function"&&ye.dispose();J=void 0}})}dispose(){typeof xe(this,k,"f")=="function"&&(xe(this,k,"f").call(this),tt(this,k,void 0,"f"))}};k=new WeakMap,p=s=je([D],p),e.Disposable=p;let h=_=class{constructor(L,J){if(L<0)throw(0,I.illegalArgument)("line must be non-negative");if(J<0)throw(0,I.illegalArgument)("character must be non-negative");this._line=L,this._character=J}static Min(...L){if(L.length===0)throw new TypeError;let J=L[0];for(let ye=1;ye<L.length;ye++){const Be=L[ye];Be.isBefore(J)&&(J=Be)}return J}static Max(...L){if(L.length===0)throw new TypeError;let J=L[0];for(let ye=1;ye<L.length;ye++){const Be=L[ye];Be.isAfter(J)&&(J=Be)}return J}static isPosition(L){if(!L)return!1;if(L instanceof _)return!0;let{line:J,character:ye}=L;return typeof J=="number"&&typeof ye=="number"}get line(){return this._line}get character(){return this._character}isBefore(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<L._character}isBeforeOrEqual(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<=L._character}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this._line===L._line&&this._character===L._character}compareTo(L){return this._line<L._line?-1:this._line>L.line?1:this._character<L._character?-1:this._character>L._character?1:0}translate(L,J=0){if(L===null||J===null)throw(0,I.illegalArgument)();let ye;return typeof L=="undefined"?ye=0:typeof L=="number"?ye=L:(ye=typeof L.lineDelta=="number"?L.lineDelta:0,J=typeof L.characterDelta=="number"?L.characterDelta:0),ye===0&&J===0?this:new _(this.line+ye,this.character+J)}with(L,J=this.character){if(L===null||J===null)throw(0,I.illegalArgument)();let ye;return typeof L=="undefined"?ye=this.line:typeof L=="number"?ye=L:(ye=typeof L.line=="number"?L.line:this.line,J=typeof L.character=="number"?L.character:this.character),ye===this.line&&J===this.character?this:new _(ye,J)}toJSON(){return{line:this.line,character:this.character}}};h=_=je([D],h),e.Position=h;let R=d=class{constructor(L,J,ye,Be){let Je,lt;if(typeof L=="number"&&typeof J=="number"&&typeof ye=="number"&&typeof Be=="number"?(Je=new h(L,J),lt=new h(ye,Be)):L instanceof h&&J instanceof h&&(Je=L,lt=J),!Je||!lt)throw new Error("Invalid arguments");Je.isBefore(lt)?(this._start=Je,this._end=lt):(this._start=lt,this._end=Je)}static isRange(L){return L instanceof d?!0:L?h.isPosition(L.start)&&h.isPosition(L.end):!1}get start(){return this._start}get end(){return this._end}contains(L){return L instanceof d?this.contains(L._start)&&this.contains(L._end):L instanceof h?!(L.isBefore(this._start)||this._end.isBefore(L)):!1}isEqual(L){return this._start.isEqual(L._start)&&this._end.isEqual(L._end)}intersection(L){const J=h.Max(L.start,this._start),ye=h.Min(L.end,this._end);if(!J.isAfter(ye))return new d(J,ye)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const J=h.Min(L.start,this._start),ye=h.Max(L.end,this.end);return new d(J,ye)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(L,J=this.end){if(L===null||J===null)throw(0,I.illegalArgument)();let ye;return L?h.isPosition(L)?ye=L:(ye=L.start||this.start,J=L.end||this.end):ye=this.start,ye.isEqual(this._start)&&J.isEqual(this.end)?this:new d(ye,J)}toJSON(){return[this.start,this.end]}};R=d=je([D],R),e.Range=R;let F=b=class extends R{constructor(L,J,ye,Be){let Je,lt;if(typeof L=="number"&&typeof J=="number"&&typeof ye=="number"&&typeof Be=="number"?(Je=new h(L,J),lt=new h(ye,Be)):L instanceof h&&J instanceof h&&(Je=L,lt=J),!Je||!lt)throw new Error("Invalid arguments");super(Je,lt);this._anchor=Je,this._active=lt}static isSelection(L){return L instanceof b?!0:L?R.isRange(L)&&h.isPosition(L.anchor)&&h.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};F=b=je([D],F),e.Selection=F;class ${constructor(L,J,ye){if(typeof L!="string"||L.length===0)throw(0,I.illegalArgument)("host");if(typeof J!="number"||J===0||Math.round(J)!==J)throw(0,I.illegalArgument)("port");if(typeof ye!="undefined"&&(typeof ye!="string"||ye.length===0||!/^[0-9A-Za-z\-]+$/.test(ye)))throw(0,I.illegalArgument)("connectionToken");this.host=L,this.port=Math.round(J),this.connectionToken=ye}}e.ResolvedAuthority=$;class se extends Error{constructor(L,J=T.RemoteAuthorityResolverErrorCode.Unknown,ye){super(L);this._message=L,this._code=J,this._detail=ye,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,se.prototype)}static NotAvailable(L,J){return new se(L,T.RemoteAuthorityResolverErrorCode.NotAvailable,J)}static TemporarilyNotAvailable(L){return new se(L,T.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=se;var z;(function(O){O[O.LF=1]="LF",O[O.CRLF=2]="CRLF"})(z=e.EndOfLine||(e.EndOfLine={}));var x;(function(O){O[O.Replace=1]="Replace",O[O.Append=2]="Append",O[O.Prepend=3]="Prepend"})(x=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let G=v=class{constructor(L,J){this._range=L,this._newText=J}static isTextEdit(L){return L instanceof v?!0:L?R.isRange(L)&&typeof L.newText=="string":!1}static replace(L,J){return new v(L,J)}static insert(L,J){return v.replace(new R(L,L),J)}static delete(L){return v.replace(L,"")}static setEndOfLine(L){const J=new v(new R(new h(0,0),new h(0,0)),"");return J.newEol=L,J}get range(){return this._range}set range(L){if(L&&!R.isRange(L))throw(0,I.illegalArgument)("range");this._range=L}get newText(){return this._newText||""}set newText(L){if(L&&typeof L!="string")throw(0,I.illegalArgument)("newText");this._newText=L}get newEol(){return this._newEol}set newEol(L){if(L&&typeof L!="number")throw(0,I.illegalArgument)("newEol");this._newEol=L}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};G=v=je([D],G),e.TextEdit=G;var M;(function(O){O[O.File=1]="File",O[O.Text=2]="Text",O[O.Cell=3]="Cell",O[O.CellOutput=4]="CellOutput",O[O.CellReplace=5]="CellReplace",O[O.CellOutputItem=6]="CellOutputItem"})(M=e.FileEditType||(e.FileEditType={}));let N=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(L,J,ye,Be){this._edits.push({_type:1,from:L,to:J,options:ye,metadata:Be})}createFile(L,J,ye){this._edits.push({_type:1,from:void 0,to:L,options:J,metadata:ye})}deleteFile(L,J,ye){this._edits.push({_type:1,from:L,to:void 0,options:J,metadata:ye})}replaceNotebookMetadata(L,J,ye){this._edits.push({_type:3,metadata:ye,uri:L,edit:{editType:5,metadata:J},notebookMetadata:J})}replaceNotebookCells(L,J,ye,Be,Je){(J!==ye||Be.length>0)&&this._edits.push({_type:5,uri:L,index:J,count:ye-J,cells:Be,metadata:Je})}replaceNotebookCellOutput(L,J,ye,Be){this._editNotebookCellOutput(L,J,!1,ye,Be)}appendNotebookCellOutput(L,J,ye,Be){this._editNotebookCellOutput(L,J,!0,ye,Be)}replaceNotebookCellOutputItems(L,J,ye,Be,Je){this._editNotebookCellOutputItems(L,J,ye,!1,Be,Je)}appendNotebookCellOutputItems(L,J,ye,Be,Je){this._editNotebookCellOutputItems(L,J,ye,!0,Be,Je)}_editNotebookCellOutputItems(L,J,ye,Be,Je,lt){this._edits.push({_type:6,metadata:lt,uri:L,index:J,outputId:ye,append:Be,newOutputItems:Je})}_editNotebookCellOutput(L,J,ye,Be,Je){this._edits.push({_type:4,metadata:Je,uri:L,index:J,append:ye,newOutputs:Be,newMetadata:void 0})}replaceNotebookCellMetadata(L,J,ye,Be){this._edits.push({_type:3,metadata:Be,uri:L,edit:{editType:11,index:J,metadata:ye}})}replace(L,J,ye,Be){this._edits.push({_type:2,uri:L,edit:new G(J,ye),metadata:Be})}insert(L,J,ye,Be){this.replace(L,new R(J,J),ye,Be)}delete(L,J,ye){this.replace(L,J,"",ye)}has(L){return this._edits.some(J=>J._type===2&&J.uri.toString()===L.toString())}set(L,J){if(J)for(const ye of J)ye&&this._edits.push({_type:2,uri:L,edit:ye});else{for(let ye=0;ye<this._edits.length;ye++){const Be=this._edits[ye];Be._type===2&&Be.uri.toString()===L.toString()&&(this._edits[ye]=void 0)}(0,E.coalesceInPlace)(this._edits)}}get(L){const J=[];for(let ye of this._edits)ye._type===2&&ye.uri.toString()===L.toString()&&J.push(ye.edit);return J}entries(){const L=new A.ResourceMap;for(let J of this._edits)if(J._type===2){let ye=L.get(J.uri);ye||(ye=[J.uri,[]],L.set(J.uri,ye)),ye[1].push(J.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};N=je([D],N),e.WorkspaceEdit=N;let B=l=class{constructor(L){this._tabstop=1,this.value=L||""}static isSnippetString(L){return L instanceof l?!0:L?typeof L.value=="string":!1}static _escape(L){return L.replace(/\$|}|\\/g,"\\$&")}appendText(L){return this.value+=l._escape(L),this}appendTabstop(L=this._tabstop++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,J=this._tabstop++){if(typeof L=="function"){const ye=new l;ye._tabstop=this._tabstop,L(ye),this._tabstop=ye._tabstop,L=ye.value}else L=l._escape(L);return this.value+="${",this.value+=J,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,J=this._tabstop++){const ye=L.map(Be=>Be.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=J,this.value+="|",this.value+=ye,this.value+="|}",this}appendVariable(L,J){if(typeof J=="function"){const ye=new l;ye._tabstop=this._tabstop,J(ye),this._tabstop=ye._tabstop,J=ye.value}else typeof J=="string"&&(J=J.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,J&&(this.value+=":",this.value+=J),this.value+="}",this}};B=l=je([D],B),e.SnippetString=B;var Q;(function(O){O[O.Unnecessary=1]="Unnecessary",O[O.Deprecated=2]="Deprecated"})(Q=e.DiagnosticTag||(e.DiagnosticTag={}));var W;(function(O){O[O.Hint=3]="Hint",O[O.Information=2]="Information",O[O.Warning=1]="Warning",O[O.Error=0]="Error"})(W=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ee=u=class{constructor(L,J){if(this.uri=L,J)if(J instanceof R)this.range=J;else if(J instanceof h)this.range=new R(J,J);else throw new Error("Illegal argument")}static isLocation(L){return L instanceof u?!0:L?R.isRange(L.range)&&C.URI.isUri(L.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};ee=u=je([D],ee),e.Location=ee;let re=class{constructor(L,J){this.location=L,this.message=J}static is(L){return L?typeof L.message=="string"&&L.location&&R.isRange(L.location.range)&&C.URI.isUri(L.location.uri):!1}static isEqual(L,J){return L===J?!0:!L||!J?!1:L.message===J.message&&L.location.range.isEqual(J.location.range)&&L.location.uri.toString()===J.location.uri.toString()}};re=je([D],re),e.DiagnosticRelatedInformation=re;let oe=class{constructor(L,J,ye=W.Error){if(!R.isRange(L))throw new TypeError("range must be set");if(!J)throw new TypeError("message must be set");this.range=L,this.message=J,this.severity=ye}toJSON(){return{severity:W[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,J){return L===J?!0:!L||!J?!1:L.message===J.message&&L.severity===J.severity&&L.code===J.code&&L.severity===J.severity&&L.source===J.source&&L.range.isEqual(J.range)&&(0,E.equals)(L.tags,J.tags)&&(0,E.equals)(L.relatedInformation,J.relatedInformation,re.isEqual)}};oe=je([D],oe),e.Diagnostic=oe;let Se=class{constructor(L,J){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:(0,P.isMarkdownString)(L)?this.contents=[L]:this.contents=[L],this.range=J}};Se=je([D],Se),e.Hover=Se;var Pe;(function(O){O[O.Text=0]="Text",O[O.Read=1]="Read",O[O.Write=2]="Write"})(Pe=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let $e=class{constructor(L,J=Pe.Text){this.range=L,this.kind=J}toJSON(){return{range:this.range,kind:Pe[this.kind]}}};$e=je([D],$e),e.DocumentHighlight=$e;var Fe;(function(O){O[O.File=0]="File",O[O.Module=1]="Module",O[O.Namespace=2]="Namespace",O[O.Package=3]="Package",O[O.Class=4]="Class",O[O.Method=5]="Method",O[O.Property=6]="Property",O[O.Field=7]="Field",O[O.Constructor=8]="Constructor",O[O.Enum=9]="Enum",O[O.Interface=10]="Interface",O[O.Function=11]="Function",O[O.Variable=12]="Variable",O[O.Constant=13]="Constant",O[O.String=14]="String",O[O.Number=15]="Number",O[O.Boolean=16]="Boolean",O[O.Array=17]="Array",O[O.Object=18]="Object",O[O.Key=19]="Key",O[O.Null=20]="Null",O[O.EnumMember=21]="EnumMember",O[O.Struct=22]="Struct",O[O.Event=23]="Event",O[O.Operator=24]="Operator",O[O.TypeParameter=25]="TypeParameter"})(Fe=e.SymbolKind||(e.SymbolKind={}));var ze;(function(O){O[O.Deprecated=1]="Deprecated"})(ze=e.SymbolTag||(e.SymbolTag={}));let U=t=class{constructor(L,J,ye,Be,Je){this.name=L,this.kind=J,this.containerName=Je,typeof ye=="string"&&(this.containerName=ye),Be instanceof ee?this.location=Be:ye instanceof R&&(this.location=new ee(Be,ye)),t.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Fe[this.kind],location:this.location,containerName:this.containerName}}};U=t=je([D],U),e.SymbolInformation=U;let K=r=class{constructor(L,J,ye,Be,Je){this.name=L,this.detail=J,this.kind=ye,this.range=Be,this.selectionRange=Je,this.children=[],r.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children&&L.children.forEach(r.validate)}};K=r=je([D],K),e.DocumentSymbol=K;var te;(function(O){O[O.Invoke=1]="Invoke",O[O.Automatic=2]="Automatic"})(te=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let le=class{constructor(L,J){this.title=L,this.kind=J}};le=je([D],le),e.CodeAction=le;let me=c=class{constructor(L){this.value=L}append(L){return new c(this.value?this.value+c.sep+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+c.sep)}};me.sep=".",me=c=je([D],me),e.CodeActionKind=me,me.Empty=new me(""),me.QuickFix=me.Empty.append("quickfix"),me.Refactor=me.Empty.append("refactor"),me.RefactorExtract=me.Refactor.append("extract"),me.RefactorInline=me.Refactor.append("inline"),me.RefactorRewrite=me.Refactor.append("rewrite"),me.Source=me.Empty.append("source"),me.SourceOrganizeImports=me.Source.append("organizeImports"),me.SourceFixAll=me.Source.append("fixAll");let De=class{constructor(L,J){if(this.range=L,this.parent=J,J&&!J.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};De=je([D],De),e.SelectionRange=De;class Oe{constructor(L,J,ye,Be,Je,lt){this.kind=L,this.name=J,this.detail=ye,this.uri=Be,this.range=Je,this.selectionRange=lt}}e.CallHierarchyItem=Oe;class ge{constructor(L,J){this.fromRanges=J,this.from=L}}e.CallHierarchyIncomingCall=ge;class Ce{constructor(L,J){this.fromRanges=J,this.to=L}}e.CallHierarchyOutgoingCall=Ce;let Ae=class{constructor(L,J){this.range=L,this.command=J}get isResolved(){return!!this.command}};Ae=je([D],Ae),e.CodeLens=Ae;let We=o=class{constructor(L,J=!1){g.set(this,void 0),tt(this,g,new P.MarkdownString(L,{supportThemeIcons:J}),"f")}static isMarkdownString(L){return L instanceof o?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}get value(){return xe(this,g,"f").value}set value(L){xe(this,g,"f").value=L}get isTrusted(){return xe(this,g,"f").isTrusted}set isTrusted(L){xe(this,g,"f").isTrusted=L}get supportThemeIcons(){return xe(this,g,"f").supportThemeIcons}appendText(L){return xe(this,g,"f").appendText(L),this}appendMarkdown(L){return xe(this,g,"f").appendMarkdown(L),this}appendCodeblock(L,J){return xe(this,g,"f").appendCodeblock(J!=null?J:"",L),this}};g=new WeakMap,We=o=je([D],We),e.MarkdownString=We;let be=class{constructor(L,J){this.label=L,this.documentation=J}};be=je([D],be),e.ParameterInformation=be;let qe=class{constructor(L,J){this.label=L,this.documentation=J,this.parameters=[]}};qe=je([D],qe),e.SignatureInformation=qe;let V=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};V=je([D],V),e.SignatureHelp=V;var Z;(function(O){O[O.Invoke=1]="Invoke",O[O.TriggerCharacter=2]="TriggerCharacter",O[O.ContentChange=3]="ContentChange"})(Z=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var pe;(function(O){O[O.Other=0]="Other",O[O.Type=1]="Type",O[O.Parameter=2]="Parameter"})(pe=e.InlineHintKind||(e.InlineHintKind={}));let Me=class{constructor(L,J,ye){this.text=L,this.range=J,this.kind=ye}};Me=je([D],Me),e.InlineHint=Me;var He;(function(O){O[O.Invoke=0]="Invoke",O[O.TriggerCharacter=1]="TriggerCharacter",O[O.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(He=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ue;(function(O){O[O.Text=0]="Text",O[O.Method=1]="Method",O[O.Function=2]="Function",O[O.Constructor=3]="Constructor",O[O.Field=4]="Field",O[O.Variable=5]="Variable",O[O.Class=6]="Class",O[O.Interface=7]="Interface",O[O.Module=8]="Module",O[O.Property=9]="Property",O[O.Unit=10]="Unit",O[O.Value=11]="Value",O[O.Enum=12]="Enum",O[O.Keyword=13]="Keyword",O[O.Snippet=14]="Snippet",O[O.Color=15]="Color",O[O.File=16]="File",O[O.Reference=17]="Reference",O[O.Folder=18]="Folder",O[O.EnumMember=19]="EnumMember",O[O.Constant=20]="Constant",O[O.Struct=21]="Struct",O[O.Event=22]="Event",O[O.Operator=23]="Operator",O[O.TypeParameter=24]="TypeParameter",O[O.User=25]="User",O[O.Issue=26]="Issue"})(Ue=e.CompletionItemKind||(e.CompletionItemKind={}));var Ze;(function(O){O[O.Deprecated=1]="Deprecated"})(Ze=e.CompletionItemTag||(e.CompletionItemTag={}));let H=class{constructor(L,J){this.label=L,this.kind=J}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&Ue[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};H=je([D],H),e.CompletionItem=H;let ne=class{constructor(L=[],J=!1){this.items=L,this.isIncomplete=J}};ne=je([D],ne),e.CompletionList=ne;var de;(function(O){O[O.Active=-1]="Active",O[O.Beside=-2]="Beside",O[O.One=1]="One",O[O.Two=2]="Two",O[O.Three=3]="Three",O[O.Four=4]="Four",O[O.Five=5]="Five",O[O.Six=6]="Six",O[O.Seven=7]="Seven",O[O.Eight=8]="Eight",O[O.Nine=9]="Nine"})(de=e.ViewColumn||(e.ViewColumn={}));var j;(function(O){O[O.Left=1]="Left",O[O.Right=2]="Right"})(j=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Y;(function(O){O[O.Off=0]="Off",O[O.On=1]="On",O[O.Relative=2]="Relative"})(Y=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ae;(function(O){O[O.Manual=1]="Manual",O[O.AfterDelay=2]="AfterDelay",O[O.FocusOut=3]="FocusOut"})(ae=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var fe;(function(O){O[O.Default=0]="Default",O[O.InCenter=1]="InCenter",O[O.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",O[O.AtTop=3]="AtTop"})(fe=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Ee;(function(O){O[O.Keyboard=1]="Keyboard",O[O.Mouse=2]="Mouse",O[O.Command=3]="Command"})(Ee=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Ne;(function(O){O[O.OpenOpen=0]="OpenOpen",O[O.ClosedClosed=1]="ClosedClosed",O[O.OpenClosed=2]="OpenClosed",O[O.ClosedOpen=3]="ClosedOpen"})(Ne=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(O){function L(J){switch(J){case"keyboard":return O.Keyboard;case"mouse":return O.Mouse;case"api":return O.Command}}O.fromValue=L}(Ee=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Le=class{constructor(L,J){if(J&&!C.URI.isUri(J))throw(0,I.illegalArgument)("target");if(!R.isRange(L)||L.isEmpty)throw(0,I.illegalArgument)("range");this.range=L,this.target=J}};Le=je([D],Le),e.DocumentLink=Le;let Ve=class{constructor(L,J,ye,Be){this.red=L,this.green=J,this.blue=ye,this.alpha=Be}};Ve=je([D],Ve),e.Color=Ve;let Ye=class{constructor(L,J){if(J&&!(J instanceof Ve))throw(0,I.illegalArgument)("color");if(!R.isRange(L)||L.isEmpty)throw(0,I.illegalArgument)("range");this.range=L,this.color=J}};Ye=je([D],Ye),e.ColorInformation=Ye;let et=class{constructor(L){if(!L||typeof L!="string")throw(0,I.illegalArgument)("label");this.label=L}};et=je([D],et),e.ColorPresentation=et;var nt;(function(O){O[O.RGB=0]="RGB",O[O.HEX=1]="HEX",O[O.HSL=2]="HSL"})(nt=e.ColorFormat||(e.ColorFormat={}));var st;(function(O){O[O.Error=0]="Error",O[O.Warning=1]="Warning",O[O.Information=2]="Information"})(st=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var it;(function(O){O[O.Always=1]="Always",O[O.Silent=2]="Silent",O[O.Never=3]="Never"})(it=e.TaskRevealKind||(e.TaskRevealKind={}));var ve;(function(O){O[O.Shared=1]="Shared",O[O.Dedicated=2]="Dedicated",O[O.New=3]="New"})(ve=e.TaskPanelKind||(e.TaskPanelKind={}));let he=a=class{constructor(L,J){if(typeof L!="string"||typeof J!="string")throw(0,I.illegalArgument)("name");this._id=L}static from(L){switch(L){case"clean":return a.Clean;case"build":return a.Build;case"rebuild":return a.Rebuild;case"test":return a.Test;default:return}}get id(){return this._id}};he.Clean=new a("clean","Clean"),he.Build=new a("build","Build"),he.Rebuild=new a("rebuild","Rebuild"),he.Test=new a("test","Test"),he=a=je([D],he),e.TaskGroup=he;function ue(O){let L="";for(let J=0;J<O.length;J++)L+=O[J].replace(/,/g,",,")+",";return L}let q=class{constructor(L,J,ye){if(typeof L!="string")throw(0,I.illegalArgument)("process");this._args=[],this._process=L,J!==void 0&&(Array.isArray(J)?(this._args=J,this._options=ye):this._options=J)}get process(){return this._process}set process(L){if(typeof L!="string")throw(0,I.illegalArgument)("process");this._process=L}get args(){return this._args}set args(L){Array.isArray(L)||(L=[]),this._args=L}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("process"),this._process!==void 0&&L.push(this._process),this._args&&this._args.length>0)for(let J of this._args)L.push(J);return ue(L)}};q=je([D],q),e.ProcessExecution=q;let Ie=class{constructor(L,J,ye){if(this._args=[],Array.isArray(J)){if(!L)throw(0,I.illegalArgument)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,I.illegalArgument)("command");this._command=L,this._args=J,this._options=ye}else{if(typeof L!="string")throw(0,I.illegalArgument)("commandLine");this._commandLine=L,this._options=J}}get commandLine(){return this._commandLine}set commandLine(L){if(typeof L!="string")throw(0,I.illegalArgument)("commandLine");this._commandLine=L}get command(){return this._command?this._command:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,I.illegalArgument)("command");this._command=L}get args(){return this._args}set args(L){this._args=L||[]}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("shell"),this._commandLine!==void 0&&L.push(this._commandLine),this._command!==void 0&&L.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let J of this._args)L.push(typeof J=="string"?J:J.value);return ue(L)}};Ie=je([D],Ie),e.ShellExecution=Ie;var Te;(function(O){O[O.Escape=1]="Escape",O[O.Strong=2]="Strong",O[O.Weak=3]="Weak"})(Te=e.ShellQuoting||(e.ShellQuoting={}));var Qe;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace"})(Qe=e.TaskScope||(e.TaskScope={}));class Ge{constructor(L){this._callback=L}computeId(){return"customExecution"+(0,y.generateUuid)()}set callback(L){this._callback=L}get callback(){return this._callback}}e.CustomExecution=Ge;let rt=f=class{constructor(L,J,ye,Be,Je,lt){this.__deprecated=!1,this._definition=this.definition=L;let ht;typeof J=="string"?(this._name=this.name=J,this._source=this.source=ye,this.execution=Be,ht=Je,this.__deprecated=!0):J===Qe.Global||J===Qe.Workspace?(this.target=J,this._name=this.name=ye,this._source=this.source=Be,this.execution=Je,ht=lt):(this.target=J,this._name=this.name=ye,this._source=this.source=Be,this.execution=Je,ht=lt),typeof ht=="string"?(this._problemMatchers=[ht],this._hasDefinedMatchers=!0):Array.isArray(ht)?(this._problemMatchers=ht,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(L){this.__id=L}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof q?this._definition={type:f.ProcessType,id:this._execution.computeId()}:this._execution instanceof Ie?this._definition={type:f.ShellType,id:this._execution.computeId()}:this._execution instanceof Ge?this._definition={type:f.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:f.EmptyType,id:(0,y.generateUuid)()}}get definition(){return this._definition}set definition(L){if(L==null)throw(0,I.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=L}get scope(){return this._scope}set target(L){this.clear(),this._scope=L}get name(){return this._name}set name(L){if(typeof L!="string")throw(0,I.illegalArgument)("name");this.clear(),this._name=L}get execution(){return this._execution}set execution(L){L===null&&(L=void 0),this.clear(),this._execution=L;const J=this._definition.type;(f.EmptyType===J||f.ProcessType===J||f.ShellType===J||f.ExtensionCallbackType===J)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(L){if(Array.isArray(L))this.clear(),this._problemMatchers=L,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.clear(),this._isBackground=L}get source(){return this._source}set source(L){if(typeof L!="string"||L.length===0)throw(0,I.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=L}get group(){return this._group}set group(L){L===null&&(L=void 0),this.clear(),this._group=L}get detail(){return this._detail}set detail(L){L===null&&(L=void 0),this._detail=L}get presentationOptions(){return this._presentationOptions}set presentationOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._presentationOptions=L}get runOptions(){return this._runOptions}set runOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._runOptions=L}};rt.ExtensionCallbackType="customExecution",rt.ProcessType="process",rt.ShellType="shell",rt.EmptyType="$empty",rt=f=je([D],rt),e.Task=rt;var ct;(function(O){O[O.SourceControl=1]="SourceControl",O[O.Window=10]="Window",O[O.Notification=15]="Notification"})(ct=e.ProgressLocation||(e.ProgressLocation={}));let Xe=class{constructor(L,J=at.None){this.collapsibleState=J,C.URI.isUri(L)?this.resourceUri=L:this.label=L}};Xe=je([D],Xe),e.TreeItem=Xe;var at;(function(O){O[O.None=0]="None",O[O.Collapsed=1]="Collapsed",O[O.Expanded=2]="Expanded"})(at=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let ut=class{constructor(L,J){this.id=L,this.color=J}};ut=je([D],ut),e.ThemeIcon=ut,ut.File=new ut("file"),ut.Folder=new ut("folder");let ot=class{constructor(L){this.id=L}};ot=je([D],ot),e.ThemeColor=ot;var yt;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace",O[O.WorkspaceFolder=3]="WorkspaceFolder"})(yt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let gt=class{constructor(L,J){if(typeof L!="string"&&(!L||!C.URI.isUri(L)&&!C.URI.isUri(L.uri)))throw(0,I.illegalArgument)("base");if(typeof J!="string")throw(0,I.illegalArgument)("pattern");typeof L=="string"?(this.baseFolder=C.URI.file(L),this.base=L):C.URI.isUri(L)?(this.baseFolder=L,this.base=L.fsPath):(this.baseFolder=L.uri,this.base=L.uri.fsPath),this.pattern=J}};gt=je([D],gt),e.RelativePattern=gt;let vt=class{constructor(L,J,ye,Be){this.enabled=typeof L=="boolean"?L:!0,typeof J=="string"&&(this.condition=J),typeof ye=="string"&&(this.hitCondition=ye),typeof Be=="string"&&(this.logMessage=Be)}get id(){return this._id||(this._id=(0,y.generateUuid)()),this._id}};vt=je([D],vt),e.Breakpoint=vt;let _t=class extends vt{constructor(L,J,ye,Be,Je){super(J,ye,Be,Je);if(L===null)throw(0,I.illegalArgument)("location");this.location=L}};_t=je([D],_t),e.SourceBreakpoint=_t;let wt=class extends vt{constructor(L,J,ye,Be,Je){super(J,ye,Be,Je);this.functionName=L}};wt=je([D],wt),e.FunctionBreakpoint=wt;let pt=class extends vt{constructor(L,J,ye,Be,Je,lt,ht){super(Be,Je,lt,ht);if(!J)throw(0,I.illegalArgument)("dataId");this.label=L,this.dataId=J,this.canPersist=ye}};pt=je([D],pt),e.DataBreakpoint=pt;let Lt=class{constructor(L,J,ye){this.command=L,this.args=J||[],this.options=ye}};Lt=je([D],Lt),e.DebugAdapterExecutable=Lt;let At=class{constructor(L,J){this.port=L,this.host=J}};At=je([D],At),e.DebugAdapterServer=At;let ft=class{constructor(L){this.path=L}};ft=je([D],ft),e.DebugAdapterNamedPipeServer=ft;let zt=class{constructor(L){this.implementation=L}};zt=je([D],zt),e.DebugAdapterInlineImplementation=zt;let bt=class{constructor(L,J){this.range=L,this.expression=J}};bt=je([D],bt),e.EvaluatableExpression=bt;let $t=class{constructor(L,J){this.range=L,this.text=J}};$t=je([D],$t),e.InlineValueText=$t;let Vt=class{constructor(L,J,ye=!0){this.range=L,this.variableName=J,this.caseSensitiveLookup=ye}};Vt=je([D],Vt),e.InlineValueVariableLookup=Vt;let Mt=class{constructor(L,J){this.range=L,this.expression=J}};Mt=je([D],Mt),e.InlineValueEvaluatableExpression=Mt;let dt=class{constructor(L,J){this.frameId=L,this.stoppedLocation=J}};dt=je([D],dt),e.InlineValueContext=dt;var cn;(function(O){O[O.Changed=1]="Changed",O[O.Created=2]="Created",O[O.Deleted=3]="Deleted"})(cn=e.FileChangeType||(e.FileChangeType={}));let Ct=w=class extends Error{constructor(L,J=n.FileSystemProviderErrorCode.Unknown,ye){var Be;super(C.URI.isUri(L)?L.toString(!0):L);this.code=(Be=ye==null?void 0:ye.name)!==null&&Be!==void 0?Be:"Unknown",(0,n.markAsFileSystemProviderError)(this,J),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,w.prototype),typeof Error.captureStackTrace=="function"&&typeof ye=="function"&&Error.captureStackTrace(this,ye)}static FileExists(L){return new w(L,n.FileSystemProviderErrorCode.FileExists,w.FileExists)}static FileNotFound(L){return new w(L,n.FileSystemProviderErrorCode.FileNotFound,w.FileNotFound)}static FileNotADirectory(L){return new w(L,n.FileSystemProviderErrorCode.FileNotADirectory,w.FileNotADirectory)}static FileIsADirectory(L){return new w(L,n.FileSystemProviderErrorCode.FileIsADirectory,w.FileIsADirectory)}static NoPermissions(L){return new w(L,n.FileSystemProviderErrorCode.NoPermissions,w.NoPermissions)}static Unavailable(L){return new w(L,n.FileSystemProviderErrorCode.Unavailable,w.Unavailable)}};Ct=w=je([D],Ct),e.FileSystemError=Ct;let Tt=class{constructor(L,J,ye){this.start=L,this.end=J,this.kind=ye}};Tt=je([D],Tt),e.FoldingRange=Tt;var en;(function(O){O[O.Comment=1]="Comment",O[O.Imports=2]="Imports",O[O.Region=3]="Region"})(en=e.FoldingRangeKind||(e.FoldingRangeKind={}));var dn;(function(O){O[O.Collapsed=0]="Collapsed",O[O.Expanded=1]="Expanded"})(dn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var tn;(function(O){O[O.Editing=0]="Editing",O[O.Preview=1]="Preview"})(tn=e.CommentMode||(e.CommentMode={}));class hn{constructor(L,J=[]){this.tokenTypes=L,this.tokenModifiers=J}}e.SemanticTokensLegend=hn;function nn(O){return typeof O=="undefined"||(0,S.isStringArray)(O)}class It{constructor(L){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,L){this._hasLegend=!0;for(let J=0,ye=L.tokenTypes.length;J<ye;J++)this._tokenTypeStrToInt.set(L.tokenTypes[J],J);for(let J=0,ye=L.tokenModifiers.length;J<ye;J++)this._tokenModifierStrToInt.set(L.tokenModifiers[J],J)}}push(L,J,ye,Be,Je){if(typeof L=="number"&&typeof J=="number"&&typeof ye=="number"&&typeof Be=="number"&&(typeof Je=="number"||typeof Je=="undefined"))return typeof Je=="undefined"&&(Je=0),this._pushEncoded(L,J,ye,Be,Je);if(R.isRange(L)&&typeof J=="string"&&nn(ye))return this._push(L,J,ye);throw(0,I.illegalArgument)()}_push(L,J,ye){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(J))throw new Error("`tokenType` is not in the provided legend");const Be=L.start.line,Je=L.start.character,lt=L.end.character-L.start.character,ht=this._tokenTypeStrToInt.get(J);let Et=0;if(ye)for(const Dt of ye){if(!this._tokenModifierStrToInt.has(Dt))throw new Error("`tokenModifier` is not in the provided legend");const kt=this._tokenModifierStrToInt.get(Dt);Et|=1<<kt>>>0}this._pushEncoded(Be,Je,lt,ht,Et)}_pushEncoded(L,J,ye,Be,Je){if(this._dataIsSortedAndDeltaEncoded&&(L<this._prevLine||L===this._prevLine&&J<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Et=this._data.length/5|0;let Dt=0,kt=0;for(let Pt=0;Pt<Et;Pt++){let Rt=this._data[5*Pt],Xt=this._data[5*Pt+1];Rt===0?(Rt=Dt,Xt+=kt):Rt+=Dt,this._data[5*Pt]=Rt,this._data[5*Pt+1]=Xt,Dt=Rt,kt=Xt}}let lt=L,ht=J;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(lt-=this._prevLine,lt===0&&(ht-=this._prevChar)),this._data[this._dataLen++]=lt,this._data[this._dataLen++]=ht,this._data[this._dataLen++]=ye,this._data[this._dataLen++]=Be,this._data[this._dataLen++]=Je,this._prevLine=L,this._prevChar=J}static _sortAndDeltaEncode(L){let J=[];const ye=L.length/5|0;for(let ht=0;ht<ye;ht++)J[ht]=ht;J.sort((ht,Et)=>{const Dt=L[5*ht],kt=L[5*Et];if(Dt===kt){const Pt=L[5*ht+1],Rt=L[5*Et+1];return Pt-Rt}return Dt-kt});const Be=new Uint32Array(L.length);let Je=0,lt=0;for(let ht=0;ht<ye;ht++){const Et=5*J[ht],Dt=L[Et+0],kt=L[Et+1],Pt=L[Et+2],Rt=L[Et+3],Xt=L[Et+4],Cn=Dt-Je,An=Cn===0?kt-lt:kt,Zt=5*ht;Be[Zt+0]=Cn,Be[Zt+1]=An,Be[Zt+2]=Pt,Be[Zt+3]=Rt,Be[Zt+4]=Xt,Je=Dt,lt=kt}return Be}build(L){return this._dataIsSortedAndDeltaEncoded?new jt(new Uint32Array(this._data),L):new jt(It._sortAndDeltaEncode(this._data),L)}}e.SemanticTokensBuilder=It;class jt{constructor(L,J){this.resultId=J,this.data=L}}e.SemanticTokens=jt;class qt{constructor(L,J,ye){this.start=L,this.deleteCount=J,this.data=ye}}e.SemanticTokensEdit=qt;class Kt{constructor(L,J){this.resultId=J,this.edits=L}}e.SemanticTokensEdits=Kt;var fn;(function(O){O[O.Separate=0]="Separate",O[O.MergeWithParent=1]="MergeWithParent"})(fn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var mn;(function(O){O[O.Initial=1]="Initial",O[O.Dynamic=2]="Dynamic"})(mn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let St=class{constructor(){}};St.Back={iconPath:new ut("arrow-left")},St=je([D],St),e.QuickInputButtons=St;var gn;(function(O){O[O.UI=1]="UI",O[O.Workspace=2]="Workspace"})(gn=e.ExtensionKind||(e.ExtensionKind={}));class pn{constructor(L,J,ye){this.badge=L,this.tooltip=J,this.color=ye}static validate(L){if(L.badge&&L.badge.length!==1&&L.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=pn;let Gt=class{constructor(L){this.kind=L}};Gt=je([D],Gt),e.ColorTheme=Gt;var vn;(function(O){O[O.Light=1]="Light",O[O.Dark=2]="Dark",O[O.HighContrast=3]="HighContrast"})(vn=e.ColorThemeKind||(e.ColorThemeKind={}));class Ot{constructor(L,J){if(L<0)throw(0,I.illegalArgument)("start must be positive");if(J<L)throw(0,I.illegalArgument)("end cannot be smaller than start");this._start=L,this._end=J}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(L){let J=this._start,ye=this._end;return L.start!==void 0&&(J=L.start),L.end!==void 0&&(ye=L.end),J===this._start&&ye===this._end?this:new Ot(J,ye)}}e.NotebookCellRange=Ot;class Wt{constructor(L,J,ye,Be,Je,lt){this.editable=L,this.breakpointMargin=J,this.statusMessage=ye,this.inputCollapsed=Be,this.outputCollapsed=Je,this.custom=lt}with(L){let{editable:J,breakpointMargin:ye,statusMessage:Be,inputCollapsed:Je,outputCollapsed:lt,custom:ht}=L;return J===void 0?J=this.editable:J===null&&(J=void 0),ye===void 0?ye=this.breakpointMargin:ye===null&&(ye=void 0),Be===void 0?Be=this.statusMessage:Be===null&&(Be=void 0),Je===void 0?Je=this.inputCollapsed:Je===null&&(Je=void 0),lt===void 0?lt=this.outputCollapsed:lt===null&&(lt=void 0),ht===void 0?ht=this.custom:ht===null&&(ht=void 0),J===this.editable&&ye===this.breakpointMargin&&Be===this.statusMessage&&Je===this.inputCollapsed&&lt===this.outputCollapsed&&ht===this.custom?this:new Wt(J,ye,Be,Je,lt,ht)}}e.NotebookCellMetadata=Wt;class Nt{constructor(L=!0,J=!0,ye={},Be=!0){this.editable=L,this.cellEditable=J,this.custom=ye,this.trusted=Be}with(L){let{editable:J,cellEditable:ye,custom:Be,trusted:Je}=L;return J===void 0?J=this.editable:J===null&&(J=void 0),ye===void 0?ye=this.cellEditable:ye===null&&(ye=void 0),Be===void 0?Be=this.custom:Be===null&&(Be=void 0),Je===void 0?Je=this.trusted:Je===null&&(Je=void 0),J===this.editable&&ye===this.cellEditable&&Be===this.custom&&Je===this.trusted?this:new Nt(J,ye,Be,Je)}}e.NotebookDocumentMetadata=Nt;class Qt{constructor(L,J,ye,Be,Je,lt){this.kind=L,this.source=J,this.language=ye,this.outputs=Be!=null?Be:[],this.metadata=Je,this.latestExecutionSummary=lt}}e.NotebookCellData=Qt;class Re{constructor(L,J){this.cells=L,this.metadata=J!=null?J:new Nt}}e.NotebookData=Re;class Ut{constructor(L,J,ye){this.mime=L,this.value=J,this.metadata=ye}static isNotebookCellOutputItem(L){return L instanceof Ut}}e.NotebookCellOutputItem=Ut;class Jt{constructor(L,J,ye){this.outputs=L,typeof J=="string"?(this.id=J,this.metadata=ye):(this.id=(0,y.generateUuid)(),this.metadata=J!=null?J:ye)}}e.NotebookCellOutput=Jt;var mt;(function(O){O[O.Markdown=1]="Markdown",O[O.Code=2]="Code"})(mt=e.NotebookCellKind||(e.NotebookCellKind={}));var _n;(function(O){O[O.Idle=1]="Idle",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(_n=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var bn;(function(O){O[O.Left=1]="Left",O[O.Right=2]="Right"})(bn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var rn;(function(O){O[O.Default=0]="Default",O[O.InCenter=1]="InCenter",O[O.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",O[O.AtTop=3]="AtTop"})(rn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));let Bt=class{constructor(L,J){this.label=L,this.timestamp=J}};Bt=je([D],Bt),e.TimelineItem=Bt;var wn;(function(O){O[O.Production=1]="Production",O[O.Development=2]="Development",O[O.Test=3]="Test"})(wn=e.ExtensionMode||(e.ExtensionMode={}));var En;(function(O){O[O.Node=1]="Node",O[O.Webworker=2]="Webworker"})(En=e.ExtensionRuntime||(e.ExtensionRuntime={}));var yn;(function(O){O[O.Other=0]="Other",O[O.Comment=1]="Comment",O[O.String=2]="String",O[O.RegEx=4]="RegEx"})(yn=e.StandardTokenType||(e.StandardTokenType={}));class Sn{constructor(L,J){this.ranges=L,this.wordPattern=J}}e.LinkedEditingRanges=Sn;var sn;(function(O){O[O.Unset=0]="Unset",O[O.Queued=1]="Queued",O[O.Running=2]="Running",O[O.Passed=3]="Passed",O[O.Failed=4]="Failed",O[O.Skipped=5]="Skipped",O[O.Errored=6]="Errored"})(sn=e.TestResultState||(e.TestResultState={}));var on;(function(O){O[O.Error=0]="Error",O[O.Warning=1]="Warning",O[O.Information=2]="Information",O[O.Hint=3]="Hint"})(on=e.TestMessageSeverity||(e.TestMessageSeverity={})),e.TestItemHookProperty=Symbol("TestItemHookProperty");const Ht=(O,L,J)=>{let ye=J;return{enumerable:!0,configurable:!1,get(){return ye},set(Be){var Je;(Je=O[e.TestItemHookProperty])===null||Je===void 0||Je.setProp(L,Be),ye=Be}}};class an{constructor(L){m.set(this,new Map),i.set(this,void 0),tt(this,i,L,"f")}get size(){return xe(this,m,"f").size}add(L){const J=xe(this,m,"f"),ye=xe(this,i,"f").call(this),Be=J.get(L.id);Be!==L&&(Be&&(ye==null||ye.delete(L.id)),J.set(L.id,L),ye==null||ye.created(L))}get(L){return xe(this,m,"f").get(L)}clear(){for(const L of xe(this,m,"f").keys())this.delete(L)}delete(L){var J;const ye=typeof L=="string"?L:L.id;xe(this,m,"f").has(ye)&&(xe(this,m,"f").delete(ye),(J=xe(this,i,"f").call(this))===null||J===void 0||J.delete(ye))}toJSON(){return[...xe(this,m,"f").values()]}[(m=new WeakMap,i=new WeakMap,Symbol.iterator)](){return xe(this,m,"f").values()}}e.TestChildrenCollection=an;class Dn{constructor(L,J,ye,Be){this.label=J,this.expandable=Be,Object.defineProperties(this,{id:{value:L,enumerable:!0,writable:!1},uri:{value:ye,enumerable:!0,writable:!1},children:{value:new an(()=>this[e.TestItemHookProperty]),enumerable:!0,writable:!1},[e.TestItemHookProperty]:{enumerable:!1,writable:!0,configurable:!1},range:Ht(this,"range",void 0),description:Ht(this,"description",void 0),runnable:Ht(this,"runnable",!0),debuggable:Ht(this,"debuggable",!0)})}invalidate(){var L;(L=this[e.TestItemHookProperty])===null||L===void 0||L.invalidate(this.id)}discoverChildren(L,J){L.report({busy:!1})}}e.TestItem=Dn;class Yt{constructor(L){this.message=L,this.severity=on.Error}static diff(L,J,ye){const Be=new Yt(L);return Be.expectedOutput=J,Be.actualOutput=ye,Be}}e.TestMessage=Yt;var X;(function(O){O[O.None=0]="None",O[O.Option=1]="Option",O[O.Default=2]="Default",O[O.Preferred=3]="Preferred"})(X=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var ce;(function(O){O[O.Untrusted=0]="Untrusted",O[O.Trusted=1]="Trusted",O[O.Unspecified=2]="Unspecified"})(ce=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var ke;(function(O){O[O.Notify=1]="Notify",O[O.OpenBrowser=2]="OpenBrowser",O[O.OpenPreview=3]="OpenPreview",O[O.Silent=4]="Silent",O[O.Ignore=5]="Ignore"})(ke=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(_e[94],we([0,1,42,18,8,118,83,7,11]),function(ie,e,E,I,P,A,S,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const n=new Map;function T(i,s){s?n.set(i,s):n.delete(i)}e.setWordDefinitionFor=T;function k(i){return n.get(i)}e.getWordDefinitionFor=k;class g extends A.MirrorTextModel{constructor(s,_,d,b,v,l,u,t){super(_,d,b,v);this._proxy=s,this._languageId=l,this._isDirty=u,this._notebook=t,this._isDisposed=!1}dispose(){(0,E.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(s){return(0,y.equals)(this._lines,s)}get document(){if(!this._document){const s=this;this._document={get uri(){return s._uri},get fileName(){return s._uri.fsPath},get isUntitled(){return s._uri.scheme===I.Schemas.untitled},get languageId(){return s._languageId},get version(){return s._versionId},get isClosed(){return s._isDisposed},get isDirty(){return s._isDirty},get notebook(){return s._notebook},save(){return s._save()},getText(_){return _?s._getTextInRange(_):s.getText()},get eol(){return s._eol===`
`?C.EndOfLine.LF:C.EndOfLine.CRLF},get lineCount(){return s._lines.length},lineAt(_){return s._lineAt(_)},offsetAt(_){return s._offsetAt(_)},positionAt(_){return s._positionAt(_)},validateRange(_){return s._validateRange(_)},validatePosition(_){return s._validatePosition(_)},getWordRangeAtPosition(_,d){return s._getWordRangeAtPosition(_,d)}}}return Object.freeze(this._document)}_acceptLanguageId(s){(0,E.ok)(!this._isDisposed),this._languageId=s}_acceptIsDirty(s){(0,E.ok)(!this._isDisposed),this._isDirty=s}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(s){const _=this._validateRange(s);if(_.isEmpty)return"";if(_.isSingleLine)return this._lines[_.start.line].substring(_.start.character,_.end.character);const d=this._eol,b=_.start.line,v=_.end.line,l=[];l.push(this._lines[b].substring(_.start.character));for(let u=b+1;u<v;u++)l.push(this._lines[u]);return l.push(this._lines[v].substring(0,_.end.character)),l.join(d)}_lineAt(s){let _;if(s instanceof C.Position?_=s.line:typeof s=="number"&&(_=s),typeof _!="number"||_<0||_>=this._lines.length||Math.floor(_)!==_)throw new Error("Illegal value for `line`");return new m(_,this._lines[_],_===this._lines.length-1)}_offsetAt(s){return s=this._validatePosition(s),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(s.line-1)+s.character}_positionAt(s){s=Math.floor(s),s=Math.max(0,s),this._ensureLineStarts();const _=this._lineStarts.getIndexOf(s),d=this._lines[_.index].length;return new C.Position(_.index,Math.min(_.remainder,d))}_validateRange(s){if(!(s instanceof C.Range))throw new Error("Invalid argument");const _=this._validatePosition(s.start),d=this._validatePosition(s.end);return _===s.start&&d===s.end?s:new C.Range(_.line,_.character,d.line,d.character)}_validatePosition(s){if(!(s instanceof C.Position))throw new Error("Invalid argument");if(this._lines.length===0)return s.with(0,0);let{line:_,character:d}=s,b=!1;if(_<0)_=0,d=0,b=!0;else if(_>=this._lines.length)_=this._lines.length-1,d=this._lines[_].length,b=!0;else{const v=this._lines[_].length;d<0?(d=0,b=!0):d>v&&(d=v,b=!0)}return b?new C.Position(_,d):s}_getWordRangeAtPosition(s,_){const d=this._validatePosition(s);if(!_)_=k(this._languageId);else if((0,P.regExpLeadsToEndlessLoop)(_))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${_.source}' because it matches the empty string.`);const b=(0,S.getWordAtText)(d.character+1,(0,S.ensureValidWordDefinition)(_),this._lines[d.line],0);if(b)return new C.Range(d.line,b.startColumn-1,d.line,b.endColumn-1)}}e.ExtHostDocumentData=g;class m{constructor(s,_,d){this._line=s,this._text=_,this._isLastLine=d}get lineNumber(){return this._line}get text(){return this._text}get range(){return new C.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new C.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=m}),define(_e[162],we([0,1,7,3,85,6,59,22,2,29]),function(ie,e,E,I,P,A,S,C,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class T{constructor(g,m,i,s){this._notebook=i,this._selector=s,this._disposables=new A.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this.uri=y.URI.from({scheme:"vscode-concat-doc",path:(0,n.generateUuid)()}),this._init(),this._disposables.add(m.onDidChangeDocument(d=>{const b=this._cellUris.get(d.document.uri);b!==void 0&&(this._cellLengths.changeValue(b,this._cells[b].document.getText().length+1),this._cellLines.changeValue(b,this._cells[b].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const _=d=>{d===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(g.onDidChangeNotebookCells(d=>_(d.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new C.ResourceMap;const g=[],m=[];for(const i of this._notebook.getCells())i.kind===E.NotebookCellKind.Code&&(!this._selector||(0,S.score)(this._selector,i.document.uri,i.document.languageId,!0))&&(this._cellUris.set(i.document.uri,this._cells.length),this._cells.push(i),g.push(i.document.getText().length+1),m.push(i.document.lineCount));this._cellLengths=new P.PrefixSumComputer(new Uint32Array(g)),this._cellLines=new P.PrefixSumComputer(new Uint32Array(m))}get version(){return this._versionId}getText(g){var m,i;if(!g){let v="";for(const l of this._cells)v+=l.document.getText()+`
`;return v=v.slice(0,-1),v}if(g.isEmpty)return"";const s=this.locationAt(g.start),_=this.locationAt(g.end),d=this._cells[(m=this._cellUris.get(s.uri))!==null&&m!==void 0?m:-1],b=this._cells[(i=this._cellUris.get(_.uri))!==null&&i!==void 0?i:-1];if(!d||!b)return"";if(d===b)return d.document.getText(new E.Range(s.range.start,_.range.end));{const v=d.document.getText(new E.Range(s.range.start,new E.Position(d.document.lineCount,0))),l=b.document.getText(new E.Range(new E.Position(0,0),_.range.end));return v+`
`+l}}offsetAt(g){const m=this._cellLines.getIndexOf(g.line),i=this._cellLengths.getAccumulatedValue(m.index-1),s=this._cells[m.index].document.offsetAt(g.with(m.remainder));return i+s}positionAt(g){if(typeof g=="number"){const i=this._cellLengths.getIndexOf(g),s=this._cellLines.getAccumulatedValue(i.index-1);return this._cells[i.index].document.positionAt(i.remainder).translate(s)}const m=this._cellUris.get(g.uri);if(m!==void 0){const i=this._cellLines.getAccumulatedValue(m-1);return new E.Position(i+g.range.start.line,g.range.start.character)}return new E.Position(0,0)}locationAt(g){E.Range.isRange(g)||(g=new E.Range(g,g));const m=this._cellLines.getIndexOf(g.start.line);let i=m;g.isEmpty||(i=this._cellLines.getIndexOf(g.end.line));const s=new E.Position(m.remainder,g.start.character),_=new E.Position(i.remainder,g.end.character),d=new E.Range(s,_),b=this._cells[m.index];return new E.Location(b.document.uri,b.document.validateRange(d))}contains(g){return this._cellUris.has(g)}validateRange(g){const m=this.validatePosition(g.start),i=this.validatePosition(g.end);return g.with(m,i)}validatePosition(g){const m=this._cellLines.getIndexOf(g.line),i=new E.Position(m.remainder,g.character),s=this._cells[m.index].document.validatePosition(i),_=this._cellLines.getAccumulatedValue(m.index-1);return new E.Position(_+s.line,s.character)}}e.ExtHostNotebookConcatDocument=T}),define(_e[163],we([0,1,7,15,3]),function(ie,e,E,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let A=class{constructor(C){this._actual=new E.ColorTheme(E.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new P.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(C){let y=C==="light"?E.ColorThemeKind.Light:C==="dark"?E.ColorThemeKind.Dark:E.ColorThemeKind.HighContrast;this._actual=new E.ColorTheme(y),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};A=je([Ke(0,I.IExtHostRpcService)],A),e.ExtHostTheming=A}),define(_e[68],we([0,1,4]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,E.createDecorator)("IURITransformerService");class I{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=S=>S,this.transformOutgoing=S=>S,this.transformOutgoingURI=S=>S,this.transformOutgoingScheme=S=>S)}}e.URITransformerService=I}),define(_e[164],we([0,1,23]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class I{constructor(){this.buffers=[]}add(y){let n=this.buffers.indexOf(y);return n<0&&(n=this.buffers.length,this.buffers.push(y)),n}}function P(C,y){if(y){const n=new I,T=(m,i)=>{if(i instanceof ArrayBuffer){const s=n.add(i);return{$$vscode_array_buffer_reference$$:!0,index:s}}else if(ArrayBuffer.isView(i)){const s=A(i);if(s){const _=n.add(i.buffer);return{$$vscode_array_buffer_reference$$:!0,index:_,view:{type:s,byteLength:i.byteLength,byteOffset:i.byteOffset}}}}return i},k=JSON.stringify(C,T),g=n.buffers.map(m=>{const i=new Uint8Array(m);return E.VSBuffer.wrap(i)});return{message:k,buffers:g}}else return{message:JSON.stringify(C),buffers:[]}}e.serializeWebviewMessage=P;function A(C){switch(C.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function S(C,y){const n=y.map(g=>{const m=new ArrayBuffer(g.byteLength);return new Uint8Array(m).set(g.buffer),m}),T=y.length?(g,m)=>{if(typeof m=="object"&&m.$$vscode_array_buffer_reference$$){const i=m,{index:s}=i,_=n[s];if(i.view)switch(i.view.type){case 1:return new Int8Array(_,i.view.byteOffset,i.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(_,i.view.byteOffset,i.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(_,i.view.byteOffset,i.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(_,i.view.byteOffset,i.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(_,i.view.byteOffset,i.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(_,i.view.byteOffset,i.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(_,i.view.byteOffset,i.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(_,i.view.byteOffset,i.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(_,i.view.byteOffset,i.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(_,i.view.byteOffset,i.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(_,i.view.byteOffset,i.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return _}return m}:void 0;return{message:JSON.parse(C,T),arrayBuffers:n}}e.deserializeWebviewMessage=S}),define(_e[69],we([0,1,2]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=void 0;function I(A,S,C){const y=A.webviewResourceRoot.replace("{{resource}}",C.scheme+P(C)).replace("{{uuid}}",S);return E.URI.parse(y)}e.asWebviewUri=I;function P(A){return A.toString().replace(/^\S+?:/,"")}}),define(_e[165],we([0,1,3,6,69,29]),function(ie,e,E,I,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class S{constructor(y,n,T){this._proxy=y,this._editors=n,this._initData=T,this._handlePool=0,this._disposables=new I.DisposableStore,this._insets=new Map,this._disposables.add(n.onDidChangeVisibleTextEditors(()=>{const k=n.getVisibleTextEditors();for(const g of this._insets.values())k.indexOf(g.editor)<0&&g.inset.dispose()}))}dispose(){this._insets.forEach(y=>y.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(y,n,T,k,g){let m;for(const l of this._editors.getVisibleTextEditors(!0))if(l.value===y){m=l;break}if(!m)throw new Error("not a visible editor");const i=this,s=this._handlePool++,_=new E.Emitter,d=new E.Emitter,b=new class{constructor(){this._uuid=(0,A.generateUuid)(),this._html="",this._options=Object.create(null)}asWebviewUri(l){return(0,P.asWebviewUri)(i._initData,this._uuid,l)}get cspSource(){return i._initData.webviewCspSource}set options(l){this._options=l,i._proxy.$setOptions(s,l)}get options(){return this._options}set html(l){this._html=l,i._proxy.$setHtml(s,l)}get html(){return this._html}get onDidReceiveMessage(){return _.event}postMessage(l){return i._proxy.$postMessage(s,l)}},v=new class{constructor(){this.editor=y,this.line=n,this.height=T,this.webview=b,this.onDidDispose=d.event}dispose(){i._insets.has(s)&&(i._insets.delete(s),i._proxy.$disposeEditorInset(s),d.fire(),d.dispose(),_.dispose())}};return this._proxy.$createEditorInset(s,m.id,m.value.document.uri,n+1,T,k||{},g.identifier,g.extensionLocation),this._insets.set(s,{editor:y,inset:v,onDidReceiveMessage:_}),v}$onDidDispose(y){const n=this._insets.get(y);n&&n.inset.dispose()}$onDidReceiveMessage(y,n){const T=this._insets.get(y);T&&T.onDidReceiveMessage.fire(n)}}e.ExtHostEditorInsets=S}),define(_e[166],we([0,1,3,63,137,4,6,22,30,11,50,24,36,157]),function(ie,e,E,I,P,A,S,C,y,n,T,k,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,m.registerIcon)("default-view-icon",g.Codicon.window,(0,P.localize)(0,null));var i;(function(a){a.ViewContainersRegistry="workbench.registry.view.containers",a.ViewsRegistry="workbench.registry.view"})(i=e.Extensions||(e.Extensions={}));var s;(function(a){a[a.Sidebar=0]="Sidebar",a[a.Panel=1]="Panel"})(s=e.ViewContainerLocation||(e.ViewContainerLocation={}));function _(a){switch(a){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=_;function d(a){return`viewContainer.${a}.enabled`}e.getEnabledViewContainerContextKey=d;class b extends S.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new E.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new E.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,n.flatten)([...this.viewContainers.values()])}registerViewContainer(f,w,D){var p;const h=this.get(f.id);if(h)return h;const R=f;return R.openCommandActionDescriptor=(D==null?void 0:D.donotRegisterOpenCommand)?void 0:(p=R.openCommandActionDescriptor)!==null&&p!==void 0?p:{id:R.id},(0,C.getOrSet)(this.viewContainers,w,[]).push(R),(D==null?void 0:D.isDefault)&&this.defaultViewContainers.push(R),this._onDidRegister.fire({viewContainer:R,viewContainerLocation:w}),R}deregisterViewContainer(f){for(const w of this.viewContainers.keys()){const D=this.viewContainers.get(w),p=D==null?void 0:D.indexOf(f);if(p!==-1){D==null||D.splice(p,1),D.length===0&&this.viewContainers.delete(w),this._onDidDeregister.fire({viewContainer:f,viewContainerLocation:w});return}}}get(f){return this.all.filter(w=>w.id===f)[0]}getViewContainers(f){return[...this.viewContainers.get(f)||[]]}getViewContainerLocation(f){return[...this.viewContainers.keys()].filter(w=>this.getViewContainers(w).filter(D=>(D==null?void 0:D.id)===f.id).length>0)[0]}getDefaultViewContainer(f){return this.defaultViewContainers.find(w=>this.getViewContainerLocation(w)===f)}}y.Registry.add(i.ViewContainersRegistry,new b);var v;(function(a){a.Open="2_open",a.Debug="4_debug",a.SCM="5_scm",a.More="9_more"})(v=e.ViewContentGroups||(e.ViewContentGroups={}));function l(a,f){var w,D,p,h;const R=(w=a.group)!==null&&w!==void 0?w:v.More,F=(D=f.group)!==null&&D!==void 0?D:v.More;return R!==F?R.localeCompare(F):((p=a.order)!==null&&p!==void 0?p:5)-((h=f.order)!==null&&h!==void 0?h:5)}class u extends S.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new E.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new E.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new E.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new E.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new T.SetMap}registerViews(f,w){this.registerViews2([{views:f,viewContainer:w}])}registerViews2(f){f.forEach(({views:w,viewContainer:D})=>this.addViews(w,D)),this._onViewsRegistered.fire(f)}deregisterViews(f,w){const D=this.removeViews(f,w);D.length&&this._onViewsDeregistered.fire({views:D,viewContainer:w})}moveViews(f,w){for(const D of this._views.keys())if(D!==w){const p=this.removeViews(f,D);p.length&&(this.addViews(p,w),this._onDidChangeContainer.fire({views:p,from:D,to:w}))}}getViews(f){return this._views.get(f)||[]}getView(f){for(const w of this._viewContainers){const D=(this._views.get(w)||[]).filter(p=>p.id===f)[0];if(D)return D}return null}getViewContainer(f){for(const w of this._viewContainers)if((this._views.get(w)||[]).filter(p=>p.id===f)[0])return w;return null}registerViewWelcomeContent(f,w){return this._viewWelcomeContents.add(f,w),this._onDidChangeViewWelcomeContent.fire(f),(0,S.toDisposable)(()=>{this._viewWelcomeContents.delete(f,w),this._onDidChangeViewWelcomeContent.fire(f)})}registerViewWelcomeContent2(f,w){const D=new Map;for(const[p,h]of w)this._viewWelcomeContents.add(f,h),D.set(p,(0,S.toDisposable)(()=>{this._viewWelcomeContents.delete(f,h),this._onDidChangeViewWelcomeContent.fire(f)}));return this._onDidChangeViewWelcomeContent.fire(f),D}getViewWelcomeContent(f){const w=[];return this._viewWelcomeContents.forEach(f,D=>w.push(D)),w.sort(l)}addViews(f,w){let D=this._views.get(w);D||(D=[],this._views.set(w,D),this._viewContainers.push(w));for(const p of f){if(this.getView(p.id)!==null)throw new Error((0,P.localize)(1,null,p.id));D.push(p)}}removeViews(f,w){const D=this._views.get(w);if(!D)return[];const p=[],h=[];for(const R of D)f.includes(R)?p.push(R):h.push(R);return p.length&&(h.length?this._views.set(w,h):(this._views.delete(w),this._viewContainers.splice(this._viewContainers.indexOf(w),1))),p}}y.Registry.add(i.ViewsRegistry,new u),e.IViewsService=(0,A.createDecorator)("viewsService"),e.FocusedViewContext=new I.RawContextKey("focusedView","",(0,P.localize)(2,null));function t(a){return`view.${a}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,A.createDecorator)("viewDescriptorService");var r;(function(a){a[a.Default=0]="Default",a[a.Expand=1]="Expand"})(r=e.ViewVisibilityState||(e.ViewVisibilityState={}));var c;(function(a){a[a.None=0]="None",a[a.Collapsed=1]="Collapsed",a[a.Expanded=2]="Expanded"})(c=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class o{constructor(f,w){this.resolved=!1,this._hasResolve=!1,(0,k.mixin)(this,f),this._hasResolve=!!w,this.resolve=async D=>{var p,h;if(w&&!this.resolved){const R=await w(D);R&&(this.tooltip=(p=this.tooltip)!==null&&p!==void 0?p:R.tooltip,this.command=(h=this.command)!==null&&h!==void 0?h:R.command)}D.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=o}),define(_e[167],we([0,1,2,147,158,19,148,166]),function(ie,e,E,I,P,A,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MoveViewsAPICommand=e.OpenIssueReporter=e.RemoveFromRecentlyOpenedAPICommand=e.NewWindowAPICommand=void 0;function y(s){return(_,...d)=>s(_.get(I.ICommandService),...d)}class n{static execute(_,d){const b={forceReuseWindow:d&&d.reuseWindow,remoteAuthority:d&&d.remoteAuthority};return _.executeCommand("_files.newWindow",b)}}e.NewWindowAPICommand=n,n.ID="vscode.newWindow",I.CommandsRegistry.registerCommand({id:n.ID,handler:y(n.execute),description:{description:"Opens an new window",args:[]}}),I.CommandsRegistry.registerCommand("_workbench.removeFromRecentlyOpened",function(s,_){return s.get(P.IWorkspacesService).removeRecentlyOpened([_])});class T{static execute(_,d){return typeof d=="string"?d=d.match(/^[^:/?#]+:\/\//)?E.URI.parse(d):E.URI.file(d):d=E.URI.revive(d),_.executeCommand("_workbench.removeFromRecentlyOpened",d)}}e.RemoveFromRecentlyOpenedAPICommand=T,T.ID="vscode.removeFromRecentlyOpened",I.CommandsRegistry.registerCommand(T.ID,y(T.execute));class k{static execute(_,d){const b=typeof d=="string"?{extensionId:d}:d;return _.executeCommand("workbench.action.openIssueReporter",b)}}e.OpenIssueReporter=k,k.ID="vscode.openIssueReporter",I.CommandsRegistry.registerCommand("_workbench.addToRecentlyOpened",async function(s,_){const d=s.get(P.IWorkspacesService);let b;const v=_.uri,l=_.label,u=_.remoteAuthority;return _.type==="workspace"?b={workspace:await d.getWorkspaceIdentifier(v),label:l,remoteAuthority:u}:_.type==="folder"?b={folderUri:v,label:l,remoteAuthority:u}:b={fileUri:v,label:l,remoteAuthority:u},d.addRecentlyOpened([b])}),I.CommandsRegistry.registerCommand("_workbench.getRecentlyOpened",async function(s){return s.get(P.IWorkspacesService).getRecentlyOpened()}),I.CommandsRegistry.registerCommand("_extensionTests.setLogLevel",function(s,_){const d=s.get(A.ILogService),b=s.get(S.IEnvironmentService);b.isExtensionDevelopment&&!!b.extensionTestsLocationURI&&d.setLevel(_)}),I.CommandsRegistry.registerCommand("_extensionTests.getLogLevel",function(s){return s.get(A.ILogService).getLevel()}),I.CommandsRegistry.registerCommand("_workbench.action.moveViews",async function(s,_){const d=s.get(C.IViewDescriptorService),b=d.getViewContainerById(_.destinationId);if(!!b){for(const v of _.viewIds){const l=d.getViewDescriptorById(v);(l==null?void 0:l.canMoveView)&&d.moveViewsToContainer([l],b,C.ViewVisibilityState.Default)}await s.get(C.IViewsService).openViewContainer(b.id,!0)}});class g{static execute(_,d){return!Array.isArray(d==null?void 0:d.viewIds)||typeof(d==null?void 0:d.destinationId)!="string"?Promise.reject("Invalid arguments"):_.executeCommand("_workbench.action.moveViews",d)}}e.MoveViewsAPICommand=g,g.ID="vscode.moveViews",I.CommandsRegistry.registerCommand({id:g.ID,handler:y(g.execute),description:{description:"Move Views",args:[]}});class m{static execute(_,d){return _.executeCommand("_workbench.open",d)}}m.ID="vscode.open",I.CommandsRegistry.registerCommand(m.ID,y(m.execute));class i{static execute(_,d,b,v,l){return _.executeCommand("_workbench.diff",[d,b,v])}}i.ID="vscode.diff",I.CommandsRegistry.registerCommand(i.ID,y(i.execute))}),define(_e[168],we([0,1,3,14,138]),function(ie,e,E,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class A{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new E.Emitter,this._onExit=new E.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(C){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=C}onEvent(C){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=C}onRequest(C){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=C}sendResponse(C){C.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${C.command}`)):this.internalSend("response",C)}sendRequest(C,y,n,T){const k={command:C};if(y&&Object.keys(y).length>0&&(k.arguments=y),this.internalSend("request",k),typeof T=="number"){const g=setTimeout(()=>{clearTimeout(g);const m=this.pendingRequests.get(k.seq);if(m){this.pendingRequests.delete(k.seq);const i={type:"response",seq:0,request_seq:k.seq,success:!1,command:C,message:(0,P.localize)(0,null,T,C)};m(i)}},T)}return n&&this.pendingRequests.set(k.seq,n),k.seq}acceptMessage(C){this.messageCallback?this.messageCallback(C):(this.queue.push(C),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(C,y){return C.type!=="event"||y.type!=="event"}async processQueue(){let C;for(;this.queue.length;){if((!C||this.needsTaskBoundaryBetween(this.queue[0],C))&&await(0,I.timeout)(0),C=this.queue.shift(),!C)return;switch(C.type){case"event":this.eventCallback&&this.eventCallback(C);break;case"request":this.requestCallback&&this.requestCallback(C);break;case"response":const y=C,n=this.pendingRequests.get(y.request_seq);n&&(this.pendingRequests.delete(y.request_seq),n(y));break}}}internalSend(C,y){y.type=C,y.seq=this.sequence++,this.sendMessage(y)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const C=new Map;this.pendingRequests.forEach((y,n)=>C.set(n,y)),await(0,I.timeout)(500),C.forEach((y,n)=>{y({type:"response",seq:0,request_seq:n,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(n)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=A}),define(_e[169],we([0,1,8,2,12,24,18]),function(ie,e,E,I,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const C=/{([^}]+)}/g;function y(r,c,o){return r.replace(C,function(a,f){return c&&f.length>0&&f[0]!=="_"?a:o&&o.hasOwnProperty(f)?o[f]:a})}e.formatPII=y;function n(r){const c={};for(const o of Object.keys(r))o.startsWith("!")||(c[o]=r[o]);return c}e.filterExceptionsFromTelemetry=n;function T(r){return r.configuration.request==="attach"&&!k(r)}e.isSessionAttach=T;function k(r){let c=r.configuration.type;if(!!c)return c==="vslsShare"&&(c=r.configuration.adapterProxy.configuration.type),(0,E.equalsIgnoreCase)(c,"extensionhost")||(0,E.equalsIgnoreCase)(c,"pwa-extensionhost")?r:r.parentSession?k(r.parentSession):void 0}e.getExtensionHostDebugSession=k;function g(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=g;function m(r,c,o){let a,f=0,w=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,D=null;for(;D=w.exec(r);){let p=D.index+1,h=p+D[0].length;if(p<=c&&h>=o){a=D[0],f=p;break}}if(a){let p=/\w+/g,h=null;for(;(h=p.exec(a))&&!(h.index+1+f+h[0].length>=o););h&&(a=a.substring(0,p.lastIndex))}return a?{start:f,end:f+a.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=m;const i=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function s(r){return!!(r&&r.match(i))}e.isUri=s;function _(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(s(r.path))return I.URI.parse(r.path);if((0,P.isAbsolute)(r.path))return I.URI.file(r.path)}return r.path}function d(r){if(typeof r.path=="object"){const c=I.URI.revive(r.path);if(c)return c.scheme===S.Schemas.file?c.fsPath:c.toString()}return r.path}function b(r,c){const o=c?_:d,a=(0,A.deepClone)(r);return l(a,(f,w)=>{f&&w&&(w.path=o(w))}),a}e.convertToDAPaths=b;function v(r,c){const o=c?_:d,a=(0,A.deepClone)(r);return l(a,(f,w)=>{!f&&w&&(w.path=o(w))}),a}e.convertToVSCPaths=v;function l(r,c){switch(r.type){case"event":const o=r;switch(o.event){case"output":c(!1,o.body.source);break;case"loadedSource":c(!1,o.body.source);break;case"breakpoint":c(!1,o.body.breakpoint.source);break;default:break}break;case"request":const a=r;switch(a.command){case"setBreakpoints":c(!0,a.arguments.source);break;case"breakpointLocations":c(!0,a.arguments.source);break;case"source":c(!0,a.arguments.source);break;case"gotoTargets":c(!0,a.arguments.source);break;case"launchVSCode":a.arguments.args.forEach(w=>c(!1,w));break;default:break}break;case"response":const f=r;if(f.success&&f.body)switch(f.command){case"stackTrace":f.body.stackFrames.forEach(w=>c(!1,w.source));break;case"loadedSources":f.body.sources.forEach(w=>c(!1,w));break;case"scopes":f.body.scopes.forEach(w=>c(!1,w.source));break;case"setFunctionBreakpoints":f.body.breakpoints.forEach(w=>c(!1,w.source));break;case"setBreakpoints":f.body.breakpoints.forEach(w=>c(!1,w.source));break;default:break}break}}function u(r){return r.filter(c=>{var o;return!((o=c.presentation)===null||o===void 0?void 0:o.hidden)}).sort((c,o)=>c.presentation?o.presentation?c.presentation.group?o.presentation.group?c.presentation.group!==o.presentation.group?c.presentation.group.localeCompare(o.presentation.group):t(c.presentation.order,o.presentation.order):-1:o.presentation.group?1:t(c.presentation.order,o.presentation.order):-1:o.presentation?1:0)}e.getVisibleAndSorted=u;function t(r,c){return typeof r!="number"?typeof c!="number"?0:1:typeof c!="number"?-1:r-c}}),define(_e[70],we([0,1,28,18,12,21,63]),function(ie,e,E,I,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cellRangeContains=e.reduceRanges=e.cellRangesToIndexes=e.cellIndexesToRanges=e.CellStatusbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBarKey=e.CellToolbarLocKey=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.NotebookRendererMatch=e.AnyRendererApi=e.NotebookCellExecutionState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var C;(function(F){F[F.Markdown=1]="Markdown",F[F.Code=2]="Code"})(C=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var y;(function(F){F[F.Running=1]="Running",F[F.Idle=2]="Idle"})(y=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={editable:!0,cellEditable:!0,custom:{},trusted:!0};var n;(function(F){F[F.Idle=1]="Idle",F[F.Pending=2]="Pending",F[F.Executing=3]="Executing"})(n=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={})),e.AnyRendererApi=Symbol("AnyRendererApi");var T;(function(F){F[F.WithHardKernelDependency=0]="WithHardKernelDependency",F[F.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",F[F.Pure=2]="Pure",F[F.Never=3]="Never"})(T=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var k;(function(F){F[F.ModelChange=1]="ModelChange",F[F.Move=2]="Move",F[F.CellClearOutput=3]="CellClearOutput",F[F.CellsClearOutput=4]="CellsClearOutput",F[F.ChangeLanguage=5]="ChangeLanguage",F[F.Initialize=6]="Initialize",F[F.ChangeCellMetadata=7]="ChangeCellMetadata",F[F.Output=8]="Output",F[F.OutputItem=9]="OutputItem",F[F.ChangeCellContent=10]="ChangeCellContent",F[F.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",F[F.Unknown=12]="Unknown"})(k=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var g;(function(F){F[F.Handle=0]="Handle",F[F.Index=1]="Index"})(g=e.SelectionStateType||(e.SelectionStateType={}));var m;(function(F){F[F.Replace=1]="Replace",F[F.Output=2]="Output",F[F.Metadata=3]="Metadata",F[F.CellLanguage=4]="CellLanguage",F[F.DocumentMetadata=5]="DocumentMetadata",F[F.OutputsSplice=6]="OutputsSplice",F[F.Move=7]="Move",F[F.Unknown=8]="Unknown",F[F.CellContent=9]="CellContent",F[F.OutputItems=10]="OutputItems",F[F.PartialMetadata=11]="PartialMetadata"})(m=e.CellEditType||(e.CellEditType={}));function i(F){const $=s.parse(F);return $?$.notebook.toString():F.toString()}e.getCellUndoRedoComparisonKey=i;var s;(function(F){F.scheme=I.Schemas.vscodeNotebookCell;const $=/^ch(\d{7,})/;function se(M,N){return M.with({scheme:F.scheme,fragment:`ch${N.toString().padStart(7,"0")}${M.scheme!==I.Schemas.file?M.scheme:""}`})}F.generate=se;function z(M){if(M.scheme===F.scheme){const N=$.exec(M.fragment);if(!!N)return{handle:Number(N[1]),notebook:M.with({scheme:M.fragment.substr(N[0].length)||I.Schemas.file,fragment:null})}}}F.parse=z;function x(M,N){return M.with({scheme:I.Schemas.vscodeNotebookCellMetadata,fragment:`ch${N.toString().padStart(7,"0")}${M.scheme!==I.Schemas.file?M.scheme:""}`})}F.generateCellMetadataUri=x;function G(M){if(M.scheme===I.Schemas.vscodeNotebookCellMetadata){const N=$.exec(M.fragment);if(!!N)return{handle:Number(N[1]),notebook:M.with({scheme:M.fragment.substr(N[0].length)||I.Schemas.file,fragment:null})}}}F.parseCellMetadataUri=G})(s=e.CellUri||(e.CellUri={}));const _=new Map([["application/json",{alwaysSecure:!0,supportedByCore:!0}],["text/markdown",{alwaysSecure:!0,supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["text/plain",{alwaysSecure:!0,supportedByCore:!0}],["application/javascript",{supportedByCore:!0}],["text/html",{supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["image/jpeg",{supportedByCore:!0}],["text/x-javascript",{supportedByCore:!0}],["application/x.notebook.error-traceback",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.stream",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function d(F){var $,se;return(se=($=_.get(F))===null||$===void 0?void 0:$.alwaysSecure)!==null&&se!==void 0?se:!1}e.mimeTypeIsAlwaysSecure=d;function b(F){var $,se;return(se=($=_.get(F))===null||$===void 0?void 0:$.supportedByCore)!==null&&se!==void 0?se:!1}e.mimeTypeSupportedByCore=b;function v(F){var $,se;return(se=($=_.get(F))===null||$===void 0?void 0:$.mergeable)!==null&&se!==void 0?se:!1}e.mimeTypeIsMergeable=v;function l(F,$){return A.isWindows&&(F=F.replace(/\//g,"\\"),$=$.replace(/\//g,"\\")),E.match(F,$)}function u(F,$,se){let z=0;for(let x=0;x<$.length;x++){if(l($[x],F))return z;z++}for(let x=0;x<se.length;x++){if(l(se[x],F))return z;z++}return z}function t(F,$,se){return F.sort((z,x)=>u(z,$,se)-u(x,$,se))}e.sortMimeTypes=t;function r(F,$,se,z=(x,G)=>x===G){const x=[];function G(B,Q,W){if(!(Q===0&&W.length===0)){const ee=x[x.length-1];ee&&ee.start+ee.deleteCount===B?(ee.deleteCount+=Q,ee.toInsert.push(...W)):x.push({start:B,deleteCount:Q,toInsert:W})}}let M=0,N=0;for(;;){if(M===F.length){G(M,0,$.slice(N));break}if(N===$.length){G(M,F.length-M,[]);break}const B=F[M],Q=$[N];if(z(B,Q)){M+=1,N+=1;continue}se(Q)?(G(M,1,[]),M+=1):(G(M,0,[Q]),N+=1)}return x}e.diff=r,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new S.RawContextKey("notebookEditorCursorAtBoundary","none");var c;(function(F){F.default="default",F.option="option"})(c=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function o(F){const $=F;return!!((typeof $.include=="string"||E.isRelativePattern($.include))&&(typeof $.exclude=="string"||E.isRelativePattern($.exclude)))}e.isDocumentExcludePattern=o;function a(F,$,se){if(Array.isArray(F.viewType)&&F.viewType.indexOf($)>=0||F.viewType===$)return!0;if(F.filenamePattern){let z=o(F.filenamePattern)?F.filenamePattern.include:F.filenamePattern,x=o(F.filenamePattern)?F.filenamePattern.exclude:void 0;if(E.match(z,(0,P.basename)(se.fsPath).toLowerCase()))return!(x&&E.match(x,(0,P.basename)(se.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=a;class f{constructor($){this.textModel=$}getElements(){const $=new Int32Array(this.textModel.cells.length);for(let se=0;se<this.textModel.cells.length;se++)$[se]=this.textModel.cells[se].getHashValue();return $}}e.CellSequence=f,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocKey="notebook.cellToolbarLocation",e.ShowCellStatusBarKey="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer";var w;(function(F){F[F.LEFT=0]="LEFT",F[F.RIGHT=1]="RIGHT"})(w=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));function D(F){F.sort((se,z)=>se-z);const $=F.shift();return $===void 0?[]:F.reduce(function(se,z){return z<=se[0][1]?se[0][1]=z+1:se.unshift([z,z+1]),se},[[$,$+1]]).reverse().map(se=>({start:se[0],end:se[1]}))}e.cellIndexesToRanges=D;function p(F){return F.reduce((se,z)=>{for(let x=z.start;x<z.end;x++)se.push(x);return se},[])}e.cellRangesToIndexes=p;function h(F){const $=F.sort((z,x)=>z.start-x.start),se=$[0];return se?$.reduce((z,x)=>{const G=z[z.length-1];return G.end>=x.start?G.end=Math.max(G.end,x.end):z.push(x),z},[se]):[]}e.reduceRanges=h;function R(F,$){return $.start>=F.start&&$.end<=F.end}e.cellRangeContains=R}),define(_e[170],we([0,1,140,4,63]),function(ie,e,E,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new P.RawContextKey("customExecutionSupported",!0,E.localize(0,null)),e.ShellExecutionSupportedContext=new P.RawContextKey("shellExecutionSupported",!1,E.localize(1,null)),e.ProcessExecutionSupportedContext=new P.RawContextKey("processExecutionSupported",!1,E.localize(2,null)),e.ITaskService=(0,I.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(_e[171],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function E(P){return[...P.entries()]}e.serializeEnvironmentVariableCollection=E;function I(P){return new Map(P)}e.deserializeEnvironmentVariableCollection=I}),define(_e[95],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=e.applyTestItemUpdate=e.TestItemExpandState=void 0;var E;(function(y){y[y.NotExpandable=0]="NotExpandable",y[y.Expandable=1]="Expandable",y[y.BusyExpanding=2]="BusyExpanding",y[y.Expanded=3]="Expanded"})(E=e.TestItemExpandState||(e.TestItemExpandState={}));const I=(y,n)=>{n.expand!==void 0&&(y.expand=n.expand),n.item!==void 0&&Object.assign(y.item,n.item)};e.applyTestItemUpdate=I;var P;(function(y){y[y.Add=0]="Add",y[y.Update=1]="Update",y[y.Remove=2]="Remove",y[y.DeltaRootsComplete=3]="DeltaRootsComplete",y[y.Retire=4]="Retire"})(P=e.TestDiffOpType||(e.TestDiffOpType={}));const A=(y,n)=>`${y}:${n.toString()}`;e.getTestSubscriptionKey=A;class S{add(n){}update(n){}remove(n,T){}complete(){}}e.IncrementalChangeCollector=S;class C{constructor(){this.items=new Map,this.roots=new Set,this.busyProviderCount=0,this.pendingRootCount=0}apply(n){const T=this.createChangeCollector();for(const k of n)switch(k[0]){case 0:{const g=k[1];if(g.parent){if(this.items.has(g.parent)){const m=this.items.get(g.parent);m.children.add(g.item.extId);const i=this.createItem(g,m);this.items.set(g.item.extId,i),T.add(i)}}else{this.roots.add(g.item.extId);const m=this.createItem(g);this.items.set(g.item.extId,m),T.add(m)}g.expand===2&&this.updateBusyProviders(1);break}case 1:{const g=k[1],m=this.items.get(g.extId);if(!m)break;(0,e.applyTestItemUpdate)(m,g),T.update(m),g.expand!==void 0&&m.expand===2&&g.expand!==2&&this.updateBusyProviders(-1);break}case 2:{const g=this.items.get(k[1]);if(!g)break;g.parent?this.items.get(g.parent).children.delete(g.item.extId):this.roots.delete(g.item.extId);const m=[[k[1]]];for(;m.length;)for(const i of m.pop()){const s=this.items.get(i);s&&(m.push(s.children),this.items.delete(i),T.remove(s,s!==g),s.expand===2&&this.updateBusyProviders(-1))}break}case 4:this.retireTest(k[1]);break;case 3:this.updatePendingRoots(k[1]);break}T.complete()}retireTest(n){}updateBusyProviders(n){this.busyProviderCount+=n}updatePendingRoots(n){this.pendingRootCount+=n}createChangeCollector(){return new S}}e.AbstractIncrementalTestCollection=C}),define(_e[172],we([0,1,12,45,13,24,21,58,141]),function(ie,e,E,I,P,A,S,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class n{constructor(k,g,m,i){if(this._contributedVariables=new Map,this._context=k,this._labelService=g,m)if(S.isWindows){const s=Object.create(null);this._envVariables=s,Object.keys(m).forEach(_=>{s[_.toLowerCase()]=m[_]})}else this._envVariables=m}resolveWithEnvironment(k,g,m){return this.recursiveResolve(k,g?g.uri:void 0,m)}async resolveAsync(k,g){return this.recursiveResolve(this._envVariables,k?k.uri:void 0,g)}resolve(k,g){return this.recursiveResolve(this._envVariables,k?k.uri:void 0,g)}resolveAnyBase(k,g,m,i){const s=A.deepClone(g);return S.isWindows&&s.windows?Object.keys(s.windows).forEach(_=>s[_]=s.windows[_]):S.isMacintosh&&s.osx?Object.keys(s.osx).forEach(_=>s[_]=s.osx[_]):S.isLinux&&s.linux&&Object.keys(s.linux).forEach(_=>s[_]=s.linux[_]),delete s.windows,delete s.osx,delete s.linux,this.recursiveResolve(this._envVariables,k?k.uri:void 0,s,m,i)}resolveAny(k,g,m){return this.resolveAnyBase(k,g,m)}async resolveAnyAsync(k,g,m){return this.resolveAnyBase(k,g,m)}resolveAnyMap(k,g,m){const i=new Map;return{newConfig:this.resolveAnyBase(k,g,m,i),resolvedVariables:i}}resolveWithInteractionReplace(k,g,m,i){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(k,g,m,i){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(k,g){if(this._contributedVariables.has(k))throw new Error("Variable "+k+" is contributed twice.");this._contributedVariables.set(k,g)}recursiveResolve(k,g,m,i,s){if(P.isString(m))return this.resolveString(k,g,m,i,s);if(P.isArray(m))return m.map(_=>this.recursiveResolve(k,g,_,i,s));if(P.isObject(m)){let _=Object.create(null);return Object.keys(m).forEach(d=>{const b=this.resolveString(k,g,d,i,s);_[b]=this.recursiveResolve(k,g,m[d],i,s)}),_}return m}resolveString(k,g,m,i,s){return m.replace(n.VARIABLE_REGEXP,(d,b)=>{if(b.includes(n.VARIABLE_LHS))return d;let v=this.evaluateSingleVariable(k,d,b,g,i);return s&&s.set(b,v),v})}fsPath(k){return this._labelService?this._labelService.getUriLabel(k,{noPrefix:!0}):k.fsPath}evaluateSingleVariable(k,g,m,i,s){let _;const d=m.split(":");d.length>1&&(m=d[0],_=d[1]);const b=()=>{const u=this._context.getFilePath();if(u)return u;throw new Error((0,y.localize)(0,null,g))},v=()=>{const u=b();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,y.localize)(1,null,g,E.basename(u)))},l=()=>{if(_){const u=this._context.getFolderUri(_);if(u)return u;throw new Error((0,y.localize)(2,null,g,_))}if(i)return i;throw this._context.getWorkspaceFolderCount()>1?new Error((0,y.localize)(3,null,g)):new Error((0,y.localize)(4,null,g))};switch(m){case"env":if(_){if(k){const u=k[S.isWindows?_.toLowerCase():_];if(P.isString(u))return u}return""}throw new Error((0,y.localize)(5,null,g));case"config":if(_){const u=this._context.getConfigurationValue(i,_);if(P.isUndefinedOrNull(u))throw new Error((0,y.localize)(6,null,g,_));if(P.isObject(u))throw new Error((0,y.localize)(7,null,g,_));return u}throw new Error((0,y.localize)(8,null,g));case"command":return this.resolveFromMap(g,_,s,"command");case"input":return this.resolveFromMap(g,_,s,"input");default:switch(m){case"workspaceRoot":case"workspaceFolder":return(0,C.normalizeDriveLetter)(this.fsPath(l()));case"cwd":return i||_?(0,C.normalizeDriveLetter)(this.fsPath(l())):I.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return E.basename(this.fsPath(l()));case"lineNumber":const u=this._context.getLineNumber();if(u)return u;throw new Error((0,y.localize)(9,null,g));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,y.localize)(10,null,g));case"file":return b();case"fileWorkspaceFolder":return v();case"relativeFile":return i||_?E.relative(this.fsPath(l()),b()):b();case"relativeFileDirname":const r=E.dirname(b());if(i||_){const f=E.relative(this.fsPath(l()),r);return f.length===0?".":f}return r;case"fileDirname":return E.dirname(b());case"fileExtname":return E.extname(b());case"fileBasename":return E.basename(b());case"fileBasenameNoExtension":const c=E.basename(b());return c.slice(0,c.length-E.extname(c).length);case"fileDirnameBasename":return E.basename(E.dirname(b()));case"execPath":const o=this._context.getExecPath();return o||g;case"execInstallFolder":const a=this._context.getAppRoot();return a||g;case"pathSeparator":return E.sep;default:try{const f=_?`${m}:${_}`:m;return this.resolveFromMap(g,f,s,void 0)}catch(f){return g}}}}resolveFromMap(k,g,m,i){if(g&&m){const s=i===void 0?m[g]:m[i+":"+g];if(typeof s=="string")return s;throw new Error((0,y.localize)(11,null,k))}return k}}e.AbstractVariableResolverService=n,n.VARIABLE_LHS="${",n.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(_e[173],we([0,1,4]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,E.createDecorator)("editorGroupsService");var I;(function(g){g[g.UP=0]="UP",g[g.DOWN=1]="DOWN",g[g.LEFT=2]="LEFT",g[g.RIGHT=3]="RIGHT"})(I=e.GroupDirection||(e.GroupDirection={}));var P;(function(g){g[g.HORIZONTAL=0]="HORIZONTAL",g[g.VERTICAL=1]="VERTICAL"})(P=e.GroupOrientation||(e.GroupOrientation={}));var A;(function(g){g[g.FIRST=0]="FIRST",g[g.LAST=1]="LAST",g[g.NEXT=2]="NEXT",g[g.PREVIOUS=3]="PREVIOUS"})(A=e.GroupLocation||(e.GroupLocation={}));var S;(function(g){g[g.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",g[g.EVEN=1]="EVEN",g[g.TOGGLE=2]="TOGGLE"})(S=e.GroupsArrangement||(e.GroupsArrangement={}));var C;(function(g){g[g.COPY_EDITORS=0]="COPY_EDITORS",g[g.MOVE_EDITORS=1]="MOVE_EDITORS"})(C=e.MergeGroupMode||(e.MergeGroupMode={}));var y;(function(g){g[g.CREATION_TIME=0]="CREATION_TIME",g[g.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",g[g.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(y=e.GroupsOrder||(e.GroupsOrder={}));var n;(function(g){g[g.GROUP_ACTIVE=0]="GROUP_ACTIVE",g[g.GROUP_INDEX=1]="GROUP_INDEX",g[g.EDITOR_OPEN=2]="EDITOR_OPEN",g[g.EDITOR_CLOSE=3]="EDITOR_CLOSE",g[g.EDITOR_MOVE=4]="EDITOR_MOVE",g[g.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",g[g.EDITOR_LABEL=6]="EDITOR_LABEL",g[g.EDITOR_PIN=7]="EDITOR_PIN",g[g.EDITOR_STICKY=8]="EDITOR_STICKY",g[g.EDITOR_DIRTY=9]="EDITOR_DIRTY"})(n=e.GroupChangeKind||(e.GroupChangeKind={}));var T;(function(g){g[g.NEW_EDITOR=1]="NEW_EDITOR",g[g.MOVE_EDITOR=2]="MOVE_EDITOR",g[g.COPY_EDITOR=3]="COPY_EDITOR"})(T=e.OpenEditorContext||(e.OpenEditorContext={}));function k(g){return g.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=k}),define(_e[174],we([0,1,4]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,E.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(_e[9],we([0,1,11,80,228,57,24,13,2,32,62,142,87,70,174,7]),function(ie,e,E,I,P,A,S,C,y,n,T,k,g,m,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.NotebookDocumentContentOptions=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookCellKind=e.NotebookCellPreviousExecutionResult=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookCellRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlineHintKind=e.InlineHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var _;(function(ve){function he(q){const{selectionStartLineNumber:Ie,selectionStartColumn:Te,positionLineNumber:Qe,positionColumn:Ge}=q,rt=new s.Position(Ie-1,Te-1),ct=new s.Position(Qe-1,Ge-1);return new s.Selection(rt,ct)}ve.to=he;function ue(q){const{anchor:Ie,active:Te}=q;return{selectionStartLineNumber:Ie.line+1,selectionStartColumn:Ie.character+1,positionLineNumber:Te.line+1,positionColumn:Te.character+1}}ve.from=ue})(_=e.Selection||(e.Selection={}));var d;(function(ve){function he(q){if(!!q){const{start:Ie,end:Te}=q;return{startLineNumber:Ie.line+1,startColumn:Ie.character+1,endLineNumber:Te.line+1,endColumn:Te.character+1}}}ve.from=he;function ue(q){if(!!q){const{startLineNumber:Ie,startColumn:Te,endLineNumber:Qe,endColumn:Ge}=q;return new s.Range(Ie-1,Te-1,Qe-1,Ge-1)}}ve.to=ue})(d=e.Range||(e.Range={}));var b;(function(ve){function he(ue){switch(ue){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 4:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}ve.to=he})(b=e.TokenType||(e.TokenType={}));var v;(function(ve){function he(q){return new s.Position(q.lineNumber-1,q.column-1)}ve.to=he;function ue(q){return{lineNumber:q.line+1,column:q.character+1}}ve.from=ue})(v=e.Position||(e.Position={}));var l;(function(ve){function he(q){switch(q){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}ve.from=he;function ue(q){switch(q){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}ve.to=ue})(l=e.DiagnosticTag||(e.DiagnosticTag={}));var u;(function(ve){function he(q){let Ie;return q.code&&((0,C.isString)(q.code)||(0,C.isNumber)(q.code)?Ie=String(q.code):Ie={value:String(q.code.value),target:q.code.target}),Object.assign(Object.assign({},d.from(q.range)),{message:q.message,source:q.source,code:Ie,severity:r.from(q.severity),relatedInformation:q.relatedInformation&&q.relatedInformation.map(t.from),tags:Array.isArray(q.tags)?(0,E.coalesce)(q.tags.map(l.from)):void 0})}ve.from=he;function ue(q){var Ie;const Te=new s.Diagnostic(d.to(q),q.message,r.to(q.severity));return Te.source=q.source,Te.code=(0,C.isString)(q.code)?q.code:(Ie=q.code)===null||Ie===void 0?void 0:Ie.value,Te.relatedInformation=q.relatedInformation&&q.relatedInformation.map(t.to),Te.tags=q.tags&&(0,E.coalesce)(q.tags.map(l.to)),Te}ve.to=ue})(u=e.Diagnostic||(e.Diagnostic={}));var t;(function(ve){function he(q){return Object.assign(Object.assign({},d.from(q.location.range)),{message:q.message,resource:q.location.uri})}ve.from=he;function ue(q){return new s.DiagnosticRelatedInformation(new s.Location(q.resource,d.to(q)),q.message)}ve.to=ue})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var r;(function(ve){function he(q){switch(q){case s.DiagnosticSeverity.Error:return g.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return g.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return g.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return g.MarkerSeverity.Hint}return g.MarkerSeverity.Error}ve.from=he;function ue(q){switch(q){case g.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case g.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case g.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case g.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}ve.to=ue})(r=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var c;(function(ve){function he(q){return typeof q=="number"&&q>=s.ViewColumn.One?q-1:q===s.ViewColumn.Beside?i.SIDE_GROUP:i.ACTIVE_GROUP}ve.from=he;function ue(q){if(typeof q=="number"&&q>=0)return q+1;throw new Error("invalid 'EditorGroupColumn'")}ve.to=ue})(c=e.ViewColumn||(e.ViewColumn={}));function o(ve){return typeof ve.range!="undefined"}function a(ve){return ve.length===0?!0:!!o(ve[0])}e.isDecorationOptionsArr=a;var f;(function(ve){function he(Ge){return Ge.map(ve.from)}ve.fromMany=he;function ue(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function q(Ge){let rt;if(ue(Ge)){const{language:ut,value:ot}=Ge;rt={value:"```"+ut+`
`+ot+"\n```\n"}}else s.MarkdownString.isMarkdownString(Ge)?rt={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons}:typeof Ge=="string"?rt={value:Ge}:rt={value:""};const ct=Object.create(null);rt.uris=ct;const Xe=ut=>{try{let ot=y.URI.parse(ut,!0);ot=ot.with({query:Ie(ot.query,ct)}),ct[ut]=ot}catch(ot){}return""},at=new P.Renderer;return at.link=Xe,at.image=ut=>Xe(I.parseHrefAndDimensions(ut).href),P(rt.value,{renderer:at}),rt}ve.from=q;function Ie(Ge,rt){if(!Ge)return Ge;let ct;try{ct=(0,A.parse)(Ge)}catch(at){}if(!ct)return Ge;let Xe=!1;return ct=(0,S.cloneAndChange)(ct,at=>{if(y.URI.isUri(at)){const ut=`__uri_${Math.random().toString(16).slice(2,8)}`;return rt[ut]=at,Xe=!0,ut}else return}),Xe?JSON.stringify(ct):Ge}function Te(Ge){const rt=new s.MarkdownString(Ge.value,Ge.supportThemeIcons);return rt.isTrusted=Ge.isTrusted,rt}ve.to=Te;function Qe(Ge){if(!!Ge)return typeof Ge=="string"?Ge:ve.from(Ge)}ve.fromStrict=Qe})(f=e.MarkdownString||(e.MarkdownString={}));function w(ve){return a(ve)?ve.map(he=>({range:d.from(he.range),hoverMessage:Array.isArray(he.hoverMessage)?f.fromMany(he.hoverMessage):he.hoverMessage?f.from(he.hoverMessage):void 0,renderOptions:he.renderOptions})):ve.map(he=>({range:d.from(he)}))}e.fromRangeOrRangeWithMessage=w;function D(ve){return typeof ve=="undefined"?ve:typeof ve=="string"?y.URI.file(ve):ve}e.pathOrURIToURI=D;var p;(function(ve){function he(ue){return typeof ue=="undefined"?ue:{contentText:ue.contentText,contentIconPath:ue.contentIconPath?D(ue.contentIconPath):void 0,border:ue.border,borderColor:ue.borderColor,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,color:ue.color,backgroundColor:ue.backgroundColor,margin:ue.margin,width:ue.width,height:ue.height}}ve.from=he})(p=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var h;(function(ve){function he(ue){return typeof ue=="undefined"?ue:{backgroundColor:ue.backgroundColor,outline:ue.outline,outlineColor:ue.outlineColor,outlineStyle:ue.outlineStyle,outlineWidth:ue.outlineWidth,border:ue.border,borderColor:ue.borderColor,borderRadius:ue.borderRadius,borderSpacing:ue.borderSpacing,borderStyle:ue.borderStyle,borderWidth:ue.borderWidth,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,cursor:ue.cursor,color:ue.color,opacity:ue.opacity,letterSpacing:ue.letterSpacing,gutterIconPath:ue.gutterIconPath?D(ue.gutterIconPath):void 0,gutterIconSize:ue.gutterIconSize,overviewRulerColor:ue.overviewRulerColor,before:ue.before?p.from(ue.before):void 0,after:ue.after?p.from(ue.after):void 0}}ve.from=he})(h=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var R;(function(ve){function he(ue){if(typeof ue=="undefined")return ue;switch(ue){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}ve.from=he})(R=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var F;(function(ve){function he(ue){return{isWholeLine:ue.isWholeLine,rangeBehavior:ue.rangeBehavior?R.from(ue.rangeBehavior):void 0,overviewRulerLane:ue.overviewRulerLane,light:ue.light?h.from(ue.light):void 0,dark:ue.dark?h.from(ue.dark):void 0,backgroundColor:ue.backgroundColor,outline:ue.outline,outlineColor:ue.outlineColor,outlineStyle:ue.outlineStyle,outlineWidth:ue.outlineWidth,border:ue.border,borderColor:ue.borderColor,borderRadius:ue.borderRadius,borderSpacing:ue.borderSpacing,borderStyle:ue.borderStyle,borderWidth:ue.borderWidth,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,cursor:ue.cursor,color:ue.color,opacity:ue.opacity,letterSpacing:ue.letterSpacing,gutterIconPath:ue.gutterIconPath?D(ue.gutterIconPath):void 0,gutterIconSize:ue.gutterIconSize,overviewRulerColor:ue.overviewRulerColor,before:ue.before?p.from(ue.before):void 0,after:ue.after?p.from(ue.after):void 0}}ve.from=he})(F=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var $;(function(ve){function he(q){return{text:q.newText,eol:q.newEol&&Z.from(q.newEol),range:d.from(q.range)}}ve.from=he;function ue(q){const Ie=new s.TextEdit(d.to(q.range),q.text);return Ie.newEol=typeof q.eol=="undefined"?void 0:Z.to(q.eol),Ie}ve.to=ue})($=e.TextEdit||(e.TextEdit={}));var se;(function(ve){function he(q,Ie,Te){var Qe,Ge,rt;const ct={edits:[]};if(q instanceof s.WorkspaceEdit)for(let Xe of q._allEntries())if(Xe._type===1)ct.edits.push({_type:1,oldUri:Xe.from,newUri:Xe.to,options:Xe.options,metadata:Xe.metadata});else if(Xe._type===2){const at=Ie==null?void 0:Ie.getDocument(Xe.uri);ct.edits.push({_type:2,resource:Xe.uri,edit:$.from(Xe.edit),modelVersionId:at==null?void 0:at.version,metadata:Xe.metadata})}else Xe._type===3?ct.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,edit:Xe.edit,notebookMetadata:Xe.notebookMetadata,notebookVersionId:(Qe=Te==null?void 0:Te.lookupNotebookDocument(Xe.uri))===null||Qe===void 0?void 0:Qe.notebookDocument.version}):Xe._type===4?(Xe.newOutputs&&ct.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,edit:{editType:2,index:Xe.index,append:Xe.append,outputs:Xe.newOutputs.map(Ne.from)}}),Xe.newMetadata&&ct.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,edit:{editType:11,index:Xe.index,metadata:Xe.newMetadata}})):Xe._type===5?ct.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,notebookVersionId:(Ge=Te==null?void 0:Te.lookupNotebookDocument(Xe.uri))===null||Ge===void 0?void 0:Ge.notebookDocument.version,edit:{editType:1,index:Xe.index,count:Xe.count,cells:Xe.cells.map(fe.from)}}):Xe._type===6&&ct.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,edit:{editType:10,outputId:Xe.outputId,items:((rt=Xe.newOutputItems)===null||rt===void 0?void 0:rt.map(Ee.from))||[],append:Xe.append}});return ct}ve.from=he;function ue(q){const Ie=new s.WorkspaceEdit;for(const Te of q.edits)Te.edit?Ie.replace(y.URI.revive(Te.resource),d.to(Te.edit.range),Te.edit.text):Ie.renameFile(y.URI.revive(Te.oldUri),y.URI.revive(Te.newUri),Te.options);return Ie}ve.to=ue})(se=e.WorkspaceEdit||(e.WorkspaceEdit={}));var z;(function(ve){const he=Object.create(null);he[s.SymbolKind.File]=0,he[s.SymbolKind.Module]=1,he[s.SymbolKind.Namespace]=2,he[s.SymbolKind.Package]=3,he[s.SymbolKind.Class]=4,he[s.SymbolKind.Method]=5,he[s.SymbolKind.Property]=6,he[s.SymbolKind.Field]=7,he[s.SymbolKind.Constructor]=8,he[s.SymbolKind.Enum]=9,he[s.SymbolKind.Interface]=10,he[s.SymbolKind.Function]=11,he[s.SymbolKind.Variable]=12,he[s.SymbolKind.Constant]=13,he[s.SymbolKind.String]=14,he[s.SymbolKind.Number]=15,he[s.SymbolKind.Boolean]=16,he[s.SymbolKind.Array]=17,he[s.SymbolKind.Object]=18,he[s.SymbolKind.Key]=19,he[s.SymbolKind.Null]=20,he[s.SymbolKind.EnumMember]=21,he[s.SymbolKind.Struct]=22,he[s.SymbolKind.Event]=23,he[s.SymbolKind.Operator]=24,he[s.SymbolKind.TypeParameter]=25;function ue(Ie){return typeof he[Ie]=="number"?he[Ie]:6}ve.from=ue;function q(Ie){for(const Te in he)if(he[Te]===Ie)return Number(Te);return s.SymbolKind.Property}ve.to=q})(z=e.SymbolKind||(e.SymbolKind={}));var x;(function(ve){function he(q){switch(q){case s.SymbolTag.Deprecated:return 1}}ve.from=he;function ue(q){switch(q){case 1:return s.SymbolTag.Deprecated}}ve.to=ue})(x=e.SymbolTag||(e.SymbolTag={}));var G;(function(ve){function he(q){return{name:q.name,kind:z.from(q.kind),tags:q.tags&&q.tags.map(x.from),containerName:q.containerName,location:W.from(q.location)}}ve.from=he;function ue(q){const Ie=new s.SymbolInformation(q.name,z.to(q.kind),q.containerName,W.to(q.location));return Ie.tags=q.tags&&q.tags.map(x.to),Ie}ve.to=ue})(G=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var M;(function(ve){function he(q){var Ie,Te;const Qe={name:q.name||"!!MISSING: name!!",detail:q.detail,range:d.from(q.range),selectionRange:d.from(q.selectionRange),kind:z.from(q.kind),tags:(Te=(Ie=q.tags)===null||Ie===void 0?void 0:Ie.map(x.from))!==null&&Te!==void 0?Te:[]};return q.children&&(Qe.children=q.children.map(he)),Qe}ve.from=he;function ue(q){const Ie=new s.DocumentSymbol(q.name,q.detail,z.to(q.kind),d.to(q.range),d.to(q.selectionRange));return(0,E.isNonEmptyArray)(q.tags)&&(Ie.tags=q.tags.map(x.to)),q.children&&(Ie.children=q.children.map(ue)),Ie}ve.to=ue})(M=e.DocumentSymbol||(e.DocumentSymbol={}));var N;(function(ve){function he(ue){const q=new s.CallHierarchyItem(z.to(ue.kind),ue.name,ue.detail||"",y.URI.revive(ue.uri),d.to(ue.range),d.to(ue.selectionRange));return q._sessionId=ue._sessionId,q._itemId=ue._itemId,q}ve.to=he})(N=e.CallHierarchyItem||(e.CallHierarchyItem={}));var B;(function(ve){function he(ue){return new s.CallHierarchyIncomingCall(N.to(ue.from),ue.fromRanges.map(q=>d.to(q)))}ve.to=he})(B=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var Q;(function(ve){function he(ue){return new s.CallHierarchyOutgoingCall(N.to(ue.to),ue.fromRanges.map(q=>d.to(q)))}ve.to=he})(Q=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var W;(function(ve){function he(q){return{range:q.range&&d.from(q.range),uri:q.uri}}ve.from=he;function ue(q){return new s.Location(y.URI.revive(q.uri),d.to(q.range))}ve.to=ue})(W=e.location||(e.location={}));var ee;(function(ve){function he(q){const Ie=q,Te=q;return{originSelectionRange:Ie.originSelectionRange?d.from(Ie.originSelectionRange):void 0,uri:Ie.targetUri?Ie.targetUri:Te.uri,range:d.from(Ie.targetRange?Ie.targetRange:Te.range),targetSelectionRange:Ie.targetSelectionRange?d.from(Ie.targetSelectionRange):void 0}}ve.from=he;function ue(q){return{targetUri:y.URI.revive(q.uri),targetRange:d.to(q.range),targetSelectionRange:q.targetSelectionRange?d.to(q.targetSelectionRange):void 0,originSelectionRange:q.originSelectionRange?d.to(q.originSelectionRange):void 0}}ve.to=ue})(ee=e.DefinitionLink||(e.DefinitionLink={}));var re;(function(ve){function he(q){return{range:d.from(q.range),contents:f.fromMany(q.contents)}}ve.from=he;function ue(q){return new s.Hover(q.contents.map(f.to),d.to(q.range))}ve.to=ue})(re=e.Hover||(e.Hover={}));var oe;(function(ve){function he(q){return{range:d.from(q.range),expression:q.expression}}ve.from=he;function ue(q){return new s.EvaluatableExpression(d.to(q.range),q.expression)}ve.to=ue})(oe=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Se;(function(ve){function he(q){if(q instanceof s.InlineValueText)return{type:"text",range:d.from(q.range),text:q.text};if(q instanceof s.InlineValueVariableLookup)return{type:"variable",range:d.from(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};if(q instanceof s.InlineValueEvaluatableExpression)return{type:"expression",range:d.from(q.range),expression:q.expression};throw new Error("Unknown 'InlineValue' type")}ve.from=he;function ue(q){switch(q.type){case"text":return{range:d.to(q.range),text:q.text};case"variable":return{range:d.to(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};case"expression":return{range:d.to(q.range),expression:q.expression}}}ve.to=ue})(Se=e.InlineValue||(e.InlineValue={}));var Pe;(function(ve){function he(q){return{frameId:q.frameId,stoppedLocation:d.from(q.stoppedLocation)}}ve.from=he;function ue(q){return new s.InlineValueContext(q.frameId,d.to(q.stoppedLocation))}ve.to=ue})(Pe=e.InlineValueContext||(e.InlineValueContext={}));var $e;(function(ve){function he(q){return{range:d.from(q.range),kind:q.kind}}ve.from=he;function ue(q){return new s.DocumentHighlight(d.to(q.range),q.kind)}ve.to=ue})($e=e.DocumentHighlight||(e.DocumentHighlight={}));var Fe;(function(ve){function he(ue){switch(ue){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}ve.to=he})(Fe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ze;(function(ve){function he(ue){return{triggerKind:Fe.to(ue.triggerKind),triggerCharacter:ue.triggerCharacter}}ve.to=he})(ze=e.CompletionContext||(e.CompletionContext={}));var U;(function(ve){function he(q){switch(q){case s.CompletionItemTag.Deprecated:return 1}}ve.from=he;function ue(q){switch(q){case 1:return s.CompletionItemTag.Deprecated}}ve.to=ue})(U=e.CompletionItemTag||(e.CompletionItemTag={}));var K;(function(ve){const he=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function ue(Te){var Qe;return(Qe=he.get(Te))!==null&&Qe!==void 0?Qe:9}ve.from=ue;const q=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Ie(Te){var Qe;return(Qe=q.get(Te))!==null&&Qe!==void 0?Qe:s.CompletionItemKind.Property}ve.to=Ie})(K=e.CompletionItemKind||(e.CompletionItemKind={}));var te;(function(ve){function he(ue,q){var Ie;const Te=new s.CompletionItem(typeof ue.label=="string"?ue.label:ue.label.name);return typeof ue.label!="string"&&(Te.label2=ue.label),Te.insertText=ue.insertText,Te.kind=K.to(ue.kind),Te.tags=(Ie=ue.tags)===null||Ie===void 0?void 0:Ie.map(U.to),Te.detail=ue.detail,Te.documentation=I.isMarkdownString(ue.documentation)?f.to(ue.documentation):ue.documentation,Te.sortText=ue.sortText,Te.filterText=ue.filterText,Te.preselect=ue.preselect,Te.commitCharacters=ue.commitCharacters,n.Range.isIRange(ue.range)?Te.range=d.to(ue.range):typeof ue.range=="object"&&(Te.range={inserting:d.to(ue.range.insert),replacing:d.to(ue.range.replace)}),Te.keepWhitespace=typeof ue.insertTextRules=="undefined"?!1:Boolean(ue.insertTextRules&1),typeof ue.insertTextRules!="undefined"&&ue.insertTextRules&4?Te.insertText=new s.SnippetString(ue.insertText):(Te.insertText=ue.insertText,Te.textEdit=Te.range instanceof s.Range?new s.TextEdit(Te.range,Te.insertText):void 0),ue.additionalTextEdits&&ue.additionalTextEdits.length>0&&(Te.additionalTextEdits=ue.additionalTextEdits.map(Qe=>$.to(Qe))),Te.command=q&&ue.command?q.fromInternal(ue.command):void 0,Te}ve.to=he})(te=e.CompletionItem||(e.CompletionItem={}));var le;(function(ve){function he(q){return{label:q.label,documentation:q.documentation?f.fromStrict(q.documentation):void 0}}ve.from=he;function ue(q){return{label:q.label,documentation:I.isMarkdownString(q.documentation)?f.to(q.documentation):q.documentation}}ve.to=ue})(le=e.ParameterInformation||(e.ParameterInformation={}));var me;(function(ve){function he(q){return{label:q.label,documentation:q.documentation?f.fromStrict(q.documentation):void 0,parameters:Array.isArray(q.parameters)?q.parameters.map(le.from):[],activeParameter:q.activeParameter}}ve.from=he;function ue(q){return{label:q.label,documentation:I.isMarkdownString(q.documentation)?f.to(q.documentation):q.documentation,parameters:Array.isArray(q.parameters)?q.parameters.map(le.to):[],activeParameter:q.activeParameter}}ve.to=ue})(me=e.SignatureInformation||(e.SignatureInformation={}));var De;(function(ve){function he(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(me.from):[]}}ve.from=he;function ue(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(me.to):[]}}ve.to=ue})(De=e.SignatureHelp||(e.SignatureHelp={}));var Oe;(function(ve){function he(q){var Ie;return{text:q.text,range:d.from(q.range),kind:ge.from((Ie=q.kind)!==null&&Ie!==void 0?Ie:s.InlineHintKind.Other),description:q.description&&f.fromStrict(q.description),whitespaceBefore:q.whitespaceBefore,whitespaceAfter:q.whitespaceAfter}}ve.from=he;function ue(q){const Ie=new s.InlineHint(q.text,d.to(q.range),ge.to(q.kind));return Ie.whitespaceAfter=q.whitespaceAfter,Ie.whitespaceBefore=q.whitespaceBefore,Ie.description=I.isMarkdownString(q.description)?f.to(q.description):q.description,Ie}ve.to=ue})(Oe=e.InlineHint||(e.InlineHint={}));var ge;(function(ve){function he(q){return q}ve.from=he;function ue(q){return q}ve.to=ue})(ge=e.InlineHintKind||(e.InlineHintKind={}));var Ce;(function(ve){function he(q){return{range:d.from(q.range),url:q.target,tooltip:q.tooltip}}ve.from=he;function ue(q){let Ie;if(q.url)try{Ie=typeof q.url=="string"?y.URI.parse(q.url,!0):y.URI.revive(q.url)}catch(Te){}return new s.DocumentLink(d.to(q.range),Ie)}ve.to=ue})(Ce=e.DocumentLink||(e.DocumentLink={}));var Ae;(function(ve){function he(q){const Ie=new s.ColorPresentation(q.label);return q.textEdit&&(Ie.textEdit=$.to(q.textEdit)),q.additionalTextEdits&&(Ie.additionalTextEdits=q.additionalTextEdits.map(Te=>$.to(Te))),Ie}ve.to=he;function ue(q){return{label:q.label,textEdit:q.textEdit?$.from(q.textEdit):void 0,additionalTextEdits:q.additionalTextEdits?q.additionalTextEdits.map(Ie=>$.from(Ie)):void 0}}ve.from=ue})(Ae=e.ColorPresentation||(e.ColorPresentation={}));var We;(function(ve){function he(q){return new s.Color(q[0],q[1],q[2],q[3])}ve.to=he;function ue(q){return[q.red,q.green,q.blue,q.alpha]}ve.from=ue})(We=e.Color||(e.Color={}));var be;(function(ve){function he(q){return{range:d.from(q.range)}}ve.from=he;function ue(q){return new s.SelectionRange(d.to(q.range))}ve.to=ue})(be=e.SelectionRange||(e.SelectionRange={}));var qe;(function(ve){function he(ue){switch(ue){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}ve.to=he})(qe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var V;(function(ve){function he(q){switch(q){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}ve.from=he;function ue(q){switch(q){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}ve.to=ue})(V=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Z;(function(ve){function he(q){if(q===s.EndOfLine.CRLF)return 1;if(q===s.EndOfLine.LF)return 0}ve.from=he;function ue(q){if(q===1)return s.EndOfLine.CRLF;if(q===0)return s.EndOfLine.LF}ve.to=ue})(Z=e.EndOfLine||(e.EndOfLine={}));var pe;(function(ve){function he(ue){if(typeof ue=="object")return ue.viewId;switch(ue){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ve.from=he})(pe=e.ProgressLocation||(e.ProgressLocation={}));var Me;(function(ve){function he(ue){const q={start:ue.start+1,end:ue.end+1};return ue.kind&&(q.kind=He.from(ue.kind)),q}ve.from=he})(Me=e.FoldingRange||(e.FoldingRange={}));var He;(function(ve){function he(ue){if(ue)switch(ue){case s.FoldingRangeKind.Comment:return T.FoldingRangeKind.Comment;case s.FoldingRangeKind.Imports:return T.FoldingRangeKind.Imports;case s.FoldingRangeKind.Region:return T.FoldingRangeKind.Region}}ve.from=he})(He=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ue;(function(ve){function he(ue){if(ue)return{pinned:typeof ue.preview=="boolean"?!ue.preview:void 0,inactive:ue.background,preserveFocus:ue.preserveFocus,selection:typeof ue.selection=="object"?d.from(ue.selection):void 0,override:typeof ue.override=="boolean"?k.EditorOverride.DISABLED:void 0}}ve.from=he})(Ue=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Ze;(function(ve){function he(q){return q instanceof s.RelativePattern||typeof q=="string"?q:ue(q)?new s.RelativePattern(q.base,q.pattern):q}ve.from=he;function ue(q){const Ie=q;return Ie&&typeof Ie.base=="string"&&typeof Ie.pattern=="string"}})(Ze=e.GlobPattern||(e.GlobPattern={}));var H;(function(ve){function he(ue){if(ue){if(Array.isArray(ue))return ue.map(he);if(typeof ue=="string")return ue;{const q=ue;return{language:q.language,scheme:q.scheme,pattern:typeof q.pattern=="undefined"?void 0:Ze.from(q.pattern),exclusive:q.exclusive}}}else return}ve.from=he})(H=e.LanguageSelector||(e.LanguageSelector={}));var ne;(function(ve){function he(q){return{start:q.start,end:q.end}}ve.from=he;function ue(q){return new s.NotebookCellRange(q.start,q.end)}ve.to=ue})(ne=e.NotebookCellRange||(e.NotebookCellRange={}));var de;(function(ve){function he(ue){return new s.NotebookCellMetadata(ue.editable,ue.breakpointMargin,ue.statusMessage,ue.inputCollapsed,ue.outputCollapsed,ue.custom)}ve.to=he})(de=e.NotebookCellMetadata||(e.NotebookCellMetadata={}));var j;(function(ve){function he(q){return q}ve.from=he;function ue(q){return new s.NotebookDocumentMetadata(q.editable,q.cellEditable,q.custom,q.trusted)}ve.to=ue})(j=e.NotebookDocumentMetadata||(e.NotebookDocumentMetadata={}));var Y;(function(ve){function he(q){return{duration:q.lastRunDuration,executionOrder:q.executionOrder,success:q.lastRunSuccess}}ve.to=he;function ue(q){return{lastRunSuccess:q.success,lastRunDuration:q.duration,executionOrder:q.executionOrder}}ve.from=ue})(Y=e.NotebookCellPreviousExecutionResult||(e.NotebookCellPreviousExecutionResult={}));var ae;(function(ve){function he(q){switch(q){case s.NotebookCellKind.Markdown:return m.CellKind.Markdown;case s.NotebookCellKind.Code:default:return m.CellKind.Code}}ve.from=he;function ue(q){switch(q){case m.CellKind.Markdown:return s.NotebookCellKind.Markdown;case m.CellKind.Code:default:return s.NotebookCellKind.Code}}ve.to=ue})(ae=e.NotebookCellKind||(e.NotebookCellKind={}));var fe;(function(ve){function he(q){var Ie;return{cellKind:ae.from(q.kind),language:q.language,source:q.source,metadata:Object.assign(Object.assign({},q.metadata),Y.from((Ie=q.latestExecutionSummary)!==null&&Ie!==void 0?Ie:{})),outputs:q.outputs?q.outputs.map(Ne.from):[]}}ve.from=he;function ue(q){return new s.NotebookCellData(ae.to(q.cellKind),q.source,q.language,q.outputs?q.outputs.map(Ne.to):void 0,q.metadata?de.to(q.metadata):void 0)}ve.to=ue})(fe=e.NotebookCellData||(e.NotebookCellData={}));var Ee;(function(ve){function he(q){return{mime:q.mime,value:q.value,metadata:q.metadata}}ve.from=he;function ue(q){return new s.NotebookCellOutputItem(q.mime,q.value,q.metadata)}ve.to=ue})(Ee=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ne;(function(ve){function he(q){return{outputId:q.id,outputs:q.outputs.map(Ee.from),metadata:q.metadata}}ve.from=he;function ue(q){const Ie=q.outputs.map(Ee.to);return new s.NotebookCellOutput(Ie,q.outputId,q.metadata)}ve.to=ue})(Ne=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Le;(function(ve){function he(Te){if(Te!=null){if(Te instanceof s.RelativePattern||typeof Te=="string")return Te;if(Ie(Te))return new s.RelativePattern(Te.base,Te.pattern);if(q(Te))return{include:Ze.from(Te.include)||void 0,exclude:Ze.from(Te.exclude)||void 0}}}ve.from=he;function ue(Te){return typeof Te=="string"?Te:Ie(Te)?{base:Te.base,pattern:Te.pattern}:{include:Te.include,exclude:Te.exclude}}ve.to=ue;function q(Te){const Qe=Te,Ge=Ze.from(Qe.include);if(!(Ge&&Ge instanceof s.RelativePattern||typeof Ge=="string"))return!1;const rt=Ze.from(Qe.exclude);return!!(rt&&rt instanceof s.RelativePattern||typeof rt=="string")}function Ie(Te){const Qe=Te;return Qe&&typeof Qe.base=="string"&&typeof Qe.pattern=="string"}})(Le=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Ve;(function(ve){function he(ue){return{backgroundColor:ue.backgroundColor,borderColor:ue.borderColor,top:ue.top?p.from(ue.top):void 0}}ve.from=he})(Ve=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Ye;(function(ve){function he(ue){var q;return{transientOutputs:(q=ue==null?void 0:ue.transientOutputs)!==null&&q!==void 0?q:!1,transientMetadata:Object.assign(Object.assign({},ue==null?void 0:ue.transientMetadata),{executionOrder:!0,lastRunDuration:!0,runState:!0,runStartTime:!0,lastRunSuccess:!0})}}ve.from=he})(Ye=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var et;(function(ve){function he(q){return{message:f.fromStrict(q.message)||"",severity:q.severity,expectedOutput:q.expectedOutput,actualOutput:q.actualOutput,location:q.location?W.from(q.location):void 0}}ve.from=he;function ue(q){const Ie=new s.TestMessage(typeof q.message=="string"?q.message:f.to(q.message));return Ie.severity=q.severity,Ie.actualOutput=q.actualOutput,Ie.expectedOutput=q.expectedOutput,Ie}ve.to=ue})(et=e.TestMessage||(e.TestMessage={}));var nt;(function(ve){function he(Te){var Qe,Ge;return{extId:Te.id,label:Te.label,uri:Te.uri,range:d.from(Te.range),debuggable:(Qe=Te.debuggable)!==null&&Qe!==void 0?Qe:!1,description:Te.description,runnable:(Ge=Te.runnable)!==null&&Ge!==void 0?Ge:!0,expandable:Te.expandable}}ve.from=he;function ue(Te){return{extId:Te.id,label:Te.label,uri:Te.uri,range:d.from(Te.range),debuggable:!1,description:Te.description,runnable:!0,expandable:!0}}ve.fromResultSnapshot=ue;function q(Te){return{id:Te.extId,label:Te.label,uri:y.URI.revive(Te.uri),range:d.to(Te.range),expandable:Te.expandable,debuggable:Te.debuggable,description:Te.description,runnable:Te.runnable}}ve.toPlain=q;function Ie(Te){const Qe=new s.TestItem(Te.extId,Te.label,y.URI.revive(Te.uri),Te.expandable);return Qe.range=d.to(Te.range),Qe.debuggable=Te.debuggable,Qe.description=Te.description,Qe.runnable=Te.runnable,Qe}ve.to=Ie})(nt=e.TestItem||(e.TestItem={}));var st;(function(ve){function he(Ie,Te){var Qe,Ge,rt;const ct={completedAt:Te.completedAt,id:Ie,output:Te.output,items:[]},Xe=[[null,Te.results]];for(;Xe.length;){const[at,ut]=Xe.pop();for(const ot of ut){const yt={children:(Ge=(Qe=ot.children)===null||Qe===void 0?void 0:Qe.map(gt=>gt.id))!==null&&Ge!==void 0?Ge:[],computedState:ot.state,item:nt.fromResultSnapshot(ot),state:{state:ot.state,duration:ot.duration,messages:ot.messages.map(et.from)},retired:void 0,expand:3,parent:(rt=at==null?void 0:at.item.extId)!==null&&rt!==void 0?rt:null,src:{provider:"",tree:-1},direct:!at};ct.items.push(yt),ot.children&&Xe.push([yt,ot.children])}}return ct}ve.from=he;const ue=(Ie,Te)=>Object.assign(Object.assign({},nt.toPlain(Ie.item)),{state:Ie.state.state,duration:Ie.state.duration,messages:Ie.state.messages.map(et.to),children:Ie.children.map(Qe=>Te.get(Qe)).filter(C.isDefined).map(Qe=>ue(Qe,Te))});function q(Ie){const Te=[],Qe=new Map;for(const Ge of Ie.items)Qe.set(Ge.item.extId,Ge),Ge.direct&&Te.push(Ge);return{completedAt:Ie.completedAt,results:Te.map(Ge=>ue(Ge,Qe))}}ve.to=q})(st=e.TestResults||(e.TestResults={}));var it;(function(ve){function he(ue){switch(ue){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}ve.to=he})(it=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(_e[175],we([0,1,2,10,7,9,44]),function(ie,e,E,I,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class C{constructor(n,T,k,g={timeout:1500,errors:3}){this._logService=n,this._documents=T,this._mainThreadBulkEdits=k,this._thresholds=g,this._callbacks=new S.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(n){return(T,k,g)=>{const i={dispose:this._callbacks.push([T,k,n])};return Array.isArray(g)&&g.push(i),i}}async $participateInSave(n,T){const k=E.URI.revive(n);let g=!1;const m=setTimeout(()=>g=!0,this._thresholds.timeout),i=[];try{for(let s of[...this._callbacks]){if(g)break;const _=this._documents.getDocument(k),d=await this._deliverEventAsyncAndBlameBadListeners(s,{document:_,reason:A.TextDocumentSaveReason.to(T)});i.push(d)}}finally{clearTimeout(m)}return i}_deliverEventAsyncAndBlameBadListeners([n,T,k],g){const m=this._badListeners.get(n);return typeof m=="number"&&m>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(k,n,T,g).then(()=>!0,i=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this._logService.error(i),!(i instanceof Error)||i.message!=="concurrent_edits"){const s=this._badListeners.get(n);this._badListeners.set(n,s?s+1:1),typeof s=="number"&&s>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(n,T,k,g){const m=[],i=Date.now(),{document:s,reason:_}=g,{version:d}=s,b=Object.freeze({document:s,reason:_,waitUntil(v){if(Object.isFrozen(m))throw(0,I.illegalState)("waitUntil can not be called async");m.push(Promise.resolve(v))}});try{T.apply(k,[b])}catch(v){return Promise.reject(v)}return Object.freeze(m),new Promise((v,l)=>{const u=setTimeout(()=>l(new Error("timeout")),this._thresholds.timeout);return Promise.all(m).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${n.identifier.value}' finished after ${Date.now()-i}ms`),clearTimeout(u),v(t)}).catch(t=>{clearTimeout(u),l(t)})}).then(v=>{const l={edits:[]};for(const u of v)if(Array.isArray(u)&&u.every(t=>t instanceof P.TextEdit))for(const{newText:t,newEol:r,range:c}of u)l.edits.push({_type:2,resource:s.uri,edit:{range:c&&A.Range.from(c),text:t,eol:r&&A.EndOfLine.from(r)}});if(l.edits.length!==0)return d===s.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(l):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=C}),define(_e[176],we([0,1,3,14,28,2,9,7]),function(ie,e,E,I,P,A,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{constructor(k,g,m,i,s){this._onDidCreate=new E.Emitter,this._onDidChange=new E.Emitter,this._onDidDelete=new E.Emitter,this._config=0,m&&(this._config+=1),i&&(this._config+=2),s&&(this._config+=4);const _=(0,P.parse)(g),d=k(b=>{if(!m)for(let v of b.created){const l=A.URI.revive(v);_(l.fsPath)&&this._onDidCreate.fire(l)}if(!i)for(let v of b.changed){const l=A.URI.revive(v);_(l.fsPath)&&this._onDidChange.fire(l)}if(!s)for(let v of b.deleted){const l=A.URI.revive(v);_(l.fsPath)&&this._onDidDelete.fire(l)}});this._disposable=C.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,d)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class n{constructor(k,g,m){this._logService=g,this._extHostDocumentsAndEditors=m,this._onFileSystemEvent=new E.Emitter,this._onDidRenameFile=new E.Emitter,this._onDidCreateFile=new E.Emitter,this._onDidDeleteFile=new E.Emitter,this._onWillRenameFile=new I.AsyncEmitter,this._onWillCreateFile=new I.AsyncEmitter,this._onWillDeleteFile=new I.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(k,g,m,i){return new y(this._onFileSystemEvent.event,k,g,m,i)}$onFileEvent(k){this._onFileSystemEvent.fire(k)}$onDidRunFileOperation(k,g){switch(k){case 2:this._onDidRenameFile.fire(Object.freeze({files:g.map(m=>({oldUri:A.URI.revive(m.source),newUri:A.URI.revive(m.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:g.map(m=>A.URI.revive(m.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:g.map(m=>A.URI.revive(m.target))}));break;default:}}getOnWillRenameFileEvent(k){return this._createWillExecuteEvent(k,this._onWillRenameFile)}getOnWillCreateFileEvent(k){return this._createWillExecuteEvent(k,this._onWillCreateFile)}getOnWillDeleteFileEvent(k){return this._createWillExecuteEvent(k,this._onWillDeleteFile)}_createWillExecuteEvent(k,g){return(m,i,s)=>{const _=function(b){m.call(i,b)};return _.extension=k,g.event(_,void 0,s)}}async $onWillRunFileOperation(k,g,m,i){switch(k){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:g.map(s=>({oldUri:A.URI.revive(s.source),newUri:A.URI.revive(s.target)}))},m,i);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:g.map(s=>A.URI.revive(s.target))},m,i);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:g.map(s=>A.URI.revive(s.target))},m,i)}}async _fireWillEvent(k,g,m,i){const s=new Set,_=[];if(await k.fireAsync(g,i,async(b,v)=>{var l;const u=Date.now(),t=await Promise.resolve(b);t instanceof C.WorkspaceEdit&&(_.push(t),s.add((l=v.extension.displayName)!==null&&l!==void 0?l:v.extension.identifier.value)),Date.now()-u>m&&this._logService.warn("SLOW file-participant",v.extension.identifier)}),!i.isCancellationRequested&&_.length!==0){const d={edits:[]};for(let b of _){let{edits:v}=S.WorkspaceEdit.from(b,this._extHostDocumentsAndEditors);d.edits=d.edits.concat(v)}return{edit:d,extensionNames:Array.from(s)}}}}e.ExtHostFileSystemEventService=n}),define(_e[177],we([0,1,3,6,18,24,2,9,7,70]),function(ie,e,E,I,P,A,S,C,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class T{constructor(i,s,_,d){this.start=i,this.deletedCount=s,this.deletedItems=_,this.items=d}static asApiEvents(i){return i.map(s=>({start:s.start,deletedCount:s.deletedCount,deletedItems:s.deletedItems,items:s.items.map(_=>_.cell)}))}}class k{constructor(i,s,_){var d;this._notebook=i,this._extHostDocument=s,this._cellData=_,this._onDidDispose=new E.Emitter,this.onDidDispose=this._onDidDispose.event,this.handle=_.handle,this.uri=S.URI.revive(_.uri),this.cellKind=_.cellKind,this._outputs=_.outputs.map(C.NotebookCellOutput.to),this._internalMetadata=(d=_.metadata)!==null&&d!==void 0?d:{},this._metadata=C.NotebookCellMetadata.to(this._internalMetadata),this._previousResult=C.NotebookCellPreviousExecutionResult.to(this._internalMetadata)}static asModelAddData(i,s){return{EOL:s.eol,lines:s.source,modeId:s.language,uri:s.uri,isDirty:!1,versionId:1,notebook:i}}dispose(){this._onDidDispose.fire(),this._onDidDispose.dispose()}get internalMetadata(){return this._internalMetadata}get cell(){if(!this._cell){const i=this,s=this._extHostDocument.getDocument(this.uri);if(!s)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._cell=Object.freeze({get index(){return i._notebook.getCellIndex(i)},notebook:i._notebook.notebookDocument,kind:C.NotebookCellKind.to(this._cellData.cellKind),document:s.document,get outputs(){return i._outputs.slice(0)},get metadata(){return i._metadata},get latestExecutionSummary(){return i._previousResult}})}return this._cell}setOutputs(i){this._outputs=i.map(C.NotebookCellOutput.to)}setOutputItems(i,s,_){const d=_.map(C.NotebookCellOutputItem.to),b=this._outputs.find(v=>v.id===i);b&&(s||(b.outputs.length=0),b.outputs.push(...d))}setMetadata(i){this._internalMetadata=i,this._metadata=C.NotebookCellMetadata.to(i),this._previousResult=C.NotebookCellPreviousExecutionResult.to(i)}}e.ExtHostCell=k;class g extends I.Disposable{constructor(i,s,_,d,b,v,l){super();this._proxy=i,this._textDocumentsAndEditors=s,this._textDocuments=_,this._emitter=d,this._viewType=b,this._metadata=v,this.uri=l,this.handle=g._handlePool++,this._cells=[],this._cellDisposableMapping=new Map,this._versionId=0,this._isDirty=!1,this._disposed=!1}dispose(){this._disposed=!0,super.dispose(),(0,I.dispose)(this._cellDisposableMapping.values())}get notebookDocument(){if(!this._notebook){const i=this;this._notebook=Object.freeze({get uri(){return i.uri},get version(){return i._versionId},get fileName(){return i.uri.fsPath},get viewType(){return i._viewType},get isDirty(){return i._isDirty},get isUntitled(){return i.uri.scheme===P.Schemas.untitled},get isClosed(){return i._disposed},get metadata(){return i._metadata},get cellCount(){return i._cells.length},cellAt(s){return s=i._validateIndex(s),i._cells[s].cell},getCells(s){return(s?i._getCells(s):i._cells).map(d=>d.cell)},save(){return i._save()}})}return this._notebook}updateBackup(i){var s;(s=this._backup)===null||s===void 0||s.delete(),this._backup=i}disposeBackup(){var i;(i=this._backup)===null||i===void 0||i.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(i){i.metadata&&(this._metadata=this._metadata.with(i.metadata))}acceptModelChanged(i,s){this._versionId=i.versionId,this._isDirty=s;for(const _ of i.rawEvents)_.kind===n.NotebookCellsChangeType.Initialize&&this._spliceNotebookCells(_.changes,!0),_.kind===n.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(_.changes,!1):_.kind===n.NotebookCellsChangeType.Move?this._moveCell(_.index,_.newIdx):_.kind===n.NotebookCellsChangeType.Output?this._setCellOutputs(_.index,_.outputs):_.kind===n.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(_.index,_.outputId,_.append,_.outputItems):_.kind===n.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(_.index,_.language):_.kind===n.NotebookCellsChangeType.ChangeCellMetadata&&this._changeCellMetadata(_.index,_.metadata)}_validateIndex(i){return i<0?0:i>=this._cells.length?this._cells.length-1:i}_validateRange(i){return i.start<0&&(i=i.with({start:0})),i.end>this._cells.length&&(i=i.with({end:this._cells.length})),i}_getCells(i){i=this._validateRange(i);const s=[];for(let _=i.start;_<i.end;_++)s.push(this._cells[_]);return s}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveDocument(this.uri)}_spliceNotebookCells(i,s){if(!this._disposed){const _=[],d=[],b=[];i.reverse().forEach(v=>{var l;const t=v[2].map(o=>{const a=new k(this,this._textDocumentsAndEditors,o);if(s||d.push(k.asModelAddData(this.notebookDocument,o)),!this._cellDisposableMapping.has(a.handle)){const f=new I.DisposableStore;f.add(a),this._cellDisposableMapping.set(a.handle,f)}return a});for(let o=v[0];o<v[0]+v[1];o++)(l=this._cellDisposableMapping.get(this._cells[o].handle))===null||l===void 0||l.dispose(),this._cellDisposableMapping.delete(this._cells[o].handle);const r=new T(v[0],v[1],[],t),c=this._cells.splice(v[0],v[1],...t);for(let o of c)b.push(o.uri),r.deletedItems.push(o.cell);_.push(r)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:d,removedDocuments:b}),s||this._emitter.emitModelChange((0,A.deepFreeze)({document:this.notebookDocument,changes:T.asApiEvents(_)}))}}_moveCell(i,s){const _=this._cells.splice(i,1);this._cells.splice(s,0,..._);const d=[new T(i,1,_.map(b=>b.cell),[]),new T(s,0,[],_)];this._emitter.emitModelChange((0,A.deepFreeze)({document:this.notebookDocument,changes:T.asApiEvents(d)}))}_setCellOutputs(i,s){const _=this._cells[i];_.setOutputs(s),this._emitter.emitCellOutputsChange((0,A.deepFreeze)({document:this.notebookDocument,cells:[_.cell]}))}_setCellOutputItems(i,s,_,d){const b=this._cells[i];b.setOutputItems(s,_,d),this._emitter.emitCellOutputsChange((0,A.deepFreeze)({document:this.notebookDocument,cells:[b.cell]}))}_changeCellLanguage(i,s){const _=this._cells[i];_.cell.document.languageId!==s&&this._textDocuments.$acceptModelModeChanged(_.uri,s)}_changeCellMetadata(i,s){var _;const d=this._cells[i],b=d.internalMetadata,v=d.cell.metadata;d.setMetadata(s);const l=d.cell.metadata;if((0,A.equals)(v,l)||this._emitter.emitCellMetadataChange((0,A.deepFreeze)({document:this.notebookDocument,cell:d.cell})),b.runState!==s.runState){const u=(_=s.runState)!==null&&_!==void 0?_:y.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,A.deepFreeze)({document:this.notebookDocument,cell:d.cell,executionState:u}))}}getCellFromIndex(i){return this._cells[i]}getCell(i){return this._cells.find(s=>s.handle===i)}getCellIndex(i){return this._cells.indexOf(i)}}e.ExtHostNotebookDocument=g,g._handlePool=0}),define(_e[178],we([0,1,7,9]),function(ie,e,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class P{constructor(C){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=C}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(C){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:C})}replaceCellMetadata(C,y){this._throwIfFinalized(),this._collectedEdits.push({editType:3,index:C,metadata:y})}replaceCellOutput(C,y){this._throwIfFinalized(),this._collectedEdits.push({editType:2,index:C,outputs:y.map(n=>I.NotebookCellOutput.from(n))})}replaceCells(C,y,n){this._throwIfFinalized(),!(C===y&&n.length===0)&&this._collectedEdits.push({editType:1,index:C,count:y-C,cells:n.map(I.NotebookCellData.from)})}}class A{constructor(C,y,n,T,k,g){this.id=C,this._proxy=y,this.notebookData=n,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=k,this._visibleRanges=T,this._viewColumn=g}get editor(){if(!this._editor){const C=this;this._editor={get document(){return C.notebookData.notebookDocument},get selections(){return C._selections},get visibleRanges(){return C._visibleRanges},revealRange(y,n){C._proxy.$tryRevealRange(C.id,I.NotebookCellRange.from(y),n!=null?n:E.NotebookEditorRevealType.Default)},get viewColumn(){return C._viewColumn},edit(y){const n=new P(this.document.version);return y(n),C._applyEdit(n.finalize())},get kernel(){return C._kernel},setDecorations(y,n){return C.setDecorations(y,n)}}}return this._editor}_acceptKernel(C){this._kernel=C}get visible(){return this._visible}_acceptVisibility(C){this._visible=C}_acceptVisibleRanges(C){this._visibleRanges=C}_acceptSelections(C){this._selections=C}_acceptViewColumn(C){this._viewColumn=C}_applyEdit(C){if(C.cellEdits.length===0)return Promise.resolve(!0);const y=[];let n=-1;for(let T=0;T<C.cellEdits.length;T++){if(n<0){y.push(C.cellEdits[T]),n++;continue}const g=y[n],m=C.cellEdits[T];if(g.editType===1&&m.editType===1&&g.index===m.index){g.cells.push(...C.cellEdits[T].cells),g.count+=C.cellEdits[T].count;continue}y.push(C.cellEdits[T]),n++}return this._proxy.$tryApplyEdits(this.id,C.documentVersionId,y)}setDecorations(C,y){if(!(y.isEmpty&&!this._hasDecorationsForKey.has(C.key)))return y.isEmpty?this._hasDecorationsForKey.delete(C.key):this._hasDecorationsForKey.add(C.key),this._proxy.$trySetDecorations(this.id,I.NotebookCellRange.from(y),C.key)}}e.ExtHostNotebookEditor=A}),define(_e[179],we([0,1,9,152,132,20,51]),function(ie,e,E,I,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class C{constructor(k){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=k}withProgress(k,g,m){const i=this._handles++,{title:s,location:_,cancellable:d}=g,b={label:(0,P.localize)(0,null,k.displayName||k.name),id:k.identifier.value};return this._proxy.$startProgress(i,{location:E.ProgressLocation.from(_),title:s,source:b,cancellable:d},k),this._withProgress(i,m,!!d)}_withProgress(k,g,m){let i;m&&(i=new A.CancellationTokenSource,this._mapHandleToCancellationSource.set(k,i));const s=d=>{this._proxy.$progressEnd(d),this._mapHandleToCancellationSource.delete(d),i&&i.dispose()};let _;try{_=g(new n(this._proxy,k),m&&i?i.token:A.CancellationToken.None)}catch(d){throw s(k),d}return _.then(d=>s(k),d=>s(k)),_}$acceptProgressCanceled(k){const g=this._mapHandleToCancellationSource.get(k);g&&(g.cancel(),this._mapHandleToCancellationSource.delete(k))}}e.ExtHostProgress=C;function y(T,k){return T.message=k.message,typeof k.increment=="number"&&(typeof T.increment=="number"?T.increment+=k.increment:T.increment=k.increment),T}class n extends I.Progress{constructor(k,g){super(m=>this.throttledReport(m));this._proxy=k,this._handle=g}throttledReport(k){this._proxy.$progressReport(this._handle,k)}}je([(0,S.throttle)(100,(T,k)=>y(T,k),()=>Object.create(null))],n.prototype,"throttledReport",null)}),define(_e[96],we([0,1,42,10,53,9,7]),function(ie,e,E,I,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class C{constructor(g,m){const i=C._Keys.nextId();g.$registerTextEditorDecorationType(i,A.DecorationRenderOptions.from(m)),this.value=Object.freeze({key:i,dispose(){g.$removeTextEditorDecorationType(i)}})}}e.TextEditorDecorationType=C,C._Keys=new P.IdGenerator("TextEditorDecorationType");class y{constructor(g,m){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=g,this._documentVersionId=g.version,this._undoStopBefore=m.undoStopBefore,this._undoStopAfter=m.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(g,m){this._throwIfFinalized();let i=null;if(g instanceof S.Position)i=new S.Range(g,g);else if(g instanceof S.Range)i=g;else throw new Error("Unrecognized location");this._pushEdit(i,m,!1)}insert(g,m){this._throwIfFinalized(),this._pushEdit(new S.Range(g,g),m,!0)}delete(g){this._throwIfFinalized();let m=null;if(g instanceof S.Range)m=g;else throw new Error("Unrecognized location");this._pushEdit(m,null,!0)}_pushEdit(g,m,i){const s=this._document.validateRange(g);this._collectedEdits.push({range:s,text:m,forceMoveMarkers:i})}setEndOfLine(g){if(this._throwIfFinalized(),g!==S.EndOfLine.LF&&g!==S.EndOfLine.CRLF)throw(0,I.illegalArgument)("endOfLine");this._setEndOfLine=g}}e.TextEditorEdit=y;class n{constructor(g,m,i,s){this._proxy=g,this._id=m,this._accept(i),this._logService=s;const _=this;this.value={get tabSize(){return _._tabSize},set tabSize(d){_._setTabSize(d)},get insertSpaces(){return _._insertSpaces},set insertSpaces(d){_._setInsertSpaces(d)},get cursorStyle(){return _._cursorStyle},set cursorStyle(d){_._setCursorStyle(d)},get lineNumbers(){return _._lineNumbers},set lineNumbers(d){_._setLineNumbers(d)}}}_accept(g){this._tabSize=g.tabSize,this._insertSpaces=g.insertSpaces,this._cursorStyle=g.cursorStyle,this._lineNumbers=A.TextEditorLineNumbersStyle.to(g.lineNumbers)}_validateTabSize(g){if(g==="auto")return"auto";if(typeof g=="number"){const m=Math.floor(g);return m>0?m:null}if(typeof g=="string"){const m=parseInt(g,10);return isNaN(m)?null:m>0?m:null}return null}_setTabSize(g){const m=this._validateTabSize(g);if(m!==null){if(typeof m=="number"){if(this._tabSize===m)return;this._tabSize=m}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:m}))}}_validateInsertSpaces(g){return g==="auto"?"auto":g==="false"?!1:Boolean(g)}_setInsertSpaces(g){const m=this._validateInsertSpaces(g);if(typeof m=="boolean"){if(this._insertSpaces===m)return;this._insertSpaces=m}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:m}))}_setCursorStyle(g){this._cursorStyle!==g&&(this._cursorStyle=g,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:g})))}_setLineNumbers(g){this._lineNumbers!==g&&(this._lineNumbers=g,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:A.TextEditorLineNumbersStyle.from(g)})))}assign(g){const m={};let i=!1;if(typeof g.tabSize!="undefined"){const s=this._validateTabSize(g.tabSize);s==="auto"?(i=!0,m.tabSize=s):typeof s=="number"&&this._tabSize!==s&&(this._tabSize=s,i=!0,m.tabSize=s)}if(typeof g.insertSpaces!="undefined"){const s=this._validateInsertSpaces(g.insertSpaces);s==="auto"?(i=!0,m.insertSpaces=s):this._insertSpaces!==s&&(this._insertSpaces=s,i=!0,m.insertSpaces=s)}typeof g.cursorStyle!="undefined"&&this._cursorStyle!==g.cursorStyle&&(this._cursorStyle=g.cursorStyle,i=!0,m.cursorStyle=g.cursorStyle),typeof g.lineNumbers!="undefined"&&this._lineNumbers!==g.lineNumbers&&(this._lineNumbers=g.lineNumbers,i=!0,m.lineNumbers=A.TextEditorLineNumbersStyle.from(g.lineNumbers)),i&&this._warnOnError(this._proxy.$trySetOptions(this._id,m))}_warnOnError(g){g.catch(m=>this._logService.warn(m))}}e.ExtHostTextEditorOptions=n;class T{constructor(g,m,i,s,_,d,b,v){this.id=g,this._proxy=m,this._logService=i,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=_,this._options=new n(this._proxy,this.id,d,i),this._visibleRanges=b,this._viewColumn=v;const l=this;this.value=Object.freeze({get document(){return s.getValue()},set document(u){throw(0,I.readonly)("document")},get selection(){return l._selections&&l._selections[0]},set selection(u){if(!(u instanceof S.Selection))throw(0,I.illegalArgument)("selection");l._selections=[u],l._trySetSelection()},get selections(){return l._selections},set selections(u){if(!Array.isArray(u)||u.some(t=>!(t instanceof S.Selection)))throw(0,I.illegalArgument)("selections");l._selections=u,l._trySetSelection()},get visibleRanges(){return l._visibleRanges},set visibleRanges(u){throw(0,I.readonly)("visibleRanges")},get options(){return l._options.value},set options(u){l._disposed||l._options.assign(u)},get viewColumn(){return l._viewColumn},set viewColumn(u){throw(0,I.readonly)("viewColumn")},edit(u,t={undoStopBefore:!0,undoStopAfter:!0}){if(l._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new y(s.getValue(),t);return u(r),l._applyEdit(r)},insertSnippet(u,t,r={undoStopBefore:!0,undoStopAfter:!0}){if(l._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let c;if(!t||Array.isArray(t)&&t.length===0)c=l._selections.map(o=>A.Range.from(o));else if(t instanceof S.Position){const{lineNumber:o,column:a}=A.Position.from(t);c=[{startLineNumber:o,startColumn:a,endLineNumber:o,endColumn:a}]}else if(t instanceof S.Range)c=[A.Range.from(t)];else{c=[];for(const o of t)if(o instanceof S.Range)c.push(A.Range.from(o));else{const{lineNumber:a,column:f}=A.Position.from(o);c.push({startLineNumber:a,startColumn:f,endLineNumber:a,endColumn:f})}}return m.$tryInsertSnippet(g,u.value,c,r)},setDecorations(u,t){const r=t.length===0;r&&!l._hasDecorationsForKey.has(u.key)||(r?l._hasDecorationsForKey.delete(u.key):l._hasDecorationsForKey.add(u.key),l._runOnProxy(()=>{if(A.isDecorationOptionsArr(t))return m.$trySetDecorations(g,u.key,A.fromRangeOrRangeWithMessage(t));{const c=new Array(4*t.length);for(let o=0,a=t.length;o<a;o++){const f=t[o];c[4*o]=f.start.line+1,c[4*o+1]=f.start.character+1,c[4*o+2]=f.end.line+1,c[4*o+3]=f.end.character+1}return m.$trySetDecorationsFast(g,u.key,c)}}))},revealRange(u,t){l._runOnProxy(()=>m.$tryRevealRange(g,A.Range.from(u),t||S.TextEditorRevealType.Default))},show(u){m.$tryShowEditor(g,A.ViewColumn.from(u))},hide(){m.$tryHideEditor(g)}})}dispose(){(0,E.ok)(!this._disposed),this._disposed=!0}_acceptOptions(g){(0,E.ok)(!this._disposed),this._options._accept(g)}_acceptVisibleRanges(g){(0,E.ok)(!this._disposed),this._visibleRanges=g}_acceptViewColumn(g){(0,E.ok)(!this._disposed),this._viewColumn=g}_acceptSelections(g){(0,E.ok)(!this._disposed),this._selections=g}async _trySetSelection(){const g=this._selections.map(A.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,g)),this.value}_applyEdit(g){const m=g.finalize();if(m.edits.length===0&&!m.setEndOfLine)return Promise.resolve(!0);const i=m.edits.map(_=>_.range);i.sort((_,d)=>_.end.line===d.end.line?_.end.character===d.end.character?_.start.line===d.start.line?_.start.character-d.start.character:_.start.line-d.start.line:_.end.character-d.end.character:_.end.line-d.end.line);for(let _=0,d=i.length-1;_<d;_++){const b=i[_].end;if(i[_+1].start.isBefore(b))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const s=m.edits.map(_=>({range:A.Range.from(_.range),text:_.text,forceMoveMarkers:_.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,m.documentVersionId,s,{setEndOfLine:typeof m.setEndOfLine=="number"?A.EndOfLine.from(m.setEndOfLine):void 0,undoStopBefore:m.undoStopBefore,undoStopAfter:m.undoStopAfter})}_runOnProxy(g){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):g().then(()=>this,m=>(m instanceof Error&&m.name==="DISPOSED"||this._logService.warn(m),null))}}e.ExtHostTextEditor=T}),define(_e[180],we([0,1,135,25,2,3,6,14,7,13,11,9,20]),function(ie,e,E,I,P,A,S,C,y,n,T,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function m(_,d){if((0,n.isString)(_))return{label:_};if(_&&typeof _=="object"&&typeof _.label=="string"){let b;return Array.isArray(_.highlights)&&(b=_.highlights.filter(v=>v.length===2&&typeof v[0]=="number"&&typeof v[1]=="number"),b=b.length?b:void 0),{label:_.label,highlights:b}}}class i{constructor(d,b,v){this._proxy=d,this.commands=b,this.logService=v,this.treeViews=new Map;function l(u){return u&&u.$treeViewId&&u.$treeItemHandle}b.registerArgumentProcessor({processArgument:u=>l(u)?this.convertArgument(u):Array.isArray(u)&&u.length>0?u.map(t=>l(t)?this.convertArgument(t):t):u})}registerTreeDataProvider(d,b,v){const l=this.createTreeView(d,{treeDataProvider:b},v);return{dispose:()=>l.dispose()}}createTreeView(d,b,v){if(!b||!b.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const l=this._proxy.$registerTreeViewDataProvider(d,{showCollapseAll:!!b.showCollapseAll,canSelectMany:!!b.canSelectMany}),u=this.createExtHostTreeView(d,b,v);return{get onDidCollapseElement(){return u.onDidCollapseElement},get onDidExpandElement(){return u.onDidExpandElement},get selection(){return u.selectedElements},get onDidChangeSelection(){return u.onDidChangeSelection},get visible(){return u.visible},get onDidChangeVisibility(){return u.onDidChangeVisibility},get message(){return u.message},set message(t){u.message=t},get title(){return u.title},set title(t){u.title=t},get description(){return u.description},set description(t){u.description=t},reveal:(t,r)=>u.reveal(t,r),dispose:async()=>{await l,this.treeViews.delete(d),u.dispose()}}}$getChildren(d,b){const v=this.treeViews.get(d);return v?v.getChildren(b):Promise.reject(new Error((0,E.localize)(0,null,d)))}async $hasResolve(d){const b=this.treeViews.get(d);if(!b)throw new Error((0,E.localize)(1,null,d));return b.hasResolve}$resolve(d,b,v){const l=this.treeViews.get(d);if(!l)throw new Error((0,E.localize)(2,null,d));return l.resolveTreeItem(b,v)}$setExpanded(d,b,v){const l=this.treeViews.get(d);if(!l)throw new Error((0,E.localize)(3,null,d));l.setExpanded(b,v)}$setSelection(d,b){const v=this.treeViews.get(d);if(!v)throw new Error((0,E.localize)(4,null,d));v.setSelection(b)}$setVisible(d,b){const v=this.treeViews.get(d);if(!v)throw new Error((0,E.localize)(5,null,d));v.setVisible(b)}createExtHostTreeView(d,b,v){const l=new s(d,b,this._proxy,this.commands.converter,this.logService,v);return this.treeViews.set(d,l),l}convertArgument(d){const b=this.treeViews.get(d.$treeViewId);return b?b.getExtensionElement(d.$treeItemHandle):null}}e.ExtHostTreeViews=i;class s extends S.Disposable{constructor(d,b,v,l,u,t){super();if(this.viewId=d,this.proxy=v,this.commands=l,this.logService=u,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new A.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new A.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new A.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new A.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new A.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new g.CancellationTokenSource,t.contributes&&t.contributes.views)for(const o in t.contributes.views)for(const a of t.contributes.views[o])a.id===d&&(this._title=a.name);this.dataProvider=b.treeDataProvider,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(o=>this._onDidChangeData.fire({message:!1,element:o})));let r,c;this._register(A.Event.debounce(this._onDidChangeData.event,(o,a)=>(o||(o={message:!1,elements:[]}),a.element!==!1&&(r||(r=new Promise(f=>c=f),this.refreshPromise=this.refreshPromise.then(()=>r)),o.elements.push(a.element)),a.message&&(o.message=!0),o),200,!0)(({message:o,elements:a})=>{a.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const f=c;return r=null,this.refresh(a).then(()=>f())})),o&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(d=>this.getExtensionElement(d)).filter(d=>!(0,n.isUndefinedOrNull)(d))}getChildren(d){const b=d?this.getExtensionElement(d):void 0;if(d&&!b)return this.logService.error(`No tree item with id '${d}' found.`),Promise.resolve([]);const v=this.getChildrenNodes(d);return(v?Promise.resolve(v):this.fetchChildrenNodes(b)).then(l=>l.map(u=>u.item))}getExtensionElement(d){return this.elements.get(d)}reveal(d,b){b=b||{select:!0,focus:!1};const v=(0,n.isUndefinedOrNull)(b.select)?!0:b.select,l=(0,n.isUndefinedOrNull)(b.focus)?!1:b.focus,u=(0,n.isUndefinedOrNull)(b.expand)?!1:b.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):d?this.refreshPromise.then(()=>this.resolveUnknownParentChain(d)).then(t=>this.resolveTreeNode(d,t[t.length-1]).then(r=>this.proxy.$reveal(this.viewId,{item:r.item,parentChain:t.map(c=>c.item)},{select:v,focus:l,expand:u})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:v,focus:l,expand:u})}get message(){return this._message}set message(d){this._message=d,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(d){this._title=d,this.proxy.$setTitle(this.viewId,d,this._description)}get description(){return this._description}set description(d){this._description=d,this.proxy.$setTitle(this.viewId,this._title,d)}setExpanded(d,b){const v=this.getExtensionElement(d);v&&(b?this._onDidExpandElement.fire(Object.freeze({element:v})):this._onDidCollapseElement.fire(Object.freeze({element:v})))}setSelection(d){(0,T.equals)(this._selectedHandles,d)||(this._selectedHandles=d,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(d){d!==this._visible&&(this._visible=d,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(d,b){var v;if(!!this.dataProvider.resolveTreeItem){const l=this.elements.get(d);if(l){const u=this.nodes.get(l);if(u){const t=(v=await this.dataProvider.resolveTreeItem(u.extensionItem,l,b))!==null&&v!==void 0?v:u.extensionItem;return u.item.tooltip=this.getTooltip(t.tooltip),u.item.command=this.getCommand(u.disposableStore,t.command),u.item}}}}resolveUnknownParentChain(d){return this.resolveParent(d).then(b=>b?this.resolveUnknownParentChain(b).then(v=>this.resolveTreeNode(b,v[v.length-1]).then(l=>(v.push(l),v))):Promise.resolve([]))}resolveParent(d){const b=this.nodes.get(d);return b?Promise.resolve(b.parent?this.elements.get(b.parent.item.handle):void 0):(0,C.asPromise)(()=>this.dataProvider.getParent(d))}resolveTreeNode(d,b){const v=this.nodes.get(d);return v?Promise.resolve(v):(0,C.asPromise)(()=>this.dataProvider.getTreeItem(d)).then(l=>this.createHandle(d,l,b,!0)).then(l=>this.getChildren(b?b.item.handle:void 0).then(()=>{const u=this.getExtensionElement(l);if(u){const t=this.nodes.get(u);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${l}`)}))}getChildrenNodes(d){if(d){let b;if(typeof d=="string"){const v=this.getExtensionElement(d);b=v?this.nodes.get(v):void 0}else b=d;return b&&b.children||null}return this.roots}async fetchChildrenNodes(d){this.clearChildren(d);const b=new g.CancellationTokenSource(this._refreshCancellationSource.token);try{const v=d?this.nodes.get(d):void 0,l=await this.dataProvider.getChildren(d);if(b.token.isCancellationRequested)return[];const u=await Promise.all((0,T.coalesce)(l||[]).map(async t=>{const r=await this.dataProvider.getTreeItem(t);return r&&!b.token.isCancellationRequested?this.createAndRegisterTreeNode(t,r,v):null}));return b.token.isCancellationRequested?[]:(0,T.coalesce)(u)}finally{b.dispose()}}refresh(d){if(d.some(v=>!v))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new g.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const v=this.getHandlesToRefresh(d);if(v.length)return this.refreshHandles(v)}return Promise.resolve(void 0)}getHandlesToRefresh(d){const b=new Set,v=d.map(u=>this.nodes.get(u));for(const u of v)if(u&&!b.has(u.item.handle)){let t=u;for(;t&&t.parent&&v.findIndex(r=>t&&t.parent&&r&&r.item.handle===t.parent.item.handle)===-1;){const r=this.elements.get(t.parent.item.handle);t=r?this.nodes.get(r):void 0}t&&!t.parent&&b.add(u.item.handle)}const l=[];return b.forEach(u=>{const t=this.elements.get(u);if(t){const r=this.nodes.get(t);r&&(!r.parent||!b.has(r.parent.item.handle))&&l.push(u)}}),l}refreshHandles(d){const b={};return Promise.all(d.map(v=>this.refreshNode(v).then(l=>{l&&(b[v]=l.item)}))).then(()=>Object.keys(b).length?this.proxy.$refresh(this.viewId,b):void 0)}refreshNode(d){const b=this.getExtensionElement(d);if(b){const v=this.nodes.get(b);if(v)return this.clearChildren(b),(0,C.asPromise)(()=>this.dataProvider.getTreeItem(b)).then(l=>{if(l){const u=this.createTreeNode(b,l,v.parent);return this.updateNodeCache(b,u,v,v.parent),v.dispose(),u}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(d,b,v){const l=this.createTreeNode(d,b,v);if(b.id&&this.elements.has(l.item.handle))throw new Error((0,E.localize)(6,null,b.id));return this.addNodeToCache(d,l),this.addNodeToParentCache(l,v),l}getTooltip(d){return y.MarkdownString.isMarkdownString(d)?k.MarkdownString.from(d):d}getCommand(d,b){return b?this.commands.toInternal(b,d):void 0}createTreeNode(d,b,v){const l=new S.DisposableStore,u=this.createHandle(d,b,v),t=this.getLightIconPath(b);return{item:{handle:u,parentHandle:v?v.item.handle:void 0,label:m(b.label,this.extension),description:b.description,resourceUri:b.resourceUri,tooltip:this.getTooltip(b.tooltip),command:this.getCommand(l,b.command),contextValue:b.contextValue,icon:t,iconDark:this.getDarkIconPath(b)||t,themeIcon:this.getThemeIcon(b),collapsibleState:(0,n.isUndefinedOrNull)(b.collapsibleState)?y.TreeItemCollapsibleState.None:b.collapsibleState,accessibilityInformation:b.accessibilityInformation},extensionItem:b,parent:v,children:void 0,disposableStore:l,dispose(){l.dispose()}}}getThemeIcon(d){return d.iconPath instanceof y.ThemeIcon?d.iconPath:void 0}createHandle(d,{id:b,label:v,resourceUri:l},u,t){if(b)return`${s.ID_HANDLE_PREFIX}/${b}`;const r=m(v,this.extension),c=u?u.item.handle:s.LABEL_HANDLE_PREFIX;let o=r?r.label:l?(0,I.basename)(l):"";o=o.indexOf("/")!==-1?o.replace("/","//"):o;const a=this.nodes.has(d)?this.nodes.get(d).item.handle:void 0,f=this.getChildrenNodes(u)||[];let w,D=0;do{if(w=`${c}/${D}:${o}`,t||!this.elements.has(w)||a===w)break;D++}while(D<=f.length);return w}getLightIconPath(d){if(d.iconPath&&!(d.iconPath instanceof y.ThemeIcon))return typeof d.iconPath=="string"||P.URI.isUri(d.iconPath)?this.getIconPath(d.iconPath):this.getIconPath(d.iconPath.light)}getDarkIconPath(d){if(d.iconPath&&!(d.iconPath instanceof y.ThemeIcon)&&d.iconPath.dark)return this.getIconPath(d.iconPath.dark)}getIconPath(d){return P.URI.isUri(d)?d:P.URI.file(d)}addNodeToCache(d,b){this.elements.set(b.item.handle,d),this.nodes.set(d,b)}updateNodeCache(d,b,v,l){this.elements.delete(b.item.handle),this.nodes.delete(d),b.item.handle!==v.item.handle&&this.elements.delete(v.item.handle),this.addNodeToCache(d,b);const u=this.getChildrenNodes(l)||[],t=u.filter(r=>r.item.handle===v.item.handle)[0];t&&u.splice(u.indexOf(t),1,b)}addNodeToParentCache(d,b){b?(b.children||(b.children=[]),b.children.push(d)):(this.roots||(this.roots=[]),this.roots.push(d))}clearChildren(d){if(d){const b=this.nodes.get(d);if(b){if(b.children)for(const v of b.children){const l=this.elements.get(v.item.handle);l&&this.clear(l)}b.children=void 0}}else this.clearAll()}clear(d){const b=this.nodes.get(d);if(b){if(b.children)for(const v of b.children){const l=this.elements.get(v.item.handle);l&&this.clear(l)}this.nodes.delete(d),this.elements.delete(b.item.handle),b.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(d=>d.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}s.LABEL_HANDLE_PREFIX="0",s.ID_HANDLE_PREFIX="1"}),define(_e[181],we([0,1,11,14,20,9,7,95]),function(ie,e,E,I,P,A,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class y{constructor(){this.testIdsToInternal=new Map}getTestById(i,s){if(s!==void 0){const _=this.testIdsToInternal.get(s),d=_==null?void 0:_.get(i);if(d)return[_,d]}return(0,E.mapFind)(this.testIdsToInternal.values(),_=>{const d=_.get(i);return d&&[_,d]})}createForHierarchy(i=()=>{}){return new g(this.createIdMap(T++),i)}createIdMap(i){const s=new k(i);return this.testIdsToInternal.set(s.id,s),{object:s,dispose:()=>this.testIdsToInternal.delete(s.id)}}}e.OwnedTestCollection=y;var n;(function(m){m[m.Disconnected=0]="Disconnected",m[m.IsChild=1]="IsChild",m[m.IsParent=2]="IsParent",m[m.IsSame=3]="IsSame"})(n=e.TestPosition||(e.TestPosition={}));let T=0;class k{constructor(i){this.id=i,this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(i){if(this.map.has(i.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${i.item.extId}`);this.map.set(i.item.extId,i),i.parent||this._roots.add(i)}has(i){return this.map.has(i)}delete(i){const s=this.map.get(i);return s?(this.map.delete(i),this._roots.delete(s),!0):!1}get(i){return this.map.get(i)}comparePositions(i,s){const _=typeof i=="string"?this.map.get(i):i,d=typeof s=="string"?this.map.get(s):s;if(!_||!d)return 0;if(_===d)return 3;for(let b=this.map.get(d.parent);b;b=this.map.get(b.parent))if(b===_)return 1;for(let b=this.map.get(_.parent);b;b=this.map.get(b.parent))if(b===d)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=k;class g{constructor(i,s){this.testIdToInternal=i,this.publishDiff=s,this.testItemToInternal=new Map,this.diff=[],this.debounceSendDiff=new I.RunOnceScheduler(()=>this.flushDiff(),200)}get treeId(){return this.testIdToInternal.object.id}addRoot(i,s){this.addItem(i,s,null)}getTestByReference(i){return this.testItemToInternal.get(i)}collectDiff(){const i=this.diff;return this.diff=[],i}pushDiff(i){const s=this.diff[this.diff.length-1];if(s&&i[0]===1){if(s[0]===1&&s[1].extId===i[1].extId){(0,C.applyTestItemUpdate)(s[1],i[1]);return}if(s[0]===0&&s[1].item.extId===i[1].extId){(0,C.applyTestItemUpdate)(s[1],i[1]);return}}this.diff.push(i),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(i,s){var _;const d=this.testIdToInternal.object.get(i);if(!!d){if((d.expandLevels===void 0||s>d.expandLevels)&&(d.expandLevels=s),d.expand===1){const b=this.refreshChildren(d);return b.isSettled?this.expandChildren(d,s-1):b.p.then(()=>this.expandChildren(d,s-1))}else if(d.expand===3)return((_=d.initialExpand)===null||_===void 0?void 0:_.isSettled)===!1?d.initialExpand.p.then(()=>this.expandChildren(d,s-1)):this.expandChildren(d,s-1)}}dispose(){var i;for(const s of this.testItemToInternal.values())(i=s.discoverCts)===null||i===void 0||i.dispose(!0),s.actual[S.TestItemHookProperty]=void 0;this.diff=[],this.testIdToInternal.dispose(),this.debounceSendDiff.dispose()}addItem(i,s,_){if(!(i instanceof S.TestItem))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${i.id} did not`);if(this.testItemToInternal.has(i))throw new Error(`Attempted to add a single TestItem ${i.id} multiple times to the tree`);if(this.testIdToInternal.object.has(i.id))throw new Error(`Attempted to insert a duplicate test item ID ${i.id}`);const d=_?_.item.extId:null,b=i.expandable?1:0,v=_==null?void 0:_.expandLevels,l={provider:s,tree:this.testIdToInternal.object.id},u={actual:i,parent:d,item:A.TestItem.from(i),expandLevels:v&&b===1?v-1:void 0,expand:b,src:l};this.testIdToInternal.object.add(u),this.testItemToInternal.set(i,u),this.pushDiff([0,{parent:d,src:l,expand:b,item:u.item}]),i[S.TestItemHookProperty]={created:t=>this.addItem(t,s,u),delete:t=>this.removeItembyId(t),invalidate:t=>this.pushDiff([4,t]),setProp:(t,r)=>this.pushDiff([1,{extId:i.id,item:{[t]:t==="range"?A.Range.from(r):r}}])};for(const t of i.children)this.addItem(t,s,u)}expandChildren(i,s){if(!(s<0)){const _=[...i.actual.children].map(d=>this.expand(d.id,s-1)).filter(I.isThenable);if(_.length)return Promise.all(_).then(()=>{})}}refreshChildren(i){i.discoverCts&&i.discoverCts.dispose(!0),i.expand=2,i.discoverCts=new P.CancellationTokenSource,this.pushExpandStateUpdate(i);const s=new I.DeferredPromise;return i.initialExpand=s,i.actual.discoverChildren({report:_=>{_.busy?(i.expand=2,this.pushExpandStateUpdate(i)):(i.expand=3,s.isSettled||s.complete(),this.pushExpandStateUpdate(i))}},i.discoverCts.token),s}pushExpandStateUpdate(i){this.pushDiff([1,{extId:i.actual.id,expand:i.expand}])}removeItembyId(i){var s;this.pushDiff([2,i]);const _=[this.testIdToInternal.object.get(i)];for(;_.length;){const d=_.pop();if(!!d){(s=d.discoverCts)===null||s===void 0||s.dispose(!0),this.testIdToInternal.object.delete(d.item.extId),this.testItemToInternal.delete(d.actual);for(const b of d.actual.children)_.push(this.testIdToInternal.object.get(b.id))}}}flushDiff(){const i=this.collectDiff();i.length&&this.publishDiff(i)}}e.SingleUseTestCollection=g}),define(_e[182],we([0,1,26,3,12]),function(ie,e,E,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class A{constructor(T){this.removedDueToLooping=T}}e.DeltaExtensionsResult=A;class S{constructor(T){this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=T,this._initialize()}_initialize(){this._extensionDescriptions.sort(y),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const T of this._extensionDescriptions){if(this._extensionsMap.has(E.ExtensionIdentifier.toKey(T.identifier))){console.error("Extension `"+T.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(E.ExtensionIdentifier.toKey(T.identifier),T),this._extensionsArr.push(T),Array.isArray(T.activationEvents))for(let k of T.activationEvents)k==="onUri"&&(k=`onUri:${E.ExtensionIdentifier.toKey(T.identifier)}`),this._activationMap.has(k)||this._activationMap.set(k,[]),this._activationMap.get(k).push(T)}}keepOnly(T){const k=new Set;T.forEach(g=>k.add(E.ExtensionIdentifier.toKey(g))),this._extensionDescriptions=this._extensionDescriptions.filter(g=>k.has(E.ExtensionIdentifier.toKey(g.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(T,k){T.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(T));const g=S._findLoopingExtensions(this._extensionDescriptions);if(k=k.concat(g.map(m=>m.identifier)),k.length>0){const m=new Set;k.forEach(i=>m.add(E.ExtensionIdentifier.toKey(i))),this._extensionDescriptions=this._extensionDescriptions.filter(i=>!m.has(E.ExtensionIdentifier.toKey(i.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new A(g)}static _findLoopingExtensions(T){const k=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(_){this._nodesSet.has(_)||(this._nodesSet.add(_),this._nodesArr.push(_))}addArc(_,d){this.addNode(_),this.addNode(d),this._arcs.has(_)?this._arcs.get(_).push(d):this._arcs.set(_,[d])}getArcs(_){return this._arcs.has(_)?this._arcs.get(_):[]}hasOnlyGoodArcs(_,d){const b=k.getArcs(_);for(let v=0;v<b.length;v++)if(!d.has(b[v]))return!1;return!0}getNodes(){return this._nodesArr}};let g=new Map;for(let _ of T){const d=E.ExtensionIdentifier.toKey(_.identifier);if(g.set(d,_),_.extensionDependencies)for(let b of _.extensionDependencies){const v=E.ExtensionIdentifier.toKey(b);k.addArc(d,v)}}let m=new Set;k.getNodes().filter(_=>k.getArcs(_).length===0).forEach(_=>m.add(_));let i=k.getNodes().filter(_=>!m.has(_)),s;do{s=!1;for(let _=0;_<i.length;_++){const d=i[_];k.hasOnlyGoodArcs(d,m)&&(i.splice(_,1),_--,m.add(d),s=!0)}}while(s);return i.map(_=>g.get(_))}containsActivationEvent(T){return this._activationMap.has(T)}containsExtension(T){return this._extensionsMap.has(E.ExtensionIdentifier.toKey(T))}getExtensionDescriptionsForActivationEvent(T){const k=this._activationMap.get(T);return k?k.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(T){const k=this._extensionsMap.get(E.ExtensionIdentifier.toKey(T));return k||void 0}}e.ExtensionDescriptionRegistry=S;var C;(function(n){n[n.Builtin=0]="Builtin",n[n.User=1]="User",n[n.Dev=2]="Dev"})(C||(C={}));function y(n,T){const k=n.isBuiltin?0:n.isUnderDevelopment?2:1,g=T.isBuiltin?0:T.isUnderDevelopment?2:1;if(k!==g)return k-g;const m=P.posix.basename(n.extensionLocation.path),i=P.posix.basename(T.extensionLocation.path);return m<i?-1:m>i?1:0}}),define(_e[183],we([0,1,23]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var I;(function(C){C[C.VersionMismatch=55]="VersionMismatch",C[C.UnexpectedError=81]="UnexpectedError"})(I=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var P;(function(C){C[C.Initialized=0]="Initialized",C[C.Ready=1]="Ready",C[C.Terminate=2]="Terminate"})(P=e.MessageType||(e.MessageType={}));function A(C){const y=E.VSBuffer.alloc(1);switch(C){case 0:y.writeUInt8(1,0);break;case 1:y.writeUInt8(2,0);break;case 2:y.writeUInt8(3,0);break}return y}e.createMessageOfType=A;function S(C,y){if(C.byteLength!==1)return!1;switch(C.readUInt8(0)){case 1:return y===0;case 2:return y===1;case 3:return y===2;default:return!1}}e.isMessageOfType=S}),define(_e[33],we([0,1,3,2,4,26,149]),function(ie,e,E,I,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingDependencyError=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:I.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,P.createDecorator)("extensionService");class C{constructor(b){this.dependency=b}}e.MissingDependencyError=C;var y;(function(d){d[d.LocalProcess=0]="LocalProcess",d[d.LocalWebWorker=1]="LocalWebWorker",d[d.Remote=2]="Remote"})(y=e.ExtensionHostKind||(e.ExtensionHostKind={}));class n{constructor(b,v,l,u){this.codeLoadingTime=b,this.activateCallTime=v,this.activateResolvedTime=l,this.activationReason=u}}e.ActivationTimes=n;class T{constructor(b,v){this.description=b,this.value=v}}e.ExtensionPointContribution=T,e.ExtensionHostLogFileName="exthost";var k;(function(d){d[d.Normal=0]="Normal",d[d.Immediate=1]="Immediate"})(k=e.ActivationKind||(e.ActivationKind={}));function g(d){d.enableProposedApi||m(d)}e.checkProposedApiEnabled=g;function m(d){throw new Error(`[${d.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${d.identifier.value}`)}e.throwProposedApiError=m;function i(d){return{type:d.isBuiltin?0:1,isBuiltin:d.isBuiltin||d.isUserBuiltin,identifier:{id:(0,S.getGalleryExtensionId)(d.publisher,d.name),uuid:d.uuid},manifest:d,location:d.extensionLocation}}e.toExtension=i;function s(d){return Object.assign(Object.assign({identifier:new A.ExtensionIdentifier(d.identifier.id),isBuiltin:d.type===0,isUserBuiltin:d.type===1&&d.isBuiltin,isUnderDevelopment:!1,extensionLocation:d.location},d.manifest),{uuid:d.identifier.uuid})}e.toExtensionDescription=s;class _{constructor(){this.onDidRegisterExtensions=E.Event.None,this.onDidChangeExtensionsStatus=E.Event.None,this.onDidChangeExtensions=E.Event.None,this.onWillActivateByEvent=E.Event.None,this.onDidChangeResponsiveChange=E.Event.None}activateByEvent(b){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(b){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(b){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(b){}canAddExtension(){return!1}canRemoveExtension(){return!1}_logOrShowMessage(b,v){}_activateById(b,v){return Promise.resolve()}_onWillActivateExtension(b){}_onDidActivateExtension(b,v,l,u,t){}_onExtensionRuntimeError(b,v){}_onExtensionHostExit(b){}}e.NullExtensionService=_}),define(_e[184],we([0,1,130,26,33,19]),function(ie,e,E,I,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const S=Promise.resolve(void 0);class C{constructor(s,_,d,b){this.startup=s,this.codeLoadingTime=_,this.activateCallTime=d,this.activateResolvedTime=b}}e.ExtensionActivationTimes=C,C.NONE=new C(!1,-1,-1,-1);class y{constructor(s){this._startup=s,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(s,_){return s===-1||_===-1?-1:_-s}build(){return new C(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=y;class n{constructor(s,_,d,b,v,l){this.activationFailed=s,this.activationFailedError=_,this.activationTimes=d,this.module=b,this.exports=v,this.subscriptions=l}}e.ActivatedExtension=n;class T extends n{constructor(s){super(!1,null,s,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=T;class k extends n{constructor(){super(!1,null,C.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=k;class g extends n{constructor(s){super(!0,s,C.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=g;let m=class{constructor(s,_,d,b,v){this._logService=v,this._registry=s,this._resolvedExtensionsSet=new Set,_.forEach(l=>this._resolvedExtensionsSet.add(I.ExtensionIdentifier.toKey(l))),this._hostExtensionsMap=new Map,d.forEach(l=>this._hostExtensionsMap.set(I.ExtensionIdentifier.toKey(l),l)),this._host=b,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(s){const _=I.ExtensionIdentifier.toKey(s);return this._activatedExtensions.has(_)}getActivatedExtension(s){const _=I.ExtensionIdentifier.toKey(s),d=this._activatedExtensions.get(_);if(!d)throw new Error("Extension `"+s.value+"` is not known or not activated");return d}activateByEvent(s,_){if(this._alreadyActivatedEvents[s])return S;const d=this._registry.getExtensionDescriptionsForActivationEvent(s);return this._activateExtensions(d.map(b=>({id:b.identifier,reason:{startup:_,extensionId:b.identifier,activationEvent:s}}))).then(()=>{this._alreadyActivatedEvents[s]=!0})}activateById(s,_){const d=this._registry.getExtensionDescription(s);if(!d)throw new Error("Extension `"+s+"` is not known");return this._activateExtensions([{id:d.identifier,reason:_}])}_handleActivateRequest(s,_,d){if(this._hostExtensionsMap.has(I.ExtensionIdentifier.toKey(s.id))){_[I.ExtensionIdentifier.toKey(s.id)]=s;return}const b=this._registry.getExtensionDescription(s.id);if(!b){this._host.onExtensionActivationError(s.id,new P.MissingDependencyError(s.id.value));const u=new Error(`Unknown dependency '${s.id.value}'`);this._activatedExtensions.set(I.ExtensionIdentifier.toKey(s.id),new g(u));return}const v=typeof b.extensionDependencies=="undefined"?[]:b.extensionDependencies;let l=!0;for(let u=0,t=v.length;u<t;u++){const r=v[u];if(!this._resolvedExtensionsSet.has(I.ExtensionIdentifier.toKey(r))){const c=this._activatedExtensions.get(I.ExtensionIdentifier.toKey(r));if(!(c&&!c.activationFailed)){if(c&&c.activationFailed){this._host.onExtensionActivationError(b.identifier,E.localize(0,null,b.displayName||b.identifier.value,r));const f=new Error(`Dependency ${r} failed to activate`);f.detail=c.activationFailedError,this._activatedExtensions.set(I.ExtensionIdentifier.toKey(b.identifier),new g(f));return}if(this._hostExtensionsMap.has(I.ExtensionIdentifier.toKey(r))){l=!1,_[I.ExtensionIdentifier.toKey(r)]={id:this._hostExtensionsMap.get(I.ExtensionIdentifier.toKey(r)),reason:s.reason};continue}const o=this._registry.getExtensionDescription(r);if(o){l=!1,_[I.ExtensionIdentifier.toKey(r)]={id:o.identifier,reason:s.reason};continue}this._host.onExtensionActivationError(b.identifier,new P.MissingDependencyError(r));const a=new Error(`Unknown dependency '${r}'`);this._activatedExtensions.set(I.ExtensionIdentifier.toKey(b.identifier),new g(a));return}}}l?_[I.ExtensionIdentifier.toKey(b.identifier)]=s:d.push(s)}_activateExtensions(s){if(s.length===0||(s=s.filter(v=>!this._activatedExtensions.has(I.ExtensionIdentifier.toKey(v.id))),s.length===0))return Promise.resolve(void 0);const _=Object.create(null),d=[];for(let v=0,l=s.length;v<l;v++)this._handleActivateRequest(s[v],_,d);for(let v=0,l=d.length;v<l;v++){const u=I.ExtensionIdentifier.toKey(d[v].id);_[u]&&delete _[u]}const b=Object.keys(_).map(v=>_[v]);return d.length===0?Promise.all(b.map(v=>this._activateExtension(v.id,v.reason))).then(v=>{}):this._activateExtensions(b).then(v=>this._activateExtensions(d))}_activateExtension(s,_){const d=I.ExtensionIdentifier.toKey(s);if(this._activatedExtensions.has(d))return Promise.resolve(void 0);const b=this._activatingExtensions.get(d);if(b)return b;const v=this._host.actualActivateExtension(s,_).then(void 0,l=>(this._host.onExtensionActivationError(s,E.localize(1,null,s.value,l.message)),this._logService.error(`Activating extension ${s.value} failed due to an error:`),this._logService.error(l),new g(l))).then(l=>{this._activatedExtensions.set(d,l),this._activatingExtensions.delete(d)});return this._activatingExtensions.set(d,v),v}};m=je([Ke(4,A.ILogService)],m),e.ExtensionsActivator=m}),define(_e[185],we([0,1,10]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class I{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((A,S)=>{this._actualOk=A,this._actualErr=S,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(A){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=A,this._actual&&this._actualOk(A))}resolveErr(A){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=A,this._actual?this._actualErr(A):(0,E.onUnexpectedError)(A))}then(A,S){return this._ensureActual().then(A,S)}catch(A){return this._ensureActual().then(void 0,A)}finally(A){return this._ensureActual().finally(A)}}e.LazyPromise=I}),define(_e[97],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class E{constructor(y,n){this.isMain=y,this.sid=n,this.nid=++E.count}}e.ProxyIdentifier=E,E.count=0;const I=[];function P(C){const y=new E(!0,C);return I[y.nid]=y,y}e.createMainContextProxyIdentifier=P;function A(C){const y=new E(!1,C);return I[y.nid]=y,y}e.createExtHostContextProxyIdentifier=A;function S(C){return I[C].sid}e.getStringIdentifierForProxy=S}),define(_e[5],we([0,1,2,97,57]),function(ie,e,E,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.CellKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var A;(function(l){l[l.Desktop=1]="Desktop",l[l.Web=2]="Web"})(A=e.UIKind||(e.UIKind={}));var S;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(S=e.TextEditorRevealType||(e.TextEditorRevealType={}));var C;(function(l){l[l.Editable=0]="Editable",l[l.SupportsHotExit=1]="SupportsHotExit"})(C=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var y;(function(l){l[l.Int8Array=1]="Int8Array",l[l.Uint8Array=2]="Uint8Array",l[l.Uint8ClampedArray=3]="Uint8ClampedArray",l[l.Int16Array=4]="Int16Array",l[l.Uint16Array=5]="Uint16Array",l[l.Int32Array=6]="Int32Array",l[l.Uint32Array=7]="Uint32Array",l[l.Float32Array=8]="Float32Array",l[l.Float64Array=9]="Float64Array",l[l.BigInt64Array=10]="BigInt64Array",l[l.BigUint64Array=11]="BigUint64Array"})(y=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var n;(function(l){l[l.Markdown=1]="Markdown",l[l.Code=2]="Code"})(n=e.CellKind||(e.CellKind={}));var T;(function(l){l[l.Text=1]="Text",l[l.Error=2]="Error",l[l.Rich=3]="Rich"})(T=e.CellOutputKind||(e.CellOutputKind={}));var k;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(k=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var g;(function(l){l[l.None=0]="None",l[l.Process=1]="Process",l[l.Output=2]="Output"})(g=e.CandidatePortSource||(e.CandidatePortSource={}));var m;(function(l){l.name="$ident";function u(r,c){return Object.defineProperty(r,l.name,{value:c,enumerable:!0}),r}l.mixin=u;function t(r){return r[l.name]}l.of=t})(m=e.ObjectIdentifier||(e.ObjectIdentifier={}));class i{static mixin(u){return u._id=i._n++,u}}e.IdObject=i,i._n=0;var s;(function(l){l.label="a",l.kind="b",l.detail="c",l.documentation="d",l.sortText="e",l.filterText="f",l.preselect="g",l.insertText="h",l.insertTextRules="i",l.range="j",l.commitCharacters="k",l.additionalTextEdits="l",l.command="m",l.kindModifier="n",l.label2="o"})(s=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var _;(function(l){l.defaultRanges="a",l.completions="b",l.isIncomplete="c",l.duration="d"})(_=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var d;(function(l){l[l.File=1]="File",l[l.Text=2]="Text",l[l.Cell=3]="Cell"})(d=e.WorkspaceEditType||(e.WorkspaceEditType={}));function b(l){if(l&&l.edits)for(const u of l.edits)typeof u.resource=="object"?u.resource=E.URI.revive(u.resource):(u.newUri=E.URI.revive(u.newUri),u.oldUri=E.URI.revive(u.oldUri)),u.metadata&&u.metadata.iconPath&&(u.metadata=(0,P.revive)(u.metadata));return l}e.reviveWorkspaceEditDto=b;var v;(function(l){l[l.Workspace=0]="Workspace",l[l.TextDocument=1]="TextDocument"})(v=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,I.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,I.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,I.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,I.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,I.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,I.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,I.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,I.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,I.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,I.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,I.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,I.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,I.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,I.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,I.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,I.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,I.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,I.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,I.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,I.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,I.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,I.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,I.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,I.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,I.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,I.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,I.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,I.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,I.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,I.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,I.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadTheming:(0,I.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,I.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,I.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,I.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,I.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,I.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,I.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,I.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,I.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,I.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,I.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,I.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,I.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,I.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,I.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,I.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,I.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,I.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,I.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,I.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,I.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,I.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,I.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,I.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,I.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,I.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookKernels:(0,I.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostTheming:(0,I.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,I.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,I.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,I.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,I.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,I.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(_e[71],we([0,1,5,3,4]),function(ie,e,E,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class A{constructor(C){this._onDidChangePassword=new I.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=C.getProxy(E.MainContext.MainThreadSecretState)}async $onDidChangePassword(C){this._onDidChangePassword.fire(C)}get(C,y){return this._proxy.$getPassword(C,y)}store(C,y,n){return this._proxy.$setPassword(C,y,n)}delete(C,y){return this._proxy.$deletePassword(C,y)}}e.ExtHostSecretState=A,e.IExtHostSecretState=(0,P.createDecorator)("IExtHostSecretState")}),define(_e[72],we([0,1,4,19,5,15]),function(ie,e,E,I,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,E.createDecorator)("IExtHostApiDeprecationService");let S=class{constructor(y,n){this._extHostLogService=n,this._reportedUsages=new Set,this._telemetryShape=y.getProxy(P.MainContext.MainThreadTelemetry)}report(y,n,T){const k=this.getUsageKey(y,n);this._reportedUsages.has(k)||(this._reportedUsages.add(k),n.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${y}' is deprecated. ${T}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:n.identifier.value,apiId:y}))}getUsageKey(y,n){return`${y}-${n.identifier.value}`}};S=je([Ke(0,A.IExtHostRpcService),Ke(1,I.ILogService)],S),e.ExtHostApiDeprecationService=S,e.NullApiDeprecationService=Object.freeze(new class{report(C,y,n){}})}),define(_e[186],we([0,1,3,5,7,26]),function(ie,e,E,I,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class S{constructor(y){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new E.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new E.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=y.getProxy(I.MainContext.MainThreadAuthentication)}$setProviders(y){return this._providers=y,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(y,n,T,k={}){const g=A.ExtensionIdentifier.toKey(y.identifier),m=this._inFlightRequests.get(g)||[],i=T.sort().join(" ");let s=m.find(_=>_.scopes===i);if(s)return s.result;{const _=this._getSession(y,g,n,T,k);s={scopes:i,result:_},m.push(s),this._inFlightRequests.set(g,m);try{await _}finally{const d=m.findIndex(b=>b.scopes===i);d>-1&&(m.splice(d),this._inFlightRequests.set(g,m))}return _}}async _getSession(y,n,T,k,g={}){await this._proxy.$ensureProvider(T);const m=y.displayName||y.name;return this._proxy.$getSession(T,k,n,m,g)}async removeSession(y,n){const T=this._authenticationProviders.get(y);return T?T.provider.removeSession(n):this._proxy.$removeSession(y,n)}registerAuthenticationProvider(y,n,T,k){var g;if(this._authenticationProviders.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this._authenticationProviders.set(y,{label:n,provider:T,options:k!=null?k:{supportsMultipleAccounts:!1}}),this._providers.find(i=>i.id===y)||this._providers.push({id:y,label:n});const m=T.onDidChangeSessions(i=>{var s,_,d;this._proxy.$sendDidChangeSessions(y,{added:(s=i.added)!==null&&s!==void 0?s:[],changed:(_=i.changed)!==null&&_!==void 0?_:[],removed:(d=i.removed)!==null&&d!==void 0?d:[]})});return this._proxy.$registerAuthenticationProvider(y,n,(g=k==null?void 0:k.supportsMultipleAccounts)!==null&&g!==void 0?g:!1),new P.Disposable(()=>{m.dispose(),this._authenticationProviders.delete(y);const i=this._providers.findIndex(s=>s.id===y);i>-1&&this._providers.splice(i),this._proxy.$unregisterAuthenticationProvider(y)})}$createSession(y,n){const T=this._authenticationProviders.get(y);if(T)return Promise.resolve(T.provider.createSession(n));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,n){const T=this._authenticationProviders.get(y);if(T)return Promise.resolve(T.provider.removeSession(n));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,n){const T=this._authenticationProviders.get(y);if(T)return Promise.resolve(T.provider.getSessions(n));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,n){return this._onDidChangeSessions.fire({provider:{id:y,label:n}}),Promise.resolve()}$onDidChangeAuthenticationProviders(y,n){return y.forEach(T=>{this._providers.some(k=>k.id===T.id)||this._providers.push(T)}),n.forEach(T=>{const k=this._providers.findIndex(g=>g.id===T.id);k>-1&&this._providers.splice(k)}),this._onDidChangeAuthenticationProviders.fire({added:y,removed:n}),Promise.resolve()}}e.ExtHostAuthentication=S}),define(_e[187],we([0,1,5,15,9]),function(ie,e,E,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let A=class{constructor(C,y){this._extHostDocumentsAndEditors=y,this._proxy=C.getProxy(E.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(C){const y=P.WorkspaceEdit.from(C,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(y)}};A=je([Ke(0,I.IExtHostRpcService)],A),e.ExtHostBulkEdits=A}),define(_e[188],we([0,1,5]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class I{constructor(A){const S=A.getProxy(E.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return S.$readText()},writeText(C){return S.$writeText(C)}})}}e.ExtHostClipboard=I}),define(_e[73],we([0,1,13,7,9,24,5,11,19,57,32,38,2,6,4,15]),function(ie,e,E,I,P,A,S,C,y,n,T,k,g,m,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let _=class{constructor(t,r){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(S.MainContext.MainThreadCommands),this._logService=r,this.converter=new d(this,c=>{const o=this._apiCommands.get(c);return(o==null?void 0:o.result)===v.Void?o:void 0},r),this._argumentProcessors=[{processArgument(c){return(0,n.revive)(c)}},{processArgument(c){return(0,A.cloneAndChange)(c,function(o){if(T.Range.isIRange(o))return P.Range.to(o);if(k.Position.isIPosition(o))return P.Position.to(o);if(T.Range.isIRange(o.range)&&g.URI.isUri(o.uri))return P.location.to(o);if(!Array.isArray(o))return o})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const r=this.registerCommand(!1,t.id,async(...c)=>{const o=t.args.map((f,w)=>{if(!f.validate(c[w]))throw new Error(`Invalid argument '${f.name}' when running '${t.id}', received: ${c[w]}`);return f.convert(c[w])}),a=await this.executeCommand(t.internalId,...o);return t.result.convert(a,c,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new I.Disposable(()=>{r.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,r,c,o,a){if(this._logService.trace("ExtHostCommands#registerCommand",r),!r.trim().length)throw new Error("invalid id");if(this._commands.has(r))throw new Error(`command '${r}' already exists`);return this._commands.set(r,{callback:c,thisArg:o,description:a}),t&&this._proxy.$registerCommand(r),new I.Disposable(()=>{this._commands.delete(r)&&t&&this._proxy.$unregisterCommand(r)})}executeCommand(t,...r){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,r,!0)}async _doExecuteCommand(t,r,c){if(this._commands.has(t))return this._executeContributedCommand(t,r);{const o=(0,A.cloneAndChange)(r,function(a){if(a instanceof I.Position)return P.Position.from(a);if(a instanceof I.Range)return P.Range.from(a);if(a instanceof I.Location)return P.location.from(a);if(!Array.isArray(a))return a});try{const a=await this._proxy.$executeCommand(t,o,c);return(0,n.revive)(a)}catch(a){if(a instanceof Error&&a.message==="$executeCommand:retry")return this._doExecuteCommand(t,r,!1);throw a}}}async _executeContributedCommand(t,r){const c=this._commands.get(t);if(!c)throw new Error("Unknown command");let{callback:o,thisArg:a,description:f}=c;if(f)for(let w=0;w<f.args.length;w++)try{(0,E.validateConstraint)(r[w],f.args[w].constraint)}catch(D){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${f.args[w].name}' - ${f.args[w].description}`)}try{return await o.apply(a,r)}catch(w){if(t===this.converter.delegatingCommandId){const D=this.converter.getActualCommand(...r);D&&(t=D.command)}throw this._logService.error(w,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...r){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(r=r.map(c=>this._argumentProcessors.reduce((o,a)=>a.processArgument(o),c)),this._executeContributedCommand(t,r)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(r=>(t&&(r=r.filter(c=>c[0]!=="_")),r))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[r,c]of this._commands){let{description:o}=c;o&&(t[r]=o)}return Promise.resolve(t)}};_=je([Ke(0,s.IExtHostRpcService),Ke(1,y.ILogService)],_),e.ExtHostCommands=_,e.IExtHostCommands=(0,i.createDecorator)("IExtHostCommands");class d{constructor(t,r,c){this._commands=t,this._lookupApiCommand=r,this._logService=c,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,r){if(!!t){const c={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return c;const o=this._lookupApiCommand(t.command);if(o)c.id=o.internalId,c.arguments=o.args.map((a,f)=>a.convert(t.arguments&&t.arguments[f]));else if((0,C.isNonEmptyArray)(t.arguments)){const a=++this._cachIdPool;this._cache.set(a,t),r.add((0,m.toDisposable)(()=>{this._cache.delete(a),this._logService.trace("CommandsConverter#DISPOSE",a)})),c.$ident=a,c.id=this.delegatingCommandId,c.arguments=[a],this._logService.trace("CommandsConverter#CREATE",t.command,a)}return c}}fromInternal(t){const r=S.ObjectIdentifier.of(t);return typeof r=="number"?this._cache.get(r):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const r=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],r?r.command:"MISSING"),r?this._commands.executeCommand(r.command,...r.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=d;class b{constructor(t,r,c,o){this.name=t,this.description=r,this.validate=c,this.convert=o}optional(){return new b(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,r){return new b(t!=null?t:this.name,r!=null?r:this.description,this.validate,this.convert)}}e.ApiCommandArgument=b,b.Uri=new b("uri","Uri of a text document",u=>g.URI.isUri(u),u=>u),b.Position=new b("position","A position in a text document",u=>I.Position.isPosition(u),P.Position.from),b.Range=new b("range","A range in a text document",u=>I.Range.isRange(u),P.Range.from),b.Selection=new b("selection","A selection in a text document",u=>I.Selection.isSelection(u),P.Selection.from),b.Number=new b("number","",u=>typeof u=="number",u=>u),b.String=new b("string","",u=>typeof u=="string",u=>u),b.CallHierarchyItem=new b("item","A call hierarchy item",u=>u instanceof I.CallHierarchyItem,P.CallHierarchyItem.to);class v{constructor(t,r){this.description=t,this.convert=r}}e.ApiCommandResult=v,v.Void=new v("no result",u=>u);class l{constructor(t,r,c,o,a){this.id=t,this.internalId=r,this.description=c,this.args=o,this.result=a}}e.ApiCommand=l}),define(_e[189],we([0,1,6,9,7,62,73,167,11,84]),function(ie,e,E,I,P,A,S,C,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const T=[new S.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",g(I.DocumentHighlight.to))),new S.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",(i,s)=>{if(!(0,y.isFalsyOrEmpty)(i)){class _ extends P.SymbolInformation{static to(b){const v=new _(b.name,I.SymbolKind.to(b.kind),b.containerName||"",new P.Location(s[0],I.Range.to(b.range)));return v.detail=b.detail,v.range=v.location.range,v.selectionRange=I.Range.to(b.selectionRange),v.children=b.children?b.children.map(_.to):[],v}}return i.map(_.to)}})),new S.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("options","Formatting options",i=>!0,i=>i)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",g(I.TextEdit.to))),new S.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range,new S.ApiCommandArgument("options","Formatting options",i=>!0,i=>i)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",g(I.TextEdit.to))),new S.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,new S.ApiCommandArgument("ch","Trigger character",i=>typeof i=="string",i=>i),new S.ApiCommandArgument("options","Formatting options",i=>!0,i=>i)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",g(I.TextEdit.to))),new S.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new S.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new S.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new S.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new S.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location-instances.",g(I.location.to))),new S.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Hover-instances.",g(I.Hover.to))),new S.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("position","A position in a text document",i=>Array.isArray(i)&&i.every(s=>P.Position.isPosition(s)),i=>i.map(I.Position.from))],new S.ApiCommandResult("A promise that resolves to an array of ranges.",i=>i.map(s=>{let _;for(const d of s.reverse())_=new P.SelectionRange(I.Range.to(d),_);return _}))),new S.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[S.ApiCommandArgument.String.with("query","Search string")],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",i=>{const s=[];if(Array.isArray(i))for(let _ of i)s.push(..._[1].map(I.WorkspaceSymbol.to));return s})),new S.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A CallHierarchyItem or undefined",i=>i.map(I.CallHierarchyItem.to))),new S.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A CallHierarchyItem or undefined",i=>i.map(I.CallHierarchyIncomingCall.to))),new S.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A CallHierarchyItem or undefined",i=>i.map(I.CallHierarchyOutgoingCall.to))),new S.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("newName","The new symbol name")],new S.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",i=>{if(!!i){if(i.rejectReason)throw new Error(i.rejectReason);return I.WorkspaceEdit.to(i)}})),new S.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new S.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",i=>i.map(I.DocumentLink.to))),new S.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",i=>{if(!!i)return new P.SemanticTokensLegend(i.tokenTypes,i.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",i=>{if(!!i){const s=(0,n.decodeSemanticTokensDto)(i);if(s.type==="full")return new P.SemanticTokens(s.data,void 0)}})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",i=>{if(!!i)return new P.SemanticTokensLegend(i.tokenTypes,i.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",i=>{if(!!i){const s=(0,n.decodeSemanticTokensDto)(i);if(s.type==="full")return new P.SemanticTokens(s.data,void 0)}})),new S.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new S.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(i,s,_)=>{if(!i)return new P.CompletionList([]);const d=i.suggestions.map(b=>I.CompletionItem.to(b,_));return new P.CompletionList(d,i.incomplete)})),new S.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new S.ApiCommandResult("A promise that resolves to SignatureHelp.",i=>{if(i)return I.SignatureHelp.to(i)})),new S.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new S.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(i,s,_)=>g(d=>new P.CodeLens(I.Range.to(d.range),d.command&&_.fromInternal(d.command)))(i))),new S.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",i=>P.Range.isRange(i),i=>P.Selection.isSelection(i)?I.Selection.from(i):I.Range.from(i)),S.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new S.ApiCommandResult("A promise that resolves to an array of Command-instances.",(i,s,_)=>g(d=>{if(d._isSynthetic){if(!d.command)throw new Error("Synthetic code actions must have a command");return _.fromInternal(d.command)}else{const b=new P.CodeAction(d.title,d.kind?new P.CodeActionKind(d.kind):void 0);return d.edit&&(b.edit=I.WorkspaceEdit.to(d.edit)),d.command&&(b.command=_.fromInternal(d.command)),b.isPreferred=d.isPreferred,b}})(i))),new S.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",i=>i?i.map(s=>new P.ColorInformation(I.Range.to(s.range),I.Color.to(s.color))):[])),new S.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new S.ApiCommandArgument("color","The color to show and insert",i=>i instanceof P.Color,I.Color.from),new S.ApiCommandArgument("context","Context object with uri and range",i=>!0,i=>({uri:i.uri,range:I.Range.from(i.range)}))],new S.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",i=>i?i.map(I.ColorPresentation.to):[])),new S.ApiCommand("vscode.executeInlineHintProvider","_executeInlineHintProvider","Execute inline hints provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of InlineHint objects",i=>i.map(I.InlineHint.to))),new S.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new S.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",g(i=>({viewType:i.viewType,displayName:i.displayName,options:{transientOutputs:i.options.transientOutputs,transientMetadata:i.options.transientMetadata},filenamePattern:i.filenamePattern.map(s=>I.NotebookExclusiveDocumentPattern.to(s))})))),new S.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of InlineValue objects",i=>i.map(I.InlineValue.to))),new S.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="number"||typeof i=="object",i=>i&&(typeof i=="number"?[i,void 0]:[I.ViewColumn.from(i.viewColumn),I.TextEditorOpenOptions.from(i)])).optional(),S.ApiCommandArgument.String.with("label","").optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[S.ApiCommandArgument.Uri.with("resource","Resource to open"),S.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="number"||typeof i=="object",i=>i&&(typeof i=="number"?[i,void 0]:[I.ViewColumn.from(i.viewColumn),I.TextEditorOpenOptions.from(i)])).optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[S.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),S.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),S.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="object",i=>i&&[I.ViewColumn.from(i.viewColumn),I.TextEditorOpenOptions.from(i)]).optional()],S.ApiCommandResult.Void)];class k{constructor(s){this._disposables=new E.DisposableStore,this._commands=s}static register(s){return T.forEach(s.registerApiCommand,s),new k(s).registerCommands()}registerCommands(){const s=_=>(...d)=>_(this._commands,...d);this._register(C.RemoveFromRecentlyOpenedAPICommand.ID,s(C.RemoveFromRecentlyOpenedAPICommand.execute),{description:"Removes an entry with the given path from the recently opened list.",args:[{name:"path",description:"Path to remove from recently opened.",constraint:_=>typeof _=="string"}]}),this._register(C.OpenIssueReporter.ID,s(C.OpenIssueReporter.execute),{description:"Opens the issue reporter with the provided extension id as the selected source",args:[{name:"extensionId",description:"extensionId to report an issue on",constraint:_=>typeof _=="string"||typeof _=="object"&&typeof _.extensionId=="string"}]})}_register(s,_,d){const b=this._commands.registerCommand(!1,s,_,this,d);this._disposables.add(b)}}e.ExtHostApiCommands=k;function g(i){return s=>{if(Array.isArray(s))return s.map(i)}}function m(i){if(!!Array.isArray(i)){const s=[];for(const _ of i)A.isLocationLink(_)?s.push(I.DefinitionLink.to(_)):s.push(I.location.to(_));return s}}}),define(_e[190],we([0,1,14,51,3,6,2,62,26,9,7,5]),function(ie,e,E,I,P,A,S,C,y,n,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class g{constructor(l,u,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=l.getProxy(k.MainContext.MainThreadComments),u.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===6){const c=this._commentControllers.get(r.handle);return c||r}else if(r&&r.$mid===7){const c=this._commentControllers.get(r.commentControlHandle);if(!c)return r;const o=c.getCommentThread(r.commentThreadHandle);return o||r}else if(r&&r.$mid===8){const c=this._commentControllers.get(r.thread.commentControlHandle);if(!c)return r;const o=c.getCommentThread(r.thread.commentThreadHandle);return o?{thread:o,text:r.text}:r}else if(r&&r.$mid===9){const c=this._commentControllers.get(r.thread.commentControlHandle);if(!c)return r;const o=c.getCommentThread(r.thread.commentThreadHandle);if(!o)return r;let a=r.commentUniqueId,f=o.getCommentByUniqueId(a);return f||r}else if(r&&r.$mid===10){const c=this._commentControllers.get(r.thread.commentControlHandle);if(!c)return r;const o=c.getCommentThread(r.thread.commentThreadHandle);if(!o)return r;let a=r.text,f=r.commentUniqueId,w=o.getCommentByUniqueId(f);return w?(w.body=a,w):r}return r}})}createCommentController(l,u,t){const r=g.handlePool++,c=new i(l,r,this._proxy,u,t);this._commentControllers.set(c.handle,c);const o=this._commentControllersByExtension.get(y.ExtensionIdentifier.toKey(l.identifier))||[];return o.push(c),this._commentControllersByExtension.set(y.ExtensionIdentifier.toKey(l.identifier),o),c}$createCommentThreadTemplate(l,u,t){const r=this._commentControllers.get(l);!r||r.$createCommentThreadTemplate(u,t)}async $updateCommentThreadTemplate(l,u,t){const r=this._commentControllers.get(l);!r||r.$updateCommentThreadTemplate(u,t)}$deleteCommentThread(l,u){const t=this._commentControllers.get(l);t&&t.$deleteCommentThread(u)}$provideCommentingRanges(l,u,t){const r=this._commentControllers.get(l);if(!r||!r.commentingRangeProvider)return Promise.resolve(void 0);const c=this._documents.getDocument(S.URI.revive(u));return(0,E.asPromise)(()=>r.commentingRangeProvider.provideCommentingRanges(c,t)).then(o=>o?o.map(a=>n.Range.from(a)):void 0)}$toggleReaction(l,u,t,r,c){const o=this._commentControllers.get(l);return!o||!o.reactionHandler?Promise.resolve(void 0):(0,E.asPromise)(()=>{const a=o.getCommentThread(u);if(a){const f=a.getCommentByUniqueId(r.uniqueIdInThread);if(o!==void 0&&f&&o.reactionHandler)return o.reactionHandler(f,d(c))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=g,g.handlePool=0;class m{constructor(l,u,t,r,c,o,a){this._proxy=l,this._commentController=u,this._id=t,this._uri=r,this._range=c,this._comments=o,this.handle=m._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new P.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputDisposables.value=new A.DisposableStore,this._id===void 0&&(this._id=`${u.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,n.Range.from(this._range),a),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=o}set threadId(l){this._id=l}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(l){l.isEqual(this._range)||(this._range=l,this.modifications.range=l,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(l){this._canReply!==l&&(this._canReply=l,this.modifications.canReply=l,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(l){this._label=l,this.modifications.label=l,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(l){this._contextValue=l,this.modifications.contextValue=l,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(l){this._comments=l,this.modifications.comments=l,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(l){this._collapseState=l,this.modifications.collapsibleState=l,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(!this._isDiposed){this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new A.DisposableStore);const l=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),u={};l("range")&&(u.range=n.Range.from(this._range)),l("label")&&(u.label=this.label),l("contextValue")&&(u.contextValue=this.contextValue),l("comments")&&(u.comments=this._comments.map(t=>s(this,this._commentController,t,this._commentsMap))),l("collapsibleState")&&(u.collapseState=b(this._collapseState)),l("canReply")&&(u.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,u)}}getCommentByUniqueId(l){for(let u of this._commentsMap){let t=u[0],r=u[1];if(l===r)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(l=>l.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}m._handlePool=0,je([(0,I.debounce)(100)],m.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=m;class i{constructor(l,u,t,r,c){this._extension=l,this._handle=u,this._proxy=t,this._id=r,this._label=c,this._threads=new Map,this._proxy.$registerCommentController(this.handle,r,c)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(l){this._reactionHandler=l,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!l})}get options(){return this._options}set options(l){this._options=l,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(l,u,t,r){if(typeof l=="string"){const c=new m(this._proxy,this,l,u,t,r,this._extension.identifier);return this._threads.set(c.handle,c),c}else{const c=new m(this._proxy,this,void 0,l,u,t,this._extension.identifier);return this._threads.set(c.handle,c),c}}$createCommentThreadTemplate(l,u){const t=new m(this._proxy,this,void 0,S.URI.revive(l),n.Range.to(u),[],this._extension.identifier);return t.collapsibleState=C.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(l,u){let t=this._threads.get(l);t&&(t.range=n.Range.to(u))}$deleteCommentThread(l){let u=this._threads.get(l);u&&u.dispose(),this._threads.delete(l)}getCommentThread(l){return this._threads.get(l)}dispose(){this._threads.forEach(l=>{l.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function s(v,l,u,t){let r=t.get(u);r||(r=++v.commentHandle,t.set(u,r));const c=u.author&&u.author.iconPath?u.author.iconPath.toString():void 0;return{mode:u.mode,contextValue:u.contextValue,uniqueIdInThread:r,body:n.MarkdownString.from(u.body),userName:u.author.name,userIconPath:c,label:u.label,commentReactions:u.reactions?u.reactions.map(o=>_(o)):void 0}}function _(v){return{label:v.label,iconPath:v.iconPath?n.pathOrURIToURI(v.iconPath):void 0,count:v.count,hasReacted:v.authorHasReacted}}function d(v){return{label:v.label||"",count:v.count||0,iconPath:v.iconPath?S.URI.revive(v.iconPath):"",authorHasReacted:v.hasReacted||!1}}function b(v){if(v!==void 0)switch(v){case T.CommentThreadCollapsibleState.Expanded:return C.CommentThreadCollapsibleState.Expanded;case T.CommentThreadCollapsibleState.Collapsed:return C.CommentThreadCollapsibleState.Collapsed}return C.CommentThreadCollapsibleState.Collapsed}}),define(_e[98],we([0,1,2,5,7,4,15,19,11,8,12]),function(ie,e,E,I,P,A,S,C,y,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let k=class ln{constructor(m,i){this._logService=i,this._provider=new Map,this._proxy=m.getProxy(I.MainContext.MainThreadDecorations)}registerFileDecorationProvider(m,i){const s=ln._handlePool++;this._provider.set(s,{provider:m,extensionId:i}),this._proxy.$registerDecorationProvider(s,i.value);const _=m.onDidChangeFileDecorations&&m.onDidChangeFileDecorations(d=>{if(!d){this._proxy.$onDidChange(s,null);return}let b=(0,y.asArray)(d);if(b.length<=ln._maxEventSize){this._proxy.$onDidChange(s,b);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",i.value,b.length);const v=b.map(t=>({uri:t,rank:(0,n.count)(t.path,"/")})),l=(0,y.groupBy)(v,(t,r)=>t.rank-r.rank||(0,n.compare)(t.uri.path,r.uri.path));let u=[];e:for(let t of l){let r;for(let c of t){let o=(0,T.dirname)(c.uri.path);if(r!==o&&(r=o,u.push(c.uri)>=ln._maxEventSize))break e}}this._proxy.$onDidChange(s,u)});return new P.Disposable(()=>{_==null||_.dispose(),this._proxy.$unregisterDecorationProvider(s),this._provider.delete(s)})}async $provideDecorations(m,i,s){if(!this._provider.has(m))return Object.create(null);const _=Object.create(null),{provider:d,extensionId:b}=this._provider.get(m);return await Promise.all(i.map(async v=>{try{const{uri:l,id:u}=v,t=await Promise.resolve(d.provideFileDecoration(E.URI.revive(l),s));if(!t)return;try{P.FileDecoration.validate(t),_[u]=[t.propagate,t.tooltip,t.badge,t.color]}catch(r){this._logService.warn(`INVALID decoration from extension '${b.value}': ${r}`)}}catch(l){this._logService.error(l)}})),_}};k._handlePool=0,k._maxEventSize=250,k=je([Ke(0,S.IExtHostRpcService),Ke(1,C.ILogService)],k),e.ExtHostDecorations=k,e.IExtHostDecorations=(0,A.createDecorator)("IExtHostDecorations")}),define(_e[191],we([0,1,129,87,2,5,7,9,3,19,22]),function(ie,e,E,I,P,A,S,C,y,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class k{constructor(i,s,_,d,b){this._name=i,this._owner=s,this._maxDiagnosticsPerFile=_,this._proxy=d,this._onDidChangeDiagnostics=b,this._isDisposed=!1,this._data=new T.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(i,s){if(!i){this.clear();return}this._checkDisposed();let _=[];if(P.URI.isUri(i)){if(!s){this.delete(i);return}this._data.set(i,s.slice()),_=[i]}else if(Array.isArray(i)){_=[];let b;i=[...i].sort(k._compareIndexedTuplesByUri);for(const v of i){const[l,u]=v;if((!b||l.toString()!==b.toString())&&(b&&this._data.get(b).length===0&&this._data.delete(b),b=l,_.push(l),this._data.set(l,[])),u){const t=this._data.get(l);t&&t.push(...u)}else{const t=this._data.get(l);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(_),!!this._proxy){const d=[];for(let b of _){let v=[];const l=this._data.get(b);if(l)if(l.length>this._maxDiagnosticsPerFile){v=[];const u=[S.DiagnosticSeverity.Error,S.DiagnosticSeverity.Warning,S.DiagnosticSeverity.Information,S.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let r of l)if(r.severity===u[t]&&v.push(C.Diagnostic.from(r))===this._maxDiagnosticsPerFile)break e;v.push({severity:I.MarkerSeverity.Info,message:(0,E.localize)(0,null,l.length-this._maxDiagnosticsPerFile),startLineNumber:v[v.length-1].startLineNumber,startColumn:v[v.length-1].startColumn,endLineNumber:v[v.length-1].endLineNumber,endColumn:v[v.length-1].endColumn})}else v=l.map(u=>C.Diagnostic.from(u));d.push([b,v])}this._proxy.$changeMany(this._owner,d)}}delete(i){this._checkDisposed(),this._onDidChangeDiagnostics.fire([i]),this._data.delete(i),this._proxy&&this._proxy.$changeMany(this._owner,[[i,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(i,s){this._checkDisposed();for(let _ of this._data.keys())i.apply(s,[_,this.get(_),this])}get(i){this._checkDisposed();const s=this._data.get(i);return Array.isArray(s)?Object.freeze(s.slice(0)):[]}has(i){return this._checkDisposed(),Array.isArray(this._data.get(i))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(i,s){return i[0].toString()<s[0].toString()?-1:i[0].toString()>s[0].toString()?1:0}}e.DiagnosticCollection=k;let g=class xt{constructor(i,s){this._logService=s,this._collections=new Map,this._onDidChangeDiagnostics=new y.Emitter,this.onDidChangeDiagnostics=y.Event.map(y.Event.debounce(this._onDidChangeDiagnostics.event,xt._debouncer,50),xt._mapper),this._proxy=i.getProxy(A.MainContext.MainThreadDiagnostics)}static _debouncer(i,s){return i?i.concat(s):s}static _mapper(i){const s=[],_=new Set;for(const d of i)typeof d=="string"?_.has(d)||(_.add(d),s.push(P.URI.parse(d))):_.has(d.toString())||(_.add(d.toString()),s.push(d));return Object.freeze(s),{uris:s}}createDiagnosticCollection(i,s){const{_collections:_,_proxy:d,_onDidChangeDiagnostics:b,_logService:v}=this,l=new class{$changeMany(r,c){d.$changeMany(r,c),v.trace("[DiagnosticCollection] change many (extension, owner, uris)",i.value,r,c.length===0?"CLEARING":c)}$clear(r){d.$clear(r),v.trace("[DiagnosticCollection] remove all (extension, owner)",i.value,r)}dispose(){d.dispose()}};let u;if(!s)s="_generated_diagnostic_collection_name_#"+xt._idPool++,u=s;else if(!_.has(s))u=s;else{this._logService.warn(`DiagnosticCollection with name '${s}' does already exist.`);do u=s+xt._idPool++;while(_.has(u))}return new class extends k{constructor(){super(s,u,xt._maxDiagnosticsPerFile,l,b);_.set(u,this)}dispose(){super.dispose(),_.delete(u)}}}getDiagnostics(i){if(i)return this._getDiagnostics(i);{const s=new Map,_=[];for(const d of this._collections.values())d.forEach((b,v)=>{let l=s.get(b.toString());typeof l=="undefined"&&(l=_.length,s.set(b.toString(),l),_.push([b,[]])),_[l][1]=_[l][1].concat(...v)});return _}}_getDiagnostics(i){let s=[];for(let _ of this._collections.values())_.has(i)&&(s=s.concat(_.get(i)));return s}$acceptMarkersChange(i){if(!this._mirrorCollection){const s="_generated_mirror",_=new k(s,s,xt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(s,_),this._mirrorCollection=_}for(const[s,_]of i)this._mirrorCollection.set(P.URI.revive(s),_.map(C.Diagnostic.to))}};g._idPool=0,g._maxDiagnosticsPerFile=1e3,g=je([Ke(1,n.ILogService)],g),e.ExtHostDiagnostics=g}),define(_e[192],we([0,1,2,5]),function(ie,e,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class P{constructor(S){this._proxy=S.getProxy(I.MainContext.MainThreadDialogs)}showOpenDialog(S){return this._proxy.$showOpenDialog(S).then(C=>C?C.map(y=>E.URI.revive(y)):void 0)}showSaveDialog(S){return this._proxy.$showSaveDialog(S).then(C=>C?E.URI.revive(C):void 0)}}e.ExtHostDialogs=P}),define(_e[193],we([0,1,10,2,7,5,18,20,8]),function(ie,e,E,I,P,A,S,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class n{constructor(k,g,m){this._documentsAndEditors=g,this._logService=m,this._documentContentProviders=new Map,this._proxy=k.getProxy(A.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,g){if(Object.keys(S.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const m=n._handlePool++;this._documentContentProviders.set(m,g),this._proxy.$registerTextContentProvider(m,k);let i;return typeof g.onDidChange=="function"&&(i=g.onDidChange(s=>{if(s.scheme!==k){this._logService.warn(`Provider for scheme '${k}' is firing event for schema '${s.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(s)&&this.$provideTextDocumentContent(m,s).then(_=>{if(!(!_&&typeof _!="string")){const d=this._documentsAndEditors.getDocument(s);if(!!d){const b=(0,y.splitLines)(_);if(!d.equalLines(b))return this._proxy.$onVirtualDocumentChange(s,_)}}},E.onUnexpectedError)})),new P.Disposable(()=>{this._documentContentProviders.delete(m)&&this._proxy.$unregisterTextContentProvider(m),i&&(i.dispose(),i=void 0)})}$provideTextDocumentContent(k,g){const m=this._documentContentProviders.get(k);return m?Promise.resolve(m.provideTextDocumentContent(I.URI.revive(g),C.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${g.scheme}`))}}e.ExtHostDocumentContentProvider=n,n._handlePool=0}),define(_e[194],we([0,1,3,6,2,5,94,9,13,24]),function(ie,e,E,I,P,A,S,C,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class T{constructor(g,m){this._onDidAddDocument=new E.Emitter,this._onDidRemoveDocument=new E.Emitter,this._onDidChangeDocument=new E.Emitter,this._onDidSaveDocument=new E.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new I.DisposableStore,this._documentLoader=new Map,this._proxy=g.getProxy(A.MainContext.MainThreadDocuments),this._documentsAndEditors=m,this._documentsAndEditors.onDidRemoveDocuments(i=>{for(const s of i)this._onDidRemoveDocument.fire(s.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(i=>{for(const s of i)this._onDidAddDocument.fire(s.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(g){if(!!g){const m=this._documentsAndEditors.getDocument(g);if(m)return m}}getDocument(g){const m=this.getDocumentData(g);if(!(m==null?void 0:m.document))throw new Error(`Unable to retrieve document from URI '${g}'`);return m.document}ensureDocumentData(g){const m=this._documentsAndEditors.getDocument(g);if(m)return Promise.resolve(m);let i=this._documentLoader.get(g.toString());return i||(i=this._proxy.$tryOpenDocument(g).then(s=>{this._documentLoader.delete(g.toString());const _=P.URI.revive(s);return(0,y.assertIsDefined)(this._documentsAndEditors.getDocument(_))},s=>(this._documentLoader.delete(g.toString()),Promise.reject(s))),this._documentLoader.set(g.toString(),i)),i}createDocumentData(g){return this._proxy.$tryCreateDocument(g).then(m=>P.URI.revive(m))}$acceptModelModeChanged(g,m){const i=P.URI.revive(g),s=this._documentsAndEditors.getDocument(i);if(!s)throw new Error("unknown document");this._onDidRemoveDocument.fire(s.document),s._acceptLanguageId(m),this._onDidAddDocument.fire(s.document)}$acceptModelSaved(g){const m=P.URI.revive(g),i=this._documentsAndEditors.getDocument(m);if(!i)throw new Error("unknown document");this.$acceptDirtyStateChanged(g,!1),this._onDidSaveDocument.fire(i.document)}$acceptDirtyStateChanged(g,m){const i=P.URI.revive(g),s=this._documentsAndEditors.getDocument(i);if(!s)throw new Error("unknown document");s._acceptIsDirty(m),this._onDidChangeDocument.fire({document:s.document,contentChanges:[]})}$acceptModelChanged(g,m,i){const s=P.URI.revive(g),_=this._documentsAndEditors.getDocument(s);if(!_)throw new Error("unknown document");_._acceptIsDirty(i),_.onEvents(m),this._onDidChangeDocument.fire((0,n.deepFreeze)({document:_.document,contentChanges:m.changes.map(d=>({range:C.Range.to(d.range),rangeOffset:d.rangeOffset,rangeLength:d.rangeLength,text:d.text}))}))}setWordDefinitionFor(g,m){(0,S.setWordDefinitionFor)(g,m)}}e.ExtHostDocuments=T}),define(_e[39],we([0,1,42,3,6,2,4,5,94,15,96,9,19,22,18,54,106]),function(ie,e,E,I,P,A,S,C,y,n,T,k,g,m,i,s,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class d{constructor(l){this.value=l,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let b=class{constructor(l,u){this._extHostRpc=l,this._logService=u,this._activeEditorId=null,this._editors=new Map,this._documents=new m.ResourceMap,this._onDidAddDocuments=new I.Emitter,this._onDidRemoveDocuments=new I.Emitter,this._onDidChangeVisibleTextEditors=new I.Emitter,this._onDidChangeActiveTextEditor=new I.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(l){this.acceptDocumentsAndEditorsDelta(l)}acceptDocumentsAndEditorsDelta(l){const u=[],t=[],r=[];if(l.removedDocuments)for(const c of l.removedDocuments){const o=A.URI.revive(c),a=this._documents.get(o);(a==null?void 0:a.unref())&&(this._documents.delete(o),u.push(a.value))}if(l.addedDocuments)for(const c of l.addedDocuments){const o=A.URI.revive(c.uri);let a=this._documents.get(o);if(a&&o.scheme!==i.Schemas.vscodeNotebookCell)throw new Error(`document '${o} already exists!'`);a||(a=new d(new y.ExtHostDocumentData(this._extHostRpc.getProxy(C.MainContext.MainThreadDocuments),o,c.lines,c.EOL,c.versionId,c.modeId,c.isDirty,c.notebook)),this._documents.set(o,a),t.push(a.value)),a.ref()}if(l.removedEditors)for(const c of l.removedEditors){const o=this._editors.get(c);this._editors.delete(c),o&&r.push(o)}if(l.addedEditors)for(const c of l.addedEditors){const o=A.URI.revive(c.documentUri);E.ok(this._documents.has(o),`document '${o}' does not exist`),E.ok(!this._editors.has(c.id),`editor '${c.id}' already exists!`);const a=this._documents.get(o).value,f=new T.ExtHostTextEditor(c.id,this._extHostRpc.getProxy(C.MainContext.MainThreadTextEditors),this._logService,new _.Lazy(()=>a.document),c.selections.map(k.Selection.to),c.options,c.visibleRanges.map(w=>k.Range.to(w)),typeof c.editorPosition=="number"?k.ViewColumn.to(c.editorPosition):void 0);this._editors.set(c.id,f)}l.newActiveEditor!==void 0&&(E.ok(l.newActiveEditor===null||this._editors.has(l.newActiveEditor),`active editor '${l.newActiveEditor}' does not exist`),this._activeEditorId=l.newActiveEditor),(0,P.dispose)(u),(0,P.dispose)(r),l.removedDocuments&&this._onDidRemoveDocuments.fire(u),l.addedDocuments&&this._onDidAddDocuments.fire(t),(l.removedEditors||l.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(c=>c.value)),l.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(l){var u;return(u=this._documents.get(l))===null||u===void 0?void 0:u.value}allDocuments(){return s.Iterable.map(this._documents.values(),l=>l.value)}getEditor(l){return this._editors.get(l)}activeEditor(l){if(!!this._activeEditorId){const u=this._editors.get(this._activeEditorId);return l?u:u==null?void 0:u.value}}allEditors(){return[...this._editors.values()]}};b=je([Ke(0,n.IExtHostRpcService),Ke(1,g.ILogService)],b),e.ExtHostDocumentsAndEditors=b,e.IExtHostDocumentsAndEditors=(0,S.createDecorator)("IExtHostDocumentsAndEditors")}),define(_e[195],we([0,1,2,5,6,7,9,116,8,23]),function(ie,e,E,I,P,A,S,C,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class T{constructor(){this._schemes=[]}add(m){this._stateMachine=void 0,this._schemes.push(m)}delete(m){const i=this._schemes.indexOf(m);i>=0&&(this._schemes.splice(i,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const m=this._schemes.sort(),i=[];let s,_,d=14,b=14;for(const v of m){let l=s?(0,y.commonPrefixLength)(s,v):0;for(l===0?_=1:_=b;l<v.length;l++)l+1===v.length?(d=b,b=9):b+=1,i.push([_,v.toUpperCase().charCodeAt(l),b]),i.push([_,v.toLowerCase().charCodeAt(l),b]),_=b;s=v,b=d}i.push([9,58,10]),i.push([10,47,12]),this._stateMachine=new C.StateMachine(i)}}provideDocumentLinks(m){this._initStateMachine();const i=[],s=C.LinkComputer.computeLinks({getLineContent(_){return m.lineAt(_-1).text},getLineCount(){return m.lineCount}},this._stateMachine);for(const _ of s){const d=S.DocumentLink.to(_);d.target&&i.push(d)}return i}}class k{constructor(m,i){this._extHostLanguageFeatures=i,this._linkProvider=new T,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=m.getProxy(I.MainContext.MainThreadFileSystem)}dispose(){var m;(m=this._linkProviderRegistration)===null||m===void 0||m.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(m,i,s,_={}){if(this._registeredSchemes.has(i))throw new Error(`a provider for the scheme '${i}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const d=this._handlePool++;this._linkProvider.add(i),this._registeredSchemes.add(i),this._fsProvider.set(d,s);let b=2;_.isCaseSensitive&&(b+=1024),_.isReadonly&&(b+=2048),typeof s.copy=="function"&&(b+=8),typeof s.open=="function"&&typeof s.close=="function"&&typeof s.read=="function"&&typeof s.write=="function"&&(b+=4),this._proxy.$registerFileSystemProvider(d,i,b).catch(l=>{console.error(`FAILED to register filesystem provider of ${m.value}-extension for the scheme ${i}`),console.error(l)});const v=s.onDidChangeFile(l=>{const u=[];for(const t of l){let{uri:r,type:c}=t;if(r.scheme===i){let o;switch(c){case A.FileChangeType.Changed:o=0;break;case A.FileChangeType.Created:o=1;break;case A.FileChangeType.Deleted:o=2;break;default:throw new Error("Unknown FileChangeType")}u.push({resource:r,type:o})}}this._proxy.$onFileSystemChange(d,u)});return(0,P.toDisposable)(()=>{v.dispose(),this._linkProvider.delete(i),this._registeredSchemes.delete(i),this._fsProvider.delete(d),this._proxy.$unregisterProvider(d)})}static _asIStat(m){const{type:i,ctime:s,mtime:_,size:d}=m;return{type:i,ctime:s,mtime:_,size:d}}$stat(m,i){return Promise.resolve(this._getFsProvider(m).stat(E.URI.revive(i))).then(k._asIStat)}$readdir(m,i){return Promise.resolve(this._getFsProvider(m).readDirectory(E.URI.revive(i)))}$readFile(m,i){return Promise.resolve(this._getFsProvider(m).readFile(E.URI.revive(i))).then(s=>n.VSBuffer.wrap(s))}$writeFile(m,i,s,_){return Promise.resolve(this._getFsProvider(m).writeFile(E.URI.revive(i),s.buffer,_))}$delete(m,i,s){return Promise.resolve(this._getFsProvider(m).delete(E.URI.revive(i),s))}$rename(m,i,s,_){return Promise.resolve(this._getFsProvider(m).rename(E.URI.revive(i),E.URI.revive(s),_))}$copy(m,i,s,_){const d=this._getFsProvider(m);if(!d.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(d.copy(E.URI.revive(i),E.URI.revive(s),_))}$mkdir(m,i){return Promise.resolve(this._getFsProvider(m).createDirectory(E.URI.revive(i)))}$watch(m,i,s,_){const d=this._getFsProvider(m).watch(E.URI.revive(s),_);this._watches.set(i,d)}$unwatch(m,i){const s=this._watches.get(i);s&&(s.dispose(),this._watches.delete(i))}$open(m,i,s){const _=this._getFsProvider(m);if(!_.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(_.open(E.URI.revive(i),s))}$close(m,i){const s=this._getFsProvider(m);if(!s.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(s.close(i))}$read(m,i,s,_){const d=this._getFsProvider(m);if(!d.read)throw new Error('FileSystemProvider does not implement "read"');const b=n.VSBuffer.alloc(_);return Promise.resolve(d.read(i,s,b.buffer,0,_)).then(v=>b.slice(0,v))}$write(m,i,s,_){const d=this._getFsProvider(m);if(!d.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(d.write(i,s,_.buffer,0,_.byteLength))}_getFsProvider(m){const i=this._fsProvider.get(m);if(!i){const s=new Error;throw s.name="ENOPRO",s.message="no provider",s}return i}}e.ExtHostFileSystem=k}),define(_e[74],we([0,1,5,64,7,23,4,15,48]),function(ie,e,E,I,P,A,S,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let n=class Ft{constructor(k,g){const m=k.getProxy(E.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(i){return m.$stat(i).catch(Ft._handleError)},readDirectory(i){return m.$readdir(i).catch(Ft._handleError)},createDirectory(i){return m.$mkdir(i).catch(Ft._handleError)},async readFile(i){return m.$readFile(i).then(s=>s.buffer).catch(Ft._handleError)},writeFile(i,s){return m.$writeFile(i,A.VSBuffer.wrap(s)).catch(Ft._handleError)},delete(i,s){return m.$delete(i,Object.assign({recursive:!1,useTrash:!1},s)).catch(Ft._handleError)},rename(i,s,_){return m.$rename(i,s,Object.assign({overwrite:!1},_)).catch(Ft._handleError)},copy(i,s,_){return m.$copy(i,s,Object.assign({overwrite:!1},_)).catch(Ft._handleError)},isWritableFileSystem(i){const s=g.getCapabilities(i);if(typeof s=="number")return!(s&2048)}})}static _handleError(k){if(!(k instanceof Error))throw new P.FileSystemError(String(k));if(k.name==="ENOPRO")throw P.FileSystemError.Unavailable(k.message);switch(k.name){case I.FileSystemProviderErrorCode.FileExists:throw P.FileSystemError.FileExists(k.message);case I.FileSystemProviderErrorCode.FileNotFound:throw P.FileSystemError.FileNotFound(k.message);case I.FileSystemProviderErrorCode.FileNotADirectory:throw P.FileSystemError.FileNotADirectory(k.message);case I.FileSystemProviderErrorCode.FileIsADirectory:throw P.FileSystemError.FileIsADirectory(k.message);case I.FileSystemProviderErrorCode.NoPermissions:throw P.FileSystemError.NoPermissions(k.message);case I.FileSystemProviderErrorCode.Unavailable:throw P.FileSystemError.Unavailable(k.message);default:throw new P.FileSystemError(k.message,k.name)}}};n=je([Ke(0,C.IExtHostRpcService),Ke(1,y.IExtHostFileSystemInfo)],n),e.ExtHostConsumerFileSystem=n,e.IExtHostConsumerFileSystem=(0,S.createDecorator)("IExtHostConsumerFileSystem")}),define(_e[196],we([0,1,6,5]),function(ie,e,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class P{constructor(S){this._handlePool=0,this._proxy=S.getProxy(I.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(S){const C=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(C,S),(0,E.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(C)})}}e.ExtHostLabelService=P}),define(_e[197],we([0,1,2,24,9,7,14,5,8,32,11,13,113,6,84,53,92,55,10]),function(ie,e,E,I,P,A,S,C,y,n,T,k,g,m,i,s,_,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class v{constructor(U,K){this._documents=U,this._provider=K}provideDocumentSymbols(U,K){const te=this._documents.getDocument(U);return(0,S.asPromise)(()=>this._provider.provideDocumentSymbols(te,K)).then(le=>{if(!(0,T.isFalsyOrEmpty)(le))return le[0]instanceof A.DocumentSymbol?le.map(P.DocumentSymbol.from):v._asDocumentSymbolTree(le)})}static _asDocumentSymbolTree(U){var K;U=U.slice(0).sort((me,De)=>{let Oe=me.location.range.start.compareTo(De.location.range.start);return Oe===0&&(Oe=De.location.range.end.compareTo(me.location.range.end)),Oe});const te=[],le=[];for(const me of U){const De={name:me.name||"!!MISSING: name!!",kind:P.SymbolKind.from(me.kind),tags:((K=me.tags)===null||K===void 0?void 0:K.map(P.SymbolTag.from))||[],detail:"",containerName:me.containerName,range:P.Range.from(me.location.range),selectionRange:P.Range.from(me.location.range),children:[]};for(;;){if(le.length===0){le.push(De),te.push(De);break}const Oe=le[le.length-1];if(n.Range.containsRange(Oe.range,De.range)&&!n.Range.equalsRange(Oe.range,De.range)){Oe.children&&Oe.children.push(De),le.push(De);break}le.pop()}}return te}}class l{constructor(U,K,te){this._documents=U,this._commands=K,this._provider=te,this._cache=new _.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(U,K){const te=this._documents.getDocument(U),le=await this._provider.provideCodeLenses(te,K);if(!(!le||K.isCancellationRequested)){const me=this._cache.add(le),De=new m.DisposableStore;this._disposables.set(me,De);const Oe={cacheId:me,lenses:[]};for(let ge=0;ge<le.length;ge++)Oe.lenses.push({cacheId:[me,ge],range:P.Range.from(le[ge].range),command:this._commands.toInternal(le[ge].command,De)});return Oe}}async resolveCodeLens(U,K){var te;const le=U.cacheId&&this._cache.get(...U.cacheId);if(!!le){let me;if(typeof this._provider.resolveCodeLens!="function"||le.isResolved?me=le:me=await this._provider.resolveCodeLens(le,K),me||(me=le),!K.isCancellationRequested){const De=U.cacheId&&this._disposables.get(U.cacheId[0]);if(!!De)return U.command=this._commands.toInternal((te=me.command)!==null&&te!==void 0?te:l._badCmd,De),U}}}releaseCodeLenses(U){var K;(K=this._disposables.get(U))===null||K===void 0||K.dispose(),this._disposables.delete(U),this._cache.delete(U)}}l._badCmd={command:"missing",title:"!!MISSING: command!!"};function u(ze){return Array.isArray(ze)?ze.map(P.DefinitionLink.from):ze?[P.DefinitionLink.from(ze)]:[]}class t{constructor(U,K){this._documents=U,this._provider=K}provideDefinition(U,K,te){const le=this._documents.getDocument(U),me=P.Position.to(K);return(0,S.asPromise)(()=>this._provider.provideDefinition(le,me,te)).then(u)}}class r{constructor(U,K){this._documents=U,this._provider=K}provideDeclaration(U,K,te){const le=this._documents.getDocument(U),me=P.Position.to(K);return(0,S.asPromise)(()=>this._provider.provideDeclaration(le,me,te)).then(u)}}class c{constructor(U,K){this._documents=U,this._provider=K}provideImplementation(U,K,te){const le=this._documents.getDocument(U),me=P.Position.to(K);return(0,S.asPromise)(()=>this._provider.provideImplementation(le,me,te)).then(u)}}class o{constructor(U,K){this._documents=U,this._provider=K}provideTypeDefinition(U,K,te){const le=this._documents.getDocument(U),me=P.Position.to(K);return(0,S.asPromise)(()=>this._provider.provideTypeDefinition(le,me,te)).then(u)}}class a{constructor(U,K){this._documents=U,this._provider=K}provideHover(U,K,te){const le=this._documents.getDocument(U),me=P.Position.to(K);return(0,S.asPromise)(()=>this._provider.provideHover(le,me,te)).then(De=>{if(!(!De||(0,T.isFalsyOrEmpty)(De.contents)))return De.range||(De.range=le.getWordRangeAtPosition(me)),De.range||(De.range=new A.Range(me,me)),P.Hover.from(De)})}}class f{constructor(U,K){this._documents=U,this._provider=K}provideEvaluatableExpression(U,K,te){const le=this._documents.getDocument(U),me=P.Position.to(K);return(0,S.asPromise)(()=>this._provider.provideEvaluatableExpression(le,me,te)).then(De=>{if(De)return P.EvaluatableExpression.from(De)})}}class w{constructor(U,K){this._documents=U,this._provider=K}provideInlineValues(U,K,te,le){const me=this._documents.getDocument(U);return(0,S.asPromise)(()=>this._provider.provideInlineValues(me,P.Range.to(K),P.InlineValueContext.to(te),le)).then(De=>{if(Array.isArray(De))return De.map(Oe=>P.InlineValue.from(Oe))})}}class D{constructor(U,K){this._documents=U,this._provider=K}provideDocumentHighlights(U,K,te){const le=this._documents.getDocument(U),me=P.Position.to(K);return(0,S.asPromise)(()=>this._provider.provideDocumentHighlights(le,me,te)).then(De=>{if(Array.isArray(De))return De.map(P.DocumentHighlight.from)})}}class p{constructor(U,K){this._documents=U,this._provider=K}provideLinkedEditingRanges(U,K,te){const le=this._documents.getDocument(U),me=P.Position.to(K);return(0,S.asPromise)(()=>this._provider.provideLinkedEditingRanges(le,me,te)).then(De=>{if(De&&Array.isArray(De.ranges))return{ranges:(0,T.coalesce)(De.ranges.map(P.Range.from)),wordPattern:De.wordPattern}})}}class h{constructor(U,K){this._documents=U,this._provider=K}provideReferences(U,K,te,le){const me=this._documents.getDocument(U),De=P.Position.to(K);return(0,S.asPromise)(()=>this._provider.provideReferences(me,De,te,le)).then(Oe=>{if(Array.isArray(Oe))return Oe.map(P.location.from)})}}class R{constructor(U,K,te,le,me,De,Oe){this._documents=U,this._commands=K,this._diagnostics=te,this._provider=le,this._logService=me,this._extension=De,this._apiDeprecation=Oe,this._cache=new _.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(U,K,te,le){const me=this._documents.getDocument(U),De=g.Selection.isISelection(K)?P.Selection.to(K):P.Range.to(K),Oe=[];for(const Ce of this._diagnostics.getDiagnostics(U))if(De.intersection(Ce.range)&&Oe.push(Ce)>R._maxCodeActionsPerFile)break;const ge={diagnostics:Oe,only:te.only?new A.CodeActionKind(te.only):void 0,triggerKind:P.CodeActionTriggerKind.to(te.trigger)};return(0,S.asPromise)(()=>this._provider.provideCodeActions(me,De,ge,le)).then(Ce=>{var Ae;if(!(!(0,T.isNonEmptyArray)(Ce)||le.isCancellationRequested)){const We=this._cache.add(Ce),be=new m.DisposableStore;this._disposables.set(We,be);const qe=[];for(let V=0;V<Ce.length;V++){const Z=Ce[V];!Z||(R._isCommand(Z)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),qe.push({_isSynthetic:!0,title:Z.title,command:this._commands.toInternal(Z,be)})):(ge.only&&(Z.kind?ge.only.contains(Z.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ge.only.value} 'requested but returned code action is of kind '${Z.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ge.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),qe.push({cacheId:[We,V],title:Z.title,command:Z.command&&this._commands.toInternal(Z.command,be),diagnostics:Z.diagnostics&&Z.diagnostics.map(P.Diagnostic.from),edit:Z.edit&&P.WorkspaceEdit.from(Z.edit),kind:Z.kind&&Z.kind.value,isPreferred:Z.isPreferred,disabled:(Ae=Z.disabled)===null||Ae===void 0?void 0:Ae.reason})))}return{cacheId:We,actions:qe}}})}async resolveCodeAction(U,K){var te;const[le,me]=U,De=this._cache.get(le,me);if(!(!De||R._isCommand(De))&&!!this._provider.resolveCodeAction){const Oe=(te=await this._provider.resolveCodeAction(De,K))!==null&&te!==void 0?te:De;return(Oe==null?void 0:Oe.edit)?P.WorkspaceEdit.from(Oe.edit):void 0}}releaseCodeActions(U){var K;(K=this._disposables.get(U))===null||K===void 0||K.dispose(),this._disposables.delete(U),this._cache.delete(U)}static _isCommand(U){return typeof U.command=="string"&&typeof U.title=="string"}}R._maxCodeActionsPerFile=1e3;class F{constructor(U,K){this._documents=U,this._provider=K}provideDocumentFormattingEdits(U,K,te){const le=this._documents.getDocument(U);return(0,S.asPromise)(()=>this._provider.provideDocumentFormattingEdits(le,K,te)).then(me=>{if(Array.isArray(me))return me.map(P.TextEdit.from)})}}class ${constructor(U,K){this._documents=U,this._provider=K}provideDocumentRangeFormattingEdits(U,K,te,le){const me=this._documents.getDocument(U),De=P.Range.to(K);return(0,S.asPromise)(()=>this._provider.provideDocumentRangeFormattingEdits(me,De,te,le)).then(Oe=>{if(Array.isArray(Oe))return Oe.map(P.TextEdit.from)})}}class se{constructor(U,K){this._documents=U,this._provider=K,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(U,K,te,le,me){const De=this._documents.getDocument(U),Oe=P.Position.to(K);return(0,S.asPromise)(()=>this._provider.provideOnTypeFormattingEdits(De,Oe,te,le,me)).then(ge=>{if(Array.isArray(ge))return ge.map(P.TextEdit.from)})}}class z{constructor(U,K){this._provider=U,this._logService=K,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(U,K){const te=C.IdObject.mixin({symbols:[]});return(0,S.asPromise)(()=>this._provider.provideWorkspaceSymbols(U,K)).then(le=>{if((0,T.isNonEmptyArray)(le)){for(const me of le)if(!!me){if(!me.name){this._logService.warn("INVALID SymbolInformation, lacks name",me);continue}const De=C.IdObject.mixin(P.WorkspaceSymbol.from(me));this._symbolCache.set(De._id,me),te.symbols.push(De)}}}).then(()=>(te.symbols.length>0&&this._resultCache.set(te._id,[te.symbols[0]._id,te.symbols[te.symbols.length-1]._id]),te))}async resolveWorkspaceSymbol(U,K){if(typeof this._provider.resolveWorkspaceSymbol!="function")return U;const te=this._symbolCache.get(U._id);if(te){const le=await(0,S.asPromise)(()=>this._provider.resolveWorkspaceSymbol(te,K));return le&&(0,I.mixin)(U,P.WorkspaceSymbol.from(le),!0)}}releaseWorkspaceSymbols(U){const K=this._resultCache.get(U);if(K){for(let[te,le]=K;te<=le;te++)this._symbolCache.delete(te);this._resultCache.delete(U)}}}class x{constructor(U,K,te){this._documents=U,this._provider=K,this._logService=te}static supportsResolving(U){return typeof U.prepareRename=="function"}provideRenameEdits(U,K,te,le){const me=this._documents.getDocument(U),De=P.Position.to(K);return(0,S.asPromise)(()=>this._provider.provideRenameEdits(me,De,te,le)).then(Oe=>{if(!!Oe)return P.WorkspaceEdit.from(Oe)},Oe=>{const ge=x._asMessage(Oe);return ge?{rejectReason:ge,edits:void 0}:Promise.reject(Oe)})}resolveRenameLocation(U,K,te){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const le=this._documents.getDocument(U),me=P.Position.to(K);return(0,S.asPromise)(()=>this._provider.prepareRename(le,me,te)).then(De=>{let Oe,ge;if(A.Range.isRange(De)?(Oe=De,ge=le.getText(De)):(0,k.isObject)(De)&&(Oe=De.range,ge=De.placeholder),!!Oe){if(Oe.start.line>me.line||Oe.end.line<me.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:P.Range.from(Oe),text:ge}}},De=>{const Oe=x._asMessage(De);return Oe?{rejectReason:Oe,range:void 0,text:void 0}:Promise.reject(De)})}static _asMessage(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}class G{constructor(U,K){this.resultId=U,this.tokens=K}}class M{constructor(U,K){this._documents=U,this._provider=K,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(U,K,te){const le=this._documents.getDocument(U),me=K!==0?this._previousResults.get(K):null;return(0,S.asPromise)(()=>me&&typeof me.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(le,me.resultId,te):this._provider.provideDocumentSemanticTokens(le,te)).then(De=>(me&&this._previousResults.delete(K),De?(De=M._fixProvidedSemanticTokens(De),this._send(M._convertToEdits(me,De),De)):null))}async releaseDocumentSemanticColoring(U){this._previousResults.delete(U)}static _fixProvidedSemanticTokens(U){return M._isSemanticTokens(U)?M._isCorrectSemanticTokens(U)?U:new A.SemanticTokens(new Uint32Array(U.data),U.resultId):M._isSemanticTokensEdits(U)?M._isCorrectSemanticTokensEdits(U)?U:new A.SemanticTokensEdits(U.edits.map(K=>new A.SemanticTokensEdit(K.start,K.deleteCount,K.data?new Uint32Array(K.data):K.data)),U.resultId):U}static _isSemanticTokens(U){return U&&!!U.data}static _isCorrectSemanticTokens(U){return U.data instanceof Uint32Array}static _isSemanticTokensEdits(U){return U&&Array.isArray(U.edits)}static _isCorrectSemanticTokensEdits(U){for(const K of U.edits)if(!(K.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(U,K){if(!M._isSemanticTokens(K)||!U||!U.tokens)return K;const te=U.tokens,le=te.length,me=K.data,De=me.length;let Oe=0;const ge=Math.min(le,De);for(;Oe<ge&&te[Oe]===me[Oe];)Oe++;if(Oe===le&&Oe===De)return new A.SemanticTokensEdits([],K.resultId);let Ce=0;const Ae=ge-Oe;for(;Ce<Ae&&te[le-Ce-1]===me[De-Ce-1];)Ce++;return new A.SemanticTokensEdits([{start:Oe,deleteCount:le-Oe-Ce,data:me.subarray(Oe,De-Ce)}],K.resultId)}_send(U,K){if(M._isSemanticTokens(U)){const te=this._nextResultId++;return this._previousResults.set(te,new G(U.resultId,U.data)),(0,i.encodeSemanticTokensDto)({id:te,type:"full",data:U.data})}if(M._isSemanticTokensEdits(U)){const te=this._nextResultId++;return M._isSemanticTokens(K)?this._previousResults.set(te,new G(K.resultId,K.data)):this._previousResults.set(te,new G(U.resultId)),(0,i.encodeSemanticTokensDto)({id:te,type:"delta",deltas:(U.edits||[]).map(le=>({start:le.start,deleteCount:le.deleteCount,data:le.data}))})}return null}}e.DocumentSemanticTokensAdapter=M;class N{constructor(U,K){this._documents=U,this._provider=K}provideDocumentRangeSemanticTokens(U,K,te){const le=this._documents.getDocument(U);return(0,S.asPromise)(()=>this._provider.provideDocumentRangeSemanticTokens(le,P.Range.to(K),te)).then(me=>me?this._send(me):null)}_send(U){return(0,i.encodeSemanticTokensDto)({id:0,type:"full",data:U.data})}}e.DocumentRangeSemanticTokensAdapter=N;class B{constructor(U,K,te,le,me){this._documents=U,this._commands=K,this._provider=te,this._apiDeprecation=le,this._extension=me,this._cache=new _.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(U){return typeof U.resolveCompletionItem=="function"}async provideCompletionItems(U,K,te,le){const me=this._documents.getDocument(U),De=P.Position.to(K),Oe=me.getWordRangeAtPosition(De)||new A.Range(De,De),ge=Oe.with({end:De}),Ce=new d.StopWatch(!0),Ae=await(0,S.asPromise)(()=>this._provider.provideCompletionItems(me,De,le,P.CompletionContext.to(te)));if(!!Ae&&!le.isCancellationRequested){const We=Array.isArray(Ae)?new A.CompletionList(Ae):Ae,be=B.supportsResolving(this._provider)?this._cache.add(We.items):this._cache.add([]),qe=new m.DisposableStore;this._disposables.set(be,qe);const V=[],Z={x:be,b:V,a:{replace:P.Range.from(Oe),insert:P.Range.from(ge)},c:We.isIncomplete||void 0,d:Ce.elapsed()};for(let pe=0;pe<We.items.length;pe++){const Me=We.items[pe],He=this._convertCompletionItem(Me,[be,pe],ge,Oe);V.push(He)}return Z}}async resolveCompletionItem(U,K){if(typeof this._provider.resolveCompletionItem=="function"){const te=this._cache.get(...U);if(!!te){const le=await(0,S.asPromise)(()=>this._provider.resolveCompletionItem(te,K));if(!!le)return this._convertCompletionItem(le,U)}}}releaseCompletionItems(U){var K;(K=this._disposables.get(U))===null||K===void 0||K.dispose(),this._disposables.delete(U),this._cache.delete(U)}_convertCompletionItem(U,K,te,le){var me;const De=this._disposables.get(K[0]);if(!De)throw Error("DisposableStore is missing...");const Oe={x:K,a:(me=U.label)!==null&&me!==void 0?me:"",o:U.label2,b:U.kind!==void 0?P.CompletionItemKind.from(U.kind):void 0,n:U.tags&&U.tags.map(P.CompletionItemTag.from),c:U.detail,d:typeof U.documentation=="undefined"?void 0:P.MarkdownString.fromStrict(U.documentation),e:U.sortText!==U.label?U.sortText:void 0,f:U.filterText!==U.label?U.filterText:void 0,g:U.preselect||void 0,i:U.keepWhitespace?1:0,k:U.commitCharacters,l:U.additionalTextEdits&&U.additionalTextEdits.map(P.TextEdit.from),m:this._commands.toInternal(U.command,De)};U.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Oe.h=U.textEdit.newText):typeof U.insertText=="string"?Oe.h=U.insertText:U.insertText instanceof A.SnippetString&&(Oe.h=U.insertText.value,Oe.i|=4);let ge;return U.textEdit?ge=U.textEdit.range:U.range&&(ge=U.range),A.Range.isRange(ge)?Oe.j=P.Range.from(ge):ge&&(!(te==null?void 0:te.isEqual(ge.inserting))||!(le==null?void 0:le.isEqual(ge.replacing)))&&(Oe.j={insert:P.Range.from(ge.inserting),replace:P.Range.from(ge.replacing)}),Oe}}class Q{constructor(U,K){this._documents=U,this._provider=K,this._cache=new _.Cache("SignatureHelp")}provideSignatureHelp(U,K,te,le){const me=this._documents.getDocument(U),De=P.Position.to(K),Oe=this.reviveContext(te);return(0,S.asPromise)(()=>this._provider.provideSignatureHelp(me,De,le,Oe)).then(ge=>{if(ge){const Ce=this._cache.add([ge]);return Object.assign(Object.assign({},P.SignatureHelp.from(ge)),{id:Ce})}})}reviveContext(U){let K;if(U.activeSignatureHelp){const te=P.SignatureHelp.to(U.activeSignatureHelp),le=this._cache.get(U.activeSignatureHelp.id,0);le?(K=le,K.activeSignature=te.activeSignature,K.activeParameter=te.activeParameter):K=te}return Object.assign(Object.assign({},U),{activeSignatureHelp:K})}releaseSignatureHelp(U){this._cache.delete(U)}}class W{constructor(U,K){this._documents=U,this._provider=K}provideInlineHints(U,K,te){const le=this._documents.getDocument(U);return(0,S.asPromise)(()=>this._provider.provideInlineHints(le,P.Range.to(K),te)).then(me=>me?{hints:me.map(P.InlineHint.from)}:void 0)}}class ee{constructor(U,K){this._documents=U,this._provider=K,this._cache=new _.Cache("DocumentLink")}provideLinks(U,K){const te=this._documents.getDocument(U);return(0,S.asPromise)(()=>this._provider.provideDocumentLinks(te,K)).then(le=>{if(!(!Array.isArray(le)||le.length===0)&&!K.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:le.map(P.DocumentLink.from)};{const me=this._cache.add(le),De={links:[],id:me};for(let Oe=0;Oe<le.length;Oe++){const ge=P.DocumentLink.from(le[Oe]);ge.cacheId=[me,Oe],De.links.push(ge)}return De}}})}resolveLink(U,K){if(typeof this._provider.resolveDocumentLink!="function")return Promise.resolve(void 0);const te=this._cache.get(...U);return te?(0,S.asPromise)(()=>this._provider.resolveDocumentLink(te,K)).then(le=>le&&P.DocumentLink.from(le)||void 0):Promise.resolve(void 0)}releaseLinks(U){this._cache.delete(U)}}class re{constructor(U,K){this._documents=U,this._provider=K}provideColors(U,K){const te=this._documents.getDocument(U);return(0,S.asPromise)(()=>this._provider.provideDocumentColors(te,K)).then(le=>Array.isArray(le)?le.map(De=>({color:P.Color.from(De.color),range:P.Range.from(De.range)})):[])}provideColorPresentations(U,K,te){const le=this._documents.getDocument(U),me=P.Range.to(K.range),De=P.Color.to(K.color);return(0,S.asPromise)(()=>this._provider.provideColorPresentations(De,{document:le,range:me},te)).then(Oe=>{if(!!Array.isArray(Oe))return Oe.map(P.ColorPresentation.from)})}}class oe{constructor(U,K){this._documents=U,this._provider=K}provideFoldingRanges(U,K,te){const le=this._documents.getDocument(U);return(0,S.asPromise)(()=>this._provider.provideFoldingRanges(le,K,te)).then(me=>{if(!!Array.isArray(me))return me.map(P.FoldingRange.from)})}}class Se{constructor(U,K,te){this._documents=U,this._provider=K,this._logService=te}provideSelectionRanges(U,K,te){const le=this._documents.getDocument(U),me=K.map(P.Position.to);return(0,S.asPromise)(()=>this._provider.provideSelectionRanges(le,me,te)).then(De=>{if(!(0,T.isNonEmptyArray)(De))return[];if(De.length!==me.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Oe=[];for(let ge=0;ge<me.length;ge++){const Ce=[];Oe.push(Ce);let Ae=me[ge],We=De[ge];for(;;){if(!We.range.contains(Ae))throw new Error("INVALID selection range, must contain the previous range");if(Ce.push(P.SelectionRange.from(We)),!We.parent)break;Ae=We.range,We=We.parent}}return Oe})}}class Pe{constructor(U,K){this._documents=U,this._provider=K,this._idPool=new s.IdGenerator(""),this._cache=new Map}async prepareSession(U,K,te){const le=this._documents.getDocument(U),me=P.Position.to(K),De=await this._provider.prepareCallHierarchy(le,me,te);if(!!De){const Oe=this._idPool.nextId();return this._cache.set(Oe,new Map),Array.isArray(De)?De.map(ge=>this._cacheAndConvertItem(Oe,ge)):[this._cacheAndConvertItem(Oe,De)]}}async provideCallsTo(U,K,te){const le=this._itemFromCache(U,K);if(!le)throw new Error("missing call hierarchy item");const me=await this._provider.provideCallHierarchyIncomingCalls(le,te);if(!!me)return me.map(De=>({from:this._cacheAndConvertItem(U,De.from),fromRanges:De.fromRanges.map(Oe=>P.Range.from(Oe))}))}async provideCallsFrom(U,K,te){const le=this._itemFromCache(U,K);if(!le)throw new Error("missing call hierarchy item");const me=await this._provider.provideCallHierarchyOutgoingCalls(le,te);if(!!me)return me.map(De=>({to:this._cacheAndConvertItem(U,De.to),fromRanges:De.fromRanges.map(Oe=>P.Range.from(Oe))}))}releaseSession(U){this._cache.delete(U)}_cacheAndConvertItem(U,K){var te;const le=this._cache.get(U),me={_sessionId:U,_itemId:le.size.toString(36),name:K.name,detail:K.detail,kind:P.SymbolKind.from(K.kind),uri:K.uri,range:P.Range.from(K.range),selectionRange:P.Range.from(K.selectionRange),tags:(te=K.tags)===null||te===void 0?void 0:te.map(P.SymbolTag.from)};return le.set(me._itemId,K),me}_itemFromCache(U,K){const te=this._cache.get(U);return te==null?void 0:te.get(K)}}class $e{constructor(U,K){this.adapter=U,this.extension=K}}class Fe{constructor(U,K,te,le,me,De,Oe){this._adapter=new Map,this._uriTransformer=K,this._proxy=U.getProxy(C.MainContext.MainThreadLanguageFeatures),this._documents=te,this._commands=le,this._diagnostics=me,this._logService=De,this._apiDeprecation=Oe}_transformDocumentSelector(U){return(0,T.coalesce)((0,T.asArray)(U).map(K=>this._doTransformDocumentSelector(K)))}_doTransformDocumentSelector(U){if(typeof U=="string")return{$serialized:!0,language:U};if(U)return{$serialized:!0,language:U.language,scheme:this._transformScheme(U.scheme),pattern:typeof U.pattern=="undefined"?void 0:P.GlobPattern.from(U.pattern),exclusive:U.exclusive}}_transformScheme(U){return this._uriTransformer&&typeof U=="string"?this._uriTransformer.transformOutgoingScheme(U):U}_createDisposable(U){return new A.Disposable(()=>{this._adapter.delete(U),this._proxy.$unregister(U)})}_nextHandle(){return Fe._handlePool++}_withAdapter(U,K,te,le,me=!1){const De=this._adapter.get(U);if(!De)return Promise.resolve(le);if(De.adapter instanceof K){let Oe;De.extension&&(Oe=Date.now(),this._logService.trace(`[${De.extension.identifier.value}] INVOKE provider '${K.name}'`));const ge=te(De.adapter,De.extension),Ce=De.extension;return Ce&&Promise.resolve(ge).then(()=>this._logService.trace(`[${Ce.identifier.value}] provider DONE after ${Date.now()-Oe}ms`),Ae=>{me&&Ae instanceof b.CancellationError||(this._logService.error(`[${Ce.identifier.value}] provider FAILED`),this._logService.error(Ae))}),ge}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(U,K){const te=this._nextHandle();return this._adapter.set(te,new $e(U,K)),te}static _extLabel(U){return U.displayName||U.name}registerDocumentSymbolProvider(U,K,te,le){const me=this._addNewAdapter(new v(this._documents,te),U),De=le&&le.label||Fe._extLabel(U);return this._proxy.$registerDocumentSymbolProvider(me,this._transformDocumentSelector(K),De),this._createDisposable(me)}$provideDocumentSymbols(U,K,te){return this._withAdapter(U,v,le=>le.provideDocumentSymbols(E.URI.revive(K),te),void 0)}registerCodeLensProvider(U,K,te){const le=this._nextHandle(),me=typeof te.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(le,new $e(new l(this._documents,this._commands.converter,te),U)),this._proxy.$registerCodeLensSupport(le,this._transformDocumentSelector(K),me);let De=this._createDisposable(le);if(me!==void 0){const Oe=te.onDidChangeCodeLenses(ge=>this._proxy.$emitCodeLensEvent(me));De=A.Disposable.from(De,Oe)}return De}$provideCodeLenses(U,K,te){return this._withAdapter(U,l,le=>le.provideCodeLenses(E.URI.revive(K),te),void 0)}$resolveCodeLens(U,K,te){return this._withAdapter(U,l,le=>le.resolveCodeLens(K,te),void 0)}$releaseCodeLenses(U,K){this._withAdapter(U,l,te=>Promise.resolve(te.releaseCodeLenses(K)),void 0)}registerDefinitionProvider(U,K,te){const le=this._addNewAdapter(new t(this._documents,te),U);return this._proxy.$registerDefinitionSupport(le,this._transformDocumentSelector(K)),this._createDisposable(le)}$provideDefinition(U,K,te,le){return this._withAdapter(U,t,me=>me.provideDefinition(E.URI.revive(K),te,le),[])}registerDeclarationProvider(U,K,te){const le=this._addNewAdapter(new r(this._documents,te),U);return this._proxy.$registerDeclarationSupport(le,this._transformDocumentSelector(K)),this._createDisposable(le)}$provideDeclaration(U,K,te,le){return this._withAdapter(U,r,me=>me.provideDeclaration(E.URI.revive(K),te,le),[])}registerImplementationProvider(U,K,te){const le=this._addNewAdapter(new c(this._documents,te),U);return this._proxy.$registerImplementationSupport(le,this._transformDocumentSelector(K)),this._createDisposable(le)}$provideImplementation(U,K,te,le){return this._withAdapter(U,c,me=>me.provideImplementation(E.URI.revive(K),te,le),[])}registerTypeDefinitionProvider(U,K,te){const le=this._addNewAdapter(new o(this._documents,te),U);return this._proxy.$registerTypeDefinitionSupport(le,this._transformDocumentSelector(K)),this._createDisposable(le)}$provideTypeDefinition(U,K,te,le){return this._withAdapter(U,o,me=>me.provideTypeDefinition(E.URI.revive(K),te,le),[])}registerHoverProvider(U,K,te,le){const me=this._addNewAdapter(new a(this._documents,te),U);return this._proxy.$registerHoverProvider(me,this._transformDocumentSelector(K)),this._createDisposable(me)}$provideHover(U,K,te,le){return this._withAdapter(U,a,me=>me.provideHover(E.URI.revive(K),te,le),void 0)}registerEvaluatableExpressionProvider(U,K,te,le){const me=this._addNewAdapter(new f(this._documents,te),U);return this._proxy.$registerEvaluatableExpressionProvider(me,this._transformDocumentSelector(K)),this._createDisposable(me)}$provideEvaluatableExpression(U,K,te,le){return this._withAdapter(U,f,me=>me.provideEvaluatableExpression(E.URI.revive(K),te,le),void 0)}registerInlineValuesProvider(U,K,te,le){const me=typeof te.onDidChangeInlineValues=="function"?this._nextHandle():void 0,De=this._addNewAdapter(new w(this._documents,te),U);this._proxy.$registerInlineValuesProvider(De,this._transformDocumentSelector(K),me);let Oe=this._createDisposable(De);if(me!==void 0){const ge=te.onDidChangeInlineValues(Ce=>this._proxy.$emitInlineValuesEvent(me));Oe=A.Disposable.from(Oe,ge)}return Oe}$provideInlineValues(U,K,te,le,me){return this._withAdapter(U,w,De=>De.provideInlineValues(E.URI.revive(K),te,le,me),void 0)}registerDocumentHighlightProvider(U,K,te){const le=this._addNewAdapter(new D(this._documents,te),U);return this._proxy.$registerDocumentHighlightProvider(le,this._transformDocumentSelector(K)),this._createDisposable(le)}$provideDocumentHighlights(U,K,te,le){return this._withAdapter(U,D,me=>me.provideDocumentHighlights(E.URI.revive(K),te,le),void 0)}registerLinkedEditingRangeProvider(U,K,te){const le=this._addNewAdapter(new p(this._documents,te),U);return this._proxy.$registerLinkedEditingRangeProvider(le,this._transformDocumentSelector(K)),this._createDisposable(le)}$provideLinkedEditingRanges(U,K,te,le){return this._withAdapter(U,p,async me=>{const De=await me.provideLinkedEditingRanges(E.URI.revive(K),te,le);if(De)return{ranges:De.ranges,wordPattern:De.wordPattern?Fe._serializeRegExp(De.wordPattern):void 0}},void 0)}registerReferenceProvider(U,K,te){const le=this._addNewAdapter(new h(this._documents,te),U);return this._proxy.$registerReferenceSupport(le,this._transformDocumentSelector(K)),this._createDisposable(le)}$provideReferences(U,K,te,le,me){return this._withAdapter(U,h,De=>De.provideReferences(E.URI.revive(K),te,le,me),void 0)}registerCodeActionProvider(U,K,te,le){var me,De;const Oe=new m.DisposableStore,ge=this._addNewAdapter(new R(this._documents,this._commands.converter,this._diagnostics,te,this._logService,U,this._apiDeprecation),U);return this._proxy.$registerQuickFixSupport(ge,this._transformDocumentSelector(K),{providedKinds:(me=le==null?void 0:le.providedCodeActionKinds)===null||me===void 0?void 0:me.map(Ce=>Ce.value),documentation:(De=le==null?void 0:le.documentation)===null||De===void 0?void 0:De.map(Ce=>({kind:Ce.kind.value,command:this._commands.converter.toInternal(Ce.command,Oe)}))},Fe._extLabel(U),Boolean(te.resolveCodeAction)),Oe.add(this._createDisposable(ge)),Oe}$provideCodeActions(U,K,te,le,me){return this._withAdapter(U,R,De=>De.provideCodeActions(E.URI.revive(K),te,le,me),void 0)}$resolveCodeAction(U,K,te){return this._withAdapter(U,R,le=>le.resolveCodeAction(K,te),void 0)}$releaseCodeActions(U,K){this._withAdapter(U,R,te=>Promise.resolve(te.releaseCodeActions(K)),void 0)}registerDocumentFormattingEditProvider(U,K,te){const le=this._addNewAdapter(new F(this._documents,te),U);return this._proxy.$registerDocumentFormattingSupport(le,this._transformDocumentSelector(K),U.identifier,U.displayName||U.name),this._createDisposable(le)}$provideDocumentFormattingEdits(U,K,te,le){return this._withAdapter(U,F,me=>me.provideDocumentFormattingEdits(E.URI.revive(K),te,le),void 0)}registerDocumentRangeFormattingEditProvider(U,K,te){const le=this._addNewAdapter(new $(this._documents,te),U);return this._proxy.$registerRangeFormattingSupport(le,this._transformDocumentSelector(K),U.identifier,U.displayName||U.name),this._createDisposable(le)}$provideDocumentRangeFormattingEdits(U,K,te,le,me){return this._withAdapter(U,$,De=>De.provideDocumentRangeFormattingEdits(E.URI.revive(K),te,le,me),void 0)}registerOnTypeFormattingEditProvider(U,K,te,le){const me=this._addNewAdapter(new se(this._documents,te),U);return this._proxy.$registerOnTypeFormattingSupport(me,this._transformDocumentSelector(K),le,U.identifier),this._createDisposable(me)}$provideOnTypeFormattingEdits(U,K,te,le,me,De){return this._withAdapter(U,se,Oe=>Oe.provideOnTypeFormattingEdits(E.URI.revive(K),te,le,me,De),void 0)}registerWorkspaceSymbolProvider(U,K){const te=this._addNewAdapter(new z(K,this._logService),U);return this._proxy.$registerNavigateTypeSupport(te),this._createDisposable(te)}$provideWorkspaceSymbols(U,K,te){return this._withAdapter(U,z,le=>le.provideWorkspaceSymbols(K,te),{symbols:[]})}$resolveWorkspaceSymbol(U,K,te){return this._withAdapter(U,z,le=>le.resolveWorkspaceSymbol(K,te),void 0)}$releaseWorkspaceSymbols(U,K){this._withAdapter(U,z,te=>te.releaseWorkspaceSymbols(K),void 0)}registerRenameProvider(U,K,te){const le=this._addNewAdapter(new x(this._documents,te,this._logService),U);return this._proxy.$registerRenameSupport(le,this._transformDocumentSelector(K),x.supportsResolving(te)),this._createDisposable(le)}$provideRenameEdits(U,K,te,le,me){return this._withAdapter(U,x,De=>De.provideRenameEdits(E.URI.revive(K),te,le,me),void 0)}$resolveRenameLocation(U,K,te,le){return this._withAdapter(U,x,me=>me.resolveRenameLocation(E.URI.revive(K),te,le),void 0)}registerDocumentSemanticTokensProvider(U,K,te,le){const me=this._nextHandle(),De=typeof te.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(me,new $e(new M(this._documents,te),U)),this._proxy.$registerDocumentSemanticTokensProvider(me,this._transformDocumentSelector(K),le,De);let Oe=this._createDisposable(me);if(De){const ge=te.onDidChangeSemanticTokens(Ce=>this._proxy.$emitDocumentSemanticTokensEvent(De));Oe=A.Disposable.from(Oe,ge)}return Oe}$provideDocumentSemanticTokens(U,K,te,le){return this._withAdapter(U,M,me=>me.provideDocumentSemanticTokens(E.URI.revive(K),te,le),null,!0)}$releaseDocumentSemanticTokens(U,K){this._withAdapter(U,M,te=>te.releaseDocumentSemanticColoring(K),void 0)}registerDocumentRangeSemanticTokensProvider(U,K,te,le){const me=this._addNewAdapter(new N(this._documents,te),U);return this._proxy.$registerDocumentRangeSemanticTokensProvider(me,this._transformDocumentSelector(K),le),this._createDisposable(me)}$provideDocumentRangeSemanticTokens(U,K,te,le){return this._withAdapter(U,N,me=>me.provideDocumentRangeSemanticTokens(E.URI.revive(K),te,le),null,!0)}registerCompletionItemProvider(U,K,te,le){const me=this._addNewAdapter(new B(this._documents,this._commands.converter,te,this._apiDeprecation,U),U);return this._proxy.$registerSuggestSupport(me,this._transformDocumentSelector(K),le,B.supportsResolving(te),`${U.identifier.value}(${le.join("")})`),this._createDisposable(me)}$provideCompletionItems(U,K,te,le,me){return this._withAdapter(U,B,De=>De.provideCompletionItems(E.URI.revive(K),te,le,me),void 0)}$resolveCompletionItem(U,K,te){return this._withAdapter(U,B,le=>le.resolveCompletionItem(K,te),void 0)}$releaseCompletionItems(U,K){this._withAdapter(U,B,te=>te.releaseCompletionItems(K),void 0)}registerSignatureHelpProvider(U,K,te,le){const me=Array.isArray(le)?{triggerCharacters:le,retriggerCharacters:[]}:le,De=this._addNewAdapter(new Q(this._documents,te),U);return this._proxy.$registerSignatureHelpProvider(De,this._transformDocumentSelector(K),me),this._createDisposable(De)}$provideSignatureHelp(U,K,te,le,me){return this._withAdapter(U,Q,De=>De.provideSignatureHelp(E.URI.revive(K),te,le,me),void 0)}$releaseSignatureHelp(U,K){this._withAdapter(U,Q,te=>te.releaseSignatureHelp(K),void 0)}registerInlineHintsProvider(U,K,te){const le=typeof te.onDidChangeInlineHints=="function"?this._nextHandle():void 0,me=this._addNewAdapter(new W(this._documents,te),U);this._proxy.$registerInlineHintsProvider(me,this._transformDocumentSelector(K),le);let De=this._createDisposable(me);if(le!==void 0){const Oe=te.onDidChangeInlineHints(ge=>this._proxy.$emitInlineHintsEvent(le));De=A.Disposable.from(De,Oe)}return De}$provideInlineHints(U,K,te,le){return this._withAdapter(U,W,me=>me.provideInlineHints(E.URI.revive(K),te,le),void 0)}registerDocumentLinkProvider(U,K,te){const le=this._addNewAdapter(new ee(this._documents,te),U);return this._proxy.$registerDocumentLinkProvider(le,this._transformDocumentSelector(K),typeof te.resolveDocumentLink=="function"),this._createDisposable(le)}$provideDocumentLinks(U,K,te){return this._withAdapter(U,ee,le=>le.provideLinks(E.URI.revive(K),te),void 0)}$resolveDocumentLink(U,K,te){return this._withAdapter(U,ee,le=>le.resolveLink(K,te),void 0)}$releaseDocumentLinks(U,K){this._withAdapter(U,ee,te=>te.releaseLinks(K),void 0)}registerColorProvider(U,K,te){const le=this._addNewAdapter(new re(this._documents,te),U);return this._proxy.$registerDocumentColorProvider(le,this._transformDocumentSelector(K)),this._createDisposable(le)}$provideDocumentColors(U,K,te){return this._withAdapter(U,re,le=>le.provideColors(E.URI.revive(K),te),[])}$provideColorPresentations(U,K,te,le){return this._withAdapter(U,re,me=>me.provideColorPresentations(E.URI.revive(K),te,le),void 0)}registerFoldingRangeProvider(U,K,te){const le=this._nextHandle(),me=typeof te.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(le,new $e(new oe(this._documents,te),U)),this._proxy.$registerFoldingRangeProvider(le,this._transformDocumentSelector(K),me);let De=this._createDisposable(le);if(me!==void 0){const Oe=te.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(me));De=A.Disposable.from(De,Oe)}return De}$provideFoldingRanges(U,K,te,le){return this._withAdapter(U,oe,me=>me.provideFoldingRanges(E.URI.revive(K),te,le),void 0)}registerSelectionRangeProvider(U,K,te){const le=this._addNewAdapter(new Se(this._documents,te,this._logService),U);return this._proxy.$registerSelectionRangeProvider(le,this._transformDocumentSelector(K)),this._createDisposable(le)}$provideSelectionRanges(U,K,te,le){return this._withAdapter(U,Se,me=>me.provideSelectionRanges(E.URI.revive(K),te,le),[])}registerCallHierarchyProvider(U,K,te){const le=this._addNewAdapter(new Pe(this._documents,te),U);return this._proxy.$registerCallHierarchyProvider(le,this._transformDocumentSelector(K)),this._createDisposable(le)}$prepareCallHierarchy(U,K,te,le){return this._withAdapter(U,Pe,me=>Promise.resolve(me.prepareSession(E.URI.revive(K),te,le)),void 0)}$provideCallHierarchyIncomingCalls(U,K,te,le){return this._withAdapter(U,Pe,me=>me.provideCallsTo(K,te,le),void 0)}$provideCallHierarchyOutgoingCalls(U,K,te,le){return this._withAdapter(U,Pe,me=>me.provideCallsFrom(K,te,le),void 0)}$releaseCallHierarchy(U,K){this._withAdapter(U,Pe,te=>Promise.resolve(te.releaseSession(K)),void 0)}static _serializeRegExp(U){return{pattern:U.source,flags:(0,y.regExpFlags)(U)}}static _serializeIndentationRule(U){return{decreaseIndentPattern:Fe._serializeRegExp(U.decreaseIndentPattern),increaseIndentPattern:Fe._serializeRegExp(U.increaseIndentPattern),indentNextLinePattern:U.indentNextLinePattern?Fe._serializeRegExp(U.indentNextLinePattern):void 0,unIndentedLinePattern:U.unIndentedLinePattern?Fe._serializeRegExp(U.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(U){return{beforeText:Fe._serializeRegExp(U.beforeText),afterText:U.afterText?Fe._serializeRegExp(U.afterText):void 0,previousLineText:U.previousLineText?Fe._serializeRegExp(U.previousLineText):void 0,action:U.action}}static _serializeOnEnterRules(U){return U.map(Fe._serializeOnEnterRule)}setLanguageConfiguration(U,K,te){let{wordPattern:le}=te;if(le&&(0,y.regExpLeadsToEndlessLoop)(le))throw new Error(`Invalid language configuration: wordPattern '${le}' is not allowed to match the empty string.`);le?this._documents.setWordDefinitionFor(K,le):this._documents.setWordDefinitionFor(K,void 0),te.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",U,"Do not use."),te.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",U,"Do not use.");const me=this._nextHandle(),De={comments:te.comments,brackets:te.brackets,wordPattern:te.wordPattern?Fe._serializeRegExp(te.wordPattern):void 0,indentationRules:te.indentationRules?Fe._serializeIndentationRule(te.indentationRules):void 0,onEnterRules:te.onEnterRules?Fe._serializeOnEnterRules(te.onEnterRules):void 0,__electricCharacterSupport:te.__electricCharacterSupport,__characterPairSupport:te.__characterPairSupport};return this._proxy.$setLanguageConfiguration(me,K,De),this._createDisposable(me)}$setWordDefinitions(U){for(const K of U)this._documents.setWordDefinitionFor(K.languageId,new RegExp(K.regexSource,K.regexFlags))}}e.ExtHostLanguageFeatures=Fe,Fe._handlePool=0}),define(_e[198],we([0,1,5,9,7]),function(ie,e,E,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class A{constructor(C,y){this._proxy=C.getProxy(E.MainContext.MainThreadLanguages),this._documents=y}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(C,y){await this._proxy.$changeLanguage(C,y);const n=this._documents.getDocumentData(C);if(!n)throw new Error(`document '${C.toString}' NOT found`);return n.document}async tokenAtPosition(C,y){var n;const T=C.version,k=I.Position.from(y),g=await this._proxy.$tokensAtPosition(C.uri,k),m={type:P.StandardTokenType.Other,range:(n=C.getWordRangeAtPosition(y))!==null&&n!==void 0?n:new P.Range(y.line,y.character,y.line,y.character)};if(!g)return m;const i={range:I.Range.to(g.range),type:I.TokenType.to(g.type)};return!i.range.contains(y)||T!==C.version?m:i}}e.ExtHostLanguages=A}),define(_e[199],we([0,1,5,19,33]),function(ie,e,E,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function A(C){return C&&C.title}let S=class{constructor(y,n){this._logService=n,this._proxy=y.getProxy(E.MainContext.MainThreadMessageService)}showMessage(y,n,T,k,g){const m={extension:y};let i;typeof k=="string"||A(k)?i=[k,...g]:(m.modal=k&&k.modal,m.useCustom=k&&k.useCustom,i=g),m.useCustom&&(0,P.checkProposedApiEnabled)(y);const s=[];for(let _=0;_<i.length;_++){const d=i[_];if(typeof d=="string")s.push({title:d,handle:_,isCloseAffordance:!1});else if(typeof d=="object"){let{title:b,isCloseAffordance:v}=d;s.push({title:b,isCloseAffordance:!!v,handle:_})}else this._logService.warn("Invalid message item:",d)}return this._proxy.$showMessage(n,T,m,s).then(_=>{if(typeof _=="number")return i[_]})}};S=je([Ke(1,I.ILogService)],S),e.ExtHostMessageService=S}),define(_e[200],we([0,1,20,3,6,2,29,5,9,7,69,70,22,177,178,53,13,23,56]),function(ie,e,E,I,P,A,S,C,y,n,T,k,g,m,i,s,_,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookCellStatusBarItemInternal=e.ExtHostNotebookController=e.NotebookEditorDecorationType=e.ExtHostNotebookKernelProviderAdapter=void 0;class v extends P.Disposable{constructor(w,D,p,h,R){super();this._editorId=w,this.uri=D,this._proxy=p,this._webviewInitData=h,this.document=R,this._onDidReceiveDocumentMessage=new I.Emitter,this._rendererIdToEmitters=new Map,this.contentProviderComm={editorId:this._editorId,onDidReceiveMessage:this._onDidReceiveDocumentMessage.event,postMessage:F=>this._proxy.$postMessage(this._editorId,void 0,F),asWebviewUri:F=>this._asWebviewUri(F)}}onDidReceiveMessage(w,D){var p;this._onDidReceiveDocumentMessage.fire(D),w!==void 0&&((p=this._rendererIdToEmitters.get(w))===null||p===void 0||p.fire(D))}getRendererComm(w){const D=new I.Emitter;return this._rendererIdToEmitters.set(w,D),{editorId:this._editorId,onDidReceiveMessage:D.event,postMessage:p=>this._proxy.$postMessage(this._editorId,w,p),asWebviewUri:p=>this._asWebviewUri(p)}}_asWebviewUri(w){return(0,T.asWebviewUri)(this._webviewInitData,this._editorId,w)}}class l extends P.Disposable{constructor(w,D,p,h){super();this._proxy=w,this._handle=D,this._extension=p,this._provider=h,this._kernelToFriendlyId=new g.ResourceMap,this._friendlyIdToKernel=new g.ResourceMap,this._provider.onDidChangeKernels&&this._register(this._provider.onDidChangeKernels(R=>{const F=R==null?void 0:R.uri;this._proxy.$onNotebookKernelChange(this._handle,F)}))}async provideKernels(w,D){const p=await this._provider.provideKernels(w.notebookDocument,D)||[],h=new Map;let R=0;const F=new Set,$=this._kernelToFriendlyId.get(w.uri),se=p.map(x=>{var G;let M=$==null?void 0:$.get(x);return M===void 0&&(x.id&&F.has(x.id)?M=`${this._extension.identifier.value}_${x.id}_${R++}`:M=`${this._extension.identifier.value}_${x.id||S.generateUuid()}`),h.set(x,M),{id:x.id,friendlyId:M,label:x.label,extension:this._extension.identifier,extensionLocation:this._extension.extensionLocation,providerHandle:this._handle,description:x.description,detail:x.detail,isPreferred:x.isPreferred,preloads:(G=x.preloads)===null||G===void 0?void 0:G.map(N=>(A.URI.isUri(N)&&(N={uri:N,provides:[]}),{uri:N.uri,provides:typeof N.provides=="string"?[N.provides]:N.provides===void 0?[]:N.provides})),supportedLanguages:x.supportedLanguages,implementsInterrupt:!!x.interrupt}});this._kernelToFriendlyId.set(w.uri,h);const z=new Map;return h.forEach((x,G)=>{z.set(x,G)}),this._friendlyIdToKernel.set(w.uri,z),se}getKernelByFriendlyId(w,D){var p;return(p=this._friendlyIdToKernel.get(w))===null||p===void 0?void 0:p.get(D)}async resolveNotebook(w,D,p,h){var R;const F=(R=this._friendlyIdToKernel.get(D.uri))===null||R===void 0?void 0:R.get(w);if(F&&this._provider.resolveKernel)return this._provider.resolveKernel(F,D.notebookDocument,p,h)}async executeNotebook(w,D,p){var h;const R=(h=this._friendlyIdToKernel.get(D.uri))===null||h===void 0?void 0:h.get(w);if(!!R){const F=p.map($=>y.NotebookCellRange.to($));return R.executeCellsRequest(D.notebookDocument,F)}}async interruptNotebookExecution(w,D){var p;const h=(p=this._friendlyIdToKernel.get(D.uri))===null||p===void 0?void 0:p.get(w);if(!(!h||!h.interrupt))return h.interrupt(D.notebookDocument)}}e.ExtHostNotebookKernelProviderAdapter=l;class u{constructor(w,D){const p=u._Keys.nextId();w.$registerNotebookEditorDecorationType(p,y.NotebookDecorationRenderOptions.from(D)),this.value={key:p,dispose(){w.$removeNotebookEditorDecorationType(p)}}}}e.NotebookEditorDecorationType=u,u._Keys=new s.IdGenerator("NotebookEditorDecorationType");class t{constructor(w,D,p,h,R,F,$){this._textDocumentsAndEditors=p,this._textDocuments=h,this._webviewInitData=R,this.logService=F,this._extensionStoragePaths=$,this._notebookContentProviders=new Map,this._notebookKernelProviders=new Map,this._documents=new g.ResourceMap,this._editors=new Map,this._webviewComm=new Map,this._onDidChangeNotebookEditorSelection=new I.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this._onDidChangeNotebookEditorVisibleRanges=new I.Emitter,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event,this._onDidChangeNotebookDocumentMetadata=new I.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidChangeNotebookCells=new I.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new I.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new I.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new I.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new I.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new I.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new I.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidSaveNotebookDocument=new I.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeActiveNotebookKernel=new I.Emitter,this.onDidChangeActiveNotebookKernel=this._onDidChangeActiveNotebookKernel.event,this._onDidChangeVisibleNotebookEditors=new I.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._activeExecutions=new g.ResourceMap,this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=w.getProxy(C.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=w.getProxy(C.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=w.getProxy(C.MainContext.MainThreadNotebookEditors),this._commandsConverter=D.converter,D.registerArgumentProcessor({processArgument:se=>{var z;if(se&&se.$mid===12){const x=(z=se.notebookEditor)===null||z===void 0?void 0:z.notebookUri,G=se.cell.handle,M=this._documents.get(x),N=M==null?void 0:M.getCell(G);if(N)return N.cell}return se}})}get activeNotebookEditor(){var w;return(w=this._activeNotebookEditor)===null||w===void 0?void 0:w.editor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(w=>w.editor)}get notebookDocuments(){return[...this._documents.values()]}lookupNotebookDocument(w){return this._documents.get(w)}_getNotebookDocument(w){const D=this._documents.get(w);if(!D)throw new Error(`NO notebook document for '${w}'`);return D}_getProviderData(w){const D=this._notebookContentProviders.get(w);if(!D)throw new Error(`NO provider for '${w}'`);return D}registerNotebookContentProvider(w,D,p,h){var R,F,$;if(this._notebookContentProviders.has(D))throw new Error(`Notebook provider for '${D}' already registered`);this._notebookContentProviders.set(D,{extension:w,provider:p});let se;p.onDidChangeNotebookContentOptions&&(se=p.onDidChangeNotebookContentOptions(()=>{const G=y.NotebookDocumentContentOptions.from(p.options);this._notebookProxy.$updateNotebookProviderOptions(D,G)}));const z=(R=h==null?void 0:h.viewOptions)===null||R===void 0?void 0:R.filenamePattern.map(G=>y.NotebookExclusiveDocumentPattern.from(G)).filter(G=>G!==void 0);((F=h==null?void 0:h.viewOptions)===null||F===void 0?void 0:F.filenamePattern)&&!z&&console.warn(`Notebook content provider view options file name pattern is invalid ${($=h==null?void 0:h.viewOptions)===null||$===void 0?void 0:$.filenamePattern}`);const x=y.NotebookDocumentContentOptions.from(h);return this._notebookProxy.$registerNotebookProvider({id:w.identifier,location:w.extensionLocation,description:w.description},D,{transientOutputs:x.transientOutputs,transientMetadata:x.transientMetadata,viewOptions:(h==null?void 0:h.viewOptions)&&z?{displayName:h.viewOptions.displayName,filenamePattern:z,exclusive:h.viewOptions.exclusive||!1}:void 0}),new n.Disposable(()=>{se==null||se.dispose(),this._notebookContentProviders.delete(D),this._notebookProxy.$unregisterNotebookProvider(D)})}registerNotebookKernelProvider(w,D,p){const h=t._notebookKernelProviderHandlePool++,R=new l(this._notebookProxy,h,w,p);return this._notebookKernelProviders.set(h,R),this._notebookProxy.$registerNotebookKernelProvider({id:w.identifier,location:w.extensionLocation,description:w.description},h,{viewType:D.viewType,filenamePattern:D.filenamePattern?y.NotebookExclusiveDocumentPattern.from(D.filenamePattern):void 0}),new n.Disposable(()=>{R.dispose(),this._notebookKernelProviders.delete(h),this._notebookProxy.$unregisterNotebookKernelProvider(h)})}createNotebookEditorDecorationType(w){return new u(this._notebookEditorsProxy,w).value}async openNotebookDocument(w){const D=this._documents.get(w);if(D)return D.notebookDocument;const p=await this._notebookDocumentsProxy.$tryOpenDocument(w),h=this._documents.get(A.URI.revive(p));return(0,_.assertIsDefined)(h==null?void 0:h.notebookDocument)}_withAdapter(w,D,p){const h=this._documents.get(A.URI.revive(D));if(!h)return[];const R=this._notebookKernelProviders.get(w);return R?p(R,h):[]}async showNotebookDocument(w,D){var p;A.URI.isUri(w)&&(w=await this.openNotebookDocument(w));let h;typeof D=="object"?h={position:y.ViewColumn.from(D.viewColumn),preserveFocus:D.preserveFocus,selections:D.selections&&D.selections.map(y.NotebookCellRange.from),pinned:typeof D.preview=="boolean"?!D.preview:void 0}:h={preserveFocus:!1};const R=await this._notebookEditorsProxy.$tryShowNotebookDocument(w.uri,w.viewType,h),F=R&&((p=this._editors.get(R))===null||p===void 0?void 0:p.editor);if(F)return F.editor;throw R?new Error(`Could NOT open editor for "${w.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${w.toString()}".`)}async $provideNotebookKernels(w,D,p){return this._withAdapter(w,D,(h,R)=>h.provideKernels(R,p))}async $resolveNotebookKernel(w,D,p,h,R){await this._withAdapter(w,p,async(F,$)=>{const se=this._webviewComm.get(D);se&&await F.resolveNotebook(h,$,se.contentProviderComm,R)})}async $resolveNotebookEditor(w,D,p){const h=this._notebookContentProviders.get(w),R=A.URI.revive(D),F=this._documents.get(R);if(!(!F||!h)){let $=this._webviewComm.get(p);$||($=new v(p,R,this._notebookProxy,this._webviewInitData,F),this._webviewComm.set(p,$))}}async $executeNotebookKernelFromProvider(w,D,p,h){await this._withAdapter(w,D,async(R,F)=>R.executeNotebook(p,F,h))}registerNotebookSerializer(w,D,p,h){const R=this._handlePool++;this._notebookSerializer.set(R,p);const F=y.NotebookDocumentContentOptions.from(h);return this._notebookProxy.$registerNotebookSerializer(R,{id:w.identifier,location:w.extensionLocation,description:w.description},D,F),(0,P.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(R)})}async $dataToNotebook(w,D){const p=this._notebookSerializer.get(w);if(!p)throw new Error("NO serializer found");const h=await p.dataToNotebook(D.buffer);return{metadata:y.NotebookDocumentMetadata.from(h.metadata),cells:h.cells.map(y.NotebookCellData.from)}}async $notebookToData(w,D){const p=this._notebookSerializer.get(w);if(!p)throw new Error("NO serializer found");const h=await p.notebookToData({metadata:y.NotebookDocumentMetadata.to(D.metadata),cells:D.cells.map(y.NotebookCellData.to)});return d.VSBuffer.wrap(h)}async $cancelNotebookCellExecution(w,D,p,h){await this._withAdapter(w,D,async(F,$)=>F.interruptNotebookExecution(p,$));const R=this._documents.get(A.URI.revive(D));if(!!R)for(let F of h)for(let $=F.start;$<F.end;$++){const se=R.getCellFromIndex($);se&&this.cancelOneNotebookCellExecution(se)}}cancelOneNotebookCellExecution(w){const D=this._activeExecutions.get(w.uri);D==null||D.cancel()}async $openNotebook(w,D,p,h,R){const{provider:F}=this._getProviderData(w),$=await F.openNotebook(A.URI.revive(D),{backupId:p,untitledDocumentData:h==null?void 0:h.buffer},R);return{metadata:y.NotebookDocumentMetadata.from($.metadata),cells:$.cells.map(y.NotebookCellData.from)}}async $saveNotebook(w,D,p){const h=this._getNotebookDocument(A.URI.revive(D)),{provider:R}=this._getProviderData(w);return await R.saveNotebook(h.notebookDocument,p),!0}async $saveNotebookAs(w,D,p,h){const R=this._getNotebookDocument(A.URI.revive(D)),{provider:F}=this._getProviderData(w);return await F.saveNotebookAs(A.URI.revive(p),R.notebookDocument,h),!0}async $backupNotebook(w,D,p){var h;const R=this._getNotebookDocument(A.URI.revive(D)),F=this._getProviderData(w),$=(h=this._extensionStoragePaths.workspaceValue(F.extension))!==null&&h!==void 0?h:this._extensionStoragePaths.globalValue(F.extension),se=String((0,b.hash)([R.uri.toString(),this._backupIdPool++])),z=A.URI.joinPath($,se),x=await F.provider.backupNotebook(R.notebookDocument,{destination:z},p);return R.updateBackup(x),x.id}$acceptNotebookActiveKernelChange(w){w.providerHandle!==void 0&&this._withAdapter(w.providerHandle,w.uri,async(D,p)=>{const h=w.kernelFriendlyId?D.getKernelByFriendlyId(A.URI.revive(w.uri),w.kernelFriendlyId):void 0;this._editors.forEach(R=>{R.editor.notebookData===p&&R.editor._acceptKernel(h)}),this._onDidChangeActiveNotebookKernel.fire({document:p.notebookDocument,kernel:h})})}$onDidReceiveMessage(w,D,p){var h;(h=this._webviewComm.get(w))===null||h===void 0||h.onDidReceiveMessage(D,p)}$acceptModelChanged(w,D,p){this._getNotebookDocument(A.URI.revive(w)).acceptModelChanged(D,p)}$acceptDirtyStateChanged(w,D){const p=this._getNotebookDocument(A.URI.revive(w));p.acceptModelChanged({rawEvents:[],versionId:p.notebookDocument.version},D)}$acceptModelSaved(w){const D=this._getNotebookDocument(A.URI.revive(w));this._onDidSaveNotebookDocument.fire(D.notebookDocument)}$acceptEditorPropertiesChanged(w,D){this.logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",w,D);const p=this._editors.get(w);if(!p)throw new Error(`unknown text editor: ${w}. known editors: ${[...this._editors.keys()]} `);D.visibleRanges&&p.editor._acceptVisibleRanges(D.visibleRanges.ranges.map(y.NotebookCellRange.to)),D.selections&&p.editor._acceptSelections(D.selections.selections.map(y.NotebookCellRange.to)),D.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:p.editor.editor,visibleRanges:p.editor.editor.visibleRanges}),D.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:p.editor.editor,selections:p.editor.editor.selections}))}$acceptEditorViewColumns(w){for(const D in w){const p=this._editors.get(D);if(!p)throw new Error(`unknown text editor: ${D}. known editors: ${[...this._editors.keys()]} `);p.editor._acceptViewColumn(y.ViewColumn.to(w[D]))}}$acceptDocumentPropertiesChanged(w,D){this.logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",w.path,D);const p=this._getNotebookDocument(A.URI.revive(w));p.acceptDocumentPropertiesChanged(D),D.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:p.notebookDocument})}_createExtHostEditor(w,D,p){if(this._editors.has(D))throw new Error(`editor with id ALREADY EXSIST: ${D}`);const h=w.uri;let R=this._webviewComm.get(D);R||(R=new v(D,h,this._notebookProxy,this._webviewInitData,w),this._webviewComm.set(D,R));const F=new i.ExtHostNotebookEditor(D,this._notebookEditorsProxy,w,p.visibleRanges.map(y.NotebookCellRange.to),p.selections.map(y.NotebookCellRange.to),typeof p.viewColumn=="number"?y.ViewColumn.to(p.viewColumn):void 0);this._editors.set(D,{editor:F})}$acceptDocumentAndEditorsDelta(w){var D,p,h,R;if(w.removedDocuments)for(const $ of w.removedDocuments){const se=A.URI.revive($),z=this._documents.get(se);z&&(z.dispose(),this._documents.delete(se),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:z.notebookDocument.getCells().map(x=>x.document.uri)}),this._onDidCloseNotebookDocument.fire(z.notebookDocument));for(const x of this._editors.values())x.editor.notebookData.uri.toString()===se.toString()&&this._editors.delete(x.editor.id)}if(w.addedDocuments){const $=[];for(const se of w.addedDocuments){const z=A.URI.revive(se.uri),x=se.viewType;if(this._documents.has(z))throw new Error(`adding EXISTING notebook ${z} `);const G=this,M=new m.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(N){G._onDidChangeNotebookCells.fire(N)},emitCellOutputsChange(N){G._onDidChangeCellOutputs.fire(N)},emitCellMetadataChange(N){G._onDidChangeCellMetadata.fire(N)},emitCellExecutionStateChange(N){G._onDidChangeCellExecutionState.fire(N)}},x,se.metadata?y.NotebookDocumentMetadata.to(se.metadata):new n.NotebookDocumentMetadata,z);M.acceptModelChanged({versionId:se.versionId,rawEvents:[{kind:k.NotebookCellsChangeType.Initialize,changes:[[0,0,se.cells]]}]},!1),$.push(...se.cells.map(N=>m.ExtHostCell.asModelAddData(M.notebookDocument,N))),(D=this._documents.get(z))===null||D===void 0||D.dispose(),this._documents.set(z,M),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:$}),this._onDidOpenNotebookDocument.fire(M.notebookDocument)}}if(w.addedEditors)for(const $ of w.addedEditors){if(this._editors.has($.id))return;const se=A.URI.revive($.documentUri),z=this._documents.get(se);z&&this._createExtHostEditor(z,$.id,$)}const F=[];if(w.removedEditors)for(const $ of w.removedEditors){const se=this._editors.get($);se&&(this._editors.delete($),((p=this._activeNotebookEditor)===null||p===void 0?void 0:p.id)===se.editor.id&&(this._activeNotebookEditor=void 0),F.push(se))}if(w.visibleEditors){this._visibleNotebookEditors=w.visibleEditors.map(se=>this._editors.get(se).editor).filter(se=>!!se);const $=new Set;this._visibleNotebookEditors.forEach(se=>$.add(se.id));for(const se of this._editors.values()){const z=$.has(se.editor.id);se.editor._acceptVisibility(z)}this._visibleNotebookEditors=[...this._editors.values()].map(se=>se.editor).filter(se=>se.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}w.newActiveEditor===null?this._activeNotebookEditor=void 0:w.newActiveEditor&&(this._activeNotebookEditor=(h=this._editors.get(w.newActiveEditor))===null||h===void 0?void 0:h.editor),w.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((R=this._activeNotebookEditor)===null||R===void 0?void 0:R.editor)}createNotebookCellStatusBarItemInternal(w,D,p){const h=new r(this._notebookProxy,this._commandsConverter,w,D,p),R=k.CellUri.parse(w.document.uri);if(R){const F=this._documents.get(R.notebook);if(F){const $=F.getCell(R.handle);$&&I.Event.once($.onDidDispose)(()=>h.dispose())}}return h}createNotebookCellExecution(w,D,p){const h=this.lookupNotebookDocument(w);if(!h)throw new Error(`Invalid cell uri / index: ${w}, ${D} `);const R=h.getCellFromIndex(D);if(!R)throw new Error(`Invalid cell uri / index: ${w}, ${D} `);if(!this._activeExecutions.has(R.uri)){const F=new a(w,h,R,this._notebookDocumentsProxy);this._activeExecutions.set(R.uri,F);const $=F.onDidChangeState(()=>{F.state===o.Resolved&&(F.dispose(),$.dispose(),this._activeExecutions.delete(R.uri))});return F.asApiObject()}}}e.ExtHostNotebookController=t,t._notebookKernelProviderHandlePool=0;class r extends P.Disposable{constructor(w,D,p,h,R){super();this._proxy=w,this._commands=D,this._cell=p,this._priority=R,this._id=r.NEXT_ID++,this._isDisposed=!1,this._text="",this._visible=!1,this._internalCommandRegistration=this._register(new P.DisposableStore),this._alignment=h!=null?h:n.NotebookCellStatusBarAlignment.Left}get apiItem(){return this._apiItem||(this._apiItem=c(this)),this._apiItem}get cell(){return this._cell}get alignment(){return this._alignment}set alignment(w){this._alignment=w,this.update()}get priority(){return this._priority}set priority(w){this._priority=w,this.update()}get text(){return this._text}set text(w){this._text=w,this.update()}get tooltip(){return this._tooltip}set tooltip(w){this._tooltip=w,this.update()}get command(){var w;return(w=this._command)===null||w===void 0?void 0:w.fromApi}set command(w){var D;((D=this._command)===null||D===void 0?void 0:D.fromApi)!==w&&(this._internalCommandRegistration.clear(),typeof w=="string"?this._command={fromApi:w,internal:this._commands.toInternal({title:"",command:w},this._internalCommandRegistration)}:w?this._command={fromApi:w,internal:this._commands.toInternal(w,this._internalCommandRegistration)}:this._command=void 0,this.update())}get accessibilityInformation(){return this._accessibilityInformation}set accessibilityInformation(w){this._accessibilityInformation=w,this.update()}show(){this._visible=!0,this.update()}hide(){this._visible=!1,this.update()}dispose(){this.hide(),this._isDisposed=!0,this._internalCommandRegistration.dispose()}update(){var w;if(!this._isDisposed){const D={alignment:this.alignment===n.NotebookCellStatusBarAlignment.Left?0:1,cellResource:this.cell.document.uri,command:(w=this._command)===null||w===void 0?void 0:w.internal,text:this.text,tooltip:this.tooltip,accessibilityInformation:this.accessibilityInformation,priority:this.priority,visible:this._visible};this._proxy.$setStatusBarEntry(this._id,D)}}}e.NotebookCellStatusBarItemInternal=r,r.NEXT_ID=0;function c(f){return Object.freeze({cell:f.cell,get alignment(){return f.alignment},set alignment(w){f.alignment=w},get priority(){return f.priority},set priority(w){f.priority=w},get text(){return f.text},set text(w){f.text=w},get tooltip(){return f.tooltip},set tooltip(w){f.tooltip=w},get command(){return f.command},set command(w){f.command=w},get accessibilityInformation(){return f.accessibilityInformation},set accessibilityInformation(w){f.accessibilityInformation=w},show(){f.show()},hide(){f.hide()},dispose(){f.dispose()}})}var o;(function(f){f[f.Init=0]="Init",f[f.Started=1]="Started",f[f.Resolved=2]="Resolved"})(o||(o={}));class a extends P.Disposable{constructor(w,D,p,h){super();this._uri=w,this._document=D,this._cell=p,this._proxy=h,this._onDidChangeState=new I.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=o.Init,this._tokenSource=this._register(new E.CancellationTokenSource),this._executionOrder=p.internalMetadata.executionOrder,this.mixinMetadata({runState:k.NotebookCellExecutionState.Pending,lastRunDuration:null,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEdits(w){return this._proxy.$applyEdits(this._uri,w,!1)}verifyStateForOutput(){if(this._state===o.Init)throw new Error("Must call start before modifying cell output");if(this._state===o.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(w){const D=[{editType:11,handle:this._cell.handle,metadata:w}];this.applyEdits(D)}cellIndexToHandle(w){const D=typeof w=="number"?this._document.getCellFromIndex(w):this._cell;if(!!D)return D.handle}asApiObject(){const w=this;return Object.freeze({get document(){return w._document.notebookDocument},get cell(){return w._cell.cell},get executionOrder(){return w._executionOrder},set executionOrder(D){w._executionOrder=D,w.mixinMetadata({executionOrder:D})},start(D){if(w._state===o.Resolved||w._state===o.Started)throw new Error("Cannot call start again");w._state=o.Started,w._onDidChangeState.fire(),w.mixinMetadata({runState:k.NotebookCellExecutionState.Executing,runStartTime:D==null?void 0:D.startTime})},end(D){var p,h;if(w._state===o.Resolved)throw new Error("Cannot call resolve twice");w._state=o.Resolved,w._onDidChangeState.fire(),w.mixinMetadata({runState:k.NotebookCellExecutionState.Idle,lastRunSuccess:(p=D==null?void 0:D.success)!==null&&p!==void 0?p:null,lastRunDuration:(h=D==null?void 0:D.duration)!==null&&h!==void 0?h:null})},clearOutput(D){return w.verifyStateForOutput(),this.replaceOutput([],D)},async appendOutput(D,p){w.verifyStateForOutput();const h=w.cellIndexToHandle(p);if(typeof h=="number")return D=Array.isArray(D)?D:[D],w.applyEdits([{editType:2,handle:h,append:!0,outputs:D.map(y.NotebookCellOutput.from)}])},async replaceOutput(D,p){w.verifyStateForOutput();const h=w.cellIndexToHandle(p);if(typeof h=="number")return D=Array.isArray(D)?D:[D],w.applyEdits([{editType:2,handle:h,outputs:D.map(y.NotebookCellOutput.from)}])},async appendOutputItems(D,p){return w.verifyStateForOutput(),D=Array.isArray(D)?D:[D],w.applyEdits([{editType:10,append:!0,items:D.map(y.NotebookCellOutputItem.from),outputId:p}])},async replaceOutputItems(D,p){return w.verifyStateForOutput(),D=Array.isArray(D)?D:[D],w.applyEdits([{editType:10,items:D.map(y.NotebookCellOutputItem.from),outputId:p}])},token:w._tokenSource.token})}}}),define(_e[201],we([0,1,3,6,5,2,9,11]),function(ie,e,E,I,P,A,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;class y{constructor(T,k){this._extHostNotebook=k,this._kernelData=new Map,this._handlePool=0,this._proxy=T.getProxy(P.MainContext.MainThreadNotebookKernels)}createKernel(T,k){const g=this._handlePool++,m=this;let i=!1;const s=new I.DisposableStore,_=new E.Emitter;this._kernelData.set(g,{id:k.id,executeHandler:k.executeHandler,onDidChangeSelection:_});const d={id:k.id,selector:k.selector,extensionId:T.identifier,extensionLocation:T.extensionLocation,label:k.label,supportedLanguages:(0,C.isNonEmptyArray)(k.supportedLanguages)?k.supportedLanguages:["plaintext"],supportsInterrupt:Boolean(k.interruptHandler),hasExecutionOrder:k.hasExecutionOrder};this._proxy.$addKernel(g,d);let b=0;const v=()=>{if(!i){const l=++b;Promise.resolve().then(()=>{l===b&&this._proxy.$updateKernel(g,d)})}};return{get id(){return d.id},get selector(){return d.selector},onDidChangeNotebookAssociation:_.event,get label(){return d.label},set label(l){d.label=l,v()},get description(){var l;return(l=d.description)!==null&&l!==void 0?l:""},set description(l){d.description=l,v()},get supportedLanguages(){return d.supportedLanguages},set supportedLanguages(l){d.supportedLanguages=(0,C.isNonEmptyArray)(l)?l:["plaintext"],v()},get hasExecutionOrder(){var l;return(l=d.hasExecutionOrder)!==null&&l!==void 0?l:!1},set hasExecutionOrder(l){d.hasExecutionOrder=l,v()},get executeHandler(){return m._kernelData.get(g).executeHandler},get interruptHandler(){return m._kernelData.get(g).interruptHandler},set interruptHandler(l){m._kernelData.get(g).interruptHandler=l,d.supportsInterrupt=Boolean(l),v()},createNotebookCellExecutionTask(l){return m._extHostNotebook.createNotebookCellExecution(l.document.uri,l.index,d.id)},dispose:()=>{i=!0,this._kernelData.delete(g),s.dispose(),_.dispose(),this._proxy.$removeKernel(g)}}}$acceptSelection(T,k,g){const m=this._kernelData.get(T);m&&m.onDidChangeSelection.fire({selected:g,notebook:this._extHostNotebook.lookupNotebookDocument(A.URI.revive(k)).notebookDocument})}$executeCells(T,k,g){const m=this._kernelData.get(T);if(!!m){const i=this._extHostNotebook.lookupNotebookDocument(A.URI.revive(k));if(!i)throw new Error("MISSING notebook");const s=[];for(let _ of g){const d=i.notebookDocument.getCells(S.NotebookCellRange.to(_));for(let b of d){const v=this._extHostNotebook.createNotebookCellExecution(i.uri,b.index,m.id);v?s.push(v):console.warn("could NOT create notebook cell execution task for: "+b.document.uri)}}try{m.executeHandler(s)}catch(_){console.error(_)}}}$cancelCells(T,k,g){const m=this._kernelData.get(T);if(!!m){const i=this._extHostNotebook.lookupNotebookDocument(A.URI.revive(k));if(!i)throw new Error("MISSING notebook");m.interruptHandler&&m.interruptHandler(i.notebookDocument)}}}e.ExtHostNotebookKernels=y}),define(_e[99],we([0,1,5,3,6,23,4,15]),function(ie,e,E,I,P,A,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class y extends P.Disposable{constructor(i,s,_,d){super();this._onDidAppend=this._register(new I.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=i,this._proxy=d,this._id=d.$register(this.name,s,_),this._disposed=!1,this._offset=0}get name(){return this._name}append(i){this.validate(),this._offset+=i?A.VSBuffer.fromString(i).byteLength:0}update(){this._id.then(i=>this._proxy.$update(i))}appendLine(i){this.validate(),this.append(i+`
`)}clear(){this.validate();const i=this._offset;this._id.then(s=>this._proxy.$clear(s,i))}show(i,s){this.validate(),this._id.then(_=>this._proxy.$reveal(_,!!(typeof i=="boolean"?i:s)))}hide(){this.validate(),this._id.then(i=>this._proxy.$close(i))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(i=>this._proxy.$dispose(i)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=y;class n extends y{constructor(i,s){super(i,!1,void 0,s)}append(i){super.append(i),this._id.then(s=>this._proxy.$append(s,i)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=n;class T extends y{constructor(i,s,_){super(i,!0,s,_)}append(i){throw new Error("Not supported")}}class k{constructor(i,s){this.name=i,this._channel=s}append(i){this._channel.then(s=>s.append(i))}appendLine(i){this._channel.then(s=>s.appendLine(i))}clear(){this._channel.then(i=>i.clear())}show(i,s){this._channel.then(_=>_.show(i,s))}hide(){this._channel.then(i=>i.hide())}dispose(){this._channel.then(i=>i.dispose())}}e.LazyOutputChannel=k;let g=class{constructor(i){this._proxy=i.getProxy(E.MainContext.MainThreadOutputService)}$setVisibleChannel(i){}createOutputChannel(i){if(i=i.trim(),!i)throw new Error("illegal argument `name`. must not be falsy");return new n(i,this._proxy)}createOutputChannelFromLogFile(i,s){if(i=i.trim(),!i)throw new Error("illegal argument `name`. must not be falsy");if(!s)throw new Error("illegal argument `file`. must not be falsy");return new T(i,s,this._proxy)}};g=je([Ke(0,C.IExtHostRpcService)],g),e.ExtHostOutputService=g,e.IExtHostOutputService=(0,S.createDecorator)("IExtHostOutputService")}),define(_e[202],we([0,1,14,20,3,6,5,2,7,10,11,46]),function(ie,e,E,I,P,A,S,C,y,n,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function g(m,i,s){const _=m.getProxy(S.MainContext.MainThreadQuickOpen);class d{constructor(o,a){this._sessions=new Map,this._instances=0,this._workspace=o,this._commands=a}showQuickPick(o,a,f,w=I.CancellationToken.None){this._onDidSelectItem=void 0;const D=Promise.resolve(o),p=++this._instances,h=_.$show(p,{title:f==null?void 0:f.title,placeHolder:f==null?void 0:f.placeHolder,matchOnDescription:f==null?void 0:f.matchOnDescription,matchOnDetail:f==null?void 0:f.matchOnDetail,ignoreFocusLost:f==null?void 0:f.ignoreFocusOut,canPickMany:f==null?void 0:f.canPickMany},w),R={},F=h.then(()=>R);return Promise.race([F,D]).then($=>{if($!==R)return D.then(se=>{const z=[];for(let x=0;x<se.length;x++){const G=se[x];let M,N,B,Q,W;typeof G=="string"?M=G:(M=G.label,N=G.description,B=G.detail,Q=G.picked,W=G.alwaysShow),z.push({label:M,description:N,handle:x,detail:B,picked:Q,alwaysShow:W})}return f&&typeof f.onDidSelectItem=="function"&&(this._onDidSelectItem=x=>{f.onDidSelectItem(se[x])}),_.$setItems(p,z),h.then(x=>{if(typeof x=="number")return se[x];if(Array.isArray(x))return x.map(G=>se[G])})})}).then(void 0,$=>{if(!(0,n.isPromiseCanceledError)($))return _.$setError(p,$),Promise.reject($)})}$onItemSelected(o){this._onDidSelectItem&&this._onDidSelectItem(o)}showInput(o,a=I.CancellationToken.None){return this._validateInput=o?o.validateInput:void 0,_.$input(o,typeof this._validateInput=="function",a).then(void 0,f=>{if(!(0,n.isPromiseCanceledError)(f))return Promise.reject(f)})}$validateInput(o){return this._validateInput?(0,E.asPromise)(()=>this._validateInput(o)):Promise.resolve(void 0)}async showWorkspaceFolderPick(o,a=I.CancellationToken.None){const f=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[o]);if(!!f){const w=await this._workspace.getWorkspaceFolders2();if(!!w)return w.find(D=>D.uri.toString()===f.uri.toString())}}createQuickPick(o,a){const f=new t(o,a,()=>this._sessions.delete(f._id));return this._sessions.set(f._id,f),f}createInputBox(o){const a=new r(o,()=>this._sessions.delete(a._id));return this._sessions.set(a._id,a),a}$onDidChangeValue(o,a){const f=this._sessions.get(o);f&&f._fireDidChangeValue(a)}$onDidAccept(o){const a=this._sessions.get(o);a&&a._fireDidAccept()}$onDidChangeActive(o,a){const f=this._sessions.get(o);f instanceof t&&f._fireDidChangeActive(a)}$onDidChangeSelection(o,a){const f=this._sessions.get(o);f instanceof t&&f._fireDidChangeSelection(a)}$onDidTriggerButton(o,a){const f=this._sessions.get(o);f&&f._fireDidTriggerButton(a)}$onDidHide(o){const a=this._sessions.get(o);a&&a._fireDidHide()}}class b{constructor(o,a){this._extensionId=o,this._onDidDispose=a,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new P.Emitter,this._onDidChangeValueEmitter=new P.Emitter,this._onDidTriggerButtonEmitter=new P.Emitter,this._onDidHideEmitter=new P.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(o){this._title=o,this.update({title:o})}get step(){return this._steps}set step(o){this._steps=o,this.update({step:o})}get totalSteps(){return this._totalSteps}set totalSteps(o){this._totalSteps=o,this.update({totalSteps:o})}get enabled(){return this._enabled}set enabled(o){this._enabled=o,this.update({enabled:o})}get busy(){return this._busy}set busy(o){this._busy=o,this.update({busy:o})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(o){this._ignoreFocusOut=o,this.update({ignoreFocusOut:o})}get value(){return this._value}set value(o){this._value=o,this.update({value:o})}get placeholder(){return this._placeholder}set placeholder(o){this._placeholder=o,this.update({placeholder:o})}get buttons(){return this._buttons}set buttons(o){this._buttons=o.slice(),this._handlesToButtons.clear(),o.forEach((a,f)=>{const w=a===y.QuickInputButtons.Back?-1:f;this._handlesToButtons.set(w,a)}),this.update({buttons:o.map((a,f)=>({iconPath:v(a.iconPath),tooltip:a.tooltip,handle:a===y.QuickInputButtons.Back?-1:f}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(o){this._value=o,this._onDidChangeValueEmitter.fire(o)}_fireDidTriggerButton(o){const a=this._handlesToButtons.get(o);a&&this._onDidTriggerButtonEmitter.fire(a)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,A.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),_.$dispose(this._id))}update(o){if(!this._disposed){for(const a of Object.keys(o)){const f=o[a];this._pendingUpdate[a]=f===void 0?null:f}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){_.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}b._nextId=1;function v(c){if(c instanceof y.ThemeIcon)return{id:c.id};const o=u(c),a=l(c);return{dark:typeof o=="string"?C.URI.file(o):o,light:typeof a=="string"?C.URI.file(a):a}}function l(c){return typeof c=="object"&&"light"in c?c.light:c}function u(c){return typeof c=="object"&&"dark"in c?c.dark:c}class t extends b{constructor(o,a,f){super(o,f);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new P.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new P.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(o){this._items=o.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),o.forEach((a,f)=>{this._handlesToItems.set(f,a),this._itemsToHandles.set(a,f)}),this.update({items:o.map((a,f)=>({label:a.label,description:a.description,handle:f,detail:a.detail,picked:a.picked,alwaysShow:a.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(o){this._canSelectMany=o,this.update({canSelectMany:o})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(o){this._matchOnDescription=o,this.update({matchOnDescription:o})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(o){this._matchOnDetail=o,this.update({matchOnDetail:o})}get sortByLabel(){return this._sortByLabel}set sortByLabel(o){this._sortByLabel=o,this.update({sortByLabel:o})}get activeItems(){return this._activeItems}set activeItems(o){this._activeItems=o.filter(a=>this._itemsToHandles.has(a)),this.update({activeItems:this._activeItems.map(a=>this._itemsToHandles.get(a))})}get selectedItems(){return this._selectedItems}set selectedItems(o){this._selectedItems=o.filter(a=>this._itemsToHandles.has(a)),this.update({selectedItems:this._selectedItems.map(a=>this._itemsToHandles.get(a))})}_fireDidChangeActive(o){const a=(0,T.coalesce)(o.map(f=>this._handlesToItems.get(f)));this._activeItems=a,this._onDidChangeActiveEmitter.fire(a)}_fireDidChangeSelection(o){const a=(0,T.coalesce)(o.map(f=>this._handlesToItems.get(f)));this._selectedItems=a,this._onDidChangeSelectionEmitter.fire(a)}}class r extends b{constructor(o,a){super(o,a);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(o){this._password=o,this.update({password:o})}get prompt(){return this._prompt}set prompt(o){this._prompt=o,this.update({prompt:o})}get validationMessage(){return this._validationMessage}set validationMessage(o){this._validationMessage=o,this.update({validationMessage:o,severity:o?k.default.Error:k.default.Ignore})}}return new d(i,s)}e.createExtHostQuickOpen=g}),define(_e[203],we([0,1,2,3,51,6,14,5,11,110,19,26,33]),function(ie,e,E,I,P,A,S,C,y,n,T,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function m(o){if(o)return typeof o.iconPath=="string"?E.URI.file(o.iconPath):o.iconPath}function i(o,a){if(!o.iconPath&&!a.iconPath)return 0;if(o.iconPath){if(!a.iconPath)return 1}else return-1;const f=typeof o.iconPath=="string"?o.iconPath:o.iconPath.fsPath,w=typeof a.iconPath=="string"?a.iconPath:a.iconPath.fsPath;return(0,n.comparePaths)(f,w)}function s(o,a){let f=0;if(o.strikeThrough!==a.strikeThrough)return o.strikeThrough?1:-1;if(o.faded!==a.faded)return o.faded?1:-1;if(o.tooltip!==a.tooltip)return(o.tooltip||"").localeCompare(a.tooltip||"");if(f=i(o,a),f!==0)return f;if(o.light&&a.light)f=i(o.light,a.light);else{if(o.light)return 1;if(a.light)return-1}if(f!==0)return f;if(o.dark&&a.dark)f=i(o.dark,a.dark);else{if(o.dark)return 1;if(a.dark)return-1}return f}function _(o,a){if(o.command!==a.command)return o.command<a.command?-1:1;if(o.title!==a.title)return o.title<a.title?-1:1;if(o.tooltip!==a.tooltip){if(o.tooltip!==void 0&&a.tooltip!==void 0)return o.tooltip<a.tooltip?-1:1;if(o.tooltip!==void 0)return 1;if(a.tooltip!==void 0)return-1}if(o.arguments===a.arguments)return 0;if(o.arguments)if(a.arguments){if(o.arguments.length!==a.arguments.length)return o.arguments.length-a.arguments.length}else return 1;else return-1;for(let f=0;f<o.arguments.length;f++){const w=o.arguments[f],D=a.arguments[f];if(w!==D)return w<D?-1:1}return 0}function d(o,a){let f=(0,n.comparePaths)(o.resourceUri.fsPath,a.resourceUri.fsPath,!0);if(f!==0)return f;if(o.command&&a.command)f=_(o.command,a.command);else{if(o.command)return 1;if(a.command)return-1}if(f!==0)return f;if(o.decorations&&a.decorations)f=s(o.decorations,a.decorations);else{if(o.decorations)return 1;if(a.decorations)return-1}return f}function b(o,a){for(let f=0;f<o.length;f++)if(o[f]!==a[f])return!1;return!0}function v(o,a){return o.command===a.command&&o.title===a.title&&o.tooltip===a.tooltip&&(o.arguments&&a.arguments?b(o.arguments,a.arguments):o.arguments===a.arguments)}function l(o,a){return(0,y.equals)(o,a,v)}class u{constructor(a,f,w){this._extension=a,this._proxy=f,this._sourceControlHandle=w,this._value="",this._onDidChange=new I.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(a){this._proxy.$setInputBoxValue(this._sourceControlHandle,a),this.updateValue(a)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(a){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,a),this._placeholder=a}get validateInput(){return(0,g.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(a){if((0,g.checkProposedApiEnabled)(this._extension),a&&typeof a!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=a,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!a)}get visible(){return this._visible}set visible(a){a=!!a,this._visible!==a&&(this._visible=a,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,a))}focus(){(0,g.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(a,f){(0,g.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,a,f)}$onInputBoxValueChange(a){this.updateValue(a)}updateValue(a){this._value=a,this._onDidChange.fire(a)}}e.ExtHostSCMInputBox=u;class t{constructor(a,f,w,D,p){this._proxy=a,this._commands=f,this._sourceControlHandle=w,this._id=D,this._label=p,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new I.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new I.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(a){this._label=a,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,a)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(a){this._hideWhenEmpty=a,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(a){this._resourceStates=[...a],this._onDidUpdateResourceStates.fire()}getResourceState(a){return this._resourceStatesMap.get(a)}$executeResourceCommand(a,f){const w=this._resourceStatesCommandsMap.get(a);return w?(0,S.asPromise)(()=>this._commands.executeCommand(w.command,...w.arguments||[],f)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var a;const f=[...this._resourceStates].sort(d),D=(0,y.sortedDiff)(this._resourceSnapshot,f,d).map(R=>{const F=R.toInsert.map($=>{const se=this._resourceHandlePool++;this._resourceStatesMap.set(se,$);const z=$.resourceUri,x=m($.decorations),G=$.decorations&&m($.decorations.light)||x,M=$.decorations&&m($.decorations.dark)||x,N=[];let B;if($.command)if($.command.command==="vscode.open"||$.command.command==="vscode.diff"){const Se=new A.DisposableStore;B=this._commands.converter.toInternal($.command,Se),this._resourceStatesDisposablesMap.set(se,Se)}else this._resourceStatesCommandsMap.set(se,$.command);G&&N.push(G),M&&M.toString()!==(G==null?void 0:G.toString())&&N.push(M);const Q=$.decorations&&$.decorations.tooltip||"",W=$.decorations&&!!$.decorations.strikeThrough,ee=$.decorations&&!!$.decorations.faded,re=$.contextValue||"";return{rawResource:[se,z,N,Q,W,ee,re,B],handle:se}});return{start:R.start,deleteCount:R.deleteCount,toInsert:F}}),p=D.map(({start:R,deleteCount:F,toInsert:$})=>[R,F,$.map(se=>se.rawResource)]),h=D.reverse();for(const{start:R,deleteCount:F,toInsert:$}of h){const se=$.map(x=>x.handle),z=this._handlesSnapshot.splice(R,F,...se);for(const x of z)this._resourceStatesMap.delete(x),this._resourceStatesCommandsMap.delete(x),(a=this._resourceStatesDisposablesMap.get(x))===null||a===void 0||a.dispose(),this._resourceStatesDisposablesMap.delete(x)}return this._resourceSnapshot=f,p}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class r{constructor(a,f,w,D,p,h){this._proxy=f,this._commands=w,this._id=D,this._label=p,this._rootUri=h,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new A.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new I.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=r._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new u(a,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,D,p,h)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(a){this._count!==a&&(this._count=a,this._proxy.$updateSourceControl(this.handle,{count:a}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(a){this._quickDiffProvider=a,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!a})}get commitTemplate(){return this._commitTemplate}set commitTemplate(a){a!==this._commitTemplate&&(this._commitTemplate=a,this._proxy.$updateSourceControl(this.handle,{commitTemplate:a}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(a){this._acceptInputDisposables.value=new A.DisposableStore,this._acceptInputCommand=a;const f=this._commands.converter.toInternal(a,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:f})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(a){if(!(this._statusBarCommands&&a&&l(this._statusBarCommands,a))){this._statusBarDisposables.value=new A.DisposableStore,this._statusBarCommands=a;const f=(a||[]).map(w=>this._commands.converter.toInternal(w,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:f})}}get selected(){return this._selected}createResourceGroup(a,f){const w=new t(this._proxy,this._commands,this.handle,a,f),D=I.Event.once(w.onDidDispose)(()=>this.createdResourceGroups.delete(w));return this.createdResourceGroups.set(w,D),this.eventuallyAddResourceGroups(),w}eventuallyAddResourceGroups(){const a=[],f=[];for(const[w,D]of this.createdResourceGroups){D.dispose();const p=w.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(w),this.eventuallyUpdateResourceStates()});I.Event.once(w.onDidDispose)(()=>{this.updatedResourceGroups.delete(w),p.dispose(),this._groups.delete(w.handle),this._proxy.$unregisterGroup(this.handle,w.handle)}),a.push([w.handle,w.id,w.label,w.features]);const h=w._takeResourceStateSnapshot();h.length>0&&f.push([w.handle,h]),this._groups.set(w.handle,w)}this._proxy.$registerGroups(this.handle,a,f),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const a=[];this.updatedResourceGroups.forEach(f=>{const w=f._takeResourceStateSnapshot();w.length!==0&&a.push([f.handle,w])}),a.length>0&&this._proxy.$spliceResourceStates(this.handle,a),this.updatedResourceGroups.clear()}getResourceGroup(a){return this._groups.get(a)}setSelectionState(a){this._selected=a,this._onDidChangeSelection.fire(a)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(a=>a.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}r._handlePool=0,je([(0,P.debounce)(100)],r.prototype,"eventuallyAddResourceGroups",null),je([(0,P.debounce)(100)],r.prototype,"eventuallyUpdateResourceStates",null);let c=class kn{constructor(a,f,w){this._commands=f,this.logService=w,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new I.Emitter,this._proxy=a.getProxy(C.MainContext.MainThreadSCM),this._telemetry=a.getProxy(C.MainContext.MainThreadTelemetry),f.registerArgumentProcessor({processArgument:D=>{if(D&&D.$mid===3){const p=this._sourceControls.get(D.sourceControlHandle);if(!p)return D;const h=p.getResourceGroup(D.groupHandle);return h?h.getResourceState(D.handle):D}else if(D&&D.$mid===4){const p=this._sourceControls.get(D.sourceControlHandle);return p?p.getResourceGroup(D.groupHandle):D}else if(D&&D.$mid===5){const p=this._sourceControls.get(D.handle);return p||D}return D}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(a,f,w,D){this.logService.trace("ExtHostSCM#createSourceControl",a.identifier.value,f,w,D),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:a.identifier.value});const p=kn._handlePool++,h=new r(a,this._proxy,this._commands,f,w,D);this._sourceControls.set(p,h);const R=this._sourceControlsByExtension.get(k.ExtensionIdentifier.toKey(a.identifier))||[];return R.push(h),this._sourceControlsByExtension.set(k.ExtensionIdentifier.toKey(a.identifier),R),h}getLastInputBox(a){this.logService.trace("ExtHostSCM#getLastInputBox",a.identifier.value);const f=this._sourceControlsByExtension.get(k.ExtensionIdentifier.toKey(a.identifier)),w=f&&f[f.length-1];return w&&w.inputBox}$provideOriginalResource(a,f,w){const D=E.URI.revive(f);this.logService.trace("ExtHostSCM#$provideOriginalResource",a,D.toString());const p=this._sourceControls.get(a);return!p||!p.quickDiffProvider||!p.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,S.asPromise)(()=>p.quickDiffProvider.provideOriginalResource(D,w)).then(h=>h||null)}$onInputBoxValueChange(a,f){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",a);const w=this._sourceControls.get(a);return w&&w.inputBox.$onInputBoxValueChange(f),Promise.resolve(void 0)}$executeResourceCommand(a,f,w,D){this.logService.trace("ExtHostSCM#$executeResourceCommand",a,f,w);const p=this._sourceControls.get(a);if(!p)return Promise.resolve(void 0);const h=p.getResourceGroup(f);return h?h.$executeResourceCommand(w,D):Promise.resolve(void 0)}$validateInput(a,f,w){this.logService.trace("ExtHostSCM#$validateInput",a);const D=this._sourceControls.get(a);return!D||!D.inputBox.validateInput?Promise.resolve(void 0):(0,S.asPromise)(()=>D.inputBox.validateInput(f,w)).then(p=>p?Promise.resolve([p.message,p.type]):Promise.resolve(void 0))}$setSelectedSourceControl(a){var f,w;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",a),a!==void 0&&((f=this._sourceControls.get(a))===null||f===void 0||f.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((w=this._sourceControls.get(this._selectedSourceControlHandle))===null||w===void 0||w.setSelectionState(!1)),this._selectedSourceControlHandle=a,Promise.resolve(void 0)}};c._handlePool=0,c=je([Ke(2,T.ILogService)],c),e.ExtHostSCM=c});var tt=this&&this.__classPrivateFieldSet||function(ie,e,E,I,P){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!P:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?P.call(ie,E):P?P.value=E:e.set(ie,E),E},xe=this&&this.__classPrivateFieldGet||function(ie,e,E,I){if(E==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!I:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?I:E==="a"?I.call(ie):I?I.value:e.get(ie)};define(_e[204],we([0,1,7,5,133,6]),function(ie,e,E,I,P,A){"use strict";var S,C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class y{constructor(g,m,i,s,_=E.StatusBarAlignment.Left,d,b){S.set(this,void 0),C.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new A.DisposableStore,tt(this,S,g,"f"),tt(this,C,m,"f"),this._id=y.ID_GEN++,this._statusId=i,this._statusName=s,this._alignment=_,this._priority=d,this._accessibilityInformation=b}get id(){return this._id}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var g;return(g=this._command)===null||g===void 0?void 0:g.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(g){this._text=g,this.update()}set tooltip(g){this._tooltip=g,this.update()}set color(g){this._color=g,this.update()}set backgroundColor(g){g&&!y.ALLOWED_BACKGROUND_COLORS.has(g.id)&&(g=void 0),this._backgroundColor=g,this.update()}set command(g){var m;((m=this._command)===null||m===void 0?void 0:m.fromApi)!==g&&(this._internalCommandRegistration.clear(),typeof g=="string"?this._command={fromApi:g,internal:xe(this,C,"f").toInternal({title:"",command:g},this._internalCommandRegistration)}:g?this._command={fromApi:g,internal:xe(this,C,"f").toInternal(g,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(g){this._accessibilityInformation=g,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,xe(this,S,"f").$dispose(this.id)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var g;this._timeoutHandle=void 0;let m=this._color;this._backgroundColor&&(m=y.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),xe(this,S,"f").$setEntry(this.id,this._statusId,this._statusName,this._text,this._tooltip,(g=this._command)===null||g===void 0?void 0:g.internal,m,this._backgroundColor,this._alignment===E.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=y,S=new WeakMap,C=new WeakMap,y.ID_GEN=0,y.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new E.ThemeColor("statusBarItem.errorForeground")]]);class n{constructor(g){this._messages=[],this._item=g.createStatusBarEntry("status.extensionMessage",(0,P.localize)(0,null),E.StatusBarAlignment.Left,Number.MIN_VALUE)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(g){const m={message:g};return this._messages.unshift(m),this._update(),new E.Disposable(()=>{const i=this._messages.indexOf(m);i>=0&&(this._messages.splice(i,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class T{constructor(g,m){this._proxy=g.getProxy(I.MainContext.MainThreadStatusBar),this._commands=m,this._statusMessage=new n(this)}createStatusBarEntry(g,m,i,s,_){return new y(this._proxy,this._commands,g,m,i,s,_)}setStatusBarMessage(g,m){const i=this._statusMessage.setMessage(g);let s;return typeof m=="number"?s=setTimeout(()=>i.dispose(),m):typeof m!="undefined"&&m.then(()=>i.dispose(),()=>i.dispose()),new E.Disposable(()=>{i.dispose(),clearTimeout(s)})}}e.ExtHostStatusBar=T}),define(_e[75],we([0,1,5,3,4]),function(ie,e,E,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class A{constructor(C){this._onDidChangeStorage=new I.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=C.getProxy(E.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(C,y){this._proxy.$registerExtensionStorageKeysToSync(C,y)}getValue(C,y,n){return this._proxy.$getValue(C,y).then(T=>T||n)}setValue(C,y,n){return this._proxy.$setValue(C,y,n)}$acceptValue(C,y,n){this._onDidChangeStorage.fire({shared:C,key:y,value:n})}}e.ExtHostStorage=A,e.IExtHostStorage=(0,P.createDecorator)("IExtHostStorage")}),define(_e[76],we([0,1,4,27,19,74,2]),function(ie,e,E,I,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,E.createDecorator)("IExtensionStoragePaths");let C=class{constructor(n,T,k){var g;this._logService=T,this._extHostFileSystem=k,this._workspace=(g=n.workspace)!==null&&g!==void 0?g:void 0,this._environment=n.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(m=>this._value=m)}async _getOrCreateWorkspaceStoragePath(){var n;if(!this._workspace)return Promise.resolve(void 0);const T=this._workspace.id,k=S.URI.joinPath(this._environment.workspaceStorageHome,T);try{return await this._extHostFileSystem.value.stat(k),this._logService.trace("[ExtHostStorage] storage dir already exists",k),k}catch(g){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",k),await this._extHostFileSystem.value.createDirectory(k),await this._extHostFileSystem.value.writeFile(S.URI.joinPath(k,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(n=S.URI.revive(this._workspace.configuration))===null||n===void 0?void 0:n.toString(),name:this._workspace.name},void 0,2))),k}catch(g){this._logService.error("[ExtHostStorage]",g);return}}workspaceValue(n){if(this._value)return S.URI.joinPath(this._value,n.identifier.value)}globalValue(n){return S.URI.joinPath(this._environment.globalStorageHome,n.identifier.value.toLowerCase())}};C=je([Ke(0,I.IExtHostInitDataService),Ke(1,P.ILogService),Ke(2,A.IExtHostConsumerFileSystem)],C),e.ExtensionStoragePaths=C}),define(_e[40],we([0,1,3,5,4,2,15,6,7,134,10,171,20,29,154]),function(ie,e,E,I,P,A,S,C,y,n,T,k,g,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,P.createDecorator)("IExtHostTerminalService");class s{constructor(t,r,c,o){this._proxy=t,this._id=r,this._creationOptions=c,this._name=o,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(f=>this._pidPromiseComplete=f);const a=this;this.value={get name(){return a._name||""},get processId(){return a._pidPromise},get creationOptions(){return a._creationOptions},get exitStatus(){return a._exitStatus},sendText(f,w=!0){a._checkDisposed(),a._proxy.$sendText(a._id,f,w)},show(f){a._checkDisposed(),a._proxy.$show(a._id,f)},hide(){a._checkDisposed(),a._proxy.$hide(a._id)},dispose(){a._disposed||(a._disposed=!0,a._proxy.$dispose(a._id))},get dimensions(){if(!(a._cols===void 0||a._rows===void 0))return{columns:a._cols,rows:a._rows}}}}async create(t,r,c,o,a,f,w,D,p,h,R){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:this._name,shellPath:t,shellArgs:r,cwd:c,env:o,icon:a,initialText:f,waitOnExit:w,strictEnv:D,hideFromUser:p,isFeatureTerminal:h,isExtensionOwnedTerminal:R})}async createExtensionTerminal(){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,r){return t===this._cols&&r===this._rows||t===0||r===0?!1:(this._cols=t,this._rows=r,!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(r=>{r!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=s;class _{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new E.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new E.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new E.Emitter,this._onProcessTitleChanged=new E.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new E.Emitter,this._onProcessShellTypeChanged=new E.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput&&this._pty.handleInput(t)}resize(t,r){this._pty.setDimensions&&this._pty.setDimensions({columns:t,rows:r})}async processBinary(t){}acknowledgeDataEvent(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(r=>this._onProcessData.fire(r)),this._pty.onDidClose&&this._pty.onDidClose((r=void 0)=>{this._onProcessExit.fire(r===void 0?void 0:r)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(r=>this._onProcessOverrideDimensions.fire(r&&{cols:r.columns,rows:r.rows})),this._pty.open(t||void 0),this._pty.setDimensions&&t&&this._pty.setDimensions(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=_;let d=1,b=class extends C.Disposable{constructor(t,r){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new E.Emitter,this._onDidOpenTerminal=new E.Emitter,this._onDidChangeActiveTerminal=new E.Emitter,this._onDidChangeTerminalDimensions=new E.Emitter,this._proxy=r.getProxy(I.MainContext.MainThreadTerminalService),this._bufferer=new i.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new E.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[c,o]of this._terminalProcesses)o.shutdown(!0)}})}get activeTerminal(){var t;return(t=this._activeTerminal)===null||t===void 0?void 0:t.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}createExtensionTerminal(t){const r=new s(this._proxy,(0,m.generateUuid)(),t,t.name),c=new _(t.pty);return r.createExtensionTerminal().then(o=>{const a=this._setupExtHostProcessListeners(o,c);this._terminalProcessDisposables[o]=a}),this._terminals.push(r),r.value}attachPtyToTerminal(t,r){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const o=new _(r),a=this._setupExtHostProcessListeners(t,o);this._terminalProcessDisposables[t]=a}async $acceptActiveTerminalChanged(t){const r=this._activeTerminal;if(t===null){this._activeTerminal=void 0,r!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const c=this._getTerminalById(t);c&&(this._activeTerminal=c,r!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,r){const c=this._getTerminalById(t);c&&this._onDidWriteTerminalData.fire({terminal:c.value,data:r})}async $acceptTerminalDimensions(t,r,c){const o=this._getTerminalById(t);o&&o.setDimensions(r,c)&&this._onDidChangeTerminalDimensions.fire({terminal:o.value,dimensions:o.value.dimensions})}async $acceptTerminalMaximumDimensions(t,r,c){var o;(o=this._terminalProcesses.get(t))===null||o===void 0||o.resize(r,c)}async $acceptTerminalTitleChange(t,r){const c=this._getTerminalById(t);c&&(c.name=r)}async $acceptTerminalClosed(t,r){const c=this._getTerminalObjectIndexById(this._terminals,t);if(c!==null){const o=this._terminals.splice(c,1)[0];o.setExitCode(r),this._onDidCloseTerminal.fire(o.value)}}$acceptTerminalOpened(t,r,c,o){if(r){const w=this._getTerminalObjectIndexById(this._terminals,r);if(w!==null){this._terminals[w]._id=t,this._onDidOpenTerminal.fire(this.terminals[w]),this._terminals[w].isOpen=!0;return}}const a={name:o.name,shellPath:o.executable,shellArgs:o.args,cwd:typeof o.cwd=="string"?o.cwd:A.URI.revive(o.cwd),env:o.env,hideFromUser:o.hideFromUser},f=new s(this._proxy,t,a,c);this._terminals.push(f),this._onDidOpenTerminal.fire(f.value),f.isOpen=!0}async $acceptTerminalProcessId(t,r){const c=this._getTerminalById(t);c&&c._setProcessId(r)}async $startExtensionTerminal(t,r){const c=this._getTerminalById(t);if(!c)return{message:(0,n.localize)(0,null,t)};c.isOpen||await new Promise(a=>{const f=this.onDidOpenTerminal(async w=>{w===c.value&&(f.dispose(),a())})});const o=this._terminalProcesses.get(t);o?o.startSendingEvents(r):this._extensionTerminalAwaitingStart[t]={initialDimensions:r}}_setupExtHostProcessListeners(t,r){const c=new C.DisposableStore;c.add(r.onProcessReady(a=>this._proxy.$sendProcessReady(t,a.pid,a.cwd))),c.add(r.onProcessTitleChanged(a=>this._proxy.$sendProcessTitle(t,a))),this._bufferer.startBuffering(t,r.onProcessData),c.add(r.onProcessExit(a=>this._onProcessExit(t,a))),r.onProcessOverrideDimensions&&c.add(r.onProcessOverrideDimensions(a=>this._proxy.$sendOverrideDimensions(t,a))),this._terminalProcesses.set(t,r);const o=this._extensionTerminalAwaitingStart[t];return o&&r instanceof _&&(r.startSendingEvents(o.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),c}$acceptProcessAckDataEvent(t,r){var c;(c=this._terminalProcesses.get(t))===null||c===void 0||c.acknowledgeDataEvent(r)}$acceptProcessInput(t,r){var c;(c=this._terminalProcesses.get(t))===null||c===void 0||c.input(r)}$acceptProcessResize(t,r,c){var o;try{(o=this._terminalProcesses.get(t))===null||o===void 0||o.resize(r,c)}catch(a){if(a.code!=="EPIPE"&&a.code!=="ERR_IPC_CHANNEL_CLOSED")throw a}}$acceptProcessShutdown(t,r){var c;(c=this._terminalProcesses.get(t))===null||c===void 0||c.shutdown(r)}$acceptProcessRequestInitialCwd(t){var r;(r=this._terminalProcesses.get(t))===null||r===void 0||r.getInitialCwd().then(c=>this._proxy.$sendProcessInitialCwd(t,c))}$acceptProcessRequestCwd(t){var r;(r=this._terminalProcesses.get(t))===null||r===void 0||r.getCwd().then(c=>this._proxy.$sendProcessCwd(t,c))}$acceptProcessRequestLatency(t){return t}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new y.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}async $provideLinks(t,r){const c=this._getTerminalById(t);if(!c)return[];this._terminalLinkCache.delete(t);const o=this._terminalLinkCancellationSource.get(t);o&&o.dispose(!0);const a=new g.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,a);const f=[],w={terminal:c.value,line:r},D=[];for(const R of this._linkProviders)D.push(new Promise(async F=>{a.token.onCancellationRequested(()=>F({provider:R,links:[]}));const $=await R.provideTerminalLinks(w,a.token)||[];a.token.isCancellationRequested||F({provider:R,links:$})}));const p=await Promise.all(D);if(a.token.isCancellationRequested)return[];const h=new Map;for(const R of p)R&&R.links.length>0&&f.push(...R.links.map(F=>{const $={id:d++,startIndex:F.startIndex,length:F.length,label:F.tooltip};return h.set($.id,{provider:R.provider,link:F}),$}));return this._terminalLinkCache.set(t,h),f}$activateLink(t,r){var c;const o=(c=this._terminalLinkCache.get(t))===null||c===void 0?void 0:c.get(r);!o||o.provider.handleTerminalLink(o.link)}_onProcessExit(t,r){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const c=this._terminalProcessDisposables[t];c&&(c.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,r)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,r){const c=this._getTerminalObjectIndexById(t,r);return c!==null?t[c]:null}_getTerminalObjectIndexById(t,r){let c=null;return t.some((o,a)=>o._id===r?(c=a,!0):!1),c}getEnvironmentVariableCollection(t){let r=this._environmentVariableCollections.get(t.identifier.value);return r||(r=new v,this._setEnvironmentVariableCollection(t.identifier.value,r)),r}_syncEnvironmentVariableCollection(t,r){const c=(0,k.serializeEnvironmentVariableCollection)(r.map);this._proxy.$setEnvironmentVariableCollection(t,r.persistent,c.length===0?void 0:c)}$initEnvironmentVariableCollections(t){t.forEach(r=>{const c=r[0],o=new v(r[1]);this._setEnvironmentVariableCollection(c,o)})}_setEnvironmentVariableCollection(t,r){this._environmentVariableCollections.set(t,r),r.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,r)})}};b=je([Ke(1,S.IExtHostRpcService)],b),e.BaseExtHostTerminalService=b;class v{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new E.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,r){this._setIfDiffers(t,{value:r,type:y.EnvironmentVariableMutatorType.Replace})}append(t,r){this._setIfDiffers(t,{value:r,type:y.EnvironmentVariableMutatorType.Append})}prepend(t,r){this._setIfDiffers(t,{value:r,type:y.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,r){const c=this.map.get(t);(!c||c.value!==r.value||c.type!==r.type)&&(this.map.set(t,r),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,r){this.map.forEach((c,o)=>t.call(r,o,c,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=v;let l=class extends b{constructor(t){super(!1,t)}createTerminal(t,r,c){throw new T.NotSupportedError}createTerminalFromOptions(t){throw new T.NotSupportedError}getDefaultShell(t,r){throw new T.NotSupportedError}getDefaultShellArgs(t,r){throw new T.NotSupportedError}$getAvailableProfiles(t){throw new T.NotSupportedError}async $getDefaultShellAndArgs(t){throw new T.NotSupportedError}$acceptWorkspacePermissionsChanged(t){throw new T.NotSupportedError}};l=je([Ke(0,S.IExtHostRpcService)],l),e.WorkerExtHostTerminalService=l}),define(_e[205],we([0,1,3,11,5,96,9,7]),function(ie,e,E,I,P,A,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(T,k){this._extHostDocumentsAndEditors=k,this._onDidChangeTextEditorSelection=new E.Emitter,this._onDidChangeTextEditorOptions=new E.Emitter,this._onDidChangeTextEditorVisibleRanges=new E.Emitter,this._onDidChangeTextEditorViewColumn=new E.Emitter,this._onDidChangeActiveTextEditor=new E.Emitter,this._onDidChangeVisibleTextEditors=new E.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=T.getProxy(P.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(g=>this._onDidChangeVisibleTextEditors.fire(g)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(g=>this._onDidChangeActiveTextEditor.fire(g))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(T){const k=this._extHostDocumentsAndEditors.allEditors();return T?k:k.map(g=>g.value)}async showTextDocument(T,k,g){let m;typeof k=="number"?m={position:S.ViewColumn.from(k),preserveFocus:g}:typeof k=="object"?m={position:S.ViewColumn.from(k.viewColumn),preserveFocus:k.preserveFocus,selection:typeof k.selection=="object"?S.Range.from(k.selection):void 0,pinned:typeof k.preview=="boolean"?!k.preview:void 0}:m={preserveFocus:!1};const i=await this._proxy.$tryShowTextDocument(T.uri,m),s=i&&this._extHostDocumentsAndEditors.getEditor(i);if(s)return s.value;throw i?new Error(`Could NOT open editor for "${T.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${T.uri.toString()}".`)}createTextEditorDecorationType(T){return new A.TextEditorDecorationType(this._proxy,T).value}$acceptEditorPropertiesChanged(T,k){const g=this._extHostDocumentsAndEditors.getEditor(T);if(!g)throw new Error("unknown text editor");if(k.options&&g._acceptOptions(k.options),k.selections){const m=k.selections.selections.map(S.Selection.to);g._acceptSelections(m)}if(k.visibleRanges){const m=I.coalesce(k.visibleRanges.map(S.Range.to));g._acceptVisibleRanges(m)}if(k.options&&this._onDidChangeTextEditorOptions.fire({textEditor:g.value,options:Object.assign(Object.assign({},k.options),{lineNumbers:S.TextEditorLineNumbersStyle.to(k.options.lineNumbers)})}),k.selections){const m=C.TextEditorSelectionChangeKind.fromValue(k.selections.source),i=k.selections.selections.map(S.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:g.value,selections:i,kind:m})}if(k.visibleRanges){const m=I.coalesce(k.visibleRanges.map(S.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:g.value,visibleRanges:m})}}$acceptEditorPositionData(T){for(const k in T){const g=this._extHostDocumentsAndEditors.getEditor(k);if(!g)throw new Error("Unknown text editor");const m=S.ViewColumn.to(T[k]);g.value.viewColumn!==m&&(g._acceptViewColumn(m),this._onDidChangeTextEditorViewColumn.fire({textEditor:g.value,viewColumn:m}))}}getDiffInformation(T){return Promise.resolve(this._proxy.$getDiffInformation(T))}}e.ExtHostEditors=y});var un=this&&this.__rest||function(ie,e){var E={};for(var I in ie)Object.prototype.hasOwnProperty.call(ie,I)&&e.indexOf(I)<0&&(E[I]=ie[I]);if(ie!=null&&typeof Object.getOwnPropertySymbols=="function")for(var P=0,I=Object.getOwnPropertySymbols(ie);P<I.length;P++)e.indexOf(I[P])<0&&Object.prototype.propertyIsEnumerable.call(ie,I[P])&&(E[I[P]]=ie[I[P]]);return E};define(_e[206],we([0,1,2,4,5,6,7]),function(ie,e,E,I,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,I.createDecorator)("IExtHostTimeline");class C{constructor(T,k){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=T.getProxy(P.MainContext.MainThreadTimeline),k.registerArgumentProcessor({processArgument:g=>{var m,i;if(g&&g.$mid===11){const s=g.uri===void 0?void 0:E.URI.revive(g.uri);return(i=(m=this._itemsBySourceAndUriMap.get(g.source))===null||m===void 0?void 0:m.get(y(s)))===null||i===void 0?void 0:i.get(g.handle)}return g}})}async $getTimeline(T,k,g,m,i){const s=this._providers.get(T);return s==null?void 0:s.provideTimeline(E.URI.revive(k),g,m,i)}registerTimelineProvider(T,k,g,m){const i=new A.DisposableStore,s=this.convertTimelineItem(k.id,m,i).bind(this);let _;k.onDidChange&&(_=k.onDidChange(b=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},b),{id:k.id})),this));const d=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},k),{scheme:T,onDidChange:void 0,async provideTimeline(b,v,l,u){var t;(u==null?void 0:u.resetCache)&&(i.clear(),(t=d.get(k.id))===null||t===void 0||t.clear());const r=await k.provideTimeline(b,v,l);if(r!=null){const c=s(b,u);return Object.assign(Object.assign({},r),{source:k.id,items:r.items.map(c)})}},dispose(){var b;for(const v of d.values())(b=v.get(k.id))===null||b===void 0||b.clear();_==null||_.dispose(),i.dispose()}}))}convertTimelineItem(T,k,g){return(m,i)=>{let s;if(i==null?void 0:i.cacheResults){let _=this._itemsBySourceAndUriMap.get(T);_===void 0&&(_=new Map,this._itemsBySourceAndUriMap.set(T,_));const d=y(m);s=_.get(d),s===void 0&&(s=new Map,_.set(d,s))}return _=>{var d,b;const{iconPath:v}=_,l=un(_,["iconPath"]),u=`${T}|${(d=_.id)!==null&&d!==void 0?d:_.timestamp}`;s==null||s.set(u,_);let t,r,c;return _.iconPath&&(v instanceof S.ThemeIcon?c={id:v.id}:E.URI.isUri(v)?(t=v,r=v):{light:t,dark:r}=v),Object.assign(Object.assign({},l),{id:(b=l.id)!==null&&b!==void 0?b:void 0,handle:u,source:T,command:_.command?k.toInternal(_.command,g):void 0,icon:t,iconDark:r,themeIcon:c,accessibilityInformation:_.accessibilityInformation})}}}registerTimelineProviderCore(T){if(this._providers.get(T.id))throw new Error(`Timeline Provider ${T.id} already exists.`);return this._proxy.$registerTimelineProvider({id:T.id,label:T.label,scheme:T.scheme}),this._providers.set(T.id,T),(0,A.toDisposable)(()=>{var g;for(const m of this._itemsBySourceAndUriMap.values())(g=m.get(T.id))===null||g===void 0||g.clear();this._providers.delete(T.id),this._proxy.$unregisterTimelineProvider(T.id),T.dispose()})}}e.ExtHostTimeline=C;function y(n){return n==null?void 0:n.toString()}}),define(_e[207],we([0,1,6,18,2,5]),function(ie,e,E,I,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class S{constructor(y){this._openers=new Map,this._proxy=y.getProxy(A.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,n,T,k){if(this._openers.has(n))throw new Error(`Opener with id '${n}' already registered`);const g=k.schemes.find(m=>!S.supportedSchemes.has(m));if(g)throw new Error(`Scheme '${g}' is not supported. Only http and https are currently supported.`);return this._openers.set(n,T),this._proxy.$registerUriOpener(n,k.schemes,y,k.label),(0,E.toDisposable)(()=>{this._openers.delete(n),this._proxy.$unregisterUriOpener(n)})}async $canOpenUri(y,n,T){const k=this._openers.get(y);if(!k)throw new Error(`Unknown opener with id: ${y}`);const g=P.URI.revive(n);return k.canOpenExternalUri(g,T)}async $openUri(y,n,T){const k=this._openers.get(y);if(!k)throw new Error(`Unknown opener id: '${y}'`);return k.openExternalUri(P.URI.revive(n.resolvedUri),{sourceUri:P.URI.revive(n.sourceUri)},T)}}e.ExtHostUriOpeners=S,S.supportedSchemes=new Set([I.Schemas.http,I.Schemas.https])}),define(_e[208],we([0,1,5,2,6,10,26]),function(ie,e,E,I,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class C{constructor(n){this.handles=new Set,this.handlers=new Map,this._proxy=n.getProxy(E.MainContext.MainThreadUrls)}registerUriHandler(n,T){if(this.handles.has(S.ExtensionIdentifier.toKey(n)))throw new Error(`Protocol handler already registered for extension ${n}`);const k=C.HandlePool++;return this.handles.add(S.ExtensionIdentifier.toKey(n)),this.handlers.set(k,T),this._proxy.$registerUriHandler(k,n),(0,P.toDisposable)(()=>{this.handles.delete(S.ExtensionIdentifier.toKey(n)),this.handlers.delete(k),this._proxy.$unregisterUriHandler(k)})}$handleExternalUri(n,T){const k=this.handlers.get(n);if(!k)return Promise.resolve(void 0);try{k.handleUri(I.URI.revive(T))}catch(g){(0,A.onUnexpectedError)(g)}return Promise.resolve(void 0)}async createAppUri(n){return I.URI.revive(await this._proxy.$createAppUri(n))}}e.ExtHostUrls=C,C.HandlePool=0});var tt=this&&this.__classPrivateFieldSet||function(ie,e,E,I,P){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!P:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?P.call(ie,E):P?P.value=E:e.set(ie,E),E},xe=this&&this.__classPrivateFieldGet||function(ie,e,E,I){if(E==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!I:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?I:E==="a"?I.call(ie):I?I.value:e.get(ie)};define(_e[49],we([0,1,23,3,2,143,164,69,5]),function(ie,e,E,I,P,A,S,C,y){"use strict";var n,T,k,g,m,i,s,_,d,b,v,l;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.serializeMessage=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class u{constructor(p,h,R,F,$,se,z){n.set(this,void 0),T.set(this,void 0),k.set(this,void 0),g.set(this,void 0),m.set(this,void 0),i.set(this,void 0),s.set(this,""),_.set(this,void 0),d.set(this,!1),b.set(this,!1),v.set(this,!1),this._onMessageEmitter=new I.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,l.set(this,new I.Emitter),this._onDidDispose=xe(this,l,"f").event,tt(this,n,p,"f"),tt(this,T,h,"f"),tt(this,_,R,"f"),tt(this,g,F,"f"),tt(this,m,$,"f"),tt(this,i,se,"f"),tt(this,v,t(se),"f"),tt(this,k,z,"f")}dispose(){tt(this,d,!0,"f"),xe(this,l,"f").fire(),xe(this,l,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(p){return tt(this,b,!0,"f"),(0,C.asWebviewUri)(xe(this,g,"f"),xe(this,n,"f"),p)}get cspSource(){return xe(this,g,"f").webviewCspSource.replace("{{uuid}}",xe(this,n,"f"))}get html(){return this.assertNotDisposed(),xe(this,s,"f")}set html(p){this.assertNotDisposed(),xe(this,s,"f")!==p&&(tt(this,s,p,"f"),!xe(this,b,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(p)&&(tt(this,b,!0,"f"),xe(this,k,"f").report("Webview vscode-resource: uris",xe(this,i,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),xe(this,T,"f").$setHtml(xe(this,n,"f"),p))}get options(){return this.assertNotDisposed(),xe(this,_,"f")}set options(p){this.assertNotDisposed(),xe(this,T,"f").$setOptions(xe(this,n,"f"),a(xe(this,i,"f"),xe(this,m,"f"),p)),tt(this,_,p,"f")}async postMessage(p){if(xe(this,d,"f"))return!1;const h=r(p,{serializeBuffersForPostMessage:xe(this,v,"f")});return xe(this,T,"f").$postMessage(xe(this,n,"f"),h.message,...h.buffers)}assertNotDisposed(){if(xe(this,d,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=u,n=new WeakMap,T=new WeakMap,k=new WeakMap,g=new WeakMap,m=new WeakMap,i=new WeakMap,s=new WeakMap,_=new WeakMap,d=new WeakMap,b=new WeakMap,v=new WeakMap,l=new WeakMap;function t(D){if(!D.enableProposedApi)return!1;try{const p=(0,A.normalizeVersion)((0,A.parseVersion)(D.engines.vscode));return!!p&&p.majorBase>=1&&p.minorBase>=56}catch(p){return!1}}e.shouldSerializeBuffersForPostMessage=t;function r(D,p){if(p.serializeBuffersForPostMessage){const h=[],R=($,se)=>{if(se&&se instanceof ArrayBuffer){let z=h.findIndex(x=>x.original===se);if(z===-1){const x=new Uint8Array(se),G=E.VSBuffer.wrap(x);z=h.length,h.push({original:se,vsBuffer:G})}return{$$vscode_array_buffer_reference$$:!0,index:z}}return se};return{message:JSON.stringify(D,R),buffers:h.map($=>$.vsBuffer)}}else return{message:JSON.stringify(D),buffers:[]}}e.serializeMessage=r;class c{constructor(p,h,R,F,$){this.initData=h,this.workspace=R,this._logService=F,this._deprecationService=$,this._webviews=new Map,this._webviewProxy=p.getProxy(y.MainContext.MainThreadWebviews)}$onMessage(p,h,...R){const F=this.getWebview(p);if(F){const{message:$}=(0,S.deserializeWebviewMessage)(h,R);F._onMessageEmitter.fire($)}}$onMissingCsp(p,h){this._logService.warn(`${h} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(p,h,R){const F=new u(p,this._webviewProxy,f(h),this.initData,this.workspace,R,this._deprecationService);return this._webviews.set(p,F),F._onDidDispose(()=>{this._webviews.delete(p)}),F}deleteWebview(p){this._webviews.delete(p)}getWebview(p){return this._webviews.get(p)}}e.ExtHostWebviews=c;function o(D){return{id:D.identifier,location:D.extensionLocation}}e.toExtensionData=o;function a(D,p,h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots||w(D,p)}}e.serializeWebviewOptions=a;function f(D){var p;return{enableCommandUris:D.enableCommandUris,enableScripts:D.enableScripts,portMapping:D.portMapping,localResourceRoots:(p=D.localResourceRoots)===null||p===void 0?void 0:p.map(h=>P.URI.from(h))}}e.reviveOptions=f;function w(D,p){return[...((p==null?void 0:p.getWorkspaceFolders())||[]).map(h=>h.uri),D.extensionLocation]}}),define(_e[209],we([0,1,20,56,6,18,25,2,9,49,92,5,7]),function(ie,e,E,I,P,A,S,C,y,n,T,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class m{constructor(t,r){this.document=t,this._storagePath=r,this._backupCounter=1,this._edits=new T.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,r){await this.getEdit(t).undo(),r||this.disposeBackup()}async redo(t,r){await this.getEdit(t).redo(),r||this.disposeBackup()}disposeEdits(t){for(const r of t)this._edits.delete(r)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=l(this.document.uri)+this._backupCounter++;return(0,S.joinPath)(this._storagePath,t)}updateBackup(t){var r;(r=this._backup)===null||r===void 0||r.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const r=this._edits.get(t,0);if(!r)throw new Error("No edit found");return r}}class i{constructor(){this._documents=new Map}get(t,r){return this._documents.get(this.key(t,r))}add(t,r,c){const o=this.key(t,r.uri);if(this._documents.has(o))throw new Error(`Document already exists for viewType:${t} resource:${r.uri}`);const a=new m(r,c);return this._documents.set(o,a),a}delete(t,r){const c=this.key(t,r.uri);this._documents.delete(c)}key(t,r){return`${t}@@@${r}`}}var s;(function(u){u[u.Text=0]="Text",u[u.Custom=1]="Custom"})(s||(s={}));class _{constructor(){this._providers=new Map}addTextProvider(t,r,c){return this.add(0,t,r,c)}addCustomProvider(t,r,c){return this.add(1,t,r,c)}get(t){return this._providers.get(t)}add(t,r,c,o){if(this._providers.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this._providers.set(r,{type:t,extension:c,provider:o}),new g.Disposable(()=>this._providers.delete(r))}}class d{constructor(t,r,c,o,a){this._extHostDocuments=r,this._extensionStoragePaths=c,this._extHostWebview=o,this._extHostWebviewPanels=a,this._editorProviders=new _,this._documents=new i,this._proxy=t.getProxy(k.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,r,c,o){const a=new P.DisposableStore;return b(c)?(a.add(this._editorProviders.addTextProvider(r,t,c)),this._proxy.$registerTextEditorProvider((0,n.toExtensionData)(t),r,o.webviewOptions||{},{supportsMove:!!c.moveCustomTextEditor},(0,n.shouldSerializeBuffersForPostMessage)(t))):(a.add(this._editorProviders.addCustomProvider(r,t,c)),this.supportEditing(c)&&a.add(c.onDidChangeCustomDocument(f=>{const w=this.getCustomDocumentEntry(r,f.document.uri);if(v(f)){const D=w.addEdit(f);this._proxy.$onDidEdit(f.document.uri,r,D,f.label)}else this._proxy.$onContentChange(f.document.uri,r)})),this._proxy.$registerCustomEditorProvider((0,n.toExtensionData)(t),r,o.webviewOptions||{},!!o.supportsMultipleEditorsPerDocument,(0,n.shouldSerializeBuffersForPostMessage)(t))),g.Disposable.from(a,new g.Disposable(()=>{this._proxy.$unregisterEditorProvider(r)}))}async $createCustomDocument(t,r,c,o,a){var f;const w=this._editorProviders.get(r);if(!w)throw new Error(`No provider found for '${r}'`);if(w.type!==1)throw new Error(`Invalid provide type for '${r}'`);const D=C.URI.revive(t),p=await w.provider.openCustomDocument(D,{backupId:c,untitledDocumentData:o==null?void 0:o.buffer},a);let h;return this.supportEditing(w.provider)&&this._extensionStoragePaths&&(h=(f=this._extensionStoragePaths.workspaceValue(w.extension))!==null&&f!==void 0?f:this._extensionStoragePaths.globalValue(w.extension)),this._documents.add(r,p,h),{editable:this.supportEditing(w.provider)}}async $disposeCustomDocument(t,r){const c=this._editorProviders.get(r);if(!c)throw new Error(`No provider found for '${r}'`);if(c.type!==1)throw new Error(`Invalid provider type for '${r}'`);const o=C.URI.revive(t),{document:a}=this.getCustomDocumentEntry(r,o);this._documents.delete(r,a),a.dispose()}async $resolveWebviewEditor(t,r,c,o,a,f){const w=this._editorProviders.get(c);if(!w)throw new Error(`No provider found for '${c}'`);const D=y.ViewColumn.to(a),p=this._extHostWebview.createNewWebview(r,o.webviewOptions,w.extension),h=this._extHostWebviewPanels.createNewWebviewPanel(r,c,o.title,D,o.panelOptions,p),R=C.URI.revive(t);switch(w.type){case 1:{const{document:F}=this.getCustomDocumentEntry(c,R);return w.provider.resolveCustomEditor(F,h,f)}case 0:{const F=this._extHostDocuments.getDocument(R);return w.provider.resolveCustomTextEditor(F,h,f)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,r,c){this.getCustomDocumentEntry(r,t).disposeEdits(c)}async $onMoveCustomEditor(t,r,c){const o=this._editorProviders.get(c);if(!o)throw new Error(`No provider found for '${c}'`);if(!o.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${c}'`);const a=this._extHostWebviewPanels.getWebviewPanel(t);if(!a)throw new Error("No webview found");const f=C.URI.revive(r),w=this._extHostDocuments.getDocument(f);await o.provider.moveCustomTextEditor(w,a,E.CancellationToken.None)}async $undo(t,r,c,o){return this.getCustomDocumentEntry(r,t).undo(c,o)}async $redo(t,r,c,o){return this.getCustomDocumentEntry(r,t).redo(c,o)}async $revert(t,r,c){const o=this.getCustomDocumentEntry(r,t);await this.getCustomEditorProvider(r).revertCustomDocument(o.document,c),o.disposeBackup()}async $onSave(t,r,c){const o=this.getCustomDocumentEntry(r,t);await this.getCustomEditorProvider(r).saveCustomDocument(o.document,c),o.disposeBackup()}async $onSaveAs(t,r,c,o){const a=this.getCustomDocumentEntry(r,t);return this.getCustomEditorProvider(r).saveCustomDocumentAs(a.document,C.URI.revive(c),o)}async $backup(t,r,c){const o=this.getCustomDocumentEntry(r,t),f=await this.getCustomEditorProvider(r).backupCustomDocument(o.document,{destination:o.getNewBackupUri()},c);return o.updateBackup(f),f.id}getCustomDocumentEntry(t,r){const c=this._documents.get(t,C.URI.revive(r));if(!c)throw new Error("No custom document found");return c}getCustomEditorProvider(t){const r=this._editorProviders.get(t),c=r==null?void 0:r.provider;if(!c||!this.supportEditing(c))throw new Error("Custom document is not editable");return c}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=d;function b(u){return typeof u.resolveCustomTextEditor=="function"}function v(u){return typeof u.undo=="function"&&typeof u.redo=="function"}function l(u){const t=u.scheme===A.Schemas.file||u.scheme===A.Schemas.untitled?u.fsPath:u.toString();return(0,I.hash)(t)+""}});var tt=this&&this.__classPrivateFieldSet||function(ie,e,E,I,P){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!P:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?P.call(ie,E):P?P.value=E:e.set(ie,E),E},xe=this&&this.__classPrivateFieldGet||function(ie,e,E,I){if(E==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!I:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?I:E==="a"?I.call(ie):I?I.value:e.get(ie)};define(_e[210],we([0,1,3,6,2,29,9,49,5,7]),function(ie,e,E,I,P,A,S,C,y,n){"use strict";var T,k,g,m,i,s,_,d,b,v,l,u,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class r extends I.Disposable{constructor(f,w,D,p,h,R,F){super();T.set(this,void 0),k.set(this,void 0),g.set(this,void 0),m.set(this,void 0),i.set(this,void 0),s.set(this,void 0),_.set(this,void 0),d.set(this,void 0),b.set(this,!0),v.set(this,!0),l.set(this,!1),u.set(this,this._register(new E.Emitter)),this.onDidDispose=xe(this,u,"f").event,t.set(this,this._register(new E.Emitter)),this.onDidChangeViewState=xe(this,t,"f").event,tt(this,T,f,"f"),tt(this,k,w,"f"),tt(this,g,D,"f"),tt(this,i,R,"f"),tt(this,d,h,"f"),tt(this,s,p,"f"),tt(this,m,F,"f")}dispose(){xe(this,l,"f")||(tt(this,l,!0,"f"),xe(this,u,"f").fire(),xe(this,k,"f").$disposeWebview(xe(this,T,"f")),xe(this,m,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),xe(this,m,"f")}get viewType(){return this.assertNotDisposed(),xe(this,g,"f")}get title(){return this.assertNotDisposed(),xe(this,s,"f")}set title(f){this.assertNotDisposed(),xe(this,s,"f")!==f&&(tt(this,s,f,"f"),xe(this,k,"f").$setTitle(xe(this,T,"f"),f))}get iconPath(){return this.assertNotDisposed(),xe(this,_,"f")}set iconPath(f){this.assertNotDisposed(),xe(this,_,"f")!==f&&(tt(this,_,f,"f"),xe(this,k,"f").$setIconPath(xe(this,T,"f"),P.URI.isUri(f)?{light:f,dark:f}:f))}get options(){return xe(this,i,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof xe(this,d,"f")=="number"&&xe(this,d,"f")<0))return xe(this,d,"f")}get active(){return this.assertNotDisposed(),xe(this,v,"f")}get visible(){return this.assertNotDisposed(),xe(this,b,"f")}_updateViewState(f){xe(this,l,"f")||(this.active!==f.active||this.visible!==f.visible||this.viewColumn!==f.viewColumn)&&(tt(this,v,f.active,"f"),tt(this,b,f.visible,"f"),tt(this,d,f.viewColumn,"f"),xe(this,t,"f").fire({webviewPanel:this}))}reveal(f,w){this.assertNotDisposed(),xe(this,k,"f").$reveal(xe(this,T,"f"),{viewColumn:f?S.ViewColumn.from(f):void 0,preserveFocus:!!w})}assertNotDisposed(){if(xe(this,l,"f"))throw new Error("Webview is disposed")}}T=new WeakMap,k=new WeakMap,g=new WeakMap,m=new WeakMap,i=new WeakMap,s=new WeakMap,_=new WeakMap,d=new WeakMap,b=new WeakMap,v=new WeakMap,l=new WeakMap,u=new WeakMap,t=new WeakMap;class c{constructor(f,w,D){this.webviews=w,this.workspace=D,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=f.getProxy(y.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,A.generateUuid)()}createWebviewPanel(f,w,D,p,h={}){const R=typeof p=="object"?p.viewColumn:p,F={viewColumn:S.ViewColumn.from(R),preserveFocus:typeof p=="object"&&!!p.preserveFocus},$=(0,C.shouldSerializeBuffersForPostMessage)(f),se=c.newHandle();this._proxy.$createWebviewPanel((0,C.toExtensionData)(f),se,w,{title:D,panelOptions:o(h),webviewOptions:(0,C.serializeWebviewOptions)(f,this.workspace,h),serializeBuffersForPostMessage:$},F);const z=this.webviews.createNewWebview(se,h,f);return this.createNewWebviewPanel(se,w,D,R,h,z)}$onDidChangeWebviewPanelViewStates(f){const w=Object.keys(f);w.sort((D,p)=>{const h=f[D],R=f[p];return h.active?1:R.active?-1:+h.visible-+R.visible});for(const D of w){const p=this.getWebviewPanel(D);if(!!p){const h=f[D];p._updateViewState({active:h.active,visible:h.visible,viewColumn:S.ViewColumn.to(h.position)})}}}async $onDidDisposeWebviewPanel(f){const w=this.getWebviewPanel(f);w==null||w.dispose(),this._webviewPanels.delete(f),this.webviews.deleteWebview(f)}registerWebviewPanelSerializer(f,w,D){if(this._serializers.has(w))throw new Error(`Serializer for '${w}' already registered`);return this._serializers.set(w,{serializer:D,extension:f}),this._proxy.$registerSerializer(w,{serializeBuffersForPostMessage:(0,C.shouldSerializeBuffersForPostMessage)(f)}),new n.Disposable(()=>{this._serializers.delete(w),this._proxy.$unregisterSerializer(w)})}async $deserializeWebviewPanel(f,w,D,p){const h=this._serializers.get(w);if(!h)throw new Error(`No serializer found for '${w}'`);const{serializer:R,extension:F}=h,$=this.webviews.createNewWebview(f,D.webviewOptions,F),se=this.createNewWebviewPanel(f,w,D.title,p,D.panelOptions,$);await R.deserializeWebviewPanel(se,D.state)}createNewWebviewPanel(f,w,D,p,h,R){const F=new r(f,this._proxy,w,D,p,h,R);return this._webviewPanels.set(f,F),F}getWebviewPanel(f){return this._webviewPanels.get(f)}}e.ExtHostWebviewPanels=c;function o(a){return{enableFindWidget:a.enableFindWidget,retainContextWhenHidden:a.retainContextWhenHidden}}});var tt=this&&this.__classPrivateFieldSet||function(ie,e,E,I,P){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!P:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?P.call(ie,E):P?P.value=E:e.set(ie,E),E},xe=this&&this.__classPrivateFieldGet||function(ie,e,E,I){if(E==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!I:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?I:E==="a"?I.call(ie):I?I.value:e.get(ie)};define(_e[211],we([0,1,3,6,49,5,7]),function(ie,e,E,I,P,A,S){"use strict";var C,y,n,T,k,g,m,i,s,_;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class d extends I.Disposable{constructor(l,u,t,r,c,o){super();C.set(this,void 0),y.set(this,void 0),n.set(this,void 0),T.set(this,void 0),k.set(this,!1),g.set(this,void 0),m.set(this,void 0),i.set(this,void 0),s.set(this,this._register(new E.Emitter)),this.onDidChangeVisibility=xe(this,s,"f").event,_.set(this,this._register(new E.Emitter)),this.onDidDispose=xe(this,_,"f").event,tt(this,n,t,"f"),tt(this,m,r,"f"),tt(this,C,l,"f"),tt(this,y,u,"f"),tt(this,T,c,"f"),tt(this,g,o,"f")}dispose(){xe(this,k,"f")||(tt(this,k,!0,"f"),xe(this,_,"f").fire(),xe(this,T,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),xe(this,m,"f")}set title(l){this.assertNotDisposed(),xe(this,m,"f")!==l&&(tt(this,m,l,"f"),xe(this,y,"f").$setWebviewViewTitle(xe(this,C,"f"),l))}get description(){return this.assertNotDisposed(),xe(this,i,"f")}set description(l){this.assertNotDisposed(),xe(this,i,"f")!==l&&(tt(this,i,l,"f"),xe(this,y,"f").$setWebviewViewDescription(xe(this,C,"f"),l))}get visible(){return xe(this,g,"f")}get webview(){return xe(this,T,"f")}get viewType(){return xe(this,n,"f")}_setVisible(l){l===xe(this,g,"f")||xe(this,k,"f")||(tt(this,g,l,"f"),xe(this,s,"f").fire())}show(l){this.assertNotDisposed(),xe(this,y,"f").$show(xe(this,C,"f"),!!l)}assertNotDisposed(){if(xe(this,k,"f"))throw new Error("Webview is disposed")}}C=new WeakMap,y=new WeakMap,n=new WeakMap,T=new WeakMap,k=new WeakMap,g=new WeakMap,m=new WeakMap,i=new WeakMap,s=new WeakMap,_=new WeakMap;class b{constructor(l,u){this._extHostWebview=u,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=l.getProxy(A.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(l,u,t,r){if(this._viewProviders.has(u))throw new Error(`View provider for '${u}' already registered`);return this._viewProviders.set(u,{provider:t,extension:l}),this._proxy.$registerWebviewViewProvider((0,P.toExtensionData)(l),u,{retainContextWhenHidden:r==null?void 0:r.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new S.Disposable(()=>{this._viewProviders.delete(u),this._proxy.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(l,u,t,r,c){const o=this._viewProviders.get(u);if(!o)throw new Error(`No view provider found for '${u}'`);const{provider:a,extension:f}=o,w=this._extHostWebview.createNewWebview(l,{},f),D=new d(l,this._proxy,u,t,w,!0);this._webviewViews.set(l,D),await a.resolveWebviewView(D,{state:r},c)}async $onDidChangeWebviewViewVisibility(l,u){this.getWebviewView(l)._setVisible(u)}async $disposeWebviewView(l){const u=this.getWebviewView(l);this._webviewViews.delete(l),u.dispose(),this._extHostWebview.deleteWebview(l)}getWebviewView(l){const u=this._webviewViews.get(l);if(!u)throw new Error("No webview found");return u}}e.ExtHostWebviewViews=b}),define(_e[100],we([0,1,3,5,2,18,8,4,15]),function(ie,e,E,I,P,A,S,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let n=class In{constructor(k){this._onDidChangeWindowState=new E.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=In.InitialState,this._proxy=k.getProxy(I.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(g=>this.$onDidChangeWindowFocus(g))}get state(){return this._state}$onDidChangeWindowFocus(k){k!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:k}),this._onDidChangeWindowState.fire(this._state))}openUri(k,g){let m;if(typeof k=="string"){m=k;try{k=P.URI.parse(k)}catch(i){return Promise.reject(`Invalid uri - '${k}'`)}}return(0,S.isFalsyOrWhitespace)(k.scheme)?Promise.reject("Invalid scheme - cannot be empty"):k.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${k.scheme}'`):this._proxy.$openUri(k,m,g)}async asExternalUri(k,g){if((0,S.isFalsyOrWhitespace)(k.scheme))return Promise.reject("Invalid scheme - cannot be empty");if(!new Set([A.Schemas.http,A.Schemas.https]).has(k.scheme))return Promise.reject(`Invalid scheme '${k.scheme}'`);const m=await this._proxy.$asExternalUri(k,g);return P.URI.from(m)}};n.InitialState={focused:!0},n=je([Ke(0,y.IExtHostRpcService)],n),e.ExtHostWindow=n,e.IExtHostWindow=(0,C.createDecorator)("IExtHostWindow")}),define(_e[212],we([0,1,19,5,27,15]),function(ie,e,E,I,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let S=class extends E.AbstractLogger{constructor(y,n){super();this._proxy=y.getProxy(I.MainContext.MainThreadLog),this._logFile=n.logFile.toJSON(),this.setLevel(n.logLevel)}$setLevel(y){this.setLevel(y)}trace(y,...n){this.getLevel()<=E.LogLevel.Trace&&this._proxy.$log(this._logFile,E.LogLevel.Trace,Array.from(arguments))}debug(y,...n){this.getLevel()<=E.LogLevel.Debug&&this._proxy.$log(this._logFile,E.LogLevel.Debug,Array.from(arguments))}info(y,...n){this.getLevel()<=E.LogLevel.Info&&this._proxy.$log(this._logFile,E.LogLevel.Info,Array.from(arguments))}warn(y,...n){this.getLevel()<=E.LogLevel.Warning&&this._proxy.$log(this._logFile,E.LogLevel.Warning,Array.from(arguments))}error(y,...n){this.getLevel()<=E.LogLevel.Error&&this._proxy.$log(this._logFile,E.LogLevel.Error,Array.from(arguments))}critical(y,...n){this.getLevel()<=E.LogLevel.Critical&&this._proxy.$log(this._logFile,E.LogLevel.Critical,Array.from(arguments))}flush(){}};S=je([Ke(0,A.IExtHostRpcService),Ke(1,P.IExtHostInitDataService)],S),e.ExtHostLogService=S}),define(_e[213],we([0,1,14,20,10,3,6,111,185,97,23]),function(ie,e,E,I,P,A,S,C,y,n,T){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function g(o,a){try{return JSON.stringify(o,a)}catch(f){return"null"}}function m(o,a){return JSON.stringify(o,a)}function i(o){return o?(a,f)=>f&&f.$mid===1?o.transformOutgoing(f):f:null}var s;(function(o){o[o.LocalSide=0]="LocalSide",o[o.OtherSide=1]="OtherSide"})(s=e.RequestInitiator||(e.RequestInitiator={}));var _;(function(o){o[o.Responsive=0]="Responsive",o[o.Unresponsive=1]="Unresponsive"})(_=e.ResponsiveState||(e.ResponsiveState={}));const d=()=>{},b=Symbol.for("rpcProtocol"),v=Symbol.for("rpcProxy");class l extends S.Disposable{constructor(a,f=null,w=null){super();this[k]=!0,this._onDidChangeResponsiveState=this._register(new A.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=a,this._logger=f,this._uriTransformer=w,this._uriReplacer=i(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let D=0,p=n.ProxyIdentifier.count;D<p;D++)this._locals[D]=null,this._proxies[D]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new E.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(D=>this._receiveOneMessage(D))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(a=>{this._pendingRPCReplies[a].resolveErr(P.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(a){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+l.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(a){this._unresponsiveTime=Date.now()+l.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(a){this._responsiveState!==a&&(this._responsiveState=a,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(a){return this._uriTransformer?(0,C.transformIncomingURIs)(a,this._uriTransformer):a}getProxy(a){const{nid:f,sid:w}=a;return this._proxies[f]||(this._proxies[f]=this._createProxy(f,w)),this._proxies[f]}_createProxy(a,f){let w={get:(D,p)=>(typeof p=="string"&&!D[p]&&p.charCodeAt(0)===36&&(D[p]=(...h)=>this._remoteCall(a,p,h)),p===v?f:D[p])};return new Proxy(Object.create(null),w)}set(a,f){return this._locals[a.nid]=f,f}assertRegistered(a){for(let f=0,w=a.length;f<w;f++){const D=a[f];if(!this._locals[D.nid])throw new Error(`Missing actor ${D.sid} (isMain: ${D.isMain})`)}}_receiveOneMessage(a){if(!this._isDisposed){const f=a.byteLength,w=u.read(a,0),D=w.readUInt8(),p=w.readUInt32();switch(D){case 1:case 2:{let{rpcId:h,method:R,args:F}=t.deserializeRequestJSONArgs(w);this._uriTransformer&&(F=(0,C.transformIncomingURIs)(F,this._uriTransformer)),this._receiveRequest(f,p,h,R,F,D===2);break}case 3:case 4:{let{rpcId:h,method:R,args:F}=t.deserializeRequestMixedArgs(w);this._uriTransformer&&(F=(0,C.transformIncomingURIs)(F,this._uriTransformer)),this._receiveRequest(f,p,h,R,F,D===4);break}case 5:{this._logger&&this._logger.logIncoming(f,p,0,"ack"),this._onDidReceiveAcknowledge(p);break}case 6:{this._receiveCancel(f,p);break}case 7:{this._receiveReply(f,p,void 0);break}case 9:{let h=t.deserializeReplyOKJSON(w);this._uriTransformer&&(h=(0,C.transformIncomingURIs)(h,this._uriTransformer)),this._receiveReply(f,p,h);break}case 8:{let h=t.deserializeReplyOKVSBuffer(w);this._receiveReply(f,p,h);break}case 10:{let h=t.deserializeReplyErrError(w);this._uriTransformer&&(h=(0,C.transformIncomingURIs)(h,this._uriTransformer)),this._receiveReplyErr(f,p,h);break}case 11:{this._receiveReplyErr(f,p,void 0);break}default:console.error("received unexpected message"),console.error(a)}}}_receiveRequest(a,f,w,D,p,h){this._logger&&this._logger.logIncoming(a,f,1,`receiveRequest ${(0,n.getStringIdentifierForProxy)(w)}.${D}(`,p);const R=String(f);let F,$;if(h){const z=new I.CancellationTokenSource;p.push(z.token),F=this._invokeHandler(w,D,p),$=()=>z.cancel()}else F=this._invokeHandler(w,D,p),$=d;this._cancelInvokedHandlers[R]=$;const se=t.serializeAcknowledged(f);this._logger&&this._logger.logOutgoing(se.byteLength,f,1,"ack"),this._protocol.send(se),F.then(z=>{delete this._cancelInvokedHandlers[R];const x=t.serializeReplyOK(f,z,this._uriReplacer);this._logger&&this._logger.logOutgoing(x.byteLength,f,1,"reply:",z),this._protocol.send(x)},z=>{delete this._cancelInvokedHandlers[R];const x=t.serializeReplyErr(f,z);this._logger&&this._logger.logOutgoing(x.byteLength,f,1,"replyErr:",z),this._protocol.send(x)})}_receiveCancel(a,f){this._logger&&this._logger.logIncoming(a,f,1,"receiveCancel");const w=String(f);this._cancelInvokedHandlers[w]&&this._cancelInvokedHandlers[w]()}_receiveReply(a,f,w){this._logger&&this._logger.logIncoming(a,f,0,"receiveReply:",w);const D=String(f);if(!!this._pendingRPCReplies.hasOwnProperty(D)){const p=this._pendingRPCReplies[D];delete this._pendingRPCReplies[D],p.resolveOk(w)}}_receiveReplyErr(a,f,w){this._logger&&this._logger.logIncoming(a,f,0,"receiveReplyErr:",w);const D=String(f);if(!!this._pendingRPCReplies.hasOwnProperty(D)){const p=this._pendingRPCReplies[D];delete this._pendingRPCReplies[D];let h;w&&(w.$isError?(h=new Error,h.name=w.name,h.message=w.message,h.stack=w.stack):h=w),p.resolveErr(h)}}_invokeHandler(a,f,w){try{return Promise.resolve(this._doInvokeHandler(a,f,w))}catch(D){return Promise.reject(D)}}_doInvokeHandler(a,f,w){const D=this._locals[a];if(!D)throw new Error("Unknown actor "+(0,n.getStringIdentifierForProxy)(a));let p=D[f];if(typeof p!="function")throw new Error("Unknown method "+f+" on actor "+(0,n.getStringIdentifierForProxy)(a));return p.apply(D,w)}_remoteCall(a,f,w){if(this._isDisposed)return Promise.reject(P.canceled());let D=null;if(w.length>0&&I.CancellationToken.isCancellationToken(w[w.length-1])&&(D=w.pop()),D&&D.isCancellationRequested)return Promise.reject(P.canceled());const p=t.serializeRequestArguments(w,this._uriReplacer),h=++this._lastMessageId,R=String(h),F=new y.LazyPromise;D&&D.onCancellationRequested(()=>{const se=t.serializeCancel(h);this._logger&&this._logger.logOutgoing(se.byteLength,h,0,"cancel"),this._protocol.send(t.serializeCancel(h))}),this._pendingRPCReplies[R]=F,this._onWillSendRequest(h);const $=t.serializeRequest(h,a,f,p,!!D);return this._logger&&this._logger.logOutgoing($.byteLength,h,0,`request: ${(0,n.getStringIdentifierForProxy)(a)}.${f}(`,w),this._protocol.send($),F}}e.RPCProtocol=l,k=b,l.UNRESPONSIVE_TIME=3*1e3;class u{constructor(a,f){this._buff=a,this._offset=f}static alloc(a,f,w){let D=new u(T.VSBuffer.alloc(w+1+4),0);return D.writeUInt8(a),D.writeUInt32(f),D}static read(a,f){return new u(a,f)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(a){this._buff.writeUInt8(a,this._offset),this._offset+=1}readUInt8(){const a=this._buff.readUInt8(this._offset);return this._offset+=1,a}writeUInt32(a){this._buff.writeUInt32BE(a,this._offset),this._offset+=4}readUInt32(){const a=this._buff.readUInt32BE(this._offset);return this._offset+=4,a}static sizeShortString(a){return 1+a.byteLength}writeShortString(a){this._buff.writeUInt8(a.byteLength,this._offset),this._offset+=1,this._buff.set(a,this._offset),this._offset+=a.byteLength}readShortString(){const a=this._buff.readUInt8(this._offset);this._offset+=1;const w=this._buff.slice(this._offset,this._offset+a).toString();return this._offset+=a,w}static sizeLongString(a){return 4+a.byteLength}writeLongString(a){this._buff.writeUInt32BE(a.byteLength,this._offset),this._offset+=4,this._buff.set(a,this._offset),this._offset+=a.byteLength}readLongString(){const a=this._buff.readUInt32BE(this._offset);this._offset+=4;const w=this._buff.slice(this._offset,this._offset+a).toString();return this._offset+=a,w}writeBuffer(a){this._buff.writeUInt32BE(a.byteLength,this._offset),this._offset+=4,this._buff.set(a,this._offset),this._offset+=a.byteLength}static sizeVSBuffer(a){return 4+a.byteLength}writeVSBuffer(a){this._buff.writeUInt32BE(a.byteLength,this._offset),this._offset+=4,this._buff.set(a,this._offset),this._offset+=a.byteLength}readVSBuffer(){const a=this._buff.readUInt32BE(this._offset);this._offset+=4;const f=this._buff.slice(this._offset,this._offset+a);return this._offset+=a,f}static sizeMixedArray(a,f){let w=0;w+=1;for(let D=0,p=a.length;D<p;D++){const h=a[D],R=f[D];switch(w+=1,R){case 1:w+=this.sizeLongString(h);break;case 2:w+=this.sizeVSBuffer(h);break;case 3:break}}return w}writeMixedArray(a,f){this._buff.writeUInt8(a.length,this._offset),this._offset+=1;for(let w=0,D=a.length;w<D;w++){const p=a[w];switch(f[w]){case 1:this.writeUInt8(1),this.writeLongString(p);break;case 2:this.writeUInt8(2),this.writeVSBuffer(p);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const a=this._buff.readUInt8(this._offset);this._offset+=1;let f=new Array(a);for(let w=0;w<a;w++)switch(this.readUInt8()){case 1:f[w]=this.readLongString();break;case 2:f[w]=this.readVSBuffer();break;case 3:f[w]=void 0;break}return f}}class t{static _arrayContainsBufferOrUndefined(a){for(let f=0,w=a.length;f<w;f++)if(a[f]instanceof T.VSBuffer||typeof a[f]=="undefined")return!0;return!1}static serializeRequestArguments(a,f){if(this._arrayContainsBufferOrUndefined(a)){let w=[],D=[];for(let p=0,h=a.length;p<h;p++){const R=a[p];R instanceof T.VSBuffer?(w[p]=R,D[p]=2):typeof R=="undefined"?(w[p]=T.VSBuffer.alloc(0),D[p]=3):(w[p]=T.VSBuffer.fromString(m(R,f)),D[p]=1)}return{type:"mixed",args:w,argsType:D}}return{type:"simple",args:m(a,f)}}static serializeRequest(a,f,w,D,p){return D.type==="mixed"?this._requestMixedArgs(a,f,w,D.args,D.argsType,p):this._requestJSONArgs(a,f,w,D.args,p)}static _requestJSONArgs(a,f,w,D,p){const h=T.VSBuffer.fromString(w),R=T.VSBuffer.fromString(D);let F=0;F+=u.sizeUInt8(),F+=u.sizeShortString(h),F+=u.sizeLongString(R);let $=u.alloc(p?2:1,a,F);return $.writeUInt8(f),$.writeShortString(h),$.writeLongString(R),$.buffer}static deserializeRequestJSONArgs(a){const f=a.readUInt8(),w=a.readShortString(),D=a.readLongString();return{rpcId:f,method:w,args:JSON.parse(D)}}static _requestMixedArgs(a,f,w,D,p,h){const R=T.VSBuffer.fromString(w);let F=0;F+=u.sizeUInt8(),F+=u.sizeShortString(R),F+=u.sizeMixedArray(D,p);let $=u.alloc(h?4:3,a,F);return $.writeUInt8(f),$.writeShortString(R),$.writeMixedArray(D,p),$.buffer}static deserializeRequestMixedArgs(a){const f=a.readUInt8(),w=a.readShortString(),D=a.readMixedArray(),p=new Array(D.length);for(let h=0,R=D.length;h<R;h++){const F=D[h];typeof F=="string"?p[h]=JSON.parse(F):p[h]=F}return{rpcId:f,method:w,args:p}}static serializeAcknowledged(a){return u.alloc(5,a,0).buffer}static serializeCancel(a){return u.alloc(6,a,0).buffer}static serializeReplyOK(a,f,w){return typeof f=="undefined"?this._serializeReplyOKEmpty(a):f instanceof T.VSBuffer?this._serializeReplyOKVSBuffer(a,f):this._serializeReplyOKJSON(a,g(f,w))}static _serializeReplyOKEmpty(a){return u.alloc(7,a,0).buffer}static _serializeReplyOKVSBuffer(a,f){let w=0;w+=u.sizeVSBuffer(f);let D=u.alloc(8,a,w);return D.writeVSBuffer(f),D.buffer}static deserializeReplyOKVSBuffer(a){return a.readVSBuffer()}static _serializeReplyOKJSON(a,f){const w=T.VSBuffer.fromString(f);let D=0;D+=u.sizeLongString(w);let p=u.alloc(9,a,D);return p.writeLongString(w),p.buffer}static deserializeReplyOKJSON(a){const f=a.readLongString();return JSON.parse(f)}static serializeReplyErr(a,f){return f?this._serializeReplyErrEror(a,f):this._serializeReplyErrEmpty(a)}static _serializeReplyErrEror(a,f){const w=T.VSBuffer.fromString(g(P.transformErrorForSerialization(f),null));let D=0;D+=u.sizeLongString(w);let p=u.alloc(10,a,D);return p.writeLongString(w),p.buffer}static deserializeReplyErrError(a){const f=a.readLongString();return JSON.parse(f)}static _serializeReplyErrEmpty(a){return u.alloc(11,a,0).buffer}}var r;(function(o){o[o.RequestJSONArgs=1]="RequestJSONArgs",o[o.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",o[o.RequestMixedArgs=3]="RequestMixedArgs",o[o.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",o[o.Acknowledged=5]="Acknowledged",o[o.Cancel=6]="Cancel",o[o.ReplyOKEmpty=7]="ReplyOKEmpty",o[o.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",o[o.ReplyOKJSON=9]="ReplyOKJSON",o[o.ReplyErrError=10]="ReplyErrError",o[o.ReplyErrEmpty=11]="ReplyErrEmpty"})(r||(r={}));var c;(function(o){o[o.String=1]="String",o[o.VSBuffer=2]="VSBuffer",o[o.Undefined=3]="Undefined"})(c||(c={}))}),define(_e[214],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const E=function(A){const S=C=>{self.removeEventListener("message",S);const y=C.data;Object.defineProperties(self,{postMessage:{value(n,T){y.postMessage(n,T)}},onmessage:{get(){return y.onmessage},set(n){y.onmessage=n}}}),y.addEventListener("message",n=>{self.dispatchEvent(new MessageEvent("message",{data:n.data}))}),y.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(A)};self.addEventListener("message",S)}.toString();class I extends EventTarget{constructor(A,S,C){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const y=`((${E})('${S}'))`,n=new Blob([y],{type:"application/javascript"}),T=URL.createObjectURL(n),k=new MessageChannel,g=T,m={type:"_newWorker",id:g,port:k.port2,url:T,options:C};A(m,[k.port2]),this.postMessage=k.port1.postMessage.bind(k.port1),this.terminate=()=>{const i={type:"_terminateWorker",id:g};k.port1.postMessage(i),URL.revokeObjectURL(T),k.port1.close(),k.port2.close()},Object.defineProperties(this,{onmessage:{get(){return k.port1.onmessage},set(i){k.port1.onmessage=i}},onmessageerror:{get(){return k.port1.onmessageerror},set(i){k.port1.onmessageerror=i}}}),k.port1.addEventListener("messageerror",i=>{const s=new MessageEvent("messageerror",{data:i.data});this.dispatchEvent(s)}),k.port1.addEventListener("message",i=>{const s=new MessageEvent("message",{data:i.data});this.dispatchEvent(s)}),k.port1.start()}}e.NestedWorker=I}),define(_e[215],we([0,1,4]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,E.createDecorator)("remoteAgentService")}),define(_e[216],we([0,1,18,12,21,2,4,215]),function(ie,e,E,I,P,A,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,S.createDecorator)("pathService");let y=class{constructor(T,k){this.localUserHome=T,this.remoteAgentService=k,this.resolveOS=(async()=>{const g=await this.remoteAgentService.getEnvironment();return(g==null?void 0:g.os)||P.OS})(),this.resolveUserHome=(async()=>{const g=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(g==null?void 0:g.userHome)||T})()}async userHome(T){return(T==null?void 0:T.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(T=>T===1?I.win32:I.posix)}async fileURI(T){let k="";if(await this.resolveOS===1&&(T=T.replace(/\\/g,"/")),T[0]==="/"&&T[1]==="/"){const m=T.indexOf("/",2);m===-1?(k=T.substring(2),T="/"):(k=T.substring(2,m),T=T.substring(m)||"/")}return A.URI.from({scheme:E.Schemas.file,authority:k,path:T,query:"",fragment:""})}};y=je([Ke(1,C.IRemoteAgentService)],y),e.AbstractPathService=y}),define(_e[41],we([0,1,11,28,24,37,8,4,12,10]),function(ie,e,E,I,P,A,S,C,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const T="\u27EA ",k=" characters skipped \u27EB",g=(T.length+k.length+5)*2;e.ISearchService=(0,C.createDecorator)("searchService");var m;(function(M){M[M.file=0]="file",M[M.text=1]="text"})(m=e.SearchProviderType||(e.SearchProviderType={}));var i;(function(M){M[M.File=1]="File",M[M.Text=2]="Text"})(i=e.QueryType||(e.QueryType={}));function s(M){return!!M.preview}e.resultIsMatch=s;function _(M){return!!M.resource}e.isFileMatch=_;function d(M){return!!M.message}e.isProgressMessage=d;var b;(function(M){M[M.Normal=0]="Normal",M[M.NewSearchStarted=1]="NewSearchStarted"})(b=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class v{constructor(N){this.resource=N,this.results=[]}}e.FileMatch=v;class l{constructor(N,B,Q){this.ranges=B;const W=Array.isArray(B)?B:[B];if(Q&&Q.matchLines===1&&u(W)){N=(0,S.getNLines)(N,Q.matchLines);let ee="",re=0,oe=0;const Se=Math.floor(Q.charsPerLine/5),Pe=[];for(const $e of W){const Fe=Math.max($e.startColumn-Se,0),ze=$e.startColumn+Q.charsPerLine;if(Fe>oe+Se+g){const U=T+(Fe-oe)+k;ee+=U+N.slice(Fe,ze),re+=Fe-(oe+U.length)}else ee+=N.slice(oe,ze);Pe.push(new r(0,$e.startColumn-re,$e.endColumn-re)),oe=ze}this.preview={text:ee,matches:Array.isArray(this.ranges)?Pe:Pe[0]}}else{const ee=Array.isArray(B)?B[0].startLineNumber:B.startLineNumber;this.preview={text:N,matches:(0,E.mapArrayOrNot)(B,re=>new t(re.startLineNumber-ee,re.startColumn,re.endLineNumber-ee,re.endColumn))}}}}e.TextSearchMatch=l;function u(M){const N=M[0].startLineNumber;for(const B of M)if(B.startLineNumber!==N||B.endLineNumber!==N)return!1;return!0}class t{constructor(N,B,Q,W){this.startLineNumber=N,this.startColumn=B,this.endLineNumber=Q,this.endColumn=W}}e.SearchRange=t;class r extends t{constructor(N,B,Q){super(N,B,N,Q)}}e.OneLineRange=r;var c;(function(M){M.Default="default",M.FileNames="fileNames",M.Type="type",M.Modified="modified",M.CountDescending="countDescending",M.CountAscending="countAscending"})(c=e.SearchSortOrder||(e.SearchSortOrder={}));function o(M,N=!0){const B=M&&M.files&&M.files.exclude,Q=N&&M&&M.search&&M.search.exclude;if(!(!B&&!Q)){if(!B||!Q)return B||Q;let W=Object.create(null);return W=P.mixin(W,P.deepClone(B)),W=P.mixin(W,P.deepClone(Q),!0),W}}e.getExcludes=o;function a(M,N){return M.excludePattern&&I.match(M.excludePattern,N)?!1:M.includePattern||M.usingSearchPaths?M.includePattern&&I.match(M.includePattern,N)?!0:M.usingSearchPaths?!!M.folderQueries&&M.folderQueries.some(B=>{const Q=B.folder.fsPath;if(A.isEqualOrParent(N,Q)){const W=y.relative(Q,N);return!B.includePattern||!!I.match(B.includePattern,W)}else return!1}):!1:!0}e.pathIncludedInQuery=a;var f;(function(M){M[M.unknownEncoding=1]="unknownEncoding",M[M.regexParseError=2]="regexParseError",M[M.globParseError=3]="globParseError",M[M.invalidLiteral=4]="invalidLiteral",M[M.rgProcessError=5]="rgProcessError",M[M.other=6]="other",M[M.canceled=7]="canceled"})(f=e.SearchErrorCode||(e.SearchErrorCode={}));class w extends Error{constructor(N,B){super(N);this.code=B}}e.SearchError=w;function D(M){const N=M.message;if((0,n.isPromiseCanceledError)(M))return new w(N,f.canceled);try{const B=JSON.parse(N);return new w(B.message,B.code)}catch(B){return new w(N,f.other)}}e.deserializeSearchError=D;function p(M){const N={message:M.message,code:M.code};return new Error(JSON.stringify(N))}e.serializeSearchError=p;function h(M){return M.type==="error"?!0:M.type==="success"}e.isSerializedSearchComplete=h;function R(M){return M.type==="success"}e.isSerializedSearchSuccess=R;function F(M){return!!M.path}e.isSerializedFileMatch=F;function $(M,N){const B=M.searchPath?M.searchPath:M.relativePath;return(0,S.fuzzyContains)(B,N)}e.isFilePatternMatch=$;class se{constructor(N){this.path=N,this.results=[]}addMatch(N){this.results.push(N)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=se;function z(M,N){const B=Object.assign(Object.assign({},M||{}),N||{});return Object.keys(B).filter(Q=>{const W=B[Q];return typeof W=="boolean"&&W})}e.resolvePatternsForProvider=z;class x{constructor(N,B){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},N.excludePattern||{}),B.excludePattern||{}),this._parsedExcludeExpression=I.parse(this._excludeExpression);let Q=N.includePattern;B.includePattern&&(Q?Q=Object.assign(Object.assign({},Q),B.includePattern):Q=B.includePattern),Q&&(this._parsedIncludeExpression=I.parse(Q))}includedInQuerySync(N,B,Q){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(N,B,Q)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(N,B,Q))}includedInQuery(N,B,Q){return Promise.resolve(this._parsedExcludeExpression(N,B,Q)).then(ee=>!!ee).then(ee=>ee?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(N,B,Q)).then(re=>!!re):Promise.resolve(!0)).then(ee=>ee)}hasSiblingExcludeClauses(){return G(this._excludeExpression)}}e.QueryGlobTester=x;function G(M){for(const N in M)if(typeof M[N]!="boolean")return!0;return!1}}),define(_e[31],we([0,1,11,14,20,3,22,18,78,25,8,13,2,136,4,19,151,47,48,27,15,7,41,5]),function(ie,e,E,I,P,A,S,C,y,n,T,k,g,m,i,s,_,d,b,v,l,u,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function c(R,F,$){return new n.ExtUri(se=>w(se,$)).isEqual(R,F)}function o(R,F,$){return c(R.uri,F.uri,$)?0:(0,T.compare)(R.uri.toString(),F.uri.toString())}function a(R,F,$){return R.index!==F.index?R.index<F.index?-1:1:c(R.uri,F.uri,$)?(0,T.compare)(R.name,F.name):(0,T.compare)(R.uri.toString(),F.uri.toString())}function f(R,F,$,se){const z=R.slice(0).sort((G,M)=>$(G,M,se)),x=F.slice(0).sort((G,M)=>$(G,M,se));return(0,E.delta)(z,x,(G,M)=>$(G,M,se))}function w(R,F){const $=F.getCapabilities(R.scheme);return!($&&$&1024)}class D extends d.Workspace{constructor(F,$,se,z,x,G){super(F,se.map(M=>new d.WorkspaceFolder(M)),z,G);this._name=$,this._isUntitled=x,this._workspaceFolders=[],this._structure=S.TernarySearchTree.forUris(G),se.forEach(M=>{this._workspaceFolders.push(M),this._structure.set(M.uri,M)})}static toExtHostWorkspace(F,$,se,z){if(!F)return{workspace:null,added:[],removed:[]};const{id:x,name:G,folders:M,configuration:N,isUntitled:B}=F,Q=[],W=$;$?M.forEach((Se,Pe)=>{const $e=g.URI.revive(Se.uri),Fe=D._findFolder(se||$,$e,z);Fe?(Fe.name=Se.name,Fe.index=Se.index,Q.push(Fe)):Q.push({uri:$e,name:Se.name,index:Pe})}):Q.push(...M.map(({uri:Se,name:Pe,index:$e})=>({uri:g.URI.revive(Se),name:Pe,index:$e}))),Q.sort((Se,Pe)=>Se.index<Pe.index?-1:1);const ee=new D(x,G,Q,N?g.URI.revive(N):null,!!B,Se=>w(Se,z)),{added:re,removed:oe}=f(W?W.workspaceFolders:[],ee.workspaceFolders,o,z);return{workspace:ee,added:re,removed:oe}}static _findFolder(F,$,se){for(let z=0;z<F.folders.length;z++){const x=F.workspaceFolders[z];if(c(x.uri,$,se))return x}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(F,$){return $&&this._structure.get(F)&&(F=(0,n.dirname)(F)),this._structure.findSubstr(F)}resolveWorkspaceFolder(F){return this._structure.get(F)}}let p=class{constructor(F,$,se,z){this._onDidChangeWorkspace=new A.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidReceieveWorkspaceTrust=new A.Emitter,this.onDidReceiveWorkspaceTrust=this._onDidReceieveWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=z,this._extHostFileSystemInfo=se,this._requestIdProvider=new y.Counter,this._barrier=new I.Barrier,this._proxy=F.getProxy(r.MainContext.MainThreadWorkspace),this._messageService=F.getProxy(r.MainContext.MainThreadMessageService);const x=$.workspace;this._confirmedWorkspace=x?new D(x.id,x.name,[],x.configuration?g.URI.revive(x.configuration):null,!!x.isUntitled,G=>w(G,se)):void 0}$initializeWorkspace(F,$){this._trusted=$,this.$acceptWorkspaceData(F),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?g.URI.from({scheme:C.Schemas.untitled,path:(0,n.basename)((0,n.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(F,$,se,...z){const x=[];if(Array.isArray(z)&&z.forEach(Q=>{g.URI.isUri(Q.uri)&&!x.some(W=>c(W.uri,Q.uri,this._extHostFileSystemInfo))&&x.push({uri:Q.uri,name:Q.name||(0,n.basenameOrAuthority)(Q.uri)})}),this._unconfirmedWorkspace||[$,se].some(Q=>typeof Q!="number"||Q<0)||se===0&&x.length===0)return!1;const G=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if($+se>G.length)return!1;const M=G.slice(0);M.splice($,se,...x.map(Q=>({uri:Q.uri,name:Q.name||(0,n.basenameOrAuthority)(Q.uri),index:void 0})));for(let Q=0;Q<M.length;Q++){const W=M[Q];if(M.some((ee,re)=>re!==Q&&c(W.uri,ee.uri,this._extHostFileSystemInfo)))return!1}M.forEach((Q,W)=>Q.index=W);const{added:N,removed:B}=f(G,M,a,this._extHostFileSystemInfo);if(N.length===0&&B.length===0)return!1;if(this._proxy){const Q=F.displayName||F.name;this._proxy.$updateWorkspaceFolders(Q,$,se,x).then(void 0,W=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(_.Severity.Error,(0,m.localize)(0,null,Q,W.toString()),{extension:F},[])})}return this.trySetWorkspaceFolders(M),!0}getWorkspaceFolder(F,$){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(F,$)}async getWorkspaceFolder2(F,$){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(F,$)}async resolveWorkspaceFolder(F){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(F)}getPath(){if(!!this._actualWorkspace){const{folders:F}=this._actualWorkspace;if(F.length!==0)return F[0].uri.fsPath}}getRelativePath(F,$){let se,z="";if(typeof F=="string"?(se=g.URI.file(F),z=F):typeof F!="undefined"&&(se=F,z=F.fsPath),!se)return z;const x=this.getWorkspaceFolder(se,!0);if(!x)return z;typeof $=="undefined"&&this._actualWorkspace&&($=this._actualWorkspace.folders.length>1);let G=(0,n.relativePath)(x.uri,se);return $&&x.name&&(G=`${x.name}/${G}`),G}trySetWorkspaceFolders(F){this._actualWorkspace&&(this._unconfirmedWorkspace=D.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:F,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(F){const{workspace:$,added:se,removed:z}=D.toExtHostWorkspace(F,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=$||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:se,removed:z}))}findFiles(F,$,se,z,x=P.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${z.value}, entryPoint: findFiles`);let G;if($===null?G=!1:$&&(typeof $=="string"?G=$:G=$.pattern),x&&x.isCancellationRequested)return Promise.resolve([]);const{includePattern:M,folder:N}=h(F);return this._proxy.$startFileSearch((0,k.withUndefinedAsNull)(M),(0,k.withUndefinedAsNull)(N),(0,k.withUndefinedAsNull)(G),(0,k.withUndefinedAsNull)(se),x).then(B=>Array.isArray(B)?B.map(Q=>g.URI.revive(Q)):[])}async findTextInFiles(F,$,se,z,x=P.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${z.value}, entryPoint: findTextInFiles`);const G=this._requestIdProvider.getNext(),M=typeof $.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:$.previewOptions,{includePattern:N,folder:B}=h($.include),Q=typeof $.exclude=="string"?$.exclude:$.exclude?$.exclude.pattern:void 0,W={ignoreSymlinks:typeof $.followSymlinks=="boolean"?!$.followSymlinks:void 0,disregardIgnoreFiles:typeof $.useIgnoreFiles=="boolean"?!$.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof $.useGlobalIgnoreFiles=="boolean"?!$.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof $.useDefaultExcludes=="boolean"?!$.useDefaultExcludes:!0,fileEncoding:$.encoding,maxResults:$.maxResults,previewOptions:M,afterContext:$.afterContext,beforeContext:$.beforeContext,includePattern:N,excludePattern:Q},ee=!1;if(this._activeSearchCallbacks[G]=re=>{if(!ee){const oe=g.URI.revive(re.resource);re.results.forEach(Se=>{(0,t.resultIsMatch)(Se)?se({uri:oe,preview:{text:Se.preview.text,matches:(0,E.mapArrayOrNot)(Se.preview.matches,Pe=>new u.Range(Pe.startLineNumber,Pe.startColumn,Pe.endLineNumber,Pe.endColumn))},ranges:(0,E.mapArrayOrNot)(Se.ranges,Pe=>new u.Range(Pe.startLineNumber,Pe.startColumn,Pe.endLineNumber,Pe.endColumn))}):se({uri:oe,text:Se.text,lineNumber:Se.lineNumber})})}},x.isCancellationRequested)return{};try{const re=await this._proxy.$startTextSearch(F,(0,k.withUndefinedAsNull)(B),W,G,x);return delete this._activeSearchCallbacks[G],re||{}}catch(re){throw delete this._activeSearchCallbacks[G],re}}$handleTextSearchResult(F,$){this._activeSearchCallbacks[$]&&this._activeSearchCallbacks[$](F)}saveAll(F){return this._proxy.$saveAll(F)}resolveProxy(F){return this._proxy.$resolveProxy(F)}get trusted(){return this._trusted}requestWorkspaceTrust(F){return this._proxy.$requestWorkspaceTrust(F)}$onDidReceiveWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidReceieveWorkspaceTrust.fire())}};p=je([Ke(0,l.IExtHostRpcService),Ke(1,v.IExtHostInitDataService),Ke(2,b.IExtHostFileSystemInfo),Ke(3,s.ILogService)],p),e.ExtHostWorkspace=p,e.IExtHostWorkspace=(0,i.createDecorator)("IExtHostWorkspace");function h(R){let F,$;return R&&(typeof R=="string"?F=R:(F=R.pattern,$=R.baseFolder||g.URI.file(R.base))),{includePattern:F,folder:$}}}),define(_e[34],we([0,1,24,3,31,5,7,153,66,13,14,4,15,19,2]),function(ie,e,E,I,P,A,S,C,y,n,T,k,g,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function s(r,c){if(c){const o=c.split(".");let a=r;for(let f=0;a&&f<o.length;f++)a=a[o[f]];return a}}function _(r){return r instanceof i.URI}function d(r){return r&&r.uri instanceof i.URI&&r.languageId&&typeof r.languageId=="string"}function b(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function v(r){return r&&r.uri instanceof i.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function l(r){if(_(r))return{resource:r};if(d(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(b(r))return{overrideIdentifier:r.languageId};if(v(r))return{resource:r.uri};if(r===null)return{resource:null}}let u=class{constructor(c,o,a){this._proxy=c.getProxy(A.MainContext.MainThreadConfiguration),this._extHostWorkspace=o,this._logService=a,this._barrier=new T.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(c=>this._actual)}$initializeConfiguration(c){this._actual=new t(this._proxy,this._extHostWorkspace,c,this._logService),this._barrier.open()}$acceptConfigurationChanged(c,o){this.getConfigProvider().then(a=>a.$acceptConfigurationChanged(c,o))}};u=je([Ke(0,g.IExtHostRpcService),Ke(1,P.IExtHostWorkspace),Ke(2,m.ILogService)],u),e.ExtHostConfiguration=u;class t{constructor(c,o,a,f){this._onDidChangeConfiguration=new I.Emitter,this._proxy=c,this._logService=f,this._extHostWorkspace=o,this._configuration=C.Configuration.parse(a),this._configurationScopes=this._toMap(a.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(c,o){const a={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=C.Configuration.parse(c),this._configurationScopes=this._toMap(c.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(o,a))}getConfiguration(c,o,a){const f=l(o)||{},w=this._toReadonlyValue(c?s(this._configuration.getValue(void 0,f,this._extHostWorkspace.workspace),c):this._configuration.getValue(void 0,f,this._extHostWorkspace.workspace));c&&this._validateConfigurationAccess(c,f,a==null?void 0:a.identifier);function D(h){if(h==null)return null;if(typeof h=="boolean")return h?1:4;switch(h){case S.ConfigurationTarget.Global:return 1;case S.ConfigurationTarget.Workspace:return 4;case S.ConfigurationTarget.WorkspaceFolder:return 5}}const p={has(h){return typeof s(w,h)!="undefined"},get:(h,R)=>{this._validateConfigurationAccess(c?`${c}.${h}`:h,f,a==null?void 0:a.identifier);let F=s(w,h);if(typeof F=="undefined")F=R;else{let $;const se=(z,x)=>{let G;const M=()=>{$=$||(0,E.deepClone)(w),G=G||s($,x)};return(0,n.isObject)(z)?new Proxy(z,{get:(N,B)=>{if(typeof B=="string"&&B.toLowerCase()==="tojson")return M(),()=>G;if($)return G=G||s($,x),G[B];const Q=N[B];return typeof B=="string"?se(Q,`${x}.${B}`):Q},set:(N,B,Q)=>(M(),G&&(G[B]=Q),!0),deleteProperty:(N,B)=>(M(),G&&delete G[B],!0),defineProperty:(N,B,Q)=>(M(),G&&Object.defineProperty(G,B,Q),!0)}):z};F=se(F,h)}return F},update:(h,R,F,$)=>{h=c?`${c}.${h}`:h;const se=D(F);return R!==void 0?this._proxy.$updateConfigurationOption(se,h,R,f,$):this._proxy.$removeConfigurationOption(se,h,f,$)},inspect:h=>{var R,F,$,se,z,x,G,M;h=c?`${c}.${h}`:h;const N=(0,E.deepClone)(this._configuration.inspect(h,f,this._extHostWorkspace.workspace));if(N)return{key:h,defaultValue:(R=N.default)===null||R===void 0?void 0:R.value,globalValue:(F=N.user)===null||F===void 0?void 0:F.value,workspaceValue:($=N.workspace)===null||$===void 0?void 0:$.value,workspaceFolderValue:(se=N.workspaceFolder)===null||se===void 0?void 0:se.value,defaultLanguageValue:(z=N.default)===null||z===void 0?void 0:z.override,globalLanguageValue:(x=N.user)===null||x===void 0?void 0:x.override,workspaceLanguageValue:(G=N.workspace)===null||G===void 0?void 0:G.override,workspaceFolderLanguageValue:(M=N.workspaceFolder)===null||M===void 0?void 0:M.override,languageIds:N.overrideIdentifiers}}};return typeof w=="object"&&(0,E.mixin)(p,w,!1),Object.freeze(p)}_toReadonlyValue(c){const o=a=>(0,n.isObject)(a)?new Proxy(a,{get:(f,w)=>o(f[w]),set:(f,w,D)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(w)}' of object`)},deleteProperty:(f,w)=>{throw new Error(`TypeError: Cannot delete read only property '${String(w)}' of object`)},defineProperty:(f,w)=>{throw new Error(`TypeError: Cannot define property '${String(w)}' for a readonly object`)},setPrototypeOf:f=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):a;return o(c)}_validateConfigurationAccess(c,o,a){const f=y.OVERRIDE_PROPERTY_PATTERN.test(c)?4:this._configurationScopes.get(c),w=a?`[${a.value}] `:"";if(f===4){typeof(o==null?void 0:o.resource)=="undefined"&&this._logService.warn(`${w}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${c}', provide the URI of a resource or 'null' for any resource.`);return}if(f===3){(o==null?void 0:o.resource)&&this._logService.warn(`${w}Accessing a window scoped configuration for a resource is not expected. To associate '${c}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(c,o){const a=new C.ConfigurationChangeEvent(c,o,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(f,w)=>a.affectsConfiguration(f,l(w))})}_toMap(c){return c.reduce((o,a)=>(o.set(a[0],a[1]),o),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,k.createDecorator)("IExtHostConfiguration")});var tt=this&&this.__classPrivateFieldSet||function(ie,e,E,I,P){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!P:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?P.call(ie,E):P?P.value=E:e.set(ie,E),E},xe=this&&this.__classPrivateFieldGet||function(ie,e,E,I){if(E==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!I:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?I:E==="a"?I.call(ie):I?I.value:e.get(ie)};define(_e[101],we([0,1,2,14,3,5,7,31,39,34,20,40,15,27,4,18,21,19,72,170,10]),function(ie,e,E,I,P,A,S,C,y,n,T,k,g,m,i,s,_,d,b,v,l){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(z){function x(M){if(M!=null)return M}z.from=x;function G(M){if(M!=null)return M}z.to=G})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var r;(function(z){function x(M){if(M!=null)return M}z.from=x;function G(M){if(M!=null)return M}z.to=G})(r=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var c;(function(z){function x(M){if(M!=null)return M}z.from=x;function G(M){if(M!=null)return M}z.to=G})(c=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var o;(function(z){function x(N){if(N){const B=N;return B&&!!B.process}else return!1}z.is=x;function G(N){if(N!=null){const B={process:N.process,args:N.args};return N.options&&(B.options=c.from(N.options)),B}}z.from=G;function M(N){if(N!=null)return new S.ProcessExecution(N.process,N.args,N.options)}z.to=M})(o=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var a;(function(z){function x(M){if(M!=null)return M}z.from=x;function G(M){if(M!=null)return M}z.to=G})(a=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var f;(function(z){function x(N){if(N){const B=N;return B&&(!!B.commandLine||!!B.command)}else return!1}z.is=x;function G(N){if(N!=null){const B={};return N.commandLine!==void 0?B.commandLine=N.commandLine:(B.command=N.command,B.args=N.args),N.options&&(B.options=a.from(N.options)),B}}z.from=G;function M(N){if(!(N==null||N.command===void 0&&N.commandLine===void 0))return N.commandLine?new S.ShellExecution(N.commandLine,N.options):new S.ShellExecution(N.command,N.args?N.args:[],N.options)}z.to=M})(f=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var w;(function(z){function x(N){if(N){let B=N;return B&&B.customExecution==="customExecution"}else return!1}z.is=x;function G(N){return{customExecution:"customExecution"}}z.from=G;function M(N,B){return B.get(N)}z.to=M})(w=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var D;(function(z){function x(G,M){let N;return G.scope!==void 0&&typeof G.scope!="number"?N=G.scope.uri:G.scope!==void 0&&typeof G.scope=="number"&&(G.scope===S.TaskScope.Workspace&&M&&M.workspaceFile?N=M.workspaceFile:N=v.USER_TASKS_GROUP_KEY),{id:G._id,workspaceFolder:N}}z.from=x})(D=e.TaskHandleDTO||(e.TaskHandleDTO={}));var p;(function(z){function x(N,B){if(N==null)return[];const Q=[];for(let W of N){const ee=G(W,B);ee&&Q.push(ee)}return Q}z.fromMany=x;function G(N,B){if(N!=null){let Q;N.execution instanceof S.ProcessExecution?Q=o.from(N.execution):N.execution instanceof S.ShellExecution?Q=f.from(N.execution):N.execution&&N.execution instanceof S.CustomExecution&&(Q=w.from(N.execution));const W=t.from(N.definition);let ee;if(N.scope?typeof N.scope=="number"?ee=N.scope:ee=N.scope.uri:ee=S.TaskScope.Workspace,!(!W||!ee)){const re=N.group?N.group.id:void 0;return{_id:N._id,definition:W,name:N.name,source:{extensionId:B.identifier.value,label:N.source,scope:ee},execution:Q,isBackground:N.isBackground,group:re,presentationOptions:r.from(N.presentationOptions),problemMatchers:N.problemMatchers,hasDefinedMatchers:N.hasDefinedMatchers,runOptions:N.runOptions?N.runOptions:{reevaluateOnRerun:!0},detail:N.detail}}}}z.from=G;async function M(N,B,Q){if(N!=null){let W;o.is(N.execution)?W=o.to(N.execution):f.is(N.execution)?W=f.to(N.execution):w.is(N.execution)&&(W=w.to(N._id,Q));const ee=t.to(N.definition);let re;if(N.source&&(N.source.scope!==void 0?typeof N.source.scope=="number"?re=N.source.scope:re=await B.resolveWorkspaceFolder(E.URI.revive(N.source.scope)):re=S.TaskScope.Workspace),!(!ee||!re)){const oe=new S.Task(ee,re,N.name,N.source.label,W,N.problemMatchers);return N.isBackground!==void 0&&(oe.isBackground=N.isBackground),N.group!==void 0&&(oe.group=S.TaskGroup.from(N.group)),N.presentationOptions&&(oe.presentationOptions=r.to(N.presentationOptions)),N._id&&(oe._id=N._id),N.detail&&(oe.detail=N.detail),oe}}}z.to=M})(p=e.TaskDTO||(e.TaskDTO={}));var h;(function(z){function x(M){return M}z.from=x;function G(M){if(!!M)return Object.assign(Object.create(null),M)}z.to=G})(h=e.TaskFilterDTO||(e.TaskFilterDTO={}));class R{constructor(x,G,M){this._id=G,this._task=M,u.set(this,void 0),tt(this,u,x,"f")}get task(){return this._task}terminate(){xe(this,u,"f").terminateTask(this)}fireDidStartProcess(x){}fireDidEndProcess(x){}}u=new WeakMap;var F;(function(z){function x(G){return{id:G._id,task:void 0}}z.from=x})(F=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let $=class{constructor(x,G,M,N,B,Q,W,ee){this._onDidExecuteTask=new P.Emitter,this._onDidTerminateTask=new P.Emitter,this._onDidTaskProcessStarted=new P.Emitter,this._onDidTaskProcessEnded=new P.Emitter,this._proxy=x.getProxy(A.MainContext.MainThreadTask),this._workspaceProvider=M,this._editorService=N,this._configurationService=B,this._terminalService=Q,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=W,this._deprecationService=ee,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(x,G,M){if(!M)return new S.Disposable(()=>{});const N=this.nextHandle();return this._handlers.set(N,{type:G,provider:M,extension:x}),this._proxy.$registerTaskProvider(N,G),new S.Disposable(()=>{this._handlers.delete(N),this._proxy.$unregisterTaskProvider(N)})}registerTaskSystem(x,G){this._proxy.$registerTaskSystem(x,G)}fetchTasks(x){return this._proxy.$fetchTasks(h.from(x)).then(async G=>{const M=[];for(let N of G){const B=await p.to(N,this._workspaceProvider,this._providedCustomExecutions2);B&&M.push(B)}return M})}get taskExecutions(){const x=[];return this._taskExecutions.forEach(G=>x.push(G)),x}terminateTask(x){if(!(x instanceof R))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(x._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(x,G,M){const N=this._providedCustomExecutions2.get(x.id);if(N){if(this._activeCustomExecutions2.get(x.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(x.id,N),this._terminalService.attachPtyToTerminal(G,await N.callback(M))}this._lastStartedTask=x.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(x)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(x){const G=await this.getTaskExecution(x);this._taskExecutionPromises.delete(x.id),this._taskExecutions.delete(x.id),this.customExecutionComplete(x),this._onDidTerminateTask.fire({execution:G})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(x){const G=await this.getTaskExecution(x.id);this._onDidTaskProcessStarted.fire({execution:G,processId:x.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(x){const G=await this.getTaskExecution(x.id);this._onDidTaskProcessEnded.fire({execution:G,exitCode:x.exitCode})}$provideTasks(x,G){const M=this._handlers.get(x);if(!M)return Promise.reject(new Error("no handler found"));const N=[],B=(0,I.asPromise)(()=>M.provider.provideTasks(T.CancellationToken.None)).then(Q=>this.provideTasksInternal(G,N,M,Q));return new Promise(Q=>{B.then(W=>{Promise.all(N).then(()=>{Q(W)})})})}async $resolveTask(x,G){const M=this._handlers.get(x);if(!M)return Promise.reject(new Error("no handler found"));if(G.definition.type!==M.type)throw new Error(`Unexpected: Task of type [${G.definition.type}] cannot be resolved by provider of type [${M.type}].`);const N=await p.to(G,this._workspaceProvider,this._providedCustomExecutions2);if(!N)throw new Error("Unexpected: Task cannot be resolved.");const B=await M.provider.resolveTask(N,T.CancellationToken.None);if(!!B){this.checkDeprecation(B,M);const Q=p.from(B,M.extension);if(!Q)throw new Error("Unexpected: Task cannot be resolved.");if(B.definition!==N.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return w.is(Q.execution)&&await this.addCustomExecution(Q,B,!0),await this.resolveTaskInternal(Q)}}nextHandle(){return this._handleCounter++}async addCustomExecution(x,G,M){const N=await this._proxy.$createTaskId(x);!M&&!this._providedCustomExecutions2.has(N)&&this._notProvidedCustomExecutions.add(N),this._providedCustomExecutions2.set(N,G.execution)}async getTaskExecution(x,G){if(typeof x=="string"){const B=this._taskExecutionPromises.get(x);if(!B)throw new Error("Unexpected: The specified task is missing an execution");return B}let M=this._taskExecutionPromises.get(x.id);if(M)return M;const N=new Promise(async(B,Q)=>{const W=G||await p.to(x.task,this._workspaceProvider,this._providedCustomExecutions2);W?B(new R(this,x.id,W)):Q("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(x.id,N),N.then(B=>(this._taskExecutions.set(x.id,B),B),B=>Promise.reject(B))}checkDeprecation(x,G){x._deprecated&&this._deprecationService.report("Task.constructor",G.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(x){this._activeCustomExecutions2.get(x.id)&&this._activeCustomExecutions2.delete(x.id),this._notProvidedCustomExecutions.has(x.id)&&this._lastStartedTask!==x.id&&(this._providedCustomExecutions2.delete(x.id),this._notProvidedCustomExecutions.delete(x.id));let M=this._notProvidedCustomExecutions.values(),N=M.next();for(;!N.done;)!this._activeCustomExecutions2.has(N.value)&&this._lastStartedTask!==N.value&&(this._providedCustomExecutions2.delete(N.value),this._notProvidedCustomExecutions.delete(N.value)),N=M.next()}};$=je([Ke(0,g.IExtHostRpcService),Ke(1,m.IExtHostInitDataService),Ke(2,C.IExtHostWorkspace),Ke(3,y.IExtHostDocumentsAndEditors),Ke(4,n.IExtHostConfiguration),Ke(5,k.IExtHostTerminalService),Ke(6,d.ILogService),Ke(7,b.IExtHostApiDeprecationService)],$),e.ExtHostTaskBase=$;let se=class extends ${constructor(x,G,M,N,B,Q,W,ee){super(x,G,M,N,B,Q,W,ee);this.registerTaskSystem(s.Schemas.vscodeRemote,{scheme:s.Schemas.vscodeRemote,authority:"",platform:_.PlatformToString(0)})}async executeTask(x,G){if(!G.execution)throw new Error("Tasks to execute must include an execution");const M=p.from(G,x);if(M===void 0)throw new Error("Task is not valid");if(w.is(M.execution))await this.addCustomExecution(M,G,!1);else throw new l.NotSupportedError;const N=await this.getTaskExecution(await this._proxy.$getTaskExecution(M),G);return this._proxy.$executeTask(M).catch(B=>{throw new Error(B)}),N}provideTasksInternal(x,G,M,N){const B=[];if(N)for(let Q of N){this.checkDeprecation(Q,M),(!Q.definition||!x[Q.definition.type])&&this._logService.warn(`The task [${Q.source}, ${Q.name}] uses an undefined task type. The task will be ignored in the future.`);const W=p.from(Q,M.extension);W&&w.is(W.execution)?(B.push(W),G.push(this.addCustomExecution(W,Q,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:B,extension:M.extension}}async resolveTaskInternal(x){if(w.is(x.execution))return x;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(x,G){return{process:void 0,variables:Object.create(null)}}$getDefaultShellAndArgs(){throw new Error("Not implemented")}async $jsonTasksSupported(){return!1}async $findExecutable(x,G,M){}};se=je([Ke(0,g.IExtHostRpcService),Ke(1,m.IExtHostInitDataService),Ke(2,C.IExtHostWorkspace),Ke(3,y.IExtHostDocumentsAndEditors),Ke(4,n.IExtHostConfiguration),Ke(5,k.IExtHostTerminalService),Ke(6,d.ILogService),Ke(7,b.IExtHostApiDeprecationService)],se),e.WorkerExtHostTask=se,e.IExtHostTask=(0,i.createDecorator)("IExtHostTask")});var un=this&&this.__rest||function(ie,e){var E={};for(var I in ie)Object.prototype.hasOwnProperty.call(ie,I)&&e.indexOf(I)<0&&(E[I]=ie[I]);if(ie!=null&&typeof Object.getOwnPropertySymbols=="function")for(var P=0,I=Object.getOwnPropertySymbols(ie);P<I.length;P++)e.indexOf(I[P])<0&&Object.prototype.propertyIsEnumerable.call(ie,I[P])&&(E[I[P]]=ie[I[P]]);return E};define(_e[217],we([0,1,11,14,23,20,3,52,6,24,13,2,29,5,39,15,9,7,31,181,95]),function(ie,e,E,I,P,A,S,C,y,n,T,k,g,m,i,s,_,d,b,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.createDefaultDocumentTestRoot=e.ExtHostTesting=void 0;const u=(p,h)=>`${p}:${h.toString()}`;let t=class{constructor(h,R,F){this.documents=R,this.workspace=F,this.resultsChangedEmitter=new S.Emitter,this.providers=new Map,this.ownedTests=new v.OwnedTestCollection,this.testSubscriptions=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=h.getProxy(m.MainContext.MainThreadTesting),this.workspaceObservers=new w(this.proxy),this.textDocumentObservers=new D(this.proxy,R)}registerTestProvider(h){const R=(0,g.generateUuid)();this.providers.set(R,h),this.proxy.$registerTestProvider(R);const F=[...this.testSubscriptions.keys()];return setTimeout(()=>{var $;for(const se of F)($=this.testSubscriptions.get(se))===null||$===void 0||$.subscribeFn(R,h)},0),new d.Disposable(()=>{this.providers.delete(R),this.proxy.$unregisterTestProvider(R)})}createTextDocumentTestObserver(h){return this.textDocumentObservers.checkout(h.uri)}createWorkspaceTestObserver(h){return this.workspaceObservers.checkout(h.uri)}async runTests(h,R=A.CancellationToken.None){const F=$=>$.map(this.getInternalTestForReference,this).filter(T.isDefined).map(se=>({src:se.src,testId:se.item.extId}));await this.proxy.$runTests({exclude:h.exclude?F(h.exclude).map($=>$.testId):void 0,tests:F(h.tests),debug:h.debug},R)}publishExtensionProvidedResults(h,R){this.proxy.$publishExtensionProvidedResults(_.TestResults.from((0,g.generateUuid)(),h),R)}$publishTestResults(h){this.results=Object.freeze(h.map(R=>(0,n.deepFreeze)(_.TestResults.to(R))).concat(this.results).sort((R,F)=>F.completedAt-R.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(h,R){const F=k.URI.revive(R),$=u(h,F);if(!this.testSubscriptions.has($)){const se=new A.CancellationTokenSource;let z;if(h===1){let N=this.documents.getDocument(F);if(!N){const B=new y.DisposableStore;N=await new Promise(Q=>{B.add((0,I.disposableTimeout)(()=>Q(void 0),5e3)),B.add(this.documents.onDidAddDocuments(W=>{const ee=W.find(re=>re.document.uri.toString()===F.toString());ee&&Q(ee)}))}).finally(()=>B.dispose())}if(N){const B=await this.workspace.getWorkspaceFolder2(F,!1);z=Q=>Q.provideDocumentTestRoot?Q.provideDocumentTestRoot(N.document,se.token):(0,e.createDefaultDocumentTestRoot)(Q,N.document,B,se.token)}}else{const N=await this.workspace.getWorkspaceFolder2(F,!1);N&&(z=B=>B.provideWorkspaceTestRoot(N,se.token))}if(!!z){const x=async(N,B)=>{try{const Q=await z(B);Q&&M.addRoot(Q,N)}catch(Q){console.error(Q)}},G=new y.DisposableStore,M=G.add(this.ownedTests.createForHierarchy(N=>this.proxy.$publishDiff(h,R,N)));G.add((0,y.toDisposable)(()=>se.dispose(!0)));for(const[N,B]of this.providers)x(N,B);M.pushDiff([3,-1]),this.testSubscriptions.set($,{store:G,collection:M,subscribeFn:x})}}}async $expandTest(h,R){const F=(0,E.mapFind)(this.testSubscriptions.values(),$=>$.collection.treeId===h.src.tree?$:void 0);await(F==null?void 0:F.collection.expand(h.testId,R<0?Infinity:R)),this.flushCollectionDiffs()}$unsubscribeFromTests(h,R){var F;const $=k.URI.revive(R),se=u(h,$);(F=this.testSubscriptions.get(se))===null||F===void 0||F.store.dispose(),this.testSubscriptions.delete(se)}$acceptDiff(h,R,F){h===1?this.textDocumentObservers.acceptDiff(k.URI.revive(R),F):this.workspaceObservers.acceptDiff(k.URI.revive(R),F)}async $runTestsForProvider(h,R){const F=this.providers.get(h.tests[0].src.provider);if(!!F){const $=h.tests.map(({testId:x,src:G})=>this.ownedTests.getTestById(x,G.tree)).filter(T.isDefined).map(([x,G])=>G),se=h.excludeExtIds.map(x=>this.ownedTests.getTestById(x)).filter(T.isDefined).filter(([x,G])=>$.some(M=>x.comparePositions(M,G)===1));if(!!$.length){const z=x=>{for(const[G,M]of se){const N=G.comparePositions(M,x.id);if(N===1||N===3)return!0}return!1};try{await F.runTests({appendOutput:x=>{this.proxy.$appendOutputToRun(h.runId,P.VSBuffer.fromString(x))},appendMessage:(x,G)=>{z(x)||(this.flushCollectionDiffs(),this.proxy.$appendTestMessageInRun(h.runId,x.id,_.TestMessage.from(G)))},setState:(x,G,M)=>{z(x)||(this.flushCollectionDiffs(),this.proxy.$updateTestStateInRun(h.runId,x.id,G,M))},tests:$.map(x=>c.unwrap(x.actual)),exclude:se.map(([,x])=>c.unwrap(x.actual)),debug:h.debug},R);for(const{collection:x}of this.testSubscriptions.values())x.flushDiff();return}catch(x){throw console.error(x),x}}}}$lookupTest(h){const R=this.ownedTests.getTestById(h.testId);if(!R)return Promise.resolve(void 0);const F=R[1],{actual:$,discoverCts:se,expandLevels:z}=F,x=un(F,["actual","discoverCts","expandLevels"]);return Promise.resolve(x)}flushCollectionDiffs(){for(const{collection:h}of this.testSubscriptions.values())h.flushDiff()}getInternalTestForReference(h){var R,F;return(F=(R=this.workspaceObservers.getMirroredTestDataByReference(h))!==null&&R!==void 0?R:(0,E.mapFind)(this.testSubscriptions.values(),$=>$.collection.getTestByReference(h)))!==null&&F!==void 0?F:this.textDocumentObservers.getMirroredTestDataByReference(h)}};t=je([Ke(0,s.IExtHostRpcService),Ke(1,i.IExtHostDocumentsAndEditors),Ke(2,b.IExtHostWorkspace)],t),e.ExtHostTesting=t;const r=async(p,h,R,F)=>{if(!!R){const $=await p.provideWorkspaceTestRoot(R,F);if(!!$)return F.onCancellationRequested(()=>{c.removeFilter(h)}),c.getWrapperForTestItem($,h)}};e.createDefaultDocumentTestRoot=r;class c extends d.TestItem{constructor(h,R,F){super(h.id,h.label,h.uri,h.expandable);if(this.actual=h,this.filterDocument=R,this.parent=F,!(h instanceof d.TestItem))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${h.id} did not`);h[d.TestItemHookProperty]={setProp:($,se)=>this[$]=se,created:$=>c.getWrapperForTestItem($,this.filterDocument,this).refreshMatch(),invalidate:()=>this.invalidate(),delete:$=>this.children.delete($)}}static removeFilter(h){this.wrapperMap.delete(h)}static getWrapperForTestItem(h,R,F){let $=this.wrapperMap.get(R);if($==null?void 0:$.has(h))return $.get(h);$||($=new WeakMap,this.wrapperMap.set(R,$));const se=new c(h,R,F);return $.set(h,se),se}static unwrap(h){return h instanceof c?h.actual:h}get hasNodeMatchingFilter(){return this._cachedMatchesFilter===void 0?this.refreshMatch():this._cachedMatchesFilter}refreshMatch(){var h;const R=this._cachedMatchesFilter;for(const $ of this.actual.children){const se=c.getWrapperForTestItem($,this.filterDocument,this);se.hasNodeMatchingFilter?this.children.add(se):this.children.delete(se)}const F=this.children.size>0||this.actual.uri.toString()===this.filterDocument.uri.toString();return this._cachedMatchesFilter=F,F!==R&&((h=this.parent)===null||h===void 0||h.refreshMatch()),this._cachedMatchesFilter}}e.TestItemFilteredWrapper=c,c.wrapperMap=new WeakMap;class o extends l.IncrementalChangeCollector{constructor(h){super();this.emitter=h,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(h){this.added.add(h)}update(h){Object.assign(h.revived,_.TestItem.toPlain(h.item)),this.added.has(h)||this.updated.add(h)}remove(h){if(this.added.has(h)){this.added.delete(h);return}if(this.updated.delete(h),h.parent&&this.alreadyRemoved.has(h.parent)){this.alreadyRemoved.add(h.item.extId);return}this.removed.add(h)}getChangeEvent(){const{added:h,updated:R,removed:F}=this;return{get added(){return[...h].map($=>$.revived)},get updated(){return[...R].map($=>$.revived)},get removed(){return[...F].map($=>$.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class a extends l.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new S.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(h){let R=[];for(const F of h){const $=this.items.get(F);$&&R.push($.revived)}return R}getMirroredTestDataById(h){return this.items.get(h)}getMirroredTestDataByReference(h){return this.items.get(h.id)}createItem(h,R){return Object.assign(Object.assign({},h),{revived:_.TestItem.toPlain(h.item),depth:R?R.depth+1:0,children:new Set})}createChangeCollector(){return new o(this.changeEmitter)}}e.MirroredTestCollection=a;class f{constructor(){this.resources=new Map}checkout(h){var R,F;const $=h.toString(),se=(R=this.resources.get($))!==null&&R!==void 0?R:this.createObserverData(h);return(F=se.pendingDeletion)===null||F===void 0||F.dispose(),se.observers++,{onDidChangeTest:se.tests.onDidChangeTests,onDidDiscoverInitialTests:new S.Emitter().event,get tests(){return se.tests.rootTestItems},dispose:(0,C.once)(()=>{--se.observers||(se.pendingDeletion=this.eventuallyDispose(h))})}}getMirroredTestDataByReference(h){for(const{tests:R}of this.resources.values()){const F=R.getMirroredTestDataByReference(h);if(F)return F}}eventuallyDispose(h){return(0,I.disposableTimeout)(()=>this.unlisten(h),10*1e3)}createObserverData(h){const R=new a,F=this.listen(h,se=>R.apply(se)),$={observers:0,tests:R,listener:F};return this.resources.set(h.toString(),$),$}unlisten(h){var R;const F=h.toString(),$=this.resources.get(F);$&&($.observers=-1,(R=$.pendingDeletion)===null||R===void 0||R.dispose(),$.listener.dispose(),this.resources.delete(F))}}class w extends f{constructor(h){super();this.proxy=h,this.diffListeners=new Map}acceptDiff(h,R){var F;(F=this.diffListeners.get(h.toString()))===null||F===void 0||F(R)}listen(h,R){this.proxy.$subscribeToDiffs(0,h);const F=h.toString();return this.diffListeners.set(F,R),new d.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,h),this.diffListeners.delete(F)})}}class D extends f{constructor(h,R){super();this.proxy=h,this.documents=R,this.diffListeners=new Map}acceptDiff(h,R){var F;(F=this.diffListeners.get(h.toString()))===null||F===void 0||F(R)}listen(h,R){if(!this.documents.getDocument(h))return new d.Disposable(()=>{});const $=h.toString();return this.diffListeners.set($,R),this.proxy.$subscribeToDiffs(1,h),new d.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,h),this.diffListeners.delete($)})}}}),define(_e[218],we([0,1,11,50,28,58,22,18,12,25,8,13,2,114,139,89,47,173,216,41]),function(ie,e,E,I,P,A,S,C,y,n,T,k,g,m,i,s,_,d,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let l=class{constructor(D,p,h,R){this.configurationService=D,this.workspaceContextService=p,this.editorGroupsService=h,this.pathService=R}text(D,p,h={}){D=this.getContentPattern(D,h);const R=this.configurationService.getValue(),F=p&&p.some(se=>!this.configurationService.getValue({resource:se}).search.useRipgrep),$=this.commonQuery(p==null?void 0:p.map(_.toWorkspaceFolder),h);return Object.assign(Object.assign({},$),{type:2,contentPattern:D,previewOptions:h.previewOptions,maxFileSize:h.maxFileSize,usePCRE2:R.search.usePCRE2||F||!1,beforeContext:h.beforeContext,afterContext:h.afterContext,userDisabledExcludesAndIgnoreFiles:h.disregardExcludeSettings&&h.disregardIgnoreFiles})}getContentPattern(D,p){const h=this.configurationService.getValue();D.isRegExp&&(D.pattern=D.pattern.replace(/\r?\n/g,"\\n"));const R=Object.assign(Object.assign({},D),{wordSeparators:h.editor.wordSeparators});return this.isCaseSensitive(D,p)&&(R.isCaseSensitive=!0),this.isMultiline(D)&&(R.isMultiline=!0),R}file(D,p={}){const h=this.commonQuery(D,p);return Object.assign(Object.assign({},h),{type:1,filePattern:p.filePattern?p.filePattern.trim():p.filePattern,exists:p.exists,sortByScore:p.sortByScore,cacheKey:p.cacheKey})}handleIncludeExclude(D,p){return D?(D=Array.isArray(D)?D.map(o):o(D),p?this.parseSearchPaths(D):{pattern:t(...Array.isArray(D)?D:[D])}):{}}commonQuery(D=[],p={}){const h=this.handleIncludeExclude(p.includePattern,p.expandPatterns),R=this.handleIncludeExclude(p.excludePattern,p.expandPatterns),F=D.length>1,$=(h.searchPaths&&h.searchPaths.length?h.searchPaths.map(x=>this.getFolderQueryForSearchPath(x,p,R)):D.map(x=>this.getFolderQueryForRoot(x,p,R,F))).filter(x=>!!x),se={_reason:p._reason,folderQueries:$,usingSearchPaths:!!(h.searchPaths&&h.searchPaths.length),extraFileResources:p.extraFileResources,excludePattern:R.pattern,includePattern:h.pattern,onlyOpenEditors:p.onlyOpenEditors,maxResults:p.maxResults};if(p.onlyOpenEditors){const G=E.coalesce(E.flatten(this.editorGroupsService.groups.map(N=>N.editors.map(B=>B.resource)))).filter(N=>(0,v.pathIncludedInQuery)(se,N.fsPath)),M=this.commonQueryFromFileList(G);return Object.assign(Object.assign({},se),M)}const z=p.extraFileResources&&p.extraFileResources.filter(x=>(0,v.pathIncludedInQuery)(se,x.fsPath));return se.extraFileResources=z&&z.length?z:void 0,se}commonQueryFromFileList(D){const p=[],h=new S.ResourceMap,R={};let F=!1;return D.forEach($=>{var se,z;if($.scheme!==C.Schemas.walkThrough)if((0,n.isAbsolutePath)($)){const G=(z=(se=this.workspaceContextService.getWorkspaceFolder($))===null||se===void 0?void 0:se.uri)!==null&&z!==void 0?z:$.with({path:y.dirname($.fsPath)});let M=h.get(G);M||(F=!0,M={folder:G,includePattern:{}},p.push(M),h.set(G,M));const N=y.relative(G.fsPath,$.fsPath);(0,k.assertIsDefined)(M.includePattern)[N.replace(/\\/g,"/")]=!0}else $.fsPath&&(F=!0,R[$.fsPath]=!0)}),{folderQueries:p,includePattern:R,usingSearchPaths:!0,excludePattern:F?void 0:{"**/*":!0}}}isCaseSensitive(D,p){if(p.isSmartCase){if(D.isRegExp){if(T.containsUppercaseCharacter(D.pattern,!0))return!0}else if(T.containsUppercaseCharacter(D.pattern))return!0}return!!D.isCaseSensitive}isMultiline(D){return D.isMultiline||D.isRegExp&&(0,m.isMultilineRegexSource)(D.pattern)||D.pattern.indexOf(`
`)>=0?!0:!!D.isMultiline}parseSearchPaths(D){const p=M=>y.isAbsolute(M)||/^\.\.?([\/\\]|$)/.test(M),R=(Array.isArray(D)?D:r(D)).map(M=>{const N=this.pathService.resolvedUserHome;return N?(0,A.untildify)(M,N.scheme===C.Schemas.file?N.fsPath:N.path):M}),F=I.groupBy(R,M=>p(M)?"searchPaths":"exprSegments"),$=(F.exprSegments||[]).map(M=>T.rtrim(M,"/")).map(M=>T.rtrim(M,"\\")).map(M=>(M[0]==="."&&(M="*"+M),c(M))),se={},z=this.expandSearchPathPatterns(F.searchPaths||[]);z&&z.length&&(se.searchPaths=z);const x=E.flatten($),G=t(...x);return G&&(se.pattern=G),se}getExcludesForFolder(D,p){return p.disregardExcludeSettings?void 0:(0,v.getExcludes)(D,!p.disregardSearchExcludeSettings)}expandSearchPathPatterns(D){if(!D||!D.length)return[];const p=E.flatten(D.map(R=>{let{pathPortion:F,globPortion:$}=u(R);$&&($=a($));const se=this.expandOneSearchPath(F);return E.flatten(se.map(z=>this.resolveOneSearchPathPattern(z,$)))})),h=new Map;return p.forEach(R=>{const F=R.searchPath.toString(),$=h.get(F);$?R.pattern&&($.pattern=$.pattern||{},$.pattern[R.pattern]=!0):h.set(F,{searchPath:R.searchPath,pattern:R.pattern?t(R.pattern):void 0})}),Array.from(h.values())}expandOneSearchPath(D){if(y.isAbsolute(D)){const p=this.workspaceContextService.getWorkspace().folders;return p[0]&&p[0].uri.scheme!==C.Schemas.file?[{searchPath:p[0].uri.with({path:D})}]:[{searchPath:g.URI.file(y.normalize(D))}]}if(this.workspaceContextService.getWorkbenchState()===2){const p=this.workspaceContextService.getWorkspace().folders[0].uri;if(D=o(D),D.startsWith("../")||D===".."){const R=y.posix.resolve(p.path,D);return[{searchPath:p.with({path:R})}]}const h=a(D);return[{searchPath:p,pattern:h}]}else{if(D==="./"||D===".\\")return[];{const p=D.match(/\.[\/\\]([^\/\\]+)(?:[\/\\](.+))?/);if(p){const h=p[1],R=this.workspaceContextService.getWorkspace().folders.filter(F=>F.name===h);if(R.length)return R.map(F=>{const $=p[2];return{searchPath:F.uri,pattern:$&&a($)}});{const F=i.localize(0,null,h);throw new Error(F)}}}}return[]}resolveOneSearchPathPattern(D,p){const h=D.pattern&&p?`${D.pattern}/${p}`:D.pattern||p,R=[{searchPath:D.searchPath,pattern:h}];return h&&!h.endsWith("**")&&R.push({searchPath:D.searchPath,pattern:h+"/**"}),R}getFolderQueryForSearchPath(D,p,h){const R=this.getFolderQueryForRoot((0,_.toWorkspaceFolder)(D.searchPath),p,h,!1);return R?Object.assign(Object.assign({},R),{includePattern:D.pattern}):null}getFolderQueryForRoot(D,p,h,R){let F;const $=g.URI.isUri(D)?D:D.uri;if(h.searchPaths){const M=h.searchPaths.filter(N=>(0,n.isEqual)(N.searchPath,$))[0];if(M&&!M.pattern)return null;M&&(F=M.pattern)}const se=this.configurationService.getValue({resource:$}),z=this.getExcludesForFolder(se,p),x=Object.assign(Object.assign({},z||{}),F||{}),G=g.URI.isUri(D)?(0,n.basename)(D):D.name;return{folder:$,folderName:R?G:void 0,excludePattern:Object.keys(x).length>0?x:void 0,fileEncoding:se.files&&se.files.encoding,disregardIgnoreFiles:typeof p.disregardIgnoreFiles=="boolean"?p.disregardIgnoreFiles:!se.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof p.disregardGlobalIgnoreFiles=="boolean"?p.disregardGlobalIgnoreFiles:!se.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof p.ignoreSymlinks=="boolean"?p.ignoreSymlinks:!se.search.followSymlinks}}};l=je([Ke(0,s.IConfigurationService),Ke(1,_.IWorkspaceContextService),Ke(2,d.IEditorGroupsService),Ke(3,b.IPathService)],l),e.QueryBuilder=l;function u(w){const D=w.match(/[\*\{\}\(\)\[\]\?]/);if(D){const p=D.index,h=w.substr(0,p).match(/[/|\\][^/\\]*$/);if(h){let R=w.substr(0,h.index);return R.match(/[/\\]/)||(R+="/"),{pathPortion:R,globPortion:w.substr((h.index||0)+1)}}}return{pathPortion:w}}function t(...w){return w.length?w.reduce((D,p)=>(D[p]=!0,D),Object.create(null)):void 0}function r(w){return P.splitGlobAware(w,",").map(D=>D.trim()).filter(D=>!!D.length)}function c(w){return[`**/${w}/**`,`**/${w}`].map(p=>p.replace(/\*\*\/\*\*/g,"**"))}function o(w){return w.replace(/\\/g,"/")}function a(w){return o(w).replace(/^\.\//,"").replace(/\/+$/g,"")}function f(w,D){w=E.distinct(w,R=>R.toString());const p=[],h=D.getWorkspace();return w&&w.forEach(R=>{let F;if(D.getWorkbenchState()===2)F=(0,n.relativePath)(h.folders[0].uri,R),F&&F!=="."&&(F="./"+F);else{const $=D.getWorkspaceFolder(R);if($){const se=$.name;if(h.folders.filter(x=>x.name===se).length===1){const x=(0,n.relativePath)($.uri,R);x===""?F=`./${$.name}`:F=`./${$.name}/${x}`}else F=R.fsPath}}F&&p.push(F)}),p}e.resolveResourcesForSearchIncludes=f}),define(_e[219],we([0,1,25,2,20,10,4,218,41,47]),function(ie,e,E,I,P,A,S,C,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const T=7e3;function k(s,_){const d=_.activationEvents;if(!d)return Promise.resolve(void 0);const b=[],v=[];for(const o of d)if(/^workspaceContains:/.test(o)){const a=o.substr("workspaceContains:".length);a.indexOf("*")>=0||a.indexOf("?")>=0||s.forceUsingSearch?v.push(a):b.push(a)}if(b.length===0&&v.length===0)return Promise.resolve(void 0);let l;const u=new Promise((o,a)=>{l=o}),t=o=>l({activationEvent:o}),r=Promise.all(b.map(o=>g(s,o,t))).then(()=>{}),c=m(s,_.identifier,v,t);return Promise.all([r,c]).then(()=>{l(void 0)}),u}e.checkActivateWorkspaceContainsExtension=k;async function g(s,_,d){for(const b of s.folders)if(await s.exists(E.joinPath(I.URI.revive(b),_))){d(`workspaceContains:${_}`);return}}async function m(s,_,d,b){if(d.length===0)return Promise.resolve(void 0);const v=new P.CancellationTokenSource,l=s.checkExists(s.folders,d,v.token),u=setTimeout(async()=>{v.cancel(),b(`workspaceContainsTimeout:${d.join(",")}`)},T);let t=!1;try{t=await l}catch(r){A.isPromiseCanceledError(r)||A.onUnexpectedError(r)}v.dispose(),clearTimeout(u),t&&b(`workspaceContains:${d.join(",")}`)}function i(s,_,d,b){const v=s.get(S.IInstantiationService),l=s.get(y.ISearchService),t=v.createInstance(C.QueryBuilder).file(_.map(r=>(0,n.toWorkspaceFolder)(I.URI.revive(r))),{_reason:"checkExists",includePattern:d,exists:!0});return l.fileSearch(t,b).then(r=>!!r.limitHit,r=>A.isPromiseCanceledError(r)?!1:Promise.reject(r))}e.checkGlobFileExists=i});var tt=this&&this.__classPrivateFieldSet||function(ie,e,E,I,P){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!P:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?P.call(ie,E):P?P.value=E:e.set(ie,E),E},xe=this&&this.__classPrivateFieldGet||function(ie,e,E,I){if(E==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!I:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?I:E==="a"?I.call(ie):I?I.value:e.get(ie)};define(_e[35],we([0,1,131,12,77,25,14,6,22,2,19,5,34,184,75,31,33,182,10,26,18,23,160,7,90,4,27,76,15,65,67,40,3,219,71,161]),function(ie,e,E,I,P,A,S,C,y,n,T,k,g,m,i,s,_,d,b,v,l,u,t,r,c,o,a,f,w,D,p,h,R,F,$,se){"use strict";var z,x,G;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,o.createDecorator)("IHostUtils");let M=class Pn extends C.Disposable{constructor(W,ee,re,oe,Se,Pe,$e,Fe,ze,U){super();this._onDidChangeRemoteConnectionData=this._register(new R.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=ee,this._extHostContext=re,this._initData=$e,this._extHostWorkspace=oe,this._extHostConfiguration=Se,this._logService=Pe,this._extHostTunnelService=ze,this._extHostTerminalService=U,this._disposables=new C.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(k.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(k.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(k.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new S.Barrier,this._readyToStartExtensionHost=new S.Barrier,this._readyToRunExtensions=new S.Barrier,this._eagerExtensionsActivated=new S.Barrier,this._registry=new d.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new i.ExtHostStorage(this._extHostContext),this._secretState=new $.ExtHostSecretState(this._extHostContext),this._storagePath=Fe,this._instaService=W.createChild(new D.ServiceCollection([i.IExtHostStorage,this._storage],[$.IExtHostSecretState,this._secretState]));const K=new Set;this._initData.hostExtensions.forEach(te=>K.add(v.ExtensionIdentifier.toKey(te))),this._activator=new m.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(te,le)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(te,le)},actualActivateExtension:async(te,le)=>{if(K.has(v.ExtensionIdentifier.toKey(te)))return await this._mainThreadExtensionsProxy.$activateExtension(te,le),new m.HostExtension;const me=this._registry.getExtensionDescription(te);return this._activateExtension(me,le)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),P.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(W){b.onUnexpectedError(W)}}async deactivateAll(){let W=[];try{W=this._registry.getAllExtensionDescriptions().map(Se=>Se.identifier).filter(Se=>this.isActivated(Se)).map(Se=>this._deactivate(Se))}catch(ee){}await Promise.all(W)}isActivated(W){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(W):!1}_activateByEvent(W,ee){return this._activator.activateByEvent(W,ee)}_activateById(W,ee){return this._activator.activateById(W,ee)}activateByIdWithErrors(W,ee){return this._activateById(W,ee).then(()=>{const re=this._activator.getActivatedExtension(W);if(re.activationFailed)return Promise.reject(re.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(W=>this._registry)}getExtensionExports(W){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(W).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const W=y.TernarySearchTree.forPaths(),ee=this._registry.getAllExtensionDescriptions().map(re=>{if(!!this._getEntryPoint(re))return this._hostUtils.realpath(re.extensionLocation.fsPath).then(oe=>W.set(n.URI.file(oe).fsPath,re))});this._extensionPathIndex=Promise.all(ee).then(()=>W)}return this._extensionPathIndex}_deactivate(W){let ee=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(W))return ee;const re=this._activator.getActivatedExtension(W);if(!re)return ee;try{typeof re.module.deactivate=="function"&&(ee=Promise.resolve(re.module.deactivate()).then(void 0,oe=>Promise.resolve(void 0)))}catch(oe){}try{(0,C.dispose)(re.subscriptions)}catch(oe){}return ee}async _activateExtension(W,ee){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(W.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(W.identifier),this._doActivateExtension(W,ee).then(re=>{const oe=re.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(W.identifier,oe.codeLoadingTime,oe.activateCallTime,oe.activateResolvedTime,ee),this._logExtensionActivationTimes(W,ee,"success",oe),re},re=>{throw this._logExtensionActivationTimes(W,ee,"failure"),re})}_logExtensionActivationTimes(W,ee,re,oe){const Se=N(W,ee);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},Se),oe||{}),{outcome:re}))}_doActivateExtension(W,ee){const re=N(W,ee);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",re);const oe=this._getEntryPoint(W);if(!oe)return Promise.resolve(new m.EmptyExtension(m.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${W.identifier.value} ${JSON.stringify(ee)}`),this._logService.flush();const Se=new m.ExtensionActivationTimesBuilder(ee.startup);return Promise.all([this._loadCommonJSModule(W.identifier,(0,A.joinPath)(W.extensionLocation,oe),Se),this._loadExtensionContext(W)]).then(Pe=>(P.mark(`code/extHost/willActivateExtension/${W.identifier.value}`),Pn._callActivate(this._logService,W.identifier,Pe[0],Pe[1],Se))).then(Pe=>(P.mark(`code/extHost/didActivateExtension/${W.identifier.value}`),Pe))}_loadExtensionContext(W){const ee=new t.ExtensionGlobalMemento(W,this._storage),re=new t.ExtensionMemento(W.identifier.value,!1,this._storage),oe=new se.ExtensionSecrets(W,this._secretState),Se=W.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?r.ExtensionMode.Test:r.ExtensionMode.Development:r.ExtensionMode.Production,Pe=this._initData.remote.isRemote?r.ExtensionKind.Workspace:r.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${W.identifier.value}`),Promise.all([ee.whenReady,re.whenReady,this._storagePath.whenReady]).then(()=>{const $e=this;let Fe;return Object.freeze({globalState:ee,workspaceState:re,secrets:oe,subscriptions:[],get extensionUri(){return W.extensionLocation},get extensionPath(){return W.extensionLocation.fsPath},asAbsolutePath(ze){return I.join(W.extensionLocation.fsPath,ze)},get storagePath(){var ze;return(ze=$e._storagePath.workspaceValue(W))===null||ze===void 0?void 0:ze.fsPath},get globalStoragePath(){return $e._storagePath.globalValue(W).fsPath},get logPath(){return I.join($e._initData.logsLocation.fsPath,W.identifier.value)},get logUri(){return n.URI.joinPath($e._initData.logsLocation,W.identifier.value)},get storageUri(){return $e._storagePath.workspaceValue(W)},get globalStorageUri(){return $e._storagePath.globalValue(W)},get extensionMode(){return Se},get extension(){return Fe===void 0&&(Fe=new B($e,W.identifier,W,Pe)),Fe},get extensionRuntime(){return(0,_.checkProposedApiEnabled)(W),$e.extensionRuntime},get environmentVariableCollection(){return $e._extHostTerminalService.getEnvironmentVariableCollection(W)}})})}static _callActivate(W,ee,re,oe,Se){return re=re||{activate:void 0,deactivate:void 0},this._callActivateOptional(W,ee,re,oe,Se).then(Pe=>new m.ActivatedExtension(!1,null,Se.build(),re,Pe,oe.subscriptions))}static _callActivateOptional(W,ee,re,oe,Se){if(typeof re.activate=="function")try{Se.activateCallStart(),W.trace(`ExtensionService#_callActivateOptional ${ee.value}`);const Pe=typeof global=="object"?global:self,$e=re.activate.apply(Pe,[oe]);return Se.activateCallStop(),Se.activateResolveStart(),Promise.resolve($e).then(Fe=>(Se.activateResolveStop(),Fe))}catch(Pe){return Promise.reject(Pe)}else return Promise.resolve(re)}_activateOneStartupFinished(W,ee){this._activateById(W.identifier,{startup:!1,extensionId:W.identifier,activationEvent:ee}).then(void 0,re=>{this._logService.error(re)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(P.getMarks());for(const W of this._registry.getAllExtensionDescriptions())if(W.activationEvents)for(const ee of W.activationEvents)ee==="onStartupFinished"&&this._activateOneStartupFinished(W,ee)}_handleEagerExtensions(){const W=this._activateByEvent("*",!0).then(void 0,Se=>{this._logService.error(Se)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(Se=>this._handleWorkspaceContainsEagerExtensions(Se.added)));const ee=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],re=this._handleWorkspaceContainsEagerExtensions(ee),oe=Promise.all([W,re]).then(()=>{});return Promise.race([oe,(0,S.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),oe}_handleWorkspaceContainsEagerExtensions(W){return W.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(ee=>this._handleWorkspaceContainsEagerExtension(W,ee))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(W,ee){if(!this.isActivated(ee.identifier)){const re=!this._initData.remote.isRemote&&!!this._initData.remote.authority,oe={folders:W.map(Pe=>Pe.uri),forceUsingSearch:re,exists:Pe=>this._hostUtils.exists(Pe.fsPath),checkExists:(Pe,$e,Fe)=>this._mainThreadWorkspaceProxy.$checkExists(Pe,$e,Fe)},Se=await(0,F.checkActivateWorkspaceContainsExtension)(oe,ee);if(!!Se)return this._activateById(ee.identifier,{startup:!0,extensionId:ee.identifier,activationEvent:Se.activationEvent}).then(void 0,Pe=>this._logService.error(Pe))}}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return this._doHandleExtensionTests()}catch(W){throw console.error(W),W}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:W,extensionTestsLocationURI:ee}=this._initData.environment;if(!W||!ee||ee.scheme!==l.Schemas.file)throw new Error(E.localize(0,null));const re=(0,A.originalFSPath)(ee),oe=await this._loadCommonJSModule(null,ee,new m.ExtensionActivationTimesBuilder(!1));if(!oe||typeof oe.run!="function")throw new Error(E.localize(1,null,re));return new Promise((Se,Pe)=>{const $e=(ze,U)=>{ze?Pe(ze):Se(typeof U=="number"&&U>0?1:0)},Fe=oe.run(re,$e);Fe&&Fe.then&&Fe.then(()=>{Se(0)}).catch(ze=>{Pe(ze.toString())})})}async $extensionTestsExit(W){this._logService.info(`extension host terminating: test runner requested exit with code ${W}`),this._logService.info(`exiting with code ${W}`),this._logService.flush(),this._hostUtils.exit(W)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(W,ee){return this._resolvers[W]=ee,(0,C.toDisposable)(()=>{delete this._resolvers[W]})}async $resolveAuthority(W,ee){const re=W.indexOf("+");if(re===-1)throw new Error("Not an authority that can be resolved!");const oe=W.substr(0,re);await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${oe}`,!1);const Se=this._resolvers[oe];if(!Se)return{type:"error",error:{code:c.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${oe}.`,detail:void 0}};try{P.mark(`code/extHost/willResolveAuthority/${oe}`);const Pe=await Se.resolve(W,{resolveAttempt:ee});P.mark(`code/extHost/didResolveAuthorityOK/${oe}`),this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(Se));const $e={authority:W,host:Pe.host,port:Pe.port,connectionToken:Pe.connectionToken},Fe={extensionHostEnv:Pe.extensionHostEnv};return{type:"ok",value:{authority:$e,options:Fe,tunnelInformation:{environmentTunnels:Pe.environmentTunnels}}}}catch(Pe){if(P.mark(`code/extHost/didResolveAuthorityError/${oe}`),Pe instanceof r.RemoteAuthorityResolverError)return{type:"error",error:{code:Pe._code,message:Pe._message,detail:Pe._detail}};throw Pe}}$startExtensionHost(W){return this._registry.keepOnly(W),this._startExtensionHost()}$activateByEvent(W,ee){return ee===1?this._activateByEvent(W,!1):this._readyToRunExtensions.wait().then(re=>this._activateByEvent(W,!1))}async $activate(W,ee){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(W)?(await this._activateById(W,ee),!0):!1}async $deltaExtensions(W,ee){W.forEach(oe=>oe.extensionLocation=n.URI.revive(oe.extensionLocation));const re=await this.getExtensionPathIndex();return await Promise.all(ee.map(async oe=>{const Se=this._registry.getExtensionDescription(oe);if(!!Se){const Pe=await this._hostUtils.realpath(Se.extensionLocation.fsPath);re.delete(n.URI.file(Pe).fsPath)}})),await Promise.all(W.map(async oe=>{const Se=await this._hostUtils.realpath(oe.extensionLocation.fsPath);re.set(n.URI.file(Se).fsPath,oe)})),this._registry.deltaExtensions(W,ee),Promise.resolve(void 0)}async $test_latency(W){return W}async $test_up(W){return W.byteLength}async $test_down(W){let ee=u.VSBuffer.alloc(W),re=Math.random()%256;for(let oe=0;oe<W;oe++)ee.writeUInt8(re,oe);return ee}async $updateRemoteConnectionData(W){this._remoteConnectionData=W,this._onDidChangeRemoteConnectionData.fire()}};M=je([Ke(0,o.IInstantiationService),Ke(1,e.IHostUtils),Ke(2,w.IExtHostRpcService),Ke(3,s.IExtHostWorkspace),Ke(4,g.IExtHostConfiguration),Ke(5,T.ILogService),Ke(6,a.IExtHostInitDataService),Ke(7,f.IExtensionStoragePaths),Ke(8,p.IExtHostTunnelService),Ke(9,h.IExtHostTerminalService)],M),e.AbstractExtHostExtensionService=M;function N(Q,W){return{id:Q.identifier.value,name:Q.name,extensionVersion:Q.version,publisherDisplayName:Q.publisher,activationEvents:Q.activationEvents?Q.activationEvents.join(","):null,isBuiltin:Q.isBuiltin,reason:W.activationEvent,reasonId:W.extensionId.value}}e.IExtHostExtensionService=(0,o.createDecorator)("IExtHostExtensionService");class B{constructor(W,ee,re,oe){z.set(this,void 0),x.set(this,void 0),G.set(this,void 0),tt(this,z,W,"f"),tt(this,x,ee,"f"),tt(this,G,re.identifier,"f"),this.id=re.identifier.value,this.extensionUri=re.extensionLocation,this.extensionPath=I.normalize((0,A.originalFSPath)(re.extensionLocation)),this.packageJSON=re,this.extensionKind=oe}get isActive(){return xe(this,z,"f").isActivated(xe(this,G,"f"))}get exports(){if(this.packageJSON.api!=="none")return xe(this,z,"f").getExtensionExports(xe(this,G,"f"))}activate(){return xe(this,z,"f").activateByIdWithErrors(xe(this,G,"f"),{startup:!1,extensionId:xe(this,x,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=B,z=new WeakMap,x=new WeakMap,G=new WeakMap}),define(_e[102],we([0,1,12,2,3,14,5,7,168,31,35,39,172,34,169,15,4,13,45]),function(ie,e,E,I,P,A,S,C,y,n,T,k,g,m,i,s,_,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,_.createDecorator)("IExtHostDebugService");let v=class{constructor(f,w,D,p,h){this._workspaceService=w,this._extensionService=D,this._editorsService=p,this._configurationService=h,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new P.Emitter,this._onDidTerminateDebugSession=new P.Emitter,this._onDidChangeActiveDebugSession=new P.Emitter,this._onDidReceiveDebugSessionCustomEvent=new P.Emitter,this._debugServiceProxy=f.getProxy(S.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new P.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new u(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(R=>{R.onDidChange(F=>{this.registerAllDebugTypes(R)}),this.registerAllDebugTypes(R)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(f,w){const D=f;if(typeof D.sourceReference=="number"&&D.sourceReference>0){let p=`debug:${encodeURIComponent(D.path||"")}`,h="?";return w&&(p+=`${h}session=${encodeURIComponent(w.id)}`,h="&"),p+=`${h}ref=${D.sourceReference}`,I.URI.parse(p)}else{if(D.path)return I.URI.file(D.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(f){const w=[];for(const D of f.getAllExtensionDescriptions())if(D.contributes){const p=D.contributes.debuggers;if(p&&p.length>0)for(const h of p)(0,i.isDebuggerMainContribution)(h)&&w.push(h.type)}this._debugServiceProxy.$registerDebugTypes(w)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const f=[];return this._breakpoints.forEach(w=>f.push(w)),f}addBreakpoints(f){this.startBreakpoints();const w=f.filter(h=>{const R=h.id;return this._breakpoints.has(R)?!1:(this._breakpoints.set(R,h),!0)});this.fireBreakpointChanges(w,[],[]);const D=[],p=new Map;for(const h of w)if(h instanceof C.SourceBreakpoint){let R=p.get(h.location.uri.toString());R||(R={type:"sourceMulti",uri:h.location.uri,lines:[]},p.set(h.location.uri.toString(),R),D.push(R)),R.lines.push({id:h.id,enabled:h.enabled,condition:h.condition,hitCondition:h.hitCondition,logMessage:h.logMessage,line:h.location.range.start.line,character:h.location.range.start.character})}else h instanceof C.FunctionBreakpoint&&D.push({type:"function",id:h.id,enabled:h.enabled,hitCondition:h.hitCondition,logMessage:h.logMessage,condition:h.condition,functionName:h.functionName});return this._debugServiceProxy.$registerBreakpoints(D)}removeBreakpoints(f){this.startBreakpoints();const w=f.filter(R=>this._breakpoints.delete(R.id));this.fireBreakpointChanges([],w,[]);const D=w.filter(R=>R instanceof C.SourceBreakpoint).map(R=>R.id),p=w.filter(R=>R instanceof C.FunctionBreakpoint).map(R=>R.id),h=w.filter(R=>R instanceof C.DataBreakpoint).map(R=>R.id);return this._debugServiceProxy.$unregisterBreakpoints(D,p,h)}startDebugging(f,w,D){return this._debugServiceProxy.$startDebugging(f?f.uri:void 0,w,{parentSessionID:D.parentSession?D.parentSession.id:void 0,repl:D.consoleMode===C.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:D.noDebug,compact:D.compact})}stopDebugging(f){return this._debugServiceProxy.$stopDebugging(f?f.id:void 0)}registerDebugConfigurationProvider(f,w,D){if(!w)return new C.Disposable(()=>{});const p=this._configProviderHandleCounter++;return this._configProviders.push({type:f,handle:p,provider:w}),this._debugServiceProxy.$registerDebugConfigurationProvider(f,D,!!w.provideDebugConfigurations,!!w.resolveDebugConfiguration,!!w.resolveDebugConfigurationWithSubstitutedVariables,p),new C.Disposable(()=>{this._configProviders=this._configProviders.filter(h=>h.provider!==w),this._debugServiceProxy.$unregisterDebugConfigurationProvider(p)})}registerDebugAdapterDescriptorFactory(f,w,D){if(!D)return new C.Disposable(()=>{});if(!this.definesDebugType(f,w))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${w}' debugger.`);if(this.getAdapterDescriptorFactoryByType(w))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const p=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:w,handle:p,factory:D}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(w,p),new C.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(h=>h.factory!==D),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(p)})}registerDebugAdapterTrackerFactory(f,w){if(!w)return new C.Disposable(()=>{});const D=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:f,handle:D,factory:w}),new C.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(p=>p.factory!==w)})}async $runInTerminal(f,w){return Promise.resolve(void 0)}async $substituteVariables(f,w){if(!this._variableResolver){const[h,R]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(h||[],this._editorsService,R)}let D;const p=await this.getFolder(f);return p&&(D={uri:p.uri,name:p.name,index:p.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(D,w)}createDebugAdapter(f,w){if(f.type==="implementation")return new c(f.implementation)}createSignService(){}async $startDASession(f,w){const D=this,p=await this.getSession(w);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(p.type),p).then(h=>{if(!h)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${p.type}' (extension might have failed to activate)`);const R=this.convertToDto(h),F=this.createDebugAdapter(R,p);if(!F)throw new Error(`Couldn't create a debug adapter for type '${p.type}'.`);const $=F;return this._debugAdapters.set(f,$),this.getDebugAdapterTrackers(p).then(se=>(se&&this._debugAdaptersTrackers.set(f,se),$.onMessage(async z=>{if(z.type==="request"&&z.command==="handshake"){const x=z,G={type:"response",seq:0,command:x.command,request_seq:x.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const M=await this._signService.sign(x.arguments.value);G.body={signature:M},$.sendResponse(G)}else throw new Error("no signer")}catch(M){G.success=!1,G.message=M.message,$.sendResponse(G)}}else se&&se.onDidSendMessage&&se.onDidSendMessage(z),z=(0,i.convertToVSCPaths)(z,!0),D._debugServiceProxy.$acceptDAMessage(f,z)}),$.onError(z=>{se&&se.onError&&se.onError(z),this._debugServiceProxy.$acceptDAError(f,z.name,z.message,z.stack)}),$.onExit(z=>{se&&se.onExit&&se.onExit((0,d.withNullAsUndefined)(z),void 0),this._debugServiceProxy.$acceptDAExit(f,(0,d.withNullAsUndefined)(z),void 0)}),se&&se.onWillStartSession&&se.onWillStartSession(),$.startSession()))})}$sendDAMessage(f,w){w=(0,i.convertToDAPaths)(w,!1);const D=this._debugAdaptersTrackers.get(f);D&&D.onWillReceiveMessage&&D.onWillReceiveMessage(w);const p=this._debugAdapters.get(f);p&&p.sendMessage(w)}$stopDASession(f){const w=this._debugAdaptersTrackers.get(f);this._debugAdaptersTrackers.delete(f),w&&w.onWillStopSession&&w.onWillStopSession();const D=this._debugAdapters.get(f);return this._debugAdapters.delete(f),D?D.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(f){const w=[],D=[],p=[];if(f.added)for(const h of f.added){const R=h.id;if(R&&!this._breakpoints.has(R)){let F;if(h.type==="function")F=new C.FunctionBreakpoint(h.functionName,h.enabled,h.condition,h.hitCondition,h.logMessage);else if(h.type==="data")F=new C.DataBreakpoint(h.label,h.dataId,h.canPersist,h.enabled,h.hitCondition,h.condition,h.logMessage);else{const $=I.URI.revive(h.uri);F=new C.SourceBreakpoint(new C.Location($,new C.Position(h.line,h.character)),h.enabled,h.condition,h.hitCondition,h.logMessage)}F._id=R,this._breakpoints.set(R,F),w.push(F)}}if(f.removed)for(const h of f.removed){const R=this._breakpoints.get(h);R&&(this._breakpoints.delete(h),D.push(R))}if(f.changed){for(const h of f.changed)if(h.id){const R=this._breakpoints.get(h.id);if(R){if(R instanceof C.FunctionBreakpoint&&h.type==="function"){const F=R;F.enabled=h.enabled,F.condition=h.condition,F.hitCondition=h.hitCondition,F.logMessage=h.logMessage,F.functionName=h.functionName}else if(R instanceof C.SourceBreakpoint&&h.type==="source"){const F=R;F.enabled=h.enabled,F.condition=h.condition,F.hitCondition=h.hitCondition,F.logMessage=h.logMessage,F.location=new C.Location(I.URI.revive(h.uri),new C.Position(h.line,h.character))}p.push(R)}}}this.fireBreakpointChanges(w,D,p)}$provideDebugConfigurations(f,w,D){return(0,A.asPromise)(async()=>{const p=this.getConfigProviderByHandle(f);if(!p)throw new Error("no DebugConfigurationProvider found");if(!p.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const h=await this.getFolder(w);return p.provideDebugConfigurations(h,D)}).then(p=>{if(!p)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return p})}$resolveDebugConfiguration(f,w,D,p){return(0,A.asPromise)(async()=>{const h=this.getConfigProviderByHandle(f);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const R=await this.getFolder(w);return h.resolveDebugConfiguration(R,D,p)})}$resolveDebugConfigurationWithSubstitutedVariables(f,w,D,p){return(0,A.asPromise)(async()=>{const h=this.getConfigProviderByHandle(f);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const R=await this.getFolder(w);return h.resolveDebugConfigurationWithSubstitutedVariables(R,D,p)})}async $provideDebugAdapter(f,w){const D=this.getAdapterDescriptorFactoryByHandle(f);if(!D)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const p=await this.getSession(w);return this.getAdapterDescriptor(D,p).then(h=>{if(!h)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${p.type}'`);return this.convertToDto(h)})}async $acceptDebugSessionStarted(f){const w=await this.getSession(f);this._onDidStartDebugSession.fire(w)}async $acceptDebugSessionTerminated(f){const w=await this.getSession(f);w&&(this._onDidTerminateDebugSession.fire(w),this._debugSessions.delete(w.id))}async $acceptDebugSessionActiveChanged(f){this._activeDebugSession=f?await this.getSession(f):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(f,w){const D=await this.getSession(f);D&&D._acceptNameChanged(w)}async $acceptDebugSessionCustomEvent(f,w){const p={session:await this.getSession(f),event:w.event,body:w.body};this._onDidReceiveDebugSessionCustomEvent.fire(p)}convertToDto(f){if(f instanceof C.DebugAdapterExecutable)return{type:"executable",command:f.command,args:f.args,options:f.options};if(f instanceof C.DebugAdapterServer)return{type:"server",port:f.port,host:f.host};if(f instanceof C.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:f.path};if(f instanceof C.DebugAdapterInlineImplementation)return{type:"implementation",implementation:f.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(f){const w=this._adapterFactories.filter(D=>D.type===f);if(w.length>0)return w[0].factory}getAdapterDescriptorFactoryByHandle(f){const w=this._adapterFactories.filter(D=>D.handle===f);if(w.length>0)return w[0].factory}getConfigProviderByHandle(f){const w=this._configProviders.filter(D=>D.handle===f);if(w.length>0)return w[0].provider}definesDebugType(f,w){if(f.contributes){const D=f.contributes.debuggers;if(D&&D.length>0){for(const p of D)if(p.label&&p.type&&p.type===w)return!0}}return!1}getDebugAdapterTrackers(f){const D=f.configuration.type,p=this._trackerFactories.filter(h=>h.type===D||h.type==="*").map(h=>(0,A.asPromise)(()=>h.factory.createDebugAdapterTracker(f)).then(R=>R,R=>null));return Promise.race([Promise.all(p).then(h=>{const R=h.filter(F=>!!F);if(R.length>0)return new r(R)}),new Promise((h,R)=>{const F=setTimeout(()=>{clearTimeout(F),R(new Error("timeout"))},1e3)})]).catch(h=>{})}async getAdapterDescriptor(f,w){const D=w.configuration.debugServer;if(typeof D=="number")return Promise.resolve(new C.DebugAdapterServer(D));if(f){const h=await this._extensionService.getExtensionRegistry();return(0,A.asPromise)(()=>f.createDebugAdapterDescriptor(w,this.daExecutableFromPackage(w,h))).then(R=>{if(R)return R})}const p=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(w,p))}daExecutableFromPackage(f,w){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(f,w,D){(f.length>0||w.length>0||D.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:f,removed:w,changed:D}))}async getSession(f){if(f)if(typeof f=="string"){const w=this._debugSessions.get(f);if(w)return w}else{let w=this._debugSessions.get(f.id);if(!w){const D=await this.getFolder(f.folderUri);w=new l(this._debugServiceProxy,f.id,f.type,f.name,D,f.configuration),this._debugSessions.set(w.id,w),this._debugServiceProxy.$sessionCached(w.id)}return w}throw new Error("cannot find session")}getFolder(f){if(f){const w=I.URI.revive(f);return this._workspaceService.resolveWorkspaceFolder(w)}return Promise.resolve(void 0)}};v=je([Ke(0,s.IExtHostRpcService),Ke(1,n.IExtHostWorkspace),Ke(2,T.IExtHostExtensionService),Ke(3,k.IExtHostDocumentsAndEditors),Ke(4,m.IExtHostConfiguration)],v),e.ExtHostDebugServiceBase=v;class l{constructor(f,w,D,p,h,R){this._debugServiceProxy=f,this._id=w,this._type=D,this._name=p,this._workspaceFolder=h,this._configuration=R}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(f){this._name=f,this._debugServiceProxy.$setDebugSessionName(this._id,f)}_acceptNameChanged(f){this._name=f}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(f,w){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,f,w)}getDebugProtocolBreakpoint(f){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,f.id)}}e.ExtHostDebugSession=l;class u{constructor(f){this.value=Object.freeze({append(w){f.$appendDebugConsole(w)},appendLine(w){this.append(w+`
`)}})}}e.ExtHostDebugConsole=u;class t extends g.AbstractVariableResolverService{constructor(f,w,D,p){super({getFolderUri:h=>{const R=f.filter(F=>F.name===h);if(R&&R.length>0)return R[0].uri},getWorkspaceFolderCount:()=>f.length,getConfigurationValue:(h,R)=>D.getConfiguration(void 0,h).get(R),getAppRoot:()=>b.cwd(),getExecPath:()=>b.env.VSCODE_EXEC_PATH,getFilePath:()=>{if(w){const h=w.activeEditor();if(h)return E.normalize(h.document.uri.fsPath)}},getWorkspaceFolderPathForFile:()=>{if(w&&p){const h=w.activeEditor();if(h){const R=p.getWorkspaceFolder(h.document.uri);if(R)return E.normalize(R.uri.fsPath)}}},getSelectedText:()=>{if(w){const h=w.activeEditor();if(h&&!h.selection.isEmpty)return h.document.getText(h.selection)}},getLineNumber:()=>{if(w){const h=w.activeEditor();if(h)return String(h.selection.end.line+1)}}},void 0,b.env)}}e.ExtHostVariableResolverService=t;class r{constructor(f){this.trackers=f}onWillStartSession(){this.trackers.forEach(f=>f.onWillStartSession?f.onWillStartSession():void 0)}onWillReceiveMessage(f){this.trackers.forEach(w=>w.onWillReceiveMessage?w.onWillReceiveMessage(f):void 0)}onDidSendMessage(f){this.trackers.forEach(w=>w.onDidSendMessage?w.onDidSendMessage(f):void 0)}onWillStopSession(){this.trackers.forEach(f=>f.onWillStopSession?f.onWillStopSession():void 0)}onError(f){this.trackers.forEach(w=>w.onError?w.onError(f):void 0)}onExit(f,w){this.trackers.forEach(D=>D.onExit?D.onExit(f,w):void 0)}}class c extends y.AbstractDebugAdapter{constructor(f){super();this.implementation=f,f.onDidSendMessage(w=>{this.acceptMessage(w)})}startSession(){return Promise.resolve(void 0)}sendMessage(f){this.implementation.handleMessage(f)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let o=class extends v{constructor(f,w,D,p,h){super(f,w,D,p,h)}createVariableResolver(f,w,D){return new t(f,w,D)}};o=je([Ke(0,s.IExtHostRpcService),Ke(1,n.IExtHostWorkspace),Ke(2,T.IExtHostExtensionService),Ke(3,k.IExtHostDocumentsAndEditors),Ke(4,m.IExtHostConfiguration)],o),e.WorkerExtHostDebugService=o}),define(_e[220],we([0,1,77,2,5,34,33,26,15,27,4,35,45,19]),function(ie,e,E,I,P,A,S,C,y,n,T,k,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let i=class{constructor(v,l,u,t,r,c,o){this._apiFactory=v,this._extensionRegistry=l,this._instaService=u,this._extHostConfiguration=t,this._extHostExtensionService=r,this._initData=c,this._logService=o,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),E.mark("code/extHost/willWaitForConfig");const v=await this._extHostConfiguration.getConfigProvider();E.mark("code/extHost/didWaitForConfig");const l=await this._extHostExtensionService.getExtensionPathIndex();this.register(new s(this._apiFactory,l,this._extensionRegistry,v,this._logService)),this.register(this._instaService.createInstance(_)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(d,l,this._initData.environment.appUriScheme))}register(v){if(Array.isArray(v.nodeModuleName))for(let l of v.nodeModuleName)this._factories.set(l,v);else this._factories.set(v.nodeModuleName,v);typeof v.alternativeModuleName=="function"&&this._alternatives.push(l=>v.alternativeModuleName(l))}};i=je([Ke(2,T.IInstantiationService),Ke(3,A.IExtHostConfiguration),Ke(4,k.IExtHostExtensionService),Ke(5,n.IExtHostInitDataService),Ke(6,m.ILogService)],i),e.RequireInterceptor=i;class s{constructor(v,l,u,t,r){this._apiFactory=v,this._extensionPaths=l,this._extensionRegistry=u,this._configProvider=t,this._logService=r,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(v,l){const u=this._extensionPaths.findSubstr(l.fsPath);if(u){let t=this._extApiImpl.get(C.ExtensionIdentifier.toKey(u.identifier));return t||(t=this._apiFactory(u,this._extensionRegistry,this._configProvider),this._extApiImpl.set(C.ExtensionIdentifier.toKey(u.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((r,c)=>t+=`	${c} -> ${r.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${l.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(S.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let _=class{constructor(v,l){this.nodeModuleName="keytar";const{environment:u}=l,t=v.getProxy(P.MainContext.MainThreadKeytar);if(u.appRoot){let r=u.appRoot.fsPath;g.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,c)=>t.$getPassword(r,c),setPassword:(r,c,o)=>t.$setPassword(r,c,o),deletePassword:(r,c)=>t.$deletePassword(r,c),findPassword:r=>t.$findPassword(r),findCredentials(r){return t.$findCredentials(r)}}}load(v,l){return this._impl}alternativeModuleName(v){const l=v.length;if(!(l<=7||!this.alternativeNames)){const u=l-7;if((v.charAt(u)==="/"||v.charAt(u)==="\\")&&v.endsWith("keytar")&&(v=v.replace(/\\/g,"/"),this.alternativeNames.has(v)))return"keytar"}}};_=je([Ke(0,y.IExtHostRpcService),Ke(1,n.IExtHostInitDataService)],_);let d=class{constructor(v,l,u){this._extensionPaths=v,this._appUriScheme=l,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=u.getProxy(P.MainContext.MainThreadTelemetry);const t=u.getProxy(P.MainContext.MainThreadWindow);this._impl=(r,c)=>{const o=I.URI.parse(r);return c?this.callOriginal(r,c):o.scheme==="http"||o.scheme==="https"?t.$openUri(o,r,{allowTunneling:!0}):o.scheme==="mailto"||o.scheme===this._appUriScheme?t.$openUri(o,r,{}):this.callOriginal(r,c)}}load(v,l,u){const t=this._extensionPaths.findSubstr(l.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=u(v),this._impl}callOriginal(v,l){return this.sendNoForwardTelemetry(),this._original(v,l)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};d=je([Ke(2,y.IExtHostRpcService)],d)}),define(_e[221],we([0,1,14,10,77,6,2,5,213,19,61,65,27,150,15,68,35,40]),function(ie,e,E,I,P,A,S,C,y,n,T,k,g,m,i,s,_,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class b{constructor(l,u,t,r){this._disposables=new A.DisposableStore,this._isTerminating=!1,this._hostUtils=t;const c=new y.RPCProtocol(l,null,r);u=b._transform(u,c);const o=new k.ServiceCollection(...(0,T.getSingletonServiceDescriptors)());o.set(g.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},u)),o.set(i.IExtHostRpcService,new i.ExtHostRpcService(c)),o.set(s.IURITransformerService,new s.URITransformerService(r)),o.set(_.IHostUtils,t);const a=new m.InstantiationService(o,!0),f=a.invokeFunction(h=>h.get(d.IExtHostTerminalService));this._disposables.add(f),this._logService=a.invokeFunction(h=>h.get(n.ILogService)),P.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",u),this._extensionService=a.invokeFunction(h=>h.get(_.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const w=new WeakMap;this._extensionService.getExtensionPathIndex().then(h=>{Error.prepareStackTrace=(R,F)=>{let $="",se,z;for(const x of F)$+=`
	at ${x.toString()}`,z=x.getFileName(),!se&&z&&(se=h.findSubstr(z));return w.set(R,se),`${R.name||"Error"}: ${R.message||""}${$}`}});const D=c.getProxy(C.MainContext.MainThreadExtensionService),p=c.getProxy(C.MainContext.MainThreadErrors);I.setUnexpectedErrorHandler(h=>{const R=I.transformErrorForSerialization(h),F=w.get(h);F?D.$onExtensionRuntimeError(F.identifier,R):p.$onUnexpectedError(R)})}terminate(l){if(!this._isTerminating){this._isTerminating=!0,this._logService.info(`extension host terminating: ${l}`),this._logService.flush(),this._disposables.dispose(),I.setUnexpectedErrorHandler(t=>{});const u=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,E.timeout)(4e3),u]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}}static _transform(l,u){l.extensions.forEach(r=>r.extensionLocation=S.URI.revive(u.transformIncomingURIs(r.extensionLocation))),l.environment.appRoot=S.URI.revive(u.transformIncomingURIs(l.environment.appRoot));const t=l.environment.extensionDevelopmentLocationURI;return t&&(l.environment.extensionDevelopmentLocationURI=t.map(r=>S.URI.revive(u.transformIncomingURIs(r)))),l.environment.extensionTestsLocationURI=S.URI.revive(u.transformIncomingURIs(l.environment.extensionTestsLocationURI)),l.environment.globalStorageHome=S.URI.revive(u.transformIncomingURIs(l.environment.globalStorageHome)),l.environment.workspaceStorageHome=S.URI.revive(u.transformIncomingURIs(l.environment.workspaceStorageHome)),l.logsLocation=S.URI.revive(u.transformIncomingURIs(l.logsLocation)),l.logFile=S.URI.revive(u.transformIncomingURIs(l.logFile)),l.workspace=u.transformIncomingURIs(l.workspace),l}}e.ExtensionHostMain=b}),define(_e[222],we([0,1,12,20,60,28,25,55,41]),function(ie,e,E,I,P,A,S,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class n{constructor(g,m,i){this.config=g,this.provider=m,this.sessionToken=i,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=g.filePattern,this.includePattern=g.includePattern&&A.parse(g.includePattern),this.maxResults=g.maxResults||void 0,this.exists=g.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=g.excludePattern&&A.parse(g.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(g=>g.cancel()),this.activeCancellationTokens=new Set}search(g){const m=this.config.folderQueries||[];return new Promise((i,s)=>{const _=d=>{this.resultCount++,g(d)};if(this.isCanceled)return i({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(d=>{const b=d.toString(),v=E.basename(b);this.globalExcludePattern&&this.globalExcludePattern(b,v)||this.matchFile(_,{base:d,basename:v})}),Promise.all(m.map(d=>this.searchInFolder(d,_))).then(d=>{i({limitHit:this.isLimitHit,stats:d[0]||void 0})},d=>{s(new Error((0,P.toErrorMessage)(d)))})})}async searchInFolder(g,m){const i=new I.CancellationTokenSource,s=this.getSearchOptionsForFolder(g),_=this.initDirectoryTree(),d=new y.QueryGlobTester(this.config,g),b=!d.hasSiblingExcludeClauses();let v;try{this.activeCancellationTokens.add(i),v=C.StopWatch.create();const l=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},s,i.token),u=v.elapsed(),t=C.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(l&&l.forEach(r=>{const c=E.posix.relative(g.folder.path,r.path);if(b){const o=E.basename(r.path);this.matchFile(m,{base:g.folder,relativePath:c,basename:o});return}this.addDirectoryEntries(_,g.folder,c,m)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(_,d,m),{providerTime:u,postProcessTime:t.elapsed()})}finally{i.dispose(),this.activeCancellationTokens.delete(i)}}getSearchOptionsForFolder(g){const m=(0,y.resolvePatternsForProvider)(this.config.includePattern,g.includePattern),i=(0,y.resolvePatternsForProvider)(this.config.excludePattern,g.excludePattern);return{folder:g.folder,excludes:i,includes:m,useIgnoreFiles:!g.disregardIgnoreFiles,useGlobalIgnoreFiles:!g.disregardGlobalIgnoreFiles,followSymlinks:!g.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const g={rootEntries:[],pathToEntries:Object.create(null)};return g.pathToEntries["."]=g.rootEntries,g}addDirectoryEntries({pathToEntries:g},m,i,s){if(i===this.filePattern){const d=E.basename(this.filePattern);this.matchFile(s,{base:m,relativePath:this.filePattern,basename:d})}function _(d){const b=E.basename(d),v=E.dirname(d);let l=g[v];l||(l=g[v]=[],_(v)),l.push({base:m,relativePath:d,basename:b})}_(i)}matchDirectoryTree({rootEntries:g,pathToEntries:m},i,s){const _=this,d=this.filePattern;function b(v){const l=A.hasSiblingFn(()=>v.map(u=>u.basename));for(let u=0,t=v.length;u<t;u++){const r=v[u],{relativePath:c,basename:o}=r;if(!!i.includedInQuerySync(c,o,d!==o?l:void 0)){const a=m[c];if(a)b(a);else{if(c===d)continue;_.matchFile(s,r)}if(_.isLimitHit)break}}}b(g)}matchFile(g,m){(!this.includePattern||m.relativePath&&this.includePattern(m.relativePath,m.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||g(m))}}class T{constructor(){this.sessions=new Map}fileSearch(g,m,i,s){const _=this.getSessionTokenSource(g.cacheKey),d=new n(g,m,_&&_.token);let b=0;const v=l=>{b+=l.length,i(l.map(u=>this.rawMatchToSearchItem(u)))};return this.doSearch(d,T.BATCH_SIZE,v,s).then(l=>({limitHit:l.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:b,detailStats:l.stats}}))}clearCache(g){const m=this.getSessionTokenSource(g);m&&m.cancel()}getSessionTokenSource(g){if(!!g)return this.sessions.has(g)||this.sessions.set(g,new I.CancellationTokenSource),this.sessions.get(g)}rawMatchToSearchItem(g){return g.relativePath?{resource:S.joinPath(g.base,g.relativePath)}:{resource:g.base}}doSearch(g,m,i,s){s.onCancellationRequested(()=>{g.cancel()});const _=b=>{b&&(d.push(b),m>0&&d.length>=m&&(i(d),d=[]))};let d=[];return g.search(_).then(b=>(d.length&&i(d),b),b=>(d.length&&i(d),Promise.reject(b)))}}e.FileSearchManager=T,T.BATCH_SIZE=512}),define(_e[223],we([0,1,12,11,20,60,25,28,2,41,18]),function(ie,e,E,I,P,A,S,C,y,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class k{constructor(b,v,l){this.query=b,this.provider=v,this.fileUtils=l,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(b,v){const l=this.query.folderQueries||[],u=new P.CancellationTokenSource;return v.onCancellationRequested(()=>u.cancel()),new Promise((t,r)=>{this.collector=new m(b);let c=!1;const o=(a,f)=>{if(!c&&!this.isLimitHit){const w=this.resultSize(a);s(a)&&typeof this.query.maxResults=="number"&&this.resultCount+w>this.query.maxResults&&(this.isLimitHit=!0,c=!0,u.cancel(),a=this.trimResultToSize(a,this.query.maxResults-this.resultCount));const D=this.resultSize(a);this.resultCount+=D,(D>0||!s(a))&&this.collector.add(a,f)}};Promise.all(l.map((a,f)=>this.searchInFolder(a,w=>o(w,f),u.token))).then(a=>{u.dispose(),this.collector.flush();const f=a.some(w=>!!w&&!!w.limitHit);t({limitHit:this.isLimitHit||f,stats:{type:"textSearchProvider"}})},a=>{u.dispose();const f=(0,A.toErrorMessage)(a);r(new Error(f))})})}resultSize(b){return s(b)?Array.isArray(b.ranges)?b.ranges.length:1:0}trimResultToSize(b,v){const l=Array.isArray(b.ranges)?b.ranges:[b.ranges],u=Array.isArray(b.preview.matches)?b.preview.matches:[b.preview.matches];return{ranges:l.slice(0,v),preview:{matches:u.slice(0,v),text:b.preview.text},uri:b.uri}}async searchInFolder(b,v,l){const u=new n.QueryGlobTester(this.query,b),t=[],r={report:a=>{if(!!this.validateProviderResult(a)){const f=b.folder.scheme===T.Schemas.file?C.hasSiblingPromiseFn(()=>this.fileUtils.readdir(S.dirname(a.uri))):void 0,w=S.relativePath(b.folder,a.uri);w&&t.push(u.includedInQuery(w,E.basename(w),f).then(D=>{D&&v(a)}))}}},c=this.getSearchOptionsForFolder(b),o=await this.provider.provideTextSearchResults(g(this.query.contentPattern),c,r,l);return await Promise.all(t),o}validateProviderResult(b){if(s(b)){if(Array.isArray(b.ranges)){if(!Array.isArray(b.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(b.preview.matches.length!==b.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(b.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(b){const v=(0,n.resolvePatternsForProvider)(this.query.includePattern,b.includePattern),l=(0,n.resolvePatternsForProvider)(this.query.excludePattern,b.excludePattern),u={folder:y.URI.from(b.folder),excludes:l,includes:v,useIgnoreFiles:!b.disregardIgnoreFiles,useGlobalIgnoreFiles:!b.disregardGlobalIgnoreFiles,followSymlinks:!b.ignoreSymlinks,encoding:b.fileEncoding&&this.fileUtils.toCanonicalName(b.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return u.usePCRE2=this.query.usePCRE2,u}}e.TextSearchManager=k;function g(d){return{isCaseSensitive:d.isCaseSensitive||!1,isRegExp:d.isRegExp||!1,isWordMatch:d.isWordMatch||!1,isMultiline:d.isMultiline||!1,pattern:d.pattern}}class m{constructor(b){this._onResult=b,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new _(512,v=>this.sendItems(v))}add(b,v){this._currentFileMatch&&(this._currentFolderIdx!==v||!S.isEqual(this._currentUri,b.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=v,this._currentFileMatch={resource:b.uri,results:[]}),this._currentFileMatch.results.push(i(b))}pushToCollector(){const b=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,b)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(b){this._onResult(b)}}e.TextSearchResultsCollector=m;function i(d){return s(d)?{preview:{matches:(0,I.mapArrayOrNot)(d.preview.matches,b=>({startLineNumber:b.start.line,startColumn:b.start.character,endLineNumber:b.end.line,endColumn:b.end.character})),text:d.preview.text},ranges:(0,I.mapArrayOrNot)(d.ranges,b=>({startLineNumber:b.start.line,startColumn:b.start.character,endLineNumber:b.end.line,endColumn:b.end.character}))}:{text:d.text,lineNumber:d.lineNumber}}function s(d){return!!d.preview}e.extensionResultIsMatch=s;class _{constructor(b,v){this.maxBatchSize=b,this.cb=v,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(b,v){!b||this.addItemToBatch(b,v)}addItems(b,v){!b||this.addItemsToBatch(b,v)}addItemToBatch(b,v){this.batch.push(b),this.batchSize+=v,this.onUpdate()}addItemsToBatch(b,v){this.batch=this.batch.concat(b),this.batchSize+=v,this.onUpdate()}onUpdate(){this.totalNumberCompleted<_.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},_.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=_,_.TIMEOUT=4e3,_.START_BATCH_AFTER_COUNT=50}),define(_e[103],we([0,1,6,5,4,222,15,68,19,2,223]),function(ie,e,E,I,P,A,S,C,y,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,P.createDecorator)("IExtHostSearch");let k=class{constructor(s,_,d){this.extHostRpc=s,this._uriTransformer=_,this._logService=d,this._proxy=this.extHostRpc.getProxy(I.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new A.FileSearchManager}_transformScheme(s){return this._uriTransformer.transformOutgoingScheme(s)}registerTextSearchProvider(s,_){if(this._textSearchUsedSchemes.has(s))throw new Error(`a text search provider for the scheme '${s}' is already registered`);this._textSearchUsedSchemes.add(s);const d=this._handlePool++;return this._textSearchProvider.set(d,_),this._proxy.$registerTextSearchProvider(d,this._transformScheme(s)),(0,E.toDisposable)(()=>{this._textSearchUsedSchemes.delete(s),this._textSearchProvider.delete(d),this._proxy.$unregisterProvider(d)})}registerFileSearchProvider(s,_){if(this._fileSearchUsedSchemes.has(s))throw new Error(`a file search provider for the scheme '${s}' is already registered`);this._fileSearchUsedSchemes.add(s);const d=this._handlePool++;return this._fileSearchProvider.set(d,_),this._proxy.$registerFileSearchProvider(d,this._transformScheme(s)),(0,E.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(s),this._fileSearchProvider.delete(d),this._proxy.$unregisterProvider(d)})}$provideFileSearchResults(s,_,d,b){const v=g(d),l=this._fileSearchProvider.get(s);if(l)return this._fileSearchManager.fileSearch(v,l,u=>{this._proxy.$handleFileMatch(s,_,u.map(t=>t.resource))},b);throw new Error("unknown provider: "+s)}$clearCache(s){return this._fileSearchManager.clearCache(s),Promise.resolve(void 0)}$provideTextSearchResults(s,_,d,b){const v=this._textSearchProvider.get(s);if(!v||!v.provideTextSearchResults)throw new Error(`Unknown provider ${s}`);const l=g(d);return this.createTextSearchManager(l,v).search(t=>this._proxy.$handleTextMatch(s,_,t),b)}createTextSearchManager(s,_){return new T.TextSearchManager(s,_,{readdir:d=>Promise.resolve([]),toCanonicalName:d=>d})}};k=je([Ke(0,S.IExtHostRpcService),Ke(1,C.IURITransformerService),Ke(2,y.ILogService)],k),e.ExtHostSearch=k;function g(i){return Object.assign(Object.assign({},i),{folderQueries:i.folderQueries&&i.folderQueries.map(m),extraFileResources:i.extraFileResources&&i.extraFileResources.map(s=>n.URI.revive(s))})}e.reviveQuery=g;function m(i){return Object.assign(Object.assign({},i),{folder:n.URI.revive(i.folder)})}}),define(_e[224],we([0,1,128,20,10,3,46,2,121,82,115,59,64,5,189,188,73,190,34,191,192,193,175,194,39,35,195,176,197,198,199,99,179,202,203,204,75,40,205,180,9,7,208,49,100,31,33,50,165,196,91,98,101,102,103,19,68,15,27,200,163,67,72,186,206,162,76,74,211,209,210,187,48,217,207,71,159,93,201]),function(ie,e,E,I,P,A,S,C,y,n,T,k,g,m,i,s,_,d,b,v,l,u,t,r,c,o,a,f,w,D,p,h,R,F,$,se,z,x,G,M,N,B,Q,W,ee,re,oe,Se,Pe,$e,Fe,ze,U,K,te,le,me,De,Oe,ge,Ce,Ae,We,be,qe,V,Z,pe,Me,He,Ue,Ze,H,ne,de,j,Y,ae,fe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ee(Ne){const Le=Ne.get(Oe.IExtHostInitDataService),Ve=Ne.get(H.IExtHostFileSystemInfo),Ye=Ne.get(pe.IExtHostConsumerFileSystem),et=Ne.get(o.IExtHostExtensionService),nt=Ne.get(re.IExtHostWorkspace),st=Ne.get(ae.IExtHostTelemetry),it=Ne.get(b.IExtHostConfiguration),ve=Ne.get(me.IURITransformerService),he=Ne.get(De.IExtHostRpcService),ue=Ne.get(z.IExtHostStorage),q=Ne.get(Z.IExtensionStoragePaths),Ie=Ne.get(le.ILogService),Te=Ne.get(Ae.IExtHostTunnelService),Qe=Ne.get(We.IExtHostApiDeprecationService),Ge=Ne.get(ee.IExtHostWindow),rt=Ne.get(j.IExtHostSecretState);he.set(m.ExtHostContext.ExtHostFileSystemInfo,Ve),he.set(m.ExtHostContext.ExtHostLogService,Ie),he.set(m.ExtHostContext.ExtHostWorkspace,nt),he.set(m.ExtHostContext.ExtHostConfiguration,it),he.set(m.ExtHostContext.ExtHostExtensionService,et),he.set(m.ExtHostContext.ExtHostStorage,ue),he.set(m.ExtHostContext.ExtHostTunnelService,Te),he.set(m.ExtHostContext.ExtHostWindow,Ge),he.set(m.ExtHostContext.ExtHostSecretState,rt),he.set(m.ExtHostContext.ExtHostTelemetry,st);const ct=he.set(m.ExtHostContext.ExtHostDecorations,Ne.get(ze.IExtHostDecorations)),Xe=he.set(m.ExtHostContext.ExtHostDocumentsAndEditors,Ne.get(c.IExtHostDocumentsAndEditors)),at=he.set(m.ExtHostContext.ExtHostCommands,Ne.get(_.IExtHostCommands)),ut=he.set(m.ExtHostContext.ExtHostTerminalService,Ne.get(x.IExtHostTerminalService)),ot=he.set(m.ExtHostContext.ExtHostDebugService,Ne.get(K.IExtHostDebugService)),yt=he.set(m.ExtHostContext.ExtHostSearch,Ne.get(te.IExtHostSearch)),gt=he.set(m.ExtHostContext.ExtHostTask,Ne.get(U.IExtHostTask)),vt=he.set(m.ExtHostContext.ExtHostOutputService,Ne.get(h.IExtHostOutputService)),_t=he.set(m.ExtHostContext.ExtHostEditorTabs,new Y.ExtHostEditorTabs),wt=he.set(m.ExtHostContext.ExtHostUrls,new Q.ExtHostUrls(he)),pt=he.set(m.ExtHostContext.ExtHostDocuments,new r.ExtHostDocuments(he,Xe)),Lt=he.set(m.ExtHostContext.ExtHostDocumentContentProviders,new u.ExtHostDocumentContentProvider(he,Xe,Ie)),At=he.set(m.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(Ie,pt,he.getProxy(m.MainContext.MainThreadBulkEdits))),ft=he.set(m.ExtHostContext.ExtHostNotebook,new ge.ExtHostNotebookController(he,at,Xe,pt,Le.environment,Ie,q)),zt=he.set(m.ExtHostContext.ExtHostNotebookKernels,new fe.ExtHostNotebookKernels(he,ft)),bt=he.set(m.ExtHostContext.ExtHostEditors,new G.ExtHostEditors(he,Xe)),$t=he.set(m.ExtHostContext.ExtHostTreeViews,new M.ExtHostTreeViews(he.getProxy(m.MainContext.MainThreadTreeViews),at,Ie)),Vt=he.set(m.ExtHostContext.ExtHostEditorInsets,new Pe.ExtHostEditorInsets(he.getProxy(m.MainContext.MainThreadEditorInsets),bt,Le.environment)),Mt=he.set(m.ExtHostContext.ExtHostDiagnostics,new v.ExtHostDiagnostics(he,Ie)),dt=he.set(m.ExtHostContext.ExtHostLanguageFeatures,new w.ExtHostLanguageFeatures(he,ve,pt,at,Mt,Ie,Qe)),cn=he.set(m.ExtHostContext.ExtHostFileSystem,new a.ExtHostFileSystem(he,dt)),Ct=he.set(m.ExtHostContext.ExtHostFileSystemEventService,new f.ExtHostFileSystemEventService(he,Ie,Xe)),Tt=he.set(m.ExtHostContext.ExtHostQuickOpen,(0,F.createExtHostQuickOpen)(he,nt,at)),en=he.set(m.ExtHostContext.ExtHostSCM,new $.ExtHostSCM(he,at,Ie)),dn=he.set(m.ExtHostContext.ExtHostComments,new d.ExtHostComments(he,at,pt)),tn=he.set(m.ExtHostContext.ExtHostProgress,new R.ExtHostProgress(he.getProxy(m.MainContext.MainThreadProgress))),hn=he.set(m.ExtHostContext.ExtHosLabelService,new $e.ExtHostLabelService(he)),nn=he.set(m.ExtHostContext.ExtHostTheming,new Ce.ExtHostTheming(he)),It=he.set(m.ExtHostContext.ExtHostAuthentication,new be.ExtHostAuthentication(he)),jt=he.set(m.ExtHostContext.ExtHostTimeline,new qe.ExtHostTimeline(he,at)),qt=he.set(m.ExtHostContext.ExtHostWebviews,new W.ExtHostWebviews(he,Le.environment,nt,Ie,Qe)),Kt=he.set(m.ExtHostContext.ExtHostWebviewPanels,new Ue.ExtHostWebviewPanels(he,qt,nt)),fn=he.set(m.ExtHostContext.ExtHostCustomEditors,new He.ExtHostCustomEditors(he,pt,q,qt,Kt)),mn=he.set(m.ExtHostContext.ExtHostWebviewViews,new Me.ExtHostWebviewViews(he,qt)),St=he.set(m.ExtHostContext.ExtHostTesting,new ne.ExtHostTesting(he,Xe,nt)),gn=he.set(m.ExtHostContext.ExtHostUriOpeners,new de.ExtHostUriOpeners(he)),pn=(0,Se.values)(m.ExtHostContext);he.assertRegistered(pn);const Gt=new Ze.ExtHostBulkEdits(he,Xe),vn=new s.ExtHostClipboard(he),Ot=new p.ExtHostMessageService(he,Ie),Wt=new l.ExtHostDialogs(he),Nt=new se.ExtHostStatusBar(he,at.converter),Qt=new D.ExtHostLanguages(he,pt);return i.ExtHostApiCommands.register(at),function(Re,Ut,Jt){const mt=function(){let X=!Re.isUnderDevelopment;function ce(ke){X||(Ie.info(`Extension '${Re.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),X=!0)}return function ke(O){if(Array.isArray(O))O.forEach(ke);else if(typeof O=="string")ce(O);else{const L=O;typeof L.scheme=="undefined"&&ce(O),!Re.enableProposedApi&&typeof L.exclusive=="boolean"&&(0,oe.throwProposedApiError)(Re)}return O}}(),_n={getSession(X,ce,ke){return It.getSession(Re,X,ce,ke)},get onDidChangeSessions(){return It.onDidChangeSessions},registerAuthenticationProvider(X,ce,ke,O){return It.registerAuthenticationProvider(X,ce,ke,O)},get onDidChangeAuthenticationProviders(){return(0,oe.checkProposedApiEnabled)(Re),It.onDidChangeAuthenticationProviders},get providers(){return(0,oe.checkProposedApiEnabled)(Re),It.providers},logout(X,ce){return(0,oe.checkProposedApiEnabled)(Re),It.removeSession(X,ce)}},bn={registerCommand(X,ce,ke){return at.registerCommand(!0,X,ce,ke)},registerTextEditorCommand(X,ce,ke){return at.registerCommand(!0,X,(...O)=>{const L=bt.getActiveTextEditor();if(!L){Ie.warn("Cannot execute "+X+" because there is no active text editor.");return}return L.edit(J=>{ce.apply(ke,[L,J,...O])}).then(J=>{J||Ie.warn("Edits from command "+X+" were not applied.")},J=>{Ie.warn("An error occurred while running command "+X,J)})})},registerDiffInformationCommand:(X,ce,ke)=>((0,oe.checkProposedApiEnabled)(Re),at.registerCommand(!0,X,async(...O)=>{const L=Xe.activeEditor(!0);if(!L){Ie.warn("Cannot execute "+X+" because there is no active text editor.");return}const J=await bt.getDiffInformation(L.id);ce.apply(ke,[J,...O])})),executeCommand(X,...ce){return at.executeCommand(X,...ce)},getCommands(X=!1){return at.getCommands(X)}},rn={get machineId(){return Le.telemetryInfo.machineId},get sessionId(){return Le.telemetryInfo.sessionId},get language(){return Le.environment.appLanguage},get appName(){return Le.environment.appName},get appRoot(){var X,ce;return(ce=(X=Le.environment.appRoot)===null||X===void 0?void 0:X.fsPath)!==null&&ce!==void 0?ce:""},get uriScheme(){return Le.environment.appUriScheme},get clipboard(){return vn.value},get shell(){return ut.getDefaultShell(!1,Jt)},get isTelemetryEnabled(){return st.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return st.onDidChangeTelemetryEnabled},get isNewAppInstall(){const X=Date.now()-new Date(Le.telemetryInfo.firstSessionDate).getTime();return isNaN(X)?!1:X<1e3*60*60*24},openExternal(X,ce){return Ge.openUri(X,{allowTunneling:!!Le.remote.authority,allowContributedOpeners:ce==null?void 0:ce.allowContributedOpeners})},asExternalUri(X){return X.scheme===Le.environment.appUriScheme?wt.createAppUri(X):Ge.asExternalUri(X,{allowTunneling:!!Le.remote.authority})},get remoteName(){return(0,Fe.getRemoteName)(Le.remote.authority)},get uiKind(){return Le.uiKind}};Le.environment.extensionTestsLocationURI||Object.freeze(rn);const Bt=Le.remote.isRemote?B.ExtensionKind.Workspace:B.ExtensionKind.UI,wn={registerTestProvider(X){return(0,oe.checkProposedApiEnabled)(Re),St.registerTestProvider(X)},createDocumentTestObserver(X){return(0,oe.checkProposedApiEnabled)(Re),St.createTextDocumentTestObserver(X)},createWorkspaceTestObserver(X){return(0,oe.checkProposedApiEnabled)(Re),St.createWorkspaceTestObserver(X)},runTests(X){return(0,oe.checkProposedApiEnabled)(Re),St.runTests(X)},publishTestResult(X,ce=!0){return(0,oe.checkProposedApiEnabled)(Re),St.publishExtensionProvidedResults(X,ce)},get onDidChangeTestResults(){return(0,oe.checkProposedApiEnabled)(Re),St.onResultsChanged},get testResults(){return(0,oe.checkProposedApiEnabled)(Re),St.results}},En={getExtension(X){const ce=Ut.getExtensionDescription(X);if(ce)return new o.Extension(et,Re.identifier,ce,Bt)},get all(){return Ut.getAllExtensionDescriptions().map(X=>new o.Extension(et,Re.identifier,X,Bt))},get onDidChange(){return Ut.onDidChange}},yn={createDiagnosticCollection(X){return Mt.createDiagnosticCollection(Re.identifier,X)},get onDidChangeDiagnostics(){return Mt.onDidChangeDiagnostics},getDiagnostics:X=>Mt.getDiagnostics(X),getLanguages(){return Qt.getLanguages()},setTextDocumentLanguage(X,ce){return Qt.changeLanguage(X.uri,ce)},match(X,ce){return(0,k.score)(N.LanguageSelector.from(X),ce.uri,ce.languageId,!0)},registerCodeActionsProvider(X,ce,ke){return dt.registerCodeActionProvider(Re,mt(X),ce,ke)},registerCodeLensProvider(X,ce){return dt.registerCodeLensProvider(Re,mt(X),ce)},registerDefinitionProvider(X,ce){return dt.registerDefinitionProvider(Re,mt(X),ce)},registerDeclarationProvider(X,ce){return dt.registerDeclarationProvider(Re,mt(X),ce)},registerImplementationProvider(X,ce){return dt.registerImplementationProvider(Re,mt(X),ce)},registerTypeDefinitionProvider(X,ce){return dt.registerTypeDefinitionProvider(Re,mt(X),ce)},registerHoverProvider(X,ce){return dt.registerHoverProvider(Re,mt(X),ce,Re.identifier)},registerEvaluatableExpressionProvider(X,ce){return dt.registerEvaluatableExpressionProvider(Re,mt(X),ce,Re.identifier)},registerInlineValuesProvider(X,ce){return dt.registerInlineValuesProvider(Re,mt(X),ce,Re.identifier)},registerDocumentHighlightProvider(X,ce){return dt.registerDocumentHighlightProvider(Re,mt(X),ce)},registerLinkedEditingRangeProvider(X,ce){return dt.registerLinkedEditingRangeProvider(Re,mt(X),ce)},registerReferenceProvider(X,ce){return dt.registerReferenceProvider(Re,mt(X),ce)},registerRenameProvider(X,ce){return dt.registerRenameProvider(Re,mt(X),ce)},registerDocumentSymbolProvider(X,ce,ke){return dt.registerDocumentSymbolProvider(Re,mt(X),ce,ke)},registerWorkspaceSymbolProvider(X){return dt.registerWorkspaceSymbolProvider(Re,X)},registerDocumentFormattingEditProvider(X,ce){return dt.registerDocumentFormattingEditProvider(Re,mt(X),ce)},registerDocumentRangeFormattingEditProvider(X,ce){return dt.registerDocumentRangeFormattingEditProvider(Re,mt(X),ce)},registerOnTypeFormattingEditProvider(X,ce,ke,...O){return dt.registerOnTypeFormattingEditProvider(Re,mt(X),ce,[ke].concat(O))},registerDocumentSemanticTokensProvider(X,ce,ke){return dt.registerDocumentSemanticTokensProvider(Re,mt(X),ce,ke)},registerDocumentRangeSemanticTokensProvider(X,ce,ke){return dt.registerDocumentRangeSemanticTokensProvider(Re,mt(X),ce,ke)},registerSignatureHelpProvider(X,ce,ke,...O){return typeof ke=="object"?dt.registerSignatureHelpProvider(Re,mt(X),ce,ke):dt.registerSignatureHelpProvider(Re,mt(X),ce,typeof ke=="undefined"?[]:[ke,...O])},registerCompletionItemProvider(X,ce,...ke){return dt.registerCompletionItemProvider(Re,mt(X),ce,ke)},registerDocumentLinkProvider(X,ce){return dt.registerDocumentLinkProvider(Re,mt(X),ce)},registerColorProvider(X,ce){return dt.registerColorProvider(Re,mt(X),ce)},registerFoldingRangeProvider(X,ce){return dt.registerFoldingRangeProvider(Re,mt(X),ce)},registerSelectionRangeProvider(X,ce){return dt.registerSelectionRangeProvider(Re,X,ce)},registerCallHierarchyProvider(X,ce){return dt.registerCallHierarchyProvider(Re,X,ce)},setLanguageConfiguration:(X,ce)=>dt.setLanguageConfiguration(Re,X,ce),getTokenInformationAtPosition(X,ce){return(0,oe.checkProposedApiEnabled)(Re),Qt.tokenAtPosition(X,ce)},registerInlineHintsProvider(X,ce){return(0,oe.checkProposedApiEnabled)(Re),dt.registerInlineHintsProvider(Re,X,ce)}},Sn={get activeTextEditor(){return bt.getActiveTextEditor()},get visibleTextEditors(){return bt.getVisibleTextEditors()},get activeTerminal(){return ut.activeTerminal},get terminals(){return ut.terminals},async showTextDocument(X,ce,ke){const O=await(C.URI.isUri(X)?Promise.resolve(sn.openTextDocument(X)):Promise.resolve(X));return bt.showTextDocument(O,ce,ke)},createTextEditorDecorationType(X){return bt.createTextEditorDecorationType(X)},onDidChangeActiveTextEditor(X,ce,ke){return bt.onDidChangeActiveTextEditor(X,ce,ke)},onDidChangeVisibleTextEditors(X,ce,ke){return bt.onDidChangeVisibleTextEditors(X,ce,ke)},onDidChangeTextEditorSelection(X,ce,ke){return bt.onDidChangeTextEditorSelection(X,ce,ke)},onDidChangeTextEditorOptions(X,ce,ke){return bt.onDidChangeTextEditorOptions(X,ce,ke)},onDidChangeTextEditorVisibleRanges(X,ce,ke){return bt.onDidChangeTextEditorVisibleRanges(X,ce,ke)},onDidChangeTextEditorViewColumn(X,ce,ke){return bt.onDidChangeTextEditorViewColumn(X,ce,ke)},onDidCloseTerminal(X,ce,ke){return ut.onDidCloseTerminal(X,ce,ke)},onDidOpenTerminal(X,ce,ke){return ut.onDidOpenTerminal(X,ce,ke)},onDidChangeActiveTerminal(X,ce,ke){return ut.onDidChangeActiveTerminal(X,ce,ke)},onDidChangeTerminalDimensions(X,ce,ke){return(0,oe.checkProposedApiEnabled)(Re),ut.onDidChangeTerminalDimensions(X,ce,ke)},onDidWriteTerminalData(X,ce,ke){return(0,oe.checkProposedApiEnabled)(Re),ut.onDidWriteTerminalData(X,ce,ke)},get state(){return Ge.state},onDidChangeWindowState(X,ce,ke){return Ge.onDidChangeWindowState(X,ce,ke)},showInformationMessage(X,...ce){return Ot.showMessage(Re,S.default.Info,X,ce[0],ce.slice(1))},showWarningMessage(X,...ce){return Ot.showMessage(Re,S.default.Warning,X,ce[0],ce.slice(1))},showErrorMessage(X,...ce){return Ot.showMessage(Re,S.default.Error,X,ce[0],ce.slice(1))},showQuickPick(X,ce,ke){return Tt.showQuickPick(X,!!Re.enableProposedApi,ce,ke)},showWorkspaceFolderPick(X){return Tt.showWorkspaceFolderPick(X)},showInputBox(X,ce){return Tt.showInput(X,ce)},showOpenDialog(X){return Wt.showOpenDialog(X)},showSaveDialog(X){return Wt.showSaveDialog(X)},createStatusBarItem(X,ce){let ke,O,L,J;return X&&typeof X!="number"?(ke=X.id,O=X.name,L=X.alignment,ce=X.priority,J=X.accessibilityInformation):(ke=Re.identifier.value,O=E.localize(0,null,Re.displayName||Re.name),L=X),Nt.createStatusBarEntry(ke,O,L,ce,J)},setStatusBarMessage(X,ce){return Nt.setStatusBarMessage(X,ce)},withScmProgress(X){return Qe.report("window.withScmProgress",Re,"Use 'withProgress' instead."),tn.withProgress(Re,{location:B.ProgressLocation.SourceControl},(ce,ke)=>X({report(O){}}))},withProgress(X,ce){return tn.withProgress(Re,X,ce)},createOutputChannel(X){return vt.createOutputChannel(X)},createWebviewPanel(X,ce,ke,O){return Kt.createWebviewPanel(Re,X,ce,ke,O)},createWebviewTextEditorInset(X,ce,ke,O){return(0,oe.checkProposedApiEnabled)(Re),Vt.createWebviewEditorInset(X,ce,ke,O,Re)},createTerminal(X,ce,ke){return typeof X=="object"?"pty"in X?ut.createExtensionTerminal(X):(X.message&&(0,oe.checkProposedApiEnabled)(Re),X.icon&&(0,oe.checkProposedApiEnabled)(Re),ut.createTerminalFromOptions(X)):ut.createTerminal(X,ce,ke)},registerTerminalLinkProvider(X){return ut.registerLinkProvider(X)},registerTreeDataProvider(X,ce){return $t.registerTreeDataProvider(X,ce,Re)},createTreeView(X,ce){return $t.createTreeView(X,ce,Re)},registerWebviewPanelSerializer:(X,ce)=>Kt.registerWebviewPanelSerializer(Re,X,ce),registerCustomEditorProvider:(X,ce,ke={})=>fn.registerCustomEditorProvider(Re,X,ce,ke),registerFileDecorationProvider(X){return ct.registerFileDecorationProvider(X,Re.identifier)},registerUriHandler(X){return wt.registerUriHandler(Re.identifier,X)},createQuickPick(){return Tt.createQuickPick(Re.identifier,!!Re.enableProposedApi)},createInputBox(){return Tt.createInputBox(Re.identifier)},get activeColorTheme(){return nn.activeColorTheme},onDidChangeActiveColorTheme(X,ce,ke){return nn.onDidChangeActiveColorTheme(X,ce,ke)},registerWebviewViewProvider(X,ce,ke){return mn.registerWebviewViewProvider(Re,X,ce,ke==null?void 0:ke.webviewOptions)},get activeNotebookEditor(){return(0,oe.checkProposedApiEnabled)(Re),ft.activeNotebookEditor},onDidChangeActiveNotebookEditor(X,ce,ke){return(0,oe.checkProposedApiEnabled)(Re),ft.onDidChangeActiveNotebookEditor(X,ce,ke)},get visibleNotebookEditors(){return(0,oe.checkProposedApiEnabled)(Re),ft.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,oe.checkProposedApiEnabled)(Re),ft.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(X,ce,ke){return(0,oe.checkProposedApiEnabled)(Re),ft.onDidChangeNotebookEditorSelection(X,ce,ke)},onDidChangeNotebookEditorVisibleRanges(X,ce,ke){return(0,oe.checkProposedApiEnabled)(Re),ft.onDidChangeNotebookEditorVisibleRanges(X,ce,ke)},showNotebookDocument(X,ce){return(0,oe.checkProposedApiEnabled)(Re),ft.showNotebookDocument(X,ce)},registerExternalUriOpener(X,ce,ke){return(0,oe.checkProposedApiEnabled)(Re),gn.registerExternalUriOpener(Re.identifier,X,ce,ke)},get openEditors(){return(0,oe.checkProposedApiEnabled)(Re),_t.tabs},get onDidChangeOpenEditors(){return(0,oe.checkProposedApiEnabled)(Re),_t.onDidChangeTabs}},sn={get rootPath(){return Qe.report("workspace.rootPath",Re,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),nt.getPath()},set rootPath(X){throw P.readonly()},getWorkspaceFolder(X){return nt.getWorkspaceFolder(X)},get workspaceFolders(){return nt.getWorkspaceFolders()},get name(){return nt.name},set name(X){throw P.readonly()},get workspaceFile(){return nt.workspaceFile},set workspaceFile(X){throw P.readonly()},updateWorkspaceFolders:(X,ce,...ke)=>nt.updateWorkspaceFolders(Re,X,ce||0,...ke),onDidChangeWorkspaceFolders:function(X,ce,ke){return nt.onDidChangeWorkspace(X,ce,ke)},asRelativePath:(X,ce)=>nt.getRelativePath(X,ce),findFiles:(X,ce,ke,O)=>nt.findFiles(N.GlobPattern.from(X),N.GlobPattern.from(ce),ke,Re.identifier,O),findTextInFiles:(X,ce,ke,O)=>{let L,J;return typeof ce=="object"?(L=ce,J=ke):(L={},J=ce,O=ke),nt.findTextInFiles(X,L||{},J,Re.identifier,O)},saveAll:X=>nt.saveAll(X),applyEdit(X){return Gt.applyWorkspaceEdit(X)},createFileSystemWatcher:(X,ce,ke,O)=>Ct.createFileSystemWatcher(N.GlobPattern.from(X),ce,ke,O),get textDocuments(){return pt.getAllDocumentData().map(X=>X.document)},set textDocuments(X){throw P.readonly()},openTextDocument(X){let ce;const ke=X;if(typeof X=="string")ce=Promise.resolve(C.URI.file(X));else if(C.URI.isUri(X))ce=Promise.resolve(X);else if(!ke||typeof ke=="object")ce=pt.createDocumentData(ke);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ce.then(O=>pt.ensureDocumentData(O).then(L=>L.document))},onDidOpenTextDocument:(X,ce,ke)=>pt.onDidAddDocument(X,ce,ke),onDidCloseTextDocument:(X,ce,ke)=>pt.onDidRemoveDocument(X,ce,ke),onDidChangeTextDocument:(X,ce,ke)=>pt.onDidChangeDocument(X,ce,ke),onDidSaveTextDocument:(X,ce,ke)=>pt.onDidSaveDocument(X,ce,ke),onWillSaveTextDocument:(X,ce,ke)=>At.getOnWillSaveTextDocumentEvent(Re)(X,ce,ke),onDidChangeConfiguration:(X,ce,ke)=>Jt.onDidChangeConfiguration(X,ce,ke),getConfiguration(X,ce){return ce=arguments.length===1?void 0:ce,Jt.getConfiguration(X,ce,Re)},registerTextDocumentContentProvider(X,ce){return Lt.registerTextDocumentContentProvider(X,ce)},registerTaskProvider:(X,ce)=>(Qe.report("window.registerTaskProvider",Re,"Use the corresponding function on the 'tasks' namespace instead"),gt.registerTaskProvider(Re,X,ce)),registerFileSystemProvider(X,ce,ke){return cn.registerFileSystemProvider(Re.identifier,X,ce,ke)},get fs(){return Ye.value},registerFileSearchProvider:(X,ce)=>((0,oe.checkProposedApiEnabled)(Re),yt.registerFileSearchProvider(X,ce)),registerTextSearchProvider:(X,ce)=>((0,oe.checkProposedApiEnabled)(Re),yt.registerTextSearchProvider(X,ce)),registerRemoteAuthorityResolver:(X,ce)=>((0,oe.checkProposedApiEnabled)(Re),et.registerRemoteAuthorityResolver(X,ce)),registerResourceLabelFormatter:X=>((0,oe.checkProposedApiEnabled)(Re),hn.$registerResourceLabelFormatter(X)),onDidCreateFiles:(X,ce,ke)=>Ct.onDidCreateFile(X,ce,ke),onDidDeleteFiles:(X,ce,ke)=>Ct.onDidDeleteFile(X,ce,ke),onDidRenameFiles:(X,ce,ke)=>Ct.onDidRenameFile(X,ce,ke),onWillCreateFiles:(X,ce,ke)=>Ct.getOnWillCreateFileEvent(Re)(X,ce,ke),onWillDeleteFiles:(X,ce,ke)=>Ct.getOnWillDeleteFileEvent(Re)(X,ce,ke),onWillRenameFiles:(X,ce,ke)=>Ct.getOnWillRenameFileEvent(Re)(X,ce,ke),openTunnel:X=>((0,oe.checkProposedApiEnabled)(Re),Te.openTunnel(Re,X).then(ce=>{if(!ce)throw new Error("cannot open tunnel");return ce})),get tunnels(){return(0,oe.checkProposedApiEnabled)(Re),Te.getTunnels()},onDidChangeTunnels:(X,ce,ke)=>((0,oe.checkProposedApiEnabled)(Re),Te.onDidChangeTunnels(X,ce,ke)),registerPortAttributesProvider:(X,ce)=>((0,oe.checkProposedApiEnabled)(Re),Te.registerPortsAttributesProvider(X,ce)),registerTimelineProvider:(X,ce)=>((0,oe.checkProposedApiEnabled)(Re),jt.registerTimelineProvider(X,ce,Re.identifier,at.converter)),get isTrusted(){return(0,oe.checkProposedApiEnabled)(Re),nt.trusted},requestWorkspaceTrust:X=>((0,oe.checkProposedApiEnabled)(Re),nt.requestWorkspaceTrust(X)),onDidReceiveWorkspaceTrust:(X,ce,ke)=>nt.onDidReceiveWorkspaceTrust(X,ce,ke)},on={get inputBox(){return Qe.report("scm.inputBox",Re,"Use 'SourceControl.inputBox' instead"),en.getLastInputBox(Re)},createSourceControl(X,ce,ke){return en.createSourceControl(Re,X,ce,ke)}},Ht={createCommentController(X,ce){return dn.createCommentController(Re,X,ce)}},an={get activeDebugSession(){return ot.activeDebugSession},get activeDebugConsole(){return ot.activeDebugConsole},get breakpoints(){return ot.breakpoints},onDidStartDebugSession(X,ce,ke){return ot.onDidStartDebugSession(X,ce,ke)},onDidTerminateDebugSession(X,ce,ke){return ot.onDidTerminateDebugSession(X,ce,ke)},onDidChangeActiveDebugSession(X,ce,ke){return ot.onDidChangeActiveDebugSession(X,ce,ke)},onDidReceiveDebugSessionCustomEvent(X,ce,ke){return ot.onDidReceiveDebugSessionCustomEvent(X,ce,ke)},onDidChangeBreakpoints(X,ce,ke){return ot.onDidChangeBreakpoints(X,ce,ke)},registerDebugConfigurationProvider(X,ce,ke){return ot.registerDebugConfigurationProvider(X,ce,ke||B.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(X,ce){return ot.registerDebugAdapterDescriptorFactory(Re,X,ce)},registerDebugAdapterTrackerFactory(X,ce){return ot.registerDebugAdapterTrackerFactory(X,ce)},startDebugging(X,ce,ke){return!ke||typeof ke=="object"&&"configuration"in ke?ot.startDebugging(X,ce,{parentSession:ke}):ot.startDebugging(X,ce,ke||{})},stopDebugging(X){return ot.stopDebugging(X)},addBreakpoints(X){return ot.addBreakpoints(X)},removeBreakpoints(X){return ot.removeBreakpoints(X)},asDebugSourceUri(X,ce){return ot.asDebugSourceUri(X,ce)}},Dn={registerTaskProvider:(X,ce)=>gt.registerTaskProvider(Re,X,ce),fetchTasks:X=>gt.fetchTasks(X),executeTask:X=>gt.executeTask(Re,X),get taskExecutions(){return gt.taskExecutions},onDidStartTask:(X,ce,ke)=>gt.onDidStartTask(X,ce,ke),onDidEndTask:(X,ce,ke)=>gt.onDidEndTask(X,ce,ke),onDidStartTaskProcess:(X,ce,ke)=>gt.onDidStartTaskProcess(X,ce,ke),onDidEndTaskProcess:(X,ce,ke)=>gt.onDidEndTaskProcess(X,ce,ke)},Yt={openNotebookDocument:X=>((0,oe.checkProposedApiEnabled)(Re),ft.openNotebookDocument(X)),get onDidOpenNotebookDocument(){return(0,oe.checkProposedApiEnabled)(Re),ft.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return(0,oe.checkProposedApiEnabled)(Re),ft.onDidCloseNotebookDocument},get onDidSaveNotebookDocument(){return(0,oe.checkProposedApiEnabled)(Re),ft.onDidSaveNotebookDocument},get notebookDocuments(){return(0,oe.checkProposedApiEnabled)(Re),ft.notebookDocuments.map(X=>X.notebookDocument)},get onDidChangeActiveNotebookKernel(){return(0,oe.checkProposedApiEnabled)(Re),ft.onDidChangeActiveNotebookKernel},registerNotebookSerializer(X,ce,ke){return(0,oe.checkProposedApiEnabled)(Re),ft.registerNotebookSerializer(Re,X,ce,ke)},registerNotebookContentProvider:(X,ce,ke)=>((0,oe.checkProposedApiEnabled)(Re),ft.registerNotebookContentProvider(Re,X,ce,ke)),registerNotebookKernelProvider:(X,ce)=>((0,oe.checkProposedApiEnabled)(Re),ft.registerNotebookKernelProvider(Re,X,ce)),createNotebookEditorDecorationType(X){return(0,oe.checkProposedApiEnabled)(Re),ft.createNotebookEditorDecorationType(X)},onDidChangeNotebookDocumentMetadata(X,ce,ke){return(0,oe.checkProposedApiEnabled)(Re),ft.onDidChangeNotebookDocumentMetadata(X,ce,ke)},onDidChangeNotebookCells(X,ce,ke){return(0,oe.checkProposedApiEnabled)(Re),ft.onDidChangeNotebookCells(X,ce,ke)},onDidChangeCellExecutionState(X,ce,ke){return(0,oe.checkProposedApiEnabled)(Re),ft.onDidChangeNotebookCellExecutionState(X,ce,ke)},onDidChangeCellOutputs(X,ce,ke){return(0,oe.checkProposedApiEnabled)(Re),ft.onDidChangeCellOutputs(X,ce,ke)},onDidChangeCellMetadata(X,ce,ke){return(0,oe.checkProposedApiEnabled)(Re),ft.onDidChangeCellMetadata(X,ce,ke)},createConcatTextDocument(X,ce){return(0,oe.checkProposedApiEnabled)(Re),new V.ExtHostNotebookConcatDocument(ft,pt,X,ce)},createCellStatusBarItem(X,ce,ke){return(0,oe.checkProposedApiEnabled)(Re),ft.createNotebookCellStatusBarItemInternal(X,ce,ke)},createNotebookCellExecutionTask(X,ce,ke){return(0,oe.checkProposedApiEnabled)(Re),ft.createNotebookCellExecution(X,ce,ke)},createNotebookKernel(X){return(0,oe.checkProposedApiEnabled)(Re),zt.createKernel(Re,X)}};return{version:Le.version,authentication:_n,commands:bn,comments:Ht,debug:an,env:rn,extensions:En,languages:yn,notebook:Yt,scm:on,tasks:Dn,test:wn,window:Sn,workspace:sn,Breakpoint:B.Breakpoint,CallHierarchyIncomingCall:B.CallHierarchyIncomingCall,CallHierarchyItem:B.CallHierarchyItem,CallHierarchyOutgoingCall:B.CallHierarchyOutgoingCall,CancellationError:P.CancellationError,CancellationTokenSource:I.CancellationTokenSource,CandidatePortSource:m.CandidatePortSource,CodeAction:B.CodeAction,CodeActionKind:B.CodeActionKind,CodeActionTriggerKind:B.CodeActionTriggerKind,CodeLens:B.CodeLens,Color:B.Color,ColorInformation:B.ColorInformation,ColorPresentation:B.ColorPresentation,ColorThemeKind:B.ColorThemeKind,CommentMode:B.CommentMode,CommentThreadCollapsibleState:B.CommentThreadCollapsibleState,CompletionItem:B.CompletionItem,CompletionItemKind:B.CompletionItemKind,CompletionItemTag:B.CompletionItemTag,CompletionList:B.CompletionList,CompletionTriggerKind:B.CompletionTriggerKind,ConfigurationTarget:B.ConfigurationTarget,CustomExecution:B.CustomExecution,DebugAdapterExecutable:B.DebugAdapterExecutable,DebugAdapterInlineImplementation:B.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:B.DebugAdapterNamedPipeServer,DebugAdapterServer:B.DebugAdapterServer,DebugConfigurationProviderTriggerKind:B.DebugConfigurationProviderTriggerKind,DebugConsoleMode:B.DebugConsoleMode,DecorationRangeBehavior:B.DecorationRangeBehavior,Diagnostic:B.Diagnostic,DiagnosticRelatedInformation:B.DiagnosticRelatedInformation,DiagnosticSeverity:B.DiagnosticSeverity,DiagnosticTag:B.DiagnosticTag,Disposable:B.Disposable,DocumentHighlight:B.DocumentHighlight,DocumentHighlightKind:B.DocumentHighlightKind,DocumentLink:B.DocumentLink,DocumentSymbol:B.DocumentSymbol,EndOfLine:B.EndOfLine,EnvironmentVariableMutatorType:B.EnvironmentVariableMutatorType,EvaluatableExpression:B.EvaluatableExpression,InlineValueText:B.InlineValueText,InlineValueVariableLookup:B.InlineValueVariableLookup,InlineValueEvaluatableExpression:B.InlineValueEvaluatableExpression,EventEmitter:A.Emitter,ExtensionKind:B.ExtensionKind,ExtensionMode:B.ExtensionMode,ExternalUriOpenerPriority:B.ExternalUriOpenerPriority,FileChangeType:B.FileChangeType,FileDecoration:B.FileDecoration,FileSystemError:B.FileSystemError,FileType:g.FileType,FoldingRange:B.FoldingRange,FoldingRangeKind:B.FoldingRangeKind,FunctionBreakpoint:B.FunctionBreakpoint,Hover:B.Hover,IndentAction:T.IndentAction,Location:B.Location,MarkdownString:B.MarkdownString,OverviewRulerLane:n.OverviewRulerLane,ParameterInformation:B.ParameterInformation,PortAutoForwardAction:B.PortAutoForwardAction,Position:B.Position,ProcessExecution:B.ProcessExecution,ProgressLocation:B.ProgressLocation,QuickInputButtons:B.QuickInputButtons,Range:B.Range,RelativePattern:B.RelativePattern,Selection:B.Selection,SelectionRange:B.SelectionRange,SemanticTokens:B.SemanticTokens,SemanticTokensBuilder:B.SemanticTokensBuilder,SemanticTokensEdit:B.SemanticTokensEdit,SemanticTokensEdits:B.SemanticTokensEdits,SemanticTokensLegend:B.SemanticTokensLegend,ShellExecution:B.ShellExecution,ShellQuoting:B.ShellQuoting,SignatureHelp:B.SignatureHelp,SignatureHelpTriggerKind:B.SignatureHelpTriggerKind,SignatureInformation:B.SignatureInformation,SnippetString:B.SnippetString,SourceBreakpoint:B.SourceBreakpoint,StandardTokenType:B.StandardTokenType,StatusBarAlignment:B.StatusBarAlignment,SymbolInformation:B.SymbolInformation,SymbolKind:B.SymbolKind,SymbolTag:B.SymbolTag,Task:B.Task,TaskGroup:B.TaskGroup,TaskPanelKind:B.TaskPanelKind,TaskRevealKind:B.TaskRevealKind,TaskScope:B.TaskScope,TextDocumentSaveReason:B.TextDocumentSaveReason,TextEdit:B.TextEdit,TextEditorCursorStyle:y.TextEditorCursorStyle,TextEditorLineNumbersStyle:B.TextEditorLineNumbersStyle,TextEditorRevealType:B.TextEditorRevealType,TextEditorSelectionChangeKind:B.TextEditorSelectionChangeKind,ThemeColor:B.ThemeColor,ThemeIcon:B.ThemeIcon,TreeItem:B.TreeItem,TreeItemCollapsibleState:B.TreeItemCollapsibleState,UIKind:m.UIKind,Uri:C.URI,ViewColumn:B.ViewColumn,WorkspaceEdit:B.WorkspaceEdit,InlineHint:B.InlineHint,InlineHintKind:B.InlineHintKind,RemoteAuthorityResolverError:B.RemoteAuthorityResolverError,ResolvedAuthority:B.ResolvedAuthority,SourceControlInputBoxValidationType:B.SourceControlInputBoxValidationType,ExtensionRuntime:B.ExtensionRuntime,TimelineItem:B.TimelineItem,NotebookCellRange:B.NotebookCellRange,NotebookCellKind:B.NotebookCellKind,NotebookCellExecutionState:B.NotebookCellExecutionState,NotebookDocumentMetadata:B.NotebookDocumentMetadata,NotebookCellMetadata:B.NotebookCellMetadata,NotebookCellData:B.NotebookCellData,NotebookData:B.NotebookData,NotebookCellStatusBarAlignment:B.NotebookCellStatusBarAlignment,NotebookEditorRevealType:B.NotebookEditorRevealType,NotebookCellOutput:B.NotebookCellOutput,NotebookCellOutputItem:B.NotebookCellOutputItem,LinkedEditingRanges:B.LinkedEditingRanges,TestItem:B.TestItem,TestResultState:B.TestResultState,TestMessage:B.TestMessage,TestMessageSeverity:B.TestMessageSeverity,WorkspaceTrustState:B.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=Ee}),define(_e[225],we([0,1,61,99,31,98,34,73,39,40,101,102,103,76,75,67,72,100,74,48,71,93]),function(ie,e,E,I,P,A,S,C,y,n,T,k,g,m,i,s,_,d,b,v,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,E.registerSingleton)(m.IExtensionStoragePaths,m.ExtensionStoragePaths),(0,E.registerSingleton)(_.IExtHostApiDeprecationService,_.ExtHostApiDeprecationService),(0,E.registerSingleton)(C.IExtHostCommands,C.ExtHostCommands),(0,E.registerSingleton)(S.IExtHostConfiguration,S.ExtHostConfiguration),(0,E.registerSingleton)(b.IExtHostConsumerFileSystem,b.ExtHostConsumerFileSystem),(0,E.registerSingleton)(k.IExtHostDebugService,k.WorkerExtHostDebugService),(0,E.registerSingleton)(A.IExtHostDecorations,A.ExtHostDecorations),(0,E.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors),(0,E.registerSingleton)(v.IExtHostFileSystemInfo,v.ExtHostFileSystemInfo),(0,E.registerSingleton)(I.IExtHostOutputService,I.ExtHostOutputService),(0,E.registerSingleton)(g.IExtHostSearch,g.ExtHostSearch),(0,E.registerSingleton)(i.IExtHostStorage,i.ExtHostStorage),(0,E.registerSingleton)(T.IExtHostTask,T.WorkerExtHostTask),(0,E.registerSingleton)(n.IExtHostTerminalService,n.WorkerExtHostTerminalService),(0,E.registerSingleton)(s.IExtHostTunnelService,s.ExtHostTunnelService),(0,E.registerSingleton)(d.IExtHostWindow,d.ExtHostWindow),(0,E.registerSingleton)(P.IExtHostWorkspace,P.ExtHostWorkspace),(0,E.registerSingleton)(l.IExtHostSecretState,l.ExtHostSecretState),(0,E.registerSingleton)(u.IExtHostTelemetry,u.ExtHostTelemetry)}),define(_e[226],we([0,1,224,35,220,7,14,5]),function(ie,e,E,I,P,A,S,C){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var n;(function(i){var s;const _=(s=self.trustedTypes)===null||s===void 0?void 0:s.createPolicy("TrustedFunctionWorkaround",{createScript:(b,...v)=>{v.forEach(r=>{var c;if(!((c=self.trustedTypes)===null||c===void 0?void 0:c.isScript(r)))throw new Error("TrustedScripts only, please")});const l=v.slice(0,-1).join(","),u=v.pop().toString();return`(function anonymous(${l}) {
${u}
})`}});function d(...b){return _?self.eval(_.createScript("",...b)):new Function(...b)}i.create=d})(n||(n={}));class T extends P.RequireInterceptor{_installInterceptor(){}getModule(s,_){for(let d of this._alternatives){let b=d(s);if(b){s=b;break}}if(this._factories.has(s))return this._factories.get(s).load(s,_,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class k extends I.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=A.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const s=this._extHostContext.getProxy(C.MainContext.MainThreadConsole);m(s,this._initData.environment.isExtensionDevelopmentDebug);const _=this._instaService.invokeFunction(E.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(T,_,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(s){return s.browser}async _loadCommonJSModule(s,_,d){var b,v,l,u,t,r,c,o;_=_.with({path:g(_.path,".js")}),s&&performance.mark(`code/extHost/willFetchExtensionCode/${s.value}`);const a=await fetch(_.toString(!0));if(s&&performance.mark(`code/extHost/didFetchExtensionCode/${s.value}`),a.status!==200)throw new Error(a.statusText);const f=await a.text(),w=`${_.toString(!0)}#vscode-extension`,D=`${f}
//# sourceURL=${w}`;let p;try{p=n.create((v=(b=k._ttpExtensionScripts)===null||b===void 0?void 0:b.createScript("module"))!==null&&v!==void 0?v:"module",(u=(l=k._ttpExtensionScripts)===null||l===void 0?void 0:l.createScript("exports"))!==null&&u!==void 0?u:"exports",(r=(t=k._ttpExtensionScripts)===null||t===void 0?void 0:t.createScript("require"))!==null&&r!==void 0?r:"require",(o=(c=k._ttpExtensionScripts)===null||c===void 0?void 0:c.createScript(D))!==null&&o!==void 0?o:D)}catch($){throw s?console.error(`Loading code for extension ${s.value} failed: ${$.message}`):console.error(`Loading code failed: ${$.message}`),console.error(`${_.toString(!0)}${typeof $.line=="number"?` line ${$.line}`:""}${typeof $.column=="number"?` column ${$.column}`:""}`),console.error($),$}const h={},R={exports:h},F=$=>{const se=this._fakeModules.getModule($,_);if(se===void 0)throw new Error(`Cannot load module '${$}'`);return se};try{return d.codeLoadingStart(),s&&performance.mark(`code/extHost/willLoadExtensionCode/${s.value}`),p(R,h,F),R.exports!==h?R.exports:h}finally{s&&performance.mark(`code/extHost/didLoadExtensionCode/${s.value}`),d.codeLoadingStop()}}async $setRemoteEnvironment(s){throw new Error("Not supported")}async _waitForDebuggerAttachment(s=5e3){if(!!this._initData.environment.isExtensionDevelopmentDebug){const _=Date.now()+s;for(;Date.now()<_&&!("__jsDebugIsReady"in globalThis);)await(0,S.timeout)(10)}}}e.ExtHostExtensionService=k,k._ttpExtensionScripts=(y=self.trustedTypes)===null||y===void 0?void 0:y.createPolicy("ExtensionScripts",{createScript:i=>i});function g(i,s){return i.endsWith(s)?i:i+s}function m(i,s){_("info","log"),_("log","log"),_("warn","warn"),_("error","error");function _(v,l){const u=console[v];console[v]=function(){i.$logExtensionHostMessage({type:"__$console",severity:l,arguments:b(arguments)}),s&&u.apply(console,arguments)}}const d=1e5;function b(v){const l=[],u=[];if(v.length)for(let t=0;t<v.length;t++){if(typeof v[t]=="undefined")v[t]="undefined";else if(v[t]instanceof Error){const r=v[t];r.stack?v[t]=r.stack:v[t]=r.toString()}u.push(v[t])}try{const t=JSON.stringify(u,function(r,c){if(c&&typeof c=="object"){if(l.indexOf(c)!==-1)return"[Circular]";l.push(c)}return c});return t.length>d?"Output omitted for a large object that exceeds the limits":t}catch(t){return`Output omitted for an object that cannot be inspected ('${t.toString()}')`}}}}),define(_e[227],we([0,1,61,19,35,226,212]),function(ie,e,E,I,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,E.registerSingleton)(P.IExtHostExtensionService,A.ExtHostExtensionService),(0,E.registerSingleton)(I.ILogService,S.ExtHostLogService)}),define(_e[229],we([0,1,23,3,183,221,214,12,77,225,227]),function(ie,e,E,I,P,A,S,C,y){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0});const T=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const k=postMessage.bind(self);if(self.postMessage=()=>console.trace("'postMessage' has been blocked"),self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const _=(n=self.trustedTypes)===null||n===void 0?void 0:n.createPolicy("extensionHostWorker",{createScriptURL:b=>b}),d=self.Worker;Worker=function(b,v){const l=`importScripts('${b}');`;v=v||{},v.name=v.name||C.basename(b.toString());const u=new Blob([l],{type:"application/javascript"}),t=URL.createObjectURL(u);return new d(_?_.createScriptURL(t):t,v)}}else self.Worker=class extends S.NestedWorker{constructor(_,d){super(k,_,Object.assign({name:C.basename(_.toString())},d))}};const g=new class{exit(_){T()}async exists(_){return!0}async realpath(_){return _}};class m{constructor(){const d=new MessageChannel,b=new I.Emitter;let v=!1;k(d.port2,[d.port2]),d.port1.onmessage=l=>{const{data:u}=l;if(!(u instanceof ArrayBuffer)){console.warn("UNKNOWN data received",u);return}const t=E.VSBuffer.wrap(new Uint8Array(u,0,u.byteLength));if((0,P.isMessageOfType)(t,2)){v=!0,s("received terminate message from renderer");return}b.fire(t)},this.protocol={onMessage:b.event,send:l=>{if(!v){const u=l.buffer.buffer.slice(l.buffer.byteOffset,l.buffer.byteOffset+l.buffer.byteLength);d.port1.postMessage(u,[u])}}}}}function i(_){return new Promise(d=>{const b=_.onMessage(v=>{b.dispose();const l=JSON.parse(v.toString());_.send((0,P.createMessageOfType)(0)),d({protocol:_,initData:l})});_.send((0,P.createMessageOfType)(1))})}let s=_=>T();(function(){const d=new m;y.mark("code/extHost/willConnectToRenderer"),i(d.protocol).then(b=>{y.mark("code/extHost/didWaitForInitData");const v=new A.ExtensionHostMain(b.protocol,b.initData,g,null);s=l=>v.terminate(l)})})()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/94d369e27d19f598228961e9feb0413f2edabe5d/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
